/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright (c) 2005-2007 V.Sokur
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

/*
 * BoCRTPrio.h	(V.Sokur)
 * include/Bo/BoCRTPrio.h
 *
 * $Id$
 */

/* ------------------------------------------------------------------------- */

#ifndef __BOCRTPRIO__
# define __BOCRTPRIO__

/******************************************************************************
 * %% BeginSection: constant declarations
 */
# pragma mark -
# pragma mark [ constant declarations ]
# pragma mark -

/* RESERVED: [0-1000] @{ */
# define BoK_CRTPRIO_TEST_MALLOC 0

# define BoK_CRTPRIO_TICK 1

# define BoK_CRTPRIO_AORP_BOOT0 100
# define BoK_CRTPRIO_AORP_ERRDEFSETUP 101

# define BoK_CRTPRIO_AORP_CCSIDEFSETUP 201
# define BoK_CRTPRIO_AORP_CCSCONVDEFSETUP 202

/*
# define BoK_CRTPRIO_AORP_ERROPS 12
# define BoK_CRTPRIO_AORP_ERRSE 13
# define BoK_CRTPRIO_AORP_ERRCLS 14
 */

# define BoK_CRTPRIO_SCANDIR 901
# define BoK_CRTPRIO_WSCANDIR 902

#if 0
/* Operation: [1001-10000] */
# define BoK_CRTPRIO_AORP_OPS 1001
/* Service: [10001-20000] */
# define BoK_CRTPRIO_AORP_SE 10001
/* Class: [20001-30000] */
# define BoK_CRTPRIO_AORP_CLASS 20001
/* @} */
#endif

/* USER */
# define BoK_CRTPRIO_USER 30001
# define BoK_CRTPRIO_LOWEST 0xffff

#endif /* !__BOCRTPRIO__ */

/******************************************************************************
 * Revision History:
 *		$Log$
 *
 *****************************************************************************/
