/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright (c) 2005-2007 V.Sokur
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

/*
 * BoLinkage.h	(V.Sokur)
 * include/Bo/BoLinkage.h
 *
 * $Id$
 */

/* ------------------------------------------------------------------------- */

#ifndef __BO_SYS_CDEFS__
# include <Bo/sys/Cdefs.h>
#endif

#ifndef __BOLINKAGE__
# define __BOLINKAGE__

/******************************************************************************
 * %% BeginSection: definitions
 */

/*
 * To use macros __myc_flinkage__(), __myc_vlinkage__() it is needed
 * to define the next macros: 
 */
# if __myc_build_shlib(libBo)

#  define myc_flinkage_public_libBo myc_flinkage_shlib_export
#  define myc_flinkage_private_libBo myc_flinkage_shlib_private
#  define myc_flinkage_internal_libBo myc_flinkage_shlib_internal

#  define myc_vlinkage_public_libBo myc_vlinkage_shlib_export
#  define myc_vlinkage_private_libBo myc_vlinkage_shlib_private
#  define myc_vlinkage_internal_libBo myc_vlinkage_shlib_internal

# else
# if __myc_use_shlib(libBo)

#  define myc_flinkage_public_libBo myc_flinkage_shlib_import
#  define myc_flinkage_private_libBo myc_flinkage_shlib_private
#  define myc_flinkage_internal_libBo myc_flinkage_shlib_internal

#  define myc_vlinkage_public_libBo myc_vlinkage_shlib_import
#  define myc_vlinkage_private_libBo myc_vlinkage_shlib_private
#  define myc_vlinkage_internal_libBo myc_vlinkage_shlib_internal

# else
# if __myc_build_archive(libBo)

#  define myc_flinkage_public_libBo myc_flinkage_archive_export
#  define myc_flinkage_private_libBo myc_flinkage_archive_private
#  define myc_flinkage_internal_libBo myc_flinkage_archive_internal

#  define myc_vlinkage_public_libBo myc_vlinkage_archive_export
#  define myc_vlinkage_private_libBo myc_vlinkage_archive_private
#  define myc_vlinkage_internal_libBo myc_vlinkage_archive_internal

# else
# if __myc_use_archive(libBo)

#  define myc_flinkage_public_libBo myc_flinkage_archive_import
#  define myc_flinkage_private_libBo myc_flinkage_archive_private
#  define myc_flinkage_internal_libBo myc_flinkage_archive_internal

#  define myc_vlinkage_public_libBo myc_vlinkage_archive_import
#  define myc_vlinkage_private_libBo myc_vlinkage_archive_private
#  define myc_vlinkage_internal_libBo myc_vlinkage_archive_internal

# else

#  define myc_flinkage_public_libBo myc_flinkage_shlib_export
#  define myc_flinkage_private_libBo myc_flinkage_shlib_private
#  define myc_flinkage_internal_libBo myc_flinkage_shlib_internal

#  define myc_vlinkage_public_libBo myc_vlinkage_shlib_export
#  define myc_vlinkage_private_libBo myc_vlinkage_shlib_private
#  define myc_vlinkage_internal_libBo myc_vlinkage_shlib_internal

# endif /* __myc_use_archive(libBo) */
# endif /* __myc_build_archive(libBo) */
# endif /* __myc_use_shlib(libBo) */
# endif /* __myc_build_shlib(libBo) */

#endif /* !__BOLINKAGE__ */

/******************************************************************************
 * Revision History:
 *		$Log$
 *
 *****************************************************************************/
