/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright (c) 2005-2007 V.Sokur
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

/*
 * BoString.h	(N.Panasiuk)
 * include/Bo/BoString.h
 *
 * $Id$
 */

/* ------------------------------------------------------------------------- */

#ifndef __BO_STRING__
# define __BO_STRING__

/******************************************************************************
 * %% BeginSection: includes
 */

# include <Bo/Types.h>
# include <Bo/libc/Stdarg.h>

/******************************************************************************
 * %% BeginSection: function prototypes
 */
# pragma mark -
# pragma mark [ function prototypes ]
# pragma mark -

# include <Bo/BoLinkage.h>

__MYC_BEGIN_CDECLS

__myc_flinkage__(public,libBo) void
__attribute__((nonnull(1)))
BoSTRfree(
# if __myc_require(prototypes)
	char **
# endif
	);

__myc_flinkage__(public,libBo) void
__attribute__((nonnull(1)))
BoWCSfree(
# if __myc_require(prototypes)
	wchar_t **
# endif
	);

# pragma mark -

__myc_flinkage__(public,libBo) size_t
BoSTRlen(
# if __myc_require(prototypes)
	char const *
# endif
	);

__myc_flinkage__(public,libBo) size_t
BoWCSlen(
# if __myc_require(prototypes)
	wchar_t const *
# endif
	);

# pragma mark -

__myc_flinkage__(public,libBo) int
BoSTRempty(
# if __myc_require(prototypes)
	char const *
# endif
	);

__myc_flinkage__(public,libBo) int
BoWCSempty(
# if __myc_require(prototypes)
	wchar_t const *
# endif
	);

# pragma mark -

__myc_flinkage__(public,libBo) char **
__attribute__((nonnull(1)))
BoSTRcpy(
# if __myc_require(prototypes)
	char **, char const *
# endif
	);

__myc_flinkage__(public,libBo) wchar_t **
__attribute__((nonnull(1)))
BoWCScpy(
# if __myc_require(prototypes)
	wchar_t **, wchar_t const *
# endif
	);

# pragma mark -

__myc_flinkage__(public,libBo) char **
__attribute__((nonnull(1)))
BoSTRncpy(
# if __myc_require(prototypes)
	char **, char const *, size_t
# endif
	);

__myc_flinkage__(public,libBo) wchar_t **
__attribute__((nonnull(1)))
BoWCSncpy(
# if __myc_require(prototypes)
	wchar_t **, wchar_t const *, size_t
# endif
	);

# pragma mark -

__myc_flinkage__(public,libBo) char **
__attribute__((nonnull(1)))
BoSTRcat(
# if __myc_require(prototypes)
	char **, char const *
# endif
	);

__myc_flinkage__(public,libBo) wchar_t **
__attribute__((nonnull(1)))
BoWCScat(
# if __myc_require(prototypes)
	wchar_t **, wchar_t const *
# endif
	);

# pragma mark -

__myc_flinkage__(public,libBo) char **
__attribute__((nonnull(1)))
BoSTRncat(
# if __myc_require(prototypes)
	char **, char const *, size_t
# endif
	);

__myc_flinkage__(public,libBo) wchar_t **
__attribute__((nonnull(1)))
BoWCSncat(
# if __myc_require(prototypes)
	wchar_t **, wchar_t const *, size_t
# endif
	);

# pragma mark -

__myc_flinkage__(public,libBo) char **
__attribute__((nonnull(1)))
BoSTRprintf(
# if __myc_require(prototypes)
	char **, char const *, ...
# endif
	);

__myc_flinkage__(public,libBo) wchar_t **
__attribute__((nonnull(1)))
BoWCSprintf(
# if __myc_require(prototypes)
	wchar_t **, wchar_t const *, ...
# endif
	);

# pragma mark -

__myc_flinkage__(public,libBo) char **
__attribute__((nonnull(1)))
BoSTRvprintf(
# if __myc_require(prototypes)
	char **, char const *, va_list
# endif
	);

__myc_flinkage__(public,libBo) wchar_t **
__attribute__((nonnull(1)))
BoWCSvprintf(
# if __myc_require(prototypes)
	wchar_t **, wchar_t const *, va_list
# endif
	);

# pragma mark -

__myc_flinkage__(public,libBo) char **
__attribute__((nonnull(1)))
BoSTRcatprintf(
# if __myc_require(prototypes)
	char **, char const *, ...
# endif
	);

__myc_flinkage__(public,libBo) wchar_t **
__attribute__((nonnull(1)))
BoWCScatprintf(
# if __myc_require(prototypes)
	wchar_t **, wchar_t const *, ...
# endif
	);

# pragma mark -

__myc_flinkage__(public,libBo) char **
__attribute__((nonnull(1)))
BoSTRcatvprintf(
# if __myc_require(prototypes)
	char **, char const *, va_list
# endif
	);

__myc_flinkage__(public,libBo) wchar_t **
__attribute__((nonnull(1)))
BoWCScatvprintf(
# if __myc_require(prototypes)
	wchar_t **, wchar_t const *, va_list
# endif
	);

# pragma mark -

__myc_flinkage__(public,libBo) char **
__attribute__((nonnull(1)))
BoSTRintercalate(
# if __myc_require(prototypes)
	char **, char const *, size_t, ...
# endif
	);

__myc_flinkage__(public,libBo) wchar_t **
__attribute__((nonnull(1)))
BoWCSintercalate(
# if __myc_require(prototypes)
	wchar_t **, wchar_t const *, size_t, ...
# endif
	);

# pragma mark -

__myc_flinkage__(public,libBo) char **
__attribute__((nonnull(1)))
BoSTRvintercalate(
# if __myc_require(prototypes)
	char **, char const *, size_t, va_list
# endif
	);

__myc_flinkage__(public,libBo) wchar_t **
__attribute__((nonnull(1)))
BoWCSvintercalate(
# if __myc_require(prototypes)
	wchar_t **, wchar_t const *, size_t, va_list
# endif
	);

# pragma mark -

__myc_flinkage__(public,libBo) char **
__attribute__((nonnull(1)))
BoSTRnintercalate(
# if __myc_require(prototypes)
	char **, char const *, char *const *, size_t
# endif
	);

__myc_flinkage__(public,libBo) wchar_t **
__attribute__((nonnull(1)))
BoWCSnintercalate(
# if __myc_require(prototypes)
	wchar_t **, wchar_t const *, wchar_t *const *, size_t
# endif
	);

__MYC_END_CDECLS

#endif /* !__BO_STRING__ */

/******************************************************************************
 * Revision History:
 *		$Log$
 *
 *****************************************************************************/
