/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright (c) 2005-2007 V.Sokur
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

/*
 * BoVersion.h	(V.Sokur)
 * include/Bo/BoVersion.h
 *
 * $Id$
 */

/* ------------------------------------------------------------------------- */

#ifndef __BOVERSION__
# define __BOVERSION__

/******************************************************************************
 * %% BeginSection: includes
 */

# include <Bo/sys/Types.h>

/******************************************************************************
 * %% BeginSection: definitions
 */

# define BOLIB_MAJOR_VERSION 2
# define BOLIB_MINOR_VERSION 8
# define BOLIB_TEENY_VERSION 1

# define BOLIB_VERSION _BO_MKVERSION(BOLIB_MAJOR_VERSION,BOLIB_MINOR_VERSION,BOLIB_TEENY_VERSION)
# define BOLIB_VERSION_STR _BO_MKSVERSION(BOLIB_MAJOR_VERSION,\
	BOLIB_MINOR_VERSION,BOLIB_TEENY_VERSION)

# define BOLIB_VERSION_MIN(aMajor,aMinor,aTeeny) \
	(((aMajor) < BOLIB_MAJOR_VERSION) \
	|| ((aMajor) == BOLIB_MAJOR_VERSION && (aMinor) < BOLIB_MINOR_VERSION) \
	|| ((aMajor) == BOLIB_MAJOR_VERSION && (aMinor) == BOLIB_MINOR_VERSION \
		&& (aTeeny) <= BOLIB_TEENY_VERSION))

#endif /* !__BOVERSION__ */

/******************************************************************************
 * Revision History:
 *		$Log$
 *
 *****************************************************************************/
