/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright (c) 2005-2007 V.Sokur
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

/*
 * Funcjmp.h	(V.Sokur)
 * include/Bo/Funcjmp.h
 *
 * $Id$
 */

/* ------------------------------------------------------------------------- */

#ifndef __BO_FUNCJMP__
# define __BO_FUNCJMP__

/******************************************************************************
 * %% BeginSection: includes
 */

/*
BO_USES_FUNCJMP
BO_FUNCJMPBUF_(aVar)
BO_INITFUNCJMP(aVar,aText)
BO_SETFUNCJMP(aText)
BO_ENDFUNCJMP(aText)
BO_FUNCJMP_EXIT({...})
BO_FUNCJMP_BREAK(aLevel,{ goto LABEL-FOR-LEVEL; })
 */

# include <Bo/Cdefs.h>

# include _BO_COMPILER_HEADER(_Funcjmp.h)

# define BO_FUNCJMP_TRY(aVar,aText) BO_INITFUNCJMP(aVar,aText);
# define BO_FUNCJMP_FINALLY(aText) BO_SETFUNCJMP(aText)
# define BO_FUNCJMP_END(aText) BO_ENDFUNCJMP(aText);

#endif /* !__BO_FUNCJMP__ */

/******************************************************************************
 * Revision History:
 *		$Log$
 *
 *****************************************************************************/
