/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright (c) 2005-2007 V.Sokur
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

/*
 * SMessages.h	(V.Sokur)
 * include/Bo/SMessages.h
 *
 * $Id$
 */

/* ------------------------------------------------------------------------- */

#ifndef __BO_STATUS_MESSAGES__
# define __BO_STATUS_MESSAGES__

/******************************************************************************
 * %% BeginSection: constant declarations
 */
# pragma mark -
# pragma mark [ constant declarations ]
# pragma mark -

/* ============================================================================
 * ARGUMENT ERROR STATUS MESSAGES
 * @{
 */
# pragma mark -
# pragma mark [ argument error status messages ]
# pragma mark -

/*
 * BoK_ArgError_ArgListLimit
 */
# define SMSG_ArgError_ArgListLimit \
	"The argument list is too long."

# define SMSG_ArgError_ArgListLimit_s /* aParam) */ \
	"%s: an argument list is too long."

# define SMSG_ArgError_ArgListLimit_s2 /* (aFuncName/aProgName/...,aParam) */ \
	"%s(%s): an argument list is too long."

# define SMSG_ArgError_ArgListLimit_s3 /* (aServiceName,aFuncName/...,aParam) */ \
	"%s:%s(%s): an argument list is too long."

/*
 * BoK_ArgError_BadAddress
 */
# define SMSG_ArgError_BadAddress \
	"The argument points outside an allocated address space of the process."

# define SMSG_ArgError_BadAddress_s /* (aParamName) */ \
	"%s: the argument points outside an allocated address space of the process."

# define SMSG_ArgError_BadAddress_s2 /* (aFuncName,aParamName) */ \
	"%s(%s): the argument points outside an allocated address space of the process."

# define SMSG_ArgError_BadAddress_s3 /* (aServiceName,aFuncName,aParamName) */ \
	"%s:%s(%s): the argument points outside an allocated address space of the process."

/*
 * BoK_ArgError_InvalidArgument
 */
# define SMSG_ArgError_InvalidArgument \
	"Invalid argument."

# define SMSG_ArgError_InvalidArgument_s /* (aParamName) */ \
	"%s: invalid argument."

# define SMSG_ArgError_InvalidArgument_s2 /* (aFuncName,aParamName) */ \
	"%s(%s): invalid argument."

# define SMSG_ArgError_InvalidArgument_s3 /* (aService,aFuncName,aParamName) */ \
	"%s:%s(%s): invalid argument."

/*
 * BoK_ArgError_InvalidString
 */
# define SMSG_ArgError_InvalidString \
	"The string is empty or NUL pointer."

# define SMSG_ArgError_InvalidString_s /* (aParamName) */ \
	"%s: the string is empty or NUL pointer."

# define SMSG_ArgError_InvalidString_s2 /* (aFuncName,aParamName) */ \
	"%s(%s): the string is empty or NUL pointer."

# define SMSG_ArgError_InvalidString_s3 /* (aService,aFuncName,aParamName) */ \
	"%s:%s(%s): the string is empty or NUL pointer."

/*
 * BoK_ArgError_Overflow
 */
# define SMSG_ArgError_Overflow \
	"The buffer is too small."

# define SMSG_ArgError_Overflow_s /* (aParamName) */ \
	"%s: the buffer is too small."

# define SMSG_ArgError_Overflow_s2 /* (aFuncName,aParamName) */ \
	"%s(%s): the buffer is too small."

# define SMSG_ArgError_Overflow_s3 /* (aService,aFuncName,aParamName) */ \
	"%s:%s(%s): the buffer is too small."
/* @} */

/* ============================================================================
 * RESOURCE ACCESS ERROR STATUS MESSAGES
 * @{
 */
# pragma mark -
# pragma mark [ resource access error status messages ]
# pragma mark -

/*
 * BoK_RacError_OperationNotPermitted
 */
# define SMSG_RacError_OperationNotPermitted \
	"Operation not permitted.\n"          \
	"Process has not appropriate privileges to access a resource."

# define SMSG_RacError_OperationNotPermitted_s /* (anOperationName) */ \
	"%s: operation not permitted.\n"          \
	"Process has not appropriate privileges to access a resource."

# define SMSG_RacError_OperationNotPermitted_s3 /* (anOperationName,p1,p2) */ \
	"%s(%s, %s): operation not permitted.\n"           \
	"Process has not appropriate privileges to access a resource."

/*
 * BoK_RacError_AccessViolation
 */
# define SMSG_RacError_AccessViolation \
	"Access rights violation."

# define SMSG_RacError_AccessViolation_s /* (anOperationName) */ \
	"%s: access rights violation."

# define SMSG_RacError_AccessViolation_s2 /* (aService,anOperationName) */ \
	"%s:%s: access rights violation."

/*
 * BoK_RacError_DeadLock
 */
# define SMSG_RacError_DeadLock \
	"An attempt to lock the resource that would have resulted in a deadlock situation."

# define SMSG_RacError_DeadLock_s /* (aResourceName) */ \
	"%s: an attempt to lock the resource that would have resulted in a deadlock situation."

# define SMSG_RacError_DeadLock_s2 /* (anOperationName,aResourceName) */ \
	"%s:%s: an attempt to lock the resource that would have resulted in a deadlock situation."

# define SMSG_RacError_DeadLock_s3 /* (aService,anOperationName,aResourceName) */ \
	"%s:%s:%s: an attempt to lock the resource that would have resulted in a deadlock situation."

/*
 * BoK_RacError_WouldBlock
 */
# define SMSG_RacError_Again \
	"The resource temporarily unavailable."

# define SMSG_RacError_Again_s /* (aResourceName) */ \
	"%s: resource temporarily unavailable."

# define SMSG_RacError_Again_s2 /* (anOperationName,aResourceName) */ \
	"%s:%s: resource temporarily unavailable."

# define SMSG_RacError_Again_s3 /* (aService,anOperationName,aResourceName) */ \
	"%s:%s:%s: resource temporarily unavailable."

# define SMSG_RacError_WouldBlock \
	"The resource temporarily unavailable, operation would block."

# define SMSG_RacError_WouldBlock_s /* (aResourceName) */ \
	"%s: resource temporarily unavailable, operation would block."

# define SMSG_RacError_WouldBlock_s2 /* (anOperationName,aResourceName) */ \
	"%s:%s: resource temporarily unavailable, operation would block."

# define SMSG_RacError_WouldBlock_s3 /* (aService,anOperationName,aResourceName) */ \
	"%s:%s:%s: resource temporarily unavailable, operation would block."

/*
 * BoK_RacError_Busy
 */
# define SMSG_RacError_Busy \
	"The resource is used [by another process] in a conflicting manner."

# define SMSG_RacError_Busy_s /* (aResourceName) */ \
	"%s: resource is used [by another process] in a conflicting manner."

# define SMSG_RacError_Busy_s2 /* (anOperationName,aResourceName) */ \
	"%s:%s: resource is used [by another process] in a conflicting manner."

# define SMSG_RacError_Busy_s3 /* (aService,anOperationName,aResourceName) */ \
	"%s:%s:%s: resource is used [by another process] in a conflicting manner."

/*
 * BoK_RacError_NotConfigured
 */
# define SMSG_RacError_NotConfigured \
	"The resource not ready to use or no such resource."

# define SMSG_RacError_NotConfigured_s /* (aResourceName) */ \
	"%s: resource not ready to use or no such resource."

# define SMSG_RacError_NotConfigured_s2 /* (anOperationName,aResourceName) */ \
	"%s:%s: resource not ready to use or no such resource."

# define SMSG_RacError_NotConfigured_s3 /* (aService,anOperationName,aResourceName) */ \
	"%s:%s:%s: resource not ready to use or no such resource."

# define SMSG_RacError_NotConfigured_i /* (aResourceName) */ \
	"%d: resource not ready to use or no such resource."

# define SMSG_RacError_NotConfigured_si /* (anOperationName,aResourceName) */ \
	"%s:%d: resource not ready to use or no such resource."

# define SMSG_RacError_NotConfigured_s2i /* (aService,anOperationName,aResourceName) */ \
	"%s:%s:%d: resource not ready to use or no such resource."

/*
 * BoK_RacError_NoRsrcAvail
 */
# define SMSG_RacError_NoRsrcAvail \
	"No resource available."

# define SMSG_RacError_NoRsrcAvail_s /* (aResourceName) */ \
	"%s: no resource available."

# define SMSG_RacError_NoRsrcAvail_s2 /* (anOperationName,aResourceName) */ \
	"%s:%s: no resource available."

# define SMSG_RacError_NoRsrcAvail_s3 /* (aService,anOperationName,aResourceName) */ \
	"%s:%s:%s: no resource available."

# define SMSG_RacError_NoRsrcAvail_i /* (aResourceName) */ \
	"%d: no resource available."

# define SMSG_RacError_NoRsrcAvail_si /* (anOperationName,aResourceName) */ \
	"%s:%d: no resource available."

# define SMSG_RacError_NoRsrcAvail_s2i /* (aService,anOperationName,aResourceName) */ \
	"%s:%s:%d: no resource available."
/* @} */

/* ============================================================================
 * [Object] STATE ERROR STATUS MESSAGES
 * @{
 */
# pragma mark -
# pragma mark [ state error status messages ]
# pragma mark -

/*
 * BoK_StateError_Invalid
 */
# define SMSG_StateError_Invalid \
	"The object is in the invalid state."

# define SMSG_StateError_Invalid_s /* (aDevice) */ \
	"%s: the object is in the invalid state."

/*
 * BoK_StateError_NotConfigured
 */
# define SMSG_StateError_NotConfigured \
	"The object not ready to be used."

# define SMSG_StateError_NotConfigured_s /* (aDevice) */ \
	"{%s}: the object not ready to be used."

# define SMSG_StateError_NotConfigured_s2 /* (anOperationName,aDevice) */ \
	"%s{%s}: the object not ready to be used."

# define SMSG_StateError_NotConfigured_s3 /* (aService,anOperationName,aDevice) */ \
	"%s:%s{%s}: the object not ready to be used."

# define SMSG_StateError_NotConfigured_i /* (aDevice) */ \
	"{%d}: the object not ready to be used."

# define SMSG_StateError_NotConfigured_si /* (anOperationName,aDevice) */ \
	"%s{%d}: the object not ready to be used."

# define SMSG_StateError_NotConfigured_s2i /* (aService,anOperationName,aDevice) */ \
	"%s:%s{%d}: the object not ready to be used."

/*
 * BoK_StateError_WrongState
 */
# define SMSG_StateError_WrongState \
	"A wrong [object] state to perform operation."

# define SMSG_StateError_WrongState_s /* (aState) */ \
	"{%s}: wrong [object] state to perform operation."

# define SMSG_StateError_WrongState_s2 /* (aDevice,aState) */ \
	"{%s:%s}: wrong [object] state to perform operation."

# define SMSG_StateError_WrongState_s3 /* (anOperationName,aDevice,aState) */ \
	"%s{%s:%s}: wrong [object] state to perform operation."

# define SMSG_StateError_WrongState_s4 /* (aService,anOperationName,aDevice,aState) */ \
	"%s:%s{%s:%s}: wrong [object] state to perform operation."

# define SMSG_StateError_WrongState_i /* (aState) */ \
	"{%d}: wrong [object] state to perform operation."

# define SMSG_StateError_WrongState_i2 /* (aDevice,aState) */ \
	"{%d:%d}: wrong [object] state to perform operation."

# define SMSG_StateError_WrongState_si2 /* (anOperationName,aDevice,aState) */ \
	"%s{%d:%d}: wrong [object] state to perform operation."

# define SMSG_StateError_WrongState_s2i2 /* (aService,anOperationName,aDevice,aState) */ \
	"%s:%s{%d:%d}: wrong [object] state to perform operation."

/*
 * BoK_StateError_Already
 */
# define SMSG_StateError_Already \
	"The object already in the state."

# define SMSG_StateError_Already_s /* (aState) */ \
	"{%s}: the object already in the state."

# define SMSG_StateError_Already_s2 /* (aDevice,aState) */ \
	"{%s:%s}: the object already in the state."

# define SMSG_StateError_Already_s3 /* (anOperationName,aDevice,aState) */ \
	"%s{%s:%s}: the object already in the state."

# define SMSG_StateError_Already_s4 /* (aService,anOperationName,aDevice,aState) */ \
	"%s:%s{%s:%s}: the object already in the state."

# define SMSG_StateError_Already_i /* (aState) */ \
	"{%d}: the object already in the state."

# define SMSG_StateError_Already_i2 /* (aDevice,aState) */ \
	"{%d:%d}: the object already in the state."

# define SMSG_StateError_Already_si2 /* (anOperationName,aDevice,aState) */ \
	"%s{%d:%d}: the object already in the state."

# define SMSG_StateError_Already_s2i2 /* (aService,anOperationName,aDevice,aState) */ \
	"%s:%s{%d:%d}: the object already in the state."

/*
 * BoK_StateError_Destructible
 */
# define SMSG_StateError_Destructible \
	"An operation can be only performed in destructive manner,\n" \
	"when the object is in that state."

# define SMSG_StateError_Destructible_s /* (aState) */ \
	"{%s}: an operation can be only performed in destructive manner,\n" \
	"when the object is in that state."

# define SMSG_StateError_Destructible_s2 /* (aDevice,aState) */ \
	"{%s:%s}: an operation can be only performed in destructive manner,\n" \
	"when the object is in that state."

# define SMSG_StateError_Destructible_s3 /* (anOperationName,aDevice,aState) */ \
	"%s{%s:%s}: the operation can be only performed in destructive manner,\n" \
	"when the object is in that state."

# define SMSG_StateError_Destructible_s4 /* (aService,anOperationName,aDevice,aState) */ \
	"%s:%s{%s:%s}: the operation can be only performed in destructive manner,\n" \
	"when the object is in that state."

# define SMSG_StateError_Destructible_i /* (aState) */ \
	"{%d}: an operation can be only performed in destructive manner,\n" \
	"when the object is in that state."

# define SMSG_StateError_Destructible_i2 /* (aDevice,aState) */ \
	"{%d:%d}: an operation can be only performed in destructive manner,\n" \
	"when the object is in that state."

# define SMSG_StateError_Destructible_si2 /* (anOperationName,aDevice,aState) */ \
	"%s{%d:%d}: the operation can be only performed in destructive manner,\n" \
	"when the object is in that state."

# define SMSG_StateError_Destructible_s2i2 /* (aService,anOperationName,aDevice,aState) */ \
	"%s:%s{%d:%d}: the operation can be only performed in destructive manner,\n" \
	"when the object is in that state."
/* @} */

/* ============================================================================
 * OPERATIONAL ERROR STATUS MESSAGES
 * @{
 */
# pragma mark -
# pragma mark [ operational error status messages ]
# pragma mark -

/*
 * BoK_OpError_Inappropriate
 */
# define SMSG_OpError_Inappropriate \
	"Inappropriate operation."

# define SMSG_OpError_Inappropriate_i /* (aDevice) */ \
	"{%d}: inappropriate operation."

# define SMSG_OpError_Inappropriate_i2 /* (anOperationName,aDevice) */ \
	"%d{%d}: inappropriate operation."

# define SMSG_OpError_Inappropriate_s /* (aDevice) */ \
	"{%s}: inappropriate operation."

# define SMSG_OpError_Inappropriate_s2 /* (anOperationName,aDevice) */ \
	"%s{%s}: inappropriate operation."

# define SMSG_OpError_Inappropriate_is /* (anOperationName,aDevice) */ \
	"%d{%s}: inappropriate operation."

# define SMSG_OpError_Inappropriate_si /* (anOperationName,aDevice) */ \
	"%s{%d}: inappropriate operation."

/*
 * BoK_OpError_NotImpl
 */
# define SMSG_OpError_NotImpl \
	"The function (operation) not implemented [in this implementation]."

# define SMSG_OpError_NotImpl_s /* (aFuncName) */ \
	"%s: function (operation) not implemented [in this implementation]."

/*
 * BoK_OpError_NotAvail
 */
# define SMSG_OpError_NotAvail \
	"Inappropriate operation to the [device] implementation."

# define SMSG_OpError_NotAvail_i /* (aDevice) */ \
	"{%d}: inappropriate operation to the [device] implementation."

# define SMSG_OpError_NotAvail_i2 /* (anOperationName,aDevice) */ \
	"%d{%d}: inappropriate operation to the [device] implementation."

# define SMSG_OpError_NotAvail_s /* (aDevice) */ \
	"{%s}: inappropriate operation to the [device] implementation."

# define SMSG_OpError_NotAvail_s2 /* (anOperationName,aDevice) */ \
	"%s{%s}: inappropriate operation to the [device] implementation."

# define SMSG_OpError_NotAvail_is /* (anOperationName,aDevice) */ \
	"%d{%s}: inappropriate operation to the [device] implementation."

# define SMSG_OpError_NotAvail_si /* (anOperationName,aDevice) */ \
	"%s{%d}: inappropriate operation to the [device] implementation."

/*
 * BoK_OpError_NotSupp
 */
# define SMSG_OpError_NotSupp \
	"The implementation does not support the operation [of the standard]."

# define SMSG_OpError_NotSupp_i /* (anOperationName) */ \
	"%d: implementation does not support the operation [of the standard]."

# define SMSG_OpError_NotSupp_i2 /* (aService,anOperationName) */ \
	"%d:%d: implementation does not support the operation [of the standard]."

# define SMSG_OpError_NotSupp_s /* (anOperationName) */ \
	"%s: implementation does not support the operation [of the standard]."

# define SMSG_OpError_NotSupp_s2 /* (aService,anOperationName) */ \
	"%s:%s: implementation does not support the operation [of the standard]."

# define SMSG_OpError_NotSupp_si /* (aService,anOperationName) */ \
	"%s:%d: implementation does not support the operation [of the standard]."

# define SMSG_OpError_NotSupp_is /* (aService,anOperationName) */ \
	"%d:%s: implementation does not support the operation [of the standard]."

/*
 * BoK_OpError_FeatureNotSupp
 */
# define SMSG_OpError_FeatureNotSupp \
	"The implementation does not support the feature [of the standard]."

# define SMSG_OpError_FeatureNotSupp_i /* (aFeatureName) */ \
	"<%d>: implementation does not support the feature [of the standard]."

# define SMSG_OpError_FeatureNotSupp_i2 /* (anOperationName,aFeatureName) */ \
	"%d<%d>: implementation does not support the feature [of the standard]."

# define SMSG_OpError_FeatureNotSupp_i3 /* (aService,anOperationName,aFeatureName) */ \
	"%d:%d<%d>: implementation does not support the feature [of the standard]."

# define SMSG_OpError_FeatureNotSupp_s /* (aFeatureName) */ \
	"%s: implementation does not support the feature [of the standard]."

# define SMSG_OpError_FeatureNotSupp_s2 /* (anOperationName,aFeatureName) */ \
	"%s<%s>: implementation does not support the feature [of the standard]."

# define SMSG_OpError_FeatureNotSupp_s3 /* (aService,anOperationName,aFeatureName) */ \
	"%s:%s<%s>: implementation does not support the feature [of the standard]."

/*
 * BoK_OpError_InProgress
 */
# define SMSG_OpError_InProgress \
	"The blocking operation now in progress,\n" \
	"[the asynchronous operation has not yet completed]."

# define SMSG_OpError_InProgress_s /* (anOperationName) */ \
	"%s: blocking operation now in progress,\n" \
	"[the asynchronous operation has not yet completed]."

# define SMSG_OpError_InProgress_s2 /* (aService,anOperationName) */ \
	"%s:%s: blocking operation now in progress,\n" \
	"[the asynchronous operation has not yet completed]."

/*
 * BoK_OpError_Already
 */
# define SMSG_OpError_Already \
	"The operation [on non-blocking device] already in progress."

# define SMSG_OpError_Already_s /* (anOperationName) */ \
	"%s: operation [on non-blocking device] already in progress."

# define SMSG_OpError_Already_s2 /* (aService,anOperationName) */ \
	"%s:%s: operation [on non-blocking device] already in progress."

/*
 * BoK_OpError_Canceled
 */
# define SMSG_OpError_Canceled \
	"The asynchronous operation was cancelled before completion."

# define SMSG_OpError_Canceled_s /* (anOperationName) */ \
	"%s: asynchronous operation was cancelled before completion."

# define SMSG_OpError_Canceled_s2 /* (aService,anOperationName) */ \
	"%s:%s: asynchronous operation was cancelled before completion."

/*
 * BoK_OpError_Interrupted
 */
# define SMSG_OpError_Interrupted \
	"The execution of an interruptible function was interrupted by\n" \
	"an asynchronous signal (such as quit or terminate signal)."

# define SMSG_OpError_Interrupted_s /* (aCallName) */ \
	"%s: execution of an interruptible function was interrupted by\n" \
	"an asynchronous signal (such as quit or terminate signal)."

# define SMSG_OpError_Interrupted_s2 /* (aService,aCallName) */ \
	"%s:%s: execution of an interruptible function was interrupted by\n" \
	"an asynchronous signal (such as quit or terminate signal)."

/*
 * BoK_OpError_TimedOut
 */
# define SMSG_OpError_TimedOut \
	"The operation timed out."

# define SMSG_OpError_TimedOut_s /* (anOperationName) */ \
	"%s: operation timed out."

# define SMSG_OpError_TimedOut_s2 /* (aService,anOperationName) */ \
	"%s:%s: operation timed out."

/*
 * BoK_OpError_UnwillingToPerform
 */
# define SMSG_OpError_UnwillingToPerform \
	"Unwilling to perform operation."

# define SMSG_OpError_UnwillingToPerform_s /* (anOperationName) */ \
	"%s: unwilling to perform operation."

# define SMSG_OpError_UnwillingToPerform_s2 /* (anOperationName,aDevice) */ \
	"%s{%s}: unwilling to perform operation."

/*
 * BoK_OpError_NotAvailIf
 */
# define SMSG_OpError_NotAvailIf_s /* aReason */ \
	"Inappropriate operation in some circumstances.\n" \
	"%s."

# define SMSG_OpError_NotAvailIf_is /* (aDevice,aReason) */ \
	"{%d}: inappropriate operation in some circumstances.\n" \
	"%s."

# define SMSG_OpError_NotAvailIf_i2s /* (anOperationName,aDevice,aReason) */ \
	"%d{%d}: inappropriate operation in some circumstances.\n" \
	"%s."

# define SMSG_OpError_NotAvailIf_s2 /* (aDevice,aReason) */ \
	"{%s}: inappropriate operation in some circumstances.\n" \
	"%s."

# define SMSG_OpError_NotAvailIf_s3 /* (anOperationName,aDevice,aReason) */ \
	"%s{%s}: inappropriate operation in some circumstances.\n" \
	"%s."

# define SMSG_OpError_NotAvailIf_is2 /* (anOperationName,aDevice,aReason) */ \
	"%d{%s}: inappropriate operation in some circumstances.\n" \
	"%s."

# define SMSG_OpError_NotAvailIf_sis /* (anOperationName,aDevice,aReason) */ \
	"%s{%d}: inappropriate operation in some circumstances.\n" \
	"%s."

/*
 * BoK_OpError_NotSuppIf
 */
# define SMSG_OpError_NotSuppIf_s /* aReason */ \
	"Unsupported operation [of the standard] in some circumstances.\n" \
	"%s."

# define SMSG_OpError_NotSuppIf_is /* (anOperationName,aReason) */ \
	"%d: unsupported operation [of the standard] in some circumstances.\n" \
	"%s."

# define SMSG_OpError_NotSuppIf_i2s /* (aService,anOperationName,aReason) */ \
	"%d:%d: unsupported operation [of the standard] in some circumstances.\n" \
	"%s."

# define SMSG_OpError_NotSuppIf_s2 /* (anOperationName,aReason) */ \
	"%s: unsupported operation [of the standard] in some circumstances.\n" \
	"%s."

# define SMSG_OpError_NotSuppIf_s3 /* (aService,anOperationName,aReason) */ \
	"%s:%s: unsupported operation [of the standard] in some circumstances.\n" \
	"%s."

# define SMSG_OpError_NotSuppIf_sis /* (aService,anOperationName,aReason) */ \
	"%s:%d: unsupported operation [of the standard] in some circumstances.\n" \
	"%s."

# define SMSG_OpError_NotSuppIf_is2 /* (aService,anOperationName,aReason) */ \
	"%d:%s: unsupported operation [of the standard] in some circumstances.\n" \
	"%s."

/* ============================================================================
 * TEXT ERROR STATUS MESSAGES
 * @{
 */
# pragma mark -
# pragma mark [ text error status messages ]
# pragma mark -

/*
 * BoK_TextError_IllegalMBSequence
 */
# define SMSG_TextError_IllegalMBSequence \
	"Illegal multibyte sequence."

/*
 * BoK_TextError_IncompleteMBSequence
 */
# define SMSG_TextError_IncompleteMBSequence \
	"Incomplete multibyte sequence."

/*
 * BoK_TextError_BadUnicodeCharacter
 */
# define SMSG_TextError_BadUnicodeCharacter \
	"Bad UNICODE character."

/*
 * BoK_TextError_MBOverflow
 */
# define SMSG_TextError_MBOverflow  \
	"Buffer for a multibyte character is too small."

/*
 * BoK_TextError_TokenMaxLen
 */
# define SMSG_TextError_TokenMaxLen \
	"The token is too long."

# define SMSG_TextError_TokenMaxLen_s /* (aToken) */ \
	"%s: token too long."

/*
 * BoK_TextError_InvalidSyntax
 */
# define SMSG_TextError_InvalidSyntax \
	"A syntax error."

# define SMSG_TextError_InvalidSyntax_s2 /* (aText,aRule) */ \
	"%s: <# %s #> syntax error."

/*
 * BoK_TextError_EndOfText
 */
# define SMSG_TextError_EndOfText \
	"Syntax error: end of text reached."

# define SMSG_TextError_EndOfText_s /* (aRule) */ \
	"<# %s #> syntax error: end of text reached."

/*
 * BoK_TextError_UnmatchedCharacter
 */
# define SMSG_TextError_UnmatchedCharacter \
	"Syntax error: unmatched character."

# define SMSG_TextError_UnmatchedCharacter_s2c /* (aText,aRule,aChar) */ \
	"%s: <# %s #> syntax error: unmatched character \'%c\'."

/*
 * BoK_TextError_EmptyToken
 */
# define SMSG_TextError_EmptyToken \
	"Syntax error: required token is empty."

# define SMSG_TextError_EmptyToken_s2 /* (aRule,aTokenName) */ \
	"<# %s #> syntax error: required token \'%s\' empty."

/*
 * BoK_TextError_UnexpectedToken
 */
# define SMSG_TextError_UnexpectedToken \
	"Syntax error: unexpected token."

# define SMSG_TextError_UnexpectedToken_s2 /* (aText,aRule) */ \
	"%s: <# %s #> syntax error: unexpected token."

# define SMSG_TextError_UnexpectedToken_s3 /* (aText,aRule,aToken) */ \
	"%s: <# %s #> syntax error: unexpected token \'%s\'."

/*
 * BoK_TextError_MissingToken
 */
# define SMSG_TextError_MissingToken \
	"Syntax error: missing token."

# define SMSG_TextError_MissingToken_s2 /* (aText,aRule) */ \
	"%s: <# %s #> syntax error: missing token."

# define SMSG_TextError_MissingToken_s3 /* (aText,aRule,aToken) */ \
	"%s: <# %s #> syntax error: missing token \'%s\'."

/*
 * BoK_TextError_BadToken
 */
# define SMSG_TextError_BadToken \
	"Syntax error: bad token."

# define SMSG_TextError_BadToken_s2 /* (aText,aRule) */ \
	"%s: <# %s #> syntax error: bad token."

# define SMSG_TextError_BadToken_s3 /* (aText,aRule,aToken) */ \
	"%s: <# %s #> syntax error: bad token \'%s\'."
/* @} */

/* ============================================================================
 * AUTHENTICATION ERROR STATUS MESSAGES
 * @{
 */
# pragma mark -
# pragma mark [ authentication error status messages ]
# pragma mark -

/*
 * BoK_AuthError_NoInformation
 */
# define SMSG_AuthError_NoInformation \
	"Authentication runtime error."

# define SMSG_AuthError_NoInformation_s /* (anOperationName) */ \
	"%s: authentication runtime error."

# define SMSG_AuthError_NoInformation_s2 /* (aService,anOperationName) */ \
	"%s:%s: authentication runtime error."

/*
 * BoK_AuthError_NeedAuth
 */
# define SMSG_AuthError_NeedAuth \
	"Need authenticator."

# define SMSG_AuthError_NeedAuth_s /* (anOperationName) */ \
	"%s: need authenticator."

# define SMSG_AuthError_NeedAuth_s2 /* (aService,anOperationName) */ \
	"%s:%s: need authenticator."
/* @} */

/* ============================================================================
 * MATH ERROR STATUS MESSAGES
 * @{
 */
# pragma mark -
# pragma mark [ math error status messages ]
# pragma mark -

/*
 * BoK_MathError_OutOfDomain
 */
# define SMSG_MathError_OutOfDomain \
	"The numerical argument out of domain."

# define SMSG_MathError_OutOfDomain_s /* (aFuncName) */ \
	"%s(): numerical argument out of domain."

# define SMSG_MathError_OutOfDomain_s2 /* (aService,aFuncName) */ \
	"%s:%s(): numerical argument out of domain."

/*
 * BoK_MathError_ResultRange
 */
# define SMSG_MathError_ResultRange \
	"The result is too large or too small."

# define SMSG_MathError_ResultRange_s /* (aFuncName) */ \
	"%s(): result too large or too small."

# define SMSG_MathError_ResultRange_s2 /* (aService,aFuncName) */ \
	"%s:%s(): result too large or too small."
/* @} */

/* ============================================================================
 * COMMON SYSTEM ERROR STATUS MESSAGES
 * @{
 */
# pragma mark -
# pragma mark [ common system error status messages ]
# pragma mark -

/*
 * BoK_SysError_NoInformation
 */
# define SMSG_SysError_NoInformation \
	"System runtime error."

# define SMSG_SysError_NoInformation_i /* (system-error-code) */ \
	"%d: runtime error."

# define SMSG_SysError_NoInformation_s /* (aText) */ \
	"%s: runtime error."

/*
 * BoK_SysError_NoSuchProcess
 */
# define SMSG_SysError_NoSuchProcess \
	"No such process."

# define SMSG_SysError_NoSuchProcess_i /* (aProcessId) */ \
	"%d: no such process."

# define SMSG_SysError_NoSuchProcess_s /* (aProcessName) */ \
	"%s: no such process."

/*
 * BoK_SysError_InvalidExecFormat
 */
# define SMSG_SysError_InvalidExecFormat \
	"The file is not in the format required by the implementation for executable files."

# define SMSG_SysError_InvalidExecFormat_s /* (aName) */ \
	"%s: the file is not in the format required by the implementation for executable files."

/*
 * BoK_SysError_NoChildToWait
 */
# define SMSG_SysError_NoChildToWait \
	"No child processes to wait."

/*
 * BoK_SysError_NoMemory
 */
# define SMSG_SysError_NoMemory \
	"Can not perform local memory allocation."

# define SMSG_SysError_NoMemory_s /* (anOperationName) */ \
	"%s: operation failure: can not perform local memory allocation."

# define SMSG_SysError_ObjectCreate_s /* (anObjectName) */ \
	"%s: fail to create an object: can not perform local memory allocation."

# define SMSG_SysError_Strdup_s /* (aString) */ \
	"%s: fail to duplicate a string: can not perform local memory allocation."

/*
 * BoK_SysError_ProcsLimit
 */
# define SMSG_SysError_ProcsLimit \
	"Too many processes."

/*
 * BoK_SysError_UsersLimit
 */
# define SMSG_SysError_UsersLimit \
	"Too many users."

/*
 * BoK_SysError_DiskQuota
 */
# define SMSG_SysError_DiskQuota \
	"Disc quota exceeded."
/* @} */

/* ============================================================================
 * I/O ERROR STATUS MESSAGES
 * @{
 */
# pragma mark -
# pragma mark [ I/O error status messages ]
# pragma mark -

/*
 * BoK_IoError_NoInformation
 */
# define SMSG_IoError_NoInformation \
	"[Physical] input/output runtime error."
/* 1. Making a directory entry
   2. Allocating an inode
   3. Reading from/writing to a file system */

# define SMSG_IoError_NoInformation_i /* system-error-code */ \
	"%d: [physical] input/output runtime error."

/*
 * BoK_IoError_NotConfigured
 */
# define SMSG_IoError_NotConfigured \
	"Device not configured, no such device or address."

# define SMSG_IoError_NotConfigured_s /* (aDevice) */ \
	"{%s}: device not configured, no such device or address."

/*
 * BoK_IoError_NotBlockDevice
 */
# define SMSG_IoError_NotBlockDevice \
	"Block device required."

# define SMSG_IoError_NotBlockDevice_s /* (aService) */ \
	"%s: block device required."

/*
 * BoK_IoError_NotSeekable
 */
# define SMSG_IoError_NotSeekable \
	"Illegal seek operation on a stream(file)," \
	" which does not support the seek operation."

# define SMSG_IoError_NotSeekable_s /* (aDevice) */ \
	"{%s}: illegal seek operation on a device," \
	" which does not support the seek operation."

# define SMSG_IoError_NotSeekable_s2 /* (aService,aDevice) */ \
	"%s{%s}: illegal seek operation on a device," \
	" which does not support the seek operation."

/*
 * BoK_IoError_NotSuppDevice
 */
# define SMSG_IoError_NotSuppDevice \
	"Not supported device."

# define SMSG_IoError_NotSuppDevice_s /* (aDevice) */ \
	"{%s}: not supported device."

# define SMSG_IoError_NotSuppDevice_s2 /* (aService,aRequiredDevice/aRequiredService) */ \
	"%s: {%s} device(s) required."

/*
 * BoK_IoError_NoPortAvail
 */
# define SMSG_IoError_NoPortAvail \
	"No free ports available."

# define SMSG_IoError_NoPortAvail_s /* (aDevice) */ \
	"{%s}: no free ports available."
/* @} */

/* ============================================================================
 * FILE ERROR STATUS MESSAGES
 * @{
 */
# pragma mark -
# pragma mark [ file error status messages ]
# pragma mark -

/*
 * BoK_FileError_NoSuchEntry
 */
# define SMSG_FileError_NoSuchEntry \
	"No such file or directory."

# define SMSG_FileError_NoSuchEntry_s /* (aName) */ \
	"%s: no such file or directory."

# define SMSG_FileError_NotFound_s /* (aName) */ \
	"%s: the named file or directory not found."

# define SMSG_FileError_NotFound_s2 /* (aName,SearchPaths) */ \
	"%s: the named file or directory not found in the search paths:\n"  \
	"%s\n"

/*
 * BoK_FileError_BadDescriptor
 */
# define SMSG_FileError_BadDescriptor \
	"The file descriptor is out of range, referres to no open file."

# define SMSG_FileError_BadDescriptor_i /* (aDescriptor) */ \
	"%d: the file descriptor is out of range, referres to no open file."

/*
 * BoK_FileError_Busy
 */
# define SMSG_FileError_Busy \
	"Mount device busy."

# define SMSG_FileError_Busy_s /* (aDeviceName) */ \
	"%s: mount device busy."

/*
 * BoK_FileError_AlreadyExists
 */
# define SMSG_FileError_AlreadyExists \
	"The file or directory already exists."

# define SMSG_FileError_AlreadyExists_s /* (aPath) */ \
	"%s: the named file or directory already exists."

/*
 * BoK_FileError_CrossDeviceLink
 */
# define SMSG_FileError_CrossDeviceLink \
	"Cross-device link."

/*
 * BoK_FileError_OperationNotAvail
 */
# define SMSG_FileError_OperationNotAvail \
	"The inappropriate function to the [device] implementation."

# define SMSG_FileError_OperationNotAvail_s /* (anOperationName) */ \
	"%s: inappropriate operation to the [device] implementation."

# define SMSG_FileError_OperationNotAvail_s2 /* (aService,anOperationName) */ \
	"%s:%s: inappropriate operation to a device implementation."

/*
 * BoK_FileError_NotDir
 */
# define SMSG_FileError_NotDir \
	"A component of the path is not a directory."

# define SMSG_FileError_NotDir_s /* (aPath) */ \
	"%s: a component of the path is not a directory."

/*
 * BoK_FileError_IsDir
 */
# define SMSG_FileError_IsDir \
	"A component of the path is a directory."

# define SMSG_FileError_IsDir_s /* (aPath) */ \
	"%s: a component of the path is a directory."

/*
 * BoK_FileError_SysDescLimit
 */
# define SMSG_FileError_SysDescLimit \
	"Too many open files in system. File table overflow."

/*
 * BoK_FileError_ProcessDescLimit
 */
# define SMSG_FileError_ProcessDescLimit \
	"Too many open files. (Maximum number of file descriptors allowed in this process)."

/*
 * BoK_FileError_IoctlOperationNotAvail
 */
# define SMSG_FileError_IoctlOperationNotAvail \
	"Inappropriate [I/O] control function for a file or special file."

# define SMSG_FileError_IoctlOperationNotAvail_i /* (aCtl) */ \
	"%d: inappropriate [I/O] control function for a file or special file."

/*
 * BoK_FileError_TextBusy
 */
# define SMSG_FileError_TextBusy \
	"A text file busy."

# define SMSG_FileError_TextBusy_s /* (aPath) */ \
	"%s: the text file busy."

/*
 * BoK_FileError_FileSizeLimit
 */
# define SMSG_FileError_FileSizeLimit \
	"A file too large."

# define SMSG_FileError_FileSizeLimit_s /* (aPath) */ \
	"%s: the file too large."

/*
 * BoK_FileError_NoFreeSpace
 */
# define SMSG_FileError_NoFreeSpace \
	"No free space left on the device during a 'write' operation\n" \
	"on a regular file, or when extending a directory. Or there are no\n" \
	"free inodes [to use] on the file system."

/*
 * BoK_FileError_SeekOnPipe
 */
# define SMSG_FileError_SeekOnPipe \
	"Illegal seek operation on a pipe or FIFO."

/*
 * BoK_FileError_ReadOnlyFS
 */
# define SMSG_FileError_ReadOnlyFS \
	"The named file resides on a read-only file system."

# define SMSG_FileError_ReadOnlyFS_s /* (aPath) */ \
	"%s: the named file resides on a read-only file system."

/*
 * BoK_FileError_LinksLimit
 */
# define SMSG_FileError_LinksLimit \
	"Too many links of a single file."

/*
 * BoK_FileError_Loop
 */
# define SMSG_FileError_Loop \
	"Too many symbolic links were encountered in translating the pathname."

# define SMSG_FileError_Loop_s /* (aPath) */ \
	"%s: too many symbolic links were encountered in translating the pathname."

/*
 * BoK_FileError_NameSizeLimit
 */
# define SMSG_FileError_NameSizeLimit \
	"A file name [path component] exceeded {NAME_MAX} characters."

# define SMSG_FileError_NameSizeLimit_s /* (aPath) */ \
	"%s: a file name [path component] exceeded {NAME_MAX} characters."

# define SMSG_FileError_PathSizeLimit \
	"A file path exceeded {PATH_MAX} characters, or path component exceeded {NAME_MAX} characters."

# define SMSG_FileError_PathSizeLimit_s /* (aPath) */ \
	"%s: a file path exceeded {PATH_MAX} characters, or path component exceeded {NAME_MAX} characters."

/*
 * BoK_FileError_DirNotEmpty
 */
# define SMSG_FileError_DirNotEmpty \
	"A directory not empty."

# define SMSG_FileError_DirNotEmpty_s /* (aPath) */ \
	"%s: the directory not empty."

/*
 * BoK_FileError_NoLockAvail
 */
# define SMSG_FileError_NoLockAvail \
	"No locks available."
/* @} */

/* ============================================================================
 * IPC (Interprocess Communication) ERROR STATUS MESSAGES
 * @{
 */
# pragma mark -
# pragma mark [ IPC error status messages ]
# pragma mark -

/* ------------------------------------------------------------------------- */
/* Argument error status messages */
# pragma mark = IPC: argument error status messages =
/* ------------------------------------------------------------------------- */

/*
 * BoK_IpcError_NotSocket
 */
# define SMSG_IpcError_NotSocket \
	"Socket operation on a non-socket. Socket required."

# define SMSG_IpcError_NotSocket_s /* (anOperationName) */ \
	"%s: socket operation on a non-socket. Socket required."

# define SMSG_IpcError_NotSocket_is /* (aSockType,anOperationName) */ \
	"%d:%s: socket operation on a non-socket. Socket required."

# define SMSG_IpcError_NotSocket_s2 /* (aSockType,anOperationName) */ \
	"%s:%s: socket operation on a non-socket. Socket required."

/*
 * BoK_IpcError_DestAddrRequired
 */
# define SMSG_IpcError_DestAddrRequired \
	"Destination address required."

/*
 * BoK_IpcError_MsgSizeLimit
 */
# define SMSG_IpcError_MsgSizeLimit \
	"Message too long."

/*
 * BoK_IpcError_Prototype
 */
# define SMSG_IpcError_Prototype \
	"Protocol wrong type for socket."

/*
 * BoK_IpcError_ProtoNotAvail
 */
# define SMSG_IpcError_ProtoNotAvail \
	"Protocol not available."

/*
 * BoK_IpcError_ProtoNotSupp
 */
# define SMSG_IpcError_ProtoNotSupp \
	"Protocol not supported."

# define SMSG_IpcError_ProtoNotSupp_s /* (aProtoName) */ \
	"%s: protocol not supported."

/*
 * BoK_IpcError_SockTypeNotSupp
 */
# define SMSG_IpcError_SockTypeNotSupp \
	"Socket type not supported."

# define SMSG_IpcError_SockTypeNotSupp_s /* (aSockType) */ \
	"%s: socket type not supported."

/*
 * BoK_IpcError_OperationNotAvailOnSock
 */
# define SMSG_IpcError_OperationNotAvailOnSock \
	"Operation not supported on socket."

# define SMSG_IpcError_OperationNotAvailOnSock_s /* (anOperationName) */ \
	"%s: operation not supported on socket."

/*
 * BoK_IpcError_PFNotSupp
 */
# define SMSG_IpcError_PFNotSupp \
	"Protocol family not supported."

# define SMSG_IpcError_PFNotSupp_i /* (aProtoFamily) */ \
	"%d: protocol family not supported."

/*
 * BoK_IpcError_AFNotSupp
 */
# define SMSG_IpcError_AFNotSupp \
	"Address family not supported by protocol family."

# define SMSG_IpcError_AFNotSupp_i2 /* (anAddressFamily,aProtoFamily) */ \
	"%d{%d}: address family not supported by protocol family."

/*
 * BoK_IpcError_AddrInUse
 */
# define SMSG_IpcError_AddrInUse \
	"Address already in use."

/*
 * BoK_IpcError_AddrNotAvail
 */
# define SMSG_IpcError_AddrNotAvail \
	"Cannot assign requested address."

/* ------------------------------------------------------------------------- */
/* Operational error status messages */
# pragma mark = IPC: operational error status messages =
/* ------------------------------------------------------------------------- */

/*
 * BoK_IpcError_NetDown
 */
# define SMSG_IpcError_NetDown \
	"Network is down. There is a serious failure of network system."

/*
 * BoK_IpcError_NetUnreach
 */
# define SMSG_IpcError_NetUnreach \
	"Network is unreachable."

/*
 * BoK_IpcError_NetReset
 */
# define SMSG_IpcError_NetReset \
	"Network dropped connection on reset."

/*
 * BoK_IpcError_ConnectionAborted
 */
# define SMSG_IpcError_ConnectionAborted \
	"Software caused connection abort."

/*
 * BoK_IpcError_ConnectionReset
 */
# define SMSG_IpcError_ConnectionReset \
	"Connection reset by peer."

/*
 * BoK_IpcError_NoBufferSpace
 */
# define SMSG_IpcError_NoBufferSpace \
	"No internal buffer space available."

/*
 * BoK_IpcError_IsConnected
 */
# define SMSG_IpcError_IsConnected \
	"Socket already connected."

/*
 * BoK_IpcError_NotConnected
 */
# define SMSG_IpcError_NotConnected \
	"Socket not connected."

/*
 * BoK_IpcError_Shutdown
 */
# define SMSG_IpcError_Shutdown \
	"Cannot send after socket shutdown."

/*
 * BoK_IpcError_ConnectionRefused
 */
# define SMSG_IpcError_ConnectionRefused \
	"Connection refused."

/*
 * BoK_IpcError_HostDown
 */
# define SMSG_IpcError_HostDown \
	"Host is down."

/*
 * BoK_IpcError_HostUnreach
 */
# define SMSG_IpcError_HostUnreach \
	"No route to host."

/*
 * BoK_IpcError_BrokenPipe
 */
# define SMSG_IpcError_BrokenPipe \
	"Broken pipe."

/*
 * BoK_IpcError_BadMsg
 */
# define SMSG_IpcError_BadMsg \
	"An implementation detects a corrupted message."
/* @} */

/* ============================================================================
 * AIB (Abstract Information Base) ERROR STATUS MESSAGES
 * @{
 */
# pragma mark -
# pragma mark [ AIB error status messages ]
# pragma mark -

/* ------------------------------------------------------------------------- */
# pragma mark = AIB: name error status messages =
/* ------------------------------------------------------------------------- */

/*
 * BoK_AIBNameError_InvalidSyntax
 */
# define SMSG_AIBNameError_InvalidSyntax \
	"A name invalid syntax."

# define SMSG_AIBNameError_InvalidSyntax_s /* (anObjectName) */ \
	"%s: name invalid syntax."

/*
 * BoK_AIBNameError_NoSuchEntry
 */
# define SMSG_AIBNameError_NoSuchEntry \
	"The name does not match the name of any entry."

# define SMSG_AIBNameError_NoSuchEntry_i /* (aName) */ \
	"%d: name does not match the name of any entry."

# define SMSG_AIBNameError_NoSuchEntry_s /* (aName) */ \
	"%s: name does not match the name of any entry."

/*
 * BoK_AIBNameError_SizeLimit
 */
# define SMSG_AIBNameError_SizeLimit \
	"The entry name is too long."

# define SMSG_AIBNameError_SizeLimit_s /* (aName) */ \
	"%s: entry name too long."

/* ------------------------------------------------------------------------- */
# pragma mark = AIB: attribute error status messages =
/* ------------------------------------------------------------------------- */

/*
 * BoK_AIBAttrError_InvalidSyntax
 */
# define SMSG_AIBAttrError_InvalidSyntax \
	"Attribute invalid syntax."

# define SMSG_AIBAttrError_InvalidSyntax_s /* (anAttrName) */ \
	"%s: attribute invalid syntax."

/*
 * BoK_AIBAttrError_NoSuchAttribute
 */
# define SMSG_AIBAttrError_NoSuchEntry \
	"The name does not match the name of any attribute."

# define SMSG_AIBAttrError_NoSuchEntry_s /* (aName) */ \
	"%s: name does not match the name of any attribute."

# define SMSG_AIBAttrError_NoSuchEntry_s2 /* (aName,aValue) */ \
	"%s,%s: (name,value) does not match the (name,value) of any attribute."

/*
 * BoK_AIBAttrError_AlreadyExists
 */
# define SMSG_AIBAttrError_AlreadyExists \
	"The attribute with such name already exists in the entry."

# define SMSG_AIBAttrError_AlreadyExists_s /* (aName) */ \
	"%s: attribute with such name already exists in the entry."

/* ------------------------------------------------------------------------- */
# pragma mark == AIB: update error status messages ===
/* ------------------------------------------------------------------------- */

/*
 * BoK_AIBUpdateError_AlreadyExists
 */
# define SMSG_AIBUpdateError_AlreadyExists \
	"The entry already exists."

# define SMSG_AIBUpdateError_AlreadyExists_s /* (aName) */ \
	"%s: such entry already exists."

# define SMSG_AIBUpdateError_AlreadyExists_p_s /* (aParamName) */ \
	"The entry, pointed to by the parameter \'%s\', already exists."

/*
 * BoK_AIBUpdateError_NoSuchParent
 */
# define SMSG_AIBUpdateError_NoSuchParent \
	"No such parent entry."

# define SMSG_AIBUpdateError_NoSuchParent_s /* (aParentName) */ \
	"%s: no such parent entry."

/*
 * BoK_AIBUpdateError_NotAllowedOnTheEntry
 */
# define SMSG_AIBUpdateError_NotAllowedOnTheEntry \
	"Operation not allowed on the entry."

# define SMSG_AIBUpdateError_NotAllowedOnTheEntry_i /* (anEntryForm) */ \
	"{%d}: operation not allowed on the entry."

# define SMSG_AIBUpdateError_NotAllowedOnTheEntry_i2 /* (anOperationName, anEntryForm) */ \
	"%d{%d}: operation not allowed on the entry."

# define SMSG_AIBUpdateError_NotAllowedOnTheEntry_s /* (anEntryForm) */ \
	"{%s}: operation not allowed on the entry."

# define SMSG_AIBUpdateError_NotAllowedOnTheEntry_s2 /* (anOperationName, anEntryForm) */ \
	"%s{%s}: operation not allowed on the entry."

/*
 * BoK_AIBUpdateError_IsCompound
 */
# define SMSG_AIBUpdateError_IsCompound \
	"The entry is compound."

# define SMSG_AIBUpdateError_IsCompound_s /* (aName) */ \
	"%s: entry is compound."

/*
 * BoK_AIBUpdateError_NotCompound
 */
# define SMSG_AIBUpdateError_NotCompound \
	"The entry not compound."

# define SMSG_AIBUpdateError_NotCompound_s /* (aName) */ \
	"%s: entry not compound."

/*
 * BoK_AIBUpdateError_IsEmptyCompound
 */
# define SMSG_AIBUpdateError_IsEmptyCompound \
	"The compound entry is empty."

# define SMSG_AIBUpdateError_IsEmptyCompound_s /* (aName) */ \
	"%s: compound entry is empty."

/*
 * BoK_AIBUpdateError_NotEmptyCompound
 */
# define SMSG_AIBUpdateError_NotEmptyCompound \
	"The compound entry not empty."

# define SMSG_AIBUpdateError_NotEmptyCompound_s /* (aName) */ \
	"%s: compound entry not empty."

/*
 * BoK_AIBUpdateError_CompoundOverflow
 */
# define SMSG_AIBUpdateError_CompoundOverflow \
	"The compound entry overflow."

# define SMSG_AIBUpdateError_CompoundOverflow_s /* (aName) */ \
	"%s: compound entry overflow."

/*
 * BoK_AIBUpdateError_IsInserted
 */
# define SMSG_AIBUpdateError_IsInserted \
	"The entry is already inserted into a some tree."

# define SMSG_AIBUpdateError_IsInserted_s /* (aName) */ \
	"%s: entry is already inserted into a some tree."

# define SMSG_AIBUpdateError_IsInserted_s2 /* (aName, aParentName) */ \
	"%s: entry is already inserted into a some tree with parent entry: \'%s\'."

/*
 * BoK_AIBUpdateError_NotInserted
 */
# define SMSG_AIBUpdateError_NotInserted \
	"The entry not inserted into the any tree."

# define SMSG_AIBUpdateError_NotInserted_s /* (aName) */ \
	"%s: entry not inserted into the any tree."

/*
 * BoK_AIBUpdateError_IsMounted
 */
# define SMSG_AIBUpdateError_IsMounted \
	"The entry is already mounted."

# define SMSG_AIBUpdateError_IsMounted_s2 /* (aName, aMounpointName) */ \
	"%s: entry is already mounted to the mountpoint \'%s\'."

/*
 * BoK_AIBUpdateError_NotMounted
 */
# define SMSG_AIBUpdateError_NotMounted \
	"The entry is not mounted or not a mountpoint."

# define SMSG_AIBUpdateError_NotMounted_s /* (aName) */ \
	"%s: entry not mounted or not a mountpoint."

/*
 * BoK_AIBUpdateError_MultipleMountNotSupp
 */
# define SMSG_AIBUpdateError_MultipleMountNotSupp \
	"The implementation does not support multiple mount."

# define SMSG_AIBUpdateError_MultipleMountNotSupp_s /* (aName) */ \
	"%s: implementation does not support multiple mount."

/*
 * BoK_AIBUpdateError_NotMountpoint
 */
# define SMSG_AIBUpdateError_NotMountpoint \
	"Mount operation on the object that can not be a mountpoint."

# define SMSG_AIBUpdateError_NotMountpoint_s /* (aName) */ \
	"%s: mount operation on the object that can not be a mountpoint."

/*
 * BoK_AIBUpdateError_NotMountable
 */
# define SMSG_AIBUpdateError_NotMountable \
	"Mount operation on the object that can not be a mountable."

# define SMSG_AIBUpdateError_NotMountable_s /* (aName) */ \
	"%s: mount operation on the object that can not be a mountable."

/* ------------------------------------------------------------------------- */
# pragma mark = AIB: service error status messages =
/* ------------------------------------------------------------------------- */

/*
 * BoK_AIBServiceError_NoInformation
 */
# define SMSG_AIBServiceError_NoInformation \
	"Service runtime error."

# define SMSG_AIBServiceError_NoInformation_i /* (aName) */ \
	"%d: service runtime error."

# define SMSG_AIBServiceError_NoInformation_s /* (aName) */ \
	"%s: service runtime error."

/*
 * BoK_AIBServiceError_Busy
 */
# define SMSG_AIBServiceError_Busy \
	"The object is presently too busy to perform a requested operation."

# define SMSG_AIBServiceError_Busy_s /* (aName) */ \
	"{%s}: object is presently too busy to perform a requested operation."

# define SMSG_AIBServiceError_Busy_si /* (anOperationName,aName) */ \
	"%s{%d}: object is presently too busy to perform a requested operation."

# define SMSG_AIBServiceError_Busy_s2 /* (anOperationName,aName) */ \
	"%s{%s}: object is presently too busy to perform a requested operation."

/*
 * BoK_AIBServiceError_NestLevelLimit
 */
# define SMSG_AIBServiceError_NestLevelLimit \
	"Too many levels of [hierarchical] structure."
/* @} */

#endif /* !__BO_STATUS_MESSAGES__ */

/******************************************************************************
 * Revision History:
 *		$Log$
 *
 *****************************************************************************/
