/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright (c) 2005-2007 V.Sokur
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

/*
 * ShlibInit_t.h	(V.Sokur)
 * include/Bo/ShlibInit_t.h
 *
 * $Id$
 */

/******************************************************************************
 * %% BeginSection: definitions
 */
# pragma mark -
# pragma mark [ definitions ]
# pragma mark -

/*
 * This file declare default stub functions, used if there are not real
 * functions in a project.
 *

__MYC_BEGIN_CDECLS

__myc_flinkage_shlib(private) bo_status_t
__myc_calltype__(cdecl)
ShlibInit(OS-SPECIFIC-PARAMETER-LIST);

__myc_flinkage_shlib(private) bo_status_t
__myc_calltype__(cdecl)
ShlibFini(OS-SPECIFIC-PARAMETER-LIST);

__MYC_END_CDECLS

WIN32:
	OS-SPECIFIC-PARAMETER-LIST: (HMODULE aModuleHandle)

UNIX:
	OS-SPECIFIC-PARAMETER-LIST: ()

 */

# include <Bo/sys/Types.h>
# include <Bo/sys/Linkage.h>
# include _BO_PLATFORM_HEADER(ShlibInit_t.h)

/******************************************************************************
 * Revision History:
 *		$Log$
 *
 *****************************************************************************/
