/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright (c) 2005-2007 V.Sokur
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

/*
 * Intrinsic.h	(V.Sokur)
 * include/Bo/aorp/Intrinsic.h
 *
 * $Id$
 */

/* ------------------------------------------------------------------------- */

#ifndef __BO_AORP_TYPES__
# include <Bo/aorp/Types.h>
#endif

#ifndef __BO_AORP_INTRINSIC__
# define __BO_AORP_INTRINSIC__

/******************************************************************************
 * %% BeginSection: function prototypes
 */
# pragma mark -
# pragma mark [ function prototypes ]
# pragma mark -

# ifndef __BOLINKAGE__
#  include <Bo/BoLinkage.h>
# endif

__MYC_BEGIN_CDECLS

__myc_flinkage__(public,libBo) aorp_object_t
__attribute__((nonnull(1)))
AorpClassof(
# if __myc_require(prototypes)
	aorp_object_t aThis
# endif
	);

__myc_flinkage__(public,libBo) aorp_object_t
__attribute__((nonnull(1)))
AorpXclassof(
# if __myc_require(prototypes)
	aorp_object_t aThis
# endif
	);

__myc_flinkage__(public,libBo) aorp_object_t
__attribute__((nonnull(1)))
AorpModuleof(
# if __myc_require(prototypes)
	aorp_object_t aThis
# endif
	);

__myc_flinkage__(public,libBo) aorp_object_t
__attribute__((nonnull(1)))
AorpXmoduleof(
# if __myc_require(prototypes)
	aorp_object_t aThis
# endif
	);

# pragma mark -

__myc_flinkage__(public,libBo) char const *
__attribute__((nonnull(1)))
AorpObjectLongkey(
# if __myc_require(prototypes)
	aorp_object_t aThis
# endif
	);

__myc_flinkage__(public,libBo) char const *
__attribute__((nonnull(1)))
AorpObjectShortkey(
# if __myc_require(prototypes)
	aorp_object_t aThis
# endif
	);

__myc_flinkage__(public,libBo) char const *
__attribute__((nonnull(1)))
AorpObjectName(
# if __myc_require(prototypes)
	aorp_object_t aThis
# endif
	);

# pragma mark -

__myc_flinkage__(public,libBo) aorp_oid1_t
__attribute__((nonnull(1)))
AorpObjectCategory(
# if __myc_require(prototypes)
	aorp_object_t aThis
# endif
	);

__myc_flinkage__(public,libBo) aorp_oid1_t
__attribute__((nonnull(1)))
AorpObjectPrimID(
# if __myc_require(prototypes)
	aorp_object_t aThis
# endif
	);

__myc_flinkage__(public,libBo) aorp_oid_t *
__attribute__((nonnull(1,2)))
AorpObjectOID(
# if __myc_require(prototypes)
	aorp_object_t aThis,
	aorp_oid_t anOid[/* AorpK_OID_LEN */]
# endif
	);

__MYC_END_CDECLS

#endif /* !__BO_AORP_INTRINSIC__ */

/******************************************************************************
 * Revision History:
 *		$Log$
 *
 *****************************************************************************/
