/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright (c) 2005-2007 V.Sokur
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

/*
 * LdmodI.h	(V.Sokur)
 * include/Bo/aorp/LdmodI.h
 *
 * $Id$
 */

/* ------------------------------------------------------------------------- */

#ifndef __BO_AORP_LDMOD_I__
# define __BO_AORP_LDMOD_I__

/******************************************************************************
 * %% BeginSection: includes
 */

# ifndef __BO_AORP_TYPES_I__
#  include <Bo/aorp/TypesI.h>
# endif

/******************************************************************************
 * %% BeginSection: function prototypes
 */
# pragma mark -
# pragma mark [ function prototypes ]
# pragma mark -

# ifndef __BOLINKAGE__
#  include <Bo/BoLinkage.h>
# endif

__MYC_BEGIN_CDECLS

/* ----------------------------------------------------------------------------
 * 'boot': bootstrap,dip,plug
 * 'shutdown': unplug,undip,halt
 */

__myc_flinkage__(private,libBo) bo_status_t
__attribute__((nonnull(1)))
_AorpModBootbuiltin(
# if __myc_require(prototypes)
	struct aorp_mobject *aModule,
	struct aorp_error *anErrPtr __myc_defval__(NULL)
# endif
	);

__myc_flinkage__(private,libBo) bo_status_t
__attribute__((nonnull(1)))
_AorpModBoot(
# if __myc_require(prototypes)
	struct aorp_mobject *aModule,
	struct aorp_error *anErrPtr __myc_defval__(NULL)
# endif
	);

__myc_flinkage__(private,libBo) bo_status_t
__attribute__((nonnull(1)))
_AorpModBoot_n(
# if __myc_require(prototypes)
	bo_seqlist_t *aList,
	struct aorp_error *anErrPtr __myc_defval__(NULL)
# endif
	);

# pragma mark -

__myc_flinkage__(private,libBo) bo_status_t
__attribute__((nonnull(1)))
_AorpModShutdown(
# if __myc_require(prototypes)
	struct aorp_mobject *aModule,
	struct aorp_error *anErrPtr __myc_defval__(NULL)
# endif
	);

/* BoS_OK */
__myc_flinkage__(private,libBo) bo_status_t
__attribute__((nonnull(1)))
_AorpModShutdown_n(
# if __myc_require(prototypes)
	bo_seqlist_t *aList,
	struct aorp_error *anErrPtr __myc_defval__(NULL)
# endif
	);

/* ----------------------------------------------------------------------------
 * 'bootstrap', 'halt'
 */
# pragma mark -

__myc_flinkage__(private,libBo) bo_status_t
__attribute__((nonnull(1)))
_AorpModBootstrap(
# if __myc_require(prototypes)
	struct aorp_mobject *aThis,
	struct aorp_mobject *aModule, /* = aThis */
	struct aorp_error *anErrPtr __myc_defval__(NULL)
# endif
	);

__myc_flinkage__(private,libBo) bo_status_t
__attribute__((nonnull(1)))
_AorpModHalt(
# if __myc_require(prototypes)
	struct aorp_mobject *aThis,
	struct aorp_error *anErrPtr __myc_defval__(NULL)
# endif
	);

/* ----------------------------------------------------------------------------
 * 'dip', 'undip'
 */
# pragma mark -

__myc_flinkage__(private,libBo) bo_status_t
__attribute__((nonnull(1)))
_AorpModDip(
# if __myc_require(prototypes)
	struct aorp_mobject *aThis,
	struct aorp_error *anErrPtr __myc_defval__(NULL)
# endif
	);

__myc_flinkage__(private,libBo) bo_status_t
__attribute__((nonnull(1)))
_AorpModUndip(
# if __myc_require(prototypes)
	struct aorp_mobject *aThis,
	struct aorp_error *anErrPtr __myc_defval__(NULL)
# endif
	);

/* ----------------------------------------------------------------------------
 * 'plug', 'unplug'
 */
# pragma mark -

/* BoS_OK */
__myc_flinkage__(private,libBo) bo_status_t
__attribute__((nonnull(1)))
_AorpModPlug(
# if __myc_require(prototypes)
	struct aorp_mobject *aThis,
	struct aorp_error *anErrPtr __myc_defval__(NULL)
# endif
	);

__myc_flinkage__(private,libBo) bo_status_t
__attribute__((nonnull(1)))
_AorpModUnplug(
# if __myc_require(prototypes)
	struct aorp_mobject *aThis,
	struct aorp_error *anErrPtr __myc_defval__(NULL)
# endif
	);

# pragma mark -

/* BoS_OK */
__myc_flinkage__(private,libBo) bo_status_t
__attribute__((nonnull(1)))
_AorpModPlugcls(
# if __myc_require(prototypes)
	struct aorp_cobject *aThis,
	struct aorp_error *anErrPtr __myc_defval__(NULL)
# endif
	);

__myc_flinkage__(private,libBo) bo_status_t
__attribute__((nonnull(1)))
AorpModUnplugcob(
# if __myc_require(prototypes)
	struct aorp_cobject *aThis,
	struct aorp_error *anErrPtr __myc_defval__(NULL)
# endif
	);

/* BoS_OK */
__myc_flinkage__(private,libBo) bo_status_t
__attribute__((nonnull(1)))
_AorpModPlugops(
# if __myc_require(prototypes)
	struct aorp_ops *aThis,
	struct aorp_error *anErrPtr __myc_defval__(NULL)
# endif
	);

__myc_flinkage__(private,libBo) bo_status_t
__attribute__((nonnull(1)))
_AorpModUnplugops(
# if __myc_require(prototypes)
	struct aorp_ops *aThis,
	struct aorp_error *anErrPtr __myc_defval__(NULL)
# endif
	);

/* ----------------------------------------------------------------------------
 * rtld subroutines
 */
# pragma mark -

__myc_flinkage__(private,libBo) bo_status_t
__attribute__((nonnull(1)))
_AorpRtldBootsmod(
# if __myc_require(prototypes)
	struct aorp_mobject *aThis,
	struct aorp_mobject *aModule, /* = aThis */
	struct aorp_error *anErrPtr __myc_defval__(NULL)
# endif
	);

__myc_flinkage__(private,libBo) bo_status_t
__attribute__((nonnull(1)))
_AorpRtldBootscls(
# if __myc_require(prototypes)
	struct aorp_cobject *aThis,
	struct aorp_mobject *aModule,
	struct aorp_error *anErrPtr __myc_defval__(NULL)
# endif
	);

__myc_flinkage__(private,libBo) bo_status_t
__attribute__((nonnull(1)))
_AorpRtldBootsops(
# if __myc_require(prototypes)
	struct aorp_ops *aThis,
	struct aorp_mobject *aModule,
	struct aorp_error *anErrPtr __myc_defval__(NULL)
# endif
	);

# pragma mark -

/* BoS_OK */
__myc_flinkage__(private,libBo) bo_status_t
__attribute__((nonnull(1)))
_AorpRtldConfigure(
# if __myc_require(prototypes)
	struct aorp_dobject *aThis,
	struct aorp_error *anErrPtr __myc_defval__(NULL)
# endif
	);

# pragma mark -

__myc_flinkage__(private,libBo) bo_status_t
__attribute__((nonnull(1)))
_AorpRtldHalt(
# if __myc_require(prototypes)
	struct aorp_dobject *aThis,
	struct aorp_error *anErrPtr __myc_defval__(NULL)
# endif
	);

__MYC_END_CDECLS

#endif /* !__BO_AORP_LDMOD_I__ */

/******************************************************************************
 * Revision History:
 *		$Log$
 *
 *****************************************************************************/
