/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright (c) 2005-2007 V.Sokur
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

/*
 * Mld.h	(V.Sokur)
 * include/Bo/aorp/Mld.h
 *
 * $Id$
 */

/* ------------------------------------------------------------------------- */

#ifndef __BO_AORP_MLD__
# define __BO_AORP_MLD__

/******************************************************************************
 * %% BeginSection: includes
 */

# ifndef __BO_AORP_TYPES__
#  include <Bo/aorp/Types.h>
# endif

/******************************************************************************
 * %% BeginSection: function prototypes
 */
# pragma mark -
# pragma mark [ function prototypes ]
# pragma mark -

# ifndef __BOLINKAGE__
#  include <Bo/BoLinkage.h>
# endif

__MYC_BEGIN_CDECLS

__myc_vlinkage__(public,libBo) int _G_mld_load_debug_only;

/* bool: BoS_TRUE, BoS_FALSE */
__myc_flinkage__(public,libBo) bo_status_t
AorpMldIsloaded(
# if __myc_require(prototypes)
	char const *aModuleName,
	struct aorp_error *anErrPtr __myc_defval__(NULL)
# endif
	);

/* bool: BoS_TRUE, BoS_FALSE */
__myc_flinkage__(public,libBo) bo_status_t
AorpMldLoad(
# if __myc_require(prototypes)
	char const *aPath,  /* utf8 for windows */
	char const *aSearchPathv[],
	size_t aPathc,
	int /* _Bool */ NoDefaultSearchPaths,
	struct aorp_error *anErrPtr __myc_defval__(NULL)
# endif
	);

/* bool: BoS_TRUE, BoS_FALSE */
__myc_flinkage__(public,libBo) bo_status_t
AorpMldLoad1(
# if __myc_require(prototypes)
	char const *aPath,  /* utf8 for windows */
	char const *aSearchPathv[],
	size_t aPathc,
	int /* _Bool */ NoDefaultSearchPaths,
	struct aorp_error *anErrPtr __myc_defval__(NULL)
# endif
	);

__myc_flinkage__(public,libBo) bo_status_t
AorpMldUnload(
# if __myc_require(prototypes)
	char const *aModuleName,
	struct aorp_error *anErrPtr __myc_defval__(NULL)
# endif
	);

__MYC_END_CDECLS

#endif /* !__BO_AORP_MLD__ */

/******************************************************************************
 * Revision History:
 *		$Log$
 *
 *****************************************************************************/
