/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright (c) 2005-2007 V.Sokur
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

/*
 * MldI.h	(V.Sokur)
 * include/Bo/aorp/MldI.h
 *
 * $Id$
 */

/* ------------------------------------------------------------------------- */

#ifndef __BO_AORP_MLD_I__
# define __BO_AORP_MLD_I__

/******************************************************************************
 * %% BeginSection: includes
 */

# ifndef __BO_AORP_TYPES_I__
#  include <Bo/aorp/TypesI.h>
# endif
# ifndef __BO_AORP_MLD__
#  include <Bo/aorp/Mld.h>
# endif

/******************************************************************************
 * %% BeginSection: function prototypes
 */
# pragma mark -
# pragma mark [ function prototypes ]
# pragma mark -

# ifndef __BOLINKAGE__
#  include <Bo/BoLinkage.h>
# endif

__MYC_BEGIN_CDECLS

__myc_flinkage__(private,libBo) bo_status_t
__attribute__((nonnull(1)))
_AorpMldLoadBuiltin(
# if __myc_require(prototypes)
	struct aorp_mobject *aModule,
	struct aorp_error *anErrPtr __myc_defval__(NULL)
# endif
	);

__myc_flinkage__(public,libBo) bo_status_t
__attribute__((nonnull(1)))
_AorpMldUnload(
# if __myc_require(prototypes)
	char const *aModuleName,
	struct aorp_error *anErrPtr __myc_defval__(NULL)
# endif
	);

__myc_flinkage__(private,libBo) bo_status_t
AorpMldUnload_ptr(
# if __myc_require(prototypes)
	struct aorp_mobject *aModule,
	struct aorp_error *anErrPtr __myc_defval__(NULL)
# endif
	);

__myc_flinkage__(private,libBo) bo_status_t
__attribute__((nonnull(1)))
_AorpMldUnload_ptr(
# if __myc_require(prototypes)
	struct aorp_mobject *aModule,
	struct aorp_error *anErrPtr __myc_defval__(NULL)
# endif
	);

/* ------------------------------------------------------------------------- */
# pragma mark -
/* ------------------------------------------------------------------------- */

__myc_flinkage__(private,libBo) bo_status_t
__attribute__((nonnull(1)))
_AorpMldOpenBuiltin(
# if __myc_require(prototypes)
	struct aorp_mobject *aModule,
	struct aorp_error *anErrPtr __myc_defval__(NULL)
# endif
	);

__myc_flinkage__(private,libBo) struct aorp_mobject *
__attribute__((nonnull(1)))
_AorpMldOpen(
# if __myc_require(prototypes)
	char const *aPath,  /* utf8 for windows */
	char const *aSearchPathv[],
	size_t aPathc,
	int /* _Bool */ NoDefaultSearchPaths,
	int /* _Bool */ *anExistsPtr,
	struct aorp_error *anErrPtr __myc_defval__(NULL)
# endif
	);

__myc_flinkage__(private,libBo) struct aorp_mobject *
__attribute__((nonnull(1,2)))
_AorpMldOpen_n(
# if __myc_require(prototypes)
	bo_seqlist_t *aList,
	char const *aPath,  /* utf8 for windows */
	char const *aSearchPathv[],
	size_t aPathc,
	int /* _Bool */ NoDefaultSearchPaths,
	struct aorp_error *anErrPtr __myc_defval__(NULL)
# endif
	);

__myc_flinkage__(private,libBo) bo_status_t
__attribute__((nonnull(1)))
_AorpMldClose(
# if __myc_require(prototypes)
	char const *aModuleName,
	struct aorp_error *anErrPtr __myc_defval__(NULL)
# endif
	);

__myc_flinkage__(private,libBo) bo_status_t
__attribute__((nonnull(1)))
_AorpMldClose_ptr(
# if __myc_require(prototypes)
	struct aorp_mobject *aModule,
	struct aorp_error *anErrPtr __myc_defval__(NULL)
# endif
	);

/* BoS_OK */
__myc_flinkage__(private,libBo) bo_status_t
__attribute__((nonnull(1)))
_AorpMldClose_n(
# if __myc_require(prototypes)
	bo_seqlist_t *aList,
	struct aorp_error *anErrPtr __myc_defval__(NULL)
# endif
	);

__MYC_END_CDECLS

#endif /* !__BO_AORP_MLD_I__ */

/******************************************************************************
 * Revision History:
 *		$Log$
 *
 *****************************************************************************/
