/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright (c) 2005-2007 V.Sokur
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

/*
 * ModlistI.h	(V.Sokur)
 * include/Bo/aorp/ModlistI.h
 *
 * $Id$
 */

/* ------------------------------------------------------------------------- */

#ifndef __BO_AORP_MODLIST_I__
# define __BO_AORP_MODLIST_I__

/******************************************************************************
 * %% BeginSection: includes
 */

# ifndef __BO_AORP_TYPES_I__
#  include <Bo/aorp/TypesI.h>
# endif

/******************************************************************************
 * %% BeginSection: function prototypes
 */
# pragma mark -
# pragma mark [ function prototypes ]
# pragma mark -

# ifndef __BOLINKAGE__
#  include <Bo/BoLinkage.h>
# endif

__MYC_BEGIN_CDECLS

__myc_flinkage__(private,libBo) bo_status_t
__attribute__((nonnull(1)))
_AorpModlistInit(
# if __myc_require(prototypes)
	struct aorp_modlist_s *aList
# endif
	);

__myc_flinkage__(private,libBo) bo_status_t
__attribute__((nonnull(1)))
_AorpModlistFini(
# if __myc_require(prototypes)
	struct aorp_modlist_s *aList
# endif
	);

__myc_flinkage__(private,libBo) bo_status_t
__attribute__((nonnull(1)))
_AorpModlistClear(
# if __myc_require(prototypes)
	struct aorp_modlist_s *aList
# endif
	);

# pragma mark -

__myc_flinkage__(private,libBo) bo_status_t
__attribute__((nonnull(1)))
_AorpModlistRdlock(
# if __myc_require(prototypes)
	struct aorp_modlist_s *aList,
	struct aorp_error *anErrPtr __myc_defval__(NULL)
# endif
	);

__myc_flinkage__(private,libBo) bo_status_t
__attribute__((nonnull(1)))
_AorpModlistWrlock(
# if __myc_require(prototypes)
	struct aorp_modlist_s *aList,
	struct aorp_error *anErrPtr __myc_defval__(NULL)
# endif
	);

/* BoS_TRUE, BoS_FALSE */
__myc_flinkage__(private,libBo) bo_status_t
__attribute__((nonnull(1)))
_AorpModlistTryrdlock(
# if __myc_require(prototypes)
	struct aorp_modlist_s *aList,
	struct aorp_error *anErrPtr __myc_defval__(NULL)
# endif
	);

/* BoS_TRUE, BoS_FALSE */
__myc_flinkage__(private,libBo) bo_status_t
__attribute__((nonnull(1)))
_AorpModlistTrywrlock(
# if __myc_require(prototypes)
	struct aorp_modlist_s *aList,
	struct aorp_error *anErrPtr __myc_defval__(NULL)
# endif
	);

__myc_flinkage__(private,libBo) bo_status_t
__attribute__((nonnull(1)))
_AorpModlistUnlock(
# if __myc_require(prototypes)
	struct aorp_modlist_s *aList,
	struct aorp_error *anErrPtr __myc_defval__(NULL)
# endif
	);

# pragma mark -

__myc_flinkage__(private,libBo) size_t
__attribute__((nonnull(1)))
_AorpModlistSize(
# if __myc_require(prototypes)
	struct aorp_modlist_s *aList
# endif
	);

__myc_flinkage__(private,libBo) struct aorp_mobject *
__attribute__((nonnull(1,2)))
_AorpModlistLookup(
# if __myc_require(prototypes)
	struct aorp_modlist_s *aList,
	aorp_oid_t const anOid[],
	struct aorp_error *anErrPtr __myc_defval__(NULL)
# endif
	);

__myc_flinkage__(private,libBo) struct aorp_mobject *
__attribute__((nonnull(1,2)))
_AorpModlistLookup_nlk(
# if __myc_require(prototypes)
	struct aorp_modlist_s *aList,
	aorp_oid_t const anOid[],
	struct aorp_error *anErrPtr __myc_defval__(NULL)
# endif
	);

__myc_flinkage__(private,libBo) struct aorp_mobject *
__attribute__((nonnull(1,2)))
_AorpModlistLookup_ptr(
# if __myc_require(prototypes)
	struct aorp_modlist_s *aList,
	bo_pointer_t aModule,
	struct aorp_error *anErrPtr __myc_defval__(NULL)
# endif
	);

__myc_flinkage__(private,libBo) struct aorp_mobject *
__attribute__((nonnull(1,2)))
_AorpModlistLookup_ptr_nlk(
# if __myc_require(prototypes)
	struct aorp_modlist_s *aList,
	bo_pointer_t aModule,
	struct aorp_error *anErrPtr __myc_defval__(NULL)
# endif
	);

__myc_flinkage__(private,libBo) bo_status_t
__attribute__((nonnull(1,2)))
_AorpModlistPushback(
# if __myc_require(prototypes)
	struct aorp_modlist_s *aList,
	struct aorp_mobject *aModule,
	struct aorp_error *anErrPtr __myc_defval__(NULL)
# endif
	);

__myc_flinkage__(private,libBo) bo_status_t
__attribute__((nonnull(1,2)))
_AorpModlistPushback_nlk(
# if __myc_require(prototypes)
	struct aorp_modlist_s *aList,
	struct aorp_mobject *aModule,
	struct aorp_error *anErrPtr __myc_defval__(NULL)
# endif
	);

__myc_flinkage__(private,libBo) struct aorp_mobject *
__attribute__((nonnull(1)))
_AorpModlistPopback(
# if __myc_require(prototypes)
	struct aorp_modlist_s *aList,
	struct aorp_error *anErrPtr __myc_defval__(NULL)
# endif
	);

__myc_flinkage__(private,libBo) struct aorp_mobject *
__attribute__((nonnull(1)))
_AorpModlistPopback_nlk(
# if __myc_require(prototypes)
	struct aorp_modlist_s *aList,
	struct aorp_error *anErrPtr __myc_defval__(NULL)
# endif
	);

__myc_flinkage__(private,libBo) struct aorp_mobject *
__attribute__((nonnull(1,2)))
_AorpModlistRemove(
# if __myc_require(prototypes)
	struct aorp_modlist_s *aList,
	aorp_oid_t const anOid[],
	struct aorp_error *anErrPtr __myc_defval__(NULL)
# endif
	);

__myc_flinkage__(private,libBo) struct aorp_mobject *
__attribute__((nonnull(1,2)))
_AorpModlistRemove_nlk(
# if __myc_require(prototypes)
	struct aorp_modlist_s *aList,
	aorp_oid_t const anOid[],
	struct aorp_error *anErrPtr __myc_defval__(NULL)
# endif
	);

__myc_flinkage__(private,libBo) struct aorp_mobject *
__attribute__((nonnull(1,2)))
_AorpModlistRemove_ptr(
# if __myc_require(prototypes)
	struct aorp_modlist_s *aList,
	struct aorp_mobject *aModule,
	struct aorp_error *anErrPtr __myc_defval__(NULL)
# endif
	);

__myc_flinkage__(private,libBo) struct aorp_mobject *
__attribute__((nonnull(1,2)))
_AorpModlistRemove_ptr_nlk(
# if __myc_require(prototypes)
	struct aorp_modlist_s *aList,
	struct aorp_mobject *aModule,
	struct aorp_error *anErrPtr __myc_defval__(NULL)
# endif
	);

__MYC_END_CDECLS

#endif /* !__BO_AORP_MODLIST_I__ */

/******************************************************************************
 * Revision History:
 *		$Log$
 *
 *****************************************************************************/
