/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright (c) 2005-2007 V.Sokur
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

/*
 * NdbI.h	(V.Sokur)
 * include/Bo/aorp/NdbI.h
 *
 * $Id$
 */

/* ------------------------------------------------------------------------- */

#ifndef __BO_AORP_NDB_I__
# define __BO_AORP_NDB_I__

/******************************************************************************
 * %% BeginSection: includes
 */

# ifndef __BO_AORP_TYPES_I__
#  include <Bo/aorp/TypesI.h>
# endif

/******************************************************************************
 * %% BeginSection: function prototypes
 */
# pragma mark -
# pragma mark [ function prototypes ]
# pragma mark -

# ifndef __BOLINKAGE__
#  include <Bo/BoLinkage.h>
# endif

__MYC_BEGIN_CDECLS

__myc_flinkage__(private,libBo) bo_status_t
__myc_calltype__(mcall)
__attribute__((nonnull(1)))
_AorpNDBInit(
# if __myc_require(prototypes)
	struct aorp_odb_s *aDB
# endif
	);

__myc_flinkage__(private,libBo) bo_status_t
__myc_calltype__(mcall)
__attribute__((nonnull(1)))
_AorpNDBFini(
# if __myc_require(prototypes)
	struct aorp_odb_s *aDB
# endif
	);

# pragma mark -

__myc_flinkage__(private,libBo) bo_status_t
__attribute__((nonnull(1)))
_AorpNDBRdlock(
# if __myc_require(prototypes)
	struct aorp_odb_s *aDB,
	struct aorp_error *anErrPtr __myc_defval__(NULL)
# endif
	);

__myc_flinkage__(private,libBo) bo_status_t
__attribute__((nonnull(1)))
_AorpNDBWrlock(
# if __myc_require(prototypes)
	struct aorp_odb_s *aDB,
	struct aorp_error *anErrPtr __myc_defval__(NULL)
# endif
	);

__myc_flinkage__(private,libBo) bo_status_t
__attribute__((nonnull(1)))
_AorpNDBTryrdlock(
# if __myc_require(prototypes)
	struct aorp_odb_s *aDB,
	struct aorp_error *anErrPtr __myc_defval__(NULL)
# endif
	);

__myc_flinkage__(private,libBo) bo_status_t
__attribute__((nonnull(1)))
_AorpNDBTrywrlock(
# if __myc_require(prototypes)
	struct aorp_odb_s *aDB,
	struct aorp_error *anErrPtr __myc_defval__(NULL)
# endif
	);

__myc_flinkage__(private,libBo) bo_status_t
__attribute__((nonnull(1)))
_AorpNDBUnlock(
# if __myc_require(prototypes)
	struct aorp_odb_s *aDB,
	struct aorp_error *anErrPtr __myc_defval__(NULL)
# endif
	);

# pragma mark -

__myc_flinkage__(private,libBo) struct aorp_mobject *
__attribute__((nonnull(1,2)))
_AorpNDBLookup(
# if __myc_require(prototypes)
	struct aorp_odb_s *aDB,
	char const *aName,
	struct aorp_error *anErrPtr __myc_defval__(NULL)
# endif
	);

__myc_flinkage__(private,libBo) struct aorp_mobject *
__attribute__((nonnull(1,2)))
_AorpNDBLookup_nlk(
# if __myc_require(prototypes)
	struct aorp_odb_s *aDB,
	char const *aName,
	struct aorp_error *anErrPtr __myc_defval__(NULL)
# endif
	);

__myc_flinkage__(private,libBo) bo_status_t
__attribute__((nonnull(1,2)))
_AorpNDBAdd(
# if __myc_require(prototypes)
	struct aorp_odb_s *aDB,
	struct aorp_mobject *anObj,
	struct aorp_error *anErrPtr __myc_defval__(NULL)
# endif
	);

__myc_flinkage__(private,libBo) bo_status_t
__attribute__((nonnull(1,2)))
_AorpNDBAdd_nlk(
# if __myc_require(prototypes)
	struct aorp_odb_s *aDB,
	struct aorp_mobject *anObj,
	struct aorp_error *anErrPtr __myc_defval__(NULL)
# endif
	);

__myc_flinkage__(private,libBo) struct aorp_mobject *
__attribute__((nonnull(1,2)))
_AorpNDBRemove(
# if __myc_require(prototypes)
	struct aorp_odb_s *aDB,
	char const *aName,
	struct aorp_error *anErrPtr __myc_defval__(NULL)
# endif
	);

__myc_flinkage__(private,libBo) struct aorp_mobject *
__attribute__((nonnull(1,2)))
_AorpNDBRemove_nlk(
# if __myc_require(prototypes)
	struct aorp_odb_s *aDB,
	char const *aName,
	struct aorp_error *anErrPtr __myc_defval__(NULL)
# endif
	);

__MYC_END_CDECLS

#endif /* !__BO_AORP_NDB_I__ */

/******************************************************************************
 * Revision History:
 *		$Log$
 *
 *****************************************************************************/
