/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright (c) 2005-2007 V.Sokur
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

/*
 * RuntimeI.h	(V.Sokur)
 * include/Bo/aorp/RuntimeI.h
 *
 * $Id$
 */

/* ------------------------------------------------------------------------- */

#ifndef __BO_AORP_RUNTIME_I__
# define __BO_AORP_RUNTIME_I__

/******************************************************************************
 * %% BeginSection: includes
 */

# ifndef __BO_AORP_TYPES_I__
#  include <Bo/aorp/TypesI.h>
# endif
# ifndef __BO_AORP_RUNTIME_P__
#  include <Bo/aorp/RuntimeP.h>
# endif

/******************************************************************************
 * %% BeginSection: function prototypes
 */
# pragma mark -
# pragma mark [ function prototypes ]
# pragma mark -

# ifndef __BOLINKAGE__
#  include <Bo/BoLinkage.h>
# endif

__MYC_BEGIN_CDECLS

/* BoS_OK */
__myc_flinkage__(private,libBo) bo_status_t
__attribute__((nonnull(1)))
_AorpObjInitonce(
# if __myc_require(prototypes)
	struct aorp_cobject *aThis,
	struct aorp_error *anErrPtr __myc_defval__(NULL)
# endif
	);

__myc_flinkage__(private,libBo) bo_status_t
__attribute__((nonnull(1)))
_AorpObjFinionce(
# if __myc_require(prototypes)
	struct aorp_cobject *aThis,
	struct aorp_error *anErrPtr __myc_defval__(NULL)
# endif
	);

# pragma mark -

/* BoS_OK */
__myc_flinkage__(private,libBo) bo_status_t
__attribute__((nonnull(1)))
_AorpObjPODinit(
# if __myc_require(prototypes)
	aorp_object_t aThis, /* x-object, c-object */
	struct aorp_podinit_s *aParmv[] __myc_defval__(NULL),
	size_t aParmc __myc_defval__(0),
	int /* _Bool */ IgnoreErrors __myc_defval__(false),
	struct aorp_error *anErrPtr __myc_defval__(NULL)
# endif
	);

/* BoS_OK */
__myc_flinkage__(private,libBo) bo_status_t
__attribute__((nonnull(1,3)))
_AorpObjPODinit_dup(
# if __myc_require(prototypes)
	aorp_object_t aThis, /* x-object, c-object */
	aorp_object_t aSource, /* s-object, x-object, c-object */
	aorp_object_t aDuplicator,
	bo_pointer_t Params __myc_defval__(NULL),
	struct aorp_dup_predicate *aFilter __myc_defval__(NULL),
	int /* _Bool */ IgnoreErrors /* false */,
	struct aorp_error *anErrPtr __myc_defval__(NULL)
# endif
	);

__myc_flinkage__(private,libBo) bo_status_t
__attribute__((nonnull(1)))
_AorpObjPODfini(
# if __myc_require(prototypes)
	aorp_object_t aThis, /* x-object, c-object */
	aorp_opflags_t Flags __myc_defval__(0),
	struct aorp_error *anErrPtr __myc_defval__(NULL)
# endif
	);

__MYC_END_CDECLS

#endif /* !__BO_AORP_RUNTIME_I__ */

/******************************************************************************
 * Revision History:
 *		$Log$
 *
 *****************************************************************************/
