/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright (c) 2005-2007 V.Sokur
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

/*
 * SelistP.h	(V.Sokur)
 * include/Bo/aorp/SelistP.h
 *
 * $Id$
 */

/* ------------------------------------------------------------------------- */

#ifndef __BO_AORP_SELIST_P__
# define __BO_AORP_SELIST_P__

/******************************************************************************
 * %% BeginSection: includes
 */

# ifndef __BO_AORP_TYPES_P__
#  include <Bo/aorp/TypesP.h>
# endif

/******************************************************************************
 * %% BeginSection: function prototypes
 */
# pragma mark -
# pragma mark [ function prototypes ]
# pragma mark -

# ifndef __BOLINKAGE__
#  include <Bo/BoLinkage.h>
# endif

__MYC_BEGIN_CDECLS

__myc_flinkage__(public,libBo) bo_status_t
__attribute__((nonnull(1)))
_AorpSelistInit(
# if __myc_require(prototypes)
	struct aorp_selist_s *aList
# endif
	);

__myc_flinkage__(public,libBo) bo_status_t
__attribute__((nonnull(1)))
_AorpSelistFini(
# if __myc_require(prototypes)
	struct aorp_selist_s *aList
# endif
	);

# pragma mark -

__myc_flinkage__(public,libBo) bo_status_t
__attribute__((nonnull(1)))
_AorpSelistRdlock(
# if __myc_require(prototypes)
	struct aorp_selist_s *aList,
	struct aorp_error *anErrPtr __myc_defval__(NULL)
# endif
	);

__myc_flinkage__(public,libBo) bo_status_t
__attribute__((nonnull(1)))
_AorpSelistWrlock(
# if __myc_require(prototypes)
	struct aorp_selist_s *aList,
	struct aorp_error *anErrPtr __myc_defval__(NULL)
# endif
	);

/* BoS_TRUE, BoS_FALSE */
__myc_flinkage__(public,libBo) bo_status_t
__attribute__((nonnull(1)))
_AorpSelistTryrdlock(
# if __myc_require(prototypes)
	struct aorp_selist_s *aList,
	struct aorp_error *anErrPtr __myc_defval__(NULL)
# endif
	);

/* BoS_TRUE, BoS_FALSE */
__myc_flinkage__(public,libBo) bo_status_t
__attribute__((nonnull(1)))
_AorpSelistTrywrlock(
# if __myc_require(prototypes)
	struct aorp_selist_s *aList,
	struct aorp_error *anErrPtr __myc_defval__(NULL)
# endif
	);

__myc_flinkage__(public,libBo) bo_status_t
__attribute__((nonnull(1)))
_AorpSelistUnlock(
# if __myc_require(prototypes)
	struct aorp_selist_s *aList,
	struct aorp_error *anErrPtr __myc_defval__(NULL)
# endif
	);

# pragma mark -

/* Number of SES, not SE */
__myc_flinkage__(public,libBo) size_t
__attribute__((nonnull(1)))
_AorpSelistSize(
# if __myc_require(prototypes)
	struct aorp_selist_s *aList
# endif
	);

__myc_flinkage__(public,libBo) struct aorp_se *
__attribute__((nonnull(1)))
_AorpSelistLookup(
# if __myc_require(prototypes)
	struct aorp_selist_s *aList,
	aorp_oid_t const anOid[],
	struct aorp_error *anErrPtr __myc_defval__(NULL)
# endif
	);

__myc_flinkage__(public,libBo) struct aorp_se *
__attribute__((nonnull(1)))
_AorpSelistLookup_nlk(
# if __myc_require(prototypes)
	struct aorp_selist_s *aList,
	aorp_oid_t const anOid[],
	struct aorp_error *anErrPtr __myc_defval__(NULL)
# endif
	);

__myc_flinkage__(public,libBo) struct aorp_se *
__attribute__((nonnull(1)))
_AorpSelistLookup_ptr(
# if __myc_require(prototypes)
	struct aorp_selist_s *aList,
	struct aorp_se *aSE,
	struct aorp_error *anErrPtr __myc_defval__(NULL)
# endif
	);

__myc_flinkage__(public,libBo) struct aorp_se *
__attribute__((nonnull(1)))
_AorpSelistLookup_ptr_nlk(
# if __myc_require(prototypes)
	struct aorp_selist_s *aList,
	struct aorp_se *aSE,
	struct aorp_error *anErrPtr __myc_defval__(NULL)
# endif
	);

__myc_flinkage__(public,libBo) bo_status_t
__attribute__((nonnull(1,2)))
_AorpSelistPushfront(
# if __myc_require(prototypes)
	struct aorp_selist_s *aList,
	struct aorp_ses *aSes,
	struct aorp_error *anErrPtr __myc_defval__(NULL)
# endif
	);

__myc_flinkage__(public,libBo) bo_status_t
__attribute__((nonnull(1,2)))
_AorpSelistPushfront_nlk(
# if __myc_require(prototypes)
	struct aorp_selist_s *aList,
	struct aorp_ses *aSes,
	struct aorp_error *anErrPtr __myc_defval__(NULL)
# endif
	);

__myc_flinkage__(public,libBo) bo_status_t
__attribute__((nonnull(1,2)))
_AorpSelistPushback(
# if __myc_require(prototypes)
	struct aorp_selist_s *aList,
	struct aorp_ses *aSes,
	struct aorp_error *anErrPtr __myc_defval__(NULL)
# endif
	);

__myc_flinkage__(public,libBo) bo_status_t
__attribute__((nonnull(1,2)))
_AorpSelistPushback_nlk(
# if __myc_require(prototypes)
	struct aorp_selist_s *aList,
	struct aorp_ses *aSes,
	struct aorp_error *anErrPtr __myc_defval__(NULL)
# endif
	);

__MYC_END_CDECLS

#endif /* !__BO_AORP_SELIST_P__ */

/******************************************************************************
 * Revision History:
 *		$Log$
 *
 *****************************************************************************/
