/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright (c) 2005-2007 V.Sokur
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

/*
 * StubP.h	(V.Sokur)
 * include/Bo/aorp/StubP.h
 *
 * $Id$
 */

/* ------------------------------------------------------------------------- */

#ifndef __BO_AORP_STUB_P__
# define __BO_AORP_STUB_P__

/******************************************************************************
 * %% BeginSection: includes
 */

# ifndef __BO_AORP_TYPES_P__
#  include <Bo/aorp/TypesP.h>
# endif

/******************************************************************************
 * %% BeginSection: function prototypes
 */
# pragma mark -
# pragma mark [ function prototypes ]
# pragma mark -

# ifndef __BOLINKAGE__
#  include <Bo/BoLinkage.h>
# endif

# define _AorpK_stub_notconfigured 4
# define _AorpK_stub_inappropriate 5
# define _AorpK_stub_notimpl 6
# define _AorpK_stub_notavail 7
# define _AorpK_stub_notsupp 8
# define _AorpK_stub_notallowed 9
# define _AorpK_stub_opc 10

__MYC_BEGIN_CDECLS

/* ~ _AorpOpNotconfigured. Needed, because _AorpModPlugops
   uses _AorpOpNotconfigured */
__myc_flinkage__(private,libBo) bo_status_t
__myc_calltype__(mcall)
__attribute__((nonnull(1)))
_AorpOpStub(
# if __myc_require(prototypes)
	struct aorp_closure *aClosure,
	struct aorp_error *anErrPtr,
	...
# endif
	);

__myc_flinkage__(public,libBo) bo_status_t
__myc_calltype__(mcall)
__attribute__((nonnull(1)))
_AorpOpNotconfigured(
# if __myc_require(prototypes)
	struct aorp_closure *aClosure,
	struct aorp_error *anErrPtr,
	...
# endif
	);

__myc_flinkage__(public,libBo) bo_status_t
__myc_calltype__(mcall)
__attribute__((nonnull(1)))
_AorpOpInappropriate(
# if __myc_require(prototypes)
	struct aorp_closure *aClosure,
	struct aorp_error *anErrPtr,
	...
# endif
	);

__myc_flinkage__(public,libBo) bo_status_t
__myc_calltype__(mcall)
__attribute__((nonnull(1)))
_AorpOpNotimplemented(
# if __myc_require(prototypes)
	struct aorp_closure *aClosure,
	struct aorp_error *anErrPtr,
	...
# endif
	);

__myc_flinkage__(public,libBo) bo_status_t
__myc_calltype__(mcall)
__attribute__((nonnull(1)))
_AorpOpNotavailable(
# if __myc_require(prototypes)
	struct aorp_closure *aClosure,
	struct aorp_error *anErrPtr,
	...
# endif
	);

__myc_flinkage__(public,libBo) bo_status_t
__myc_calltype__(mcall)
__attribute__((nonnull(1)))
_AorpOpNotsupported(
# if __myc_require(prototypes)
	struct aorp_closure *aClosure,
	struct aorp_error *anErrPtr,
	...
# endif
	);

__myc_flinkage__(public,libBo) bo_status_t
__myc_calltype__(mcall)
__attribute__((nonnull(1)))
_AorpOpNotallowed(
# if __myc_require(prototypes)
	struct aorp_closure *aClosure,
	struct aorp_error *anErrPtr,
	...
# endif
	);

__MYC_END_CDECLS

#endif /* !__BO_AORP_STUB_P__ */

/******************************************************************************
 * Revision History:
 *		$Log$
 *
 *****************************************************************************/
