/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright (c) 2005-2007 V.Sokur
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

/*
 * TypesI.h	(V.Sokur)
 * include/Bo/aorp/TypesI.h
 *
 * $Id$
 */

/* ------------------------------------------------------------------------- */

#ifndef __BO_AORP_TYPES_P__
# include <Bo/aorp/TypesP.h>
#endif

#ifndef __BO_AORP_TYPES_I__
# define __BO_AORP_TYPES_I__

/******************************************************************************
 * %% BeginSection: includes
 */

# ifndef AORP_MODULE_EXT
#  ifdef BO_SYSTYPE_FreeBSD
#   define AORP_MODULE_EXT ".so" /* .version */
#  else
#  ifdef BO_SYSTYPE_MacOSX
#   define AORP_MODULE_EXT ".dylib" /* .version */
#  else
#  ifdef BO_SYSTYPE_WIN32
#   define AORP_MODULE_EXT ".dll" /* .version */
#  else
#   define AORP_MODULE_EXT ".so" /* .version */
#  endif /* BO_SYSTYPE_WIN32 */
#  endif /* BO_SYSTYPE_MacOSX */
#  endif /* BO_SYSTYPE_FreeBSD */
# endif /* !AORP_MODULE_EXT */

/* NOT FOR YOUR BUSINESS @{ */
# ifdef _DEBUG
#  include <Bo/Debug.h>

_BoDbg_StaticAssert(
	sizeof_aorp_hint_x_16,
	sizeof(u_int16_t) == sizeof(aorp_hint_x));

_BoDbg_StaticAssert(
	sizeof_aorp_closure,
	sizeof(struct aorp_closure_s) == sizeof(struct aorp_closure));

/* @todo: uncomment if AorpK_BOXOBJ_HEADER_SIZE is defined */
#if 0
_BoDbg_StaticAssert(
	sizeof_aorp_extra_header,
	sizeof(struct aorp_extra_header) == (AorpK_BOXOBJ_HEADER_SIZE_WITH_EXTRA - AorpK_BOXOBJ_HEADER_SIZE)
);
_BoDbg_StaticAssert(
	sizeof_aorp_extra_header2,
	sizeof(struct aorp_extra_header) == (AorpK_BOAOBJ_HEADER_SIZE_WITH_EXTRA - AorpK_BOAOBJ_HEADER_SIZE)
);
#endif

_BoDbg_StaticAssert(
	sizeof_aorp_sobject,
	sizeof(struct aorp_sobject_s) == sizeof(struct aorp_sobject));

_BoDbg_StaticAssert(
	sizeof_aorp_aobject,
	sizeof(struct aorp_aobject_s) == sizeof(struct aorp_aobject));

#  include <Bo/sys/csType.h>
_BoDbg_StaticAssert(sizeof_aorp_oid_x, sizeof(bo_cset_x) <= sizeof(aorp_oid_x));
_BoDbg_StaticAssert(sizeof_aorp_oid_x_16, sizeof(u_int16_t) == sizeof(aorp_oid_x));
_BoDbg_StaticAssert(sizeof_aorp_oid_t_16, sizeof(u_int16_t) == sizeof(aorp_oid_t));

# endif /* _DEBUG */
/* @} */

#endif /* !__BO_AORP_TYPES_I__ */

/******************************************************************************
 * Revision History:
 *		$Log$
 *
 *****************************************************************************/
