/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright (c) 2005-2007 V.Sokur
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

/*
 * Udvariant.h	(V.Sokur)
 * include/Bo/aorp/Udvariant.h
 *
 * $Id$
 */

/* ------------------------------------------------------------------------- */

#ifndef __BO_AORP_TYPES__
# include <Bo/aorp/Types.h>
#endif

#ifndef __BO_AORP_UDVARIANT__
# define __BO_AORP_UDVARIANT__

/******************************************************************************
 * %% BeginSection: function declarations
 */
# pragma mark -
# pragma mark [ function declarations ]
# pragma mark -

/* ----------------------------------------------------------------------------
 * AORP_UDVARIANT_OBJ
 */

# if (BO_USE_UDVARIANT_VERSION == 128)
#  define AORP_UDVARIANT_OBJ AORP_UDVARIANT128_OBJ
# else
#  define AORP_UDVARIANT_OBJ AORP_UDVARIANT64_OBJ
# endif

# if __myc_support(DINI)
#  define AORP_UDVARIANT64_OBJ(aThis) \
	(struct aorp_udvariant64){ \
		.udc_hint = _AorpK_HINT_ANYOB, \
		.udc_reserved = 0, \
		.u = { .udc_obj = aThis } \
	}
# else
#  define AORP_UDVARIANT64_OBJ(aThis) AorpUdvariant64_obj(aThis)
# endif

# if __myc_support(DINI)
#  define AORP_UDVARIANT128_OBJ(aThis) \
	(struct aorp_udvariant128){ \
		.udc_hint = _AorpK_HINT_ANYOB, \
		.udc_reserved = 0, \
		.u = { .udc_obj = aThis } \
	}
# else
#  define AORP_UDVARIANT128_OBJ(aThis) AorpUdvariant128_obj(aThis)
# endif

/* ----------------------------------------------------------------------------
 * AORP_UDVARIANT_PTR
 */

# if (BO_USE_UDVARIANT_VERSION == 128)
#  define AORP_UDVARIANT_PTR AORP_UDVARIANT128_PTR
# else
#  define AORP_UDVARIANT_PTR AORP_UDVARIANT64_PTR
# endif

# if __myc_support(DINI)
#  define AORP_UDVARIANT64_PTR(aThis) \
	(struct aorp_udvariant64){ \
		.udc_hint = AorpK_HINT_POINTER, \
		.udc_reserved = 0, \
		.u = { .udc_udata = aThis } \
	}
# else
#  define AORP_UDVARIANT64_PTR(aThis) AorpUdvariant64_ptr(aThis)
# endif

# if __myc_support(DINI)
#  define AORP_UDVARIANT128_PTR(aThis) \
	(struct aorp_udvariant128){ \
		.udc_hint = AorpK_HINT_POINTER, \
		.udc_reserved = 0, \
		.u = { .udc_udata = aThis } \
	}
# else
#  define AORP_UDVARIANT128_PTR(aThis) AorpUdvariant128_ptr(aThis)
# endif

/* ----------------------------------------------------------------------------
 * AORP_UDVARIANT_STR
 */

# if (BO_USE_UDVARIANT_VERSION == 128)
#  define AORP_UDVARIANT_STR AORP_UDVARIANT128_STR
# else
#  define AORP_UDVARIANT_STR AORP_UDVARIANT64_STR
# endif

# if __myc_support(DINI)
#  define AORP_UDVARIANT64_STR(aThis) \
	(struct aorp_udvariant64){ \
		.udc_hint = AorpK_HINT_STR, \
		.udc_reserved = 0, \
		.u = { .udc_str = aThis } \
	}
# else
#  define AORP_UDVARIANT64_STR(aThis) AorpUdvariant64_str(aThis)
# endif

# if __myc_support(DINI)
#  define AORP_UDVARIANT128_STR(aThis) \
	(struct aorp_udvariant128){ \
		.udc_hint = AorpK_HINT_STR, \
		.udc_reserved = 0, \
		.u = { .udc_str = aThis } \
	}
# else
#  define AORP_UDVARIANT128_STR(aThis) AorpUdvariant128_str(aThis)
# endif

/* ----------------------------------------------------------------------------
 * AORP_UDVARIANT_WCS
 */

# if (BO_USE_UDVARIANT_VERSION == 128)
#  define AORP_UDVARIANT_WCS AORP_UDVARIANT128_WCS
# else
#  define AORP_UDVARIANT_WCS AORP_UDVARIANT64_WCS
# endif

# if __myc_support(DINI)
#  define AORP_UDVARIANT64_WCS(aThis) \
	(struct aorp_udvariant64){ \
		.udc_hint = AorpK_HINT_WCS, \
		.udc_reserved = 0, \
		.u = { .udc_wcs = aThis } \
	}
# else
#  define AORP_UDVARIANT64_WCS(aThis) AorpUdvariant64_wcs(aThis)
# endif

# if __myc_support(DINI)
#  define AORP_UDVARIANT128_WCS(aThis) \
	(struct aorp_udvariant128){ \
		.udc_hint = AorpK_HINT_WCS, \
		.udc_reserved = 0, \
		.u = { .udc_wcs = aThis } \
	}
# else
#  define AORP_UDVARIANT128_WCS(aThis) AorpUdvariant128_wcs(aThis)
# endif

/* ----------------------------------------------------------------------------
 * AORP_UDVARIANT_I32
 */

# if (BO_USE_UDVARIANT_VERSION == 128)
#  define AORP_UDVARIANT_I32 AORP_UDVARIANT128_I32
# else
#  define AORP_UDVARIANT_I32 AORP_UDVARIANT64_I32
# endif

# if __myc_support(DINI)
#  define AORP_UDVARIANT64_I32(aThis) \
	(struct aorp_udvariant64){ \
		.udc_hint = AorpK_HINT_INT32, \
		.udc_reserved = 0, \
		.u = { .udc_i32 = aThis } \
	}
# else
#  define AORP_UDVARIANT64_I32(aThis) AorpUdvariant64_i32(aThis)
# endif

# if __myc_support(DINI)
#  define AORP_UDVARIANT128_I32(aThis) \
	(struct aorp_udvariant128){ \
		.udc_hint = AorpK_HINT_INT32, \
		.udc_reserved = 0, \
		.u = { .udc_i32 = aThis } \
	}
# else
#  define AORP_UDVARIANT128_I32(aThis) AorpUdvariant128_i32(aThis)
# endif

/* ----------------------------------------------------------------------------
 * AORP_UDVARIANT_I64
 */

# if (BO_USE_UDVARIANT_VERSION == 128)
#  define AORP_UDVARIANT_I64 AORP_UDVARIANT128_I64
# else
#  define AORP_UDVARIANT_I64 AORP_UDVARIANT64_I64
# endif

# if __myc_support(DINI)
#  define AORP_UDVARIANT64_I64(aThis) \
	(struct aorp_udvariant64){ \
		.udc_hint = AorpK_HINT_INT64, \
		.udc_reserved = 0, \
		.u = { .udc_i64 = aThis } \
	}
# else
#  define AORP_UDVARIANT64_I64(aThis) AorpUdvariant64_i64(aThis)
# endif

# if __myc_support(DINI)
#  define AORP_UDVARIANT128_I64(aThis) \
	(struct aorp_udvariant128){ \
		.udc_hint = AorpK_HINT_INT64, \
		.udc_reserved = 0, \
		.u = { .udc_i128 = aThis } \
	}
# else
#  define AORP_UDVARIANT128_I64(aThis) AorpUdvariant128_i64(aThis)
# endif

/* ----------------------------------------------------------------------------
 * AORP_UDVARIANT_F32
 */

# if (BO_USE_UDVARIANT_VERSION == 128)
#  define AORP_UDVARIANT_F32 AORP_UDVARIANT128_F32
# else
#  define AORP_UDVARIANT_F32 AORP_UDVARIANT64_F32
# endif

# if __myc_support(DINI)
#  define AORP_UDVARIANT64_F32(aThis) \
	(struct aorp_udvariant64){ \
		.udc_hint = AorpK_HINT_FLOAT32, \
		.udc_reserved = 0, \
		.u = { .udc_f32 = aThis } \
	}
# else
#  define AORP_UDVARIANT64_F32(aThis) AorpUdvariant64_f32(aThis)
# endif

# if __myc_support(DINI)
#  define AORP_UDVARIANT128_F32(aThis) \
	(struct aorp_udvariant128){ \
		.udc_hint = AorpK_HINT_FLOAT32, \
		.udc_reserved = 0, \
		.u = { .udc_f32 = aThis } \
	}
# else
#  define AORP_UDVARIANT128_F32(aThis) AorpUdvariant128_f32(aThis)
# endif

/* ----------------------------------------------------------------------------
 * AORP_UDVARIANT_F64
 */

# if (BO_USE_UDVARIANT_VERSION == 128)
#  define AORP_UDVARIANT_F64 AORP_UDVARIANT128_F64
# else
#  define AORP_UDVARIANT_F64 AORP_UDVARIANT64_F64
# endif

# if __myc_support(DINI)
#  define AORP_UDVARIANT64_F64(aThis) \
	(struct aorp_udvariant64){ \
		.udc_hint = AorpK_HINT_FLOAT64, \
		.udc_reserved = 0, \
		.u = { .udc_f64 = aThis } \
	}
# else
#  define AORP_UDVARIANT64_F64(aThis) AorpUdvariant64_f64(aThis)
# endif

# if __myc_support(DINI)
#  define AORP_UDVARIANT128_F64(aThis) \
	(struct aorp_udvariant128){ \
		.udc_hint = AorpK_HINT_FLOAT64, \
		.udc_reserved = 0, \
		.u = { .udc_f128 = aThis } \
	}
# else
#  define AORP_UDVARIANT128_F64(aThis) AorpUdvariant128_f64(aThis)
# endif

/* ----------------------------------------------------------------------------
 * AORP_UDVARIANT_F128
 */

# if (BO_USE_UDVARIANT_VERSION == 128)
#  define AORP_UDVARIANT_F128 AORP_UDVARIANT128_F128
# else
#  define AORP_UDVARIANT_F128 ...
# endif

# if __myc_support(DINI)
#  define AORP_UDVARIANT128_F128(aThis) \
	(struct aorp_udvariant128){ \
		.udc_hint = AorpK_HINT_FLOAT128, \
		.udc_reserved = 0, \
		.u = { .udc_f128 = aThis } \
	}
# else
#  define AORP_UDVARIANT128_F128(aThis) AorpUdvariant128_f128(aThis)
# endif

/* ------------------------------------------------------------------------- */
# pragma mark -
/* ------------------------------------------------------------------------- */

/*
 * AorpUdvariant_obj
 */

__myc_extern_inline__ struct aorp_udvariant64
AorpUdvariant64_obj(
# if __myc_require(prototypes)
	aorp_object_t aThis
# else
	aThis
# endif
	)
# if !__myc_require(prototypes)
	aorp_object_t aThis;
# endif
{
	struct aorp_udvariant64 retval = {
		_AorpK_HINT_ANYOB, 0
	};
	retval.u.udc_obj = aThis;
	return (retval);
}

__myc_extern_inline__ struct aorp_udvariant128
AorpUdvariant128_obj(
# if __myc_require(prototypes)
	aorp_object_t aThis
# else
	aThis
# endif
	)
# if !__myc_require(prototypes)
	aorp_object_t aThis;
# endif
{
	struct aorp_udvariant128 retval = {
		_AorpK_HINT_ANYOB, 0
	};
	retval.u.udc_obj = aThis;
	return (retval);
}

/* ----------------------------------------------------------------------------
 * AorpUdvariant_ptr
 */

__myc_extern_inline__ struct aorp_udvariant64
AorpUdvariant64_ptr(
# if __myc_require(prototypes)
	bo_pointer_t aThis
# else
	aThis
# endif
	)
# if !__myc_require(prototypes)
	bo_pointer_t aThis;
# endif
{
	struct aorp_udvariant64 retval = {
		AorpK_HINT_POINTER, 0
	};
	retval.u.udc_udata = aThis;
	return (retval);
}

__myc_extern_inline__ struct aorp_udvariant128
AorpUdvariant128_ptr(
# if __myc_require(prototypes)
	bo_pointer_t aThis
# else
	aThis
# endif
	)
# if !__myc_require(prototypes)
	bo_pointer_t aThis;
# endif
{
	struct aorp_udvariant128 retval = {
		AorpK_HINT_POINTER, 0
	};
	retval.u.udc_udata = aThis;
	return (retval);
}

/* ----------------------------------------------------------------------------
 * AorpUdvariant_str
 */

__myc_extern_inline__ struct aorp_udvariant64
AorpUdvariant64_str(
# if __myc_require(prototypes)
	char *aThis
# else
	aThis
# endif
	)
# if !__myc_require(prototypes)
	char *aThis;
# endif
{
	struct aorp_udvariant64 retval = {
		AorpK_HINT_STR, 0
	};
	retval.u.udc_str = aThis;
	return (retval);
}

__myc_extern_inline__ struct aorp_udvariant128
AorpUdvariant128_str(
# if __myc_require(prototypes)
	char *aThis
# else
	aThis
# endif
	)
# if !__myc_require(prototypes)
	char *aThis;
# endif
{
	struct aorp_udvariant128 retval = {
		AorpK_HINT_STR, 0
	};
	retval.u.udc_str = aThis;
	return (retval);
}

/* ----------------------------------------------------------------------------
 * AorpUdvariant_wcs
 */

__myc_extern_inline__ struct aorp_udvariant64
AorpUdvariant64_wcs(
# if __myc_require(prototypes)
	wchar_t *aThis
# else
	aThis
# endif
	)
# if !__myc_require(prototypes)
	wchar_t *aThis;
# endif
{
	struct aorp_udvariant64 retval = {
		AorpK_HINT_WCS, 0
	};
	retval.u.udc_wcs = aThis;
	return (retval);
}

__myc_extern_inline__ struct aorp_udvariant128
AorpUdvariant128_wcs(
# if __myc_require(prototypes)
	wchar_t *aThis
# else
	aThis
# endif
	)
# if !__myc_require(prototypes)
	wchar_t *aThis;
# endif
{
	struct aorp_udvariant128 retval = {
		AorpK_HINT_WCS, 0
	};
	retval.u.udc_wcs = aThis;
	return (retval);
}

/* ----------------------------------------------------------------------------
 * AorpUdvariant_i32
 */

__myc_extern_inline__ struct aorp_udvariant64
AorpUdvariant64_i32(
# if __myc_require(prototypes)
	int32_t aThis
# else
	aThis
# endif
	)
# if !__myc_require(prototypes)
	int32_t aThis;
# endif
{
	struct aorp_udvariant64 retval = {
		AorpK_HINT_INT32, 0
	};
	retval.u.udc_i32 = aThis;
	return (retval);
}

__myc_extern_inline__ struct aorp_udvariant128
AorpUdvariant128_i32(
# if __myc_require(prototypes)
	int32_t aThis
# else
	aThis
# endif
	)
# if !__myc_require(prototypes)
	int32_t aThis;
# endif
{
	struct aorp_udvariant128 retval = {
		AorpK_HINT_INT32, 0
	};
	retval.u.udc_i32 = aThis;
	return (retval);
}

/* ----------------------------------------------------------------------------
 * AorpUdvariant_i64
 */

__myc_extern_inline__ struct aorp_udvariant64
AorpUdvariant64_i64(
# if __myc_require(prototypes)
	int64_t aThis
# else
	aThis
# endif
	)
# if !__myc_require(prototypes)
	int64_t aThis;
# endif
{
	struct aorp_udvariant64 retval = {
		AorpK_HINT_INT64, 0
	};
	retval.u.udc_i64 = aThis;
	return (retval);
}

__myc_extern_inline__ struct aorp_udvariant128
AorpUdvariant128_i64(
# if __myc_require(prototypes)
	int64_t aThis
# else
	aThis
# endif
	)
# if !__myc_require(prototypes)
	int64_t aThis;
# endif
{
	struct aorp_udvariant128 retval = {
		AorpK_HINT_INT64, 0
	};
	retval.u.udc_i64 = aThis;
	return (retval);
}

/* ----------------------------------------------------------------------------
 * AorpUdvariant_f32
 */

__myc_extern_inline__ struct aorp_udvariant64
AorpUdvariant64_f32(
# if __myc_require(prototypes)
	float aThis
# else
	aThis
# endif
	)
# if !__myc_require(prototypes)
	float aThis;
# endif
{
	struct aorp_udvariant64 retval = {
		AorpK_HINT_FLOAT32, 0
	};
	retval.u.udc_f32 = aThis;
	return (retval);
}

__myc_extern_inline__ struct aorp_udvariant128
AorpUdvariant128_f32(
# if __myc_require(prototypes)
	float aThis
# else
	aThis
# endif
	)
# if !__myc_require(prototypes)
	float aThis;
# endif
{
	struct aorp_udvariant128 retval = {
		AorpK_HINT_FLOAT32, 0
	};
	retval.u.udc_f32 = aThis;
	return (retval);
}

/* ----------------------------------------------------------------------------
 * AorpUdvariant_f64
 */

__myc_extern_inline__ struct aorp_udvariant64
AorpUdvariant64_f64(
# if __myc_require(prototypes)
	double aThis
# else
	aThis
# endif
	)
# if !__myc_require(prototypes)
	double aThis;
# endif
{
	struct aorp_udvariant64 retval = {
		AorpK_HINT_FLOAT64, 0
	};
	retval.u.udc_f64 = aThis;
	return (retval);
}

__myc_extern_inline__ struct aorp_udvariant128
AorpUdvariant128_f64(
# if __myc_require(prototypes)
	double aThis
# else
	aThis
# endif
	)
# if !__myc_require(prototypes)
	double aThis;
# endif
{
	struct aorp_udvariant128 retval = {
		AorpK_HINT_FLOAT64, 0
	};
	retval.u.udc_f64 = aThis;
	return (retval);
}

/* ----------------------------------------------------------------------------
 * AorpUdvariant_f128
 */

__myc_extern_inline__ struct aorp_udvariant128
AorpUdvariant128_f128(
# if __myc_require(prototypes)
	long double aThis
# else
	aThis
# endif
	)
# if !__myc_require(prototypes)
	long double aThis;
# endif
{
	struct aorp_udvariant128 retval = {
		AorpK_HINT_FLOAT128, 0
	};
	retval.u.udc_f128 = aThis;
	return (retval);
}

#endif /* !__BO_AORP_UDVARIANT__ */

/******************************************************************************
 * Revision History:
 *		$Log$
 *
 *****************************************************************************/
