/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright (c) 2005-2007 V.Sokur
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

/*
 * _ABI.h	(V.Sokur)
 * include/Bo/aorp/_ABI.h
 *
 * $Id$
 */

/******************************************************************************
 * %% BeginSection: definitions
 */
# pragma mark -
# pragma mark [ definitions ]
# pragma mark -

/*
 * The named-variadic-macro is rather used, because ISO C99 requires
 * rest arguments of a macro-call to be used.
 */

/*
 * _A_call
 */
# if __myc_support(NVM)

#  define _A_call _A_call1

#  define _A_call1(anOpname,aService,aThis,anErrPtr...) \
	_Art_call1(__aorp_builtin_opidof(anOpname,aService),__aorp_builtin_serviceidof(aService),aThis,anErrPtr)

#  define _A_call2(anOpname,aService,anId2,aThis,anErrPtr...) \
	_Art_call2(__aorp_builtin_opidof(anOpname,aService),__aorp_builtin_serviceidof(aService),anId2,aThis,anErrPtr)

#  define _A_call3(anOpname,aService,anId2,anId3,aThis,anErrPtr...) \
	_Art_call3(__aorp_builtin_opidof(anOpname,aService),__aorp_builtin_serviceidof(aService),anId2,anId3,aThis,anErrPtr)

#  define _A_call4(anOpname,aService,anId2,anId3,anId4,aThis,anErrPtr...) \
	_Art_call4(__aorp_builtin_opidof(anOpname,aService),__aorp_builtin_serviceidof(aService),anId2,anId3,anId4,aThis,anErrPtr)

#  define _A_call5(anOpname,aService,anId2,anId3,anId4,anId5,aThis,anErrPtr...) \
	_Art_call5(__aorp_builtin_opidof(anOpname,aService),__aorp_builtin_serviceidof(aService),anId2,anId3,anId4,anId5,aThis,anErrPtr)

# else
# if __myc_support(AVM)

#  define _A_call _A_call1

#  define _A_call1(anOpname,aService,aThis,...) \
	_Art_call1(__aorp_builtin_opidof(anOpname,aService),__aorp_builtin_serviceidof(aService),aThis,__VA_ARGS__)

#  define _A_call2(anOpname,aService,anId2,aThis,...) \
	_Art_call2(__aorp_builtin_opidof(anOpname,aService),__aorp_builtin_serviceidof(aService),anId2,aThis,__VA_ARGS__)

#  define _A_call3(anOpname,aService,anId2,anId3,aThis,...) \
	_Art_call3(__aorp_builtin_opidof(anOpname,aService),__aorp_builtin_serviceidof(aService),anId2,anId3,aThis,__VA_ARGS__)

#  define _A_call4(anOpname,aService,anId2,anId3,anId4,aThis,...) \
	_Art_call4(__aorp_builtin_opidof(anOpname,aService),__aorp_builtin_serviceidof(aService),anId2,anId3,anId4,aThis,__VA_ARGS__)

#  define _A_call5(anOpname,aService,anId2,anId3,anId4,anId5,aThis,...) \
	_Art_call5(__aorp_builtin_opidof(anOpname,aService),__aorp_builtin_serviceidof(aService),anId2,anId3,anId4,anId5,aThis,__VA_ARGS__)

# endif /* __myc_support(AVM) */
# endif /* __myc_support(NVM) */

/*
 * _Art_call
 */
# if __myc_support(NVM)

#  define _Art_call _Art_call1

#  define _Art_call1(anOpcode,aServiceId,aThis,anErrPtr...) \
	__aorp_call_(1,anOpcode,(aServiceId),aThis,anErrPtr)

#  define _Art_call2(anOpcode,aServiceId,anId2,aThis,anErrPtr...) \
	__aorp_call_(2,anOpcode,(aServiceId,anId2),aThis,anErrPtr)

#  define _Art_call3(anOpcode,aServiceId,anId2,anId3,aThis,anErrPtr...) \
	__aorp_call_(3,anOpcode,(aServiceId,anId2,anId3),aThis,anErrPtr)

#  define _Art_call4(anOpcode,aServiceId,anId2,anId3,anId4,aThis,anErrPtr...) \
	__aorp_call_(4,anOpcode,(aServiceId,anId2,anId3,anId4),aThis,anErrPtr)

#  define _Art_call5(anOpcode,aServiceId,anId2,anId3,anId4,anId5,aThis,anErrPtr...) \
	__aorp_call_(5,anOpcode,(aServiceId,anId2,anId3,anId4,anId5),aThis,anErrPtr)

# else
# if __myc_support(AVM)

#  define _Art_call _Art_call1

#  define _Art_call1(anOpcode,aServiceId,aThis,...) \
	__aorp_call_(1,anOpcode,(aServiceId),aThis,__VA_ARGS__)

#  define _Art_call2(anOpcode,aServiceId,anId2,aThis,...) \
	__aorp_call_(2,anOpcode,(aServiceId,anId2),aThis,__VA_ARGS__)

#  define _Art_call3(anOpcode,aServiceId,anId2,anId3,aThis,...) \
	__aorp_call_(3,anOpcode,(aServiceId,anId2,anId3),aThis,__VA_ARGS__)

#  define _Art_call4(anOpcode,aServiceId,anId2,anId3,anId4,aThis,...) \
	__aorp_call_(4,anOpcode,(aServiceId,anId2,anId3,anId4),aThis,__VA_ARGS__)

#  define _Art_call5(anOpcode,aServiceId,anId2,anId3,anId4,anId5,aThis,...) \
	__aorp_call_(5,anOpcode,(aServiceId,anId2,anId3,anId4,anId5),aThis,__VA_ARGS__)

# endif /* __myc_support(AVM) */
# endif /* __myc_support(NVM) */

/*
 * _A_socall
 */
# if __myc_support(NVM)

#  define _A_socall(anOpname,aService,aSobject,anErrPtr...) \
	_Art_socall(__aorp_builtin_opidof(anOpname,aService),aSobject,anErrPtr)

# else
# if __myc_support(AVM)

#  define _A_socall(anOpname,aService,aSobject,...) \
	_Art_socall(__aorp_builtin_opidof(anOpname,aService),aSobject,__VA_ARGS__)

# endif /* __myc_support(AVM) */
# endif /* __myc_support(NVM) */

/*
 * _Art_socall
 */
# if __myc_support(NVM)

#  define _Art_socall(anOpcode,aSobject,anErrPtr...) \
	(AORP_CLOSURE_Opcode(AORP_SOBJECT_Getclosure(aSobject)) = (anOpcode), \
		(*AORP_CLOSURE_Opimpl(AORP_SOBJECT_Getclosure(aSobject),anOpcode))( \
			AORP_SOBJECT_Getclosure(aSobject),anErrPtr \
	))

# else
# if __myc_support(AVM)

#  define _Art_socall(anOpcode,aSobject,...) \
	(AORP_CLOSURE_Opcode(AORP_SOBJECT_Getclosure(aSobject)) = (anOpcode), \
		(*AORP_CLOSURE_Opimpl(AORP_SOBJECT_Getclosure(aSobject),anOpcode))( \
			AORP_SOBJECT_Getclosure(aSobject),__VA_ARGS__ \
	))

# endif /* __myc_support(AVM) */
# endif /* __myc_support(NVM) */

/*
 * _A_closcall
 */
# if __myc_support(NVM)

#  define _A_closcall(anOpname,aService,aClosure,anErrPtr...) \
	_Art_closcall(__aorp_builtin_opidof(anOpname,aService),aClosure,anErrPtr)

# else
# if __myc_support(AVM)

#  define _A_closcall(anOpname,aService,aClosure,...) \
	_Art_closcall(__aorp_builtin_opidof(anOpname,aService),aClosure,__VA_ARGS__)

# endif /* __myc_support(AVM) */
# endif /* __myc_support(NVM) */

/*
 * _Art_closcall
 */
# if __myc_support(NVM)

#  define _Art_closcall(anOpcode,aClosure,anErrPtr...) \
	((*AORP_CLOSURE_Opimpl(aClosure,anOpcode))(aorp_closure_p(aClosure),anErrPtr))

# else
# if __myc_support(AVM)

#  define _Art_closcall(anOpcode,aClosure,...) \
	((*AORP_CLOSURE_Opimpl(aClosure,anOpcode))(aorp_closure_p(aClosure),__VA_ARGS__))

# endif /* __myc_support(AVM) */
# endif /* __myc_support(NVM) */

/*
 * _A_opscall
 */
# if __myc_support(NVM)

#  define _A_opscall(anOpname,aService,anOps,aClosure,anErrPtr...) \
	_Art_opscall(__aorp_builtin_opidof(anOpname,aService),anOps,aClosure,anErrPtr)

# else
# if __myc_support(AVM)

#  define _A_opscall(anOpname,aService,anOps,aClosure,...) \
	_Art_opscall(__aorp_builtin_opidof(anOpname,aService),anOps,aClosure,__VA_ARGS__)

# endif /* __myc_support(AVM) */
# endif /* __myc_support(NVM) */

/*
 * _Art_opscall
 */
# if __myc_support(NVM)

#  define _Art_opscall(anOpcode,anOps,aClosure,anErrPtr...) \
	((*AORP_OPS_Opimpl(anOps,anOpcode))(aorp_closure_p(aClosure),anErrPtr))

# else
# if __myc_support(AVM)

#  define _Art_opscall(anOpcode,anOps,aClosure,...) \
	((*AORP_OPS_Opimpl(anOps,anOpcode))(aorp_closure_p(aClosure),__VA_ARGS__))

# endif /* __myc_support(AVM) */
# endif /* __myc_support(NVM) */

/*
 * Internal
 */

/*
 * __aorp_call
 */
# if __myc_support(macro_retval)

#  if __myc_support(NVM)
#   define __aorp_call_(N,anOpcode,anOIDinParen,aThis,anErrPtr...) \
	__extension__ ({ \
		bo_status_t aorpCallStatus; \
		__aorp_call_v(aorpCallStatus =,anOpcode,anOIDinParen,aThis,anErrPtr); \
		/* return */ (aorpCallStatus); \
	})

#  else
#  if __myc_support(AVM)
#   define __aorp_call_(N,anOpcode,anOIDinParen,aThis,...) \
	__extension__ ({ \
		bo_status_t aorpCallStatus; \
		__aorp_call_v(aorpCallStatus =,anOpcode,anOIDinParen,aThis,__VA_ARGS__); \
		/* return */ (aorpCallStatus); \
	})
#  endif /* __myc_support(AVM) */
#  endif /* __myc_support(NVM) */

# else /* !__myc_support(macro_retval) */
# ifdef __cplusplus

#  if __myc_support(NVM)
#   define __aorp_call_(N,anOpcode,anOIDinParen,aThis,anErrPtr...) \
		(__aorp_call_ret(__aorp_call_tramp( \
			__aorp_call_closure(aThis,N,anOpcode,_RQUO(anOIDinParen)), \
			anErrPtr \
		)))
#  else
#  if __myc_support(AVM)
#   define __aorp_call_(N,anOpcode,anOIDinParen,aThis,...) \
		(__aorp_call_ret(__aorp_call_tramp( \
			__aorp_call_closure(aThis,N,anOpcode,_RQUO(anOIDinParen)), \
			__VA_ARGS__ \
		)))
#  endif /* __myc_support(AVM) */
#  endif /* __myc_support(NVM) */

# else /* !__cplusplus */

#  if __myc_support(NVM)
#   define __aorp_call_(N,anOpcode,anOIDinParen,aThis,anErrPtr...) \
		(__aorp_call_ret(__aorp_call_tramp( \
			__aorp_call_closure(aThis,N,anOpcode,anOIDinParen), \
			anErrPtr \
		)))
#  else
#  if __myc_support(AVM)
#   define __aorp_call_(N,anOpcode,anOIDinParen,aThis,...) \
		(__aorp_call_ret(__aorp_call_tramp( \
			__aorp_call_closure(aThis,N,anOpcode,anOIDinParen), \
			__VA_ARGS__ \
		)))
#  endif /* __myc_support(AVM) */
#  endif /* __myc_support(NVM) */

# endif /* __cplusplus */
# endif /* __myc_support(macro_retval) */

/*
 * __aorp_call_v
 */
# if __myc_support(NVM)

#  define __aorp_call_v(aStatusEqu,anOpcode,anOpsOIDinParen,aThis,anErrPtr...) \
	do { \
		struct aorp_operation *aorpCallOp; \
		struct aorp_closure aorpCallClosure; \
		aorp_oid_t aorpCallOpid[] = _A_ropsoid_i(anOpcode, anOpsOIDinParen); \
		AORP_OID_Count(aorpCallOpid) = __myc_namembs(aorpCallOpid) - 2; \
		aorpCallOp = AorpLookupoporstub(aThis, aorpCallOpid, &aorpCallClosure); \
		aStatusEqu (*aorpCallOp->impl_)(&aorpCallClosure, anErrPtr); \
	} while (0)

# else
# if __myc_support(AVM)

#  define __aorp_call_v(aStatusEqu,anOpcode,anOpsOIDinParen,aThis,...) \
	do { \
		struct aorp_operation *aorpCallOp; \
		struct aorp_closure aorpCallClosure; \
		aorp_oid_t aorpCallOpid[] = _A_ropsoid_i(anOpcode, anOpsOIDinParen); \
		AORP_OID_Count(aorpCallOpid) = __myc_namembs(aorpCallOpid) - 2; \
		aorpCallOp = AorpLookupoporstub(aThis, aorpCallOpid, &aorpCallClosure); \
		aStatusEqu (*aorpCallOp->impl_)(&aorpCallClosure, __VA_ARGS__); \
	} while (0)

# endif /* __myc_support(AVM) */
# endif /* __myc_support(NVM) */

# pragma mark -

# if !__myc_support(macro_retval)
#  ifdef __cplusplus

struct __aorp_call_closure;

extern "C" bo_status_t
__aorp_call_tramp(struct __aorp_call_closure &, ...);

inline bo_status_t __aorp_call_ret(bo_status_t aStatus) {
	return (aStatus);
}

struct __aorp_call_closure {
	struct aorp_closure  clo_;
	aorp_operation_fn    impl_;

	__aorp_call_closure(aorp_object_t aThis, unsigned N,
			aorp_oid1_t anOpcode, aorp_oid1_t anId)
	{
		aorp_oid_t opid[] = _Art_ropsoid1_i(anOpcode,anId);
		this->impl_ = AorpLookupoporstub(aThis, opid, &this->clo_)->impl_;
	}

	__aorp_call_closure(aorp_object_t aThis, unsigned N,
			aorp_oid1_t anOpcode, aorp_oid1_t anId, aorp_oid1_t anId2)
	{
		aorp_oid_t opid[] = _Art_ropsoid2_i(anOpcode,anId,anId2);
		this->impl_ = AorpLookupoporstub(aThis, opid, &this->clo_)->impl_;
	}

	__aorp_call_closure(aorp_object_t aThis, unsigned N,
			aorp_oid1_t anOpcode, aorp_oid1_t anId, aorp_oid1_t anId2,
			aorp_oid1_t anId3)
	{
		aorp_oid_t opid[] = _Art_ropsoid3_i(anOpcode,anId,anId2,anId3);
		this->impl_ = AorpLookupoporstub(aThis, opid, &this->clo_)->impl_;
	}

	__aorp_call_closure(aorp_object_t aThis, unsigned N,
			aorp_oid1_t anOpcode, aorp_oid1_t anId, aorp_oid1_t anId2,
			aorp_oid1_t anId3, aorp_oid1_t anId4)
	{
		aorp_oid_t opid[] = _Art_ropsoid4_i(anOpcode,anId,anId2,anId3,anId4);
		this->impl_ = AorpLookupoporstub(aThis, opid, &this->clo_)->impl_;
	}
};

#  else /* ! __cplusplus */

#   ifndef __AORP_CLOSURE_TRAMP_STRUC_DEFINED
#    define __AORP_CLOSURE_TRAMP_STRUC_DEFINED
struct __aorp_closure_tramp {
	struct aorp_closure  clo_;
	aorp_operation_fn    impl_;
};
#   endif /* __AORP_CLOSURE_TRAMP_STRUC_DEFINED */

#   if __myc_support(TUNO_DINI)
#    define __aorp_closure_tramp_att() \
		&(struct __aorp_closure_tramp){ .clo_ = {0}, .impl_ = NULLF }
#    define __aorp_closure_tramp_det() ((void)0)
#   else
extern struct __aorp_closure_tramp *__aorp_closure_tramp_att();
extern void __aorp_closure_tramp_det();
#   endif /* __myc_support(TUNO_DINI) */

extern bo_status_t
__aorp_call_tramp(struct __aorp_closure_tramp *, ...);

__myc_extern_inline__ bo_status_t __aorp_call_ret(bo_status_t aStatus) {
	__aorp_closure_tramp_det();
	return (aStatus);
}

#   define __aorp_call_closure(aThis,N,anOpcode,anOIDinParen) \
		__myc_xconcat(__aorp_call_closure,N)( \
			__aorp_closure_tramp_att(), \
			aThis,N,anOpcode,_RQUO(anOIDinParen) \
		)

__myc_extern_inline__ struct __aorp_closure_tramp *
__aorp_call_closure1(
	struct __aorp_closure_tramp *aClosure,
	aorp_object_t aThis, unsigned N,
	aorp_oid1_t anOpcode, aorp_oid1_t anId
	)
{
	aorp_oid_t opid[] = _Art_ropsoid1_i(anOpcode,anId);
	aClosure->impl_ = AorpLookupoporstub(aThis, opid, &aClosure->clo_)->impl_;
	return (aClosure);
}

__myc_extern_inline__ struct __aorp_closure_tramp *
__aorp_call_closure2(
	struct __aorp_closure_tramp *aClosure,
	aorp_object_t aThis, unsigned N,
	aorp_oid1_t anOpcode, aorp_oid1_t anId, aorp_oid1_t anId2
	)
{
	aorp_oid_t opid[] = _Art_ropsoid2_i(anOpcode,anId,anId2);
	aClosure->impl_ = AorpLookupoporstub(aThis, opid, &aClosure->clo_)->impl_;
	return (aClosure);
}

__myc_extern_inline__ struct __aorp_closure_tramp *
__aorp_call_closure3(
	struct __aorp_closure_tramp *aClosure,
	aorp_object_t aThis, unsigned N,
	aorp_oid1_t anOpcode, aorp_oid1_t anId, aorp_oid1_t anId2,
	aorp_oid1_t anId3
	)
{
	aorp_oid_t opid[] = _Art_ropsoid3_i(anOpcode,anId,anId2,anId3);
	aClosure->impl_ = AorpLookupoporstub(aThis, opid, &aClosure->clo_)->impl_;
	return (aClosure);
}

__myc_extern_inline__ struct __aorp_closure_tramp *
__aorp_call_closure4(
	struct __aorp_closure_tramp *aClosure,
	aorp_object_t aThis, unsigned N,
	aorp_oid1_t anOpcode, aorp_oid1_t anId, aorp_oid1_t anId2,
	aorp_oid1_t anId3, aorp_oid1_t anId4
	)
{
	aorp_oid_t opid[] = _Art_ropsoid4_i(anOpcode,anId,anId2,anId3,anId4);
	aClosure->impl_ = AorpLookupoporstub(aThis, opid, &aClosure->clo_)->impl_;
	return (aClosure);
}

#  endif /* __cplusplus */
# endif /* !__myc_support(macro_retval) */

/******************************************************************************
 * Revision History:
 *		$Log$
 *
 *****************************************************************************/
