/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright (c) 2005-2007 V.Sokur
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

/*
 * _AorpC.h	(V.Sokur)
 * include/Bo/aorp/_AorpC.h
 *
 * $Id$
 */

/* ------------------------------------------------------------------------- */

#ifndef __AORPC_FIRST_INCLUDED__
# define __AORPC_FIRST_INCLUDED__ 1

/******************************************************************************
 * %% BeginSection: definitions
 */

/* ----------------------------------------------------------------------------
 * service-element oid (init form)
 */

# define _A_seoid_i(anOIDinParen) \
	_A_seoid_i_(__myc_list_count(anOIDinParen),anOIDinParen)

# define _A_seoid_i_(N,anOIDinParen) \
	{ (aorp_oid_t)(N + 1), _AORP_OID_NONOP, AorpK_SE_CATEGORY, _RQUO(anOIDinParen) }

/* ------------------------------------------------------------------------- */

# define _Art_seoid1_i(aServiceId) \
	{ 2, _AORP_OID_NONOP, AorpK_SE_CATEGORY, aServiceId }

# define _Art_seoid2_i(aServiceId, aDomainId) \
	{ 3, _AORP_OID_NONOP, AorpK_SE_CATEGORY, aServiceId, aDomainId }

# define _A_seoid1_i(aServiceName) \
	_Art_seoid1_i(_A_serviceidof(aServiceName))

# define _A_seoid2_i(aServiceName,aDomainName) \
	_Art_seoid2_i(_A_serviceidof(aServiceName), _A_opdomidof(aDomainName))

/* ----------------------------------------------------------------------------
 * ops oid (init form)
 */

/* anOIDinParen = (id1, ... ) */
# define _A_opsoid_i(anOIDinParen) \
	_A_ropsoid_i(_AORP_OID_NONOP,anOIDinParen)

# define _A_opsoid_i_(N,anOIDinParen) \
	_A_ropsoid_i_(_AORP_OID_NONOP,N,anOIDinParen)

/* ------------------------------------------------------------------------- */

# define _Art_opsoid1_i(aServiceId) \
	_Art_ropsoid1_i(_AORP_OID_NONOP,aServiceId)

# define _Art_opsoid2_i(aServiceId,aDomainId) \
	_Art_ropsoid2_i(_AORP_OID_NONOP,aServiceId,aDomainId)

# define _Art_opsoid3_i(aServiceId,aDomainId,anId3) \
	_Art_ropsoid3_i(_AORP_OID_NONOP,aServiceId,aDomainId,anId3)

# define _Art_opsoid4_i(aServiceId,aDomainId,anId3,anId4) \
	_Art_ropsoid4_i(_AORP_OID_NONOP,aServiceId,aDomainId,anId3,anId4)

/* ------------------------------------------------------------------------- */

# define _A_opsoid1_i(aServiceName) \
	_Art_opsoid1_i(_A_serviceidof(aServiceName))

# define _A_opsoid2_i(aServiceName,aDomainName) \
	_Art_opsoid2_i(_A_serviceidof(aServiceName),_A_opdomidof(aDomainName))

# define _A_opsoid3_i(aServiceName,aDomainName,anId3) \
	_Art_opsoid3_i(_A_serviceidof(aServiceName),_A_opdomidof(aDomainName),anId3)

# define _A_opsoid4_i(aServiceName,aDomainName,anId3,anId4) \
	_Art_opsoid4_i(_A_serviceidof(aServiceName),_A_opdomidof(aDomainName),anId3,anId4)

/* ------------------------------------------------------------------------- */

/* anOIDinParen = (id1, ... ) */
# define _A_ropsoid_i(anOpId,anOIDinParen) \
	_A_ropsoid_i_(anOpId,__myc_list_count(anOIDinParen),anOIDinParen)

# define _A_ropsoid_i_(anOpId,N,anOIDinParen) \
	{ (aorp_oid_t)(N + 1), anOpId, AorpK_OPS_CATEGORY, _RQUO(anOIDinParen) }

/* ------------------------------------------------------------------------- */

# define _Art_ropsoid1_i(anOpId,aServiceId) \
	{ 2, anOpId, AorpK_OPS_CATEGORY, aServiceId }

# define _Art_ropsoid2_i(anOpId,aServiceId,aDomainId) \
	{ 3, anOpId, AorpK_OPS_CATEGORY, aServiceId, aDomainId }

# define _Art_ropsoid3_i(anOpId,aServiceId,aDomainId,anId3) \
	{ 4, anOpId, AorpK_OPS_CATEGORY, aServiceId, aDomainId, anId3 }

# define _Art_ropsoid4_i(anOpId,aServiceId,aDomainId,anId3,anId4) \
	{ 5, anOpId, AorpK_OPS_CATEGORY, aServiceId, aDomainId, anId3, anId4 }

/* ------------------------------------------------------------------------- */

# define _A_ropsoid1_i(aRoutine,aServiceName) \
	_Art_ropsoid1_i(_A_opidof(aRoutine,aServiceName),_A_serviceidof(aServiceName))

# define _A_ropsoid2_i(aRoutine,aServiceName,aDomainName) \
	_Art_ropsoid2_i(_A_opidof(aRoutine,aServiceName),_A_serviceidof(aServiceName),_A_opdomidof(aDomainName))

# define _A_ropsoid3_i(aRoutine,aServiceName,aDomainName,anId3) \
	_Art_ropsoid3_i(_A_opidof(aRoutine,aServiceName),_A_serviceidof(aServiceName),_A_opdomidof(aDomainName),anId3)

# define _A_ropsoid4_i(aRoutine,aServiceName,aDomainName,anId3,anId4) \
	_Art_ropsoid4_i(_A_opidof(aRoutine,aServiceName),_A_serviceidof(aServiceName),_A_opdomidof(aDomainName),anId3,anId4)

/* ----------------------------------------------------------------------------
 * class oid (init form)
 */

/* anOIDinParen = (id1, ... ) */
# define _A_classoid_i(anOIDinParen) \
	_A_classoid_i_(__myc_list_count(anOIDinParen),anOIDinParen)

# define _A_classoid_i_(N,anOIDinParen) \
	{ (aorp_oid_t)(N + 1), _AORP_OID_NONOP, AorpK_OBJECT_CATEGORY, _RQUO(anOIDinParen) }

/* ------------------------------------------------------------------------- */

# define _Art_classoid1_i(anObjectId) \
	{ 2, _AORP_OID_NONOP, AorpK_OBJECT_CATEGORY, anObjectId }

# define _Art_classoid2_i(anObjectId, aSecondId) \
	{ 3, _AORP_OID_NONOP, AorpK_OBJECT_CATEGORY, anObjectId, aSecondId }

# define _A_classoid1_i(anObjectName) \
	_Art_classoid1_i(_A_objectidof(anObjectName))

# define _A_classoid2_i(anObjectName, aSecondId) \
	_Art_classoid2_i(_A_objectidof(anObjectName), aSecondId)

/* ----------------------------------------------------------------------------
 * module oid (init form)
 */

/* anOIDinParen = (id1, ... ) */
# define _A_moduleoid_i(anOIDinParen) \
	_A_moduleoid_i_(__myc_list_count(anOIDinParen),anOIDinParen)

# define _A_moduleoid_i_(N,anOIDinParen) \
	{ (aorp_oid_t)(N + 1), _AORP_OID_NONOP, AorpK_MODULE_CATEGORY, _RQUO(anOIDinParen) }

/* ------------------------------------------------------------------------- */

# define _Art_moduleoid1_i(aModuleId) \
	{ 2, _AORP_OID_NONOP, AorpK_MODULE_CATEGORY, aModuleId }

# define _A_moduleoid1_i(aModuleName) \
	_Art_moduleoid1_i(_A_moduleidof(aModuleName))

/* ============================================================================
 * MISC pseudo-keywords
 * @{
 */
# pragma mark -
# pragma mark [ MISC pseudo-keywords ]
# pragma mark -

/* aProtocolNS: (service-name, opdom-name [, id3, ...]) */
# define _A_ns_protocol_nm2id(aProtocolNS) \
	__aorpc_ns_protocol_nm2id(aProtocolNS)

/* anObjectNS: (object-name, id2, ...) */
# define _A_ns_object_nm2id(anObjectNS) \
	__aorpc_ns_object_nm2id(anObjectNS)

/* ----------------------------------------------------------------------------
 * @group Intrinsic
 * @{
 */

/*
aorp_object_t
_Art_classof(aorp_object_t aThis);
 */
# define _Art_classof(anObject) AorpClassof(anObject)

/*
aorp_object_t
_Art_xclassof(aorp_object_t aThis);
 */
# define _Art_xclassof(anObject) AorpXclassof(anObject)

/*
aorp_object_t
_Art_moduleof(aorp_object_t aThis);
 */
# define _Art_moduleof(anObject) AorpModuleof(anObject)

/*
aorp_object_t
_Art_xmoduleof(aorp_object_t aThis);
 */
# define _Art_xmoduleof(anObject) AorpXmoduleof(anObject)

/* ------------------------------------------------------------------------- */

/*
char const *
_Art_longkeyof(aorp_object_t aThis);
 */
# define _Art_longkeyof(anObject) AorpObjectLongkey(anObject)

/*
char const *
_Art_shortkeyof(aorp_object_t aThis);
 */
# define _Art_shortkeyof(anObject) AorpObjectShortkey(anObject)

/*
char const *
_Art_nameof(aorp_object_t aThis);
 */
# define _Art_nameof(anObject) AorpObjectName(anObject)

/* ------------------------------------------------------------------------- */

/*
aorp_oid1_t
_Art_categoryof(aorp_object_t aThis);
 */
# define _Art_categoryof(anObject) AorpObjectCategory(anObject)

/*
aorp_oid1_t
_Art_primidof(aorp_object_t aThis);
 */
# define _Art_primidof(anObject) AorpObjectPrimID(anObject)

/*
aorp_oid_t *
_Art_oidof(
	aorp_object_t aThis,
	aorp_oid_t aBuffer[<AorpK_OID_LEN>]
	);
 */
# define _Art_oidof(anObject, aBuffer) AorpObjectOID(anObject, aBuffer)

/* ------------------------------------------------------------------------- */

/* Get the service-object for the aorp-object @this.
   The object is not retained. That's why releasing the service-object
   is releasing the object @this. */

# define _Art_seobjbyoid(aThis, anOID, aBuffer, anErrPtr) \
	AorpSeobject(aThis, anOID, aBuffer, anErrPtr)

# define _Art_seobjbyoid1(aThis, aServiceId, aBuffer, anErrPtr) \
	AorpSeobject1(aThis, aServiceId, aBuffer, anErrPtr)

# define _Art_seobjbyoid2(aThis, aServiceId, aSecondId, aBuffer, anErrPtr) \
	AorpSeobject2(aThis, aServiceId, aSecondId, aBuffer, anErrPtr)

# define _Art_seobjof(aThis, aServiceId, aBuffer, anErrPtr) \
	_Art_seobjbyoid1(aThis, aServiceId, aBuffer, anErrPtr)

# define _A_seobjof(aThis, aServiceName, aBuffer, anErrPtr) \
	_Art_seobjof(aThis, _A_serviceidof(aServiceName), aBuffer, anErrPtr)

/* ------------------------------------------------------------------------- */

# define _Art_suppservice(aThis, anOID, anErrPtr) \
	AorpSuppservice(aThis, anOID, anErrPtr)

# define _Art_suppservice1(aThis, aServiceId, anErrPtr) \
	AorpSuppservice1(aThis, aServiceId, anErrPtr)

# define _Art_suppservice2(aThis, aServiceId, aSecondId, anErrPtr) \
	AorpSuppservice2(aThis, aServiceId, aSecondId, anErrPtr)

# define _A_suppservice(aThis, aServiceName, anErrPtr) \
	_Art_suppservice1(aThis, _A_serviceidof(aServiceName), anErrPtr)

/* ------------------------------------------------------------------------- */

# define _Art_pushback_ses(aThis, aSes, anErrPtr) \
	_AorpSelistPushback( \
		&aorp_cobject_p(aThis)->selist_, aorp_ses_p(aSes), anErrPtr \
	)

# define _Art_pushfront_ses(aThis, aSes, anErrPtr) \
	_AorpSelistPushfront( \
		&aorp_cobject_p(aThis)->selist_, aorp_ses_p(aSes), anErrPtr \
	)

# define _Art_pushback_ses_nlk(aThis, aSes, anErrPtr) \
	_AorpSelistPushback_nlk( \
		&aorp_cobject_p(aThis)->selist_, aorp_ses_p(aSes), anErrPtr \
	)

# define _Art_pushfront_ses_nlk(aThis, aSes, anErrPtr) \
	_AorpSelistPushfront_nlk( \
		&aorp_cobject_p(aThis)->selist_, aorp_ses_p(aSes), anErrPtr \
	)

/* ------------------------------------------------------------------------- */

/* Get the pointer to the pod (plain object data) of the aorp-object @this,
   specified by the @oid, if any. */

# define _Art_podbyoid(aThis, anOID, anErrPtr) \
	AorpLookupPOD(aThis, anOID, anErrPtr)

# define _Art_podbyoid1(aThis, aServiceId, anErrPtr) \
	AorpLookupPOD1(aThis, aServiceId, anErrPtr)

# define _Art_podbyoid2(aThis, aServiceId, aSecondId, anErrPtr) \
	AorpLookupPOD2(aThis, aServiceId, aSecondId, anErrPtr)

# define _Art_podof(aThis, aServiceId, anErrPtr) \
	_Art_podbyoid1(aThis, aServiceId, anErrPtr)

# define _A_podof(aThis, aServiceName, anErrPtr) \
	_Art_podof(aThis, _A_serviceidof(aServiceName), anErrPtr)

/* ------------------------------------------------------------------------- */

/* Get the closure for the aorp-object @this, specified by the @oid. */

# define _Art_closurebyoid(aThis, anOID, aBuffer, anErrPtr) \
	_AorpClosure(aThis, anOID, aBuffer, anErrPtr)

# define _Art_closurebyoid1(aThis, aServiceId, aBuffer, anErrPtr) \
	_AorpClosure1(aThis, aServiceId, aBuffer, anErrPtr)

# define _Art_closurebyoid2(aThis, aServiceId, aSecondId, aBuffer, anErrPtr) \
	_AorpClosure2(aThis, aServiceId, aSecondId, aBuffer, anErrPtr)

# define _Art_closureof(aThis, aServiceId, aBuffer, anErrPtr) \
	_Art_closurebyoid1(aThis, aServiceId, aBuffer, anErrPtr)

# define _A_closureof(aThis, aServiceName, aBuffer, anErrPtr) \
	_Art_closureof(aThis, _A_serviceidof(aServiceName), aBuffer, anErrPtr)

/* @} */

/* ----------------------------------------------------------------------------
 * @group Constructor
 * @{
 */
# pragma mark -

/* ----------------------------------------------------------------------------
 * Construct object
 */

# define _Art_allocbyoid(anOID, Flags, aMemory, anErrPtr) \
	AorpAlloc(_Art_clsbyoid(anOID), Flags, aMemory, 0, anErrPtr)

# define _A_allocbyoid(anOIDinParen, Flags, aMemory, anErrPtr) \
	AorpAlloc(_A_clsbyoid(anOIDinParen), Flags, aMemory, 0, anErrPtr)

/* ------------------------------------------------------------------------- */

# define _Art_alloc1(anObjectId, Flags, aMemory, anErrPtr) \
	AorpAlloc(_Art_clsbyoid1(anObjectId), Flags, aMemory, 0, anErrPtr)

# define _Art_alloc2(aPrimId, aSecondId, Flags, aMemory, anErrPtr) \
	AorpAlloc(_Art_clsbyoid2(aPrimId, aSecondId), Flags, aMemory, 0, anErrPtr)

# define _Art_initx(aThis, aParmv, aParmc, anErrPtr) \
	AorpInitDeallocIfError(aThis, aParmv, aParmc, anErrPtr)

# define _Art_init(aThis, aParmv, aParmc, anErrPtr) \
	AorpInit(aThis, aParmv, aParmc, anErrPtr)

/* ----------------------------------------------------------------------------
 * Open object by id
 */

# define _Art_openbyoid(anOID, Flags, aMemory, aParmv, aParmc, anErrPtr) \
	_Art_initx( \
		_Art_allocbyoid(anOID, Flags, aMemory, anErrPtr), \
		aParmv, aParmc, anErrPtr \
	)

# define _A_openbyoid(anOIDinParen, Flags, aMemory, aParmv, aParmc, anErrPtr) \
	_Art_initx( \
		_A_allocbyoid(anOIDinParen, Flags, aMemory, anErrPtr), \
		aParmv, aParmc, anErrPtr \
	)

/* ------------------------------------------------------------------------- */

# define _Art_open1(anObjectId, Flags, aMemory, aParmv, aParmc, anErrPtr) \
	_Art_initx( \
		_Art_alloc1(anObjectId, Flags, aMemory, anErrPtr), \
		aParmv, aParmc, anErrPtr \
	)

# define _Art_open2(aPrimId, aSecondId, Flags, aMemory, aParmv, aParmc, anErrPtr) \
	_Art_initx( \
		_Art_alloc2(aPrimId, aSecondId, Flags, aMemory, anErrPtr), \
		aParmv, aParmc, anErrPtr \
	)

/* ------------------------------------------------------------------------- */

# define _A_openbyoid_v0(aResultRef, anOIDinParen, Flags, aMemory, anErrPtr) \
	((aResultRef) = _A_openbyoid(anOIDinParen, Flags, aMemory, NULL, 0, anErrPtr))

/* aPodInitParm: (N, (service-name, opdom-name [, id3, ...]), parm1) */
# define _A_openbyoid_v1(aResultRef, anOIDinParen, Flags, aMemory, aPodInitParm, anErrPtr) \
	do { \
		__aorp_defproinitpod_(1,aPodInitParm); \
		struct aorp_podinit_s *aorpOpenParmv[] = { \
			__aorp_refproinitpod_list_(1) \
		}; \
		(aResultRef) = _A_openbyoid( \
			anOIDinParen, Flags, aMemory, \
			aorpOpenParmv, __myc_namembs(aorpOpenParmv), anErrPtr \
		); \
	} while (0)

# define _A_openbyoid_v2(aResultRef, anOIDinParen, Flags, aMemory, p1, p2, anErrPtr) \
	do { \
		__aorp_defproinitpod_(1,p1); \
		__aorp_defproinitpod_(2,p2); \
		struct aorp_podinit_s *aorpOpenParmv[] = { \
			__aorp_refproinitpod_list_(2) \
		}; \
		(aResultRef) = _A_openbyoid( \
			anOIDinParen, Flags, aMemory, \
			aorpOpenParmv, __myc_namembs(aorpOpenParmv), anErrPtr \
		); \
	} while (0)

# define _A_openbyoid_v3(aResultRef, anOIDinParen, Flags, aMemory, p1, p2, p3, anErrPtr) \
	do { \
		__aorp_defproinitpod_(1,p1); \
		__aorp_defproinitpod_(2,p2); \
		__aorp_defproinitpod_(3,p3); \
		struct aorp_podinit_s *aorpOpenParmv[] = { \
			__aorp_refproinitpod_list_(3) \
		}; \
		(aResultRef) = _A_openbyoid( \
			anOIDinParen, Flags, aMemory, \
			aorpOpenParmv, __myc_namembs(aorpOpenParmv), anErrPtr \
		); \
	} while (0)

# define _A_openbyoid_v4(aResultRef, anOIDinParen, Flags, aMemory, p1, p2, p3, p4, anErrPtr) \
	do { \
		__aorp_defproinitpod_(1,p1); \
		__aorp_defproinitpod_(2,p2); \
		__aorp_defproinitpod_(3,p3); \
		__aorp_defproinitpod_(4,p4); \
		struct aorp_podinit_s *aorpOpenParmv[] = { \
			__aorp_refproinitpod_list_(4) \
		}; \
		(aResultRef) = _A_openbyoid( \
			anOIDinParen, Flags, aMemory, \
			aorpOpenParmv, __myc_namembs(aorpOpenParmv), anErrPtr \
		); \
	} while (0)

# define _A_openbyoid_v5(aResultRef, anOIDinParen, Flags, aMemory, p1, p2, p3, p4, p5, anErrPtr) \
	do { \
		__aorp_defproinitpod_(1,p1); \
		__aorp_defproinitpod_(2,p2); \
		__aorp_defproinitpod_(3,p3); \
		__aorp_defproinitpod_(4,p4); \
		__aorp_defproinitpod_(5,p5); \
		struct aorp_podinit_s *aorpOpenParmv[] = { \
			__aorp_refproinitpod_list_(5) \
		}; \
		(aResultRef) = _A_openbyoid( \
			anOIDinParen, Flags, aMemory, \
			aorpOpenParmv, __myc_namembs(aorpOpenParmv), anErrPtr \
		); \
	} while (0)

# define _A_openbyoid_v6(aResultRef, anOIDinParen, Flags, aMemory, p1, p2, p3, p4, p5, p6, anErrPtr) \
	do { \
		__aorp_defproinitpod_(1,p1); \
		__aorp_defproinitpod_(2,p2); \
		__aorp_defproinitpod_(3,p3); \
		__aorp_defproinitpod_(4,p4); \
		__aorp_defproinitpod_(5,p5); \
		__aorp_defproinitpod_(6,p6); \
		struct aorp_podinit_s *aorpOpenParmv[] = { \
			__aorp_refproinitpod_list_(6) \
		}; \
		(aResultRef) = _A_openbyoid( \
			anOIDinParen, Flags, aMemory, \
			aorpOpenParmv, __myc_namembs(aorpOpenParmv), anErrPtr \
		); \
	} while (0)

# define _A_openbyoid_v7(aResultRef, anOIDinParen, Flags, aMemory, p1, p2, p3, p4, p5, p6, p7, anErrPtr) \
	do { \
		__aorp_defproinitpod_(1,p1); \
		__aorp_defproinitpod_(2,p2); \
		__aorp_defproinitpod_(3,p3); \
		__aorp_defproinitpod_(4,p4); \
		__aorp_defproinitpod_(5,p5); \
		__aorp_defproinitpod_(6,p6); \
		__aorp_defproinitpod_(7,p7); \
		struct aorp_podinit_s *aorpOpenParmv[] = { \
			__aorp_refproinitpod_list_(7) \
		}; \
		(aResultRef) = _A_openbyoid( \
			anOIDinParen, Flags, aMemory, \
			aorpOpenParmv, __myc_namembs(aorpOpenParmv), anErrPtr \
		); \
	} while (0)

# define _A_openbyoid_v8(aResultRef, anOIDinParen, Flags, aMemory, p1, p2, p3, p4, p5, p6, p7, p8, anErrPtr) \
	do { \
		__aorp_defproinitpod_(1,p1); \
		__aorp_defproinitpod_(2,p2); \
		__aorp_defproinitpod_(3,p3); \
		__aorp_defproinitpod_(4,p4); \
		__aorp_defproinitpod_(5,p5); \
		__aorp_defproinitpod_(6,p6); \
		__aorp_defproinitpod_(7,p7); \
		__aorp_defproinitpod_(8,p8); \
		struct aorp_podinit_s *aorpOpenParmv[] = { \
			__aorp_refproinitpod_list_(8) \
		}; \
		(aResultRef) = _A_openbyoid( \
			anOIDinParen, Flags, aMemory, \
			aorpOpenParmv, __myc_namembs(aorpOpenParmv), anErrPtr \
		); \
	} while (0)

# define _A_openbyoid_v9(aResultRef, anOIDinParen, Flags, aMemory, p1, p2, p3, p4, p5, p6, p7, p8, p9, anErrPtr) \
	do { \
		__aorp_defproinitpod_(1,p1); \
		__aorp_defproinitpod_(2,p2); \
		__aorp_defproinitpod_(3,p3); \
		__aorp_defproinitpod_(4,p4); \
		__aorp_defproinitpod_(5,p5); \
		__aorp_defproinitpod_(6,p6); \
		__aorp_defproinitpod_(7,p7); \
		__aorp_defproinitpod_(8,p8); \
		__aorp_defproinitpod_(9,p9); \
		struct aorp_podinit_s *aorpOpenParmv[] = { \
			__aorp_refproinitpod_list_(9) \
		}; \
		(aResultRef) = _A_openbyoid( \
			anOIDinParen, Flags, aMemory, \
			aorpOpenParmv, __myc_namembs(aorpOpenParmv), anErrPtr \
		); \
	} while (0)

# define _A_openbyoid_v10(aResultRef, anOIDinParen, Flags, aMemory, p1, p2, p3, p4, p5, p6, p7, p8, p9, p10, anErrPtr) \
	do { \
		__aorp_defproinitpod_(1,p1); \
		__aorp_defproinitpod_(2,p2); \
		__aorp_defproinitpod_(3,p3); \
		__aorp_defproinitpod_(4,p4); \
		__aorp_defproinitpod_(5,p5); \
		__aorp_defproinitpod_(6,p6); \
		__aorp_defproinitpod_(7,p7); \
		__aorp_defproinitpod_(8,p8); \
		__aorp_defproinitpod_(9,p9); \
		__aorp_defproinitpod_(10,p10); \
		struct aorp_podinit_s *aorpOpenParmv[] = { \
			__aorp_refproinitpod_list_(10) \
		}; \
		(aResultRef) = _A_openbyoid( \
			anOIDinParen, Flags, aMemory, \
			aorpOpenParmv, __myc_namembs(aorpOpenParmv), anErrPtr \
		); \
	} while (0)

/* ----------------------------------------------------------------------------
 * Open object by name
 */

# define _A_open1(anObjectName, Flags, aMemory, aParmv, aParmc, anErrPtr) \
	_Art_open1(_A_objectidof(anObjectName), Flags, aMemory, \
		aParmv, aParmc, anErrPtr)

# define _A_open2(anObjectName, aSecondId, Flags, aMemory, aParmc, aParmv, anErrPtr) \
	_Art_open2(_A_objectidof(anObjectName), aSecondId, Flags, aMemory, \
		aParmv, aParmc, anErrPtr)

/* ------------------------------------------------------------------------- */

/* anObjectNS: (object-name, id2, ...) */
# define _A_openbyname_v0(aResultRef, anObjectNS, Flags, aMemory, anErrPtr) \
	_A_openbyoid_v0(aResultRef, \
		__aorpc_ns_object_nm2id(anObjectNS), \
		Flags, aMemory, anErrPtr \
	)

/* aPodInitParm: (N, (service-name, opdom-name [, id3, ...]), parm1) */
# define _A_openbyname_v1(aResultRef, anObjectNS, Flags, aMemory, aPodInitParm, anErrPtr) \
	_A_openbyoid_v1(aResultRef, \
		__aorpc_ns_object_nm2id(anObjectNS), \
		Flags, aMemory, aPodInitParm, anErrPtr \
	)

# define _A_openbyname_v2(aResultRef, anObjectNS, Flags, aMemory, p1, p2, anErrPtr) \
	_A_openbyoid_v2(aResultRef, \
		__aorpc_ns_object_nm2id(anObjectNS), \
		Flags, aMemory, p1, p2, anErrPtr \
	)

# define _A_openbyname_v3(aResultRef, anObjectNS, Flags, aMemory, p1, p2, p3, anErrPtr) \
	_A_openbyoid_v3(aResultRef, \
		__aorpc_ns_object_nm2id(anObjectNS), \
		Flags, aMemory, p1, p2, p3, anErrPtr \
	)

# define _A_openbyname_v4(aResultRef, anObjectNS, Flags, aMemory, p1, p2, p3, p4, anErrPtr) \
	_A_openbyoid_v4(aResultRef, \
		__aorpc_ns_object_nm2id(anObjectNS), \
		Flags, aMemory, p1, p2, p3, p4, anErrPtr \
	)

# define _A_openbyname_v5(aResultRef, anObjectNS, Flags, aMemory, p1, p2, p3, p4, p5, anErrPtr) \
	_A_openbyoid_v5(aResultRef, \
		__aorpc_ns_object_nm2id(anObjectNS), \
		Flags, aMemory, p1, p2, p3, p4, p5, anErrPtr \
	)

# define _A_openbyname_v6(aResultRef, anObjectNS, Flags, aMemory, p1, p2, p3, p4, p5, p6, anErrPtr) \
	_A_openbyoid_v6(aResultRef, \
		__aorpc_ns_object_nm2id(anObjectNS), \
		Flags, aMemory, p1, p2, p3, p4, p5, p6, anErrPtr \
	)

# define _A_openbyname_v7(aResultRef, anObjectNS, Flags, aMemory, p1, p2, p3, p4, p5, p6, p7, anErrPtr) \
	_A_openbyoid_v7(aResultRef, \
		__aorpc_ns_object_nm2id(anObjectNS), \
		Flags, aMemory, p1, p2, p3, p4, p5, p6, p7, anErrPtr \
	)

# define _A_openbyname_v8(aResultRef, anObjectNS, Flags, aMemory, p1, p2, p3, p4, p5, p6, p7, p8, anErrPtr) \
	_A_openbyoid_v8(aResultRef, \
		__aorpc_ns_object_nm2id(anObjectNS), \
		Flags, aMemory, p1, p2, p3, p4, p5, p6, p7, p8, anErrPtr \
	)

# define _A_openbyname_v9(aResultRef, anObjectNS, Flags, aMemory, p1, p2, p3, p4, p5, p6, p7, p8, p9, anErrPtr) \
	_A_openbyoid_v9(aResultRef, \
		__aorpc_ns_object_nm2id(anObjectNS), \
		Flags, aMemory, p1, p2, p3, p4, p5, p6, p7, p8, p9, anErrPtr \
	)

# define _A_openbyname_v10(aResultRef, anObjectNS, Flags, aMemory, p1, p2, p3, p4, p5, p6, p7, p8, p9, p10, anErrPtr) \
	_A_openbyoid_v10(aResultRef, \
		__aorpc_ns_object_nm2id(anObjectNS), \
		Flags, aMemory, p1, p2, p3, p4, p5, p6, p7, p8, p9, p10, anErrPtr \
	)
/* @} */

/* @} MISC pseudo-keywords */

/* ============================================================================
 * COMMON pseudo-keywords
 * @{
 */
# pragma mark -
# pragma mark [ OPDOM pseudo-keywords ]
# pragma mark -

# define _A_hbdecl_ __aorp_hbdecl()
# define _A_end __aorp_end()
# define _A_end_ucb __aorp_end_ucb()

/* @} COMMON pseudo-keywords */

/* ============================================================================
 * OPDOM pseudo-keywords
 * @{
 */
# pragma mark -
# pragma mark [ OPDOM pseudo-keywords ]
# pragma mark -

/*
 * operation-domain oid1
 */

/* @todo: implement @{ */
# define _Art_opdomidof(aDomainNameStr) \
	AorpName2id(AorpK_OPDOMDB_CATEGORY, aDomainNameStr, NULL)
/* @} */

/*
 * get opdom id by name (AorpK_<domain>_opdom)
 */
# define _A_opdomidof(aDomainName) __aorp_opdomidof(aDomainName)

/* ------------------------------------------------------------------------- */

/*
 * 1. declare tag, typename
 */
# define _A_opdom_tag(aDomainName) __aorp_opdom_tag(aDomainName)
# define _A_opdom_typename(aDomainName) __aorp_opdom_typename(aDomainName)

/*
 * 1. declare object
 * 2. object reference
 */
# define _A_opdom(aDomainName) __aorp_opdom(aDomainName)

/*
 * declare an opdom in a protocol
 */
# define _A_domdecl(aDomainName) __aorp_domdecl(aDomainName)
# define _A_domdecl_ __aorp_current_domdecl
/* @} OPDOM pseudo-keywords */

/* ============================================================================
 * SERVICE pseudo-keywords
 * @{
 */
# pragma mark -
# pragma mark [ SERVICE pseudo-keywords ]
# pragma mark -

/*
 * service oid1
 */

/* @todo: implement @{ */
# define _Art_serviceidof(aServiceNameStr) \
	AorpName2id(AorpK_SERVICEDB_CATEGORY, aServiceNameStr, NULL)
/* @} */

/*
 * get service id by name
 */
# define _A_serviceidof(aServiceName) __aorp_builtin_serviceidof(aServiceName)

/* ----------------------------------------------------------------------------
 * service declaration
 */

/* begin service */
# define _A_service(aServiceName) __aorp_begin_service(aServiceName)

/* end service common-type-block */
# define _A_end_ctb __aorp_end_ctb

/* get number of service operations */
# define _A_sopcountof(aServiceName) __aorp_builtin_sopcountof(aServiceName)

/* get service operation oid1 */
# define _A_opidof(aRoutine,aServiceName) \
	__aorp_builtin_opidof(aRoutine,aServiceName)

# define _A_opcodeof(aRoutine,aServiceName) _A_opidof(aRoutine,aServiceName)

/* @} SERVICE pseudo-keywords */

/* ============================================================================
 * SERVICE OPERATION pseudo-keywords
 * @{
 */
# pragma mark -
# pragma mark [ SERVICE OPERATION pseudo-keywords ]
# pragma mark -

/*
 * service operation specifiers
 */
# define _A_attribute(attributes) __aorp_op_attribute(attributes)
# define _A_return(spec) __aorp_op_return(spec)

/*
 * declaration of a service operation
 */
# define _A_op(aRoutine,aNameStr,aProto) \
	__aorp_current_op(aRoutine,aNameStr,aProto)

/* @} SERVICE OPERATION pseudo-keywords */

/* ============================================================================
 * OBJECT pseudo-keywords
 * @{
 */
# pragma mark -
# pragma mark [ OBJECT pseudo-keywords ]
# pragma mark -

/*
 * get object id by name-str
 */
/* @todo: implement @{ */
# define _Art_objectidof(anObjectNameStr) \
	AorpName2id(AorpK_OBJECTDB_CATEGORY, anObjectNameStr, NULL)
/* @} */

/*
 * get object id by name
 */
# define _A_objectidof(anObjectName) __aorp_objectidof(anObjectName)

/* @} OBJECT pseudo-keywords */

/* ============================================================================
 * XOBJECT pseudo-keywords
 * @{
 */
# pragma mark -
# pragma mark [ XOBJECT pseudo-keywords ]
# pragma mark -

/*
 * declare tag, typename
 */

/* NOT FOR YOUR BUSINESS @{ */
# define _A_xobject_tag_(N,anObjectNS) __aorp_xobject_tag(N,anObjectNS)
# define _A_xobject_typename_(N,anObjectNS) __aorp_xobject_typename(N,anObjectNS)

# define _A_xobject_tag(anObjectName) __aorp_xobject_tag(1,(anObjectName))
# define _A_xobject_typename(anObjectName) __aorp_xobject_typename(1,anObjectName))
/* @} */

/*
 * 1. declare object
 * 2. object reference
 */
# define _A_xobject_(N,anObjectNS) __aorp_xobject(N,anObjectNS)
# define _A_xobject(anObjectName) __aorp_xobject(1,(anObjectName))

/*
 * get size of xobject<name>
 */
# define _A_xobsizeof_(N,anObjectNS) __aorp_xobsizeof(N,anObjectNS)
# define _A_xobsizeof(anObjectName) __aorp_xobsizeof(1,(anObjectName))

/*
 * get pod offset in a xobject<name>
 */
# define _A_xoboffsetof_(N,anObjectNS,aProtoDomainName,aPODFieldName) \
	__aorp_xoboffsetof(N,anObjectNS,aProtoDomainName,aPODFieldName)

# define _A_xoboffsetof(anObjectName,aProtoDomainName,aPODFieldName) \
	__aorp_xoboffsetof(1,(anObjectName),aProtoDomainName,aPODFieldName)

# define _A_self_xoboffsetof(aProtoDomainName,aPODFieldName) \
	__aorp_current_xoboffsetof(aProtoDomainName,aPODFieldName)

/* @} XOBJECT pseudo-keywords */

/* ============================================================================
 * COBJECT pseudo-keywords
 * @{
 */
# pragma mark -
# pragma mark [ COBJECT pseudo-keywords ]
# pragma mark -

/*
 * declare tag, typename
 */

/* NOT FOR YOUR BUSINESS @{ */
# define _A_cobject_tag_(N,anObjectNS) __aorp_cobject_tag(N,anObjectNS)
# define _A_cobject_typename_(N,anObjectNS) __aorp_cobject_typename(N,anObjectNS)

# define _A_cobject_tag(anObjectName) _A_cobject_tag_(1,(anObjectName))
# define _A_cobject_typename(anObjectName) __aorp_cobject_typename(1,(anObjectName))
/* @} */

/*
 * 1. declare object
 * 2. object reference
 */
# define _A_cobject_(N,anObjectNS) __aorp_cobject(N,anObjectNS)
# define _A_cobject(anObjectName) __aorp_cobject(1,(anObjectName))

/*
 * get pod offset in a cobject<name>
 */
# define _A_coboffsetof_(N,anObjectNS,aProtoDomainName,aPODFieldName) \
	__aorp_coboffsetof(N,anObjectNS,aProtoDomainName,aPODFieldName)

# define _A_coboffsetof(anObjectName,aProtoDomainName,aPODFieldName) \
	__aorp_coboffsetof(1,(anObjectName),aProtoDomainName,aPODFieldName)

# define _A_self_coboffsetof(aProtoDomainName,aPODFieldName) \
	__aorp_current_coboffsetof(aProtoDomainName,aPODFieldName)

/* ----------------------------------------------------------------------------
 * class declarations
 */

/*
 * class [var] definition
 */
# define _A_class_(N,anObjectNS) __aorp_begin_class(N,anObjectNS)
# define _A_class(anObjectName) __aorp_begin_class(1,(anObjectName))

# define _A_classex_(N,anObjectNS,K,anExObjectNS) \
	__aorp_begin_classex(N,anObjectNS,K,anExObjectNS)

/*
 * class [var] external declaration
 */

# define _A_clsdecl_(N,anObjectNS) __aorp_cobvardecl(N,anObjectNS)
# define _A_clsdecl(anObjectName) __aorp_cobvardecl(1,(anObjectName))
# define _A_clsdecl2(anObjectName,aSecondName) \
	__aorp_cobvardecl(2,(anObjectName,aSecondName))

# define _A_self_clsdecl __aorp_current_cobvardecl

/*
 * class [var] reference
 */

# define _A_clsref_(N,anObjectNS) __aorp_cobvarref(N,anObjectNS)
# define _A_clsref(anObjectName) __aorp_cobvarref(1,(anObjectName))
# define _A_clsref2(anObjectName,aSecondName) \
	__aorp_cobvarref(2,(anObjectName,aSecondName))

# define _A_self_clsref __aorp_current_cobvarref

/* ------------------------------------------------------------------------- */

/* Get the cobject-class (or stub aorp-object) specified by the @oid.
   The result cobject should not be closed (or released via AorpRelease). */

# define _Art_clsbyoid(anOID) _AorpGetclsorstub(anOID)

# if __myc_support(NVM)
#  define _Art_vclsbyoid(aPrimId...) \
	_AorpVgetclsorstub(aPrimId, AorpK_INVAL_OID)
# else
# if __myc_support(AVM)
#  define _Art_vclsbyoid(...) \
	_AorpVgetclsorstub(__VA_ARGS__, AorpK_INVAL_OID)
# endif /* __myc_support(AVM) */
# endif /* __myc_support(NVM) */

# define _A_clsbyoid(anOIDinParen) _Art_vclsbyoid(_RQUO(anOIDinParen))

# define _Art_clsbyoid1(anObjectId) \
	_Art_vclsbyoid(anObjectId)

# define _Art_clsbyoid2(aPrimId, aSecondId) \
	_Art_vclsbyoid(aPrimId, aSecondId)

# define _A_clsbyname1(anObjectName) \
	_Art_clsbyoid1(_A_objectidof(anObjectName))

# define _A_clsbyname2(anObjectName, aSecondId) \
	_Art_clsbyoid2(_A_objectidof(anObjectName), aSecondId)

/* ------------------------------------------------------------------------- */

/* Get any (class, module) cobject specified by the @oid.
   The result cobject should be closed via _Art_cobclose
   (or released via AorpRelease). */

# define _Art_cobopenbyoid(aResultRef, anOID, anErrPtr) \
	(aResultRef = AorpGetcobject(anOID, anErrPtr))

# define _Art_cobclose(anObject, anErrPtr) \
	AorpEndcobject(anObject, anErrPtr)


# ifndef __myc_list_count_notsupp
#  define _A_clsopenbyoid(aResultRef, anOIDinParen, anErrPtr) \
	do { \
		aorp_oid_t ___oid[] = _A_classoid_i(anOIDinParen); \
		aResultRef = AorpGetcobject(___oid, anErrPtr); \
	} while (0)
# else
#  define _A_clsopenbyoid(aResultRef, anOIDinParen, anErrPtr) \
	do { \
		aorp_oid_t ___oid[] = _A_classoid_i(anOIDinParen); \
		AORP_OID_Count(___oid) = __myc_namembs(___oid) - 2; \
		aResultRef = AorpGetcobject(___oid, anErrPtr); \
	} while (0)
# endif /* !__myc_list_count_notsupp */

# define _Art_clsopen1(aResultRef, anObjectId, anErrPtr) \
	do { \
		aorp_oid_t ___oid[] = _Art_classoid1_i(anObjectId); \
		aResultRef = AorpGetcobject(___oid, anErrPtr); \
	} while (0)

# define _Art_clsopen2(aResultRef, aPrimId, aSecondId, anErrPtr) \
	do { \
		aorp_oid_t ___oid[] = _Art_classoid2_i(aPrimId, aSecondId); \
		aResultRef = AorpGetcobject(___oid, anErrPtr); \
	} while (0)

# define _A_clsopen1(aResultRef, anObjectName, anErrPtr) \
	_Art_clsopen1(aResultRef, _A_objectidof(anObjectName), anErrPtr)

# define _A_clsopen2(aResultRef, anObjectName, aSecondId, anErrPtr) \
	_Art_clsopen2(aResultRef, _A_objectidof(anObjectName), aSecondId, anErrPtr)

/* ------------------------------------------------------------------------- */

/* Get any (class, module) cobject specified by the @oid (without internal locks).
   The result cobject should be closed via _Art_cobclose_nlk.
   Very dangerous.
   It is strongly recommended the functions to be only used
   while init-once and fini-once executing. */

# define _Art_cobopenbyoid_nlk(aResultRef, anOID, anErrPtr) \
	(aResultRef = AorpGetcobject_nlk(anOID, anErrPtr))

# define _Art_cobclose_nlk(anObject, anErrPtr) \
	AorpEndcobject_nlk(anObject, anErrPtr)


# ifndef __myc_list_count_notsupp
#  define _A_clsopenbyoid_nlk(aResultRef, anOIDinParen, anErrPtr) \
	do { \
		aorp_oid_t ___oid[] = _A_classoid_i(anOIDinParen); \
		aResultRef = AorpGetcobject_nlk(___oid, anErrPtr); \
	} while (0)
# else
#  define _A_clsopenbyoid_nlk(aResultRef, anOIDinParen, anErrPtr) \
	do { \
		aorp_oid_t ___oid[] = _A_classoid_i(anOIDinParen); \
		AORP_OID_Count(___oid) = __myc_namembs(___oid) - 2; \
		aResultRef = AorpGetcobject_nlk(___oid, anErrPtr); \
	} while (0)
# endif /* !__myc_list_count_notsupp */

# define _Art_clsopen1_nlk(aResultRef, anObjectId, anErrPtr) \
	do { \
		aorp_oid_t ___oid[] = _Art_classoid1_i(anObjectId); \
		aResultRef = AorpGetcobject_nlk(___oid, anErrPtr); \
	} while (0)

# define _Art_clsopen2_nlk(aResultRef, aPrimId, aSecondId, anErrPtr) \
	do { \
		aorp_oid_t ___oid[] = _Art_classoid2_i(aPrimId, aSecondId); \
		aResultRef = AorpGetcobject_nlk(___oid, anErrPtr); \
	} while (0)

# define _A_clsopen1_nlk(aResultRef, anObjectName, anErrPtr) \
	_Art_clsopen1_nlk(aResultRef, _A_objectidof(anObjectName), anErrPtr)

# define _A_clsopen2_nlk(aResultRef, anObjectName, aSecondId, anErrPtr) \
	_Art_clsopen2_nlk(aResultRef, _A_objectidof(anObjectName), aSecondId, anErrPtr)

/* @} COBJECT pseudo-keywords */

/* ============================================================================
 * MOBJECT pseudo-keywords
 * @{
 */
# pragma mark -
# pragma mark [ MOBJECT pseudo-keywords ]
# pragma mark -

/* ----------------------------------------------------------------------------
 * mobject declarations
 */

/*
 * 1. declare object
 * 2. object reference
 */
# define _A_mobject_(N,anObjectNS) __aorp_mobject(N,anObjectNS)
# define _A_mobject(anObjectName) __aorp_mobject(1,(anObjectName))

/* ----------------------------------------------------------------------------
 * module declarations
 */

/*
 * get module id by name-str
 */
/* @todo: implement @{ */
# define _Art_moduleidof(aModuleNameStr) \
	AorpName2id(AorpK_MODULEDB_CATEGORY, aModuleNameStr, NULL)
/* @} */

/*
 * get module id by name
 */
# define _A_moduleidof(aModuleName) __aorp_moduleidof(aModuleName)

/*
 * module [var] definition
 */
# define _A_module(aModuleName) __aorp_begin_module(aModuleName)

/*
 * module [var] external declaration
 */
# define _A_moddecl(aModuleName) __aorp_mobvardecl(aModuleName)
# define _A_self_moddecl __aorp_current_mobvardecl

/*
 * module [var] reference
 */
# define _A_modref(aModuleName) __aorp_mobvarref(aModuleName)
# define _A_self_modref __aorp_current_mobvarref

/* ------------------------------------------------------------------------- */

/* The result mobject should not be closed (or released via AorpRelease). */

# define _Art_modbyoid(anOID) _AorpGetcobject(anOID)

# if __myc_support(NVM)
#  define _Art_vmodbyoid(aPrimId...) \
	_AorpVgetmodule(aPrimId, AorpK_INVAL_OID)
# else
# if __myc_support(AVM)
#  define _Art_vmodbyoid(...) \
	_AorpVgetmodule(__VA_ARGS__, AorpK_INVAL_OID)
# endif /* __myc_support(AVM) */
# endif /* __myc_support(NVM) */

# define _A_modbyoid(anOIDinParen) _Art_vmodbyoid(_RQUO(anOIDinParen))

# define _Art_modbyoid1(aModuleId) \
	_Art_vmodbyoid(aModuleId)

# define _Art_modbyoid2(aPrimId, aSecondId) \
	_Art_vmodbyoid(aPrimId, aSecondId)

# define _A_modbyname1(aModuleName) \
	_Art_modbyoid1(_A_moduleidof(aModuleName))

# define _A_modbyname2(aModuleName, aSecondId) \
	_Art_modbyoid2(_A_moduleidof(aModuleName), aSecondId)

/* ------------------------------------------------------------------------- */

/* The result cobject should be closed via _Art_cobclose
   (or released via AorpRelease). */

# ifndef __myc_list_count_notsupp
#  define _A_modopenbyoid(aResultRef, anOIDinParen, anErrPtr) \
	do { \
		aorp_oid_t ___oid[] = _A_moduleoid_i(anOIDinParen); \
		aResultRef = AorpGetcobject(___oid, anErrPtr); \
	} while (0)
# else
#  define _A_modopenbyoid(aResultRef, anOIDinParen, anErrPtr) \
	do { \
		aorp_oid_t ___oid[] = _A_moduleoid_i(anOIDinParen); \
		AORP_OID_Count(___oid) = __myc_namembs(___oid) - 2; \
		aResultRef = AorpGetcobject(___oid, anErrPtr); \
	} while (0)
# endif /* !__myc_list_count_notsupp */

# define _Art_modopen1(aResultRef, aModuleId, anErrPtr) \
	do { \
		aorp_oid_t ___oid[] = _Art_moduleoid1_i(aModuleId); \
		aResultRef = AorpGetcobject(___oid, anErrPtr); \
	} while (0)

# define _Art_modopen2(aResultRef, aPrimId, aSecondId, anErrPtr) \
	do { \
		aorp_oid_t ___oid[] = _Art_moduleoid2_i(aPrimId, aSecondId); \
		aResultRef = AorpGetcobject(___oid, anErrPtr); \
	} while (0)

# define _A_modopen1(aResultRef, aModuleName, anErrPtr) \
	_Art_modopen1(aResultRef, _A_moduleidof(aModuleName), anErrPtr)

# define _A_modopen2(aResultRef, aModuleName, aSecondId, anErrPtr) \
	_Art_modopen2(aResultRef, _A_moduleidof(aModuleName), aSecondId, anErrPtr)

/* ------------------------------------------------------------------------- */

/* The result cobject should be closed via _Art_cobclose_nlk.
   Very dangerous.
   It is strongly recommended the functions to be only used
   while init-once and fini-once executing. */

# ifndef __myc_list_count_notsupp
#  define _A_modopenbyoid_nlk(aResultRef, anOIDinParen, anErrPtr) \
	do { \
		aorp_oid_t ___oid[] = _A_moduleoid_i(anOIDinParen); \
		aResultRef = AorpGetcobject_nlk(___oid, anErrPtr); \
	} while (0)
# else
#  define _A_modopenbyoid_nlk(aResultRef, anOIDinParen, anErrPtr) \
	do { \
		aorp_oid_t ___oid[] = _A_moduleoid_i(anOIDinParen); \
		AORP_OID_Count(___oid) = __myc_namembs(___oid) - 2; \
		aResultRef = AorpGetcobject_nlk(___oid, anErrPtr); \
	} while (0)
# endif /* !__myc_list_count_notsupp */

# define _Art_modopen1_nlk(aResultRef, anObjectId, anErrPtr) \
	do { \
		aorp_oid_t ___oid[] = _Art_moduleoid1_i(anObjectId); \
		aResultRef = AorpGetcobject_nlk(___oid, anErrPtr); \
	} while (0)

# define _Art_modopen2_nlk(aResultRef, aPrimId, aSecondId, anErrPtr) \
	do { \
		aorp_oid_t ___oid[] = _Art_moduleoid2_i(aPrimId, aSecondId); \
		aResultRef = AorpGetcobject_nlk(___oid, anErrPtr); \
	} while (0)

# define _A_modopen1_nlk(aResultRef, aModuleName, anErrPtr) \
	_Art_modopen1_nlk(aResultRef, _A_moduleidof(aModuleName), anErrPtr)

# define _A_modopen2_nlk(aResultRef, aModuleName, aSecondId, anErrPtr) \
	_Art_modopen2_nlk(aResultRef, _A_moduleidof(aModuleName), aSecondId, anErrPtr)

/* @} MOBJECT pseudo-keywords */

/* ============================================================================
 * OPS pseudo-keywords
 * @{
 */
# pragma mark -
# pragma mark [ OPS pseudo-keywords ]
# pragma mark -

/* Get the operation-set (or stub aorp-object) specified by the @oid.
   The result should not be closed (or released via AorpRelease). */

# define _Art_opsbyoid(anOID) ((struct aorp_ops *)_AorpGetopsorstub(anOID))

# if __myc_support(NVM)
#  define _Art_vopsbyoid(aServiceId...) \
	((struct aorp_ops *)_AorpVgetopsorstub(aServiceId, AorpK_INVAL_OID))
# else
# if __myc_support(AVM)
#  define _Art_vopsbyoid(...) \
	((struct aorp_ops *)_AorpVgetopsorstub(__VA_ARGS__, AorpK_INVAL_OID))
# endif /* __myc_support(AVM) */
# endif /* __myc_support(NVM) */

# define _A_opsbyoid(anOIDinParen) _Art_vopsbyoid(_RQUO(anOIDinParen))

/*
 * ops var external declaration
 */
# define _A_opsdecl_(N,aProtocolNS) __aorp_opsdecl(N,aProtocolNS)
# define _A_self_opsdecl __aorp_current_opsdecl

/*
 * ops var reference
 */
# define _A_opsref_(N,aProtocolNS) __aorp_opsref(N,aProtocolNS)
# define _A_self_opsref __aorp_current_opsref

/* @} OPS pseudo-keywords */

/* ============================================================================
 * PROTOCOL INIT pseudo-keywords
 * @{
 */
# pragma mark -
# pragma mark [ PROTOCOL INIT pseudo-keywords ]
# pragma mark -

/*
 * protocol init declaration
 */

/* begin protocol init */
# define _A_protocol_init_(N,aProtocolNS) \
	__aorp_begin_protocol_init(N,aProtocolNS)

# define _A_protocol_init(aServiceName,aDomainName) \
	__aorp_begin_protocol_init(2,(aServiceName,aDomainName))

/*
 * pod reference
 */

# define _A_proinitpod_(N,aProtocolNS) __aorp_proinitpod(N,aProtocolNS)
# define _A_self_proinitpod __aorp_self_proinitpod

/* @} */

/* ============================================================================
 * PROTOCOL pseudo-keywords
 * @{
 */

/*
 * pod reference
 */

# define _A_pod_(N,aProtocolNS) __aorp_pod(N,aProtocolNS)
# define _A_self_pod __aorp_self_pod

/*
 * pod size
 */

# define _A_podsizeof_(N,aProtocolNS) __aorp_podsizeof(N,aProtocolNS)

# define _A_podsizeof(aServiceName,aDomainName) \
	__aorp_podsizeof(2,(aServiceName,aDomainName))

# define _A_self_podsize __aorp_self_podsize

/* ----------------------------------------------------------------------------
 * declare a pod member in a (c)object
 */

# define _A_poddecl_(N,aProtocolNS,aPODFieldName) \
	__aorp_poddecl(N,aProtocolNS,aPODFieldName)

# define _A_poddecl(aServiceName,aDomainName,aPODFieldName) \
	__aorp_poddecl(2,(aServiceName,aDomainName),aPODFieldName)

/* ----------------------------------------------------------------------------
 * protocol declaration
 */

/* begin protocol */
# define _A_protocol_(N,aProtocolNS) \
	__aorp_begin_protocol(N,aProtocolNS)

# define _A_protocol(aServiceName,aDomainName) \
	__aorp_begin_protocol(2,(aServiceName,aDomainName))

/* end protocol pod */
# define _A_end_pod __aorp_end_pod

/* @} */

/* ============================================================================
 * PROTOCOL OPERATION pseudo-keywords
 * @{
 */
# pragma mark -
# pragma mark [ PROTOCOL OPERATION pseudo-keywords ]
# pragma mark -

/*
 * declaration of a protocol (service) operation implementation
 */
# define _A_imop(aRoutine) __aorp_current_imop(aRoutine)

# define _A_imop_rr(aRoutine,aRealRoutine) \
	__aorp_current_imop_rr(aRoutine,aRealRoutine)

/*
 * declaration of an unimplemented protocol (service) operation
 */
# define _A_imop_nil(aRoutine) __aorp_current_imop_nil(aRoutine)

/* ----------------------------------------------------------------------------
 * declaration of a foreign protocol (service) operation implementation
 *
 * VARIANT 1
 */

# define _A_imop_f(aRoutine,K,aForeignProtocolNSids) \
	__aorp_current_imop_f(aRoutine,K,aForeignProtocolNSids)

# define _A_imop_nf(aRoutine,K,aForeignProtocolNSnms) \
	__aorp_current_imop_nf(aRoutine,K,aForeignProtocolNSnms)

/* ----------------------------------------------------------------------------
 * declaration of a foreign protocol (service) operation implementation
 *
 * VARIANT 2
 */

# define _A_imop_fr(aRoutine,K,aForeignProtocolNSids,aForeignRoutine) \
	__aorp_current_imop_fr(aRoutine,K,aForeignProtocolNSids,aForeignRoutine)

# define _A_imop_nfr(aRoutine,K,aForeignProtocolNSnms,aForeignRoutine) \
	__aorp_current_imop_nfr(aRoutine,K,aForeignProtocolNSnms,aForeignRoutine)

/* ------------------------------------------------------------------------- */

/*
 * definition of a protocol (service) operation implementation
 */
# define _A_impdef(aRoutine) __aorp_current_impdef(aRoutine)

/*
 * reference to a protocol (service) operation implementation
 */
# define _A_impref(aRoutine) __aorp_current_impref(aRoutine)

/* @} PROTOCOL OPERATION pseudo-keywords */

/* ============================================================================
 * SERVICE ELEMENT SET pseudo-keywords
 * @{
 */
# pragma mark -
# pragma mark [ SERVICE ELEMENT SET pseudo-keywords ]
# pragma mark -

# define _A_ses_tag(aName) __aorp_ses_tag(aName)
# define _A_ses_typename(aName) __aorp_ses_typename(aName)

/*
 * 1. declare object (type instantiation)
 */
# define _A_ses_inst(aName,aSeCount) __aorp_ses_inst(aName,aSeCount)

/*
 * 2. object reference
 */
# define _A_ses(aName) __aorp_ses(aName)

/* ------------------------------------------------------------------------- */

/*
 * var definition
 */
# define _A_begin_ses(aName,aVarName) __aorp_begin_ses(aName,aVarName)

/* it is required that '_A_opsdecl_(M,aProtocolNS)' will be made before */
# define _A_ses_entry_(N,anObjectNS,M,aProtocolNS,aProtocolNSids,aPODFieldName,aReldist) \
	__aorp_ses_entry(N,anObjectNS,M,aProtocolNS,aProtocolNSids,aPODFieldName,aReldist)

# define _A_ses_entry_f_(N,anObjectNS,M,aProtocolNS,aProtocolNSids,aPODFieldName,aReldist) \
	__aorp_ses_entry_f(N,anObjectNS,M,aProtocolNS,aProtocolNSids,aPODFieldName,aReldist)

/* Can be only used if aProtocolNS: (service-name, opdom-name [, id3, ...]) */
# define _A_ses_entry(anObjectName,M,aProtocolNS,aPODFieldName,aReldist) \
	__aorp_ses_entry(1,(anObjectName),M,aProtocolNS,_A_ns_protocol_nm2id(aProtocolNS),aPODFieldName,aReldist)

# define _A_ses_entry_f(anObjectName,M,aProtocolNS,aPODFieldName,aReldist) \
	__aorp_ses_entry_f(1,(anObjectName),M,aProtocolNS,_A_ns_protocol_nm2id(aProtocolNS),aPODFieldName,aReldist)


/* it is required that '_A_opsdecl_(M,aProtocolNS)' will be made before */
# define _A_sesent_(M,aProtocolNS,aProtocolNSids,aPODFieldName,aReldist) \
	__aorp_current_ses_entry(M,aProtocolNS,aProtocolNSids,aPODFieldName,aReldist)

# define _A_sesent_f_(M,aProtocolNS,aProtocolNSids,aPODFieldName,aReldist) \
	__aorp_current_ses_entry_f(M,aProtocolNS,aProtocolNSids,aPODFieldName,aReldist)

/* Can be only used if aProtocolNS: (service-name, opdom-name [, id3, ...]) */
# define _A_sesent(M,aProtocolNS,aPODFieldName,aReldist) \
	__aorp_current_ses_entry(M,aProtocolNS,_A_ns_protocol_nm2id(aProtocolNS),aPODFieldName,aReldist)

# define _A_sesent_f(M,aProtocolNS,aPODFieldName,aReldist) \
	__aorp_current_ses_entry_f(M,aProtocolNS,_A_ns_protocol_nm2id(aProtocolNS),aPODFieldName,aReldist)

# define _A_end_ses __aorp_end_ses

/* @} SERVICE ELEMENT SET pseudo-keywords */

# include <Bo/aorp/_AorpCx.h>

#endif /* !__AORPC_FIRST_INCLUDED__ */

/* ------------------------------------------------------------------------- */

#if !__AORPC_FIRST_INCLUDED__

/******************************************************************************
 * %% BeginSection: definitions
 */
# pragma mark -
# pragma mark [ definitions ]
# pragma mark -

# include <Bo/aorp/_AorpCv.h>

# ifdef __aorpc_impl
# if __aorpc_impl
#  ifndef __AORPCIMP_INCLUDED__
#   define __AORPCIMP_INCLUDED__
#   include <Bo/aorp/_AorpCimp.h>
#  endif /* !__AORPCI_INCLUDED__ */
# endif
# endif /* __aorpc_impl */
# include <Bo/aorp/_AorpCitf.h>

#endif /* !__AORPC_FIRST_INCLUDED__ */

/* ------------------------------------------------------------------------- */

#if __AORPC_FIRST_INCLUDED__
# undef __AORPC_FIRST_INCLUDED__
# define __AORPC_FIRST_INCLUDED__ 0
#endif /* __AORPC_FIRST_INCLUDED__ */

/******************************************************************************
 * Revision History:
 *		$Log$
 *
 *****************************************************************************/
