/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright (c) 2005-2007 V.Sokur
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

/*
 * _AorpCimp.h	(V.Sokur)
 * include/Bo/aorp/_AorpCimp.h
 *
 * $Id$
 */

/******************************************************************************
 * %% BeginSection: definitions
 */

/* ============================================================================
 * SERVICE pseudo-keywords
 * @{
 */
# pragma mark -
# pragma mark [ SERVICE pseudo-keywords ]
# pragma mark -

/*
 * begin service
 */
# define __aorp_begin_service_imp(aServiceName,N,aProtocolNS) \
enum { \
	__aorpc_list_convolution_ps(_AorpK_,1,(__myc_list_at(0,aProtocolNS)),_service_definition_start) = 1 \
};

/*
 * end service ctb
 */
# define __aorp_end_service_ctb_imp(N,aProtocolNS) \
__MYC_BEGIN_CDECLS \
enum { \
	__aorp_op_imp(N,aProtocolNS, init_once, "init-once", ( \
			struct aorp_closure *aClosure, \
			struct aorp_error *anErrPtr \
		)), \
	__aorp_op_imp(N,aProtocolNS, fini_once, "fini-once", ( \
			struct aorp_closure *aClosure, \
			struct aorp_error *anErrPtr \
		)), \
	__aorp_op_imp(N,aProtocolNS, pod_init, "pod-init", ( \
			struct aorp_closure *aClosure, \
			struct aorp_error *anErrPtr, \
			aorp_opflags_t Flags, \
			bo_pointer_t aParm \
		)), \
	__aorp_op_imp(N,aProtocolNS, pod_fini, "pod-fini", ( \
			struct aorp_closure *aClosure, \
			struct aorp_error *anErrPtr, \
			aorp_opflags_t Flags \
		)), \

/*
 * end service
 */
# define __aorp_end_service_imp(N,aProtocolNS) \
	__aorpc_list_convolution_ps(_AorpK_,1,(__myc_list_at(0,aProtocolNS)),_last_service_operation) = 0 \
}; \
__MYC_END_CDECLS \
enum { \
	__aorpc_list_convolution_ps(_AorpK_,1,(__myc_list_at(0,aProtocolNS)),_service_definition_finish) = 1 \
}

/* @} SERVICE pseudo-keywords */

/* ============================================================================
 * SERVICE OPERATION pseudo-keywords
 * @{
 */
# pragma mark -
# pragma mark [ SERVICE OPERATION pseudo-keywords ]
# pragma mark -

/*
 * declaration of a service operation
 */

# define __aorp_op_imp(N,aProtocolNS,aRoutine,aNameStr,aProto) \
		__aorp_start_impname(N,aProtocolNS,aRoutine) = 1 \
	}; \
	__aorp_opnamesigndecl(__myc_list_at(0,aProtocolNS),aRoutine,aNameStr) \
	__aorp_imptypedef(__myc_list_at(0,aProtocolNS),aRoutine,aProto); \
	__aorp_impdecl(N,aProtocolNS,aRoutine,aProto); \
	enum { \
		__aorp_finish_impname(N,aProtocolNS,aRoutine) = 1

/*
 * human name and signature of a service operation
 */

# define __aorp_opnamesigndecl(aServiceName,aRoutine,aNameStr) \
	__aorp_opnamedecl(aServiceName,aRoutine,aNameStr) \
	__aorp_opsigndecl(aServiceName,aRoutine)

# if defined(_MSC_VER) && (_MSC_VER < 1800)
#  define __aorp_opnamedecl(aServiceName,aRoutine,aNameStr) \
	static char const \
	__aorp_opname_storage(aServiceName,aRoutine)[] = (NULL != aNameStr \
		? aNameStr \
		: __myc_xstringify(aRoutine) \
	);
# else
# ifdef __GNUC__
#  define __aorp_opnamedecl(aServiceName,aRoutine,aNameStr) \
	static char const \
	__aorp_opname_storage(aServiceName,aRoutine)[] = aNameStr;
# else
#  define __aorp_opnamedecl(aServiceName,aRoutine,aNameStr) \
	static char const \
	__aorp_opname_storage(aServiceName,aRoutine)[] = aNameStr;
# endif /* __GNUC__ */
# endif /* _MSC_VER */

# define __aorp_opsigndecl(aServiceName,aRoutine) \
	/* @todo: implement */ \
	static char const __aorp_opsign_storage(aServiceName,aRoutine)[] = AORP_STD_SIGNATURE;

/* @} SERVICE OPERATION pseudo-keywords */

/* ============================================================================
 * XOBJECT pseudo-keywords
 * @{
 */
# pragma mark -
# pragma mark [ OBJECT pseudo-keywords ]
# pragma mark -

/* @} XOBJECT pseudo-keywords */

/* ============================================================================
 * COBJECT pseudo-keywords
 * @{
 */
# pragma mark -
# pragma mark [ COBJECT pseudo-keywords ]
# pragma mark -

/* @} COBJECT pseudo-keywords */

/* ============================================================================
 * MOBJECT pseudo-keywords
 * @{
 */
# pragma mark -
# pragma mark [ MOBJECT pseudo-keywords ]
# pragma mark -

/* @} MOBJECT pseudo-keywords */

/* ============================================================================
 * PROTOCOL INIT pseudo-keywords
 * @{
 */
# pragma mark -
# pragma mark [ PROTOCOL INIT pseudo-keywords ]
# pragma mark -

/* @} PROTOCOL INIT pseudo-keywords */

/* ============================================================================
 * PROTOCOL pseudo-keywords
 * @{
 */
# pragma mark -
# pragma mark [ PROTOCOL pseudo-keywords ]
# pragma mark -

/*
 * begin protocol [pod]
 */

# define __aorp_protocol_pod_imp(N,aProtocolNS) \
enum { \
	__aorpc_list_convolution_ps(_AorpK_,N,aProtocolNS,_protocol_definition_start) = 1 \
}; \
struct __aorp_pod_tag(N,aProtocolNS)

/*
 * end protocol pod
 */

# define __aorp_end_empty_protocol_pod_imp(N,aProtocolNS) ; \
	typedef struct __aorp_pod_tag(N,aProtocolNS) __aorp_pod_typename(N,aProtocolNS); \
	__aorp_protocol_ops_imp(N,aProtocolNS,__aorpc_ns_id_protocol)

# define __aorp_end_norm_protocol_pod_imp(N,aProtocolNS) ; \
	typedef struct __aorp_pod_tag(N,aProtocolNS) __aorp_pod_typename(N,aProtocolNS); \
	__aorp_protocol_ops_imp(N,aProtocolNS,__aorpc_ns_id_protocol)

/* ----------------------------------------------------------------------------
 * protocol ops
 */

# define __aorp_protocol_ops_imp(N,aProtocolNS,aProtocolNSids) \
__MYC_BEGIN_CDECLS \
__aorp_opsdef(N,aProtocolNS) = { \
	/* .basic_ = */ { \
		/* .hint_ = */       0, \
		/* .rtxi_ = */       0, \
		/* .isa_ = */        NULL, \
		/* .rtsi_ = */       0, \
		/* .refc_ = */       0, \
		/* .rwlock_ = */     BO_CPURWLOCK_ZERO_INITIALIZER, \
		/* .aorp_version_ = */ AORP_VERSION, \
		/* .long_key_ = */   AORP_OPS_CATEGORY "/" __aorpc_list_mkstrkey(N,aProtocolNS), \
		/* .short_key_ = */  __aorpc_list_mkstrkey(N,aProtocolNS), \
		/* .name_ = */       __myc_xstringify(__myc_list_at(0,aProtocolNS)), \
		/* .dbelem_ = */ { \
			/* .oid_ = */        _A_opsoid_i_(N,aProtocolNSids), \
			/* .btelem_ = */     AORP_ODBELEM1_ZERO_INITIALIZER, \
			/* .db_ = */         NULL \
		}, \
		/* .ucb = */ { \
			/* .bootstrap_ = */  NULLF, \
			/* .halt_ = */       NULLF, \
			/* .configure_ = */  NULLF \
		} \
	}, \
	/* .podsize_ = */    __aorp_podsizeof(N,aProtocolNS), \
	/* .opc_ = */        __aorp_builtin_sopcountof(__myc_list_at(0,aProtocolNS)), \
	/* .opv_ = */ {

/* ----------------------------------------------------------------------------
 * end protocol
 */

# define __aorp_end_protocol_imp(N,aProtocolNS) \
		{ \
			/* .art_name_ = */    NULL, \
			/* .human_name_ = */  NULL, \
			/* .signature_ = */   NULL, \
			/* .impl_ = */        NULLF \
		} \
	} \
}; \
__MYC_END_CDECLS \
enum { \
	__aorpc_list_convolution_ps(_AorpK_,N,aProtocolNS,_protocol_definition_finish) = 1 \
}

/* @} PROTOCOL pseudo-keywords */

/* ============================================================================
 * PROTOCOL OPERATION pseudo-keywords
 * @{
 */
# pragma mark -
# pragma mark [ PROTOCOL OPERATION pseudo-keywords ]
# pragma mark -

/*
 * declaration of a protocol (service) operation implementation
 */

# define __aorp_imop_imp(N,aProtocolNS,aRoutine) \
	{ \
		/* .art_name_ = */   __myc_xstringify(aRoutine), \
		/* .human_name_ = */ __aorp_getopname(aRoutine,__myc_list_at(0,aProtocolNS)), \
		/* .signature_ = */  __aorp_getopsign(aRoutine,__myc_list_at(0,aProtocolNS)), \
		/* .impl_ = */       __aorp_impref(N,aProtocolNS,aRoutine), \
		/* .frgn_opsid_ = */ {0}, \
		/* .frgn_ops_ = */   NULL \
	}

/* ------------------------------------------------------------------------- */

# define __aorp_imop_rr_imp(N,aProtocolNS,aRoutine,aRealRoutine) \
	{ \
		/* .art_name_ = */   __myc_xstringify(aRoutine), \
		/* .human_name_ = */ __aorp_getopname(aRoutine,__myc_list_at(0,aProtocolNS)), \
		/* .signature_ = */  __aorp_getopsign(aRoutine,__myc_list_at(0,aProtocolNS)), \
		/* .impl_ = */       AORP_REDIRECT_OP, \
		/* .frgn_opsid_ = */ { 0, __aorp_builtin_opidof(aRealRoutine,__myc_list_at(0,aProtocolNS)), 0 }, \
		/* .frgn_ops_ = */   NULL \
	}

/*
 * declaration of an unimplemented protocol (service) operation
 */
# define __aorp_imop_nil_imp(N,aProtocolNS,aRoutine) \
	{ \
		/* .art_name_ = */   __myc_xstringify(aRoutine), \
		/* .human_name_ = */ __aorp_getopname(aRoutine,__myc_list_at(0,aProtocolNS)), \
		/* .signature_ = */  __aorp_getopsign(aRoutine,__myc_list_at(0,aProtocolNS)), \
		/* .impl_ = */       ((aorp_operation_fn)0), \
		/* .frgn_opsid_ = */ {0}, \
		/* .frgn_ops_ = */   NULL \
	}

/* ----------------------------------------------------------------------------
 * declaration of a foreign protocol (service) operation implementation
 *
 * VARIANT 1
 */
# define __aorp_imop_f_imp(N,aProtocolNS,aRoutine,K,aForeignProtocolNSids) \
	{ \
		/* .art_name_ = */   __myc_xstringify(aRoutine), \
		/* .human_name_ = */ __aorp_getopname(aRoutine,__myc_list_at(0,aProtocolNS)), \
		/* .signature_ = */  __aorp_getopsign(aRoutine,__myc_list_at(0,aProtocolNS)), \
		/* .impl_ = */       AORP_FOREIGN_OP, \
		/* .frgn_opsid_ = */ _A_opsoid_i_(K,aForeignProtocolNSids), \
		/* .frgn_ops_ = */   NULL \
	}

/* ----------------------------------------------------------------------------
 * declaration of a foreign protocol (service) operation implementation
 *
 * VARIANT 2
 */
# define __aorp_imop_fr_imp(N,aProtocolNS,aRoutine,K,aForeignProtocolNSids,aForeignRoutine) \
	{ \
		/* .art_name_ = */   __myc_xstringify(aRoutine), \
		/* .human_name_ = */ __aorp_getopname(aRoutine,__myc_list_at(0,aProtocolNS)), \
		/* .signature_ = */  __aorp_getopsign(aRoutine,__myc_list_at(0,aProtocolNS)), \
		/* .impl_ = */       AORP_FOREIGN_OP, \
		/* .frgn_opsid_ = */ _A_ropsoid_i_(aForeignRoutine,K,aForeignProtocolNSids), \
		/* .frgn_ops_ = */   NULL \
	}

/* @} PROTOCOL OPERATION pseudo-keywords */
