/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright (c) 2005-2007 V.Sokur
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

/*
 * _AorpCitf.h	(V.Sokur)
 * include/Bo/aorp/_AorpCitf.h
 *
 * $Id$
 */

/******************************************************************************
 * %% BeginSection: definitions
 */

/* ============================================================================
 * SERVICE pseudo-keywords
 * @{
 */
# pragma mark -
# pragma mark [ SERVICE pseudo-keywords ]
# pragma mark -

/*
 * begin service
 */
# define __aorp_begin_service_itf(aServiceName) \
enum { \
	__aorpc_list_convolution_ps(_AorpK_,1,(aServiceName),_service_declaration_start) = 1 \
}; \
enum { \
	__aorp_declare_builtin_serviceidof(aServiceName) = __aorp_serviceidof(aServiceName) \
};

/*
 * end service ctb
 */
# define __aorp_end_service_ctb_itf(aServiceName) \
enum { \
	__aorp_declare_builtin_opidof(init_once,aServiceName) = 0, \
	__aorp_declare_builtin_opidof(fini_once,aServiceName) = 1, \
	__aorp_declare_builtin_opidof(pod_init,aServiceName) = 2, \
	__aorp_declare_builtin_opidof(pod_fini,aServiceName) = 3,

/*
 * end service
 */
# define __aorp_end_service_itf(aServiceName) \
	__aorp_declare_builtin_sopcountof(aServiceName) \
}; \
enum { \
	__aorpc_list_convolution_ps(_AorpK_,1,(aServiceName),_service_declaration_finish) = 1 \
}

/* @} SERVICE pseudo-keywords */

/* ============================================================================
 * SERVICE OPERATION pseudo-keywords
 * @{
 */
# pragma mark -
# pragma mark [ SERVICE OPERATION pseudo-keywords ]
# pragma mark -

/*
 * declaration of a service operation
 */

# define __aorp_op_itf(aServiceName,aRoutine,aNameStr,aProto) \
	__aorp_declare_builtin_opidof(aRoutine,aServiceName)

/* @} SERVICE OPERATION pseudo-keywords */

/* ============================================================================
 * XOBJECT pseudo-keywords
 * @{
 */
# pragma mark -
# pragma mark [ XOBJECT pseudo-keywords ]
# pragma mark -

# define __aorp_begin_xobject_itf(N,anObjectNS) \
enum { \
	__aorpc_list_convolution_ps(_AorpK_,N,anObjectNS,_xobject_declaration_start) = 1 \
}; \
struct __aorp_xobject_tag(N,anObjectNS)

# define __aorp_end_xobject_itf(N,anObjectNS) ; \
typedef struct __aorp_xobject_tag(N,anObjectNS) __aorp_xobject_typename(N,anObjectNS); \
enum { \
	__aorpc_list_convolution_ps(_AorpK_,N,anObjectNS,_xobject_declaration_finish) = 1 \
}

/* @} XOBJECT pseudo-keywords */

/* ============================================================================
 * COBJECT pseudo-keywords
 * @{
 */
# pragma mark -
# pragma mark [ COBJECT pseudo-keywords ]
# pragma mark -

# define __aorp_begin_cobject_itf(N,anObjectNS)  \
enum { \
	__aorpc_list_convolution_ps(_AorpK_,N,anObjectNS,_cobject_declaration_start) = 1 \
}; \
struct __aorp_cobject_tag(N,anObjectNS)

# define __aorp_end_cobject_itf(N,anObjectNS) ; \
typedef struct __aorp_cobject_tag(N,anObjectNS) __aorp_cobject_typename(N,anObjectNS); \
enum { \
	__aorpc_list_convolution_ps(_AorpK_,N,anObjectNS,_cobject_declaration_finish) = 1 \
}

/* @} COBJECT pseudo-keywords */

/* ============================================================================
 * MOBJECT pseudo-keywords
 * @{
 */
# pragma mark -
# pragma mark [ MOBJECT pseudo-keywords ]
# pragma mark -

# define __aorp_begin_mobject_itf(N,anObjectNS) \
enum { \
	__aorpc_list_convolution_ps(_AorpK_,N,anObjectNS,_mobject_declaration_start) = 1 \
}; \
struct __aorp_mobject_tag(N,anObjectNS)

# define __aorp_end_mobject_itf(N,anObjectNS) ; \
typedef struct __aorp_mobject_tag(N,anObjectNS) __aorp_mobject_typename(N,anObjectNS); \
enum { \
	__aorpc_list_convolution_ps(_AorpK_,N,anObjectNS,_mobject_declaration_finish) = 1 \
}

/* @} MOBJECT pseudo-keywords */

/* ============================================================================
 * PROTOCOL INIT pseudo-keywords
 * @{
 */
# pragma mark -
# pragma mark [ PROTOCOL INIT pseudo-keywords ]
# pragma mark -

# define __aorp_begin_protocol_init_itf(N,aProtocolNS) \
enum { \
	__aorpc_list_convolution_ps(_AorpK_,N,aProtocolNS,_protocol_init_declaration_start) = 1 \
}; \
struct __aorp_proinitpod_tag(N,aProtocolNS)

# define __aorp_end_protocol_init_itf(N,aProtocolNS) ; \
typedef struct __aorp_proinitpod_tag(N,aProtocolNS) \
	__aorp_proinitpod_typename(N,aProtocolNS); \
enum { \
	__aorpc_list_convolution_ps(_AorpK_,N,aProtocolNS,_protocol_init_declaration_finish) = 1 \
}

/* @} PROTOCOL INIT pseudo-keywords */

/* ============================================================================
 * PROTOCOL pseudo-keywords
 * @{
 */
# pragma mark -
# pragma mark [ PROTOCOL pseudo-keywords ]
# pragma mark -

/*
 * begin protocol [pod]
 */

# define __aorp_protocol_pod_itf(N,aProtocolNS) \
enum { \
	__aorpc_list_convolution_ps(_AorpK_,N,aProtocolNS,_protocol_declaration_start) = 1 \
}; \
struct __aorp_pod_tag(N,aProtocolNS)

/*
 * end protocol pod
 */

# define __aorp_end_empty_protocol_pod_itf(N,aProtocolNS) ; \
	typedef struct __aorp_pod_tag(N,aProtocolNS) __aorp_pod_typename(N,aProtocolNS); \
	__aorp_protocol_ops_itf(N,aProtocolNS)

# define __aorp_end_norm_protocol_pod_itf(N,aProtocolNS) ; \
	typedef struct __aorp_pod_tag(N,aProtocolNS) __aorp_pod_typename(N,aProtocolNS); \
	__aorp_protocol_ops_itf(N,aProtocolNS)

/* ----------------------------------------------------------------------------
 * protocol ops
 */

# define __aorp_protocol_ops_itf(N,aProtocolNS) \
__MYC_BEGIN_CDECLS \
__aorp_opsdecl(N,aProtocolNS); \
__MYC_END_CDECLS \
__aorp_opsdef_enum(N,aProtocolNS) {

/* ----------------------------------------------------------------------------
 * end protocol
 */

# define __aorp_end_protocol_itf(N,aProtocolNS) \
	__aorpc_list_convolution_ps(_AorpK_,N,aProtocolNS,_last_protocol_operation) = 0 \
}; \
enum { \
	__aorpc_list_convolution_ps(_AorpK_,N,aProtocolNS,_protocol_declaration_finish) = 1 \
}

/* @} PROTOCOL pseudo-keywords */

/* ============================================================================
 * PROTOCOL OPERATION pseudo-keywords
 * @{
 */
# pragma mark -
# pragma mark [ PROTOCOL OPERATION pseudo-keywords ]
# pragma mark -

/*
 * declaration of a protocol (service) operation implementation
 */
# define __aorp_imop_itf(N,aProtocolNS,aRoutine) \
	__aorpc_list_convolution_ps(_AorpK_,N,aProtocolNS,__myc_xconcat3(_,aRoutine,_myself)) = 1, \
	__aorpc_list_convolution_ps(_AorpK_,N,aProtocolNS,__myc_xconcat3(_,aRoutine,_foreign)) = 0

/* ------------------------------------------------------------------------- */

# define __aorp_imop_rr_itf(N,aProtocolNS,aRoutine,aRealRoutine) \
	__aorpc_list_convolution_ps(_AorpK_,N,aProtocolNS,__myc_xconcat5(_,aRoutine,_,aRealRoutine,_myself)) = 1, \
	__aorpc_list_convolution_ps(_AorpK_,N,aProtocolNS,__myc_xconcat5(_,aRoutine,_,aRealRoutine,_foreign)) = 0

/*
 * declaration of an unimplemented protocol (service) operation
 */
# define __aorp_imop_nil_itf(N,aProtocolNS,aRoutine) \
	__aorpc_list_convolution_ps(_AorpK_,N,aProtocolNS,__myc_xconcat3(_,aRoutine,_myself)) = 1, \
	__aorpc_list_convolution_ps(_AorpK_,N,aProtocolNS,__myc_xconcat3(_,aRoutine,_foreign)) = 0

/* ----------------------------------------------------------------------------
 * declaration of a foreign protocol (service) operation implementation
 *
 * VARIANT 1
 */
# define __aorp_imop_f_itf(N,aProtocolNS,aRoutine,K,aForeignProtocolNSids) \
	__aorpc_list_convolution_ps(_AorpK_,N,aProtocolNS,__myc_xconcat3(_,aRoutine,_myself)) = 0, \
	__aorpc_list_convolution_ps(_AorpK_,N,aProtocolNS,__myc_xconcat3(_,aRoutine,_foreign)) = 1

/* ----------------------------------------------------------------------------
 * declaration of a foreign protocol (service) operation implementation
 *
 * VARIANT 2
 */
# define __aorp_imop_fr_itf(N,aProtocolNS,aRoutine,K,aForeignProtocolNSids,aForeignRoutine) \
	__aorpc_list_convolution_ps(_AorpK_,N,aProtocolNS,__myc_xconcat3(_,aRoutine,_myself)) = 0, \
	__aorpc_list_convolution_ps(_AorpK_,N,aProtocolNS,__myc_xconcat3(_,aRoutine,_foreign)) = 1

/* @} PROTOCOL OPERATION pseudo-keywords */
