/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright (c) 2005-2007 V.Sokur
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

/*
 * _AorpCv.h	(V.Sokur)
 * include/Bo/aorp/_AorpCv.h
 *
 * $Id$
 */

/******************************************************************************
 * %% BeginSection: definitions
 */
# pragma mark -
# pragma mark [ definitions ]
# pragma mark -

# ifndef __aorpc_decl
#  ifdef __aorpc_decl__
#   define __aorpc_decl __aorpc_decl__
#  else
#   define __aorpc_decl __aorpc_decl_default
#  endif
# endif

# ifndef __aorpc_impl
#  ifdef __aorpc_impl__
#   define __aorpc_impl __aorpc_impl__
#  else
#   define __aorpc_impl __aorpc_impl_default
#  endif
# endif

/* ----------------------------------------------------------------------------
 * service namespace
 */

# ifndef __aorpc_service_name
#  ifdef __aorpc_service_name__
#   define __aorpc_service_name __aorpc_service_name__
#  else
#   define __aorpc_service_name any
#  endif
# endif

/* ----------------------------------------------------------------------------
 * protocol namespace
 */

# ifndef __aorpc_ns_id_protocol
#  ifdef __aorpc_ns_id_protocol__
#   define __aorpc_ns_id_protocol __aorpc_ns_id_protocol__
#  endif
# endif

# ifndef __aorpc_ns_protocol
#  ifdef __aorpc_ns_protocol__
#   define __aorpc_ns_protocol_c __aorpc_ns_protocol_c__
#   define __aorpc_ns_protocol __aorpc_ns_protocol__
#  else
#   define __aorpc_ns_protocol_c 2
#   undef __aorpc_ns_protocol
#   define __aorpc_ns_protocol (__aorpc_service_name, Any)
#   undef __aorpc_ns_id_protocol
#  endif
# endif

# ifndef __aorpc_ns_id_protocol
#  define __aorpc_ns_id_protocol __aorpc_ns_protocol_nm2id(__aorpc_ns_protocol)
# endif

# ifndef __aorpc_ns_self_proinitpod
#  ifdef __aorpc_ns_self_proinitpod__
#   define __aorpc_ns_self_proinitpod __aorpc_ns_self_proinitpod__
#   define __aorpc_ns_self_proinitpod_c __aorpc_ns_self_proinitpod_c__
#  else
#   define __aorpc_ns_self_proinitpod __aorpc_ns_protocol
#   define __aorpc_ns_self_proinitpod_c __aorpc_ns_protocol_c
#  endif
# endif

/* ----------------------------------------------------------------------------
 * object namespace
 */

# ifndef __aorpc_object_name
#  ifdef __aorpc_object_name__
#   define __aorpc_object_name __aorpc_object_name__
#  endif
# endif

# ifndef __aorpc_ns_id_object
#  ifdef __aorpc_ns_id_object__
#   define __aorpc_ns_id_object __aorpc_ns_id_object__
#  endif
# endif

# ifndef __aorpc_ns_object
#  ifdef __aorpc_ns_object__
#   define __aorpc_ns_object_c __aorpc_ns_object_c__
#   define __aorpc_ns_object __aorpc_ns_object__
#  else
#   define __aorpc_ns_object_c 1
#   undef __aorpc_ns_object
#   define __aorpc_ns_object (__aorpc_object_name)
#   undef __aorpc_ns_id_object
#  endif
# endif

# ifndef __aorpc_ns_id_object
#  define __aorpc_ns_id_object __aorpc_ns_object_nm2id(__aorpc_ns_object)
# endif

/* ----------------------------------------------------------------------------
 * module namespace
 */

# ifndef __aorpc_module_name
#  ifdef __aorpc_module_name__
#   define __aorpc_module_name __aorpc_module_name__
#  else
#   define __aorpc_module_name any
#  endif
# endif

# ifndef __aorpc_builtin_module
#  ifdef __aorpc_builtin_module__
#   define __aorpc_builtin_module __aorpc_builtin_module__
#  endif
# endif

/******************************************************************************
 * Revision History:
 *		$Log$
 *
 *****************************************************************************/
