/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright (c) 2005-2007 V.Sokur
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

/*
 * _AorpCx.h	(V.Sokur)
 * include/Bo/aorp/_AorpCx.h
 *
 * $Id$
 */

/******************************************************************************
 * %% BeginSection: definitions
 */
# pragma mark -
# pragma mark [ definitions ]
# pragma mark -

# define __aorpc_list_mkstrkey(N,aListInParen) \
	__myc_list_convolution_sa(__myc_xstringify, "/", N,aListInParen)

/* ------------------------------------------------------------------------- */

# define __aorpc_list_convolution_ps(aPrefix,N,aListInParen,aSuffix) \
	__myc_xconcat3(aPrefix,__myc_list_convolution(N,aListInParen),aSuffix)

# define __aorpc_list_convolution_p(aPrefix,N,aListInParen) \
	__myc_xconcat(aPrefix,__myc_list_convolution(N,aListInParen))

# define __aorpc_list_convolution_s(N,aListInParen,aSuffix) \
	__myc_xconcat(__myc_list_convolution(N,aListInParen),aSuffix)

# define __aorpc_list_convolution(N,aListInParen) \
	__myc_list_convolution(N,aListInParen)

/* ========================================================================= */

/* type of an aorpc declaration */
/* switch (__aorpc_decl) */
# define __aorpc_decl_nothing 0
# define __aorpc_decl_service 1
# define __aorpc_decl_protocol_init 2
# define __aorpc_decl_protocol 3
# define __aorpc_decl_xobject 4
# define __aorpc_decl_cobject 5
# define __aorpc_decl_mobject 6
# define __aorpc_decl_class 7
# define __aorpc_decl_module 8

# define __aorpc_decl_default __aorpc_decl_nothing

/* Should be set to default value in _AorpcCv.h and _AorpCend.h */
# define __aorpc_decl __aorpc_decl_default

/* ------------------------------------------------------------------------- */

# define __aorpc_interface (!(__aorpc_impl))

/* The macro is used for [protocol] ops, [cobject] class, [mobject] module.
   [default: declare interface]. */
# define __aorpc_impl_default 0

/* Should be set to default value in _AorpcCv.h and _AorpCend.h */
# define __aorpc_impl __aorpc_impl_default
/* # define __aorpc_impl 1 */

/* Test if a [protocol] ops implementation */
# define __aorpc_implement_ops(N,aListInParen) \
	(__aorpc_list_convolution_p(__aorpc_implement_ops_,N,aListInParen) + 0)

/* ------------------------------------------------------------------------- */

/*
 * Test if a service is now realized by a protocol
 */

/* default */
# define __aorpc_realize_service_default(aName) 0
# define __aorpc_realize_service(aName) __aorpc_realize_service_default(aName)

/* Test if a client need a service interface */
# define __aorpc_need_service(aName) \
	(__aorpc_list_convolution_p(__aorpc_need_service_,1,(aName)) + 0)

/* Test if a service is used */
# define __aorpc_uses_service(aName) \
	(__aorpc_realize_service(aName) || __aorpc_need_service(aName))

/* ============================================================================
 * MISC pseudo-keywords
 * @{
 */
# pragma mark -
# pragma mark [ MISC pseudo-keywords ]
# pragma mark -

# define __aorpc_ns_protocol_nm2id(aNamespaceInParen) \
	__myc_list_apply2_to(__aorp_opdomidof,1,__aorp_serviceidof,0,aNamespaceInParen)

# define __aorpc_ns_object_nm2id(aNamespaceInParen) \
	__myc_list_apply_to(__aorp_objectidof,0,aNamespaceInParen)

/* ----------------------------------------------------------------------------
 * @group Constructor
 * @{
 */
# pragma mark -

# define __aorp_refproinitpod_(anIndex) \
	__aorp_refproinitpod(__myc_xconcat(aorpOpenParm,anIndex))
# define __aorp_refproinitpod(aVarName) __aorp_refproinitpod2(aVarName)
# define __aorp_refproinitpod2(aVarName) aorp_podinit_p(&(aVarName))

/*
 * I don't understand why the GCC compiles the 1st version incorrectly.
 */
# if 0

#  define __aorp_refproinitpod_list_(N) \
	__myc_xconcat(__aorp_refproinitpod_list_,N)

#  define __aorp_refproinitpod_list_1 __aorp_refproinitpod_(1)
#  define __aorp_refproinitpod_list_2 __aorp_refproinitpod_list_(1), __aorp_refproinitpod_(2)
#  define __aorp_refproinitpod_list_3 __aorp_refproinitpod_list_(2), __aorp_refproinitpod_(3)
#  define __aorp_refproinitpod_list_4 __aorp_refproinitpod_list_(3), __aorp_refproinitpod_(4)
#  define __aorp_refproinitpod_list_5 __aorp_refproinitpod_list_(4), __aorp_refproinitpod_(5)
#  define __aorp_refproinitpod_list_6 __aorp_refproinitpod_list_(5), __aorp_refproinitpod_(6)
#  define __aorp_refproinitpod_list_7 __aorp_refproinitpod_list_(6), __aorp_refproinitpod_(7)
#  define __aorp_refproinitpod_list_8 __aorp_refproinitpod_list_(7), __aorp_refproinitpod_(8)
#  define __aorp_refproinitpod_list_9 __aorp_refproinitpod_list_(8), __aorp_refproinitpod_(9)
#  define __aorp_refproinitpod_list_10 __aorp_refproinitpod_list_(9), __aorp_refproinitpod_(10)

# else

#  define __aorp_refproinitpod_list_(N) \
	__aorp_refproinitpod_list_helper(__myc_xconcat(__aorp_refproinitpod_list_,N),N)
#  define __aorp_refproinitpod_list_helper(anExecutor,N) anExecutor(N)

#  define __aorp_refproinitpod_list_1(N) __aorp_refproinitpod_(N)
#  define __aorp_refproinitpod_list_2(N) __aorp_refproinitpod_list_(1), __aorp_refproinitpod_(N)
#  define __aorp_refproinitpod_list_3(N) __aorp_refproinitpod_list_(2), __aorp_refproinitpod_(N)
#  define __aorp_refproinitpod_list_4(N) __aorp_refproinitpod_list_(3), __aorp_refproinitpod_(N)
#  define __aorp_refproinitpod_list_5(N) __aorp_refproinitpod_list_(4), __aorp_refproinitpod_(N)
#  define __aorp_refproinitpod_list_6(N) __aorp_refproinitpod_list_(5), __aorp_refproinitpod_(N)
#  define __aorp_refproinitpod_list_7(N) __aorp_refproinitpod_list_(6), __aorp_refproinitpod_(N)
#  define __aorp_refproinitpod_list_8(N) __aorp_refproinitpod_list_(7), __aorp_refproinitpod_(N)
#  define __aorp_refproinitpod_list_9(N) __aorp_refproinitpod_list_(8), __aorp_refproinitpod_(N)
#  define __aorp_refproinitpod_list_10(N) __aorp_refproinitpod_list_(9), __aorp_refproinitpod_(N)

# endif

/* ------------------------------------------------------------------------- */

# define __aorp_defproinitpod_(anIndex,aPodInitParm) \
	__aorp_defproinitpod( \
		__myc_xconcat(aorpOpenParm,anIndex), \
		__myc_list_at(0,aPodInitParm),__myc_list_at(1,aPodInitParm), \
		__myc_list_popfront2(aPodInitParm) \
	)

# define __aorp_defproinitpod(aVarName,N,aProtocolNSnms,aPodInitParm) \
	__aorp_defproinitpod2(aVarName,N,aProtocolNSnms,aPodInitParm)

# define __aorp_defproinitpod2(aVarName,N,aProtocolNSnms,aPodInitParm) \
	__myc_list_execp(__aorp_defproinitpod_helper, \
		aPodInitParm, aVarName, \
		N, aProtocolNSnms, __aorpc_ns_protocol_nm2id(aProtocolNSnms) \
	)

# if __myc_support(NVM)
#  define __aorp_defproinitpod_helper(aVarName,N,aProtocolNSnms,aProtocolNSids,aParm...) \
	__aorp_proinitpod(N,aProtocolNSnms) aVarName = { \
		/* .common = */ { \
			/* .oid = */ _A_opsoid_i_(N,aProtocolNSids) \
		}, \
		aParm \
	}
# else
# if __myc_support(AVM)
#  define __aorp_defproinitpod_helper(aVarName,N,aProtocolNSnms,aProtocolNSids,...) \
	__aorp_proinitpod(N,aProtocolNSnms) aVarName = { \
		/* .common = */ { \
			/* .oid = */ _A_opsoid_i_(N,aProtocolNSids) \
		}, \
		__VA_ARGS__ \
	}
# endif /* __myc_support(AVM) */
# endif /* __myc_support(NVM) */

/* @} MISC pseudo-keywords */

/* ============================================================================
 * COMMON pseudo-keywords
 * @{
 */
# pragma mark -
# pragma mark [ OPDOM pseudo-keywords ]
# pragma mark -

# define __aorp_hbdecl() __aorp_hbdecl_u(__aorpc_decl)()
# define __aorp_hbdecl_u(aDeclSpec) __myc_xconcat(__aorp_hbdecl_u,aDeclSpec)

# define __aorp_hbdecl_u__aorpc_decl() ...
# define __aorp_hbdecl_u0() ...
# define __aorp_hbdecl_u__aorpc_decl_nothing() ...

# define __aorp_hbdecl_u1() ...
# define __aorp_hbdecl_u__aorpc_decl_service() ...
# define __aorp_hbdecl_u2() __aorp_hbdecl_podinit
# define __aorp_hbdecl_u__aorpc_decl_protocol_init() __aorp_hbdecl_podinit
# define __aorp_hbdecl_u3() ...
# define __aorp_hbdecl_u__aorpc_decl_protocol() ...
# define __aorp_hbdecl_u4() __aorp_hbdecl_xobject
# define __aorp_hbdecl_u__aorpc_decl_xobject() __aorp_hbdecl_xobject
# define __aorp_hbdecl_u5() __aorp_hbdecl_cobject
# define __aorp_hbdecl_u__aorpc_decl_cobject() __aorp_hbdecl_cobject
# define __aorp_hbdecl_u6() __aorp_hbdecl_mobject
# define __aorp_hbdecl_u__aorpc_decl_mobject() __aorp_hbdecl_mobject

# define __aorp_hbdecl_u7() ...
# define __aorp_hbdecl_u__aorpc_decl_class() ...
# define __aorp_hbdecl_u8() ...
# define __aorp_hbdecl_u__aorpc_decl_module() ...

/* ------------------------------------------------------------------------- */

# define __aorp_end() __aorp_end_u(__aorpc_decl)()
# define __aorp_end_u(aDeclSpec) __myc_xconcat(__aorp_end_u,aDeclSpec)

/* used for opdom */
# define __aorp_end_u__aorpc_decl()
# define __aorp_end_u0()
# define __aorp_end_u__aorpc_decl_nothing()

# define __aorp_end_u1() __aorp_end_service
# define __aorp_end_u__aorpc_decl_service() __aorp_end_service
# define __aorp_end_u2() __aorp_end_protocol_init
# define __aorp_end_u__aorpc_decl_protocol_init() __aorp_end_protocol_init
# define __aorp_end_u3() __aorp_end_protocol
# define __aorp_end_u__aorpc_decl_protocol() __aorp_end_protocol
# define __aorp_end_u4() __aorp_end_xobject
# define __aorp_end_u__aorpc_decl_xobject() __aorp_end_xobject
# define __aorp_end_u5() __aorp_end_cobject
# define __aorp_end_u__aorpc_decl_cobject() __aorp_end_cobject
# define __aorp_end_u6() __aorp_end_mobject
# define __aorp_end_u__aorpc_decl_mobject() __aorp_end_mobject

# define __aorp_end_u7() __aorp_end_class
# define __aorp_end_u__aorpc_decl_class() __aorp_end_class
# define __aorp_end_u8() __aorp_end_module
# define __aorp_end_u__aorpc_decl_module() __aorp_end_module

/* ------------------------------------------------------------------------- */

# define __aorp_end_ucb() __aorp_end_ucb_u(__aorpc_decl)()
# define __aorp_end_ucb_u(aDeclSpec) __myc_xconcat(__aorp_end_ucb_u,aDeclSpec)

# define __aorp_end_ucb_u__aorpc_decl() ...
# define __aorp_end_ucb_u0() ...
# define __aorp_end_ucb_u__aorpc_decl_nothing() ...

# define __aorp_end_ucb_u1() ...
# define __aorp_end_ucb_u__aorpc_decl_service() ...
# define __aorp_end_ucb_u2() ...
# define __aorp_end_ucb_u__aorpc_decl_protocol_init() ...
# define __aorp_end_ucb_u3() ...
# define __aorp_end_ucb_u__aorpc_decl_protocol() ...
# define __aorp_end_ucb_u4() ...
# define __aorp_end_ucb_u__aorpc_decl_xobject() ...
# define __aorp_end_ucb_u5() ...
# define __aorp_end_ucb_u__aorpc_decl_cobject() ...
# define __aorp_end_ucb_u6() ...
# define __aorp_end_ucb_u__aorpc_decl_mobject() ...

# define __aorp_end_ucb_u7() __aorp_end_ucb_class
# define __aorp_end_ucb_u__aorpc_decl_class() __aorp_end_ucb_class
# define __aorp_end_ucb_u8() __aorp_end_ucb_module
# define __aorp_end_ucb_u__aorpc_decl_module() __aorp_end_ucb_module

/* @} COMMON pseudo-keywords */

/* ============================================================================
 * OPDOM pseudo-keywords
 * @{
 */
# pragma mark -
# pragma mark [ OPDOM pseudo-keywords ]
# pragma mark -

/*
 * get opdom id by name (AorpK_<domain>_opdom)
 */
# define __aorp_opdomidof(aDomainName) \
	__aorpc_list_convolution_ps(AorpK_,1,(aDomainName),_opdom)

/* @todo: redesign: __aorp_opdom_isempty */
/* AorpK_<domain>_opdom_empty */
# define __aorp_opdom_isempty(aDomainName) \
	__aorpc_list_convolution_ps(AorpK_,1,(aDomainName),_opdom_empty)

/* ------------------------------------------------------------------------- */

/*
 * 1. declare tag, typename
 * (<domain>_guts)
 */
# define __aorp_opdom_tag(aDomainName) __myc_xconcat(aDomainName,_guts)
# define __aorp_opdom_typename(aDomainName) struct __aorp_opdom_tag(aDomainName)

/*
 * 1. declare object
 * 2. object reference
 */
# define __aorp_opdom(aDomainName) struct __aorp_opdom_tag(aDomainName)

/*
 * declare an opdom in a protocol
 */
# define __aorp_domdecl(aDomainName) __aorp_opdom_typename(aDomainName) _guts

#if 1
# define __aorp_current_domdecl __aorp_domdecl(__myc_list_at(1,__aorpc_ns_protocol))
# define __aorp_current_domname __myc_list_at(1,__aorpc_ns_protocol)
#else
# define __aorp_current_domdecl __aorp_domdecl(__myc_list_at(1,__aorpc_ns_protocol__))
# define __aorp_current_domname __myc_list_at(1,__aorpc_ns_protocol__)
#endif
/* @} OPDOM pseudo-keywords */

/* ============================================================================
 * SERVICE pseudo-keywords
 * @{
 */
# pragma mark -
# pragma mark [ SERVICE pseudo-keywords ]
# pragma mark -

/* ----------------------------------------------------------------------------
 * service oid1
 */

/*
 * get [public] service id by name (AorpK_<service>_service)
 */
# define __aorp_serviceidof(aServiceName) \
	__aorpc_list_convolution_ps(AorpK_,1,(aServiceName),_service)

/*
 * get [devel] service id by name (_AorpK_<service>_service)
 */
# define __aorp_builtin_serviceidof(aServiceName) \
	__aorpc_list_convolution_ps(_AorpK_,1,(aServiceName),_service)

# define __aorp_declare_builtin_serviceidof(aServiceName) \
	__aorpc_list_convolution_ps(_AorpK_,1,(aServiceName),_service)

/* ------------------------------------------------------------------------- */

/*
 * get [public] number of service operations (AorpK_<service>_opc)
 */
#if 0
# define __aorp_sopcountof(aServiceName) \
	__aorpc_list_convolution_ps(AorpK_,1,(aServiceName),_opc)
#endif

/*
 * get [devel] number of service operations (_AorpK_<service>_opc)
 */
# define __aorp_builtin_sopcountof(aServiceName) \
	__aorpc_list_convolution_ps(_AorpK_,1,(aServiceName),_opc)

# define __aorp_declare_builtin_sopcountof(aServiceName) \
	__aorpc_list_convolution_ps(_AorpK_,1,(aServiceName),_opc)

/* ------------------------------------------------------------------------- */

/*
 * get [public] service operation oid1 (AorpK_<service>_<routine>)
 */
#if 0
# define __aorp_opidof(aRoutine,aServiceName) \
	__aorpc_list_convolution_p(AorpK_,2,(aServiceName,aRoutine))
#endif

/*
 * get [devel] service operation oid1 (_AorpK_<service>_<routine>)
 */
# define __aorp_builtin_opidof(aRoutine,aServiceName) \
	__aorpc_list_convolution_p(_AorpK_,2,(aServiceName,aRoutine))

# define __aorp_declare_builtin_opidof(aRoutine,aServiceName) \
	__aorpc_list_convolution_p(_AorpK_,2,(aServiceName,aRoutine))

/*
 * service operation name (as string)
 */

# define __aorp_getopname(aRoutine,aServiceName) \
	__aorp_opname_storage(aServiceName,aRoutine)

# define __aorp_opname_storage(aServiceName,aRoutine) \
	__aorpc_list_convolution_ps(_S_,2,(aServiceName,aRoutine),_name)

/*
 * service operation signature (as string)
 */

# define __aorp_getopsign(aRoutine,aServiceName) \
	__aorp_opsign_storage(aServiceName,aRoutine)

# define __aorp_opsign_storage(aServiceName,aRoutine) \
	__aorpc_list_convolution_ps(_S_,2,(aServiceName,aRoutine),_signature)

/* ----------------------------------------------------------------------------
 * begin service
 */

# define __aorp_begin_service(aServiceName) \
	__aorp_begin_service_y(__aorpc_impl)(aServiceName)

# define __aorp_begin_service_y(DasIstImpl) \
	__myc_xconcat(__aorp_begin_service_y,DasIstImpl)

#if 1
# define __aorp_begin_service_y1(aServiceName) \
	__aorp_begin_service_imp(aServiceName,__aorpc_ns_protocol_c,__aorpc_ns_protocol)
#else
# define __aorp_begin_service_y1(aServiceName) \
	__aorp_begin_service_imp(aServiceName,__aorpc_ns_protocol_c__,__aorpc_ns_protocol__)
#endif
# define __aorp_begin_service_y0(aServiceName) \
	__aorp_begin_service_itf(aServiceName)
# define __aorp_begin_service_y__aorpc_impl(aServiceName) \
	__aorp_begin_service_itf(aServiceName)

/* ----------------------------------------------------------------------------
 * end service ctb
 */

# define __aorp_end_ctb __aorp_end_service_ctb()

# define __aorp_end_service_ctb() \
	__aorp_end_service_ctb_y(__aorpc_impl)()

# define __aorp_end_service_ctb_y(DasIstImpl) \
	__myc_xconcat(__aorp_end_service_ctb_y,DasIstImpl)

#if 1
# define __aorp_end_service_ctb_y1() \
	__aorp_end_service_ctb_imp(__aorpc_ns_protocol_c,__aorpc_ns_protocol)
#else
# define __aorp_end_service_ctb_y1() \
	__aorp_end_service_ctb_imp(__aorpc_ns_protocol_c__,__aorpc_ns_protocol__)
#endif
# define __aorp_end_service_ctb_y0() \
	__aorp_end_service_ctb_itf(__aorpc_service_name)
# define __aorp_end_service_ctb_y__aorpc_impl() \
	__aorp_end_service_ctb_itf(__aorpc_service_name)

/* ----------------------------------------------------------------------------
 * end service
 */

# define __aorp_end_service __aorp_end_service_()

# define __aorp_end_service_() \
	__aorp_end_service_y(__aorpc_impl)()

# define __aorp_end_service_y(DasIstImpl) \
	__myc_xconcat(__aorp_end_service_y,DasIstImpl)

#if 1
# define __aorp_end_service_y1() \
	__aorp_end_service_imp(__aorpc_ns_protocol_c,__aorpc_ns_protocol)
#else
# define __aorp_end_service_y1() \
	__aorp_end_service_imp(__aorpc_ns_protocol_c__,__aorpc_ns_protocol__)
#endif
# define __aorp_end_service_y0() \
	__aorp_end_service_itf(__aorpc_service_name)
# define __aorp_end_service_y__aorpc_impl() \
	__aorp_end_service_itf(__aorpc_service_name)

/* @} SERVICE pseudo-keywords */

/* ============================================================================
 * SERVICE OPERATION pseudo-keywords
 * @{
 */
# pragma mark -
# pragma mark [ SERVICE OPERATION pseudo-keywords ]
# pragma mark -

/* ----------------------------------------------------------------------------
 * declaration of a service operation
 */

# define __aorp_current_op(aRoutine,aNameStr,aProto) \
	__aorp_op(aRoutine,aNameStr,aProto)

# define __aorp_op(aRoutine,aNameStr,aProto) \
	__aorp_op_y(__aorpc_impl)(aRoutine,aNameStr,aProto)

# define __aorp_op_y(DasIstImpl) \
	__myc_xconcat(__aorp_op_y,DasIstImpl)

#if 1
# define __aorp_op_y1(aRoutine,aNameStr,aProto) \
	__aorp_op_imp(__aorpc_ns_protocol_c,__aorpc_ns_protocol,aRoutine,aNameStr,aProto)
#else
# define __aorp_op_y1(aRoutine,aNameStr,aProto) \
	__aorp_op_imp(__aorpc_ns_protocol_c__,__aorpc_ns_protocol__,aRoutine,aNameStr,aProto)
#endif
# define __aorp_op_y0(aRoutine,aNameStr,aProto) \
	__aorp_op_itf(__aorpc_service_name,aRoutine,aNameStr,aProto)
# define __aorp_op_y__aorpc_impl(aRoutine,aNameStr,aProto) \
	__aorp_op_itf(__aorpc_service_name,aRoutine,aNameStr,aProto)

/* ------------------------------------------------------------------------- */

# define __aorp_op_attribute(attributes)
# define __aorp_op_return(spec)

/* @} SERVICE OPERATION pseudo-keywords */

/* ============================================================================
 * OBJECT pseudo-keywords
 * @{
 */
# pragma mark -
# pragma mark [ OBJECT pseudo-keywords ]
# pragma mark -

/*
 * get object id by name (AorpK_<object>_object)
 */
# define __aorp_objectidof(anObjectName) \
	__aorpc_list_convolution_ps(AorpK_,1,(anObjectName),_object)

/* @todo: redesign: __aorp_iscreatable */
/* AorpK_<object>_object_creatable */
# define __aorp_iscreatable(anObjectName) \
	__aorpc_list_convolution_ps(AorpK_,1,(anObjectName),_object_creatable)

/* @} OBJECT pseudo-keywords */

/* ============================================================================
 * XOBJECT pseudo-keywords
 * @{
 */
# pragma mark -
# pragma mark [ XOBJECT pseudo-keywords ]
# pragma mark -

/*
 * declare tag, typename
 */
# define __aorp_xobject_tag(N,anObjectNS) \
	__aorpc_list_convolution_s(N,anObjectNS,_xobject)

# define __aorp_xobject_typename(N,anObjectNS) \
	__aorpc_list_convolution_s(N,anObjectNS,_xobject_t)

/* ----------------------------------------------------------------------------
 * 1. declare object
 * 2. object reference
 */

# define __aorp_xobject(N,anObjectNS) \
	__aorp_xobject_u(__aorpc_decl)(N,anObjectNS)

# define __aorp_xobject_u(aDeclSpec) \
	__myc_xconcat(__aorp_xobject_u,aDeclSpec)

/* reference */
# define __aorp_xobject_u0(N,anObjectNS) struct __aorp_xobject_tag(N,anObjectNS)
# define __aorp_xobject_u__aorpc_decl_nothing(N,anObjectNS) \
	struct __aorp_xobject_tag(N,anObjectNS)

/* declaration */
# define __aorp_xobject_u4(N,anObjectNS) __aorp_begin_xobject(N,anObjectNS)
# define __aorp_xobject_u__aorpc_decl_xobject(N,anObjectNS) \
	__aorp_begin_xobject(N,anObjectNS)

/* ------------------------------------------------------------------------- */

/* xobject header */
# define __aorp_hbdecl_xobject struct aorp_aobject_s ahb_

/* ------------------------------------------------------------------------- */

# define __aorp_begin_xobject(N,anObjectNS) \
	__aorp_begin_xobject_y(__aorpc_impl)(N,anObjectNS)

# define __aorp_begin_xobject_y(DasIstImpl) \
	__myc_xconcat(__aorp_begin_xobject_y,DasIstImpl)

# define __aorp_begin_xobject_y1(N,anObjectNS) \
	__aorp_begin_xobject_imp(N,anObjectNS)
# define __aorp_begin_xobject_y0(N,anObjectNS) \
	__aorp_begin_xobject_itf(N,anObjectNS)
# define __aorp_begin_xobject_y__aorpc_impl(N,anObjectNS) \
	__aorp_begin_xobject_itf(N,anObjectNS)

/* ------------------------------------------------------------------------- */

/* end xobject redirection */
# define __aorp_end_xobject \
	__aorp_end_xobject_(__aorpc_ns_object_c,__aorpc_ns_object)

# define __aorp_end_xobject_(N,anObjectNS) \
	__aorp_end_xobject_y(__aorpc_impl)(N,anObjectNS)

# define __aorp_end_xobject_y(DasIstImpl) \
	__myc_xconcat(__aorp_end_xobject_y,DasIstImpl)

# define __aorp_end_xobject_y1(N,anObjectNS) \
	__aorp_end_xobject_imp(N,anObjectNS)
# define __aorp_end_xobject_y0(N,anObjectNS) \
	__aorp_end_xobject_itf(N,anObjectNS)
# define __aorp_end_xobject_y__aorpc_impl(N,anObjectNS) \
	__aorp_end_xobject_itf(N,anObjectNS)

/* ----------------------------------------------------------------------------
 * get size of xobject<name>
 */

/* @todo: redesign: __aorp_iscreatable */
#if 1
# define __aorp_xobsizeof(N,anObjectNS) \
	__aorp_xobsizeof_x(__aorp_iscreatable(__myc_list_at(0,anObjectNS)))( \
		N,anObjectNS \
	)

# define __aorp_xobsizeof_x(IsObjectCreatable) \
	__myc_xconcat(__aorp_xobsizeof_x,IsObjectCreatable)

# define __aorp_xobsizeof_x0(N,anObjectNS) 0
# define __aorp_xobsizeof_x1(N,anObjectNS) \
	sizeof(__aorp_xobject_typename(N,anObjectNS))

#else
# define __aorp_xobsizeof(N,anObjectNS) \
	sizeof(__aorp_xobject_typename(N,anObjectNS))
#endif
/* @} */

/* ----------------------------------------------------------------------------
 * get pod offset in a xobject<name>
 */

/* @todo: redesign @{ */
#if 1
# define __aorp_xoboffsetof(N,anObjectNS,aProtoDomainName,aPODFieldName) \
	__aorp_xoboffsetof_x(__aorp_opdom_isempty(aProtoDomainName))( \
		N,anObjectNS,aPODFieldName \
	)

# define __aorp_xoboffsetof_x(IsDomainEmpty) \
	__myc_xconcat(__aorp_xoboffsetof_x,IsDomainEmpty)

# define __aorp_xoboffsetof_x1(N,anObjectNS,aPODFieldName) 0
# define __aorp_xoboffsetof_x0(N,anObjectNS,aPODFieldName) \
	__myc_offsetof(__aorp_xobject_typename(N,anObjectNS),aPODFieldName)
#endif
/* @} */

# define __aorp_current_xoboffsetof(aProtoDomainName,aPODFieldName) \
	__aorp_xoboffsetof(__aorpc_ns_object_c,__aorpc_ns_object,aProtoDomainName,aPODFieldName)

/* @} XOBJECT pseudo-keywords */

/* ============================================================================
 * COBJECT pseudo-keywords
 * @{
 */
# pragma mark -
# pragma mark [ COBJECT pseudo-keywords ]
# pragma mark -

/*
 * declare tag, typename
 */
# define __aorp_cobject_tag(N,anObjectNS) \
	__aorpc_list_convolution_s(N,anObjectNS,_cobject)

# define __aorp_cobject_typename(N,anObjectNS) \
	__aorpc_list_convolution_s(N,anObjectNS,_cobject_t)

/* ----------------------------------------------------------------------------
 * 1. declare object
 * 2. object reference
 */

# define __aorp_cobject(N,anObjectNS) \
	__aorp_cobject_u(__aorpc_decl)(N,anObjectNS)

# define __aorp_cobject_u(aDeclSpec) \
	__myc_xconcat(__aorp_cobject_u,aDeclSpec)

/* reference */
# define __aorp_cobject_u0(N,anObjectNS) struct __aorp_cobject_tag(N,anObjectNS)
# define __aorp_cobject_u__aorpc_decl_nothing(N,anObjectNS) \
	struct __aorp_cobject_tag(N,anObjectNS)

/* declaration */
# define __aorp_cobject_u5(N,anObjectNS) __aorp_begin_cobject(N,anObjectNS)
# define __aorp_cobject_u__aorpc_decl_cobject(N,anObjectNS) \
	__aorp_begin_cobject(N,anObjectNS)

/* ------------------------------------------------------------------------- */

/* cobject header */
# define __aorp_hbdecl_cobject struct aorp_cobject ahb_

/* ------------------------------------------------------------------------- */

# define __aorp_begin_cobject(N,anObjectNS) \
	__aorp_begin_cobject_y(__aorpc_impl)(N,anObjectNS)

# define __aorp_begin_cobject_y(DasIstImpl) \
	__myc_xconcat(__aorp_begin_cobject_y,DasIstImpl)

# define __aorp_begin_cobject_y1(N,anObjectNS) \
	__aorp_begin_cobject_imp(N,anObjectNS)
# define __aorp_begin_cobject_y0(N,anObjectNS) \
	__aorp_begin_cobject_itf(N,anObjectNS)
# define __aorp_begin_cobject_y__aorpc_impl(N,anObjectNS) \
	__aorp_begin_cobject_itf(N,anObjectNS)

/* ------------------------------------------------------------------------- */

/* end cobject redirection */
# define __aorp_end_cobject \
	__aorp_end_cobject_(__aorpc_ns_object_c,__aorpc_ns_object)

# define __aorp_end_cobject_(N,anObjectNS) \
	__aorp_end_cobject_y(__aorpc_impl)(N,anObjectNS)

# define __aorp_end_cobject_y(DasIstImpl) \
	__myc_xconcat(__aorp_end_cobject_y,DasIstImpl)

# define __aorp_end_cobject_y1(N,anObjectNS) \
	__aorp_end_cobject_imp(N,anObjectNS)
# define __aorp_end_cobject_y0(N,anObjectNS) \
	__aorp_end_cobject_itf(N,anObjectNS)
# define __aorp_end_cobject_y__aorpc_impl(N,anObjectNS) \
	__aorp_end_cobject_itf(N,anObjectNS)

/* ----------------------------------------------------------------------------
 * get pod offset in a cobject<name>
 */

/* @todo: redesign @{ */
#if 1
# define __aorp_coboffsetof(N,anObjectNS,aProtoDomainName,aPODFieldName) \
	__aorp_coboffsetof_x(__aorp_opdom_isempty(aProtoDomainName))( \
		N,anObjectNS,aPODFieldName \
	)

# define __aorp_coboffsetof_x(IsDomainEmpty) \
	__myc_xconcat(__aorp_coboffsetof_x,IsDomainEmpty)

# define __aorp_coboffsetof_x1(N,anObjectNS,aPODFieldName) 0
# define __aorp_coboffsetof_x0(N,anObjectNS,aPODFieldName) \
	__myc_offsetof(__aorp_cobject_typename(N,anObjectNS),aPODFieldName)
#endif
/* @} */

# define __aorp_current_coboffsetof(aProtoDomainName,aPODFieldName) \
	__aorp_coboffsetof(__aorpc_ns_object_c,__aorpc_ns_object,aProtoDomainName,aPODFieldName)

/* ----------------------------------------------------------------------------
 * class [var] definition
 */

# define __aorp_begin_classex(N,anObjectNS,K,anExObjectNS) \
typedef __aorp_cobject_typename(K,anExObjectNS) __aorp_cobject_typename(N,anObjectNS); \
__aorp_begin_class(N,anObjectNS)

# define __aorp_begin_class(N,anObjectNS) \
enum { \
	__aorpc_list_convolution_ps(_AorpK_,N,anObjectNS,_class_definition_start) = 1 \
}; \
__MYC_BEGIN_CDECLS \
__aorp_cobvardef(N,anObjectNS) = { \
	/* .ahb_ = */ { \
		/* .basic_ = */ { \
			/* .hint_ = */       /* AorpK_HINT_COBJECT */ 0, \
			/* .rtxi_ = */       /* _AORP_RTXI_COBJECT_FLAGS */ 0, \
			/* .isa_ = */        /* _A_modref(xxx) */ NULL, \
			/* .rtsi_ = */       0, \
			/* .refc_ = */       0, \
			/* .rwlock_ = */     BO_CPURWLOCK_ZERO_INITIALIZER, \
			/* .aorp_version_ = */ AORP_VERSION, \
			/* .long_key_ = */   AORP_OBJECT_CATEGORY "/" __aorpc_list_mkstrkey(N,anObjectNS), \
			/* .short_key_ = */  __aorpc_list_mkstrkey(N,anObjectNS), \
			/* .name_ = */       __myc_xstringify(__myc_list_at(0,anObjectNS)), \
			/* .dbelem_ = */ { \
				/* .oid_ = */        _A_classoid_i_(N,__aorpc_ns_id_object), \
				/* .btelem_ = */     AORP_ODBELEM1_ZERO_INITIALIZER, \
				/* .db_ = */         NULL \
			},
# if 0
			/* .ucb = */ {
				/* .bootstrap_ = */  (aorp_object_bootstrap_fn)_im_Xxx_class_bootstrap,
				/* .halt_ = */       (aorp_object_halt_fn)_im_Xxx_class_halt,
				/* .configure_ = */  (aorp_object_configure_fn)_im_Xxx_class_configure
			}
# endif

/* ------------------------------------------------------------------------- */

/* end ucb-class redirection */
# define __aorp_end_ucb_class \
	__aorp_end_ucb_class_(__aorpc_ns_object_c,__aorpc_ns_object)

# define __aorp_end_ucb_class_(N,anObjectNS) \
		}, \
		/* .selist_ = */     AORP_SELIST_ZERO_INITIALIZER, \
		/* .instsz_ = */     __aorp_xobsizeof(N,anObjectNS) \
	},

/* end class redirection */
# define __aorp_end_class \
	__aorp_end_class_(__aorpc_ns_object_c,__aorpc_ns_object)

# define __aorp_end_class_(N,anObjectNS) \
}; \
__MYC_END_CDECLS \
enum { \
	__aorpc_list_convolution_ps(_AorpK_,N,anObjectNS,_class_definition_finish) = 1 \
}

/* ------------------------------------------------------------------------- */

/*
 * cobject var external declaration
 */
# define __aorp_cobvardecl(N,anObjectNS) \
	__myc_vlinkage_amod(private) struct aorp_cobject \
	__aorp_cobvarname(N,anObjectNS)

# define __aorp_current_cobvardecl \
	__aorp_cobvardecl(__aorpc_ns_object_c,__aorpc_ns_object)

/*
 * cobject var reference
 */
# define __aorp_cobvarref(N,anObjectNS) \
	((struct aorp_cobject *)&__aorp_cobvarname(N,anObjectNS))

# define __aorp_current_cobvarref \
	__aorp_cobvarref(__aorpc_ns_object_c,__aorpc_ns_object)

/*
 *  cobject var definition
 */
#if 0
# define __aorp_cobvardef(N,anObjectNS) \
	__myc_vlinkage_amod(private) \
	struct __aorp_cobject_tag(N,anObjectNS) __aorp_cobvarname(N,anObjectNS); \
	struct __aorp_cobject_tag(N,anObjectNS) __aorp_cobvarname(N,anObjectNS)
#else
# define __aorp_cobvardef(N,anObjectNS) \
	__myc_vlinkage_amod(private) \
	__aorp_cobject_typename(N,anObjectNS) __aorp_cobvarname(N,anObjectNS); \
	__aorp_cobject_typename(N,anObjectNS) __aorp_cobvarname(N,anObjectNS)
#endif

/*
 * cobject var name
 */
# define __aorp_cobvarname(N,anObjectNS) \
	__aorpc_list_convolution_ps(_G_,N,anObjectNS,_class)

/* @} COBJECT pseudo-keywords */

/* ============================================================================
 * MOBJECT pseudo-keywords
 * @{
 */
# pragma mark -
# pragma mark [ MODULE pseudo-keywords ]
# pragma mark -

/*
 * declare tag, typename
 */

/* NOT FOR YOUR BUSINESS @{ */
# define _A_mobject_tag(N,anObjectNS) __aorp_mobject_tag(N,anObjectNS)
# define _A_mobject_typename(N,anObjectNS) __aorp_mobject_typename(N,anObjectNS)
/* @} */

#if 0
# define __aorp_mobject_tag(N,anObjectNS) \
	__aorpc_list_convolution_s(N,anObjectNS,_mobject)
# define __aorp_mobject_typename(N,anObjectNS) \
	__aorpc_list_convolution_s(N,anObjectNS,_mobject_t)
#else
# define __aorp_mobject_tag(N,anObjectNS) aorp_mobject
# define __aorp_mobject_typename(N,anObjectNS) aorp_mobject_t
#endif

/* ----------------------------------------------------------------------------
 * 1. declare object
 * 2. object reference
 */

# define __aorp_mobject(N,anObjectNS) \
	__aorp_mobject_u(__aorpc_decl)(N,anObjectNS)

# define __aorp_mobject_u(aDeclSpec) \
	__myc_xconcat(__aorp_mobject_u,aDeclSpec)

/* reference */
# define __aorp_mobject_u0(N,anObjectNS) struct __aorp_mobject_tag(N,anObjectNS)
# define __aorp_mobject_u__aorpc_decl_nothing(N,anObjectNS) \
	struct __aorp_mobject_tag(N,anObjectNS)

/* declaration */
# define __aorp_mobject_u6(N,anObjectNS) __aorp_begin_mobject(N,anObjectNS)
# define __aorp_mobject_u__aorpc_decl_mobject(N,anObjectNS) \
	__aorp_begin_mobject(N,anObjectNS)

/* ------------------------------------------------------------------------- */

/* mobject header */
# define __aorp_hbdecl_mobject struct aorp_mobject ahb_

/* ------------------------------------------------------------------------- */

# define __aorp_begin_mobject(N,anObjectNS) \
	__aorp_begin_mobject_y(__aorpc_impl)(N,anObjectNS)

# define __aorp_begin_mobject_y(DasIstImpl) \
	__myc_xconcat(__aorp_begin_mobject_y,DasIstImpl)

# define __aorp_begin_mobject_y1(N,anObjectNS) \
	__aorp_begin_mobject_imp(N,anObjectNS)
# define __aorp_begin_mobject_y0(N,anObjectNS) \
	__aorp_begin_mobject_itf(N,anObjectNS)
# define __aorp_begin_mobject_y__aorpc_impl(N,anObjectNS) \
	__aorp_begin_mobject_itf(N,anObjectNS)

/* ------------------------------------------------------------------------- */

/* end mobject redirection */
# define __aorp_end_mobject \
	__aorp_end_mobject_(__aorpc_ns_object_c,__aorpc_ns_object)

# define __aorp_end_mobject_(N,anObjectNS) \
	__aorp_end_mobject_y(__aorpc_impl)(N,anObjectNS)

# define __aorp_end_mobject_y(DasIstImpl) \
	__myc_xconcat(__aorp_end_mobject_y,DasIstImpl)

# define __aorp_end_mobject_y1(N,anObjectNS) \
	__aorp_end_mobject_imp(N,anObjectNS)
# define __aorp_end_mobject_y0(N,anObjectNS) \
	__aorp_end_mobject_itf(N,anObjectNS)
# define __aorp_end_mobject_y__aorpc_impl(N,anObjectNS) \
	__aorp_end_mobject_itf(N,anObjectNS)

/* ----------------------------------------------------------------------------
 * get module id by name (AorpK_<module>_module)
 */
# define __aorp_moduleidof(aModuleName) \
	__aorpc_list_convolution_ps(AorpK_,1,(aModuleName),_module)

/* ----------------------------------------------------------------------------
 * module [var] definition
 */

# define __aorp_begin_module(aModuleName) \
enum { \
	__aorpc_list_convolution_ps(_AorpK_,1,(aModuleName),_module_definition_start) = 1 \
}; \
__MYC_BEGIN_CDECLS \
__aorp_mobvardef(aModuleName) = { \
	/* .basic_ = */ { \
		/* .basic_ = */ { \
			/* .hint_ = */       /* AorpK_HINT_MOBJECT */ 0, \
			/* .rtxi_ = */       /* _AORP_RTXI_MOBJECT_FLAGS */ 0, \
			/* .isa_ = */        NULL, \
			/* .rtsi_ = */       0, \
			/* .refc_ = */       0, \
			/* .rwlock_ = */     BO_CPURWLOCK_ZERO_INITIALIZER, \
			/* .aorp_version_ = */ AORP_VERSION, \
			/* .long_key_ = */   AORP_MODULE_CATEGORY "/" __myc_xstringify(aModuleName), \
			/* .short_key_ = */  __myc_xstringify(aModuleName), \
			/* .name_ = */       __myc_xstringify(aModuleName), \
			/* .dbelem_ = */ { \
				/* .oid_ = */        _A_moduleoid1_i(aModuleName), \
				/* .btelem_ = */     AORP_ODBELEM1_ZERO_INITIALIZER, \
				/* .db_ = */         NULL \
			},
# if 0
			/* .ucb = */ {
				/* .bootstrap_ = */  (aorp_object_bootstrap_fn)_im_Xxx_module_bootstrap,
				/* .halt_ = */       (aorp_object_halt_fn)_im_Xxx_module_halt,
				/* .configure_ = */  (aorp_object_configure_fn)_im_Xxx_module_configure
			}
# endif

/* ------------------------------------------------------------------------- */

/* end ucb-module redirection */
# define __aorp_end_ucb_module __aorp_end_ucb_module_(__aorpc_module_name)
# define __aorp_end_ucb_module_(aModuleName) \
		}, \
		/* .selist_ = */     AORP_SELIST_ZERO_INITIALIZER, \
		/* .instsz_ = */     0 \
	}, \
	/* .openc_ = */          0, \
	/* .dl_self_ = */        NULL, \
	/* .prerequisites_ = */  AORP_MODLIST_ZERO_INITIALIZER, \
	/* .dependencies_ = */   AORP_MODLIST_ZERO_INITIALIZER, \
	/* .mld_dbelem_ = */ { \
		/* .name_ = */       __myc_xstringify(aModuleName), \
		/* .btelem_ = */     AORP_ODBELEM1_ZERO_INITIALIZER, \
		/* .db_ = */         NULL \
	},

/* ------------------------------------------------------------------------- */

# if 0
	/* .required_ = */       NULLF,
	/* .ops_count_ = */      0,
	/* .ops_list_ = */       NULL,
	/* .class_count_ = */    0,
	/* .class_list_ = */     NULL
# endif

/* ------------------------------------------------------------------------- */

# define __aorp_end_module __aorp_end_module_(__aorpc_module_name)
# define __aorp_end_module_(aModuleName) \
}; \
__aorp_module_export(aModuleName); \
__MYC_END_CDECLS \
enum { \
	__aorpc_list_convolution_ps(_AorpK_,1,(aModuleName),_module_definition_finish) = 1 \
}

# define __aorp_module_export(aModuleName) \
	__aorp_module_export_blt(__aorpc_builtin_module)(aModuleName)

# define __aorp_module_export_blt(IsBuiltin) \
	__myc_xconcat(__aorp_module_export_blt,IsBuiltin)

# define __aorp_module_export_blt1(aModuleName) \
enum { \
	__aorpc_list_convolution_ps(_AorpK_,1,(aModuleName),_builtin_module) = 1, \
	_AorpK_builtin_module = 1 \
}

# define __aorp_module_export_blt0(aModuleName) \
__myc_vlinkage_amod(public) struct aorp_mobject *_G_aorp_module; \
struct aorp_mobject *_G_aorp_module = __aorp_mobvarref(aModuleName); \
enum { \
	__aorpc_list_convolution_ps(_AorpK_,1,(aModuleName),_builtin_module) = 0, \
	_AorpK_builtin_module = 0 \
}

/* ------------------------------------------------------------------------- */

/*
 * mobject var external declaration
 */
# define __aorp_mobvardecl(aModuleName) \
	__myc_vlinkage_amod(private) struct aorp_mobject \
	__aorp_mobvarname(aModuleName)

# define __aorp_current_mobvardecl __aorp_mobvardecl(__aorpc_module_name)

/*
 * mobject var reference
 */
# define __aorp_mobvarref(aModuleName) \
	((struct aorp_mobject *)&__aorp_mobvarname(aModuleName))

# define __aorp_current_mobvarref __aorp_mobvarref(__aorpc_module_name)

/*
 *  mobject var definition
 */
# define __aorp_mobvardef(aModuleName) \
	__myc_vlinkage_amod(private) \
	struct __aorp_mobject_tag(1,(aModuleName)) __aorp_mobvarname(aModuleName); \
	struct __aorp_mobject_tag(1,(aModuleName)) __aorp_mobvarname(aModuleName)

/*
 * mobject var name
 */
# define __aorp_mobvarname(aModuleName) \
	__aorpc_list_convolution_ps(_G_,1,(aModuleName),_module)

/* @} MOBJECT pseudo-keywords */

/* ============================================================================
 * OPS pseudo-keywords
 * @{
 */
# pragma mark -
# pragma mark [ OPS pseudo-keywords ]
# pragma mark -

/*
 * ops var external declaration
 */

# define __aorp_opsdecl(N,aProtocolNS) \
	__myc_vlinkage_amod(private) struct aorp_ops \
	__aorp_opsname(N,aProtocolNS)

#if 0
# define __aorp_current_opsdecl \
	__aorp_opsdecl(__aorpc_ns_protocol_c,__aorpc_ns_protocol)
#else
# define __aorp_current_opsdecl \
	__aorp_opsdecl(__aorpc_ns_protocol_c__,__aorpc_ns_protocol__)
#endif

/*
 * ops var reference
 */

# define __aorp_opsref(N,aProtocolNS) \
	((struct aorp_ops *)&__aorp_opsname(N,aProtocolNS))

#if 0
# define __aorp_current_opsref \
	__aorp_opsref(__aorpc_ns_protocol_c,__aorpc_ns_protocol)
#else
# define __aorp_current_opsref \
	__aorp_opsref(__aorpc_ns_protocol_c__,__aorpc_ns_protocol__)
#endif

/*
 * ops var definition
 */

# define _A_opsdef_(N,aProtocolNS) __aorp_opsdef(N,aProtocolNS)

# define __aorp_opsdef(N,aProtocolNS) \
	__aorp_opsdef_helper(__myc_list_at(0,aProtocolNS),N,aProtocolNS)

# define __aorp_opsdef_helper(aServiceName,N,aProtocolNS) \
	_STRUCT_AORP_OPS(aServiceName,__aorp_builtin_sopcountof(aServiceName)); \
	__myc_vlinkage_amod(private) _TYPENAME_AORP_OPS(aServiceName) \
	__aorp_opsname(N,aProtocolNS); \
	_TYPENAME_AORP_OPS(aServiceName) __aorp_opsname(N,aProtocolNS)

# define __aorp_opsdef_enum(N,aProtocolNS) \
	enum __aorp_opsname_enum(N,aProtocolNS)

/*
 * ops var name
 */

# define __aorp_opsname(N,aProtocolNS) \
	__aorpc_list_convolution_ps(_G_,N,aProtocolNS,_ops)

# define __aorp_opsname_enum(N,aProtocolNS) \
	__aorpc_list_convolution_ps(_Enum_,N,aProtocolNS,_ops)

/* @} OPS pseudo-keywords */

/* ============================================================================
 * PROTOCOL INIT pseudo-keywords
 * @{
 */
# pragma mark -
# pragma mark [ PROTOCOL INIT pseudo-keywords ]
# pragma mark -

/* ----------------------------------------------------------------------------
 * declare proinitpod: tag, typename
 */

/* NOT FOR YOUR BUSINESS @{ */
#if 0
# define _A_proinitpod_tag_(N,aProtocolNS) \
	__aorp_proinitpod_tag(N,aProtocolNS)

# define _A_proinitpod_typename_(N,aProtocolNS) \
	__aorp_proinitpod_typename(N,aProtocolNS)

# define _A_proinitpod_tag(aServiceName,aDomainName) \
	__aorp_proinitpod_tag(2,(aServiceName,aDomainName))

# define _A_proinitpod_typename(aServiceName,aDomainName) \
	__aorp_proinitpod_typename(2,(aServiceName,aDomainName))
#endif
/* @} */

# define __aorp_proinitpod_tag(N,aProtocolNS) \
	__aorpc_list_convolution_s(N,aProtocolNS,_proinit)

# define __aorp_proinitpod_typename(N,aProtocolNS) \
	__aorpc_list_convolution_s(N,aProtocolNS,_proinit_t)

/*
 * pod reference
 */

# define __aorp_proinitpod(N,aProtocolNS) \
	__aorp_proinitpod_typename(N,aProtocolNS)

# define __aorp_self_proinitpod \
	__aorp_proinitpod(__aorpc_ns_self_proinitpod_c,__aorpc_ns_self_proinitpod)

/* ------------------------------------------------------------------------- */

/* podinit header */
# define __aorp_hbdecl_podinit struct aorp_podinit_s ahb_

/* ----------------------------------------------------------------------------
 * begin, end protocol init
 */

# define __aorp_begin_protocol_init(N,aProtocolNS) \
	__aorp_begin_protocol_init_y(__aorpc_impl)(N,aProtocolNS)

# define __aorp_begin_protocol_init_y(DasIstImpl) \
	__myc_xconcat(__aorp_begin_protocol_init_y,DasIstImpl)

#if 1
# define __aorp_begin_protocol_init_y1(N,aProtocolNS) \
	__aorp_begin_protocol_init_imp(__aorpc_ns_protocol_c,__aorpc_ns_protocol)
#else
# define __aorp_begin_protocol_init_y1(N,aProtocolNS) \
	__aorp_begin_protocol_init_imp(__aorpc_ns_protocol_c__,__aorpc_ns_protocol__)
#endif
# define __aorp_begin_protocol_init_y0(N,aProtocolNS) \
	__aorp_begin_protocol_init_itf(N,aProtocolNS)
# define __aorp_begin_protocol_init_y__aorpc_impl(N,aProtocolNS) \
	__aorp_begin_protocol_init_itf(N,aProtocolNS)

/* ------------------------------------------------------------------------- */

# define __aorp_end_protocol_init \
	__aorp_end_protocol_init_(__aorpc_ns_protocol_c,__aorpc_ns_protocol)

# define __aorp_end_protocol_init_(N,aProtocolNS) \
	__aorp_end_protocol_init_y(__aorpc_impl)(N,aProtocolNS)

# define __aorp_end_protocol_init_y(DasIstImpl) \
	__myc_xconcat(__aorp_end_protocol_init_y,DasIstImpl)

#if 1
# define __aorp_end_protocol_init_y1(N,aProtocolNS) \
	__aorp_end_protocol_init_imp(N,aProtocolNS)
#else
# define __aorp_end_protocol_init_y1(N,aProtocolNS) \
	__aorp_end_protocol_init_imp(__aorpc_ns_protocol_c__,__aorpc_ns_protocol__)
#endif
# define __aorp_end_protocol_init_y0(N,aProtocolNS) \
	__aorp_end_protocol_init_itf(N,aProtocolNS)
# define __aorp_end_protocol_init_y__aorpc_impl(N,aProtocolNS) \
	__aorp_end_protocol_init_itf(N,aProtocolNS)

/* @} PROTOCOL INIT pseudo-keywords */

/* ============================================================================
 * PROTOCOL pseudo-keywords
 * @{
 */
# pragma mark -
# pragma mark [ PROTOCOL pseudo-keywords ]
# pragma mark -

/* ----------------------------------------------------------------------------
 * declare protocol pod: tag, typename
 */

/* NOT FOR YOUR BUSINESS @{ */
#if 0
# define _A_pod_tag_(N,aProtocolNS) __aorp_pod_tag(N,aProtocolNS)
# define _A_pod_typename_(N,aProtocolNS) __aorp_pod_typename(N,aProtocolNS)

# define _A_pod_tag(aServiceName,aDomainName) \
	__aorp_pod_tag(2,(aServiceName,aDomainName))

# define _A_pod_typename(aServiceName,aDomainName) \
	__aorp_pod_typename(2,(aServiceName,aDomainName))
#endif
/* @} */

# define __aorp_pod_tag(N,aProtocolNS) \
	__aorpc_list_convolution_s(N,aProtocolNS,_pod)

# define __aorp_pod_typename(N,aProtocolNS) \
	__aorpc_list_convolution_s(N,aProtocolNS,_pod_t)

/* ----------------------------------------------------------------------------
 * pod reference
 */

#if 0
# define __aorp_pod(N,aProtocolNS) __aorp_pod_typename(N,aProtocolNS)
#else
# define __aorp_pod(N,aProtocolNS) __aorp_opdom_typename(__myc_list_at(1,aProtocolNS))
#endif

#if 1
# define __aorp_self_pod \
	__aorp_pod(__aorpc_ns_protocol_c,__aorpc_ns_protocol)
#else
# define __aorp_self_pod \
	__aorp_pod(__aorpc_ns_protocol_c__,__aorpc_ns_protocol__)
#endif

/* ----------------------------------------------------------------------------
 * pod size
 */

/* @todo: redesign @{ */
#if 1
# define __aorp_podsizeof(N,aProtocolNS) \
	__aorp_podsizeof_x(__aorp_opdom_isempty(__myc_list_at(1,aProtocolNS)))( \
		N,aProtocolNS \
	)

# define __aorp_podsizeof_x(IsDomainEmpty) \
	__myc_xconcat(__aorp_podsizeof_x,IsDomainEmpty)

# define __aorp_podsizeof_x1(N,aProtocolNS) 0
# define __aorp_podsizeof_x0(N,aProtocolNS) \
	sizeof(__aorp_pod_typename(N,aProtocolNS))
#endif
/* @} */

#if 1
# define __aorp_self_podsize \
	__aorp_podsizeof(__aorpc_ns_protocol_c,__aorpc_ns_protocol)
#else
# define __aorp_self_podsize \
	__aorp_podsizeof(__aorpc_ns_protocol_c__,__aorpc_ns_protocol__)
#endif

/* ----------------------------------------------------------------------------
 * declaration of a pod member in a (c)object
 */

/* @todo: redesign: __aorp_opdom_isempty */
# define __aorp_poddecl(N,aProtocolNS,aField) \
	__aorp_poddecl_x(__aorp_opdom_isempty(__myc_list_at(1,aProtocolNS)))( \
		N,aProtocolNS,aField \
	)

# define __aorp_poddecl_x(IsDomainEmpty) \
	__myc_xconcat(__aorp_poddecl_x,IsDomainEmpty)

# define __aorp_poddecl_x1(N,aProtocolNS,aField)
# define __aorp_poddecl_x0(N,aProtocolNS,aField) \
	__aorp_pod_typename(N,aProtocolNS) aField;

/* ----------------------------------------------------------------------------
 * begin protocol [pod]
 */

/* protocol header */
# define __aorp_hbdecl_protocol

# define __aorp_begin_protocol(N,aProtocolNS) __aorp_protocol_pod(N,aProtocolNS)

# define __aorp_protocol_pod(N,aProtocolNS) \
	__aorp_protocol_pod_y(__aorpc_impl)(N,aProtocolNS)

# define __aorp_protocol_pod_y(DasIstImpl) \
	__myc_xconcat(__aorp_protocol_pod_y,DasIstImpl)

#if 1
# define __aorp_protocol_pod_y1(N,aProtocolNS) \
	__aorp_protocol_pod_imp(__aorpc_ns_protocol_c,__aorpc_ns_protocol)
#else
# define __aorp_protocol_pod_y1(N,aProtocolNS) \
	__aorp_protocol_pod_imp(__aorpc_ns_protocol_c__,__aorpc_ns_protocol__)
#endif
# define __aorp_protocol_pod_y0(N,aProtocolNS) \
	__aorp_protocol_pod_itf(N,aProtocolNS)
# define __aorp_protocol_pod_y__aorpc_impl(N,aProtocolNS) \
	__aorp_protocol_pod_itf(N,aProtocolNS)

/* ----------------------------------------------------------------------------
 * end protocol pod
 */

# define __aorp_end_pod \
	__aorp_end_protocol_pod(__aorpc_ns_protocol_c,__aorpc_ns_protocol)

/* @todo: redesign: __aorp_opdom_isempty */
# define __aorp_end_protocol_pod(N,aProtocolNS) \
	__aorp_end_protocol_pod_x(__aorp_opdom_isempty(__myc_list_at(1,aProtocolNS)))( \
		N,aProtocolNS \
	)

# define __aorp_end_protocol_pod_x(IsDomainEmpty) \
	__myc_xconcat(__aorp_end_protocol_pod_x,IsDomainEmpty)


# define __aorp_end_protocol_pod_x1(N,aProtocolNS) \
	__aorp_end_protocol_pod_x1_y(__aorpc_impl)(N,aProtocolNS)

# define __aorp_end_protocol_pod_x1_y(DasIstImpl) \
	__myc_xconcat(__aorp_end_protocol_pod_x1_y,DasIstImpl)

#if 1
# define __aorp_end_protocol_pod_x1_y1(N,aProtocolNS) \
	__aorp_end_empty_protocol_pod_imp(N,aProtocolNS)
#else
# define __aorp_end_protocol_pod_x1_y1(N,aProtocolNS) \
	__aorp_end_empty_protocol_pod_imp(__aorpc_ns_protocol_c__,__aorpc_ns_protocol__)
#endif
# define __aorp_end_protocol_pod_x1_y0(N,aProtocolNS) \
	__aorp_end_empty_protocol_pod_itf(N,aProtocolNS)
# define __aorp_end_protocol_pod_x1_y__aorpc_impl(N,aProtocolNS) \
	__aorp_end_empty_protocol_pod_itf(N,aProtocolNS)


# define __aorp_end_protocol_pod_x0(N,aProtocolNS) \
	__aorp_end_protocol_pod_x0_y(__aorpc_impl)(N,aProtocolNS)

# define __aorp_end_protocol_pod_x0_y(DasIstImpl) \
	__myc_xconcat(__aorp_end_protocol_pod_x0_y,DasIstImpl)

#if 1
# define __aorp_end_protocol_pod_x0_y1(N,aProtocolNS) \
	__aorp_end_norm_protocol_pod_imp(N,aProtocolNS)
#else
# define __aorp_end_protocol_pod_x0_y1(N,aProtocolNS) \
	__aorp_end_norm_protocol_pod_imp(__aorpc_ns_protocol_c__,__aorpc_ns_protocol__)
#endif
# define __aorp_end_protocol_pod_x0_y0(N,aProtocolNS) \
	__aorp_end_norm_protocol_pod_itf(N,aProtocolNS)
# define __aorp_end_protocol_pod_x0_y__aorpc_impl(N,aProtocolNS) \
	__aorp_end_norm_protocol_pod_itf(N,aProtocolNS)

/* ----------------------------------------------------------------------------
 * end protocol
 */

# define __aorp_end_protocol \
	__aorp_end_protocol_(__aorpc_ns_protocol_c,__aorpc_ns_protocol)

# define __aorp_end_protocol_(N,aProtocolNS) \
	__aorp_end_protocol_y(__aorpc_impl)(N,aProtocolNS)

# define __aorp_end_protocol_y(DasIstImpl) \
	__myc_xconcat(__aorp_end_protocol_y,DasIstImpl)

#if 1
# define __aorp_end_protocol_y1(N,aProtocolNS) \
	__aorp_end_protocol_imp(N,aProtocolNS)
#else
# define __aorp_end_protocol_y1(N,aProtocolNS) \
	__aorp_end_protocol_imp(__aorpc_ns_protocol_c__,__aorpc_ns_protocol__)
#endif
# define __aorp_end_protocol_y0(N,aProtocolNS) \
	__aorp_end_protocol_itf(N,aProtocolNS)
# define __aorp_end_protocol_y__aorpc_impl(N,aProtocolNS) \
	__aorp_end_protocol_itf(N,aProtocolNS)

/* @} PROTOCOL pseudo-keywords */

/* ============================================================================
 * PROTOCOL OPERATION pseudo-keywords
 * @{
 */
# pragma mark -
# pragma mark [ PROTOCOL OPERATION pseudo-keywords ]
# pragma mark -

/* ----------------------------------------------------------------------------
 * declaration of a protocol (service) operation implementation
 */

# define __aorp_current_imop(aRoutine) \
	__aorp_imop(__aorpc_ns_protocol_c,__aorpc_ns_protocol,aRoutine)

# define __aorp_imop(N,aProtocolNS,aRoutine) \
	__aorp_imop_y(__aorpc_impl)(N,aProtocolNS,aRoutine)

# define __aorp_imop_y(DasIstImpl) \
	__myc_xconcat(__aorp_imop_y,DasIstImpl)

#if 1
# define __aorp_imop_y1(N,aProtocolNS,aRoutine) \
	__aorp_imop_imp(N,aProtocolNS,aRoutine)
#else
# define __aorp_imop_y1(N,aProtocolNS,aRoutine) \
	__aorp_imop_imp(__aorpc_ns_protocol_c__,__aorpc_ns_protocol__,aRoutine)
#endif
# define __aorp_imop_y0(N,aProtocolNS,aRoutine) \
	__aorp_imop_itf(N,aProtocolNS,aRoutine)
# define __aorp_imop_y__aorpc_impl(N,aProtocolNS,aRoutine) \
	__aorp_imop_itf(N,aProtocolNS,aRoutine)

/* ------------------------------------------------------------------------- */

# define __aorp_current_imop_rr(aRoutine,aRealRoutine) \
	__aorp_imop_rr(__aorpc_ns_protocol_c,__aorpc_ns_protocol,aRoutine,aRealRoutine)

# define __aorp_imop_rr(N,aProtocolNS,aRoutine,aRealRoutine) \
	__aorp_imop_rr_y(__aorpc_impl)(N,aProtocolNS,aRoutine,aRealRoutine)

# define __aorp_imop_rr_y(DasIstImpl) \
	__myc_xconcat(__aorp_imop_rr_y,DasIstImpl)

#if 1
# define __aorp_imop_rr_y1(N,aProtocolNS,aRoutine,aRealRoutine) \
	__aorp_imop_rr_imp(N,aProtocolNS,aRoutine,aRealRoutine)
#else
# define __aorp_imop_rr_y1(N,aProtocolNS,aRoutine,aRealRoutine) \
	__aorp_imop_rr_imp(__aorpc_ns_protocol_c__,__aorpc_ns_protocol__,aRoutine,aRealRoutine)
#endif
# define __aorp_imop_rr_y0(N,aProtocolNS,aRoutine,aRealRoutine) \
	__aorp_imop_rr_itf(N,aProtocolNS,aRoutine,aRealRoutine)
# define __aorp_imop_rr_y__aorpc_impl(N,aProtocolNS,aRoutine,aRealRoutine) \
	__aorp_imop_rr_itf(N,aProtocolNS,aRoutine,aRealRoutine)

/* ----------------------------------------------------------------------------
 * declaration of an unimplemented protocol (service) operation
 */

# define __aorp_current_imop_nil(aRoutine) \
	__aorp_imop_nil(__aorpc_ns_protocol_c,__aorpc_ns_protocol,aRoutine)

# define __aorp_imop_nil(N,aProtocolNS,aRoutine) \
	__aorp_imop_nil_y(__aorpc_impl)(N,aProtocolNS,aRoutine)

# define __aorp_imop_nil_y(DasIstImpl) \
	__myc_xconcat(__aorp_imop_nil_y,DasIstImpl)

#if 1
# define __aorp_imop_nil_y1(N,aProtocolNS,aRoutine) \
	__aorp_imop_nil_imp(N,aProtocolNS,aRoutine)
#else
# define __aorp_imop_nil_y1(N,aProtocolNS,aRoutine) \
	__aorp_imop_nil_imp(__aorpc_ns_protocol_c__,__aorpc_ns_protocol__,aRoutine)
#endif
# define __aorp_imop_nil_y0(N,aProtocolNS,aRoutine) \
	__aorp_imop_nil_itf(N,aProtocolNS,aRoutine)
# define __aorp_imop_nil_y__aorpc_impl(N,aProtocolNS,aRoutine) \
	__aorp_imop_nil_itf(N,aProtocolNS,aRoutine)

/* ----------------------------------------------------------------------------
 * declaration of a foreign protocol (service) operation implementation
 *
 * VARIANT 1
 */

# define __aorp_current_imop_f(aRoutine,K,aForeignProtocolNSids) \
	__aorp_imop_f(__aorpc_ns_protocol_c,__aorpc_ns_protocol,aRoutine,K,aForeignProtocolNSids)

# define __aorp_current_imop_nf(aRoutine,K,aForeignProtocolNSnms) \
	__aorp_current_imop_f(aRoutine,K,_A_ns_protocol_nm2id(aForeignProtocolNSnms))


# define __aorp_imop_f(N,aProtocolNS,aRoutine,K,aForeignProtocolNSids) \
	__aorp_imop_f_y(__aorpc_impl)(N,aProtocolNS,aRoutine,K,aForeignProtocolNSids)

# define __aorp_imop_f_y(DasIstImpl) \
	__myc_xconcat(__aorp_imop_f_y,DasIstImpl)

#if 1
# define __aorp_imop_f_y1(N,aProtocolNS,aRoutine,K,aForeignProtocolNSids) \
	__aorp_imop_f_imp(N,aProtocolNS,aRoutine,K,aForeignProtocolNSids)
#else
# define __aorp_imop_f_y1(N,aProtocolNS,aRoutine,K,aForeignProtocolNSids) \
	__aorp_imop_f_imp(__aorpc_ns_protocol_c__,__aorpc_ns_protocol__,aRoutine,K,aForeignProtocolNSids)
#endif
# define __aorp_imop_f_y0(N,aProtocolNS,aRoutine,K,aForeignProtocolNSids) \
	__aorp_imop_f_itf(N,aProtocolNS,aRoutine,K,aForeignProtocolNSids)
# define __aorp_imop_f_y__aorpc_impl(N,aProtocolNS,aRoutine,K,aForeignProtocolNSids) \
	__aorp_imop_f_itf(N,aProtocolNS,aRoutine,K,aForeignProtocolNSids)

/* ----------------------------------------------------------------------------
 * declaration of a foreign protocol (service) operation implementation
 *
 * VARIANT 2
 */

# define __aorp_current_imop_fr(aRoutine,K,aForeignProtocolNSids,aForeignRoutine) \
	__aorp_imop_fr(__aorpc_ns_protocol_c,__aorpc_ns_protocol,aRoutine,K,aForeignProtocolNSids,aForeignRoutine)

# define __aorp_current_imop_nfr(aRoutine,K,aForeignProtocolNSnms,aForeignRoutine) \
	__aorp_current_imop_fr(aRoutine,K,_A_ns_protocol_nm2id(aForeignProtocolNSnms),_A_opidof(aForeignRoutine,__myc_list_at(0,aForeignProtocolNSnms)))


# define __aorp_imop_fr(N,aProtocolNS,aRoutine,K,aForeignProtocolNSids,aForeignRoutine) \
	__aorp_imop_fr_y(__aorpc_impl)(N,aProtocolNS,aRoutine,K,aForeignProtocolNSids,aForeignRoutine)

# define __aorp_imop_fr_y(DasIstImpl) \
	__myc_xconcat(__aorp_imop_fr_y,DasIstImpl)

#if 1
# define __aorp_imop_fr_y1(N,aProtocolNS,aRoutine,K,aForeignProtocolNSids,aForeignRoutine) \
	__aorp_imop_fr_imp(N,aProtocolNS,aRoutine,K,aForeignProtocolNSids,aForeignRoutine)
#else
# define __aorp_imop_fr_y1(N,aProtocolNS,aRoutine,K,aForeignProtocolNSids,aForeignRoutine) \
	__aorp_imop_fr_imp(__aorpc_ns_protocol_c__,__aorpc_ns_protocol__,aRoutine,K,aForeignProtocolNSids,aForeignRoutine)
#endif
# define __aorp_imop_fr_y0(N,aProtocolNS,aRoutine,K,aForeignProtocolNSids,aForeignRoutine) \
	__aorp_imop_fr_itf(N,aProtocolNS,aRoutine,K,aForeignProtocolNSids,aForeignRoutine)
# define __aorp_imop_fr_y__aorpc_impl(N,aProtocolNS,aRoutine,K,aForeignProtocolNSids,aForeignRoutine) \
	__aorp_imop_fr_itf(N,aProtocolNS,aRoutine,K,aForeignProtocolNSids,aForeignRoutine)

/* ------------------------------------------------------------------------- */

/*
 * definition of a protocol (service) operation implementation
 */

#if 1
# define __aorp_current_impdef(aRoutine) \
	__aorp_impdef(__aorpc_ns_protocol_c,__aorpc_ns_protocol,aRoutine)
#else
# define __aorp_current_impdef(aRoutine) \
	__aorp_impdef(__aorpc_ns_protocol_c__,__aorpc_ns_protocol__,aRoutine)
#endif

# define __aorp_impdef(N,aProtocolNS,aRoutine) \
	bo_status_t __aorp_impname(N,aProtocolNS,aRoutine)

/*
 * reference to a protocol (service) operation implementation
 */

#if 1
# define __aorp_current_impref(aRoutine) \
	__aorp_impref(__aorpc_ns_protocol_c,__aorpc_ns_protocol,aRoutine)
#else
# define __aorp_current_impref(aRoutine) \
	__aorp_impref(__aorpc_ns_protocol_c__,__aorpc_ns_protocol__,aRoutine)
#endif

# define __aorp_impref(N,aProtocolNS,aRoutine) \
	((aorp_operation_fn) __aorp_impname(N,aProtocolNS,aRoutine))

/* ----------------------------------------------------------------------------
 * typedef of a protocol (service) operation implementation (function)
 */

# if __myc_require(prototypes)
#  define __aorp_imptypedef(aServiceName,aRoutine,aProto) \
	typedef /* int, ssize_t, off_t, bo_hash_t, bo_mismatch_t, bo_cset_t */ bo_status_t \
	(__myc_tcalltype__(mcall) *__aorp_imptypename(aServiceName,aRoutine)) aProto
# else
#  define __aorp_imptypedef(aServiceName,aRoutine,aProto) \
	typedef /* ssize_t, off_t, bo_hash_t, bo_mismatch_t */ bo_status_t \
	(__myc_tcalltype__(mcall) *__aorp_imptypename(aServiceName,aRoutine))()
# endif

/* aorp_<service>_<routine>_fn */
# define __aorp_imptypename(aServiceName,aRoutine) \
	__aorpc_list_convolution_ps(aorp_,2,(aServiceName,aRoutine),_fn)

/* ----------------------------------------------------------------------------
 * declaration of a protocol (service) operation implementation (function)
 */

# if __myc_require(prototypes)
#  define __aorp_impdecl(N,aProtocolNS,aRoutine,aProto) \
	__myc_flinkage_amod(private) bo_status_t \
	__myc_calltype__(mcall) \
	__aorp_impname(N,aProtocolNS,aRoutine) aProto
# else
#  define __aorp_impdecl(N,aProtocolNS,aRoutine,aProto) \
	__myc_flinkage_amod(private) bo_status_t \
	__myc_calltype__(mcall) \
	__aorp_impname(N,aProtocolNS,aRoutine)()
# endif

/*
 * name of a protocol (service) operation implementation (function)
 */

# define __aorp_impname(N,aProtocolNS,aRoutine) \
	__aorpc_list_convolution_ps(_im_,N,aProtocolNS,__myc_xconcat(_,aRoutine))

# define __aorp_start_impname(N,aProtocolNS,aRoutine) \
	__aorpc_list_convolution_ps(_AorpK_,N,aProtocolNS,__myc_xconcat3(_,aRoutine,_start))

# define __aorp_finish_impname(N,aProtocolNS,aRoutine) \
	__aorpc_list_convolution_ps(_AorpK_,N,aProtocolNS,__myc_xconcat3(_,aRoutine,_finish))

/* @} PROTOCOL OPERATION pseudo-keywords */

/* ============================================================================
 * SERVICE ELEMENT SET pseudo-keywords
 * @{
 */
# pragma mark -
# pragma mark [ SERVICE ELEMENT SET pseudo-keywords ]
# pragma mark -

# define __aorp_ses_tag(aName) _TAG_AORP_SES(aName)
# define __aorp_ses_typename(aName) _TYPENAME_AORP_SES(aName)

/*
 * 1. declare object (type instantiation)
 */
# define __aorp_ses_inst(aName,aSeCount) _STRUCT_AORP_SES(aName,aSeCount)

/*
 * 2. object reference
 */
# define __aorp_ses(aName) __aorp_ses_typename(aName)

/*
 * var definition
 */
# define __aorp_begin_ses(aName,aVarName) \
/* enum { \
	__aorpc_list_convolution_ps(_AorpK_,2,(aVarName,aName),_ses_start) = 1 \
}; */ \
__aorp_ses_typename(aName) aVarName = { \
	/* .hint_ = */        AorpK_HINT_SES, \
	/* .unused_ = */      0, \
	/* .self_alloc_ = */  BO_MALLOC_ZERO_INITIALIZER, \
	/* .lelem_ = */       AORP_SELIST_ELEM_ZERO_INITIALIZER, \
	/* .sec_ = */         __myc_namembs(aVarName.sev_) - 1, \
	/* .sev_ = */ {

/* ------------------------------------------------------------------------- */

# define __aorp_ses_entry(N,anObjectNS,M,aProtocolNS,aProtocolNSids,aPODFieldName,aReldist) \
	__myc_xconcat(__aorp_ses_entry,aReldist)(N,anObjectNS,M,aProtocolNS,aProtocolNSids,aPODFieldName,aReldist)

# define __aorp_ses_entry2 __aorp_ses_entry1
# define __aorp_ses_entry3 __aorp_ses_entry1

# define __aorp_ses_entry0(N,anObjectNS,M,aProtocolNS,aProtocolNSids,aPODFieldName,aReldist) \
		{ \
			/* .hint_ = */           AorpK_HINT_SE, \
			/* .unused_ = */         0, \
			/* .opsid_ = */          _A_opsoid_i_(M,aProtocolNSids), \
			/* .reldist_ = */        (aReldist), \
			/* .podoffs_ = */        __aorp_coboffsetof(N,anObjectNS,__myc_list_at(1,aProtocolNS),aPODFieldName), \
			/* .once_inited_ = */    false, \
			/* .ops_ = */            __aorp_opsref(M,aProtocolNS), \
			/* .frgn_opsid_ = */     {0} \
		}

# define __aorp_ses_entry1(N,anObjectNS,M,aProtocolNS,aProtocolNSids,aPODFieldName,aReldist) \
		{ \
			/* .hint_ = */           AorpK_HINT_SE, \
			/* .unused_ = */         0, \
			/* .opsid_ = */          _A_opsoid_i_(M,aProtocolNSids), \
			/* .reldist_ = */        (aReldist), \
			/* .podoffs_ = */        __aorp_xoboffsetof(N,anObjectNS,__myc_list_at(1,aProtocolNS),aPODFieldName), \
			/* .once_inited_ = */    false, \
			/* .ops_ = */            __aorp_opsref(M,aProtocolNS), \
			/* .frgn_opsid_ = */     {0} \
		}

/* ------------------------------------------------------------------------- */

# define __aorp_ses_entry_f(N,anObjectNS,M,aProtocolNS,aProtocolNSids,aPODFieldName,aReldist) \
	__myc_xconcat(__aorp_ses_entry_f,aReldist)(N,anObjectNS,M,aProtocolNS,aProtocolNSids,aPODFieldName,aReldist)

# define __aorp_ses_entry_f2 __aorp_ses_entry_f1
# define __aorp_ses_entry_f3 __aorp_ses_entry_f1

# define __aorp_ses_entry_f0(N,anObjectNS,M,aProtocolNS,aProtocolNSids,aPODFieldName,aReldist) \
		{ \
			/* .hint_ = */           AorpK_HINT_SE, \
			/* .unused_ = */         0, \
			/* .opsid_ = */          _A_opsoid_i_(M,aProtocolNSids), \
			/* .reldist_ = */        (aReldist), \
			/* .podoffs_ = */        __aorp_coboffsetof(N,anObjectNS,__myc_list_at(1,aProtocolNS),aPODFieldName), \
			/* .once_inited_ = */    false, \
			/* .ops_ = */            AORP_FOREIGN_OPS, \
			/* .frgn_opsid_ = */     _A_opsoid_i_(M,aProtocolNSids) \
		}

# define __aorp_ses_entry_f1(N,anObjectNS,M,aProtocolNS,aProtocolNSids,aPODFieldName,aReldist) \
		{ \
			/* .hint_ = */           AorpK_HINT_SE, \
			/* .unused_ = */         0, \
			/* .opsid_ = */          _A_opsoid_i_(M,aProtocolNSids), \
			/* .reldist_ = */        (aReldist), \
			/* .podoffs_ = */        __aorp_xoboffsetof(N,anObjectNS,__myc_list_at(1,aProtocolNS),aPODFieldName), \
			/* .once_inited_ = */    false, \
			/* .ops_ = */            AORP_FOREIGN_OPS, \
			/* .frgn_opsid_ = */     _A_opsoid_i_(M,aProtocolNSids) \
		}

/* ------------------------------------------------------------------------- */

# define __aorp_current_ses_entry(M,aProtocolNS,aProtocolNSids,aPODFieldName,aReldist) \
	__aorp_ses_entry(__aorpc_ns_object_c,__aorpc_ns_object,M,aProtocolNS,aProtocolNSids,aPODFieldName,aReldist)

# define __aorp_current_ses_entry_f(M,aProtocolNS,aProtocolNSids,aPODFieldName,aReldist) \
	__aorp_ses_entry_f(__aorpc_ns_object_c,__aorpc_ns_object,M,aProtocolNS,aProtocolNSids,aPODFieldName,aReldist)

/* ------------------------------------------------------------------------- */

# define __aorp_end_ses , \
		{0} \
	} \
}; \
enum { \
	__myc_xconcat3(_AorpK_,__LINE__,_ses_finish) = 1 \
}

/* @} SERVICE ELEMENT SET pseudo-keywords */

/******************************************************************************
 * Revision History:
 *		$Log$
 *
 *****************************************************************************/
