/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright (c) 2005-2007 V.Sokur
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

/*
 * Rtbtlink.h	(V.Sokur)
 * include/Bo/fundis/btreetmpl/Rtbtlink.h
 *
 * $Id$
 */

/******************************************************************************
 * %% BeginSection: includes
 */

/*
#include "Bo/fundis/Rtbtree.h"

#include "Bo/services/MIB/Services.h"
#include "Bo/Errors.h"
#include "Bo/Debug.h"
 */

/******************************************************************************
 * %% BeginSection: function definitions
 */
#pragma mark -
#pragma mark [ function definitions ]
#pragma mark -

/*
__MYC_BEGIN_CDECLS
 */

#ifdef NEED_MY_RTBTREE_LINKNODE_PROTO1
# undef NEED_MY_RTBTREE_LINKNODE_PROTO1

__myc_extern_inline__ bo_status_t
MY_RTBTREE_LinkNode(
#if __myc_require(prototypes)
	struct bo_rtbtree *aTree,
	struct bo_btree_node *aNode,
	int /* _Bool */ Force
	struct bo_btree_node **aNewFirstPtr,
	struct bo_btree_node **aNewLastPtr
#endif
	);

#endif /* NEED_MY_RTBTREE_LINKNODE_PROTO1 */

#ifdef NEED_MY_RTBTREE_LINKNODE_DECL1
# undef NEED_MY_RTBTREE_LINKNODE_DECL1

__myc_extern_inline__ bo_status_t
MY_RTBTREE_LinkNode(
#if __myc_require(prototypes)
	struct bo_rtbtree *aTree,
	struct bo_btree_node *aNode,
	int /* _Bool */ Force,
	struct bo_btree_node **aNewFirstPtr,
	struct bo_btree_node **aNewLastPtr
#else
	aTree, aNode, Force, aNewFirstPtr, aNewLastPtr
#endif
	)
#if !__myc_require(prototypes)
	struct bo_rtbtree *aTree;
	struct bo_btree_node *aNode;
	int /* _Bool */ Force;
	struct bo_btree_node **aNewFirstPtr, **aNewLastPtr;
#endif

# define NEED_MY_RTBTREE_LINKNODE_IMPL 1

#endif /* NEED_MY_RTBTREE_LINKNODE_DECL1 */


#ifdef NEED_MY_RTBTREE_LINKNODE_PROTO2
# undef NEED_MY_RTBTREE_LINKNODE_PROTO2

__myc_extern_inline__ bo_status_t
MY_RTBTREE_LinkNode(
#if __myc_require(prototypes)
	struct bo_rtbtree *aTree,
	bo_mismatch_t (*aComparator)(bo_pointer_t , bo_pointer_t ),
	struct bo_btree_node *aNode,
	int /* _Bool */ Force,
	struct bo_btree_node **aNewFirstPtr,
	struct bo_btree_node **aNewLastPtr
#endif
	);

#endif /* NEED_MY_RTBTREE_LINKNODE_PROTO2 */

#ifdef NEED_MY_RTBTREE_LINKNODE_DECL2
# undef NEED_MY_RTBTREE_LINKNODE_DECL2

__myc_extern_inline__ bo_status_t
MY_RTBTREE_LinkNode(
#if __myc_require(prototypes)
	struct bo_rtbtree *aTree,
	bo_mismatch_t (*aComparator)(bo_pointer_t , bo_pointer_t ),
	struct bo_btree_node *aNode,
	int /* _Bool */ Force,
	struct bo_btree_node **aNewFirstPtr,
	struct bo_btree_node **aNewLastPtr
#else
	aTree, aComparator, aNode, Force, aNewFirstPtr, aNewLastPtr
#endif
	)
#if !__myc_require(prototypes)
	struct bo_rtbtree const *aTree;
	bo_mismatch_t (*aComparator)(/* bo_pointer_t , bo_pointer_t */);
	struct bo_btree_node *aNode;
	int /* _Bool */ Force;
	struct bo_btree_node **aNewFirstPtr, **aNewLastPtr;
#endif

# define NEED_MY_RTBTREE_LINKNODE_IMPL 2

#endif /* NEED_MY_RTBTREE_LINKNODE_DECL2 */


#ifdef NEED_MY_RTBTREE_LINKNODE_PROTO3
# undef NEED_MY_RTBTREE_LINKNODE_PROTO3

__myc_extern_inline__ bo_status_t
MY_RTBTREE_LinkNode(
#if __myc_require(prototypes)
	struct bo_rtbtree *aTree,
	struct bo_btninfo_opv const *anInfoOpv,
	struct bo_btree_node *aNode,
	int /* _Bool */ Force,
	struct bo_btree_node **aNewFirstPtr,
	struct bo_btree_node **aNewLastPtr
#endif
	);

#endif /* NEED_MY_RTBTREE_LINKNODE_PROTO3 */

#ifdef NEED_MY_RTBTREE_LINKNODE_DECL3
# undef NEED_MY_RTBTREE_LINKNODE_DECL3

__myc_extern_inline__ bo_status_t
MY_RTBTREE_LinkNode(
#if __myc_require(prototypes)
	struct bo_rtbtree *aTree,
	struct bo_btninfo_opv const *anInfoOpv,
	struct bo_btree_node *aNode,
	int /* _Bool */ Force,
	struct bo_btree_node **aNewFirstPtr,
	struct bo_btree_node **aNewLastPtr
#else
	aTree, anInfoOpv, aNode, Force, aNewFirstPtr, aNewLastPtr
#endif
	)
#if !__myc_require(prototypes)
	struct bo_rtbtree const *aTree;
	struct bo_btninfo_opv const *anInfoOpv;
	struct bo_btree_node *aNode;
	int /* _Bool */ Force;
	struct bo_btree_node **aNewFirstPtr, **aNewLastPtr;
#endif

# define NEED_MY_RTBTREE_LINKNODE_IMPL 3

#endif /* NEED_MY_RTBTREE_LINKNODE_DECL3 */


#ifdef NEED_MY_RTBTREE_LINKNODE_IMPL

# if (3 == NEED_MY_RTBTREE_LINKNODE_IMPL)
#  undef MY_BTREE_Cmpuserinfo
#  define MY_BTREE_Cmpuserinfo(aNodeLhs,aNodeInfoLhs,aNodeRhs,anUserInfoRhs) \
	((*anInfoOpv->btni_compare)(aNodeInfoLhs,anUserInfoRhs))
#  define MY_BTREE_Cmpuserinfo_DEFINED
# else
# if (2 == NEED_MY_RTBTREE_LINKNODE_IMPL)
#  undef MY_BTREE_Cmpuserinfo
#  define MY_BTREE_Cmpuserinfo(aNodeLhs,aNodeInfoLhs,aNodeRhs,anUserInfoRhs) \
	((*aComparator)(aNodeInfoLhs,anUserInfoRhs))
#  define MY_BTREE_Cmpuserinfo_DEFINED
# else
#  ifndef MY_BTREE_Cmpuserinfo
#   define MY_BTREE_Cmpuserinfo No comparator defined!!!
#  endif
# endif /* 2 == NEED_MY_RTBTREE_LINKNODE_IMPL */
# endif /* 3 == NEED_MY_RTBTREE_LINKNODE_IMPL */

# ifndef MY_RTBTREE_Done
#  define MY_RTBTREE_Done(aNode) return (BoS_NORMAL)
# endif
# ifndef MY_RTBTREE_Exist
#  define MY_RTBTREE_Exist(aNode) return (BoS_ERR)
# endif

{
#if 1

	struct bo_btree_node *iter;
	BO_RTBTREE_LinkNode(struct bo_btree_node,btn_link,
		iter,aNode,aTree,Force,aNewFirstPtr,aNewLastPtr,
		{ _$0 = MY_BTREE_Cmpuserinfo(iter,iter->btn_info,aNode,aNode->btn_info); },
		{ MY_RTBTREE_Done(aNode); },
		{ MY_RTBTREE_Exist(NULL); }
	);
	/* NOTREACHED */
	assert(0);

#else
// @todo: remove
	struct bo_btree_node *head,
	                     *t,       /* temp-node */
	                     *parent;  /* inserted-node-parent */
	bo_btree_dir_t nodeDir;        /* parent-to-inserted-node-direction */
	bo_pointer_t userInfo;
	bo_mismatch_t mismatch;

	assert(NULL != aTree);
	assert(NULL != aNode);

	head = BO_BTREE_Head_(aTree);
	userInfo = aNode->btn_info;

	/*
	 * Lookup insert position
	 */

	parent = head;
	nodeDir = BoK_BTREE_LEFT_DIR;
	for (;;) {
		if (NULL == (t = BO_RTBTREE_NODE_XLink(parent,nodeDir))) {
			break;
			/* NOTREACHED */
		}
		mismatch = MY_BTREE_Cmpuserinfo(t,t->btn_info,aNode,userInfo);
		if (0 == mismatch && !Force) {
			/* exists */
			return (BoS_ERR);
			/* NOTREACHED */
		}
		nodeDir = BO_BTREE_UserinfoDir(mismatch);
		parent = t;
	}

	/*
	 * Link node with parent
	 */

	BO_RTBTREE_NODE_LLink(aNode) = NULL;
	BO_RTBTREE_NODE_RLink(aNode) = parent;
	*(u_int16_t *)(&aNode->btn_link[2]) = 0;
	aNode->btn_rbackref = 1;

	if (parent == head) {
		/* Empty tree */
		aNode->btn_last = aNode->btn_first = 1;
		BO_RTBTREE_NODE_LLink(parent) = aNode;
		if (NULL != aNewFirstPtr)
			*aNewFirstPtr = aNode;
		if (NULL != aNewLastPtr)
			*aNewLastPtr = aNode;
		return (BoS_NORMAL);
		/* NOTREACHED */
	}

	if (BoK_BTREE_LEFT_DIR == nodeDir) {
		if ((aNode->btn_first = parent->btn_first)) {
			parent->btn_first = 0;
			if (NULL != aNewFirstPtr)
				*aNewFirstPtr = aNode;
		}
		BO_RTBTREE_NODE_LLink(parent) = aNode;
		return (BoS_NORMAL);
		/* NOTREACHED */
	}

	/* (BoK_BTREE_RIGHT_DIR == nodeDir) */
	{
		BO_RTBTREE_NODE_RLink(aNode) = BO_RTBTREE_NODE_RLink(parent);
		if ((aNode->btn_last = parent->btn_last)) {
			parent->btn_last = 0;
			if (NULL != aNewLastPtr)
				*aNewLastPtr = aNode;
		}
		BO_RTBTREE_NODE_RLink(parent) = aNode;
		parent->btn_rbackref = 0;
		return (BoS_NORMAL);
		/* NOTREACHED */
	}
#endif
}

# undef MY_RTBTREE_Done
# undef MY_RTBTREE_Exist

# ifdef MY_BTREE_Cmpuserinfo_DEFINED
#  undef MY_BTREE_Cmpuserinfo_DEFINED
#  undef MY_BTREE_Cmpuserinfo
# endif

# undef NEED_MY_RTBTREE_LINKNODE_IMPL
#endif /* NEED_MY_RTBTREE_LINKNODE_IMPL */

/*
__MYC_END_CDECLS
 */

/******************************************************************************
 * Revision History:
 *		$Log$
 *
 *****************************************************************************/
