/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright (c) 2005-2007 V.Sokur
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

/*
 * Rtbtlink_b.h	(V.Sokur)
 * include/Bo/fundis/btreetmpl/Rtbtlink_b.h
 *
 * $Id$
 */

/******************************************************************************
 * %% BeginSection: includes
 */

/*
#include "Bo/fundis/Rtbtree.h"

#include "Bo/services/MIB/Services.h"
#include "Bo/Errors.h"
#include "Bo/Debug.h"
 */

/******************************************************************************
 * %% BeginSection: function definitions
 */
#pragma mark -
#pragma mark [ function definitions ]
#pragma mark -

/*
__MYC_BEGIN_CDECLS
 */

#ifdef NEED_MY_RTBTREE_LINKNODE_B_PROTO1
# undef NEED_MY_RTBTREE_LINKNODE_B_PROTO1

__myc_extern_inline__ bo_status_t
MY_RTBTREE_LinkNode_b(
#if __myc_require(prototypes)
	struct bo_rtbtree *aTree,
	struct bo_btree_node *aNode,
	int /* _Bool */ Force
	struct bo_btree_node **aNewFirstPtr,
	struct bo_btree_node **aNewLastPtr
#endif
	);

#endif /* NEED_MY_RTBTREE_LINKNODE_B_PROTO1 */

#ifdef NEED_MY_RTBTREE_LINKNODE_B_DECL1
# undef NEED_MY_RTBTREE_LINKNODE_B_DECL1

__myc_extern_inline__ bo_status_t
MY_RTBTREE_LinkNode_b(
#if __myc_require(prototypes)
	struct bo_rtbtree *aTree,
	struct bo_btree_node *aNode,
	int /* _Bool */ Force,
	struct bo_btree_node **aNewFirstPtr,
	struct bo_btree_node **aNewLastPtr
#else
	aTree, aNode, Force, aNewFirstPtr, aNewLastPtr
#endif
	)
#if !__myc_require(prototypes)
	struct bo_rtbtree *aTree;
	struct bo_btree_node *aNode;
	int /* _Bool */ Force;
	struct bo_btree_node **aNewFirstPtr, **aNewLastPtr;
#endif

# define NEED_MY_RTBTREE_LINKNODE_B_IMPL 1

#endif /* NEED_MY_RTBTREE_LINKNODE_B_DECL1 */


#ifdef NEED_MY_RTBTREE_LINKNODE_B_PROTO2
# undef NEED_MY_RTBTREE_LINKNODE_B_PROTO2

__myc_extern_inline__ bo_status_t
MY_RTBTREE_LinkNode_b(
#if __myc_require(prototypes)
	struct bo_rtbtree *aTree,
	bo_mismatch_t (*aComparator)(bo_pointer_t , bo_pointer_t ),
	struct bo_btree_node *aNode,
	int /* _Bool */ Force,
	struct bo_btree_node **aNewFirstPtr,
	struct bo_btree_node **aNewLastPtr
#endif
	);

#endif /* NEED_MY_RTBTREE_LINKNODE_B_PROTO2 */

#ifdef NEED_MY_RTBTREE_LINKNODE_B_DECL2
# undef NEED_MY_RTBTREE_LINKNODE_B_DECL2

__myc_extern_inline__ bo_status_t
MY_RTBTREE_LinkNode_b(
#if __myc_require(prototypes)
	struct bo_rtbtree *aTree,
	bo_mismatch_t (*aComparator)(bo_pointer_t , bo_pointer_t ),
	struct bo_btree_node *aNode,
	int /* _Bool */ Force,
	struct bo_btree_node **aNewFirstPtr,
	struct bo_btree_node **aNewLastPtr
#else
	aTree, aComparator, aNode, Force, aNewFirstPtr, aNewLastPtr
#endif
	)
#if !__myc_require(prototypes)
	struct bo_rtbtree const *aTree;
	bo_mismatch_t (*aComparator)(/* bo_pointer_t , bo_pointer_t */);
	struct bo_btree_node *aNode;
	int /* _Bool */ Force;
	struct bo_btree_node **aNewFirstPtr, **aNewLastPtr;
#endif

# define NEED_MY_RTBTREE_LINKNODE_B_IMPL 2

#endif /* NEED_MY_RTBTREE_LINKNODE_B_DECL2 */


#ifdef NEED_MY_RTBTREE_LINKNODE_B_PROTO3
# undef NEED_MY_RTBTREE_LINKNODE_B_PROTO3

__myc_extern_inline__ bo_status_t
MY_RTBTREE_LinkNode_b(
#if __myc_require(prototypes)
	struct bo_rtbtree *aTree,
	struct bo_btninfo_opv const *anInfoOpv,
	struct bo_btree_node *aNode,
	int /* _Bool */ Force,
	struct bo_btree_node **aNewFirstPtr,
	struct bo_btree_node **aNewLastPtr
#endif
	);

#endif /* NEED_MY_RTBTREE_LINKNODE_B_PROTO3 */

#ifdef NEED_MY_RTBTREE_LINKNODE_B_DECL3
# undef NEED_MY_RTBTREE_LINKNODE_B_DECL3

__myc_extern_inline__ bo_status_t
MY_RTBTREE_LinkNode_b(
#if __myc_require(prototypes)
	struct bo_rtbtree *aTree,
	struct bo_btninfo_opv const *anInfoOpv,
	struct bo_btree_node *aNode,
	int /* _Bool */ Force,
	struct bo_btree_node **aNewFirstPtr,
	struct bo_btree_node **aNewLastPtr
#else
	aTree, anInfoOpv, aNode, Force, aNewFirstPtr, aNewLastPtr
#endif
	)
#if !__myc_require(prototypes)
	struct bo_rtbtree const *aTree;
	struct bo_btninfo_opv const *anInfoOpv;
	struct bo_btree_node *aNode;
	int /* _Bool */ Force;
	struct bo_btree_node **aNewFirstPtr, **aNewLastPtr;
#endif

# define NEED_MY_RTBTREE_LINKNODE_B_IMPL 3

#endif /* NEED_MY_RTBTREE_LINKNODE_B_DECL3 */


#ifdef NEED_MY_RTBTREE_LINKNODE_B_IMPL

# if (3 == NEED_MY_RTBTREE_LINKNODE_B_IMPL)
#  undef MY_BTREE_Cmpuserinfo
#  define MY_BTREE_Cmpuserinfo(aNodeLhs,aNodeInfoLhs,aNodeRhs,anUserInfoRhs) \
	((*anInfoOpv->btni_compare)(aNodeInfoLhs,anUserInfoRhs))
#  define MY_BTREE_Cmpuserinfo_DEFINED
# else
# if (2 == NEED_MY_RTBTREE_LINKNODE_B_IMPL)
#  undef MY_BTREE_Cmpuserinfo
#  define MY_BTREE_Cmpuserinfo(aNodeLhs,aNodeInfoLhs,aNodeRhs,anUserInfoRhs) \
	((*aComparator)(aNodeInfoLhs,anUserInfoRhs))
#  define MY_BTREE_Cmpuserinfo_DEFINED
# else
#  ifndef MY_BTREE_Cmpuserinfo
#   define MY_BTREE_Cmpuserinfo No comparator defined!!!
#  endif
# endif /* 2 == NEED_MY_RTBTREE_LINKNODE_B_IMPL */
# endif /* 3 == NEED_MY_RTBTREE_LINKNODE_B_IMPL */

# ifndef MY_RTBTREE_Done
#  define MY_RTBTREE_Done(aNode) return (BoS_NORMAL)
# endif
# ifndef MY_RTBTREE_Exist
#  define MY_RTBTREE_Exist(aNode) return (BoS_ERR)
# endif
# ifndef MY_RTBTREE_Himax
#  define MY_RTBTREE_Himax(aNode) return (BoS_ERR)
# endif

{
#if 1

	struct bo_btree_node *iter;
	BO_RTBTREE_LinkNode_b(struct bo_btree_node,btn_link,
		iter,aNode,aTree,Force,aNewFirstPtr,aNewLastPtr,
		{ _$0 = MY_BTREE_Cmpuserinfo(iter,iter->btn_info,aNode,aNode->btn_info); },
		{ MY_RTBTREE_Done(aNode); },
		{ MY_RTBTREE_Exist(NULL); },
		{ MY_RTBTREE_Himax(NULL); }
	);
	/* NOTREACHED */
	assert(0);

#else
// @todo: remove
	struct bo_btree_node *head,
	                     *t,       /* temp-node */
	                     *parent,      /* inserted-node-parent */
	                     *rebalance,   /* rebalance-node */
	                     *rebalParent, /* rebalance-parent-node */
	                     *rebalChild,  /* rebalance-child-node */
	                     *rebalChild2; /* rebalance-child-child-node */
	bo_btree_dir_t nodeDir,            /* parent-to-inserted-node-direction */
	               rebalDir,           /* parent-to-rebalance-direction */
	               direction,          /* rebalance-down-direction */
	               tdir;               /* temp-direction */
	bo_pointer_t userInfo;
	bo_mismatch_t mismatch;
	int factor;
	size_t high;                       /* tree-high */

	assert(NULL != aTree);
	assert(NULL != aNode);

	head = (struct bo_btree_node *)BO_BTREE_Head(aTree);
	userInfo = aNode->btn_info;

	/*
	 * Lookup insert position
	 */

	high = 0;
	parent = head;
	direction = nodeDir = BoK_BTREE_LEFT_DIR;
	rebalParent = parent;
	rebalDir = nodeDir;
	rebalance = t = BO_RTBTREE_NODE_Link(parent,nodeDir);
	if (NULL != t) {
		mismatch = MY_BTREE_Cmpuserinfo(t,t->btn_info,aNode,userInfo);
		if (0 == mismatch && !Force) {
			/* exists */
			return (BoS_ERR);
			/* NOTREACHED */
		}
		direction = nodeDir = BO_BTREE_UserinfoDir(mismatch);

		for (;;) {
			parent = t;
			if (NULL == (t = BO_RTBTREE_NODE_XLink(parent,nodeDir))) {
				break;
				/* NOTREACHED */
			}
			if (BoL_BTREE_HIGH_MAX == ++high) {
				/* level limit exceeded */
				return (BoS_ERR);
				/* NOTREACHED */
			}

			mismatch = MY_BTREE_Cmpuserinfo(t,t->btn_info,aNode,userInfo);
			if (0 == mismatch && !Force) {
				/* exists */
				return (BoS_ERR);
				/* NOTREACHED */
			}
			tdir = BO_BTREE_UserinfoDir(mismatch);

			if (BO_BTREE_NODE_IsUnbalanced(t)) {
				rebalParent = parent;
				rebalDir = nodeDir;
				rebalance = t;
				direction = tdir;
			}
			nodeDir = tdir;
		}
	}

	/*
	 * Link node with parent
	 */

	BO_RTBTREE_NODE_LLink(aNode) = NULL;
	BO_RTBTREE_NODE_RLink(aNode) = parent;
	*(u_int16_t *)(&aNode->btn_link[2]) = 0;
	aNode->btn_rbackref = 1;

	if (parent == head) {
		/* The tree is empty. */
		aNode->btn_last = aNode->btn_first = 1;
		BO_RTBTREE_NODE_LLink(parent) = aNode;
		if (NULL != aNewFirstPtr)
			*aNewFirstPtr = aNode;
		if (NULL != aNewLastPtr)
			*aNewLastPtr = aNode;
		return (BoS_NORMAL);
		/* NOTREACHED */
	}

	if (BoK_BTREE_LEFT_DIR == nodeDir) {
		if ((aNode->btn_first = parent->btn_first)) {
			parent->btn_first = 0;
			if (NULL != aNewFirstPtr)
				*aNewFirstPtr = aNode;
		}
		BO_RTBTREE_NODE_LLink(parent) = aNode;
	}
	else {
		BO_RTBTREE_NODE_RLink(aNode) = BO_RTBTREE_NODE_RLink(parent);
		if ((aNode->btn_last = parent->btn_last)) {
			parent->btn_last = 0;
			if (NULL != aNewLastPtr)
				*aNewLastPtr = aNode;
		}
		BO_RTBTREE_NODE_RLink(parent) = aNode;
		parent->btn_rbackref = 0;
	}

	/*
	 * Correct node's balance factors from rebalance-node to inserted-node.
	 */

	factor = ((BoK_BTREE_LEFT_DIR == direction) ? -1 : +1);
	rebalChild = BO_RTBTREE_NODE_Link(rebalance,direction);

	assert(((BoK_BTREE_LEFT_DIR == direction) && (NULL != rebalChild)) ||
				!BO_BTREE_NODE_IsRBackref(rebalance));

	for (t = rebalChild; aNode != t; t = BO_RTBTREE_NODE_Link(t,tdir)) {
		mismatch = MY_BTREE_Cmpuserinfo(t,t->btn_info,aNode,userInfo);
		tdir = BO_BTREE_UserinfoDir(mismatch);
		t->btn_balance = ((BoK_BTREE_LEFT_DIR == tdir) ? -1 : 1);
	}

	/*
	 * Rebalancing
	 */

	if (0 == rebalance->btn_balance) {
		/* In this case the tree grows.
		   We do not need to do something longer. */
		rebalance->btn_balance = factor;
		return (BoS_NORMAL);
		/* NOTREACHED */
	}

	if (-factor == rebalance->btn_balance) {
		/* The tree becomes more balanced. And the tree's high is unchanged.
		   We do not need to do something longer. */
		rebalance->btn_balance = 0;
		return (BoS_NORMAL);
		/* NOTREACHED */
	}

	/*
	 * The tree becomes more unbalanced.
	 */
	if (factor == rebalChild->btn_balance) {
		/* In this case the simple rotation is needed to be performed. */
		if (BoK_BTREE_LEFT_DIR == direction)
			BO_RTBTREE_RotateRight(rebalance,rebalChild);
		else
			BO_RTBTREE_RotateLeft(rebalance,rebalChild);
		rebalance->btn_balance = 0;
	}
	else {
		/* In this case the double-ply rotation is needed to be performed. */
		rebalChild2 = BO_RTBTREE_NODE_Link(rebalChild,!direction);

		if (BoK_BTREE_LEFT_DIR == direction) {
			BO_RTBTREE_RotateLeft(rebalChild,rebalChild2);
			BO_RTBTREE_RotateRight(rebalance,rebalChild2);
		}
		else {
			BO_RTBTREE_RotateRight(rebalChild,rebalChild2);
			BO_RTBTREE_RotateLeft(rebalance,rebalChild2);
		}

		rebalance->btn_balance = rebalChild->btn_balance = 0;
		if (factor == rebalChild2->btn_balance)
			rebalance->btn_balance = -factor;
		else if (-factor == rebalChild2->btn_balance)
			rebalChild->btn_balance = factor;

		rebalChild = rebalChild2;
	} /* (factor != rebalChild->btn_balance) */
	rebalChild->btn_balance = 0;

	BO_RTBTREE_NODE_Link(rebalParent,rebalDir) = rebalChild;
	return (BoS_NORMAL);
#endif
}

# undef MY_RTBTREE_Done
# undef MY_RTBTREE_Exist

# ifdef MY_BTREE_Cmpuserinfo_DEFINED
#  undef MY_BTREE_Cmpuserinfo_DEFINED
#  undef MY_BTREE_Cmpuserinfo
# endif

# undef NEED_MY_RTBTREE_LINKNODE_B_IMPL
#endif /* NEED_MY_RTBTREE_LINKNODE_B_IMPL */

/*
__MYC_END_CDECLS
 */

/******************************************************************************
 * Revision History:
 *		$Log$
 *
 *****************************************************************************/
