/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright (c) 2005-2007 V.Sokur
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

/*
 * Rtbtunlink.h	(V.Sokur)
 * include/Bo/fundis/btreetmpl/Rtbtunlink.h
 *
 * $Id$
 */

/******************************************************************************
 * %% BeginSection: includes
 */

/*
#include "Bo/fundis/Rtbtree.h"

#include "Bo/services/MIB/Services.h"
#include "Bo/Errors.h"
#include "Bo/Debug.h"
 */

/******************************************************************************
 * %% BeginSection: function definitions
 */
#pragma mark -
#pragma mark [ function definitions ]
#pragma mark -

/*
__MYC_BEGIN_CDECLS
 */

#ifdef NEED_MY_RTBTREE_UNLINKNODE_PROTO1
# undef NEED_MY_RTBTREE_UNLINKNODE_PROTO1

__myc_extern_inline__ struct bo_btree_node * /* = NULL */
MY_RTBTREE_UnlinkNode(
#if __myc_require(prototypes)
	struct bo_btree *aTree,
	bo_pointer_t aRqInfo,
	struct bo_btree_node **aNewFirstPtr,
	struct bo_btree_node **aNewLastPtr
#endif
	);

#endif /* NEED_MY_RTBTREE_UNLINKNODE_PROTO1 */

#ifdef NEED_MY_RTBTREE_UNLINKNODE_DECL1
# undef NEED_MY_RTBTREE_UNLINKNODE_DECL1

__myc_extern_inline__ struct bo_btree_node * /* = NULL */
MY_RTBTREE_UnlinkNode(
#if __myc_require(prototypes)
	struct bo_btree *aTree,
	bo_pointer_t aRqInfo,
	struct bo_btree_node **aNewFirstPtr,
	struct bo_btree_node **aNewLastPtr
#else
	aTree, aRqInfo, aNewFirstPtr, aNewLastPtr
#endif
	)
#if !__myc_require(prototypes)
	struct bo_btree *aTree;
	bo_pointer_t aRqInfo;
	struct bo_btree_node **aNewFirstPtr, **aNewLastPtr;
#endif

# define NEED_MY_RTBTREE_UNLINKNODE_IMPL 1

#endif /* NEED_MY_RTBTREE_UNLINKNODE_DECL1 */


#ifdef NEED_MY_RTBTREE_UNLINKNODE_PROTO2
# undef NEED_MY_RTBTREE_UNLINKNODE_PROTO2

__myc_extern_inline__ struct bo_btree_node * /* = NULL */
MY_RTBTREE_UnlinkNode(
#if __myc_require(prototypes)
	struct bo_btree *aTree,
	bo_mismatch_t (*aComparator)(bo_pointer_t , bo_pointer_t ),
	bo_pointer_t aRqInfo,
	struct bo_btree_node **aNewFirstPtr,
	struct bo_btree_node **aNewLastPtr
#endif
	);

#endif /* NEED_MY_RTBTREE_UNLINKNODE_PROTO2 */

#ifdef NEED_MY_RTBTREE_UNLINKNODE_DECL2
# undef NEED_MY_RTBTREE_UNLINKNODE_DECL2

__myc_extern_inline__ struct bo_btree_node * /* = NULL */
MY_RTBTREE_UnlinkNode(
#if __myc_require(prototypes)
	struct bo_btree *aTree,
	bo_mismatch_t (*aComparator)(bo_pointer_t , bo_pointer_t ),
	bo_pointer_t aRqInfo,
	struct bo_btree_node **aNewFirstPtr,
	struct bo_btree_node **aNewLastPtr
#else
	aTree, aComparator, aRqInfo, aNewFirstPtr, aNewLastPtr
#endif
	)
#if !__myc_require(prototypes)
	struct bo_btree const *aTree;
	bo_mismatch_t (*aComparator)(/* bo_pointer_t , bo_pointer_t */);
	bo_pointer_t aRqInfo;
	struct bo_btree_node **aNewFirstPtr, **aNewLastPtr;
#endif

# define NEED_MY_RTBTREE_UNLINKNODE_IMPL 2

#endif /* NEED_MY_RTBTREE_UNLINKNODE_DECL2 */


#ifdef NEED_MY_RTBTREE_UNLINKNODE_PROTO3
# undef NEED_MY_RTBTREE_UNLINKNODE_PROTO3

__myc_extern_inline__ struct bo_btree_node * /* = NULL */
MY_RTBTREE_UnlinkNode(
#if __myc_require(prototypes)
	struct bo_btree const *aTree,
	struct bo_btninfo_opv const *anInfoOpv,
	bo_pointer_t aRqInfo,
	struct bo_btree_node **aNewFirstPtr,
	struct bo_btree_node **aNewLastPtr
#endif
	);

#endif /* NEED_MY_RTBTREE_UNLINKNODE_PROTO3 */

#ifdef NEED_MY_RTBTREE_UNLINKNODE_DECL3
# undef NEED_MY_RTBTREE_UNLINKNODE_DECL3

__myc_extern_inline__ struct bo_btree_node * /* = NULL */
MY_RTBTREE_UnlinkNode(
#if __myc_require(prototypes)
	struct bo_btree const *aTree,
	struct bo_btninfo_opv const *anInfoOpv,
	bo_pointer_t aRqInfo,
	struct bo_btree_node **aNewFirstPtr,
	struct bo_btree_node **aNewLastPtr
#else
	aTree, anInfoOpv, aRqInfo, aNewFirstPtr, aNewLastPtr
#endif
	)
#if !__myc_require(prototypes)
	struct bo_btree const *aTree;
	struct bo_btninfo_opv const *anInfoOpv;
	bo_pointer_t aRqInfo;
	struct bo_btree_node **aNewFirstPtr, **aNewLastPtr;
#endif

# define NEED_MY_RTBTREE_UNLINKNODE_IMPL 3

#endif /* NEED_MY_RTBTREE_UNLINKNODE_DECL3 */


#ifdef NEED_MY_RTBTREE_UNLINKNODE_IMPL

# if (3 == NEED_MY_RTBTREE_UNLINKNODE_IMPL)
#  undef MY_BTREE_Cmpuserinfo
#  define MY_BTREE_Cmpuserinfo(aNodeLhs,aNodeInfoLhs,aNodeRhs,anUserInfoRhs) \
	((*anInfoOpv->btni_compare)(aNodeInfoLhs,anUserInfoRhs))
#  define MY_BTREE_Cmpuserinfo_DEFINED
# else
# if (2 == NEED_MY_RTBTREE_UNLINKNODE_IMPL)
#  undef MY_BTREE_Cmpuserinfo
#  define MY_BTREE_Cmpuserinfo(aNodeLhs,aNodeInfoLhs,aNodeRhs,anUserInfoRhs) \
	((*aComparator)(aNodeInfoLhs,anUserInfoRhs))
#  define MY_BTREE_Cmpuserinfo_DEFINED
# else
#  ifndef MY_BTREE_Cmpuserinfo
#   define MY_BTREE_Cmpuserinfo No comparator defined!!!
#  endif
# endif /* 2 == NEED_MY_RTBTREE_UNLINKNODE_IMPL */
# endif /* 3 == NEED_MY_RTBTREE_UNLINKNODE_IMPL */

# ifndef MY_RTBTREE_Done
#  define MY_RTBTREE_Done(aNode) return (aNode)
# endif
# ifndef MY_RTBTREE_NotFound
#  define MY_RTBTREE_NotFound(aNode) return (aNode)
# endif

{
#if 1

	struct bo_btree_node *iter;
	BO_RTBTREE_UnlinkNode(struct bo_btree_node,btn_link,
		iter,aTree,aNewFirstPtr,aNewLastPtr,
		{ _$0 = MY_BTREE_Cmpuserinfo(iter,iter->btn_info,NULL,aRqInfo); },
		{ MY_RTBTREE_Done(iter); },
		{ MY_RTBTREE_NotFound(NULL); }
	);
	/* NOTREACHED */
	assert(0);

#else
// @todo: remove
	struct bo_btree_node *head,
	                     *t,           /* temp-node */
	                     *node,        /* removed-node */
	                     *parent,      /* removed-node-parent */
	                     *right,       /* node-right-link */
	                     *left,        /* node-left-link */
	                     *r,           /* replace-node */
	                     *q;           /* replace-node-parent */
	bo_btree_dir_t direction;          /* parent-to-removed-node-direction */
	bo_mismatch_t mismatch;

	assert(NULL != aTree);
	assert(NULL != aRqInfo);

	head = (struct bo_btree_node *)BO_BTREE_Head(aTree);

	/*
	 * Lookup node with info
	 */

	parent = head;
	direction = BoK_BTREE_LEFT_DIR;
	for (;;) {
		if (NULL == (node = BO_RTBTREE_NODE_XLink(parent,direction))) {
			/* not found */
			return (node);
			/* NOTREACHED */
		}
		mismatch = MY_BTREE_Cmpuserinfo(node,node->btn_info,NULL,aRqInfo);
		if (0 == mismatch) {
			break;
			/* NOTREACHED */
		}
		direction = ((mismatch <= 0) ? BoK_BTREE_RIGHT_DIR : BoK_BTREE_LEFT_DIR);
		parent = node;
	}

	/*
	 * Unlink node
	 */

	if (parent == head && BO_RTBTREE_NODE_IsLeaf(node)) {
		/* The tree becomes empty. */
		BO_RTBTREE_NODE_LLink(head) = NULL;
		BO_RTBTREE_NODE_RLink(head) = head;
		if (NULL != aNewFirstPtr)
			*aNewFirstPtr = NULL;
		if (NULL != aNewLastPtr)
			*aNewLastPtr = NULL;
		return (node);
		/* NOTREACHED */
	}

	left = BO_RTBTREE_NODE_LLink(node);
	right = BO_RTBTREE_NODE_RLink(node);

	if (BO_BTREE_NODE_IsRBackref(node)) {
		/* A removed node has not right child. */
		r = parent;
		if (BoK_BTREE_RIGHT_DIR == direction && NULL == left) {
			BO_RTBTREE_NODE_RLink(parent) = right;
			parent->btn_rbackref = 1;
		}
		else {
			if (NULL != (BO_RTBTREE_NODE_Link(parent,direction) = left)) {
				r = left;
				do {
					t = left;
					left = BO_RTBTREE_NODE_RLink(t);
				}
				while (!BO_BTREE_NODE_IsRBackref(t));
				BO_RTBTREE_NODE_RLink(t) = right;
			}
		}
	}
	else {
		/* A removed node has right child. */
		r = right;
		if (NULL != (t = BO_RTBTREE_NODE_LLink(r))) {
			do {
				q = r;
				r = t;
			}
			while (NULL != (t = BO_RTBTREE_NODE_LLink(r)));
			if (q == (t = BO_RTBTREE_NODE_RLink(r))) {
				assert(BO_BTREE_NODE_IsRBackref(r));
				t = NULL;
			}
			BO_RTBTREE_NODE_LLink(q) = t;
			BO_RTBTREE_NODE_RLink(r) = right;
			r->btn_rbackref = 0;
		}
		BO_RTBTREE_NODE_Link(parent,direction) = r;
		if (NULL != (BO_RTBTREE_NODE_LLink(r) = left)) {
			do {
				t = left;
				left = BO_RTBTREE_NODE_RLink(t);
			}
			while (!BO_BTREE_NODE_IsRBackref(t));
			BO_RTBTREE_NODE_RLink(t) = r;
		}
	}

	if (node->btn_first) {
		r->btn_first = node->btn_first;
		if (NULL != aNewFirstPtr)
			*aNewFirstPtr = r;
	}
	if (node->btn_last) {
		r->btn_last = node->btn_last;
		if (NULL != aNewLastPtr)
			*aNewLastPtr = r;
	}

	return (node);
#endif
}

# undef MY_RTBTREE_Done
# undef MY_RTBTREE_NotFound

# ifdef MY_BTREE_Cmpuserinfo_DEFINED
#  undef MY_BTREE_Cmpuserinfo_DEFINED
#  undef MY_BTREE_Cmpuserinfo
# endif

# undef NEED_MY_RTBTREE_UNLINKNODE_IMPL
#endif /* NEED_MY_RTBTREE_UNLINKNODE_IMPL */

/*
__MYC_END_CDECLS
 */

/******************************************************************************
 * Revision History:
 *		$Log$
 *
 *****************************************************************************/
