/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright (c) 2005-2007 V.Sokur
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

/*
 * Srtbtins.h	(V.Sokur)
 * include/Bo/fundis/btreetmpl/Srtbtins.h
 *
 * $Id$
 */

/******************************************************************************
 * %% BeginSection: includes
 */

/*
#include "Bo/fundis/Srtbtree.h"

#include "Bo/services/MIB/Services.h"
#include "Bo/Errors.h"
#include "Bo/Debug.h"
 */

/******************************************************************************
 * %% BeginSection: function definitions
 */
#pragma mark -
#pragma mark [ function definitions ]
#pragma mark -

/*
__MYC_BEGIN_CDECLS
 */

#ifdef NEED_MY_SRTBTREE_INSERTNODE_PROTO1
# undef NEED_MY_SRTBTREE_INSERTNODE_PROTO1

__myc_extern_inline__ bo_srtbtree_iterator /* = NULL */
MY_SRTBTREE_InsertNode(
#if __myc_require(prototypes)
	struct bo_srtbtree *aTree,
	struct bo_srtbtree_node *aNode,
	int /* _Bool */ Force
#endif
	);

#endif /* NEED_MY_SRTBTREE_INSERTNODE_PROTO1 */

#ifdef NEED_MY_SRTBTREE_INSERTNODE_DECL1
# undef NEED_MY_SRTBTREE_INSERTNODE_DECL1

__myc_extern_inline__ bo_srtbtree_iterator /* = NULL */
MY_SRTBTREE_InsertNode(
#if __myc_require(prototypes)
	struct bo_srtbtree *aTree,
	struct bo_srtbtree_node *aNode,
	int /* _Bool */ Force
#else
	aTree, aNode, Force
#endif
	)
#if !__myc_require(prototypes)
	struct bo_srtbtree *aTree;
	struct bo_srtbtree_node *aNode;
	int /* _Bool */ Force;
#endif

# define NEED_MY_SRTBTREE_INSERTNODE_IMPL 1

#endif /* NEED_MY_SRTBTREE_INSERTNODE_DECL1 */


#ifdef NEED_MY_SRTBTREE_INSERTNODE_PROTO2
# undef NEED_MY_SRTBTREE_INSERTNODE_PROTO2

__myc_extern_inline__ bo_srtbtree_iterator /* = NULL */
MY_SRTBTREE_InsertNode(
#if __myc_require(prototypes)
	struct bo_srtbtree *aTree,
	bo_mismatch_t (*aComparator)(bo_pointer_t , bo_pointer_t ),
	struct bo_srtbtree_node *aNode,
	int /* _Bool */ Force
#endif
	);

#endif /* NEED_MY_SRTBTREE_INSERTNODE_PROTO2 */

#ifdef NEED_MY_SRTBTREE_INSERTNODE_DECL2
# undef NEED_MY_SRTBTREE_INSERTNODE_DECL2

__myc_extern_inline__ bo_srtbtree_iterator /* = NULL */
MY_SRTBTREE_InsertNode(
#if __myc_require(prototypes)
	struct bo_srtbtree *aTree,
	bo_mismatch_t (*aComparator)(bo_pointer_t , bo_pointer_t ),
	struct bo_srtbtree_node *aNode,
	int /* _Bool */ Force
#else
	aTree, aComparator, aNode, Force
#endif
	)
#if !__myc_require(prototypes)
	struct bo_srtbtree *aTree;
	bo_mismatch_t (*aComparator)(/* bo_pointer_t , bo_pointer_t */);
	struct bo_srtbtree_node *aNode;
	int /* _Bool */ Force;
#endif

# define NEED_MY_SRTBTREE_INSERTNODE_IMPL 2

#endif /* NEED_MY_SRTBTREE_INSERTNODE_DECL2 */


#ifdef NEED_MY_SRTBTREE_INSERTNODE_PROTO3
# undef NEED_MY_SRTBTREE_INSERTNODE_PROTO3

__myc_extern_inline__ bo_srtbtree_iterator /* = NULL */
MY_SRTBTREE_InsertNode(
#if __myc_require(prototypes)
	struct bo_srtbtree *aTree,
	struct bo_btninfo_opv const *anInfoOpv,
	struct bo_srtbtree_node *aNode,
	int /* _Bool */ Force
#endif
	);

#endif /* NEED_MY_SRTBTREE_INSERTNODE_PROTO3 */

#ifdef NEED_MY_SRTBTREE_INSERTNODE_DECL3
# undef NEED_MY_SRTBTREE_INSERTNODE_DECL3

__myc_extern_inline__ bo_srtbtree_iterator /* = NULL */
MY_SRTBTREE_InsertNode(
#if __myc_require(prototypes)
	struct bo_srtbtree *aTree,
	struct bo_btninfo_opv const *anInfoOpv,
	struct bo_srtbtree_node *aNode,
	int /* _Bool */ Force
#else
	aTree, anInfoOpv, aNode, Force
#endif
	)
#if !__myc_require(prototypes)
	struct bo_srtbtree *aTree;
	struct bo_btninfo_opv const *anInfoOpv;
	struct bo_srtbtree_node *aNode;
	int /* _Bool */ Force;
#endif

# define NEED_MY_SRTBTREE_INSERTNODE_IMPL 3

#endif /* NEED_MY_SRTBTREE_INSERTNODE_DECL3 */


#ifdef NEED_MY_SRTBTREE_INSERTNODE_IMPL

# if (3 == NEED_MY_SRTBTREE_INSERTNODE_IMPL)
#  undef MY_BTREE_Cmpuserinfo
#  define MY_BTREE_Cmpuserinfo(aNodeLhs,aNodeInfoLhs,aNodeRhs,anUserInfoRhs) \
	((*anInfoOpv->btni_compare)(aNodeInfoLhs,anUserInfoRhs))
#  define MY_BTREE_Cmpuserinfo_DEFINED
# else
# if (2 == NEED_MY_SRTBTREE_INSERTNODE_IMPL)
#  undef MY_BTREE_Cmpuserinfo
#  define MY_BTREE_Cmpuserinfo(aNodeLhs,aNodeInfoLhs,aNodeRhs,anUserInfoRhs) \
	((*aComparator)(aNodeInfoLhs,anUserInfoRhs))
#  define MY_BTREE_Cmpuserinfo_DEFINED
# else
#  ifndef MY_BTREE_Cmpuserinfo
#   define MY_BTREE_Cmpuserinfo No comparator defined!!!
#  endif
# endif /* 2 == NEED_MY_SRTBTREE_INSERTNODE_IMPL */
# endif /* 3 == NEED_MY_SRTBTREE_INSERTNODE_IMPL */

# ifndef MY_RTBTREE_Done
#  define MY_RTBTREE_Done(aNode) return /*(bo_srtbtree_iterator)*/(aNode)
# endif
# ifndef MY_RTBTREE_Exist
#  define MY_RTBTREE_Exist(aNode) return /*(bo_srtbtree_iterator)*/(aNode)
# endif

{
#if 1

	struct bo_srtbtree_node *iter;

	BO_SRTBTREE_InsertNode(struct bo_srtbtree_node,btn_link,
		iter,aNode,aTree,Force,
		{ _$0 = MY_BTREE_Cmpuserinfo(iter,iter->btn_info,aNode,aNode->btn_info); },
		{ MY_RTBTREE_Done(aNode); },
		{ MY_RTBTREE_Exist(NULL); }
	);
	/* NOTREACHED */
	assert(0);

#else
// @todo: remove
	bo_srtbtree_iterator ___retval;
	bo_status_t ___status;

	assert(NULL != aTree);
	assert(NULL != aNode);

# if (3 == (NEED_MY_SRTBTREE_INSERTNODE_IMPL + 0))
	___status = MY_RTBTREE_LinkNode(
		bo_btree_p(aTree),
		Force,
		anInfoOpv,
		bo_btree_node_p(aNode),
		(struct bo_srtbtree_node **)&aTree->bt_first,
		(struct bo_srtbtree_node **)&aTree->bt_last
	);
# else
# if (2 == (NEED_MY_SRTBTREE_INSERTNODE_IMPL + 0))
	___status = MY_RTBTREE_LinkNode(
		bo_btree_p(aTree),
		Force,
		aComparator,
		bo_btree_node_p(aNode),
		(struct bo_srtbtree_node **)&aTree->bt_first,
		(struct bo_srtbtree_node **)&aTree->bt_last
	);
# else
	___status = MY_RTBTREE_LinkNode(
		bo_btree_p(aTree),
		Force,
		bo_btree_node_p(aNode),
		(struct bo_srtbtree_node **)&aTree->bt_first,
		(struct bo_srtbtree_node **)&aTree->bt_last
	);
# endif
# endif

	___retval = NULL;
	if (BoS_SUCCESS(___status)) {
		struct bo_srtbtree_node *t;
		bo_cdllist_t *list;

		list = &aTree->bt_nodelist;
		if (NULL != (t = BO_SRTBTREE_Last_defo(aTree)))
			t->btn_last_defo = 0;
		aNode->btn_last_defo = 1;
		BO_CDLLIST_PushBack(struct bo_srtbtree_node,btn_lelem,list,aNode);
		___retval = aNode;
	}

	MY_RTBTREE_Done(___retval);
#endif
}

# undef MY_RTBTREE_Done
# undef MY_RTBTREE_Exist

# ifdef MY_BTREE_Cmpuserinfo_DEFINED
#  undef MY_BTREE_Cmpuserinfo_DEFINED
#  undef MY_BTREE_Cmpuserinfo
# endif

# undef NEED_MY_SRTBTREE_INSERTNODE_IMPL
#endif /* NEED_MY_SRTBTREE_INSERTNODE_IMPL */

/*
__MYC_END_CDECLS
 */

/******************************************************************************
 * Revision History:
 *		$Log$
 *
 *****************************************************************************/
