/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright (c) 2005-2007 V.Sokur
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

/*
 * Srtbtrem_b.h	(V.Sokur)
 * include/Bo/fundis/btreetmpl/Srtbtrem_b.h
 *
 * $Id$
 */

/******************************************************************************
 * %% BeginSection: includes
 */

/*
#include "Bo/fundis/Rtbtree.h"

#include "Bo/services/MIB/Services.h"
#include "Bo/Errors.h"
#include "Bo/Debug.h"
 */

/******************************************************************************
 * %% BeginSection: function definitions
 */
#pragma mark -
#pragma mark [ function definitions ]
#pragma mark -

/*
__MYC_BEGIN_CDECLS
 */

#ifdef NEED_MY_SRTBTREE_REMOVENODE_B_PROTO1
# undef NEED_MY_SRTBTREE_REMOVENODE_B_PROTO1

__myc_extern_inline__ struct bo_srtbtree_node * /* = NULL */
MY_SRTBTREE_RemoveNode_b(
#if __myc_require(prototypes)
	struct bo_srtbtree *aTree,
	bo_pointer_t aRqInfo
#endif
	);

#endif /* NEED_MY_SRTBTREE_REMOVENODE_B_PROTO1 */

#ifdef NEED_MY_SRTBTREE_REMOVENODE_B_DECL1
# undef NEED_MY_SRTBTREE_REMOVENODE_B_DECL1

__myc_extern_inline__ struct bo_srtbtree_node * /* = NULL */
MY_SRTBTREE_RemoveNode_b(
#if __myc_require(prototypes)
	struct bo_srtbtree *aTree,
	bo_pointer_t aRqInfo
#else
	aTree, aRqInfo
#endif
	)
#if !__myc_require(prototypes)
	struct bo_srtbtree *aTree;
	bo_pointer_t aRqInfo;
#endif

# define NEED_MY_SRTBTREE_REMOVENODE_B_IMPL 1

#endif /* NEED_MY_SRTBTREE_REMOVENODE_B_DECL1 */


#ifdef NEED_MY_SRTBTREE_REMOVENODE_B_PROTO2
# undef NEED_MY_SRTBTREE_REMOVENODE_B_PROTO2

__myc_extern_inline__ struct bo_srtbtree_node * /* = NULL */
MY_SRTBTREE_RemoveNode_b(
#if __myc_require(prototypes)
	struct bo_srtbtree *aTree,
	bo_mismatch_t (*aComparator)(bo_pointer_t , bo_pointer_t ),
	bo_pointer_t aRqInfo
#endif
	);

#endif /* NEED_MY_SRTBTREE_REMOVENODE_B_PROTO2 */

#ifdef NEED_MY_SRTBTREE_REMOVENODE_B_DECL2
# undef NEED_MY_SRTBTREE_REMOVENODE_B_DECL2

__myc_extern_inline__ struct bo_srtbtree_node * /* = NULL */
MY_SRTBTREE_RemoveNode_b(
#if __myc_require(prototypes)
	struct bo_srtbtree *aTree,
	bo_mismatch_t (*aComparator)(bo_pointer_t , bo_pointer_t ),
	bo_pointer_t aRqInfo
#else
	aTree, aComparator, aRqInfo
#endif
	)
#if !__myc_require(prototypes)
	struct bo_srtbtree *aTree;
	bo_mismatch_t (*aComparator)(/* bo_pointer_t , bo_pointer_t */);
	bo_pointer_t aRqInfo;
#endif

# define NEED_MY_SRTBTREE_REMOVENODE_B_IMPL 2

#endif /* NEED_MY_SRTBTREE_REMOVENODE_B_DECL2 */


#ifdef NEED_MY_SRTBTREE_REMOVENODE_B_PROTO3
# undef NEED_MY_SRTBTREE_REMOVENODE_B_PROTO3

__myc_extern_inline__ struct bo_srtbtree_node * /* = NULL */
MY_SRTBTREE_RemoveNode_b(
#if __myc_require(prototypes)
	struct bo_srtbtree *aTree,
	struct bo_btninfo_opv const *anInfoOpv,
	bo_pointer_t aRqInfo
#endif
	);

#endif /* NEED_MY_SRTBTREE_REMOVENODE_B_PROTO3 */

#ifdef NEED_MY_SRTBTREE_REMOVENODE_B_DECL3
# undef NEED_MY_SRTBTREE_REMOVENODE_B_DECL3

__myc_extern_inline__ struct bo_srtbtree_node * /* = NULL */
MY_SRTBTREE_RemoveNode_b(
#if __myc_require(prototypes)
	struct bo_srtbtree *aTree,
	struct bo_btninfo_opv const *anInfoOpv,
	bo_pointer_t aRqInfo
#else
	aTree, anInfoOpv, aRqInfo
#endif
	)
#if !__myc_require(prototypes)
	struct bo_srtbtree *aTree;
	struct bo_btninfo_opv const *anInfoOpv;
	bo_pointer_t aRqInfo;
#endif

# define NEED_MY_SRTBTREE_REMOVENODE_B_IMPL 3

#endif /* NEED_MY_SRTBTREE_REMOVENODE_B_DECL3 */


#ifdef NEED_MY_SRTBTREE_REMOVENODE_B_IMPL

# if (3 == NEED_MY_SRTBTREE_REMOVENODE_B_IMPL)
#  undef MY_BTREE_Cmpuserinfo
#  define MY_BTREE_Cmpuserinfo(aNodeLhs,aNodeInfoLhs,aNodeRhs,anUserInfoRhs) \
	((*anInfoOpv->btni_compare)(aNodeInfoLhs,anUserInfoRhs))
#  define MY_BTREE_Cmpuserinfo_DEFINED
# else
# if (2 == NEED_MY_SRTBTREE_REMOVENODE_B_IMPL)
#  undef MY_BTREE_Cmpuserinfo
#  define MY_BTREE_Cmpuserinfo(aNodeLhs,aNodeInfoLhs,aNodeRhs,anUserInfoRhs) \
	((*aComparator)(aNodeInfoLhs,anUserInfoRhs))
#  define MY_BTREE_Cmpuserinfo_DEFINED
# else
#  ifndef MY_BTREE_Cmpuserinfo
#   define MY_BTREE_Cmpuserinfo No comparator defined!!!
#  endif
# endif /* 2 == NEED_MY_SRTBTREE_REMOVENODE_B_IMPL */
# endif /* 3 == NEED_MY_SRTBTREE_REMOVENODE_B_IMPL */

# ifndef MY_RTBTREE_Done
#  define MY_RTBTREE_Done(aNode) return (aNode)
# endif
# ifndef MY_RTBTREE_NotFound
#  define MY_RTBTREE_NotFound(aNode) return (aNode)
# endif

{
#if 1

	struct bo_srtbtree_node *iter;

	BO_SRTBTREE_RemoveNode_b(struct bo_srtbtree_node,btn_link,
		iter,aTree,
		{ _$0 = MY_BTREE_Cmpuserinfo(iter,iter->btn_info,NULL,aRqInfo); },
		{ MY_RTBTREE_Done(iter); },
		{ MY_RTBTREE_NotFound(NULL); }
	);
	/* NOTREACHED */
	assert(0);

#else
// @todo: remove
	struct bo_srtbtree_node *___node;      /* removed-node */

	assert(NULL != aTree);
	assert(NULL != aRqInfo);

# if (3 == (NEED_MY_SRTBTREE_REMOVENODE_B_IMPL + 0))
	___node = (struct bo_srtbtree_node *)MY_RTBTREE_UnlinkNode_b(
		bo_btree_p(aTree),
		anInfoOpv,
		aRqInfo,
		(struct bo_srtbtree_node **)&aTree->bt_first,
		(struct bo_srtbtree_node **)&aTree->bt_last
	);
# else
# if (2 == (NEED_MY_SRTBTREE_REMOVENODE_B_IMPL + 0))
	___node = (struct bo_srtbtree_node *)MY_RTBTREE_UnlinkNode_b(
		bo_btree_p(aTree),
		aComparator,
		aRqInfo,
		(struct bo_srtbtree_node **)&aTree->bt_first,
		(struct bo_srtbtree_node **)&aTree->bt_last
	);
# else
	___node = (struct bo_srtbtree_node *)MY_RTBTREE_UnlinkNode_b(
		bo_btree_p(aTree),
		aRqInfo,
		(struct bo_srtbtree_node **)&aTree->bt_first,
		(struct bo_srtbtree_node **)&aTree->bt_last
	);
# endif
# endif

	if (NULL != ___node) {
		struct bo_srtbtree_node *____t;
		bo_cdllist_t *____list;

		____list = &aTree->bt_nodelist;
		BO_CDLLIST_Remove(struct bo_srtbtree_node,btn_lelem,____list,___node);
		if (NULL != (____t = BO_SRTBTREE_Last_defo(aTree)))
			____t->btn_last_defo = 1;
	}

	MY_RTBTREE_Done(___node);
#endif
}

# undef MY_RTBTREE_Done
# undef MY_RTBTREE_NotFound

# ifdef MY_BTREE_Cmpuserinfo_DEFINED
#  undef MY_BTREE_Cmpuserinfo_DEFINED
#  undef MY_BTREE_Cmpuserinfo
# endif

# undef NEED_MY_SRTBTREE_REMOVENODE_B_IMPL
#endif /* NEED_MY_SRTBTREE_REMOVENODE_B_IMPL */

/*
__MYC_END_CDECLS
 */

/******************************************************************************
 * Revision History:
 *		$Log$
 *
 *****************************************************************************/
