/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright (c) 2005-2007 V.Sokur
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

/*
 * Alloca.h	(V.Sokur)
 * include/Bo/libc/Alloca.h
 *
 * $Id$
 */

/* ------------------------------------------------------------------------- */

#ifndef __BO_LIBC_ALLOCA__
# define __BO_LIBC_ALLOCA__

/******************************************************************************
 * %% BeginSection: includes
 */

# include <Bo/sys/Cdefs.h>

# ifdef HAS_ALLOCA
#  ifdef ALLOCA_HEADER_HAS_ALLOCA_DECL
#   include __MYC_LIBC_HEADER(alloca.h)
#  else
#  ifdef MALLOC_HEADER_HAS_ALLOCA_DECL
#   include __MYC_LIBC_HEADER(malloc.h)
#  else
#  ifdef STDLIB_HEADER_HAS_ALLOCA_DECL
#   include __MYC_LIBC_HEADER(stdlib.h)
#  else
#  ifdef HAS_PRAGMA_ALLOCA
#   pragma alloca
#  endif /* HAS_PRAGMA_ALLOCA */
#  endif /* STDLIB_HEADER_HAS_ALLOCA_DECL */
#  endif /* MALLOC_HEADER_HAS_ALLOCA_DECL */
#  endif /* ALLOCA_HEADER_HAS_ALLOCA_DECL */
# endif /* HAS_ALLOCA */

#endif /* !__BO_LIBC_ALLOCA__ */

/******************************************************************************
 * Revision History:
 *		$Log$
 *
 *****************************************************************************/
