/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright (c) 2005-2007 V.Sokur
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

/*
 * Malloc.h	(V.Sokur)
 * include/Bo/libc/Malloc.h
 *
 * $Id$
 */

/* ------------------------------------------------------------------------- */

#ifndef __BO_LIBC_MALLOC__
# define __BO_LIBC_MALLOC__

/******************************************************************************
 * %% BeginSection: includes
 */
# pragma mark -

# include <Bo/libc/Stddef.h>

# ifdef STDLIB_HEADER_HAS_MALLOC_DECL
#  include __MYC_LIBC_HEADER(stdlib.h)
# else /* !STDLIB_HEADER_HAS_MALLOC_DECL */
# ifdef MALLOC_HEADER_HAS_MALLOC_DECL
#  include __MYC_LIBC_HEADER(malloc.h)
# else /* !MALLOC_HEADER_HAS_MALLOC_DECL */

__MYC_BEGIN_CDECLS

extern __BO_VOID_PTR__
malloc(
#if __myc_require(prototypes)
	size_t
#endif
	);

extern __BO_VOID_PTR__
calloc(
#if __myc_require(prototypes)
	size_t ,
	size_t
#endif
	);

extern __BO_VOID_PTR__
realloc(
#if __myc_require(prototypes)
	__BO_VOID_PTR__ ,
	size_t
#endif
	);

extern void
free(
#if __myc_require(prototypes)
	__BO_VOID_PTR__
#endif
	);

__MYC_END_CDECLS

# endif /* !MALLOC_HEADER_HAS_MALLOC_DECL */
# endif /* !STDLIB_HEADER_HAS_MALLOC_DECL */

/******************************************************************************
 * %% BeginSection: function prototypes
 */
# pragma mark -

# include <Bo/BoLinkage.h>

__MYC_BEGIN_CDECLS

__myc_flinkage__(public,libBo) __BO_VOID_PTR__
__myc_calltype__(cdecl)
bo_malloc(
#if __myc_require(prototypes)
	size_t aBytec
#endif
	);

__myc_flinkage__(public,libBo) __BO_VOID_PTR__
__myc_calltype__(cdecl)
bo_calloc(
#if __myc_require(prototypes)
	size_t anElemc,
	size_t anElemsz
#endif
	);

__myc_flinkage__(public,libBo) __BO_VOID_PTR__
__myc_calltype__(cdecl)
bo_realloc(
#if __myc_require(prototypes)
	__BO_VOID_PTR__ aPtr,
	size_t aNewBytec
#endif
	);

__myc_flinkage__(public,libBo) void
__myc_calltype__(cdecl)
bo_free(
#if __myc_require(prototypes)
	__BO_VOID_PTR__ aPtr
#endif
	);

__MYC_END_CDECLS

#endif /* !__BO_LIBC_MALLOC__ */

/******************************************************************************
 * Revision History:
 *		$Log$
 *
 *****************************************************************************/
