/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright (c) 2005-2007 V.Sokur
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

/*
 * Stdlib.h	(V.Sokur)
 * include/Bo/libc/Stdlib.h
 *
 * $Id$
 */

/* ------------------------------------------------------------------------- */

#ifndef __BO_LIBC_STDLIB__
# define __BO_LIBC_STDLIB__

/******************************************************************************
 * %% BeginSection: includes
 */

# include <Bo/sys/Types.h>

# if __myc_exists(stdlib,h)
#  include __MYC_LIBC_HEADER(stdlib.h)
# endif /* stdlib.h */

# include <Bo/libc/Stddef.h>
# include <Bo/libc/Wchar.h>

/******************************************************************************
 * %% BeginSection: definitions
 */
# pragma mark -

# ifndef HAS_STRTOLL
#  ifdef HAS__STRTOLL
#   define strtoll(aStr, anEndPtr, aRadix) _strtoll(aStr, anEndPtr, aRadix)
#  else
#  ifdef HAS__STRTOI64
#   define strtoll(aStr, anEndPtr, aRadix) _strtoi64(aStr, anEndPtr, aRadix)
#  else
#   define strtoll(aStr, anEndPtr, aRadix) strtol(aStr, anEndPtr, aRadix)
#  endif /* HAS__STRTOI64 */
#  endif /* HAS__STRTOLL */
# endif /* !HAS_STRTOLL */

# ifndef HAS_WCSTOLL
#  ifdef HAS__WCSTOLL
#   define wcstoll(aStr, anEndPtr, aRadix) _wcstoll(aStr, anEndPtr, aRadix)
#  else
#  ifdef HAS__WCSTOI64
#   define wcstoll(aStr, anEndPtr, aRadix) _wcstoi64(aStr, anEndPtr, aRadix)
#  else
#   define wcstoll(aStr, anEndPtr, aRadix) wcstol(aStr, anEndPtr, aRadix)
#  endif /* HAS__WCSTOI64 */
#  endif /* HAS__WCSTOLL */
# endif /* !HAS_WCSTOLL */

#endif /* !__BO_LIBC_STDLIB__ */

/******************************************************************************
 * Revision History:
 *		$Log$
 *
 *****************************************************************************/
