/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright (c) 2005-2007 V.Sokur
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

/*
 * Wchar.h	(V.Sokur)
 * include/Bo/libc/Wchar.h
 *
 * $Id$
 */

/* ------------------------------------------------------------------------- */

#ifndef __BO_LIBC_WCHAR__
# define __BO_LIBC_WCHAR__

/******************************************************************************
 * %% BeginSection: includes
 */

# include <Bo/sys/Types.h>

# include <Bo/libc/Stddef.h>

# if __myc_exists(wchar,h)
#  include __MYC_LIBC_HEADER(wchar.h)
# endif

/******************************************************************************
 * %% BeginSection: function prototypes
 */
# pragma mark -

# include <Bo/BoLinkage.h>

__MYC_BEGIN_CDECLS

/*
 * File System Representation path
 * Useful for MacOSX, ...
 */

 /* retval: number of bytes converted,
    not including the terminating NUL character */
__myc_flinkage__(public,libBo) ssize_t
BoWpath2FSpath(
# if __myc_require(prototypes)
	wchar_t const *aPath,
	char aFSpath[/* BoL_PATH_MAX * BoL_MB_LEN_MAX */],
	size_t aBufsz, /* in bytes */
	struct aorp_error *anErrPtr
# endif
	);

 /* retval: number of wide characters converted,
    not including the terminating NUL character */
__myc_flinkage__(public,libBo) ssize_t
BoFSpath2Wpath(
# if __myc_require(prototypes)
	char const *aFSpath,
	wchar_t aPath[/* BoL_PATH_MAX */],
	size_t aBufsz, /* in wchars */
	struct aorp_error *anErrPtr
# endif
	);

# pragma mark -

/* canonical (without locale) */
__myc_flinkage__(public,libBo) wint_t
BoTowlower_c(
# if __myc_require(prototypes)
	wint_t aCharacter
# endif
	);

/* canonical (without locale) */
__myc_flinkage__(public,libBo) wint_t
BoTowupper_c(
# if __myc_require(prototypes)
	wint_t aCharacter
# endif
	);

__MYC_END_CDECLS

#endif /* !__BO_LIBC_WCHAR__ */

/******************************************************************************
 * Revision History:
 *		$Log$
 *
 *****************************************************************************/
