/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright (c) 2005-2007 V.Sokur
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

/*
 * _Jmptab.h	(V.Sokur)
 * include/Bo/machine/i386/msc/_Jmptab.h
 *
 * $Id$
 */

/* ------------------------------------------------------------------------- */

#ifndef __BO_I386_MSC__JMPTAB__
# define __BO_I386_MSC__JMPTAB__

/******************************************************************************
 * %% BeginSection: includes
 */

# include <Bo/sys/Types.h>

/******************************************************************************
 * %% BeginSection: definitions
 */

# ifndef BO_JMPTAB_DEFINED
#  define BO_JMPTAB_DEFINED

#  define __bo_janame(aTabName,anActionName) \
	__myc_xconcat4(_L_jmptab_,aTabName,_,anActionName)

#  define __bo_jatab(aTabName) \
	__myc_xconcat(_s_jmptab_,aTabName)


#  define BO_BEGIN_JMPTAB(aTabName,N) \
	static int __myc_xconcat3(_s_jmptab_,aTabName,_inited) = 0; \
	static DWORD __bo_jatab(aTabName)[((0 == N) ? BoL_JMPTAB_SIZE : N) + 1]; \
	if (!__myc_xconcat3(_s_jmptab_,aTabName,_inited)) { \
		DWORD jmptabActionAddr; \
		int jmptabActionIdx = 0; \
		BO_JALINK_DEFAULT(aTabName)

#  define BO_JALINK_DEFAULT(T) BO_JALINK(T,default)
#  define BO_JALINK(T,A) \
	__asm { \
		__asm push __bo_janame(T,A) \
		__asm pop dword ptr [jmptabActionAddr] \
	}; \
	__bo_jatab(T)[jmptabActionIdx++] = jmptabActionAddr;

#  define BO_END_JMPTAB(T) \
		__myc_xconcat3(_s_jmptab_,T,_inited) = 1; \
	}


/* x = [0,N], default: 0 */
#  define BO_JMPSW(T,x) { \
__bo_janame(T,start):; \
	{ \
		DWORD jmptabActionAddr = __bo_jatab(T)[0]; \
		if (!((x) < 0 || __myc_namembs(__bo_jatab(T)) <= (size_t)(x))) \
			jmptabActionAddr = __bo_jatab(T)[x]; \
		__asm { jmp jmptabActionAddr }; \
	} \
	{

#  define BO_JMPCASE_DEFAULT(T) __bo_janame(T,default)
#  define BO_JMPCASE(T,A) __bo_janame(T,A)
#  define BO_JMPBREAKSW(T) goto __bo_janame(T,finish);

#  define BO_JMPENDSW(T) \
__bo_janame(T,finish):; \
	}}

# endif /* BO_JMPTAB_DEFINED */

#endif /* !__BO_I386_MSC__JMPTAB__ */

/******************************************************************************
 * Revision History:
 *		$Log$
 *
 *****************************************************************************/
