/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright (c) 2005-2007 V.Sokur
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

/*
 * BoMalloc.h	(V.Sokur)
 * include/Bo/memman/BoMalloc.h
 *
 * $Id$
 */

/* ------------------------------------------------------------------------- */

#ifndef __BO_MEMMAN_BOMALLOC__
# define __BO_MEMMAN_BOMALLOC__

/******************************************************************************
 * %% BeginSection: includes
 */

# include <Bo/memman/Types.h>

/******************************************************************************
 * %% BeginSection: function prototypes
 */
# pragma mark -
# pragma mark [ function prototypes ]
# pragma mark -

# include <Bo/BoLinkage.h>

__MYC_BEGIN_CDECLS

__myc_flinkage__(public,libBo) bo_status_t
_BoMallocOpv(
# if __myc_require(prototypes)
	struct bo_malloc const *aNewMalloc, /* = NULL */
	struct bo_malloc *anOldMalloc /* = NULL */
# endif
	);

# pragma mark -

__myc_flinkage__(public,libBo) bo_pointer_t
_BoMalloc(
# if __myc_require(prototypes)
	size_t aBytec,
	struct aorp_error *
# endif
	);

__myc_flinkage__(public,libBo) bo_pointer_t
_BoMcalloc(
# if __myc_require(prototypes)
	size_t anElemc,
	size_t anElemsz,
	struct aorp_error *
# endif
	);

__myc_flinkage__(public,libBo) bo_pointer_t
_BoMrealloc(
# if __myc_require(prototypes)
	bo_pointer_t aPtr,
	size_t aBytec,
	struct aorp_error *
# endif
	);

__myc_flinkage__(public,libBo) void
_BoMfree(
# if __myc_require(prototypes)
	bo_pointer_t aPtr
# endif
	);

# pragma mark -

__myc_flinkage__(public,libBo) bo_pointer_t
__myc_calltype__(mcall)
BoMalloc(
# if __myc_require(prototypes)
	size_t aBytec
# endif
	);

__myc_flinkage__(public,libBo) bo_pointer_t
__myc_calltype__(mcall)
BoMcalloc(
# if __myc_require(prototypes)
	size_t anElemc,
	size_t anElemsz
# endif
	);

__myc_flinkage__(public,libBo) bo_pointer_t
__myc_calltype__(mcall)
BoMrealloc(
# if __myc_require(prototypes)
	bo_pointer_t aPtr,
	size_t aBytec
# endif
	);

__myc_flinkage__(public,libBo) void
__myc_calltype__(mcall)
BoMfree(
# if __myc_require(prototypes)
	bo_pointer_t aPtr
# endif
	);

# pragma mark -

__myc_vlinkage__(public,libBo) int _G_BoMalloc_verbose;

__MYC_END_CDECLS

#endif /* !__BO_MEMMAN_BOMALLOC__ */

/******************************************************************************
 * Revision History:
 *		$Log$
 *
 *****************************************************************************/
