/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright (c) 2005-2007 V.Sokur
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

/*
 * Memstg.h	(N.Panasiuk)
 * include/Bo/memman/Memstg.h
 *
 * $Id$
 */

/* ------------------------------------------------------------------------- */

#ifndef __BO_MEMMAN_MEMSTG__
# define __BO_MEMMAN_MEMSTG__

/******************************************************************************
 * %% BeginSection: includes
 */

# include <Bo/memman/Types.h>

/******************************************************************************
 * %% BeginSection: function prototypes
 */
# pragma mark -
# pragma mark [ function prototypes ]
# pragma mark -

# include <Bo/BoLinkage.h>

__MYC_BEGIN_CDECLS

__myc_flinkage__(public,libBo) void
BoMEMSTGclose(
# if __myc_require(prototypes)
	struct bo_memstg_s *aMemstg
# endif
	);
# define BoMEMSTGclose(x) BoMEMSTGclose(bo_memstg_p(x))

__myc_flinkage__(public,libBo) void
__attribute__((nonnull(1)))
BoMEMSTGdestroy(
# if __myc_require(prototypes)
	struct bo_memstg_s *aMemstg
# endif
	);
# define BoMEMSTGdestroy(x) BoMEMSTGdestroy(bo_memstg_p(x))

/* ------------------------------------------------------------------------- */
# pragma mark -
/* ------------------------------------------------------------------------- */

__myc_flinkage__(public,libBo) bo_memstg_t *
BoSMEMSTGopen(
# if __myc_require(prototypes)
	bo_memstg_t *aMemory /* = NULL */,
	struct bo_memstg_s *aParent /* = NULL */,
	struct aorp_error *anErrPtr __myc_defval__(NULL)
# endif
	);
# define BoSMEMSTGopen(x,y,z) BoSMEMSTGopen(x,bo_memstg_p(y),z)

__myc_flinkage__(public,libBo) void
__attribute__((nonnull(1)))
BoSMEMSTGclear(
# if __myc_require(prototypes)
	bo_memstg_t *aMemstg
# endif
	);

__myc_flinkage__(public,libBo) bo_pointer_t
__attribute__((nonnull(1)))
BoSMEMSTGalloc(
# if __myc_require(prototypes)
	bo_memstg_t *aMemstg,
	size_t aBytec,
	struct aorp_error *anErrPtr __myc_defval__(NULL)
# endif
	);

__myc_flinkage__(public,libBo) bo_pointer_t
__attribute__((nonnull(1)))
BoSMEMSTGaalloc(
# if __myc_require(prototypes)
	bo_memstg_t *aMemstg,
	size_t aBytec,
	size_t anAlign,
	struct aorp_error *anErrPtr __myc_defval__(NULL)
# endif
	);

/* NOTE! All allocated blocks after @aPtr will be free */
__myc_flinkage__(public,libBo) void
__attribute__((nonnull(1)))
BoSMEMSTGfree(
# if __myc_require(prototypes)
	bo_memstg_t *aMemstg,
	bo_pointer_t aPtr
# endif
	);

__myc_flinkage__(public,libBo) bo_memstg_state_t *
__attribute__((nonnull(1,2)))
BoSMEMSTGgetstate(
# if __myc_require(prototypes)
	bo_memstg_state_t *aMemory,
	bo_memstg_t const *aMemstg
# endif
	);

__myc_flinkage__(public,libBo) bo_memstg_t *
__attribute__((nonnull(1,2)))
BoSMEMSTGsetstate(
# if __myc_require(prototypes)
	bo_memstg_t *aMemstg,
	bo_memstg_state_t const *aState
# endif
	);

/* ------------------------------------------------------------------------- */
# pragma mark -
/* ------------------------------------------------------------------------- */

__myc_flinkage__(public,libBo) bo_pool_t *
BoPOOLopen(
# if __myc_require(prototypes)
	bo_pool_t *aMemory /* = NULL */,
	struct bo_memstg_s *aParent /* = NULL */,
	size_t anUserObjsz /* != 0 */,
	size_t anAlign /* = 0 */,
	struct aorp_error *anErrPtr __myc_defval__(NULL)
# endif
	);
# define BoPOOLopen(a,b,c,d,e) BoPOOLopen(a,bo_memstg_p(b),c,d,e)

__myc_flinkage__(public,libBo) void
__attribute__((nonnull(1)))
BoPOOLclear(
# if __myc_require(prototypes)
	bo_pool_t *aPool
# endif
	);

__myc_flinkage__(public,libBo) bo_pointer_t
__attribute__((nonnull(1)))
BoPOOLget(
# if __myc_require(prototypes)
	bo_pool_t *aPool,
	struct aorp_error *anErrPtr __myc_defval__(NULL)
# endif
	);

/* NOTE! All the blocks after @aPtr will be free */
__myc_flinkage__(public,libBo) void
__attribute__((nonnull(1)))
BoPOOLfree(
# if __myc_require(prototypes)
	bo_pool_t *aPool,
	bo_pointer_t aPtr
# endif
	);

__myc_flinkage__(public,libBo) bo_memstg_state_t *
__attribute__((nonnull(1,2)))
BoPOOLgetstate(
# if __myc_require(prototypes)
	bo_memstg_state_t *aMemory,
	bo_pool_t const *aPool
# endif
	);

__myc_flinkage__(public,libBo) bo_pool_t *
__attribute__((nonnull(1,2)))
BoPOOLsetstate(
# if __myc_require(prototypes)
	bo_pool_t *aPool,
	bo_memstg_state_t const *aState
# endif
	);

__MYC_END_CDECLS

#endif /* !defined(__BO_MEMMAN_MEMSTG__) */

/******************************************************************************
 *
 *
 *
 *****************************************************************************/
