/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright (c) 2005-2007 V.Sokur
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

/*
 * TypesI.h	(V.Sokur)
 * include/Bo/memman/TypesI.h
 *
 * $Id$
 */

/* ------------------------------------------------------------------------- */

#ifndef __BO_MEMMAN_TYPES_I__
# define __BO_MEMMAN_TYPES_I__

/******************************************************************************
 * %% BeginSection: includes
 */

# include <Bo/memman/Types.h>

/******************************************************************************
 * %% BeginSection: bo_zmalloc declarations
 */
# pragma mark -
# pragma mark [ bo_zmalloc declarations ]
# pragma mark -

typedef bo_status_t
(__myc_tcalltype__(mcall) *bo_zmalloc_destroy_fn)(
# if __myc_require(prototypes)
	struct bo_zmalloc *anAllocator,
	bo_opflags_t Flags __myc_defval__(0),
	struct aorp_error *anErrPtr __myc_defval__(NULL)
# endif
	) __attribute__((mcalltype, nonnull(1)));

struct bo_zmalloc {
	int                     zm_version_;
	bo_zmalloc_destroy_fn   zm_destroy_;

	bo_cpulock_t            zm_mutex_;
	bo_refc_t               zm_refc_;

	struct bo_malloc        zm_alloc_;
	struct bo_zmalloc_uctx  zm_uctx_;
	size_t                  zm_granularity_;
	size_t                  zm_uobjsz_;

#if 0
	bo_cdllist_t            zm_zone_list_;
	bo_cdllist_t            zm_free_list_;
#else
	bo_csllist_t            zm_zone_list_;
	bo_csllist_t            zm_free_list_;
#endif
};

# pragma pack(push,1)
struct bo_zmalloc_zone {
	struct bo_zmalloc *zmz_owner_;
#if 0
	bo_cdllelem_t      zmz_zlelem_;
#else
	bo_csllelem_t      zmz_zlelem_;
#endif
/*
	struct bo_zmalloc_granule zmz_granule_list_[];
*/
};
# pragma pack(pop)

# pragma pack(push,1)
struct bo_zmalloc_granule {
	union {
		struct bo_zmalloc *zmg_owner_;
#if 0
		bo_cdllelem_t      zmg_flelem_;
#else
		bo_csllelem_t      zmg_flelem_;
#endif
	} u;
	bo_refc_t              zmg_refc_;
/*
	char                   zmg_uobj[];
*/
};
# pragma pack(pop)

#endif /* !__BO_MEMMAN_TYPES_I__ */

/******************************************************************************
 * Revision History:
 *		$Log$
 *
 *****************************************************************************/
