/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright (c) 2005-2007 V.Sokur
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

/*
 * BoeverloopP.h	(V.Sokur)
 * include/Bo/objects/BoeverloopP.h
 *
 * $Id$
 */

/* ------------------------------------------------------------------------- */

#ifndef __BO_OBJECTS_BOEVERLOOP_P__
# define __BO_OBJECTS_BOEVERLOOP_P__

/******************************************************************************
 * %% BeginSection: includes
 */

# include <Bo/objects/Boeverloop.h>

/******************************************************************************
 * %% BeginSection: type declarations
 */
# pragma mark -
# pragma mark [ type declarations ]
# pragma mark -

# include <Bo/services/alg/jobcntl/_EverloopP.h>
# include <Bo/services/alg/_XucntlP.h>
# include <Bo/services/alg/_CtorP.h>
# include <Bo/services/alg/_DestorP.h>


# define __aorpc_ns_object_c 1
# define __aorpc_ns_object (Boeverloop)
# include <Bo/aorp/AorpCxob.h>

_A_xobject(Boeverloop)
{
	_A_hbdecl_;
	_A_poddecl(ucntl,Xucntl,     ucntl_part_)
	_A_poddecl(runloop,Everloop, rloop_part_)
/*
 * The impl of the 'job' service acts on Everloop domain.
 * That's why there is not (job,Everloop) pod.
 *
	_A_poddecl(job,Everloop,     job_part_)
 */
}
_A_end;

# include <Bo/aorp/AorpCend.h>


# define __aorpc_ns_object_c 1
# define __aorpc_ns_object (Boeverloop)
# include <Bo/aorp/AorpCcob.h>

_A_cobject(Boeverloop)
{
	_A_hbdecl_;
	_A_poddecl(constructor,Ctor,  ctor_part_)
	_A_poddecl(descriptor,Destor, destor_part_)
}
_A_end;

# include <Bo/aorp/AorpCend.h>

#endif /* !__BO_OBJECTS_BOEVERLOOP_P__ */

/******************************************************************************
 * Revision History:
 *		$Log$
 *
 *****************************************************************************/
