/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright (c) 2005-2007 V.Sokur
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

/*
 * BokumasP.h	(V.Sokur)
 * include/Bo/objects/BokumasP.h
 *
 * $Id$
 */

/* ------------------------------------------------------------------------- */

#ifndef __BO_OBJECTS_BOKUMAS_P__
# define __BO_OBJECTS_BOKUMAS_P__

/******************************************************************************
 * %% BeginSection: includes
 */

# include <Bo/objects/Bokumas.h>

/******************************************************************************
 * %% BeginSection: type declarations
 */
# pragma mark -
# pragma mark [ type declarations ]
# pragma mark -

# include <Bo/services/alg/_KumasP.h>
# include <Bo/services/alg/_KumCtorP.h>
# include <Bo/services/alg/_DestorP.h>
# include <Bo/services/alg/_DupP.h>

/* ------------------------------------------------------------------------- */

# define __aorpc_ns_object_c 1
# define __aorpc_ns_object (Bokumas)
# include <Bo/aorp/AorpCxob.h>

_A_xobject(Bokumas)
{
	_A_hbdecl_;
	_A_poddecl(ucntl,Kumas,  ucntl_part_)
}
_A_end;

# include <Bo/aorp/AorpCend.h>


# define __aorpc_ns_object_c 1
# define __aorpc_ns_object (Bokumas)
# include <Bo/aorp/AorpCcob.h>

_A_cobject(Bokumas) /* = Bokum */
{
	_A_hbdecl_;
	_A_poddecl(constructor,KumCtor,  ctor_part_)
	_A_poddecl(descriptor,Destor,    destor_part_)
	_A_poddecl(duplicator,Dup,       dup_part_)
	u_int32_t kum_magic;
}
_A_end;

# include <Bo/aorp/AorpCend.h>

#endif /* !__BO_OBJECTS_BOKUMAS_P__ */

/******************************************************************************
 * Revision History:
 *		$Log$
 *
 *****************************************************************************/
