/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright (c) 2005-2007 V.Sokur
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

/*
 * Bokumfam.h	(V.Sokur)
 * include/Bo/objects/Bokumfam.h
 *
 * $Id$
 */

/* ------------------------------------------------------------------------- */

#ifndef __BO_OBJECTS_BOKUMFAM__
# define __BO_OBJECTS_BOKUMFAM__

/******************************************************************************
 * %% BeginSection: includes
 */

# include <Bo/sys/Types.h>

/******************************************************************************
 * %% BeginSection: type/constant declarations
 */
# pragma mark -
# pragma mark [ type/constant declarations ]
# pragma mark -

/*
 * Bokumfam
 * oid: <<category>>/<<object>>/<<impl>>
 *
 * constructor, descriptor, ucntl, dup
 */
/*
# define AorpK_Bokumfam_object (5)
# define AorpK_Bokumfam_object_creatable 1
 */
# include <Bo/services/MIB/Objects.h>

/******************************************************************************
 * %% BeginSection: type declarations
 */
# pragma mark -
# pragma mark [ type declarations ]
# pragma mark -

_A_xobject(Bokumfam);

# include <Bo/services/alg/_Kumfam.h>

/******************************************************************************
 * %% BeginSection: function prototypes
 */
# pragma mark -
# pragma mark [ function prototypes ]
# pragma mark -

/*
 * Canonical prototype
 *
aorp_object_t
BokumfamOpen_c(
	aorp_opflags_t Flags,            // 0
	bo_pointer_t aMemory,            // NULL
	aorp_podinit_t aParmv[],
	size_t aParmc,
	struct aorp_error *anErrPtr      // NULL
	);
 */
# define BokumfamOpen_c(Flags, aMemory, aParmv, aParmc, anErrPtr) \
	_A_open1(Bokumfam, Flags, aMemory, aParmv, (size_t)(aParmc), anErrPtr)

/* ------------------------------------------------------------------------- */

/*
void
BokumfamOpen< _TAG >(
	aorp_object_t &aResultRef,
	bo_pointer_t aData,
	size_t aBytec,
	struct aorp_error *anErrPtr // = NULL
	);
 */

# define BokumfamOpen(_TAG, aResultRef, aData, aBytec, anErrPtr) \
	_A_openbyname_v1( \
		aResultRef, (Bokumfam, _TAG), 0, NULL, \
		(2,(ucntl,Kumfam), aData, (size_t)(aBytec)), \
		anErrPtr \
	)

/*
void
BokumfamOpenCB< _TAG >(
	aorp_object_t &aResultRef,
	bo_pointer_t aData,
	size_t aBytec,
	struct aorp_custom_opv *aCB,
	struct aorp_error *anErrPtr // = NULL
	);
 */

# define BokumfamOpenCB(_TAG, aResultRef, aData, aBytec, aCB, anErrPtr) \
	_A_openbyname_v1( \
		aResultRef, (Bokumfam, _TAG), 0, NULL, \
		(3,(ucntl,Kumfam,_TAG), aData, (size_t)(aBytec), aCB), \
		anErrPtr \
	)

/* ------------------------------------------------------------------------- */

/*
void
BokumfamOpen_i32(
	aorp_object_t &aResultRef,
	int32_t aDataVar,
	struct aorp_error *anErrPtr // = NULL
	);
 */
# define BokumfamOpen_i32(aResultRef, aDataVar, anErrPtr) \
	BokumfamOpen(AorpK_CUSTOM_I32_TAG, aResultRef, &(aDataVar), (sizeof aDataVar), anErrPtr)

/*
void
BokumfamOpen_i64(
	aorp_object_t &aResultRef,
	int64_t aDataVar,
	struct aorp_error *anErrPtr // = NULL
	);
 */
# define BokumfamOpen_i64(aResultRef, aDataVar, anErrPtr) \
	BokumfamOpen(AorpK_CUSTOM_I64_TAG, aResultRef, &(aDataVar), (sizeof aDataVar), anErrPtr)

/*
void
BokumfamOpen_f32(
	aorp_object_t &aResultRef,
	float aDataVar,
	struct aorp_error *anErrPtr // = NULL
	);
 */
# define BokumfamOpen_f32(aResultRef, aDataVar, anErrPtr) \
	BokumfamOpen(AorpK_CUSTOM_F32_TAG, aResultRef, &(aDataVar), (sizeof aDataVar), anErrPtr)

/*
void
BokumfamOpen_f64(
	aorp_object_t &aResultRef,
	double aDataVar,
	struct aorp_error *anErrPtr // = NULL
	);
 */
# define BokumfamOpen_f64(aResultRef, aDataVar, anErrPtr) \
	BokumfamOpen(AorpK_CUSTOM_F64_TAG, aResultRef, &(aDataVar), (sizeof aDataVar), anErrPtr)

/*
void
BokumfamOpen_str(
	aorp_object_t &aResultRef,
	char const *aString,
	struct aorp_error *anErrPtr // = NULL
	);
 */
# define BokumfamOpen_str(aResultRef, aString, anErrPtr) \
	BokumfamOpen(AorpK_CUSTOM_STR_TAG, aResultRef, aString, -1, anErrPtr)

/*
void
BokumfamOpen_str_n(
	aorp_object_t &aResultRef,
	char const *aString,
	size_t aBytec,
	struct aorp_error *anErrPtr // = NULL
	);
 */
# define BokumfamOpen_str_n(aResultRef, aString, aBytec, anErrPtr) \
	BokumfamOpen(AorpK_CUSTOM_STR_TAG, aResultRef, aString, aBytec, anErrPtr)

/*
void
BokumfamOpen_wcs(
	aorp_object_t &aResultRef,
	wchar_t const *aString,
	struct aorp_error *anErrPtr // = NULL
	);
 */
# define BokumfamOpen_wcs(aResultRef, aString, anErrPtr) \
	BokumfamOpen(AorpK_CUSTOM_WCS_TAG, aResultRef, aString, -1, anErrPtr)

/*
void
BokumfamOpen_wcs_n(
	aorp_object_t &aResultRef,
	wchar_t const *aString,
	size_t aCharc,
	struct aorp_error *anErrPtr // = NULL
	);
 */
# define BokumfamOpen_wcs_n(aResultRef, aString, aCharc, anErrPtr) \
	BokumfamOpen(AorpK_CUSTOM_WCS_TAG, aResultRef, aString, (aCharc  * sizeof(wchar_t)), anErrPtr)

/*
void
BokumfamOpen_buf(
	aorp_object_t &aResultRef,
	struct aorp_kumfam_buf *aBufPtr,
	struct aorp_error *anErrPtr // = NULL
	);
 */
# define BokumfamOpen_buf(aResultRef, aBufPtr, anErrPtr) \
	BokumfamOpen(AorpK_CUSTOM_BUF_TAG, aResultRef, aBufPtr, -1, anErrPtr)

/*
void
BokumfamOpen_bufcb(
	aorp_object_t &aResultRef,
	struct aorp_kumfam_buf *aBufPtr,
	struct aorp_custom_opv *aCB,
	struct aorp_error *anErrPtr // = NULL
	);
 */
# define BokumfamOpen_bufcb(aResultRef, aBufPtr, aCB, anErrPtr) \
	BokumfamOpenCB(AorpK_CUSTOM_BUFCB_TAG, aResultRef, aBufPtr, -1, aCB, anErrPtr)

typedef _A_proinitpod_(3,(ucntl,Kumfam,WithCB))
	_A_proinitpod_(3,(ucntl,Kumfam,AorpK_CUSTOM_BUFCB_TAG));

// @todo: remove
# define BokumfamOpen_bufx(aResultRef, aBufPtr, anErrPtr) \
	BokumfamOpen(AorpK_CUSTOM_BUFX_TAG, aResultRef, aBufPtr, -1, anErrPtr)

/*
void
BokumfamOpen_aggr(
	aorp_object_t &aResultRef,
	aorp_object_t aLhs,
	aorp_object_t aRhs,
	_Bool WithRetain,
	struct aorp_error *anErrPtr // = NULL
	);
 */
# define BokumfamOpen_aggr(aResultRef, aLhs, aRhs, WithRetain, anErrPtr) \
	_A_openbyname_v1( \
		aResultRef, (Bokumfam, AorpK_CUSTOM_AGGR_TAG), 0, NULL, \
		(3,(ucntl,Kumfam,AorpK_CUSTOM_AGGR_TAG), aLhs, aRhs, WithRetain), \
		anErrPtr \
	)

typedef _A_proinitpod_(3,(ucntl,Kumfam,aggr))
	_A_proinitpod_(3,(ucntl,Kumfam,AorpK_CUSTOM_AGGR_TAG));

#endif /* !__BO_OBJECTS_BOKUMFAM__ */

/******************************************************************************
 * Revision History:
 *		$Log$
 *
 *****************************************************************************/
