/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright (c) 2005-2007 V.Sokur
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

/*
 * Bolordlis.h	(N.Panasiuk)
 * include/Bo/objects/Bolordlis.h
 *
 * $Id$
 */

/* ------------------------------------------------------------------------- */

#ifndef __BO_OBJECTS_BOLORDLIS__
# define __BO_OBJECTS_BOLORDLIS__

/******************************************************************************
 * %% BeginSection: includes
 */

# include <Bo/sys/Types.h>

/******************************************************************************
 * %% BeginSection: type/constant declarations
 */
# pragma mark -
# pragma mark [ type/constant declarations ]
# pragma mark -

/*
 * Bolordlis
 * oid: <<category>>/<<object>>/<<impl>>
 *
 * constructor, descriptor, ucntl, container
 */
/*
# define AorpK_Bolordlis_object (41)
# define AorpK_Bolordlis_object_creatable 1
 */
# include <Bo/services/MIB/Objects.h>

/******************************************************************************
 * %% BeginSection: type declarations
 */
# pragma mark -
# pragma mark [ type declarations ]
# pragma mark -

_A_xobject_(2,(Bolordlis,object));
_A_xobject_(2,(Bolordlis,udvariant));

# include <Bo/services/alg/basis/_Lordlis.h>
# include <Bo/services/alg/_Xucntl.h>

/******************************************************************************
 * %% BeginSection: function prototypes
 */
# pragma mark -
# pragma mark [ function prototypes ]
# pragma mark -

/*
 * Canonical prototype
 *
aorp_object_t
BolordlisOpen_c(
	int aDataCategory,
	aorp_opflags_t Flags,       // 0
	bo_pointer_t aMemory,       // NULL
	aorp_podinit_t aParmv[],
	size_t aParmc,
	struct aorp_error *anErrPtr // NULL
	);
 */
# define BolordlisOpen_c(aDataCategory, Flags, aMemory, aParmv, aParmc, anErrPtr) \
	_A_open2(Bolordlis, aDataCategory, Flags, aMemory, aParmv, (size_t)(aParmc), anErrPtr)

/* ------------------------------------------------------------------------- */

/*
void
BolordlisOpen< _TDataCategory >(
	aorp_object_t &aResultRef,
	aorp_opflags_t Flags,       // 0
	bo_pointer_t aMemory,       // NULL
	aorp_hint_t anAssocHint,
	struct aorp_error *anErrPtr // NULL
	);
 */
# define BolordlisOpen(_TDataCategory, aResultRef, Flags, aMemory, \
	                   anAssocHint, anErrPtr) \
	_A_openbyname_v1( \
		aResultRef, (Bolordlis, _TDataCategory), Flags, aMemory, \
		(2,(container,Lordlis), 0, anAssocHint), \
		anErrPtr \
	)

/*
void
BolordlisudOpen(
	aorp_object_t &aResultRef,
	aorp_opflags_t Flags,       // 0
	bo_pointer_t aMemory,       // NULL
	aorp_hint_t anAssocHint,
	struct aorp_error *anErrPtr // NULL
	);
 */
# define BolordlisudOpen(aResultRef, Flags, aMemory, anAssocHint, anErrPtr) \
	BolordlisOpen(AorpK_CTNR_UDVARIANT_DATA, aResultRef, Flags, aMemory, \
		anAssocHint, anErrPtr)

/*
void
BolordlisobOpen(
	aorp_object_t &aResultRef,
	aorp_opflags_t Flags,       // 0
	bo_pointer_t aMemory,       // NULL
	aorp_hint_t anAssocHint,
	struct aorp_error *anErrPtr // NULL
	);
 */
# define BolordlisobOpen(aResultRef, Flags, aMemory, anAssocHint, anErrPtr) \
	BolordlisOpen(AorpK_CTNR_OBJECT_DATA, aResultRef, Flags, aMemory, \
		anAssocHint, anErrPtr)

#endif /* !__BO_OBJECTS_BOLORDLIS__ */

/******************************************************************************
 * Revision History:
 *		$Log$
 *
 *****************************************************************************/
