/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright (c) 2005-2007 V.Sokur
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

/*
 * Boqdfalex.h	(V.Sokur)
 * include/Bo/objects/Boqdfalex.h
 *
 * $Id$
 */

/* ------------------------------------------------------------------------- */

#ifndef __BO_OBJECTS_BOQDFALEX__
# define __BO_OBJECTS_BOQDFALEX__

/******************************************************************************
 * %% BeginSection: includes
 */

# include <Bo/sys/Types.h>

/******************************************************************************
 * %% BeginSection: type/constant declarations
 */
# pragma mark -
# pragma mark [ type/constant declarations ]
# pragma mark -

/*
 * Boqdfalex
 * oid: <<category>>/<<object>>/<<impl>>
 *
 * constructor, descriptor, ucntl, lexan
 */
/*
# define AorpK_Boqdfalex_object (120)
# define AorpK_Boqdfalex_object_creatable 1
 */
# include <Bo/services/MIB/Objects.h>

/******************************************************************************
 * %% BeginSection: type declarations
 */
# pragma mark -
# pragma mark [ type declarations ]
# pragma mark -

_A_xobject(Boqdfalex);

# include <Bo/services/alg/textan/_Qdfalex.h>
# include <Bo/services/alg/_Xucntl.h>

/******************************************************************************
 * %% BeginSection: function prototypes
 */
# pragma mark -
# pragma mark [ function prototypes ]
# pragma mark -

/*
 * Canonical prototype
 *
aorp_object_t
BoqdfalexOpen_c(
	aorp_opflags_t Flags,            // 0
	bo_pointer_t aMemory,            // NULL
	aorp_podinit_t aParmv[],
	size_t aParmc,
	struct aorp_error *anErrPtr      // NULL
	);
 */
# define BoqdfalexOpen_c(Flags, aMemory, aParmv, aParmc, anErrPtr) \
	_A_open1(Boqdfalex, Flags, aMemory, aParmv, (size_t)(aParmc), anErrPtr)

/* ------------------------------------------------------------------------- */

/*
void
BoqdfalexOpen(
	aorp_object_t &aResultRef,
	aorp_opflags_t Flags,       // 0
	bo_pointer_t aMemory,       // NULL
	aorp_object_t anInputStream,
	aorp_object_t aQDFA,
	struct aorp_token_predicate *aPredicate, // NULL
	struct aorp_error *anErrPtr // NULL
	);
 */
# define BoqdfalexOpen(aResultRef, Flags, aMemory, \
	                 anInputStream, aQDFA, aPredicate, anErrPtr) \
	_A_openbyname_v1( \
		aResultRef, (Boqdfalex), Flags, aMemory, \
		(2,(lexan,Qdfalex), anInputStream, aQDFA, aPredicate), \
		anErrPtr \
	)

#endif /* !__BO_OBJECTS_BOQDFALEX__ */

/******************************************************************************
 * Revision History:
 *		$Log$
 *
 *****************************************************************************/
