/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright (c) 2005-2007 V.Sokur
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

/*
 * Boqlrtab.h	(N.Panasiuk)
 * include/Bo/objects/Boqlrtab.h
 *
 * $Id$
 */

/* ------------------------------------------------------------------------- */

#ifndef __BO_OBJECTS_BOQLRTAB__
# define __BO_OBJECTS_BOQLRTAB__

/******************************************************************************
 * %% BeginSection: includes
 */

# include <Bo/sys/Types.h>

/******************************************************************************
 * %% BeginSection: type/constant declarations
 */
# pragma mark -
# pragma mark [ type/constant declarations ]
# pragma mark -

/*
 * Boqlrtab
 * oid: <<category>>/<<object>>/<<impl>>
 *
 * constructor, descriptor, ucntl, lrtab
 */
/*
# define AorpK_Boqlrtab_object (125)
# define AorpK_Boqlrtab_object_creatable 1
 */
# include <Bo/services/MIB/Objects.h>

/******************************************************************************
 * %% BeginSection: type declarations
 */
# pragma mark -
# pragma mark [ type declarations ]
# pragma mark -

_A_xobject(Boqlrtab);

# include <Bo/services/alg/textan/_Qlrtab.h>
# include <Bo/services/alg/_Xucntl.h>

/******************************************************************************
 * %% BeginSection: function prototypes
 */
# pragma mark -
# pragma mark [ function prototypes ]
# pragma mark -

/*
 * Canonical prototype
 *
aorp_object_t
BoqlrtabOpen_c(
	aorp_opflags_t Flags,            // 0
	bo_pointer_t aMemory,            // NULL
	aorp_podinit_t aParmv[],
	size_t aParmc,
	struct aorp_error *anErrPtr      // NULL
	);
 */
# define BoqdfaOpen_c(Flags, aMemory, aParmv, aParmc, anErrPtr) \
	_A_open1(Boqdfa, Flags, aMemory, aParmv, (size_t)(aParmc), anErrPtr)

/* ------------------------------------------------------------------------- */

/*
void
BoqlrtabOpen(
	aorp_object_t &aResultRef,
	aorp_opflags_t Flags,       // 0
	bo_pointer_t aMemory,       // NULL
	unsigned long aStartState,
	unsigned long aStateMax,
	unsigned long aTokenMax,
	unsigned long aSymbolMax,
	unsigned long aRuleMax,
	int anLRTabelem,
	bo_pointer_t anLRTable,
	int aRrhslenTabelem,
	bo_pointer_t aRrhslenTable,
	int aRlhsTabelem,
	bo_pointer_t aRlhsTable,
	int aRactTabelem,
	bo_pointer_t aRactTable,
	struct aorp_error *anErrPtr // NULL
	);
 */
# define BoqlrtabOpen(aResultRef, Flags, aMemory, \
	                 aStartState, aStateMax, aTokenMax, aSymbolMax, aRuleMax, \
					 anLRTabelem, anLRTable, aRrhslenTabelem, aRrhslenTable, \
					 aRlhsTabelem, aRlhsTable, aRactTabelem, aRactTable, anErrPtr) \
	_A_openbyname_v1( \
		aResultRef, (Boqlrtab), Flags, aMemory, \
		(2,(lrtab,Qlrtab),aStartState,aStateMax,aTokenMax,aSymbolMax,aRuleMax, \
			anLRTabelem,anLRTable,aRrhslenTabelem,aRrhslenTable, \
			aRlhsTabelem,aRlhsTable,aRactTabelem,aRactTable), \
		anErrPtr \
	)

#endif /* !__BO_OBJECTS_BOQLRTAB__ */

/******************************************************************************
 * Revision History:
 *		$Log$
 *
 *****************************************************************************/
