/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright (c) 2005-2007 V.Sokur
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

/*
 * Bosl2.h	(S.Makhmali)
 * include/Bo/objects/Bosl2.h
 *
 * $Id$
 */

/* ------------------------------------------------------------------------- */

#ifndef __BO_OBJECTS_BOSL2__
# define __BO_OBJECTS_BOSL2__

/******************************************************************************
 * %% BeginSection: includes
 */

# include <Bo/sys/Types.h>

/******************************************************************************
 * %% BeginSection: type/constant declarations
 */
# pragma mark -
# pragma mark [ type/constant declarations ]
# pragma mark -

/*
 * Bosl2
 * oid: <<category>>/<<object>>/<<impl>>
 *
 * constructor, descriptor, ucntl, log
 */
/*
# define AorpK_Bosl2_object (92)
# define AorpK_Bosl2_object_creatable 1
 */
# include <Bo/services/MIB/Objects.h>

/******************************************************************************
 * %% BeginSection: type declarations
 */
# pragma mark -
# pragma mark [ type declarations ]
# pragma mark -

_A_xobject(Bosl2);

# include <Bo/services/alg/infos/_Slogcli2.h>
# include <Bo/services/alg/_Xucntl.h>

/******************************************************************************
 * %% BeginSection: function prototypes
 */
# pragma mark -
# pragma mark [ function prototypes ]
# pragma mark -

# include <Bo/services/MIB/Services.h>

/*
 * Canonical prototype
 *
aorp_object_t
Bosl2Open_c(
	aorp_opflags_t Flags,            // 0
	bo_pointer_t aMemory,            // NULL
	aorp_podinit_t aParmv[],
	size_t aParmc,
	struct aorp_error *anErrPtr      // NULL
	);
 */
# define Bosl2Open_c(Flags, aMemory, aParmv, aParmc, anErrPtr) \
	_A_open(Bosl2, Flags, aMemory, aParmv, (size_t)(aParmc), anErrPtr)

/*
void
Bosl2Open(
	aorp_object_t &aResultRef,
	aorp_opflags_t Flags,		               // 0
	bo_pointer_t aMemory,                      // NULL
	struct aorp_logattr_t const *aLogattr,
	struct bo_uconn_ds const *aSrvaddr;        // NULL
	struct timespec const *aHandshakeTimeout,  // NULL
	int AsyncMode,                             // 0
	bo_msec_t aLatency,                        // 0 ; used in async mode
	size_t aMqsup,                             // 0 ; used in async mode
	size_t aMqslo,                             // 0 ; used in async mode
	struct aorp_error *anErrPtr                // NULL
	);
 */

# define Bosl2Open(aResultRef, Flags, aMemory, aLogattr, aSrvaddr, aTimeout, \
		AsyncMode, aLatency, aMqsup, aMqslo, anErrPtr) \
	_A_openbyname_v1( \
		aResultRef, (Bosl2), Flags, aMemory, \
		(2,(log,Slogcli2), aLogattr, aSrvaddr, aTimeout, \
		                   AsyncMode, aLatency, aMqsup, aMqslo), \
		anErrPtr \
	)

#endif /* !__BO_OBJECTS_BOSL2__ */

/******************************************************************************
 * Revision History:
 *		$Log$
 *
 *****************************************************************************/
