/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright (c) 2005-2007 V.Sokur
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

/*
 * Ccsconvtypes.h	(V.Sokur)
 * include/Bo/services/Ccsconvtypes.h
 *
 * $Id$
 */

/* ------------------------------------------------------------------------- */

#ifndef __BO_SERVICES_CCSCONVTYPES__
# define __BO_SERVICES_CCSCONVTYPES__

/******************************************************************************
* %% BeginSection: includes
*/

# include <Bo/sys/Types.h>
# include <Bo/csType.h>

/******************************************************************************
* %% BeginSection: type declarations
*/
# pragma mark -
# pragma mark [ type declarations ]
# pragma mark -

struct aorp_ccscvtor {
	unsigned short           ccv_src_mbmax,
	                         ccv_dst_mbmax;
	char                     ccv_closure[AorpK_CLOSURE_SIZE];
	aorp_object_t            ccv_src,
	                         ccv_dst;

# ifndef AorpK_CCSCVTOR_OPAQUE_SIZE
#  define AorpK_CCSCVTOR_OPAQUE_SIZE (36)
# endif
	char                     ccv_opaque[AorpK_CCSCVTOR_OPAQUE_SIZE];

# define AORP_CCSCVTOR_MAGIC "CCSC"
};

#endif /* !__BO_SERVICES_CCSCONVTYPES__ */

/******************************************************************************
* Revision History:
*		$Log$
*
*****************************************************************************/
