/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright (c) 2005-2007 V.Sokur
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

/*
 * Ccsi.h	(V.Sokur)
 * include/Bo/services/Ccsi.h
 *
 * $Id$
 */

/* ------------------------------------------------------------------------- */

#ifndef __BO_SERVICES_CCSI__
# define __BO_SERVICES_CCSI__

/******************************************************************************
 * %% BeginSection: includes
 */

# include <Bo/services/CcsiP.h>

/******************************************************************************
 * %% BeginSection: function prototypes
 */
# pragma mark -
# pragma mark [ function prototypes ]
# pragma mark -

# include <Bo/BoLinkage.h>

__MYC_BEGIN_CDECLS

__myc_vlinkage__(public,libBo) aorp_object_t _G_ccsi_service_default;

# pragma mark -

# define AorpCcsiStat_(anId,anErrPtr) AorpCcsiStat(NULL,anId,anErrPtr)
# define AorpCcsiIANAName_(anId,anErrPtr) AorpCcsiIANAName(NULL,anId,anErrPtr)
# define AorpCcsiMIMEName_(anId,anErrPtr) AorpCcsiMIMEName(NULL,anId,anErrPtr)
# define AorpCcsiName2Enum_(aNameOrAlias,anErrPtr) AorpCcsiGetidbyname(NULL,aNameOrAlias,anErrPtr)

# pragma mark -

__myc_flinkage__(public,libBo) struct aorp_ccsastat const *
AorpCcsiStat(
# if __myc_require(prototypes)
	aorp_object_t aSelf /* = NULL */,
	bo_cset_t anId,
	struct aorp_error *anErrPtr __myc_defval__(NULL)
# endif
	);

__myc_flinkage__(public,libBo) char const *
AorpCcsiIANAName(
# if __myc_require(prototypes)
	aorp_object_t aSelf /* = NULL */,
	bo_cset_t anId,
	struct aorp_error *anErrPtr __myc_defval__(NULL)
# endif
	);

__myc_flinkage__(public,libBo) char const *
AorpCcsiMIMEName(
# if __myc_require(prototypes)
	aorp_object_t aSelf /* = NULL */,
	bo_cset_t anId,
	struct aorp_error *anErrPtr __myc_defval__(NULL)
# endif
	);

__myc_flinkage__(public,libBo) bo_cset_t
__attribute__((nonnull(2)))
AorpCcsiGetidbyname(
# if __myc_require(prototypes)
	aorp_object_t aSelf /* = NULL */,
	char const *aNameOrAlias,
	struct aorp_error *anErrPtr __myc_defval__(NULL)
# endif
	);

# pragma mark -

__myc_flinkage__(public,libBo) bo_status_t
_AorpCcsiAddtab(
# if __myc_require(prototypes)
	aorp_object_t aSelf /* = NULL */,
	size_t aCount,
	struct Ccsi_dbelem aTable[],
	struct aorp_error *anErrPtr __myc_defval__(NULL)
# endif
	);

__myc_flinkage__(public,libBo) bo_status_t
_AorpCcsiAddtab_nlk(
# if __myc_require(prototypes)
	aorp_object_t aSelf /* = NULL */,
	size_t aCount,
	struct Ccsi_dbelem aTable[],
	struct aorp_error *anErrPtr __myc_defval__(NULL)
# endif
	);

__myc_flinkage__(public,libBo) bo_status_t
_AorpCcsiRmtab(
# if __myc_require(prototypes)
	aorp_object_t aSelf /* = NULL */,
	size_t aCount,
	struct Ccsi_dbelem aTable[],
	struct aorp_error *anErrPtr __myc_defval__(NULL)
# endif
	);

__myc_flinkage__(public,libBo) bo_status_t
_AorpCcsiRmtab_nlk(
# if __myc_require(prototypes)
	aorp_object_t aSelf /* = NULL */,
	size_t aCount,
	struct Ccsi_dbelem aTable[],
	struct aorp_error *anErrPtr __myc_defval__(NULL)
# endif
	);

__MYC_END_CDECLS

#endif /* !__BO_SERVICES_CCSI__ */

/******************************************************************************
 * Revision History:
 *		$Log$
 *
 *****************************************************************************/
