/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright (c) 2005-2007 V.Sokur
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

/*
 * Ctor.h	(V.Sokur)
 * include/Bo/services/Ctor.h
 *
 * $Id$
 */

/* ------------------------------------------------------------------------- */

#ifndef __NEED__AORP_CDEFS_CTOR_DECLS
#ifndef __BO_SERVICES_CTOR__
# define __BO_SERVICES_CTOR__

# define __NEED__AORP_CDEFS_CTOR_DECLS

/******************************************************************************
 * %% BeginSection: includes
 */

# include <Bo/services/CtorP.h>

/******************************************************************************
 * %% BeginSection: function prototypes
 */
# pragma mark -
# pragma mark [ function prototypes ]
# pragma mark -

# include <Bo/BoLinkage.h>

__MYC_BEGIN_CDECLS

__myc_flinkage__(public,libBo) bo_status_t
__attribute__((nonnull(1)))
AorpFini(
# if __myc_require(prototypes)
	aorp_object_t aThis,
	aorp_opflags_t Flags,
	struct aorp_error *anErrPtr
# endif
	);

__myc_flinkage__(public,libBo) bo_status_t
__attribute__((nonnull(1)))
AorpDealloc(
# if __myc_require(prototypes)
	aorp_object_t aThis,
	aorp_opflags_t Flags,
	struct aorp_error *anErrPtr
# endif
	);

/* ------------------------------------------------------------------------- */
# pragma mark -
/* ------------------------------------------------------------------------- */

__myc_flinkage__(public,libBo) bo_status_t
__attribute__((nonnull(1,2)))
_AorpInit(
# if __myc_require(prototypes)
	aorp_object_t aSelf,
	aorp_object_t aThis,
	aorp_podinit_t aParmv[] /* = NULL */,
	size_t aParmc /* = 0 */,
	struct aorp_error *anErrPtr
# endif
	);

__myc_flinkage__(public,libBo) bo_status_t
__attribute__((nonnull(1,2)))
_AorpFini(
# if __myc_require(prototypes)
	aorp_object_t aSelf,
	aorp_object_t aThis,
	aorp_opflags_t Flags,
	struct aorp_error *anErrPtr
# endif
	);

__myc_flinkage__(public,libBo) bo_status_t
__attribute__((nonnull(1,2)))
_AorpDealloc(
# if __myc_require(prototypes)
	aorp_object_t aSelf,
	aorp_object_t aThis,
	aorp_opflags_t Flags,
	struct aorp_error *anErrPtr
# endif
	);

__MYC_END_CDECLS

#endif /* !__BO_SERVICES_CTOR__ */
#endif /* !__NEED__AORP_CDEFS_CTOR_DECLS */

/* ------------------------------------------------------------------------- */
# pragma mark -
/* ------------------------------------------------------------------------- */

#ifdef __NEED__AORP_CDEFS_CTOR_DECLS
# undef __NEED__AORP_CDEFS_CTOR_DECLS

# ifndef _AORP_CDEFS_CTOR_DECLS_MADE
#  define _AORP_CDEFS_CTOR_DECLS_MADE

__MYC_BEGIN_CDECLS

__myc_flinkage__(public,libBo) aorp_object_t
__attribute__((nonnull(1)))
AorpAlloc(
# if __myc_require(prototypes)
	aorp_object_t aSelf,
	aorp_opflags_t Flags /* = 0 */,
	bo_pointer_t aMemory /* = NULL */,
	size_t anExtraSize /* = 0 */,
	struct aorp_error *anErrPtr
# endif
	);

# pragma mark -

__myc_flinkage__(public,libBo) bo_status_t
__attribute__((nonnull(1)))
AorpInit(
# if __myc_require(prototypes)
	aorp_object_t aThis,
	aorp_podinit_t aParmv[] /* = NULL */,
	size_t aParmc /* = 0 */,
	struct aorp_error *anErrPtr
# endif
	);

# pragma mark -

__myc_flinkage__(public,libBo) aorp_object_t
AorpInitDeallocIfError(
# if __myc_require(prototypes)
	aorp_object_t aThis,
	aorp_podinit_t aParmv[] /* = NULL */,
	size_t aParmc /* = 0 */,
	struct aorp_error *anErrPtr
# endif
	);

__MYC_END_CDECLS

# endif /* !_AORP_CDEFS_CTOR_DECLS_MADE */
#endif /* __NEED__AORP_CDEFS_CTOR_DECLS */

/******************************************************************************
 * Revision History:
 *		$Log$
 *
 *****************************************************************************/
