/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright (c) 2005-2007 V.Sokur
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

/*
 * Destor.h	(V.Sokur)
 * include/Bo/services/Destor.h
 *
 * $Id$
 */

/* ------------------------------------------------------------------------- */

#ifndef __BO_SERVICES_DESTOR__
# define __BO_SERVICES_DESTOR__

/******************************************************************************
 * %% BeginSection: includes
 */

# include <Bo/services/DestorP.h>

/******************************************************************************
 * %% BeginSection: function prototypes
 */
# pragma mark -
# pragma mark [ function prototypes ]
# pragma mark -

# include <Bo/BoLinkage.h>

__MYC_BEGIN_CDECLS

__myc_flinkage__(public,libBo) bo_status_t
__attribute__((nonnull(1,2)))
AorpGetdescriptor(
# if __myc_require(prototypes)
	aorp_object_t aThis,
	aorp_descriptor_t aDescriptor,
	struct aorp_error *anErrPtr
# endif
	);

# define AorpGetdescriptor(aThis, aDescriptor, anErrPtr) \
	_A_call(get, descriptor, aThis, anErrPtr, aDescriptor)

/* ------------------------------------------------------------------------- */
# pragma mark -
/* ------------------------------------------------------------------------- */

__myc_flinkage__(public,libBo) bo_status_t
__attribute__((nonnull(1,2,3)))
AorpGetdescriptor_l(
# if __myc_require(prototypes)
	aorp_object_t aThis,
	aorp_descriptor_t aDescriptor,
	char const *aLocale,
	struct aorp_error *anErrPtr
# endif
	);

# define AorpGetdescriptor_l(aThis, aDescriptor, aLocale, anErrPtr) \
	_A_call(get_l, descriptor, aThis, anErrPtr, aDescriptor, aLocale)

__MYC_END_CDECLS

#endif /* !__BO_SERVICES_DESTOR__ */

/******************************************************************************
 * Revision History:
 *		$Log$
 *
 *****************************************************************************/
