/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright (c) 2005-2007 V.Sokur
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

/*
 * Dup.h	(V.Sokur)
 * include/Bo/services/Dup.h
 *
 * $Id$
 */

/* ------------------------------------------------------------------------- */

#ifndef __BO_SERVICES_DUP__
# define __BO_SERVICES_DUP__

/******************************************************************************
 * %% BeginSection: includes
 */

# include <Bo/services/DupP.h>

/******************************************************************************
 * %% BeginSection: function prototypes
 */
# pragma mark -
# pragma mark [ function prototypes ]
# pragma mark -

# include <Bo/BoLinkage.h>

__MYC_BEGIN_CDECLS

# define AorpDup(aThis, Flags, aMemory, anExtraSize, anErrPtr) \
	AorpDup4(aThis, Flags, aMemory, anExtraSize, anErrPtr)

__myc_flinkage__(public,libBo) aorp_object_t
__attribute__((nonnull(1)))
AorpDup4(
# if __myc_require(prototypes)
	aorp_object_t aThis,
	aorp_opflags_t Flags __myc_defval__(0),
	bo_pointer_t aMemory __myc_defval__(NULL),
	size_t anExtraSize __myc_defval__(0),
	struct aorp_error *anErrPtr __myc_defval__(NULL)
# endif
	);

# if __myc_support(macro_retval)
#  define AorpDup4(aThis, Flags, aMemory, anExtraSize, anErrPtr) \
	__extension__ ({ \
		bo_stsptr_t ___retval; \
		___retval = _A_call( \
			dup4, duplicator, aThis, anErrPtr, \
			aThis, Flags, aMemory, anExtraSize \
		); \
		/* return */ aorp_object_p(BoSP_NORMAL(___retval) ? BO_PTR_FROM_STATUS(___retval) : BoS_EPTR); \
	})
# else /* !__myc_support(macro_retval) */
#  define AorpDup4(aThis, Flags, aMemory, anExtraSize, anErrPtr) \
	_im_AorpDup4(aThis, Flags, aMemory, anExtraSize, anErrPtr)
__myc_extern_inline__ aorp_object_t
__attribute__((nonnull(1)))
_im_AorpDup4(
# if __myc_require(prototypes)
	aorp_object_t aThis,
	aorp_opflags_t Flags,
	bo_pointer_t aMemory,
	size_t anExtraSize,
	struct aorp_error *anErrPtr
# else
	aThis, Flags, aMemory, anExtraSize, anErrPtr
# endif
	)
# if !__myc_require(prototypes)
	aorp_object_t aThis;
	aorp_opflags_t Flags;
	bo_pointer_t aMemory;
	size_t anExtraSize;
	struct aorp_error *anErrPtr;
# endif
{
	bo_stsptr_t retval;
	retval = _A_call(
		dup4, duplicator, aThis, anErrPtr,
		aThis, Flags, aMemory, anExtraSize
	);
	return aorp_object_p(BoSP_NORMAL(retval) ? BO_PTR_FROM_STATUS(retval) : BoS_EPTR);
}
# endif /* __myc_support(macro_retval) */

/* ------------------------------------------------------------------------- */
# pragma mark -
/* ------------------------------------------------------------------------- */

__myc_flinkage__(public,libBo) aorp_object_t
__attribute__((nonnull(1)))
AorpDup5(
# if __myc_require(prototypes)
	aorp_object_t aThis,
	aorp_opflags_t Flags __myc_defval__(0),
	bo_pointer_t aMemory __myc_defval__(NULL),
	size_t anExtraSize __myc_defval__(0),
	bo_pointer_t aParm __myc_defval__(0),
	struct aorp_error *anErrPtr __myc_defval__(NULL)
# endif
	);

# if __myc_support(macro_retval)
#  define AorpDup5(aThis, Flags, aMemory, anExtraSize, aParm, anErrPtr) \
	__extension__ ({ \
		bo_stsptr_t ___retval; \
		___retval = _A_call( \
			dup5, duplicator, aThis, anErrPtr, \
			aThis, Flags, aMemory, anExtraSize, aParm \
		); \
		/* return */ aorp_object_p(BoSP_NORMAL(___retval) ? BO_PTR_FROM_STATUS(___retval) : BoS_EPTR); \
	})
# else /* !__myc_support(macro_retval) */
#  define AorpDup5(aThis, Flags, aMemory, anExtraSize, aParm, anErrPtr) \
	_im_AorpDup5(aThis, Flags, aMemory, anExtraSize, aParm, anErrPtr)
__myc_extern_inline__ aorp_object_t
__attribute__((nonnull(1)))
_im_AorpDup5(
# if __myc_require(prototypes)
	aorp_object_t aThis,
	aorp_opflags_t Flags,
	bo_pointer_t aMemory,
	size_t anExtraSize,
	bo_pointer_t aParm,
	struct aorp_error *anErrPtr
# else
	aThis, Flags, aMemory, anExtraSize, aParm, anErrPtr
# endif
	)
# if !__myc_require(prototypes)
	aorp_object_t aThis;
	aorp_opflags_t Flags;
	bo_pointer_t aMemory;
	size_t anExtraSize;
	bo_pointer_t aParm;
	struct aorp_error *anErrPtr;
# endif
{
	bo_stsptr_t retval;
	retval = _A_call(
		dup5, duplicator, aThis, anErrPtr,
		aThis, Flags, aMemory, anExtraSize, aParm
	);
	return aorp_object_p(BoSP_NORMAL(retval) ? BO_PTR_FROM_STATUS(retval) : BoS_EPTR);
}
# endif /* __myc_support(macro_retval) */

/* ------------------------------------------------------------------------- */
# pragma mark -
/* ------------------------------------------------------------------------- */

__myc_flinkage__(public,libBo) aorp_object_t
__attribute__((nonnull(1)))
AorpDupf(
# if __myc_require(prototypes)
	aorp_object_t aThis,
	aorp_opflags_t Flags __myc_defval__(0),
	bo_pointer_t aMemory  __myc_defval__(NULL),
	size_t anExtraSize __myc_defval__(0),
	struct aorp_dup_predicate *aFilter __myc_defval__(NULL),
	struct aorp_error *anErrPtr __myc_defval__(NULL)
# endif
	);

# if __myc_support(macro_retval)
#  define AorpDupf(aThis, Flags, aMemory, anExtraSize, aFilter, anErrPtr) \
	__extension__ ({ \
		bo_stsptr_t ___retval; \
		___retval = _A_call( \
			dupf, duplicator, aThis, anErrPtr, \
			aThis, Flags, aMemory, anExtraSize, aFilter \
		); \
		/* return */ aorp_object_p(BoSP_NORMAL(___retval) ? BO_PTR_FROM_STATUS(___retval) : BoS_EPTR); \
	})
# else /* !__myc_support(macro_retval) */
#  define AorpDupf(aThis, Flags, aMemory, anExtraSize, aFilter, anErrPtr) \
	_im_AorpDupf(aThis, Flags, aMemory, anExtraSize, aFilter, anErrPtr)
__myc_extern_inline__ aorp_object_t
__attribute__((nonnull(1)))
_im_AorpDupf(
# if __myc_require(prototypes)
	aorp_object_t aThis,
	aorp_opflags_t Flags,
	bo_pointer_t aMemory,
	size_t anExtraSize,
	struct aorp_dup_predicate *aFilter,
	struct aorp_error *anErrPtr
# else
	aThis, Flags, aMemory, anExtraSize, aFilter, anErrPtr
# endif
	)
# if !__myc_require(prototypes)
	aorp_object_t aThis;
	aorp_opflags_t Flags;
	bo_pointer_t aMemory;
	size_t anExtraSize;
	struct aorp_dup_predicate *aFilter;
	struct aorp_error *anErrPtr;
# endif
{
	bo_stsptr_t retval;
	retval = _A_call(
		dupf, duplicator, aThis, anErrPtr,
		aThis, Flags, aMemory, anExtraSize, aFilter
	);
	return aorp_object_p(BoSP_NORMAL(retval) ? BO_PTR_FROM_STATUS(retval) : BoS_EPTR);
}
# endif /* __myc_support(macro_retval) */

/* ------------------------------------------------------------------------- */
# pragma mark -
/* ------------------------------------------------------------------------- */

# ifndef AORP_LAZY_DUP_DECLARED
#  define AORP_LAZY_DUP_DECLARED
/* retain used */
__myc_flinkage__(public,libBo) aorp_object_t
__myc_calltype__(mcall)
__attribute__((nonnull(1)))
AorpLazydup(
# if __myc_require(prototypes)
	aorp_object_t aThis,
	aorp_opflags_t Flags __myc_defval__(0),  /* unused */
	bo_pointer_t aParm __myc_defval__(NULL), /* unused */
	struct aorp_error *anErrPtr __myc_defval__(NULL)
# endif
	);
# endif /* !AORP_LAZY_DUP_DECLARED */

/* ------------------------------------------------------------------------- */
# pragma mark -
/* ------------------------------------------------------------------------- */

__myc_flinkage__(public,libBo) aorp_object_t
__myc_calltype__(mcall)
__attribute__((nonnull(1)))
AorpDups(
# if __myc_require(prototypes)
	aorp_object_t aThis,
	aorp_opflags_t Flags __myc_defval__(0),
	struct aorp_error *anErrPtr __myc_defval__(NULL)
# endif
	);

# define AorpDups(aThis,Flags,anErrPtr) \
	AorpDup(aThis,Flags,NULL,0,anErrPtr)

/* ------------------------------------------------------------------------- */
# pragma mark -
/* ------------------------------------------------------------------------- */

__myc_flinkage__(public,libBo) aorp_object_t
__myc_calltype__(mcall)
__attribute__((nonnull(1)))
AorpDups2(
# if __myc_require(prototypes)
	aorp_object_t aThis,
	aorp_opflags_t Flags __myc_defval__(0),
	bo_pointer_t aParm __myc_defval__(NULL), /* unused */
	struct aorp_error *anErrPtr __myc_defval__(NULL)
# endif
	);

# define AorpDups2(aThis,Flags,aParm,anErrPtr) \
	AorpDup(aThis,Flags,NULL,0,anErrPtr)

__MYC_END_CDECLS

#endif /* !__BO_SERVICES_DUP__ */

/******************************************************************************
 * Revision History:
 *		$Log$
 *
 *****************************************************************************/
