/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright (c) 2005-2007 V.Sokur
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

/*
 * DupP.h	(V.Sokur)
 * include/Bo/services/DupP.h
 *
 * $Id$
 */

/* ------------------------------------------------------------------------- */

#ifndef __BO_SERVICES_DUP_P__
# define __BO_SERVICES_DUP_P__

/******************************************************************************
 * %% BeginSection: includes
 */

# include <Bo/sys/Types.h>

/******************************************************************************
 * %% BeginSection: duplicator service declarations
 */
# pragma mark -
# pragma mark [ duplicator service declarations ]
# pragma mark -

# define __aorpc_need_service_duplicator 1

#endif /* !__BO_SERVICES_DUP_P__ */

#pragma mark -

#if __aorpc_uses_service(duplicator)
# undef __aorpc_need_service_duplicator

/*
 * duplicator service
 * @{
 */

/*
 * duplicator {\object(class)}
 */
/*
# define AorpK_duplicator_service (1004)
 */
# include <Bo/services/MIB/Services.h>

# define __aorpc_service_name duplicator
# include <Bo/aorp/AorpCsrvc.h>

_A_service(duplicator)
_A_end_ctb

	_A_attribute((nonnull(1,3)))
	_A_op(dup4, "dup::clone-object", (
			struct aorp_closure *aClosure,
			struct aorp_error *anErrPtr,
			aorp_object_t aSource,
			aorp_opflags_t Flags,
			bo_pointer_t aMemory,
			size_t anExtraSize
		)),

	_A_attribute((nonnull(1,3)))
	_A_op(dup5, "dup::clone-object-with-params", (
			struct aorp_closure *aClosure,
			struct aorp_error *anErrPtr,
			aorp_object_t aSource,
			aorp_opflags_t Flags,
			bo_pointer_t aMemory,
			size_t anExtraSize,
			bo_pointer_t Params
		)),

	_A_attribute((nonnull(1,3,4)))
	_A_op(dupf, "dup::clone-object-with-predicate", (
			struct aorp_closure *aClosure,
			struct aorp_error *anErrPtr,
			aorp_object_t *anObjectPtr,
			aorp_object_t aSource,
			aorp_opflags_t Flags,
			bo_pointer_t aMemory,
			size_t anExtraSize,
			struct aorp_dup_predicate *aFilter
		)),

_A_end;

# include <Bo/aorp/AorpCend.h>
/* @} */
#endif /* __aorpc_uses_service(duplicator) */

/******************************************************************************
 * Revision History:
 *		$Log$
 *
 *****************************************************************************/
