/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright (c) 2005-2007 V.Sokur
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

/*
 * Lrostypes.h	(V.Sokur)
 * include/Bo/services/Lrostypes.h
 *
 * $Id$
 */

/* ------------------------------------------------------------------------- */

#ifndef __BO_SERVICES_LROSTYPES__
# define __BO_SERVICES_LROSTYPES__

/******************************************************************************
 * %% BeginSection: includes
 */

# ifndef LROS_NO_BO_TYPES_HEADER
#  include <Bo/Types.h>
# else
#  include <stddef.h>
# endif

/******************************************************************************
 * %% BeginSection: constant declarations
 */
# pragma mark -
# pragma mark [ constant declarations ]
# pragma mark -

/*
 * Missing types and constants
 */
# ifdef LROS_NO_BO_TYPES_HEADER

#  define __myc_tcalltype__(x)
#  define __attribute__(x)


# ifndef _BO_MKVERSION
#  define _BO_MKVERSION(aMajor,aMinor,aTeeny) \
	((((u_int32_t)(aMajor) & 0xff) << 24) | \
		(((u_int32_t)(aMinor) & 0xff) << 16) | \
		((u_int32_t)(aTeeny) & 0xffff))
# endif

# ifndef BoK_INFINITE_DURATION
#  define BoK_INFINITE_DURATION (-1LL)
# endif


# ifndef FAM_LENGTH
#  ifdef __cplusplus
#   define FAM_LENGTH	1
#  else
#  if 0
#   define FAM_LENGTH	/* 0 */
#  else
#   define FAM_LENGTH	1
#  endif /* __myc_support(FAM) */
#  endif /* __cplusplus */
# endif /* FAM_LENGTH */


# ifdef _MSC_VER

#  define HAS_INT8_TYPE
#  define HAS_U_INT8_TYPE
#  define HAS_INT16_TYPE
#  define HAS_U_INT16_TYPE
#  define HAS_INT32_TYPE
#  define HAS_U_INT32_TYPE
#  define HAS_INT64_TYPE
#  define HAS_U_INT64_TYPE

#  define HAS_SIZE_TYPE
#  define HAS_INTPTR_TYPE
#  define HAS_UINTPTR_TYPE

typedef __int8 int8_t;
typedef unsigned __int8 u_int8_t;
typedef __int16	int16_t;
typedef unsigned __int16 u_int16_t;
typedef __int32 int32_t;
typedef unsigned __int32 u_int32_t;
typedef __int64 int64_t;
typedef unsigned __int64 u_int64_t;

/* assume wINDOWS */
#  define __BO_PID_TYPE__ DWORD

# endif /* _MSC_VER */

# ifndef HAS_INT8_TYPE
typedef char int8_t;
# endif

# ifndef HAS_UINT8_TYPE
#  ifdef HAS_U_INT8_TYPE
typedef u_int8_t uint8_t;
#  else
typedef unsigned int8_t uint8_t;
#  endif
# endif

# ifndef HAS_U_INT8_TYPE
#  ifdef HAS_UINT8_TYPE
typedef uint8_t u_int8_t;
#  else
typedef unsigned int8_t u_int8_t;
#  endif
# endif

# ifndef HAS_INT16_TYPE
typedef short int16_t;
# endif

# ifndef HAS_UINT16_TYPE
#  ifdef HAS_U_INT16_TYPE
typedef u_int16_t uint16_t;
#  else
typedef unsigned int16_t uint16_t;
#  endif
# endif

# ifndef HAS_U_INT16_TYPE
#  ifdef HAS_UINT16_TYPE
typedef uint16_t u_int16_t;
#  else
typedef unsigned int16_t u_int16_t;
#  endif
# endif

# ifndef HAS_INT32_TYPE
typedef long int32_t;
# endif

# ifndef HAS_UINT32_TYPE
#  ifdef HAS_U_INT32_TYPE
typedef u_int32_t uint32_t;
#  else
typedef unsigned int32_t uint32_t;
#  endif
# endif

# ifndef HAS_U_INT32_TYPE
#  ifdef HAS_UINT32_TYPE
typedef uint32_t u_int32_t;
#  else
typedef unsigned int32_t u_int32_t;
#  endif
# endif

# ifndef HAS_INT64_TYPE
#  ifndef LROS_NO_LONG_LONG_TYPE
typedef long long int64_t;
#  endif
# endif

# ifndef HAS_UINT64_TYPE
#  ifdef HAS_U_INT64_TYPE
typedef u_int64_t uint64_t;
#  else
#  ifdef HAS_INT64_TYPE
typedef unsigned int64_t uint64_t;
#  else
#  ifndef LROS_NO_LONG_LONG_TYPE
typedef unsigned long long uint64_t;
#  endif
#  endif
#  endif
# endif

# ifndef HAS_U_INT64_TYPE
#  ifdef HAS_UINT64_TYPE
typedef uint64_t u_int64_t;
#  else
#  ifdef HAS_INT64_TYPE
typedef unsigned int64_t u_int64_t;
#  else
#  ifndef LROS_NO_LONG_LONG_TYPE
typedef unsigned int64_t u_int64_t;
#  endif
#  endif
#  endif
# endif


# ifndef HAS_SIZE_TYPE
#  ifndef __SIZE_TYPE_DEFINED__
#   define __SIZE_TYPE_DEFINED__
typedef unsigned long size_t;
#  endif
# endif

# ifndef HAS_SSIZE_TYPE
#  ifndef __SSIZE_TYPE_DEFINED__
#   define __SSIZE_TYPE_DEFINED__
typedef long ssize_t;
#  endif
# endif

# ifndef __BO_POINTER_TYPE_DEFINED__
#  define __BO_POINTER_TYPE_DEFINED__
typedef void *bo_pointer_t;
typedef void const *bo_const_pointer_t;
# endif


# ifdef HAS_INT64_TYPE
typedef u_int64_t   bo_tick_t;
typedef int64_t     bo_time_t;
typedef int64_t     bo_time_x;
# else
typedef u_int32_t   bo_tick_t;
typedef int32_t     bo_time_t;
typedef int32_t     bo_time_x;
# endif

/* The number of milliseconds since 0 hour January 1, 1970
   Coordinated Universal Time (UTC). */
typedef bo_time_t   bo_mtime_t;
typedef bo_time_x   bo_mtime_x;

/* The number of microseconds since 0 hour January 1, 1970
   Coordinated Universal Time (UTC). */
typedef bo_time_t   bo_utime_t;
typedef bo_time_x   bo_utime_x;

/* The number of nanoseconds since 0 hour January 1, 1970
   Coordinated Universal Time (UTC). */
typedef bo_time_t   bo_ntime_t;
typedef bo_time_x   bo_ntime_x;

typedef bo_time_t   bo_sec_t;  /* duration in seconds */
typedef bo_time_x   bo_sec_x;

typedef bo_time_t   bo_msec_t; /* duration in milliseconds */
typedef bo_time_x   bo_msec_x;

typedef bo_time_t   bo_usec_t; /* duration in microseconds */
typedef bo_time_x   bo_usec_x;

typedef bo_time_t   bo_nsec_t; /* duration in nanoseconds */
typedef bo_time_x   bo_nsec_x;


# ifndef HAS_PID_TYPE
#  ifdef __BO_PID_TYPE__
typedef __BO_PID_TYPE__ pid_t;
#  else
typedef int32_t pid_t;
#  endif
# endif


# ifdef HAS_INT64_TYPE
typedef int64_t     bo_status_t;
typedef int64_t     bo_status_x;
# else
typedef int32_t     bo_status_t;
typedef int32_t     bo_status_x;
# endif

typedef int32_t     bo_errcode_t;
typedef u_int16_t   bo_errcode_x;


# ifndef __BO_ABSBUFX_STRUC_DEFINED__
#  define __BO_ABSBUFX_STRUC_DEFINED__
struct bo_malloc;

struct bo_absbufx {
	struct bo_malloc const *alloc; /* used on base */
	size_t                  size;
	bo_pointer_t            base;
};

struct bo_nabsbufx {
	struct bo_malloc const *alloc; /* used on base */
	size_t                  capacity;
	size_t                  size;
	bo_pointer_t            base;
};
# endif /* !__BO_ABSBUFX_STRUC_DEFINED__ */

# ifndef __BO_MALLOC_STRUC_DEFINED__
#  define __BO_MALLOC_STRUC_DEFINED__

typedef bo_pointer_t
(*bo_malloc_alloc_fn)(size_t );

typedef bo_pointer_t
(*bo_malloc_calloc_fn)(size_t anElemc, size_t anElemsz);

typedef bo_pointer_t
(*bo_malloc_realloc_fn)(bo_pointer_t , size_t );

typedef void
(*bo_malloc_free_fn)(bo_pointer_t );

struct bo_malloc {
	bo_malloc_alloc_fn    mm_alloc;
	bo_malloc_calloc_fn   mm_calloc;
	bo_malloc_realloc_fn  mm_realloc;
	bo_malloc_free_fn     mm_free;
};

#  define BO_MALLOC_ZERO_INITIALIZER { NULLF, NULLF, NULLF, NULLF }

# endif /* !__BO_MALLOC_STRUC_DEFINED__ */

# endif /* LROS_NO_BO_TYPES_HEADER */

/* ------------------------------------------------------------------------- */
# pragma mark -
/* ------------------------------------------------------------------------- */

/*
 * Duration constants
 */

# define LrosK_INFINITE_DURATION BoK_INFINITE_DURATION

/*
 * Header size
 */

# define LrosK_HEADER_SIZE 72
# define LrosL_PACKET_SIZE_MIN LrosK_HEADER_SIZE

/*
 * Light-weight Remote Operation Service VERSION
 */

# define LrosK_SERVICE_VERSION 1

/*
 * Byte Order declaration
 */

# define LrosK_BIG_BYTE_ORDER 1
# define LrosK_LITTLE_BYTE_ORDER 0

/*
 * Operation priority
 */

# define LrosK_MAX_PRIORITY (4)
# define LrosK_HIGH_PRIORITY (2)
# define LrosK_NORMAL_PRIORITY (0)
# define LrosK_LOW_PRIORITY (-2)
# define LrosK_MIN_PRIORITY (-4)

/*
 * Operation types
 */

# define LrosK_INVAL_OPTYPE (-1)
# define LrosK_NULL_OPTYPE (0)
# define LrosK_UNK_OPTYPE (2)

# define LrosK_INVOKE_OPTYPE (3)
# define LrosK_RESULT_OPTYPE (4)
# define LrosK_ERROR_OPTYPE (5)
# define LrosK_REJECT_U_OPTYPE (6)
# define LrosK_REJECT_P_OPTYPE (7)

/*
 * Operation classes
 */

# define LrosK_SYNC_CALL (0)
# define LrosK_ASYNC_CALL (1)

# define LrosK_ASYNC_CALL_BIT (2)
# define LrosK_RESULT_BIT 3
# define LrosK_ERROR_BIT 4

# define LrosF_SYNC_CALL (0)
# define LrosF_ASYNC_CALL (1 << LrosK_ASYNC_CALL_BIT)
# define LrosF_RESULT (1 << LrosK_RESULT_BIT)
# define LrosF_ERROR (1 << LrosK_ERROR_BIT)


# define LrosK_INVAL_OPCLASS (-1)
# define LrosK_NULL_OPCLASS (0)
# define LrosK_UNK_OPCLASS (2)

# define LrosK_ANONE_OPCLASS LrosF_ASYNC_CALL
# define LrosK_SRE_OPCLASS (LrosF_SYNC_CALL | LrosF_RESULT | LrosF_ERROR)  /* synchronous  + (result or error) */
# define LrosK_ARE_OPCLASS (LrosF_ASYNC_CALL | LrosF_RESULT | LrosF_ERROR) /* asynchronous + (result or error) */
# define LrosK_AR_OPCLASS (LrosF_ASYNC_CALL | LrosF_RESULT)                /* asynchronous + (result only)  */
# define LrosK_AE_OPCLASS (LrosF_ASYNC_CALL | LrosF_ERROR)                 /* asynchronous + (error only, if any)   */

/*
 * Operation codes
 */

# define LrosK_INVAL_OPCODE (-1)
# define LrosK_NULL_OPCODE (0)
# define LrosK_UNK_OPCODE (2)

# define LrosK_BIND_OPCODE (3)
# define LrosK_UNBIND_OPCODE (4)
# define LrosK_START_OPCODE (5)
# define LrosK_STOP_OPCODE (6)

# define LrosK_USER_OPCODE (20)

/*
 * Operation results re-codes
 */

# define LrosK_INVAL_RETCODE (-1)
# define LrosK_NULL_RETCODE (0)
# define LrosK_UNK_RETCODE (2)

# define LrosK_SUCCESS_RETCODE (3)
# define LrosK_PARTIAL_SUCCESS_RETCODE (4)
# define LrosK_REFFERAL_RETCODE (5)

/* ============================================================================
 * Light-weight Remote Operation Service PACKET DECLARATIONS
 * @{
 */
# pragma mark -
# pragma mark [ lros-packet declarations ]
# pragma mark -

struct lros_packet_header {
	u_int32_t  lrp_packet_len;  /* including the header */
	u_int8_t   lrp_version;
	u_int8_t   lrp_databyteorder;
	u_int8_t   lrp_priority;
	u_int8_t   lrp_padding;
	u_int8_t   lrp_optype;
	u_int8_t   lrp_opclass;
	u_int16_t  lrp_opcode;
	u_int16_t  lrp_data_offs;
	u_int16_t  lrp_data_len;

	/* currently */
	u_int32_t  lrp_invoker_ip[4]; /* IPv4: use lrp_invoker_ip[0] */

	u_int64_t  lrp_process_id;    /* wINDOWS: GetCurrentProcessId */
	u_int64_t  lrp_invoke_id;     /* use high 32 bits */
	u_int64_t  lrp_linked_id;

	u_int64_t  lrp_timestamp1;
		/* current timestamp when making packet */
	u_int64_t  lrp_timestamp2;
		/* result(error, reject): timestamp2 of an invoke packet
		   invoke: timestamp2 = timestamp1 */
};
typedef struct lros_packet_header lros_packet_header_t;

# define LROS_PACKET_VERSION(aPacket) ((aPacket)->lrp_version)
# define LROS_PACKET_LEN(aPacket) ((aPacket)->lrp_packet_len)
# define LROS_PACKET_PADDING(aPacket) ((aPacket)->lrp_padding)
# define LROS_PACKET_PRIORITY(aPacket) ((aPacket)->lrp_priority)
# define LROS_PACKET_OPTYPE(aPacket) ((aPacket)->lrp_optype)
# define LROS_PACKET_OPCLASS(aPacket) ((aPacket)->lrp_opclass)
# define LROS_PACKET_OPCODE(aPacket) ((aPacket)->lrp_opcode)
# define LROS_PACKET_DATA_OFFS(aPacket) ((aPacket)->lrp_data_offs)
# define LROS_PACKET_DATA_LEN(aPacket) ((aPacket)->lrp_data_len)
# define LROS_PACKET_DATA_BORDER(aPacket) ((aPacket)->lrp_databyteorder)
# define LROS_PACKET_INVOKER_IP(aPacket) ((aPacket)->lrp_invoker_ip)
# define LROS_PACKET_PROCESS_ID(aPacket) ((aPacket)->lrp_process_id)
# define LROS_PACKET_INVOKE_ID(aPacket) ((aPacket)->lrp_invoke_id)
# define LROS_PACKET_LINKED_ID(aPacket) ((aPacket)->lrp_linked_id)
# define LROS_PACKET_TIMESTAMP1(aPacket) ((aPacket)->lrp_timestamp1)
# define LROS_PACKET_TIMESTAMP2(aPacket) ((aPacket)->lrp_timestamp2)

# define LROS_PACKET_DATA(aPacket) (((char *)(aPacket)) + (aPacket)->lrp_data_offs)

/*
 * Packet data declarations
 */

struct lros_error_data {
	u_int16_t  e_code;
	char       e_msg[FAM_LENGTH];
};
typedef struct lros_error_data lros_error_data_t;

struct lros_reject_data {
	u_int16_t  rj_reason;
	char       rj_msg[FAM_LENGTH];
};
typedef struct lros_reject_data lros_reject_data_t;

struct lros_result_data {
	u_int16_t  re_code;
	char       re_value[FAM_LENGTH];
};
typedef struct lros_result_data lros_result_data_t;

struct lros_invoke_data {
	char       i_argbuf[FAM_LENGTH];
};
typedef struct lros_invoke_data lros_invoke_data_t;

/******************************************************************************
 * %% BeginSection: type declarations
 */
# pragma mark -
# pragma mark [ type declarations ]
# pragma mark -

/*
 * User data declarations
 */

# ifndef LROS_NO_BO_TYPES_HEADER

typedef bo_status_t
(__myc_tcalltype__(mcall) *lros_call_fn)() __attribute__((mcalltype));

typedef bo_status_t
(__myc_tcalltype__(mcall) *lros_invoke_cb)(
# if __myc_require(prototypes)
	int aByteorder,                   /* argument byteorder */
	bo_const_pointer_t anInputBuffer, /* input arg data buffer */
	size_t anInputBufsz,              /* size of input arg data */
	int *anOutputByteorderPtr,        /* output data byteorder */
	struct bo_absbufx *anOutputBuffer /* for output result data */
# endif
	) __attribute__((mcalltype));

typedef bo_status_t
(__myc_tcalltype__(mcall) *lros_result_handler)(
# if __myc_require(prototypes)
	int aByteorder,              /* argument byteorder */
	bo_const_pointer_t aBuffer,  /* resul data buffer */
	size_t aBufsz                /* size of resul data */
# endif
	) __attribute__((mcalltype));

typedef bo_status_t
(__myc_tcalltype__(mcall) *lros_error_handler)(
# if __myc_require(prototypes)
	u_int32_t anOpcode,      /* code of operation */
	bo_errcode_t anErrcode,  /* error code */
	char const *anErrmsg     /* error message */
# endif
	) __attribute__((mcalltype));

typedef bo_status_t
(__myc_tcalltype__(mcall) *lros_reject_handler)(
# if __myc_require(prototypes)
	u_int32_t anOpcode,     /* code of operation */
	bo_errcode_t aReason,   /* reason code */
	char const *aMsg        /* reject message */
# endif
	) __attribute__((mcalltype));

# else

typedef bo_status_t (*lros_call_fn)();

typedef bo_status_t
(*lros_invoke_cb)(
	int aByteorder,                   /* argument byteorder */
	bo_const_pointer_t anInputBuffer, /* input arg data buffer */
	size_t anInputBufsz,              /* size of input arg data */
	int *anOutputByteorderPtr,        /* output data byteorder */
	struct bo_absbufx *anOutputBuffer /* for output result data */
	);

typedef bo_status_t
(*lros_result_handler)(
	int aByteorder,             /* argument byteorder */
	bo_const_pointer_t aBuffer, /* resul data buffer */
	size_t aBufsz               /* size of resul data */
	);

typedef bo_status_t
(*lros_error_handler)(
	u_int32_t anOpcode,      /* code of operation */
	bo_errcode_t anErrcode,  /* error code */
	char const *anErrmsg     /* error message */
	);

typedef bo_status_t
(*lros_reject_handler)(
	u_int32_t anOpcode,     /* code of operation */
	bo_errcode_t aReason,   /* reason code */
	char const *aMsg        /* reject message */
	);

# endif /* !LROS_NO_BO_TYPES_HEADER */

struct lros_callent {
	u_int32_t     opcode;
	u_int32_t     opclass;
	lros_call_fn  opimpl;   /* lros_invoke_cb, lros_result_handler */
	bo_msec_t     duration;
	u_int32_t     recallc;
};

struct lros_context {
	u_int32_t            host_ip;
	pid_t                remote_pid;
	struct lros_callent *calltab;
	lros_error_handler   err_handler;
	lros_reject_handler  rej_handler;
};

#endif /* !__BO_SERVICES_LROSTYPES__ */

/******************************************************************************
 * Revision History:
 *		$Log$
 *
 *****************************************************************************/
