/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright (c) 2005-2007 V.Sokur
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

/*
 * Lstner.h	(V.Sokur)
 * include/Bo/services/Lstner.h
 *
 * $Id$
 */

/* ------------------------------------------------------------------------- */

#ifndef __BO_SERVICES_LSTNER__
# define __BO_SERVICES_LSTNER__

/******************************************************************************
 * %% BeginSection: includes
 */

# include <Bo/services/LstnerP.h>

/******************************************************************************
 * %% BeginSection: function prototypes
 */
# pragma mark -
# pragma mark [ function prototypes ]
# pragma mark -

__MYC_BEGIN_CDECLS

/*
ssize_t
__attribute__((nonnull(1)))
AorpNotifierCount(
	aorp_object_t aThis,
	struct aorp_error *anErrPtr
	);
 */
# define AorpNotifierCount(aThis, anErrPtr) \
	_A_call(notifierc, listener, aThis, anErrPtr)

# pragma mark -

/*
bo_status_t
__attribute__((nonnull(1)))
_AorpClearNotifiers(
	aorp_object_t aThis,
	struct aorp_error *anErrPtr
	);
 */
# define _AorpClearNotifiers(aThis, anErrPtr) \
	_A_call(clearnotifiers, listener, aThis, anErrPtr)

# pragma mark -

/*
bo_status_t
__attribute__((nonnull(1,2)))
AorpAttachToNotifier(
	aorp_object_t aThis,
	aorp_object_t aNtfier,
	int32_t *Events // = NULL: all events; app is responsible for the event-set lifetime
	struct aorp_error *anErrPtr
	);
 */
# define AorpAttachToNotifier(aThis, aNtfier, Events, anErrPtr) \
	_A_call(attachtonotifier, listener, aThis, anErrPtr, aNtfier, Events)

# pragma mark -

/*
bo_status_t
__attribute__((nonnull(1,2)))
AorpDetachFromNotifier(
	aorp_object_t aThis,
	aorp_object_t aNtfier,
	struct aorp_error *anErrPtr
	);
 */
# define AorpDetachFromNotifier(aThis, aNtfier, anErrPtr) \
	_A_call(detachfromnotifier, listener, aThis, anErrPtr, aNtfier)

# pragma mark -

/*
bo_status_t
__attribute__((nonnull(1)))
AorpBecomeDeaf(
	aorp_object_t aThis,
	struct aorp_error *anErrPtr
	);
 */
# define AorpBecomeDeaf(aThis, anErrPtr) \
	_A_call(becomedeaf, listener, aThis, anErrPtr)

# pragma mark -

/*
bo_status_t
__attribute__((nonnull(1)))
AorpBecomeAware(
	aorp_object_t aThis,
	struct aorp_error *anErrPtr
	);
 */
# define AorpBecomeAware(aThis, anErrPtr) \
	_A_call(becomeaware, listener, aThis, anErrPtr)

# pragma mark -

/*
bo_stsbool_t
__attribute__((nonnull(1)))
AorpIsAware(
	aorp_object_t aThis,
	struct aorp_error *anErrPtr
	);
 *
 * true: BoS_OK
 * false: BoS_NORMAL
 */
# define AorpIsAware(aThis, anErrPtr) \
	_A_call(isaware, listener, aThis, anErrPtr)

# pragma mark -

/* NOT FOR YOUR BUSINESS */
/* @{ */

/*
bo_status_t
__attribute__((nonnull(1,2)))
_AorpListen(
	aorp_object_t ,
	aorp_object_t ,
	bo_notice_t ,
	struct aorp_error *
	);
 */
# define _AorpListen(x, y1, y2, z) _A_call(listen, listener, x, z, y1, y2)

# pragma mark -

/*
bo_status_t
__attribute__((nonnull(1,2)))
_AorpUnlinkNotifier(
	aorp_object_t ,
	aorp_object_t ,
	struct aorp_error *
	);
 */
# define _AorpUnlinkNotifier(x, y, z) \
	_A_call(unlinknotifier, listener, x, z, y)

# pragma mark -

/*
bo_status_t
__attribute__((nonnull(1,2)))
_AorpUnlinkNotifier_nlk(
	aorp_object_t ,
	aorp_object_t ,
	struct aorp_error *
	);
 */
# define _AorpUnlinkNotifier_nlk(x, y, z) \
	_A_call(unlinknotifier_nlk, listener, x, z, y)

/* @} */

__MYC_END_CDECLS

#endif /* !__BO_SERVICES_LSTNER__ */

/******************************************************************************
 * Revision History:
 *		$Log$
 *
 *****************************************************************************/
