/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright (c) 2005-2007 V.Sokur
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

/*
 * LstnerP.h	(V.Sokur)
 * include/Bo/services/LstnerP.h
 *
 * $Id$
 */

/* ------------------------------------------------------------------------- */

#ifndef __BO_SERVICES_LSTNER_P__
# define __BO_SERVICES_LSTNER_P__

/******************************************************************************
 * %% BeginSection: includes
 */

# include <Bo/services/Ntfiertypes.h>

/******************************************************************************
 * %% BeginSection: listener service declarations
 */
# pragma mark -
# pragma mark [ listener service declarations ]
# pragma mark -

# define __aorpc_need_service_listener 1

#endif /* !__BO_SERVICES_LSTNER_P__ */

#pragma mark -

#if __aorpc_uses_service(listener)
# undef __aorpc_need_service_listener

/*
 * listener service
 * @{
 */

/*
 * listener {\object(instance)}
 */
/*
# define AorpK_listener_service (1019)
 */
# include <Bo/services/MIB/Services.h>

# define __aorpc_service_name listener
# include <Bo/aorp/AorpCsrvc.h>

_A_service(listener)

# if __aorpc_interface

typedef bo_status_t
(__myc_tcalltype__(mcall) *aorp_listener_client_cb)(
# if __myc_require(prototypes)
		bo_pointer_t anUserdata,
		aorp_object_t aNtfier,
		bo_pointer_t aPacket,
		struct aorp_error *anErrPtr
# endif
	) __attribute__((mcalltype));

	struct aorp_listener_client_context {
		aorp_listener_client_cb  cb;
		bo_pointer_t             udata;
	};

# endif /* __aorpc_interface */

_A_end_ctb

	_A_attribute((nonnull(1)))
	_A_op(notifierc, "listener::notifier-count", (
			struct aorp_closure *aClosure,
			struct aorp_error *anErrPtr
		)),

	_A_attribute((nonnull(1)))
	_A_op(clearnotifiers, "listener::clear-notifiers", (
			struct aorp_closure *aClosure,
			struct aorp_error *anErrPtr
		)),

	_A_attribute((nonnull(1,3)))
	_A_op(listen, "listener::listen", (
			struct aorp_closure *aClosure,
			struct aorp_error *anErrPtr,
			aorp_object_t aNtfier,
			bo_notice_t aNotice
		)),

	_A_attribute((nonnull(1,3)))
	_A_op(attachtonotifier, "listener::attach-to-notifier", (
			struct aorp_closure *aClosure,
			struct aorp_error *anErrPtr,
			aorp_object_t aNtfier,
			int32_t *Events /* = NULL: all events */
		)),

	_A_attribute((nonnull(1,3)))
	_A_op(detachfromnotifier, "listener::detach-from-notifier", (
			struct aorp_closure *aClosure,
			struct aorp_error *anErrPtr,
			aorp_object_t aNtfier
		)),

	_A_attribute((nonnull(1,3)))
	_A_op(unlinknotifier, "listener::unlink-notifier", (
			struct aorp_closure *aClosure,
			struct aorp_error *anErrPtr,
			aorp_object_t aNtfier
		)),

	_A_attribute((nonnull(1,3)))
	_A_op(unlinknotifier_nlk, "listener::unlink-notifier-nolock", (
			struct aorp_closure *aClosure,
			struct aorp_error *anErrPtr,
			aorp_object_t aNtfier
		)),

	_A_attribute((nonnull(1)))
	_A_op(becomedeaf, "listener::become-deaf", (
			struct aorp_closure *aClosure,
			struct aorp_error *anErrPtr
		)),

	_A_attribute((nonnull(1)))
	_A_op(becomeaware, "listener::become-aware", (
			struct aorp_closure *aClosure,
			struct aorp_error *anErrPtr
		)),

	_A_attribute((nonnull(1)))
	_A_op(isaware, "listener::is-aware", (
			struct aorp_closure *aClosure,
			struct aorp_error *anErrPtr
		)),

_A_end;

# include <Bo/aorp/AorpCend.h>
/* @} */
#endif /* __aorpc_uses_service(listener) */

/******************************************************************************
 * Revision History:
 *		$Log$
 *
 *****************************************************************************/
