/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright (c) 2005-2007 V.Sokur
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

/*
 * Modules.h	(V.Sokur)
 * include/Bo/services/MIB/Modules.h
 *
 * $Id$
 */

/* ------------------------------------------------------------------------- */

#ifndef __BO_SERVICES_MIB_MODULES__
# define __BO_SERVICES_MIB_MODULES__

/******************************************************************************
 * %% BeginSection: constant declarations
 */

/* @seealso: Bo/aorp/Types.h */
# ifndef AorpK_inval_module
#  define AorpK_inval_module (-1)
#  define AorpK_null_module (0)
#  define AORP_null_module "null"
#  define AorpK_unk_module (2)
# endif

/*
 * Modules (MIB)
 */

# define AorpK_any_module AorpK_null_module

/*
 * stub
 * oid: <<category>>/<<module>>
 */
# define AorpK_stub_module (1)

/*
 * akm
 * oid: <<category>>/<<module>>
 */
# define AorpK_akm_module (4)

/*
 * error
 * oid: <<category>>/<<module>>
 */
# define AorpK_error_module (8)

/*
 * ccsi
 * oid: <<category>>/<<module>>
 */
# define AorpK_ccsi_module (9)

/*
 * ccsconv
 * oid: <<category>>/<<module>>
 */
# define AorpK_ccsconv_module (10)


/* dummy: basic-info-structures */
# define AorpK_bambis_module (20)

/*
 * bamctnr
 * oid: <<category>>/<<module>>
 */
# define AorpK_bamctnr_module (21)

/*
 * bamstr
 * oid: <<category>>/<<module>>
 */
# define AorpK_bamstr_module (22)


/*
 * bamkumfcn
 * oid: <<category>>/<<module>>
 */
# define AorpK_bamkumfcn_module (26)

/*
 * bamkumasi
 * oid: <<category>>/<<module>>
 */
# define AorpK_bamkumasi_module (27)


/*
 * bamios3
 * oid: <<category>>/<<module>>
 */
# define AorpK_bamios3_module (30)


/* dummy: job-control */
# define AorpK_bamjcl_module (40)

/*
 * bamrloop
 * oid: <<category>>/<<module>>
 */
# define AorpK_bamrloop_module (41)

/*
 * bamule
 * oid: <<category>>/<<module>>
 */
# define AorpK_bamule_module (42)


/* dummy: crypt-all */
# define AorpK_bamcrypta_module (50)

/*
 * bamcrypt
 * oid: <<category>>/<<module>>
 */
# define AorpK_bamcrypt_module (51)

/*
 * bamchash
 * oid: <<category>>/<<module>>
 */
# define AorpK_bamchash_module (52)


// @todo: remove
///*
// * bosl
// * oid: <<category>>/<<module>>
// */
//# define AorpK_bosl_module (60)
//
///*
// * bosld
// * oid: <<category>>/<<module>>
// */
//# define AorpK_bosld_module (61)
//
///*
// * bosl2
// * oid: <<category>>/<<module>>
// */
//# define AorpK_bosl2_module (62)
//
///*
// * bosld2
// * oid: <<category>>/<<module>>
// */
//# define AorpK_bosld2_module (63)
//
///*
// * boslpgd2
// * oid: <<category>>/<<module>>
// */
//# define AorpK_boslpgd2_module (64)

/*
 * bamboslpgd2
 * oid: <<category>>/<<module>>
 */
# define AorpK_bamboslpgd2_module (64)

/*
 * bambosl2
 * oid: <<category>>/<<module>>
 */
# define AorpK_bambosl2_module (65)

/*
 * bambosld2
 * oid: <<category>>/<<module>>
 */
# define AorpK_bambosld2_module (66)


/*
 * bamuri
 * oid: <<category>>/<<module>>
 */
# define AorpK_bamuri_module (70)

/*
 * bamuri4
 * oid: <<category>>/<<module>>
 */
# define AorpK_bamuri4_module (71)


/*
 * bamotidc
 * oid: <<category>>/<<module>>
 */
# define AorpK_bamotidc_module (90)

/*
 * bamsocket
 * oid: <<category>>/<<module>>
 */
# define AorpK_bamsocket_module (91)


/*
 * bamtextan
 * oid: <<category>>/<<module>>
 */
# define AorpK_bamtextan_module (100)

/*
 * bamplist
 * oid: <<category>>/<<module>>
 */
# define AorpK_bamplist_module (101)

/*
 * bamco
 * oid: <<category>>/<<module>>
 */
# define AorpK_bamco_module (102)

# define AorpK_USER_AVAILABLE_MODULE (10000)

#endif /* !__BO_SERVICES_MIB_MODULES__ */

/******************************************************************************
 * Revision History:
 *		$Log$
 *
 *****************************************************************************/
