/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright (c) 2005-2007 V.Sokur
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

/*
 * Objects.h	(V.Sokur)
 * include/Bo/services/MIB/Objects.h
 *
 * $Id$
 */

/* ------------------------------------------------------------------------- */

#ifndef __BO_SERVICES_MIB_OBJECTS__
# define __BO_SERVICES_MIB_OBJECTS__

/******************************************************************************
 * %% BeginSection: constant declarations
 */

/* @seealso: Bo/aorp/Types.h */
# ifndef AorpK_Inval_object
#  define AorpK_Inval_object (-1)
#  define AorpK_Null_object (0)
#  define AORP_Null_object "null"
#  define AorpK_Unk_object (2)
# endif

/*
 * Objects (MIB)
 */

# define AorpK_Null_object_creatable 0

# define AorpK_Any_object AorpK_Null_object
# define AorpK_Any_object_creatable 0

/*
 * Bostub
 * oid: <<category>>/<<object>>/<<impl>>
 */
# define AorpK_Bostub_object (1)
# define AorpK_Bostub_object_creatable 0


/*
 * Bokum
 * oid: <<category>>/<<object>>/<<impl>>
 *
 * constructor, descriptor, ucntl, dup
 */
# define AorpK_Bokum_object (3)
# define AorpK_Bokum_object_creatable 1

/*
 * Bokumas
 * oid: <<category>>/<<object>>/<<impl>>
 *
 * constructor, descriptor, ucntl, dup
 */
# define AorpK_Bokumas_object (4)
# define AorpK_Bokumas_object_creatable 1

/*
 * Bokumfam
 * oid: <<category>>/<<object>>/<<impl>>
 *
 * constructor, descriptor, ucntl, dup
 */
# define AorpK_Bokumfam_object (5)
# define AorpK_Bokumfam_object_creatable 1

/*
 * Bountfier
 * oid: <<category>>/<<object>>/<<impl>>
 *
 * constructor, descriptor, ucntl, notifier
 */
# define AorpK_Bountfier_object (11)
# define AorpK_Bountfier_object_creatable 1

/*
 * Bocbulsner
 * oid: <<category>>/<<object>>/<<impl>>
 *
 * constructor, descriptor, ucntl, listener
 */
# define AorpK_Bocbulsner_object (13)
# define AorpK_Bocbulsner_object_creatable 1

/*
 * Bocbmlsner
 * oid: <<category>>/<<object>>/<<impl>>
 *
 * constructor, descriptor, ucntl, listener
 */
# define AorpK_Bocbmlsner_object (14)
# define AorpK_Bocbmlsner_object_creatable 1

/*
 * Boerr
 * oid: <<category>>/<<object>>/<<impl>>
 *
 * descriptor, ucntl, error
 */
# define AorpK_Boerr_object (15)
# define AorpK_Boerr_object_creatable 0

/*
 * Boccsi
 * oid: <<category>>/<<object>>/<<impl>>
 *
 * descriptor, ucntl, ccsi
 */
# define AorpK_Boccsi_object (16)
# define AorpK_Boccsi_object_creatable 0

/*
 * Boccsconv
 * oid: <<category>>/<<object>>/<<impl>>
 *
 * descriptor, ucntl, ccsconv
 */
# define AorpK_Boccsconv_object (17)
# define AorpK_Boccsconv_object_creatable 0

/*
 * Bolarr
 * oid: <<category>>/<<object>>/<<impl>>
 *
 * constructor, descriptor, ucntl, container
 */
# define AorpK_Bolarr_object (21)
# define AorpK_Bolarr_object_creatable 1

/*
 * Bowarr
 * oid: <<category>>/<<object>>/<<impl>>
 *
 * constructor, descriptor, ucntl, container
 */
# define AorpK_Bowarr_object (22)
# define AorpK_Bowarr_object_creatable 1

/*
 * Bounarr
 * oid: <<category>>/<<object>>/<<impl>>
 *
 * constructor, descriptor, ucntl, container, notifier
 */
# define AorpK_Bounarr_object (23)
# define AorpK_Bounarr_object_creatable 1

/*
 * Boxarr
 * oid: <<category>>/<<object>>/<<impl>>
 *
 * constructor, descriptor, ucntl, container
 */
# define AorpK_Boxarr_object (24)
# define AorpK_Boxarr_object_creatable 1

/*
 * Bollis
 * oid: <<category>>/<<object>>/<<impl>>
 *
 * constructor, descriptor, ucntl, container
 */
# define AorpK_Bollis_object (25)
# define AorpK_Bollis_object_creatable 1

/*
 * Bowlis
 * oid: <<category>>/<<object>>/<<impl>>
 *
 * constructor, descriptor, ucntl, container
 */
# define AorpK_Bowlis_object (26)
# define AorpK_Bowlis_object_creatable 1

/*
 * Bounlis
 * oid: <<category>>/<<object>>/<<impl>>
 *
 * constructor, descriptor, ucntl, container, notifier{\uni-notifier}
 */
# define AorpK_Bounlis_object (27)
# define AorpK_Bounlis_object_creatable 1

/*
 * Boxlis
 * oid: <<category>>/<<object>>/<<impl>>
 *
 * constructor, descriptor, ucntl, container
 */
# define AorpK_Boxlis_object (28)
# define AorpK_Boxlis_object_creatable 1

/*
 * Boldicarr
 * oid: <<category>>/<<object>>/<<impl>>
 *
 * constructor, descriptor, ucntl, container
 */
# define AorpK_Boldicarr_object (29)
# define AorpK_Boldicarr_object_creatable 1

/*
 * Bowdicarr
 * oid: <<category>>/<<object>>/<<impl>>
 *
 * constructor, descriptor, ucntl, container
 */
# define AorpK_Bowdicarr_object (30)
# define AorpK_Bowdicarr_object_creatable 1

/*
 * Boundicarr
 * oid: <<category>>/<<object>>/<<impl>>
 *
 * constructor, descriptor, ucntl, container, notifier
 */
# define AorpK_Boundicarr_object (31)
# define AorpK_Boundicarr_object_creatable 1

/*
 * Boxdicarr
 * oid: <<category>>/<<object>>/<<impl>>
 *
 * constructor, descriptor, ucntl, container
 */
# define AorpK_Boxdicarr_object (32)
# define AorpK_Boxdicarr_object_creatable 1

/*
 * Boldiclis
 * oid: <<category>>/<<object>>/<<impl>>
 *
 * constructor, descriptor, ucntl, container
 */
# define AorpK_Boldiclis_object (33)
# define AorpK_Boldiclis_object_creatable 1

/*
 * Bowdiclis
 * oid: <<category>>/<<object>>/<<impl>>
 *
 * constructor, descriptor, ucntl, container
 */
# define AorpK_Bowdiclis_object (34)
# define AorpK_Bowdiclis_object_creatable 1

/*
 * Boundiclis
 * oid: <<category>>/<<object>>/<<impl>>
 *
 * constructor, descriptor, ucntl, container, notifier
 */
# define AorpK_Boundiclis_object (35)
# define AorpK_Boundiclis_object_creatable 1

/*
 * Boxdiclis
 * oid: <<category>>/<<object>>/<<impl>>
 *
 * constructor, descriptor, ucntl, container
 */
# define AorpK_Boxdiclis_object (36)
# define AorpK_Boxdiclis_object_creatable 1

/*
 * Boldictre
 * oid: <<category>>/<<object>>/<<impl>>
 *
 * constructor, descriptor, ucntl, container
 */
# define AorpK_Boldictre_object (37)
# define AorpK_Boldictre_object_creatable 1

/*
 * Bowdictre
 * oid: <<category>>/<<object>>/<<impl>>
 *
 * constructor, descriptor, ucntl, container
 */
# define AorpK_Bowdictre_object (38)
# define AorpK_Bowdictre_object_creatable 1

/*
 * Boundictre
 * oid: <<category>>/<<object>>/<<impl>>
 *
 * constructor, descriptor, ucntl, container, notifier
 */
# define AorpK_Boundictre_object (39)
# define AorpK_Boundictre_object_creatable 1

/*
 * Boxdictre
 * oid: <<category>>/<<object>>/<<impl>>
 *
 * constructor, descriptor, ucntl, container
 */
# define AorpK_Boxdictre_object (40)
# define AorpK_Boxdictre_object_creatable 1

/*
 * Bolordlis
 * oid: <<category>>/<<object>>/<<impl>>
 *
 * constructor, descriptor, ucntl, container
 */
# define AorpK_Bolordlis_object (41)
# define AorpK_Bolordlis_object_creatable 1

/*
 * Zstream
 * oid: <<category>>/<<object>>/<<impl>>
 *
 * constructor, descriptor, ucntl, ios
 */
# define AorpK_Zstream_object (50)
# define AorpK_Zstream_object_creatable 1

/*
 * Fstream
 * oid: <<category>>/<<object>>/<<impl>>
 *
 * constructor, descriptor, ucntl, ios
 */
# define AorpK_Fstream_object (51)
# define AorpK_Fstream_object_creatable 1

/*
 * Bstream
 * oid: <<category>>/<<object>>/<<impl>>
 *
 * constructor, descriptor, ucntl, ios
 */
# define AorpK_Bstream_object (52)
# define AorpK_Bstream_object_creatable 1

/*
 * Boeverloop
 * oid: <<category>>/<<object>>/<<impl>>
 *
 * constructor, descriptor, ucntl, runloop
 */
# define AorpK_Boeverloop_object (60)
# define AorpK_Boeverloop_object_creatable 1
/* compat @{ */
# define AorpK_Everloop_object AorpK_Boeverloop_object
# define AorpK_Everloop_object_creatable AorpK_Boeverloop_object_creatable
/* @} */

/*
 * Boasurloop
 * oid: <<category>>/<<object>>/<<impl>>
 *
 * constructor, descriptor, ucntl, runloop
 */
# define AorpK_Boasurloop_object (61)
# define AorpK_Boasurloop_object_creatable 1
/* compat @{ */
# define AorpK_Borloop_object AorpK_Boasurloop_object
# define AorpK_Borloop_object_creatable AorpK_Boasurloop_object_creatable
/* @} */

/*
 * Bosched
 * oid: <<category>>/<<object>>/<<impl>>
 *
 * constructor, descriptor, ucntl, sched, job
 */
# define AorpK_Bosched_object (65)
# define AorpK_Bosched_object_creatable 1

/*
 * Bocrypt
 * oid: <<category>>/<<object>>/<<impl>>
 *
 * descriptor, ucntl, crypt, chash
 */
# define AorpK_Bocrypt_object (70)
# define AorpK_Bocrypt_object_creatable 0

/*
 * Bochash
 * oid: <<category>>/<<object>>/<<impl>>
 *
 * descriptor, ucntl, chash
 */

# define AorpK_Bochash_object (75)
# define AorpK_Bochash_object_creatable 0

/*
 * Bosl
 * oid: <<category>>/<<object>>/<<impl>>
 *
 * constructor, descriptor, ucntl, log
 */
# define AorpK_Bosl_object (90)
# define AorpK_Bosl_object_creatable 1

/*
 * Bosld
 * oid: <<category>>/<<object>>/<<impl>>
 *
 * constructor, descriptor, ucntl, log
 */
# define AorpK_Bosld_object (91)
# define AorpK_Bosld_object_creatable 1

/*
 * Bosl2
 * oid: <<category>>/<<object>>/<<impl>>
 *
 * constructor, descriptor, ucntl, log
 */
# define AorpK_Bosl2_object (92)
# define AorpK_Bosl2_object_creatable 1

/*
 * Bosld2
 * oid: <<category>>/<<object>>/<<impl>>
 *
 * constructor, descriptor, ucntl, log
 */
# define AorpK_Bosld2_object (93)
# define AorpK_Bosld2_object_creatable 1

/*
 * Boslpgd2
 * oid: <<category>>/<<object>>/<<impl>>
 *
 * constructor, descriptor, ucntl, log
 */
# define AorpK_Boslpgd2_object (94)
# define AorpK_Boslpgd2_object_creatable 1

/*
 * Bourilib
 * oid: <<category>>/<<object>>/<<impl>>
 *
 * constructor, descriptor, ucntl, urilib
 */
# define AorpK_Bourilib_object (100)
# define AorpK_Bourilib_object_creatable 0

/*
 * Bouri
 * oid: <<category>>/<<object>>/<<impl>>
 *
 * constructor, descriptor, ucntl, uri
 */
# define AorpK_Bouri_object (101)
# define AorpK_Bouri_object_creatable 1

/*
 * Bouribend
 * oid: <<category>>/<<object>>/<<impl>>
 *
 * descriptor, ucntl, uribend
 */
# define AorpK_Bouribend_object (102)
# define AorpK_Bouribend_object_creatable 0

/*
 * Botidcntl
 * oid: <<category>>/<<object>>/<<impl>>
 *
 * descriptor, ucntl, otidcntl
 */

# define AorpK_Botidcntl_object (110)
# define AorpK_Botidcntl_object_creatable 0

/*
 * Bosck
 * oid: <<category>>/<<object>>/<<impl>>
 *
 * constructor, descriptor, ucntl, oti, ios
 */
# define AorpK_Bosck_object (111)
# define AorpK_Bosck_object_creatable 1

/*
 * Boqdfalex
 * oid: <<category>>/<<object>>/<<impl>>
 *
 * constructor, descriptor, ucntl, lexan
 */
# define AorpK_Boqdfalex_object (120)
# define AorpK_Boqdfalex_object_creatable 1

/*
 * Boqdfalsc
 * oid: <<category>>/<<object>>/<<impl>>
 *
 * descriptor, ucntl, lexspecc
 */
# define AorpK_Boqdfalsc_object (121)
# define AorpK_Boqdfalsc_object_creatable 0

/*
 * Boqdfa
 * oid: <<category>>/<<object>>/<<impl>>
 *
 * constructor, descriptor, ucntl, lexopen
 */
# define AorpK_Boqdfa_object (122)
# define AorpK_Boqdfa_object_creatable 1

/*
 * Bogsqdfa
 * oid: <<category>>/<<object>>/<<impl>>
 *
 * descriptor, ucntl, lexopen
 */
# define AorpK_Bogsqdfa_object (123)
# define AorpK_Bogsqdfa_object_creatable 0

/*
 * Boqlalrgsc
 * oid: <<category>>/<<object>>/<<impl>>
 *
 * descriptor, ucntl, gramspecc
 */
# define AorpK_Boqlalrgsc_object (124)
# define AorpK_Boqlalrgsc_object_creatable 0

/*
 * Boqlrtab
 * oid: <<category>>/<<object>>/<<impl>>
 *
 * constructor, descriptor, ucntl, lrtab
 */
# define AorpK_Boqlrtab_object (125)
# define AorpK_Boqlrtab_object_creatable 1


# define AorpK_USER_AVAILABLE_OBJECT (10000)

#endif /* !__BO_SERVICES_MIB_OBJECTS__ */

/******************************************************************************
 * Revision History:
 *		$Log$
 *
 *****************************************************************************/
