/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright (c) 2005-2007 V.Sokur
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

/*
 * Opdom.h	(V.Sokur)
 * include/Bo/services/MIB/Opdom.h
 *
 * $Id$
 */

/* ------------------------------------------------------------------------- */

#ifndef __BO_SERVICES_MIB_OPDOM__
# define __BO_SERVICES_MIB_OPDOM__

/******************************************************************************
 * %% BeginSection: constant declarations
 */

/* @seealso: Bo/aorp/Types.h */
# ifndef AorpK_Inval_opdom
#  define AorpK_Inval_opdom (-1)
#  define AorpK_Null_opdom (0)
#  define AORP_Null_opdom "null"
#  define AorpK_Unk_opdom (2)
# endif

/*
 * Operation Domain (MIB)
 */

# define AorpK_Null_opdom_empty 1

# define AorpK_Any_opdom AorpK_Null_opdom
# define AorpK_Any_opdom_empty AorpK_Null_opdom_empty

# define AorpK_Stub_opdom AorpK_Null_opdom
# define AorpK_Stub_opdom_empty AorpK_Null_opdom_empty

/* ----------------------------------------------------------------------------
 * core service domain
 * [3, 150[
 * @{
 */

/*
 * Ctor
 *
 * constructor
 * oid: <<category>>/<<service>>/<<domain>>/<<impl>>
 */
# define AorpK_Ctor_opdom (3)
# define AorpK_Ctor_opdom_empty 1

/*
 * Dup
 *
 * duplicator
 * oid: <<category>>/<<service>>/<<domain>>/<<impl>>
 */
# define AorpK_Dup_opdom (4)
# define AorpK_Dup_opdom_empty 1

/*
 * Destor
 *
 * descriptor
 * oid: <<category>>/<<service>>/<<domain>>/<<impl>>
 */
# define AorpK_Destor_opdom (5)
# define AorpK_Destor_opdom_empty 0

/*
 * Xucntl
 *
 * ucntl
 * oid: <<category>>/<<service>>/<<domain>>/<<impl>>
 */
# define AorpK_Xucntl_opdom (6)
# define AorpK_Xucntl_opdom_empty 0

/*
 * Zucntl
 *
 * ucntl
 * oid: <<category>>/<<service>>/<<domain>>/<<impl>>
 */
# define AorpK_Zucntl_opdom (7)
# define AorpK_Zucntl_opdom_empty 1

/*
 * Cucntl
 *
 * ucntl
 * oid: <<category>>/<<service>>/<<domain>>/<<impl>>
 */
# define AorpK_Cucntl_opdom (8)
# define AorpK_Cucntl_opdom_empty 1

/*
 * PoolCtor
 *
 * constructor
 * oid: <<category>>/<<service>>/<<domain>>/<<impl>>
 */
# define AorpK_PoolCtor_opdom (9)
# define AorpK_PoolCtor_opdom_empty 0

/*
 * PoolUcntl
 *
 * ucntl
 * oid: <<category>>/<<service>>/<<domain>>/<<impl>>
 */
# define AorpK_PoolUcntl_opdom (10)
# define AorpK_PoolUcntl_opdom_empty 1

/*
 * KumCtor
 *
 * constructor
 * oid: <<category>>/<<service>>/<<domain>>/<<impl>>
 */
# define AorpK_KumCtor_opdom (11)
# define AorpK_KumCtor_opdom_empty 0

/*
 * Kum
 *
 * ucntl
 * oid: <<category>>/<<service>>/<<domain>>/<<impl>>
 */
# define AorpK_Kum_opdom (12)
# define AorpK_Kum_opdom_empty 0

/*
 * Kumas
 *
 * ucntl
 * oid: <<category>>/<<service>>/<<domain>>/<<impl>>
 */
# define AorpK_Kumas_opdom (13)
# define AorpK_Kumas_opdom_empty 0

/*
 * Kumfam
 *
 * ucntl
 * oid: <<category>>/<<service>>/<<domain>>/<<impl>>
 */
# define AorpK_Kumfam_opdom (14)
# define AorpK_Kumfam_opdom_empty 0

/*
 * Err
 *
 * error
 * oid: <<category>>/<<service>>/<<domain>>/<<impl>>
 */
# define AorpK_Err_opdom (15)
# define AorpK_Err_opdom_empty 0

/*
 * Ccsi
 *
 * ccsi
 * oid: <<category>>/<<service>>/<<domain>>/<<impl>>
 */
# define AorpK_Ccsi_opdom (16)
# define AorpK_Ccsi_opdom_empty 0

/*
 * Ccsconv
 *
 * ccsconv
 * oid: <<category>>/<<service>>/<<domain>>/<<impl>>
 */
# define AorpK_Ccsconv_opdom (17)
# define AorpK_Ccsconv_opdom_empty 1

/*
 * Ccscvtor
 *
 * ccscvtor
 * oid: <<category>>/<<service>>/<<domain>>/<<IANA-registered-CCS>>/<<impl>>
 */
# define AorpK_Ccscvtor_opdom (18)
# define AorpK_Ccscvtor_opdom_empty 1

/*
 * Untfier
 *
 * notifier
 * oid: <<category>>/<<service>>/<<domain>>/<<impl>>
 */
# define AorpK_Untfier_opdom (19)
# define AorpK_Untfier_opdom_empty 0

/*
 * Mntfier
 *
 * notifier
 * oid: <<category>>/<<service>>/<<domain>>/<<impl>>
 */
# define AorpK_Mntfier_opdom (20)
# define AorpK_Mntfier_opdom_empty 0

/*
 * Ulstner
 *
 * listener
 * oid: <<category>>/<<service>>/<<domain>>/<<impl>>
 */
# define AorpK_Ulstner_opdom (21)
# define AorpK_Ulstner_opdom_empty 0

/*
 * Mlstner
 *
 * listener
 * oid: <<category>>/<<service>>/<<domain>>/<<impl>>
 */
# define AorpK_Mlstner_opdom (22)
# define AorpK_Mlstner_opdom_empty 0

/*
 * CbUlsner
 *
 * listener
 * oid: <<category>>/<<service>>/<<domain>>/<<impl>>
 */
# define AorpK_CbUlsner_opdom (23)
# define AorpK_CbUlsner_opdom_empty 0

/*
 * CbMlsner
 *
 * listener
 * oid: <<category>>/<<service>>/<<domain>>/<<impl>>
 */
# define AorpK_CbMlsner_opdom (24)
# define AorpK_CbMlsner_opdom_empty 0
/* @} */

/* ----------------------------------------------------------------------------
 * basis service domain
 * [150, 250[
 * @{
 */

/*
 * Larr
 *
 * container
 * oid: <<category>>/<<service>>/<<domain>>/<<data-category: {udvariant,object,...}>>/<<impl>>
 */
# define AorpK_Larr_opdom (150)
# define AorpK_Larr_opdom_empty 0

/*
 * Warr
 *
 * container
 * oid: <<category>>/<<service>>/<<domain>>/<<data-category: {udvariant,object,...}>>/<<impl>>
 */
# define AorpK_Warr_opdom (151)
# define AorpK_Warr_opdom_empty 0

/*
 * Unarr
 *
 * container
 * oid: <<category>>/<<service>>/<<domain>>/<<data-category: {udvariant,object,...}>>/<<impl>>
 */
# define AorpK_Unarr_opdom (152)
# define AorpK_Unarr_opdom_empty 0

/*
 * Xarr
 *
 * container
 * oid: <<category>>/<<service>>/<<domain>>/<<data-category: {udvariant,object,...}>>/<<impl>>
 */
# define AorpK_Xarr_opdom (153)
# define AorpK_Xarr_opdom_empty 0

/*
 * Llis
 *
 * container
 * oid: <<category>>/<<service>>/<<domain>>/<<data-category: {udvariant,object,...}>>/<<impl>>
 */
# define AorpK_Llis_opdom (154)
# define AorpK_Llis_opdom_empty 0

/*
 * Wlis
 *
 * container
 * oid: <<category>>/<<service>>/<<domain>>/<<data-category: {udvariant,object,...}>>/<<impl>>
 */
# define AorpK_Wlis_opdom (155)
# define AorpK_Wlis_opdom_empty 0

/*
 * Unlis
 *
 * container
 * oid: <<category>>/<<service>>/<<domain>>/<<data-category: {udvariant,object,...}>>/<<impl>>
 */
# define AorpK_Unlis_opdom (156)
# define AorpK_Unlis_opdom_empty 0

/*
 * Xlis
 *
 * container
 * oid: <<category>>/<<service>>/<<domain>>/<<data-category: {udvariant,object,...}>>/<<impl>>
 */
# define AorpK_Xlis_opdom (157)
# define AorpK_Xlis_opdom_empty 0

/*
 * Ldicarr
 *
 * container
 * oid: <<category>>/<<service>>/<<domain>>/<<impl>>
 */
# define AorpK_Ldicarr_opdom (160)
# define AorpK_Ldicarr_opdom_empty 0

/*
 * Wdicarr
 *
 * container
 * oid: <<category>>/<<service>>/<<domain>>/<<impl>>
 */
# define AorpK_Wdicarr_opdom (161)
# define AorpK_Wdicarr_opdom_empty 0

/*
 * Undicarr
 *
 * container
 * oid: <<category>>/<<service>>/<<domain>>/<<impl>>
 */
# define AorpK_Undicarr_opdom (162)
# define AorpK_Undicarr_opdom_empty 0

/*
 * Xdicarr
 *
 * container
 * oid: <<category>>/<<service>>/<<domain>>/<<impl>>
 */
# define AorpK_Xdicarr_opdom (163)
# define AorpK_Xdicarr_opdom_empty 0

/*
 * Ldiclis
 *
 * container
 * oid: <<category>>/<<service>>/<<domain>>/<<impl>>
 */
# define AorpK_Ldiclis_opdom (164)
# define AorpK_Ldiclis_opdom_empty 0

/*
 * Wdiclis
 *
 * container
 * oid: <<category>>/<<service>>/<<domain>>/<<impl>>
 */
# define AorpK_Wdiclis_opdom (165)
# define AorpK_Wdiclis_opdom_empty 0

/*
 * Undiclis
 *
 * container
 * oid: <<category>>/<<service>>/<<domain>>/<<impl>>
 */
# define AorpK_Undiclis_opdom (166)
# define AorpK_Undiclis_opdom_empty 0

/*
 * Xdiclis
 *
 * container
 * oid: <<category>>/<<service>>/<<domain>>/<<impl>>
 */
# define AorpK_Xdiclis_opdom (167)
# define AorpK_Xdiclis_opdom_empty 0

/*
 * Ldictre
 *
 * container
 * oid: <<category>>/<<service>>/<<domain>>/<<impl>>
 */
# define AorpK_Ldictre_opdom (168)
# define AorpK_Ldictre_opdom_empty 0

/*
 * Wdictre
 *
 * container
 * oid: <<category>>/<<service>>/<<domain>>/<<impl>>
 */
# define AorpK_Wdictre_opdom (169)
# define AorpK_Wdictre_opdom_empty 0

/*
 * Undictre
 *
 * container
 * oid: <<category>>/<<service>>/<<domain>>/<<impl>>
 */
# define AorpK_Undictre_opdom (170)
# define AorpK_Undictre_opdom_empty 0

/*
 * Xdictre
 *
 * container
 * oid: <<category>>/<<service>>/<<domain>>/<<impl>>
 */
# define AorpK_Xdictre_opdom (171)
# define AorpK_Xdictre_opdom_empty 0

/*
 * Lordlis
 *
 * container
 * oid: <<category>>/<<service>>/<<domain>>/<<impl>>
 */
# define AorpK_Lordlis_opdom (172)
# define AorpK_Lordlis_opdom_empty 0
/* @} */

/* ----------------------------------------------------------------------------
 * io service domain
 * [250, 350[
 * @{
 */

/*
 * Zeios
 *
 * ios
 * oid: <<category>>/<<service>>/<<domain>>/<<impl>>
 */
# define AorpK_Zeios_opdom (250)
# define AorpK_Zeios_opdom_empty 1

/*
 * Fiios
 *
 * ios
 * oid: <<category>>/<<service>>/<<domain>>/<<impl>>
 */
# define AorpK_Fiios_opdom (251)
# define AorpK_Fiios_opdom_empty 0

/*
 * Byios
 *
 * ios
 * oid: <<category>>/<<service>>/<<domain>>/<<impl>>
 */
# define AorpK_Byios_opdom (252)
# define AorpK_Byios_opdom_empty 0
/* @} */

/* ----------------------------------------------------------------------------
 * hilis service domain
 * [350, 700[
 * @{
 */

/*
 * Uri
 *
 * uri
 * oid: <<category>>/<<service>>/<<domain>>/<<impl>>
 */
# define AorpK_Uri_opdom (350)
# define AorpK_Uri_opdom_empty 0

/*
 * Uriucntl
 *
 * ucntl
 * oid: <<category>>/<<service>>/<<domain>>/<<impl>>
 */
# define AorpK_Uriucntl_opdom (351)
# define AorpK_Uriucntl_opdom_empty 0

/*
 * Guribend
 *
 * uribend
 * oid: <<category>>/<<service>>/<<domain>>/<<impl>>
 */
# define AorpK_Guribend_opdom (352)
# define AorpK_Guribend_opdom_empty 0

/*
 * Uritramp
 *
 * uribend
 * oid: <<category>>/<<service>>/<<domain>>/<<impl>>
 */
# define AorpK_Uritramp_opdom (353)
# define AorpK_Uritramp_opdom_empty 0

/*
 * Urilib
 *
 * urilib
 * oid: <<category>>/<<service>>/<<domain>>/<<impl>>
 */
# define AorpK_Urilib_opdom (354)
# define AorpK_Urilib_opdom_empty 0

/*
 * Plstat
 *
 * plstat
 * oid: <<category>>/<<service>>/<<domain>>/<<impl>>
 */
# define AorpK_Plstat_opdom (360)
# define AorpK_Plstat_opdom_empty 1
/* @} */

/* ----------------------------------------------------------------------------
 * jobcntl service domain
 * [700, 800[
 * @{
 */

/*
 * Everloop
 *
 * runloop
 * oid: <<category>>/<<service>>/<<domain>>/<<impl>>
 */
# define AorpK_Everloop_opdom (700)
# define AorpK_Everloop_opdom_empty 0

/*
 * Asurloop
 *
 * runloop
 * oid: <<category>>/<<service>>/<<domain>>/<<impl>>
 */
# define AorpK_Asurloop_opdom (701)
# define AorpK_Asurloop_opdom_empty 0

/*
 * Ule
 *
 * sched
 * oid: <<category>>/<<service>>/<<domain>>/<<impl>>
 */
# define AorpK_Ule_opdom (705)
# define AorpK_Ule_opdom_empty 0
/* @} */

/* ----------------------------------------------------------------------------
 * crypt service domain
 * [800, 900[
 * @{
 */

/*
 * Crypt
 *
 * crypt
 * oid: <<category>>/<<service>>/<<domain>>/<<impl>>
 */
# define AorpK_Crypt_opdom (800)
# define AorpK_Crypt_opdom_empty 1

/*
 * Cryptal
 *
 * cryptal
 * oid: <<category>>/<<service>>/<<domain>>/<<impl>>
 */
# define AorpK_Cryptal_opdom (801)
# define AorpK_Cryptal_opdom_empty 1

/*
 * CHash
 *
 * chash
 * oid: <<category>>/<<service>>/<<domain>>/<<impl>>
 */
# define AorpK_CHash_opdom (802)
# define AorpK_CHash_opdom_empty 1

/*
 * CHashal
 *
 * chashal
 * oid: <<category>>/<<service>>/<<domain>>/<<impl>>
 */
# define AorpK_CHashal_opdom (803)
# define AorpK_CHashal_opdom_empty 1
/* @} */

/* ----------------------------------------------------------------------------
 * net service domain
 * [900, 1100[
 * @{
 */

/*
 * Otidc
 *
 * otidcntl
 * oid: <<category>>/<<service>>/<<domain>>/<<impl>>
 */
# define AorpK_Otidc_opdom (900)
# define AorpK_Otidc_opdom_empty 1

/*
 * Socket
 *
 * oti
 * oid: <<category>>/<<service>>/<<domain>>/<<impl>>
 */
# define AorpK_Socket_opdom (901)
# define AorpK_Socket_opdom_empty 0

// @todo: ???
///*
// * Tris
// *
// * tris
// * oid: <<category>>/<<service>>/<<domain>>/<<impl>>
// */
//# define AorpK_Tris_opdom (40)
//# define AorpK_Tris_opdom_empty 0
//

/* @} */

/* ----------------------------------------------------------------------------
 * infos service domain
 * [1100, 1400[
 * @{
 */

/*
 * Slogcli
 *
 * log
 * oid: <<category>>/<<service>>/<<domain>>/<<impl>>
 */
# define AorpK_Slogcli_opdom (1100)
# define AorpK_Slogcli_opdom_empty 0

/*
 * Slogsrv
 *
 * log
 * oid: <<category>>/<<service>>/<<domain>>/<<impl>>
 */
# define AorpK_Slogsrv_opdom (1101)
# define AorpK_Slogsrv_opdom_empty 0

/*
 * Slogcli2
 *
 * log
 * oid: <<category>>/<<service>>/<<domain>>/<<impl>>
 */
# define AorpK_Slogcli2_opdom (1102)
# define AorpK_Slogcli2_opdom_empty 0

/*
 * Slogsrv2
 *
 * log
 * oid: <<category>>/<<service>>/<<domain>>/<<impl>>
 */
# define AorpK_Slogsrv2_opdom (1103)
# define AorpK_Slogsrv2_opdom_empty 0

/*
 * Slogpgsrv2
 *
 * log
 * oid: <<category>>/<<service>>/<<domain>>/<<impl>>
 */
# define AorpK_Slogpgsrv2_opdom (1104)
# define AorpK_Slogpgsrv2_opdom_empty 0
/* @} */

/* ----------------------------------------------------------------------------
 * textan service domain
 * [1400, 1500[
 * @{
 */

/*
 * Qdfalex
 *
 * lexan
 * oid: <<category>>/<<service>>/<<domain>>/<<impl>>
 */
# define AorpK_Qdfalex_opdom (1400)
# define AorpK_Qdfalex_opdom_empty 0

/*
 * Qlrsyxan
 *
 * syxan
 * oid: <<category>>/<<service>>/<<domain>>/<<impl>>
 */
# define AorpK_Qlrsyxan_opdom (1401)
# define AorpK_Qlrsyxan_opdom_empty 0

/*
 * Qdfa
 *
 * dfa
 * oid: <<category>>/<<service>>/<<domain>>/<<impl>>
 */
# define AorpK_Qdfa_opdom (1402)
# define AorpK_Qdfa_opdom_empty 0

/*
 * Qdfalsc
 *
 * lexspecc
 * oid: <<category>>/<<service>>/<<domain>>/<<impl>>
 */
# define AorpK_Qdfalsc_opdom (1403)
# define AorpK_Qdfalsc_opdom_empty 1

/*
 * Qlalrgsc
 *
 * gramspecc
 * oid: <<category>>/<<service>>/<<domain>>/<<impl>>
 */
# define AorpK_Qlalrgsc_opdom (1404)
# define AorpK_Qlalrgsc_opdom_empty 1

/*
 * Qlrtab
 *
 * lrtab
 * oid: <<category>>/<<service>>/<<domain>>/<<impl>>
 */
# define AorpK_Qlrtab_opdom (1405)
# define AorpK_Qlrtab_opdom_empty 0
/* @} */

# define AorpK_USER_AVAILABLE_OPDOM (10000)

#endif /* !__BO_SERVICES_MIB_OPDOM__ */

/******************************************************************************
 * Revision History:
 *		$Log$
 *
 *****************************************************************************/
