/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright (c) 2005-2007 V.Sokur
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

/*
 * Services.h	(V.Sokur)
 * include/Bo/services/MIB/Services.h
 *
 * $Id$
 */

/* ------------------------------------------------------------------------- */

#ifndef __BO_SERVICES_MIB_SERVICES__
# define __BO_SERVICES_MIB_SERVICES__

/******************************************************************************
 * %% BeginSection: constant declarations
 */

/* @seealso: Bo/aorp/Types.h */
# ifndef AorpK_inval_service
#  define AorpK_inval_service (-1)
#  define AorpK_null_service (0)
#  define AORP_null_service "null"
#  define AorpK_unk_service (2)
# endif

/*
 * Services (MIB)
 */

# define AorpK_any_service AorpK_null_service

/* ----------------------------------------------------------------------------
 * sys pseudo-services
 * [100, 200[
 * @{
 */
# define AorpK_sys_pseudo_service (100)
# define AORP_sys_pseudo_service "sys-pseudo"
# define _AORP_sys_pseudo_service sys_pseudo

# define AorpK_fstat_pseudo_service (101)
# define AORP_fstat_pseudo_service "fstat"
# define _AORP_fstat_pseudo_service fstat

# define AorpK_fcntl_pseudo_service (102)
# define AORP_fcntl_pseudo_service "fcntl"
# define _AORP_fcntl_pseudo_service fcntl

# define AorpK_io_pseudo_service (103)
# define AORP_io_pseudo_service "io"
# define _AORP_io_pseudo_service io

# define AorpK_dir_pseudo_service (104)
# define AORP_dir_pseudo_service "dir"
# define _AORP_dir_pseudo_service dir

# define AorpK_process_pseudo_service (105)
# define AORP_process_pseudo_service "process"
# define _AORP_process_pseudo_service process

# define AorpK_wait_pseudo_service (106)
# define AORP_wait_pseudo_service "wait"
# define _AORP_wait_pseudo_service wait

# define AorpK_sys_time_pseudo_service (107)
# define AORP_sys_time_pseudo_service "sys-time"
# define _AORP_sys_time_pseudo_service sys_time
/* @} */

/* ----------------------------------------------------------------------------
 * libc pseudo-services
 * [200, 300[
 * @{
 */
# define AorpK_libc_pseudo_service (200)
# define AORP_libc_pseudo_service "libc-pseudo"
# define _AORP_libc_pseudo_service libc_pseudo

# define AorpK_stdio_pseudo_service (201)
# define AORP_stdio_pseudo_service "stdio"
# define _AORP_stdio_pseudo_service stdio

# define AorpK_stddir_pseudo_service (202)
# define AORP_stddir_pseudo_service "stddir"
# define _AORP_stddir_pseudo_service stddir

# define AorpK_wchar_pseudo_service (203)
# define AORP_wchar_pseudo_service "wchar-pseudo"
# define _AORP_wchar_pseudo_service wchar_pseudo

# define AorpK_libc_time_pseudo_service (204)
# define AORP_libc_time_pseudo_service "libc-time"
# define _AORP_libc_time_pseudo_service libc_time
/* @} */

/* ----------------------------------------------------------------------------
 * posix pseudo-services
 * @{
 */
# define AorpK_posix_pseudo_service (300)
# define AORP_posix_pseudo_service "posix-pseudo"
# define _AORP_posix_pseudo_service posix_pseudo
/* @} */

/* ----------------------------------------------------------------------------
 * other pseudo-services
 * [500, 1000[
 * @{
 */

/*
 * stralg
 */
# define AorpK_stralg_pseudo_service (504)
# define AORP_stralg_pseudo_service "stralg"
# define _AORP_stralg_pseudo_service stralg

/*
 * ctnralg
 */
# define AorpK_ctnralg_pseudo_service (505)
# define AORP_ctnralg_pseudo_service "ctnralg"
# define _AORP_ctnralg_pseudo_service ctnralg

/*
 * btree
 */
# define AorpK_btree_pseudo_service (506)
# define AORP_btree_pseudo_service "btree"
# define _AORP_btree_pseudo_service btree

/*
 * txtscan
 */
# define AorpK_txtscan_pseudo_service (507)
# define AORP_txtscan_pseudo_service "txtscan"
# define _AORP_txtscan_pseudo_service txtscan

/*
 * memman
 */
# define AorpK_memman_pseudo_service (508)
# define AORP_memman_pseudo_service "memman"
# define _AORP_memman_pseudo_service memman
/* @} */

/* ----------------------------------------------------------------------------
 * core services
 * [1000, 1050[
 * @{
 */

/*
 * aorprt
 */
# define AorpK_aorprt_pseudo_service (1000)
# define AORP_aorprt_pseudo_service "aorp-runtime"
# define _AORP_aorprt_pseudo_service aorp_runtime

/*
 * stub
 */
# define AorpK_stub_service (1)

/*
 * constructor {\object(class)}
 */
# define AorpK_constructor_service (1003)

/*
 * duplicator {\object(class)}
 */
# define AorpK_duplicator_service (1004)

/*
 * descriptor {\object(class)}
 */
# define AorpK_descriptor_service (1005)

/*
 * ucntl {\object(instance)}
 */
# define AorpK_ucntl_service (1006) /* 1007 */

/*
 * error {\object(class)}
 */
# define AorpK_error_service (1008)

/*
 * ccsi {\object(class)}
 * Coded Character Set Infrastructure
 */
# define AorpK_ccsi_service (1009)

/*
 * ccsconv {\object(class)} [Constructor]
 * Coded Character Set Conversion
 */
# define AorpK_ccsconv_service (1010)

/*
 * ccscvtor {\ops}
 * Coded Character Set Convertor
 */
# define AorpK_ccscvtor_service (1011)

/*
 * notifier {\object(instance)}
 */
# define AorpK_notifier_service (1017) /* 1018 */

/*
 * listener {\object(instance)}
 */
# define AorpK_listener_service (1019) /* 1020 */
/* @} */

/* ----------------------------------------------------------------------------
 * basis services
 * [1050, 1070[
 * @{
 */

/*
 * container {\object(instance)}
 */
# define AorpK_container_service (1050)
/* @} */

/* ----------------------------------------------------------------------------
 * io services
 * [1070, 1090[
 * @{
 */

/*
 * ios {\object(instance)}
 */
# define AorpK_ios_service (1070)

/*
 * iostr {\object(instance)}
 */
# define AorpK_iostr_service (1071)

/*
 * ioport {\object(instance)}
 */
# define AorpK_ioport_service (1072)

/*
 * iopump {\object(instance)}
 */
# define AorpK_iopump_service (1073)

/*
 * strjet {\object(class)}
 */
# define AorpK_strjet_service (1075)

/*
 * strum {\object(instance)}
 */
# define AorpK_strum_service (1076)

/*
 * strmod {\object(instance)}
 */
# define AorpK_strmod_service (1077)

/*
 * mui {\object(instance)}
 */
# define AorpK_mui_service (1080)
/* @} */

/* ----------------------------------------------------------------------------
 * hilis services
 * [1090, 1110[
 * @{
 */

/*
 * urilib {\object(class)}
 */
# define AorpK_urilib_service (1090)

/*
 * uribend {\object(class)}
 */
# define AorpK_uribend_service (1091)

/*
 * uri {\object(instance)}
 */
# define AorpK_uri_service (1092)

/*
 * propbag {\object(instance)}
 */
# define AorpK_propbag_service (1093)

/*
 * plstat {\object(class)}
 */
# define AorpK_plstat_service (1094)

// @todo: ???
///*
// * plnode {\object(instance)}
// */
//# define AorpK_plnode_service (1075)
//
///*
// * plist {\object(instance)}
// */
//# define AorpK_plist_service (1076)
//
///*
// * plmount {\object(instance)}
// */
//# define AorpK_plmount_service (1077)
//
///*
// * plio {\object(class)}
// */
//# define AorpK_plio_service (1079)
/* @} */

/* ----------------------------------------------------------------------------
 * jobcntl services
 * [1110, 1130[
 * @{
 */

/*
 * job {\object(instance)}
 */
# define AorpK_job_service (1110)

/*
 * runloop {\object(instance)}
 */
# define AorpK_runloop_service (1111)

/*
 * sched {\object(instance)}
 */
# define AorpK_sched_service (1112)
/* @} */

/* ----------------------------------------------------------------------------
 * crypt services
 * [1130, 1150[
 * @{
 */

/*
 * crypt {\object(class)}
 */
# define AorpK_crypt_service (1130)

/*
 * cryptal {\ops}
 */
# define AorpK_cryptal_service (1131)

/*
 * chash {\object(class)}
 */
# define AorpK_chash_service (1132)

/*
 * chashal {\ops}
 */
# define AorpK_chashal_service (1133)
/* @} */

/* ----------------------------------------------------------------------------
 * net services
 * [1150, 1190[
 * @{
 */

/*
 * otidcntl {\object(class)}
 */
# define AorpK_otidcntl_service (1150)

/*
 * oti {\object(instance)}
 */
# define AorpK_oti_service (1151)

// @todo: ???
///*
// * pafi {\object(class)}
// * protocol-address-family Info Service
// */
//# define AorpK_pafi_service (1150)
/* @} */

/* ----------------------------------------------------------------------------
 * infos services
 * [1190, 1250[
 * @{
 */

/*
 * log {\object(instance)}
 */
# define AorpK_log_service (1190)
/* @} */

/* ----------------------------------------------------------------------------
 * textan services
 * [1250, 1290[
 * @{
 */

/*
 * lexan {\object(instance)}
 */
# define AorpK_lexan_service (1250)

/*
 * syxan {\object(instance)}
 */
# define AorpK_syxan_service (1251)

/*
 * lexspecc {\object(class)}
 */
# define AorpK_lexspecc_service (1252)

/*
 * lexopen {\object(instance)}
 */
# define AorpK_lexopen_service (1253)

/*
 * dfa {\object(instance)|\object(class)}
 */
# define AorpK_dfa_service (1254)

/*
 * gramspecc {\object(class)}
 */
# define AorpK_gramspecc_service (1255)

/*
 * lrtab {\object(instance)|\object(class)}
 */
# define AorpK_lrtab_service (1256)
/* @} */


# define AorpK_USER_AVAILABLE_SERVICE (10000)

#endif /* !__BO_SERVICES_MIB_SERVICES__ */

/******************************************************************************
 * Revision History:
 *		$Log$
 *
 *****************************************************************************/
