/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright (c) 2005-2007 V.Sokur
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

/*
 * Ntfier.h	(V.Sokur)
 * include/Bo/services/Ntfier.h
 *
 * $Id$
 */

/* ------------------------------------------------------------------------- */

#ifndef __BO_SERVICES_NTFIER__
# define __BO_SERVICES_NTFIER__

/******************************************************************************
 * %% BeginSection: includes
 */

# include <Bo/services/NtfierP.h>

/******************************************************************************
 * %% BeginSection: function prototypes
 */
# pragma mark -
# pragma mark [ function prototypes ]
# pragma mark -

__MYC_BEGIN_CDECLS

/*
ssize_t
__attribute__((nonnull(1)))
AorpListenerCount(
	aorp_object_t aThis,
	struct aorp_error *anErrPtr
	);
 */
# define AorpListenerCount(aThis, anErrPtr) \
	_A_call(listenerc, notifier, aThis, anErrPtr)

# pragma mark -

/*
bo_status_t
__attribute__((nonnull(1)))
AorpRemoveListener(
	aorp_object_t aThis,
	aorp_object_t aLstner,
	struct aorp_error *anErrPtr
	);
 */
# define AorpRemoveListener(aThis, aLstner, anErrPtr) \
	_A_call(rmlistener, notifier, aThis, anErrPtr, aLstner)

# pragma mark -

/* NOT FOR YOUR BUSINESS
 * Theses operations are intended to be called internally.
 * @{
 */

/*
bo_status_t
__attribute__((nonnull(1)))
_AorpClearListeners(
	aorp_object_t ,
	struct aorp_error *
	);
 */
# define _AorpClearListeners(x, z) \
	_A_call(clearlisteners, notifier, x, z)

# pragma mark -

/*
bo_status_t
__attribute__((nonnull(1,2)))
_AorpPostNotice(
	aorp_object_t ,
	bo_notice_t ,
	struct aorp_error *
	);
 */
# define _AorpPostNotice(x, y, z) \
	_A_call(postnotice, notifier, x, z, y)

# pragma mark -

/*
bo_status_t
__attribute__((nonnull(1)))
_AorpUnlinkListener_nlk(
	aorp_object_t ,
	aorp_object_t ,
	struct aorp_error *
	);
 */
# define _AorpUnlinkListener_nlk(x, y, z) \
	_A_call(unlinklistener_nlk, notifier, x, z, y)

/* @} */

# pragma mark -

/* NOT FOR YOUR BUSINESS
 * Theses operations are intended to be called by a listener.
 * @{
 */

/*
bo_status_t
__attribute__((nonnull(1,2)))
_AorpAddListener(
	aorp_object_t ,
	aorp_object_t ,
	int32_t *,
	struct aorp_error *
	);
 */
# define _AorpAddListener(x, y1, y2, z) \
	_A_call(addlistener, notifier, x, z, y1, y2)

# pragma mark -

/*
bo_status_t
__attribute__((nonnull(1)))
_AorpUnlinkListener(
	aorp_object_t ,
	aorp_object_t ,
	struct aorp_error *
	);
 */
# define _AorpUnlinkListener(x, y, z) \
	_A_call(unlinklistener, notifier, x, z, y)

/* @} */

__MYC_END_CDECLS

#endif /* !__BO_SERVICES_NTFIER__ */

/******************************************************************************
 * Revision History:
 *		$Log$
 *
 *****************************************************************************/
