/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright (c) 2005-2007 V.Sokur
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

/*
 * NtfierP.h	(V.Sokur)
 * include/Bo/services/NtfierP.h
 *
 * $Id$
 */

/* ------------------------------------------------------------------------- */

#ifndef __BO_SERVICES_NTFIER_P__
# define __BO_SERVICES_NTFIER_P__

/******************************************************************************
 * %% BeginSection: includes
 */

# include <Bo/services/Ntfiertypes.h>

/******************************************************************************
 * %% BeginSection: notifier service declarations
 */
# pragma mark -
# pragma mark [ notifier service declarations ]
# pragma mark -

# define __aorpc_need_service_notifier 1

#endif /* !__BO_SERVICES_NTFIER_P__ */

#pragma mark -

#if __aorpc_uses_service(notifier)
# undef __aorpc_need_service_notifier

/*
 * notifier service
 * @{
 */

/*
 * notifier {\object(instance)}
 */
/*
# define AorpK_notifier_service (1017)
 */
# include <Bo/services/MIB/Services.h>

# define __aorpc_service_name notifier
# include <Bo/aorp/AorpCsrvc.h>

_A_service(notifier)

# if __aorpc_interface

	struct aorp_notifier_client {
		aorp_object_t   listener;
		int32_t        *events;
	};

# endif /* __aorpc_interface */

_A_end_ctb

	_A_attribute((nonnull(1)))
	_A_op(listenerc, "notifier::listener-count", (
			struct aorp_closure *aClosure,
			struct aorp_error *anErrPtr
		)),

	_A_attribute((nonnull(1)))
	_A_op(clearlisteners, "notifier::clear-listeners", (
			struct aorp_closure *aClosure,
			struct aorp_error *anErrPtr
		)),

	_A_attribute((nonnull(1,3)))
	_A_op(postnotice, "notifier::post-notice", (
			struct aorp_closure *aClosure,
			struct aorp_error *anErrPtr,
			bo_notice_t aNotice
		)),

	_A_attribute((nonnull(1,3)))
	_A_op(addlistener, "notifier::add-listener", (
			struct aorp_closure *aClosure,
			struct aorp_error *anErrPtr,
			aorp_object_t aListener,
			int32_t *Events /* = NULL: all events */
		)),

	_A_attribute((nonnull(1)))
	_A_op(rmlistener, "notifier::remove-listener", (
			struct aorp_closure *aClosure,
			struct aorp_error *anErrPtr,
			aorp_object_t aListener
		)),

	_A_attribute((nonnull(1)))
	_A_op(unlinklistener, "notifier::unlink-listener", (
			struct aorp_closure *aClosure,
			struct aorp_error *anErrPtr,
			aorp_object_t aListener
		)),

	_A_attribute((nonnull(1)))
	_A_op(unlinklistener_nlk, "notifier::unlink-listener-nolock", (
			struct aorp_closure *aClosure,
			struct aorp_error *anErrPtr,
			aorp_object_t aListener
		)),

_A_end;

# include <Bo/aorp/AorpCend.h>
/* @} */
#endif /* __aorpc_uses_service(notifier) */

/******************************************************************************
 * Revision History:
 *		$Log$
 *
 *****************************************************************************/
