/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright (c) 2005-2007 V.Sokur
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

/*
 * Ucntl.h	(V.Sokur)
 * include/Bo/services/Ucntl.h
 *
 * $Id$
 */

/* ------------------------------------------------------------------------- */

#ifndef __BO_SERVICES_UCNTL__
# define __BO_SERVICES_UCNTL__

/******************************************************************************
 * %% BeginSection: includes
 */

# include <Bo/services/UcntlP.h>

/******************************************************************************
 * %% BeginSection: function prototypes
 */
# pragma mark -
# pragma mark [ function prototypes ]
# pragma mark -

# include <Bo/BoLinkage.h>

__MYC_BEGIN_CDECLS

__myc_flinkage__(public,libBo) ssize_t
__myc_calltype__(mcall)
__attribute__((nonnull(1)))
AorpRetain(
# if __myc_require(prototypes)
	aorp_object_t aThis,
	struct aorp_error *anErrPtr __myc_defval__(NULL)
# endif
	);

# define AorpRetain(aThis, anErrPtr) \
	((ssize_t) _A_call(retain, ucntl, aThis, anErrPtr))

/* ------------------------------------------------------------------------- */
# pragma mark -
/* ------------------------------------------------------------------------- */

__myc_flinkage__(public,libBo) ssize_t
__myc_calltype__(mcall)
__attribute__((nonnull(1)))
AorpRelease(
# if __myc_require(prototypes)
	aorp_object_t aThis,
	aorp_opflags_t Flags __myc_defval__(0),
	struct aorp_error *anErrPtr __myc_defval__(NULL)
# endif
	);

# define AorpRelease(aThis, Flags, anErrPtr) \
	((ssize_t) _A_call(release, ucntl, aThis, anErrPtr, Flags))

/* ------------------------------------------------------------------------- */
# pragma mark -
/* ------------------------------------------------------------------------- */

__myc_flinkage__(public,libBo) bo_hash_t
__myc_calltype__(mcall)
__attribute__((nonnull(1)))
AorpHash(
# if __myc_require(prototypes)
	aorp_object_t aThis,
	struct aorp_error *anErrPtr __myc_defval__(NULL)
# endif
	);

# define AorpHash(aThis, anErrPtr) \
	((bo_hash_t) _A_call(hash, ucntl, aThis, anErrPtr))

/* ------------------------------------------------------------------------- */
# pragma mark -
/* ------------------------------------------------------------------------- */

__myc_flinkage__(public,libBo) bo_mismatch_t
__myc_calltype__(mcall)
__attribute__((nonnull(1,2)))
AorpCompare(
# if __myc_require(prototypes)
	aorp_object_t aLhs,
	AORP_ONEP_OF((aorp_object_t, aorp_comparable_t)) aRhs
# endif
	);

# define AorpCompare(aLhs, aRhs) \
	((bo_mismatch_t) _A_call(compare, ucntl, aLhs, NULL, aLhs, aRhs))

/* ------------------------------------------------------------------------- */
# pragma mark -
/* ------------------------------------------------------------------------- */

__myc_flinkage__(public,libBo) ssize_t
__attribute__((nonnull(1)))
_AorpRetainvalue(
# if __myc_require(prototypes)
	aorp_object_t ,
	ssize_t ,
	struct aorp_error *
# endif
	);

# define _AorpRetainvalue(x,y,z) \
	((ssize_t) _A_call(retain_value, ucntl, x, z, y))

/* ------------------------------------------------------------------------- */
# pragma mark -
/* ------------------------------------------------------------------------- */

# ifndef AORP_LAZY_DUP_DECLARED
#  define AORP_LAZY_DUP_DECLARED
/* retain used */
__myc_flinkage__(public,libBo) aorp_object_t
__myc_calltype__(mcall)
__attribute__((nonnull(1)))
AorpLazydup(
# if __myc_require(prototypes)
	aorp_object_t aThis,
	aorp_opflags_t Flags __myc_defval__(0),  /* unused */
	bo_pointer_t aParm __myc_defval__(NULL), /* unused */
	struct aorp_error *anErrPtr __myc_defval__(NULL)
# endif
	);
# endif /* !AORP_LAZY_DUP_DECLARED */

/*
 * for btree, etc.
 */

/* without 'dump()' */
__myc_vlinkage__(public,libBo) struct bo_btninfo_opv const _G_ucntl_btninfo_opv;

__MYC_END_CDECLS

#endif /* !__BO_SERVICES_UCNTL__ */

/******************************************************************************
 * Revision History:
 *		$Log$
 *
 *****************************************************************************/
