/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright (c) 2005-2007 V.Sokur
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

/*
 * _CbUlsnerP.h	(V.Sokur)
 * include/Bo/services/alg/_CbUlsnerP.h
 *
 * $Id$
 */

/* ------------------------------------------------------------------------- */

#ifndef __BO_SERVICES_ALG__CBULSNER_P__
# define __BO_SERVICES_ALG__CBULSNER_P__

/******************************************************************************
 * %% BeginSection: includes
 */

# include <Bo/services/alg/_CbUlsner.h>
# include <Bo/services/alg/_UlstnerP.h>

/******************************************************************************
 * %% BeginSection: type declarations
 */
# pragma mark -
# pragma mark [ type declarations ]
# pragma mark -

_A_opdom(CbUlsner) {
	_ULSTNER_GUTS;
	struct aorp_listener_client_context  uls_cli;
}
_A_end;

/*
 * {listener,CbUlsner} protocol
 * @{
 */

# define __aorpc_ns_protocol_c 2
# define __aorpc_ns_protocol (listener,CbUlsner)
# define __aorpc_realize_service_file <Bo/services/LstnerP.h>
# include <Bo/aorp/AorpCpro.h>

_A_protocol(listener,CbUlsner)
{
	_A_domdecl_;
}
_A_end_pod

_A_imop_nf(init_once,2,(listener,Ulstner)),
_A_imop_nf(fini_once,2,(listener,Ulstner)),
_A_imop(pod_init),
_A_imop_nf(pod_fini,2,(listener,Ulstner)),

_A_imop_nf(notifierc,2,(listener,Ulstner)),
_A_imop_nf(clearnotifiers,2,(listener,Ulstner)),
_A_imop(listen),
_A_imop_nf(attachtonotifier,2,(listener,Ulstner)),
_A_imop_nf(detachfromnotifier,2,(listener,Ulstner)),
_A_imop_nf(unlinknotifier,2,(listener,Ulstner)),
_A_imop_nf(unlinknotifier_nlk,2,(listener,Ulstner)),
_A_imop_nf(becomedeaf,2,(listener,Ulstner)),
_A_imop_nf(becomeaware,2,(listener,Ulstner)),
_A_imop_nf(isaware,2,(listener,Ulstner)),

_A_end;

# include <Bo/aorp/AorpCend.h>
/* @} */

#endif /* !__BO_SERVICES_ALG__CBULSNER_P__ */

/******************************************************************************
 * Revision History:
 *		$Log$
 *
 *****************************************************************************/
