/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright (c) 2005-2007 V.Sokur
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

/*
 * _Ccsiblttab.h	(V.Sokur)
 * include/Bo/services/alg/_Ccsiblttab.h
 *
 * $Id$
 */

/******************************************************************************
 * %% BeginSection: definitions
 */
# pragma mark -
# pragma mark [ definitions ]
# pragma mark -

_STRUCT_AORP_CCSASTAT(1);
_STRUCT_AORP_CCSASTAT(2);
_STRUCT_AORP_CCSASTAT(3);
_STRUCT_AORP_CCSASTAT(4);
_STRUCT_AORP_CCSASTAT(5);
_STRUCT_AORP_CCSASTAT(6);
_STRUCT_AORP_CCSASTAT(7);
_STRUCT_AORP_CCSASTAT(8);
_STRUCT_AORP_CCSASTAT(9);
_STRUCT_AORP_CCSASTAT(10);

static _TYPENAME_AORP_CCSASTAT(10) _S_ascii_ccsastat = {
	/* .iana_id = */   BoK_ASCII_CSET,
	/* .iana_name = */ _BO_ASCII_CSET_NAME,
	/* .mime_name = */ _BO_ASCII_CSET_MIME,
	/* .wincp = */     367,
	/* .mb_max = */    1,
	/* .aliasc = */    10,
	/* .aliasv = */ {
		"iso-ir-6",
		"ANSI_X3.4-1986",
		"ISO_646.irv:1991",
		"ASCII",
		"ISO646-US",
		"US-ASCII",
		"us",
		"IBM367",
		"CP367",
		"csASCII",
		NULL
	}
};

static _TYPENAME_AORP_CCSASTAT(8) _S_latin1_ccsastat = {
	/* .iana_id = */   BoK_LATIN1_CSET,
	/* .iana_name = */ _BO_LATIN1_CSET_NAME,
	/* .mime_name = */ _BO_LATIN1_CSET_MIME,
	/* .wincp = */     819,
	/* .mb_max = */    0,
	/* .aliasc = */    8,
	/* .aliasv = */ {
		"iso-ir-100",
		"ISO_8859-1",
		"ISO-8859-1",
		"latin1",
		"l1",
		"IBM819",
		"CP819",
		"csISOLatin1",
		NULL
	}
};

static _TYPENAME_AORP_CCSASTAT(6) _S_latin2_ccsastat = {
	/* .iana_id = */   BoK_LATIN2_CSET,
	/* .iana_name = */ _BO_LATIN2_CSET_NAME,
	/* .mime_name = */ _BO_LATIN2_CSET_MIME,
	/* .wincp = */     0,
	/* .mb_max = */    0,
	/* .aliasc = */    6,
	/* .aliasv = */ {
		"iso-ir-101",
		"ISO_8859-2",
		"ISO-8859-2",
		"latin2",
		"l2",
		"csISOLatin2",
		NULL
	}
};

static _TYPENAME_AORP_CCSASTAT(6) _S_latin3_ccsastat = {
	/* .iana_id = */   BoK_LATIN3_CSET,
	/* .iana_name = */ _BO_LATIN3_CSET_NAME,
	/* .mime_name = */ _BO_LATIN3_CSET_MIME,
	/* .wincp = */     0,
	/* .mb_max = */    0,
	/* .aliasc = */    6,
	/* .aliasv = */ {
		"iso-ir-109",
		"ISO_8859-3",
		"ISO-8859-3",
		"latin3",
		"l3",
		"csISOLatin3",
		NULL
	}
};

static _TYPENAME_AORP_CCSASTAT(6) _S_latin4_ccsastat = {
	/* .iana_id = */   BoK_LATIN4_CSET,
	/* .iana_name = */ _BO_LATIN4_CSET_NAME,
	/* .mime_name = */ _BO_LATIN4_CSET_MIME,
	/* .wincp = */     0,
	/* .mb_max = */    0,
	/* .aliasc = */    6,
	/* .aliasv = */ {
		"iso-ir-110",
		"ISO_8859-4",
		"ISO-8859-4",
		"latin4",
		"l4",
		"csISOLatin4",
		NULL
	}
};

static _TYPENAME_AORP_CCSASTAT(8) _S_latin_cyr_ccsastat = {
	/* .iana_id = */   BoK_LATIN_CYR_CSET,
	/* .iana_name = */ _BO_LATIN_CYR_CSET_NAME,
	/* .mime_name = */ _BO_LATIN_CYR_CSET_MIME,
	/* .wincp = */     28595,
	/* .mb_max = */    1,
	/* .aliasc = */    8,
	/* .aliasv = */ {
		"iso-ir-144",
		"ISO_8859-5",
		"ISO-8859-5",
		"cyrillic",
		"csISOLatinCyrillic",
		"ISO8859-5",
		"CP28595",
		"28595",
		NULL
	}
};

static _TYPENAME_AORP_CCSASTAT(5) _S_utf8_ccsastat = {
	/* .iana_id = */   BoK_UTF8_CSET,
	/* .iana_name = */ _BO_UTF8_CSET_NAME,
	/* .mime_name = */ _BO_UTF8_CSET_MIME,
	/* .wincp = */     65001,
	/* .mb_max = */    6,
	/* .aliasc = */    5,
	/* .aliasv = */ {
		"UTF8",
		"UTF-8",
		"UTF_8",
		"CP65001",
		"65001",
		NULL
	}
};

static _TYPENAME_AORP_CCSASTAT(6) _S_koi8r_ccsastat = {
	/* .iana_id = */   BoK_KOI8R_CSET,
	/* .iana_name = */ _BO_KOI8R_CSET_NAME,
	/* .mime_name = */ _BO_KOI8R_CSET_MIME,
	/* .wincp = */     20866,
	/* .mb_max = */    1,
	/* .aliasc = */    6,
	/* .aliasv = */ {
		"csKOI8R",
		"KOI8R",
		"KOI8-R",
		"KOI8_R",
		"CP20866",
		"20866",
		NULL
	}
};

static _TYPENAME_AORP_CCSASTAT(3) _S_ibm_cyr_ccsastat = {
	/* .iana_id = */   BoK_IBM_CYR_CSET,
	/* .iana_name = */ _BO_IBM_CYR_CSET_NAME,
	/* .mime_name = */ _BO_IBM_CYR_CSET_MIME,
	/* .wincp = */     866,
	/* .mb_max = */    1,
	/* .aliasc = */    3,
	/* .aliasv = */ {
		"csIBM866",
		"CP866",
		"866",
		NULL
	}
};

static _TYPENAME_AORP_CCSASTAT(6) _S_koi8u_ccsastat = {
	/* .iana_id = */   BoK_KOI8U_CSET,
	/* .iana_name = */ _BO_KOI8U_CSET_NAME,
	/* .mime_name = */ _BO_KOI8U_CSET_MIME,
	/* .wincp = */     21866,
	/* .mb_max = */    1,
	/* .aliasc = */    6,
	/* .aliasv = */ {
		"csKOI8U",
		"KOI8U",
		"KOI8-U",
		"KOI8_U",
		"CP21866",
		"21866",
		NULL
	}
};

static _TYPENAME_AORP_CCSASTAT(3) _S_win_cyr_ccsastat = {
	/* .iana_id = */   BoK_WIN_CYR_CSET,
	/* .iana_name = */ _BO_WIN_CYR_CSET_NAME,
	/* .mime_name = */ _BO_WIN_CYR_CSET_MIME,
	/* .wincp = */     1251,
	/* .mb_max = */    1,
	/* .aliasc = */    3,
	/* .aliasv = */ {
		"MS-CYRL",
		"CP1251",
		"1251",
		NULL
	}
};

static struct Ccsi_dbelem _S_Ccsi_builtin_table[] = {
	{ BoK_ASCII_CSET,     _AORP_CCSASTAT_NAME,      (struct aorp_ccsastat *)&_S_ascii_ccsastat },
	{ BoK_ASCII_CSET,     _AORP_CCSASTAT_ALIAS,     (struct aorp_ccsastat *)&_S_ascii_ccsastat },
	{ BoK_ASCII_CSET,     _AORP_CCSASTAT_ALIAS,     (struct aorp_ccsastat *)&_S_ascii_ccsastat },
	{ BoK_ASCII_CSET,     _AORP_CCSASTAT_ALIAS,     (struct aorp_ccsastat *)&_S_ascii_ccsastat },
	{ BoK_ASCII_CSET,     _AORP_CCSASTAT_ALIAS,     (struct aorp_ccsastat *)&_S_ascii_ccsastat },
	{ BoK_ASCII_CSET,     _AORP_CCSASTAT_ALIAS,     (struct aorp_ccsastat *)&_S_ascii_ccsastat },
	{ BoK_ASCII_CSET,     _AORP_CCSASTAT_ALIAS,     (struct aorp_ccsastat *)&_S_ascii_ccsastat },
	{ BoK_ASCII_CSET,     _AORP_CCSASTAT_ALIAS,     (struct aorp_ccsastat *)&_S_ascii_ccsastat },
	{ BoK_ASCII_CSET,     _AORP_CCSASTAT_ALIAS,     (struct aorp_ccsastat *)&_S_ascii_ccsastat },
	{ BoK_ASCII_CSET,     _AORP_CCSASTAT_ALIAS,     (struct aorp_ccsastat *)&_S_ascii_ccsastat },
	{ BoK_ASCII_CSET,     _AORP_CCSASTAT_ALIAS,     (struct aorp_ccsastat *)&_S_ascii_ccsastat },

	{ BoK_LATIN1_CSET,    _AORP_CCSASTAT_NAME,      (struct aorp_ccsastat *)&_S_latin1_ccsastat },
	{ BoK_LATIN1_CSET,    _AORP_CCSASTAT_ALIAS,     (struct aorp_ccsastat *)&_S_latin1_ccsastat },
	{ BoK_LATIN1_CSET,    _AORP_CCSASTAT_ALIAS,     (struct aorp_ccsastat *)&_S_latin1_ccsastat },
	{ BoK_LATIN1_CSET,    _AORP_CCSASTAT_ALIAS,     (struct aorp_ccsastat *)&_S_latin1_ccsastat },
	{ BoK_LATIN1_CSET,    _AORP_CCSASTAT_ALIAS,     (struct aorp_ccsastat *)&_S_latin1_ccsastat },
	{ BoK_LATIN1_CSET,    _AORP_CCSASTAT_ALIAS,     (struct aorp_ccsastat *)&_S_latin1_ccsastat },
	{ BoK_LATIN1_CSET,    _AORP_CCSASTAT_ALIAS,     (struct aorp_ccsastat *)&_S_latin1_ccsastat },
	{ BoK_LATIN1_CSET,    _AORP_CCSASTAT_ALIAS,     (struct aorp_ccsastat *)&_S_latin1_ccsastat },
	{ BoK_LATIN1_CSET,    _AORP_CCSASTAT_ALIAS,     (struct aorp_ccsastat *)&_S_latin1_ccsastat },

	{ BoK_LATIN2_CSET,    _AORP_CCSASTAT_NAME,      (struct aorp_ccsastat *)&_S_latin2_ccsastat },
	{ BoK_LATIN2_CSET,    _AORP_CCSASTAT_ALIAS,     (struct aorp_ccsastat *)&_S_latin2_ccsastat },
	{ BoK_LATIN2_CSET,    _AORP_CCSASTAT_ALIAS,     (struct aorp_ccsastat *)&_S_latin2_ccsastat },
	{ BoK_LATIN2_CSET,    _AORP_CCSASTAT_ALIAS,     (struct aorp_ccsastat *)&_S_latin2_ccsastat },
	{ BoK_LATIN2_CSET,    _AORP_CCSASTAT_ALIAS,     (struct aorp_ccsastat *)&_S_latin2_ccsastat },
	{ BoK_LATIN2_CSET,    _AORP_CCSASTAT_ALIAS,     (struct aorp_ccsastat *)&_S_latin2_ccsastat },
	{ BoK_LATIN2_CSET,    _AORP_CCSASTAT_ALIAS,     (struct aorp_ccsastat *)&_S_latin2_ccsastat },

	{ BoK_LATIN3_CSET,    _AORP_CCSASTAT_NAME,      (struct aorp_ccsastat *)&_S_latin3_ccsastat },
	{ BoK_LATIN3_CSET,    _AORP_CCSASTAT_ALIAS,     (struct aorp_ccsastat *)&_S_latin3_ccsastat },
	{ BoK_LATIN3_CSET,    _AORP_CCSASTAT_ALIAS,     (struct aorp_ccsastat *)&_S_latin3_ccsastat },
	{ BoK_LATIN3_CSET,    _AORP_CCSASTAT_ALIAS,     (struct aorp_ccsastat *)&_S_latin3_ccsastat },
	{ BoK_LATIN3_CSET,    _AORP_CCSASTAT_ALIAS,     (struct aorp_ccsastat *)&_S_latin3_ccsastat },
	{ BoK_LATIN3_CSET,    _AORP_CCSASTAT_ALIAS,     (struct aorp_ccsastat *)&_S_latin3_ccsastat },
	{ BoK_LATIN3_CSET,    _AORP_CCSASTAT_ALIAS,     (struct aorp_ccsastat *)&_S_latin3_ccsastat },

	{ BoK_LATIN4_CSET,    _AORP_CCSASTAT_NAME,      (struct aorp_ccsastat *)&_S_latin4_ccsastat },
	{ BoK_LATIN4_CSET,    _AORP_CCSASTAT_ALIAS,     (struct aorp_ccsastat *)&_S_latin4_ccsastat },
	{ BoK_LATIN4_CSET,    _AORP_CCSASTAT_ALIAS,     (struct aorp_ccsastat *)&_S_latin4_ccsastat },
	{ BoK_LATIN4_CSET,    _AORP_CCSASTAT_ALIAS,     (struct aorp_ccsastat *)&_S_latin4_ccsastat },
	{ BoK_LATIN4_CSET,    _AORP_CCSASTAT_ALIAS,     (struct aorp_ccsastat *)&_S_latin4_ccsastat },
	{ BoK_LATIN4_CSET,    _AORP_CCSASTAT_ALIAS,     (struct aorp_ccsastat *)&_S_latin4_ccsastat },
	{ BoK_LATIN4_CSET,    _AORP_CCSASTAT_ALIAS,     (struct aorp_ccsastat *)&_S_latin4_ccsastat },

	{ BoK_LATIN_CYR_CSET, _AORP_CCSASTAT_NAME,      (struct aorp_ccsastat *)&_S_latin_cyr_ccsastat },
	{ BoK_LATIN_CYR_CSET, _AORP_CCSASTAT_ALIAS,     (struct aorp_ccsastat *)&_S_latin_cyr_ccsastat },
	{ BoK_LATIN_CYR_CSET, _AORP_CCSASTAT_ALIAS,     (struct aorp_ccsastat *)&_S_latin_cyr_ccsastat },
	{ BoK_LATIN_CYR_CSET, _AORP_CCSASTAT_ALIAS,     (struct aorp_ccsastat *)&_S_latin_cyr_ccsastat },
	{ BoK_LATIN_CYR_CSET, _AORP_CCSASTAT_ALIAS,     (struct aorp_ccsastat *)&_S_latin_cyr_ccsastat },
	{ BoK_LATIN_CYR_CSET, _AORP_CCSASTAT_ALIAS,     (struct aorp_ccsastat *)&_S_latin_cyr_ccsastat },
	{ BoK_LATIN_CYR_CSET, _AORP_CCSASTAT_ALIAS,     (struct aorp_ccsastat *)&_S_latin_cyr_ccsastat },
	{ BoK_LATIN_CYR_CSET, _AORP_CCSASTAT_ALIAS,     (struct aorp_ccsastat *)&_S_latin_cyr_ccsastat },
	{ BoK_LATIN_CYR_CSET, _AORP_CCSASTAT_ALIAS,     (struct aorp_ccsastat *)&_S_latin_cyr_ccsastat },

	{ BoK_UTF8_CSET,      _AORP_CCSASTAT_NAME,      (struct aorp_ccsastat *)&_S_utf8_ccsastat },
	{ BoK_UTF8_CSET,      _AORP_CCSASTAT_ALIAS,     (struct aorp_ccsastat *)&_S_utf8_ccsastat },
	{ BoK_UTF8_CSET,      _AORP_CCSASTAT_ALIAS,     (struct aorp_ccsastat *)&_S_utf8_ccsastat },
	{ BoK_UTF8_CSET,      _AORP_CCSASTAT_ALIAS,     (struct aorp_ccsastat *)&_S_utf8_ccsastat },
	{ BoK_UTF8_CSET,      _AORP_CCSASTAT_ALIAS,     (struct aorp_ccsastat *)&_S_utf8_ccsastat },
	{ BoK_UTF8_CSET,      _AORP_CCSASTAT_ALIAS,     (struct aorp_ccsastat *)&_S_utf8_ccsastat },

	{ BoK_KOI8R_CSET,     _AORP_CCSASTAT_NAME,      (struct aorp_ccsastat *)&_S_koi8r_ccsastat },
	{ BoK_KOI8R_CSET,     _AORP_CCSASTAT_ALIAS,     (struct aorp_ccsastat *)&_S_koi8r_ccsastat },
	{ BoK_KOI8R_CSET,     _AORP_CCSASTAT_ALIAS,     (struct aorp_ccsastat *)&_S_koi8r_ccsastat },
	{ BoK_KOI8R_CSET,     _AORP_CCSASTAT_ALIAS,     (struct aorp_ccsastat *)&_S_koi8r_ccsastat },
	{ BoK_KOI8R_CSET,     _AORP_CCSASTAT_ALIAS,     (struct aorp_ccsastat *)&_S_koi8r_ccsastat },
	{ BoK_KOI8R_CSET,     _AORP_CCSASTAT_ALIAS,     (struct aorp_ccsastat *)&_S_koi8r_ccsastat },
	{ BoK_KOI8R_CSET,     _AORP_CCSASTAT_ALIAS,     (struct aorp_ccsastat *)&_S_koi8r_ccsastat },

	{ BoK_IBM_CYR_CSET,   _AORP_CCSASTAT_NAME,      (struct aorp_ccsastat *)&_S_ibm_cyr_ccsastat },
	{ BoK_IBM_CYR_CSET,   _AORP_CCSASTAT_ALIAS,     (struct aorp_ccsastat *)&_S_ibm_cyr_ccsastat },
	{ BoK_IBM_CYR_CSET,   _AORP_CCSASTAT_ALIAS,     (struct aorp_ccsastat *)&_S_ibm_cyr_ccsastat },
	{ BoK_IBM_CYR_CSET,   _AORP_CCSASTAT_ALIAS,     (struct aorp_ccsastat *)&_S_ibm_cyr_ccsastat },

	{ BoK_KOI8U_CSET,     _AORP_CCSASTAT_NAME,      (struct aorp_ccsastat *)&_S_koi8u_ccsastat },
	{ BoK_KOI8U_CSET,     _AORP_CCSASTAT_ALIAS,     (struct aorp_ccsastat *)&_S_koi8u_ccsastat },
	{ BoK_KOI8U_CSET,     _AORP_CCSASTAT_ALIAS,     (struct aorp_ccsastat *)&_S_koi8u_ccsastat },
	{ BoK_KOI8U_CSET,     _AORP_CCSASTAT_ALIAS,     (struct aorp_ccsastat *)&_S_koi8u_ccsastat },
	{ BoK_KOI8U_CSET,     _AORP_CCSASTAT_ALIAS,     (struct aorp_ccsastat *)&_S_koi8u_ccsastat },
	{ BoK_KOI8U_CSET,     _AORP_CCSASTAT_ALIAS,     (struct aorp_ccsastat *)&_S_koi8u_ccsastat },
	{ BoK_KOI8U_CSET,     _AORP_CCSASTAT_ALIAS,     (struct aorp_ccsastat *)&_S_koi8u_ccsastat },

	{ BoK_WIN_CYR_CSET,   _AORP_CCSASTAT_NAME,      (struct aorp_ccsastat *)&_S_win_cyr_ccsastat },
	{ BoK_WIN_CYR_CSET,   _AORP_CCSASTAT_ALIAS,     (struct aorp_ccsastat *)&_S_win_cyr_ccsastat },
	{ BoK_WIN_CYR_CSET,   _AORP_CCSASTAT_ALIAS,     (struct aorp_ccsastat *)&_S_win_cyr_ccsastat },
	{ BoK_WIN_CYR_CSET,   _AORP_CCSASTAT_ALIAS,     (struct aorp_ccsastat *)&_S_win_cyr_ccsastat },

	{ BoK_INVAL_CSET, NULL, NULL },
};

/******************************************************************************
 * Revision History:
 *		$Log$
 *
 *****************************************************************************/
