/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright (c) 2005-2007 V.Sokur
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

/*
 * _Kumfam.h	(V.Sokur)
 * include/Bo/services/alg/_Kumfam.h
 *
 * $Id$
 */

/* ------------------------------------------------------------------------- */

#ifndef __BO_SERVICES_ALG__KUMFAM__
# define __BO_SERVICES_ALG__KUMFAM__

/******************************************************************************
 * %% BeginSection: includes
 */

# include <Bo/services/UcntlP.h>

/******************************************************************************
 * %% BeginSection: type declarations
 */
# pragma mark -
# pragma mark [ type declarations ]
# pragma mark -

/*
 * Kumfam
 *
 * ucntl
 * oid: <<category>>/<<service>>/<<domain>>/<<impl>>
 */
/*
# define AorpK_Kumfam_opdom (14)
# define AorpK_Kumfam_opdom_empty 0
 */
# include <Bo/services/MIB/Opdom.h>

# define __aorpc_ns_protocol_c 2
# define __aorpc_ns_protocol (ucntl,Kumfam)
# include <Bo/aorp/AorpCproi.h>

_A_protocol_init(ucntl,Kumfam)
{
	_A_hbdecl_;
	bo_pointer_t  data;
	size_t        bytec;
}
_A_end;

# include <Bo/aorp/AorpCend.h>


# define __aorpc_ns_protocol_c 3
# define __aorpc_ns_protocol (ucntl,Kumfam,WithCB)
# include <Bo/aorp/AorpCproi.h>

_A_protocol_init_(3,(ucntl,Kumfam,WithCB))
{
	_A_hbdecl_;
	bo_pointer_t             data;
	size_t                   bytec;
	struct aorp_custom_opv  *cb;
}
_A_end;

# include <Bo/aorp/AorpCend.h>


# define __aorpc_ns_protocol_c 3
# define __aorpc_ns_protocol (ucntl,Kumfam,aggr)
# include <Bo/aorp/AorpCproi.h>

_A_protocol_init_(3,(ucntl,Kumfam,aggr))
{
	_A_hbdecl_;
	aorp_object_t   lhs;
	aorp_object_t   rhs;
	_Bool           need_retain;
}
_A_end;

# include <Bo/aorp/AorpCend.h>

#endif /* !__BO_SERVICES_ALG__KUMFAM__ */

/******************************************************************************
 * Revision History:
 *		$Log$
 *
 *****************************************************************************/
