/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright (c) 2005-2007 V.Sokur
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

/*
 * Ctnrbase.h	(N.Panasiuk)
 * include/Bo/services/alg/basis/Ctnrbase.h
 *
 * $Id$
 */

/* ------------------------------------------------------------------------- */

#ifndef __BO_SERVICES_ALG_BASIS_CTNRBASE__
# define __BO_SERVICES_ALG_BASIS_CTNRBASE__

/******************************************************************************
 * %% BeginSection: includes
 */

/*
 * It is required the next files are optionally included first:
 *
# include <Bo/sys/Types.h>
 */

/******************************************************************************
 * %% BeginSection: type declarations
 */
# pragma mark -
# pragma mark [ type declarations ]
# pragma mark -

/*
 * [container] elem type
 */

/* Dic<any> */
struct aorp_dic_ctnr_assoc {
	intptr_t   das_key;
		/* currently supported:
			_AorpK_HINT_ANYOB,
			AorpK_HINT_STR,
			AorpK_HINT_WCS,
			AorpK_HINT_INT32 */

	bo_hash_t  das_hash;
	bo_index_t das_idx;
};

# define AORP_DIC_CTNR_ASSOC_GUTS \
	intptr_t   das_key; \
	bo_hash_t  das_hash; \
	bo_index_t das_idx


/* Olis */
union aorp_olis_ctnr_assoc {
	intptr_t        oas_key;
	int64_t         oas_key64;
	/* currently supported:
		_AorpK_HINT_ANYOB,
		AorpK_HINT_STR,
		AorpK_HINT_WCS,
		AorpK_HINT_INT32,
		AorpK_HINT_INT64 */
};

# define AORP_OLIS_CTNR_ASSOC_GUTS \
	intptr_t        oas_key; \
	int64_t         oas_key64


/*
 * [container] duplicate filter param
 */

/* Dic<udvariant> */
struct aorp_udvariant_dic_ctnr_pred_parm {
	aorp_hint_t                  assoc_hint;
	struct aorp_dic_ctnr_assoc  *assoc;
	struct aorp_udvariant       *data;
};

/* Dic<object> */
struct aorp_object_dic_ctnr_pred_parm {
	aorp_hint_t                  assoc_hint;
	struct aorp_dic_ctnr_assoc  *assoc;
	aorp_object_t                data;
};


/* Olis<udvariant> */
struct aorp_udvariant_olis_ctnr_pred_parm {
	aorp_hint_t                  assoc_hint;
	union aorp_olis_ctnr_assoc  *assoc;
	struct aorp_udvariant       *data;
};

/* Olis<object> */
struct aorp_object_olis_ctnr_pred_parm {
	aorp_hint_t                  assoc_hint;
	union aorp_olis_ctnr_assoc  *assoc;
	aorp_object_t                data;
};


#endif /* !__BO_SERVICES_ALG_BASIS_CTNRBASE__ */

/******************************************************************************
 * Revision History:
 *		$Log$
 *
 *****************************************************************************/
