/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright (c) 2005-2007 V.Sokur
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

/*
 * _CtnrbaseI.h	(V.Sokur)
 * include/Bo/services/alg/basis/_CtnrbaseI.h
 *
 * $Id$
 */

/* ------------------------------------------------------------------------- */

#ifndef __BO_SERVICES_ALG_BASIS__CTNRBASE_I__
# define __BO_SERVICES_ALG_BASIS__CTNRBASE_I__

/******************************************************************************
 * %% BeginSection: includes
 */

# include <Bo/services/alg/basis/Ctnrbase.h>

/******************************************************************************
 * %% BeginSection: declarations
 */
# pragma mark -
# pragma mark [ declarations ]
# pragma mark -

/*
 * container category, type
 */

# define array_Ctnr_list_category AorpK_ARRAY_CTNR
# define list_Ctnr_list_category AorpK_LIST_CTNR
# define dicarr_Ctnr_list_category AorpK_DICARR_CTNR
# define diclis_Ctnr_list_category AorpK_DICLIS_CTNR
# define dictre_Ctnr_list_category AorpK_DICTRE_CTNR
# define olis_Ctnr_list_category AorpK_OLIS_CTNR

typedef bo_seqlist_t array_Ctnr_list_type;
typedef bo_cdllist_t list_Ctnr_list_type;
typedef bo_seqlist_t dicarr_Ctnr_list_type;
typedef bo_cdllist_t diclis_Ctnr_list_type;
typedef bo_rtbtree_t dictre_Ctnr_list_type;
typedef bo_rtbtree_t olis_Ctnr_list_type;

/*
 * [container] data category
 */

# define udvariant_Ctnr_data_category AorpK_CTNR_UDVARIANT_DATA
# define object_Ctnr_data_category AorpK_CTNR_OBJECT_DATA

/*
 * [container] elem type
 */

/* Arr */
/*
struct aorp_udvariant;
aorp_object_t;
 */
struct udvariant_array_Ctnr_elem {
	struct aorp_udvariant  qe_data;
};
typedef struct udvariant_array_Ctnr_elem udvariant_array_Ctnr_elem_t;
typedef struct udvariant_array_Ctnr_elem *udvariant_array_Ctnr_iterator;
# define udvariant_array_Ctnr_elem_data(anElemRef) ((anElemRef).qe_data)

struct object_array_Ctnr_elem {
	aorp_object_t  qe_data;
};
typedef struct object_array_Ctnr_elem object_array_Ctnr_elem_t;
typedef struct object_array_Ctnr_elem *object_array_Ctnr_iterator;
# define object_array_Ctnr_elem_data(anElemRef) ((anElemRef).qe_data)

/* List */
struct udvariant_list_Ctnr_elem {
	bo_cdllelem_t          qe_header;
	struct aorp_udvariant  qe_data;
};
typedef struct udvariant_list_Ctnr_elem udvariant_list_Ctnr_elem_t;
typedef struct udvariant_list_Ctnr_elem *udvariant_list_Ctnr_iterator;
# define udvariant_list_Ctnr_elem_data(anElemRef) ((anElemRef).qe_data)

struct object_list_Ctnr_elem {
	bo_cdllelem_t  qe_header;
	aorp_object_t  qe_data;
};
typedef struct object_list_Ctnr_elem object_list_Ctnr_elem_t;
typedef struct object_list_Ctnr_elem *object_list_Ctnr_iterator;
# define object_list_Ctnr_elem_data(anElemRef) ((anElemRef).qe_data)

/* Dic<any> */
struct dic_Ctnr_assoc {
	AORP_DIC_CTNR_ASSOC_GUTS;
};

# ifndef _DicK_ASSOC_HINT_DEFAULT
#  define _DicK_ASSOC_HINT_DEFAULT AorpK_HINT_STR
# endif 

/* Dic<arr> */
struct udvariant_dicarr_Ctnr_elem {
	struct dic_Ctnr_assoc  qe_assoc;
	struct aorp_udvariant  qe_data;
};
typedef struct udvariant_dicarr_Ctnr_elem udvariant_dicarr_Ctnr_elem_t;
typedef struct udvariant_dicarr_Ctnr_elem *udvariant_dicarr_Ctnr_iterator;
# define udvariant_dicarr_Ctnr_elem_data(anElemRef) ((anElemRef).qe_data)

struct object_dicarr_Ctnr_elem {
	struct dic_Ctnr_assoc  qe_assoc;
	aorp_object_t          qe_data;
};
typedef struct object_dicarr_Ctnr_elem object_dicarr_Ctnr_elem_t;
typedef struct object_dicarr_Ctnr_elem *object_dicarr_Ctnr_iterator;
# define object_dicarr_Ctnr_elem_data(anElemRef) ((anElemRef).qe_data)

/* Dic<lis> */
struct udvariant_diclis_Ctnr_elem {
	bo_cdllelem_t          qe_header;
	struct dic_Ctnr_assoc  qe_assoc;
	struct aorp_udvariant  qe_data;
};
typedef struct udvariant_diclis_Ctnr_elem udvariant_diclis_Ctnr_elem_t;
typedef struct udvariant_diclis_Ctnr_elem *udvariant_diclis_Ctnr_iterator;
# define udvariant_diclis_Ctnr_elem_data(anElemRef) ((anElemRef).qe_data)

struct object_diclis_Ctnr_elem {
	bo_cdllelem_t          qe_header;
	struct dic_Ctnr_assoc  qe_assoc;
	aorp_object_t          qe_data;
};
typedef struct object_diclis_Ctnr_elem object_diclis_Ctnr_elem_t;
typedef struct object_diclis_Ctnr_elem *object_diclis_Ctnr_iterator;
# define object_diclis_Ctnr_elem_data(anElemRef) ((anElemRef).qe_data)

/* Dic<tre> */
struct udvariant_dictre_Ctnr_elem {
	bo_rtbtelem_t          qe_header;
	struct dic_Ctnr_assoc  qe_assoc;
	struct aorp_udvariant  qe_data;
};
typedef struct udvariant_dictre_Ctnr_elem udvariant_dictre_Ctnr_elem_t;
typedef struct udvariant_dictre_Ctnr_elem *udvariant_dictre_Ctnr_iterator;
# define udvariant_dictre_Ctnr_elem_data(anElemRef) ((anElemRef).qe_data)

struct object_dictre_Ctnr_elem {
	bo_rtbtelem_t          qe_header;
	struct dic_Ctnr_assoc  qe_assoc;
	aorp_object_t          qe_data;
};
typedef struct object_dictre_Ctnr_elem object_dictre_Ctnr_elem_t;
typedef struct object_dictre_Ctnr_elem *object_dictre_Ctnr_iterator;
# define object_dictre_Ctnr_elem_data(anElemRef) ((anElemRef).qe_data)

/* Olis */
union olis_Ctnr_assoc {
	AORP_OLIS_CTNR_ASSOC_GUTS;
};

# ifndef _OlisK_ASSOC_HINT_DEFAULT
#  define _OlisK_ASSOC_HINT_DEFAULT AorpK_HINT_STR
# endif

struct udvariant_olis_Ctnr_elem {
	bo_rtbtelem_t          qe_header;
	union olis_Ctnr_assoc  qe_assoc;
	struct aorp_udvariant  qe_data;
};
typedef struct udvariant_olis_Ctnr_elem udvariant_olis_Ctnr_elem_t;
typedef struct udvariant_olis_Ctnr_elem *udvariant_olis_Ctnr_iterator;
# define udvariant_olis_Ctnr_elem_data(anElemRef) ((anElemRef).qe_data)

struct object_olis_Ctnr_elem {
	bo_rtbtelem_t          qe_header;
	union olis_Ctnr_assoc  qe_assoc;
	aorp_object_t          qe_data;
};
typedef struct object_olis_Ctnr_elem object_olis_Ctnr_elem_t;
typedef struct object_olis_Ctnr_elem *object_olis_Ctnr_iterator;
# define object_olis_Ctnr_elem_data(anElemRef) ((anElemRef).qe_data)

/* ----------------------------------------------------------------------------
 * container traits stuff
 * @{
 */
# pragma mark -
# pragma mark [ container traits stuff ]
# pragma mark -

/*
__Ctnr_traits< _Name > {
	list_tag: {
		array,
		list,
		dicarr,
		diclis,
		dictre
	}
	list_category{\enum}: {
		array = AorpK_ARRAY_CTNR
		list = AorpK_LIST_CTNR
		dicarr = AorpK_DICARR_CTNR
		diclis = AorpK_DICLIS_CTNR
		dictre = AorpK_DICTRE_CTNR
	}

	data_tag: { udvariant, object }
	int data_category{\enum}: {
		udvariant = AorpK_CTNR_UDVARIANT_DATA
		object = AorpK_CTNR_OBJECT_DATA
	}

	bool    with_size_max
	bool    with_udopv
	bool    with_rwlock
	bool    with_alloc
	bool    with_signal_ins
	bool    with_notification_ins
	bool    with_signal_rem
	bool    with_notification_rem
	bool    associative

	varname udopv_default
	varname alloc_defautl
};
 */

# define _Ctnr_traits(X) __Ctnr_traits(__USE_CTNR_OPDOM__,X)

# define _Ctnr_list_tag _Ctnr_traits(list_tag)
# define _Ctnr_list_type __Ctnr_list_type(__USE_CTNR_OPDOM__)
# define __Ctnr_list_type(_Opdom) __Ctnr_list_type_x(__Ctnr_traits(_Opdom,list_tag))
# define __Ctnr_list_type_x(_ListTag) __myc_xconcat3(_ListTag,_,Ctnr_list_type)
# define _Ctnr_list_category __Ctnr_list_category(__USE_CTNR_OPDOM__)
# define __Ctnr_list_category(_Opdom) __Ctnr_list_category_x(__Ctnr_traits(_Opdom,list_tag))
# define __Ctnr_list_category_x(_ListTag) __myc_xconcat3(_ListTag,_,Ctnr_list_category)

# define _Ctnr_data_tag _Ctnr_traits(data_tag)
# define _Ctnr_data_category __Ctnr_data_category(__USE_CTNR_OPDOM__)
# define __Ctnr_data_category(_Opdom) __Ctnr_data_category_x(__Ctnr_traits(_Opdom,data_tag))
# define __Ctnr_data_category_x(_DataTag) __myc_xconcat3(_DataTag,_,Ctnr_data_category)

# define _Ctnr_udopv_default _Ctnr_traits(udopv_default)
# define _Ctnr_alloc_default _Ctnr_traits(alloc_default)

# define __Ctnr_traits(_Opdom,X) __myc_traits_name(_Opdom,X)
/* @} */

/* ----------------------------------------------------------------------------
 * container itself stuff
 * @{
 */
# pragma mark -
# pragma mark [ container itself stuff ]
# pragma mark -

/*
 * container pod template
 *

_Ctnr_pod< _Opdom > {
	__Ctnr_traits< _Opdom, list_type >  q_list

#if __Ctnr_traits< _Opdom, with_size_max >
	bo_index_t                        q_size_max
#endif

#if __Ctnr_traits< _Opdom, with_rwlock >
	bo_cpurwlock_t                    q_rwlock
#endif

#if __Ctnr_traits< _Opdom, with_udopv >
	struct aorp_udopv                 q_udopv
#endif

#if __Ctnr_traits< _Opdom, with_alloc >
	struct bo_zmalloc                *q_alloc
	size_t                            q_granularity
#endif

#if __Ctnr_traits< _Opdom, with_signal_ins >
	bo_vaxevent_ref                   q_evref
#endif

#if __Ctnr_traits< _Opdom, associative >
	aorp_hint_t                       q_assoc_hint
#endif
}
 */

# define _Ctnr_Sizemax(aPod) __Ctnr_Sizemax(__USE_CTNR_OPDOM__, aPod)
# define _Ctnr_Udopv(aPod) __Ctnr_Udopv(__USE_CTNR_OPDOM__, aPod)
# define _Ctnr_Allocator(aPod) __Ctnr_Allocator(__USE_CTNR_OPDOM__, aPod)
# define _Ctnr_Rdlock(aPod) __Ctnr_Rdlock(__USE_CTNR_OPDOM__, aPod)
# define _Ctnr_Wrlock(aPod) __Ctnr_Wrlock(__USE_CTNR_OPDOM__, aPod)
# define _Ctnr_Unlock(aPod) __Ctnr_Unlock(__USE_CTNR_OPDOM__, aPod)

/*
 * NOT FOR YOUR BUSINESS
 */

# define __Ctnr_Sizemax(_Opdom, aPod) \
	__Ctnr_Sizemax_x(__Ctnr_traits(_Opdom,with_size_max),aPod)
# define __Ctnr_Sizemax_x(_WithSizemax,aPod) \
	__Ctnr_Sizemax_x2(__myc_xconcat(__Ctnr_Sizemax,_WithSizemax),aPod)
# define __Ctnr_Sizemax_x2(_Helper,aPod) __Ctnr_Sizemax_x3(_Helper(aPod))
# define __Ctnr_Sizemax_x3(X) X

# define __Ctnr_Sizemax0(aPod) AorpL_CTNR_SIZE_MAX
# define __Ctnr_Sizemax1(aPod) ((aPod)->q_size_max)


# define __Ctnr_Udopv(_Opdom, aPod) \
	__Ctnr_Udopv_x(__Ctnr_traits(_Opdom,with_udopv),_Opdom,aPod)
# define __Ctnr_Udopv_x(_WithUdopv,_Opdom,aPod) \
	__Ctnr_Udopv_x2(__myc_xconcat(__Ctnr_Udopv,_WithUdopv),_Opdom,aPod)
# define __Ctnr_Udopv_x2(_Helper,_Opdom,aPod) __Ctnr_Udopv_x3(_Helper(_Opdom,aPod))
# define __Ctnr_Udopv_x3(X) X

# define __Ctnr_Udopv0(_Opdom,aPod) __Ctnr_traits(_Opdom,udopv_default)
# define __Ctnr_Udopv1(_Opdom,aPod) ((aPod)->q_udopv)


# define __Ctnr_Allocator(_Opdom, aPod) \
	__Ctnr_Allocator_x(__Ctnr_traits(_Opdom,with_alloc),_Opdom,aPod)
# define __Ctnr_Allocator_x(_WithAlloc,_Opdom,aPod) \
	__Ctnr_Allocator_x2(__myc_xconcat(__Ctnr_Allocator,_WithAlloc),_Opdom,aPod)
# define __Ctnr_Allocator_x2(_Helper,_Opdom,aPod) __Ctnr_Allocator_x3(_Helper(_Opdom,aPod))
# define __Ctnr_Allocator_x3(X) X

# define __Ctnr_Allocator0(_Opdom,aPod) __Ctnr_traits(_Opdom,alloc_default)
# define __Ctnr_Allocator1(_Opdom,aPod) ((aPod)->q_alloc)


# define __Ctnr_Rdlock(_Opdom, aPod) \
	__Ctnr_Rdlock_x(__Ctnr_traits(_Opdom,with_rwlock),aPod)
# define __Ctnr_Rdlock_x(_WithLock,aPod) \
	__Ctnr_Rdlock_x2(__myc_xconcat(__Ctnr_Rdlock,_WithLock),aPod)
# define __Ctnr_Rdlock_x2(_Helper,aPod) __Ctnr_Rdlock_x3(_Helper(aPod))
# define __Ctnr_Rdlock_x3(X) X

# define __Ctnr_Rdlock0(aPod) ((void)0)
# define __Ctnr_Rdlock1(aPod) BoCpurlock((aPod)->q_rwlock)


# define __Ctnr_Wrlock(_Opdom, aPod) \
	__Ctnr_Wrlock_x(__Ctnr_traits(_Opdom,with_rwlock),aPod)
# define __Ctnr_Wrlock_x(_WithLock,aPod) \
	__Ctnr_Wrlock_x2(__myc_xconcat(__Ctnr_Wrlock,_WithLock),aPod)
# define __Ctnr_Wrlock_x2(_Helper,aPod) __Ctnr_Wrlock_x3(_Helper(aPod))
# define __Ctnr_Wrlock_x3(X) X

# define __Ctnr_Wrlock0(aPod) ((void)0)
# define __Ctnr_Wrlock1(aPod) BoCpuwlock((aPod)->q_rwlock)


# define __Ctnr_Unlock(_Opdom, aPod) \
	__Ctnr_Unlock_x(__Ctnr_traits(_Opdom,with_rwlock),aPod)
# define __Ctnr_Unlock_x(_WithLock,aPod) \
	__Ctnr_Unlock_x2(__myc_xconcat(__Ctnr_Unlock,_WithLock),aPod)
# define __Ctnr_Unlock_x2(_Helper,aPod) __Ctnr_Unlock_x3(_Helper(aPod))
# define __Ctnr_Unlock_x3(X) X

# define __Ctnr_Unlock0(aPod) ((void)0)
# define __Ctnr_Unlock1(aPod) BoCpurwunlock((aPod)->q_rwlock)
/* @} */

/* ----------------------------------------------------------------------------
 * internal container iterator stuff
 * @{
 */
# pragma mark -
# pragma mark [ internal container iterator stuff ]
# pragma mark -

# define _Ctnr_iterator __Ctnr_iterator(__USE_CTNR_OPDOM__)

# define _Ctnr_iter_elem(anIter) (*(anIter))

# define _Ctnr_iter_deref(anIter) _Ctnr_elem_data(_Ctnr_iter_elem(anIter))
# define _Ctnr_iter_deref_ptr(anIter) _Ctnr_elem_data_ptr(_Ctnr_iter_elem(anIter))
# define _Ctnr_iter_udvariant(anIter) _Ctnr_elem_udvariant(_Ctnr_iter_elem(anIter))
# define _Ctnr_iter_object(anIter) _Ctnr_elem_object(_Ctnr_iter_elem(anIter))
# define _Ctnr_iter_assoc(anIter) _Ctnr_elem_assoc(_Ctnr_iter_elem(anIter))

/*
 * NOT FOR YOUR BUSINESS
 */

# define __Ctnr_iterator(_Opdom) \
	__Ctnr_iterator_x(__Ctnr_traits(_Opdom,data_tag),__Ctnr_traits(_Opdom,list_tag))
# define __Ctnr_iterator_x(_DataTag,_ListTag) \
	__myc_xconcat4(_DataTag,_,_ListTag,_Ctnr_iterator)
/* @} */

/* ----------------------------------------------------------------------------
 * conrainer elem stuff
 * @{
 */
# pragma mark -
# pragma mark [ conrainer elem stuff ]
# pragma mark -

# define _Ctnr_elem_type __Ctnr_elem_type(__USE_CTNR_OPDOM__)

# define _Ctnr_elem_data(anElemRef) __Ctnr_elem_data(__USE_CTNR_OPDOM__, anElemRef)
# define _Ctnr_elem_data_ptr(anElemRef) __Ctnr_elem_data_ptr(__USE_CTNR_OPDOM__, anElemRef)
# define _Ctnr_elem_udvariant(anElemRef) __Ctnr_elem_udvariant(__USE_CTNR_OPDOM__, anElemRef)
# define _Ctnr_elem_object(anElemRef) __Ctnr_elem_object(__USE_CTNR_OPDOM__, anElemRef)
# define _Ctnr_elem_assoc(anElemRef) __Ctnr_elem_assoc(__USE_CTNR_OPDOM__, anElemRef)

/* aVar: (aorp_udvariant*|aorp_object) */
# define _Ctnr_elem_Init(aStatusRef, aPod, anElemRef, aVar, anErrPtr) \
	__Ctnr_elem_Init(__USE_CTNR_OPDOM__, aStatusRef, aPod, anElemRef, aVar, anErrPtr)
# define _Ctnr_elem_Destroy(aStatusRef, aPod, anElemRef, anErrPtr) \
	__Ctnr_elem_Destroy(__USE_CTNR_OPDOM__, aStatusRef, aPod, anElemRef, anErrPtr)
# define _Ctnr_elem_RetainData(aStatusRef, aPod, anElemRef, anErrPtr) \
	__Ctnr_elem_RetainData(__USE_CTNR_OPDOM__, aStatusRef, aPod, anElemRef, anErrPtr)
# define _Ctnr_elem_ReleaseData(aStatusRef, aPod, anElemRef, anErrPtr) \
	__Ctnr_elem_ReleaseData(__USE_CTNR_OPDOM__, aStatusRef, aPod, anElemRef, anErrPtr)

/*
 * NOT FOR YOUR BUSINESS
 */

# define __Ctnr_elem_type(_Opdom) \
	__Ctnr_elem_type_x(__Ctnr_traits(_Opdom,data_tag),__Ctnr_traits(_Opdom,list_tag))
# define __Ctnr_elem_type_x(_DataTag,_ListTag) \
	__myc_xconcat4(_DataTag,_,_ListTag,_Ctnr_elem_t)


# define __Ctnr_elem_data(_Opdom,anElemRef) \
	__Ctnr_elem_data_x(__Ctnr_traits(_Opdom,data_tag),__Ctnr_traits(_Opdom,list_tag),anElemRef)
# define __Ctnr_elem_data_x(_DataTag,_ListTag,anElemRef) \
	__Ctnr_elem_data_x2(__myc_xconcat4(_DataTag,_,_ListTag,_Ctnr_elem_data),anElemRef)
# define __Ctnr_elem_data_x2(_Helper,anElemRef) \
	__Ctnr_elem_data_x3(_Helper(anElemRef))
# define __Ctnr_elem_data_x3(X) X


# define __Ctnr_elem_data_ptr(_Opdom,anElemRef) \
	__Ctnr_elem_data_ptr_x(__Ctnr_traits(_Opdom,data_tag),__Ctnr_traits(_Opdom,list_tag),anElemRef)
# define __Ctnr_elem_data_ptr_x(_DataTag,_ListTag,anElemRef) \
	__Ctnr_elem_data_ptr_x2(__myc_xconcat(_DataTag,_Ctnr_elem_data_ptr),_ListTag,anElemRef)
# define __Ctnr_elem_data_ptr_x2(_Helper,_ListTag,anElemRef) \
	__Ctnr_elem_data_ptr_x3(_Helper(_ListTag,anElemRef))
# define __Ctnr_elem_data_ptr_x3(X) X

# define udvariant_Ctnr_elem_data_ptr(_ListTag,anElemRef) \
	udvariant_Ctnr_elem_data_ptr_x(__myc_xconcat3(udvariant_,_ListTag,_Ctnr_elem_data),anElemRef)
# define udvariant_Ctnr_elem_data_ptr_x(_Helper,anElemRef) \
	udvariant_Ctnr_elem_data_ptr_x2(_Helper(anElemRef))
# define udvariant_Ctnr_elem_data_ptr_x2(X) (&X)

# define object_Ctnr_elem_data_ptr(_ListTag,anElemRef) \
	object_Ctnr_elem_data_ptr_x(__myc_xconcat3(object_,_ListTag,_Ctnr_elem_data),anElemRef)
# define object_Ctnr_elem_data_ptr_x(_Helper,anElemRef) \
	object_Ctnr_elem_data_ptr_x2(_Helper(anElemRef))
# define object_Ctnr_elem_data_ptr_x2(X) X


# define __Ctnr_elem_udvariant(_Opdom,anElemRef) \
	__Ctnr_elem_udvariant_x(__Ctnr_traits(_Opdom,data_tag),__Ctnr_traits(_Opdom,list_tag),anElemRef)
# define __Ctnr_elem_udvariant_x(_DataTag,_ListTag,anElemRef) \
	__Ctnr_elem_udvariant_x2(__myc_xconcat(_DataTag,_Ctnr_elem_udvariant),_ListTag,anElemRef)
# define __Ctnr_elem_udvariant_x2(_Helper,_ListTag,anElemRef) \
	__Ctnr_elem_udvariant_x3(_Helper(_ListTag,anElemRef))
# define __Ctnr_elem_udvariant_x3(X) X

# define udvariant_Ctnr_elem_udvariant(_ListTag,anElemRef) \
	udvariant_Ctnr_elem_udvariant_x(__myc_xconcat3(udvariant_,_ListTag,_Ctnr_elem_data),anElemRef)
# define udvariant_Ctnr_elem_udvariant_x(_Helper,anElemRef) \
	udvariant_Ctnr_elem_udvariant_x2(_Helper(anElemRef))
# define udvariant_Ctnr_elem_udvariant_x2(X) X

# define object_Ctnr_elem_udvariant(_ListTag,anElemRef) \
	object_Ctnr_elem_udvariant_x(__myc_xconcat3(object_,_ListTag,_Ctnr_elem_data),anElemRef)
# define object_Ctnr_elem_udvariant_x(_Helper,anElemRef) \
	object_Ctnr_elem_udvariant_x2(_Helper(anElemRef))
# define object_Ctnr_elem_udvariant_x2(X) AORP_UDVARIANT_OBJ(X)


# define __Ctnr_elem_object(_Opdom,anElemRef) \
	__Ctnr_elem_object_x(__Ctnr_traits(_Opdom,data_tag),__Ctnr_traits(_Opdom,list_tag),anElemRef)
# define __Ctnr_elem_object_x(_DataTag,_ListTag,anElemRef) \
	__Ctnr_elem_object_x2(__myc_xconcat(_DataTag,_Ctnr_elem_object),_ListTag,anElemRef)
# define __Ctnr_elem_object_x2(_Helper,_ListTag,anElemRef) \
	__Ctnr_elem_object_x3(_Helper(_ListTag,anElemRef))
# define __Ctnr_elem_object_x3(X) X

# define udvariant_Ctnr_elem_object(_ListTag,anElemRef) \
	udvariant_Ctnr_elem_object_x(__myc_xconcat3(udvariant_,_ListTag,_Ctnr_elem_data),anElemRef)
# define udvariant_Ctnr_elem_object_x(_Helper,anElemRef) \
	udvariant_Ctnr_elem_object_x2(_Helper(anElemRef))
# define udvariant_Ctnr_elem_object_x2(X) \
	((_AorpK_HINT_ANYOB == AORP_OBJECT_Hint(&X)) ? X.u.udc_udata : NULL)

# define object_Ctnr_elem_object(_ListTag,anElemRef) \
	object_Ctnr_elem_object_x(__myc_xconcat3(object_,_ListTag,_Ctnr_elem_data),anElemRef)
# define object_Ctnr_elem_object_x(_Helper,anElemRef) \
	object_Ctnr_elem_object_x2(_Helper(anElemRef))
# define object_Ctnr_elem_object_x2(X) X


# define __Ctnr_elem_assoc(_Opdom,anElemRef) ((anElemRef).qe_assoc)

/*
 * init elem
 */

# define __Ctnr_elem_Init(_Opdom, aStatusRef, aPod, anElemRef, aVar, anErrPtr) \
	__Ctnr_elem_Init_x(__Ctnr_traits(_Opdom,data_tag), _Opdom, aStatusRef, \
			aPod, anElemRef, aVar, anErrPtr)

# define __Ctnr_elem_Init_x(_DataTag, _Opdom, aStatusRef, aPod, anElemRef, aVar, anErrPtr) \
	__Ctnr_elem_Init_x2(__myc_xconcat(_DataTag,_Ctnr_elem_Init), _Opdom, \
			aStatusRef, aPod, anElemRef, aVar, anErrPtr)

# define __Ctnr_elem_Init_x2(_Helper, _Opdom, aStatusRef, aPod, anElemRef, aVar, anErrPtr) \
	__Ctnr_elem_Init_x3(_Helper(_Opdom, aStatusRef, aPod, anElemRef, aVar, anErrPtr))

# define __Ctnr_elem_Init_x3(X) X

# define udvariant_Ctnr_elem_Init(_Opdom, aStatusRef, aPod, anElemRef, aVar, anErrPtr) \
	AORP_UDVARIANT_Copy( \
		aStatusRef, &__Ctnr_Udopv(_Opdom,aPod), \
		(aVar), &__Ctnr_elem_data(_Opdom,anElemRef), 0, NULL, anErrPtr \
	)

# define object_Ctnr_elem_Init(_Opdom, aStatusRef, aPod, anElemRef, aVar, anErrPtr) \
	(aStatusRef = \
		(NULL != (__Ctnr_elem_data(_Opdom,anElemRef) = AorpLazydup((aVar)->u.udc_udata, 0, 0, anErrPtr))) \
			? BoS_NORMAL \
			: BoS_ERR)

/*
 * destroy elem
 */

# define __Ctnr_elem_Destroy(_Opdom, aStatusRef, aPod, anElemRef, anErrPtr) \
	__Ctnr_elem_Destroy_x(__Ctnr_traits(_Opdom,data_tag), \
			__Ctnr_traits(_Opdom,associative), _Opdom, aStatusRef, aPod, \
			anElemRef, anErrPtr)

# define __Ctnr_elem_Destroy_x(_DataTag, _Associative, _Opdom, aStatusRef, aPod, anElemRef, anErrPtr) \
	__Ctnr_elem_Destroy_x2(__myc_xconcat3(_DataTag,_Ctnr_elem_Destroy,_Associative), \
			_Opdom, aStatusRef, aPod, anElemRef, anErrPtr)

# define __Ctnr_elem_Destroy_x2(_Helper, _Opdom, aStatusRef, aPod, anElemRef, anErrPtr) \
	__Ctnr_elem_Destroy_x3(_Helper(_Opdom, aStatusRef, aPod, anElemRef, anErrPtr))

# define __Ctnr_elem_Destroy_x3(X) X

# define udvariant_Ctnr_elem_Destroy0(_Opdom, aStatusRef, aPod, anElemRef, anErrPtr) \
	AORP_UDVARIANT_ReleaseData( \
		aStatusRef, &__Ctnr_Udopv(_Opdom,aPod), \
		&__Ctnr_elem_data(_Opdom,anElemRef), 0, anErrPtr \
	)

# define object_Ctnr_elem_Destroy0(_Opdom, aStatusRef, aPod, anElemRef, anErrPtr) \
	(aStatusRef = AorpRelease(__Ctnr_elem_data(_Opdom,anElemRef), 0, anErrPtr))

# define udvariant_Ctnr_elem_Destroy1(_Opdom, aStatusRef, aPod, anElemRef, anErrPtr) \
	do { \
		AORP_UDVARIANT_ReleaseData( \
			aStatusRef, &__Ctnr_Udopv(_Opdom,aPod), \
			&__Ctnr_elem_data(_Opdom,anElemRef), 0, anErrPtr \
		); \
		_Ctnr_DestroyAssoc( \
			aStatusRef, (aPod)->q_assoc_hint, \
			__Ctnr_elem_assoc(_Opdom,anElemRef), anErrPtr \
		); \
	} while (0)

# define object_Ctnr_elem_Destroy1(_Opdom, aStatusRef, aPod, anElemRef, anErrPtr) \
	do { \
		aStatusRef = BoS_NORMAL; \
		if (NULL != __Ctnr_elem_data(_Opdom,anElemRef)) \
			aStatusRef = AorpRelease(__Ctnr_elem_data(_Opdom,anElemRef), 0, anErrPtr); \
		_Ctnr_DestroyAssoc( \
			aStatusRef, (aPod)->q_assoc_hint, \
			__Ctnr_elem_assoc(_Opdom,anElemRef), anErrPtr \
		); \
	} while (0)

/*
 * retain elem data
 */

# define __Ctnr_elem_RetainData(_Opdom, aStatusRef, aPod, anElemRef, anErrPtr) \
	__Ctnr_elem_RetainData_x(__Ctnr_traits(_Opdom,data_tag), _Opdom, aStatusRef, \
			aPod, anElemRef, anErrPtr)

# define __Ctnr_elem_RetainData_x(_DataTag, _Opdom, aStatusRef, aPod, anElemRef, anErrPtr) \
	__Ctnr_elem_RetainData_x2(__myc_xconcat(_DataTag,_Ctnr_elem_RetainData), _Opdom, \
			aStatusRef, aPod, anElemRef, anErrPtr)

# define __Ctnr_elem_RetainData_x2(_Helper, _Opdom, aStatusRef, aPod, anElemRef, anErrPtr) \
	__Ctnr_elem_RetainData_x3(_Helper(_Opdom, aStatusRef, aPod, anElemRef, anErrPtr))

# define __Ctnr_elem_RetainData_x3(X) X

# define udvariant_Ctnr_elem_RetainData(_Opdom, aStatusRef, aPod, anElemRef, anErrPtr) \
	AORP_UDVARIANT_RetainData( \
		aStatusRef, &__Ctnr_Udopv(_Opdom,aPod), \
		&__Ctnr_elem_data(_Opdom,anElemRef), anErrPtr \
	)

# define object_Ctnr_elem_RetainData(_Opdom, aStatusRef, aPod, anElemRef, anErrPtr) \
	(aStatusRef = ((NULL != __Ctnr_elem_data(_Opdom,anElemRef)) \
		? AorpRetain(__Ctnr_elem_data(_Opdom,anElemRef), anErrPtr) \
		: BoS_NORMAL))

/*
 * release elem data
 */

# define __Ctnr_elem_ReleaseData(_Opdom, aStatusRef, aPod, anElemRef, anErrPtr) \
	__Ctnr_elem_ReleaseData_x(__Ctnr_traits(_Opdom,data_tag), _Opdom, aStatusRef, \
			aPod, anElemRef, anErrPtr)

# define __Ctnr_elem_ReleaseData_x(_DataTag, _Opdom, aStatusRef, aPod, anElemRef, anErrPtr) \
	__Ctnr_elem_ReleaseData_x2(__myc_xconcat(_DataTag,_Ctnr_elem_ReleaseData), _Opdom, \
			aStatusRef, aPod, anElemRef, anErrPtr)

# define __Ctnr_elem_ReleaseData_x2(_Helper, _Opdom, aStatusRef, aPod, anElemRef, anErrPtr) \
	__Ctnr_elem_ReleaseData_x3(_Helper(_Opdom, aStatusRef, aPod, anElemRef, anErrPtr))

# define __Ctnr_elem_ReleaseData_x3(X) X

# define udvariant_Ctnr_elem_ReleaseData(_Opdom, aStatusRef, aPod, anElemRef, anErrPtr) \
	AORP_UDVARIANT_ReleaseData( \
		aStatusRef, &__Ctnr_Udopv(_Opdom,aPod), \
		&__Ctnr_elem_data(_Opdom,anElemRef), 0, anErrPtr \
	)

# define object_Ctnr_elem_ReleaseData(_Opdom, aStatusRef, aPod, anElemRef, anErrPtr) \
	(aStatusRef = ((NULL != __Ctnr_elem_data(_Opdom,anElemRef)) \
		? AorpRelease(__Ctnr_elem_data(_Opdom,anElemRef), 0, anErrPtr) \
		: BoS_NORMAL))

/*
 * destroy assoc
 */

# define _Ctnr_DestroyAssoc(aStatusRef, anAssocHint, anAssocRef, anErrPtr) \
	do { \
		intptr_t ___key = (anAssocRef).das_key; \
		(anAssocRef).das_key = (intptr_t)NULL; \
		aStatusRef = BoS_NORMAL; \
		switch ((anAssocHint)) { \
		case _AorpK_HINT_ANYOB: \
			if (NULL != (aorp_object_t)___key) \
				aStatusRef = AorpRelease((aorp_object_t)___key, 0, anErrPtr); \
			break; \
		case AorpK_HINT_STR: \
			strdup_free((char *)___key); \
			break; \
		case AorpK_HINT_WCS: \
			wcsdup_free((wchar_t *)___key); \
			break; \
		default: \
			(anAssocRef).das_key = 0; \
			break; \
		} \
	} while (0)
/* @} */

/* ----------------------------------------------------------------------------
 * container cursor stuff
 * @{
 */
# pragma mark -
# pragma mark [ container cursor stuff ]
# pragma mark -

# define _Ctnr_cursor_spec _Ctnr_cursor_spec_typename
# define _Ctnr_cursor_spec_p(x) __Ctnr_cursor_spec_p(__USE_CTNR_OPDOM__, x)

# define _Ctnr_cursor_spec_tag __Ctnr_cursor_spec_tag(__USE_CTNR_OPDOM__)
# define _Ctnr_cursor_spec_typename __Ctnr_cursor_spec_typename(__USE_CTNR_OPDOM__)
# define _Ctnr_cursor_spec_struc __Ctnr_cursor_spec_struc(__USE_CTNR_OPDOM__)

/*
 * NOT FOR YOUR BUSINESS
 */

# define __Ctnr_cursor_spec_tag(_Opdom) \
	__Ctnr_cursor_spec_tag_x(__Ctnr_traits(_Opdom,data_tag),__Ctnr_traits(_Opdom,list_tag))
# define __Ctnr_cursor_spec_tag_x(_DataTag,_ListTag) \
	__myc_xconcat4(_DataTag,_,_ListTag,_Ctnr_cursor_spec_s)

# define __Ctnr_cursor_spec_typename(_Opdom) struct __Ctnr_cursor_spec_tag(_Opdom)

# define __Ctnr_cursor_spec_struc(_Opdom) \
	__Ctnr_cursor_spec_typename(_Opdom) { \
		__Ctnr_list_type(_Opdom) *list; \
		__Ctnr_iterator(_Opdom)   pos; \
		int                       beforehand; \
	}
# define __Ctnr_cursor_spec_p(_Opdom,x) ((__Ctnr_cursor_spec_typename(_Opdom) *)(x))

struct udvariant_array_Ctnr_cursor_spec_s {
	array_Ctnr_list_type          *list;
	udvariant_array_Ctnr_iterator  pos;
	int                            beforehand;
};

struct object_array_Ctnr_cursor_spec_s {
	array_Ctnr_list_type          *list;
	object_array_Ctnr_iterator     pos;
	int                            beforehand;
};

struct udvariant_list_Ctnr_cursor_spec_s {
	list_Ctnr_list_type           *list;
	udvariant_list_Ctnr_iterator   pos;
	int                            beforehand;
};

struct object_list_Ctnr_cursor_spec_s {
	list_Ctnr_list_type           *list;
	object_list_Ctnr_iterator      pos;
	int                            beforehand;
};

struct udvariant_dicarr_Ctnr_cursor_spec_s {
	dicarr_Ctnr_list_type          *list;
	udvariant_dicarr_Ctnr_iterator  pos;
	int                             beforehand;
};

struct object_dicarr_Ctnr_cursor_spec_s {
	dicarr_Ctnr_list_type          *list;
	object_dicarr_Ctnr_iterator     pos;
	int                             beforehand;
};

struct udvariant_diclis_Ctnr_cursor_spec_s {
	diclis_Ctnr_list_type          *list;
	udvariant_diclis_Ctnr_iterator  pos;
	int                             beforehand;
};

struct object_diclis_Ctnr_cursor_spec_s {
	diclis_Ctnr_list_type          *list;
	object_diclis_Ctnr_iterator     pos;
	int                             beforehand;
};

struct udvariant_dictre_Ctnr_cursor_spec_s {
	dictre_Ctnr_list_type          *list;
	udvariant_dictre_Ctnr_iterator  pos;
	int                             beforehand;
};

struct object_dictre_Ctnr_cursor_spec_s {
	dictre_Ctnr_list_type          *list;
	object_dictre_Ctnr_iterator     pos;
	int                             beforehand;
};

struct udvariant_olis_Ctnr_cursor_spec_s {
	olis_Ctnr_list_type            *list;
	udvariant_olis_Ctnr_iterator    pos;
	int                             beforehand;
};

struct object_olis_Ctnr_cursor_spec_s {
	olis_Ctnr_list_type            *list;
	object_olis_Ctnr_iterator       pos;
	int                             beforehand;
};

struct unknown_Ctnr_cursor_spec_s {
	bo_pointer_t  x;
	bo_pointer_t  y;
	int           beforehand;
};

# ifdef _DEBUG
#  include <Bo/Debug.h>
_BoDbg_StaticAssert(
	sizeof_ctnr_cursor_spec,
	(sizeof(struct unknown_Ctnr_cursor_spec_s) <= AorpK_YQCURSOR_OPAQUE_SIZE));
# endif /* _DEBUG */
/* @} */

# pragma mark -
# pragma mark [ symbol declarations ]
# pragma mark -

/*
__MYC_BEGIN_CDECLS
__myc_vlinkage_amod(private) struct aorp_udopv const _G_ctnr_udopv_default;
__myc_vlinkage_amod(private) struct bo_zmalloc *_G_lisud_alloc_default;
__myc_vlinkage_amod(private) struct bo_zmalloc *_G_lisob_alloc_default;
__MYC_END_CDECLS
 */

#endif /* !__BO_SERVICES_ALG_BASIS__CTNRBASE_I__ */

/******************************************************************************
 * Revision History:
 *		$Log$
 *
 *****************************************************************************/
