/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright (c) 2005-2007 V.Sokur
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

/*
 * _UndicarrP.h	(V.Sokur)
 * include/Bo/services/alg/basis/_UndicarrP.h
 *
 * $Id$
 */

/* ------------------------------------------------------------------------- */

#ifndef __BO_SERVICES_ALG_BASIS__UNDICARR_P__
# define __BO_SERVICES_ALG_BASIS__UNDICARR_P__

/******************************************************************************
 * %% BeginSection: includes
 */

# include <Bo/services/alg/basis/_Undicarr.h>
# include <Bo/services/alg/basis/_WdicarrP.h>

/******************************************************************************
 * %% BeginSection: type declarations
 */
# pragma mark -
# pragma mark [ type declarations ]
# pragma mark -

/* @todo: redesign opdom;
   _A_opdom(Undicarr) == _A_opdom(Wdicarr) */

/*
 * {container,Undicarr} protocol
 * @{
 */

# define __aorpc_ns_protocol_c 2
# define __aorpc_ns_protocol (container,Undicarr)
# define __aorpc_realize_service_file <Bo/services/basis/CtnrP.h>
# include <Bo/aorp/AorpCpro.h>

_A_protocol(container,Undicarr)
{
	_A_domdecl(Wdicarr);
/* @todo: redesign; see above */
# define Undicarr_guts Wdicarr_guts
}
_A_end_pod

/* @todo: redesign */

# ifndef Undicarr_FOREIGN_NS_PROTOCOL
#  define Undicarr_FOREIGN_NS_PROTOCOL_C 2
#  define Undicarr_FOREIGN_NS_PROTOCOL (container,Wdicarr)
# endif

_A_imop_nf(init_once,Undicarr_FOREIGN_NS_PROTOCOL_C,Undicarr_FOREIGN_NS_PROTOCOL),
_A_imop_nf(fini_once,Undicarr_FOREIGN_NS_PROTOCOL_C,Undicarr_FOREIGN_NS_PROTOCOL),
_A_imop_nf(pod_init,Undicarr_FOREIGN_NS_PROTOCOL_C,Undicarr_FOREIGN_NS_PROTOCOL),
_A_imop_nf(pod_fini,Undicarr_FOREIGN_NS_PROTOCOL_C,Undicarr_FOREIGN_NS_PROTOCOL),

_A_imop_nf(count,Undicarr_FOREIGN_NS_PROTOCOL_C,Undicarr_FOREIGN_NS_PROTOCOL),
_A_imop_nf(maxcount,Undicarr_FOREIGN_NS_PROTOCOL_C,Undicarr_FOREIGN_NS_PROTOCOL),
_A_imop_nf(clear,Undicarr_FOREIGN_NS_PROTOCOL_C,Undicarr_FOREIGN_NS_PROTOCOL),

_A_imop_nf(opencrsr,Undicarr_FOREIGN_NS_PROTOCOL_C,Undicarr_FOREIGN_NS_PROTOCOL),
_A_imop_nf(closecrsr,Undicarr_FOREIGN_NS_PROTOCOL_C,Undicarr_FOREIGN_NS_PROTOCOL),
_A_imop_nf(advancecrsr,Undicarr_FOREIGN_NS_PROTOCOL_C,Undicarr_FOREIGN_NS_PROTOCOL),
_A_imop_nf(getbycrsr,Undicarr_FOREIGN_NS_PROTOCOL_C,Undicarr_FOREIGN_NS_PROTOCOL),

_A_imop_nf(rdlock,Undicarr_FOREIGN_NS_PROTOCOL_C,Undicarr_FOREIGN_NS_PROTOCOL),
_A_imop_nf(wrlock,Undicarr_FOREIGN_NS_PROTOCOL_C,Undicarr_FOREIGN_NS_PROTOCOL),
_A_imop_nf(unlock,Undicarr_FOREIGN_NS_PROTOCOL_C,Undicarr_FOREIGN_NS_PROTOCOL),

_A_imop_nf(at,Undicarr_FOREIGN_NS_PROTOCOL_C,Undicarr_FOREIGN_NS_PROTOCOL),
_A_imop_nf(at_nlk,Undicarr_FOREIGN_NS_PROTOCOL_C,Undicarr_FOREIGN_NS_PROTOCOL),
_A_imop_nf(find,Undicarr_FOREIGN_NS_PROTOCOL_C,Undicarr_FOREIGN_NS_PROTOCOL),
_A_imop_nf(find_nlk,Undicarr_FOREIGN_NS_PROTOCOL_C,Undicarr_FOREIGN_NS_PROTOCOL),
_A_imop(insert),
_A_imop(insert_nlk),
_A_imop_nf(remove,Undicarr_FOREIGN_NS_PROTOCOL_C,Undicarr_FOREIGN_NS_PROTOCOL),
_A_imop_nf(remove_nlk,Undicarr_FOREIGN_NS_PROTOCOL_C,Undicarr_FOREIGN_NS_PROTOCOL),
_A_imop_nf(delete,Undicarr_FOREIGN_NS_PROTOCOL_C,Undicarr_FOREIGN_NS_PROTOCOL),
_A_imop_nf(delete_nlk,Undicarr_FOREIGN_NS_PROTOCOL_C,Undicarr_FOREIGN_NS_PROTOCOL),

_A_imop_nf(foreach,Undicarr_FOREIGN_NS_PROTOCOL_C,Undicarr_FOREIGN_NS_PROTOCOL),
_A_imop_nf(foreach_nlk,Undicarr_FOREIGN_NS_PROTOCOL_C,Undicarr_FOREIGN_NS_PROTOCOL),

_A_imop(set),
_A_imop(set_nlk),

_A_end;

# include <Bo/aorp/AorpCend.h>
/* @} */

#endif /* !__BO_SERVICES_ALG_BASIS__UNDICARR_P__ */

/******************************************************************************
 * Revision History:
 *		$Log$
 *
 *****************************************************************************/
