/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright (c) 2005-2007 V.Sokur
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

/*
 * _UndiclisP.h	(V.Sokur)
 * include/Bo/services/alg/basis/_UndiclisP.h
 *
 * $Id$
 */

/* ------------------------------------------------------------------------- */

#ifndef __BO_SERVICES_ALG_BASIS__UNDICLIS_P__
# define __BO_SERVICES_ALG_BASIS__UNDICLIS_P__

/******************************************************************************
 * %% BeginSection: includes
 */

# include <Bo/services/alg/basis/_Undiclis.h>
# include <Bo/services/alg/basis/_WdiclisP.h>

/******************************************************************************
 * %% BeginSection: type declarations
 */
# pragma mark -
# pragma mark [ type declarations ]
# pragma mark -

/* @todo: redesign opdom;
   _A_opdom(Undiclis) == _A_opdom(Wdiclis) */

/*
 * {container,Undiclis} protocol
 * @{
 */

# define __aorpc_ns_protocol_c 2
# define __aorpc_ns_protocol (container,Undiclis)
# define __aorpc_realize_service_file <Bo/services/basis/CtnrP.h>
# include <Bo/aorp/AorpCpro.h>

_A_protocol(container,Undiclis)
{
	_A_domdecl(Wdiclis);
/* @todo: redesign; see above */
# define Undiclis_guts Wdiclis_guts
}
_A_end_pod

/* @todo: redesign */

# ifndef Undiclis_FOREIGN_NS_PROTOCOL
#  define Undiclis_FOREIGN_NS_PROTOCOL_C 2
#  define Undiclis_FOREIGN_NS_PROTOCOL (container,Wdiclis)
# endif

_A_imop_nf(init_once,Undiclis_FOREIGN_NS_PROTOCOL_C,Undiclis_FOREIGN_NS_PROTOCOL),
_A_imop_nf(fini_once,Undiclis_FOREIGN_NS_PROTOCOL_C,Undiclis_FOREIGN_NS_PROTOCOL),
_A_imop_nf(pod_init,Undiclis_FOREIGN_NS_PROTOCOL_C,Undiclis_FOREIGN_NS_PROTOCOL),
_A_imop_nf(pod_fini,Undiclis_FOREIGN_NS_PROTOCOL_C,Undiclis_FOREIGN_NS_PROTOCOL),

_A_imop_nf(count,Undiclis_FOREIGN_NS_PROTOCOL_C,Undiclis_FOREIGN_NS_PROTOCOL),
_A_imop_nf(maxcount,Undiclis_FOREIGN_NS_PROTOCOL_C,Undiclis_FOREIGN_NS_PROTOCOL),
_A_imop_nf(clear,Undiclis_FOREIGN_NS_PROTOCOL_C,Undiclis_FOREIGN_NS_PROTOCOL),

_A_imop_nf(opencrsr,Undiclis_FOREIGN_NS_PROTOCOL_C,Undiclis_FOREIGN_NS_PROTOCOL),
_A_imop_nf(closecrsr,Undiclis_FOREIGN_NS_PROTOCOL_C,Undiclis_FOREIGN_NS_PROTOCOL),
_A_imop_nf(advancecrsr,Undiclis_FOREIGN_NS_PROTOCOL_C,Undiclis_FOREIGN_NS_PROTOCOL),
_A_imop_nf(getbycrsr,Undiclis_FOREIGN_NS_PROTOCOL_C,Undiclis_FOREIGN_NS_PROTOCOL),

_A_imop_nf(rdlock,Undiclis_FOREIGN_NS_PROTOCOL_C,Undiclis_FOREIGN_NS_PROTOCOL),
_A_imop_nf(wrlock,Undiclis_FOREIGN_NS_PROTOCOL_C,Undiclis_FOREIGN_NS_PROTOCOL),
_A_imop_nf(unlock,Undiclis_FOREIGN_NS_PROTOCOL_C,Undiclis_FOREIGN_NS_PROTOCOL),

_A_imop_nf(at,Undiclis_FOREIGN_NS_PROTOCOL_C,Undiclis_FOREIGN_NS_PROTOCOL),
_A_imop_nf(at_nlk,Undiclis_FOREIGN_NS_PROTOCOL_C,Undiclis_FOREIGN_NS_PROTOCOL),
_A_imop_nf(find,Undiclis_FOREIGN_NS_PROTOCOL_C,Undiclis_FOREIGN_NS_PROTOCOL),
_A_imop_nf(find_nlk,Undiclis_FOREIGN_NS_PROTOCOL_C,Undiclis_FOREIGN_NS_PROTOCOL),
_A_imop(insert),
_A_imop(insert_nlk),
_A_imop_nf(remove,Undiclis_FOREIGN_NS_PROTOCOL_C,Undiclis_FOREIGN_NS_PROTOCOL),
_A_imop_nf(remove_nlk,Undiclis_FOREIGN_NS_PROTOCOL_C,Undiclis_FOREIGN_NS_PROTOCOL),
_A_imop_nf(delete,Undiclis_FOREIGN_NS_PROTOCOL_C,Undiclis_FOREIGN_NS_PROTOCOL),
_A_imop_nf(delete_nlk,Undiclis_FOREIGN_NS_PROTOCOL_C,Undiclis_FOREIGN_NS_PROTOCOL),

_A_imop_nf(foreach,Undiclis_FOREIGN_NS_PROTOCOL_C,Undiclis_FOREIGN_NS_PROTOCOL),
_A_imop_nf(foreach_nlk,Undiclis_FOREIGN_NS_PROTOCOL_C,Undiclis_FOREIGN_NS_PROTOCOL),

_A_imop(set),
_A_imop(set_nlk),

_A_end;

# include <Bo/aorp/AorpCend.h>
/* @} */

#endif /* !__BO_SERVICES_ALG_BASIS__UNDICLIS_P__ */

/******************************************************************************
 * Revision History:
 *		$Log$
 *
 *****************************************************************************/
