/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright (c) 2005-2007 V.Sokur
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

/*
 * _UnlisP.h	(V.Sokur)
 * include/Bo/services/alg/basis/_UnlisP.h
 *
 * $Id$
 */

/* ------------------------------------------------------------------------- */

#ifndef __BO_SERVICES_ALG_BASIS__UNLIS_P__
# define __BO_SERVICES_ALG_BASIS__UNLIS_P__

/******************************************************************************
 * %% BeginSection: includes
 */

# include <Bo/services/alg/basis/_Unlis.h>
# include <Bo/services/alg/basis/_WlisP.h>

/******************************************************************************
 * %% BeginSection: type declarations
 */
# pragma mark -
# pragma mark [ type declarations ]
# pragma mark -

/* @todo: redesign opdom;
   _A_opdom(Unlis) == _A_opdom(Wlis) */

/*
 * {container,Unlis} protocol
 * @{
 */

# define __aorpc_ns_protocol_c 2
# define __aorpc_ns_protocol (container,Unlis)
# define __aorpc_realize_service_file <Bo/services/basis/CtnrP.h>
# include <Bo/aorp/AorpCpro.h>

_A_protocol(container,Unlis)
{
	_A_domdecl(Wlis);
/* @todo: redesign; see above */
# define Unlis_guts Wlis_guts
}
_A_end_pod

/* @todo: redesign */

# ifndef Unlis_FOREIGN_NS_PROTOCOL
#  define Unlis_FOREIGN_NS_PROTOCOL_C 2
#  define Unlis_FOREIGN_NS_PROTOCOL (container,Wlis)
# endif

_A_imop_nf(init_once,Unlis_FOREIGN_NS_PROTOCOL_C,Unlis_FOREIGN_NS_PROTOCOL),
_A_imop_nf(fini_once,Unlis_FOREIGN_NS_PROTOCOL_C,Unlis_FOREIGN_NS_PROTOCOL),
_A_imop_nf(pod_init,Unlis_FOREIGN_NS_PROTOCOL_C,Unlis_FOREIGN_NS_PROTOCOL),
_A_imop_nf(pod_fini,Unlis_FOREIGN_NS_PROTOCOL_C,Unlis_FOREIGN_NS_PROTOCOL),

_A_imop_nf(count,Unlis_FOREIGN_NS_PROTOCOL_C,Unlis_FOREIGN_NS_PROTOCOL),
_A_imop_nf(maxcount,Unlis_FOREIGN_NS_PROTOCOL_C,Unlis_FOREIGN_NS_PROTOCOL),
_A_imop_nf(clear,Unlis_FOREIGN_NS_PROTOCOL_C,Unlis_FOREIGN_NS_PROTOCOL),

_A_imop_nf(opencrsr,Unlis_FOREIGN_NS_PROTOCOL_C,Unlis_FOREIGN_NS_PROTOCOL),
_A_imop_nf(closecrsr,Unlis_FOREIGN_NS_PROTOCOL_C,Unlis_FOREIGN_NS_PROTOCOL),
_A_imop_nf(advancecrsr,Unlis_FOREIGN_NS_PROTOCOL_C,Unlis_FOREIGN_NS_PROTOCOL),
_A_imop_nf(getbycrsr,Unlis_FOREIGN_NS_PROTOCOL_C,Unlis_FOREIGN_NS_PROTOCOL),

_A_imop_nf(rdlock,Unlis_FOREIGN_NS_PROTOCOL_C,Unlis_FOREIGN_NS_PROTOCOL),
_A_imop_nf(wrlock,Unlis_FOREIGN_NS_PROTOCOL_C,Unlis_FOREIGN_NS_PROTOCOL),
_A_imop_nf(unlock,Unlis_FOREIGN_NS_PROTOCOL_C,Unlis_FOREIGN_NS_PROTOCOL),

_A_imop_nf(at,Unlis_FOREIGN_NS_PROTOCOL_C,Unlis_FOREIGN_NS_PROTOCOL),
_A_imop_nf(at_nlk,Unlis_FOREIGN_NS_PROTOCOL_C,Unlis_FOREIGN_NS_PROTOCOL),
_A_imop_nf(find,Unlis_FOREIGN_NS_PROTOCOL_C,Unlis_FOREIGN_NS_PROTOCOL),
_A_imop_nf(find_nlk,Unlis_FOREIGN_NS_PROTOCOL_C,Unlis_FOREIGN_NS_PROTOCOL),
_A_imop(insert),
_A_imop(insert_nlk),
_A_imop(remove),
_A_imop(remove_nlk),
_A_imop(delete),
_A_imop(delete_nlk),

_A_imop_nf(foreach,Unlis_FOREIGN_NS_PROTOCOL_C,Unlis_FOREIGN_NS_PROTOCOL),
_A_imop_nf(foreach_nlk,Unlis_FOREIGN_NS_PROTOCOL_C,Unlis_FOREIGN_NS_PROTOCOL),

_A_imop(set),
_A_imop(set_nlk),

_A_end;

# include <Bo/aorp/AorpCend.h>
/* @} */

#endif /* !__BO_SERVICES_ALG_BASIS__UNLIS_P__ */

/******************************************************************************
 * Revision History:
 *		$Log$
 *
 *****************************************************************************/
