/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright (c) 2005-2007 V.Sokur
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WDICARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WDICARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

/*
 * _WdicarrP.h	(V.Sokur)
 * include/Bo/services/alg/basis/_WdicarrP.h
 *
 * $Id$
 */

/* ------------------------------------------------------------------------- */

#ifndef __BO_SERVICES_ALG_BASIS__WDICARR_P__
# define __BO_SERVICES_ALG_BASIS__WDICARR_P__

/******************************************************************************
 * %% BeginSection: includes
 */

# include <Bo/services/alg/basis/_Wdicarr.h>

/******************************************************************************
 * %% BeginSection: type declarations
 */
# pragma mark -
# pragma mark [ type declarations ]
# pragma mark -

_A_opdom(Wdicarr) {
	bo_seqlist_t       q_list;
	aorp_hint_t        q_assoc_hint;
	bo_index_t         q_size_max;
	bo_cpurwlock_t     q_rwlock;
	struct aorp_udopv  q_udopv;
}
_A_end;

/*
 * {container,Wdicarr} protocol
 * @{
 */

# define __aorpc_ns_protocol_c 2
# define __aorpc_ns_protocol (container,Wdicarr)
# define __aorpc_realize_service_file <Bo/services/basis/CtnrP.h>
# include <Bo/aorp/AorpCpro.h>

_A_protocol(container,Wdicarr)
{
	_A_domdecl_;
}
_A_end_pod

_A_imop_nil(init_once),
_A_imop_nil(fini_once),
_A_imop(pod_init),
_A_imop(pod_fini),

_A_imop(count),
_A_imop(maxcount),
_A_imop(clear),

_A_imop(opencrsr),
_A_imop(closecrsr),
_A_imop(advancecrsr),
_A_imop(getbycrsr),

_A_imop(rdlock),
_A_imop(wrlock),
_A_imop(unlock),

_A_imop(at),
_A_imop(at_nlk),
_A_imop(find),
_A_imop(find_nlk),
_A_imop(insert),
_A_imop(insert_nlk),
_A_imop(remove),
_A_imop(remove_nlk),
_A_imop(delete),
_A_imop(delete_nlk),

_A_imop(foreach),
_A_imop(foreach_nlk),

_A_imop(set),
_A_imop(set_nlk),

_A_imop(count_nlk),		//	@note: MaxL

_A_end;

# include <Bo/aorp/AorpCend.h>
/* @} */

#endif /* !__BO_SERVICES_ALG_BASIS__WDICARR_P__ */

/******************************************************************************
 * Revision History:
 *		$Log$
 *
 *****************************************************************************/
