/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright (c) 2005-2007 V.Sokur
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

/*
 * _Xarr.h	(V.Sokur)
 * include/Bo/services/alg/basis/_Xarr.h
 *
 * $Id$
 */

/* ------------------------------------------------------------------------- */

#ifndef __BO_SERVICES_ALG_BASIS__XARR__
# define __BO_SERVICES_ALG_BASIS__XARR__

/******************************************************************************
 * %% BeginSection: includes
 */

# include <Bo/services/basis/CtnrP.h>

# include <Bo/Thrtypes.h>

/******************************************************************************
 * %% BeginSection: type declarations
 */
# pragma mark -
# pragma mark [ type declarations ]
# pragma mark -

/*
 * Xarr
 *
 * container
 * oid: <<category>>/<<service>>/<<domain>>/<<impl>>
 */
/*
# define AorpK_Xarr_opdom (153)
# define AorpK_Xarr_opdom_empty 0
 */
# include <Bo/services/MIB/Opdom.h>

# define __aorpc_ns_protocol_c 2
# define __aorpc_ns_protocol (container,Xarr)
# include <Bo/aorp/AorpCproi.h>

/* @todo: redesign protocol-init;
   _A_protocol_init(container,Xarr) extends _A_protocol_init(container,Warr) */
_A_protocol_init(container,Xarr)
{
	/* _A_proinitpod_(2,(container,Warr)) @{ */
	_A_hbdecl_;
	bo_index_t  size_init; /* should be < AorpL_CTNR_SIZE_MAX */
	bo_index_t  size_max;  /* -1: infinite, i.e < AorpL_CTNR_SIZE_MAX */
	struct aorp_udopv const  *udopv; /* =NULL, use default */
	/* @} */
	bo_vaxevent_ref  evref;
}
_A_end;

# include <Bo/aorp/AorpCend.h>

#endif /* !__BO_SERVICES_ALG_BASIS__XARR__ */

/******************************************************************************
 * Revision History:
 *		$Log$
 *
 *****************************************************************************/
