/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright (c) 2005-2007 V.Sokur
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

/*
 * _XdictreP.h	(V.Sokur)
 * include/Bo/services/alg/basis/_XdictreP.h
 *
 * $Id$
 */

/* ------------------------------------------------------------------------- */

#ifndef __BO_SERVICES_ALG_BASIS__XDICTRE_P__
# define __BO_SERVICES_ALG_BASIS__XDICTRE_P__

/******************************************************************************
 * %% BeginSection: includes
 */

# include <Bo/services/alg/basis/_Xdictre.h>
# include <Bo/services/alg/basis/_WdictreP.h>

/******************************************************************************
 * %% BeginSection: type declarations
 */
# pragma mark -
# pragma mark [ type declarations ]
# pragma mark -

/* @todo: redesign opdom;
   _A_opdom(Xdictre) extends _A_opdom(Wdictre) */
_A_opdom(Xdictre) {
	/* _A_opdom(Wdictre) { */
	bo_rtbtree_t       q_list;
	aorp_hint_t        q_assoc_hint;
	bo_index_t         q_size_max;
	bo_cpurwlock_t     q_rwlock;
	struct aorp_udopv  q_udopv;
	struct bo_zmalloc *q_alloc;
	/* } */
	bo_vaxevent_ref    q_evref;
};

/*
 * {container,Xdictre} protocol
 * @{
 */

# define __aorpc_ns_protocol_c 2
# define __aorpc_ns_protocol (container,Xdictre)
# define __aorpc_realize_service_file <Bo/services/basis/CtnrP.h>
# include <Bo/aorp/AorpCpro.h>

_A_protocol(container,Xdictre)
{
	_A_domdecl_;
}
_A_end_pod

/* @todo: redesign */

# ifndef Xdictre_FOREIGN_NS_PROTOCOL
#  define Xdictre_FOREIGN_NS_PROTOCOL_C 2
#  define Xdictre_FOREIGN_NS_PROTOCOL (container,Wdictre)
# endif

_A_imop_nf(init_once,Xdictre_FOREIGN_NS_PROTOCOL_C,Xdictre_FOREIGN_NS_PROTOCOL),
_A_imop_nf(fini_once,Xdictre_FOREIGN_NS_PROTOCOL_C,Xdictre_FOREIGN_NS_PROTOCOL),
_A_imop(pod_init),
_A_imop_nf(pod_fini,Xdictre_FOREIGN_NS_PROTOCOL_C,Xdictre_FOREIGN_NS_PROTOCOL),

_A_imop_nf(count,Xdictre_FOREIGN_NS_PROTOCOL_C,Xdictre_FOREIGN_NS_PROTOCOL),
_A_imop_nf(maxcount,Xdictre_FOREIGN_NS_PROTOCOL_C,Xdictre_FOREIGN_NS_PROTOCOL),
_A_imop_nf(clear,Xdictre_FOREIGN_NS_PROTOCOL_C,Xdictre_FOREIGN_NS_PROTOCOL),

_A_imop_nf(opencrsr,Xdictre_FOREIGN_NS_PROTOCOL_C,Xdictre_FOREIGN_NS_PROTOCOL),
_A_imop_nf(closecrsr,Xdictre_FOREIGN_NS_PROTOCOL_C,Xdictre_FOREIGN_NS_PROTOCOL),
_A_imop_nf(advancecrsr,Xdictre_FOREIGN_NS_PROTOCOL_C,Xdictre_FOREIGN_NS_PROTOCOL),
_A_imop_nf(getbycrsr,Xdictre_FOREIGN_NS_PROTOCOL_C,Xdictre_FOREIGN_NS_PROTOCOL),

_A_imop_nf(rdlock,Xdictre_FOREIGN_NS_PROTOCOL_C,Xdictre_FOREIGN_NS_PROTOCOL),
_A_imop_nf(wrlock,Xdictre_FOREIGN_NS_PROTOCOL_C,Xdictre_FOREIGN_NS_PROTOCOL),
_A_imop_nf(unlock,Xdictre_FOREIGN_NS_PROTOCOL_C,Xdictre_FOREIGN_NS_PROTOCOL),

_A_imop_nf(at,Xdictre_FOREIGN_NS_PROTOCOL_C,Xdictre_FOREIGN_NS_PROTOCOL),
_A_imop_nf(at_nlk,Xdictre_FOREIGN_NS_PROTOCOL_C,Xdictre_FOREIGN_NS_PROTOCOL),
_A_imop_nf(find,Xdictre_FOREIGN_NS_PROTOCOL_C,Xdictre_FOREIGN_NS_PROTOCOL),
_A_imop_nf(find_nlk,Xdictre_FOREIGN_NS_PROTOCOL_C,Xdictre_FOREIGN_NS_PROTOCOL),
_A_imop(insert),
_A_imop(insert_nlk),
_A_imop_nf(remove,Xdictre_FOREIGN_NS_PROTOCOL_C,Xdictre_FOREIGN_NS_PROTOCOL),
_A_imop_nf(remove_nlk,Xdictre_FOREIGN_NS_PROTOCOL_C,Xdictre_FOREIGN_NS_PROTOCOL),
_A_imop_nf(delete,Xdictre_FOREIGN_NS_PROTOCOL_C,Xdictre_FOREIGN_NS_PROTOCOL),
_A_imop_nf(delete_nlk,Xdictre_FOREIGN_NS_PROTOCOL_C,Xdictre_FOREIGN_NS_PROTOCOL),

_A_imop_nf(foreach,Xdictre_FOREIGN_NS_PROTOCOL_C,Xdictre_FOREIGN_NS_PROTOCOL),
_A_imop_nf(foreach_nlk,Xdictre_FOREIGN_NS_PROTOCOL_C,Xdictre_FOREIGN_NS_PROTOCOL),

_A_imop(set),
_A_imop(set_nlk),

_A_end;

# include <Bo/aorp/AorpCend.h>
/* @} */

#endif /* !__BO_SERVICES_ALG_BASIS__XDICTRE_P__ */

/******************************************************************************
 * Revision History:
 *		$Log$
 *
 *****************************************************************************/
