/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright (c) 2005-2007 V.Sokur
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

/*
 * _CHash.h	(V.Sokur)
 * include/Bo/services/alg/crypt/_CHash.h
 *
 * $Id$
 */

/* ------------------------------------------------------------------------- */

#ifndef __BO_SERVICES_ALG_CRYPT__CHASH__
# define __BO_SERVICES_ALG_CRYPT__CHASH__

/******************************************************************************
 * %% BeginSection: includes
 */

# include <Bo/services/crypt/Crypttypes.h>

/******************************************************************************
 * %% BeginSection: type declarations
 */
# pragma mark -
# pragma mark [ type declarations ]
# pragma mark -

/*
 * CHash
 *
 * chash
 * oid: <<category>>/<<service>>/<<domain>>/<<impl>>
 */
/*
# define AorpK_CHash_opdom (802)
# define AorpK_CHash_opdom_empty 1
 */
# include <Bo/services/MIB/Opdom.h>

# define __aorpc_decl __aorpc_decl_protocol_init
# define __aorpc_service_name chash
# define __aorp_service_opdom CHash
# include <Bo/aorp/AorpC.h>

_A_protocol_init(CHash,chash)
_A_end;

# include <Bo/aorp/AorpCend.h>

/*
 * CHashal
 *
 * chashal
 * oid: <<category>>/<<service>>/<<domain>>/<<impl>>
 */
/*
# define AorpK_CHashal_opdom (803)
# define AorpK_CHashal_opdom_empty 1
 */
# include <Bo/services/MIB/Opdom.h>

# define __aorpc_decl __aorpc_decl_protocol_init
# define __aorpc_service_name chashal
# define __aorp_service_opdom CHashal
# include <Bo/aorp/AorpC.h>

_A_protocol_init(CHashal,chashal)
_A_end;

# include <Bo/aorp/AorpCend.h>

#endif /* !__BO_SERVICES_ALG_CRYPT__CHASH__ */

/******************************************************************************
 * Revision History:
 *		$Ics$
 *
 *****************************************************************************/
