/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright (c) 2005-2007 V.Sokur
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

/*
 * _CryptP.h	(V.Sokur)
 * include/Bo/services/alg/crypt/_CryptP.h
 *
 * $Id$
 */

/* ------------------------------------------------------------------------- */

#ifndef __BO_SERVICES_ALG_CRYPT__CRYPT_P__
# define __BO_SERVICES_ALG_CRYPT__CRYPT_P__

/******************************************************************************
 * %% BeginSection: includes
 */

# include <Bo/services/alg/crypt/_Crypt.h>

/******************************************************************************
 * %% BeginSection: type declarations
 */
# pragma mark -
# pragma mark [ type declarations ]
# pragma mark -

/*
 * {Crypt,crypt} protocol
 * @{
 */

# include <Bo/services/crypt/CryptP.h>

# ifdef __need_Crypt_crypt_protocol_impl
#  define __aorpc_impl 1
# endif
# define __aorpc_decl __aorpc_decl_protocol
# define __aorpc_service_name crypt
# define __aorp_service_opdom Crypt
# include <Bo/aorp/AorpC.h>

_A_protocol(Crypt,crypt)
_A_end_pod

_A_imop_nil(init_once),
_A_imop_nil(fini_once),
_A_imop_nil(pod_init),
_A_imop_nil(pod_fini),

_A_imop(openalg),
_A_imop(closealg),

_A_end;

# include <Bo/aorp/AorpCend.h>

/* @} */

/*
 * CRYPTAL protocol
 * @{
 */

/* Common */
# ifdef AORP_NEED_COMMON_CRYPTAL_PROTOCOL
#  undef AORP_NEED_COMMON_CRYPTAL_PROTOCOL

#  include <Bo/services/crypt/CryptP.h>

#  ifdef __need_Cryptal_cryptal_protocol_impl
#   define __aorpc_impl 1
#  endif
#  define __aorpc_decl __aorpc_decl_protocol
#  define __aorpc_service_name cryptal
#  define __aorp_service_opdom Cryptal
#  include <Bo/aorp/AorpC.h>

_A_protocol(Cryptal,cryptal)
_A_end_pod

_A_imop(init_once),
_A_imop(fini_once),
_A_imop_nil(pod_init),
_A_imop_nil(pod_fini),

_A_imop(init),
_A_imop(destroyctx),
_A_imop(encrypt),
_A_imop(decrypt),
_A_imop(encrypt_inplace),
_A_imop(decrypt_inplace),
_A_imop(encrypt_mem),
_A_imop(decrypt_mem),
_A_imop(block_size),
_A_imop(keylen),

_A_end;

#  include <Bo/aorp/AorpCend.h>

# endif /* AORP_NEED_COMMON_CRYPTAL_PROTOCOL */
/* @} */


/*
 * CRYPTALSC (StreamCipher) protocol
 * @{
 */

# ifdef AORP_NEED_STREAM_CIFER_CRYPTAL_PROTOCOL
#  undef AORP_NEED_STREAM_CIFER_CRYPTAL_PROTOCOL

#  include <Bo/services/crypt/CryptP.h>

#  ifdef __need_CryptalSC_cryptal_protocol_impl
#   define __aorpc_impl 1
#  endif
#  define __aorpc_decl __aorpc_decl_protocol
#  define __aorpc_service_name cryptal
#  define __aorp_service_opdom Cryptal
#  include <Bo/aorp/AorpC.h>

_A_protocol(Cryptal,cryptal)
_A_end_pod

_A_imop_nil(init_once),
_A_imop_nil(fini_once),
_A_imop_nil(pod_init),
_A_imop_nil(pod_fini),

_A_imop(initctx),
_A_imop(destroyctx),

_A_imop(encrypt),
_A_imop_rr(decrypt,encrypt),
_A_imop(encrypt_inplace),
_A_imop_rr(decrypt_inplace,encrypt_inplace),
_A_imop(encrypt_mem),
_A_imop_rr(decrypt_mem,encrypt_mem),

_A_imop(block_size),
_A_imop(keylen),

_A_end;

#  include <Bo/aorp/AorpCend.h>

# endif /* AORP_NEED_STREAM_CIFER_CRYPTAL_PROTOCOL */
/* @} */

#endif /* !__BO_SERVICES_ALG_CRYPT__CRYPTA_P__ */

/******************************************************************************
 * Revision History:
 *		$Ics$
 *
 *****************************************************************************/
