/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright (c) 2005-2007 V.Sokur
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

/*
 * _PlnodedefsI.h	(N.Panasiuk)
 * include/Bo/services/alg/hilis/_PlnodedefsI.h
 *
 * $Id$
 */

/* ------------------------------------------------------------------------- */

#ifndef __BO_SERVICES_ALG_HILIS__PLNODEDEFS_I__
# define __BO_SERVICES_ALG_HILIS__PLNODEDEFS_I__

/******************************************************************************
 * %% BeginSection: includes
 */

/*
 * It is required the next files are included first:
 *
# include <Bo/services/hilis/Pltypes.h>
 */

/******************************************************************************
 * %% BeginSection: type/constant declarations
 */
# pragma mark -
# pragma mark [ type/constant declarations ]
# pragma mark -

struct aorp_plist_node {
	struct aorp_plist_node  *pln_parent;
};
# define aorp_plist_node_p(aNode) ((struct aorp_plist_node *)(aNode))

# define _AORP_PLIST_NODE_GUTS \
	struct aorp_plist_node  *pln_parent


struct aorp_plist_named_node {
	_AORP_PLIST_NODE_GUTS;
	char const  *pln_name;
};
# define aorp_plist_named_node_p(aNode) ((struct aorp_plist_named_node *)(aNode))

# define _AORP_PLIST_NAMED_NODE_GUTS \
	_AORP_PLIST_NODE_GUTS; \
	char const  *pln_name


struct aorp_plist_anon_node {
	_AORP_PLIST_NODE_GUTS;
	char const  *pln_opaque;
	u_int16_t    pln_dsz;
	u_int16_t    pln_spector;
/*
	char         pln_implementation_specific_info[];
	char         pln_cdata[1];
 */
};
# define aorp_plist_anon_node_p(aNode) ((struct aorp_plist_anon_node *)(aNode))

# define _AORP_PLIST_ANON_NODE_GUTS \
	_AORP_PLIST_NODE_GUTS; \
	char const  *pln_opaque; \
	u_int16_t    pln_dsz; \
	u_int16_t    pln_spector

#endif /* !__BO_SERVICES_ALG_HILIS__PLNODEDEFS_I__ */

/******************************************************************************
 * Revision History:
 *		$Log$
 *
 *****************************************************************************/
