/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright (c) 2005-2007 V.Sokur
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

/*
 * _Uri.h	(N.Panasiuk)
 * include/Bo/services/alg/hilis/_Uri.h
 *
 * $Id$
 */

/* ------------------------------------------------------------------------- */

#ifndef __BO_SERVICES_ALG_HILIS__URI__
# define __BO_SERVICES_ALG_HILIS__URI__

/******************************************************************************
 * %% BeginSection: includes
 */

# include <Bo/services/hilis/UriP.h>

/******************************************************************************
 * %% BeginSection: type declarations
 */
# pragma mark -
# pragma mark [ type declarations ]
# pragma mark -

/*
 * Uri
 *
 * uri
 * oid: <<category>>/<<service>>/<<domain>>/<<impl>>
 */
/*
# define AorpK_Uri_opdom (350)
# define AorpK_Uri_opdom_empty 0
 */
# include <Bo/services/MIB/Opdom.h>

# define __aorpc_ns_protocol_c 2
# define __aorpc_ns_protocol (uri,Uri)
# include <Bo/aorp/AorpCproi.h>

# define AorpK_URI_INIT_WITH_STRING 0
# define AorpK_URI_INIT_WITH_WSTRING 1
# define AorpK_URI_INIT_WITH_FSPATH 2
# define AorpK_URI_INIT_WITH_FSWPATH 3
# define AorpK_URI_INIT_WITH_URI 4

_A_protocol_init(uri,Uri)
{
	_A_hbdecl_;

	int                             initsw;

	aorp_object_t                   urilib;

	intptr_t                        src;
	size_t                          src_len;

	bo_pointer_t                    spec_buf;
	size_t                          spec_bufsz;

	struct aorp_uri_options const  *opts;
}
_A_end;

# include <Bo/aorp/AorpCend.h>

#endif /* !__BO_SERVICES_ALG_HILIS__URILIB__ */

/******************************************************************************
 * Revision History:
 *		$Log$
 *
 *****************************************************************************/
