/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright (c) 2005-2007 V.Sokur
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

/*
 * _UribendppP.h	(N.Panasiuk)
 * include/Bo/services/alg/hilis/_UribendppP.h
 *
 * $Id$
 */

/* ------------------------------------------------------------------------- */

#ifndef __BO_SERVICES_ALG_HILIS__URIBEND_PREPROCESSOR_P__
# define __BO_SERVICES_ALG_HILIS__URIBEND_PREPROCESSOR_P__

/******************************************************************************
 * %% BeginSection: includes
 */

# include <Bo/services/alg/hilis/_GuritypesI.h>

/******************************************************************************
 * %% BeginSection: type/constant declarations
 */
# pragma mark -
# pragma mark [ type/constant declarations ]
# pragma mark -

/*
# define __aorp_uri_scheme            BoK_URI_JDBC_POSTGRESQL_SCHEME
# define __aorp_uri_scheme_name       jdbc
# define __aorp_uri_scheme_name_s    "jdbc" [default __myc_xstringify(__aorp_uri_scheme_name)]
# define __aorp_uri_subscheme_name    postgresql [default undef]
# define __aorp_uri_subscheme_name_s "postgresql" [default __myc_xstringify(__aorp_uri_subscheme_name)]
# define __aorp_uri_scheme_subdelim  ":" [default NULL]
# define __aorp_uri_scheme_rule       BO_URI_JDBC_POSTGRESQL_SCHEME_RULE

# define __aorp_uri_scan_delim       "[@//][!:/?#]" [default NULL]

# define __aorp_uri_parser_astate    (0) [default (0)]
# define __aorp_uri_parser_rstate    (5) [default (0)] 

# define __aorp_uri_printer_astate   (0) [default (0)]
# define __aorp_uri_printer_rstate   (5) [default (0)] 

# define __aorp_uri_host_field_idx      (0) [default undef]
# define __aorp_uri_port_field_idx      (1) [default undef]
# define __aorp_uri_user_field_idx      (2) [default undef]
# define __aorp_uri_passwd_field_idx    (3) [default undef]
# define __aorp_uri_path_field_idx      (4) [default undef]
# define __aorp_uri_parm_field_idx      (5) [default undef]
# define __aorp_uri_query_field_idx     (6) [default undef]
# define __aorp_uri_fragment_field_idx  (7) [default undef]
 */

/* ----------------------------------------------------------------------------
 * default definitions
 * @{
 */

# ifndef __aorp_uri_scheme_name_s
#  define __aorp_uri_scheme_name_s __myc_xstringify(__aorp_uri_scheme_name)
# endif

# ifdef __aorp_uri_subscheme_name
#  ifndef __aorp_uri_subscheme_name_s
#   define __aorp_uri_subscheme_name_s __myc_xstringify(__aorp_uri_subscheme_name)
#  endif
# endif

# ifndef __aorp_uri_scheme_subdelim
#  define __aorp_uri_scheme_subdelim (NULL)
# endif

# ifndef __aorp_uri_scan_delim
#  define __aorp_uri_scan_delim (NULL)
# endif

# ifndef __aorp_uri_parser_astate
#  define __aorp_uri_parser_astate (0)
# endif

# ifndef __aorp_uri_parser_rstate
#  define __aorp_uri_parser_rstate (0)
# endif

# ifndef __aorp_uri_printer_astate
#  define __aorp_uri_printer_astate (0)
# endif

# ifndef __aorp_uri_printer_rstate
#  define __aorp_uri_printer_rstate (0)
# endif

# ifndef __aorp_uri_host_field_idx
#  define __aorp_uri_host_field_idx _AorpK_URI_INVAL_FIELD_INDEX
# endif

# ifndef __aorp_uri_port_field_idx
#  define __aorp_uri_port_field_idx _AorpK_URI_INVAL_FIELD_INDEX
# endif

# ifndef __aorp_uri_user_field_idx
#  define __aorp_uri_user_field_idx _AorpK_URI_INVAL_FIELD_INDEX
# endif

# ifndef __aorp_uri_passwd_field_idx
#  define __aorp_uri_passwd_field_idx _AorpK_URI_INVAL_FIELD_INDEX
# endif

# ifndef __aorp_uri_path_field_idx
#  define __aorp_uri_path_field_idx _AorpK_URI_INVAL_FIELD_INDEX
# endif

# ifndef __aorp_uri_parm_field_idx
#  define __aorp_uri_parm_field_idx _AorpK_URI_INVAL_FIELD_INDEX
# endif

# ifndef __aorp_uri_query_field_idx
#  define __aorp_uri_query_field_idx _AorpK_URI_INVAL_FIELD_INDEX
# endif

# ifndef __aorp_uri_fragment_field_idx
#  define __aorp_uri_fragment_field_idx _AorpK_URI_INVAL_FIELD_INDEX
# endif

/* @} */

/* ----------------------------------------------------------------------------
 * declare parser state table
 * @{
 */

# define _AORP_URI_PARSER_STATETAB_BEGIN1() \
	static aorp_uri_toktype_t __aorp_uri_tokfixtab_varname[_AorpL_URI_SCANER_TOKFIXTAB_LEN_MIN + 1]; \
	static aorp_uri_parser_tabelem_t __aorp_uri_parser_statetab_plan_varname[][1] = {

# define _AORP_URI_PARSER_STATETAB_BEGIN2(s1) \
	static aorp_uri_toktype_t __aorp_uri_tokfixtab_varname[_AorpL_URI_SCANER_TOKFIXTAB_LEN_MIN + 2] = { \
		(s1) \
	}; \
	static aorp_uri_parser_tabelem_t __aorp_uri_parser_statetab_plan_varname[][2] = {

# define _AORP_URI_PARSER_STATETAB_BEGIN3(s1,s2) \
	static aorp_uri_toktype_t __aorp_uri_tokfixtab_varname[_AorpL_URI_SCANER_TOKFIXTAB_LEN_MIN + 3] = { \
		(s1), (s2) \
	}; \
	static aorp_uri_parser_tabelem_t __aorp_uri_parser_statetab_plan_varname[][3] = {

# define _AORP_URI_PARSER_STATETAB_BEGIN4(s1,s2,s3) \
	static aorp_uri_toktype_t __aorp_uri_tokfixtab_varname[_AorpL_URI_SCANER_TOKFIXTAB_LEN_MIN + 4] = { \
		(s1), (s2), (s3) \
	}; \
	static aorp_uri_parser_tabelem_t __aorp_uri_parser_statetab_plan_varname[][4] = {

# define _AORP_URI_PARSER_STATETAB_BEGIN5(s1,s2,s3,s4) \
	static aorp_uri_toktype_t __aorp_uri_tokfixtab_varname[_AorpL_URI_SCANER_TOKFIXTAB_LEN_MIN + 5] = { \
		(s1), (s2), (s3), (s4) \
	}; \
	static aorp_uri_parser_tabelem_t __aorp_uri_parser_statetab_plan_varname[][5] = {

# define _AORP_URI_PARSER_STATETAB_BEGIN6(s1,s2,s3,s4,s5) \
	static aorp_uri_toktype_t __aorp_uri_tokfixtab_varname[_AorpL_URI_SCANER_TOKFIXTAB_LEN_MIN + 6] = { \
		(s1), (s2), (s3), (s4), (s5) \
	}; \
	static aorp_uri_parser_tabelem_t __aorp_uri_parser_statetab_plan_varname[][6] = {

# define _AORP_URI_PARSER_STATETAB_BEGIN7(s1,s2,s3,s4,s5,s6) \
	static aorp_uri_toktype_t __aorp_uri_tokfixtab_varname[_AorpL_URI_SCANER_TOKFIXTAB_LEN_MIN + 7] = { \
		(s1), (s2), (s3), (s4), (s5), (s6) \
	}; \
	static aorp_uri_parser_tabelem_t __aorp_uri_parser_statetab_plan_varname[][7] = {

# define _AORP_URI_PARSER_STATETAB_BEGIN8(s1,s2,s3,s4,s5,s6,s7) \
	static aorp_uri_toktype_t __aorp_uri_tokfixtab_varname[_AorpL_URI_SCANER_TOKFIXTAB_LEN_MIN + 8] = { \
		(s1), (s2), (s3), (s4), (s5), (s6), (s7) \
	}; \
	static aorp_uri_parser_tabelem_t __aorp_uri_parser_statetab_plan_varname[][8] = {

# define _AORP_URI_PARSER_STATETAB_BEGIN9(s1,s2,s3,s4,s5,s6,s7,s8) \
	static aorp_uri_toktype_t __aorp_uri_tokfixtab_varname[_AorpL_URI_SCANER_TOKFIXTAB_LEN_MIN + 9] = { \
		(s1), (s2), (s3), (s4), (s5), (s6), (s7), (s8) \
	}; \
	static aorp_uri_parser_tabelem_t __aorp_uri_parser_statetab_plan_varname[][9] = {

# define _AORP_URI_PARSER_STATETAB_BEGIN10(s1,s2,s3,s4,s5,s6,s7,s8,s9) \
	static aorp_uri_toktype_t __aorp_uri_tokfixtab_varname[_AorpL_URI_SCANER_TOKFIXTAB_LEN_MIN + 10] = { \
		(s1), (s2), (s3), (s4), (s5), (s6), (s7), (s8), (s9) \
	}; \
	static aorp_uri_parser_tabelem_t __aorp_uri_parser_statetab_plan_varname[][10] = {

# define _AORP_URI_PARSER_STATETAB_END \
		/*{ 0 }*/ \
	}; \
	static aorp_uri_parser_tabelem_t * \
	__aorp_uri_parser_statetab_varname[__myc_namembs(__aorp_uri_parser_statetab_plan_varname)] = { \
		__aorp_uri_parser_statetab_plan_varname[0], \
		NULL \
	}

/* @} */

/* ----------------------------------------------------------------------------
 * declare printer state table
 * @{
 */

# define _AORP_URI_PRINTER_STATETAB_BEGIN(aPrintCount) \
	static aorp_uri_printer_tabelem_t __aorp_uri_printer_statetab_plan_varname[][aPrintCount] = {

# define _AORP_URI_PRINTER_STATETAB_END \
		/*{ 0 }*/ \
	}; \
	static aorp_uri_printer_tabelem_t * \
	__aorp_uri_printer_statetab_varname[__myc_namembs(__aorp_uri_printer_statetab_plan_varname)] = { \
		__aorp_uri_printer_statetab_plan_varname[0], \
		NULL \
	}

/* @} */

/* ----------------------------------------------------------------------------
 * declare specinfo
 * @{
 */

# define _AORP_URI_SPECINFO_BEGIN() \
	static struct aorp_uri_fieldinfo __aorp_uri_fieldinfov_varname[] = {

# define _AORP_URI_SPECINFO_END \
		{ _AorpK_URI_FIELD_INVAL_TYPE, _AorpK_URI_FIELD_INVAL_SPECTOR, 0, 0, NULL } \
	}; \
	static __aorp_uri_schemeinfo_struct __aorp_uri_schemeinfo_varname = __aorp_uri_schemeinfo_init; \
	static struct aorp_uri_fieldinfo *__aorp_uri_fieldptrfixv_varname[__myc_namembs(__aorp_uri_fieldinfov_varname)]; \
	static struct aorp_uri_specinfo __aorp_uri_specinfo_varname = { \
		aorp_uri_schemeinfo_p(&__aorp_uri_schemeinfo_varname), \
		__aorp_uri_spec_size, \
		__myc_namembs(__aorp_uri_fieldinfov_varname) - 1, \
		__aorp_uri_fieldinfov_varname, \
		__myc_namembs(__aorp_uri_fieldptrfixv_varname) - 1, \
		__aorp_uri_fieldptrfixv_varname, \
		{ \
			__aorp_uri_host_field_idx, \
			__aorp_uri_port_field_idx, \
			__aorp_uri_user_field_idx, \
			__aorp_uri_passwd_field_idx, \
			__aorp_uri_path_field_idx, \
			__aorp_uri_parm_field_idx, \
			__aorp_uri_query_field_idx, \
			__aorp_uri_fragment_field_idx \
		} \
	}

# define _AORP_URI_FIELDINFO_ENTRY(field,type,spector,aDefval) \
	{ \
		__myc_xconcat3(_AorpK_uri_field_,type,_type), \
		__myc_xconcat3(_AorpK_uri_field_,spector,_spector), \
		__aorp_uri_offsetof(field), \
		__aorp_uri_membsizeof(field), \
		(aDefval) \
	}

/* @} */

/* ----------------------------------------------------------------------------
 * generic uri backend init
 * @{
 */

# define _AORP_GURIBEND_INITIALIZER \
	{ /* .guts = */ { \
		/* backend-tools @{ */ \
			/* .urbe_scaner_open = */ NULLF, \
			/* .urbe_parser_open = */ NULLF, \
			/* .urbe_serializer_open = */ NULLF, \
			/* .urbe_builder_open = */ NULLF, \
			/* .urbe_printer_open = */ NULLF, \
		/* @} */ \
		/* scan-rules @{ */ \
			/* .urbe_delim = */ __aorp_uri_scan_delim, \
			/* .urbe_tokfixelemc = */ __myc_namembs(__aorp_uri_tokfixtab_varname), \
			/* .urbe_tokfixtab = */ __aorp_uri_tokfixtab_varname, \
		/* @} */ \
		/* parse-rules @{ */ \
			/* .urbe_parser_astate = */ __aorp_uri_parser_astate, \
			/* .urbe_parser_rstate = */ __aorp_uri_parser_rstate, \
			/* .urbe_parser_tokenc = */ __myc_namembs(__aorp_uri_parser_statetab_plan_varname[0]), \
			/* .urbe_parser_statec = */ __myc_namembs(__aorp_uri_parser_statetab_plan_varname), \
			/* .urbe_parser_statetab = */ __aorp_uri_parser_statetab_varname, \
		/* @} */ \
		/* print-rules @{ */ \
			/* .urbe_printer_astate = */ __aorp_uri_printer_astate, \
			/* .urbe_printer_rstate = */ __aorp_uri_printer_rstate, \
			/* .urbe_printer_printc = */ __myc_namembs(__aorp_uri_printer_statetab_plan_varname[0]), \
			/* .urbe_printer_statec = */ __myc_namembs(__aorp_uri_printer_statetab_plan_varname), \
			/* .urbe_printer_statetab = */ __aorp_uri_printer_statetab_varname, \
		/* @} */ \
		/* .urbe_specinfo = */ &__aorp_uri_specinfo_varname, \
		/* .urbe_initflags = */ 0 \
	} /* @} */ }

/* @} */

/* ----------------------------------------------------------------------------
 * NOT FOR YOUR BUSINESS
 * @{
 */

# ifndef _AorpK_uri_field_int_type
#  define _AorpK_uri_field_int_type _AorpK_URI_FIELD_INT_TYPE
# endif

# ifndef _AorpK_uri_field_cstrptr_type
#  define _AorpK_uri_field_cstrptr_type _AorpK_URI_FIELD_CSTRPTR_TYPE
# endif

# ifndef _AorpK_uri_field_cstrbuf_type
#  define _AorpK_uri_field_cstrbuf_type _AorpK_URI_FIELD_CSTRBUF_TYPE
# endif

# ifndef _AorpK_uri_field_charseq_type
#  define _AorpK_uri_field_charseq_type _AorpK_URI_FIELD_CHARSEQ_TYPE
# endif


# ifndef _AorpK_uri_field_unk_spector
#  define _AorpK_uri_field_unk_spector _AorpK_URI_FIELD_UNK_SPECTOR
# endif

# ifndef _AorpK_uri_field_path_spector
#  define _AorpK_uri_field_path_spector _AorpK_URI_FIELD_PATH_SPECTOR
# endif

# ifndef _AorpK_uri_field_char_spector
#  define _AorpK_uri_field_char_spector _AorpK_URI_FIELD_CHAR_SPECTOR
# endif

/* ------------------------------------------------------------------------- */

# ifndef __aorp_uri_subscheme_name

#  define __aorp_uri_tokfixtab_varname \
	__myc_xconcat3(_S_,__aorp_uri_scheme_name,_uri_tokfixtab)

#  define __aorp_uri_parser_statetab_plan_varname \
	__myc_xconcat3(_S_,__aorp_uri_scheme_name,_uri_parser_statetab_plan)
#  define __aorp_uri_parser_statetab_varname \
	__myc_xconcat3(_S_,__aorp_uri_scheme_name,_uri_parser_statetab)

#  define __aorp_uri_printer_statetab_plan_varname \
	__myc_xconcat3(_S_,__aorp_uri_scheme_name,_uri_printer_statetab_plan)
#  define __aorp_uri_printer_statetab_varname \
	__myc_xconcat3(_S_,__aorp_uri_scheme_name,_uri_printer_statetab)

#  define __aorp_uri_schemeinfo_struct aorp_uri_schemeinfo_t
#  define __aorp_uri_schemeinfo_varname \
	__myc_xconcat3(_S_,__aorp_uri_scheme_name,_uri_schemeinfo)

#  define __aorp_uri_schemeinfo_init \
	AORP_MAKE_URI_SCHEMEINFO( \
		__aorp_uri_scheme, \
		__aorp_uri_scheme_name_s, \
		__aorp_uri_scheme_rule \
	)

#  define __aorp_uri_offsetof(field) \
	__myc_offsetof(aorp_uri_spec(__aorp_uri_scheme_name), field)
#  define __aorp_uri_membsizeof(field) \
	__myc_membsizeof(aorp_uri_spec(__aorp_uri_scheme_name),field)

#  define __aorp_uri_fieldinfov_varname \
	__myc_xconcat3(_S_,__aorp_uri_scheme_name,_uri_fieldinfov)

#  define __aorp_uri_fieldptrfixv_varname \
	__myc_xconcat3(_S_,__aorp_uri_scheme_name,_uri_fieldptrfixv)

#  define __aorp_uri_spec_size sizeof(aorp_uri_spec(__aorp_uri_scheme_name))
#  define __aorp_uri_specinfo_varname \
	__myc_xconcat3(_S_,__aorp_uri_scheme_name,_uri_specinfo)

# else

#  define __aorp_uri_tokfixtab_varname \
	__myc_xconcat5(_S_,__aorp_uri_scheme_name,_,__aorp_uri_subscheme_name,_uri_tokfixtab)

#  define __aorp_uri_parser_statetab_plan_varname \
	__myc_xconcat5(_S_,__aorp_uri_scheme_name,_,__aorp_uri_subscheme_name,_uri_parser_statetab_plan)
#  define __aorp_uri_parser_statetab_varname \
	__myc_xconcat5(_S_,__aorp_uri_scheme_name,_,__aorp_uri_subscheme_name,_uri_parser_statetab)

#  define __aorp_uri_printer_statetab_plan_varname \
	__myc_xconcat5(_S_,__aorp_uri_scheme_name,_,__aorp_uri_subscheme_name,_uri_printer_statetab_plan)
#  define __aorp_uri_printer_statetab_varname \
	__myc_xconcat5(_S_,__aorp_uri_scheme_name,_,__aorp_uri_subscheme_name,_uri_printer_statetab)

#  define __aorp_uri_schemeinfo_struct aorp_uri_schemeinfo2_t
#  define __aorp_uri_schemeinfo_varname \
	__myc_xconcat5(_S_,__aorp_uri_scheme_name,_,__aorp_uri_subscheme_name,_uri_schemeinfo)

#  define __aorp_uri_schemeinfo_init \
	AORP_MAKE_URI_SCHEMEINFO2( \
		__aorp_uri_scheme, \
		__aorp_uri_scheme_name_s, \
		__aorp_uri_subscheme_name_s, \
		__aorp_uri_scheme_subdelim, \
		__aorp_uri_scheme_rule \
	)

#  define __aorp_uri_offsetof(field) \
	__myc_offsetof(aorp_uri_spec2(__aorp_uri_scheme_name,__aorp_uri_subscheme_name), field)
#  define __aorp_uri_membsizeof(field) \
	__myc_membsizeof(aorp_uri_spec2(__aorp_uri_scheme_name,__aorp_uri_subscheme_name),field)

#  define __aorp_uri_fieldinfov_varname \
	__myc_xconcat5(_S_,__aorp_uri_scheme_name,_,__aorp_uri_subscheme_name,_uri_fieldinfov)

#  define __aorp_uri_fieldptrfixv_varname \
	__myc_xconcat5(_S_,__aorp_uri_scheme_name,_,__aorp_uri_subscheme_name,_uri_fieldptrfixv)

#  define __aorp_uri_spec_size \
	sizeof(aorp_uri_spec2(__aorp_uri_scheme_name,__aorp_uri_subscheme_name))
#  define __aorp_uri_specinfo_varname \
	__myc_xconcat5(_S_,__aorp_uri_scheme_name,_,__aorp_uri_subscheme_name,_uri_specinfo)

# endif

/* @} */

#endif /* !__BO_SERVICES_ALG_HILIS__URIBEND_PREPROCESSOR_P__ */

/******************************************************************************
 * Revision History:
 *		$Log$
 *
 *****************************************************************************/
