/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright (c) 2005-2007 V.Sokur
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

/*
 * _Uriblttab.h	(N.Panasiuk)
 * include/Bo/services/alg/hilis/_Uriblttab.h
 *
 * $Id$
 */

/******************************************************************************
 * %% BeginSection: includes
 */

/******************************************************************************
 * %% BeginSection: definitions
 */
# pragma mark -
# pragma mark [ definitions ]
# pragma mark -

static aorp_uri_schemeinfo_t _S_http_uri_schemeinfo = AORP_MAKE_URI_SCHEMEINFO(
	BoK_URI_HTTP_SCHEME,_BO_URI_HTTP_SCHEME_NAME,BO_URI_HTTP_SCHEME_RULE
);

static aorp_uri_schemeinfo_t _S_ftp_uri_schemeinfo = AORP_MAKE_URI_SCHEMEINFO(
	BoK_URI_FTP_SCHEME,_BO_URI_FTP_SCHEME_NAME,BO_URI_FTP_SCHEME_RULE
);

static aorp_uri_schemeinfo_t _S_mailto_uri_schemeinfo = AORP_MAKE_URI_SCHEMEINFO(
	BoK_URI_MAILTO_SCHEME,_BO_URI_MAILTO_SCHEME_NAME,BO_URI_MAILTO_SCHEME_RULE
);

static aorp_uri_schemeinfo_t _S_file_uri_schemeinfo = AORP_MAKE_URI_SCHEMEINFO(
	BoK_URI_FILE_SCHEME,_BO_URI_FILE_SCHEME_NAME,BO_URI_FILE_SCHEME_RULE
);

static aorp_uri_schemeinfo_t _S_sluzba_uri_schemeinfo = AORP_MAKE_URI_SCHEMEINFO(
	BoK_URI_SLUZBA_SCHEME,_BO_URI_SLUZBA_SCHEME_NAME,BO_URI_SLUZBA_SCHEME_RULE
);


static aorp_uri_schemeinfo_t _S_adbc_uri_schemeinfo = AORP_MAKE_URI_SCHEMEINFO(
	BoK_URI_ADBC_SCHEME,_BO_URI_ADBC_SCHEME_NAME,BO_URI_ADBC_SCHEME_RULE
);

static aorp_uri_schemeinfo2_t _S_adbc_postgesql_uri_schemeinfo = AORP_MAKE_URI_SCHEMEINFO2(
	BoK_URI_ADBC_POSTGRESQL_SCHEME,
	_BO_URI_ADBC_SCHEME_NAME,
	_BO_URI_ADBC_POSTGRESQL_SUBSCHEME_NAME,
	":",
	BO_URI_ADBC_POSTGRESQL_SCHEME_RULE
);

static aorp_uri_schemeinfo2_t _S_adbc_sqlite_uri_schemeinfo = AORP_MAKE_URI_SCHEMEINFO2(
	BoK_URI_ADBC_SQLITE_SCHEME,
	_BO_URI_ADBC_SCHEME_NAME,
	_BO_URI_ADBC_SQLITE_SUBSCHEME_NAME,
	":",
	BO_URI_ADBC_SQLITE_SCHEME_RULE
);

static aorp_uri_schemeinfo2_t _S_adbc_odbc_uri_schemeinfo = AORP_MAKE_URI_SCHEMEINFO2(
	BoK_URI_ADBC_ODBC_SCHEME,
	_BO_URI_ADBC_SCHEME_NAME,
	_BO_URI_ADBC_ODBC_SUBSCHEME_NAME,
	":",
	BO_URI_ADBC_ODBC_SCHEME_RULE
);


static struct aorp_uri_schemeinfo *_S_uri_schemeinfo_builtin_table[] = {
	aorp_uri_schemeinfo_p(&_S_http_uri_schemeinfo),
	aorp_uri_schemeinfo_p(&_S_ftp_uri_schemeinfo),
	aorp_uri_schemeinfo_p(&_S_mailto_uri_schemeinfo),
	aorp_uri_schemeinfo_p(&_S_file_uri_schemeinfo),
	aorp_uri_schemeinfo_p(&_S_sluzba_uri_schemeinfo),

	aorp_uri_schemeinfo_p(&_S_adbc_uri_schemeinfo),
	aorp_uri_schemeinfo_p(&_S_adbc_postgesql_uri_schemeinfo),
	aorp_uri_schemeinfo_p(&_S_adbc_sqlite_uri_schemeinfo),
	aorp_uri_schemeinfo_p(&_S_adbc_odbc_uri_schemeinfo),

	NULL
};

/******************************************************************************
 * Revision History:
 *		$Log$
 *
 *****************************************************************************/
