/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright (c) 2005-2007 V.Sokur
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

/*
 * _UrilibP.h	(N.Panasiuk)
 * include/Bo/services/alg/hilis/_UrilibP.h
 *
 * $Id$
 */

/* ------------------------------------------------------------------------- */

#ifndef __BO_SERVICES_ALG_HILIS__URILIB_P__
# define __BO_SERVICES_ALG_HILIS__URILIB_P__

/******************************************************************************
 * %% BeginSection: includes
 */

# include <Bo/services/alg/hilis/_Urilib.h>

# include <Bo/Thrtypes.h>

/******************************************************************************
 * %% BeginSection: type declarations
 */
# pragma mark -
# pragma mark [ type declarations ]
# pragma mark -

_A_opdom(Urilib) {
	bo_smutex_t   uril_dbmx;
	bo_rtbtree_t  uril_db1; /* enum-to-string */
	bo_rtbtree_t  uril_db2; /* string-to-enum */
}
_A_end;

/*
 * {urilib,Urilib} protocol
 * @{
 */

# define __aorpc_ns_protocol_c 2
# define __aorpc_ns_protocol (urilib,Urilib)
# define __aorpc_realize_service_file <Bo/services/hilis/UrilibP.h>
# include <Bo/aorp/AorpCpro.h>

_A_protocol(urilib,Urilib)
{
	_A_domdecl_;
}
_A_end_pod

_A_imop(init_once),
_A_imop(fini_once),
_A_imop_nil(pod_init),
_A_imop_nil(pod_fini),

_A_imop(create),
_A_imop(create_w),
_A_imop(create_fsp),
_A_imop(create_fsp_w),

_A_imop(supportscheme),
_A_imop(getschemebyname),
_A_imop(getschemename),
_A_imop(getschemeinfobyname),
_A_imop(getschemeinfobyid),

_A_imop(addschemeinfo),
_A_imop(addschemeinfo_nlk),
_A_imop(rmschemeinfo),
_A_imop(rmschemeinfo_nlk),

_A_imop(parsescheme),
_A_imop(parsescheme_w),

_A_end;

# include <Bo/aorp/AorpCend.h>

/* @} */

#endif /* !__BO_SERVICES_ALG_HILIS__URILIB_P__ */

/******************************************************************************
 * Revision History:
 *		$Log$
 *
 *****************************************************************************/
