/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright (c) 2005-2007 V.Sokur
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

/*
 * _UriprdefsP.h	(A.Kuzina)
 * include/Bo/services/alg/hilis/_UriprdefsP.h
 *
 * $Id$
 */

/* ------------------------------------------------------------------------- */

#ifndef __BO_SERVICES_ALG_HILIS__URIPRDEFS_P__
# define __BO_SERVICES_ALG_HILIS__URIPRDEFS_P__

/******************************************************************************
 * %% BeginSection: macros/constants definitions
 */
# pragma mark -
# pragma mark [ macros/constants declarations ]
# pragma mark -

/* Base characters sequence */
# define AORP_URI_UP_ALPHA    "ABCDEFGHIJKLMNOPQRSTUVWXYZ"
# define AORP_URI_LOW_ALPHA   "abcdefghijklmnopqrstuvwxyz"
# define AORP_URI_DIGIT       "0123456789"
# define AORP_URI_RESERVED    ";/?:@&=+$,"
# define AORP_URI_MARK        "-_.!~*'()"

# define AORP_URI_ALPHA       AORP_URI_UP_ALPHA AORP_URI_LOW_ALPHA
# define AORP_URI_ALPHANUM    AORP_URI_ALPHA AORP_URI_DIGIT
# define AORP_URI_HEX         AORP_URI_DIGIT "ABCDEFabcdef"
# define AORP_URI_ESCAPED     "%" AORP_URI_HEX
# define AORP_URI_UNRESERVED  AORP_URI_ALPHANUM AORP_URI_MARK
# define AORP_URI_URIC        AORP_URI_RESERVED AORP_URI_UNRESERVED AORP_URI_ESCAPED
# define AORP_URI_PCHAR       AORP_URI_UNRESERVED AORP_URI_ESCAPED ":@&=+$,"

# define AORP_URI_END_SCHEME  ":"

# define AORP_URI_SCHEME_SCAN_DELIM \
	"[^"                            \
	AORP_URI_UP_ALPHA               \
	AORP_URI_LOW_ALPHA              \
	AORP_URI_DIGIT                  \
	"+-."                           \
	"]"


# define AORP_WURI_UP_ALPHA    __myc_wtext("ABCDEFGHIJKLMNOPQRSTUVWXYZ")
# define AORP_WURI_LOW_ALPHA   __myc_wtext("abcdefghijklmnopqrstuvwxyz")
# define AORP_WURI_DIGIT       __myc_wtext("0123456789")
# define AORP_WURI_RESERVED    __myc_wtext(";/?:@&=+$,")
# define AORP_WURI_MARK        __myc_wtext("-_.!~*'()")

# define AORP_WURI_ALPHA       AORP_URI_UP_ALPHA AORP_URI_LOW_ALPHA
# define AORP_WURI_ALPHANUM    AORP_URI_ALPHA AORP_URI_DIGIT
# define AORP_WURI_HEX         AORP_URI_DIGIT __myc_wtext("ABCDEFabcdef")
# define AORP_WURI_ESCAPED     __myc_wtext("%") AORP_URI_HEX
# define AORP_WURI_UNRESERVED  AORP_URI_ALPHANUM AORP_URI_MARK
# define AORP_WURI_URIC        AORP_URI_RESERVED AORP_URI_UNRESERVED AORP_URI_ESCAPED
# define AORP_WURI_PCHAR       AORP_URI_UNRESERVED AORP_URI_ESCAPED __myc_wtext(":@&=+$,")

# define AORP_WURI_END_SCHEME  __myc_wtext(":")

# define AORP_WURI_SCHEME_SCAN_DELIM \
	__myc_wtext("[^")                \
	AORP_WURI_UP_ALPHA               \
	AORP_WURI_LOW_ALPHA              \
	AORP_WURI_DIGIT                  \
	__myc_wtext("+-.")               \
	__myc_wtext("]")


#endif /* !__BO_SERVICES_ALG_HILIS__URIPRDEFS_P__ */

/******************************************************************************
 * Revision History:
 *		$Log$
 *
 *****************************************************************************/
