/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright (c) 2005-2007 V.Sokur
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

/*
 * _Slogcli2.h	(S.Makhmali)
 * include/Bo/services/alg/infos/_Slogcli2.h
 *
 * $Id$
 */

/* ------------------------------------------------------------------------- */

#ifndef __BO_SERVICES_ALG_INFOS__SLOGCLI2__
# define __BO_SERVICES_ALG_INFOS__SLOGCLI2__

/******************************************************************************
 * %% BeginSection: includes
 */

# include <Bo/services/infos/LogP.h>
# include <Bo/services/infos/Log2types.h>

# include <Bo/Trpdefs.h>
# include <Bo/libc/Time.h>
	/* timespec{} */

/******************************************************************************
 * %% BeginSection: type declarations
 */
# pragma mark -
# pragma mark [ type declarations ]
# pragma mark -

# ifndef Slogcli2_L_LATENCY_MIN
#  define Slogcli2_L_LATENCY_MIN       40 /* msec */
# endif
# ifndef Slogcli2_L_LATENCY_MAX
#  define Slogcli2_L_LATENCY_MAX       (60 * 60 * 1000) /* msec */
# endif

# ifndef Slogcli2_L_MQSUP
#  define Slogcli2_L_MQSUP             1024
# endif


/*
 * Slogcli2
 *
 * log
 * oid: <<category>>/<<service>>/<<domain>>/<<impl>>
 */
/*
# define AorpK_Slogcli2_opdom (1102)
# define AorpK_Slogcli2_opdom_empty 0
 */
# include <Bo/services/MIB/Opdom.h>

# define __aorpc_ns_protocol_c 2
# define __aorpc_ns_protocol (log,Slogcli2)
# include <Bo/aorp/AorpCproi.h>

_A_protocol_init(log,Slogcli2)
{
	_A_hbdecl_;

	aorp_logattr_t const      *attr;

	/* server = { */
	struct bo_uconn_ds const  *srvaddr;
		/* currently, the content of srvaddr is not owned by the implementation */

	struct timespec const     *handshake_timeout;
	/* } */

	int                        async_mode;
	/* used in async mode; latency = { 0, [40, 60 * 60 * 1000] } */
	bo_msec_t                  latency;
	size_t                     mqsup,
	                           mqslo; /* "upper waterline", "lower waterline" */
}
_A_end;

# include <Bo/aorp/AorpCend.h>

#endif /* !__BO_SERVICES_ALG_INFOS__SLOGCLI2__ */

/******************************************************************************
 * Revision History:
 *		$Log$
 *
 *****************************************************************************/
