/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright (c) 2005-2007 V.Sokur
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

/*
 * _SlogcliP.h	(V.Sokur)
 * include/Bo/services/alg/_SlogcliP.h
 *
 * $Id$
 */

/* ------------------------------------------------------------------------- */

#ifndef __BO_SERVICES_ALG__SLOGCLI_P__
# define __BO_SERVICES_ALG__SLOGCLI_P__

/******************************************************************************
 * %% BeginSection: includes
 */

# include <Bo/services/alg/infos/_Slogcli.h>

# include <Bo/Thrtypes.h>
	/* S-mutex */

/******************************************************************************
 * %% BeginSection: type declarations
 */
# pragma mark -
# pragma mark [ type declarations ]
# pragma mark -

_A_opdom(Slogcli) {
	bo_smutex_t           slog_mutex;
	int                   slog_state;
	aorp_logattr_t        slog_attr;
	char                 *slog_srvaddr;
	struct timespec       slog_handshake_timeout;
	u_int32_t             slog_connid;
	aorp_object_t         slog_main_strm, /* or console */
	                      slog_pout_strm,
	                      slog_perr_strm;
}
_A_end;

/*
 * {log,Slogcli} protocol
 * @{
 */

# define __aorpc_ns_protocol_c 2
# define __aorpc_ns_protocol (log,Slogcli)
# define __aorpc_realize_service_file <Bo/services/infos/LogP.h>
# include <Bo/aorp/AorpCpro.h>

_A_protocol(log,Slogcli)
{
	_A_domdecl_;
}
_A_end_pod

_A_imop_nil(init_once),
_A_imop_nil(fini_once),
_A_imop(pod_init),
_A_imop(pod_fini),

_A_imop(openconn),
_A_imop(reopenconn),
_A_imop(closeconn),
_A_imop(setprifilter),
_A_imop(getprifilter),
_A_imop(setattrfilter),
_A_imop(getattrfilter),
_A_imop(printf),
_A_imop(vprintf),
#if 1
_A_imop_nil(wprintf),
_A_imop_nil(vwprintf),
#else
_A_imop(wprintf),
_A_imop(vwprintf),
#endif
_A_imop(write),
_A_imop(_send),

_A_end;

# include <Bo/aorp/AorpCend.h>

#endif /* !__BO_SERVICES_ALG__SLOGCLI_P__ */

/******************************************************************************
 * Revision History:
 *		$Log$
 *
 *****************************************************************************/
