/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright (c) 2005-2007 V.Sokur
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

/*
 * _Slogpgsrv2P.h	(N.Panasiuk)
 * include/Bo/services/alg/_Slogpgsrv2P.h
 *
 * $Id$
 */

/* ------------------------------------------------------------------------- */

#ifndef __BO_SERVICES_ALG__SLOGPGSRV2_P__
# define __BO_SERVICES_ALG__SLOGPGSRV2_P__

/******************************************************************************
 * %% BeginSection: includes
 */

# include <Bo/services/alg/infos/_Slogpgsrv2.h>

# include <Bo/services/alg/infos/_Slogsrv2P.h>
	/* opdom Slogsrv2 */

/******************************************************************************
 * %% BeginSection: type declarations
 */
# pragma mark -
# pragma mark [ type declarations ]
# pragma mark -

/*
 * {log,Slogpgsrv2} protocol
 * @{
 */

# define __aorpc_ns_protocol_c 2
# define __aorpc_ns_protocol (log,Slogpgsrv2)
# define __aorpc_realize_service_file <Bo/services/infos/LogP.h>
# include <Bo/aorp/AorpCpro.h>

_A_protocol(log,Slogpgsrv2)
{
	_A_domdecl(Slogsrv2);
}
_A_end_pod

_A_imop_nf(init_once,2,(log,Slogsrv2)),
_A_imop_nf(fini_once,2,(log,Slogsrv2)),
_A_imop(pod_init),
_A_imop_nf(pod_fini,2,(log,Slogsrv2)),

_A_imop_nf(openconn,2,(log,Slogsrv2)),
_A_imop_nf(reopenconn,2,(log,Slogsrv2)),
_A_imop_nf(closeconn,2,(log,Slogsrv2)),
_A_imop_nf(setprifilter,2,(log,Slogsrv2)),
_A_imop_nf(getprifilter,2,(log,Slogsrv2)),
_A_imop_nf(setattrfilter,2,(log,Slogsrv2)),
_A_imop_nf(getattrfilter,2,(log,Slogsrv2)),
_A_imop_nf(printf,2,(log,Slogsrv2)),
_A_imop_nf(vprintf,2,(log,Slogsrv2)),
_A_imop_nf(wprintf,2,(log,Slogsrv2)),
_A_imop_nf(vwprintf,2,(log,Slogsrv2)),
_A_imop_nf(write,2,(log,Slogsrv2)),
_A_imop_nf(_send,2,(log,Slogsrv2)),

_A_end;

# include <Bo/aorp/AorpCend.h>

/* @} */

#endif /* !__BO_SERVICES_ALG__SLOGPGSRV2_P__ */

/******************************************************************************
 * Revision History:
 *		$Log$
 *
 *****************************************************************************/
