/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright (c) 2005-2007 V.Sokur
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

/*
 * _Fiios.h	(V.Sokur)
 * include/Bo/services/alg/io/_Fiios.h
 *
 * $Id$
 */

/* ------------------------------------------------------------------------- */

#ifndef __BO_SERVICES_ALG_IO__FIIOS__
# define __BO_SERVICES_ALG_IO__FIIOS__

/******************************************************************************
 * %% BeginSection: includes
 */

# include <Bo/services/io/IosP.h>
# include <Bo/services/io/IostrP.h>

/******************************************************************************
 * %% BeginSection: type declarations
 */
# pragma mark -
# pragma mark [ type declarations ]
# pragma mark -

/*
 * Fiios
 *
 * ios
 * oid: <<category>>/<<service>>/<<domain>>/<<impl>>
 */
/*
# define AorpK_Fiios_opdom (251)
# define AorpK_Fiios_opdom_empty 0
 */
# include <Bo/services/MIB/Opdom.h>

# define __aorpc_ns_protocol_c 2
# define __aorpc_ns_protocol (ios,Fiios)
# include <Bo/aorp/AorpCproi.h>

# define AorpK_FIIOS_INIT_UCONN 0
# define AorpK_FIIOS_INIT_PATH 1
# define AorpK_FIIOS_INIT_WPATH 2
# define AorpK_FIIOS_INIT_URI 3
# define AorpK_FIIOS_INIT_FD 4
# define AorpK_FIIOS_INIT_FILE 5

_A_protocol_init(ios,Fiios)
{
	_A_hbdecl_;

	int        initsw;

#if 1
	intptr_t        file;
	bo_pointer_t    fomode; /* libc or unix style; wide text for WPATH only */
	bo_ownership_t  owns;
#else
	union {
		FILE              *fp;
		int                fd;
		struct {
			aorp_object_t  flocation;
			char const    *mode;
		} _uri;
		struct {
			char const    *flocation;
			char const    *mode;
		} _p;
		struct {
			wchar_t const *flocation;
			wchar_t const *mode;
		} _wp;
	} u;
	bo_ownership_t  owns;
#endif
}
_A_end;

# include <Bo/aorp/AorpCend.h>

#endif /* !__BO_SERVICES_ALG_IO__FIIOS__ */

/******************************************************************************
 * Revision History:
 *		$Log$
 *
 *****************************************************************************/
