/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright (c) 2005-2007 V.Sokur
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

/*
 * _FiiosP.h	(V.Sokur)
 * include/Bo/services/alg/io/_FiiosP.h
 *
 * $Id$
 */

/* ------------------------------------------------------------------------- */

#ifndef __BO_SERVICES_ALG_IO__FIIOS_P__
# define __BO_SERVICES_ALG_IO__FIIOS_P__

/******************************************************************************
 * %% BeginSection: includes
 */

# include <Bo/services/alg/io/_Fiios.h>

/******************************************************************************
 * %% BeginSection: type declarations
 */
# pragma mark -
# pragma mark [ type declarations ]
# pragma mark -

_A_opdom(Fiios) {
	bo_byte_t              fios_myfp;
	bo_byte_t              fios_myiob;
	bo_byte_t              fios_pad[2];

	bo_pointer_t           fios_fp;
	int                    fios_oflags;

	aorp_iobufmode_t       fios_bufmode;
	struct bo_absbuf       fios_iobuf;

	bo_cpulock_t           fios_intmx;
	struct bo_nabsbuf      fios_rdbuf;
}
_A_end;

/* ----------------------------------------------------------------------------
 * {iostr,Fiios} protocol
 * @{
 */

# define __aorpc_ns_protocol_c 2
# define __aorpc_ns_protocol (iostr,Fiios)
# define __aorpc_realize_service_file <Bo/services/io/IostrP.h>
# include <Bo/aorp/AorpCpro.h>

_A_protocol(iostr,Fiios)
{
	_A_domdecl_;
}
_A_end_pod

_A_imop_nil(init_once),
_A_imop_nil(fini_once),
_A_imop_nil(pod_init),
_A_imop_nil(pod_fini),

_A_imop(setiobuf),
_A_imop(getiobuf),

_A_imop(read),
_A_imop(readall),
_A_imop(getrdbuf),
_A_imop(endrdbuf),

_A_imop(write),
_A_imop(printf),
_A_imop(vprintf),
_A_imop(wprintf),
_A_imop(vwprintf),
_A_imop(flush),
_A_imop(seek),

_A_imop(readv),
_A_imop(writev),
_A_imop(pread),
_A_imop(pwrite),

_A_end;

# include <Bo/aorp/AorpCend.h>
/* @} */

/* ----------------------------------------------------------------------------
 * {ios,Fiios} protocol
 * @{
 */

# define __aorpc_ns_protocol_c 2
# define __aorpc_ns_protocol (ios,Fiios)
# define __aorpc_realize_service_file <Bo/services/io/IosP.h>
# include <Bo/aorp/AorpCpro.h>

_A_protocol(ios,Fiios)
{
	_A_domdecl_;
}
_A_end_pod

_A_imop_nil(init_once),
_A_imop_nil(fini_once),
_A_imop(pod_init),
_A_imop(pod_fini),

_A_imop(gettinfo),
_A_imop(getstate),
_A_imop(sync),
_A_imop(optctl),
_A_imop(bind),
_A_imop(rebind),
_A_imop(unbind),
_A_imop(control),

_A_imop(poll),
_A_imop(poll_abs),
_A_imop(getpollbox),
_A_imop_rr(getselbox,getpollbox),

_A_end;

# include <Bo/aorp/AorpCend.h>
/* @} */

#endif /* !__BO_SERVICES_ALG_IO__FIIOS_P__ */

/******************************************************************************
 * Revision History:
 *		$Log$
 *
 *****************************************************************************/
