/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright (c) 2005-2007 V.Sokur
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

/*
 * Rlevents.h	(N.Panasiuk)
 * include/Bo/services/alg/jobcntl/Rlevents.h
 *
 * $Id$
 */

/* ------------------------------------------------------------------------- */

#ifndef __BO_SERVICES_ALG_JOBCNTL_RLEVENTS__
# define __BO_SERVICES_ALG_JOBCNTL_RLEVENTS__

/******************************************************************************
 * %% BeginSection: includes
 */

# include <Bo/Noticedefs.h>

/******************************************************************************
 * %% BeginSection: type declarations
 */
# pragma mark -
# pragma mark [ type declarations ]
# pragma mark -

# define _AORP_MAKE_RL_NEVENT(x) BO_MAKE_NEVENT(AorpK_runloop_service,x)

# define _AorpK_RlEvent_Run 3
# define _AorpK_RlEvent_Cancel 4
# define _AorpK_RlEvent_Suspend 5
# define _AorpK_RlEvent_Resume 6
# define _AorpK_RlEvent_Execjob 7

/* RUN-EVENT-SPECIFICATION @{ */
# define AorpK_RlEvent_Run _AORP_MAKE_RL_NEVENT(_AorpK_RlEvent_Run)
/*
	run-vaxevent = [
		.vxe_event = AorpK_RlEvent_Run;
		.vxe_sender = @acceptor;
	];
 */
/* @} */

/* CANCEL-EVENT-SPECIFICATION @{ */
# define AorpK_RlEvent_Cancel _AORP_MAKE_RL_NEVENT(_AorpK_RlEvent_Cancel)
/*
	cancel-vaxevent = [
		.vxe_event = AorpK_RlEvent_Cancel;
		.vxe_sender = @acceptor;
	];
 */
/* @} */

/* SUSPEND-EVENT-SPECIFICATION @{ */
# define AorpK_RlEvent_Suspend _AORP_MAKE_RL_NEVENT(_AorpK_RlEvent_Suspend)
/*
	suspend-vaxevent = [
		.vxe_event = AorpK_RlEvent_Suspend;
		.vxe_sender = @acceptor;
	];
 */
/* @} */

/* RESUME-EVENT-SPECIFICATION @{ */
# define AorpK_RlEvent_Resume _AORP_MAKE_RL_NEVENT(_AorpK_RlEvent_Resume)
/*
	resume-vaxevent = [
		.vxe_event = AorpK_RlEvent_Resume;
		.vxe_sender = @acceptor;
	];
 */
/* @} */

/* EXECJOB-EVENT-SPECIFICATION @{ */
# define AorpK_RlEvent_Execjob _AORP_MAKE_RL_NEVENT(_AorpK_RlEvent_Execjob)
/*
	execjob-vaxevent = [
		.vxe_event = AorpK_RlEvent_Execjob;
		.vxe_sender = @acceptor;
	];
 */
/* @} */

#endif /* !__BO_SERVICES_ALG_JOBCNTL_RLEVENTS__ */

/******************************************************************************
 * Revision History:
 *		$Log$
 *
 *****************************************************************************/
