/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright (c) 2005-2007 V.Sokur
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

/*
 * _AsurloopP.h	(V.Sokur)
 * include/Bo/services/alg/jobcntl/_AsurloopP.h
 *
 * $Id$
 */

/* ------------------------------------------------------------------------- */

#ifndef __BO_SERVICES_ALG_JOBCNTL__ASURLOOP_P__
# define __BO_SERVICES_ALG_JOBCNTL__ASURLOOP_P__

/******************************************************************************
 * %% BeginSection: includes
 */

# include <Bo/services/alg/jobcntl/_Asurloop.h>

# include <Bo/Thrtypes.h>
# include <Bo/libc/Time.h>
	/* timespec */

/******************************************************************************
 * %% BeginSection: type declarations
 */
# pragma mark -
# pragma mark [ type declarations ]
# pragma mark -

# include <Bo/services/alg/jobcntl/_EverldefsI.h>

_A_opdom(Asurloop) {
	_EVERLOOP_GUTS;
	bo_vaxevent_t  rl_wakeup_ev;
}
_A_end;

/*
 * {runloop,Asurloop} protocol
 * @{
 */

# define __aorpc_ns_protocol_c 2
# define __aorpc_ns_protocol (runloop,Asurloop)
# define __aorpc_realize_service_file <Bo/services/jobcntl/RunloopP.h>
# include <Bo/aorp/AorpCpro.h>

_A_protocol(runloop,Asurloop)
{
	_A_domdecl_;
}
_A_end_pod

_A_imop_nf(init_once,2,(runloop,Everloop)),
_A_imop_nf(fini_once,2,(runloop,Everloop)),
_A_imop(pod_init),
_A_imop(pod_fini),

_A_imop_nf(run,2,(runloop,Everloop)),
_A_imop_nf(cancel,2,(runloop,Everloop)),
_A_imop_nf(suspend,2,(runloop,Everloop)),
_A_imop_nf(resume,2,(runloop,Everloop)),

_A_imop_nf(lockjl,2,(runloop,Everloop)),
_A_imop_nf(unlockjl,2,(runloop,Everloop)),

_A_imop_nf(execjob,2,(runloop,Everloop)),
_A_imop_nf(findjob,2,(runloop,Everloop)),
_A_imop_nf(findjob_nlk,2,(runloop,Everloop)),
_A_imop_nf(addjob,2,(runloop,Everloop)),
_A_imop_nf(addjob_nlk,2,(runloop,Everloop)),
_A_imop_nf(rmjob,2,(runloop,Everloop)),
_A_imop_nf(rmjob_nlk,2,(runloop,Everloop)),
_A_imop_nf(deljob,2,(runloop,Everloop)),
_A_imop_nf(deljob_nlk,2,(runloop,Everloop)),

_A_imop_nf(getjobstatus,2,(runloop,Everloop)),
_A_imop_nf(getstate,2,(runloop,Everloop)),

_A_imop_nf(getperiod,2,(runloop,Everloop)),
_A_imop_nf(setperiod,2,(runloop,Everloop)),

_A_imop_nf(addjob3,2,(runloop,Everloop)),
_A_imop_nf(addjob3_nlk,2,(runloop,Everloop)),
_A_imop_nf(getmode,2,(runloop,Everloop)),

_A_imop_nf(cancelf,2,(runloop,Everloop)),
_A_imop_nf(suspendf,2,(runloop,Everloop)),
_A_imop_nf(resumef,2,(runloop,Everloop)),

_A_end;

# include <Bo/aorp/AorpCend.h>
/* @} */

#endif /* !__BO_SERVICES_ALG_JOBCNTL__ASURLOOP_P__ */

/******************************************************************************
 * Revision History:
 *		$Log$
 *
 *****************************************************************************/
