/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright (c) 2005-2007 V.Sokur
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

/*
 * _EverldefsI.h	(V.Sokur)
 * include/Bo/services/alg/jobcntl/_EverldefsI.h
 *
 * $Id$
 */

/* ------------------------------------------------------------------------- */

#ifndef __BO_SERVICES_ALG_JOBCNTL__EVERLDEFS_I__
# define __BO_SERVICES_ALG_JOBCNTL__EVERLDEFS_I__

/******************************************************************************
 * %% BeginSection: type declarations
 */
# pragma mark -
# pragma mark [ type declarations ]
# pragma mark -

/* Limits */
# define _EverlL_JOB_MAX (128)

struct Everl_jlelem {
	AORP_ONEP_OF((struct aorp_ujob *, aorp_object_t)) jle_job;
	bo_pointer_t       jle_jobparm;
	struct aorp_error *jle_joberr;
	aorp_sobject_t     jle_sejob_;
	bo_index_t         jle_jobid;
	short              jle_wait_to_run;
	short              jle_job_status;
};

/* NOTE!!! run-strategy != 0 means that exec-job was called */
# define _EVERLOOP_GUTS \
	volatile bo_state_t    rl_state; \
	struct timespec        rl_start; \
	struct timespec        rl_period; \
	bo_seqlist_t           rl_jlist; \
	struct Everl_jlelem    rl_jlelem; \
	bo_pthread_t           rl_work_thr; \
	int                    rl_run_strategy; /* all: 0, -1; some jobs: 1 */ \
	bo_vaxevent_ref        rl_wakeup_evref; \
	bo_cond_t              rl_suspend_cond; \
	bo_cpulock_t           rl_start_cntl; \
	bo_smutex_t            rl_jlist_mx

/* @todo: fixme */
# ifdef HAS_INT64_TYPE

#  define _EVERLOOP_Getstate(aPod) \
	BoAtomicLoad64_acq(&(aPod)->rl_state)

#  define _EVERLOOP_Setstate(aPod,aState) \
	BoAtomicStore64_rel(&(aPod)->rl_state,aState)

# else /* !HAS_INT64_TYPE */

#  define _EVERLOOP_Getstate(aPod) \
	BoAtomicLoad32_acq(&(aPod)->rl_state)

#  define _EVERLOOP_Setstate(aPod,aState) \
	BoAtomicStore32_rel(&(aPod)->rl_state,aState)

# endif /* HAS_INT64_TYPE */

#endif /* !__BO_SERVICES_ALG_JOBCNTL__EVERLDEFS_I__ */

/******************************************************************************
 * Revision History:
 *		$Log$
 *
 *****************************************************************************/
