/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright (c) 2005-2007 V.Sokur
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

/*
 * _EverloopP.h	(V.Sokur)
 * include/Bo/services/alg/jobcntl/_EverloopP.h
 *
 * $Id$
 */

/* ------------------------------------------------------------------------- */

#ifndef __BO_SERVICES_ALG_JOBCNTL__EVERLOOP_P__
# define __BO_SERVICES_ALG_JOBCNTL__EVERLOOP_P__

/******************************************************************************
 * %% BeginSection: includes
 */

# include <Bo/services/alg/jobcntl/_Everloop.h>

# include <Bo/libc/Time.h>
	/* timespec */

/******************************************************************************
 * %% BeginSection: type declarations
 */
# pragma mark -
# pragma mark [ type declarations ]
# pragma mark -

# include <Bo/services/alg/jobcntl/_EverldefsI.h>

_A_opdom(Everloop) {
	_EVERLOOP_GUTS;
}
_A_end;

/* ----------------------------------------------------------------------------
 * {runloop,Everloop} protocol
 * @{
 */

# define __aorpc_ns_protocol_c 2
# define __aorpc_ns_protocol (runloop,Everloop)
# define __aorpc_realize_service_file <Bo/services/jobcntl/RunloopP.h>
# include <Bo/aorp/AorpCpro.h>

_A_protocol(runloop,Everloop)
{
	_A_domdecl_;
}
_A_end_pod

_A_imop_nil(init_once),
_A_imop_nil(fini_once),
_A_imop(pod_init),
_A_imop(pod_fini),

_A_imop(run),
_A_imop(cancel),
_A_imop(suspend),
_A_imop(resume),

_A_imop(lockjl),
_A_imop(unlockjl),

_A_imop(execjob),
_A_imop(findjob),
_A_imop(findjob_nlk),
_A_imop(addjob),
_A_imop(addjob_nlk),
_A_imop(rmjob),
_A_imop(rmjob_nlk),
_A_imop(deljob),
_A_imop(deljob_nlk),

_A_imop(getjobstatus),
_A_imop(getstate),

_A_imop(getperiod),
_A_imop(setperiod),

_A_imop(addjob3),
_A_imop(addjob3_nlk),
_A_imop(getmode),

_A_imop(cancelf),
_A_imop(suspendf),
_A_imop(resumef),

_A_end;

# include <Bo/aorp/AorpCend.h>
/* @} */

/* ----------------------------------------------------------------------------
 * {job,Everloop} protocol
 * @{
 */

# include <Bo/services/jobcntl/JobP.h>

# define __aorpc_ns_protocol_c 2
# define __aorpc_ns_protocol (job,Everloop)
# define __aorpc_realize_service_file <Bo/services/jobcntl/JobP.h>
# include <Bo/aorp/AorpCpro.h>

/*
 * The impl of the 'job' service acts on Everloop domain.
 */
_A_protocol(job,Everloop)
{
	_A_domdecl_;
}
_A_end_pod

_A_imop_nil(init_once),
_A_imop_nil(fini_once),
_A_imop_nil(pod_init),
_A_imop_nil(pod_fini),

_A_imop_nfr(schedule,2,(runloop,Everloop),run),
_A_imop_nfr(unschedule,2,(runloop,Everloop),cancel),
_A_imop(exec),

_A_end;

# include <Bo/aorp/AorpCend.h>
/* @} */

#endif /* !__BO_SERVICES_ALG_JOBCNTL__EVERLOOP_P__ */

/******************************************************************************
 * Revision History:
 *		$Log$
 *
 *****************************************************************************/
