/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright (c) 2005-2007 V.Sokur
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

/*
 * _UleP.h	(S.Makhmali)
 * include/Bo/services/alg/jobcntl/_UleP.h
 *
 * $Id$
 */

/* ------------------------------------------------------------------------- */

#ifndef __BO_SERVICES_ALG_JOBCNTL__ULE_P__
# define __BO_SERVICES_ALG_JOBCNTL__ULE_P__

/******************************************************************************
 * %% BeginSection: includes
 */

# include <Bo/services/alg/jobcntl/_Ule.h>

# include <Bo/Thrtypes.h>
	/* simple-mutex */

/******************************************************************************
 * %% BeginSection: type declarations
 */
# pragma mark -
# pragma mark [ type declarations ]
# pragma mark -

_A_opdom(Ule) {
	bo_smutex_t                ule_entlist_mx;
	bo_seqlist_t               ule_entlist;
	size_t                     ule_jtelemc;
	struct aorp_sched_jtelem  *ule_jtable;
	unsigned                   ule_accuracy;
	int                        ule_execmode;
	bo_usec_t                  ule_rate_1;
}
_A_end;

struct Sched_ulelem {
	struct aorp_sched_entry_header   *sule_entry;
	bo_index_t    sule_entid;
	struct bo_tm  sule_atime;
};

/* ----------------------------------------------------------------------------
 * {sched,Ule} protocol
 * @{
 */

# define __aorpc_ns_protocol_c 2
# define __aorpc_ns_protocol (sched,Ule)
# define __aorpc_realize_service_file <Bo/services/jobcntl/SchedP.h>
# include <Bo/aorp/AorpCpro.h>

_A_protocol(sched,Ule)
{
	_A_domdecl_;
}
_A_end_pod

_A_imop_nil(init_once),
_A_imop_nil(fini_once),
_A_imop(pod_init),
_A_imop(pod_fini),

_A_imop(parseent),
_A_imop(parseent2),
_A_imop(printent),

_A_imop(lockel),
_A_imop(unlockel),

_A_imop(addent),
_A_imop(addent_nlk),
_A_imop(rment),
_A_imop(rment_nlk),
_A_imop(delent),
_A_imop(delent_nlk),

_A_imop(setaction),
_A_imop(unsetaction),
_A_imop(setjtable),
_A_imop(unsetjtable),

_A_imop(checktime),
_A_imop(checktime_tm),

_A_imop(execmode),

_A_end;

# include <Bo/aorp/AorpCend.h>
/* @} */

/* ----------------------------------------------------------------------------
 * {job,Ule} protocol
 * @{
 */

# include <Bo/services/jobcntl/JobP.h>

# define __aorpc_ns_protocol_c 2
# define __aorpc_ns_protocol (job,Ule)
# define __aorpc_realize_service_file <Bo/services/jobcntl/JobP.h>
# include <Bo/aorp/AorpCpro.h>

/*
 * The impl of the 'job' service acts on Sched domain.
 */
_A_protocol(job,Ule)
{
	_A_domdecl_;
}
_A_end_pod

_A_imop_nil(init_once),
_A_imop_nil(fini_once),
_A_imop_nil(pod_init),
_A_imop_nil(pod_fini),

_A_imop(schedule),
_A_imop(unschedule),
_A_imop(exec),

_A_end;

# include <Bo/aorp/AorpCend.h>
/* @} */

#endif /* !__BO_SERVICES_ALG_JOBCNTL__ULE_P__ */

/******************************************************************************
 * Revision History:
 *		$Log$
 *
 *****************************************************************************/
