/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright (c) 2005-2007 V.Sokur
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

/*
 * _Afblttab.h	(S.Makhmali)
 * include/Bo/services/alg/net/_Afblttab.h
 *
 * $Id$
 */

/******************************************************************************
 * %% BeginSection: definitions
 */
# pragma mark -
# pragma mark [ definitions ]
# pragma mark -

static struct Tris_af_dbelem _S_Tris_af_builtin_table[] = {
	{ TrifK_UNSPEC_FAMILY, TRIF_UNSPEC_FAMILY },
	{ TrifK_LOCAL_FAMILY, TRIF_LOCAL_FAMILY },
	{ TrifK_UNIX_FAMILY, TRIF_UNIX_FAMILY },
	{ TrifK_INET_FAMILY, TRIF_INET_FAMILY },
	{ TrifK_IMPLINK_FAMILY, TRIF_IMPLINK_FAMILY },
	{ TrifK_PUP_FAMILY, TRIF_PUP_FAMILY },
	{ TrifK_CHAOS_FAMILY, TRIF_CHAOS_FAMILY },
	{ TrifK_NETBIOS_FAMILY, TRIF_NETBIOS_FAMILY },
	{ TrifK_ISO_FAMILY, TRIF_ISO_FAMILY },
	{ TrifK_OSI_FAMILY, TRIF_OSI_FAMILY },
	{ TrifK_ECMA_FAMILY, TRIF_ECMA_FAMILY },
	{ TrifK_DATAKIT_FAMILY, TRIF_DATAKIT_FAMILY },
	{ TrifK_CCITT_FAMILY, TRIF_CCITT_FAMILY },
	{ TrifK_SNA_FAMILY, TRIF_SNA_FAMILY },
	{ TrifK_DECnet_FAMILY, TRIF_DECnet_FAMILY },
	{ TrifK_DLI_FAMILY, TRIF_DLI_FAMILY },
	{ TrifK_LAT_FAMILY, TRIF_LAT_FAMILY },
	{ TrifK_HYLINK_FAMILY, TRIF_HYLINK_FAMILY },
	{ TrifK_APPLETALK_FAMILY, TRIF_APPLETALK_FAMILY },
	{ TrifK_ROUTE_FAMILY, TRIF_ROUTE_FAMILY },
	{ TrifK_LINK_FAMILY, TRIF_LINK_FAMILY },
	{ TrifK_pseudo_XTP_FAMILY, TRIF_pseudo_XTP_FAMILY },
	{ TrifK_COIP_FAMILY, TRIF_COIP_FAMILY },
	{ TrifK_CNT_FAMILY, TRIF_CNT_FAMILY },
	{ TrifK_pseudo_RTIP_FAMILY, TRIF_pseudo_RTIP_FAMILY },
	{ TrifK_IPX_FAMILY, TRIF_IPX_FAMILY },
	{ TrifK_SIP_FAMILY, TRIF_SIP_FAMILY },
	{ TrifK_pseudo_PIP_FAMILY, TRIF_pseudo_PIP_FAMILY },
	{ TrifK_ISDN_FAMILY, TRIF_ISDN_FAMILY },
	{ TrifK_E164_FAMILY, TRIF_E164_FAMILY },
	{ TrifK_pseudo_KEY_FAMILY, TRIF_pseudo_KEY_FAMILY },
	{ TrifK_INET6_FAMILY, TRIF_INET6_FAMILY },
	{ TrifK_NATM_FAMILY, TRIF_NATM_FAMILY },
	{ TrifK_ATM_FAMILY, TRIF_ATM_FAMILY },
	{ TrifK_pseudo_HDRCMPLT_FAMILY, TRIF_pseudo_HDRCMPLT_FAMILY },
	{ TrifK_NETGRAPH_FAMILY, TRIF_NETGRAPH_FAMILY },
	{ TrifK_SLOW_FAMILY, TRIF_SLOW_FAMILY },
	{ TrifK_SCLUSTER_FAMILY, TRIF_SCLUSTER_FAMILY },
	{ TrifK_ARP_FAMILY, TRIF_ARP_FAMILY },
	{ TrifK_BLUETOOTH_FAMILY, TRIF_BLUETOOTH_FAMILY },

	{ TrifK_NS_FAMILY, TRIF_NS_FAMILY },
	{ TrifK_VOICEVIEW_FAMILY, TRIF_VOICEVIEW_FAMILY },
	{ TrifK_FIREFOX_FAMILY, TRIF_FIREFOX_FAMILY },
	{ TrifK_UNKNOWN1_FAMILY, TRIF_UNKNOWN1_FAMILY },
	{ TrifK_BAN_FAMILY, TRIF_BAN_FAMILY },
	{ TrifK_CLUSTER_FAMILY, TRIF_CLUSTER_FAMILY },
	{ TrifK_12844_FAMILY, TRIF_12844_FAMILY },
	{ TrifK_IRDA_FAMILY, TRIF_IRDA_FAMILY },
	{ TrifK_NETDES_FAMILY, TRIF_NETDES_FAMILY },
	{ TrifK_TCNPROCESS_FAMILY, TRIF_TCNPROCESS_FAMILY },
	{ TrifK_TCNMESSAGE_FAMILY, TRIF_TCNMESSAGE_FAMILY },
	{ TrifK_ICLFXBM_FAMILY, TRIF_ICLFXBM_FAMILY },
	{ TrifK_BTH_FAMILY, TRIF_BTH_FAMILY },

	{ TrifK_MAX_FAMILY, TRIF_MAX_FAMILY },

	{ TrifK_INVAL_FAMILY, NULL }
};

/******************************************************************************
 * Revision History:
 *		$Log$
 *
 *****************************************************************************/
