/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright (c) 2009 V.Sokur
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

/*
 * _Socket.h	(S.Makhmali)
 * include/Bo/services/alg/net/_Socket.h
 *
 * $Id$
 */

/* ------------------------------------------------------------------------- */

#ifndef __BO_SERVICES_ALG_NET__SOCKET__
# define __BO_SERVICES_ALG_NET__SOCKET__

/******************************************************************************
 * %% BeginSection: includes
 */

# include <Bo/services/net/OtiP.h>

/******************************************************************************
 * %% BeginSection: type declarations
 */
# pragma mark -
# pragma mark [ type declarations ]
# pragma mark -

/*
 * Socket
 *
 * oti
 * oid: <<category>>/<<service>>/<<domain>>/<<impl>>
 */
/*
# define AorpK_Socket_opdom (901)
# define AorpK_Socket_opdom_empty 0
*/
# include <Bo/services/MIB/Opdom.h>

/* ------------------------------------------------------------------------- */

# define __aorpc_ns_protocol_c 2
# define __aorpc_ns_protocol (oti,Socket)
# include <Bo/aorp/AorpCproi.h>

_A_protocol_init(oti,Socket)
{
	_A_hbdecl_;
	struct bo_uconn_ds  *uconn;
	int                  openflags;
	struct bo_tinfo_oti *info;
}
_A_end;

# include <Bo/aorp/AorpCend.h>

#if 0
/* ------------------------------------------------------------------------- */

/*
 * The impl of the 'ios' service acts on Socket domain.
 */
# define __aorpc_ns_protocol_c 2
# define __aorpc_ns_protocol (ios,Socket)
# include <Bo/aorp/AorpCproi.h>

_A_protocol_init(ios,Socket)
_A_end;

# include <Bo/aorp/AorpCend.h>
#endif

#endif /* !__BO_SERVICES_ALG_NET__SOCKET__ */

/******************************************************************************
 * Revision History:
 *		$Log$
 *
 *****************************************************************************/
