/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright (c) 2005-2007 V.Sokur
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

/*
 * _TrisP.h	(V.Sokur)
 * include/Bo/services/alg/net/_TrisP.h
 *
 * $Id$
 */

/* ------------------------------------------------------------------------- */

#ifndef __BO_SERVICES_ALG_NET__TRIS_P__
# define __BO_SERVICES_ALG_NET__TRIS_P__

/******************************************************************************
 * %% BeginSection: includes
 */

# include <Bo/services/alg/net/_Tris.h>

# if 0
# include <Bo/Thrtypes.h>
# endif

/******************************************************************************
 * %% BeginSection: type declarations
 */
# pragma mark -
# pragma mark [ type declarations ]
# pragma mark -

_A_opdom(Tris) {
# if 0
	bo_smutex_t   tri_dbmx;
# endif
	bo_rtbtree_t  tri_afdb1; /* enum-to-string */
	bo_rtbtree_t  tri_afdb2; /* string-to-enum */
	bo_rtbtree_t  tri_pfdb1; /* enum-to-string */
	bo_rtbtree_t  tri_pfdb2; /* string-to-enum */
}
_A_end;

/*
 * {tris,Tris} protocol
 * @{
 */

# define __aorpc_ns_protocol_c 2
# define __aorpc_ns_protocol (tris,Tris)
# define __aorpc_realize_service_file <Bo/services/net/TrisP.h>
# include <Bo/aorp/AorpCpro.h>

_A_protocol(tris,Tris)
{
	_A_domdecl_;
}
_A_end_pod

_A_imop(init_once),
_A_imop(fini_once),
_A_imop_nil(pod_init),
_A_imop_nil(pod_fini),

_A_imop(afname),
_A_imop(afname2enum),
_A_imop(protoname),
_A_imop(protoname2enum),
_A_imop(protoinfobyid),
_A_imop(protoinfobyname),

_A_end;

# include <Bo/aorp/AorpCend.h>
/* @} */

#endif /* !__BO_SERVICES_ALG_NET__TRIS_P__ */

/******************************************************************************
 * Revision History:
 *		$Log$
 *
 *****************************************************************************/
