/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright (c) 2005-2007 V.Sokur
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

/*
 * _QdfaP.h	(N.Panasiuk)
 * include/Bo/services/alg/textan/_QdfaP.h
 *
 * $Id$
 */

/* ------------------------------------------------------------------------- */

#ifndef __BO_SERVICES_ALG_TEXTAN__QDFA_P__
# define __BO_SERVICES_ALG_TEXTAN__QDFA_P__

/******************************************************************************
 * %% BeginSection: includes
 */

# include <Bo/services/alg/textan/_Qdfa.h>

# include <Bo/services/alg/textan/_QdfadefsI.h>

/******************************************************************************
 * %% BeginSection: type declarations
 */
# pragma mark -
# pragma mark [ type declarations ]
# pragma mark -

_A_opdom(Qdfa) {
	_QDFA_GUTS;
}
_A_end;

/* ----------------------------------------------------------------------------
 * {dfa,Qdfa} protocol
 * @{
 */

# include <Bo/services/textan/LexopenP.h>

# define __aorpc_ns_protocol_c 2
# define __aorpc_ns_protocol (dfa,Qdfa)
# define __aorpc_realize_service_file <Bo/services/textan/DfaP.h>
# include <Bo/aorp/AorpCpro.h>

_A_protocol(dfa,Qdfa)
{
	_A_domdecl_;
}
_A_end_pod

_A_imop_nil(init_once),
_A_imop_nil(fini_once),
_A_imop(pod_init),
_A_imop(pod_fini),

_A_end;

# include <Bo/aorp/AorpCend.h>
/* @} */

/* ----------------------------------------------------------------------------
 * {lexopen,Qdfa} protocol
 * @{
 */

# define __aorpc_ns_protocol_c 2
# define __aorpc_ns_protocol (lexopen,Qdfa)
# define __aorpc_realize_service_file <Bo/services/textan/LexopenP.h>
# include <Bo/aorp/AorpCpro.h>

/*
 * The impl of the 'lexopen' service acts on Dfa domain.
 */
_A_protocol(lexopen,Qdfa)
{
	_A_domdecl_;
}
_A_end_pod

_A_imop_nil(init_once),
_A_imop_nil(fini_once),
_A_imop_nil(pod_init),
_A_imop_nil(pod_fini),

_A_imop(open),

_A_end;

# include <Bo/aorp/AorpCend.h>
/* @} */

#endif /* !__BO_SERVICES_ALG_TEXTAN__QDFA_P__ */

/******************************************************************************
 * Revision History:
 *		$Log$
 *
 *****************************************************************************/
