/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright (c) 2005-2007 V.Sokur
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

/*
 * _QdfalexP.h	(N.Panasiuk)
 * include/Bo/services/alg/textan/_QdfalexP.h
 *
 * $Id$
 */

/* ------------------------------------------------------------------------- */

#ifndef __BO_SERVICES_ALG_TEXTAN__QDFALEX_P__
# define __BO_SERVICES_ALG_TEXTAN__QDFALEX_P__

/******************************************************************************
 * %% BeginSection: includes
 */

# include <Bo/services/alg/textan/_Qdfalex.h>

# include <Bo/services/alg/textan/_QdfaP.h>

/******************************************************************************
 * %% BeginSection: type declarations
 */
# pragma mark -
# pragma mark [ type declarations ]
# pragma mark -

typedef bo_status_t
(__myc_tcalltype__(mcall) *qdfalex_fetchtoken_fn)(
# if __myc_require(prototypes)
	struct aorp_closure *aClosure,
	struct aorp_error *anErrPtr,
	struct aorp_token *aToken
# endif
	) __attribute__((mcalltype, nonnull(1,3)));

_A_opdom(Qdfalex) {
	aorp_object_t                 lxan_qdfa;
	_A_opdom(Qdfa)               *lxan_qdfa_pod;
	unsigned long                 lxan_current_state;

	aorp_object_t                 lxan_stream;
	unsigned char const          *lxan_forward;
	unsigned char const          *lxan_end;
	unsigned char const          *lxan_lexeme;

	struct aorp_token_predicate  *lxan_predicate;

	qdfalex_fetchtoken_fn         lxan_fetchtoken;
}
_A_end;

/*
 * {lexan,Qdfalex} protocol
 * @{
 */

# define __aorpc_ns_protocol_c 2
# define __aorpc_ns_protocol (lexan,Qdfalex)
# define __aorpc_realize_service_file <Bo/services/textan/LexanP.h>
# include <Bo/aorp/AorpCpro.h>

_A_protocol(lexan,Qdfalex)
{
	_A_domdecl_;
}
_A_end_pod

_A_imop_nil(init_once),
_A_imop_nil(fini_once),
_A_imop(pod_init),
_A_imop(pod_fini),

_A_imop(fetchtoken),

_A_end;

# include <Bo/aorp/AorpCend.h>
/* @} */

#endif /* !__BO_SERVICES_ALG_TEXTAN__QDFALEX_P__ */

/******************************************************************************
 * Revision History:
 *		$Log$
 *
 *****************************************************************************/
