/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright (c) 2005-2007 V.Sokur
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

/*
 * _Qlrtab.h	(N.Panasiuk)
 * include/Bo/services/alg/textan/_Qlrtab.h
 *
 * $Id$
 */

/* ------------------------------------------------------------------------- */

#ifndef __BO_SERVICES_ALG_TEXTAN__QLRTAB__
# define __BO_SERVICES_ALG_TEXTAN__QLRTAB__

/******************************************************************************
 * %% BeginSection: includes
 */

# include <Bo/services/textan/LrtabP.h>

/******************************************************************************
 * %% BeginSection: type declarations
 */
# pragma mark -
# pragma mark [ type declarations ]
# pragma mark -

/*
 * Qlrtab
 *
 * lrtab
 * oid: <<category>>/<<service>>/<<domain>>/<<impl>>
 */
/*
# define AorpK_Qlrtab_opdom (1405)
# define AorpK_Qlrtab_opdom_empty 0
 */
# include <Bo/services/MIB/Opdom.h>

# define __aorpc_ns_protocol_c 2
# define __aorpc_ns_protocol (lrtab,Qlrtab)
# include <Bo/aorp/AorpCproi.h>

_A_protocol_init(lrtab,Qlrtab)
{
	_A_hbdecl_;

	unsigned long  start_state;
	unsigned long  state_max;
	unsigned long  token_max;
	unsigned long  symbol_max;
	unsigned long  rule_max;

	short          lr_tabelem;
	bo_pointer_t   lr_table;

	short          rrhslen_tabelem;
	bo_pointer_t   rrhslen_table;

	short          rlhs_tabelem;
	bo_pointer_t   rlhs_table;

	short          ract_tabelem;
	bo_pointer_t   ract_table;
}
_A_end;

# include <Bo/aorp/AorpCend.h>

#endif /* !__BO_SERVICES_ALG_TEXTAN__QLRTAB__ */

/******************************************************************************
 * Revision History:
 *		$Log$
 *
 *****************************************************************************/
