/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright (c) 2005-2007 V.Sokur
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

/*
 * _QlrtabdefsI.h	(N.Panasiuk)
 * include/Bo/services/alg/textan/_QlrtabdefsI.h
 *
 * $Id$
 */

/* ------------------------------------------------------------------------- */

#ifndef __BO_SERVICES_ALG_TEXTAN__QLRTABDEFS_I__
# define __BO_SERVICES_ALG_TEXTAN__QLRTABDEFS_I__

/******************************************************************************
 * %% BeginSection: type declarations
 */
# pragma mark -
# pragma mark [ type declarations ]
# pragma mark -

# define _QLRTAB_GUTS \
	unsigned long  qlrt_start_state; \
	unsigned long  qlrt_state_max;  /* maximum state value */ \
	unsigned long  qlrt_token_max;  /* maximum token value */ \
	unsigned long  qlrt_symbol_max; /* maximum symbol value */ \
	unsigned long  qlrt_rule_max;   /* maximum rule value */ \
	short          qlrt_lr_tabelem; \
	bo_pointer_t   qlrt_lr_table; \
	short          qlrt_rrhslen_tabelem; \
	bo_pointer_t   qlrt_rrhslen_table; \
	short          qlrt_rlhs_tabelem; \
	bo_pointer_t   qlrt_rlhs_table; \
	short          qlrt_ract_tabelem; \
	bo_pointer_t   qlrt_ract_table

#endif /* !__BO_SERVICES_ALG_TEXTAN__QLRTABDEFS_I__ */

/******************************************************************************
 * Revision History:
 *		$Log$
 *
 *****************************************************************************/
