/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright (c) 2005-2007 V.Sokur
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

/*
 * Ctnrop.h	(V.Sokur)
 * include/Bo/services/basis/Ctnrop.h
 *
 * $Id$
 */

/* ------------------------------------------------------------------------- */

#ifndef __BO_SERVICES_BASIS_CTNR_OP__
# define __BO_SERVICES_BASIS_CTNR_OP__

/******************************************************************************
 * %% BeginSection: constant declarations
 */
# pragma mark -
# pragma mark [ constant declarations ]
# pragma mark -

# define AorpK_container_count (4)
# define AorpK_container_maxcount (5)
# define AorpK_container_clear (6)

# define AorpK_container_opencrsr (7)
# define AorpK_container_closecrsr (8)
# define AorpK_container_advancecrsr (9)
# define AorpK_container_getbycrsr (10)

# define AorpK_container_rdlock (11)
# define AorpK_container_wrlock (12)
# define AorpK_container_unlock (13)

# define AorpK_container_at (14)       /* result: element */
# define AorpK_container_at_nlk (15)   /* result: element */
# define AorpK_container_find (16)     /* result: cursor, cursor should be opened */
# define AorpK_container_find_nlk (17) /* result: cursor, cursor should be opened */
# define AorpK_container_insert (18)
# define AorpK_container_insert_nlk (19)
# define AorpK_container_remove (20)
# define AorpK_container_remove_nlk (21)
# define AorpK_container_delete (22)
# define AorpK_container_delete_nlk (23)

# define AorpK_container_foreach (24)
# define AorpK_container_foreach_nlk (25)

# define AorpK_container_set (26)
# define AorpK_container_set_nlk (27)
# define AorpK_container_count_nlk (28)			//	@note: MaxL

# define AorpK_container_opc (29)

#endif /* !__BO_SERVICES_BASIS_CTNR_OP__ */

/******************************************************************************
 * Revision History:
 *		$Log$
 *
 *****************************************************************************/
