/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright (c) 2005-2007 V.Sokur
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

/*
 * Ctnrtypes.h	(V.Sokur)
 * include/Bo/services/basis/Ctnrtypes.h
 *
 * $Id$
 */

/* ------------------------------------------------------------------------- */

#ifndef __BO_SERVICES_BASIS_CTNRTYPES__
# define __BO_SERVICES_BASIS_CTNRTYPES__

/******************************************************************************
 * %% BeginSection: includes
 */

# include <Bo/sys/Types.h>

# include <Bo/libc/Limits.h>
	/* BoL_INDEX_MIN, BoL_INDEX_MAX */

/******************************************************************************
 * %% BeginSection: type/constant declarations
 */
# pragma mark -
# pragma mark [ type/constant declarations ]
# pragma mark -

/*
 * limits
 */
# define AorpL_CTNR_SIZE_MAX (BoL_INDEX_MAX - 8)

/*
 * container category
 */

# define AorpK_NULL_CTNR 0
# define AorpK_UNK_CTNR 2
# define AorpK_ARRAY_CTNR 3
# define AorpK_LIST_CTNR 4
# define AorpK_DICARR_CTNR 5 /* dictionary on array */
# define AorpK_DICLIS_CTNR 6 /* dictionary on list */
# define AorpK_DICTRE_CTNR 7 /* dictionary on btree */
# define AorpK_OLIS_CTNR 8 /* order list */

/*
 * data category of an element type of an container
 */

# define AorpK_CTNR_NULL_DATA 0
# define AorpK_CTNR_UNK_DATA 2

# define AorpK_CTNR_UDVARIANT_DATA 3
# define AORP_CTNR_UDVARIANT_DATA udvariant
# define _AORP_CTNR_UDVARIANT_DATA "udvariant"

# define AorpK_CTNR_OBJECT_DATA 4
# define AORP_CTNR_OBJECT_DATA object
# define _AORP_CTNR_OBJECT_DATA "object"

#endif /* !__BO_SERVICES_BASIS_CTNRTYPES__ */

/******************************************************************************
 * Revision History:
 *		$Log$
 *
 *****************************************************************************/
