/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright (c) 2005-2007 V.Sokur
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

/*
 * Cryptop.h	(V.Sokur)
 * include/Bo/services/crypt/Cryptop.h
 *
 * $Id$
 */

/* ------------------------------------------------------------------------- */

#ifndef __BO_SERVICES_CRYPT_CRYPT_OP__
# define __BO_SERVICES_CRYPT_CRYPT_OP__

/******************************************************************************
 * %% BeginSection: constant declarations
 */
# pragma mark -
# pragma mark [ constant declarations ]
# pragma mark -

/*
 * crypt {\object(class)}
 */
/*
# define AorpK_crypt_service (1130)
# define AorpK_crypt_service_subclassable 0
 */
# include <Bo/services/MIB/Services.h>

# define AorpK_crypt_openalg (4)
# define AorpK_crypt_closealg (5)
# define AorpK_crypt_opc (6)

# pragma mark -

/*
 * cryptal {\ops}
 */
/*
# define AorpK_cryptal_service (1131)
# define AorpK_cryptal_service_subclassable 1
 */

# define AorpK_cryptal_initctx (4)
# define AorpK_cryptal_destroyctx (5)
# define AorpK_cryptal_encrypt (6)
# define AorpK_cryptal_decrypt (7)
# define AorpK_cryptal_encrypt_inplace (8)
# define AorpK_cryptal_decrypt_inplace (9)
# define AorpK_cryptal_encrypt_mem (10)
# define AorpK_cryptal_decrypt_mem (11)
# define AorpK_cryptal_block_size (12)
# define AorpK_cryptal_keylen (13)

# define AorpK_cryptal_opc (14)

#endif /* !__BO_SERVICES_CRYPT_CRYPT_OP__ */

/******************************************************************************
 * Revision History:
 *		$Log$
 *
 *****************************************************************************/
