/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright (c) 2005-2007 V.Sokur
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

/*
 * Plio.h	(N.Panasiuk)
 * include/Bo/services/hilis/Plio.h
 *
 * $Id$
 */

/* ------------------------------------------------------------------------- */

#ifndef __BO_SERVICES_HILIS_PLIO__
# define __BO_SERVICES_HILIS_PLIO__

/******************************************************************************
 * %% BeginSection: includes
 */

# include <Bo/services/hilis/PlioP.h>

/******************************************************************************
 * %% BeginSection: function prototypes
 */
# pragma mark -
# pragma mark [ function prototypes ]
# pragma mark -

# include <Bo/BoLinkage.h>

__MYC_BEGIN_CDECLS

__myc_vlinkage__(public,libBo) aorp_object_t _G_plio_service_default;

/* ============================================================================
 * PLIST-DOCUMENT-OPERATIONS
 */
# pragma mark -
# pragma mark +++ plist-document-operations +++
# pragma mark -

__myc_flinkage__(public,libBo) aorp_object_t
AorpPLDScan(
# if __myc_require(prototypes)
	aorp_object_t aSelf /* = NULL */,
	struct aorp_plist_scaner *aScaner,          /* scaner */
	struct aorp_plist_options const *Options,   /* options */
	struct aorp_error *anErrPtr __myc_defval__(NULL)
# endif
	);

__myc_flinkage__(public,libBo) aorp_object_t
AorpPLDFscan(
# if __myc_require(prototypes)
	aorp_object_t aSelf /* = NULL */,
	struct aorp_uri const *anAbsolutePath,      /* absolute-path */
	struct aorp_plist_options const *Options,   /* options */
	struct aorp_error *anErrPtr __myc_defval__(NULL)
# endif
	);

__myc_flinkage__(public,libBo) aorp_object_t
AorpPLDFscan_p(
# if __myc_require(prototypes)
	aorp_object_t aSelf /* = NULL */,
	char const *anAbsolutePath,                 /* absolute-path */
	struct aorp_plist_options const *Options,   /* options */
	struct aorp_error *anErrPtr __myc_defval__(NULL)
# endif
	);

__myc_flinkage__(public,libBo) aorp_object_t
AorpPLDFscan_wp(
# if __myc_require(prototypes)
	aorp_object_t aSelf /* = NULL */,
	wchar_t const *anAbsolutePath,              /* absolute-path */
	struct aorp_plist_options const *Options,   /* options */
	struct aorp_error *anErrPtr __myc_defval__(NULL)
# endif
	);

__myc_flinkage__(public,libBo) aorp_object_t
AorpPLDSscan(
# if __myc_require(prototypes)
	aorp_object_t aSelf /* = NULL */,
	char const *aText,                          /* text */
	struct aorp_plist_options const *Options,   /* options */
	struct aorp_error *anErrPtr __myc_defval__(NULL)
# endif
	);

/* ------------------------------------------------------------------------- */
# pragma mark -
/* ------------------------------------------------------------------------- */

__myc_flinkage__(public,libBo) ssize_t
AorpPLDPrint(
# if __myc_require(prototypes)
	aorp_object_t aSelf /* = NULL */,
	struct aorp_plist_printer *aPrinter,        /* printer */
	struct aorp_plist_options const *Options,   /* options */
	aorp_object_t aRoot,
	struct aorp_error *anErrPtr __myc_defval__(NULL)
# endif
	);

__myc_flinkage__(public,libBo) ssize_t
AorpPLDSprint(
# if __myc_require(prototypes)
	aorp_object_t aSelf /* = NULL */,
	aorp_object_t aStream,                      /* stream */
	struct aorp_plist_options const *Options,   /* options */
	aorp_object_t aRoot,
	struct aorp_error *anErrPtr __myc_defval__(NULL)
# endif
	);

__myc_flinkage__(public,libBo) ssize_t
AorpPLDFprint(
# if __myc_require(prototypes)
	aorp_object_t aSelf /* = NULL */,
	struct bo_uri const *aPath,                 /* path */
	struct aorp_plist_options const *Options,   /* options */
	aorp_object_t aRoot,
	struct aorp_error *anErrPtr __myc_defval__(NULL)
# endif
	);

__myc_flinkage__(public,libBo) ssize_t
AorpPLDFprint_p(
# if __myc_require(prototypes)
	aorp_object_t aSelf /* = NULL */,
	char const *aPath,                          /* path */
	struct aorp_plist_options const *Options,   /* options */
	aorp_object_t aRoot,
	struct aorp_error *anErrPtr __myc_defval__(NULL)
# endif
	);

__myc_flinkage__(public,libBo) ssize_t
AorpPLDFprint_wp(
# if __myc_require(prototypes)
	aorp_object_t aSelf /* = NULL */,
	wchar_t const *aPath,                       /* path */
	struct aorp_plist_options const *Options,   /* options */
	aorp_object_t aRoot,
	struct aorp_error *anErrPtr __myc_defval__(NULL)
# endif
	);

/* ============================================================================
 * PLIST-NODE-OPERATIONS
 */
# pragma mark -
# pragma mark +++ plist-node-operations +++
# pragma mark -

# define AorpPLNScan(aSelf, aScaner,Options,anErrPtr) \
	AorpPLNScan2(aSelf, aScaner, Options, NULL, NULL, anErrPtr)

# define AorpPLNFscan(aSelf, aPath,Options,anErrPtr) \
	AorpPLNFscan2(aSelf, aPath, Options, NULL, NULL, anErrPtr)

# define AorpPLNFscan_p(aSelf, aPath,Options,anErrPtr) \
	AorpPLNFscan2_p(aSelf, aPath, Options, NULL, NULL, anErrPtr)

# define AorpPLNFscan_wp(aSelf, aPath,Options,anErrPtr) \
	AorpPLNFscan2_wp(aSelf, aPath, Options, NULL, NULL, anErrPtr)

# define AorpPLNSscan(aSelf, aText,aBytec,Options,anErrPtr) \
	AorpPLNSscan2(aSelf, aText, aBytec, Options, NULL, NULL, anErrPtr)

__myc_flinkage__(public,libBo) aorp_object_t
AorpPLNScan2(
# if __myc_require(prototypes)
	aorp_object_t aSelf /* = NULL */,
	struct aorp_plist_scaner *aScaner,          /* scaner */
	struct aorp_plist_options const *Options,   /* options */
	aorp_object_t aTop __myc_defval__(NULL),
	aorp_object_t aCur __myc_defval__(NULL),
	struct aorp_error *anErrPtr __myc_defval__(NULL)
# endif
	);

__myc_flinkage__(public,libBo) aorp_object_t
AorpPLNFscan2(
# if __myc_require(prototypes)
	aorp_object_t aSelf /* = NULL */,
	struct aorp_uri const *anAbsolutePath,      /* absolute-path */
	struct aorp_plist_options const *Options,   /* options */
	aorp_object_t aTop __myc_defval__(NULL),
	aorp_object_t aCur __myc_defval__(NULL),
	struct aorp_error *anErrPtr __myc_defval__(NULL)
# endif
	);

__myc_flinkage__(public,libBo) aorp_object_t
AorpPLNFscan2_p(
# if __myc_require(prototypes)
	aorp_object_t aSelf /* = NULL */,
	char const *anAbsolutePath,                 /* absolute-path */
	struct aorp_plist_options const *Options,   /* options */
	aorp_object_t aTop __myc_defval__(NULL),
	aorp_object_t aCur __myc_defval__(NULL),
	struct aorp_error *anErrPtr __myc_defval__(NULL)
# endif
	);

__myc_flinkage__(public,libBo) aorp_object_t
AorpPLNFscan2_wp(
# if __myc_require(prototypes)
	aorp_object_t aSelf /* = NULL */,
	wchar_t const *anAbsolutePath,              /* absolute-path */
	struct aorp_plist_options const *Options,   /* options */
	aorp_object_t aTop __myc_defval__(NULL),
	aorp_object_t aCur __myc_defval__(NULL),
	struct aorp_error *anErrPtr __myc_defval__(NULL)
# endif
	);

__myc_flinkage__(public,libBo) aorp_object_t
AorpPLNSscan2(
# if __myc_require(prototypes)
	aorp_object_t aSelf /* = NULL */,
	size_t aBytec,
	char const *aText,                          /* text */
	struct aorp_plist_options const *Options,   /* options */
	aorp_object_t aTop __myc_defval__(NULL),
	aorp_object_t aCur __myc_defval__(NULL),
	struct aorp_error *anErrPtr __myc_defval__(NULL)
# endif
	);

/* ------------------------------------------------------------------------- */
# pragma mark -
/* ------------------------------------------------------------------------- */

__myc_flinkage__(public,libBo) ssize_t
AorpPLNPrint(
# if __myc_require(prototypes)
	aorp_object_t aSelf /* = NULL */,
	struct aorp_plist_printer *aPrinter,        /* printer */
	struct aorp_plist_options const *Options,   /* options */
	aorp_object_t aNode,                        /* plist-node */
	struct aorp_error *anErrPtr __myc_defval__(NULL)
# endif
	);

__myc_flinkage__(public,libBo) ssize_t
AorpPLNSprint(
# if __myc_require(prototypes)
	aorp_object_t aSelf /* = NULL */,
	aorp_object_t aStream,                      /* stream */
	struct aorp_plist_options const *Options,   /* options */
	aorp_object_t aNode,                        /* plist-node */
	struct aorp_error *anErrPtr __myc_defval__(NULL)
# endif
	);

__myc_flinkage__(public,libBo) ssize_t
AorpPLNFprint(
# if __myc_require(prototypes)
	aorp_object_t aSelf /* = NULL */,
	struct aorp_uri const *aPath,               /* path */
	struct aorp_plist_options const *Options,   /* options */
	aorp_object_t aNode,                        /* plist-node */
	struct aorp_error *anErrPtr __myc_defval__(NULL)
# endif
	);

__myc_flinkage__(public,libBo) ssize_t
AorpPLNFprint_p(
# if __myc_require(prototypes)
	aorp_object_t aSelf /* = NULL */,
	char const *aPath,                          /* path */
	struct aorp_plist_options const *Options,   /* options */
	aorp_object_t aNode,                        /* plist-node */
	struct aorp_error *anErrPtr __myc_defval__(NULL)
# endif
	);

__myc_flinkage__(public,libBo) ssize_t
AorpPLNFprint_wp(
# if __myc_require(prototypes)
	aorp_object_t aSelf /* = NULL */,
	wchar_t const *aPath,                       /* path */
	struct aorp_plist_options const *Options,   /* options */
	aorp_object_t aNode,                        /* plist-node */
	struct aorp_error *anErrPtr __myc_defval__(NULL)
# endif
	);

__MYC_END_CDECLS

#endif /* !__BO_SERVICES_HILIS_PLIO__ */

/******************************************************************************
 * Revision History:
 *		$Log$
 *
 *****************************************************************************/
