/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright (c) 2005-2007 V.Sokur
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

/*
 * PlistP.h	(N.Panasiuk)
 * include/Bo/services/plist/PlistP.h
 *
 * $Id$
 */

/* ------------------------------------------------------------------------- */

#ifndef __BO_SERVICES_PLIST_PLIST_P__
# define __BO_SERVICES_PLIST_PLIST_P__

/******************************************************************************
 * %% BeginSection: includes
 */

# include <Bo/services/plist/Pltypes.h>

/******************************************************************************
 * %% BeginSection: plist service declarations
 */
# pragma mark -
# pragma mark [ plist service declarations ]
# pragma mark -

/*
 * plist service
 * @{
 */

# include <Bo/services/plist/Plistop.h>
# include <Bo/aorp/StdopP.h>

# define __aorpc_decl __aorpc_decl_service
# define __aorpc_service_name plist
# include <Bo/aorp/AorpC.h>

_A_service(plist)

# define AORP_plist_init_once AORP_any_init_once
# define AORP_plist_init_once_signature AORP_any_init_once_signature
# define AORP_plist_fini_once AORP_any_fini_once
# define AORP_plist_fini_once_signature AORP_any_fini_once_signature
# define AORP_plist_pod_init AORP_any_pod_init
# define AORP_plist_pod_init_signature AORP_any_pod_init_signature
# define AORP_plist_pod_fini AORP_any_pod_fini
# define AORP_plist_pod_fini_signature AORP_any_pod_fini_signature

_A_op(insert, (
		struct aorp_closure *aClosure,
		struct aorp_error *anErrPtr,
		aorp_object_t aStartNode,
		char const *aToParentPath,
		aorp_object_t aNode
	)) __attribute__((nonnull(1,5)));

# define AORP_plist_insert "insert"
# define AORP_plist_insert_signature AORP_STD_SIGNATURE \
	" " _AORP_SIGN_POINTER \
	" " _AORP_SIGN_CSTRING \
	" " _AORP_SIGN_POINTER

_A_op(remove, (
		struct aorp_closure *aClosure,
		struct aorp_error *anErrPtr,
		aorp_object_t aStartNode,
		char const *aPath,
		aorp_opflags_t Flags,
		aorp_object_t *aResultPtr
	)) __attribute__((nonnull(1,6)));

# define AORP_plist_remove "remove"
# define AORP_plist_remove_signature AORP_STD_SIGNATURE \
	" " _AORP_SIGN_POINTER \
	" " _AORP_SIGN_CSTRING \
	" " _AORP_SIGN_FLAGS_T \
	" " _AORP_SMOD_POINTER _AORP_SIGN_POINTER

_A_op(delete, (
		struct aorp_closure *aClosure,
		struct aorp_error *anErrPtr,
		aorp_object_t aStartNode,
		char const *aPath,
		aorp_opflags_t Flags
	)) __attribute__((nonnull(1)));

# define AORP_plist_delete "delete"
# define AORP_plist_delete_signature AORP_STD_SIGNATURE \
	" " _AORP_SIGN_POINTER \
	" " _AORP_SIGN_CSTRING \
	" " _AORP_SIGN_FLAGS_T

_A_op(move, (
		struct aorp_closure *aClosure,
		struct aorp_error *anErrPtr,
		aorp_object_t aStartNode,
		char const *aFromPath,
		char const *aToParentPath
	)) __attribute__((nonnull(1)));

# define AORP_plist_move "move"
# define AORP_plist_move_signature AORP_STD_SIGNATURE \
	" " _AORP_SIGN_POINTER \
	" " _AORP_SIGN_CSTRING \
	" " _AORP_SIGN_CSTRING

_A_op(copy, (
		struct aorp_closure *aClosure,
		struct aorp_error *anErrPtr,
		aorp_object_t aStartNode,
		char const *aFromPath,
		char const *aToParentPath
	)) __attribute__((nonnull(1)));

# define AORP_plist_copy "copy"
# define AORP_plist_copy_signature AORP_STD_SIGNATURE \
	" " _AORP_SIGN_POINTER \
	" " _AORP_SIGN_CSTRING \
	" " _AORP_SIGN_CSTRING

_A_op(get, (
		struct aorp_closure *aClosure,
		struct aorp_error *anErrPtr,
		aorp_object_t aStartNode,
		char const *aPath,
		aorp_opflags_t Flags,
		aorp_object_t *aResultPtr
	)) __attribute__((nonnull(1,6)));

# define AORP_plist_get "get"
# define AORP_plist_get_signature AORP_STD_SIGNATURE \
	" " _AORP_SIGN_POINTER \
	" " _AORP_SIGN_CSTRING \
	" " _AORP_SIGN_FLAGS_T \
	" " _AORP_SIGN_POINTER

_A_op(link, (
		struct aorp_closure *aClosure,
		struct aorp_error *anErrPtr
		aorp_object_t aStartNode,
		char const *aPath,
		char const *aTarget,
		aorp_object_t *aResultPtr
	)) __attribute__((nonnull(1,5)));

# define AORP_plist_link "link"
# define AORP_plist_link_signature AORP_STD_SIGNATURE \
	" " _AORP_SIGN_POINTER \
	" " _AORP_SIGN_CSTRING \
	" " _AORP_SIGN_CSTRING \
	" " _AORP_SMOD_POINTER _AORP_SIGN_POINTER

_A_end;

# include <Bo/aorp/AorpCend.h>

/* @} */

#endif /* !__BO_SERVICES_PLIST_PLIST_P__ */

/******************************************************************************
 * Revision History:
 *		$Log$
 *
 *****************************************************************************/
