/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright (c) 2005-2007 V.Sokur
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

/*
 * Plmount.h	(N.Panasiuk)
 * include/Bo/services/plist/Plmount.h
 *
 * $Id$
 */

/* ------------------------------------------------------------------------- */

#ifndef __BO_SERVICES_PLIST_PLMOUNT__
# define __BO_SERVICES_PLIST_PLMOUNT__

/******************************************************************************
 * %% BeginSection: includes
 */

# include <Bo/services/plist/Pltypes.h>

/******************************************************************************
 * %% BeginSection: type/constant declarations
 */
# pragma mark -
# pragma mark [ type/constant declarations ]
# pragma mark -

# include <Bo/services/plist/Plmountop.h>

/******************************************************************************
 * %% BeginSection: function prototypes
 */
# pragma mark -
# pragma mark [ function prototypes ]
# pragma mark -

# include <Bo/aorp/Runtime.h>

__MYC_BEGIN_CDECLS

/*
bo_status_t
__attribute__((nonnull(4)))
AorpPlmountMount(
	aorp_object_t aRoot, // = NULL
	aorp_object_t aStartNode, // = NULL
	aorp_object_t aMounted,
	char const *aMountPoint,
	struct aorp_error *anErrPtr
	);
 */
# define AorpPlmountMount(aRoot, aStartNode, aMounted, aMountPoint, anErrPtr) \
	_A_call(mount, plmount, ((aRoot) ? (aRoot) : (aStartNode)), anErrPtr, \
		aStartNode, aMounted, aMountPoint)

# pragma mark -

/*
bo_status_t
__attribute__((nonnull(4)))
AorpPlmountUmount(
	aorp_object_t aRoot, // = NULL
	aorp_object_t aStartNode, // = NULL
	char const *aMountPoint,
	aorp_object_t *aResultPtr,
	struct aorp_error *anErrPtr
	);
 */
# define AorpPlmountUmount(aRoot, aStartNode, aMountPoint, aResultPtr, anErrPtr) \
	_A_call(umount, plmount, ((aRoot) ? (aRoot) : (aStartNode)), anErrPtr, aStartNode, aMountPoint, aResultPtr)

#if 0
/* ============================================================================
 * PLIST-NODE-OPERATIONS
 */
# pragma mark -
# pragma mark +++ plist-node-operations +++
# pragma mark -

/*
bo_status_t
__attribute__((nonnull(1,2)))
AorpPLNMount(
	aorp_object_t aMountPoint,
	aorp_object_t aMounted,
	struct aorp_error *anErrPtr
	);
 */
# define AorpPLNMount(aMountPoint, aMounted, anErrPtr) \
	_A_call(pln_mount, plmount, aMountPoint, anErrPtr, aMounted)

# pragma mark -

/*
bo_status_t
__attribute__((nonnull(1,2)))
AorpPLNUmount(
	aorp_object_t aMountPoint,
	aorp_object_t *aResultPtr,
	struct aorp_error *anErrPtr
	);
 */
# define AorpPLNUmount(aMountPoint, aResultPtr, anErrPtr) \
	_A_call(pln_umount, plmount, aMountPoint, anErrPtr, aResultPtr)

# pragma mark -

/*
bo_status_t
__attribute__((nonnull(1)))
AorpPLNIsMountpoint(
	aorp_object_t aNode,
	struct aorp_error *anErrPtr
	);
 */
# define AorpPLNIsMountpoint(aNode, anErrPtr) \
	_A_call(pln_ismountpoint, plmount, aNode, anErrPtr)

# pragma mark -

/*
bo_status_t
__attribute__((nonnull(1)))
AorpPLNIsMounted(
	aorp_object_t aNode,
	struct aorp_error *anErrPtr
	);
 */
# define AorpPLNIsMounted(aNode, anErrPtr) \
	_A_call(pln_ismounted, plmount, aNode, anErrPtr)

# pragma mark -

/*
bo_status_t
__attribute__((nonnull(1)))
AorpPLNMountedRoot(
	aorp_object_t aMountpoint,
	aorp_object_t *aResultPtr,
	struct aorp_error *anErrPtr
	);
 */
# define AorpPLNMountedRoot(aMountpoint, aResultPtr, anErrPtr) \
	_A_call(pln_mountedroot, plmount, aMountpoint, anErrPtr, aResultPtr)

# pragma mark -

/*
bo_status_t
__attribute__((nonnull(1)))
AorpPLNMountedRoot1(
	aorp_object_t aMountpoint,
	aorp_object_t *aResultPtr,
	struct aorp_error *anErrPtr
	);
 */
# define AorpPLNMountedRoot1(aMountpoint, aResultPtr, anErrPtr) \
	_A_call(pln_mountedroot1, plmount, aMountpoint, anErrPtr, aResultPtr)

# pragma mark -

/*
bo_status_t
__attribute__((nonnull(1)))
AorpPLNMountpointRoot(
	aorp_object_t aMounted,
	aorp_object_t *aResultPtr,
	struct aorp_error *anErrPtr
	);
 */
# define AorpPLNMountpointRoot(aMounted, aResultPtr, anErrPtr) \
	_A_call(pln_mountpointroot, plmount, aMounted, anErrPtr, aResultPtr)

# pragma mark -

/*
bo_status_t
__attribute__((nonnull(1)))
AorpPLNMountpointRoot1(
	aorp_object_t aMounted,
	aorp_object_t *aResultPtr,
	struct aorp_error *anErrPtr
	);
 */
# define AorpPLNMountpointRoot1(aMounted, aResultPtr, anErrPtr) \
	_A_call(pln_mountpointroot1, plmount, aMounted, anErrPtr, aResultPtr)
#endif

__MYC_END_CDECLS

#endif /* !__BO_SERVICES_PLIST_PLMOUNT__ */

/******************************************************************************
 * Revision History:
 *		$Log$
 *
 *****************************************************************************/
