/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright (c) 2005-2007 V.Sokur
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

/*
 * PlmountP.h	(N.Panasiuk)
 * include/Bo/services/plist/PlmountP.h
 *
 * $Id$
 */

/* ------------------------------------------------------------------------- */

#ifndef __BO_SERVICES_PLIST_PLMOUNT_P__
# define __BO_SERVICES_PLIST_PLMOUNT_P__

/******************************************************************************
 * %% BeginSection: includes
 */

# include <Bo/services/plist/Pltypes.h>

/******************************************************************************
 * %% BeginSection: plmount service declarations
 */
# pragma mark -
# pragma mark [ plmount service declarations ]
# pragma mark -

/*
 * plmount service
 * @{
 */

# include <Bo/services/plist/Plmountop.h>
# include <Bo/aorp/StdopP.h>

# define __aorpc_decl __aorpc_decl_service
# define __aorpc_service_name plmount
# include <Bo/aorp/AorpC.h>

_A_service(plmount)

# define AORP_plmount_init_once AORP_any_init_once
# define AORP_plmount_init_once_signature AORP_any_init_once_signature
# define AORP_plmount_fini_once AORP_any_fini_once
# define AORP_plmount_fini_once_signature AORP_any_fini_once_signature
# define AORP_plmount_pod_init AORP_any_pod_init
# define AORP_plmount_pod_init_signature AORP_any_pod_init_signature
# define AORP_plmount_pod_fini AORP_any_pod_fini
# define AORP_plmount_pod_fini_signature AORP_any_pod_fini_signature

_A_op(mount, (
		struct aorp_closure *aClosure,
		struct aorp_error *anErrPtr,
		aorp_object_t aStartNode,
		aorp_object_t aMounted,
		char const *aMountPoint
	)) __attribute__((nonnull(1,5)));

# define AORP_plmount_mount "mount"
# define AORP_plmount_mount_signature AORP_STD_SIGNATURE \
	" " _AORP_SIGN_POINTER \
	" " _AORP_SIGN_POINTER \
	" " _AORP_SIGN_CSTRING

_A_op(umount, (
		struct aorp_closure *aClosure,
		struct aorp_error *anErrPtr,
		aorp_object_t aStartNode,
		char const *aMountPoint,
		aorp_object_t *aResultPtr
	)) __attribute__((nonnull(1,4)));

# define AORP_plmount_umount "unmount"
# define AORP_plmount_umount_signature AORP_STD_SIGNATURE \
	" " _AORP_SIGN_POINTER \
	" " _AORP_SIGN_CSTRING \
	" " _AORP_SMOD_POINTER _AORP_SIGN_POINTER

_A_end;

# include <Bo/aorp/AorpCend.h>

/* @} */

#endif /* !__BO_SERVICES_PLIST_PLMOUNT_P__ */

/******************************************************************************
 * Revision History:
 *		$Log$
 *
 *****************************************************************************/
