/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright (c) 2005-2007 V.Sokur
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

/*
 * Plnodeop.h	(N.Panasiuk)
 * include/Bo/services/plist/Plnodeop.h
 *
 * $Id$
 */

/* ------------------------------------------------------------------------- */

#ifndef __BO_SERVICES_PLIST_PLNODE_OP__
# define __BO_SERVICES_PLIST_PLNODE_OP__

/******************************************************************************
 * %% BeginSection: constant declarations
 */
# pragma mark -
# pragma mark [ constant declarations ]
# pragma mark -

/*
 * plnode {\object(instance)}
 */
/*
# define AorpK_plnode_service (1075)
# define AorpK_plnode_service_subclassable 0
 */
# include <Bo/services/MIB/Services.h>

# define AorpK_plnode_stat (4)
# define AorpK_plnode_cntl (5)

# define AorpK_plnode_read (6)
# define AorpK_plnode_readbyindex (7)
# define AorpK_plnode_write (8)
# define AorpK_plnode_writebyindex (9)

# define AorpK_plnode_count (10)

# define AorpK_plnode_insert (11)
# define AorpK_plnode_remove (12)
# define AorpK_plnode_delete (13)
# define AorpK_plnode_find (14)
# define AorpK_plnode_foreach (15)

# define AorpK_plnode_insert_crsr (16)
# define AorpK_plnode_remove_crsr (17)
# define AorpK_plnode_delete_crsr (18)
# define AorpK_plnode_find_crsr (19)
# define AorpK_plnode_foreach_crsr (20)
# define AorpK_plnode_getpos (21)

# define AorpK_plnode_opencrsr (22)
# define AorpK_plnode_closecrsr (23)
# define AorpK_plnode_advancecrsr (24)
# define AorpK_plnode_getbycrsr (25)

# define AorpK_plnode_walk (26)
# define AorpK_plnode_lookup (27)

# define AorpK_plnode_opc (28)

#endif /* !__BO_SERVICES_PLIST_PLNODE_OP__ */

/******************************************************************************
 * Revision History:
 *		$Log$
 *
 *****************************************************************************/
