/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright (c) 2005-2007 V.Sokur
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

/*
 * Plstat.h	(N.Panasiuk)
 * include/Bo/services/hilis/Plstat.h
 *
 * $Id$
 */

/* ------------------------------------------------------------------------- */

#ifndef __BO_SERVICES_HILIS_PLSTAT__
# define __BO_SERVICES_HILIS_PLSTAT__

/******************************************************************************
 * %% BeginSection: includes
 */

# include <Bo/services/hilis/PlstatP.h>

/******************************************************************************
 * %% BeginSection: function prototypes
 */
# pragma mark -
# pragma mark [ function prototypes ]
# pragma mark -

# include <Bo/BoLinkage.h>

__MYC_BEGIN_CDECLS

__myc_vlinkage__(public,libBo) aorp_object_t _G_plstat_service_default;

/* ------------------------------------------------------------------------- */
# pragma mark -
/* ------------------------------------------------------------------------- */

__myc_flinkage__(public,libBo) bo_status_t
AorpPlstatStat(
# if __myc_require(prototypes)
	aorp_object_t aSelf /* = NULL */,
	aorp_object_t aRoot /* = NULL */,
	aorp_object_t aStartNode /* = NULL */,
	char const *aPath,
	aorp_opflags_t Flags,
	struct aorp_plist_stat *aStatPtr,
	struct aorp_error *anErrPtr __myc_defval__(NULL)
# endif
	);

__myc_flinkage__(public,libBo) aorp_object_t
AorpPlstatMkcomm(
# if __myc_require(prototypes)
	aorp_object_t aSelf /* = NULL */,
	aorp_object_t aRoot /* = NULL */,
	aorp_object_t aStartNode /* = NULL */,
	char const *aToParentPath,
	char const *aData,
	size_t aBytec __myc_defval__(-1), /* -1 means that the data len should be calculated */
	int aCommStyle __myc_defval__(AorpK_PL_CCOMM_STYLE),
	struct aorp_error *anErrPtr __myc_defval__(NULL)
# endif
	);

__myc_flinkage__(public,libBo) aorp_object_t
AorpPlstatMkvar(
# if __myc_require(prototypes)
	aorp_object_t aSelf /* = NULL */,
	aorp_object_t aRoot /* = NULL */,
	aorp_object_t aStartNode /* = NULL */,
	char const *aToParentPath,
	char const *aName,
	aorp_plist_attrlist_t *anAttrList __myc_defval__(NULL),
	char const *aValue __myc_defval__(NULL),
	int aSpecificator __myc_defval__(AorpK_PL_RAW_SPECTOR),
	struct aorp_error *anErrPtr __myc_defval__(NULL)
# endif
	);

__myc_flinkage__(public,libBo) aorp_object_t
AorpPlstatMklist(
# if __myc_require(prototypes)
	aorp_object_t aSelf /* = NULL */,
	aorp_object_t aRoot /* = NULL */,
	aorp_object_t aStartNode /* = NULL */,
	char const *aToParentPath,
	char const *aName,
	aorp_plist_attrlist_t *anAttrList __myc_defval__(NULL),
	struct aorp_error *anErrPtr __myc_defval__(NULL)
# endif
	);

__myc_flinkage__(public,libBo) aorp_object_t
AorpPlstatMklistelem(
# if __myc_require(prototypes)
	aorp_object_t aSelf /* = NULL */,
	aorp_object_t aRoot /* = NULL */,
	aorp_object_t aStartNode /* = NULL */,
	char const *aToParentPath,
	char const *aData,
	size_t aBytec __myc_defval__(-1), /* -1 means that the data len should be calculated */
	int aSpecificator __myc_defval__(AorpK_PL_RAW_SPECTOR),
	struct aorp_error *anErrPtr __myc_defval__(NULL)
# endif
	);

__myc_flinkage__(public,libBo) aorp_object_t
AorpPlstatMktuple(
# if __myc_require(prototypes)
	aorp_object_t aSelf /* = NULL */,
	aorp_object_t aRoot /* = NULL */,
	aorp_object_t aStartNode /* = NULL */,
	char const *aToParentPath,
	char const *aName,
	aorp_plist_attrlist_t *anAttrList __myc_defval__(NULL),
	struct aorp_error *anErrPtr __myc_defval__(NULL)
# endif
	);

__myc_flinkage__(public,libBo) aorp_object_t
AorpPlstatMkdict(
# if __myc_require(prototypes)
	aorp_object_t aSelf /* = NULL */,
	aorp_object_t aRoot /* = NULL */,
	aorp_object_t aStartNode /* = NULL */,
	char const *aToParentPath,
	char const *aName,
	aorp_plist_attrlist_t *anAttrList __myc_defval__(NULL),
	struct aorp_error *anErrPtr __myc_defval__(NULL)
# endif
	);

__myc_flinkage__(public,libBo) aorp_object_t
AorpPlstatMkdoc(
# if __myc_require(prototypes)
	aorp_object_t aSelf /* = NULL */,
	aorp_object_t aRoot /* = NULL */,
	aorp_object_t aStartNode /* = NULL */,
	char const *aToParentPath,
	char const *aName,
	aorp_plist_attrlist_t *anAttrList __myc_defval__(NULL),
	bo_cset_t aDocEncoding __myc_defval__(AorpK_PLISTDOC_ENCODING_DEFAULT),
	bo_cset_t aRequiredEncoding __myc_defval__(AorpK_PLISTDOC_ENCODING_DEFAULT),
	aorp_object_t aFileLoc __myc_defval__(NULL),
	struct aorp_error *anErrPtr __myc_defval__(NULL)
# endif
	);

__MYC_END_CDECLS

#endif /* !__BO_SERVICES_HILIS_PLSTAT__ */

/******************************************************************************
 * Revision History:
 *		$Log$
 *
 *****************************************************************************/
