/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright (c) 2005-2007 V.Sokur
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

/*
 * PlstatP.h	(N.Panasiuk)
 * include/Bo/services/hilis/PlstatP.h
 *
 * $Id$
 */

/* ------------------------------------------------------------------------- */

#ifndef __BO_SERVICES_HILIS_PLSTAT_P__
# define __BO_SERVICES_HILIS_PLSTAT_P__

/******************************************************************************
 * %% BeginSection: includes
 */

# include <Bo/services/hilis/Pltypes.h>

/******************************************************************************
 * %% BeginSection: plstat service declarations
 */
# pragma mark -
# pragma mark [ plstat service declarations ]
# pragma mark -

# define __aorpc_need_service_plstat 1

#endif /* !__BO_SERVICES_HILIS_PLSTAT_P__ */

#pragma mark -

#if __aorpc_uses_service(plstat)
# undef __aorpc_need_service_plstat

/*
 * plstat {\object(class)}
 */
/*
# define AorpK_plstat_service (1094)
 */
# include <Bo/services/MIB/Services.h>

# define __aorpc_service_name plstat
# include <Bo/aorp/AorpCsrvc.h>

_A_service(plstat)
_A_end_ctb

	_A_attribute((nonnull(1)))
	_A_op(stat, "plstat::stat", (
			struct aorp_closure *aClosure,
			struct aorp_error *anErrPtr,
			aorp_object_t aRoot,
			aorp_object_t aStartNode,
			char const *aPath,
			aorp_opflags_t Flags,
			struct aorp_plist_stat *aStatPtr
		)),

	_A_attribute((nonnull(1)))
	_A_op(mkcomm, "plstat::make-comment", (
			struct aorp_closure *aClosure,
			struct aorp_error *anErrPtr,
			aorp_object_t aRoot,
			aorp_object_t aStartNode,
			char const *aToParentPath,
			char const *aData,
			size_t aBytec,
			int aCommStyle
		)),

	_A_attribute((nonnull(1)))
	_A_op(mkvar, "plstat::make-variable", (
			struct aorp_closure *aClosure,
			struct aorp_error *anErrPtr,
			aorp_object_t aRoot,
			aorp_object_t aStartNode,
			char const *aToParentPath,
			char const *aName,
			aorp_plist_attrlist_t *anAttrList,
			char const *aValue,
			int aSpecificator
		)),

	_A_attribute((nonnull(1)))
	_A_op(mklist, "plstat::make-list", (
			struct aorp_closure *aClosure,
			struct aorp_error *anErrPtr,
			aorp_object_t aRoot,
			aorp_object_t aStartNode,
			char const *aToParentPath,
			char const *aName,
			aorp_plist_attrlist_t *anAttrList
		)),

	_A_attribute((nonnull(1)))
	_A_op(mklistelem, "plstat::make-list-element", (
			struct aorp_closure *aClosure,
			struct aorp_error *anErrPtr,
			aorp_object_t aRoot,
			aorp_object_t aStartNode,
			char const *aToParentPath,
			char const *aData,
			size_t aBytec,
			int aSpecificator
		)),

	_A_attribute((nonnull(1)))
	_A_op(mktuple, "plstat::make-tuple", (
			struct aorp_closure *aClosure,
			struct aorp_error *anErrPtr,
			aorp_object_t aRoot,
			aorp_object_t aStartNode,
			char const *aToParentPath,
			char const *aName,
			aorp_plist_attrlist_t *anAttrList
		)),

	_A_attribute((nonnull(1)))
	_A_op(mkdict, "plstat::make-dictionary", (
			struct aorp_closure *aClosure,
			struct aorp_error *anErrPtr,
			aorp_object_t aRoot,
			aorp_object_t aStartNode,
			char const *aToParentPath,
			char const *aName,
			aorp_plist_attrlist_t *anAttrList
		)),

	_A_attribute((nonnull(1)))
	_A_op(mkdoc, "plstat::make-document", (
			struct aorp_closure *aClosure,
			struct aorp_error *anErrPtr,
			aorp_object_t aRoot,
			aorp_object_t aStartNode,
			char const *aToParentPath,
			char const *aName,
			aorp_plist_attrlist_t *anAttrList,
			bo_cset_t aDocEncoding,
			bo_cset_t aRequiredEncoding,
			aorp_object_t aFileLoc
		)),

_A_end;

# include <Bo/aorp/AorpCend.h>
/* @} */
#endif /* __aorpc_uses_service(plstat) */

/******************************************************************************
 * Revision History:
 *		$Log$
 *
 *****************************************************************************/
