/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright (c) 2005-2007 V.Sokur
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

/*
 * Propbag.h	(V.Sokur)
 * include/Bo/services/hilis/Propbag.h
 *
 * $Id$
 */

/* ------------------------------------------------------------------------- */

#ifndef __BO_SERVICES_HILIS_PROPBAG__
# define __BO_SERVICES_HILIS_PROPBAG__

/******************************************************************************
 * %% BeginSection: includes
 */

# include <Bo/services/hilis/PropbagP.h>

/******************************************************************************
 * %% BeginSection: function prototypes
 */
# pragma mark -
# pragma mark [ function prototypes ]
# pragma mark -

/*
ssize_t
__attribute__((nonnull(1)))
AorpGetproperty(
	aorp_object_t aThis,
	char const *aName,
	unsigned aMethod,
	bo_pointer_t aBuffer __myc_defval__(NULL),
	size_t aBytec __myc_defval__(0),
	struct aorp_error *anErrPtr __myc_defval__(NULL)
	);
*/
# define AorpGetproperty(aThis, aName, aMethod, aBuffer, aBytec, anErrPtr) \
	((ssize_t) _A_call(get, propbag, aThis, anErrPtr, aName, aMethod, aBuffer, aBytec))

# pragma mark -

/*
ssize_t
__attribute__((nonnull(1)))
AorpSetproperty(
	aorp_object_t aThis,
	char const *aName,
	unsigned aMethod,
	bo_const_pointer_t aBuffer __myc_defval__(NULL),
	size_t aBytec __myc_defval__(0),
	struct aorp_error *anErrPtr __myc_defval__(NULL)
	);
*/
# define AorpSetproperty(aThis, aName, aMethod, aBuffer, aBytec, anErrPtr) \
	((ssize_t) _A_call(set, propbag, aThis, anErrPtr, aName, aMethod, aBuffer, aBytec))

# pragma mark -

/*
bo_status_t
__attribute__((nonnull(1)))
AorpPropbagBatchmode(
	aorp_object_t aThis,
	struct aorp_error *anErrPtr __myc_defval__(NULL)
	);
*/
# define AorpPropbagBatchmode(aThis, anErrPtr) \
	_A_call(batchmode, propbag, aThis, anErrPtr)

# pragma mark -

/*
bo_status_t
__attribute__((nonnull(1)))
AorpPropbagApply(
	aorp_object_t aThis,
	struct aorp_error *anErrPtr __myc_defval__(NULL)
	);
*/
# define AorpPropbagApply(aThis, anErrPtr) \
	_A_call(apply, propbag, aThis, anErrPtr)

#endif /* !__BO_SERVICES_HILIS_URIBEND__ */

/******************************************************************************
 * Revision History:
 *		$Log$
 *
 *****************************************************************************/
