/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright (c) 2005-2007 V.Sokur
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

/*
 * Uri.h	(N.Panasiuk)
 * include/Bo/services/hilis/Uri.h
 *
 * $Id$
 */

/* ------------------------------------------------------------------------- */

#ifndef __BO_SERVICES_HILIS_URI__
# define __BO_SERVICES_HILIS_URI__

/******************************************************************************
 * %% BeginSection: includes
 */

# include <Bo/services/hilis/UriP.h>

/******************************************************************************
 * %% BeginSection: function prototypes
 */
# pragma mark -
# pragma mark [ function prototypes ]
# pragma mark -

/*
ssize_t
__attribute__((nonnull(1)))
AorpUriGetstring(
	aorp_object_t aThis,
	char *aBuffer __myc_defval__(NULL),
	size_t aBytec __myc_defval__(0),
	struct aorp_uri_options const *Options __myc_defval__(NULL),
	struct aorp_error *anErrPtr __myc_defval__(NULL)
	);
*/
# define AorpUriGetstring(aThis, aBuffer, aBytec, Options, anErrPtr) \
	((ssize_t) _A_call(getstring, uri, aThis, anErrPtr, aBuffer, aBytec, Options))

# pragma mark -

/*
ssize_t
__attribute__((nonnull(1)))
AorpUriGetstring_w(
	aorp_object_t aThis,
	wchar_t *aBuffer __myc_defval__(NULL),
	size_t aCharc __myc_defval__(0),
	struct aorp_uri_options const *Options __myc_defval__(NULL),
	struct aorp_error *anErrPtr __myc_defval__(NULL)
	);
*/
# define AorpUriGetstring_w(aThis, aBuffer, aCharc, Options, anErrPtr) \
	((ssize_t) _A_call(getstring_w, uri, aThis, anErrPtr, aBuffer, aCharc, Options))

# pragma mark -

/*
ssize_t
__attribute__((nonnull(1)))
AorpUriGetfspath(
	aorp_object_t aThis,
	char *aBuffer __myc_defval__(NULL),
	size_t aBytec __myc_defval__(0),
	struct aorp_uri_options const *Options __myc_defval__(NULL),
	struct aorp_error *anErrPtr __myc_defval__(NULL)
	);
*/
# define AorpUriGetfspath(aThis, aBuffer, aBytec, Options, anErrPtr) \
	((ssize_t) _A_call(getfspath, uri, aThis, anErrPtr, aBuffer, aBytec, Options))

# pragma mark -

/*
ssize_t
__attribute__((nonnull(1)))
AorpUriGetfspath_w(
	aorp_object_t aThis,
	wchar_t *aBuffer __myc_defval__(NULL),
	size_t aCharc __myc_defval__(0),
	struct aorp_uri_options const *Options __myc_defval__(NULL),
	struct aorp_error *anErrPtr __myc_defval__(NULL)
	);
*/
# define AorpUriGetfspath_w(aThis, aBuffer, aCharc, Options, anErrPtr) \
	((ssize_t) _A_call(getfspath_w, uri, aThis, anErrPtr, aBuffer, aCharc, Options))

# pragma mark -

/*
char const *
__attribute__((nonnull(1)))
AorpUriGetfspath_dma(
	aorp_object_t aThis,
	struct aorp_uri_options const *Options __myc_defval__(NULL),
	struct aorp_error *anErrPtr __myc_defval__(NULL)
	);
*/

# if __myc_support(macro_retval)
#  define AorpUriGetfspath_dma(aThis, Options, anErrPtr) \
	__extension__ ({ \
		bo_stsptr_t ___retval = _A_call(getfspath_dma, uri, aThis, anErrPtr, Options); \
		/* return */ (BoSP_NORMAL(___retval) ? BO_STR_FROM_STATUS(___retval) : BoS_ESTR); \
	})
# else
__myc_extern_inline__ char const *
AorpUriGetfspath_dma(
	aorp_object_t aThis,
	struct aorp_uri_options const *Options,
	struct aorp_error *anErrPtr
	)
{
	bo_stsptr_t retval = _A_call(getfspath_dma, uri, aThis, anErrPtr, Options);
	return (BoSP_NORMAL(retval) ? BO_STR_FROM_STATUS(retval) : BoS_ESTR);
}
# endif

# pragma mark -

/*
ssize_t
__attribute__((nonnull(1)))
AorpUriGethostname(
	aorp_object_t aThis,
	char *aBuffer __myc_defval__(NULL),
	size_t aBytec __myc_defval__(0),
	struct aorp_uri_options const *Options __myc_defval__(NULL),
	struct aorp_error *anErrPtr __myc_defval__(NULL)
	);
*/
# define AorpUriGethostname(aThis, aBuffer, aBytec, Options, anErrPtr) \
	((ssize_t) _A_call(gethostname, uri, aThis, anErrPtr, aBuffer, aBytec, Options))

# pragma mark -

/*
char const *
__attribute__((nonnull(1)))
AorpUriGethostname_dma(
	aorp_object_t aThis,
	struct aorp_uri_options const *Options __myc_defval__(NULL),
	struct aorp_error *anErrPtr __myc_defval__(NULL)
	);
*/

# if __myc_support(macro_retval)
#  define AorpUriGethostname_dma(aThis, Options, anErrPtr) \
	__extension__ ({ \
		bo_stsptr_t ___retval = _A_call(gethostname_dma, uri, aThis, anErrPtr, Options); \
		/* return */ (BoSP_NORMAL(___retval) ? BO_STR_FROM_STATUS(___retval) : BoS_ESTR); \
	})
# else
__myc_extern_inline__ char const *
AorpUriGethostname_dma(
	aorp_object_t aThis,
	struct aorp_uri_options const *Options,
	struct aorp_error *anErrPtr
	)
{
	bo_stsptr_t retval = _A_call(gethostname_dma, uri, aThis, anErrPtr, Options);
	return (BoSP_NORMAL(retval) ? BO_STR_FROM_STATUS(retval) : BoS_ESTR);
}
# endif

# pragma mark -

/*
int
__attribute__((nonnull(1)))
AorpUriGetportnum(
	aorp_object_t aThis,
	struct aorp_error *anErrPtr __myc_defval__(NULL)
	);
*/
# define AorpUriGetportnum(aThis, anErrPtr) \
	((int) _A_call(getportnum, uri, aThis, anErrPtr))

# pragma mark -

/*
ssize_t
__attribute__((nonnull(1)))
AorpUriGetport(
	aorp_object_t aThis,
	char *aBuffer __myc_defval__(NULL),
	size_t aBytec __myc_defval__(0),
	struct aorp_uri_options const *Options __myc_defval__(NULL),
	struct aorp_error *anErrPtr __myc_defval__(NULL)
	);
*/
# define AorpUriGetport(aThis, aBuffer, aBytec, Options, anErrPtr) \
	((ssize_t) _A_call(getport, uri, aThis, anErrPtr, aBuffer, aBytec, Options))

# pragma mark -

/*
char const *
__attribute__((nonnull(1)))
AorpUriGetport_dma(
	aorp_object_t aThis,
	struct aorp_uri_options const *Options __myc_defval__(NULL),
	struct aorp_error *anErrPtr __myc_defval__(NULL)
	);
*/

# if __myc_support(macro_retval)
#  define AorpUriGetport_dma(aThis, Options, anErrPtr) \
	__extension__ ({ \
		bo_stsptr_t ___retval = _A_call(getport_dma, uri, aThis, anErrPtr, Options); \
		/* return */ (BoSP_NORMAL(___retval) ? BO_STR_FROM_STATUS(___retval) : BoS_ESTR); \
	})
# else
__myc_extern_inline__ char const *
AorpUriGetport_dma(
	aorp_object_t aThis,
	struct aorp_uri_options const *Options,
	struct aorp_error *anErrPtr
	)
{
	bo_stsptr_t retval = _A_call(getport_dma, uri, aThis, anErrPtr, Options);
	return (BoSP_NORMAL(retval) ? BO_STR_FROM_STATUS(retval) : BoS_ESTR);
}
# endif

# pragma mark -

/*
ssize_t
__attribute__((nonnull(1)))
AorpUriGetusername(
	aorp_object_t aThis,
	char *aBuffer __myc_defval__(NULL),
	size_t aBytec __myc_defval__(0),
	struct aorp_uri_options const *Options __myc_defval__(NULL),
	struct aorp_error *anErrPtr __myc_defval__(NULL)
	);
*/
# define AorpUriGetusername(aThis, aBuffer, aBytec, Options, anErrPtr) \
	((ssize_t) _A_call(getusername, uri, aThis, anErrPtr, aBuffer, aBytec, Options))

# pragma mark -

/*
char const *
__attribute__((nonnull(1)))
AorpUriGetusername_dma(
	aorp_object_t aThis,
	struct aorp_uri_options const *Options __myc_defval__(NULL),
	struct aorp_error *anErrPtr __myc_defval__(NULL)
	);
*/

# if __myc_support(macro_retval)
#  define AorpUriGetusername_dma(aThis, Options, anErrPtr) \
	__extension__ ({ \
		bo_stsptr_t ___retval = _A_call(getusername_dma, uri, aThis, anErrPtr, Options); \
		/* return */ (BoSP_NORMAL(___retval) ? BO_STR_FROM_STATUS(___retval) : BoS_ESTR); \
	})
# else
__myc_extern_inline__ char const *
AorpUriGetusername_dma(
	aorp_object_t aThis,
	struct aorp_uri_options const *Options,
	struct aorp_error *anErrPtr
	)
{
	bo_stsptr_t retval = _A_call(getusername_dma, uri, aThis, anErrPtr, Options);
	return (BoSP_NORMAL(retval) ? BO_STR_FROM_STATUS(retval) : BoS_ESTR);
}
# endif

# pragma mark -

/*
ssize_t
__attribute__((nonnull(1)))
AorpUriGetpasswd(
	aorp_object_t aThis,
	char *aBuffer __myc_defval__(NULL),
	size_t aBytec __myc_defval__(0),
	struct aorp_uri_options const *Options __myc_defval__(NULL),
	struct aorp_error *anErrPtr __myc_defval__(NULL)
	);
*/
# define AorpUriGetpasswd(aThis, aBuffer, aBytec, Options, anErrPtr) \
	((ssize_t) _A_call(getpasswd, uri, aThis, anErrPtr, aBuffer, aBytec, Options))

# pragma mark -

/*
char const *
__attribute__((nonnull(1)))
AorpUriGetpasswd_dma(
	aorp_object_t aThis,
	struct aorp_uri_options const *Options __myc_defval__(NULL),
	struct aorp_error *anErrPtr __myc_defval__(NULL)
	);
*/

# if __myc_support(macro_retval)
#  define AorpUriGetpasswd_dma(aThis, Options, anErrPtr) \
	__extension__ ({ \
		bo_stsptr_t ___retval = _A_call(getpasswd_dma, uri, aThis, anErrPtr, Options); \
		/* return */ (BoSP_NORMAL(___retval) ? BO_STR_FROM_STATUS(___retval) : BoS_ESTR); \
	})
# else
__myc_extern_inline__ char const *
AorpUriGetpasswd_dma(
	aorp_object_t aThis,
	struct aorp_uri_options const *Options,
	struct aorp_error *anErrPtr
	)
{
	bo_stsptr_t retval = _A_call(getpasswd_dma, uri, aThis, anErrPtr, Options);
	return (BoSP_NORMAL(retval) ? BO_STR_FROM_STATUS(retval) : BoS_ESTR);
}
# endif

# pragma mark -

/*
ssize_t
__attribute__((nonnull(1)))
AorpUriGetparm(
	aorp_object_t aThis,
	char *aBuffer __myc_defval__(NULL),
	size_t aBytec __myc_defval__(0),
	struct aorp_uri_options const *Options __myc_defval__(NULL),
	struct aorp_error *anErrPtr __myc_defval__(NULL)
	);
*/
# define AorpUriGetparm(aThis, aBuffer, aBytec, Options, anErrPtr) \
	((ssize_t) _A_call(getparm, uri, aThis, anErrPtr, aBuffer, aBytec, Options))

# pragma mark -

/*
char const *
__attribute__((nonnull(1)))
AorpUriGetparm_dma(
	aorp_object_t aThis,
	struct aorp_uri_options const *Options __myc_defval__(NULL),
	struct aorp_error *anErrPtr __myc_defval__(NULL)
	);
*/

# if __myc_support(macro_retval)
#  define AorpUriGetparm_dma(aThis, Options, anErrPtr) \
	__extension__ ({ \
		bo_stsptr_t ___retval = _A_call(getparm_dma, uri, aThis, anErrPtr, Options); \
		/* return */ (BoSP_NORMAL(___retval) ? BO_STR_FROM_STATUS(___retval) : BoS_ESTR); \
	})
# else
__myc_extern_inline__ char const *
AorpUriGetparm_dma(
	aorp_object_t aThis,
	struct aorp_uri_options const *Options,
	struct aorp_error *anErrPtr
	)
{
	bo_stsptr_t retval = _A_call(getparm_dma, uri, aThis, anErrPtr, Options);
	return (BoSP_NORMAL(retval) ? BO_STR_FROM_STATUS(retval) : BoS_ESTR);
}
# endif

# pragma mark -

/*
ssize_t
__attribute__((nonnull(1)))
AorpUriGetquery(
	aorp_object_t aThis,
	char *aBuffer __myc_defval__(NULL),
	size_t aBytec __myc_defval__(0),
	struct aorp_uri_options const *Options __myc_defval__(NULL),
	struct aorp_error *anErrPtr __myc_defval__(NULL)
	);
*/
# define AorpUriGetquery(aThis, aBuffer, aBytec, Options, anErrPtr) \
	((ssize_t) _A_call(getquery, uri, aThis, anErrPtr, aBuffer, aBytec, Options))

# pragma mark -

/*
char const *
__attribute__((nonnull(1)))
AorpUriGetquery_dma(
	aorp_object_t aThis,
	struct aorp_uri_options const *Options __myc_defval__(NULL),
	struct aorp_error *anErrPtr __myc_defval__(NULL)
	);
*/

# if __myc_support(macro_retval)
#  define AorpUriGetquery_dma(aThis, Options, anErrPtr) \
	__extension__ ({ \
		bo_stsptr_t ___retval = _A_call(getquery_dma, uri, aThis, anErrPtr, Options); \
		/* return */ (BoSP_NORMAL(___retval) ? BO_STR_FROM_STATUS(___retval) : BoS_ESTR); \
	})
# else
__myc_extern_inline__ char const *
AorpUriGetquery_dma(
	aorp_object_t aThis,
	struct aorp_uri_options const *Options,
	struct aorp_error *anErrPtr
	)
{
	bo_stsptr_t retval = _A_call(getquery_dma, uri, aThis, anErrPtr, Options);
	return (BoSP_NORMAL(retval) ? BO_STR_FROM_STATUS(retval) : BoS_ESTR);
}
# endif

# pragma mark -

/*
ssize_t
__attribute__((nonnull(1)))
AorpUriGetfragment(
	aorp_object_t aThis,
	char *aBuffer __myc_defval__(NULL),
	size_t aBytec __myc_defval__(0),
	struct aorp_uri_options const *Options __myc_defval__(NULL),
	struct aorp_error *anErrPtr __myc_defval__(NULL)
	);
*/
# define AorpUriGetfragment(aThis, aBuffer, aBytec, Options, anErrPtr) \
	((ssize_t) _A_call(getfragment, uri, aThis, anErrPtr, aBuffer, aBytec, Options))

# pragma mark -

/*
char const *
__attribute__((nonnull(1)))
AorpUriGetfragment_dma(
	aorp_object_t aThis,
	struct aorp_uri_options const *Options __myc_defval__(NULL),
	struct aorp_error *anErrPtr __myc_defval__(NULL)
	);
*/

# if __myc_support(macro_retval)
#  define AorpUriGetfragment_dma(aThis, Options, anErrPtr) \
	__extension__ ({ \
		bo_stsptr_t ___retval = _A_call(getfragment_dma, uri, aThis, anErrPtr, Options); \
		/* return */ (BoSP_NORMAL(___retval) ? BO_STR_FROM_STATUS(___retval) : BoS_ESTR); \
	})
# else
__myc_extern_inline__ char const *
AorpUriGetfragment_dma(
	aorp_object_t aThis,
	struct aorp_uri_options const *Options,
	struct aorp_error *anErrPtr
	)
{
	bo_stsptr_t retval = _A_call(getfragment_dma, uri, aThis, anErrPtr, Options);
	return (BoSP_NORMAL(retval) ? BO_STR_FROM_STATUS(retval) : BoS_ESTR);
}
# endif

#endif /* !__BO_SERVICES_HILIS_URIBEND__ */

/******************************************************************************
 * Revision History:
 *		$Log$
 *
 *****************************************************************************/
