/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright (c) 2005-2007 V.Sokur
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

/*
 * UriP.h	(N.Panasiuk)
 * include/Bo/services/hilis/UriP.h
 *
 * $Id$
 */

/* ------------------------------------------------------------------------- */

#ifndef __BO_SERVICES_HILIS_URI_P__
# define __BO_SERVICES_HILIS_URI_P__

/******************************************************************************
 * %% BeginSection: includes
 */

# include <Bo/services/hilis/Uritypes.h>

/******************************************************************************
 * %% BeginSection: uri service declarations
 */
# pragma mark -
# pragma mark [ uri service declarations ]
# pragma mark -

# define __aorpc_need_service_uri 1

#endif /* !__BO_SERVICES_HILIS_URI_P__ */

#pragma mark -

#if __aorpc_uses_service(uri)
# undef __aorpc_need_service_uri

/*
 * uri {\object(instance)}
 */
/*
# define AorpK_uri_service (1092)
 */
# include <Bo/services/MIB/Services.h>

# define __aorpc_service_name uri
# include <Bo/aorp/AorpCsrvc.h>

_A_service(uri)
_A_end_ctb

	_A_attribute((nonnull(1)))
	_A_op(getstring, "get-uri-string-representation", (
			struct aorp_closure *aClosure,
			struct aorp_error *anErrPtr,
			char *aBuffer,
			size_t aBytec,
			struct aorp_uri_options const *Options
		)),

	_A_attribute((nonnull(1)))
	_A_op(getstring_w, "get-uri-wstring-representation", (
			struct aorp_closure *aClosure,
			struct aorp_error *anErrPtr,
			wchar_t *aBuffer,
			size_t aCharc,
			struct aorp_uri_options const *Options
		)),

	_A_attribute((nonnull(1)))
	_A_op(getfspath, "get-file-system-path-from-uri", (
			struct aorp_closure *aClosure,
			struct aorp_error *anErrPtr,
			char *aBuffer,
			size_t aBytec,
			struct aorp_uri_options const *Options
		)),

	_A_attribute((nonnull(1)))
	_A_op(getfspath_w, "get-file-system-wpath-from-uri", (
			struct aorp_closure *aClosure,
			struct aorp_error *anErrPtr,
			wchar_t *aBuffer,
			size_t aCharc,
			struct aorp_uri_options const *Options
		)),

	_A_attribute((nonnull(1)))
	_A_op(getfspath_dma, "get-file-system-path-dma-from-uri", (
			struct aorp_closure *aClosure,
			struct aorp_error *anErrPtr,
			struct aorp_uri_options const *Options
		)),

	_A_attribute((nonnull(1)))
	_A_op(gethostname, "get-uri-host-name", (
			struct aorp_closure *aClosure,
			struct aorp_error *anErrPtr,
			char *aBuffer,
			size_t aBytec,
			struct aorp_uri_options const *Options
		)),

	_A_attribute((nonnull(1)))
	_A_op(gethostname_dma, "get-host-name-dma-from-uri", (
			struct aorp_closure *aClosure,
			struct aorp_error *anErrPtr,
			struct aorp_uri_options const *Options
		)),

	_A_attribute((nonnull(1)))
	_A_op(getportnum, "get-uri-port-number", (
			struct aorp_closure *aClosure,
			struct aorp_error *anErrPtr
		)),

	_A_attribute((nonnull(1)))
	_A_op(getport, "get-uri-port", (
			struct aorp_closure *aClosure,
			struct aorp_error *anErrPtr,
			char *aBuffer,
			size_t aBytec,
			struct aorp_uri_options const *Options
		)),

	_A_attribute((nonnull(1)))
	_A_op(getport_dma, "get-port-dma-from-uri", (
			struct aorp_closure *aClosure,
			struct aorp_error *anErrPtr,
			struct aorp_uri_options const *Options
		)),

	_A_attribute((nonnull(1)))
	_A_op(getusername, "get-uri-user-name", (
			struct aorp_closure *aClosure,
			struct aorp_error *anErrPtr,
			char *aBuffer,
			size_t aBytec,
			struct aorp_uri_options const *Options
		)),

	_A_attribute((nonnull(1)))
	_A_op(getusername_dma, "get-user-name-dma-from-uri", (
			struct aorp_closure *aClosure,
			struct aorp_error *anErrPtr,
			struct aorp_uri_options const *Options
		)),

	_A_attribute((nonnull(1)))
	_A_op(getpasswd, "get-uri-password", (
			struct aorp_closure *aClosure,
			struct aorp_error *anErrPtr,
			char *aBuffer,
			size_t aBytec,
			struct aorp_uri_options const *Options
		)),

	_A_attribute((nonnull(1)))
	_A_op(getpasswd_dma, "get-password-dma-from-uri", (
			struct aorp_closure *aClosure,
			struct aorp_error *anErrPtr,
			struct aorp_uri_options const *Options
		)),

	_A_attribute((nonnull(1)))
	_A_op(getparm, "get-uri-parameters", (
			struct aorp_closure *aClosure,
			struct aorp_error *anErrPtr,
			char *aBuffer,
			size_t aBytec,
			struct aorp_uri_options const *Options
		)),

	_A_attribute((nonnull(1)))
	_A_op(getparm_dma, "get-parameters-dma-from-uri", (
			struct aorp_closure *aClosure,
			struct aorp_error *anErrPtr,
			struct aorp_uri_options const *Options
		)),

	_A_attribute((nonnull(1)))
	_A_op(getquery, "get-uri-query", (
			struct aorp_closure *aClosure,
			struct aorp_error *anErrPtr,
			char *aBuffer,
			size_t aBytec,
			struct aorp_uri_options const *Options
		)),

	_A_attribute((nonnull(1)))
	_A_op(getquery_dma, "get-query-dma-from-uri", (
			struct aorp_closure *aClosure,
			struct aorp_error *anErrPtr,
			struct aorp_uri_options const *Options
		)),

	_A_attribute((nonnull(1)))
	_A_op(getfragment, "get-uri-fragment", (
			struct aorp_closure *aClosure,
			struct aorp_error *anErrPtr,
			char *aBuffer,
			size_t aBytec,
			struct aorp_uri_options const *Options
		)),

	_A_attribute((nonnull(1)))
	_A_op(getfragment_dma, "get-fragment-dma-from-uri", (
			struct aorp_closure *aClosure,
			struct aorp_error *anErrPtr,
			struct aorp_uri_options const *Options
		)),

_A_end;

# include <Bo/aorp/AorpCend.h>
/* @} */
#endif /* __aorpc_uses_service(uri) */

/******************************************************************************
 * Revision History:
 *		$Log$
 *
 *****************************************************************************/
