/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright (c) 2005-2007 V.Sokur
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

/*
 * Uribend.h	(N.Panasiuk)
 * include/Bo/services/hilis/Uribend.h
 *
 * $Id$
 */

/* ------------------------------------------------------------------------- */

#ifndef __BO_SERVICES_HILIS_URIBEND__
# define __BO_SERVICES_HILIS_URIBEND__

/******************************************************************************
 * %% BeginSection: includes
 */

# include <Bo/services/hilis/UribendP.h>

/******************************************************************************
 * %% BeginSection: function prototypes
 */
# pragma mark -
# pragma mark [ function prototypes ]
# pragma mark -

/*
bo_status_t
__attribute__((nonnull(1,2)))
_AorpDestroyUriSpecification(
	aorp_object_t aThis,
	struct aorp_uri *anUri,
	aorp_opflags_t Flags __myc_defval__(0),
	struct aorp_error *anErrPtr __myc_defval__(NULL)
	);
*/
# define _AorpDestroyUriSpecification(aThis, anUri, Flags, anErrPtr) \
	_A_call(destroy, uribend, aThis, anErrPtr, anUri, Flags)

# pragma mark -

/*
Function returning actual spec-buffer size.
ssize_t
__attribute__((nonnull(1,2,3,7)))
_AorpCreateUriSpecification(
	aorp_object_t aThis,
	aorp_object_t anUrilib,
	char const *anUriStr,
	struct aorp_uri *aHeader __myc_defval__(AorpK_URI_NULL_MEM),
	bo_pointer_t aSpecBuf __myc_defval__(AorpK_URI_NULL_MEM),
	size_t aSpecBufsz __myc_defval__(0),
	struct aorp_uri_options const *Options,
	struct aorp_error *anErrPtr __myc_defval__(NULL)
	);
*/
# define _AorpCreateUriSpecification(aThis, anUrilib, anUriStr, aHeader, aSpecBuf, aSpecBufsz, Options, anErrPtr) \
	((ssize_t) _A_call(create, uribend, aThis, anErrPtr, \
		anUrilib, anUriStr, aHeader, aSpecBuf, aSpecBufsz, Options))

# pragma mark -

/*
Function returning actual spec-buffer size.
ssize_t
__attribute__((nonnull(1,2,3,7)))
_AorpCopyUriSpecification(
	aorp_object_t aThis,
	aorp_object_t anUrilib,
	struct aorp_uri const *anUri,
	struct aorp_uri *aHeader __myc_defval__(AorpK_URI_NULL_MEM),
	bo_pointer_t aSpecBuf __myc_defval__(AorpK_URI_NULL_MEM),
	size_t aSpecBufsz __myc_defval__(0),
	struct aorp_uri_options const *Options,
	struct aorp_error *anErrPtr __myc_defval__(NULL)
	);
*/
# define _AorpCopyUriSpecification(aThis, anUrilib, anUri, aHeader, aSpecBuf, aSpecBufsz, Options, anErrPtr) \
	((ssize_t) _A_call(copy, uribend, aThis, anErrPtr, \
		anUrilib, anUri, aHeader, aSpecBuf, aSpecBufsz, Options))

# pragma mark -

/*
char *
__attribute__((nonnull(1,2,3,5)))
_AorpConvertUriToString(
	aorp_object_t aThis,
	aorp_object_t anUrilib,
	struct aorp_uri const *anUri,
	bo_pointer_t *aMemPtr, // = NULL
	size_t *aMemszPtr,
	struct aorp_uri_options const *Options __myc_defval__(NULL),
	struct aorp_error *anErrPtr __myc_defval__(NULL)
	);
*/

# if __myc_support(macro_retval)
#  define _AorpConvertUriToString(aThis, anUrilib, anUri, aMemPtr, aMemszPtr, Options, anErrPtr) \
	__extension__ ({ \
		bo_stsptr_t ___retval = _A_call( \
			convtostring, uribend, aThis, anErrPtr, \
			anUrilib, anUri, aMemPtr, aMemszPtr, Options \
		); \
		/* return */ (BoSP_NORMAL(___retval) ? BO_STR_FROM_STATUS(___retval) : BoS_ESTR); \
	})
# else
__myc_extern_inline__ char *
_AorpConvertUriToString(
	aorp_object_t aThis,
	aorp_object_t anUrilib,
	struct aorp_uri const *anUri,
	bo_pointer_t *aMemPtr,
	size_t *aMemszPtr,
	struct aorp_uri_options const *Options __myc_defval__(NULL),
	struct aorp_error *anErrPtr __myc_defval__(NULL)
	)
{
	bo_stsptr_t retval = _A_call(
		convtostring, uribend, aThis, anErrPtr,
		anUrilib, anUri, aMemPtr, aMemszPtr, Options
	);
	return (BoSP_NORMAL(retval) ? BO_STR_FROM_STATUS(retval) : BoS_ESTR);
}
# endif

# pragma mark -

/*
ssize_t
__attribute__((nonnull(1,2)))
_AorpPrintUriComponent(
	aorp_object_t aThis,
	struct aorp_uri const *anUri,
	int aComponentID,
	char *aBuffer __myc_defval__(NULL),
	size_t aBytec __myc_defval__(0),
	struct aorp_uri_options const *Options __myc_defval__(NULL),
	struct aorp_error *anErrPtr __myc_defval__(NULL)
	);
*/
# define _AorpPrintUriComponent(aThis, anUri, aComponentID, aBuffer, aBytec, Options, anErrPtr) \
	((ssize_t) _A_call(printcomponent, uribend, aThis, anErrPtr, \
		anUri, aComponentID, aBuffer, aBytec, Options))

#endif /* !__BO_SERVICES_HILIS_URIBEND__ */

/******************************************************************************
 * Revision History:
 *		$Log$
 *
 *****************************************************************************/
