/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright (c) 2005-2007 V.Sokur
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

/*
 * UribendP.h	(N.Panasiuk)
 * include/Bo/services/hilis/UribendP.h
 *
 * $Id$
 */

/* ------------------------------------------------------------------------- */

#ifndef __BO_SERVICES_HILIS_URIBEND_P__
# define __BO_SERVICES_HILIS_URIBEND_P__

/******************************************************************************
 * %% BeginSection: includes
 */

# include <Bo/services/hilis/Uritypes.h>

/******************************************************************************
 * %% BeginSection: uri-backend service declarations
 */
# pragma mark -
# pragma mark [ uri-backend service declarations ]
# pragma mark -

# define __aorpc_need_service_uribend 1

#endif /* !__BO_SERVICES_HILIS_URIBEND_P__ */

#pragma mark -

#if __aorpc_uses_service(uribend)
# undef __aorpc_need_service_uribend

/*
 * uribend {\object(class)}
 */
/*
# define AorpK_uribend_service (1091)
 */
# include <Bo/services/MIB/Services.h>

# define __aorpc_service_name uribend
# include <Bo/aorp/AorpCsrvc.h>

_A_service(uribend)
_A_end_ctb

	_A_return((
		BoS_SUCCESS = [ ];
		BoS_FAILURE = [ BoS_EPTR = (BoK_RacError_NotConfigured, /* @todo */...); ];
	))
	_A_attribute((nonnull(1,3)))
	_A_op(destroy, "destroy-uri-specification", (
			struct aorp_closure *aClosure,
			struct aorp_error *anErrPtr,
			struct aorp_uri *anUri,
			aorp_opflags_t Flags
		)),

	_A_return((
		BoS_SUCCESS = [ ];
		BoS_FAILURE = [ BoS_EPTR = (BoK_RacError_NotConfigured, /* @todo */...); ];
	))
	_A_attribute((nonnull(1,3,4,8)))
	_A_op(create, "create-uri-specification", (
			struct aorp_closure *aClosure,
			struct aorp_error *anErrPtr,
			aorp_object_t anUrilib,
			char const *anUriStr,
			struct aorp_uri *aHeader,
			bo_pointer_t aSpecBuf,
			size_t aSpecBufsz,
			struct aorp_uri_options const *Options
		)),

	_A_return((
		BoS_SUCCESS = [ ];
		BoS_FAILURE = [ BoS_EPTR = (BoK_RacError_NotConfigured, /* @todo */...); ];
	))
	_A_attribute((nonnull(1,3,4,8)))
	_A_op(copy, "copy-uri-specification", (
			struct aorp_closure *aClosure,
			struct aorp_error *anErrPtr,
			aorp_object_t anUrilib,
			struct aorp_uri const *anUri,
			struct aorp_uri *aHeader,
			bo_pointer_t aSpecBuf,
			size_t aSpecBufsz,
			struct aorp_uri_options const *Options
		)),

	_A_return((
		BoS_SUCCESS = [ ];
		BoS_FAILURE = [ BoS_EPTR = (BoK_RacError_NotConfigured, /* @todo */...); ];
	))
	_A_attribute((nonnull(1,3,4,6)))
	_A_op(convtostring, "convert-uri-to-string", (
			struct aorp_closure *aClosure,
			struct aorp_error *anErrPtr,
			aorp_object_t anUrilib,
			struct aorp_uri const *anUri,
			bo_pointer_t *aMemPtr,
			size_t *aMemszPtr,
			struct aorp_uri_options const *Options
		)),

	_A_return((
		BoS_SUCCESS = [ ];
		BoS_FAILURE = [ BoS_ERR = (BoK_RacError_NotConfigured, /* @todo */...); ];
	))
	_A_attribute((nonnull(1,3)))
	_A_op(printcomponent, "print-uri-component", (
			struct aorp_closure *aClosure,
			struct aorp_error *anErrPtr,
			struct aorp_uri const *anUri,
			int aComponentID,
			char *aBuffer,
			size_t aBytec,
			struct aorp_uri_options const *Options
		)),

_A_end;

# include <Bo/aorp/AorpCend.h>
/* @} */
#endif /* __aorpc_uses_service(uribend) */

/******************************************************************************
 * Revision History:
 *		$Log$
 *
 *****************************************************************************/
