/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright (c) 2005-2007 V.Sokur
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

/*
 * UrilibP.h	(N.Panasiuk)
 * include/Bo/services/hilis/UrilibP.h
 *
 * $Id$
 */

/* ------------------------------------------------------------------------- */

#ifndef __BO_SERVICES_HILIS_URILIB_P__
# define __BO_SERVICES_HILIS_URILIB_P__

/******************************************************************************
 * %% BeginSection: includes
 */

# include <Bo/services/hilis/Uritypes.h>

/******************************************************************************
 * %% BeginSection: urilib service declarations
 */
# pragma mark -
# pragma mark [ urilib service declarations ]
# pragma mark -

# define __aorpc_need_service_urilib 1

#endif /* !__BO_SERVICES_HILIS_URILIB_P__ */

#pragma mark -

#if __aorpc_uses_service(urilib)
# undef __aorpc_need_service_urilib

/*
 * urilib {\object(class)}
 */
/*
# define AorpK_urilib_service (1090)
 */
# include <Bo/services/MIB/Services.h>

# define __aorpc_service_name urilib
# include <Bo/aorp/AorpCsrvc.h>

_A_service(urilib)
_A_end_ctb

	_A_return((
		BoS_SUCCESS = [ ];
		BoS_FAILURE = [ BoS_EPTR = (BoK_RacError_NotConfigured, /* @todo */...); ];
	))
	_A_attribute((nonnull(1,4)))
	_A_op(create, "create-uri-with-string", (
			struct aorp_closure *aClosure,
			struct aorp_error *anErrPtr,
			bo_pointer_t anObjectMemory,
			char const *anUriStr,
			bo_pointer_t aSpecBuf,
			size_t aSpecBufsz,
			size_t *anActualSpecszPtr,
			struct aorp_uri_options const *Options
		)),

	_A_return((
		BoS_SUCCESS = [ ];
		BoS_FAILURE = [ BoS_EPTR = (BoK_RacError_NotConfigured, /* @todo */...); ];
	))
	_A_attribute((nonnull(1,4)))
	_A_op(create_w, "create-uri-with-wstring", (
			struct aorp_closure *aClosure,
			struct aorp_error *anErrPtr,
			bo_pointer_t anObjectMemory,
			wchar_t const *anUriStr,
			bo_pointer_t aSpecBuf,
			size_t aSpecBufsz,
			size_t *anActualSpecszPtr,
			struct aorp_uri_options const *Options
		)),

	_A_return((
		BoS_SUCCESS = [ ];
		BoS_FAILURE = [ BoS_EPTR = (BoK_RacError_NotConfigured, /* @todo */...); ];
	))
	_A_attribute((nonnull(1,4)))
	_A_op(create_fsp, "create-uri-with-file-system-path", (
			struct aorp_closure *aClosure,
			struct aorp_error *anErrPtr,
			bo_pointer_t anObjectMemory,
			char const *aPath,
			bo_pointer_t aSpecBuf,
			size_t aSpecBufsz,
			size_t *anActualSpecszPtr,
			struct aorp_uri_options const *Options
		)),

	_A_return((
		BoS_SUCCESS = [ ];
		BoS_FAILURE = [ BoS_EPTR = (BoK_RacError_NotConfigured, /* @todo */...); ];
	))
	_A_attribute((nonnull(1,4)))
	_A_op(create_fsp_w, "create-uri-with-file-system-wpath", (
			struct aorp_closure *aClosure,
			struct aorp_error *anErrPtr,
			bo_pointer_t anObjectMemory,
			wchar_t const *aPath,
			bo_pointer_t aSpecBuf,
			size_t aSpecBufsz,
			size_t *anActualSpecszPtr,
			struct aorp_uri_options const *Options
		)),

	_A_attribute((nonnull(1,3)))
	_A_op(supportscheme, "support-uri-scheme", (
			struct aorp_closure *aClosure,
			struct aorp_error *anErrPtr,
			char const *aSchemeNamev[],
			size_t aCount
		)),

	_A_return((
		BoS_SUCCESS = [];
		BoS_FAILURE = [
			BoK_URI_INVAL_SCHEME = (
				BoK_RacError_NotConfigured,
				BoK_AIBNameError_NoSuchEntry
			);
		];
	))
	_A_attribute((nonnull(1,3)))
	_A_op(getschemebyname, "get-uri-scheme-by-name", (
			struct aorp_closure *aClosure,
			struct aorp_error *anErrPtr,
			char const *aSchemeNamev[],
			size_t aCount
		)),

	_A_return((
		BoS_SUCCESS = [];
		BoS_FAILURE = [
			NULL = (BoK_RacError_NotConfigured, BoK_AIBNameError_NoSuchEntry);
		];
	))
	_A_attribute((nonnull(1)))
	_A_op(getschemename, "get-uri-scheme-name", (
			struct aorp_closure *aClosure,
			struct aorp_error *anErrPtr,
			bo_uri_scheme_t aScheme
		)),

	_A_return((
		BoS_SUCCESS = [];
		BoS_FAILURE = [
			NULL = (BoK_RacError_NotConfigured, BoK_AIBNameError_NoSuchEntry);
		];
	))
	_A_attribute((nonnull(1,3)))
	_A_op(getschemeinfobyname, "get-uri-scheme-information-by-name", (
			struct aorp_closure *aClosure,
			struct aorp_error *anErrPtr,
			char const *aSchemeNamev[],
			size_t aCount
		)),

	_A_return((
		BoS_SUCCESS = [];
		BoS_FAILURE = [
			NULL = (BoK_RacError_NotConfigured, BoK_AIBNameError_NoSuchEntry);
		];
	))
	_A_attribute((nonnull(1)))
	_A_op(getschemeinfobyid, "get-uri-scheme-information-by-id", (
			struct aorp_closure *aClosure,
			struct aorp_error *anErrPtr,
			bo_uri_scheme_t aScheme
		)),

	_A_attribute((nonnull(1,3)))
	_A_op(addschemeinfo, "add-uri-scheme-information", (
			struct aorp_closure *aClosure,
			struct aorp_error *anErrPtr,
			struct aorp_uri_schemeinfo *anInfov[],
			size_t aCount
		)),

	_A_attribute((nonnull(1,4)))
	_A_op(addschemeinfo_nlk, "add-uri-scheme-information-nolock", (
			struct aorp_closure *aClosure,
			struct aorp_error *anErrPtr,
			struct aorp_uri_schemeinfo *anInfov[],
			size_t aCount
		)),

	_A_attribute((nonnull(1,3)))
	_A_op(rmschemeinfo, "remove-uri-scheme-information", (
			struct aorp_closure *aClosure,
			struct aorp_error *anErrPtr,
			struct aorp_uri_schemeinfo *anInfov[],
			size_t aCount
		)),

	_A_attribute((nonnull(1,3)))
	_A_op(rmschemeinfo_nlk, "remove-uri-scheme-information-nolock", (
			struct aorp_closure *aClosure,
			struct aorp_error *anErrPtr,
			struct aorp_uri_schemeinfo *anInfov[],
			size_t aCount
		)),

	_A_attribute((nonnull(1,3)))
	_A_op(parsescheme, "parse-uri-scheme", (
			struct aorp_closure *aClosure,
			struct aorp_error *anErrPtr,
			char const *anUriStr,
			char *aBuffer,
			size_t aBytec,
			char const **aNextPartPtr
		)),

	_A_attribute((nonnull(1,3)))
	_A_op(parsescheme_w, "wparse-uri-scheme", (
			struct aorp_closure *aClosure,
			struct aorp_error *anErrPtr,
			wchar_t const *anUriStr,
			wchar_t *aBuffer,
			size_t aCharc,
			wchar_t const **aNextPartPtr
		)),

_A_end;

# include <Bo/aorp/AorpCend.h>
/* @} */
#endif /* __aorpc_uses_service(urilib) */

/******************************************************************************
 * Revision History:
 *		$Log$
 *
 *****************************************************************************/
