/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright (c) 2005-2007 V.Sokur
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

/*
 * Ioport.h	(V.Sokur)
 * include/Bo/services/io/Ioport.h
 *
 * $Id$
 */

/* ------------------------------------------------------------------------- */

#ifndef __BO_SERVICES_IO_IOPORT__
# define __BO_SERVICES_IO_IOPORT__

/******************************************************************************
 * %% BeginSection: includes
 */

# include <Bo/services/io/IoportP.h>

/******************************************************************************
 * %% BeginSection: function prototypes
 */
# pragma mark -
# pragma mark [ function prototypes ]
# pragma mark -

__MYC_BEGIN_CDECLS

/*
ssize_t
__attribute__((nonnull(1)))
AorpIoportGetsuppfmt(
	aorp_object_t aThis,
	aorp_iopmfmt_t aFormatv[],
	size_t aFormatc,
	struct aorp_error *anErrPtr
	);
*/
# define AorpIoportGetsuppfmt(aThis, aFormatv, aFormatc, anErrPtr) \
	((ssize_t) _A_call(getsuppfmt, ioport, aThis, anErrPtr, aFormatv, (size_t)(aFormatc)))

# pragma mark -

/*
bo_stsbool_t
__attribute__((nonnull(1)))
AorpIoportGetmsg(
	aorp_object_t aThis,
	struct aorp_iopmsg *aMsg,
	struct aorp_error *anErrPtr
	);
*/
# define AorpIoportGetmsg(aThis, aMsg, anErrPtr) \
	_A_call(getmsg, ioport, aThis, anErrPtr, aMsg)

# pragma mark -

/*
bo_status_t
__attribute__((nonnull(1)))
AorpIoportPutmsg(
	aorp_object_t aThis,
	struct aorp_iopmsg const *aMsg,
	struct aorp_error *anErrPtr
	);
*/
# define AorpIoportPutmsg(aThis, aMsg, anErrPtr) \
	_A_call(putmsg, ioport, aThis, anErrPtr, aMsg)

# pragma mark -

/*
bo_status_t
__attribute__((nonnull(1)))
AorpIoportSetExternalAllocator(
	aorp_object_t aThis,
	aorp_object_t anAlloc,
	struct aorp_error *anErrPtr
	);
*/
# define AorpIoportSetExternalAllocator(aThis, anAlloc, anErrPtr) \
	_A_call(setxalloc, ioport, aThis, anErrPtr, anAlloc)

# pragma mark -

/*
bo_status_t
__attribute__((nonnull(1)))
AorpIoportSetcntlo(
	aorp_object_t aThis,
	aorp_object_t aCntlobj,
	struct aorp_error *anErrPtr
	);
 *
 * NOTE!!!
 * The object, referenced by the parameter @cntlobj, is not retained.
 */
# define AorpIoportSetcntlo(aThis, aCntlobj, anErrPtr) \
	_A_call(setcntlo, ioport, aThis, anErrPtr, aCntlobj)

__MYC_END_CDECLS

#endif /* !__BO_SERVICES_IO_IOPORT__ */

/******************************************************************************
 * Revision History:
 *		$Log$
 *
 *****************************************************************************/
