/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright (c) 2005-2007 V.Sokur
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

/*
 * IoportP.h	(V.Sokur)
 * include/Bo/services/io/IoportP.h
 *
 * $Id$
 */

/* ------------------------------------------------------------------------- */

#ifndef __BO_SERVICES_IO_IOPORT_P__
# define __BO_SERVICES_IO_IOPORT_P__

/******************************************************************************
 * %% BeginSection: includes
 */

# include <Bo/services/io/Iopotypes.h>

/******************************************************************************
 * %% BeginSection: ioport service declarations
 */
# pragma mark -
# pragma mark [ ioport service declarations ]
# pragma mark -

# define __aorpc_need_service_ioport 1

#endif /* !__BO_SERVICES_IO_IOPORT_P__ */

#pragma mark -

#if __aorpc_uses_service(ioport)
# undef __aorpc_need_service_ioport

/*
 * ioport service
 * @{
 */

/*
 * ioport {\object(instance)}
 */
/*
# define AorpK_ioport_service (1072)
 */
# include <Bo/services/MIB/Services.h>

# define __aorpc_service_name ioport
# include <Bo/aorp/AorpCsrvc.h>

_A_service(ioport)

# if __aorpc_interface

/*
 * state domain
 */
# ifndef BoK_STATE_IOPORT
#  define BoK_STATE_IOPORT __myc_mk4ccs("iopo")
#  define _BoK_STATE_IOPORT __myc_mk4cc('i','o','p','o')
# endif

# endif /* __aorpc_interface */

_A_end_ctb

	_A_attribute((nonnull(1)))
	_A_op(getsuppfmt, "ioport::get-supported-msg-formats", (
			struct aorp_closure *aClosure,
			struct aorp_error *anErrPtr,
			aorp_iopmfmt_t aFormatv[],
			size_t aFormatc
		)),

	_A_attribute((nonnull(1)))
	_A_op(getmsg, "ioport::get-message", (
			struct aorp_closure *aClosure,
			struct aorp_error *anErrPtr,
			struct aorp_iopmsg *aMsg
		)),

	_A_attribute((nonnull(1)))
	_A_op(putmsg, "ioport::put-message", (
			struct aorp_closure *aClosure,
			struct aorp_error *anErrPtr,
			struct aorp_iopmsg const *aMsg
		)),

	_A_attribute((nonnull(1)))
	_A_op(setxalloc, "ioport::set-external-allocator", (
			struct aorp_closure *aClosure,
			struct aorp_error *anErrPtr,
			aorp_object_t anAlloc
		)),

	/* @todo: ??? */
	_A_attribute((nonnull(1)))
	_A_op(setcntlo, "ioport::set-control-object", (
			struct aorp_closure *aClosure,
			struct aorp_error *anErrPtr,
			aorp_object_t aCntlobj
		)),

_A_end;

# include <Bo/aorp/AorpCend.h>
/* @} */
#endif /* __aorpc_uses_service(ioport) */

/******************************************************************************
 * Revision History:
 *		$Log$
 *
 *****************************************************************************/
