/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright (c) 2005-2007 V.Sokur
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

/*
 * Iopotypes.h	(V.Sokur)
 * include/Bo/services/io/Iopotypes.h
 *
 * $Id$
 */

/* ------------------------------------------------------------------------- */

#ifndef __BO_SERVICES_IO_IOPOTYPES__
# define __BO_SERVICES_IO_IOPOTYPES__

/******************************************************************************
 * %% BeginSection: includes
 */

# ifndef __BO_SERVICES_IO_IOSTYPES__
#  include <Bo/services/io/Iostypes.h>
# endif

/******************************************************************************
 * %% BeginSection: constant/type declarations
 */
# pragma mark -
# pragma mark [ constant/type declarations ]
# pragma mark -

/*
 * IOP message
 */

# define AorpL_IOPMSG_SIZE_MAX 512 /* sizeof(struct aorp_iopmsg_xxx) */

typedef u_int32_t aorp_iopmfmt_t;

struct aorp_iopmsg {
	aorp_iopmfmt_t  fmt;
};

struct aorp_iopmsg_raw {
	aorp_iopmfmt_t      fmt;
	struct bo_nabsbuf   buf;
};

struct aorp_iopmsg_rawx {
	aorp_iopmfmt_t      fmt;
	struct bo_nabsbufx  buf;
};

typedef void
(__myc_tcalltype__(mcall) *aorp_iopmsg_destroy_cb)(
# if __myc_require(prototypes)
	bo_pointer_t
# endif
	) __attribute__((mcalltype));

struct aorp_iopmsg_dcb {
	aorp_iopmfmt_t          fmt;
	aorp_iopmsg_destroy_cb  destroy_self;
	/* data */
};
# define aorp_iopmsg_dcb_p(x) ((struct aorp_iopmsg_dcb *)(x))

# define AORP_IOPMSG_DCB_Destroy(aMsg) \
	do { \
		if (NULLF != aorp_iopmsg_dcb_p(aMsg)->destroy_self) \
			(*aorp_iopmsg_dcb_p(aMsg)->destroy_self)(aMsg); \
	} while (0)

/*
 * [well known] values for aorp_iopmsg.fmt
 */

# define AorpK_IOPMSG_INVAL_FORMAT (-1)
# define AorpK_IOPMSG_NULL_FORMAT (0)
# define AorpK_IOPMSG_UNK_FORMAT (2)

# define AorpK_IOPMSG_RAW_FORMAT __myc_mk4ccs("msg-")
# define _AorpK_IOPMSG_RAW_FORMAT __myc_mk4cc('m','s','g','-')

# define AorpK_IOPMSG_RAWX_FORMAT __myc_mk4ccs("msg+")
# define _AorpK_IOPMSG_RAWX_FORMAT __myc_mk4cc('m','s','g','+')

/* dummy */
# define AorpK_IOPMSG_DCB_FORMAT __myc_mk4ccs("mdcb")
# define _AorpK_IOPMSG_DCB_FORMAT __myc_mk4cc('m','d','c','b')

#endif /* !__BO_SERVICES_IO_IOPOTYPES__ */

/******************************************************************************
 * Revision History:
 *		$Log$
 *
 *****************************************************************************/
