/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright (c) 2005-2007 V.Sokur
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

/*
 * Iosnotice.h	(V.Sokur)
 * include/Bo/services/io/Iosnotice.h
 *
 * $Id$
 */

/* ------------------------------------------------------------------------- */

#ifndef __BO_SERVICES_IO_IOSNOTICE__
# define __BO_SERVICES_IO_IOSNOTICE__

/******************************************************************************
 * %% BeginSection: constant/type declarations
 */
# pragma mark -
# pragma mark [ constant/type declarations ]
# pragma mark -

# define AorpK_IosNotice_Error (3)
# define AorpK_IosNotice_Timer (4)

# define AorpK_IosNotice_EOF (10) /* end of file */
# define AorpK_IosNotice_EOSEG (11) /* end of segment */
# define AorpK_IosNotice_EOSTR (12) /* end of streaming (@todo: ???) */

# define AorpK_IosNotice_Opening (20)
# define AorpK_IosNotice_OpenDone (21) /* (success or fail) */
# define AorpK_IosNotice_Closing (22)
# define AorpK_IosNotice_CloseDone (23) /* (success or fail) */
# define AorpK_IosNotice_Starting (24)
# define AorpK_IosNotice_Started (25) /* (success or fail) */
# define AorpK_IosNotice_Stopping (26)
# define AorpK_IosNotice_Stopped (27) /* (success or fail) */
# define AorpK_IosNotice_Suspended (28)
# define AorpK_IosNotice_Resumed (29)

# define AorpK_IosNotice_BeginBuffering (30) /* start buffering content */
# define AorpK_IosNotice_EndBuffering (31) /* buffering content completed */

# define AorpK_IosNotice_Connecting (40) /* start connecting to a server */
# define AorpK_IosNotice_ConnectDone (41) /* connect to a server completed (success or fail) */
# define AorpK_IosNotice_Reconnecting (42)
# define AorpK_IosNotice_ReconnectDone (43) /* (success or fail) */
# define AorpK_IosNotice_ClientConnect (44)
# define AorpK_IosNotice_ClientDisconnect (45)

# define AorpK_IosNotice_BindDone (101)
# define AorpK_IosNotice_RebindDone (102)
# define AorpK_IosNotice_UnbindDone (103)

#endif /* !__BO_SERVICES_IO_IOSNOTICE__ */

/******************************************************************************
 * Revision History:
 *		$Log$
 *
 *****************************************************************************/
