/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright (c) 2005-2007 V.Sokur
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

/*
 * Iospolldef.h	(V.Sokur)
 * include/Bo/services/io/Iospolldef.h
 *
 * $Id$
 */

/* ------------------------------------------------------------------------- */

#ifndef __BO_SERVICES_IO_IOSPOLLDEF__
# define __BO_SERVICES_IO_IOSPOLLDEF__

/******************************************************************************
 * %% BeginSection: includes
 */

# include <Bo/sys/Types.h>

/******************************************************************************
 * %% BeginSection: constant/type declarations
 */
# pragma mark -
# pragma mark [ constant/type declarations ]
# pragma mark -

# ifndef AORP_POLLEVENTS_DEFINED
struct aorp_pollevents {
	u_int16_t  events;  /* events to look for */
	u_int16_t  revents; /* events returned */
};
#  define AORP_POLLEVENTS_DEFINED
# endif /* !AORP_POLLEVENTS_DEFINED */

# ifndef AorpF_POLLRDNORM
#  define AorpF_POLLRDNORM 0x0100
#  define AorpF_POLLRDBAND 0x0200
#  define AorpF_POLLIN (AorpF_POLLRDNORM | AorpF_POLLRDBAND)
#  define AorpF_POLLPRI 0x0400

#  define AorpF_POLLWRNORM 0x0010
#  define AorpF_POLLOUT AorpF_POLLWRNORM
#  define AorpF_POLLWRBAND 0x0020

#  define AorpF_POLLERR 0x0001
#  define AorpF_POLLHUP 0x0002
#  define AorpF_POLLNVAL 0x0004
# endif /* !AorpF_POLLRDNORM */

#endif /* !__BO_SERVICES_IO_IOSPOLLDEF__ */

/******************************************************************************
 * Revision History:
 *		$Log$
 *
 *****************************************************************************/
