/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright (c) 2005-2007 V.Sokur
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

/*
 * Iostypes.h	(V.Sokur)
 * include/Bo/services/io/Iostypes.h
 *
 * $Id$
 */

/* ------------------------------------------------------------------------- */

#ifndef __BO_SERVICES_IO_IOSTYPES__
# define __BO_SERVICES_IO_IOSTYPES__

/******************************************************************************
 * %% BeginSection: includes
 */

# include <Bo/Types.h>
# include <Bo/Statedefs.h>
# include <Bo/Optdefs.h>
# include <Bo/Trpdefs.h>

# include <Bo/services/io/Ioscntlcom.h>
# include <Bo/services/io/Iosnotice.h>
# include <Bo/services/io/Iospolldef.h>
/*
# include <Bo/services/io/Cmniosopt.h>
# include <Bo/services/io/Fiosopt.h>
# include <Bo/services/io/Miosopt.h>
 */

/******************************************************************************
 * %% BeginSection: constant/type declarations
 */
# pragma mark -
# pragma mark [ constant/type declarations ]
# pragma mark -

# define AorpK_IOS_BUFSIZ 1024


typedef int aorp_iobufmode_t;

# ifndef AorpK_IOS_NONEBF
#  define AorpK_IOS_NONEBF (0)
#  define AorpK_IOS_LINEBF (1)
#  define AorpK_IOS_FULLBF (2)
# endif


typedef int aorp_seekorigin_t;

/*
 * values for seek origin
 */

# ifndef AorpK_IOS_SEEK_BEG
#  define AorpK_IOS_SEEK_BEG (0)
#  define AorpK_IOS_SEEK_CUR (1)
#  define AorpK_IOS_SEEK_END (2)
/* flags used with origin */
#  define AorpK_IOS_SEEK_RDPOS 0x0
#  define AorpK_IOS_SEEK_WRPOS 0x10
# endif


typedef int aorp_seekformat_t;

/*
 * values for seek format
 */

# ifndef AorpK_SEEK_INVAL_FORMAT
#  define AorpK_SEEK_INVAL_FORMAT (-1)
#  define AorpK_SEEK_NULL_FORMAT (0)
#  define AorpK_SEEK_UNK_FORMAT (2)
#  define AorpK_SEEK_BIN_FORMAT (3)
#  define AorpK_SEEK_NTIME_FORMAT (4) /* nanoseconds */
#  define AorpK_SEEK_UTIME_FORMAT (5) /* microseconds */
#  define AorpK_SEEK_VIDEOFRAME_FORMAT (6)
#  define AorpK_SEEK_PLAYLIST_FORMAT (7)
#  define AorpK_SEEK_SMPTE_FORMAT (8)
# endif

/*
 * read/write flags
 */

# define AorpF_IOR_PEEK 0x0100 /* read without modifying the file pointer */

/*
 * MUI flags
 */

# define AorpF_MUI_EXTRAS 0x0100 /* pause(resume, ...) streams additionly to the paused */
# define AorpF_MUI_START_PAUSED 0x0200
# define AorpF_MUI_PORT_ONLY 0x0400 /* apply options(params, ...) to a port only */

#endif /* !__BO_SERVICES_IO_IOSTYPES__ */

/******************************************************************************
 * Revision History:
 *		$Log$
 *
 *****************************************************************************/
