/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright (c) 2005-2007 V.Sokur
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

/*
 * MUI.h	(V.Sokur)
 * include/Bo/services/io/MUI.h
 *
 * $Id$
 */

/* ------------------------------------------------------------------------- */

#ifndef __BO_SERVICES_IO_MUI__
# define __BO_SERVICES_IO_MUI__

/******************************************************************************
 * %% BeginSection: includes
 */

# include <Bo/services/io/MUIP.h>

/******************************************************************************
 * %% BeginSection: function prototypes
 */
# pragma mark -
# pragma mark [ function prototypes ]
# pragma mark -

__MYC_BEGIN_CDECLS

/*
bo_status_t
__attribute__((nonnull(1)))
AorpMUISetup(
	aorp_object_t aThis,
	aorp_opflags_t Flags,       // = 0
	struct bo_options *Options, // = NULL
	struct aorp_error *anErrPtr
	);
 */
# define AorpMUISetup(aThis, Flags, Options, anErrPtr) \
	_A_call(setup, mui, aThis, anErrPtr, Flags, Options)

# pragma mark -

/*
bo_status_t
__attribute__((nonnull(1)))
AorpMUITeardown(
	aorp_object_t aThis,
	aorp_opflags_t Flags,       // = 0
	struct bo_options *Options, // = NULL
	struct aorp_error *anErrPtr
	);
 */
# define AorpMUITeardown(aThis, Flags, Options, anErrPtr) \
	_A_call(teardown, mui, aThis, anErrPtr, Flags, Options)

# pragma mark -

/*
bo_status_t
__attribute__((nonnull(1)))
AorpMUIStart(
	aorp_object_t aThis,
	aorp_opflags_t Flags,       // = 0
	struct bo_options *Options, // = NULL
	struct aorp_error *anErrPtr
	);
 */
# define AorpMUIStart(aThis, Flags, Options, anErrPtr) \
	_A_call(start, mui, aThis, anErrPtr, Flags, Options)

# define AorpMUIPlay(aThis, Flags, Options, anErrPtr) \
	AorpMUIStart(aThis, Flags, Options, anErrPtr)

# pragma mark -

/*
bo_status_t
__attribute__((nonnull(1)))
AorpMUIStop(
	aorp_object_t aThis,
	aorp_opflags_t Flags,       // = 0
	struct bo_options *Options, // = NULL
	struct aorp_error *anErrPtr
	);
 */
# define AorpMUIStop(aThis, Flags, Options, anErrPtr) \
	_A_call(stop, mui, aThis, anErrPtr, Flags, Options)

# pragma mark -

/*
bo_status_t
__attribute__((nonnull(1)))
AorpMUIPause(
	aorp_object_t aThis,
	aorp_opflags_t Flags,       // = 0
	struct bo_options *Options, // = NULL
	struct aorp_error *anErrPtr
	);
 */
# define AorpMUIPause(aThis, Flags, Options, anErrPtr) \
	_A_call(pause, mui, aThis, anErrPtr, Flags, Options)

# pragma mark -

/*
bo_status_t
__attribute__((nonnull(1)))
AorpMUIResume(
	aorp_object_t aThis,
	aorp_opflags_t Flags,       // = 0
	struct bo_options *Options, // = NULL
	struct aorp_error *anErrPtr
	);
 */
# define AorpMUIResume(aThis, Flags, Options, anErrPtr) \
	_A_call(resume, mui, aThis, anErrPtr, Flags, Options)

__MYC_END_CDECLS

#endif /* !__BO_SERVICES_IO_MUI__ */

/******************************************************************************
 * Revision History:
 *		$Log$
 *
 *****************************************************************************/
