/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright (c) 2005-2007 V.Sokur
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 * Idea is originated with Ritchie D.M., "A Stream Input-Output System"
 */

/*
 * Strjet.h	(V.Sokur)
 * include/Bo/services/io/Strjet.h
 *
 * $Id$
 */

/* ------------------------------------------------------------------------- */

#ifndef __BO_SERVICES_IO_STRJET__
# define __BO_SERVICES_IO_STRJET__

/******************************************************************************
 * %% BeginSection: includes
 */

# include <Bo/services/Strmtypes.h>

/******************************************************************************
 * %% BeginSection: type/constant declarations
 */
# pragma mark -
# pragma mark [ type/constant declarations ]
# pragma mark -

# include <Bo/services/Strmop.h>

/******************************************************************************
 * %% BeginSection: function prototypes
 */
# pragma mark -
# pragma mark [ function prototypes ]
# pragma mark -

__MYC_BEGIN_CDECLS

/*
bo_status_t
__attribute__((nonnull(1,2,3)))
AorpOpenstrum(
	aorp_object_t aThis,
	char const *aName,
			// ex.: "/dev/strum/<device>";
			//   where device:
			//   -) zero device [any free]; zeroN: zero0, zero1, ...
			//   -) rfx - remote functional execution device [any free]; rfxN: rfx0, rfx1, ...
			//   -) ...
	aorp_object_t *aStrumPtr,
	struct aorp_error *anErrPtr
	);
 */
# define AorpOpenstrum(aThis, aName, aStrumPtr, anErrPtr) \
	_A_call(openstrum, strjet, aThis, anErrPtr, aName, aStrumPtr)

# pragma mark -

/*
bo_status_t
__attribute__((nonnull(1,2)))
_AorpClosestrum(
	aorp_object_t aThis,
	aorp_object_t aStrum,
	struct aorp_error *anErrPtr
	);
 */
# define _AorpClosestrum(aThis, aStrum, anErrPtr) \
	_A_call(closestrum, strjet, aThis, anErrPtr, aStrum)

# pragma mark -

/*
bo_status_t
__attribute__((nonnull(1)))
_AorpStrjetCloseall(
	aorp_object_t aThis,
	struct aorp_error *anErrPtr
	);
 */
# define _AorpStrjetCloseall(aThis, anErrPtr) \
	_A_call(closeall, strjet, aThis, anErrPtr)

# pragma mark -

/*
bo_status_t
__attribute__((nonnull(1,2,4)))
_AorpStrjetRegister(
	aorp_object_t aThis,
	char *aMajorName,
	unsigned aMinorNum,
	aorp_object_t aStrum,
	struct aorp_error *anErrPtr
	);
 */
# define _AorpStrjetRegister(aThis, aMajorName, aMinorNum, aStrum, anErrPtr) \
	_A_call(register, strjet, aThis, anErrPtr, aMajorName, aMinorNum, aStrum)

# pragma mark -

/*
bo_status_t
__attribute__((nonnull(1,2)))
_AorpStrjetUnregister(
	aorp_object_t aThis,
	char *aMajorName,
	unsigned aMinorNum
	struct aorp_error *anErrPtr
	);
 */
# define _AorpStrjetUnregister(aThis, aMajorName, aMinorNum, anErrPtr) \
	_A_call(unregister, strjet, aThis, anErrPtr, aMajorName, aMinorNum)

# pragma mark -

/*
bo_status_t
__attribute__((nonnull(1,2)))
_AorpStrjetGetalloc(
	aorp_object_t aThis,
	struct strm_alloctx const **anAllocPtr,
	struct aorp_error *anErrPtr
	);
 */
# define _AorpStrjetGetalloc(aThis, anAllocPtr, anErrPtr) \
	_A_call(getalloc, strjet, aThis, anErrPtr, anAllocPtr)

__MYC_END_CDECLS

#endif /* !__BO_SERVICES_IO_STRJET__ */

/******************************************************************************
 * Revision History:
 *		$Log$
 *
 *****************************************************************************/
