/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright (c) 2005-2007 V.Sokur
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 * Idea is originated with Ritchie D.M., "A Stream Input-Output System"
 */

/*
 * Strmod.h	(V.Sokur)
 * include/Bo/services/io/Strmod.h
 *
 * $Id$
 */

/* ------------------------------------------------------------------------- */

#ifndef __BO_SERVICES_IO_STRMOD__
# define __BO_SERVICES_IO_STRMOD__

/******************************************************************************
 * %% BeginSection: includes
 */

# include <Bo/services/Strmtypes.h>

/******************************************************************************
 * %% BeginSection: type/constant declarations
 */
# pragma mark -
# pragma mark [ type/constant declarations ]
# pragma mark -

# include <Bo/services/Strmop.h>

/******************************************************************************
 * %% BeginSection: function prototypes
 */
# pragma mark -
# pragma mark [ function prototypes ]
# pragma mark -

__MYC_BEGIN_CDECLS

/*
bo_status_t
__attribute__((nonnull(1,2)))
_AorpStrmodOpen(
	aorp_object_t aThis,
	aorp_object_t aStrum,
	int aQuetype,
	struct aorp_error *anErrPtr
	);
 */
# define _AorpStrmodOpen(aThis, aStrum, aQuetype, anErrPtr) \
	_A_call(open, strmod, aThis, anErrPtr, aStrum, aQuetype)

# pragma mark -

/*
bo_status_t
__attribute__((nonnull(1,2)))
_AorpStrmodClose(
	aorp_object_t aThis,
	aorp_object_t aStrum,
	int aQuetype,
	struct aorp_error *anErrPtr
	);
 */
# define _AorpStrmodClose(aThis, aStrum, aQuetype, anErrPtr) \
	_A_call(close, strmod, aThis, anErrPtr, aStrum, aQuetype)

# pragma mark -

/*
bo_status_t
__attribute__((nonnull(1,2)))
_AorpStrmodConnect(
	aorp_object_t aThis,
	struct strm_queue *aQue,
	int aQuetype,
	int aConntype,
	struct aorp_error *anErrPtr
	);
 */
# define _AorpStrmodConnect(aThis, aQue, aQuetype, aConntype, anErrPtr) \
	_A_call(connect, strmod, aThis, anErrPtr, aQue, aQuetype, aConntype)

# pragma mark -

/*
bo_status_t
__attribute__((nonnull(1,2)))
_AorpStrmodCanconnect(
	aorp_object_t aThis,
	struct strm_queue *aQue,
	int aQuetype,
	int aConntype,
	struct strm_conninfo const *aRqInfo,
	struct strm_conninfo *aReInfo,
	struct aorp_error *anErrPtr
	);
 *
 * BoS_OK: success, yes
 * BoS_NORMAL: success, no
 */
# define _AorpStrmodCanconnect(aThis, aQue, aQuetype, aConntype, aRqInfo, aReInfo, anErrPtr) \
	_A_call(canconnect, strmod, aThis, anErrPtr, aQue, aQuetype, aConntype, aRqInfo, aReInfo)

# pragma mark -

/*
bo_status_t
__attribute__((nonnull(1)))
_AorpStrmodPoll(
	aorp_object_t aThis,
	int aQuetype,
	struct aorp_error *anErrPtr
	);
 *
 * BoS_OK: success, yes
 * BoS_NORMAL: success, no
 * BoS_STRMOD_AFUNC: afunctional
 */
# define _AorpStrmodPoll(aThis, aQuetype, anErrPtr) \
	_A_call(poll, strmod, aThis, anErrPtr, aQuetype)

# pragma mark -

/*
bo_status_t
__attribute__((nonnull(1,2,3)))
_AorpStrmodPutmsg(
	aorp_object_t aThis,
	struct strm_queue *aQue,
	struct strm_msg_ds *aMsg,
	struct aorp_error *anErrPtr
	);
 *
 * BoS_OK: if OKAY(strum.putnext)
 * BoS_NORMAL: if SUCCESS(strum.putnext)
 */
# define _AorpStrmodPutmsg(aThis, aQue, aMsg, anErrPtr) \
	_A_call(putmsg, strmod, aThis, anErrPtr, aQue, aMsg)

# pragma mark -

/*
bo_status_t
__attribute__((nonnull(1,2)))
_AorpStrmodService(
	aorp_object_t aThis,
	struct strm_queue *aQue,
	struct aorp_error *anErrPtr
	);
 *
 * BoS_OK: success, yes
 * BoS_NORMAL: success, no
 * BoS_STRMOD_AFUNC: afunctional
 */
# define _AorpStrmodService(aThis, aQue, anErrPtr) \
	_A_call(service, strmod, aThis, anErrPtr, aQue)

# pragma mark -

/*
bo_status_t
__attribute__((nonnull(1,2)))
_AorpStrmodGetinfo(
	aorp_object_t aThis,
	struct strm_modinfo const **anInfoPtr,
	struct aorp_error *anErrPtr
	);
 */
# define _AorpStrmodGetinfo(aThis, anInfoPtr, anErrPtr) \
	_A_call(getinfo, strmod, aThis, anErrPtr, anInfoPtr)

# pragma mark -

/*
bo_status_t
__attribute__((nonnull(1,2)))
_AorpStrmodGetstat(
	aorp_object_t aThis,
	struct strm_modstat **aStatPtr,
	struct aorp_error *anErrPtr
	);
 */
# define _AorpStrmodGetstat(aThis, aStatPtr, anErrPtr) \
	_A_call(getstat, strmod, aThis, anErrPtr, aStatPtr)

__MYC_END_CDECLS

#endif /* !__BO_SERVICES_IO_STRMOD__ */

/******************************************************************************
 * Revision History:
 *		$Log$
 *
 *****************************************************************************/
