/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright (c) 2005-2007 V.Sokur
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 * Idea is originated with Ritchie D.M., "A Stream Input-Output System"
 */

/*
 * Strmop.h	(V.Sokur)
 * include/Bo/services/io/Strmop.h
 *
 * $Id$
 */

/* ------------------------------------------------------------------------- */

#ifndef __BO_SERVICES_IO_STRM_OP__
# define __BO_SERVICES_IO_STRM_OP__

/******************************************************************************
 * %% BeginSection: constant declarations
 */
# pragma mark -
# pragma mark [ constant declarations ]
# pragma mark -

/*
 * strjet {\object(class)}
 */
/*
# define AorpK_strjet_service (1075)
# define AorpK_strjet_service_subclassable 0
 */
# include <Bo/services/MIB/Services.h>

# define AorpK_strjet_openstrum (4)
# define AorpK_strjet_closestrum (5) /* not for direct usage */
# define AorpK_strjet_closeall (6)   /* not for direct usage */
# define AorpK_strjet_register (7)   /* register strum, not for direct usage */
# define AorpK_strjet_unregister (8) /* unregister strum, called by the strum */
# define AorpK_strjet_getalloc (9)
# define AorpK_strjet_opc (10)

/*
 * strum {\object(instance)}
 */
/*
# define AorpK_strum_service (1076)
# define AorpK_strum_service_subclassable 0
 */
# include <Bo/services/MIB/Services.h>

# define AorpK_strum_start (4)
# define AorpK_strum_stop (5)

# define AorpK_strum_lock (6)
# define AorpK_strum_unlock (7)

# define AorpK_strum_findmod (8)
# define AorpK_strum_addmod (9)
# define AorpK_strum_rmmod (10)
# define AorpK_strum_delmod (11)

# define AorpK_strum_connect (12)
# define AorpK_strum_reserved1 (13)

# define AorpK_strum_putnext (14)
# define AorpK_strum_canputnext (15)
# define AorpK_strum_pushwq (16)  /* push [back] to wait que */
# define AorpK_strum_pushfwq (17) /* push [front] to wait que */
# define AorpK_strum_popwq (18)   /* pop [front] from wait que */

# define AorpK_strum_getalloc (19)

# define AorpK_strum_opc (20)

/*
 * strmod {\object(instance)}
 */
/*
# define AorpK_strmod_service (1077)
# define AorpK_strmod_service_subclassable 0
 */
# include <Bo/services/MIB/Services.h>

# define AorpK_strmod_open (4)
# define AorpK_strmod_close (5)
# define AorpK_strmod_connect (6)
# define AorpK_strmod_canconnect (7)
# define AorpK_strmod_poll (8)
# define AorpK_strmod_putmsg (9)
# define AorpK_strmod_service (10)
# define AorpK_strmod_getinfo (11)
# define AorpK_strmod_getstat (12)
# define AorpK_strmod_opc (13)

#endif /* !__BO_SERVICES_IO_STRM_OP__ */

/******************************************************************************
 * Revision History:
 *		$Log$
 *
 *****************************************************************************/
