/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright (c) 2005-2007 V.Sokur
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

/*
 * Job.h	(V.Sokur)
 * include/Bo/services/jobcntl/Job.h
 *
 * $Id$
 */

/* ------------------------------------------------------------------------- */

#ifndef __BO_SERVICES_JOBCNTL_JOB__
# define __BO_SERVICES_JOBCNTL_JOB__

/******************************************************************************
 * %% BeginSection: includes
 */

# include <Bo/services/jobcntl/JobP.h>

/******************************************************************************
 * %% BeginSection: function prototypes
 */
# pragma mark -
# pragma mark [ function prototypes ]
# pragma mark -

__MYC_BEGIN_CDECLS

/* NOT FOR YOUR BUSINESS
 * Theses operations are intended to be called by a runloop.
 * @{
 */

/*
bo_status_t
__attribute__((nonnull(1)))
_AorpJobSchedule(
	aorp_object_t ,
	aorp_object_t ,
	unsigned ,
	struct aorp_error *
	);
 */
# define _AorpJobSchedule(x, y1, y2, z) _A_call(schedule, job, x, z, y1, y2)

# pragma mark -

/*
bo_status_t
__attribute__((nonnull(1)))
_AorpJobUnschedule(
	aorp_object_t ,
	aorp_object_t ,
	struct aorp_error *
	);
 */
# define _AorpJobUnschedule(x, y, z) _A_call(unschedule, job, x, z, y)

# pragma mark -

/*
bo_status_t
__attribute__((nonnull(1)))
_AorpJobExec(
	aorp_object_t ,
	bo_pointer_t ,
	struct aorp_error *
	);
 */
# define _AorpJobExec(x, y, z) _A_call(exec, job, x, z, y)

/* @} */

__MYC_END_CDECLS

#endif /* !__BO_SERVICES_JOBCNTL_JOB__ */

/******************************************************************************
 * Revision History:
 *		$Log$
 *
 *****************************************************************************/
