/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright (c) 2005-2007 V.Sokur
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

/*
 * Runloopop.h	(V.Sokur)
 * include/Bo/services/jobcntl/Runloopop.h
 *
 * $Id$
 */

/* ------------------------------------------------------------------------- */

#ifndef __BO_SERVICES_JOBCNTL_RUNLOOP_OP__
# define __BO_SERVICES_JOBCNTL_RUNLOOP_OP__

/******************************************************************************
 * %% BeginSection: constant declarations
 */
# pragma mark -
# pragma mark [ constant declarations ]
# pragma mark -

# define AorpK_runloop_run (4)
# define AorpK_runloop_cancel (5)
# define AorpK_runloop_suspend (6)
# define AorpK_runloop_resume (7)

# define AorpK_runloop_lockjl (8)
# define AorpK_runloop_unlockjl (9)

# define AorpK_runloop_execjob (10)
# define AorpK_runloop_findjob (11)
# define AorpK_runloop_findjob_nlk (12)
# define AorpK_runloop_addjob (13)
# define AorpK_runloop_addjob_nlk (14)
# define AorpK_runloop_rmjob (15)
# define AorpK_runloop_rmjob_nlk (16)
# define AorpK_runloop_deljob (17)
# define AorpK_runloop_deljob_nlk (18)

# define AorpK_runloop_getjobstatus (19)
# define AorpK_runloop_getstate (20)

# define AorpK_runloop_getperiod (21)
# define AorpK_runloop_setperiod (22)

# define AorpK_runloop_addjob3 (23)
# define AorpK_runloop_addjob3_nlk (24)
# define AorpK_runloop_getmode (25)

# define AorpK_runloop_cancelf (26)
# define AorpK_runloop_suspendf (27)
# define AorpK_runloop_resumef (28)

# define AorpK_runloop_opc (29)

#endif /* !__BO_SERVICES_JOBCNTL_RUNLOOP_OP__ */

/******************************************************************************
 * Revision History:
 *		$Log$
 *
 *****************************************************************************/
