/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright (c) 2009 V.Sokur
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

/*
 * Oti.h	(S.Makhmali)
 * include/Bo/services/net/Oti.h
 *
 * $Id$
 */

/* ------------------------------------------------------------------------- */

#ifndef __BO_SERVICES_NET_OTI__
# define __BO_SERVICES_NET_OTI__

/******************************************************************************
 * %% BeginSection: includes
 */

# include <Bo/services/net/OtiP.h>

// @todo: redesign
# if __myc_exists(netinet7in,h)
#  include __MYC_LIBC_HEADER(netinet/in.h)
	/* address structures */
# endif
# if __myc_exists(winsock2,h)
#  include __MYC_LIBC_HEADER(winsock2.h)
#  ifndef HAS_TIMEVAL_STRUC
#   define HAS_TIMEVAL_STRUC
#  endif
# endif

/******************************************************************************
 * %% BeginSection: function prototypes
 */
# pragma mark -
# pragma mark [ function prototypes ]
# pragma mark -

__MYC_BEGIN_CDECLS

/*
bo_status_t
__attribute__((nonnull(1)))
AorpOtiMkListen(
	aorp_object_t aThis,
	struct aorp_error *anErrPtr
	);
 */
# define AorpOtiMkListen(aThis, anErrPtr) \
	_A_call(mklisten, oti, aThis, anErrPtr)

# pragma mark -

/*
bo_status_t
__attribute__((nonnull(1,2)))
AorpOtiListen(
	aorp_object_t aThis,
	bo_pointer_t anUconn,
	size_t aBufsz,
	struct aorp_oti_tcall **aCall,
	struct aorp_error *anErrPtr
	);
 */
# define AorpOtiListen(aThis, anUconn, aBufsz, aCall, anErrPtr) \
	_A_call(listen, oti, aThis, anErrPtr, anUconn, aBufsz, aCall)

# pragma mark -

/*
bo_status_t
__attribute__((nonnull(1,2,3)))
AorpOtiAccept(
	aorp_object_t aThis,
	aorp_object_t aConnobj,
	struct aorp_oti_tcall *aCall,
	struct aorp_error *anErrPtr
	);
*/
# define AorpOtiAccept(aThis, aConnobj, aCall, anErrPtr) \
	_A_call(accept, oti, aThis, anErrPtr, aConnobj, aCall)

# pragma mark -

/*
bo_status_t
__attribute__((nonnull(1)))
AorpOtiConnect(
	aorp_object_t aThis,
	struct bo_uconn_ds *anUconn,
	struct bo_options *Options,
	struct bo_nabsbuf *aUdata,
	struct aorp_oti_tcall **aRecvcall,
	struct aorp_error *anErrPtr
	);
 */
# define AorpOtiConnect(aThis, anUconn, Options, aUdata, aRecvcall, anErrPtr) \
	_A_call(connect, oti, aThis, anErrPtr, anUconn, Options, aUdata, aRecvcall)

# pragma mark -

/*
ssize_t
__attribute__((nonnull(1,2)))
AorpOtiReceive(
	aorp_object_t aThis,
	bo_pointer_t aBuffer,
	size_t aBufsz,
	int *FlagsPtr,
	struct aorp_error *anErrPtr
	);
*/
# define AorpOtiReceive(aThis, aBuffer, aBufsz, FlagsPtr, anErrPtr) \
	((ssize_t) _A_call(receive, oti, aThis, anErrPtr, aBuffer, (size_t)(aBufsz), FlagsPtr))

# pragma mark -

/*
ssize_t
__attribute__((nonnull(1,2)))
AorpOtiSend(
	aorp_object_t aThis,
	bo_const_pointer_t aBuffer,
	size_t aLen,
	int Flags,
	struct aorp_error *anErrPtr
	);
*/
# define AorpOtiSend(aThis, aBuffer, aLen, Flags, anErrPtr) \
	((ssize_t) _A_call(send, oti, aThis, anErrPtr, aBuffer, (size_t)(aLen), Flags))

# pragma mark -

/*
ssize_t
__attribute__((nonnull(1,4)))
AorpOtiRcvudata(
	aorp_object_t aThis,
	struct bo_uconn_ds *anUconn,
	struct bo_options *Options,
	struct bo_nabsbuf *aUdata,
	int *FlagsPtr,
	struct aorp_error *anErrPtr
);
*/
# define AorpOtiRcvudata(aThis, anUconn, Options, aUdata, FlagsPtr, anErrPtr) \
	((ssize_t) _A_call(rcvudata, oti, aThis, anErrPtr, anUconn, Options, aUdata, FlagsPtr))

# pragma mark -

/*
bo_status_t
__attribute__((nonnull(1,2)))
AorpOtiRcvuderr(
	aorp_object_t aThis,
	struct aorp_oti_tuderr *aUderr,
	struct aorp_error *anErrPtr
);
*/
# define AorpOtiRcvuderr(aThis, aUderr, anErrPtr) \
	_A_call(rcvudata, oti, aThis, anErrPtr, aUderr)

# pragma mark -

/*
ssize_t
__attribute__((nonnull(1,4)))
AorpOtiSndudata(
	aorp_object_t aThis,
	struct bo_uconn_ds *anUconn,
	struct bo_options *Options,
	struct bo_nabsbuf *aUdata,
	int Flags,
	struct aorp_error *anErrPtr
);
*/
# define AorpOtiSndudata(aThis, anUconn, Options, aUdata, Flags, anErrPtr) \
	((ssize_t) _A_call(sndudata, oti, aThis, anErrPtr, anUconn, Options, aUdata, Flags))

# pragma mark -

/*
ssize_t
__attribute__((nonnull(1,4)))
AorpOtiRcvvudata(
	aorp_object_t aThis,
	struct bo_uconn_ds *anUconn,
	struct bo_options *Options,
	struct bo_qnabsbuf *aUdatav,
	ssize_t aUdatac
	int *FlagsPtr,
	struct aorp_error *anErrPtr
);
*/
# define AorpOtiRcvvudata(aThis, anUconn, Options, aUdatav, aUdatac, FlagsPtr, anErrPtr) \
	((ssize_t) _A_call(rcvvudata, oti, aThis, anErrPtr, anUconn, Options, aUdatav, aUdatac, FlagsPtr))

# pragma mark -

/*
ssize_t
__attribute__((nonnull(1,4)))
AorpOtiSndvudata(
	aorp_object_t aThis,
	struct bo_uconn_ds *anUconn,
	struct bo_options *Options,
	struct bo_qnabsbuf *aUdatav,
	ssize_t aUdatac
	int Flags,
	struct aorp_error *anErrPtr
);
*/
# define AorpOtiSndvudata(aThis, anUconn, Options, aUdatav, aUdatac, Flags, anErrPtr) \
	((ssize_t) _A_call(sndvudata, oti, aThis, anErrPtr, anUconn, Options, aUdatav, (ssize_t)(aUdatac), Flags))

# pragma mark -

/*
ssize_t
__attribute__((nonnull(1,2)))
AorpOtiRecvmsg(
	aorp_object_t aThis,
	struct aorp_oti_msghdr *aMsg,
	int Flags,
	struct aorp_error *anErrPtr
	);
*/
# define AorpOtiRecvmsg(aThis, aMsg, Flags, anErrPtr) \
	((ssize_t) _A_call(recvmsg, oti, aThis, anErrPtr, aMsg, Flags))

# pragma mark -

/*
ssize_t
__attribute__((nonnull(1,2)))
AorpOtiSendmsg(
	aorp_object_t aThis,
	struct aorp_oti_msghdr *aMsg,
	int Flags,
	struct aorp_error *anErrPtr
	);
*/
# define AorpOtiSendmsg(aThis, aMsg, Flags, anErrPtr) \
	((ssize_t) _A_call(sendmsg, oti, aThis, anErrPtr, aMsg, Flags))

# pragma mark -

/*
bo_status_t
__attribute__((nonnull(1)))
AorpOtiGetprotaddr(
	aorp_object_t aThis,
	struct aorp_oti_tbind **aLocaladdr,
	struct aorp_oti_tbind **aPeeraddr,
	struct aorp_error *anErrPtr
);
*/
# define AorpOtiGetprotaddr(aThis, aLocaladdr, aPeeraddr, anErrPtr) \
	_A_call(getprotaddr, oti, aThis, anErrPtr, aLocaladdr, aPeeraddr)

/*
bo_status_t
__attribute__((nonnull(1)))
AorpOtiDisconnect(
	aorp_object_t aThis,
	struct bo_nabsbuf *aUdata,
	int aSequence,
	struct aorp_error *anErrPtr
);
 */
# define AorpOtiDisconnect(aThis, aUdata, aSequence, anErrPtr) \
	_A_call(disconnect, oti, aThis, anErrPtr, aUdata, aSequence)

# pragma mark -

/*
bo_status_t
__attribute__((nonnull(1)))
AorpOtiShutdown(
	aorp_object_t aThis,
	int How,
	struct aorp_error *anErrPtr
);
 */
# define AorpOtiShutdown(aThis, How, anErrPtr) \
	_A_call(shutdown, oti, aThis, anErrPtr, How)

# pragma mark -

/*
bo_status_t
__attribute__((nonnull(1)))
AorpOtiSndrel(
	aorp_object_t aThis,
	struct aorp_error *anErrPtr
);
 */
# define AorpOtiSndrel(aThis, anErrPtr) \
	_A_call(shutdown, oti, aThis, anErrPtr, BoK_OTI_SHUT_WR)

# pragma mark -

/*
bo_status_t
__attribute__((nonnull(1)))
AorpOtiRcvrel(
	aorp_object_t aThis,
	struct aorp_error *anErrPtr
);
 */
# define AorpOtiRcvrel(aThis, anErrPtr) \
	_A_call(rcvrel, oti, aThis, anErrPtr)

# pragma mark -

/*
bo_status_t
__attribute__((nonnull(1)))
AorpOtiRcvdis(
	aorp_object_t aThis,
	struct aorp_oti_tdiscon aDiscon,
	struct aorp_error *anErrPtr
);
 */
# define AorpOtiRcvdis(aThis, aDiscon, anErrPtr) \
	_A_call(rcvdis, oti, aThis, anErrPtr, aDiscon)

__MYC_END_CDECLS

#endif /* !__BO_SERVICES_NET_OTI__ */

/******************************************************************************
 * Revision History:
 *		$Log$
 *
 *****************************************************************************/
