/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright (c) 2009 V.Sokur
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

/*
 * Otidcntl.h	(S.Makhmali)
 * include/Bo/services/net/Otidcntl.h
 *
 * $Id$
 */

/* ------------------------------------------------------------------------- */

#ifndef __BO_SERVICES_NET_OTIDCNTL__
# define __BO_SERVICES_NET_OTIDCNTL__

/******************************************************************************
 * %% BeginSection: includes
 */

# include <Bo/services/net/OtidcntlP.h>

/******************************************************************************
 * %% BeginSection: function prototypes
 */
# pragma mark -
# pragma mark [ function prototypes ]
# pragma mark -

__MYC_BEGIN_CDECLS


/*
aorp_object_t
__attribute__((nonnull(1)))
AorpOtiOpendev(
	aorp_object_t aSelf,
	struct bo_uconn_ds *anUconn,
	int OpenFlags,
	struct bo_tinfo_oti *anInfo,
	struct aorp_error *anErrPtr
	);
 */

# if __myc_support(macro_retval)
#  define AorpOtiOpendev(aSelf, anUconn, OpenFlags, anInfo, anErrPtr) \
	__extension__ ({ \
		bo_stsptr_t ___retval = _A_call(opendev, otidcntl, aSelf, anErrPtr, anUconn, OpenFlags, anInfo); \
		/* return */ (BoSP_NORMAL(___retval) ? BO_AOB_FROM_STATUS(___retval) : NULL); \
	})
# else
__myc_extern_inline__ aorp_object_t
AorpOtiOpendev(
	aorp_object_t aSelf,
	struct bo_uconn_ds *anUconn,
	int OpenFlags,
	struct bo_tinfo_oti *anInfo,
	struct aorp_error *anErrPtr
	)
{
	bo_stsptr_t retval = _A_call(opendev, otidcntl, aSelf, anErrPtr, anUconn, OpenFlags, anInfo);
	return (BoSP_NORMAL(retval) ? BO_AOB_FROM_STATUS(retval) : NULL);
}
# endif

__MYC_END_CDECLS

#endif /* !__BO_SERVICES_NET_OTIDCNTL__ */

/******************************************************************************
 * Revision History:
 *		$Log$
 *
 *****************************************************************************/
