/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright (c) 2009 V.Sokur
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

/*
 * OtidcntlP.h	(S.Makhmali)
 * include/Bo/services/net/OtidcntlP.h
 *
 * $Id$
 */

/* ------------------------------------------------------------------------- */

#ifndef __BO_SERVICES_NET_OTIDCNTL_P__
# define __BO_SERVICES_NET_OTIDCNTL_P__

/******************************************************************************
* %% BeginSection: includes
*/

# include <Bo/services/net/Otitypes.h>

/******************************************************************************
* %% BeginSection: otidcntl service declarations
*/
# pragma mark -
# pragma mark [ otidcntl service declarations ]
# pragma mark -

# define __aorpc_need_service_otidcntl 1

#endif /* !__BO_SERVICES_NET_OTIDCNTL_P__ */

#pragma mark -

#if __aorpc_uses_service(otidcntl)
# undef __aorpc_need_service_otidcntl

/*
 * otidcntl service
 * @{
 */

/*
 * otidcntl {\object(class)}
 */
/*
# define AorpK_otidcntl_service (1050)
 */
# include <Bo/services/MIB/Services.h>

# define __aorpc_service_name otidcntl
# include <Bo/aorp/AorpCsrvc.h>

_A_service(otidcntl)
_A_end_ctb

	_A_attribute((nonnull(1)))
	_A_op(opendev, "otidcntl::open-device", (
			struct aorp_closure *aClosure,
			struct aorp_error *anErrPtr,
			struct bo_uconn_ds *anUconn,
			int OpenFlags,
			struct bo_tinfo_oti *anInfo
		)),

_A_end;

# include <Bo/aorp/AorpCend.h>
/* @} */
#endif /* __aorpc_uses_service(otidcntl) */

/******************************************************************************
 * Revision History:
 *		$Log$
 *
 *****************************************************************************/
