/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright (c) 2005-2007 V.Sokur
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

/*
 * Pafi.h	(V.Sokur)
 * include/Bo/services/net/Pafi.h
 *
 * $Id$
 */

/* ------------------------------------------------------------------------- */

#ifndef __BO_SERVICES_NET_PAFI__
# define __BO_SERVICES_NET_PAFI__

/******************************************************************************
 * %% BeginSection: includes
 */

# include <Bo/services/net/PafiP.h>

/******************************************************************************
 * %% BeginSection: function prototypes
 */
# pragma mark -
# pragma mark [ function prototypes ]
# pragma mark -

__MYC_BEGIN_CDECLS

/*
char const *
__attribute__((nonnull(1)))
AorpPafiAfnamebyid(
	aorp_object_t aSelf,
	int anId,
	struct aorp_error *anErrPtr
	);
*/
# define AorpPafiAfnamebyid(aSelf, anId, anErrPtr) \
	((char const *)(intptr_t) _A_call(afnamebyid, pafi, aSelf, anErrPtr, anId, aNamePtr))

# pragma mark -

/*
int
__attribute__((nonnull(1,2)))
AorpPafiAfidbyname(
	aorp_object_t aSelf,
	char const *aName,
	struct aorp_error *anErrPtr
	);
*/
# define AorpPafiAfidbyname(aSelf, aName, anErrPtr) \
	((int) _A_call(afidbyname, pafi, aSelf, anErrPtr, aName))

# pragma mark -

/*
char const *
__attribute__((nonnull(1)))
AorpPafiProtonamebyid(
	aorp_object_t aSelf,
	int anId,
	struct aorp_error *anErrPtr
	);
*/
# define AorpPafiProtonamebyid(aSelf, anId, anErrPtr) \
	((char const *)(intptr_t) _A_call(protonamebyid, pafi, aSelf, anErrPtr, anId))

# pragma mark -

/*
int
__attribute__((nonnull(1,2)))
AorpPafiProtoidbyname(
	aorp_object_t aSelf,
	char const *aName,
	struct aorp_error *anErrPtr
	);
*/
# define AorpPafiProtoidbyname(aSelf, aName, anErrPtr) \
	((int) _A_call(protoidbyname, pafi, aSelf, anErrPtr, aName))

# pragma mark -

/*
bo_status_t
__attribute__((nonnull(1,3)))
AorpPafiProtoinfobyid(
	aorp_object_t aSelf,
	int anId,
	struct aorp_pafi_protoinfo *aResult,
	struct aorp_error *anErrPtr
	);
*/
# define AorpPafiProtoinfobyid(aSelf, anId, aResult, anErrPtr) \
	_A_call(protoinfobyid, pafi, aSelf, anErrPtr, anId, aResult)

# pragma mark -

/*
bo_status_t
__attribute__((nonnull(1,2,3)))
AorpPafiProtoinfobyname(
	aorp_object_t aSelf,
	char const *aName,
	struct aorp_pafi_protoinfo *aResult,
	struct aorp_error *anErrPtr
	);
*/
# define AorpPafiProtoinfobyname(aSelf, aName, aResult, anErrPtr) \
	_A_call(protoinfobyname, pafi, aSelf, anErrPtr, aName, aResult)

__MYC_END_CDECLS

#endif /* !__BO_SERVICES_NET_PAFI__ */

/******************************************************************************
 * Revision History:
 *		$Log$
 *
 *****************************************************************************/
