/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright (c) 2005-2007 V.Sokur
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

/*
 * GramspeccP.h	(N.Panasiuk)
 * include/Bo/services/textan/GramspeccP.h
 *
 * $Id$
 */

/* ------------------------------------------------------------------------- */

#ifndef __BO_SERVICES_TEXTAN_GRAMSPECC_P__
# define __BO_SERVICES_TEXTAN_GRAMSPECC_P__

/******************************************************************************
 * %% BeginSection: includes
 */

# include <Bo/services/textan/Types.h>

/******************************************************************************
 * %% BeginSection: gramspecc service declarations
 */
# pragma mark -
# pragma mark [ gramspecc service declarations ]
# pragma mark -

# define __aorpc_need_service_gramspecc 1

#endif /* !__BO_SERVICES_TEXTAN_GRAMSPECC_P__ */

#pragma mark -

#if __aorpc_uses_service(gramspecc)
# undef __aorpc_need_service_gramspecc

/*
 * gramspecc {\object(class)}
 */
/*
# define AorpK_gramspecc_service (1255)
 */
# include <Bo/services/MIB/Services.h>

# define __aorpc_service_name gramspecc
# include <Bo/aorp/AorpCsrvc.h>

_A_service(gramspecc)
_A_end_ctb

	_A_attribute((nonnull(1,3)))
	_A_op(compile, "gramspecc:compile", (
			struct aorp_closure *aClosure,
			struct aorp_error *anErrPtr,
			aorp_object_t anInputStream,
			aorp_object_t aLog,
			char const *Options
		)),

	_A_attribute((nonnull(1,3)))
	_A_op(compile_s, "gramspecc:compile-string", (
			struct aorp_closure *aClosure,
			struct aorp_error *anErrPtr,
			char const *anInputString,
			aorp_object_t aLog,
			char const *Options
		)),

	_A_attribute((nonnull(1,3)))
	_A_op(compile_fp, "gramspecc:compile-file-from-path", (
			struct aorp_closure *aClosure,
			struct aorp_error *anErrPtr,
			char const *aPath,
			aorp_object_t aLog,
			char const *Options
		)),

_A_end;

# include <Bo/aorp/AorpCend.h>
/* @} */
#endif /* __aorpc_uses_service(gramspecc) */

/******************************************************************************
 * Revision History:
 *		$Log$
 *
 *****************************************************************************/
