/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright (c) 2005-2007 V.Sokur
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

/*
 * Lexopen.h	(N.Panasiuk)
 * include/Bo/services/textan/Lexopen.h
 *
 * $Id$
 */

/* ------------------------------------------------------------------------- */

#ifndef __BO_SERVICES_TEXTAN_LEXOPEN__
# define __BO_SERVICES_TEXTAN_LEXOPEN__

/******************************************************************************
 * %% BeginSection: includes
 */

# include <Bo/services/textan/LexopenP.h>

/******************************************************************************
 * %% BeginSection: function prototypes
 */
# pragma mark -
# pragma mark [ function prototypes ]
# pragma mark -

/*
aorp_object_t
__attribute__((nonnull(1,2)))
AorpLexopen(
	aorp_object_t aThis,
	aorp_opflags_t Flags,       // 0
	bo_pointer_t aMemory,       // NULL
	aorp_object_t anInputStream,
	struct aorp_token_predicate *aPredicate __myc_defval__(NULL),
	struct aorp_error *anErrPtr __myc_defval__(NULL)
	);
 */
# if __myc_support(macro_retval)
#  define AorpLexopen(aThis, Flags, aMemory, anInputStream, aPredicate, anErrPtr) \
	__extension__ ({ \
		bo_stsptr_t ___retval = _A_call(open, lexopen, aThis, anErrPtr, Flags, aMemory, anInputStream, aPredicate); \
		/* return */ (BoSP_ILLPTR(___retval) ? NULL : BO_AOB_FROM_STATUS(___retval)); \
	})
# else
__myc_extern_inline__ aorp_object_t
AorpLexopen(
	aorp_object_t aThis,
	aorp_opflags_t Flags,
	bo_pointer_t aMemory,
	aorp_object_t anInputStream,
	struct aorp_token_predicate *aPredicate,
	struct aorp_error *anErrPtr
	)
{
	bo_stsptr_t retval = _A_call(open, lexopen, aThis, anErrPtr, Flags, aMemory, anInputStream, aPredicate);
	return (BoSP_ILLPTR(retval) ? NULL : BO_AOB_FROM_STATUS(retval));
}
# endif

#endif /* !__BO_SERVICES_TEXTAN_LEXOPEN__ */

/******************************************************************************
 * Revision History:
 *		$Log$
 *
 *****************************************************************************/
