/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright (c) 2005-2007 V.Sokur
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

/*
 * Tcpsi.h	(N.Panasiuk)
 * include/Bo/services/textan/Tcpsi.h
 *
 * $Id$
 */

/* ------------------------------------------------------------------------- */

#ifndef __BO_SERVICES_TEXTAN_TCPSI__
# define __BO_SERVICES_TEXTAN_TCPSI__

/******************************************************************************
 * %% BeginSection: includes
 */

# include <Bo/services/textan/TcpsiP.h>

/******************************************************************************
 * %% BeginSection: function prototypes
 */
# pragma mark -
# pragma mark [ function prototypes ]
# pragma mark -

# include <Bo/BoLinkage.h>

__MYC_BEGIN_CDECLS

__myc_vlinkage__(public,libBo) aorp_object_t _G_tcpsi_service_default;

# pragma mark -

# define AorpTcpsiStat_(anId,anErrPtr) AorpTcpsiStat(NULL,anId,anErrPtr)
# define AorpTcpsiGetnamebyid_(anId,anErrPtr) AorpTcpsiGetnamebyid(NULL,anId,anErrPtr)
# define AorpTcpsiGetidbyname_(aName,anErrPtr) AorpTcpsiGetidbyname(NULL,aName,anErrPtr)
# define AorpTcpsiGetidbyuri_(aScheme,anErrPtr) AorpTcpsiGetidbyuri(NULL,aScheme,anErrPtr)

# pragma mark -

__myc_flinkage__(public,libBo) struct aorp_tcpstat const *
AorpTcpsiStat(
# if __myc_require(prototypes)
	aorp_object_t aSelf /* = NULL */,
	bo_textproto_t anId,
	struct aorp_error *anErrPtr __myc_defval__(NULL)
# endif
	);

__myc_flinkage__(public,libBo) char const *
AorpTcpsiGetnamebyid(
# if __myc_require(prototypes)
	aorp_object_t aSelf /* = NULL */,
	bo_textproto_t anId,
	struct aorp_error *anErrPtr __myc_defval__(NULL)
# endif
	);

__myc_flinkage__(public,libBo) bo_textproto_t
__attribute__((nonnull(2)))
AorpTcpsiGetidbyname(
# if __myc_require(prototypes)
	aorp_object_t aSelf /* = NULL */,
	char const *aName,
	struct aorp_error *anErrPtr __myc_defval__(NULL)
# endif
	);

__myc_flinkage__(public,libBo) bo_textproto_t
AorpTcpsiGetidbyuri(
# if __myc_require(prototypes)
	aorp_object_t aSelf /* = NULL */,
	bo_uri_scheme_t aScheme,
	struct aorp_error *anErrPtr __myc_defval__(NULL)
# endif
	);

# pragma mark -

__myc_flinkage__(public,libBo) bo_status_t
_AorpTcpsiAddtab(
# if __myc_require(prototypes)
	aorp_object_t aSelf /* = NULL */,
	size_t aCount,
	struct Tcpsi_dbelem aTable[],
	struct aorp_error *anErrPtr __myc_defval__(NULL)
# endif
	);

__myc_flinkage__(public,libBo) bo_status_t
_AorpTcpsiAddtab_nlk(
# if __myc_require(prototypes)
	aorp_object_t aSelf /* = NULL */,
	size_t aCount,
	struct Tcpsi_dbelem aTable[],
	struct aorp_error *anErrPtr __myc_defval__(NULL)
# endif
	);

__myc_flinkage__(public,libBo) bo_status_t
_AorpTcpsiRmtab(
# if __myc_require(prototypes)
	aorp_object_t aSelf /* = NULL */,
	size_t aCount,
	struct Tcpsi_dbelem aTable[],
	struct aorp_error *anErrPtr __myc_defval__(NULL)
# endif
	);

__myc_flinkage__(public,libBo) bo_status_t
_AorpTcpsiRmtab_nlk(
# if __myc_require(prototypes)
	aorp_object_t aSelf /* = NULL */,
	size_t aCount,
	struct Tcpsi_dbelem aTable[],
	struct aorp_error *anErrPtr __myc_defval__(NULL)
# endif
	);

__MYC_END_CDECLS

#endif /* !__BO_SERVICES_TEXTAN_TCPSI__ */

/******************************************************************************
 * Revision History:
 *		$Log$
 *
 *****************************************************************************/
