/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright (c) 2005-2007 V.Sokur
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

/*
 * Textcomp.h	(N.Panasiuk)
 * include/Bo/services/textan/Textcomp.h
 *
 * $Id$
 */

/* ------------------------------------------------------------------------- */

#ifndef __BO_SERVICES_TEXTAN_TEXTCOMP__
# define __BO_SERVICES_TEXTAN_TEXTCOMP__

/******************************************************************************
 * %% BeginSection: includes
 */

# include <Bo/services/textan/TextcompP.h>

/******************************************************************************
 * %% BeginSection: function prototypes
 */
# pragma mark -
# pragma mark [ function prototypes ]
# pragma mark -

# include <Bo/BoLinkage.h>

__MYC_BEGIN_CDECLS

__myc_vlinkage__(public,libBo) aorp_object_t _G_textcomp_service_default;

# pragma mark -

# define AorpOpenTextcomp_i_(aProtocol,aTextcomp,anErrPtr) \
	AorpOpenTextcomp_i(NULL,aProtocol,aTextcomp,anErrPtr)

# define AorpOpenTextcomp_s_(aProtocol,aTextcomp,anErrPtr) \
	AorpOpenTextcomp_s(NULL,aProtocol,aTextcomp,anErrPtr)

# define AorpOpenTextcomp_u_(aScheme,aTextcomp,anErrPtr) \
	AorpOpenTextcomp_u(NULL,aScheme,aTextcomp,anErrPtr)

# pragma mark -

__myc_flinkage__(public,libBo) bo_status_t
__attribute__((nonnull(3)))
AorpOpenTextcomp_i(
# if __myc_require(prototypes)
	aorp_object_t aSelf /* = NULL */,
	bo_textproto_t aProtocol,
	struct aorp_textcomp *aTextcomp,
	struct aorp_error *anErrPtr __myc_defval__(NULL)
# endif
	);

__myc_flinkage__(public,libBo) bo_status_t
__attribute__((nonnull(2,3)))
AorpOpenTextcomp_s(
# if __myc_require(prototypes)
	aorp_object_t aSelf /* = NULL */,
	char const *aProtocol,
	struct aorp_textcomp *aTextcomp,
	struct aorp_error *anErrPtr __myc_defval__(NULL)
# endif
	);

__myc_flinkage__(public,libBo) bo_status_t
__attribute__((nonnull(3)))
AorpOpenTextcomp_u(
# if __myc_require(prototypes)
	aorp_object_t aSelf /* = NULL */,
	bo_textproto_t aScheme,
	struct aorp_textcomp *aTextcomp,
	struct aorp_error *anErrPtr __myc_defval__(NULL)
# endif
	);

# pragma mark -

__myc_flinkage__(public,libBo) bo_status_t
AorpTextcompClose(
# if __myc_require(prototypes)
	struct aorp_textcomp *aTextcomp,
	struct aorp_error *anErrPtr __myc_defval__(NULL)
# endif
	);

# pragma mark -

__myc_flinkage__(public,libBo) aorp_object_t
__attribute__((nonnull(1,2)))
AorpTextcompScanmsg(
# if __myc_require(prototypes)
	struct aorp_textcomp *aTextcomp,
	aorp_object_t aStream,
	struct aorp_error *anErrPtr __myc_defval__(NULL)
# endif
	);

__myc_flinkage__(public,libBo) aorp_object_t
__attribute__((nonnull(1,2)))
AorpTextcompScanmsgFromBuffer(
# if __myc_require(prototypes)
	struct aorp_textcomp *aTextcomp,
	char const *aBuffer,
	size_t aBufsz,
	struct aorp_error *anErrPtr __myc_defval__(NULL)
# endif
	);

# pragma mark -

__myc_flinkage__(public,libBo) aorp_object_t
__attribute__((nonnull(1)))
AorpTextcompOpenmsg(
# if __myc_require(prototypes)
	struct aorp_textcomp *aTextcomp,
	struct aorp_error *anErrPtr __myc_defval__(NULL)
# endif
	);

__myc_flinkage__(public,libBo) ssize_t
__attribute__((nonnull(1,2,3)))
AorpTextcompPrintmsg(
# if __myc_require(prototypes)
	struct aorp_textcomp *aTextcomp,
	aorp_object_t aStream,
	aorp_object_t aMessage,
	struct aorp_error *anErrPtr __myc_defval__(NULL)
# endif
	);

__myc_flinkage__(public,libBo) ssize_t
__attribute__((nonnull(1,2,4)))
AorpTextcompPrintmsgToBuffer(
# if __myc_require(prototypes)
	struct aorp_textcomp *aTextcomp,
	char *aBuffer,
	size_t aBufsz,
	aorp_object_t aMessage,
	struct aorp_error *anErrPtr __myc_defval__(NULL)
# endif
	);

__MYC_END_CDECLS

#endif /* !__BO_SERVICES_TEXTAN_TEXTCOMP__ */

/******************************************************************************
 * Revision History:
 *		$Log$
 *
 *****************************************************************************/
