/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright (c) 2005-2007 V.Sokur
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

/*
 * Shashfcns.h	(V.Sokur)
 * include/Bo/stralg/Shashfcns.h
 *
 * $Id$
 */

/* ------------------------------------------------------------------------- */

#ifndef __BO_STRALG_SHASHFCNS__
# define __BO_STRALG_SHASHFCNS__

/******************************************************************************
 * %% BeginSection: includes
 */

# include <Bo/Types.h>

/******************************************************************************
 * %% BeginSection: function prototypes
 */
# pragma mark -
# pragma mark [ function prototypes ]
# pragma mark -

# include <Bo/BoLinkage.h>

__MYC_BEGIN_CDECLS

__myc_flinkage__(public,libBo) bo_hash_t
BoStrhash(
# if __myc_require(prototypes)
	char const *aStr
# endif
	);

__myc_flinkage__(public,libBo) bo_hash_t
BoStrnhash(
# if __myc_require(prototypes)
	char const *aStr,
	size_t aBytec
# endif
	);

__myc_flinkage__(public,libBo) bo_hash_t
BoWcshash(
# if __myc_require(prototypes)
	wchar_t const *aStr
# endif
	);

__myc_flinkage__(public,libBo) bo_hash_t
BoBhash(
# if __myc_require(prototypes)
	bo_byte_t const *aBytev,
	size_t aBytec
# endif
	);

__MYC_END_CDECLS

#endif /* !__BO_STRALG_SHASHFCNS__ */

/******************************************************************************
 * Revision History:
 *		$Log$
 *
 *****************************************************************************/
