/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright (c) 2005-2007 V.Sokur
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

/*
 * Cdefs.h	(V.Sokur)
 * include/Bo/sys/Cdefs.h
 *
 * $Id$
 */

/* ------------------------------------------------------------------------- */

#ifndef __BO_SYS_CDEFS__
# define __BO_SYS_CDEFS__

/******************************************************************************
 * %% BeginSection: includes
 */

# ifdef c_plusplus /* for C++ V2.0 */
#  ifndef __cplusplus
#   define __cplusplus
#  endif
# endif

# include <Bo/sys/Stdconfig.h>

/******************************************************************************
 *  Misc. CPP operators
 */
# pragma mark -

# ifndef __STD_CPP__
#  ifdef __STDC__
#   define __STD_CPP__
#  endif
# endif
# ifndef __STD_CPP__
#  ifdef __cplusplus
#   define __STD_CPP__
#  endif
# endif

/* ------------------------------------------------------------------------- */

# ifndef __myc_concat
#  ifdef __STD_CPP__
#   define __myc_concat(x,y) x ## y
#   define __myc_concat3(x,y,z) x ## y ## z
#   define __myc_concat4(x,y,z,w) x ## y ## z ## w
#   define __myc_concat5(x,y,z,w,v) x ## y ## z ## w ## v
#   define __myc_concat6(x,y,z,w,v,u) x ## y ## z ## w ## v ## u
#   define __myc_concat7(x,y,z,w,v,u,q) x ## y ## z ## w ## v ## u ## q
#   define __myc_concat8(x,y,z,w,v,u,q,r) x ## y ## z ## w ## v ## u ## q ## r
#   define __myc_concat9(x,y,z,w,v,u,q,r,s) x ## y ## z ## w ## v ## u ## q ## r ## s
#   define __myc_concat10(x,y,z,w,v,u,q,r,s,t) x ## y ## z ## w ## v ## u ## q ## r ## s ## t
#   define __myc_concat11(x,y,z,w,v,u,q,r,s,t,p) x ## y ## z ## w ## v ## u ## q ## r ## s ## t ## p
#   define __myc_concat12(x,y,z,w,v,u,q,r,s,t,p,a) x ## y ## z ## w ## v ## u ## q ## r ## s ## t ## p ## a
#   define __myc_concat13(x,y,z,w,v,u,q,r,s,t,p,a,b) x ## y ## z ## w ## v ## u ## q ## r ## s ## t ## p ## a ## b
#   define __myc_concat14(x,y,z,w,v,u,q,r,s,t,p,a,b,c) x ## y ## z ## w ## v ## u ## q ## r ## s ## t ## p ## a ## b ## c
#  else /* !__STD_CPP__ */
#   define __myc_concat(x,y) x/**/y
#   define __myc_concat3(x,y,z) x/**/y/**/z
#   define __myc_concat4(x,y,z,w) x/**/y/**/z/**/w
#   define __myc_concat5(x,y,z,w,v) x/**/y/**/z/**/w/**/v
#   define __myc_concat6(x,y,z,w,v,u) x/**/y/**/z/**/w/**/v/**/u
#   define __myc_concat7(x,y,z,w,v,u,q) x/**/y/**/z/**/w/**/v/**/u/**/q
#   define __myc_concat8(x,y,z,w,v,u,q,r) x/**/y/**/z/**/w/**/v/**/u/**/q/**/r
#   define __myc_concat9(x,y,z,w,v,u,q,r,s) x/**/y/**/z/**/w/**/v/**/u/**/q/**/r/**/s
#   define __myc_concat10(x,y,z,w,v,u,q,r,s,t) x/**/y/**/z/**/w/**/v/**/u/**/q/**/r/**/s/**/t
#   define __myc_concat11(x,y,z,w,v,u,q,r,s,t,p) x/**/y/**/z/**/w/**/v/**/u/**/q/**/r/**/s/**/t/**/p
#   define __myc_concat12(x,y,z,w,v,u,q,r,s,t,p,a) x/**/y/**/z/**/w/**/v/**/u/**/q/**/r/**/s/**/t/**/p/**/a
#   define __myc_concat13(x,y,z,w,v,u,q,r,s,t,p,a,b) x/**/y/**/z/**/w/**/v/**/u/**/q/**/r/**/s/**/t/**/p/**/a/**/b
#   define __myc_concat14(x,y,z,w,v,u,q,r,s,t,p,a,b,c) x/**/y/**/z/**/w/**/v/**/u/**/q/**/r/**/s/**/t/**/p/**/a/**/b/**/c
#  endif /* __STD_CPP__ */
# endif
# ifndef __myc_xconcat
#  define __myc_xconcat(x,y) __myc_concat(x,y)
#  define __myc_xconcat3(x,y,z) __myc_concat3(x,y,z)
#  define __myc_xconcat4(x,y,z,w) __myc_concat4(x,y,z,w)
#  define __myc_xconcat5(x,y,z,w,v) __myc_concat5(x,y,z,w,v)
#  define __myc_xconcat6(x,y,z,w,v,u) __myc_concat6(x,y,z,w,v,u)
#  define __myc_xconcat7(x,y,z,w,v,u,q) __myc_concat7(x,y,z,w,v,u,q)
#  define __myc_xconcat8(x,y,z,w,v,u,q,r) __myc_concat8(x,y,z,w,v,u,q,r)
#  define __myc_xconcat9(x,y,z,w,v,u,q,r,s) __myc_concat9(x,y,z,w,v,u,q,r,s)
#  define __myc_xconcat10(x,y,z,w,v,u,q,r,s,t) __myc_concat10(x,y,z,w,v,u,q,r,s,t)
#  define __myc_xconcat11(x,y,z,w,v,u,q,r,s,t,p) __myc_concat11(x,y,z,w,v,u,q,r,s,t,p)
#  define __myc_xconcat12(x,y,z,w,v,u,q,r,s,t,p,a) __myc_concat12(x,y,z,w,v,u,q,r,s,t,p,a)
#  define __myc_xconcat13(x,y,z,w,v,u,q,r,s,t,p,a,b) __myc_concat13(x,y,z,w,v,u,q,r,s,t,p,a,b)
#  define __myc_xconcat14(x,y,z,w,v,u,q,r,s,t,p,a,b,c) __myc_concat14(x,y,z,w,v,u,q,r,s,t,p,a,b,c)
# endif

# ifndef __myc_rconcat
#  define __myc_rconcat(x,y) x/**/y
#  define __myc_rconcat3(x,y,z) x/**/y/**/z
#  define __myc_rconcat4(x,y,z,w) x/**/y/**/z/**/w
#  define __myc_rconcat5(x,y,z,w,v) x/**/y/**/z/**/w/**/v
#  define __myc_rconcat6(x,y,z,w,v,u) x/**/y/**/z/**/w/**/v/**/u
#  define __myc_rconcat7(x,y,z,w,v,u,q) x/**/y/**/z/**/w/**/v/**/u/**/q
#  define __myc_rconcat8(x,y,z,w,v,u,q,r) x/**/y/**/z/**/w/**/v/**/u/**/q/**/r
#  define __myc_rconcat9(x,y,z,w,v,u,q,r,s) x/**/y/**/z/**/w/**/v/**/u/**/q/**/r/**/s
#  define __myc_rconcat10(x,y,z,w,v,u,q,r,s,t) x/**/y/**/z/**/w/**/v/**/u/**/q/**/r/**/s/**/t
#  define __myc_rconcat11(x,y,z,w,v,u,q,r,s,t,p) x/**/y/**/z/**/w/**/v/**/u/**/q/**/r/**/s/**/t/**/p
#  define __myc_rconcat12(x,y,z,w,v,u,q,r,s,t,p,a) x/**/y/**/z/**/w/**/v/**/u/**/q/**/r/**/s/**/t/**/p/**/a
#  define __myc_rconcat13(x,y,z,w,v,u,q,r,s,t,p,a,b) x/**/y/**/z/**/w/**/v/**/u/**/q/**/r/**/s/**/t/**/p/**/a/**/b
#  define __myc_rconcat14(x,y,z,w,v,u,q,r,s,t,p,a,b,c) x/**/y/**/z/**/w/**/v/**/u/**/q/**/r/**/s/**/t/**/p/**/a/**/b/**/c
# endif
# ifndef __myc_sconcat
#  define __myc_sconcat(x,y) __myc_rconcat(x,y)
#  define __myc_sconcat3(x,y,z) __myc_rconcat3(x,y,z)
#  define __myc_sconcat4(x,y,z,w) __myc_rconcat4(x,y,z,w)
#  define __myc_sconcat5(x,y,z,w,v) __myc_rconcat5(x,y,z,w,v)
#  define __myc_sconcat6(x,y,z,w,v,u) __myc_rconcat6(x,y,z,w,v,u)
#  define __myc_sconcat7(x,y,z,w,v,u,q) __myc_rconcat7(x,y,z,w,v,u,q)
#  define __myc_sconcat8(x,y,z,w,v,u,q,r) __myc_rconcat8(x,y,z,w,v,u,q,r)
#  define __myc_sconcat9(x,y,z,w,v,u,q,r,s) __myc_rconcat9(x,y,z,w,v,u,q,r,s)
#  define __myc_sconcat10(x,y,z,w,v,u,q,r,s,t) __myc_rconcat10(x,y,z,w,v,u,q,r,s,t)
#  define __myc_sconcat11(x,y,z,w,v,u,q,r,s,t,p) __myc_rconcat11(x,y,z,w,v,u,q,r,s,t,p)
#  define __myc_sconcat12(x,y,z,w,v,u,q,r,s,t,p,a) __myc_rconcat12(x,y,z,w,v,u,q,r,s,t,p,a)
#  define __myc_sconcat13(x,y,z,w,v,u,q,r,s,t,p,a,b) __myc_rconcat13(x,y,z,w,v,u,q,r,s,t,p,a,b)
#  define __myc_sconcat14(x,y,z,w,v,u,q,r,s,t,p,a,b,c) __myc_rconcat14(x,y,z,w,v,u,q,r,s,t,p,a,b,c)
# endif

/* @todo: fixme */
# ifndef __myc_mnpconcat
/* for preprocessor that translate comment into empty, not space (???) */
#  ifdef __GNUC__
#   define __myc_mnpconcat(aMacroName,aParamInParen) aMacroName/**/aParamInParen
#  else
#  ifdef _MSC_VER
#   define __myc_mnpconcat(aMacroName,aMacroParam) __myc_xconcat(aMacroName,aMacroParam)
#  else
#   define __myc_mnpconcat(aMacroName,aMacroParam) __myc_xconcat(aMacroName,aMacroParam)
#  endif /* _MSC_VER */
#  endif /* __GNUC__ */
# endif /* !__myc_mnpconcat */

/* ------------------------------------------------------------------------- */

# ifndef __myc_stringify
#  ifdef __STD_CPP__
#   define __myc_stringify(x)	#x
#  else
#   define __myc_stringify(x)	"x"
#  endif
#  define __myc_xstringify(x)	__myc_stringify(x)
# endif
# ifndef __myc_xstringify
#  define __myc_xstringify(x)	__myc_stringify(x)
# endif

/* ------------------------------------------------------------------------- */

/* @todo: fixme */
# ifdef _MSC_VER
#  define __myc_message(aText) __pragma(message(__myc_xstringify(aText)))
#  define __myc_strmessage(aText) __pragma(message(aText))
# else
#  ifdef __GNUC__ // gcc
#   define __myc_message(aText)
#   define __myc_strmessage(aText)
#  else
#   define __myc_message(aText) #warning aText
#   define __myc_strmessage(aText) #warning aText
#  endif
# endif

/* ------------------------------------------------------------------------- */

# ifndef __myc_macro_call
#  define __myc_macro_call(aMacroName,aParamInParen) __myc_mnpconcat(aMacroName,aParamInParen)
# endif

/* ------------------------------------------------------------------------- */

/* designed to test file existence */
# define ___myc_exists(x) (x + 0)
# define __myc_exists(Name,Ext) ___myc_exists(__myc_xconcat4(has_,Name,_,Ext))

/* ------------------------------------------------------------------------- */

# define ___myc_wtext(aText) L ## aText
# define __myc_wtext(aText) ___myc_wtext(aText)

# define ___myc_wchar(aCh) L ## aCh
# define __myc_wchar(aCh) ___myc_wchar(aCh)

# ifdef __cplusplus
#  define __myc_defval__(aValue) = aValue
# else
#  define __myc_defval__(aValue)
# endif

/******************************************************************************
 * %% BeginSection: includes
 */
# pragma mark -

# if __myc_exists(sys7cdefs,h)
#  include __MYC_LIBC_HEADER(sys/cdefs.h)
# endif

/******************************************************************************
 * Language Settings
 */

/* ============================================================================
 * Options
 */
# pragma mark -

# ifndef __myc_option
#  define __myc_option(opt)	__myc_xconcat(myc_option_,opt)
# endif
/* options:
enum_always_int
*/

# ifndef myc_option_enum_always_int
#  ifdef ENUM_ALWAYS_INT
#   define myc_option_enum_always_int ENUM_ALWAYS_INT
#  else
#   define myc_option_enum_always_int 1
#  endif
# endif

/* ============================================================================
 * Prototypes
 */
# pragma mark -

# ifndef __myc_require
#  define __myc_require(proto) __myc_xconcat(myc_require_,proto)
# endif
/* prototypes:
const_prototypes
prototypes
varargs_prototypes
nested_prototypes
wide_prototypes
*/

# ifdef __NOT_STDC_ENV__
#  ifndef __USE_KR_C__
#   define __USE_KR_C__
#  endif
# endif /* __NOT_STDC_ENV__ */

# ifdef __USE_KR_C__
#  ifdef __myc_require
#   undef __myc_require
#  endif
#  define __myc_require(proto) NO

#  ifdef myc_support_stdarg
#   undef myc_support_stdarg
#  endif
#  define myc_support_stdarg NO

#  ifdef myc_support_varargs
#   undef myc_support_varargs
#  endif
#  define myc_support_varargs YES
# endif /* __USE_KR_C__ */


# ifdef REQUIRE_PROTOTYPES
#  ifdef __myc_require
#   undef __myc_require
#  endif
#  define __myc_require(proto) YES
# endif /* REQUIRE_PROTOTYPES */


/* NOT FOR YOUR BUSINESS */
/* @{ */
# if defined(__cplusplus)
#  ifdef myc_require_const_prototypes
#   undef myc_require_const_prototypes
#  endif
#  define myc_require_const_prototypes YES
#  ifdef myc_require_prototypes
#   undef myc_require_prototypes
#  endif
#  define myc_require_prototypes YES
# endif /* __cplusplus */

# ifdef __MWERKS__
#  if __option(require_prototypes)
#   ifdef myc_require_const_prototypes
#    undef myc_require_const_prototypes
#   endif
#   define myc_require_const_prototypes YES
#   ifdef myc_require_prototypes
#    undef myc_require_prototypes
#   endif
#   define myc_require_prototypes YES
#  else /* !require_prototypes */
#   ifndef myc_require_const_prototypes
#    define myc_require_const_prototypes NO
#   endif
#   ifndef myc_require_prototypes
#    define myc_require_prototypes NO
#   endif
#  endif /* !require_prototypes */
# else /* !__MWERKS__ */
#  ifdef __STD_CPP__
#   ifdef myc_require_const_prototypes
#    undef myc_require_const_prototypes
#   endif
#   define myc_require_const_prototypes YES
#   ifdef myc_require_prototypes
#    undef myc_require_prototypes
#   endif
#   define myc_require_prototypes YES
#  else /* !__STD_CPP__ */
#   ifndef myc_require_const_prototypes
#    define myc_require_const_prototypes NO
#   endif
#   ifndef myc_require_prototypes
#    define myc_require_prototypes NO
#   endif
#  endif /* !__STD_CPP__ */
# endif /* !__MWERKS__ */

# if myc_require_prototypes
#  ifdef myc_require_varargs_prototypes
#   undef myc_require_varargs_prototypes
#  endif
#  define myc_require_varargs_prototypes YES
# else
#  ifndef myc_require_varargs_prototypes
#   define myc_require_varargs_prototypes NO
#  endif
# endif

# ifndef myc_require_nested_prototypes
#  define myc_require_nested_prototypes	myc_require_prototypes
# endif

/* @todo: ??? */
# ifndef myc_require_wide_prototypes
#  define myc_require_wide_prototypes	(!myc_require_prototypes)
# endif
/* @} */

# ifndef __myc_proto__
#  if __myc_require(prototypes)
#   define __myc_proto__(parm) parm
#  else
#   define __myc_proto__(parm) ()
#  endif
# endif

# define __MYC_P __myc_proto__

/* ============================================================================
 * Language Keywords/Pseudo-Keywords Support
 */
# pragma mark -

# define __myc_support_keyword(aKeyword) __myc_xconcat3(myc_support_,aKeyword,_keyword)
/* keywords:
_Pragma  // C99
__pragma // MSC
// __thread
// const
// signed
// volatile
// inline
// restrict
typeof
__attribute__
// __extension__
// __cdecl
__declspec
*/

/* NOT FOR YOUR BUSINESS */
/* @{ */
# ifndef myc_support__Pragma_keyword
#  ifdef SUPPORT_C99_PRAGMA_KEYWORD
#   define myc_support__Pragma_keyword YES
#  else
#   define myc_support__Pragma_keyword NO
#  endif
# endif

# ifndef myc_support___pragma_keyword
#  ifdef SUPPORT_MSC_PRAGMA_KEYWORD
#   define myc_support___pragma_keyword YES
#  else
#   define myc_support___pragma_keyword NO
#  endif
# endif

# ifndef myc_support___thread_keyword
#  ifdef SUPPORT_C99_THREAD_STORAGE_CLASS_KEYWORD
#   define myc_support___thread_keyword YES
/* #   define __thread */
#  else
#  ifdef SUPPORT_MSC_THREAD_STORAGE_CLASS_KEYWORD
#   define myc_support___thread_keyword YES
#   define __thread __declspec(thread)
#  else
#   define myc_support___thread_keyword NO
#   define __thread
#  endif
#  endif
# endif

# ifndef myc_support_const_keyword
#  ifdef __cplusplus
#   define myc_support_const_keyword	1
#  endif
# endif
# ifndef myc_support_const_keyword
#  ifdef SUPPORT_CONST_KEYWORD
#   define myc_support_const_keyword	SUPPORT_CONST_KEYWORD
#  else
#   define myc_support_const_keyword	0
#  endif
# endif
# if myc_support_const_keyword
#  if (myc_support_const_keyword != 1)
#   if (myc_support_const_keyword == 2)
#    define const	__const
#   else
#    define const	__const__
#   endif
#  endif
# endif
# if !myc_support_const_keyword
#  define const
# endif

# ifndef myc_support_signed_keyword
#  ifdef __cplusplus
#   define myc_support_signed_keyword	1
#  endif
# endif
# ifndef myc_support_signed_keyword
#  ifdef SUPPORT_SIGNED_KEYWORD
#   define myc_support_signed_keyword	SUPPORT_SIGNED_KEYWORD
#  else
#   define myc_support_signed_keyword	0
#  endif
# endif
# if myc_support_signed_keyword
#  if (myc_support_signed_keyword != 1)
#   if (myc_support_signed_keyword == 2)
#    define signed	__signed
#   else
#    define signed	__signed__
#   endif
#  endif
# endif
# if !myc_support_signed_keyword
#  define signed
# endif

# ifndef myc_support_volatile_keyword
#  ifdef __cplusplus
#   define myc_support_volatile_keyword	1
#  endif
# endif
# ifndef myc_support_volatile_keyword
#  ifdef SUPPORT_VOLATILE_KEYWORD
#   define myc_support_volatile_keyword	SUPPORT_VOLATILE_KEYWORD
#  else
#   define myc_support_volatile_keyword	0
#  endif
# endif
# if myc_support_volatile_keyword
#  if (myc_support_volatile_keyword != 1)
#   if (myc_support_volatile_keyword == 2)
#    define volatile	__volatile
#   else
#    define volatile	__volatile__
#   endif
#  endif
# endif
# if !myc_support_volatile_keyword
#  define volatile
# endif

# ifndef myc_support_inline_keyword
#  ifdef __cplusplus
#   define myc_support_inline_keyword	1
#  endif
# endif
# ifndef myc_support_inline_keyword
#  ifdef SUPPORT_INLINE_KEYWORD
#   define myc_support_inline_keyword	SUPPORT_INLINE_KEYWORD
#  else
#   define myc_support_inline_keyword	0
#  endif
# endif
# if myc_support_inline_keyword
#  if (myc_support_inline_keyword != 1)
#   if (myc_support_inline_keyword == 2)
#    define inline	__inline
#   else
#    define inline	__inline__
#   endif
#  endif
# endif
# if !myc_support_inline_keyword
#  define inline
# endif

# ifndef myc_support_restrict_keyword
#  ifdef SUPPORT_RESTRICT_KEYWORD
#   define myc_support_restrict_keyword	SUPPORT_RESTRICT_KEYWORD
#  else
#   define myc_support_restrict_keyword	0
#  endif
# endif
# if myc_support_restrict_keyword
#  if (myc_support_restrict_keyword != 1)
#   if (myc_support_restrict_keyword == 2)
#    define restrict	__restrict
#    define myc_restrict_is_defined
#   else
#    define restrict	__restrict__
#    define myc_restrict_is_defined
#   endif
#  endif
#  define __Restrict restrict
# endif
# if !myc_support_restrict_keyword
#  define restrict
#  define __Restrict
# endif

# ifdef _MSC_VER
/* Due to windows stupid __declspec(restrict). */
#  ifdef myc_restrict_is_defined
#   undef restrict
#   undef myc_restrict_is_defined
#  endif
# endif
/* @} */

# ifndef __myc_pragma
#  if __myc_support_keyword(_Pragma)
#   define __myc_pragma(aText) _Pragma(__myc_xstringify(aText))
#  else
#  if __myc_support_keyword(__pragma)
#   define __myc_pragma(aText) __pragma(aText)
#  else
#   define __myc_pragma(aText) #pragma aText
#  endif
#  endif
# endif /* __myc_pragma */

/* ----------------------------------------------------------------------------
 * Language Pseudo-Keywords Support
 */
# pragma mark -

/* NOT FOR YOUR BUSINESS */
/* @{ */
# ifndef myc_support_typeof_keyword
#  ifdef SUPPORT_TYPEOF_KEYWORD
#   define myc_support_typeof_keyword	SUPPORT_TYPEOF_KEYWORD
#  else
#   define myc_support_typeof_keyword	0
#  endif
# endif
# if myc_support_typeof_keyword
#  if (myc_support_typeof_keyword != 1)
#   if (myc_support_typeof_keyword == 2)
#    define typeof	__typeof
#   else
#    define typeof	__typeof__
#   endif
#  endif
# endif
# if !myc_support_typeof_keyword
#  define typeof(var)	Was ist das?
# endif

# ifndef myc_support___attribute___keyword
#  ifdef SUPPORT_ATTRIBUTE_KEYWORD
#   define myc_support___attribute___keyword YES
#  else
#   define myc_support___attribute___keyword NO
#  endif
# endif
# if !myc_support___attribute___keyword
#  define __attribute__(attributes)
# endif

# ifndef myc_support___extension___keyword
#  ifdef SUPPORT_EXTENSION_KEYWORD
#   define myc_support___extension___keyword YES
#  else
#   define myc_support___extension___keyword NO
#  endif
# endif
# if !myc_support___extension___keyword
#  define __extension__
# endif

# ifndef myc_support___cdecl_keyword
#  ifdef SUPPORT_CDECL_KEYWORD
#   define myc_support___cdecl_keyword YES
#  else
#   define myc_support___cdecl_keyword NO
#  endif
# endif
# if !myc_support___cdecl_keyword
#  define __cdecl
# endif

# ifndef myc_support___declspec_keyword
#  ifdef SUPPORT_DECLSPEC_KEYWORD
#   define myc_support___declspec_keyword YES
#  else
#   define myc_support___declspec_keyword NO
#  endif
# endif
# if !myc_support___declspec_keyword
#  define __declspec(x)
# endif
/* @} */

/* pseudo-keyword */
# define __status__(x)

/* ============================================================================
 * Pragmas Support
 */
# pragma mark -

# define __myc_support_pragma(aPragma)	__myc_xconcat3(myc_support_,aPragma,_pragma)
/* pragmas:
omp - OpenMP pragmas
*/

/* NOT FOR YOUR BUSINESS */
/* @{ */

# ifndef myc_support_omp_pragma
#  ifdef SUPPORT_OMP_PRAGMA
#   define myc_support_omp_pragma YES
#  else
#   define myc_support_omp_pragma NO
#  endif
# endif
/* @} */

/*
 * OpenMP Pragmas
 */

# define __myc_support_omp_pragma(aPragma)	__myc_xconcat3(myc_support_omp_,aPragma,_pragma)
/* pragmas:
threadprivate
...
*/

/* NOT FOR YOUR BUSINESS */
/* @{ */

# ifndef myc_support_omp_threadprivate_pragma
#  ifdef SUPPORT_OMP_THREADPRIVATE_PRAGMA
#   define myc_support_omp_threadprivate_pragma YES
#  else
#   define myc_support_omp_threadprivate_pragma NO
#  endif
# endif
/* @} */

/* ============================================================================
 * Language Features Support
 */
# pragma mark -

# define __myc_support(aFeature)	__myc_xconcat(myc_support_,aFeature)
/* features:
KnR - K&R C style
VLA - variable length array
FAM - flexible array member
TUNO - [temporary] unnamed object (compound literal [as real object])
DINI - [named] designated initializer
TUNO_DINI - TUNO + DINI
macro_retval
AVM - anonymous variadic macro (C99)
NVM - named variadic macro (traditional)
nested_functions
label_address
varargs
stdarg
thread_storage_class
*/

/* NOT FOR YOUR BUSINESS */
/* @{ */

# ifndef myc_support_KnR
#  ifdef SUPPORT_KnR
#   define myc_support_KnR YES
#  else
#   define myc_support_KnR NO
#  endif
# endif

/* Variable length array:
int vec[x];
 */
# ifndef myc_support_VLA
#  ifdef SUPPORT_VARIABLE_LENGTH_ARRAY
#   define myc_support_VLA YES
#  else
#   define myc_support_VLA NO
#  endif
# endif

/* Flexible array member:
struct {
	int m;
	...
	char name[];
}
 */
# ifndef myc_support_FAM
#  ifdef SUPPORT_FLEXIBLE_ARRAY_MEMBER
#   define myc_support_FAM YES
#  else
#   define myc_support_FAM NO
#  endif
# endif

# ifndef myc_support_TUNO
#  ifdef __cplusplus
#   define myc_support_TUNO NO
#  else
#   ifdef SUPPORT_TEMPORARY_UNNAMED_OBJECT
#    define myc_support_TUNO YES
#   else
#    define myc_support_TUNO NO
#   endif
#  endif
# endif

# ifndef myc_support_DINI
#  ifdef __cplusplus
#   define myc_support_DINI NO
#  else
#   ifdef SUPPORT_DESIGNATED_INITIALIZERS
#    define myc_support_DINI YES
#   else
#    define myc_support_DINI NO
#   endif
#  endif
# endif

# ifndef myc_support_TUNO_DINI
#  if (myc_support_DINI && myc_support_TUNO)
#   define myc_support_TUNO_DINI YES
#  else
#   define myc_support_TUNO_DINI NO
#  endif
# endif

# ifndef myc_support_macro_retval
#  ifdef SUPPORT_MACRO_RETVAL
#   define myc_support_macro_retval YES
#  else
#   define myc_support_macro_retval NO
#  endif
# endif

# ifndef myc_support_AVM
#  ifdef SUPPORT_ANONYMOUS_VARIADIC_MACRO
#   define myc_support_AVM YES
#  else
#   define myc_support_AVM NO
#  endif
# endif

# ifndef myc_support_NVM
#  ifdef SUPPORT_NAMED_VARIADIC_MACRO
#   define myc_support_NVM YES
#  else
#   define myc_support_NVM NO
#  endif
# endif

# ifndef myc_support_nested_functions
#  ifdef __cplusplus
#   define myc_support_nested_functions NO
#  else
#   ifdef SUPPORT_NESTED_FUNCTIONS
#    define myc_support_nested_functions YES
#   else
#    define myc_support_nested_functions NO
#   endif
#  endif
# endif

# ifndef myc_support_label_address
#  ifdef SUPPORT_LABEL_ADDRESS
#   define myc_support_label_address YES
#  else
#   define myc_support_label_address NO
#  endif
# endif

# ifndef myc_support_varargs
#  ifdef SUPPORT_VARARGS
#   define myc_support_varargs YES
#  else
#  ifdef __STDC__
#   define myc_support_varargs NO
#  else
#  ifdef __cplusplus
#   define myc_support_varargs NO
#  else
#   define myc_support_varargs YES
#  endif
#  endif
#  endif
# endif

# ifndef myc_support_stdarg
#  ifdef SUPPORT_STDARG
#   define myc_support_stdarg YES
#  else
#  ifdef __STDC__
#   define myc_support_stdarg YES
#  else
#  ifdef __cplusplus
#   define myc_support_stdarg YES
#  else
#   define myc_support_stdarg NO
#  endif
#  endif
#  endif
# endif

# ifndef myc_support_thread_storage_class
#  define myc_support_thread_storage_class myc_support___thread_keyword
# endif
/* @} */

/* ============================================================================
 * Types Support
 */
# pragma mark -

# define __myc_support_type(aTp)	__myc_xconcat3(myc_support_,aTp,_type)
/* types:
void_ptr
long_long
long_double
long_float
_Bool
_Complex
_Complex_float
_Complex_double
_Complex_long_double
*/

/* NOT FOR YOUR BUSINESS */
/* @{ */
# ifndef myc_support_void_ptr_type
#  ifdef SUPPORT_VOID_PTR
#   define myc_support_void_ptr_type YES
#  else
#   define myc_support_void_ptr_type NO
#  endif
# endif

# ifndef myc_support_long_long_type
#  ifdef SUPPORT_LONG_LONG_TYPE
#   define myc_support_long_long_type YES
#  else
#   define myc_support_long_long_type NO
#  endif
# endif

# ifndef myc_support_long_double_type
#  ifdef SUPPORT_LONG_DOUBLE_TYPE
#   define myc_support_long_double_type YES
#  else
#   define myc_support_long_double_type NO
#  endif
# endif

# ifndef myc_support_long_float_type
#  ifdef SUPPORT_LONG_FLOAT_TYPE
#   define myc_support_long_float_type YES
#  else
#   define myc_support_long_float_type NO
#  endif
# endif

# ifndef myc_support__Bool_type
#  ifdef SUPPORT__BOOL_TYPE
#   define myc_support__Bool_type YES
#  else
#   define myc_support__Bool_type NO
#  endif
# endif

# ifndef myc_support__Complex_type
#  ifdef SUPPORT__COMPLEX_TYPE
#   define myc_support__Complex_type YES
#  else
#   define myc_support__Complex_type NO
#  endif
# endif

# ifndef myc_support__Complex_float_type
#  ifdef SUPPORT__COMPLEX_FLOAT_TYPE
#   define myc_support__Complex_float_type YES
#  else
#   define myc_support__Complex_float_type NO
#  endif
# endif

# ifndef myc_support__Complex_double_type
#  ifdef SUPPORT__COMPLEX_DOUBLE_TYPE
#   define myc_support__Complex_double_type YES
#  else
#   define myc_support__Complex_double_type NO
#  endif
# endif

# ifndef myc_support__Complex_long_double_type
#  ifdef SUPPORT__COMPLEX_LONG_DOUBLE_TYPE
#   define myc_support__Complex_long_double_type YES
#  else
#   define myc_support__Complex_long_double_type NO
#  endif
# endif
/* @} */

/* ----------------------------------------------------------------------------
 *
 */

# ifndef __MYC_QALIGN
#  ifdef _MSC_VER
#   define __MYC_QALIGN(k) __declspec(align(k))
#  else
#   define __MYC_QALIGN(k) __attribute__((aligned(k)))
#  endif
# endif

/* ----------------------------------------------------------------------------
 * remove-paren: (x1,x2,...) -> x1,x2,...
 */

# define _RQUO(anExprInParen) __myc_remove_paren(anExprInParen)

# define __myc_remove_paren(anExprInParen) \
	__myc_remove_paren_helper(__myc_remove_paren0,anExprInParen)
# define __myc_remove_paren_helper(aTreater,anExprInParen) \
	__myc_remove_paren_helper2(__myc_macro_call(aTreater,anExprInParen))

# ifdef _MSC_VER
#  define __myc_remove_paren_helper2(aList) __myc_remove_paren_helper3(aList)
#  define __myc_remove_paren_helper3(aList) aList
# else
# ifdef __GNUC__
#  define __myc_remove_paren_helper2(aList) aList
# else
#  define __myc_remove_paren_helper2(aList) aList
# endif /* __GNUC__ */
# endif /* _MSC_VER */

# if __myc_support(NVM)
#  define __myc_remove_paren0(x1...) x1
# else
# if __myc_support(AVM)
#  define __myc_remove_paren0(...) __VA_ARGS__
# endif /* __myc_support(AVM) */
# endif /* __myc_support(NVM) */

/******************************************************************************
 * %% BeginSection: compile time list support
 */

# define __myc_list_count(aListInParen) -2
# define __myc_list_count_notsupp

/*
 * list execution [template]
 */

# define __myc_list_exec(anExecutor,aListInParen) \
	__myc_list_exec2(anExecutor,_RQUO(aListInParen))
# define __myc_list_exec2(anExecutor,aList) \
	__myc_list_exec3(anExecutor(aList))
# define __myc_list_exec3(x) x

/* with parameters */
# if __myc_support(NVM)
#  define __myc_list_execp(anExecutor,aListInParen,aParams...) \
	__myc_list_execp2(anExecutor,aParams,_RQUO(aListInParen))
#  define __myc_list_execp2(anExecutor,aList...) \
	__myc_list_execp3(anExecutor(aList))
# else
# if __myc_support(AVM)
#  define __myc_list_execp(anExecutor,aListInParen,...) \
	__myc_list_execp2(anExecutor,__VA_ARGS__,_RQUO(aListInParen))
#  define __myc_list_execp2(anExecutor,...) \
	__myc_list_execp3(anExecutor(__VA_ARGS__))
# endif /* __myc_support(AVM) */
# endif /* __myc_support(NVM) */
# define __myc_list_execp3(x) x

/* ----------------------------------------------------------------------------
 * convolution: {N, (x1,x2,...)} -> {x1_x2_..._xN}
 */

# define __myc_list_convolution(N,aListInParen) \
	__myc_list_exec(__myc_xconcat(__myc_list_convolution,N),aListInParen)

/* ------------------------------------------------------------------------- */

# define __myc_list_convolution1(x1) x1
# define __myc_list_convolution2(x1,x2) \
	__myc_xconcat3(__myc_list_convolution1(x1),_,x2)
# define __myc_list_convolution3(x1,x2,x3) \
	__myc_xconcat3(__myc_list_convolution2(x1,x2),_,x3)
# define __myc_list_convolution4(x1,x2,x3,x4) \
	__myc_xconcat3(__myc_list_convolution3(x1,x2,x3),_,x4)
# define __myc_list_convolution5(x1,x2,x3,x4,x5) \
	__myc_xconcat3(__myc_list_convolution4(x1,x2,x3,x4),_,x5)
# define __myc_list_convolution6(x1,x2,x3,x4,x5,x6) \
	__myc_xconcat3(__myc_list_convolution5(x1,x2,x3,x4,x5),_,x6)
# define __myc_list_convolution7(x1,x2,x3,x4,x5,x6,x7) \
	__myc_xconcat3(__myc_list_convolution6(x1,x2,x3,x4,x5,x6),_,x7)
# define __myc_list_convolution8(x1,x2,x3,x4,x5,x6,x7,x8) \
	__myc_xconcat3(__myc_list_convolution7(x1,x2,x3,x4,x5,x6,x7),_,x8)
# define __myc_list_convolution9(x1,x2,x3,x4,x5,x6,x7,x8,x9) \
	__myc_xconcat3(__myc_list_convolution8(x1,x2,x3,x4,x5,x6,x7,x8),_,x9)
# define __myc_list_convolution10(x1,x2,x3,x4,x5,x6,x7,x8,x9,x10) \
	__myc_xconcat3(__myc_list_convolution9(x1,x2,x3,x4,x5,x6,x7,x8,x9),_,x10)

/* ----------------------------------------------------------------------------
 * convolution_x: {D, N, (x1,x2,...)} -> {x1 D x2 D ... D xN}
 */

# define __myc_list_convolution_x(D,N,aListInParen) \
	__myc_list_execp(__myc_xconcat(__myc_list_convolution_x,N),aListInParen,D)

/* ------------------------------------------------------------------------- */

# define __myc_list_convolution_x1(D,x1) x1
# define __myc_list_convolution_x2(D,x1,x2) \
	__myc_xconcat3(__myc_list_convolution_x1(D,x1),D,x2)
# define __myc_list_convolution_x3(D,x1,x2,x3) \
	__myc_xconcat3(__myc_list_convolution_x2(D,x1,x2),D,x3)
# define __myc_list_convolution_x4(D,x1,x2,x3,x4) \
	__myc_xconcat3(__myc_list_convolution_x3(D,x1,x2,x3),D,x4)
# define __myc_list_convolution_x5(D,x1,x2,x3,x4,x5) \
	__myc_xconcat3(__myc_list_convolution_x4(D,x1,x2,x3,x4),D,x5)
# define __myc_list_convolution_x6(D,x1,x2,x3,x4,x5,x6) \
	__myc_xconcat3(__myc_list_convolution_x5(D,x1,x2,x3,x4,x5),D,x6)
# define __myc_list_convolution_x7(D,x1,x2,x3,x4,x5,x6,x7) \
	__myc_xconcat3(__myc_list_convolution_x6(D,x1,x2,x3,x4,x5,x6),D,x7)
# define __myc_list_convolution_x8(D,x1,x2,x3,x4,x5,x6,x7,x8) \
	__myc_xconcat3(__myc_list_convolution_x7(D,x1,x2,x3,x4,x5,x6,x7),D,x8)
# define __myc_list_convolution_x9(D,x1,x2,x3,x4,x5,x6,x7,x8,x9) \
	__myc_xconcat3(__myc_list_convolution_x8(D,x1,x2,x3,x4,x5,x6,x7,x8),D,x9)
# define __myc_list_convolution_x10(D,x1,x2,x3,x4,x5,x6,x7,x8,x9,x10) \
	__myc_xconcat3(__myc_list_convolution_x9(D,x1,x2,x3,x4,x5,x6,x7,x8,x9),D,x10)

/* ----------------------------------------------------------------------------
 * convolution_s: {D, N, (x1,x2,...)} -> {x1 D x2 D ... D xN}
 */

# define __myc_list_convolution_s(D,N,aListInParen) \
	__myc_list_execp(__myc_xconcat(__myc_list_convolution_s,N),aListInParen,D)

/* ------------------------------------------------------------------------- */

# define __myc_list_convolution_s1(D,x1) x1
# define __myc_list_convolution_s2(D,x1,x2) \
	__myc_sconcat3(__myc_list_convolution_s1(D,x1),D,x2)
# define __myc_list_convolution_s3(D,x1,x2,x3) \
	__myc_sconcat3(__myc_list_convolution_s2(D,x1,x2),D,x3)
# define __myc_list_convolution_s4(D,x1,x2,x3,x4) \
	__myc_sconcat3(__myc_list_convolution_s3(D,x1,x2,x3),D,x4)
# define __myc_list_convolution_s5(D,x1,x2,x3,x4,x5) \
	__myc_sconcat3(__myc_list_convolution_s4(D,x1,x2,x3,x4),D,x5)
# define __myc_list_convolution_s6(D,x1,x2,x3,x4,x5,x6) \
	__myc_sconcat3(__myc_list_convolution_s5(D,x1,x2,x3,x4,x5),D,x6)
# define __myc_list_convolution_s7(D,x1,x2,x3,x4,x5,x6,x7) \
	__myc_sconcat3(__myc_list_convolution_s6(D,x1,x2,x3,x4,x5,x6),D,x7)
# define __myc_list_convolution_s8(D,x1,x2,x3,x4,x5,x6,x7,x8) \
	__myc_sconcat3(__myc_list_convolution_s7(D,x1,x2,x3,x4,x5,x6,x7),D,x8)
# define __myc_list_convolution_s9(D,x1,x2,x3,x4,x5,x6,x7,x8,x9) \
	__myc_sconcat3(__myc_list_convolution_s8(D,x1,x2,x3,x4,x5,x6,x7,x8),D,x9)
# define __myc_list_convolution_s10(D,x1,x2,x3,x4,x5,x6,x7,x8,x9,x10) \
	__myc_sconcat3(__myc_list_convolution_s9(D,x1,x2,x3,x4,x5,x6,x7,x8,x9),D,x10)

/* ----------------------------------------------------------------------------
 * convolution_xa: {A, D, N, (x1,x2,...)} -> {A(x1) D A(x2) D ... D A(xN)}
 */

# define __myc_list_convolution_xa(A,D,N,aListInParen) \
	__myc_list_execp(__myc_xconcat(__myc_list_convolution_xa,N),aListInParen,A,D)

/* ------------------------------------------------------------------------- */

# define __myc_list_convolution_xa1(A,D,x1) A(x1)
# define __myc_list_convolution_xa2(A,D,x1,x2) \
	__myc_xconcat3(__myc_list_convolution_xa1(A,D,x1),D,A(x2))
# define __myc_list_convolution_xa3(A,D,x1,x2,x3) \
	__myc_xconcat3(__myc_list_convolution_xa2(A,D,x1,x2),D,A(x3))
# define __myc_list_convolution_xa4(A,D,x1,x2,x3,x4) \
	__myc_xconcat3(__myc_list_convolution_xa3(A,D,x1,x2,x3),D,A(x4))
# define __myc_list_convolution_xa5(A,D,x1,x2,x3,x4,x5) \
	__myc_xconcat3(__myc_list_convolution_xa4(A,D,x1,x2,x3,x4),D,A(x5))
# define __myc_list_convolution_xa6(A,D,x1,x2,x3,x4,x5,x6) \
	__myc_xconcat3(__myc_list_convolution_xa5(A,D,x1,x2,x3,x4,x5),D,A(x6))
# define __myc_list_convolution_xa7(A,D,x1,x2,x3,x4,x5,x6,x7) \
	__myc_xconcat3(__myc_list_convolution_xa6(A,D,x1,x2,x3,x4,x5,x6),D,A(x7))
# define __myc_list_convolution_xa8(A,D,x1,x2,x3,x4,x5,x6,x7,x8) \
	__myc_xconcat3(__myc_list_convolution_xa7(A,D,x1,x2,x3,x4,x5,x6,x7),D,A(x8))
# define __myc_list_convolution_xa9(A,D,x1,x2,x3,x4,x5,x6,x7,x8,x9) \
	__myc_xconcat3(__myc_list_convolution_xa8(A,D,x1,x2,x3,x4,x5,x6,x7,x8),D,A(x9))
# define __myc_list_convolution_xa10(A,D,x1,x2,x3,x4,x5,x6,x7,x8,x9,x10) \
	__myc_xconcat3(__myc_list_convolution_xa9(A,D,x1,x2,x3,x4,x5,x6,x7,x8,x9),D,A(x10))

/* ----------------------------------------------------------------------------
 * convolution_sa: {A, D, N, (x1,x2,...)} -> {A(x1) D A(x2) D ... D A(xN)}
 */

# define __myc_list_convolution_sa(A,D,N,aListInParen) \
	__myc_list_execp(__myc_xconcat(__myc_list_convolution_sa,N),aListInParen,A,D)

/* ------------------------------------------------------------------------- */

# define __myc_list_convolution_sa1(A,D,x1) A(x1)
# define __myc_list_convolution_sa2(A,D,x1,x2) \
	__myc_sconcat3(__myc_list_convolution_sa1(A,D,x1),D,A(x2))
# define __myc_list_convolution_sa3(A,D,x1,x2,x3) \
	__myc_sconcat3(__myc_list_convolution_sa2(A,D,x1,x2),D,A(x3))
# define __myc_list_convolution_sa4(A,D,x1,x2,x3,x4) \
	__myc_sconcat3(__myc_list_convolution_sa3(A,D,x1,x2,x3),D,A(x4))
# define __myc_list_convolution_sa5(A,D,x1,x2,x3,x4,x5) \
	__myc_sconcat3(__myc_list_convolution_sa4(A,D,x1,x2,x3,x4),D,A(x5))
# define __myc_list_convolution_sa6(A,D,x1,x2,x3,x4,x5,x6) \
	__myc_sconcat3(__myc_list_convolution_sa5(A,D,x1,x2,x3,x4,x5),D,A(x6))
# define __myc_list_convolution_sa7(A,D,x1,x2,x3,x4,x5,x6,x7) \
	__myc_sconcat3(__myc_list_convolution_sa6(A,D,x1,x2,x3,x4,x5,x6),D,A(x7))
# define __myc_list_convolution_sa8(A,D,x1,x2,x3,x4,x5,x6,x7,x8) \
	__myc_sconcat3(__myc_list_convolution_sa7(A,D,x1,x2,x3,x4,x5,x6,x7),D,A(x8))
# define __myc_list_convolution_sa9(A,D,x1,x2,x3,x4,x5,x6,x7,x8,x9) \
	__myc_sconcat3(__myc_list_convolution_sa8(A,D,x1,x2,x3,x4,x5,x6,x7,x8),D,A(x9))
# define __myc_list_convolution_sa10(A,D,x1,x2,x3,x4,x5,x6,x7,x8,x9,x10) \
	__myc_sconcat3(__myc_list_convolution_sa9(A,D,x1,x2,x3,x4,x5,x6,x7,x8,x9),D,A(x10))

/* ----------------------------------------------------------------------------
 * at: {K, (x1,x2,...)} -> {xK}
 */

# define __myc_list_at(K,aListInParen) \
	__myc_list_exec(__myc_xconcat(__myc_list_at_,K),aListInParen)

/* ------------------------------------------------------------------------- */

# if __myc_support(NVM)
#  define __myc_list_at_0(x0,x1...) x0
#  define __myc_list_at_1(x0,x1,x2...) x1
#  define __myc_list_at_2(x0,x1,x2,x3...) x2
#  define __myc_list_at_3(x0,x1,x2,x3,x4...) x3
#  define __myc_list_at_4(x0,x1,x2,x3,x4,x5...) x4
#  define __myc_list_at_5(x0,x1,x2,x3,x4,x5,x6...) x5
#  define __myc_list_at_6(x0,x1,x2,x3,x4,x5,x6,x7...) x6
#  define __myc_list_at_7(x0,x1,x2,x3,x4,x5,x6,x7,x8...) x7
#  define __myc_list_at_8(x0,x1,x2,x3,x4,x5,x6,x7,x8,x9...) x8
#  define __myc_list_at_9(x0,x1,x2,x3,x4,x5,x6,x7,x8,x9,x10...) x9
#  define __myc_list_at_10(x0,x1,x2,x3,x4,x5,x6,x7,x8,x9,x10,x11...) x10
# else
# if __myc_support(AVM)
#  define __myc_list_at_0(x0,...) x0
#  define __myc_list_at_1(x0,x1,...) x1
#  define __myc_list_at_2(x0,x1,x2,...) x2
#  define __myc_list_at_3(x0,x1,x2,x3,...) x3
#  define __myc_list_at_4(x0,x1,x2,x3,x4,...) x4
#  define __myc_list_at_5(x0,x1,x2,x3,x4,x5,...) x5
#  define __myc_list_at_6(x0,x1,x2,x3,x4,x5,x6,...) x6
#  define __myc_list_at_7(x0,x1,x2,x3,x4,x5,x6,x7,...) x7
#  define __myc_list_at_8(x0,x1,x2,x3,x4,x5,x6,x7,x8,...) x8
#  define __myc_list_at_9(x0,x1,x2,x3,x4,x5,x6,x7,x8,x9,...) x9
#  define __myc_list_at_10(x0,x1,x2,x3,x4,x5,x6,x7,x8,x9,x10,...) x10
# endif /* __myc_support(AVM) */
# endif /* __myc_support(NVM) */

/* ----------------------------------------------------------------------------
 * pushback: {(x1,x2,...),z} -> {(x1,x2,...,z)}
 */

# define __myc_list_pushback(aListInParen,aMyCListPushParameter1) \
	__myc_list_pushback_n(aListInParen,1,aMyCListPushParameter1)

# define __myc_list_pushback2(aListInParen,aMyCListPushParameter1,aMyCListPushParameter2) \
	__myc_list_pushback_n(aListInParen,2,aMyCListPushParameter1,aMyCListPushParameter2)

# if __myc_support(NVM)
#  define __myc_list_pushback_n(aListInParen,K,aMyCListPushParameters...) \
	__myc_list_execp(__myc_xconcat(__myc_list_pushback_,K),aListInParen,aMyCListPushParameters)
# else
# if __myc_support(AVM)
#  define __myc_list_pushback_n(aListInParen,K,...) \
	__myc_list_execp(__myc_xconcat(__myc_list_pushback_,K),aListInParen,__VA_ARGS__)
# endif /* __myc_support(AVM) */
# endif /* __myc_support(NVM) */

/* ------------------------------------------------------------------------- */

# if __myc_support(NVM)
#  define __myc_list_pushback_1(a,x1...) (x1,a)
#  define __myc_list_pushback_2(a1,a2,x1...) (x1,a1,a2)
#  define __myc_list_pushback_3(a1,a2,a3,x1...) (x1,a1,a2,a3)
#  define __myc_list_pushback_4(a1,a2,a3,a4,x1...) (x1,a1,a2,a3,a4)
#  define __myc_list_pushback_5(a1,a2,a3,a4,a5,x1...) (x1,a1,a2,a3,a4,a5)
#  define __myc_list_pushback_6(a1,a2,a3,a4,a5,a6,x1...) (x1,a1,a2,a3,a4,a5,a6)
#  define __myc_list_pushback_7(a1,a2,a3,a4,a5,a6,a7,x1...) (x1,a1,a2,a3,a4,a5,a6,a7)
#  define __myc_list_pushback_8(a1,a2,a3,a4,a5,a6,a7,a8,x1...) (x1,a1,a2,a3,a4,a5,a6,a7,a8)
#  define __myc_list_pushback_9(a1,a2,a3,a4,a5,a6,a7,a8,a9,x1...) (x1,a1,a2,a3,a4,a5,a6,a7,a8,a9)
#  define __myc_list_pushback_10(a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,x1...) (x1,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10)
# else
# if __myc_support(AVM)
#  define __myc_list_pushback_1(a,...) (__VA_ARGS__,a)
#  define __myc_list_pushback_2(a1,a2,...) (__VA_ARGS__,a1,a2)
#  define __myc_list_pushback_3(a1,a2,a3,...) (__VA_ARGS__,a1,a2,a3)
#  define __myc_list_pushback_4(a1,a2,a3,a4,...) (__VA_ARGS__,a1,a2,a3,a4)
#  define __myc_list_pushback_5(a1,a2,a3,a4,a5,...) (__VA_ARGS__,a1,a2,a3,a4,a5)
#  define __myc_list_pushback_6(a1,a2,a3,a4,a5,a6,...) (__VA_ARGS__,a1,a2,a3,a4,a5,a6)
#  define __myc_list_pushback_7(a1,a2,a3,a4,a5,a6,a7,...) (__VA_ARGS__,a1,a2,a3,a4,a5,a6,a7)
#  define __myc_list_pushback_8(a1,a2,a3,a4,a5,a6,a7,a8,...) (__VA_ARGS__,a1,a2,a3,a4,a5,a6,a7,a8)
#  define __myc_list_pushback_9(a1,a2,a3,a4,a5,a6,a7,a8,a9,...) (__VA_ARGS__,a1,a2,a3,a4,a5,a6,a7,a8,a9)
#  define __myc_list_pushback_10(a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,...) (__VA_ARGS__,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10)
# endif /* __myc_support(AVM) */
# endif /* __myc_support(NVM) */

/* ----------------------------------------------------------------------------
 * pushfront: {(x1,x2,...),z} -> {(z,x1,x2,...)}
 */

# define __myc_list_pushfront(aListInParen,aMyCListPushParameter1) \
	__myc_list_pushfront_n(aListInParen,1,aMyCListPushParameter1)

# define __myc_list_pushfront2(aListInParen,aMyCListPushParameter1,aMyCListPushParameter2) \
	__myc_list_pushfront_n(aListInParen,2,aMyCListPushParameter1,aMyCListPushParameter2)

# if __myc_support(NVM)
#  define __myc_list_pushfront_n(aListInParen,K,aMyCListPushParameters...) \
	__myc_list_execp(__myc_list_pushfront_0,aListInParen,aMyCListPushParameters)
# else
# if __myc_support(AVM)
#  define __myc_list_pushfront_n(aListInParen,K,...) \
	__myc_list_execp(__myc_list_pushfront_0,aListInParen,__VA_ARGS__)
# endif /* __myc_support(AVM) */
# endif /* __myc_support(NVM) */

/* ------------------------------------------------------------------------- */

# if __myc_support(NVM)
#  define __myc_list_pushfront_0(a...) (a)
# else
# if __myc_support(AVM)
#  define __myc_list_pushfront_0(a,...) (a,__VA_ARGS__)
# endif /* __myc_support(AVM) */
# endif /* __myc_support(NVM) */

/* ----------------------------------------------------------------------------
 * popfront: {(x0,x1,x2,...)} -> {(x1,x2,...)}
 */

# define __myc_list_popfront(aListInParen) \
	__myc_list_popfront_n(aListInParen,1)

# define __myc_list_popfront2(aListInParen) \
	__myc_list_popfront_n(aListInParen,2)

# define __myc_list_popfront_n(aListInParen,K) \
	__myc_list_exec(__myc_xconcat(__myc_list_popfront_,K),aListInParen)

/* ------------------------------------------------------------------------- */

# if __myc_support(NVM)
#  define __myc_list_popfront_1(x0,x1...) (x1)
#  define __myc_list_popfront_2(x0,x1,x2...) (x2)
#  define __myc_list_popfront_3(x0,x1,x2,x3...) (x3)
#  define __myc_list_popfront_4(x0,x1,x2,x3,x4...) (x4)
#  define __myc_list_popfront_5(x0,x1,x2,x3,x4,x5...) (x5)
#  define __myc_list_popfront_6(x0,x1,x2,x3,x4,x5,x6...) (x6)
#  define __myc_list_popfront_7(x0,x1,x2,x3,x4,x5,x6,x7...) (x7)
#  define __myc_list_popfront_8(x0,x1,x2,x3,x4,x5,x6,x7,x8...) (x8)
#  define __myc_list_popfront_9(x0,x1,x2,x3,x4,x5,x6,x7,x8,x9...) (x9)
#  define __myc_list_popfront_10(x0,x1,x2,x3,x4,x5,x6,x7,x8,x9,x10...) (x10)
# else
# if __myc_support(AVM)
#  define __myc_list_popfront_1(x0,...) (__VA_ARGS__)
#  define __myc_list_popfront_2(x0,x1,...) (__VA_ARGS__)
#  define __myc_list_popfront_3(x0,x1,x2,...) (__VA_ARGS__)
#  define __myc_list_popfront_4(x0,x1,x2,x3,...) (__VA_ARGS__)
#  define __myc_list_popfront_5(x0,x1,x2,x3,x4,...) (__VA_ARGS__)
#  define __myc_list_popfront_6(x0,x1,x2,x3,x4,x5,...) (__VA_ARGS__)
#  define __myc_list_popfront_7(x0,x1,x2,x3,x4,x5,x6,...) (__VA_ARGS__)
#  define __myc_list_popfront_8(x0,x1,x2,x3,x4,x5,x6,x7,...) (__VA_ARGS__)
#  define __myc_list_popfront_9(x0,x1,x2,x3,x4,x5,x6,x7,x8,...) (__VA_ARGS__)
#  define __myc_list_popfront_10(x0,x1,x2,x3,x4,x5,x6,x7,x8,x9,...) (__VA_ARGS__)
# endif /* __myc_support(AVM) */
# endif /* __myc_support(NVM) */

/* ----------------------------------------------------------------------------
 * replacefront: {(x0,x1,x2,...),z} -> {(z,x1,x2,...)}
 */

# define __myc_list_replacefront(aListInParen,aMyCListPushParameter) \
	__myc_list_pushfront(__myc_list_popfront(aListInParen),aMyCListPushParameter)

# define __myc_list_replacefront2(aListInParen,aMyCListPushParameter1,aMyCListPushParameter2) \
	__myc_list_replacefront_n(aListInParen,2,aMyCListPushParameter1,aMyCListPushParameter2)

# if __myc_support(NVM)
#  define __myc_list_replacefront_n(aListInParen,K,aMyCListPushParameters...) \
	__myc_list_pushfront_n(__myc_list_popfront_n(aListInParen,K),K,aMyCListPushParameters)
# else
# if __myc_support(AVM)
#  define __myc_list_replacefront_n(aListInParen,K,...) \
	__myc_list_pushfront_n(__myc_list_popfront_n(aListInParen,K),K,__VA_ARGS__)
# endif /* __myc_support(AVM) */
# endif /* __myc_support(NVM) */

/* ----------------------------------------------------------------------------
 * apply_to: {A, K, (x0,x1,x2,...)} -> {(x0,x1,x2,...A(xK),...)}
 */

# define __myc_list_apply_to(A,K,aListInParen) \
	__myc_list_execp(__myc_xconcat(__myc_list_apply_to_,K),aListInParen,A)

/* ------------------------------------------------------------------------- */

# ifdef __GNUC__

#  if __myc_support(NVM)
#   define __myc_list_apply_to_0(A,x0,x1...) (A(x0) , ##x1)
#   define __myc_list_apply_to_1(A,x0,x1,x2...) (x0,A(x1) , ##x2)
#   define __myc_list_apply_to_2(A,x0,x1,x2,x3...) (x0,x1,A(x2) , ##x3)
#   define __myc_list_apply_to_3(A,x0,x1,x2,x3,x4...) (x0,x1,x2,A(x3) , ##x4)
#   define __myc_list_apply_to_4(A,x0,x1,x2,x3,x4,x5...) (x0,x1,x2,x3,A(x4) , ##x5)
#   define __myc_list_apply_to_5(A,x0,x1,x2,x3,x4,x5,x6...) (x0,x1,x2,x3,x4,A(x5) , ##x6)
#   define __myc_list_apply_to_6(A,x0,x1,x2,x3,x4,x5,x6,x7...) (x0,x1,x2,x3,x4,x5,A(x6) , ##x7)
#   define __myc_list_apply_to_7(A,x0,x1,x2,x3,x4,x5,x6,x7,x8...) (x0,x1,x2,x3,x4,x5,x6,A(x7) , ##x8)
#   define __myc_list_apply_to_8(A,x0,x1,x2,x3,x4,x5,x6,x7,x8,x9...)  (x0,x1,x2,x3,x4,x5,x6,x7,A(x8) , ##x9)
#   define __myc_list_apply_to_9(A,x0,x1,x2,x3,x4,x5,x6,x7,x8,x9,x10...) (x0,x1,x2,x3,x4,x5,x6,x7,x8,A(x9) , ##x10)
#  else
#  if __myc_support(AVM)
#   define __myc_list_apply_to_0(A,x0,...) (A(x0), ##__VA_ARGS__)
#   define __myc_list_apply_to_1(A,x0,x1,...) (x0,A(x1), ##__VA_ARGS__)
#   define __myc_list_apply_to_2(A,x0,x1,x2,...) (x0,x1,A(x2), ##__VA_ARGS__)
#   define __myc_list_apply_to_3(A,x0,x1,x2,x3,...) (x0,x1,x2,A(x3), ##__VA_ARGS__)
#   define __myc_list_apply_to_4(A,x0,x1,x2,x3,x4,...) (x0,x1,x2,x3,A(x4), ##__VA_ARGS__)
#   define __myc_list_apply_to_5(A,x0,x1,x2,x3,x4,x5,...) (x0,x1,x2,x3,x4,A(x5), ##__VA_ARGS__)
#   define __myc_list_apply_to_6(A,x0,x1,x2,x3,x4,x5,x6,...) (x0,x1,x2,x3,x4,x5,A(x6), ##__VA_ARGS__)
#   define __myc_list_apply_to_7(A,x0,x1,x2,x3,x4,x5,x6,x7,...) (x0,x1,x2,x3,x4,x5,x6,A(x7), ##__VA_ARGS__)
#   define __myc_list_apply_to_8(A,x0,x1,x2,x3,x4,x5,x6,x7,x8,...)  (x0,x1,x2,x3,x4,x5,x6,x7,A(x8), ##__VA_ARGS__)
#   define __myc_list_apply_to_9(A,x0,x1,x2,x3,x4,x5,x6,x7,x8,x9,...) (x0,x1,x2,x3,x4,x5,x6,x7,x8,A(x9), ##__VA_ARGS__)
#  endif /* __myc_support(AVM) */
#  endif /* __myc_support(NVM) */

# else
# ifdef _MSC_VER

#  define __myc_list_apply_to_0(A,x0,...) (A(x0),__VA_ARGS__)
#  define __myc_list_apply_to_1(A,x0,x1,...) (x0,A(x1),__VA_ARGS__)
#  define __myc_list_apply_to_2(A,x0,x1,x2,...) (x0,x1,A(x2),__VA_ARGS__)
#  define __myc_list_apply_to_3(A,x0,x1,x2,x3,...) (x0,x1,x2,A(x3),__VA_ARGS__)
#  define __myc_list_apply_to_4(A,x0,x1,x2,x3,x4,...) (x0,x1,x2,x3,A(x4),__VA_ARGS__)
#  define __myc_list_apply_to_5(A,x0,x1,x2,x3,x4,x5,...) (x0,x1,x2,x3,x4,A(x5),__VA_ARGS__)
#  define __myc_list_apply_to_6(A,x0,x1,x2,x3,x4,x5,x6,...) (x0,x1,x2,x3,x4,x5,A(x6),__VA_ARGS__)
#  define __myc_list_apply_to_7(A,x0,x1,x2,x3,x4,x5,x6,x7,...) (x0,x1,x2,x3,x4,x5,x6,A(x7),__VA_ARGS__)
#  define __myc_list_apply_to_8(A,x0,x1,x2,x3,x4,x5,x6,x7,x8,...)  (x0,x1,x2,x3,x4,x5,x6,x7,A(x8),__VA_ARGS__)
#  define __myc_list_apply_to_9(A,x0,x1,x2,x3,x4,x5,x6,x7,x8,x9,...) (x0,x1,x2,x3,x4,x5,x6,x7,x8,A(x9),__VA_ARGS__)

# else

/*
 * Generic version has a problem if the variable argument is left out.
 */
#  if __myc_support(NVM)
#   define __myc_list_apply_to_0(A,x0,x1...) (A(x0),x1)
#   define __myc_list_apply_to_1(A,x0,x1,x2...) (x0,A(x1),x2)
#   define __myc_list_apply_to_2(A,x0,x1,x2,x3...) (x0,x1,A(x2),x3)
#   define __myc_list_apply_to_3(A,x0,x1,x2,x3,x4...) (x0,x1,x2,A(x3),x4)
#   define __myc_list_apply_to_4(A,x0,x1,x2,x3,x4,x5...) (x0,x1,x2,x3,A(x4),x5)
#   define __myc_list_apply_to_5(A,x0,x1,x2,x3,x4,x5,x6...) (x0,x1,x2,x3,x4,A(x5),x6)
#   define __myc_list_apply_to_6(A,x0,x1,x2,x3,x4,x5,x6,x7...) (x0,x1,x2,x3,x4,x5,A(x6),x7)
#   define __myc_list_apply_to_7(A,x0,x1,x2,x3,x4,x5,x6,x7,x8...) (x0,x1,x2,x3,x4,x5,x6,A(x7),x8)
#   define __myc_list_apply_to_8(A,x0,x1,x2,x3,x4,x5,x6,x7,x8,x9...)  (x0,x1,x2,x3,x4,x5,x6,x7,A(x8),x9)
#   define __myc_list_apply_to_9(A,x0,x1,x2,x3,x4,x5,x6,x7,x8,x9,x10...) (x0,x1,x2,x3,x4,x5,x6,x7,x8,A(x9),x10)
#  else
#  if __myc_support(AVM)
#   define __myc_list_apply_to_0(A,x0,...) (A(x0),__VA_ARGS__)
#   define __myc_list_apply_to_1(A,x0,x1,...) (x0,A(x1),__VA_ARGS__)
#   define __myc_list_apply_to_2(A,x0,x1,x2,...) (x0,x1,A(x2),__VA_ARGS__)
#   define __myc_list_apply_to_3(A,x0,x1,x2,x3,...) (x0,x1,x2,A(x3),__VA_ARGS__)
#   define __myc_list_apply_to_4(A,x0,x1,x2,x3,x4,...) (x0,x1,x2,x3,A(x4),__VA_ARGS__)
#   define __myc_list_apply_to_5(A,x0,x1,x2,x3,x4,x5,...) (x0,x1,x2,x3,x4,A(x5),__VA_ARGS__)
#   define __myc_list_apply_to_6(A,x0,x1,x2,x3,x4,x5,x6,...) (x0,x1,x2,x3,x4,x5,A(x6),__VA_ARGS__)
#   define __myc_list_apply_to_7(A,x0,x1,x2,x3,x4,x5,x6,x7,...) (x0,x1,x2,x3,x4,x5,x6,A(x7),__VA_ARGS__)
#   define __myc_list_apply_to_8(A,x0,x1,x2,x3,x4,x5,x6,x7,x8,...)  (x0,x1,x2,x3,x4,x5,x6,x7,A(x8),__VA_ARGS__)
#   define __myc_list_apply_to_9(A,x0,x1,x2,x3,x4,x5,x6,x7,x8,x9,...) (x0,x1,x2,x3,x4,x5,x6,x7,x8,A(x9),__VA_ARGS__)
#  endif /* __myc_support(AVM) */
#  endif /* __myc_support(NVM) */

# endif /* _MSC_VER */
# endif /* __GNUC__ */

/* ----------------------------------------------------------------------------
 * apply2_to: {A2, K2, A1, K1, (x0,x1,x2,...)} -> {(x0,x1,x2,...A1(xK1),...,A2(K2),...)}
 */

# define __myc_list_apply2_to(A2,K2,A1,K1,aListInParen) \
	__myc_list_apply_to(A2,K2,__myc_list_apply_to(A1,K1,aListInParen))

/* ----------------------------------------------------------------------------
 * foreach: {A, N, (x1,x2,...)} -> {A(x1),A(x2),...,A(xN)}
 */

# define __myc_list_foreach(A,N,aListInParen) \
	__myc_list_execp(__myc_xconcat(__myc_list_foreach,N),aListInParen,A)

/* ------------------------------------------------------------------------- */

# define __myc_list_foreach1(A,x1) (A(x1))
# define __myc_list_foreach2(A,x1,x2) (A(x1),A(x2))
# define __myc_list_foreach3(A,x1,x2,x3) (A(x1),A(x2),A(x3))
# define __myc_list_foreach4(A,x1,x2,x3,x4) (A(x1),A(x2),A(x3),A(x4))
# define __myc_list_foreach5(A,x1,x2,x3,x4,x5) (A(x1),A(x2),A(x3),A(x4),A(x5))
# define __myc_list_foreach6(A,x1,x2,x3,x4,x5,x6) (A(x1),A(x2),A(x3),A(x4),A(x5),A(x6))
# define __myc_list_foreach7(A,x1,x2,x3,x4,x5,x6,x7) (A(x1),A(x2),A(x3),A(x4),A(x5),A(x6),A(x7))
# define __myc_list_foreach8(A,x1,x2,x3,x4,x5,x6,x7,x8) (A(x1),A(x2),A(x3),A(x4),A(x5),A(x6),A(x7),A(x8))
# define __myc_list_foreach9(A,x1,x2,x3,x4,x5,x6,x7,x8,x9)  (A(x1),A(x2),A(x3),A(x4),A(x5),A(x6),A(x7),A(x8),A(x9))
# define __myc_list_foreach10(A,x1,x2,x3,x4,x5,x6,x7,x8,x9,x10) (A(x1),A(x2),A(x3),A(x4),A(x5),A(x6),A(x7),A(x8),A(x9),A(x10))

/* ----------------------------------------------------------------------------
 * traits support
 */

# define __myc_traits_name(aTraitsName,aNameOfInterest) \
	__myc_xconcat3(aTraitsName,_traits_,aNameOfInterest)

# define __myc_traits_value(aTraitsName,aNameOfInterest) \
	__myc_xconcat3(aTraitsName,_traits_,aNameOfInterest)

/* Useful for compile time only */
# define __myc_traits_bool(aTraitsName,aNameOfInterest) \
	(0 != (__myc_xconcat3(aTraitsName,_traits_,aNameOfInterest) + 0))

/* ----------------------------------------------------------------------------
 * thread private storage support
 */

# if __myc_support_omp_pragma(threadprivate)
#  define __myc_begin_threadprivate(aName)
#  define __myc_end_threadprivate(aName) __myc_pragma(omp threadprivate(aName))
# endif

# if __myc_support(thread_storage_class)
#  define __MYC_BEGIN_THREADPRIVATE(aName)
#  define __MYC_END_THREADPRIVATE(aName)
#else
#if __myc_support_omp_pragma(threadprivate)
#  define __MYC_BEGIN_THREADPRIVATE(aName) __myc_begin_threadprivate(aName)
#  define __MYC_END_THREADPRIVATE(aName) __myc_end_threadprivate(aName)
#else
#  define __MYC_BEGIN_THREADPRIVATE(aName)
#  define __MYC_END_THREADPRIVATE(aName)
#endif /* __myc_support_omp_pragma(threadprivate) */
#endif /* __myc_support(thread_storage_class) */

/******************************************************************************
 * %% BeginSection: includes
 */
# pragma mark -

# include <Bo/sys/Linkage.h>

#endif /* !__BO_SYS_CDEFS__ */

#ifndef __BO_SYS_TYPES__
# include <Bo/sys/Types.h>
#endif

#ifndef __BO__AORP_CDEFS__
# include <Bo/aorp/_AorpCdefs.h>
# define __BO__AORP_CDEFS__
#endif

/******************************************************************************
 * Revision History:
 *		$Log$
 *
 *****************************************************************************/
