/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright (c) 2005-2007 V.Sokur
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

/*
 * Siteconfig.h	(V.Sokur)
 * include/Bo/sys/Siteconfig.h
 *
 * $Id$
 */

/******************************************************************************
 * %% BeginSection: declarations
 */

#ifdef __SITECONFIG_BEFORE_SYSCONFIG

/*
 * Use compile options
 */

/* # define _POSIX_SOURCE // 1003.1-1988 */
# ifdef _WIN32
#  ifdef _POSIX_SOURCE
#   ifndef _POSIX_
#    define _POSIX_
#   endif
#  endif
#  ifdef _POSIX_
#   ifndef _POSIX_SOURCE
#    define _POSIX_SOURCE
#   endif
#  endif
# endif
/*
# ifndef _XOPEN_SOURCE
#  define _XOPEN_SOURCE 600L
# endif
 */

# ifdef __GNUC__
#  ifndef _GNU_SOURCE
#   define _GNU_SOURCE /* includes BSD, XOPEN (?) */
#  endif
# endif /* __GNUC__ */
# ifdef __GNUC__
/* @todo: fixme - compiler version */
#  if __GNUC__ > 5 || (__GNUC__ == 5 && __GNUC_MINOR__ >= 2)
#   ifndef _DEFAULT_SOURCE
#    define _DEFAULT_SOURCE
#   endif
#  else
#   ifndef _BSD_SOURCE
#    define _BSD_SOURCE
#   endif
#  endif
# else
#  ifndef _BSD_SOURCE
#   define _BSD_SOURCE
#  endif
# endif

/* See BO_BUILD_MULTITHREADED in "Bo/sys/_BoConfig.h" */
# ifndef _NO_REENTRANT
#  ifndef _REENTRANT
#   define _REENTRANT
#  endif
# endif
# ifndef _NO_THREAD_SAFE
#  ifndef _THREAD_SAFE
#   define _THREAD_SAFE
#  endif
# endif
# ifdef _REENTRANT
#  ifndef _THREAD_SAFE
#   define _THREAD_SAFE
#  endif
# endif
# ifdef _THREAD_SAFE
#  ifndef _REENTRANT
#   define _REENTRANT
#  endif
# endif


/*
 * Defaults
 * May be redefined in the platform specific Sysconfig.h
 */

# ifndef _FILE_OFFSET_BITS
#  define _FILE_OFFSET_BITS 64
# endif
# ifndef _LARGEFILE_SOURCE
#  define _LARGEFILE_SOURCE
# endif
# ifndef _LARGEFILE64_SOURCE
#  ifdef _LARGEFILE_SOURCE
#   if (64 <= _FILE_OFFSET_BITS + 0)
#    define _LARGEFILE64_SOURCE
#   endif
#  endif
# endif

#endif /* __SITECONFIG_BEFORE_SYSCONFIG */

/* ------------------------------------------------------------------------- */
#pragma mark -
/* ------------------------------------------------------------------------- */

#ifdef __SITECONFIG_AFTER_SYSCONFIG

#endif /* __SITECONFIG_AFTER_SYSCONFIG */

/******************************************************************************
 * Revision History:
 *		$Log$
 *
 *****************************************************************************/
