/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright (c) 2005-2007 V.Sokur
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

/*
 * Stdconfig.h	(V.Sokur)
 * include/Bo/sys/Stdconfig.h
 *
 * $Id$
 */

/* ------------------------------------------------------------------------- */

#ifndef __BO_SYS_STDCONFIG__
# define __BO_SYS_STDCONFIG__

/* unknown pragma */
# ifdef _MSC_VER
#  pragma warning(disable:4068)
# endif


# ifndef YES
#  define YES 1
# endif
# ifndef NO
#  define NO 0
# endif

# if 0
# ifdef WITH_DEBUG
#  ifdef NDEBUG
#   undef NDEBUG
#  endif
# else
#  ifndef NDEBUG
#   define NDEBUG 1
#  endif
# endif
# endif /* if 0 */


# define __SITECONFIG_BEFORE_SYSCONFIG
# include <Bo/sys/Siteconfig.h>
# undef __SITECONFIG_BEFORE_SYSCONFIG

/*
 * Specific
 */
# include <Bo/whereami/Siteguess.h>
# include <Bo/sys/Sysparam.h>
# include <Bo/sys/Sysconfig.h>

# define __SITECONFIG_AFTER_SYSCONFIG
# include <Bo/sys/Siteconfig.h>
# undef __SITECONFIG_AFTER_SYSCONFIG


# define __BOCONFIG_BEFORE_PROJECT_CONFIG
# include <Bo/sys/BoConfig.h>
# undef __BOCONFIG_BEFORE_PROJECT_CONFIG

# ifdef CONFIG_HEADER
#  include CONFIG_HEADER
# else
#  ifdef HAS_CONFIG_H
#   include "config.h"
#  endif
# endif

# define __BOCONFIG_AFTER_PROJECT_CONFIG
# include <Bo/sys/BoConfig.h>
# undef __BOCONFIG_AFTER_PROJECT_CONFIG

#endif /* !__BO_SYS_STDCONFIG__ */
