/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright (c) 2005-2007 V.Sokur
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

/*
 * Sysparam.h	(V.Sokur)
 * include/Bo/sys/Sysparam.h
 *
 * $Id$
 */

/* ------------------------------------------------------------------------- */

#ifndef __BO_SYS_SYSPARAM__
# define __BO_SYS_SYSPARAM__

# ifndef __BO_SYS_STDCONFIG__
#  error You should not include this file directly!
# endif

/******************************************************************************
 *  machine specific
 */

# ifndef LITTLE_BYTE_ORDER
#  define LITTLE_BYTE_ORDER __bo_machine_le
# endif
# ifndef BIG_BYTE_ORDER
#  define BIG_BYTE_ORDER __bo_machine_be
# endif
# ifndef BO_BYTE_ORDER
#  define BO_BYTE_ORDER __bo_byteorder
# endif

# if (BO_BYTE_ORDER == LITTLE_BYTE_ORDER)
#  ifndef __LITTLE_ENDIAN__
#   define __LITTLE_ENDIAN__
#  endif
# endif
# if (BO_BYTE_ORDER == BIG_BYTE_ORDER)
#  ifndef __BIG_ENDIAN__
#   define __BIG_ENDIAN__
#  endif
# endif

# ifndef BO_M_WORD32
#  define BO_M_WORD32 __bo_machine_word32
# endif
# ifndef BO_M_WORD64
#  define BO_M_WORD64 __bo_machine_word64
# endif

# ifndef BO_M_WORD
#  define BO_M_WORD __bo_machine_word
# endif

# ifndef BoK_NATURAL_ALIGN
#  ifdef __bo_machine_natural_align
#   define BoK_NATURAL_ALIGN __bo_machine_natural_align
#  endif
# endif
# ifndef BoK_NATURAL_ALIGN
#  if BO_M_WORD == BO_M_WORD32
#   define BoK_NATURAL_ALIGN 4
#  endif
#  if BO_M_WORD == BO_M_WORD64
#   define BoK_NATURAL_ALIGN 8
#  endif
# endif

/******************************************************************************
 *  platform specific
 */

# include _BO_PLATFORM_CONFIG_HEADER(Sysparam.h)

#endif /* !__BO_SYS_SYSPARAM__ */
