/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright (c) 2005-2007 V.Sokur
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

/*
 * _BoConfig.h	(V.Sokur)
 * include/Bo/sys/_BoConfig.h
 *
 * $Id$
 */

/******************************************************************************
 * %% BeginSection: declarations
 */

#ifdef __BOCONFIG_BEFORE_PROJECT_CONFIG

# ifndef build_shlib_libBo
# ifndef use_shlib_libBo
# ifndef build_archive_libBo
# ifndef use_archive_libBo
#  define use_shlib_libBo 1
# endif /* !use_archive_libBo */
# endif /* !build_archive_libBo */
# endif /* !use_shlib_libBo */
# endif /* !build_shlib_libBo */

# define BO_BUILTIN_MODULES
# define BO_BUILTIN_AKM_MODULE /* aorp-kernel-module */
# define BO_BUILTIN_ERROR_MODULE
# define BO_BUILTIN_CCSI_MODULE
# define BO_BUILTIN_CCSCONV_MODULE

# define BO_USE_UDVARIANT_VERSION 64

# define BO_BUILD_MULTITHREADED
/*
 * mutually exclusive
 *
# define BO_BUILD_SINGLETHREADED
 */

# define SMP

/* # define BO_CPU_DISABLE_CMPXCHG */

#endif /* __BOCONFIG_BEFORE_PROJECT_CONFIG */

/* ------------------------------------------------------------------------- */
#pragma mark -
/* ------------------------------------------------------------------------- */

#ifdef __BOCONFIG_AFTER_PROJECT_CONFIG

# ifdef NDEBUG
#  undef _DEBUG
#  undef _CRT_MANIFEST_DEBUG
# endif
# ifdef _DEBUG
#  ifndef BO_CRT_NDEBUG0
#   ifndef _BO_CRT_DEBUG0
#    define _BO_CRT_DEBUG0
#   endif
#  endif
# endif

#endif /* __BOCONFIG_AFTER_PROJECT_CONFIG */

/******************************************************************************
 * Revision History:
 *		$Log$
 *
 *****************************************************************************/
