/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright (c) 2005-2007 V.Sokur
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

/*
 * _FModedefs.h	(V.Sokur)
 * include/Bo/sys/_FModedefs.h
 *
 * $Id$
 */

/* ------------------------------------------------------------------------- */

#ifndef __BO_SYS_FMODEDEFS__
# define __BO_SYS_FMODEDEFS__

/******************************************************************************
 * %% BeginSection: constant declarations / macro definitions
 */

/* stat interface */

/*
 * File mode constants
 */

# ifndef S_IFMMASK
#  define S_IFMMASK 0007777 /* @todo: ??? */
# endif

/* Read, write, execute/search by owner */

/* RWX mask for owner */
# ifndef S_IRWXU
#  ifdef _S_IRWXU
#   define S_IRWXU _S_IRWXU
#  else
#   define S_IRWXU 0000700
#  endif
# endif
/* R for owner */
# ifndef S_IRUSR
#  ifdef _S_IRUSR
#   define S_IRUSR _S_IRUSR
#  else
#   define S_IRUSR 0000400
#  endif
# endif
/* W for owner */
# ifndef S_IWUSR
#  ifdef _S_IWUSR
#   define S_IWUSR _S_IWUSR
#  else
#   define S_IWUSR 0000200
#  endif
# endif
/* X for owner */
# ifndef S_IXUSR
#  ifdef _S_IXUSR
#   define S_IXUSR _S_IXUSR
#  else
#   define S_IXUSR 0000100
#  endif
# endif

/* Read, write, execute/search by group */

/* RWX mask for group */
# ifndef S_IRWXG
#  ifdef _S_IRWXG
#   define S_IRWXG _S_IRWXG
#  else
#   define S_IRWXG 0000070
#  endif
# endif
/* R for group */
# ifndef S_IRGRP
#  ifdef _S_IRGRP
#   define S_IRGRP _S_IRGRP
#  else
#   define S_IRGRP 0000040
#  endif
# endif
/* W for group */
# ifndef S_IWGRP
#  ifdef _S_IWGRP
#   define S_IWGRP _S_IWGRP
#  else
#   define S_IWGRP 0000020
#  endif
# endif
/* X for group */
# ifndef S_IXGRP
#  ifdef _S_IXGRP
#   define S_IXGRP _S_IXGRP
#  else
#   define S_IXGRP 0000010
#  endif
# endif

/* Read, write, execute/search by others */

/* RWX mask for other */
# ifndef S_IRWXO
#  ifdef _S_IRWXO
#   define S_IRWXO _S_IRWXO
#  else
#   define S_IRWXO 0000007
#  endif
# endif
/* R for other */
# ifndef S_IROTH
#  ifdef _S_IROTH
#   define S_IROTH _S_IROTH
#  else
#   define S_IROTH 0000004
#  endif
# endif
/* W for other */
# ifndef S_IWOTH
#  ifdef _S_IWOTH
#   define S_IWOTH _S_IWOTH
#  else
#   define S_IWOTH 0000002
#  endif
# endif
/* X for other */
# ifndef S_IXOTH
#  ifdef _S_IXOTH
#   define S_IXOTH _S_IXOTH
#  else
#   define S_IXOTH 0000001
#  endif
# endif

# ifndef S_ISEXTRAB
#  define S_ISEXTRAB 07000
# endif
# ifndef S_ISUID
#  define S_ISUID 00 /* 0004000 */ /* set user id on execution */
# endif
# ifndef S_ISGID
#  define S_ISGID 00 /* 0002000 */ /* set group id on execution */
# endif
# ifndef S_ISVTX
#  define S_ISVTX 00 /* 0001000 */ /* directory restricted delete */
# endif

#endif /* !__BO_SYS_FMODEDEFS__ */

/******************************************************************************
 * Revision History:
 *		$Log$
 *
 *****************************************************************************/
