/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright (c) 2005-2007 V.Sokur
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

/*
 * _FTypedefs.h	(V.Sokur)
 * include/Bo/sys/_FTypedefs.h
 *
 * $Id$
 */

/* ------------------------------------------------------------------------- */

#ifndef __BO_SYS_FTYPEDEFS__
# define __BO_SYS_FTYPEDEFS__

/******************************************************************************
 * %% BeginSection: constant declarations / macro definitions
 */

/* stat interface */

/*
 * File type constants
 */

# ifndef S_IFMT
#  ifdef _S_IFMT
#   define S_IFMT _S_IFMT /* file type mask */
#  endif
# endif

# ifndef S_IFIFO
#  ifdef _S_IFIFO
#   define S_IFIFO _S_IFIFO /* named pipe (fifo) */
#  endif
# endif
# ifndef S_IFCHR
#  ifdef _S_IFCHR
#   define S_IFCHR _S_IFCHR /* character special */
#  endif
# endif
# ifndef S_IFDIR
#  ifdef _S_IFDIR
#   define S_IFDIR _S_IFDIR /* directory */
#  endif
# endif
# ifndef S_IFBLK
#  ifdef _S_IFBLK
#   define S_IFBLK _S_IFBLK /* block special */
#  endif
# endif
# ifndef S_IFREG
#  ifdef _S_IFREG
#   define S_IFREG _S_IFREG /* regular */
#  endif
# endif
# ifndef S_IFLNK
#  ifdef _S_IFLNK
#   define S_IFLNK _S_IFLNK /* symbolic link */
#  endif
# endif
# ifndef S_IFSOCK
#  ifdef _S_IFSOCK
#   define S_IFSOCK _S_IFSOCK /* socket */
#  endif
# endif

/*
 * The following macros are provided to test whether a file is
 * of the specified type.
 */

# ifndef S_ISFIFO
#  ifdef S_IFIFO
#   define S_ISFIFO(aMode) (S_IFIFO == ((aMode) & S_IFMT))
#  else
#   define S_ISFIFO(aMode) (0)
#  endif
# endif
# ifndef S_ISCHR
#  ifdef S_IFCHR
#   define S_ISCHR(aMode) (S_IFCHR == ((aMode) & S_IFMT))
#  else
#   define S_ISCHR(aMode) (0)
#  endif
# endif
# ifndef S_ISDIR
#  ifdef S_IFDIR
#   define S_ISDIR(aMode) (S_IFDIR == ((aMode) & S_IFMT))
#  else
#   define S_ISDIR(aMode) (0)
#  endif
# endif
# ifndef S_ISBLK
#  ifdef S_IFBLK
#   define S_ISBLK(aMode) (S_IFBLK == ((aMode) & S_IFMT))
#  else
#   define S_ISBLK(aMode) (0)
#  endif
# endif
# ifndef S_ISREG
#  ifdef S_IFREG
#   define S_ISREG(aMode) (S_IFREG == ((aMode) & S_IFMT))
#  else
#   define S_ISREG(aMode) (0)
#  endif
# endif
# ifndef S_ISLNK
#  ifdef S_IFLNK
#   define S_ISLNK(aMode) (S_IFLNK == ((aMode) & S_IFMT))
#  else
#   define S_ISLNK(aMode) (0)
#  endif
# endif
# ifndef S_ISSOCK
#  ifdef S_IFSOCK
#   define S_ISSOCK(aMode) (S_IFSOCK == ((aMode) & S_IFMT))
#  else
#   define S_ISSOCK(aMode) (0)
#  endif
# endif

#endif /* !__BO_SYS_FTYPEDEFS__ */

/******************************************************************************
 * Revision History:
 *		$Log$
 *
 *****************************************************************************/
