/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright (c) 2005-2007 V.Sokur
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

/*
 * _Stdbool.h	(V.Sokur)
 * include/Bo/sys/_Stdbool.h
 *
 * $Id$
 */

/* ------------------------------------------------------------------------- */

#ifndef __BO_SYS__STDBOOL__
# define __BO_SYS__STDBOOL__

/******************************************************************************
 * %% BeginSection: type declarations
 */
# pragma mark -
# pragma mark [ type declarations ]
# pragma mark -

# if __myc_support_type(_Bool)

#  if __myc_exists(stdbool,h)
#   include __MYC_LIBC_HEADER(stdbool.h)
#  else /* !has_stdbool_h */
#   ifndef __cplusplus
#    define bool _Bool
#    define true 1
#    define false 0
#    define __bool_true_false_are_defined 1
#   endif /* !__cplusplus  */
#  endif /* !has_stdbool_h */

#  ifdef __cplusplus
#   ifndef _MSC_VER
#    ifndef _Bool
#     define _Bool int /* bool */
#    endif
#   else
#   if _MSC_VER < 1900
#    include <yvals.h>
using ::std::_Bool;
#   else
typedef char _Bool;
#   endif
#   endif
#  endif /* __cplusplus  */

# else /* !__myc_support_type(_Bool) */

#  ifndef _MSC_VER

typedef int _Bool;
#   define SIZEOF__BOOL SIZEOF_INT

#   ifdef __cplusplus
#    ifndef _Bool
#     define _Bool int /* bool */
#    endif
#   endif /* __cplusplus  */

#  else /* _MSC_VER */
#   ifndef __cplusplus
typedef int _Bool;
#    define SIZEOF__BOOL SIZEOF_INT
#   else /* __cplusplus */
#    include <yvals.h>
// using ::std::_Bool;
typedef int _Bool;
#   endif /* __cplusplus */
#  endif /* _MSC_VER */

#  ifndef __cplusplus
#   define bool _Bool
#   define true 1
#   define false 0
#   define __bool_true_false_are_defined 1
#  endif /* !__cplusplus  */

# endif /* __myc_support_type(_Bool) */

#endif /* !__BO_SYS__STDBOOL__ */

/******************************************************************************
 * Revision History:
 *		$Log$
 *
 *****************************************************************************/
