/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright (c) 2005-2007 V.Sokur
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

/*
 * _Sched.h	(V.Sokur)
 * include/Bo/sys/posix/_Sched.h
 *
 * $Id$
 */

/* ------------------------------------------------------------------------- */

#ifndef __BO_POSIX__SCHED__
# define __BO_POSIX__SCHED__

/******************************************************************************
 * %% BeginSection: includes
 */

# if __myc_exists(sched,h)
#  include __MYC_LIBC_HEADER(sched.h)
# else
# ifdef HAS_PTHREAD_YIELD_NP
#  include __MYC_LIBC_HEADER(pthread.h)
# else
# ifdef HAS_PTHREAD_YIELD
#  include __MYC_LIBC_HEADER(pthread.h)
# else
# if __myc_exists(unistd,h)
#  include __MYC_LIBC_HEADER(unistd.h)
# endif /* __myc_exists(unistd,h) */
# endif /* HAS_PTHREAD_YIELD */
# endif /* HAS_PTHREAD_YIELD_NP */
# endif /* __myc_exists(sched,h) */

/******************************************************************************
 * %% BeginSection: definitions
 */

# if __myc_exists(sched,h)
#  define BoSchedYield() sched_yield()
# else
# ifdef HAS_PTHREAD_YIELD_NP
#  define BoSchedYield() pthread_yield_np()
# else
# ifdef HAS_PTHREAD_YIELD
#  define BoSchedYield() pthread_yield()
# else
# if __myc_exists(unistd,h)
#  define BoSchedYield() usleep(1000)
# endif /* __myc_exists(unistd,h) */
# endif /* HAS_PTHREAD_YIELD */
# endif /* HAS_PTHREAD_YIELD_NP */
# endif /* __myc_exists(sched,h) */

#endif /* !__BO_POSIX__SCHED__ */

/******************************************************************************
 * Revision History:
 *		$Log$
 *
 *****************************************************************************/
