/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright (c) 2005-2007 V.Sokur
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

/*
 * BoConfig.h	(V.Sokur)
 * include/Bo/sys/w32/BoConfig.h
 *
 * $Id$
 */

/******************************************************************************
 * %% BeginSection: declarations
 */

/* additionals Bo.library requires here */

#ifdef __BOCONFIG_BEFORE_PROJECT_CONFIG

// Refer to MSDN for the latest info on corresponding values for different platforms.

// Allow use of features specific to Windows XP or later.
# define _BO_BUILD_WINVER 0x0501 /* WINVER */

// Allow use of features specific to Windows XP or later.
# define _BO_BUILD_WIN32_WINNT 0x0501 /* _WIN32_WINNT */

// Allow use of features specific to Windows 98 or later.
# define _BO_BUILD_WIN32_WINDOWS 0x0410 /* _WIN32_WINDOWS */

// Allow use of features specific to IE 6.0 or later.
# define _BO_BUILD_WIN32_IE 0x0600 /* _WIN32_IE */

// Uncomment this if you want build Bo.library
// which cannot be loaded dynamically via the LoadLibrary mechanism.
//# define _BO_BUILD_NDYLOAD

//# define _BO_BUILD_PCOND_USE_PULSE_EVENT

#endif /* __BOCONFIG_BEFORE_PROJECT_CONFIG */

/* ------------------------------------------------------------------------- */
#pragma mark -
/* ------------------------------------------------------------------------- */

#ifdef __BOCONFIG_AFTER_PROJECT_CONFIG

// Allow use of features specific to Windows XP or later.
// Change this to the appropriate value to target other versions of Windows.
# ifndef WINVER
#  define WINVER _BO_BUILD_WINVER
# endif

// Allow use of features specific to Windows XP or later.
// Change this to the appropriate value to target other versions of Windows.
# ifndef _WIN32_WINNT
#  define _WIN32_WINNT _BO_BUILD_WIN32_WINNT
# endif

// Allow use of features specific to Windows 98 or later.
// Change this to the appropriate value to target Windows Me or later.
# ifndef _WIN32_WINDOWS
#  define _WIN32_WINDOWS _BO_BUILD_WIN32_WINDOWS
# endif

// Allow use of features specific to IE 6.0 or later.
// Change this to the appropriate value to target other versions of IE.
# ifndef _WIN32_IE
#  define _WIN32_IE _BO_BUILD_WIN32_IE
# endif

// @{
# ifndef _FORCENAMELESSUNION
#  ifndef _NO_FORCENAMELESSUNION
#   define _FORCENAMELESSUNION
#  endif
# endif

# ifndef _CRT_SECURE_NO_DEPRECATE
#  ifndef _NO_CRT_SECURE_NO_DEPRECATE
#   define _CRT_SECURE_NO_DEPRECATE
#  endif
# endif

# ifndef _CRT_NONSTDC_NO_DEPRECATE
#  ifndef _NO_CRT_NONSTDC_NO_DEPRECATE
#   define _CRT_NONSTDC_NO_DEPRECATE
#  endif
# endif

# ifndef __cplusplus
#  ifndef COBJMACROS
#   ifndef _NO_COBJMACROS
#    define COBJMACROS
#   endif
#  endif
	// see <strmif.h>, ...
# endif
// @}

# ifdef _AFXDLL
#  include <afx.h>
# else
#  include <windows.h>
# endif /* _AFXDLL */

#endif /* __BOCONFIG_AFTER_PROJECT_CONFIG */

/* ------------------------------------------------------------------------- */
#pragma mark -
/* ------------------------------------------------------------------------- */

#include <Bo/sys/_BoConfig.h>

/******************************************************************************
 * Revision History:
 *		$Log$
 *
 *****************************************************************************/
