/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright (c) 2005-2007 V.Sokur
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

/*
 * crtdefs.h	(V.Sokur)
 * include/Bo/sys/w32/crt/crtdefs.h
 *
 * $Id$
 */

/* ------------------------------------------------------------------------- */

#ifndef __BO_W32_CRT_CRTDEFS__
# define __BO_W32_CRT_CRTDEFS__

/******************************************************************************
 * %% BeginSection: includes
 */

typedef int (__cdecl *__bo_crt_int_fn)();
typedef void (__cdecl *__bo_crt_void_fn)();

# define __bo_crt_int_void_fn_are_defined

/*
 * Sections
 *
 * @seealso: VC/crt/src/sect_attribs.h
 */
# define __BO_CRT_INIT_SECTION_NAME ".CRT$XIX"
# define __BO_CRT_FINI_SECTION_NAME ".CRT$XTX"

# define __BO_CRT_LIBINIT_SECTION_NAME ".CRT$XIY"
# define __BO_CRT_LIBFINI_SECTION_NAME ".CRT$XTY"
# define __BO_CRT_APPINIT_SECTION_NAME ".CRT$XIZ"
# define __BO_CRT_APPFINI_SECTION_NAME ".CRT$XTZ"

/*
 * Class storage
 */
# define __myc_section_alloc(aName) __declspec(allocate(aName))

/* currently for function only */
# define __myc_section(aSectName,anEntryType,anEntry) \
	__myc_pragma(section(aSectName,long,read)) \
	__myc_section_alloc(aSectName) static anEntryType \
	__myc_xconcat(anEntry,_entry) = anEntry;

# define __myc_crt_init_section(anEntry) \
	__myc_section(__BO_CRT_INIT_SECTION_NAME,__bo_crt_int_fn,anEntry)

# define __myc_crt_fini_section(anEntry) \
	__myc_section(__BO_CRT_FINI_SECTION_NAME,__bo_crt_void_fn,anEntry)

# define __myc_crt_libinit_section(anEntry) \
	__myc_section(__BO_CRT_LIBINIT_SECTION_NAME,__bo_crt_int_fn,anEntry)

# define __myc_crt_libfini_section(anEntry) \
	__myc_section(__BO_CRT_LIBFINI_SECTION_NAME,__bo_crt_void_fn,anEntry)

# define __myc_crt_appinit_section(anEntry) \
	__myc_section(__BO_CRT_APPINIT_SECTION_NAME,__bo_crt_int_fn,anEntry)

# define __myc_crt_appfini_section(anEntry) \
	__myc_section(__BO_CRT_APPFINI_SECTION_NAME,__bo_crt_void_fn,anEntry)

#endif /* !__BO_W32_CRT_CRTDEFS__ */

/******************************************************************************
 * Revision History:
 *		$Log$
 *
 *****************************************************************************/
