/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright (c) 2005-2007 V.Sokur
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

/*
 * Support.h	(N.Panasiuk)
 * include/bwr/Bo/test/Support.h
 */

/* ------------------------------------------------------------------------- */

#ifndef __BO_TEST_SUPPORT__
# define __BO_TEST_SUPPORT__

/******************************************************************************
 * %% BeginSection: includes
 */

# ifndef __BO_TEST_TYPES__
#  include <Bo/test/Types.h>
# endif

/******************************************************************************
 * %% BeginSection: function prototypes
 */
# pragma mark -
# pragma mark [ function prototypes ]
# pragma mark -

# ifndef __BO_TEST_LIBINTR_LINKAGE__
#  include <Bo/test/libintr/Linkage.h>
# endif

__MYC_BEGIN_CDECLS

# define BoTESTcall(aTestProc) \
	_BoTESTcall(aTestProc, NULL, __myc_xstringify(aTestProc), 0)

# define BoTESTncall(aTestProc,aName) \
	_BoTESTcall(aTestProc, NULL, aName, 0)

# define BoTESTxcall(aTestProc,anUserCtx) \
	_BoTESTcall(aTestProc, anUserCtx, __myc_xstringify(aTestProc), 0)

# define BoTESTxncall(aTestProc,anUserCtx,aName) \
	_BoTESTcall(aTestProc, anUserCtx, aName, 0)

# define BoTESTcallif(aTestProc,aCond) \
	_BoTESTcall(aTestProc, NULL, __myc_xstringify(aTestProc), !(aCond))

# define BoTESTncallif(aTestProc,aName,aCond) \
	_BoTESTcall(aTestProc, NULL, aName, !(aCond))

# define BoTESTxcallif(aTestProc,anUserCtx,aCond) \
	_BoTESTcall(aTestProc, anUserCtx, __myc_xstringify(aTestProc), !(aCond))

# define BoTESTxncallif(aTestProc,anUserCtx,aName,aCond) \
	_BoTESTcall(aTestProc, anUserCtx, aName, !(aCond))

# define BoTESTskip(aTestProc) \
	_BoTESTcall(aTestProc, NULL, __myc_xstringify(aTestProc), 1)

# define BoTESTnskip(aTestProc,aName) \
	_BoTESTcall(aTestProc, NULL, aName, 1)

# define BoTESTxskip(aTestProc,anUserCtx) \
	_BoTESTcall(aTestProc, anUserCtx, __myc_xstringify(aTestProc), 1)

# define BoTESTxnskip(aTestProc,anUserCtx,aName) \
	_BoTESTcall(aTestProc, anUserCtx, aName, 1)

/* ------------------------------------------------------------------------- */
# pragma mark --- boolean tests ---
/* ------------------------------------------------------------------------- */

# define BoTESTtrue(x) _BoTESTtrue(__BO_TEST_PARM__(x))
# define BoTESTfalse(x) _BoTESTfalse(__BO_TEST_PARM__(x))
# define BoTESTall(x, y) _BoTESTall(__BO_TEST_PARM2__(x,y))
# define BoTESTany(x, y) _BoTESTany(__BO_TEST_PARM2__(x,y))
# define BoTESTbooleq(x, y) _BoTESTbooleq(__BO_TEST_PARM2__(x,y))
# define BoTESTboolne(x, y) _BoTESTbooleq(__BO_TEST_PARM2__(x,y))

/* ------------------------------------------------------------------------- */
# pragma mark --- char tests ---
/* ------------------------------------------------------------------------- */

# define BoTESTchareq(x, y) _BoTESTchareq(__BO_TEST_PARM2__(x,y))
# define BoTESTcharne(x, y) _BoTESTcharne(__BO_TEST_PARM2__(x,y))
# define BoTESTcharlt(x, y) _BoTESTcharlt(__BO_TEST_PARM2__(x,y))
# define BoTESTcharle(x, y) _BoTESTcharle(__BO_TEST_PARM2__(x,y))
# define BoTESTchargt(x, y) _BoTESTchargt(__BO_TEST_PARM2__(x,y))
# define BoTESTcharge(x, y) _BoTESTcharge(__BO_TEST_PARM2__(x,y))

/* ------------------------------------------------------------------------- */
# pragma mark --- unsigned char tests ---
/* ------------------------------------------------------------------------- */

# define BoTESTuchareq(x, y) _BoTESTuchareq(__BO_TEST_PARM2__(x,y))
# define BoTESTucharne(x, y) _BoTESTucharne(__BO_TEST_PARM2__(x,y))
# define BoTESTucharlt(x, y) _BoTESTucharlt(__BO_TEST_PARM2__(x,y))
# define BoTESTucharle(x, y) _BoTESTucharle(__BO_TEST_PARM2__(x,y))
# define BoTESTuchargt(x, y) _BoTESTuchargt(__BO_TEST_PARM2__(x,y))
# define BoTESTucharge(x, y) _BoTESTucharge(__BO_TEST_PARM2__(x,y))

/* ------------------------------------------------------------------------- */
# pragma mark --- short tests ---
/* ------------------------------------------------------------------------- */

# define BoTESTshteq(x, y) _BoTESTshteq(__BO_TEST_PARM2__(x,y))
# define BoTESTshtne(x, y) _BoTESTshtne(__BO_TEST_PARM2__(x,y))
# define BoTESTshtlt(x, y) _BoTESTshtlt(__BO_TEST_PARM2__(x,y))
# define BoTESTshtle(x, y) _BoTESTshtle(__BO_TEST_PARM2__(x,y))
# define BoTESTshtgt(x, y) _BoTESTshtgt(__BO_TEST_PARM2__(x,y))
# define BoTESTshtge(x, y) _BoTESTshtge(__BO_TEST_PARM2__(x,y))

/* ------------------------------------------------------------------------- */
# pragma mark --- unsigned short tests ---
/* ------------------------------------------------------------------------- */

# define BoTESTushteq(x, y) _BoTESTushteq(__BO_TEST_PARM2__(x,y))
# define BoTESTushtne(x, y) _BoTESTushtne(__BO_TEST_PARM2__(x,y))
# define BoTESTushtlt(x, y) _BoTESTushtlt(__BO_TEST_PARM2__(x,y))
# define BoTESTushtle(x, y) _BoTESTushtle(__BO_TEST_PARM2__(x,y))
# define BoTESTushtgt(x, y) _BoTESTushtgt(__BO_TEST_PARM2__(x,y))
# define BoTESTushtge(x, y) _BoTESTushtge(__BO_TEST_PARM2__(x,y))

/* ------------------------------------------------------------------------- */
# pragma mark --- int tests ---
/* ------------------------------------------------------------------------- */

# define BoTESTinteq(x, y) _BoTESTinteq(__BO_TEST_PARM2__(x,y))
# define BoTESTintne(x, y) _BoTESTintne(__BO_TEST_PARM2__(x,y))
# define BoTESTintlt(x, y) _BoTESTintlt(__BO_TEST_PARM2__(x,y))
# define BoTESTintle(x, y) _BoTESTintle(__BO_TEST_PARM2__(x,y))
# define BoTESTintgt(x, y) _BoTESTintgt(__BO_TEST_PARM2__(x,y))
# define BoTESTintge(x, y) _BoTESTintge(__BO_TEST_PARM2__(x,y))

/* ------------------------------------------------------------------------- */
# pragma mark --- unsigned int tests ---
/* ------------------------------------------------------------------------- */

# define BoTESTuinteq(x, y) _BoTESTuinteq(__BO_TEST_PARM2__(x,y))
# define BoTESTuintne(x, y) _BoTESTuintne(__BO_TEST_PARM2__(x,y))
# define BoTESTuintlt(x, y) _BoTESTuintlt(__BO_TEST_PARM2__(x,y))
# define BoTESTuintle(x, y) _BoTESTuintle(__BO_TEST_PARM2__(x,y))
# define BoTESTuintgt(x, y) _BoTESTuintgt(__BO_TEST_PARM2__(x,y))
# define BoTESTuintge(x, y) _BoTESTuintge(__BO_TEST_PARM2__(x,y))

/* ------------------------------------------------------------------------- */
# pragma mark --- long tests ---
/* ------------------------------------------------------------------------- */

# define BoTESTlongeq(x, y) _BoTESTlongeq(__BO_TEST_PARM2__(x,y))
# define BoTESTlongne(x, y) _BoTESTlongne(__BO_TEST_PARM2__(x,y))
# define BoTESTlonglt(x, y) _BoTESTlonglt(__BO_TEST_PARM2__(x,y))
# define BoTESTlongle(x, y) _BoTESTlongle(__BO_TEST_PARM2__(x,y))
# define BoTESTlonggt(x, y) _BoTESTlonggt(__BO_TEST_PARM2__(x,y))
# define BoTESTlongge(x, y) _BoTESTlongge(__BO_TEST_PARM2__(x,y))

/* ------------------------------------------------------------------------- */
# pragma mark --- unsigned long tests ---
/* ------------------------------------------------------------------------- */

# define BoTESTulongeq(x, y) _BoTESTulongeq(__BO_TEST_PARM2__(x,y))
# define BoTESTulongne(x, y) _BoTESTulongne(__BO_TEST_PARM2__(x,y))
# define BoTESTulonglt(x, y) _BoTESTulonglt(__BO_TEST_PARM2__(x,y))
# define BoTESTulongle(x, y) _BoTESTulongle(__BO_TEST_PARM2__(x,y))
# define BoTESTulonggt(x, y) _BoTESTulonggt(__BO_TEST_PARM2__(x,y))
# define BoTESTulongge(x, y) _BoTESTulongge(__BO_TEST_PARM2__(x,y))

/* ------------------------------------------------------------------------- */
# pragma mark --- float tests ---
/* ------------------------------------------------------------------------- */

# define BoTESTflteq(x, y) _BoTESTflteq(__BO_TEST_PARM2__(x,y))
# define BoTESTfltne(x, y) _BoTESTfltne(__BO_TEST_PARM2__(x,y))
# define BoTESTfltlt(x, y) _BoTESTfltlt(__BO_TEST_PARM2__(x,y))
# define BoTESTfltle(x, y) _BoTESTfltle(__BO_TEST_PARM2__(x,y))
# define BoTESTfltgt(x, y) _BoTESTfltgt(__BO_TEST_PARM2__(x,y))
# define BoTESTfltge(x, y) _BoTESTfltge(__BO_TEST_PARM2__(x,y))

/* ------------------------------------------------------------------------- */
# pragma mark --- double tests ---
/* ------------------------------------------------------------------------- */

# define BoTESTdbleq(x, y) _BoTESTdbleq(__BO_TEST_PARM2__(x,y))
# define BoTESTdblne(x, y) _BoTESTdblne(__BO_TEST_PARM2__(x,y))
# define BoTESTdbllt(x, y) _BoTESTdbllt(__BO_TEST_PARM2__(x,y))
# define BoTESTdblle(x, y) _BoTESTdblle(__BO_TEST_PARM2__(x,y))
# define BoTESTdblgt(x, y) _BoTESTdblgt(__BO_TEST_PARM2__(x,y))
# define BoTESTdblge(x, y) _BoTESTdblge(__BO_TEST_PARM2__(x,y))

/* ------------------------------------------------------------------------- */
# pragma mark --- int8_t tests ---
/* ------------------------------------------------------------------------- */

# define BoTESTi8eq(x, y) _BoTESTi8eq(__BO_TEST_PARM2__(x,y))
# define BoTESTi8ne(x, y) _BoTESTi8ne(__BO_TEST_PARM2__(x,y))
# define BoTESTi8lt(x, y) _BoTESTi8lt(__BO_TEST_PARM2__(x,y))
# define BoTESTi8le(x, y) _BoTESTi8le(__BO_TEST_PARM2__(x,y))
# define BoTESTi8gt(x, y) _BoTESTi8gt(__BO_TEST_PARM2__(x,y))
# define BoTESTi8ge(x, y) _BoTESTi8ge(__BO_TEST_PARM2__(x,y))

/* ------------------------------------------------------------------------- */
# pragma mark --- u_int8_t tests ---
/* ------------------------------------------------------------------------- */

# define BoTESTu8eq(x, y) _BoTESTu8eq(__BO_TEST_PARM2__(x,y))
# define BoTESTu8ne(x, y) _BoTESTu8ne(__BO_TEST_PARM2__(x,y))
# define BoTESTu8lt(x, y) _BoTESTu8lt(__BO_TEST_PARM2__(x,y))
# define BoTESTu8le(x, y) _BoTESTu8le(__BO_TEST_PARM2__(x,y))
# define BoTESTu8gt(x, y) _BoTESTu8gt(__BO_TEST_PARM2__(x,y))
# define BoTESTu8ge(x, y) _BoTESTu8ge(__BO_TEST_PARM2__(x,y))

/* ------------------------------------------------------------------------- */
# pragma mark --- int16_t tests ---
/* ------------------------------------------------------------------------- */

# define BoTESTi16eq(x, y) _BoTESTi16eq(__BO_TEST_PARM2__(x,y))
# define BoTESTi16ne(x, y) _BoTESTi16ne(__BO_TEST_PARM2__(x,y))
# define BoTESTi16lt(x, y) _BoTESTi16lt(__BO_TEST_PARM2__(x,y))
# define BoTESTi16le(x, y) _BoTESTi16le(__BO_TEST_PARM2__(x,y))
# define BoTESTi16gt(x, y) _BoTESTi16gt(__BO_TEST_PARM2__(x,y))
# define BoTESTi16ge(x, y) _BoTESTi16ge(__BO_TEST_PARM2__(x,y))

/* ------------------------------------------------------------------------- */
# pragma mark --- u_int16_t tests ---
/* ------------------------------------------------------------------------- */

# define BoTESTu16eq(x, y) _BoTESTu16eq(__BO_TEST_PARM2__(x,y))
# define BoTESTu16ne(x, y) _BoTESTu16ne(__BO_TEST_PARM2__(x,y))
# define BoTESTu16lt(x, y) _BoTESTu16lt(__BO_TEST_PARM2__(x,y))
# define BoTESTu16le(x, y) _BoTESTu16le(__BO_TEST_PARM2__(x,y))
# define BoTESTu16gt(x, y) _BoTESTu16gt(__BO_TEST_PARM2__(x,y))
# define BoTESTu16ge(x, y) _BoTESTu16ge(__BO_TEST_PARM2__(x,y))

/* ------------------------------------------------------------------------- */
# pragma mark --- int32_t tests ---
/* ------------------------------------------------------------------------- */

# define BoTESTi32eq(x, y) _BoTESTi32eq(__BO_TEST_PARM2__(x,y))
# define BoTESTi32ne(x, y) _BoTESTi32ne(__BO_TEST_PARM2__(x,y))
# define BoTESTi32lt(x, y) _BoTESTi32lt(__BO_TEST_PARM2__(x,y))
# define BoTESTi32le(x, y) _BoTESTi32le(__BO_TEST_PARM2__(x,y))
# define BoTESTi32gt(x, y) _BoTESTi32gt(__BO_TEST_PARM2__(x,y))
# define BoTESTi32ge(x, y) _BoTESTi32ge(__BO_TEST_PARM2__(x,y))

/* ------------------------------------------------------------------------- */
# pragma mark --- u_int32_t tests ---
/* ------------------------------------------------------------------------- */

# define BoTESTu32eq(x, y) _BoTESTu32eq(__BO_TEST_PARM2__(x,y))
# define BoTESTu32ne(x, y) _BoTESTu32ne(__BO_TEST_PARM2__(x,y))
# define BoTESTu32lt(x, y) _BoTESTu32lt(__BO_TEST_PARM2__(x,y))
# define BoTESTu32le(x, y) _BoTESTu32le(__BO_TEST_PARM2__(x,y))
# define BoTESTu32gt(x, y) _BoTESTu32gt(__BO_TEST_PARM2__(x,y))
# define BoTESTu32ge(x, y) _BoTESTu32ge(__BO_TEST_PARM2__(x,y))

/* ------------------------------------------------------------------------- */
# pragma mark --- int64_t tests ---
/* ------------------------------------------------------------------------- */

# define BoTESTi64eq(x, y) _BoTESTi64eq(__BO_TEST_PARM2__(x,y))
# define BoTESTi64ne(x, y) _BoTESTi64ne(__BO_TEST_PARM2__(x,y))
# define BoTESTi64lt(x, y) _BoTESTi64lt(__BO_TEST_PARM2__(x,y))
# define BoTESTi64le(x, y) _BoTESTi64le(__BO_TEST_PARM2__(x,y))
# define BoTESTi64gt(x, y) _BoTESTi64gt(__BO_TEST_PARM2__(x,y))
# define BoTESTi64ge(x, y) _BoTESTi64ge(__BO_TEST_PARM2__(x,y))

/* ------------------------------------------------------------------------- */
# pragma mark --- u_int64_t tests ---
/* ------------------------------------------------------------------------- */

# define BoTESTu64eq(x, y) _BoTESTu64eq(__BO_TEST_PARM2__(x,y))
# define BoTESTu64ne(x, y) _BoTESTu64ne(__BO_TEST_PARM2__(x,y))
# define BoTESTu64lt(x, y) _BoTESTu64lt(__BO_TEST_PARM2__(x,y))
# define BoTESTu64le(x, y) _BoTESTu64le(__BO_TEST_PARM2__(x,y))
# define BoTESTu64gt(x, y) _BoTESTu64gt(__BO_TEST_PARM2__(x,y))
# define BoTESTu64ge(x, y) _BoTESTu64ge(__BO_TEST_PARM2__(x,y))

/* ------------------------------------------------------------------------- */
# pragma mark --- size_t tests ---
/* ------------------------------------------------------------------------- */

# define BoTESTsizeeq(x, y) _BoTESTsizeeq(__BO_TEST_PARM2__(x,y))
# define BoTESTsizene(x, y) _BoTESTsizene(__BO_TEST_PARM2__(x,y))
# define BoTESTsizelt(x, y) _BoTESTsizelt(__BO_TEST_PARM2__(x,y))
# define BoTESTsizele(x, y) _BoTESTsizele(__BO_TEST_PARM2__(x,y))
# define BoTESTsizegt(x, y) _BoTESTsizegt(__BO_TEST_PARM2__(x,y))
# define BoTESTsizege(x, y) _BoTESTsizege(__BO_TEST_PARM2__(x,y))

/* ------------------------------------------------------------------------- */
# pragma mark --- ssize_t tests ---
/* ------------------------------------------------------------------------- */

# define BoTESTssizeeq(x, y) _BoTESTssizeeq(__BO_TEST_PARM2__(x,y))
# define BoTESTssizene(x, y) _BoTESTssizene(__BO_TEST_PARM2__(x,y))
# define BoTESTssizelt(x, y) _BoTESTssizelt(__BO_TEST_PARM2__(x,y))
# define BoTESTssizele(x, y) _BoTESTssizele(__BO_TEST_PARM2__(x,y))
# define BoTESTssizegt(x, y) _BoTESTssizegt(__BO_TEST_PARM2__(x,y))
# define BoTESTssizege(x, y) _BoTESTssizege(__BO_TEST_PARM2__(x,y))

/* ------------------------------------------------------------------------- */
# pragma mark --- pointer tests ---
/* ------------------------------------------------------------------------- */

# define BoTESTptreq(x, y) \
	_BoTESTptreq(__BO_TEST_PARM2__((char const *)(x),(char const *)(y)))
# define BoTESTptrne(x, y) \
	_BoTESTptrne(__BO_TEST_PARM2__((char const *)(x),(char const *)(y)))
# define BoTESTptrlt(x, y) \
	_BoTESTptrlt(__BO_TEST_PARM2__((char const *)(x),(char const *)(y)))
# define BoTESTptrle(x, y) \
	_BoTESTptrle(__BO_TEST_PARM2__((char const *)(x),(char const *)(y)))
# define BoTESTptrgt(x, y) \
	_BoTESTptrgt(__BO_TEST_PARM2__((char const *)(x),(char const *)(y)))
# define BoTESTptrge(x, y) \
	_BoTESTptrge(__BO_TEST_PARM2__((char const *)(x),(char const *)(y)))

/* ------------------------------------------------------------------------- */
# pragma mark --- bo_time_t/bo_utime_t/bo_mtime_t/... tests ---
/* ------------------------------------------------------------------------- */

# define BoTESTtimeeq(x, y) _BoTESTtimeeq(__BO_TEST_PARM2__(x,y))
# define BoTESTtimene(x, y) _BoTESTtimene(__BO_TEST_PARM2__(x,y))
# define BoTESTtimelt(x, y) _BoTESTtimelt(__BO_TEST_PARM2__(x,y))
# define BoTESTtimele(x, y) _BoTESTtimele(__BO_TEST_PARM2__(x,y))
# define BoTESTtimegt(x, y) _BoTESTtimegt(__BO_TEST_PARM2__(x,y))
# define BoTESTtimege(x, y) _BoTESTtimege(__BO_TEST_PARM2__(x,y))

/* ------------------------------------------------------------------------- */
# pragma mark --- bo_status_t tests ---
/* ------------------------------------------------------------------------- */

# define BoTESTfailure(x) BoTESTstslt(x, 0)
# define BoTESTsuccess(x) BoTESTstsle(0, x)
# define BoTESTok(x) BoTESTstslt(0, x)

# define BoTESTstseq(x, y) _BoTESTstseq(__BO_TEST_PARM2__(x,y))
# define BoTESTstsne(x, y) _BoTESTstsne(__BO_TEST_PARM2__(x,y))
# define BoTESTstslt(x, y) _BoTESTstslt(__BO_TEST_PARM2__(x,y))
# define BoTESTstsle(x, y) _BoTESTstsle(__BO_TEST_PARM2__(x,y))
# define BoTESTstsgt(x, y) _BoTESTstsgt(__BO_TEST_PARM2__(x,y))
# define BoTESTstsge(x, y) _BoTESTstsge(__BO_TEST_PARM2__(x,y))

/* ------------------------------------------------------------------------- */
# pragma mark --- string tests ---
/* ------------------------------------------------------------------------- */

# define BoTESTstreq(x, y) _BoTESTstreq(__BO_TEST_PARM2__(x,y))
# define BoTESTstrne(x, y) _BoTESTstrne(__BO_TEST_PARM2__(x,y))
# define BoTESTstrlt(x, y) _BoTESTstrlt(__BO_TEST_PARM2__(x,y))
# define BoTESTstrle(x, y) _BoTESTstrle(__BO_TEST_PARM2__(x,y))
# define BoTESTstrgt(x, y) _BoTESTstrgt(__BO_TEST_PARM2__(x,y))
# define BoTESTstrge(x, y) _BoTESTstrge(__BO_TEST_PARM2__(x,y))

# define BoTESTstrieq(x, y) _BoTESTstrieq(__BO_TEST_PARM2__(x,y))
# define BoTESTstrine(x, y) _BoTESTstrine(__BO_TEST_PARM2__(x,y))
# define BoTESTstrilt(x, y) _BoTESTstrilt(__BO_TEST_PARM2__(x,y))
# define BoTESTstrile(x, y) _BoTESTstrile(__BO_TEST_PARM2__(x,y))
# define BoTESTstrigt(x, y) _BoTESTstrigt(__BO_TEST_PARM2__(x,y))
# define BoTESTstrige(x, y) _BoTESTstrige(__BO_TEST_PARM2__(x,y))

/*
 * 1. '*': match 0 or more symbols
 * 2. '?': match 0 or 1 symbol
 * 3. '{' expr '}': where @expr is comma separated groups of symbol,
 *     without wildcards
 */
# define BoTESTstrsh(x, y) _BoTESTstrsh(__BO_TEST_PARM2__(x,y))

/* ------------------------------------------------------------------------- */
# pragma mark --- wstring tests ---
/* ------------------------------------------------------------------------- */

# define BoTESTwcseq(x, y) _BoTESTwcseq(__BO_TEST_PARM2__(x,y))
# define BoTESTwcsne(x, y) _BoTESTwcsne(__BO_TEST_PARM2__(x,y))
# define BoTESTwcslt(x, y) _BoTESTwcslt(__BO_TEST_PARM2__(x,y))
# define BoTESTwcsle(x, y) _BoTESTwcsle(__BO_TEST_PARM2__(x,y))
# define BoTESTwcsgt(x, y) _BoTESTwcsgt(__BO_TEST_PARM2__(x,y))
# define BoTESTwcsge(x, y) _BoTESTwcsge(__BO_TEST_PARM2__(x,y))

# define BoTESTwcsieq(x, y) _BoTESTwcsieq(__BO_TEST_PARM2__(x,y))
# define BoTESTwcsine(x, y) _BoTESTwcsine(__BO_TEST_PARM2__(x,y))
# define BoTESTwcsilt(x, y) _BoTESTwcsilt(__BO_TEST_PARM2__(x,y))
# define BoTESTwcsile(x, y) _BoTESTwcsile(__BO_TEST_PARM2__(x,y))
# define BoTESTwcsigt(x, y) _BoTESTwcsigt(__BO_TEST_PARM2__(x,y))
# define BoTESTwcsige(x, y) _BoTESTwcsige(__BO_TEST_PARM2__(x,y))

/* ------------------------------------------------------------------------- */
# pragma mark --- memory tests ---
/* ------------------------------------------------------------------------- */

# define BoTESTmemeq(x, y, z) _BoTESTmemeq(__BO_TEST_PARM3__(x,y,z))
# define BoTESTmemne(x, y, z) _BoTESTmemne(__BO_TEST_PARM3__(x,y,z))
# define BoTESTmemlt(x, y, z) _BoTESTmemlt(__BO_TEST_PARM3__(x,y,z))
# define BoTESTmemle(x, y, z) _BoTESTmemle(__BO_TEST_PARM3__(x,y,z))
# define BoTESTmemgt(x, y, z) _BoTESTmemgt(__BO_TEST_PARM3__(x,y,z))
# define BoTESTmemge(x, y, z) _BoTESTmemge(__BO_TEST_PARM3__(x,y,z))

/* ------------------------------------------------------------------------- */
# pragma mark --- common ---
/* ------------------------------------------------------------------------- */

# define BoTESTrun(anArgc, anArgv, aTestProc) \
	_BoTESTrun(anArgc, anArgv, aTestProc, NULL)

__myc_flinkage__(public,libBoTEST) int
_BoTESTrun(
# if __myc_require(prototypes)
	int anArgc,
	char *anArgv[],
	bo_test_proc_fn aTestProc,
	bo_pointer_t anUserCtx
# endif
	);

__myc_flinkage__(public,libBoTEST) void
_BoTESTcall(
# if __myc_require(prototypes)
	bo_test_proc_fn aTestProc,
	bo_pointer_t anUserCtx,
	char const *aTestName,
	_Bool toSkip
# endif
	);

__myc_flinkage__(public,libBoTEST) void
_BoTESTdo(
# if __myc_require(prototypes)
	_Bool toSkip,
	bo_test_fn aTest,
	char const *aFile,
	char const *aFunc,
	int aLine,
	...
# endif
	);

# ifdef BO_SYSTYPE_WIN32
#  define BoTESTdo(aTestFunc, ...) BoTESTdo_I(aTestFunc,__VA_ARGS__)
#  define BoTESTdo_I(aTestFunc, ...) _BoTESTdo(0,aTestFunc, \
	__FILE__,__func__,__LINE__,__VA_ARGS__)
# else
# if __myc_support(AVM)
#  define BoTESTdo(...) BoTESTdo_I(__VA_ARGS__)
#  define BoTESTdo_I(aTestFunc, ...) _BoTESTdo(0,aTestFunc, \
	__FILE__,__func__,__LINE__,##__VA_ARGS__)
# else
# if __myc_support(NVM)
#  define BoTESTdo(aTestFunc, x...) BoTESTdo_I(aTestFunc, x)
#  define BoTESTdo_I(aTestFunc, x...) _BoTESTdo(0,aTestFunc, \
	__FILE__,__func__,__LINE__,##x)
# endif /* __myc_support(NVM) */
# endif /* __myc_support(AVM) */
# endif /* !BO_SYSTYPE_WIN32 */

/* ------------------------------------------------------------------------- */
# pragma mark --- prototype helpers ---
/* ------------------------------------------------------------------------- */

# if __myc_require(prototypes)
#  define __PROTO__(_Typ)  (_Typ, char const *, char const *, int, \
	char const *, _Bool)
#  define __PROTO2__(_Typ) (_Typ, _Typ, char const *, char const *, int, \
	char const *, char const *, _Bool)
#  define __PROTO3__(_Typ1, _Typ2) (_Typ1, _Typ1, _Typ2, char const *, \
	char const *, int, char const *, char const *, char const *, _Bool)
# else
#  define __PROTO__(_Typ)  ()
#  define __PROTO2__(_Typ) ()
#  define __PROTO3__(_Typ1, _Typ2) ()
# endif

/* ------------------------------------------------------------------------- */
# pragma mark --- boolean tests ---
/* ------------------------------------------------------------------------- */

__myc_flinkage__(public,libBoTEST) void _BoTESTtrue __PROTO__(_Bool);
__myc_flinkage__(public,libBoTEST) void _BoTESTfalse __PROTO__(_Bool);
__myc_flinkage__(public,libBoTEST) void _BoTESTbooleq __PROTO2__(_Bool);
__myc_flinkage__(public,libBoTEST) void _BoTESTboolne __PROTO2__(_Bool);
__myc_flinkage__(public,libBoTEST) void _BoTESTall __PROTO2__(_Bool);
__myc_flinkage__(public,libBoTEST) void _BoTESTany __PROTO2__(_Bool);

/* ------------------------------------------------------------------------- */
# pragma mark --- char tests ---
/* ------------------------------------------------------------------------- */

__myc_flinkage__(public,libBoTEST) void _BoTESTchareq __PROTO2__(char);
__myc_flinkage__(public,libBoTEST) void _BoTESTcharne __PROTO2__(char);
__myc_flinkage__(public,libBoTEST) void _BoTESTcharlt __PROTO2__(char);
__myc_flinkage__(public,libBoTEST) void _BoTESTcharle __PROTO2__(char);
__myc_flinkage__(public,libBoTEST) void _BoTESTchargt __PROTO2__(char);
__myc_flinkage__(public,libBoTEST) void _BoTESTcharge __PROTO2__(char);

/* ------------------------------------------------------------------------- */
# pragma mark --- unsigned char tests ---
/* ------------------------------------------------------------------------- */

__myc_flinkage__(public,libBoTEST) void _BoTESTuchareq __PROTO2__(u_char_t);
__myc_flinkage__(public,libBoTEST) void _BoTESTucharne __PROTO2__(u_char_t);
__myc_flinkage__(public,libBoTEST) void _BoTESTucharlt __PROTO2__(u_char_t);
__myc_flinkage__(public,libBoTEST) void _BoTESTucharle __PROTO2__(u_char_t);
__myc_flinkage__(public,libBoTEST) void _BoTESTuchargt __PROTO2__(u_char_t);
__myc_flinkage__(public,libBoTEST) void _BoTESTucharge __PROTO2__(u_char_t);

/* ------------------------------------------------------------------------- */
# pragma mark --- short tests ---
/* ------------------------------------------------------------------------- */

__myc_flinkage__(public,libBoTEST) void _BoTESTshteq __PROTO2__(short);
__myc_flinkage__(public,libBoTEST) void _BoTESTshtne __PROTO2__(short);
__myc_flinkage__(public,libBoTEST) void _BoTESTshtlt __PROTO2__(short);
__myc_flinkage__(public,libBoTEST) void _BoTESTshtle __PROTO2__(short);
__myc_flinkage__(public,libBoTEST) void _BoTESTshtgt __PROTO2__(short);
__myc_flinkage__(public,libBoTEST) void _BoTESTshtge __PROTO2__(short);

/* ------------------------------------------------------------------------- */
# pragma mark --- unsigned short tests ---
/* ------------------------------------------------------------------------- */

__myc_flinkage__(public,libBoTEST) void _BoTESTushteq __PROTO2__(unsigned short);
__myc_flinkage__(public,libBoTEST) void _BoTESTushtne __PROTO2__(unsigned short);
__myc_flinkage__(public,libBoTEST) void _BoTESTushtlt __PROTO2__(unsigned short);
__myc_flinkage__(public,libBoTEST) void _BoTESTushtle __PROTO2__(unsigned short);
__myc_flinkage__(public,libBoTEST) void _BoTESTushtgt __PROTO2__(unsigned short);
__myc_flinkage__(public,libBoTEST) void _BoTESTushtge __PROTO2__(unsigned short);

/* ------------------------------------------------------------------------- */
# pragma mark --- int tests ---
/* ------------------------------------------------------------------------- */

__myc_flinkage__(public,libBoTEST) void _BoTESTinteq __PROTO2__(int);
__myc_flinkage__(public,libBoTEST) void _BoTESTintne __PROTO2__(int);
__myc_flinkage__(public,libBoTEST) void _BoTESTintlt __PROTO2__(int);
__myc_flinkage__(public,libBoTEST) void _BoTESTintle __PROTO2__(int);
__myc_flinkage__(public,libBoTEST) void _BoTESTintgt __PROTO2__(int);
__myc_flinkage__(public,libBoTEST) void _BoTESTintge __PROTO2__(int);

/* ------------------------------------------------------------------------- */
# pragma mark --- unsigned int tests ---
/* ------------------------------------------------------------------------- */

__myc_flinkage__(public,libBoTEST) void _BoTESTuinteq __PROTO2__(unsigned);
__myc_flinkage__(public,libBoTEST) void _BoTESTuintne __PROTO2__(unsigned);
__myc_flinkage__(public,libBoTEST) void _BoTESTuintlt __PROTO2__(unsigned);
__myc_flinkage__(public,libBoTEST) void _BoTESTuintle __PROTO2__(unsigned);
__myc_flinkage__(public,libBoTEST) void _BoTESTuintgt __PROTO2__(unsigned);
__myc_flinkage__(public,libBoTEST) void _BoTESTuintge __PROTO2__(unsigned);

/* ------------------------------------------------------------------------- */
# pragma mark --- long tests ---
/* ------------------------------------------------------------------------- */

__myc_flinkage__(public,libBoTEST) void _BoTESTlongeq __PROTO2__(long);
__myc_flinkage__(public,libBoTEST) void _BoTESTlongne __PROTO2__(long);
__myc_flinkage__(public,libBoTEST) void _BoTESTlonglt __PROTO2__(long);
__myc_flinkage__(public,libBoTEST) void _BoTESTlongle __PROTO2__(long);
__myc_flinkage__(public,libBoTEST) void _BoTESTlonggt __PROTO2__(long);
__myc_flinkage__(public,libBoTEST) void _BoTESTlongge __PROTO2__(long);

/* ------------------------------------------------------------------------- */
# pragma mark --- unsigned long tests ---
/* ------------------------------------------------------------------------- */

__myc_flinkage__(public,libBoTEST) void _BoTESTulongeq __PROTO2__(unsigned long);
__myc_flinkage__(public,libBoTEST) void _BoTESTulongne __PROTO2__(unsigned long);
__myc_flinkage__(public,libBoTEST) void _BoTESTulonglt __PROTO2__(unsigned long);
__myc_flinkage__(public,libBoTEST) void _BoTESTulongle __PROTO2__(unsigned long);
__myc_flinkage__(public,libBoTEST) void _BoTESTulonggt __PROTO2__(unsigned long);
__myc_flinkage__(public,libBoTEST) void _BoTESTulongge __PROTO2__(unsigned long);

/* ------------------------------------------------------------------------- */
# pragma mark --- float tests ---
/* ------------------------------------------------------------------------- */

__myc_flinkage__(public,libBoTEST) void _BoTESTflteq __PROTO2__(float);
__myc_flinkage__(public,libBoTEST) void _BoTESTfltne __PROTO2__(float);
__myc_flinkage__(public,libBoTEST) void _BoTESTfltlt __PROTO2__(float);
__myc_flinkage__(public,libBoTEST) void _BoTESTfltle __PROTO2__(float);
__myc_flinkage__(public,libBoTEST) void _BoTESTfltgt __PROTO2__(float);
__myc_flinkage__(public,libBoTEST) void _BoTESTfltge __PROTO2__(float);

/* ------------------------------------------------------------------------- */
# pragma mark --- double tests ---
/* ------------------------------------------------------------------------- */

__myc_flinkage__(public,libBoTEST) void _BoTESTdbleq __PROTO2__(double);
__myc_flinkage__(public,libBoTEST) void _BoTESTdblne __PROTO2__(double);
__myc_flinkage__(public,libBoTEST) void _BoTESTdbllt __PROTO2__(double);
__myc_flinkage__(public,libBoTEST) void _BoTESTdblle __PROTO2__(double);
__myc_flinkage__(public,libBoTEST) void _BoTESTdblgt __PROTO2__(double);
__myc_flinkage__(public,libBoTEST) void _BoTESTdblge __PROTO2__(double);

/* ------------------------------------------------------------------------- */
# pragma mark --- int8_t tests ---
/* ------------------------------------------------------------------------- */

__myc_flinkage__(public,libBoTEST) void _BoTESTi8eq __PROTO2__(int8_t);
__myc_flinkage__(public,libBoTEST) void _BoTESTi8ne __PROTO2__(int8_t);
__myc_flinkage__(public,libBoTEST) void _BoTESTi8lt __PROTO2__(int8_t);
__myc_flinkage__(public,libBoTEST) void _BoTESTi8le __PROTO2__(int8_t);
__myc_flinkage__(public,libBoTEST) void _BoTESTi8gt __PROTO2__(int8_t);
__myc_flinkage__(public,libBoTEST) void _BoTESTi8ge __PROTO2__(int8_t);

/* ------------------------------------------------------------------------- */
# pragma mark --- u_int8_t tests ---
/* ------------------------------------------------------------------------- */

__myc_flinkage__(public,libBoTEST) void _BoTESTu8eq __PROTO2__(u_int8_t);
__myc_flinkage__(public,libBoTEST) void _BoTESTu8ne __PROTO2__(u_int8_t);
__myc_flinkage__(public,libBoTEST) void _BoTESTu8lt __PROTO2__(u_int8_t);
__myc_flinkage__(public,libBoTEST) void _BoTESTu8le __PROTO2__(u_int8_t);
__myc_flinkage__(public,libBoTEST) void _BoTESTu8gt __PROTO2__(u_int8_t);
__myc_flinkage__(public,libBoTEST) void _BoTESTu8ge __PROTO2__(u_int8_t);

/* ------------------------------------------------------------------------- */
# pragma mark --- int16_t tests ---
/* ------------------------------------------------------------------------- */

__myc_flinkage__(public,libBoTEST) void _BoTESTi16eq __PROTO2__(int16_t);
__myc_flinkage__(public,libBoTEST) void _BoTESTi16ne __PROTO2__(int16_t);
__myc_flinkage__(public,libBoTEST) void _BoTESTi16lt __PROTO2__(int16_t);
__myc_flinkage__(public,libBoTEST) void _BoTESTi16le __PROTO2__(int16_t);
__myc_flinkage__(public,libBoTEST) void _BoTESTi16gt __PROTO2__(int16_t);
__myc_flinkage__(public,libBoTEST) void _BoTESTi16ge __PROTO2__(int16_t);

/* ------------------------------------------------------------------------- */
# pragma mark --- u_int16_t tests ---
/* ------------------------------------------------------------------------- */

__myc_flinkage__(public,libBoTEST) void _BoTESTu16eq __PROTO2__(u_int16_t);
__myc_flinkage__(public,libBoTEST) void _BoTESTu16ne __PROTO2__(u_int16_t);
__myc_flinkage__(public,libBoTEST) void _BoTESTu16lt __PROTO2__(u_int16_t);
__myc_flinkage__(public,libBoTEST) void _BoTESTu16le __PROTO2__(u_int16_t);
__myc_flinkage__(public,libBoTEST) void _BoTESTu16gt __PROTO2__(u_int16_t);
__myc_flinkage__(public,libBoTEST) void _BoTESTu16ge __PROTO2__(u_int16_t);

/* ------------------------------------------------------------------------- */
# pragma mark --- int32_t tests ---
/* ------------------------------------------------------------------------- */

__myc_flinkage__(public,libBoTEST) void _BoTESTi32eq __PROTO2__(int32_t);
__myc_flinkage__(public,libBoTEST) void _BoTESTi32ne __PROTO2__(int32_t);
__myc_flinkage__(public,libBoTEST) void _BoTESTi32lt __PROTO2__(int32_t);
__myc_flinkage__(public,libBoTEST) void _BoTESTi32le __PROTO2__(int32_t);
__myc_flinkage__(public,libBoTEST) void _BoTESTi32gt __PROTO2__(int32_t);
__myc_flinkage__(public,libBoTEST) void _BoTESTi32ge __PROTO2__(int32_t);

/* ------------------------------------------------------------------------- */
# pragma mark --- u_int32_t tests ---
/* ------------------------------------------------------------------------- */

__myc_flinkage__(public,libBoTEST) void _BoTESTu32eq __PROTO2__(u_int32_t);
__myc_flinkage__(public,libBoTEST) void _BoTESTu32ne __PROTO2__(u_int32_t);
__myc_flinkage__(public,libBoTEST) void _BoTESTu32lt __PROTO2__(u_int32_t);
__myc_flinkage__(public,libBoTEST) void _BoTESTu32le __PROTO2__(u_int32_t);
__myc_flinkage__(public,libBoTEST) void _BoTESTu32gt __PROTO2__(u_int32_t);
__myc_flinkage__(public,libBoTEST) void _BoTESTu32ge __PROTO2__(u_int32_t);

/* ------------------------------------------------------------------------- */
# pragma mark --- int64_t tests ---
/* ------------------------------------------------------------------------- */

__myc_flinkage__(public,libBoTEST) void _BoTESTi64eq __PROTO2__(int64_t);
__myc_flinkage__(public,libBoTEST) void _BoTESTi64ne __PROTO2__(int64_t);
__myc_flinkage__(public,libBoTEST) void _BoTESTi64lt __PROTO2__(int64_t);
__myc_flinkage__(public,libBoTEST) void _BoTESTi64le __PROTO2__(int64_t);
__myc_flinkage__(public,libBoTEST) void _BoTESTi64gt __PROTO2__(int64_t);
__myc_flinkage__(public,libBoTEST) void _BoTESTi64ge __PROTO2__(int64_t);

/* ------------------------------------------------------------------------- */
# pragma mark --- u_int64_t tests ---
/* ------------------------------------------------------------------------- */

__myc_flinkage__(public,libBoTEST) void _BoTESTu64eq __PROTO2__(u_int64_t);
__myc_flinkage__(public,libBoTEST) void _BoTESTu64ne __PROTO2__(u_int64_t);
__myc_flinkage__(public,libBoTEST) void _BoTESTu64lt __PROTO2__(u_int64_t);
__myc_flinkage__(public,libBoTEST) void _BoTESTu64le __PROTO2__(u_int64_t);
__myc_flinkage__(public,libBoTEST) void _BoTESTu64gt __PROTO2__(u_int64_t);
__myc_flinkage__(public,libBoTEST) void _BoTESTu64ge __PROTO2__(u_int64_t);

/* ------------------------------------------------------------------------- */
# pragma mark --- size_t tests ---
/* ------------------------------------------------------------------------- */

__myc_flinkage__(public,libBoTEST) void _BoTESTsizeeq __PROTO2__(size_t);
__myc_flinkage__(public,libBoTEST) void _BoTESTsizene __PROTO2__(size_t);
__myc_flinkage__(public,libBoTEST) void _BoTESTsizelt __PROTO2__(size_t);
__myc_flinkage__(public,libBoTEST) void _BoTESTsizele __PROTO2__(size_t);
__myc_flinkage__(public,libBoTEST) void _BoTESTsizegt __PROTO2__(size_t);
__myc_flinkage__(public,libBoTEST) void _BoTESTsizege __PROTO2__(size_t);

/* ------------------------------------------------------------------------- */
# pragma mark --- ssize_t tests ---
/* ------------------------------------------------------------------------- */

__myc_flinkage__(public,libBoTEST) void _BoTESTssizeeq __PROTO2__(ssize_t);
__myc_flinkage__(public,libBoTEST) void _BoTESTssizene __PROTO2__(ssize_t);
__myc_flinkage__(public,libBoTEST) void _BoTESTssizelt __PROTO2__(ssize_t);
__myc_flinkage__(public,libBoTEST) void _BoTESTssizele __PROTO2__(ssize_t);
__myc_flinkage__(public,libBoTEST) void _BoTESTssizegt __PROTO2__(ssize_t);
__myc_flinkage__(public,libBoTEST) void _BoTESTssizege __PROTO2__(ssize_t);

/* ------------------------------------------------------------------------- */
# pragma mark --- char const * tests ---
/* ------------------------------------------------------------------------- */

__myc_flinkage__(public,libBoTEST) void _BoTESTptreq __PROTO2__(char const *);
__myc_flinkage__(public,libBoTEST) void _BoTESTptrne __PROTO2__(char const *);
__myc_flinkage__(public,libBoTEST) void _BoTESTptrlt __PROTO2__(char const *);
__myc_flinkage__(public,libBoTEST) void _BoTESTptrle __PROTO2__(char const *);
__myc_flinkage__(public,libBoTEST) void _BoTESTptrgt __PROTO2__(char const *);
__myc_flinkage__(public,libBoTEST) void _BoTESTptrge __PROTO2__(char const *);

/* ------------------------------------------------------------------------- */
# pragma mark --- bo_time_t tests ---
/* ------------------------------------------------------------------------- */

__myc_flinkage__(public,libBoTEST) void _BoTESTtimeeq __PROTO2__(bo_time_t);
__myc_flinkage__(public,libBoTEST) void _BoTESTtimene __PROTO2__(bo_time_t);
__myc_flinkage__(public,libBoTEST) void _BoTESTtimelt __PROTO2__(bo_time_t);
__myc_flinkage__(public,libBoTEST) void _BoTESTtimele __PROTO2__(bo_time_t);
__myc_flinkage__(public,libBoTEST) void _BoTESTtimegt __PROTO2__(bo_time_t);
__myc_flinkage__(public,libBoTEST) void _BoTESTtimege __PROTO2__(bo_time_t);

/* ------------------------------------------------------------------------- */
# pragma mark --- bo_status_t tests ---
/* ------------------------------------------------------------------------- */

__myc_flinkage__(public,libBoTEST) void _BoTESTstseq __PROTO2__(bo_status_t);
__myc_flinkage__(public,libBoTEST) void _BoTESTstsne __PROTO2__(bo_status_t);
__myc_flinkage__(public,libBoTEST) void _BoTESTstslt __PROTO2__(bo_status_t);
__myc_flinkage__(public,libBoTEST) void _BoTESTstsle __PROTO2__(bo_status_t);
__myc_flinkage__(public,libBoTEST) void _BoTESTstsgt __PROTO2__(bo_status_t);
__myc_flinkage__(public,libBoTEST) void _BoTESTstsge __PROTO2__(bo_status_t);

/* ------------------------------------------------------------------------- */
# pragma mark --- string tests ---
/* ------------------------------------------------------------------------- */

__myc_flinkage__(public,libBoTEST) void _BoTESTstreq __PROTO2__(char const *);
__myc_flinkage__(public,libBoTEST) void _BoTESTstrne __PROTO2__(char const *);
__myc_flinkage__(public,libBoTEST) void _BoTESTstrlt __PROTO2__(char const *);
__myc_flinkage__(public,libBoTEST) void _BoTESTstrle __PROTO2__(char const *);
__myc_flinkage__(public,libBoTEST) void _BoTESTstrgt __PROTO2__(char const *);
__myc_flinkage__(public,libBoTEST) void _BoTESTstrge __PROTO2__(char const *);

__myc_flinkage__(public,libBoTEST) void _BoTESTstrieq __PROTO2__(char const *);
__myc_flinkage__(public,libBoTEST) void _BoTESTstrine __PROTO2__(char const *);
__myc_flinkage__(public,libBoTEST) void _BoTESTstrilt __PROTO2__(char const *);
__myc_flinkage__(public,libBoTEST) void _BoTESTstrile __PROTO2__(char const *);
__myc_flinkage__(public,libBoTEST) void _BoTESTstrigt __PROTO2__(char const *);
__myc_flinkage__(public,libBoTEST) void _BoTESTstrige __PROTO2__(char const *);

__myc_flinkage__(public,libBoTEST) void _BoTESTstrsh __PROTO2__(char const *);

/* ------------------------------------------------------------------------- */
# pragma mark --- wstring tests ---
/* ------------------------------------------------------------------------- */

__myc_flinkage__(public,libBoTEST)
void _BoTESTwcseq __PROTO2__(wchar_t const *);
__myc_flinkage__(public,libBoTEST)
void _BoTESTwcsne __PROTO2__(wchar_t const *);
__myc_flinkage__(public,libBoTEST)
void _BoTESTwcslt __PROTO2__(wchar_t const *);
__myc_flinkage__(public,libBoTEST)
void _BoTESTwcsle __PROTO2__(wchar_t const *);
__myc_flinkage__(public,libBoTEST)
void _BoTESTwcsgt __PROTO2__(wchar_t const *);
__myc_flinkage__(public,libBoTEST)
void _BoTESTwcsge __PROTO2__(wchar_t const *);

__myc_flinkage__(public,libBoTEST)
void _BoTESTwcsieq __PROTO2__(wchar_t const *);
__myc_flinkage__(public,libBoTEST)
void _BoTESTwcsine __PROTO2__(wchar_t const *);
__myc_flinkage__(public,libBoTEST)
void _BoTESTwcsilt __PROTO2__(wchar_t const *);
__myc_flinkage__(public,libBoTEST)
void _BoTESTwcsile __PROTO2__(wchar_t const *);
__myc_flinkage__(public,libBoTEST)
void _BoTESTwcsigt __PROTO2__(wchar_t const *);
__myc_flinkage__(public,libBoTEST)
void _BoTESTwcsige __PROTO2__(wchar_t const *);

/* ------------------------------------------------------------------------- */
# pragma mark --- memory tests ---
/* ------------------------------------------------------------------------- */

__myc_flinkage__(public,libBoTEST)
void _BoTESTmemeq __PROTO3__(bo_const_pointer_t,size_t);
__myc_flinkage__(public,libBoTEST)
void _BoTESTmemne __PROTO3__(bo_const_pointer_t,size_t);
__myc_flinkage__(public,libBoTEST)
void _BoTESTmemlt __PROTO3__(bo_const_pointer_t,size_t);
__myc_flinkage__(public,libBoTEST)
void _BoTESTmemle __PROTO3__(bo_const_pointer_t,size_t);
__myc_flinkage__(public,libBoTEST)
void _BoTESTmemgt __PROTO3__(bo_const_pointer_t,size_t);
__myc_flinkage__(public,libBoTEST)
void _BoTESTmemge __PROTO3__(bo_const_pointer_t,size_t);

/* ------------------------------------------------------------------------- */

# undef __PROTO__
# undef __PROTO2__

__MYC_END_CDECLS

#endif /* !__BO_TEST_SUPPORT__ */

/******************************************************************************
 * Revision History:
 *		$Log$
 *
 *****************************************************************************/
