/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright (c) 2005-2007 V.Sokur
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

/*
 * Types.h	(N.Panasiuk)
 * include/bwr/Bo/test/Types.h
 *
 * $Id$
 */

/* ------------------------------------------------------------------------- */

#ifndef __BO_TEST_TYPES__
# define __BO_TEST_TYPES__

/******************************************************************************
 * %% BeginSection: includes
 */

# ifndef __BO_TYPES__
#  include <Bo/Types.h>
# endif

# ifndef __BO_LIBC_STDARG__
#  include <Bo/libc/Stdarg.h>
# endif

/******************************************************************************
 * %% BeginSection: type/constant declarations
 */
# pragma mark -
# pragma mark [ type/constant declarations ]
# pragma mark -

typedef void
(__myc_tcalltype__(mcall) *bo_test_proc_fn)() __attribute__((mcalltype));

typedef bo_status_t
(__myc_tcalltype__(mcall) *bo_test_fn)(
# if __myc_require(prototypes)
	char **aReportPtr,
	char const *aTest,
	char const *aFile,
	char const *aFunc,
	int aLine,
	va_list ArgPtr
# endif
	) __attribute__((mcalltype, nonnull(1,2,3,4)));

# define __BO_TEST_PARM__(x)    x,__FILE__,__func__,__LINE__, \
	__myc_xstringify(x),0
# define __BO_TEST_PARM2__(x,y) x,y,__FILE__,__func__,__LINE__, \
	__myc_xstringify(x),__myc_xstringify(y),0
# define __BO_TEST_PARM3__(x,y,z) x,y,z,__FILE__,__func__,__LINE__, \
	__myc_xstringify(x),__myc_xstringify(y),__myc_xstringify(z),0

#endif /* !__BO_TEST_TYPES__ */

/******************************************************************************
 * Revision History:
 *		$Log$
 *
 *****************************************************************************/
