/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright (c) 2005-2007 V.Sokur
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

/*
 * tproType.h	(N.Panasiuk)
 * include/Bo/tproType.h
 *
 * $Id$
 */

/* ------------------------------------------------------------------------- */

#ifndef __BO_TPROTYPE__
# define __BO_TPROTYPE__

/******************************************************************************
 * %% BeginSection: includes
 */

# ifndef __BO_SYS_TYPES__
#  include <Bo/sys/Types.h>
# endif

/******************************************************************************
 * %% BeginSection: type declarations
 */
# pragma mark -
# pragma mark [ type declarations ]
# pragma mark -

# ifndef __BO_TEXTCOMP_TYPE__
#  define __BO_TEXTCOMP_TYPE__ u_int32_t
# endif
# ifndef BO_TEXTCOMP_TYPE_DEFINED
#  define BO_TEXTCOMP_TYPE_DEFINED
typedef __BO_TEXTCOMP_TYPE__ bo_textproto_t;
# endif

typedef u_int32_t bo_textproto_x;

/* ============================================================================
 * TEXTCOMP declarations
 * @{
 */

/* "INVALID" text-command-protocol */
# ifndef BoK_INVAL_TEXTCOMP
#  define BoK_INVAL_TEXTCOMP (-1)
# endif

/* "NULL" text-command-protocol */
# ifndef BoK_NULL_TEXTCOMP
#  define BoK_NULL_TEXTCOMP (0)
# endif

/* Unknown text-command-protocol. Program dependent, default value. */
# ifndef BoK_UNK_TEXTCOMP
#  define BoK_UNK_TEXTCOMP (2)
# endif

/* ------------------------------------------------------------------------- */

/* HTTP (Hypertext Transfer Protocol) */
# ifndef BoK_HTTP_TEXTCOMP
#  define BoK_HTTP_TEXTCOMP (4)
#  define BO_HTTP_TEXTCOMP http
#  define _BO_HTTP_TEXTCOMP "http"
# endif /* BoK_HTTP_TEXTCOMP */

/* FTP (File Transfer Protocol) */
# ifndef BoK_FTP_TEXTCOMP
#  define BoK_FTP_TEXTCOMP (5)
#  define BO_FTP_TEXTCOMP ftp
#  define _BO_FTP_TEXTCOMP "ftp"
# endif /* BoK_FTP_TEXTCOMP */

/* MAILTO (Simple Mail Transfer Protocol) */
# ifndef BoK_MAILTO_TEXTCOMP
#  define BoK_MAILTO_TEXTCOMP (6)
#  define BO_MAILTO_TEXTCOMP mailto
#  define _BO_MAILTO_TEXTCOMP "mailto"
# endif /* BoK_MAILTO_TEXTCOMP */

#endif /* !__BO_TPROTYPE__ */

/******************************************************************************
 * Revision History:
 *		$Log$
 *
 *****************************************************************************/
