/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright (c) 2005-2007 V.Sokur
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

/*
 * Machdefs.h	(V.Sokur)
 * include/Bo/whereami/Machdefs.h
 *
 * $Id$
 */

/* ---------------------------------------------------------------------- */

#ifndef __BO_WHEREAMI_MACHDEFS__
# define __BO_WHEREAMI_MACHDEFS__

# define __bo_machine_word32 32
# define __bo_machine_word64 64
# define __bo_machine_word3264 3264

# define __bo_machine_le	1234
# define __bo_machine_be	4321
# define __bo_machine_xe	12344321

/*
 * +++ machine architecture: i386 +++
 * Intel
 * AMD
 */
# include "Bo/whereami/machine/i386/md-i386.h"

/*
 * +++ machine architecture: ia64 +++
 * Intel ia64
 */
# include "Bo/whereami/machine/ia64/md-ia64.h"

/*
 * +++ machine architecture: arm +++
 * ARM v6/v7/v8 (all 32-bit arms)
 */
# include "Bo/whereami/machine/arm/md-arm.h"

/*
 * +++ machine architecture: aarch64 +++
 * AARCH64
 */
# include "Bo/whereami/machine/arm64/md-arm64.h"

/*
 * +++ machine architecture: amd64 +++
 * AMD 64
 */
# include "Bo/whereami/machine/amd64/md-amd64.h"

#endif /* !__BO_WHEREAMI_MACHDEFS__  */
