/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright (c) 2005-2007 V.Sokur
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

/*
 * Machguess.h	(V.Sokur)
 * include/Bo/whereami/Machguess.h
 *
 * $Id$
 */

/* ---------------------------------------------------------------------- */

#ifndef __BO_WHEREAMI_MACHGUESS__
# define __BO_WHEREAMI_MACHGUESS__

/*
 * Next macros should be defined (sample):
 *
# define __bo_machine_arch __bo_machine_arch_i386 [i.e.: "i386"]
# define __bo_machine_arch__ __bo_machine_arch_i386__ [i.e.: i386]
# define __bo_machine __bo_machine_i386 [i.e.: "i386"]
# define __bo_machine__ __bo_machine_i386__ [i.e.: i386]
# define __bo_machine_word __bo_machine_word_i386 [i.e.: 32]
# define __bo_byteorder __bo_machine_le [i.e.: 1234]
# define __bo_cputype __bo_cputype_pentium3 [i.e.: "pentium3"]
# define __bo_machine_cpu __bo_machine_cpu_pentium3 [i.e.: "sse mmx i686 i586 i486 i386"]

# define __BO_MACHINE_HEADER(aHeader) ; <Bo/machine/i386/aHeader>
# define __BO_MACHINE_CONFIG_HEADER(aHeader) ; <Bo/whereami/machine/i386/aHeader>
 */

# include "Bo/whereami/Machdefs.h"


# ifndef bo_machine_info_defined
#  define bo_machine_info_defined

/*
 * +++ machine architecture: i386 +++
 * Intel
 * AMD
 */
#  include "Bo/whereami/machine/i386/tm-i386.h"

/*
 * +++ machine architecture: ia64 +++
 * Intel ia64
 */
#  include "Bo/whereami/machine/ia64/tm-ia64.h"

/*
 * +++ machine architecture: amd64 +++
 * AMD 64
 */
#  include "Bo/whereami/machine/amd64/tm-amd64.h"

/*
 * +++ machine architecture: arm +++
 * ARM
 */
#  include "Bo/whereami/machine/arm/tm-arm.h"

/*
 * +++ machine architecture: aarch64 +++
 * ARM64
 */
#  include "Bo/whereami/machine/arm64/tm-arm64.h"

# endif /* !bo_machine_info_defined  */

#endif /* !__BO_WHEREAMI_MACHGUESS__  */
