/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright (c) 2005-2007 V.Sokur
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

/*
 * Siteguess.h	(V.Sokur)
 * include/Bo/whereami/Siteguess.h
 *
 * $Id$
 */

/* ------------------------------------------------------------------------- */

/*
 * Next macros should be defined (sample) (and see Machguess.h, CCguess.h):
 *
# define __bo_hosttype __bo_machine "-" __bo_systype [i.e.: "i386-FreeBSD"]
# define __bo_kernel_arch __bo_system_arch [i.e.: "FreeBSD"]
# define __bo_kernel_arch__ __bo_system_arch__ [i.e.: freebsd]
# define __bo_system_arch "FreeBSD"
# define __bo_system_arch__ freebsd
# define __bo_systype "FreeBSD"
# define __bo_systype__ freebsd
 */

# define _BO_COMPILER_HEADER(aHeader) __BO_COMPILER_HEADER(aHeader)
# define _BO_COMPILER_CONFIG_HEADER(aHeader) __BO_COMPILER_CONFIG_HEADER(aHeader)
# define _BO_MACHINE_HEADER(aHeader) __BO_MACHINE_HEADER(aHeader)
# define _BO_MACHINE_CONFIG_HEADER(aHeader) __BO_MACHINE_CONFIG_HEADER(aHeader)
# define _BO_PLATFORM_HEADER(aHeader) __BO_PLATFORM_HEADER(aHeader)
# define _BO_PLATFORM_CONFIG_HEADER(aHeader) __BO_PLATFORM_CONFIG_HEADER(aHeader)


#ifndef _BO_CROSSCOMPILE

/*
 * System Type
 * BSD4_4
 */
# if defined(BSD4_4) || defined(__BSD4_4) || defined(__BSD4_4__) || defined(_BSD4_4) \
	|| defined(BSD44) || defined(__BSD44) || defined(__BSD44__) || defined(_BSD44) \
	|| defined(_SYSTYPE_BSD4_4) || defined(SYSTYPE_BSD4_4) \
	|| defined(__bsd44__) || defined(__bsd44) || defined(bsd44) \
	|| defined(__bsd4_4__) || defined(__bsd4_4) || defined(bsd4_4) \
	|| defined(__hp_bsd4_4__) || defined(__hp_bsd4_4) || defined(hp_bsd4_4)

#  ifndef _SYSTYPE_BSD4_4
#   define _SYSTYPE_BSD4_4
#  endif

# endif /* BSD4_4 */

/*
 * System Type
 * BSD4_3
 * BSD
 */
# if defined(BSD) || defined(__BSD) || defined(__BSD__) || defined(_BSD) \
	|| defined(BSD43) || defined(__BSD43) || defined(__BSD43__) || defined(_BSD43) \
	|| defined(BSD4_3) || defined(__BSD4_3) || defined(__BSD4_3__) || defined(_BSD4_3) \
	|| defined(_SYSTYPE_BSD) || defined(SYSTYPE_BSD) \
	|| defined(__bsd43__) || defined(__bsd43) || defined(bsd43) \
	|| defined(__bsd4_3__) || defined(__bsd4_3) || defined(bsd4_3)

#  ifndef _SYSTYPE_BSD4_3
#   define _SYSTYPE_BSD4_3
#  endif
#  ifndef _SYSTYPE_BSD
#   define _SYSTYPE_BSD
#  endif

#  ifndef __NOT_STDC_ENV__
#   define __NOT_STDC_ENV__
#  endif
#  ifndef __NOT_POSIX_ENV__
#   define __NOT_POSIX_ENV__
#  endif

# endif /* BSD4_3 */

/*
 * System Type
 * SVR4
 */
# if defined(SVR4) || defined(__SVR4) || defined(__SVR4__) || defined(_SVR4) \
	|| defined(_SYSTYPE_SVR4) || defined(SYSTYPE_SVR4) \
	|| defined(__svr4__) || defined(__svr4) || defined(svr4)

#  ifndef _SYSTYPE_SVR4
#   define _SYSTYPE_SVR4
#  endif

# endif /* SVR4 */

/*
 * System Type
 * SVR3
 */
# if defined(SYSV) || defined(__SYSV) || defined(__SYSV__) || defined(_SYSV) \
	|| defined(_SYSTYPE_SYSV) || defined(SYSTYPE_SYSV)

#  ifndef _SYSTYPE_SVR3
#   define _SYSTYPE_SVR3
#  endif

#  ifndef __NOT_STDC_ENV__
#   define __NOT_STDC_ENV__
#  endif
#  ifndef __NOT_POSIX_ENV__
#   define __NOT_POSIX_ENV__
#  endif

# endif /* SVR3 */

/*
 * System Type
 * SVR2
 */
# if defined(SVR2) || defined(__SVR2) || defined(__SVR2__) || defined(_SVR2) \
	|| defined(_SYSTYPE_SVR2) || defined(SYSTYPE_SVR2) \
	|| defined(__svr2__) || defined(__svr2) || defined(svr2)

#  ifndef _SYSTYPE_SVR2
#   define _SYSTYPE_SVR2
#  endif

# endif /* SVR2 */

/*
 * System Type
 * SVR1
 */
# if defined(SVR1) || defined(__SVR1) || defined(__SVR1__) || defined(_SVR1) \
	|| defined(_SYSTYPE_SVR1) || defined(SYSTYPE_SVR1) \
	|| defined(__svr1__) || defined(__svr1) || defined(svr1)

#  ifndef _SYSTYPE_SVR1
#   define _SYSTYPE_SVR1
#  endif

# endif /* SVR1 */

/*
 * System Type
 * OSF1
 */
# if defined(__OSF1__) \
	|| defined(__osf1__) || defined(osf1) || defined(__osf1) \
	|| defined(__osf__) || defined(osf) || defined(__osf) \
	|| defined(__hp_osf__) || defined(hp_osf) || defined(__hp_osf)

#  ifndef _SYSTYPE_OSF1
#   define _SYSTYPE_OSF1
#  endif

# endif /* OSF1 */

/*
 * System Type
 * MACH
 */
# if defined(MACH)
#  ifndef _SYSTYPE_MACH
#   define _SYSTYPE_MACH
#  endif

#  ifndef __GNU__
#   ifndef __NOT_STDC_ENV__
#    define __NOT_STDC_ENV__
#   endif
#   ifndef __NOT_POSIX_ENV__
#    define __NOT_POSIX_ENV__
#   endif
#  endif

# endif /* MACH */


/* +++ compiler info +++ */
# include "Bo/whereami/Ccguess.h"


/* ========================================================================= */
/* %% BeginSection: FreeBSD */
/* ========================================================================= */
# pragma mark -
# pragma mark [ FreeBsd ]
# pragma mark -

# ifdef __FreeBSD__

/* +++ machine info +++ */
#  include "Bo/whereami/Machguess.h"

/* +++ host type +++ */
#  ifndef __bo_hosttype
#   define __bo_hosttype __bo_machine "-" __bo_systype
#  endif

/* +++ kernel architecture +++ */
#  ifndef __bo_kernel_arch
#   define __bo_kernel_arch __bo_system_arch
#   define __bo_kernel_arch__ __bo_system_arch__
#  endif

/* +++ system architecture +++ */
#  ifndef __bo_system_arch
#   define __bo_system_arch "FreeBSD"
#   define __bo_system_arch__ freebsd
#  endif

/* +++ system type +++ */
#  ifndef __bo_systype
#   if (6 < __FreeBSD__ + 0)
#    define __bo_systype "FreeBSD7"
#    define __bo_systype__ freebsd7
/*#    define __BO_PLATFORM_HEADER(aHeader) <Bo/sys/freebsd7/aHeader> */
#    define __BO_PLATFORM_HEADER(aHeader) <Bo/sys/freebsd/aHeader>
#    define __BO_PLATFORM_CONFIG_HEADER(aHeader) <Bo/whereami/plaf/freebsd/aHeader>
#   else
#   if (5 < __FreeBSD__ + 0)
#    define __bo_systype "FreeBSD6"
#    define __bo_systype__ freebsd6
/*#    define __BO_PLATFORM_HEADER(aHeader) <Bo/sys/freebsd6/aHeader> */
#    define __BO_PLATFORM_HEADER(aHeader) <Bo/sys/freebsd/aHeader>
#    define __BO_PLATFORM_CONFIG_HEADER(aHeader) <Bo/whereami/plaf/freebsd/aHeader>
#   else
#   if (4 < __FreeBSD__ + 0)
#    define __bo_systype "FreeBSD5"
#    define __bo_systype__ freebsd5
/*#    define __BO_PLATFORM_HEADER(aHeader) <Bo/sys/freebsd5/aHeader> */
#    define __BO_PLATFORM_HEADER(aHeader) <Bo/sys/freebsd/aHeader>
#    define __BO_PLATFORM_CONFIG_HEADER(aHeader) <Bo/whereami/plaf/freebsd/aHeader>
#   else
#    define __bo_systype "FreeBSD"
#    define __bo_systype__ freebsd
#    define __BO_PLATFORM_HEADER(aHeader) <Bo/sys/freebsd/aHeader>
#    define __BO_PLATFORM_CONFIG_HEADER(aHeader) <Bo/whereami/plaf/freebsd/aHeader>
#   endif /* !FreeBSD5 */
#   endif /* !FreeBSD6 */
#   endif /* !FreeBSD7 */
#  endif /* !__bo_systype */

# endif /* __FreeBSD__ */
/* ========================================================================= */
/* %% EndSection: FreeBSD */
/* ========================================================================= */

/* ========================================================================= */
/* %% BeginSection: Linux */
/* ========================================================================= */
# pragma mark -     
# pragma mark [ Linux ]
# pragma mark -
                
# ifdef __linux__
#  undef linux
                    
/* +++ machine info +++ */
#  include "Bo/whereami/Machguess.h"
                    
/* +++ host type +++ */
#  ifndef __bo_hosttype
#   define __bo_hosttype __bo_machine "-" __bo_systype
#  endif
                    
/* +++ kernel architecture +++ */
#  ifndef __bo_kernel_arch
#   define __bo_kernel_arch __bo_system_arch
#   define __bo_kernel_arch__ __bo_system_arch__
#  endif
                    
/* +++ system architecture +++ */
#  ifndef __bo_system_arch
#   define __bo_system_arch "Linux"
#   define __bo_system_arch__ linux
#  endif

/* +++ system type +++ */
#  ifndef __bo_systype
#   define __bo_systype "Linux"
#   define __bo_systype__ linux
#   define __BO_PLATFORM_HEADER(aHeader) <Bo/sys/linux/aHeader>
#   define __BO_PLATFORM_CONFIG_HEADER(aHeader) <Bo/whereami/plaf/linux/aHeader>
#  endif /* !__bo_systype */

# endif /* __linux__ */
/* ========================================================================= */
/* %% EndSection: Linux */
/* ========================================================================= */

/* ========================================================================= */
/* %% BeginSection: MacOSX */
/* ========================================================================= */
# pragma mark -
# pragma mark [ MacOSX ]
# pragma mark -

# ifdef __APPLE_CC__
#  ifndef __MacOSX__
#   define __MacOSX__
#  endif
# endif

# ifdef __MacOSX__

/* +++ machine info +++ */
#  include "Bo/whereami/Machguess.h"

/* +++ host type +++ */
#  ifndef __bo_hosttype
#   define __bo_hosttype __bo_machine "-" __bo_system_arch
#  endif

/* +++ kernel architecture +++ */
#   ifndef __bo_kernel_arch
#    define __bo_kernel_arch __bo_system_arch
#    define __bo_kernel_arch__ __bo_system_arch__
#   endif

/* +++ system architecture +++ */
#   ifndef __bo_system_arch
#    define __bo_system_arch "Darwin"
#    define __bo_system_arch__ Darwin
#   endif

/* +++ system type +++ */
/* @todo: fixme */
#  ifndef __bo_systype
#   define __bo_systype "Darwin"
#   define __bo_systype__ Darwin
#   define __BO_PLATFORM_HEADER(aHeader) <Bo/sys/macosx/aHeader>
#   define __BO_PLATFORM_CONFIG_HEADER(aHeader) <Bo/whereami/plaf/macosx/aHeader>
#  endif /* !__bo_systype */

# endif /* __MacOSX__ */
/* ========================================================================= */
/* %% EndSection: MacOSX */
/* ========================================================================= */

/* ========================================================================= */
/* %% BeginSection: Win */
/* ========================================================================= */
# pragma mark -
# pragma mark [ Win ]
# pragma mark -

# ifdef WIN32
#  ifndef _WIN32
#   define _WIN32
#  endif
# endif
# ifdef WIN64
#  ifndef _WIN64
#   define _WIN64
#  endif
# endif

# ifdef _WIN64
#  ifndef __WINDOWS__
#   define __WINDOWS__
#  endif
# endif
# ifdef _WIN32
#  ifndef __WINDOWS__
#   define __WINDOWS__
#  endif
# endif

# ifdef WINNT
#  ifndef _WINNT
#   define _WINNT
#  endif
# endif

# ifdef __WINDOWS__

/* +++ machine info +++ */
#  include "Bo/whereami/Machguess.h"

/* +++ host type +++ */
#  ifndef __bo_hosttype
#   define __bo_hosttype __bo_machine "-" __bo_system_arch
#  endif

/* +++ kernel architecture +++ */
#   ifndef __bo_kernel_arch
#    define __bo_kernel_arch __bo_system_arch
#    define __bo_kernel_arch__ __bo_system_arch__
#   endif

/* +++ system architecture +++ */
#   ifndef __bo_system_arch
#    define __bo_system_arch "Windows"
#    define __bo_system_arch__ Windows
#   endif

/* +++ system type +++ */
/* @todo: fixme */
#  ifndef __bo_systype
#   ifdef _WINNT
#    define __bo_systype "winnt"
#    define __bo_systype__ winnt
#    define __BO_PLATFORM_HEADER(aHeader) <Bo/sys/w32/aHeader>
#    define __BO_PLATFORM_CONFIG_HEADER(aHeader) <Bo/whereami/plaf/w32/aHeader>
#   else
#   ifdef _WIN64
#    define __bo_systype "win64"
#    define __bo_systype__ w64
#    define __BO_PLATFORM_HEADER(aHeader) <Bo/sys/w32/aHeader>
#    define __BO_PLATFORM_CONFIG_HEADER(aHeader) <Bo/whereami/plaf/w32/aHeader>
#   else
#   ifdef _WIN32
#    define __bo_systype "win32"
#    define __bo_systype__ w32
#    define __BO_PLATFORM_HEADER(aHeader) <Bo/sys/w32/aHeader>
#    define __BO_PLATFORM_CONFIG_HEADER(aHeader) <Bo/whereami/plaf/w32/aHeader>
#   else
#    define __bo_systype "win32s"
#    define __bo_systype__ w32s
#    define __BO_PLATFORM_HEADER(aHeader) <Bo/sys/w32/aHeader>
#    define __BO_PLATFORM_CONFIG_HEADER(aHeader) <Bo/whereami/plaf/w32/aHeader>
#   endif /* !WIN32 */
#   endif /* !WIN64 */
#   endif /* !WINNT */
#  endif /* !__bo_systype */

# endif /* __WINDOWS__ */
/* ========================================================================= */
/* %% EndSection: Win */
/* ========================================================================= */


# include "Bo/whereami/Ccguess.h"

#else /* _BO_CROSSCOMPILE */

#endif /* _BO_CROSSCOMPILE */
