/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright (c) 2005-2007 V.Sokur
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

/*
 * Cconfig.h	(V.Sokur)
 * include/Bo/whereami/compiler/gcc/Cconfig.h
 *
 * $Id$
 */

/* ------------------------------------------------------------------------- */

/*
 * LANGUAGE(compiler): keywords/pseudo-keywords
 */

#if (4 <= __GNUC__)
# define SUPPORT_C99_PRAGMA_KEYWORD
/*# define SUPPORT_C99_THREAD_STORAGE_CLASS_KEYWORD*/
#endif

#define SUPPORT_CONST_KEYWORD 1
#define SUPPORT_SIGNED_KEYWORD 1
#define SUPPORT_VOLATILE_KEYWORD 1
#define SUPPORT_INLINE_KEYWORD 2
#define SUPPORT_RESTRICT_KEYWORD 2
#define SUPPORT_TYPEOF_KEYWORD 2
#define SUPPORT_ATTRIBUTE_KEYWORD
#define SUPPORT_CONSTRUCTOR_ATTRIBUTE
#define SUPPORT_DESTRUCTOR_ATTRIBUTE
/* @todo: fixme; gcc version */
#if (4 < __GNUC__) || (4 == __GNUC__ && 3<= __GNUC_MINOR__)
# define SUPPORT_CONSTRUCTOR_WITH_PARM_ATTRIBUTE
# define SUPPORT_DESTRUCTOR_WITH_PARM_ATTRIBUTE
#endif
#define SUPPORT_EXTENSION_KEYWORD
/*
#define SUPPORT_CDECL_KEYWORD
#define SUPPORT_DECLSPEC_KEYWORD
 */

/*
 * LANGUAGE(compiler): pragmas
 */

/* @todo: fixme */
/*
#define SUPPORT_OMP_PRAGMA
#define SUPPORT_OMP_THREADPRIVATE_PRAGMA
 */

/*
 * LANGUAGE(compiler): features
 */

#if (4 <= __GNUC__)
# define SUPPORT_VARIABLE_LENGTH_ARRAY
# define SUPPORT_FLEXIBLE_ARRAY_MEMBER
# define SUPPORT_TEMPORARY_UNNAMED_OBJECT
# define SUPPORT_DESIGNATED_INITIALIZERS
#endif
#define SUPPORT_MACRO_RETVAL

#define SUPPORT_ANONYMOUS_VARIADIC_MACRO
/* traditional */
#ifndef __STDC_HOSTED__
# define SUPPORT_NAMED_VARIADIC_MACRO
#else
# define SUPPORT_NAMED_VARIADIC_MACRO
#endif

/* The compiler supports option -fnested-functions. If the support of
   nested functions is required the option -fnested-functions should  be
   set and macro SUPPORT_NESTED_FUNCTIONS defined. */
#ifndef SUPPORT_NESTED_FUNCTIONS
# define SUPPORT_NESTED_FUNCTIONS
#endif

#define SUPPORT_LABEL_ADDRESS

#if (__GNUC__ < 3)
# define SUPPORT_VARARGS
#else
# define SUPPORT_STDARG
#endif

/*
 * LANGUAGE(compiler): types
 */

#define SUPPORT_VOID_PTR
#define SUPPORT_LONG_LONG_TYPE
#define SUPPORT_LONG_DOUBLE_TYPE
/* #define SUPPORT_LONG_FLOAT_TYPE */
#if (4 <= __GNUC__)
# define SUPPORT__BOOL_TYPE
# define SUPPORT__COMPLEX_TYPE
# define SUPPORT__COMPLEX_FLOAT_TYPE
# define SUPPORT__COMPLEX_DOUBLE_TYPE
# define SUPPORT__COMPLEX_LONG_DOUBLE_TYPE
#endif

/*
 * SYSTEM(compiler): types
 */

#define HAS_PTRDIFF_TYPE
#define HAS_SIZE_TYPE
#define HAS_SSIZE_TYPE
#define HAS_INTPTR_TYPE
#define HAS_UINTPTR_TYPE
#define HAS_INT8_TYPE
#define HAS_UINT8_TYPE
#define HAS_INT16_TYPE
#define HAS_UINT16_TYPE
#define HAS_INT32_TYPE
#define HAS_UINT32_TYPE
/* @todo: fixme */
#if (4 <= __GNUC__)
# define HAS_INT64_TYPE
# define HAS_UINT64_TYPE
#endif
