/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright (c) 2005-2007 V.Sokur
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

/*
 * Linkage.h	(V.Sokur)
 * include/Bo/whereami/compiler/gcc/Linkage.h
 *
 * $Id$
 */

/* ------------------------------------------------------------------------- */

#ifdef __cplusplus
# define __myc_extern_inline__ inline
#else
# define __myc_extern_inline__ static inline
#endif /* !__cplusplus */

/* @{ */
#define myc_flinkage_shlib_are_defined
#define myc_vlinkage_shlib_are_defined

#if (4 <= __GNUC__)
# define myc_flinkage_shlib_export extern __attribute__((visibility("default")))
# define myc_flinkage_shlib_private /* extern */ __attribute__((visibility("hidden")))
# define myc_flinkage_shlib_internal /* extern */ __attribute__((visibility("internal")))
# define myc_flinkage_shlib_import extern __attribute__((visibility("default")))

# define myc_vlinkage_shlib_export extern __attribute__((visibility("default")))
# define myc_vlinkage_shlib_private extern __attribute__((visibility("hidden")))
# define myc_vlinkage_shlib_internal extern __attribute__((visibility("internal")))
# define myc_vlinkage_shlib_import extern __attribute__((visibility("default")))
#else
# define myc_flinkage_shlib_export extern
# define myc_flinkage_shlib_private __private_extern__
# define myc_flinkage_shlib_internal __private_extern__
# define myc_flinkage_shlib_import extern

# define myc_vlinkage_shlib_export extern
# define myc_vlinkage_shlib_private __private_extern__
# define myc_vlinkage_shlib_internal __private_extern__
# define myc_vlinkage_shlib_import extern
#endif
/* @} */

/* @{ */
#define myc_tcalltype_are_defined

#define myc_tcalltype_cdecl
#define myc_tcalltype_stdcall
#define myc_tcalltype_mcall
/* @} */
