/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright (c) 2005-2007 V.Sokur
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

/*
 * Cconfig.h	(V.Sokur)
 * include/Bo/whereami/compiler/msc/Cconfig.h
 *
 * $Id$
 */

/* ------------------------------------------------------------------------- */

/*
 * We may not use STDC and POSIX on win32 due to stupid headers.
 *
 * We recommend to use other people compiler on a normal people system,
 * for example, FreeBSD or MacOSX.
 *
#ifndef __STDC__
# define __STDC__ 0x1989L
#endif

#ifndef _POSIX_
# define _POSIX_ 1
#endif

#ifdef _POSIX_
# ifndef __POSIX_VISIBLE
#  define __POSIX_VISIBLE 1
# endif
#endif
 */
#define __STDC__ 0x1989L
#define __STD_CPP__

#define __func__ __FUNCTION__

//
// LANGUAGE(compiler): keywords/pseudo-keywords
//

//#define SUPPORT_C99_PRAGMA_KEYWORD
#define SUPPORT_MSC_PRAGMA_KEYWORD
//#define SUPPORT_C99_THREAD_STORAGE_CLASS_KEYWORD
#define SUPPORT_MSC_THREAD_STORAGE_CLASS_KEYWORD

#define SUPPORT_CONST_KEYWORD 1
#define SUPPORT_SIGNED_KEYWORD 1
#define SUPPORT_VOLATILE_KEYWORD 1
#define SUPPORT_INLINE_KEYWORD 2
#define SUPPORT_RESTRICT_KEYWORD 2
//#define SUPPORT_TYPEOF_KEYWORD 2
//#define SUPPORT_ATTRIBUTE_KEYWORD
//#define SUPPORT_EXTENSION_KEYWORD
#define SUPPORT_CDECL_KEYWORD
#define SUPPORT_DECLSPEC_KEYWORD

//
// LANGUAGE(compiler): pragmas
//

#ifdef _OPENMP
# define SUPPORT_OMP_PRAGMA
# define SUPPORT_OMP_THREADPRIVATE_PRAGMA
#endif

//
// LANGUAGE(compiler): features
//

//#define SUPPORT_VARIABLE_LENGTH_ARRAY
#define SUPPORT_FLEXIBLE_ARRAY_MEMBER
//#define SUPPORT_TEMPORARY_UNNAMED_OBJECT
//#define SUPPORT_DESIGNATED_INITIALIZERS
//#define SUPPORT_MACRO_RETVAL
#define SUPPORT_ANONYMOUS_VARIADIC_MACRO
/* traditional */
//#define SUPPORT_NAMED_VARIADIC_MACRO
//#define SUPPORT_NESTED_FUNCTIONS
//#define SUPPORT_LABEL_ADDRESS
//#define SUPPORT_VARARGS
#define SUPPORT_STDARG

//
// LANGUAGE(compiler): types
//

#define SUPPORT_VOID_PTR
#define SUPPORT_LONG_LONG_TYPE
#define SUPPORT_LONG_DOUBLE_TYPE
//#define SUPPORT_LONG_FLOAT_TYPE
#if (1800 <= _MSC_VER)
# define SUPPORT__BOOL_TYPE
#endif
//#define SUPPORT__COMPLEX_TYPE
//#define SUPPORT__COMPLEX_FLOAT_TYPE
//#define SUPPORT__COMPLEX_DOUBLE_TYPE
//#define SUPPORT__COMPLEX_LONG_DOUBLE_TYPE

//
// SYSTEM(compiler): types
//

#define HAS_PTRDIFF_TYPE
#define HAS_SIZE_TYPE
//#define HAS_SSIZE_TYPE
#define HAS_INTPTR_TYPE
#define HAS_UINTPTR_TYPE

#define HAS_INT8_TYPE
#define HAS_U_INT8_TYPE
#define HAS_INT16_TYPE
#define HAS_U_INT16_TYPE
#define HAS_INT32_TYPE
#define HAS_U_INT32_TYPE
#define HAS_INT64_TYPE
#define HAS_U_INT64_TYPE
#if (_MSC_VER < 1600)
typedef __int8 int8_t;
typedef __int16	int16_t;
typedef __int32 int32_t;
typedef __int64 int64_t;
#endif
typedef unsigned __int8 u_int8_t;
typedef unsigned __int16 u_int16_t;
typedef unsigned __int32 u_int32_t;
typedef unsigned __int64 u_int64_t;
