/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright (c) 2005-2007 V.Sokur
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

/*
 * md-amd64.h	(V.Sokour)
 * include/Bo/whereami/machine/i386/md-amd64.h
 *
 * $Id$
 */

/* ---------------------------------------------------------------------- */

#ifndef __BO_MACHINE_DEFINITIONS_amd64__
# define __BO_MACHINE_DEFINITIONS_amd64__

/*
 * +++ machine architecture: amd64 +++
 * AMD 64
 */

/* # define __bo_machine_arch_amd64 "amd64" */
# define __bo_machine_arch_amd64 "x86_64"
# define __bo_machine_arch_amd64__ x86_64

# define __bo_machine_amd64 "amd64"
# define __bo_machine_amd64__ amd64

# define __bo_machine_word_amd64 __bo_machine_word64
# define __bo_byteorder_amd64 __bo_machine_le

# define __bo_cputype_x86_64 "x86_64"
# define __bo_cputype_amd64_nocona __bo_cputype_x86_64
# define __bo_cputype_amd64_k8 "k8"
# define __bo_cputype_amd64_opteron __bo_cputype_amd64_k8

# define __bo_machine_cpu_amd64 " sse2 sse mmx " __bo_cputype_x86_64
# define __bo_machine_cpu_amd64_nocona " sse3 " __bo_machine_cpu_amd64
# define __bo_machine_cpu_amd64_k8 __bo_cputype_amd64_k8 " 3dnow " __bo_machine_cpu_amd64
# define __bo_machine_cpu_amd64_opteron __bo_machine_cpu_amd64_k8

#endif /* !__BO_MACHINE_DEFINITIONS_amd64__ */
