/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright (c) 2005-2007 V.Sokur
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

/*
 * tm-amd64.h	(V.Sokour)
 * include/Bo/whereami/machine/i386/tm-amd64.h
 *
 * $Id$
 */

/* ---------------------------------------------------------------------- */

#ifndef __BO_MACHINE_GUESS_amd64__
# define __BO_MACHINE_GUESS_amd64__

/*
 * +++ machine architecture: amd64 +++
 * AMD 64
 */

# ifdef x86_64
#  ifndef __x86_64__
#   define __x86_64__
#  endif
# endif
# ifdef __x86_64
#  ifndef __x86_64__
#   define __x86_64__
#  endif
# endif
# ifdef __x86_64__
#  ifndef _A_AMD64
#   define _A_AMD64
#  endif
#  ifndef _M_X86_64
#   define _M_X86_64
#  endif
# endif

# ifdef amd64
#  ifndef __amd64__
#   define __amd64__
#  endif
# endif
# ifdef __amd64
#  ifndef __amd64__
#   define __amd64__
#  endif
# endif
# ifdef _M_AMD64
#  ifndef __amd64__
#   define __amd64__
#  endif
# endif
# ifdef __amd64__
#  ifndef _A_AMD64
#   define _A_AMD64
#  endif
#  ifndef _M_X86_64
#   define _M_X86_64
#  endif
# endif

# ifdef k8
#  ifndef __k8__
#   define __k8__
#  endif
# endif
# ifdef __k8
#  ifndef __k8__
#   define __k8__
#  endif
# endif
# ifdef __k8__
#  ifndef _M_K8
#   define _M_K8
#  endif
# endif

# ifdef opteron
#  ifndef __opteron__
#   define __opteron__
#  endif
# endif
# ifdef __opteron
#  ifndef __opteron__
#   define __opteron__
#  endif
# endif
# ifdef __opteron__
#  ifndef _M_OPTERON
#   define _M_OPTERON
#  endif
# endif


# ifdef _A_AMD64

#  undef __bo_machine_arch
#  undef __bo_machine
#  undef __bo_byteorder
#  undef __bo_cputype
#  undef __bo_machine_cpu

#  define __bo_machine_arch __bo_machine_arch_amd64
#  define __bo_machine_arch__ __bo_machine_arch_amd64__

#  define __bo_machine __bo_machine_amd64
#  define __bo_machine__ __bo_machine_amd64__
#  undef i386
#  undef amd64
#  define __BO_MACHINE_HEADER(aHeader) <Bo/machine/amd64/aHeader>
#  define __BO_MACHINE_CONFIG_HEADER(aHeader) <Bo/whereami/machine/amd64/aHeader>

#  define __bo_machine_word __bo_machine_word_amd64
#  define __bo_byteorder __bo_byteorder_amd64

#  ifdef _M_OPTERON
#   define __bo_cputype __bo_cputype_amd64_opteron
#   define __bo_machine_cpu __bo_machine_cpu_amd64_opteron
#  else
#  ifdef _M_K8
#   define __bo_cputype __bo_cputype_amd64_k8
#   define __bo_machine_cpu __bo_machine_cpu_amd64_k8
#  else
#  ifdef _M_X86_64
#   define __bo_cputype __bo_cputype_x86_64
#   define __bo_machine_cpu __bo_machine_cpu_amd64
#  endif /* _M_X86_64 */
#  endif /* _M_K8 */
#  endif /* _M_OPTERON */

# endif /* _A_AMD64 */

#endif /* !__BO_MACHINE_GUESS_amd64__  */
