/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright (c) 2005-2007 T.Zakharchenko
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

/*
 * md-arm.h	(T.Zakharchenko)
 * include/Bo/whereami/machine/arm/md-arm.h
 *
 * $Id$
 */

/* ---------------------------------------------------------------------- */

#ifndef __BO_MACHINE_DEFINITIONS_arm__
# define __BO_MACHINE_DEFINITIONS_arm__


# define __bo_machine_arch_arm32 "arm32"
# define __bo_machine_arch_arm32__ arm32

# define __bo_machine_arm32 "arm32"
# define __bo_machine_arm32__ arm32


# define __bo_machine_arch_arm64 "arm64"
# define __bo_machine_arch_arm64__ arm64

# define __bo_machine_arm64 "arm64"
# define __bo_machine_arm64__ arm64

# define __bo_cputype_arm64 "arm64"
# define __bo_machine_cpu_arm64 __bo_cputype_arm64

/*
 * +++ machine architecture: armv8 (32 bit ? 64 bit) +++
 */

# define __bo_machine_arch_armv8 "armv8"
# define __bo_machine_arch_armv8__ armv8

# define __bo_machine_armv8 "armv8"
# define __bo_machine_armv8__ armv8

/* @todo: fixme */
/*
# define __bo_machine_word_armv8 __bo_machine_word32
# define __bo_byteorder_armv8 __bo_machine_le
 */

# define __bo_cputype_armv8 "armv8"
# define __bo_machine_cpu_armv8 __bo_cputype_armv8


/*
 * +++ machine architecture: armv7 +++
 */

# define __bo_machine_arch_armv7 "armv7"
# define __bo_machine_arch_armv7__ armv7

# define __bo_machine_armv7 "armv7"
# define __bo_machine_armv7__ armv7

# define __bo_machine_word_armv7 __bo_machine_word32
# define __bo_byteorder_armv7 __bo_machine_le

# define __bo_cputype_armv7 "armv7"
# define __bo_machine_cpu_armv7 __bo_cputype_armv7


/*
 * +++ machine architecture: armv6 +++
 */

# define __bo_machine_arch_armv6 "armv6"
# define __bo_machine_arch_armv6__ armv6

# define __bo_machine_armv6 "armv6"
# define __bo_machine_armv6__ armv6

# define __bo_machine_word_armv6 __bo_machine_word32
# define __bo_byteorder_armv6 __bo_machine_le

# define __bo_cputype_armv6 "armv6"
# define __bo_machine_cpu_armv6 __bo_cputype_armv6

#endif /* !__BO_MACHINE_DEFINITIONS_arm__ */
