/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright (c) 2005-2007 T.Zakharchenko
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

/*
 * tm-armv7.h	(T.Zakharchenko)
 * include/Bo/whereami/machine/armv7/tm-arm.h
 *
 * $Id$
 */

/* ---------------------------------------------------------------------- */

#ifndef __BO_MACHINE_GUESS_arm__
# define __BO_MACHINE_GUESS_arm__

/*
 * +++ machine architecture: arm64 +++
 */

# ifdef __aarch64__
#  ifndef __arm64__
#   define __arm64__
#  endif
# endif


/*
 * +++ machine architecture: arm +++
 */

# ifdef arm
#  ifndef __arm__
#   define __arm__
#  endif
# endif
# ifdef __arm
#  ifndef __arm__
#   define __arm__
#  endif
# endif


/*
 * ARMv8
 * @todo: fixme - is armv8 only 64-bit?
 */

# ifdef armv8
#  ifndef __armv8__
#   define __armv8__
#  endif
# endif
# ifdef __ARM_ARCH_8A__
#  ifndef __armv8__
#   define __armv8__
#  endif
#  ifndef __armv8a__
#   define __armv8a__
#  endif
# endif

# ifdef __armv8__
#  ifndef __arm__
#   define __arm__
#  endif
#  ifndef _A_ARM
#   define _A_ARM 8
#  endif
#  ifdef __armv8a__
#   ifndef _M_ARM_8A
#    define _M_ARM_8A
#   endif
#   ifndef _M_ARM_8
#    define _M_ARM_8
#   endif
#  endif
/* @todo: fixme */
/*
#  ifndef _M_ARM32
#   define _M_ARM32
#  endif
 */
# endif


/*
 * ARMv7
 */

# ifdef armv7
#  ifndef __armv7__
#   define __armv7__
#  endif
# endif
# ifdef __armv7
#  ifndef __armv7__
#   define __armv7__
#  endif
# endif
# ifdef __ARM_ARCH_7__
#  ifndef __armv7__
#   define __armv7__
#  endif
# endif
# ifdef __ARM_ARCH_7A__
#  ifndef __armv7__
#   define __armv7__
#  endif
#  ifndef __armv7a__
#   define __armv7a__
#  endif
# endif
# ifdef __ARM_ARCH_7R__
#  ifndef __armv7__
#   define __armv7__
#  endif
#  ifndef __armv7r__
#   define __armv7r__
#  endif
# endif
# ifdef __ARM_ARCH_7M__
#  ifndef __armv7__
#   define __armv7__
#  endif
#  ifndef __armv7m__
#   define __armv7m__
#  endif
# endif
# ifdef __ARM_ARCH_7S__
#  ifndef __armv7__
#   define __armv7__
#  endif
#  ifndef __armv7s__
#   define __armv7s__
#  endif
# endif

# ifdef __armv7__
#  ifndef __arm__
#   define __arm__
#  endif
#  ifndef _A_ARM
#   define _A_ARM      7
#  endif
#  ifdef __armv7a__
#   ifndef _M_ARM_7A
#    define _M_ARM_7A
#   endif
#   ifndef _M_ARM_7
#    define _M_ARM_7   101
#   endif
#  endif
#  ifdef __armv7r__
#   ifndef _M_ARM_7R
#    define _M_ARM_7R
#   endif
#   ifndef _M_ARM_7
#    define _M_ARM_7   122
#   endif
#  endif
#  ifdef __armv7m__
#   ifndef _M_ARM_7M
#    define _M_ARM_7M
#   endif
#   ifndef _M_ARM_7
#    define _M_ARM_7   115
#   endif
#  endif
#  ifdef __armv7s__
#   ifndef _M_ARM_7S
#    define _M_ARM_7S
#   endif
#   ifndef _M_ARM_7
#    define _M_ARM_7   123
#   endif
#  endif
#  ifndef _M_ARM_7
#   define _M_ARM_7    1
#  endif
/* @todo: fixme */
#  ifndef _M_ARM32
#   define _M_ARM32
#  endif
# endif /* defined(__armv7__) */


/*
 * ARMv6
 */

# ifdef armv6
#  ifndef __armv6__
#   define __armv6__
#  endif
# endif
# ifdef __armv6
#  ifndef __armv6__
#   define __armv6__
#  endif
# endif
# ifdef __ARM_ARCH_6__
#  ifndef __armv6__
#   define __armv6__
#  endif
# endif
# ifdef __ARM_ARCH_6J__
#  ifndef __armv6__
#   define __armv6__
#  endif
#  ifndef __armv6j__
#   define __armv6j__
#  endif
# endif
# ifdef __ARM_ARCH_6K__
#  ifndef __armv6__
#   define __armv6__
#  endif
#  ifndef __armv6k__
#   define __armv6k__
#  endif
# endif
# ifdef __ARM_ARCH_6T2__
#  ifndef __armv6__
#   define __armv6__
#  endif
#  ifndef __armv6t2__
#   define __armv6t2__
#  endif
# endif
# ifdef __ARM_ARCH_6Z__
#  ifndef __armv6__
#   define __armv6__
#  endif
#  ifndef __armv6z__
#   define __armv6z__
#  endif
# endif
# ifdef __ARM_ARCH_6ZK__
#  ifndef __armv6__
#   define __armv6__
#  endif
#  ifndef __armv6zk__
#   define __armv6zk__
#  endif
# endif

# ifdef __armv6__
#  ifndef __arm__
#   define __arm__
#  endif
#  ifndef _A_ARM
#   define _A_ARM      6
#  endif
#  ifdef __armv6j__
#   ifndef _M_ARM_6J
#    define _M_ARM_6J
#   endif
#   ifndef _M_ARM_6
#    define _M_ARM_6   112
#   endif
#  endif
#  ifdef __armv6k__
#   ifndef _M_ARM_6K
#    define _M_ARM_6K
#   endif
#   ifndef _M_ARM_6
#    define _M_ARM_6   113
#   endif
#  endif
#  ifdef __armv6t2__
#   ifndef _M_ARM_6T2
#    define _M_ARM_6T2
#   endif
#   ifndef _M_ARM_6
#    define _M_ARM_6   124
#   endif
#  endif
#  ifdef __armv6z__
#   ifndef _M_ARM_6Z
#    define _M_ARM_6Z
#   endif
#   ifndef _M_ARM_6
#    define _M_ARM_6   132
#   endif
#  endif
#  ifdef __armv6zk__
#   ifndef _M_ARM_6ZK
#    define _M_ARM_6ZK
#   endif
#   ifndef _M_ARM_6
#    define _M_ARM_6   245
#   endif
#  endif
#  ifndef _M_ARM_6
#   define _M_ARM_6    1
#  endif
/* @todo: fixme */
#  ifndef _M_ARM32
#   define _M_ARM32
#  endif
# endif /* defined(__armv6__) */

/* ---------------------------------------------------------------------- */

/* @todo: fixme */
# ifdef __arm64__
#  ifndef _A_ARM
#   define _A_ARM 8
#  endif
#  ifndef _M_ARM_8A
#   define _M_ARM_8A
#  endif
#  ifndef _M_ARM_8
#   define _M_ARM_8
#  endif
# endif

/* ---------------------------------------------------------------------- */

# ifdef __ARM_64BIT_STATE
#  ifndef _M_ARM64
#   define _M_ARM64
#  endif
# else
# ifdef __ARM_32BIT_STATE
#  ifndef _M_ARM32
#   define _M_ARM32
#  endif
# else
# endif /* defined(__ARM_32BIT_STATE) */
# endif /* defined(__ARM_64BIT_STATE) */

# ifdef __arm64__
#  ifndef _M_ARM32
#   ifndef _M_ARM64
#    define _M_ARM64
#   endif
#  endif
# endif

# ifdef __arm__
#  ifndef _M_ARM64
#   ifndef _M_ARM32
#    define _M_ARM32
#   endif
#  endif
# endif

# if defined(_M_ARM32) && defined(_M_ARM64)
#  error "arm32 and arm64 are mutually exclusive"
# endif

# ifdef _M_ARM32
#  ifndef _A_ARM32
#   define _A_ARM32
#  endif
# endif

# ifdef _M_ARM64
#  ifndef _A_ARM64
#   define _A_ARM64
#  endif
# endif

/* ---------------------------------------------------------------------- */

# ifdef _A_ARM

#  undef __bo_machine_arch
#  undef __bo_machine
#  undef __bo_byteorder
#  undef __bo_cputype
#  undef __bo_machine_cpu

#  ifdef _M_ARM64
#   define __bo_machine_arch __bo_machine_arch_arm64
#   define __bo_machine_arch__ __bo_machine_arch_arm64__
#   define __bo_machine __bo_machine_arm64
#   define __bo_machine__ __bo_machine_arm64__
#   undef arm
#   undef arm32
#   undef arm64
#   define __BO_MACHINE_HEADER(aHeader) <Bo/machine/arm64/aHeader>
#   define __BO_MACHINE_CONFIG_HEADER(aHeader) <Bo/whereami/machine/arm64/aHeader>
#  else
#  ifdef _M_ARM32
#   define __bo_machine_arch __bo_machine_arch_arm32
#   define __bo_machine_arch__ __bo_machine_arch_arm32__
#   define __bo_machine __bo_machine_arm32
#   define __bo_machine__ __bo_machine_arm32__
#   undef arm
#   undef arm32
#   undef arm64
#   define __BO_MACHINE_HEADER(aHeader) <Bo/machine/arm/aHeader>
#   define __BO_MACHINE_CONFIG_HEADER(aHeader) <Bo/whereami/machine/arm/aHeader>
#  else
#  endif /* defined(_M_ARM32) */
#  endif /* defined(_M_ARM64) */

#  if defined(_M_ARM_8) && defined(_M_ARM64)
#   define __bo_machine_word __bo_machine_word64
/* @todo: fixme */
#   define __bo_byteorder __bo_machine_le
/* @todo: fixme - test */
#   if 1
#    define __bo_cputype __bo_cputype_armv8
#    define __bo_machine_cpu __bo_machine_cpu_armv8
#   else
#    define __bo_cputype __bo_cputype_arm64
#    define __bo_machine_cpu __bo_machine_cpu_arm64
#   endif
#  else
#  if defined(_M_ARM_8) && defined(_M_ARM32)
#   define __bo_machine_word __bo_machine_word32
/* @todo: fixme */
#   define __bo_byteorder __bo_machine_le
#   define __bo_cputype __bo_cputype_armv8
#   define __bo_machine_cpu __bo_machine_cpu_armv8
#  else
#  ifdef _M_ARM_7
#   define __bo_machine_word __bo_machine_word_armv7
#   define __bo_byteorder __bo_byteorder_armv7
#   define __bo_cputype __bo_cputype_armv7
#   define __bo_machine_cpu __bo_machine_cpu_armv7
#  else
#  ifdef _M_ARM_6
#   define __bo_machine_word __bo_machine_word_armv6
#   define __bo_byteorder __bo_byteorder_armv6
#   define __bo_cputype __bo_cputype_armv6
#   define __bo_machine_cpu __bo_machine_cpu_armv6
#  else
#  endif /* defined(_M_ARM_6) */
#  endif /* defined(_M_ARM_7) */
#  endif /*defined(_M_ARM_8) & defined(_M_ARM32)*/
#  endif /*defined(_M_ARM_8) & defined(_M_ARM64)*/

# endif /* _A_ARM */

#endif /* !__BO_MACHINE_GUESS_arm__  */
