/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright (c) 2005-2007 V.Sokur
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

/*
 * md-i386.h	(V.Sokur)
 * include/Bo/whereami/machine/i386/md-i386.h
 *
 * $Id$
 */

/* ---------------------------------------------------------------------- */

#ifndef __BO_MACHINE_DEFINITIONS_i386__
# define __BO_MACHINE_DEFINITIONS_i386__

/*
 * +++ machine architecture: i386 +++
 * Intel
 * AMD
 */

# define __bo_machine_arch_i386 "i386"
# define __bo_machine_arch_i386__ i386

# define __bo_machine_i386 "i386"
# define __bo_machine_i386__ i386

# define __bo_machine_word_i386 __bo_machine_word32
# define __bo_byteorder_i386 __bo_machine_le

/*
 * Intel 386
 */
# define __bo_cputype_i386 "i386"
# define __bo_cputype_i486 "i486"
# define __bo_cputype_i586 "i586"
# define __bo_cputype_pentium __bo_cputype_i586
# define __bo_cputype_i586_mmx "i586_mmx"
# define __bo_cputype_i686 "i686"
# define __bo_cputype_pentiumpro __bo_cputype_i686
# define __bo_cputype_pentium2 "pentium2"
# define __bo_cputype_pentium3 "pentium3"
# define __bo_cputype_pentium4 "pentium4"

# define __bo_machine_cpu_i386 __bo_cputype_i386
# define __bo_machine_cpu_i486 __bo_cputype_i486 " " __bo_machine_cpu_i386
# define __bo_machine_cpu_i586 __bo_cputype_i586 " " __bo_machine_cpu_i486
# define __bo_machine_cpu_pentium __bo_machine_cpu_i586
# define __bo_machine_cpu_i586_mmx " mmx " __bo_machine_cpu_i586
# define __bo_machine_cpu_i686 __bo_cputype_i686 " " __bo_machine_cpu_i586
# define __bo_machine_cpu_pentiumpro __bo_machine_cpu_i686
# define __bo_machine_cpu_pentium2 " mmx " __bo_machine_cpu_i686
# define __bo_machine_cpu_pentium3 " sse " __bo_machine_cpu_pentium2
# define __bo_machine_cpu_pentium4 " sse2 " __bo_machine_cpu_pentium3

/*
 * AMD 386
 */
# define __bo_machine_arch_amd_i386 __bo_machine_arch_i386
# define __bo_machine_arch_amd_i386__ __bo_machine_arch_i386__

# define __bo_machine_amd_i386 "amd386"
# define __bo_machine_amd_i386__ amd386

# define __bo_cputype_k5 "k5"
# define __bo_cputype_k6 "k6"
# define __bo_cputype_k7 "k7"
# define __bo_cputype_athlon __bo_cputype_k7
# define __bo_cputype_k8 "k8"
# define __bo_cputype_athlon4 __bo_cputype_k8
# define __bo_cputype_opteron __bo_cputype_k8

# define __bo_machine_cpu_k5 __bo_cputype_k5 " " __bo_machine_cpu_i586
# define __bo_machine_cpu_k6 __bo_cputype_k6 " mmx " __bo_machine_cpu_k5
# define __bo_machine_cpu_k7 __bo_cputype_k7 " 3dnow " __bo_machine_cpu_k6
# define __bo_machine_cpu_athlon " athlon " __bo_machine_cpu_k7
# define __bo_machine_cpu_k8 " athlon-xp sse " __bo_machine_cpu_athlon
# define __bo_machine_cpu_athlon4 __bo_machine_cpu_k8
# define __bo_machine_cpu_opteron " sse2 " __bo_machine_cpu_athlon4

#endif /* !__BO_MACHINE_DEFINITIONS_i386__ */
