/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright (c) 2005-2007 V.Sokur
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

/*
 * tm-i386.h	(V.Sokur)
 * include/Bo/whereami/machine/i386/tm-i386.h
 *
 * $Id$
 */

/* ---------------------------------------------------------------------- */

#ifndef __BO_MACHINE_GUESS_i386__
# define __BO_MACHINE_GUESS_i386__

/*
 * +++ machine architecture: i386 +++
 * Intel
 * AMD
 */

/*
 * Intel 386
 */
# ifdef i386
#  ifndef __i386__
#   define __i386__
#  endif
# endif
# ifdef __i386
#  ifndef __i386__
#   define __i386__
#  endif
# endif
# ifdef _M_IX86
#  ifndef __i386__
#   define __i386__
#  endif
# endif
# ifdef _X86_
#  ifndef __i386__
#   define __i386__
#  endif
# endif
# ifdef __i386__
#  ifndef _A_I386
#   define _A_I386
#  endif
#  ifndef _M_I386
#   define _M_I386
#  endif
#  ifndef _M_INTEL
#   define _M_INTEL
#  endif
# endif

# ifdef i486
#  ifndef __i486__
#   define __i486__
#  endif
# endif
# ifdef __i486
#  ifndef __i486__
#   define __i486__
#  endif
# endif
# ifdef __i486__
#  ifndef _A_I386
#   define _A_I386
#  endif
#  ifndef _M_I486
#   define _M_I486
#  endif
#  ifndef _M_INTEL
#   define _M_INTEL
#  endif
# endif

# ifdef i586
#  ifndef __i586__
#   define __i586__
#  endif
# endif
# ifdef __i586
#  ifndef __i586__
#   define __i586__
#  endif
# endif
# ifdef __i586__
#  ifndef _A_I386
#   define _A_I386
#  endif
#  ifndef _M_I586
#   define _M_I586
#  endif
#  ifndef _M_INTEL
#   define _M_INTEL
#  endif
# endif

# ifdef pentium
#  ifndef __pentium__
#   define __pentium__
#  endif
# endif
# ifdef __pentium
#  ifndef __pentium__
#   define __pentium__
#  endif
# endif
# ifdef __pentium__
#  ifndef _A_I386
#   define _A_I386
#  endif
#  ifndef _M_I586
#   define _M_I586
#  endif
#  ifndef _M_INTEL
#   define _M_INTEL
#  endif
# endif

# ifdef i686
#  ifndef __i686__
#   define __i686__
#  endif
# endif
# ifdef __i686
#  ifndef __i686__
#   define __i686__
#  endif
# endif
# ifdef __i686__
#  ifndef _A_I386
#   define _A_I386
#  endif
#  ifndef _M_I686
#   define _M_I686
#  endif
#  ifndef _M_INTEL
#   define _M_INTEL
#  endif
# endif

# ifdef pentiumpro
#  ifndef __pentiumpro__
#   define __pentiumpro__
#  endif
# endif
# ifdef __pentiumpro
#  ifndef __pentiumpro__
#   define __pentiumpro__
#  endif
# endif
# ifdef __pentiumpro__
#  ifndef _A_I386
#   define _A_I386
#  endif
#  ifndef _M_I686
#   define _M_I686
#  endif
#  ifndef _M_INTEL
#   define _M_INTEL
#  endif
# endif

# ifdef __p2__
#  ifndef __pentium2__
#   define __pentium2__
#  endif
# endif
# ifdef p2
#  ifndef __pentium2__
#   define __pentium2__
#  endif
# endif
# ifdef __p2
#  ifndef __pentium2__
#   define __pentium2__
#  endif
# endif
# ifdef pentium2
#  ifndef __pentium2__
#   define __pentium2__
#  endif
# endif
# ifdef __pentium2
#  ifndef __pentium2__
#   define __pentium2__
#  endif
# endif
# ifdef __pentium2__
#  ifndef _A_I386
#   define _A_I386
#  endif
#  ifndef _M_PENTIUM2
#   define _M_PENTIUM2
#  endif
#  ifndef _M_INTEL
#   define _M_INTEL
#  endif
# endif

# ifdef __p3__
#  ifndef __pentium3__
#   define __pentium3__
#  endif
# endif
# ifdef p3
#  ifndef __pentium3__
#   define __pentium3__
#  endif
# endif
# ifdef __p3
#  ifndef __pentium3__
#   define __pentium3__
#  endif
# endif
# ifdef pentium3
#  ifndef __pentium3__
#   define __pentium3__
#  endif
# endif
# ifdef __pentium3
#  ifndef __pentium3__
#   define __pentium3__
#  endif
# endif
# ifdef __pentium3__
#  ifndef _A_I386
#   define _A_I386
#  endif
#  ifndef _M_PENTIUM3
#   define _M_PENTIUM3
#  endif
#  ifndef _M_INTEL
#   define _M_INTEL
#  endif
# endif

# ifdef __p4__
#  ifndef __pentium4__
#   define __pentium4__
#  endif
# endif
# ifdef p4
#  ifndef __pentium4__
#   define __pentium4__
#  endif
# endif
# ifdef __p4
#  ifndef __pentium4__
#   define __pentium4__
#  endif
# endif
# ifdef pentium4
#  ifndef __pentium4__
#   define __pentium4__
#  endif
# endif
# ifdef __pentium4
#  ifndef __pentium4__
#   define __pentium4__
#  endif
# endif
# ifdef __pentium4__
#  ifndef _A_I386
#   define _A_I386
#  endif
#  ifndef _M_PENTIUM4
#   define _M_PENTIUM4
#  endif
#  ifndef _M_INTEL
#   define _M_INTEL
#  endif
# endif

/*
 * AMD 386
 */
# ifdef k5
#  ifndef __k5__
#   define __k5__
#  endif
# endif
# ifdef __k5
#  ifndef __k5__
#   define __k5__
#  endif
# endif
# ifdef __k5__
#  ifndef _A_I386
#   define _A_I386
#  endif
#  ifndef _M_K5
#   define _M_K5
#  endif
#  ifndef _M_AMD
#   define _M_AMD
#  endif
# endif

# ifdef k6
#  ifndef __k6__
#   define __k6__
#  endif
# endif
# ifdef __k6
#  ifndef __k6__
#   define __k6__
#  endif
# endif
# ifdef __k6__
#  ifndef _A_I386
#   define _A_I386
#  endif
#  ifndef _M_K6
#   define _M_K6
#  endif
#  ifndef _M_AMD
#   define _M_AMD
#  endif
# endif

# ifdef k7
#  ifndef __k7__
#   define __k7__
#  endif
# endif
# ifdef __k7
#  ifndef __k7__
#   define __k7__
#  endif
# endif
# ifdef __k7__
#  ifndef _A_I386
#   define _A_I386
#  endif
#  ifndef _M_K7
#   define _M_K7
#  endif
#  ifndef _M_AMD
#   define _M_AMD
#  endif
# endif

# ifdef athlon
#  ifndef __athlon__
#   define __athlon__
#  endif
# endif
# ifdef __athlon
#  ifndef __athlon__
#   define __athlon__
#  endif
# endif
# ifdef __athlon__
#  ifndef _A_I386
#   define _A_I386
#  endif
#  ifndef _M_ATHLON
#   define _M_ATHLON
#  endif
#  ifndef _M_AMD
#   define _M_AMD
#  endif
# endif

# ifdef k8
#  ifndef __k8__
#   define __k8__
#  endif
# endif
# ifdef __k8
#  ifndef __k8__
#   define __k8__
#  endif
# endif
# ifdef __k8__
#  ifndef _M_K8
#   define _M_K8
#  endif
#  ifndef _M_AMD
#   define _M_AMD
#  endif
# endif

# ifdef opteron
#  ifndef __opteron__
#   define __opteron__
#  endif
# endif
# ifdef __opteron
#  ifndef __opteron__
#   define __opteron__
#  endif
# endif
# ifdef __opteron__
#  ifndef _M_OPTERON
#   define _M_OPTERON
#  endif
#  ifndef _M_AMD
#   define _M_AMD
#  endif
# endif


# ifdef x86_64
#  ifndef __x86_64__
#   define __x86_64__ 1
#  endif
# endif
# ifdef __x86_64
#  ifndef __x86_64__
#   define __x86_64__ 1
#  endif
# endif
# ifdef amd64
#  ifndef __x86_64__
#   define __x86_64__ 1
#  endif
# endif
# ifdef __amd64
#  ifndef __x86_64__
#   define __x86_64__ 1
#  endif
# endif
# ifdef __amd64__
#  ifndef __x86_64__
#   define __x86_64__ 1
#  endif
# endif
# ifdef __x86_64__
#  undef _A_I386
#  undef _M_INTEL
# endif


# ifdef _A_I386

#  undef __bo_machine_arch
#  undef __bo_machine
#  undef __bo_byteorder
#  undef __bo_cputype
#  undef __bo_machine_cpu

#  define __bo_machine_arch __bo_machine_arch_i386
#  define __bo_machine_arch__ __bo_machine_arch_i386__

#  ifdef __bo_machine_i386
#   define __bo_machine __bo_machine_i386
#   define __bo_machine__ __bo_machine_i386__
#   undef i386
#   define __BO_MACHINE_HEADER(aHeader) <Bo/machine/i386/aHeader>
#   define __BO_MACHINE_CONFIG_HEADER(aHeader) <Bo/whereami/machine/i386/aHeader>
#  endif

#  define __bo_machine_word __bo_machine_word_i386
#  define __bo_byteorder __bo_byteorder_i386

#  ifdef _M_PENTIUM4
#   define __bo_cputype __bo_cputype_pentium4
#   define __bo_machine_cpu __bo_machine_cpu_pentium4
#  else
#  ifdef _M_PENTIUM3
#   define __bo_cputype __bo_cputype_pentium3
#   define __bo_machine_cpu __bo_machine_cpu_pentium3
#  else
#  ifdef _M_PENTIUM2
#   define __bo_cputype __bo_cputype_pentium2
#   define __bo_machine_cpu __bo_machine_cpu_pentium2
#  else
#  ifdef _M_I686
#   define __bo_cputype __bo_cputype_i686
#   define __bo_machine_cpu __bo_machine_cpu_i686
#  else
#  ifdef _M_I586
#   define __bo_cputype __bo_cputype_i586
#   define __bo_machine_cpu __bo_machine_cpu_i586
#  else
#  ifdef _M_I486
#   define __bo_cputype __bo_cputype_i486
#   define __bo_machine_cpu __bo_machine_cpu_i486
#  else
#  ifdef _M_I386
#   define __bo_cputype __bo_cputype_i386
#   define __bo_machine_cpu __bo_machine_cpu_i386
#  endif /* _M_I386 */
#  endif /* _M_I486 */
#  endif /* _M_I586 */
#  endif /* _M_I686 */
#  endif /* _M_PENTIUM2 */
#  endif /* _M_PENTIUM3 */
#  endif /* _M_PENTIUM4 */

#  ifdef _M_AMD

#   undef __bo_machine
#   undef __bo_cputype
#   undef __bo_machine_cpu

#   ifdef __bo_machine_amd_i386
#    define __bo_machine __bo_machine_amd_i386
#    define __bo_machine__ __bo_machine_amd_i386__
#    undef amd386
#    undef i386
#    define __BO_MACHINE_HEADER(aHeader) <Bo/machine/i386/aHeader>
#    define __BO_MACHINE_CONFIG_HEADER(aHeader) <Bo/whereami/machine/i386/aHeader>
#   endif

#   ifdef _M_OPTERON
#    define __bo_cputype __bo_cputype_opteron
#    define __bo_machine_cpu __bo_machine_cpu_opteron
#   else
#   ifdef _M_K8
#    define __bo_cputype __bo_cputype_k8
#    define __bo_machine_cpu __bo_machine_cpu_k8
#   else
#   ifdef _M_ATHLON
#    define __bo_cputype __bo_cputype_athlon
#    define __bo_machine_cpu __bo_machine_cpu_athlon
#   else
#   ifdef _M_K7
#    define __bo_cputype __bo_cputype_k7
#    define __bo_machine_cpu __bo_machine_cpu_k7
#   else
#   ifdef _M_K6
#    define __bo_cputype __bo_cputype_k6
#    define __bo_machine_cpu __bo_machine_cpu_k6
#   else
#   ifdef _M_K5
#    define __bo_cputype __bo_cputype_k5
#    define __bo_machine_cpu __bo_machine_cpu_k5
#   endif /* _M_K5 */
#   endif /* _M_K6 */
#   endif /* _M_K7 */
#   endif /* _M_ATHLON */
#   endif /* _M_K8 */
#   endif /* _M_OPTERON */
#  endif /* _M_AMD */

# endif /* _A_I386 */

#endif /* !__BO_MACHINE_GUESS_i386__  */
