/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright (c) 2005-2007 V.Sokur
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

/*
 * tm-ia64.h	(V.Sokur)
 * include/Bo/whereami/machine/i386/tm-ia64.h
 *
 * $Id$
 */

/* ---------------------------------------------------------------------- */

#ifndef __BO_MACHINE_GUESS_ia64__
# define __BO_MACHINE_GUESS_ia64__

/*
 * +++ machine architecture: ia64 +++
 * Intel ia64
 */

# ifdef ia64
#  ifndef __ia64__
#   define __ia64__
#  endif
# endif
# ifdef __ia64
#  ifndef __ia64__
#   define __ia64__
#  endif
# endif
# ifdef __ia64__
#  ifndef _A_IA64
#   define _A_IA64
#  endif
#  ifndef _M_IA64
#   define _M_IA64
#  endif
# endif


# ifdef _A_IA64

#  undef __bo_machine_arch
#  undef __bo_machine
#  undef __bo_byteorder
#  undef __bo_cputype
#  undef __bo_machine_cpu

#  define __bo_machine_arch __bo_machine_arch_ia64
#  define __bo_machine_arch__ __bo_machine_arch_ia64__

#  define __bo_machine __bo_machine_ia64
#  define __bo_machine__ __bo_machine_ia64__
#  undef ia64
#  define __BO_MACHINE_HEADER(aHeader) <Bo/machine/ia64/aHeader>
#  define __BO_MACHINE_CONFIG_HEADER(aHeader) <Bo/whereami/machine/ia64/aHeader>

#  define __bo_machine_word __bo_machine_word_ia64
#  define __bo_byteorder __bo_byteorder_ia64

#  ifdef _M_IA64
#   define __bo_cputype __bo_cputype_itanium
#  endif

# endif /* _A_IA64 */

#endif /* !__BO_MACHINE_GUESS_ia64__  */
