/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright (c) 2005-2007 V.Sokur
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

/*
 * Sysconfig.h	(V.Sokur)
 * include/Bo/whereami/plaf/bsd/Sysconfig.h
 *
 * $Id$
 */

/* ------------------------------------------------------------------------- */

/* @todo: fixme version (???) */
#undef _FILE_OFFSET_BITS
#define _FILE_OFFSET_BITS 64
#undef _LARGEFILE_SOURCE
#define _LARGEFILE_SOURCE
#undef _LARGEFILE64_SOURCE
#define _LARGEFILE64_SOURCE
#ifndef _INTEGRAL_MAX_BITS
# define _INTEGRAL_MAX_BITS 64
#endif

/* ------------------------------------------------------------------------- */
#pragma mark -
/* ------------------------------------------------------------------------- */

/* Path separator */
#ifndef BO_PATH_SEP
# define BO_PATH_SEP '/'
# define _BO_PATH_SEP "/"
#endif

/* Paths delimiter */
#ifndef BO_PATH_DELIM
# define BO_PATH_DELIM ':'
# define _BO_PATH_DELIM ":"
#endif

#ifndef __MYC_LIBC_HEADER
/*# define __MYC_LIBC_HEADER(aHeader) </usr/include/aHeader>*/
# define __MYC_LIBC_HEADER(aHeader) <aHeader>
#endif

/*
 * SYSTEM(compiler): headers
 */

#define has_sys7cdefs_h 1
#define has_sys7param_h 1
#define has_sys7syslimits_h 1
#define has_sys7types_h 1
#define has_bitstring_h 1
#define has_sys7bitstring_h 1
#define has_sys7stat_h 1
#define has_sys7wait_h 1
#define has_sys7time_h 1
#define has_time_h 1
#define has_sys7ioctl_h 1
#define has_sys7fcntl_h 1 /* fixme */
#define has_fcntl_h 1
#define has_sys7file_h 1 /* fixme */
#define has_sys7uio_h 1 /* fixme */
#define has_paths_h 1
#define has_sysexits_h 1
#define has_unistd_h 1
/* #define has_process_h 1 */
#define has_dirent_h 1
#define has_sys7dirent_h 1 /* fixme */
/* #define has_direct_h 1 */
#define has_dlfcn_h 1
#define has_poll_h 1
#define has_sys7select_h 1
#define has_signal_h 1

#define has_stddef_h 1
#define has_stdio_h 1
#define has_stdlib_h 1
#define has_stdarg_h 1
#define has_varargs_h 1
#define has_machine7varargs_h 0
#define has_stdbool_h 1
#define has_stdint_h 1
#define has_alloca_h 1
/* #define has_malloc_h 1 */
#define has_string_h 1
#define has_strings_h 1
#define has_wchar_h 1
/* #define has_tchar_h 1 */
#define has_sched_h 1
#define has_int_fmtio_h 1 /* NetBSD */
#define has_inttypes_h 1
#define has_machine7atomic_h 1
#define has_machine7cpufunc_h 1

#define has_sys7socket_h 1
/* #define has_xti_h 1 */
#define has_netinet7in_h 1
#define has_arpa7inet_h 1
#define has_netdb_h 1

/*
 * SYSTEM(compiler): types
 */

#define __BO_SYSERRCODE_TYPE__ int
#define BoGetposixerr() errno
#define BoGetsyserr() errno

#define HAS_INO_TYPE
#define PRIino PRIu32
#define HAS_MODE_TYPE
#define PRImode PRIu16
/* @todo: fixme version(?) */
#define HAS_OFF_TYPE
#if (64 == (_FILE_OFFSET_BITS + 0))
# define PRIoff PRIi64
#else
# define PRIoff PRIi32
#endif

/* @todo: version */
/* Process/Group/User ID */
#define HAS_PID_TYPE
#define PRIpid PRIi32
#define HAS_GID_TYPE
#define PRIgid PRIu32
#define HAS_UID_TYPE
#define PRIuid PRIu32

#define HAS_TIME_TYPE
/* #define HAS_SECONDS_TYPE */
/* #define HAS_SSECONDS_TYPE */
/* #define HAS_MSECONDS_TYPE */
/* #define HAS_SMSECONDS_TYPE */
#define HAS_USECONDS_TYPE
#define HAS_SUSECONDS_TYPE
#define HAS_TIMESPEC_STRUC /* <time.h> */
#define HAS_TIMEVAL_STRUC /* <sys/time.h> */
#define HAS_DIR_STRUC /* <dirent.h> */
#define HAS_DIRENT_STRUC /* <sys/dirent.h> */

#ifdef has_xti_h
# define HAS_T_SCALAR_TYPE
# define HAS_T_INFO_STRUC
# define HAS_NETBUF_STRUC
# define HAS_T_CALL_STRUC
# define HAS_T_BIND_STRUC
# define HAS_T_UNITDATA_STRUC
#endif

/* Socket support */
/* sys/socket.h */
#define HAS_SOCKLEN_TYPE
#define __BO_SOCKSYSOBJ_TYPE__ int
#define __BO_INVAL_SOCKSYSOBJ ((int)-1)

/* Dynamic library support */
/* dlfcn.h */
#define __BO_DLSYSOBJ_TYPE__ __BO_VOID_PTR__
#define __BO_DLFUNC_TYPE__ __BO_VOID_PTR__
#define __BO_DLVAR_TYPE__ __BO_VOID_PTR__
#define __BO_INVAL_DLSYSOBJ NULL

/*
 * SYSTEM(compiler): functions
 */

/*
 * [file-] stat interface
 * @{
 * 1. file type constants: S_IFMT, ... ; S_ISDIR, ...
 * 2. file mode constants: S_IRWXU, ...
 * 3. stat declarations: struct stat
 * 4. functions:
 *		chmod, fchmod
 *		stat, lstat, fstat
 *		umask
 *		mkdir, mkfifo [, mknod]
 */

/* <sys/stat.h> */

#define HAS_STAT_STRUC

#define HAS_STAT
/* #define HAS_WSTAT */
#define HAS_LSTAT
/* #define HAS_WLSTAT */
#define HAS_FSTAT

#define HAS_UMASK

#define HAS_CHMOD
/* #define HAS_WCHMOD */
#define HAS_FCHMOD

#define HAS_MKDIR
/* #define HAS_WMKDIR */
#define HAS_MKFIFO
/* #define HAS_WMKFIFO */

/* <sys/stat.h>, <unistd.h> */

#define HAS_MKNOD
/* #define HAS_WMKNOD */
/* @} */

/*
 * file-control interface
 * @{
 * 1. open-only flags: O_RDONLY, ...; O_CREAT, ...
 * 2. copyfile flags: CPF_OVERWRITE, CPF_IGNORE_MODE
 * 3. fcntl command constants (and arguments/flags): F_DUPFD, ...
 * 4. file type constants [optional, <sys/stat.h>]
 * 5. file mode constants [optional, <sys/stat.h>]
 * 6. file ofset constants [optional, <unistd.h>]
 * 7. flock declarations: struct flock, lock operations
 * 8. functions:
 *		open, creat, dup, dup2
 *		fcntl
 *		flock
 */

/* <fcntl.h>, <sys/fcntl.h> */

#define HAS_FLOCK_STRUC

#define HAS_OPEN
/* #define HAS_WOPEN */
#define HAS_CREAT
/* #define HAS_WCREAT */
#define HAS_FCNTL
#define HAS_FLOCK

/* <unistd.h> */
#define HAS_LOCKF
#define HAS_DUP
#define HAS_DUP2
/* @} */

/*
 * low level I/O interface
 * @{
 * 1. functions:
 *		close
 *		read, write, pread, pwrite
 *		readv, writev
 *		lseek, tell
 */

/* <unistd.h> */
#define HAS_CLOSE
#define HAS_READ
#define HAS_WRITE
#define HAS_LSEEK
/* # define HAS_TELL */
#define HAS_PREAD
#define HAS_PWRITE

/* <sys/uio.h> */
#define HAS_IOVEC_STRUC
#define HAS_READV
#define HAS_WRITEV
/* @} */

/*
 * dir-control interface
 * @{
 * 1. functions:
 *		unlink, rmdir, remove, rename,
 *		getcwd, getwd,
 *		chdir, fchdir
 */

/* <unistd.h> */
#define HAS_UNLINK
/* #define HAS_WUNLINK */
#define HAS_RMDIR
/* #define HAS_WRMDIR */
#define HAS_CHDIR
/* #define HAS_WCHDIR */
#define HAS_FCHDIR
#define HAS_GETCWD
/* #define HAS_WGETCWD */

/* <stdio.h> */
#define HAS_REMOVE
/* #define HAS_WREMOVE */
#define HAS_RENAME
/* #define HAS_WRENAME */
/* @} */

/*
 * process interface
 * @{
 * 1. functions:
 *		_exit, exit
 *		execl, execle, execlp, execv, execve, execvp
 *		fork, vfork
 *		nice
 *		getgid, getegid
 *		setgid, setregid, setegid [, setrgid]
 *		getpgid [, getpgrp]
 *		setpgid [, setpgrp]
 *		getuid, geteuid
 *		setuid, setreuid, seteuid [, setruid]
 *		getpid, getppid
 *		getsid, setsid
 */

/* <stdlib.h> */
#define HAS_EXIT

/* <unistd.h> */
#define HAS__EXIT

/* <unistd.h>, <stdlib.h> */
#define HAS_ENVIRON
#define HAS_SYS_ERRLIST
#define HAS_SYS_NERR

/* <unistd.h> */
#define HAS_EXECL
#define HAS_EXECLE
#define HAS_EXECLP
#define HAS_EXECV
#define HAS_EXECVE
#define HAS_EXECVP
/* #define HAS_WEXECL */
/* #define HAS_WEXECLE */
/* #define HAS_WEXECLP */
/* #define HAS_WEXECV */
/* #define HAS_WEXECVE */
/* #define HAS_WEXECVP */

/* #define HAS__SPAWNL */
/* #define HAS__SPAWNLP */
/* #define HAS__SPAWNLE */
/* #define HAS__SPAWNV */
/* #define HAS__SPAWNVP */
/* #define HAS__SPAWNVE */
/* #define HAS__WSPAWNL */
/* #define HAS__WSPAWNLP */
/* #define HAS__WSPAWNLE */
/* #define HAS__WSPAWNV */
/* #define HAS__WSPAWNVP */
/* #define HAS__WSPAWNVE */

#define HAS_FORK
#define HAS_VFORK

#define HAS_GETGID /* real group ID of the current process */
#define HAS_GETEGID /* effective group ID of the current process */
#define HAS_SETGID
#define HAS_SETREGID
#define HAS_SETEGID
/* #define HAS_SETRGID */

#define HAS_GETPGID /* process group */
#define HAS_GETPGRP /* process group of the current process */
#define HAS_SETPGID
#define HAS_SETPGRP

#define HAS_GETUID /* real user ID of the current process */
#define HAS_GETEUID /* effective user ID of the current process */
#define HAS_SETUID
#define HAS_SETREUID
#define HAS_SETEUID
/* #define HAS_SETRUID */

#define HAS_GETPID /* process ID of the current process */
#define HAS_GETPPID /* parent process ID of the current process */

#define HAS_GETSID
#define HAS_SETSID

#define HAS_NICE
/* @} */

/*
 * wait interface
 * @{
 * 1. functions:
 *		wait, waitpid, wait3, wait4
 */

/* <sys/wait.h> */
#define HAS_WAIT
#define HAS_WAITPID
#define HAS_WAIT3
#define HAS_WAIT4
/* @} */

/* ------------------------------------------------------------------------- */

/*
 * standard I/O interface
 * @{
 */

/* <stdio.h> */

/*
 * string
 */

#define HAS_SNPRINTF
#define SNPRINTF_OUTPUT_ALWAYS_NULL_TERMINATED
#define SNPRINTF_RETURNS_NCHARS_WOULD_HAVE_BEEN_PRINTED
	/* not including the terminating NUL character */

#define HAS_VSNPRINTF
#define VSNPRINTF_OUTPUT_ALWAYS_NULL_TERMINATED
#define VSNPRINTF_RETURNS_NCHARS_WOULD_HAVE_BEEN_PRINTED
	/* not including the terminating NUL character */

#define HAS_SWPRINTF
/* #define SWPRINTF_OUTPUT_ALWAYS_NULL_TERMINATED */
/* #define SWPRINTF_RETURNS_NCHARS_WOULD_HAVE_BEEN_PRINTED */
	/* not including the terminating NUL character */

#define HAS_VSWPRINTF
/* #define VSWPRINTF_OUTPUT_ALWAYS_NULL_TERMINATED */
/* #define VSWPRINTF_RETURNS_NCHARS_WOULD_HAVE_BEEN_PRINTED */
	/* not including the terminating NUL character */

#define HAS_ASPRINTF
#define HAS_VASPRINTF
/* #define HAS_ASWPRINTF */
/* #define HAS_VASWPRINTF */

/* #define HAS__SCPRINTF */
/* #define HAS__VSCPRINTF */
/* #define HAS__SCWPRINTF */
/* #define HAS__VSCWPRINTF */

/*
 * file
 */

/* #define HAS_WFOPEN */
#define HAS_FDOPEN
#define HAS_FILENO

#define HAS_FWPRINTF
#define HAS_VFWPRINTF

#define HAS_FSEEK
#define HAS_FTELL
#define HAS_FSEEKO
#define HAS_FTELLO
/* @} */

/*
 * malloc, alloca
 * @{
 */

/* <stdlib.h> */
#define STDLIB_HEADER_HAS_MALLOC_DECL

#define HAS_ALLOCA
/* <alloca.h> */
#define ALLOCA_HEADER_HAS_ALLOCA_DECL
/* @} */

/*
 * stdlib
 * @{
 * 1. functions: exit, _Exit
 */

/* @todo: fixme, version */
#define HAS_STRTOL
#define HAS_WCSTOL
#define HAS_STRTOLL
#define HAS_WCSTOLL
#define HAS_STRTOD
#define HAS_WCSTOD
/* @} */

/*
 * string, memory operations
 * @{
 * <string.h>, <strings.h>, <extras.h>
 */

/* <string.h> */
#define HAS_STRDUP
/* #define HAS_WCSDUP */

/* BSD: <strings.h>, MWERKS: <extras.h> */
#define HAS_STRCASECMP
#define HAS_STRNCASECMP
#define HAS_BZERO
#define HAS_BCMP
#define HAS_BCOPY
/* @} */

/*
 * dirent
 * @{
 * <sys/dirent.h>, <dirent.h>
 */

#define HAS_GETDIRENTRIES

#define HAS_OPENDIR
/* #define HAS_WOPENDIR */
#define HAS_CLOSEDIR
#define HAS_READDIR
/* #define HAS_WREADDIR */
#define HAS_READDIR_R
/* #define HAS_WREADDIR_R */
#define HAS_REWINDDIR
#define HAS_SEEKDIR
#define HAS_TELLDIR
#define HAS_SCANDIR
/* #define HAS_WSCANDIR */
#define HAS_ALPHASORT
/* #define HAS_WALPHASORT */
/* @} */

/*
 * time
 * @{
 */

/* <sys/time.h> */

#define HAS_GETTIMEOFDAY
#define HAS_NANOSLEEP /* nanoseconds */

/* <time.h> */

#define HAS_CTIME_R
#define HAS_GMTIME_R
#define HAS_LOCALTIME_R
#define HAS_MKTIME
#define HAS_TIMEGM
/* @} */

/* <sys/ioctl.h> */
#define HAS_IOCTL

/*
 * unistd
 * @{
 * sys:
 * 1. posix version: _POSIX_VERSION, _POSIX2_VERSION
 * 2. access constants (access() function): F_OK, X_OK, W_OK, R_OK
 * 3. extended access constants [optional]
 * 4. file offset constants: SEEK_SET, SEEK_CUR, SEEK_END
 * 5. configurable pathname variables constants: _PC_LINK_MAX, ...
 * 6. configurable system string constants: _SC_PATH
 *
 * 7. Xopen version: _XOPEN_VERSION
 * 8. standard input/output/error file descriptor constants: STDIN_FILENO, STDOUT_FILENO, STDERR_FILENO
 * 9. constants for posix features support: _POSIX_ASYNCHRONOUS_IO, _POSIX_SHELL, _POSIX_THREADS, ...
 * 10. constants for Xopen features support: _XOPEN_CRYPT, ...
 * 11. lock constants
 * 12. configurable system variables constants: _SC_VERSION, _SC_PATH (???), _SC_ARG_MAX, ... _SC_XOPEN_SHM, ...
 * 13. functions:
 *		pathconf, fpathconf, sysconf
 *		gethostid, sethostid, gethostname, sethostname
 *		getlogin, setlogin, getlogin_r
 *		getgroups, setgroups
 *		ttyname, ttyname_r, isatty, ctermid; tcgetpgrp, tcsetpgrp
 *		chown, fchown, lchown
 *		access, link, symlink
 *		mkstemp, mktemp, pipe
 *		ftruncate, truncate
 *		readlink
 *		sync [io]
 *		getopt
 *		sleep, usleep [time]
 *		alarm, ualarm, pause
 */

#define HAS_GETHOSTNAME

#define HAS_SLEEP /* seconds */
/* #define HAS_MSLEEP */ /* milliseconds */
#define HAS_USLEEP /* microseconds */
/* @} */

/*
 * dlfcn
 * @{
 */
#define DL_INIT_FINI_AUTOMATIC_CALLED
/* @} */

/*
 * netdb
 * @{
 * <netdb.h>
 */

#define HAS_GETADDRINFO
#define HAS_FREEADDRINFO

/* @} */

/*
 * THREAD
 */

/* @todo: fixme */
#define HAS_POSIX_THREAD
#define HAS_PTHREAD_YIELD
/* #define HAS_PTHREAD_YIELD_NP */
/* #define HAS_PTHREAD_SUSPEND */
/* #define HAS_PTHREAD_SUSPEND_NP */
/* #define HAS_PTHREAD_RESUME */
/* #define HAS_PTHREAD_RESUME_NP */
#define HAS_PTHREAD_MUTEX
#define HAS_PTHREAD_COND
/* @} */

/*
#define BO_FSPATH2WPATH_PLAF_IMPL
#define BO_WPATH2FSPATH_PLAF_IMPL
 */
