/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright (c) 2005-2007 V.Sokur
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

/*
 * Sysconfig.h	(V.Sokur)
 * include/Bo/whereami/plaf/w32/Sysconfig.h
 *
 * $Id$
 */

/* ------------------------------------------------------------------------- */

/* @todo: fixme version (???) */
#undef _FILE_OFFSET_BITS
#define _FILE_OFFSET_BITS 64
#undef _LARGEFILE_SOURCE
#define _LARGEFILE_SOURCE
#undef _LARGEFILE64_SOURCE
#define _LARGEFILE64_SOURCE
#ifndef _INTEGRAL_MAX_BITS
# define _INTEGRAL_MAX_BITS 64
#endif

/* ------------------------------------------------------------------------- */
#pragma mark -
/* ------------------------------------------------------------------------- */

/* Path separator */
#ifndef BO_PATH_SEP
# define BO_PATH_SEP '\\'
# define _BO_PATH_SEP "\\"
#endif

/* Paths delimiter */
#ifndef BO_PATH_DELIM
# define BO_PATH_DELIM ';'
# define _BO_PATH_DELIM ";"
#endif

#ifndef __MYC_LIBC_HEADER
# define __MYC_LIBC_HEADER(aHeader) <aHeader>
#endif

//
// SYSTEM(compiler): headers
//

//#define has_sys7cdefs_h 1
//#define has_sys7param_h 1
//#define has_sys7syslimits_h 1
#define has_sys7types_h 1
//#define has_sys7bitstring_h 1
#define has_sys7stat_h 1
//#define has_sys7wait_h 1
//#define has_sys7time_h 1
#define has_time_h 1
//#define has_sys7ioctl_h 1
//#define has_sys7fcntl_h 1
#define has_fcntl_h 1
#define has_share_h 1
#define has_sys7locking_h 1
//#define has_paths_h 1
//#define has_sysexits_h 1
//#define has_unistd_h 1
#define has_windows_h 1
#define has_process_h 1
//#define has_dirent_h 1
//#define has_sys7dirent_h 1
#define has_direct_h 1
//#define has_dlfcn_h 1
//#define has_poll_h 1
//#define has_sys7select_h 1

#define has_stddef_h 1
#define has_stdio_h 1
#define has_stdlib_h 1
#define has_stdarg_h 1
#if (1800 <= _MSC_VER)
# define has_stdbool_h 1
# define has_inttypes_h 1
#endif
#if (1600 <= _MSC_VER)
# define has_stdint_h 1
#endif
//#define has_alloca_h 1
#define has_malloc_h 1
#define has_string_h 1
//#define has_strings_h 1
#define has_wchar_h 1
#define has_tchar_h 1
//#define has_sched_h 1
//#define has_int_fmtio_h 1

#define has_io_h 1
#define has_winsock2_h 1
#define has_ws2def_h 1
#define has_ws2tcpip_h 1
//#define has_sys7socket_h 1
//#define has_xti_h 1
//#define has_netinet7in_h 1
//#define has_arpa7inet_h 1
//#define has_netdb_h 1

//
// SYSTEM(compiler): types
//

#define __BO_SYSERRCODE_TYPE__ DWORD
#define BoGetposixerr() errno
#define BoGetsyserr() GetLastError()

//#define HAS_INO_TYPE
#define HAS__INO_TYPE
#define PRI_ino PRIu16
//#define HAS_MODE_TYPE
//#define HAS__MODE_TYPE
/* @todo: fixme version(?) */
//#define HAS_OFF_TYPE
#define HAS__OFF_TYPE
#define PRI_off PRIi32

/* @todo: version */
/* Process/Group/User ID */
//#define HAS_PID_TYPE
//#define HAS_GID_TYPE
//#define HAS_UID_TYPE
#define __BO_PID_TYPE__ DWORD
#define PRIpid PRIu32
#define __BO_GID_TYPE__ DWORD
#define PRIgid PRIu32
#define __BO_UID_TYPE__ DWORD
#define PRIuid PRIu32

#define HAS_TIME_TYPE
//#define HAS_SECONDS_TYPE
//#define HAS_SSECONDS_TYPE
//#define HAS_MSECONDS_TYPE
//#define HAS_SMSECONDS_TYPE
//#define HAS_USECONDS_TYPE
//#define HAS_SUSECONDS_TYPE
#if 1900 <= _MSC_VER
# define HAS_TIMESPEC_STRUC
#endif
//#define HAS_TIMEVAL_STRUC
//#define HAS_DIR_STRUC
//#define HAS_DIRENT_STRUC

#ifdef has_xti_h
# define HAS_T_SCALAR_TYPE
# define HAS_T_INFO_STRUC
# define HAS_NETBUF_STRUC
# define HAS_T_CALL_STRUC
# define HAS_T_BIND_STRUC
# define HAS_T_UNITDATA_STRUC
#endif

/* Socket support */
/* sys/socket.h */
#define HAS_SOCKLEN_TYPE
#define __BO_SOCKLEN_TYPE__ int
#define __BO_SOCKSYSOBJ_TYPE__ SOCKET
#define __BO_INVAL_SOCKSYSOBJ (INVALID_SOCKET)

/* Dynamic library support */
/* windows.h ? */
#define __BO_DLSYSOBJ_TYPE__ HMODULE
#define __BO_DLFUNC_TYPE__ FARPROC
#define __BO_DLVAR_TYPE__ FARPROC
#define __BO_INVAL_DLSYSOBJ ((HMODULE)0)


#if (BO_M_WORD == BO_M_WORD32)
# define __BO_REFC_TYPE__ /* volatile */ LONG
# define __BO_REFC_xTYPE__ LONG
# define __REFC_TYPE_MAX__ 0x3fffffff
# define __REFC_TYPE_MAX2__ 0x7fffffff
#else
#if (BO_M_WORD == BO_M_WORD64)
# define __BO_REFC_TYPE__ /* volatile */ int64_t
# define __BO_REFC_xTYPE__ int64_t
# define __REFC_TYPE_MAX__ 0x3fffffffffffffffLL
# define __REFC_TYPE_MAX2__ 0x7fffffffffffffffLL
#endif /* !(BO_M_WORD == BO_M_WORD64) */
#endif /* !(BO_M_WORD == BO_M_WORD32) */


#if (BO_M_WORD == BO_M_WORD32)
# define __BO_LLOCK_TYPE__ /* volatile */ DWORD
# define __BO_LLOCK_xTYPE__ LONG
#else
#if (BO_M_WORD == BO_M_WORD64)
# define __BO_LLOCK_TYPE__ /* volatile */ u_int64_t
# define __BO_LLOCK_xTYPE__ u_int64_t
#endif /* !(BO_M_WORD == BO_M_WORD64) */
#endif /* !(BO_M_WORD == BO_M_WORD32) */

//
// SYSTEM(compiler): functions
//

/*
 * [file-] stat interface
 * @{
 * 1. file type constants: S_IFMT, ... ; S_ISDIR, ...
 * 2. file mode constants: S_IRWXU, ...
 * 3. stat declarations: struct stat
 * 4. functions:
 *		chmod, fchmod
 *		stat, lstat, fstat
 *		umask
 *		mkdir, mkfifo [, mknod]
 */

/* <sys/stat.h> */

#define HAS__STAT_STRUC
#define HAS__STAT64_STRUC

#define HAS__STAT
#define HAS__STAT64

#define HAS__WSTAT
#define HAS__WSTAT64

//#define HAS__LSTAT
//#define HAS__LSTAT64
//#define HAS__WLSTAT
//#define HAS__WLSTAT64

#define HAS__FSTAT
#define HAS__FSTAT64

#define HAS__UMASK

/* <io.h> */
#define HAS__CHMOD
#define HAS__WCHMOD
//#define HAS__FCHMOD

#ifdef _WIN32_WINNT
# if (0x0600 <= _WIN32_WINNT)
#  define HAS_GetFileInformationByHandleEx
#  define HAS_SetFileInformationByHandle
# endif
#endif

/* <direct.h> */

#define HAS__MKDIR
#define HAS__WMKDIR
//#define HAS_MKFIFO
//#define HAS_WMKFIFO
//#define HAS_MKNOD
//#define HAS_WMKNOD
/* @} */

/*
 * file-control interface
 * @{
 * 1. open-only flags: O_RDONLY, ...; O_CREAT, ...
 * 2. copyfile flags: CPF_OVERWRITE, CPF_IGNORE_MODE
 * 3. fcntl command constants (and arguments/flags): F_DUPFD, ...
 * 4. file type constants [optional, <sys/stat.h>]
 * 5. file mode constants [optional, <sys/stat.h>]
 * 6. file ofset constants [optional, <unistd.h>]
 * 7. flock declarations: struct flock, lock operations
 * 8. functions:
 *		open, creat, dup, dup2
 *		fcntl
 *		flock
 */

/* <io.h>, <share.h>, <fcntl.h>, <sys/locking.h>, <wchar.h> */

//#define HAS_FLOCK_STRUC

#define HAS__OPEN
#define HAS__WOPEN
#define HAS__SOPEN
#define HAS__WSOPEN
#define HAS__CREAT
#define HAS__WCREAT
//#define HAS_FCNTL
#define HAS__LOCKING
#define HAS__DUP
#define HAS__DUP2
/* @} */

/*
 * low level I/O interface
 * @{
 * 1. functions:
 *		close
 *		read, write
 *		readv, writev
 *		lseek, tell
 */

/* <io.h> */
#define HAS__CLOSE
#define HAS__READ
#define HAS__WRITE

#define HAS__LSEEK
#define HAS__LSEEKi64
#ifdef _LARGEFILE64_SOURCE
# define OVERLOAD_LSEEK__LSEEKi64
#endif

#define HAS__TELL
#define HAS__TELLi64
#ifdef _LARGEFILE64_SOURCE
# define OVERLOAD_TELL__TELLi64
#endif

//#define HAS_IOVEC_STRUC
//#define HAS_PREAD
//#define HAS_PWRITE
//#define HAS_READV
//#define HAS_WRITEV
/* @} */

/*
 * dir-control interface
 * @{
 * 1. functions:
 *		unlink, rmdir, remove, rename,
 *		getcwd, getwd,
 *		chdir, fchdir
 */

/* <direct.h> */
#define HAS__RMDIR
#define HAS__WRMDIR
#define HAS__CHDIR
#define HAS__WCHDIR
//#define HAS__FCHDIR
#define HAS__GETCWD
#define HAS__WGETCWD

/* <io.h>, <stdio.h> */
#define HAS__UNLINK
#define HAS__WUNLINK
#define HAS_REMOVE
#define HAS__WREMOVE
#define HAS_RENAME
#define HAS__WRENAME
/* @} */

/*
 * process interface
 * @{
 * 1. functions:
 *		_exit, exit
 *		execl, execle, execlp, execv, execve, execvp
 *		fork, vfork
 *		nice
 *		getgid, getegid
 *		setgid, setregid, setegid [, setrgid]
 *		getpgid [, getpgrp]
 *		setpgid [, setpgrp]
 *		getuid, geteuid
 *		setuid, setreuid, seteuid [, setruid]
 *		getpid, getppid
 *		getsid, setsid
 */

/* <process.h>, <stdlib.h> */
#define HAS_EXIT
#define HAS__EXIT

/* <stdlib.h> */
#define HAS__ENVIRON
#define HAS__SYS_ERRLIST
#define HAS__SYS_NERR

/* <process.h> */
#define HAS__EXECL
#define HAS__EXECLE
#define HAS__EXECLP
#define HAS__EXECV
#define HAS__EXECVE
#define HAS__EXECVP
#define HAS__WEXECL
#define HAS__WEXECLE
#define HAS__WEXECLP
#define HAS__WEXECV
#define HAS__WEXECVE
#define HAS__WEXECVP

#define HAS__SPAWNL
#define HAS__SPAWNLP
#define HAS__SPAWNLE
#define HAS__SPAWNV
#define HAS__SPAWNVP
#define HAS__SPAWNVE
#define HAS__WSPAWNL
#define HAS__WSPAWNLP
#define HAS__WSPAWNLE
#define HAS__WSPAWNV
#define HAS__WSPAWNVP
#define HAS__WSPAWNVE

#define HAS__GETPID /* process ID of the current process */
/* @} */

/*
 * wait interface
 * @{
 * 1. functions:
 *		wait, waitpid, wait3, wait4
 */

//#define HAS_WAIT
//#define HAS_WAITPID
//#define HAS_WAIT3
//#define HAS_WAIT4
/* @} */

/* ------------------------------------------------------------------------- */

/*
 * standard I/O interface
 * @{
 */

/* <stdio.h> */

/*
 * string
 */

#define HAS__SNPRINTF_S
#define _SNPRINTF_S_OUTPUT_ALWAYS_NULL_TERMINATED
//#define _SNPRINTF_S_RETURNS_NCHARS_WOULD_HAVE_BEEN_PRINTED

#define HAS__SPRINTF_P
#define _SPRINTF_P_OUTPUT_ALWAYS_NULL_TERMINATED

//#define HAS_SNPRINTF
//#define SNPRINTF_OUTPUT_ALWAYS_NULL_TERMINATED
	/* The MS function snprintf does not really produce NULL
	   terminated output, but snprintf_s (sprintf_p) does. */
//#define SNPRINTF_RETURNS_NCHARS_WOULD_HAVE_BEEN_PRINTED
//#define OVERLOAD_SNPRINTF__SNPRINTF_S
#define OVERLOAD_SNPRINTF__SPRINTF_P

#define HAS__VSNPRINTF_S
#define _VSNPRINTF_S_OUTPUT_ALWAYS_NULL_TERMINATED
//#define _VSNPRINTF_S_RETURNS_NCHARS_WOULD_HAVE_BEEN_PRINTED

#define HAS__VSPRINTF_P
#define _VSPRINTF_P_OUTPUT_ALWAYS_NULL_TERMINATED

//#define HAS_VSNPRINTF
//#define VSNPRINTF_OUTPUT_ALWAYS_NULL_TERMINATED
	/* The MS function vsnprintf does not really produce NULL
	   terminated output, but vsnprintf_s (vsprintf_p) does. */
//#define VSNPRINTF_RETURNS_NCHARS_WOULD_HAVE_BEEN_PRINTED
//#define OVERLOAD_VSNPRINTF__VSNPRINTF_S
#define OVERLOAD_VSNPRINTF__VSPRINTF_P

#define HAS__SNWPRINTF_S
#define _SNWPRINTF_S_OUTPUT_ALWAYS_NULL_TERMINATED
//#define _SNWPRINTF_S_RETURNS_NCHARS_WOULD_HAVE_BEEN_PRINTED

#define HAS__SWPRINTF_P
#define _SWPRINTF_P_OUTPUT_ALWAYS_NULL_TERMINATED

//#define HAS_SWPRINTF
//#define OVERLOAD_SWPRINTF__SNWPRINTF_S
#define OVERLOAD_SWPRINTF__SWPRINTF_P

#define HAS__VSNWPRINTF_S
#define _VSNWPRINTF_S_OUTPUT_ALWAYS_NULL_TERMINATED
//#define _VSNWPRINTF_S_RETURNS_NCHARS_WOULD_HAVE_BEEN_PRINTED

#define HAS__VSWPRINTF_P
#define _VSWPRINTF_P_OUTPUT_ALWAYS_NULL_TERMINATED

//#define HAS_VSWPRINTF
//#define OVERLOAD_VSWPRINTF__VSNWPRINTF_S
#define OVERLOAD_VSWPRINTF__VSWPRINTF_P

//#define HAS_ASPRINTF
//#define HAS_VASPRINTF
//#define HAS_ASWPRINTF
//#define HAS_VASWPRINTF

#define HAS__SCPRINTF
#define HAS__VSCPRINTF
#define HAS__SCWPRINTF
#define HAS__VSCWPRINTF

/*
 * file
 */

//#define HAS_WFOPEN
#define HAS__WFOPEN
#ifdef _POSIX_
# define HAS_FDOPEN
#else
# define HAS__FDOPEN
#endif
#ifdef _POSIX_
# define HAS_FILENO
#else
# define HAS__FILENO
#endif

#define HAS_FWPRINTF
#define HAS_VFWPRINTF

#define HAS_FSEEK
#define HAS_FTELL
//#define HAS_FSEEKO
//#define HAS_FTELLO
#define HAS__FSEEKi64
#define HAS__FTELLi64
/* @} */

/*
 * malloc, alloca
 * @{
 */

/* <stdlib.h> */
#define STDLIB_HEADER_HAS_MALLOC_DECL

/* <malloc.h> */
#define MALLOC_HEADER_HAS_MALLOC_DECL

#define HAS_ALLOCA
/* <malloc.h> */
#define MALLOC_HEADER_HAS_ALLOCA_DECL
/* @} */

/*
 * stdlib
 * @{
 * 1. functions: exit, _Exit
 */

#define HAS_STRTOL
#define HAS_WCSTOL
/* @todo: fixme, version */
//#define HAS_STRTOLL
//#define HAS_WCSTOLL
#if (64 <= _INTEGRAL_MAX_BITS)
# define HAS__STRTOI64
# define HAS__WCSTOI64
#endif
#define HAS_STRTOD
#define HAS_WCSTOD
/* @} */

/*
 * string, memory operations
 * @{
 * <string.h>, <strings.h>, <extras.h>
 */

/* <string.h> */
#define HAS__STRDUP
#define HAS__WCSDUP

/* BSD: <strings.h>, MWERKS: <extras.h> */
#define HAS__STRICMP
//#define HAS_STRCASECMP
#define HAS__WCSICMP
#define HAS__STRNICMP
//#define HAS_STRNCASECMP
//#define HAS_BZERO
//#define HAS_BCMP
//#define HAS_BCOPY
/* @} */

/*
 * dirent
 * @{
 * <sys/dirent.h>, <dirent.h>
 */

//#define HAS_GETDIRENTRIES

//#define HAS_OPENDIR
//#define HAS_WOPENDIR
//#define HAS_OPENDIR_T
//#define HAS_WOPENDIR_T
//#define HAS_CLOSEDIR
//#define HAS_READDIR
//#define HAS_WREADDIR
//#define HAS_READDIR_R
//#define HAS_WREADDIR_R
//#define HAS_REWINDDIR
//#define HAS_SEEKDIR
//#define HAS_TELLDIR
//#define HAS_SCANDIR
//#define HAS_WSCANDIR
//#define HAS_ALPHASORT
//#define HAS_WALPHASORT
/* @} */

/*
 * time
 * @{
 */

/* <sys/time.h> */

//#define HAS_GETTIMEOFDAY
//#define HAS_NANOSLEEP ; nanoseconds

/* <time.h> */

//#define HAS_CTIME_R
#define HAS_CTIME_S
//#define HAS_GMTIME_R
#define HAS_GMTIME_S
//#define HAS_LOCALTIME_R
#define HAS_LOCALTIME_S
#define HAS_MKTIME
#define HAS__MKGMTIME
/* @} */

/*
 * unistd (windows)
 * @{
 * sys:
 * 1. posix version: _POSIX_VERSION, _POSIX2_VERSION
 * 2. access constants (access() function): F_OK, X_OK, W_OK, R_OK
 * 3. extended access constants [optional]
 * 4. file offset constants: SEEK_SET, SEEK_CUR, SEEK_END
 * 5. configurable pathname variables constants: _PC_LINK_MAX, ...
 * 6. configurable system string constants: _SC_PATH
 *
 * 7. Xopen version: _XOPEN_VERSION
 * 8. standard input/output/error file descriptor constants: STDIN_FILENO, STDOUT_FILENO, STDERR_FILENO
 * 9. constants for posix features support: _POSIX_ASYNCHRONOUS_IO, _POSIX_SHELL, _POSIX_THREADS, ...
 * 10. constants for Xopen features support: _XOPEN_CRYPT, ...
 * 11. lock constants
 * 12. configurable system variables constants: _SC_VERSION, _SC_PATH (???), _SC_ARG_MAX, ... _SC_XOPEN_SHM, ...
 * 13. functions:
 *		pathconf, fpathconf, sysconf
 *		gethostid, sethostid, gethostname, sethostname
 *		getlogin, setlogin, getlogin_r
 *		getgroups, setgroups
 *		ttyname, ttyname_r, isatty, ctermid; tcgetpgrp, tcsetpgrp
 *		chown, fchown, lchown
 *		access, link, symlink
 *		mkstemp, mktemp, pipe
 *		readlink
 *		sync [io]
 *		getopt
 *		sleep, usleep [time]
 *		alarm, ualarm, pause
 */

#define HAS_GETHOSTNAME

//#define HAS_SLEEP     ; seconds
#define HAS_Sleep_IN_MILLISECONDS /* <windows.h> */
//#define HAS_MSLEEP    ; milliseconds
//#define HAS_USLEEP    ; microseconds
/* @} */

/* <sys/ioctl.h> */
//#define HAS_IOCTL
#define HAS_IOCTLSOCKET

/*
 * netdb
 * @{
 * <netdb.h>, <ws2tcpip.h>
 */

#define HAS_GETADDRINFO
#define HAS_FREEADDRINFO

/* @} */

/*
 * THREAD
 * @{
 */

#define HAS_W32_THREAD
#define HAS_W32_CS /* critical section */
#define HAS_W32_CV /* condition variable */
#define HAS_W32_MUTEX
#define HAS_W32_EVENT
/* @} */

#define WCHAR_FSPATH_REPRESENTATION
//#define BO_FSPATH2WPATH_PLAF_IMPL
//#define BO_WPATH2FSPATH_PLAF_IMPL
