/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright 2016 Seenaptec Ltd. All rights reserved.
 * SEENAPTEC PROPRIETARY/CONFIDENTIAL.
 *
 * $Id$
 */

/*
 * Watershed.h	(V.Sokur)
 * Vipm/Analysis/Watershed.h
 */

/* ------------------------------------------------------------------------- */

#ifndef __VIPM_ANALYSIS_WATERSHED_H__
# define __VIPM_ANALYSIS_WATERSHED_H__

/******************************************************************************
 * %% BeginSection: includes
 */

# ifndef __VIPM_ANALYSIS_WATERSHED_ALGORITHM_H__
#  include <Vipm/Analysis/Watershed/Algorithm.h>
# endif
# ifndef __VIPM_ANALYSIS_WATERSHED_UTILS_H__
#  include <Vipm/Analysis/Watershed/Utils.h>
# endif


/******************************************************************************
 * %% BeginSection: function prototypes
 */

# include <Vipm/Linkage.h>
# define __PUB __myc_flinkage__(public,libVipm)
__MYC_BEGIN_CDECLS

__PUB bo_status_t
VipmWatershed(
# if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_array_t                    aSource,
	vipm_site_t const              *aRoiSrc,
	struct _Vipm_wtscontext        *aWtsctx
# endif
	);

/* @note: the function works correctly only with solid mask */
__PUB bo_status_t
VipmWatershedEx(
# if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_array_t                    aSource,
	vipm_array_t                    aMask,
	vipm_site_t const              *aRoiSrc,
	vipm_Npoint_t const            *aStartMsk,
	struct _Vipm_wtscontext        *aWtsctx
# endif
	);


__MYC_END_CDECLS
# undef __PUB


#endif /* !defined(__VIPM_ANALYSIS_WATERSHED_H__) */


/******************************************************************************
 *
 *
 *
 *****************************************************************************/
