/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright 2016 Seenaptec Ltd. All rights reserved.
 * SEENAPTEC PROPRIETARY/CONFIDENTIAL.
 *
 * $Id$
 */

/*
 * Fwtsresult.h	(V.Sokur)
 * Vipm/Analysis/Watershed/Fwtsresult.h
 */

/* ------------------------------------------------------------------------- */

#ifndef __VIPM_ANALYSIS_WATERSHED_FWTSRESULT_H__
# define __VIPM_ANALYSIS_WATERSHED_FWTSRESULT_H__

/******************************************************************************
 * %% BeginSection: includes
 */

# ifndef __VIPM_ANALYSIS_WATERSHED_TYPES_H__
#  include <Vipm/Analysis/Watershed/Types.h>
# endif

# ifndef __BO_MEMMAN_MEMSTG__
#  include <Bo/memman/Memstg.h>
# endif


/******************************************************************************
 * %% BeginSection: function prototypes
 */
# pragma mark -
# pragma mark [ function prototypes ]
# pragma mark -

# include <Vipm/Linkage.h>
# define __PUB __myc_flinkage__(public,libVipm)
# define __PROT __myc_flinkage__(public,libVipm)
# define __PRIV __myc_flinkage__(private,libVipm)
__MYC_BEGIN_CDECLS

/*
 * Assume, the fields ".wts_opxlstg", ".wts_mmstack"
 * are set to NULL or valid values.
 */
__PUB struct _Vipm_fwtsresult *
VipmFWTSRESinit(
#if __myc_require(prototypes)
	struct _Vipm_fwtsresult        *aThis,
	vipm_mutptr_t                   aPxlstg,
	vipm_rref_t                     aMemstg
#endif
	);

__PUB struct _Vipm_fwtsresult *
VipmFWTSRESfini(
#if __myc_require(prototypes)
	struct _Vipm_fwtsresult        *aThis
#endif
	);


__PUB struct _Vipm_fwtsregion *
VipmFWTSRESnewregion(
#if __myc_require(prototypes)
	struct _Vipm_fwtsresult        *aThis,
	bo_int32_t                      aPixLind,
	vipm_int                        aPixVal
#endif
	);

__PUB vipm_mutptr_t
VipmFWTSRESalloca(
#if __myc_require(prototypes)
	struct _Vipm_fwtsresult        *aThis,
	bo_size_t                       aBytec,
	bo_size_t                       Align
#endif
	);

/* ------------------------------------------------------------------------- */

__PROT void
VipmFWTSRES_freea(
#if __myc_require(prototypes)
	struct _Vipm_fwtsresult        *aThis,
	vipm_mutptr_t                   aPtr
#endif
	);


/* +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ */

/* @todo: fixme; @{ */
# define VipmFWTSRESalloca(r,n,a)   BoSMEMSTGaalloc((void *)(r)->wts_mmstack, n, ((a) ? (a) : __VIPM_BASE_ALIGN), NULL)
# define VipmFWTSRES_freea(r,p)     BoSMEMSTGfree((void *)(r)->wts_mmstack, p)
/* @} */


__MYC_END_CDECLS
# undef __PUB
# undef __PROT
# undef __PRIV


#endif /* !defined(__VIPM_ANALYSIS_WATERSHED_FWTSRESULT_H__) */


/******************************************************************************
 *
 *
 *
 *****************************************************************************/
