/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright 2016 Seenaptec Ltd. All rights reserved.
 * SEENAPTEC PROPRIETARY/CONFIDENTIAL.
 *
 * $Id$
 */

/*
 * TreeBuilder.h	(V.Sokur)
 * Vipm/Analysis/Watershed/TreeBuilder.h
 */

/* ------------------------------------------------------------------------- */

#ifndef __VIPM_ANALYSIS_WATERSHED_TREEBUILDER_H__
# define __VIPM_ANALYSIS_WATERSHED_TREEBUILDER_H__

/******************************************************************************
 * %% BeginSection: includes
 */

# ifndef __VIPM_ANALYSIS_WATERSHED_TYPES_H__
#  include <Vipm/Analysis/Watershed/Types.h>
# endif
# ifndef __VIPM_UTILS_STREE_BUILDER_H__
#  include <Vipm/Utils/STreeBuilder.h>
# endif


/******************************************************************************
 * %% BeginSection: type/constant declarations
 */

struct _Vipm_wtstreebuilder {
	struct _Vipm_streebuilder       wstb_base;
	vipm_wtslsrctx_t                wstb_lsrctx_buf;
};
typedef struct _Vipm_wtstreebuilder     vipm_wtstreebuilder_t;
# define vipm_wtstreebuilder_p(x)       vipm_wtstreebuilder_cp(x)
# define vipm_wtstreebuilder_cp(x)     ((struct _Vipm_wtstreebuilder const *)(x))
# define vipm_wtstreebuilder_mp(x)     ((struct _Vipm_wtstreebuilder *)(x))


/******************************************************************************
 * %% BeginSection: function prototypes
 */
# pragma mark -
# pragma mark [ function prototypes ]
# pragma mark -

# include <Vipm/Linkage.h>
# define __PUB __myc_flinkage__(public,libVipm)
# define __PROT __myc_flinkage__(public,libVipm)
# define __PRIV __myc_flinkage__(private,libVipm)
__MYC_BEGIN_CDECLS

__PUB void *
VipmWTSTBxinterface(
#if __myc_require(prototypes)
	void
#endif
	);

__PUB struct _Vipm_streebuilder *
VipmWTSTBopen(
#if __myc_require(prototypes)
	struct _Vipm_wtstreebuilder    *aBuilder,           /* = NULL */
	struct _Vipm_stree             *aXtrnTree,          /* = NULL */
	vipm_rref_t                     aXtrnMmstack,       /* = NULL */
	vipm_rref_t                     aParentMmstack      /* = NULL */
#endif
	);

__PUB struct _Vipm_streebuilder *
VipmWTSTBinit(
#if __myc_require(prototypes)
	struct _Vipm_wtstreebuilder    *aBuilder,           /* = NULL */
	struct _Vipm_stree             *aXtrnTree,          /* = NULL */
	vipm_rref_t                     aXtrnMmstack,       /* = NULL */
	vipm_rref_t                     aParentMmstack      /* = NULL */
#endif
	);

/* Specific init-part */
__PUB struct _Vipm_streebuilder *
__VipmWTSTBinit__(
#if __myc_require(prototypes)
	struct _Vipm_streebuilder      *aBuilder            /* != NULL */
#endif
	);

/* ------------------------------------------------------------------------- */

__PROT struct _Vipm_wtsregion *
__VipmWTSTBnewregion(
#if __myc_require(prototypes)
	struct _Vipm_wtsregion         *aMemory,
	struct _Vipm_streebuilder      *aBuilder,
	struct _Vipm_wtslsrctx         *aLsrctx
#endif
	);

__PROT struct _Vipm_streenode *
__VipmWTSTBnewregionNode(
#if __myc_require(prototypes)
	struct _Vipm_wtsregion         *aMemory,
	struct _Vipm_streebuilder      *aBuilder,
	struct _Vipm_wtslsrctx         *aLsrctx
#endif
	);

__PROT struct _Vipm_streenode *
__VipmWTSTBnewnodeWithRegion(
#if __myc_require(prototypes)
	struct _Vipm_streebuilder      *aBuilder,
	struct _Vipm_wtsregion         *aRegion
#endif
	);

/* ------------------------------------------------------------------------- */

__PROT void
__VipmWTSTBdisposergn(
#if __myc_require(prototypes)
	struct _Vipm_wtsregion         *aRegion,
	struct _Vipm_streebuilder      *aBuilder,
	struct _Vipm_wtslsrctx         *aLsrctx
#endif
	);

__PROT void
__VipmWTSTBdestroyrgn(
#if __myc_require(prototypes)
	struct _Vipm_wtsregion         *aRegion,
	struct _Vipm_streebuilder      *aBuilder,
	struct _Vipm_wtslsrctx         *aLsrctx
#endif
	);


__MYC_END_CDECLS
# undef __PUB
# undef __PROT
# undef __PRIV


#endif /* !defined(__VIPM_ANALYSIS_WATERSHED_TREEBUILDER_H__) */


/******************************************************************************
 *
 *
 *
 *****************************************************************************/
