/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright 2016 Seenaptec Ltd. All rights reserved.
 * SEENAPTEC PROPRIETARY/CONFIDENTIAL.
 *
 * $Id$
 */

/*
 * Utils.h	(V.Sokur)
 * Vipm/Analysis/Watershed/Utils.h
 */

/* ------------------------------------------------------------------------- */

#ifndef __VIPM_ANALYSIS_WATERSHED_UTILS_H__
# define __VIPM_ANALYSIS_WATERSHED_UTILS_H__

/******************************************************************************
 * %% BeginSection: includes
 */

# ifndef __VIPM_ANALYSIS_WATERSHED_TYPES_H__
#  include <Vipm/Analysis/Watershed/Types.h>
# endif

#if 0
# ifndef __VIPM_ANALYSIS_WATERSHED_FWTSREGION_H__
#  include <Vipm/Analysis/Watershed/Fwtsregion.h>
# endif
# ifndef __VIPM_ANALYSIS_WATERSHED_FWTSRESULT_H__
#  include <Vipm/Analysis/Watershed/Fwtsresult.h>
# endif
#endif


/******************************************************************************
 * %% BeginSection: function prototypes
 */
# pragma mark -
# pragma mark [ function prototypes ]
# pragma mark -

# include <Vipm/Linkage.h>
# define __PUB __myc_flinkage__(public,libVipm)
# define __PROT __myc_flinkage__(public,libVipm)
# define __PRIV __myc_flinkage__(private,libVipm)
__MYC_BEGIN_CDECLS

/*
 * Watershed listener-context
 */

__PUB struct _Vipm_wtslsrctx *
VipmWTSLSCinit(
#if __myc_require(prototypes)
	struct _Vipm_wtslsrctx         *aLsrctx,
	struct _Vipm_wtsfeature_ds     *aFeatdesList,
	vipm_int                        aNumFeatures,
	vipm_rank_t                     aRank,
	vipm_int const                  aVolume[],
	vipm_int const                  aStrideSrc[]
#endif
	);

__PUB struct _Vipm_wtslsrctx *
VipmWTSLSCsetimvol(
#if __myc_require(prototypes)
	struct _Vipm_wtslsrctx         *aLsrctx,
	vipm_rank_t                     aRank,
	vipm_int const                  aVolume[],
	vipm_int const                  aStrideSrc[]
#endif
	);

__PUB struct _Vipm_wtslsrctx *
VipmWTSLSCinit2D(
#if __myc_require(prototypes)
	struct _Vipm_wtslsrctx         *aLsrctx,
	struct _Vipm_wtsfeature_ds     *aFeatdesList,
	vipm_int                        aNumFeatures,
	vipm_int                        aHeight,
	vipm_int                        aWidth,
	vipm_int                        aYStride
#endif
	);

__PUB struct _Vipm_wtslsrctx *
VipmWTSLSCsetimvol2D(
#if __myc_require(prototypes)
	struct _Vipm_wtslsrctx         *aLsrctx,
	vipm_int                        aHeight,
	vipm_int                        aWidth,
	vipm_int                        aYStride
#endif
	);

__PUB struct _Vipm_wtslsrctx *
VipmWTSLSCfixup(
#if __myc_require(prototypes)
	struct _Vipm_wtslsrctx         *aLsrctx
#endif
	);


/* ========================================================================= */

/*
 * Watershed feature
 */

__PUB vipm_int
VipmWTSFindexByMagic(
#if __myc_require(prototypes)
	struct _Vipm_wtsfeature_ds     *aFeatdesList,
	vipm_int                        aNumFeatures,
	bo_uint32_t                     aFeatMagic
#endif
	);


__MYC_END_CDECLS
# undef __PUB
# undef __PROT
# undef __PRIV


#endif /* !defined(__VIPM_ANALYSIS_WATERSHED_UTILS_H__) */


/******************************************************************************
 *
 *
 *
 *****************************************************************************/
