/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright 2018 Seenaptec Ltd. All rights reserved.
 * SEENAPTEC PROPRIETARY/CONFIDENTIAL.
 *
 * $Id$
 */

/*
 * Algorithm.h	(D.Vinnyk)
 * Vipm/ArithLogic/Arithmetic/Algorithm.h
 */

/* ------------------------------------------------------------------------- */

#ifndef __VIPM_ARITHLOGIC_ARITHMETIC_ALGORITHM_H__
# define __VIPM_ARITHLOGIC_ARITHMETIC_ALGORITHM_H__

/******************************************************************************
 * %% BeginSection: includes
 */

# ifndef __VIPM_ARITHLOGIC_ARITHMETIC_TYPES_H__
#  include "Vipm/ArithLogic/Arithmetic/Types.h"
# endif


/******************************************************************************
 * %% BeginSection: function prototypes
 */
# pragma mark -
# pragma mark [ function prototypes ]
# pragma mark -

# include <Vipm/Linkage.h>
# define __PUB __myc_flinkage__(public,libVipm)
# define __PRIV __myc_flinkage__(private,libVipm)
__MYC_BEGIN_CDECLS

/*
 * Generic
 */

/*
 * ADD
 */

__PUB bo_status_t
VipmTGAadd(
#if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_rref_t                     aParm, /* (vipm_tga_arithparm_t *) */
	vipm_rank_t                     aRank,
	vipm_int const                  aVolume[],
	vipm_uint                       anElemTypeDst,
	vipm_mutptr_t                   aBaseDst,  vipm_int const aStartDst[], vipm_int const aStrideDst[],
	vipm_uint                       anElemTypeSrc1,
	vipm_imuptr_t                   aBaseSrc1, vipm_int const aStartSrc1[], vipm_int const aStrideSrc1[],
	vipm_uint                       anElemTypeSrc2,
	vipm_imuptr_t                   aBaseSrc2, vipm_int const aStartSrc2[], vipm_int const aStrideSrc2[]
#endif
	);

#if 0 /* @todo: fixme - add TGA pack functions for operations with scalar */
__PUB bo_status_t
VipmTGAaddC(
#if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_rref_t                     aParm, /* (vipm_tga_arithparm_t *) */
	vipm_rank_t                     aRank,
	vipm_int const                  aVolume[],
	vipm_uint                       anElemTypeDst,
	vipm_mutptr_t                   aBaseDst,  vipm_int const aStartDst[], vipm_int const aStrideDst[],
	vipm_uint                       anElemTypeSrc1,
	vipm_imuptr_t                   aBaseSrc1, vipm_int const aStartSrc1[], vipm_int const aStrideSrc1[],
	vipm_uint                       anElemTypeSrc2, /* unused, assumed scalar */
	vipm_imuptr_t                   aBaseSrc2,
	vipm_int const                  aStartSrc2[], vipm_int const aStrideSrc2[] /* both unused, assumed NULL */
#endif
	);
#endif /* if (0) */

__PUB bo_status_t
VipmTGAaddq(
#if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_rref_t                     aParm, /* (vipm_tga_arithparm_t *) */
	vipm_rank_t                     aRank,
	vipm_int const                  aVolume[],
	vipm_uint                       anElemTypeDst,
	vipm_mutptr_t                   aBaseDst,  vipm_int const aStartDst[], vipm_int const aStrideDst[],
	vipm_uint                       anElemTypeSrc1,
	vipm_imuptr_t                   aBaseSrc1, vipm_int const aStartSrc1[], vipm_int const aStrideSrc1[],
	vipm_uint                       anElemTypeSrc2,
	vipm_imuptr_t                   aBaseSrc2, vipm_int const aStartSrc2[], vipm_int const aStrideSrc2[]
#endif
	);

#if 0 /* @todo: fixme - add TGA pack functions for operations with scalar */
__PUB bo_status_t
VipmTGAaddqC(
#if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_rref_t                     aParm, /* (vipm_tga_arithparm_t *) */
	vipm_rank_t                     aRank,
	vipm_int const                  aVolume[],
	vipm_uint                       anElemTypeDst,
	vipm_mutptr_t                   aBaseDst,  vipm_int const aStartDst[], vipm_int const aStrideDst[],
	vipm_uint                       anElemTypeSrc1,
	vipm_imuptr_t                   aBaseSrc1, vipm_int const aStartSrc1[], vipm_int const aStrideSrc1[],
	vipm_uint                       anElemTypeSrc2, /* unused, assumed scalar */
	vipm_imuptr_t                   aBaseSrc2,
	vipm_int const                  aStartSrc2[], vipm_int const aStrideSrc2[] /* both unused, assumed NULL */
#endif
	);
#endif /* if (0) */

__PUB bo_status_t
VipmTGAaddsq(
#if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_rref_t                     aParm, /* (vipm_tga_arithparm_t *) */
	vipm_rank_t                     aRank,
	vipm_int const                  aVolume[],
	vipm_uint                       anElemTypeDst,
	vipm_mutptr_t                   aBaseDst,  vipm_int const aStartDst[], vipm_int const aStrideDst[],
	vipm_uint                       anElemTypeSrc1,
	vipm_imuptr_t                   aBaseSrc1, vipm_int const aStartSrc1[], vipm_int const aStrideSrc1[],
	vipm_uint                       anElemTypeSrc2,
	vipm_imuptr_t                   aBaseSrc2, vipm_int const aStartSrc2[], vipm_int const aStrideSrc2[]
#endif
	);

#if 0 /* @todo: fixme - add TGA pack functions for operations with scalar */
__PUB bo_status_t
VipmTGAaddsqC(
#if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_rref_t                     aParm, /* (vipm_tga_arithparm_t *) */
	vipm_rank_t                     aRank,
	vipm_int const                  aVolume[],
	vipm_uint                       anElemTypeDst,
	vipm_mutptr_t                   aBaseDst,  vipm_int const aStartDst[], vipm_int const aStrideDst[],
	vipm_uint                       anElemTypeSrc1,
	vipm_imuptr_t                   aBaseSrc1, vipm_int const aStartSrc1[], vipm_int const aStrideSrc1[],
	vipm_uint                       anElemTypeSrc2, /* unused, assumed scalar */
	vipm_imuptr_t                   aBaseSrc2,
	vipm_int const                  aStartSrc2[], vipm_int const aStrideSrc2[] /* both unused, assumed NULL */
#endif
	);
#endif /* if (0) */

/*
 * SUB
 */

__PUB bo_status_t
VipmTGAsub(
#if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_rref_t                     aParm, /* (vipm_tga_arithparm_t *) */
	vipm_rank_t                     aRank,
	vipm_int const                  aVolume[],
	vipm_uint                       anElemTypeDst,
	vipm_mutptr_t                   aBaseDst,  vipm_int const aStartDst[], vipm_int const aStrideDst[],
	vipm_uint                       anElemTypeSrc1,
	vipm_imuptr_t                   aBaseSrc1, vipm_int const aStartSrc1[], vipm_int const aStrideSrc1[],
	vipm_uint                       anElemTypeSrc2,
	vipm_imuptr_t                   aBaseSrc2, vipm_int const aStartSrc2[], vipm_int const aStrideSrc2[]
#endif
	);

#if 0 /* @todo: fixme - add TGA pack functions for operations with scalar */
__PUB bo_status_t
VipmTGAsubC(
#if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_rref_t                     aParm, /* (vipm_tga_arithparm_t *) */
	vipm_rank_t                     aRank,
	vipm_int const                  aVolume[],
	vipm_uint                       anElemTypeDst,
	vipm_mutptr_t                   aBaseDst,  vipm_int const aStartDst[], vipm_int const aStrideDst[],
	vipm_uint                       anElemTypeSrc1,
	vipm_imuptr_t                   aBaseSrc1, vipm_int const aStartSrc1[], vipm_int const aStrideSrc1[],
	vipm_uint                       anElemTypeSrc2, /* unused, assumed scalar */
	vipm_imuptr_t                   aBaseSrc2,
	vipm_int const                  aStartSrc2[], vipm_int const aStrideSrc2[] /* both unused, assumed NULL */
#endif
	);
#endif /* if (0) */

__PUB bo_status_t
VipmTGAsubq(
#if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_rref_t                     aParm, /* (vipm_tga_arithparm_t *) */
	vipm_rank_t                     aRank,
	vipm_int const                  aVolume[],
	vipm_uint                       anElemTypeDst,
	vipm_mutptr_t                   aBaseDst,  vipm_int const aStartDst[], vipm_int const aStrideDst[],
	vipm_uint                       anElemTypeSrc1,
	vipm_imuptr_t                   aBaseSrc1, vipm_int const aStartSrc1[], vipm_int const aStrideSrc1[],
	vipm_uint                       anElemTypeSrc2,
	vipm_imuptr_t                   aBaseSrc2, vipm_int const aStartSrc2[], vipm_int const aStrideSrc2[]
#endif
	);

#if 0 /* @todo: fixme - add TGA pack functions for operations with scalar */
__PUB bo_status_t
VipmTGAsubqC(
#if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_rref_t                     aParm, /* (vipm_tga_arithparm_t *) */
	vipm_rank_t                     aRank,
	vipm_int const                  aVolume[],
	vipm_uint                       anElemTypeDst,
	vipm_mutptr_t                   aBaseDst,  vipm_int const aStartDst[], vipm_int const aStrideDst[],
	vipm_uint                       anElemTypeSrc1,
	vipm_imuptr_t                   aBaseSrc1, vipm_int const aStartSrc1[], vipm_int const aStrideSrc1[],
	vipm_uint                       anElemTypeSrc2, /* unused, assumed scalar */
	vipm_imuptr_t                   aBaseSrc2,
	vipm_int const                  aStartSrc2[], vipm_int const aStrideSrc2[] /* both unused, assumed NULL */
#endif
	);
#endif /* if (0) */

__PUB bo_status_t
VipmTGAsubsq(
#if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_rref_t                     aParm, /* (vipm_tga_arithparm_t *) */
	vipm_rank_t                     aRank,
	vipm_int const                  aVolume[],
	vipm_uint                       anElemTypeDst,
	vipm_mutptr_t                   aBaseDst,  vipm_int const aStartDst[], vipm_int const aStrideDst[],
	vipm_uint                       anElemTypeSrc1,
	vipm_imuptr_t                   aBaseSrc1, vipm_int const aStartSrc1[], vipm_int const aStrideSrc1[],
	vipm_uint                       anElemTypeSrc2,
	vipm_imuptr_t                   aBaseSrc2, vipm_int const aStartSrc2[], vipm_int const aStrideSrc2[]
#endif
	);

#if 0 /* @todo: fixme - add TGA pack functions for operations with scalar */
__PUB bo_status_t
VipmTGAsubsqC(
#if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_rref_t                     aParm, /* (vipm_tga_arithparm_t *) */
	vipm_rank_t                     aRank,
	vipm_int const                  aVolume[],
	vipm_uint                       anElemTypeDst,
	vipm_mutptr_t                   aBaseDst,  vipm_int const aStartDst[], vipm_int const aStrideDst[],
	vipm_uint                       anElemTypeSrc1,
	vipm_imuptr_t                   aBaseSrc1, vipm_int const aStartSrc1[], vipm_int const aStrideSrc1[],
	vipm_uint                       anElemTypeSrc2, /* unused, assumed scalar */
	vipm_imuptr_t                   aBaseSrc2,
	vipm_int const                  aStartSrc2[], vipm_int const aStrideSrc2[] /* both unused, assumed NULL */
#endif
	);
#endif /* if (0) */

__PUB bo_status_t
VipmTGArsub(
#if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_rref_t                     aParm, /* (vipm_tga_arithparm_t *) */
	vipm_rank_t                     aRank,
	vipm_int const                  aVolume[],
	vipm_uint                       anElemTypeDst,
	vipm_mutptr_t                   aBaseDst,  vipm_int const aStartDst[], vipm_int const aStrideDst[],
	vipm_uint                       anElemTypeSrc1,
	vipm_imuptr_t                   aBaseSrc1, vipm_int const aStartSrc1[], vipm_int const aStrideSrc1[],
	vipm_uint                       anElemTypeSrc2,
	vipm_imuptr_t                   aBaseSrc2, vipm_int const aStartSrc2[], vipm_int const aStrideSrc2[]
#endif
	);

#if 0 /* @todo: fixme - add TGA pack functions for operations with scalar */
__PUB bo_status_t
VipmTGArsubC(
#if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_rref_t                     aParm, /* (vipm_tga_arithparm_t *) */
	vipm_rank_t                     aRank,
	vipm_int const                  aVolume[],
	vipm_uint                       anElemTypeDst,
	vipm_mutptr_t                   aBaseDst,  vipm_int const aStartDst[], vipm_int const aStrideDst[],
	vipm_uint                       anElemTypeSrc1,
	vipm_imuptr_t                   aBaseSrc1, vipm_int const aStartSrc1[], vipm_int const aStrideSrc1[],
	vipm_uint                       anElemTypeSrc2, /* unused, assumed scalar */
	vipm_imuptr_t                   aBaseSrc2,
	vipm_int const                  aStartSrc2[], vipm_int const aStrideSrc2[] /* both unused, assumed NULL */
#endif
	);
#endif /* if (0) */

__PUB bo_status_t
VipmTGArsubq(
#if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_rref_t                     aParm, /* (vipm_tga_arithparm_t *) */
	vipm_rank_t                     aRank,
	vipm_int const                  aVolume[],
	vipm_uint                       anElemTypeDst,
	vipm_mutptr_t                   aBaseDst,  vipm_int const aStartDst[], vipm_int const aStrideDst[],
	vipm_uint                       anElemTypeSrc1,
	vipm_imuptr_t                   aBaseSrc1, vipm_int const aStartSrc1[], vipm_int const aStrideSrc1[],
	vipm_uint                       anElemTypeSrc2,
	vipm_imuptr_t                   aBaseSrc2, vipm_int const aStartSrc2[], vipm_int const aStrideSrc2[]
#endif
	);

#if 0 /* @todo: fixme - add TGA pack functions for operations with scalar */
__PUB bo_status_t
VipmTGArsubqC(
#if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_rref_t                     aParm, /* (vipm_tga_arithparm_t *) */
	vipm_rank_t                     aRank,
	vipm_int const                  aVolume[],
	vipm_uint                       anElemTypeDst,
	vipm_mutptr_t                   aBaseDst,  vipm_int const aStartDst[], vipm_int const aStrideDst[],
	vipm_uint                       anElemTypeSrc1,
	vipm_imuptr_t                   aBaseSrc1, vipm_int const aStartSrc1[], vipm_int const aStrideSrc1[],
	vipm_uint                       anElemTypeSrc2, /* unused, assumed scalar */
	vipm_imuptr_t                   aBaseSrc2,
	vipm_int const                  aStartSrc2[], vipm_int const aStrideSrc2[] /* both unused, assumed NULL */
#endif
	);
#endif /* if (0) */

__PUB bo_status_t
VipmTGArsubsq(
#if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_rref_t                     aParm, /* (vipm_tga_arithparm_t *) */
	vipm_rank_t                     aRank,
	vipm_int const                  aVolume[],
	vipm_uint                       anElemTypeDst,
	vipm_mutptr_t                   aBaseDst,  vipm_int const aStartDst[], vipm_int const aStrideDst[],
	vipm_uint                       anElemTypeSrc1,
	vipm_imuptr_t                   aBaseSrc1, vipm_int const aStartSrc1[], vipm_int const aStrideSrc1[],
	vipm_uint                       anElemTypeSrc2,
	vipm_imuptr_t                   aBaseSrc2, vipm_int const aStartSrc2[], vipm_int const aStrideSrc2[]
#endif
	);

#if 0 /* @todo: fixme - add TGA pack functions for operations with scalar */
__PUB bo_status_t
VipmTGArsubsqC(
#if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_rref_t                     aParm, /* (vipm_tga_arithparm_t *) */
	vipm_rank_t                     aRank,
	vipm_int const                  aVolume[],
	vipm_uint                       anElemTypeDst,
	vipm_mutptr_t                   aBaseDst,  vipm_int const aStartDst[], vipm_int const aStrideDst[],
	vipm_uint                       anElemTypeSrc1,
	vipm_imuptr_t                   aBaseSrc1, vipm_int const aStartSrc1[], vipm_int const aStrideSrc1[],
	vipm_uint                       anElemTypeSrc2, /* unused, assumed scalar */
	vipm_imuptr_t                   aBaseSrc2,
	vipm_int const                  aStartSrc2[], vipm_int const aStrideSrc2[] /* both unused, assumed NULL */
#endif
	);
#endif /* if (0) */

/*
 * MUL
 */

__PUB bo_status_t
VipmTGAmul(
#if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_rref_t                     aParm, /* (vipm_tga_arithparm_t *) */
	vipm_rank_t                     aRank,
	vipm_int const                  aVolume[],
	vipm_uint                       anElemTypeDst,
	vipm_mutptr_t                   aBaseDst,  vipm_int const aStartDst[], vipm_int const aStrideDst[],
	vipm_uint                       anElemTypeSrc1,
	vipm_imuptr_t                   aBaseSrc1, vipm_int const aStartSrc1[], vipm_int const aStrideSrc1[],
	vipm_uint                       anElemTypeSrc2,
	vipm_imuptr_t                   aBaseSrc2, vipm_int const aStartSrc2[], vipm_int const aStrideSrc2[]
#endif
	);

#if 0 /* @todo: fixme - add TGA pack functions for operations with scalar */
__PUB bo_status_t
VipmTGAmulC(
#if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_rref_t                     aParm, /* (vipm_tga_arithparm_t *) */
	vipm_rank_t                     aRank,
	vipm_int const                  aVolume[],
	vipm_uint                       anElemTypeDst,
	vipm_mutptr_t                   aBaseDst,  vipm_int const aStartDst[], vipm_int const aStrideDst[],
	vipm_uint                       anElemTypeSrc1,
	vipm_imuptr_t                   aBaseSrc1, vipm_int const aStartSrc1[], vipm_int const aStrideSrc1[],
	vipm_uint                       anElemTypeSrc2, /* unused, assumed scalar */
	vipm_imuptr_t                   aBaseSrc2,
	vipm_int const                  aStartSrc2[], vipm_int const aStrideSrc2[] /* both unused, assumed NULL */
#endif
	);
#endif /* if (0) */

/*
 * DIV
 */

__PUB bo_status_t
VipmTGAdiv(
#if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_rref_t                     aParm, /* (vipm_tga_arithparm_t *) */
	vipm_rank_t                     aRank,
	vipm_int const                  aVolume[],
	vipm_uint                       anElemTypeDst,
	vipm_mutptr_t                   aBaseDst,  vipm_int const aStartDst[], vipm_int const aStrideDst[],
	vipm_uint                       anElemTypeSrc1,
	vipm_imuptr_t                   aBaseSrc1, vipm_int const aStartSrc1[], vipm_int const aStrideSrc1[],
	vipm_uint                       anElemTypeSrc2,
	vipm_imuptr_t                   aBaseSrc2, vipm_int const aStartSrc2[], vipm_int const aStrideSrc2[]
#endif
	);

#if 0 /* @todo: fixme - add TGA pack functions for operations with scalar */
__PUB bo_status_t
VipmTGAdivC(
#if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_rref_t                     aParm, /* (vipm_tga_arithparm_t *) */
	vipm_rank_t                     aRank,
	vipm_int const                  aVolume[],
	vipm_uint                       anElemTypeDst,
	vipm_mutptr_t                   aBaseDst,  vipm_int const aStartDst[], vipm_int const aStrideDst[],
	vipm_uint                       anElemTypeSrc1,
	vipm_imuptr_t                   aBaseSrc1, vipm_int const aStartSrc1[], vipm_int const aStrideSrc1[],
	vipm_uint                       anElemTypeSrc2, /* unused, assumed scalar */
	vipm_imuptr_t                   aBaseSrc2,
	vipm_int const                  aStartSrc2[], vipm_int const aStrideSrc2[] /* both unused, assumed NULL */
#endif
	);
#endif /* if (0) */

__PUB bo_status_t
VipmTGAdivr(
#if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_rref_t                     aParm, /* (vipm_tga_arithparm_t *) */
	vipm_rank_t                     aRank,
	vipm_int const                  aVolume[],
	vipm_uint                       anElemTypeDst,
	vipm_mutptr_t                   aBaseDst,  vipm_int const aStartDst[], vipm_int const aStrideDst[],
	vipm_uint                       anElemTypeSrc1,
	vipm_imuptr_t                   aBaseSrc1, vipm_int const aStartSrc1[], vipm_int const aStrideSrc1[],
	vipm_uint                       anElemTypeSrc2,
	vipm_imuptr_t                   aBaseSrc2, vipm_int const aStartSrc2[], vipm_int const aStrideSrc2[]
#endif
	);

#if 0 /* @todo: fixme - add TGA pack functions for operations with scalar */
__PUB bo_status_t
VipmTGAdivrC(
#if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_rref_t                     aParm, /* (vipm_tga_arithparm_t *) */
	vipm_rank_t                     aRank,
	vipm_int const                  aVolume[],
	vipm_uint                       anElemTypeDst,
	vipm_mutptr_t                   aBaseDst,  vipm_int const aStartDst[], vipm_int const aStrideDst[],
	vipm_uint                       anElemTypeSrc1,
	vipm_imuptr_t                   aBaseSrc1, vipm_int const aStartSrc1[], vipm_int const aStrideSrc1[],
	vipm_uint                       anElemTypeSrc2, /* unused, assumed scalar */
	vipm_imuptr_t                   aBaseSrc2,
	vipm_int const                  aStartSrc2[], vipm_int const aStrideSrc2[] /* both unused, assumed NULL */
#endif
	);
#endif /* if (0) */

__PUB bo_status_t
VipmTGArdiv(
#if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_rref_t                     aParm, /* (vipm_tga_arithparm_t *) */
	vipm_rank_t                     aRank,
	vipm_int const                  aVolume[],
	vipm_uint                       anElemTypeDst,
	vipm_mutptr_t                   aBaseDst,  vipm_int const aStartDst[], vipm_int const aStrideDst[],
	vipm_uint                       anElemTypeSrc1,
	vipm_imuptr_t                   aBaseSrc1, vipm_int const aStartSrc1[], vipm_int const aStrideSrc1[],
	vipm_uint                       anElemTypeSrc2,
	vipm_imuptr_t                   aBaseSrc2, vipm_int const aStartSrc2[], vipm_int const aStrideSrc2[]
#endif
	);

#if 0 /* @todo: fixme - add TGA pack functions for operations with scalar */
__PUB bo_status_t
VipmTGArdivC(
#if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_rref_t                     aParm, /* (vipm_tga_arithparm_t *) */
	vipm_rank_t                     aRank,
	vipm_int const                  aVolume[],
	vipm_uint                       anElemTypeDst,
	vipm_mutptr_t                   aBaseDst,  vipm_int const aStartDst[], vipm_int const aStrideDst[],
	vipm_uint                       anElemTypeSrc1,
	vipm_imuptr_t                   aBaseSrc1, vipm_int const aStartSrc1[], vipm_int const aStrideSrc1[],
	vipm_uint                       anElemTypeSrc2, /* unused, assumed scalar */
	vipm_imuptr_t                   aBaseSrc2,
	vipm_int const                  aStartSrc2[], vipm_int const aStrideSrc2[] /* both unused, assumed NULL */
#endif
	);
#endif /* if (0) */

__PUB bo_status_t
VipmTGArdivr(
#if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_rref_t                     aParm, /* (vipm_tga_arithparm_t *) */
	vipm_rank_t                     aRank,
	vipm_int const                  aVolume[],
	vipm_uint                       anElemTypeDst,
	vipm_mutptr_t                   aBaseDst,  vipm_int const aStartDst[], vipm_int const aStrideDst[],
	vipm_uint                       anElemTypeSrc1,
	vipm_imuptr_t                   aBaseSrc1, vipm_int const aStartSrc1[], vipm_int const aStrideSrc1[],
	vipm_uint                       anElemTypeSrc2,
	vipm_imuptr_t                   aBaseSrc2, vipm_int const aStartSrc2[], vipm_int const aStrideSrc2[]
#endif
	);

#if 0 /* @todo: fixme - add TGA pack functions for operations with scalar */
__PUB bo_status_t
VipmTGArdivrC(
#if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_rref_t                     aParm, /* (vipm_tga_arithparm_t *) */
	vipm_rank_t                     aRank,
	vipm_int const                  aVolume[],
	vipm_uint                       anElemTypeDst,
	vipm_mutptr_t                   aBaseDst,  vipm_int const aStartDst[], vipm_int const aStrideDst[],
	vipm_uint                       anElemTypeSrc1,
	vipm_imuptr_t                   aBaseSrc1, vipm_int const aStartSrc1[], vipm_int const aStrideSrc1[],
	vipm_uint                       anElemTypeSrc2, /* unused, assumed scalar */
	vipm_imuptr_t                   aBaseSrc2,
	vipm_int const                  aStartSrc2[], vipm_int const aStrideSrc2[] /* both unused, assumed NULL */
#endif
	);
#endif /* if (0) */

/*
 * MLA
 */

__PUB bo_status_t
VipmTGAmla(
#if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_rref_t                     aParm, /* (vipm_tga_arithparm_t *) */
	vipm_rank_t                     aRank,
	vipm_int const                  aVolume[],
	vipm_uint                       anElemTypeDst,
	vipm_mutptr_t                   aBaseDst,  vipm_int const aStartDst[], vipm_int const aStrideDst[],
	vipm_uint                       anElemTypeSrc1,
	vipm_imuptr_t                   aBaseSrc1, vipm_int const aStartSrc1[], vipm_int const aStrideSrc1[],
	vipm_uint                       anElemTypeSrc2,
	vipm_imuptr_t                   aBaseSrc2, vipm_int const aStartSrc2[], vipm_int const aStrideSrc2[],
	vipm_uint                       anElemTypeSrc3,
	vipm_imuptr_t                   aBaseSrc3, vipm_int const aStartSrc3[], vipm_int const aStrideSrc3[]
#endif
	);

#if 0 /* @todo: fixme - add TGA pack functions for operations with scalar */
__PUB bo_status_t
VipmTGAmlaC(
#if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_rref_t                     aParm, /* (vipm_tga_arithparm_t *) */
	vipm_rank_t                     aRank,
	vipm_int const                  aVolume[],
	vipm_uint                       anElemTypeDst,
	vipm_mutptr_t                   aBaseDst,  vipm_int const aStartDst[], vipm_int const aStrideDst[],
	vipm_uint                       anElemTypeSrc1,
	vipm_imuptr_t                   aBaseSrc1, vipm_int const aStartSrc1[], vipm_int const aStrideSrc1[],
	vipm_uint                       anElemTypeSrc2,
	vipm_imuptr_t                   aBaseSrc2, vipm_int const aStartSrc2[], vipm_int const aStrideSrc2[],
	vipm_uint                       anElemTypeSrc3, /* unused, assumed scalar */
	vipm_imuptr_t                   aBaseSrc3,
	vipm_int const                  aStartSrc3[], vipm_int const aStrideSrc3[] /* both unused, assumed NULL */
#endif
	);

__PUB bo_status_t
VipmTGAmlaCC(
#if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_rref_t                     aParm, /* (vipm_tga_arithparm_t *) */
	vipm_rank_t                     aRank,
	vipm_int const                  aVolume[],
	vipm_uint                       anElemTypeDst,
	vipm_mutptr_t                   aBaseDst,  vipm_int const aStartDst[], vipm_int const aStrideDst[],
	vipm_uint                       anElemTypeSrc1,
	vipm_imuptr_t                   aBaseSrc1, vipm_int const aStartSrc1[], vipm_int const aStrideSrc1[],
	vipm_uint                       anElemTypeSrc2, /* unused, assumed scalar */
	vipm_imuptr_t                   aBaseSrc2,
	vipm_int const                  aStartSrc2[], vipm_int const aStrideSrc2[], /* both unused, assumed NULL */
	vipm_uint                       anElemTypeSrc3, /* unused, assumed scalar */
	vipm_imuptr_t                   aBaseSrc3,
	vipm_int const                  aStartSrc3[], vipm_int const aStrideSrc3[] /* both unused, assumed NULL */
#endif
	);
#endif /* if (0) */

/*
 * MLS
 */

__PUB bo_status_t
VipmTGAmls(
#if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_rref_t                     aParm, /* (vipm_tga_arithparm_t *) */
	vipm_rank_t                     aRank,
	vipm_int const                  aVolume[],
	vipm_uint                       anElemTypeDst,
	vipm_mutptr_t                   aBaseDst,  vipm_int const aStartDst[], vipm_int const aStrideDst[],
	vipm_uint                       anElemTypeSrc1,
	vipm_imuptr_t                   aBaseSrc1, vipm_int const aStartSrc1[], vipm_int const aStrideSrc1[],
	vipm_uint                       anElemTypeSrc2,
	vipm_imuptr_t                   aBaseSrc2, vipm_int const aStartSrc2[], vipm_int const aStrideSrc2[],
	vipm_uint                       anElemTypeSrc3,
	vipm_imuptr_t                   aBaseSrc3, vipm_int const aStartSrc3[], vipm_int const aStrideSrc3[]
#endif
	);

#if 0 /* @todo: fixme - add TGA pack functions for operations with scalar */
__PUB bo_status_t
VipmTGAmlsC(
#if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_rref_t                     aParm, /* (vipm_tga_arithparm_t *) */
	vipm_rank_t                     aRank,
	vipm_int const                  aVolume[],
	vipm_uint                       anElemTypeDst,
	vipm_mutptr_t                   aBaseDst,  vipm_int const aStartDst[], vipm_int const aStrideDst[],
	vipm_uint                       anElemTypeSrc1,
	vipm_imuptr_t                   aBaseSrc1, vipm_int const aStartSrc1[], vipm_int const aStrideSrc1[],
	vipm_uint                       anElemTypeSrc2,
	vipm_imuptr_t                   aBaseSrc2, vipm_int const aStartSrc2[], vipm_int const aStrideSrc2[],
	vipm_uint                       anElemTypeSrc3, /* unused, assumed scalar */
	vipm_imuptr_t                   aBaseSrc3,
	vipm_int const                  aStartSrc3[], vipm_int const aStrideSrc3[] /* both unused, assumed NULL */
#endif
	);

__PUB bo_status_t
VipmTGAmlsCC(
#if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_rref_t                     aParm, /* (vipm_tga_arithparm_t *) */
	vipm_rank_t                     aRank,
	vipm_int const                  aVolume[],
	vipm_uint                       anElemTypeDst,
	vipm_mutptr_t                   aBaseDst,  vipm_int const aStartDst[], vipm_int const aStrideDst[],
	vipm_uint                       anElemTypeSrc1,
	vipm_imuptr_t                   aBaseSrc1, vipm_int const aStartSrc1[], vipm_int const aStrideSrc1[],
	vipm_uint                       anElemTypeSrc2, /* unused, assumed scalar */
	vipm_imuptr_t                   aBaseSrc2,
	vipm_int const                  aStartSrc2[], vipm_int const aStrideSrc2[], /* both unused, assumed NULL */
	vipm_uint                       anElemTypeSrc3, /* unused, assumed scalar */
	vipm_imuptr_t                   aBaseSrc3,
	vipm_int const                  aStartSrc3[], vipm_int const aStrideSrc3[] /* both unused, assumed NULL */
#endif
	);
#endif /* if (0) */

__PUB bo_status_t
VipmTGAmlrs(
#if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_rref_t                     aParm, /* (vipm_tga_arithparm_t *) */
	vipm_rank_t                     aRank,
	vipm_int const                  aVolume[],
	vipm_uint                       anElemTypeDst,
	vipm_mutptr_t                   aBaseDst,  vipm_int const aStartDst[], vipm_int const aStrideDst[],
	vipm_uint                       anElemTypeSrc1,
	vipm_imuptr_t                   aBaseSrc1, vipm_int const aStartSrc1[], vipm_int const aStrideSrc1[],
	vipm_uint                       anElemTypeSrc2,
	vipm_imuptr_t                   aBaseSrc2, vipm_int const aStartSrc2[], vipm_int const aStrideSrc2[],
	vipm_uint                       anElemTypeSrc3,
	vipm_imuptr_t                   aBaseSrc3, vipm_int const aStartSrc3[], vipm_int const aStrideSrc3[]
#endif
	);

#if 0 /* @todo: fixme - add TGA pack functions for operations with scalar */
__PUB bo_status_t
VipmTGAmlrsC(
#if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_rref_t                     aParm, /* (vipm_tga_arithparm_t *) */
	vipm_rank_t                     aRank,
	vipm_int const                  aVolume[],
	vipm_uint                       anElemTypeDst,
	vipm_mutptr_t                   aBaseDst,  vipm_int const aStartDst[], vipm_int const aStrideDst[],
	vipm_uint                       anElemTypeSrc1,
	vipm_imuptr_t                   aBaseSrc1, vipm_int const aStartSrc1[], vipm_int const aStrideSrc1[],
	vipm_uint                       anElemTypeSrc2,
	vipm_imuptr_t                   aBaseSrc2, vipm_int const aStartSrc2[], vipm_int const aStrideSrc2[],
	vipm_uint                       anElemTypeSrc3, /* unused, assumed scalar */
	vipm_imuptr_t                   aBaseSrc3,
	vipm_int const                  aStartSrc3[], vipm_int const aStrideSrc3[] /* both unused, assumed NULL */
#endif
	);

__PUB bo_status_t
VipmTGAmlrsCC(
#if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_rref_t                     aParm, /* (vipm_tga_arithparm_t *) */
	vipm_rank_t                     aRank,
	vipm_int const                  aVolume[],
	vipm_uint                       anElemTypeDst,
	vipm_mutptr_t                   aBaseDst,  vipm_int const aStartDst[], vipm_int const aStrideDst[],
	vipm_uint                       anElemTypeSrc1,
	vipm_imuptr_t                   aBaseSrc1, vipm_int const aStartSrc1[], vipm_int const aStrideSrc1[],
	vipm_uint                       anElemTypeSrc2, /* unused, assumed scalar */
	vipm_imuptr_t                   aBaseSrc2,
	vipm_int const                  aStartSrc2[], vipm_int const aStrideSrc2[], /* both unused, assumed NULL */
	vipm_uint                       anElemTypeSrc3, /* unused, assumed scalar */
	vipm_imuptr_t                   aBaseSrc3,
	vipm_int const                  aStartSrc3[], vipm_int const aStrideSrc3[] /* both unused, assumed NULL */
#endif
	);
#endif /* if (0) */

/*
 * MATMUL
 */

#if 0 /* @todo: fixme - add TGA pack functions for matmul */
__PUB bo_status_t
VipmTGAmulmm(
#if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_rref_t                     aParm, /* (vipm_tga_arithparm_t *) */
	vipm_rank_t                     aRank,
	vipm_int const                  aVolume[],
	vipm_uint                       anElemTypeDst,
	vipm_mutptr_t                   aBaseDst,  vipm_int const aStartDst[], vipm_int const aStrideDst[],
	vipm_uint                       anElemTypeSrc1,
	vipm_imuptr_t                   aBaseSrc1, vipm_int const aStartSrc1[], vipm_int const aStrideSrc1[],
	vipm_uint                       anElemTypeSrc2,
	vipm_imuptr_t                   aBaseSrc2, vipm_int const aStartSrc2[], vipm_int const aStrideSrc2[]
#endif
	);

__PUB bo_status_t
VipmTGAmulmv(
#if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_rref_t                     aParm, /* (vipm_tga_arithparm_t *) */
	vipm_rank_t                     aRank,
	vipm_int const                  aVolume[],
	vipm_uint                       anElemTypeDst,
	vipm_mutptr_t                   aBaseDst,  vipm_int const aStartDst[], vipm_int const aStrideDst[],
	vipm_uint                       anElemTypeSrc1,
	vipm_imuptr_t                   aBaseSrc1, vipm_int const aStartSrc1[], vipm_int const aStrideSrc1[],
	vipm_uint                       anElemTypeSrc2,
	vipm_imuptr_t                   aBaseSrc2, vipm_int const aStartSrc2[], vipm_int const aStrideSrc2[]
#endif
	);

__PUB bo_status_t
VipmTGAmulmvn(
#if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_rref_t                     aParm, /* (vipm_tga_arithparm_t *) */
	vipm_rank_t                     aRank,
	vipm_int const                  aVolume[],
	vipm_uint                       anElemTypeDst,
	vipm_mutptr_t                   aBaseDst,  vipm_int const aStartDst[], vipm_int const aStrideDst[],
	vipm_uint                       anElemTypeSrc1,
	vipm_imuptr_t                   aBaseSrc1, vipm_int const aStartSrc1[], vipm_int const aStrideSrc1[],
	vipm_uint                       anElemTypeSrc2,
	vipm_imuptr_t                   aBaseSrc2, vipm_int const aStartSrc2[], vipm_int const aStrideSrc2[]
#endif
	);
#endif /* if (0) */

/*
 * NEG
 */

__PUB bo_status_t
VipmTGAneg(
#if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_rref_t                     aParm, /* (vipm_tga_arithparm_t *) */
	vipm_rank_t                     aRank,
	vipm_int const                  aVolume[],
	vipm_uint                       anElemTypeDst,
	vipm_mutptr_t                   aBaseDst,  vipm_int const aStartDst[], vipm_int const aStrideDst[],
	vipm_uint                       anElemTypeSrc,
	vipm_imuptr_t                   aBaseSrc, vipm_int const aStartSrc[], vipm_int const aStrideSrc[]
#endif
	);

__PUB bo_status_t
VipmTGAnegq(
#if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_rref_t                     aParm, /* (vipm_tga_arithparm_t *) */
	vipm_rank_t                     aRank,
	vipm_int const                  aVolume[],
	vipm_uint                       anElemTypeDst,
	vipm_mutptr_t                   aBaseDst,  vipm_int const aStartDst[], vipm_int const aStrideDst[],
	vipm_uint                       anElemTypeSrc,
	vipm_imuptr_t                   aBaseSrc, vipm_int const aStartSrc[], vipm_int const aStrideSrc[]
#endif
	);

/*
 * EXP
 */

__PUB bo_status_t
VipmTGAexp(
#if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_rref_t                     aParm, /* (vipm_tga_arithparm_t *) */
	vipm_rank_t                     aRank,
	vipm_int const                  aVolume[],
	vipm_uint                       anElemTypeDst,
	vipm_mutptr_t                   aBaseDst,  vipm_int const aStartDst[], vipm_int const aStrideDst[],
	vipm_uint                       anElemTypeSrc,
	vipm_imuptr_t                   aBaseSrc, vipm_int const aStartSrc[], vipm_int const aStrideSrc[]
#endif
	);

/*
 * SIGMOID
 */

__PUB bo_status_t
VipmTGAsigmoidalpha(
#if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_rref_t                     aParm, /* (vipm_tga_arithparm_t *) */
	vipm_rank_t                     aRank,
	vipm_int const                  aVolume[],
	vipm_uint                       anElemTypeDst,
	vipm_mutptr_t                   aBaseDst,  vipm_int const aStartDst[], vipm_int const aStrideDst[],
	vipm_uint                       anElemTypeSrc,
	vipm_imuptr_t                   aBaseSrc, vipm_int const aStartSrc[], vipm_int const aStrideSrc[]
#endif
	);

/*
 * LN
 */

__PUB bo_status_t
VipmTGAln(
#if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_rref_t                     aParm, /* (vipm_tga_arithparm_t *) */
	vipm_rank_t                     aRank,
	vipm_int const                  aVolume[],
	vipm_uint                       anElemTypeDst,
	vipm_mutptr_t                   aBaseDst,  vipm_int const aStartDst[], vipm_int const aStrideDst[],
	vipm_uint                       anElemTypeSrc,
	vipm_imuptr_t                   aBaseSrc, vipm_int const aStartSrc[], vipm_int const aStrideSrc[]
#endif
	);


/* ========================================================================= */

/*
 * ADD
 *
 * add: r[i] = (a[i] + b[i]) * (2**f)
 * addq{int}: saturate(round(scale(add)))
 * addsq: addq with signed result
 */

__PUB bo_status_t
vipma_add(
#if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_rank_t                     aRank,
	vipm_int const                  aVolume[],
	vipm_uint                       anElemTypeDst,
	vipm_mutptr_t                   aBaseDst,  vipm_int const aStartDst[], vipm_int const aStrideDst[],
	vipm_uint                       anElemTypeSrc1,
	vipm_imuptr_t                   aBaseSrc1, vipm_int const aStartSrc1[], vipm_int const aStrideSrc1[],
	vipm_uint                       anElemTypeSrc2,
	vipm_imuptr_t                   aBaseSrc2, vipm_int const aStartSrc2[], vipm_int const aStrideSrc2[],
	/* Useful for integer types */
	vipm_int                        aScaleFactor, vipm_int aRoundMode
#endif
	);

__PUB bo_status_t
vipma_addC(
#if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_rank_t                     aRank,
	vipm_int const                  aVolume[],
	vipm_uint                       anElemTypeDst,
	vipm_mutptr_t                   aBaseDst,  vipm_int const aStartDst[], vipm_int const aStrideDst[],
	vipm_uint                       anElemTypeSrc1,
	vipm_imuptr_t                   aBaseSrc1, vipm_int const aStartSrc1[], vipm_int const aStrideSrc1[],
	vipm_imuptr_t                   aSrc2,
	/* Useful for integer types */
	vipm_int                        aScaleFactor, vipm_int aRoundMode
#endif
	);

__PUB bo_status_t
vipma_addq(
#if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_rank_t                     aRank,
	vipm_int const                  aVolume[],
	vipm_uint                       anElemTypeDst,
	vipm_mutptr_t                   aBaseDst,  vipm_int const aStartDst[], vipm_int const aStrideDst[],
	vipm_uint                       anElemTypeSrc1,
	vipm_imuptr_t                   aBaseSrc1, vipm_int const aStartSrc1[], vipm_int const aStrideSrc1[],
	vipm_uint                       anElemTypeSrc2,
	vipm_imuptr_t                   aBaseSrc2, vipm_int const aStartSrc2[], vipm_int const aStrideSrc2[],
	/* Useful for integer types */
	vipm_int                        aScaleFactor, vipm_int aRoundMode
#endif
	);

__PUB bo_status_t
vipma_addqC(
#if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_rank_t                     aRank,
	vipm_int const                  aVolume[],
	vipm_uint                       anElemTypeDst,
	vipm_mutptr_t                   aBaseDst,  vipm_int const aStartDst[], vipm_int const aStrideDst[],
	vipm_uint                       anElemTypeSrc1,
	vipm_imuptr_t                   aBaseSrc1, vipm_int const aStartSrc1[], vipm_int const aStrideSrc1[],
	vipm_imuptr_t                   aSrc2,
	/* Useful for integer types */
	vipm_int                        aScaleFactor, vipm_int aRoundMode
#endif
	);

__PUB bo_status_t
vipma_addsq(
#if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_rank_t                     aRank,
	vipm_int const                  aVolume[],
	vipm_uint                       anElemTypeDst,
	vipm_mutptr_t                   aBaseDst,  vipm_int const aStartDst[], vipm_int const aStrideDst[],
	vipm_uint                       anElemTypeSrc1,
	vipm_imuptr_t                   aBaseSrc1, vipm_int const aStartSrc1[], vipm_int const aStrideSrc1[],
	vipm_uint                       anElemTypeSrc2,
	vipm_imuptr_t                   aBaseSrc2, vipm_int const aStartSrc2[], vipm_int const aStrideSrc2[],
	/* Useful for integer types */
	vipm_int                        aScaleFactor, vipm_int aRoundMode
#endif
	);

__PUB bo_status_t
vipma_addsqC(
#if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_rank_t                     aRank,
	vipm_int const                  aVolume[],
	vipm_uint                       anElemTypeDst,
	vipm_mutptr_t                   aBaseDst,  vipm_int const aStartDst[], vipm_int const aStrideDst[],
	vipm_uint                       anElemTypeSrc1,
	vipm_imuptr_t                   aBaseSrc1, vipm_int const aStartSrc1[], vipm_int const aStrideSrc1[],
	vipm_imuptr_t                   aSrc2,
	/* Useful for integer types */
	vipm_int                        aScaleFactor, vipm_int aRoundMode
#endif
	);

/*
 * SUB
 *
 * sub : r[i] = (a[i] + b[i]) * (2**f)
 * rsub: r[i] = (b[i] - a[i]) * (2**f)
 * {r}subq{int}: saturate(round(scale({r}sub)))
 * {r}subsq: {r}subq with signed result
 */

__PUB bo_status_t
vipma_sub(
#if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_rank_t                     aRank,
	vipm_int const                  aVolume[],
	vipm_uint                       anElemTypeDst,
	vipm_mutptr_t                   aBaseDst,  vipm_int const aStartDst[], vipm_int const aStrideDst[],
	vipm_uint                       anElemTypeSrc1,
	vipm_imuptr_t                   aBaseSrc1, vipm_int const aStartSrc1[], vipm_int const aStrideSrc1[],
	vipm_uint                       anElemTypeSrc2,
	vipm_imuptr_t                   aBaseSrc2, vipm_int const aStartSrc2[], vipm_int const aStrideSrc2[],
	/* Useful for integer types */
	vipm_int                        aScaleFactor, vipm_int aRoundMode
#endif
	);

__PUB bo_status_t
vipma_subC(
#if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_rank_t                     aRank,
	vipm_int const                  aVolume[],
	vipm_uint                       anElemTypeDst,
	vipm_mutptr_t                   aBaseDst,  vipm_int const aStartDst[], vipm_int const aStrideDst[],
	vipm_uint                       anElemTypeSrc1,
	vipm_imuptr_t                   aBaseSrc1, vipm_int const aStartSrc1[], vipm_int const aStrideSrc1[],
	vipm_imuptr_t                   aSrc2,
	/* Useful for integer types */
	vipm_int                        aScaleFactor, vipm_int aRoundMode
#endif
	);

__PUB bo_status_t
vipma_subq(
#if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_rank_t                     aRank,
	vipm_int const                  aVolume[],
	vipm_uint                       anElemTypeDst,
	vipm_mutptr_t                   aBaseDst,  vipm_int const aStartDst[], vipm_int const aStrideDst[],
	vipm_uint                       anElemTypeSrc1,
	vipm_imuptr_t                   aBaseSrc1, vipm_int const aStartSrc1[], vipm_int const aStrideSrc1[],
	vipm_uint                       anElemTypeSrc2,
	vipm_imuptr_t                   aBaseSrc2, vipm_int const aStartSrc2[], vipm_int const aStrideSrc2[],
	/* Useful for integer types */
	vipm_int                        aScaleFactor, vipm_int aRoundMode
#endif
	);

__PUB bo_status_t
vipma_subqC(
#if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_rank_t                     aRank,
	vipm_int const                  aVolume[],
	vipm_uint                       anElemTypeDst,
	vipm_mutptr_t                   aBaseDst,  vipm_int const aStartDst[], vipm_int const aStrideDst[],
	vipm_uint                       anElemTypeSrc1,
	vipm_imuptr_t                   aBaseSrc1, vipm_int const aStartSrc1[], vipm_int const aStrideSrc1[],
	vipm_imuptr_t                   aSrc2,
	/* Useful for integer types */
	vipm_int                        aScaleFactor, vipm_int aRoundMode
#endif
	);

__PUB bo_status_t
vipma_subsq(
#if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_rank_t                     aRank,
	vipm_int const                  aVolume[],
	vipm_uint                       anElemTypeDst,
	vipm_mutptr_t                   aBaseDst,  vipm_int const aStartDst[], vipm_int const aStrideDst[],
	vipm_uint                       anElemTypeSrc1,
	vipm_imuptr_t                   aBaseSrc1, vipm_int const aStartSrc1[], vipm_int const aStrideSrc1[],
	vipm_uint                       anElemTypeSrc2,
	vipm_imuptr_t                   aBaseSrc2, vipm_int const aStartSrc2[], vipm_int const aStrideSrc2[],
	/* Useful for integer types */
	vipm_int                        aScaleFactor, vipm_int aRoundMode
#endif
	);

__PUB bo_status_t
vipma_subsqC(
#if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_rank_t                     aRank,
	vipm_int const                  aVolume[],
	vipm_uint                       anElemTypeDst,
	vipm_mutptr_t                   aBaseDst,  vipm_int const aStartDst[], vipm_int const aStrideDst[],
	vipm_uint                       anElemTypeSrc1,
	vipm_imuptr_t                   aBaseSrc1, vipm_int const aStartSrc1[], vipm_int const aStrideSrc1[],
	vipm_imuptr_t                   aSrc2,
	/* Useful for integer types */
	vipm_int                        aScaleFactor, vipm_int aRoundMode
#endif
	);

__PUB bo_status_t
vipma_rsub(
#if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_rank_t                     aRank,
	vipm_int const                  aVolume[],
	vipm_uint                       anElemTypeDst,
	vipm_mutptr_t                   aBaseDst,  vipm_int const aStartDst[], vipm_int const aStrideDst[],
	vipm_uint                       anElemTypeSrc1,
	vipm_imuptr_t                   aBaseSrc1, vipm_int const aStartSrc1[], vipm_int const aStrideSrc1[],
	vipm_uint                       anElemTypeSrc2,
	vipm_imuptr_t                   aBaseSrc2, vipm_int const aStartSrc2[], vipm_int const aStrideSrc2[],
	/* Useful for integer types */
	vipm_int                        aScaleFactor, vipm_int aRoundMode
#endif
	);

__PUB bo_status_t
vipma_rsubC(
#if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_rank_t                     aRank,
	vipm_int const                  aVolume[],
	vipm_uint                       anElemTypeDst,
	vipm_mutptr_t                   aBaseDst,  vipm_int const aStartDst[], vipm_int const aStrideDst[],
	vipm_uint                       anElemTypeSrc1,
	vipm_imuptr_t                   aBaseSrc1, vipm_int const aStartSrc1[], vipm_int const aStrideSrc1[],
	vipm_imuptr_t                   aSrc2,
	/* Useful for integer types */
	vipm_int                        aScaleFactor, vipm_int aRoundMode
#endif
	);

__PUB bo_status_t
vipma_rsubq(
#if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_rank_t                     aRank,
	vipm_int const                  aVolume[],
	vipm_uint                       anElemTypeDst,
	vipm_mutptr_t                   aBaseDst,  vipm_int const aStartDst[], vipm_int const aStrideDst[],
	vipm_uint                       anElemTypeSrc1,
	vipm_imuptr_t                   aBaseSrc1, vipm_int const aStartSrc1[], vipm_int const aStrideSrc1[],
	vipm_uint                       anElemTypeSrc2,
	vipm_imuptr_t                   aBaseSrc2, vipm_int const aStartSrc2[], vipm_int const aStrideSrc2[],
	/* Useful for integer types */
	vipm_int                        aScaleFactor, vipm_int aRoundMode
#endif
	);

__PUB bo_status_t
vipma_rsubqC(
#if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_rank_t                     aRank,
	vipm_int const                  aVolume[],
	vipm_uint                       anElemTypeDst,
	vipm_mutptr_t                   aBaseDst,  vipm_int const aStartDst[], vipm_int const aStrideDst[],
	vipm_uint                       anElemTypeSrc1,
	vipm_imuptr_t                   aBaseSrc1, vipm_int const aStartSrc1[], vipm_int const aStrideSrc1[],
	vipm_imuptr_t                   aSrc2,
	/* Useful for integer types */
	vipm_int                        aScaleFactor, vipm_int aRoundMode
#endif
	);

__PUB bo_status_t
vipma_rsubsq(
#if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_rank_t                     aRank,
	vipm_int const                  aVolume[],
	vipm_uint                       anElemTypeDst,
	vipm_mutptr_t                   aBaseDst,  vipm_int const aStartDst[], vipm_int const aStrideDst[],
	vipm_uint                       anElemTypeSrc1,
	vipm_imuptr_t                   aBaseSrc1, vipm_int const aStartSrc1[], vipm_int const aStrideSrc1[],
	vipm_uint                       anElemTypeSrc2,
	vipm_imuptr_t                   aBaseSrc2, vipm_int const aStartSrc2[], vipm_int const aStrideSrc2[],
	/* Useful for integer types */
	vipm_int                        aScaleFactor, vipm_int aRoundMode
#endif
	);

__PUB bo_status_t
vipma_rsubsqC(
#if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_rank_t                     aRank,
	vipm_int const                  aVolume[],
	vipm_uint                       anElemTypeDst,
	vipm_mutptr_t                   aBaseDst,  vipm_int const aStartDst[], vipm_int const aStrideDst[],
	vipm_uint                       anElemTypeSrc1,
	vipm_imuptr_t                   aBaseSrc1, vipm_int const aStartSrc1[], vipm_int const aStrideSrc1[],
	vipm_imuptr_t                   aSrc2,
	/* Useful for integer types */
	vipm_int                        aScaleFactor, vipm_int aRoundMode
#endif
	);

/*
 * MUL
 *
 * mul: r[i] = (a[i] * b[i]) * (2**f)
 * mul{int}: saturate(round(scale(mul)))
 */

__PUB bo_status_t
vipma_mul(
#if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_rank_t                     aRank,
	vipm_int const                  aVolume[],
	vipm_uint                       anElemTypeDst,
	vipm_mutptr_t                   aBaseDst,  vipm_int const aStartDst[], vipm_int const aStrideDst[],
	vipm_uint                       anElemTypeSrc1,
	vipm_imuptr_t                   aBaseSrc1, vipm_int const aStartSrc1[], vipm_int const aStrideSrc1[],
	vipm_uint                       anElemTypeSrc2,
	vipm_imuptr_t                   aBaseSrc2, vipm_int const aStartSrc2[], vipm_int const aStrideSrc2[],
	/* Useful for integer types */
	vipm_int                        aScaleFactor, vipm_int aRoundMode
#endif
	);

__PUB bo_status_t
vipma_mulC(
#if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_rank_t                     aRank,
	vipm_int const                  aVolume[],
	vipm_uint                       anElemTypeDst,
	vipm_mutptr_t                   aBaseDst,  vipm_int const aStartDst[], vipm_int const aStrideDst[],
	vipm_uint                       anElemTypeSrc1,
	vipm_imuptr_t                   aBaseSrc1, vipm_int const aStartSrc1[], vipm_int const aStrideSrc1[],
	vipm_imuptr_t                   aSrc2,
	/* Useful for integer types */
	vipm_int                        aScaleFactor, vipm_int aRoundMode
#endif
	);

/*
 * DIV
 *
 * div : r[i] = (a[i] / b[i]) * (2**f)
 * rdiv: r[i] = (b[i] / a[i]) * (2**f)
 * {r}div{int} : saturate(round(scale(int-div)))
 * {r}divr{int}: saturate(round(scale(float-div)))
 */

__PUB bo_status_t
vipma_div(
#if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_rank_t                     aRank,
	vipm_int const                  aVolume[],
	vipm_uint                       anElemTypeDst,
	vipm_mutptr_t                   aBaseDst,  vipm_int const aStartDst[], vipm_int const aStrideDst[],
	vipm_uint                       anElemTypeSrc1,
	vipm_imuptr_t                   aBaseSrc1, vipm_int const aStartSrc1[], vipm_int const aStrideSrc1[],
	vipm_uint                       anElemTypeSrc2,
	vipm_imuptr_t                   aBaseSrc2, vipm_int const aStartSrc2[], vipm_int const aStrideSrc2[],
	/* Useful for integer types */
	vipm_int                        aScaleFactor, vipm_int aRoundMode
#endif
	);

__PUB bo_status_t
vipma_divC(
#if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_rank_t                     aRank,
	vipm_int const                  aVolume[],
	vipm_uint                       anElemTypeDst,
	vipm_mutptr_t                   aBaseDst,  vipm_int const aStartDst[], vipm_int const aStrideDst[],
	vipm_uint                       anElemTypeSrc1,
	vipm_imuptr_t                   aBaseSrc1, vipm_int const aStartSrc1[], vipm_int const aStrideSrc1[],
	vipm_imuptr_t                   aSrc2,
	/* Useful for integer types */
	vipm_int                        aScaleFactor, vipm_int aRoundMode
#endif
	);

__PUB bo_status_t
vipma_divr(
#if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_rank_t                     aRank,
	vipm_int const                  aVolume[],
	vipm_uint                       anElemTypeDst,
	vipm_mutptr_t                   aBaseDst,  vipm_int const aStartDst[], vipm_int const aStrideDst[],
	vipm_uint                       anElemTypeSrc1,
	vipm_imuptr_t                   aBaseSrc1, vipm_int const aStartSrc1[], vipm_int const aStrideSrc1[],
	vipm_uint                       anElemTypeSrc2,
	vipm_imuptr_t                   aBaseSrc2, vipm_int const aStartSrc2[], vipm_int const aStrideSrc2[],
	/* Useful for integer types */
	vipm_int                        aScaleFactor, vipm_int aRoundMode
#endif
	);

__PUB bo_status_t
vipma_divrC(
#if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_rank_t                     aRank,
	vipm_int const                  aVolume[],
	vipm_uint                       anElemTypeDst,
	vipm_mutptr_t                   aBaseDst,  vipm_int const aStartDst[], vipm_int const aStrideDst[],
	vipm_uint                       anElemTypeSrc1,
	vipm_imuptr_t                   aBaseSrc1, vipm_int const aStartSrc1[], vipm_int const aStrideSrc1[],
	vipm_imuptr_t                   aSrc2,
	/* Useful for integer types */
	vipm_int                        aScaleFactor, vipm_int aRoundMode
#endif
	);

__PUB bo_status_t
vipma_rdiv(
#if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_rank_t                     aRank,
	vipm_int const                  aVolume[],
	vipm_uint                       anElemTypeDst,
	vipm_mutptr_t                   aBaseDst,  vipm_int const aStartDst[], vipm_int const aStrideDst[],
	vipm_uint                       anElemTypeSrc1,
	vipm_imuptr_t                   aBaseSrc1, vipm_int const aStartSrc1[], vipm_int const aStrideSrc1[],
	vipm_uint                       anElemTypeSrc2,
	vipm_imuptr_t                   aBaseSrc2, vipm_int const aStartSrc2[], vipm_int const aStrideSrc2[],
	/* Useful for integer types */
	vipm_int                        aScaleFactor, vipm_int aRoundMode
#endif
	);

__PUB bo_status_t
vipma_rdivC(
#if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_rank_t                     aRank,
	vipm_int const                  aVolume[],
	vipm_uint                       anElemTypeDst,
	vipm_mutptr_t                   aBaseDst,  vipm_int const aStartDst[], vipm_int const aStrideDst[],
	vipm_uint                       anElemTypeSrc1,
	vipm_imuptr_t                   aBaseSrc1, vipm_int const aStartSrc1[], vipm_int const aStrideSrc1[],
	vipm_imuptr_t                   aSrc2,
	/* Useful for integer types */
	vipm_int                        aScaleFactor, vipm_int aRoundMode
#endif
	);

__PUB bo_status_t
vipma_rdivr(
#if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_rank_t                     aRank,
	vipm_int const                  aVolume[],
	vipm_uint                       anElemTypeDst,
	vipm_mutptr_t                   aBaseDst,  vipm_int const aStartDst[], vipm_int const aStrideDst[],
	vipm_uint                       anElemTypeSrc1,
	vipm_imuptr_t                   aBaseSrc1, vipm_int const aStartSrc1[], vipm_int const aStrideSrc1[],
	vipm_uint                       anElemTypeSrc2,
	vipm_imuptr_t                   aBaseSrc2, vipm_int const aStartSrc2[], vipm_int const aStrideSrc2[],
	/* Useful for integer types */
	vipm_int                        aScaleFactor, vipm_int aRoundMode
#endif
	);

__PUB bo_status_t
vipma_rdivrC(
#if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_rank_t                     aRank,
	vipm_int const                  aVolume[],
	vipm_uint                       anElemTypeDst,
	vipm_mutptr_t                   aBaseDst,  vipm_int const aStartDst[], vipm_int const aStrideDst[],
	vipm_uint                       anElemTypeSrc1,
	vipm_imuptr_t                   aBaseSrc1, vipm_int const aStartSrc1[], vipm_int const aStrideSrc1[],
	vipm_imuptr_t                   aSrc2,
	/* Useful for integer types */
	vipm_int                        aScaleFactor, vipm_int aRoundMode
#endif
	);

/*
 * MLA
 *
 * mla  : r[i] = (a[i] + b[i] * c[i]) * (2**f)
 * mlaC : r[i] = (a[i] + b[i] * c) * (2**f)
 * mlaCC: r[i] = (a[i] * b + c) * (2**f)
 * mla{int}: saturate(round(scale(mla)))
 */

__PUB bo_status_t
vipma_mla(
#if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_rank_t                     aRank,
	vipm_int const                  aVolume[],
	vipm_uint                       anElemTypeDst,
	vipm_mutptr_t                   aBaseDst,  vipm_int const aStartDst[], vipm_int const aStrideDst[],
	vipm_uint                       anElemTypeSrc1,
	vipm_imuptr_t                   aBaseSrc1, vipm_int const aStartSrc1[], vipm_int const aStrideSrc1[],
	vipm_uint                       anElemTypeSrc2,
	vipm_imuptr_t                   aBaseSrc2, vipm_int const aStartSrc2[], vipm_int const aStrideSrc2[],
	vipm_uint                       anElemTypeSrc3,
	vipm_imuptr_t                   aBaseSrc3, vipm_int const aStartSrc3[], vipm_int const aStrideSrc3[],
	/* Useful for integer types */
	vipm_int                        aScaleFactor, vipm_int aRoundMode
#endif
	);

__PUB bo_status_t
vipma_mlaC(
#if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_rank_t                     aRank,
	vipm_int const                  aVolume[],
	vipm_uint                       anElemTypeDst,
	vipm_mutptr_t                   aBaseDst,  vipm_int const aStartDst[], vipm_int const aStrideDst[],
	vipm_uint                       anElemTypeSrc1,
	vipm_imuptr_t                   aBaseSrc1, vipm_int const aStartSrc1[], vipm_int const aStrideSrc1[],
	vipm_uint                       anElemTypeSrc2,
	vipm_imuptr_t                   aBaseSrc2, vipm_int const aStartSrc2[], vipm_int const aStrideSrc2[],
	vipm_imuptr_t                   aSrc3,
	/* Useful for integer types */
	vipm_int                        aScaleFactor, vipm_int aRoundMode
#endif
	);

__PUB bo_status_t
vipma_mlaCC(
#if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_rank_t                     aRank,
	vipm_int const                  aVolume[],
	vipm_uint                       anElemTypeDst,
	vipm_mutptr_t                   aBaseDst,  vipm_int const aStartDst[], vipm_int const aStrideDst[],
	vipm_uint                       anElemTypeSrc1,
	vipm_imuptr_t                   aBaseSrc1, vipm_int const aStartSrc1[], vipm_int const aStrideSrc1[],
	vipm_imuptr_t                   aSrc2,
	vipm_imuptr_t                   aSrc3,
	/* Useful for integer types */
	vipm_int                        aScaleFactor, vipm_int aRoundMode
#endif
	);

/*
 * MLS
 *
 * mls   : r[i] = (a[i] - b[i] * c[i]) * (2**f)
 * mlsC  : r[i] = (a[i] - b[i] * c) * (2**f)
 * mlsCC : r[i] = (a[i] * b - c) * (2**f)
 *
 * mlrs  : r[i] = (b[i] * c[i] - a[i]) * (2**f)
 * mlrsC : r[i] = (b[i] * c - a[i]) * (2**f)
 * mlrsCC: r[i] = (c - a[i] * b) * (2**f)
 *
 * ml{r}s{int} : saturate(round(scale(ml{r}s)))
 */

__PUB bo_status_t
vipma_mls(
#if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_rank_t                     aRank,
	vipm_int const                  aVolume[],
	vipm_uint                       anElemTypeDst,
	vipm_mutptr_t                   aBaseDst,  vipm_int const aStartDst[], vipm_int const aStrideDst[],
	vipm_uint                       anElemTypeSrc1,
	vipm_imuptr_t                   aBaseSrc1, vipm_int const aStartSrc1[], vipm_int const aStrideSrc1[],
	vipm_uint                       anElemTypeSrc2,
	vipm_imuptr_t                   aBaseSrc2, vipm_int const aStartSrc2[], vipm_int const aStrideSrc2[],
	vipm_uint                       anElemTypeSrc3,
	vipm_imuptr_t                   aBaseSrc3, vipm_int const aStartSrc3[], vipm_int const aStrideSrc3[],
	/* Useful for integer types */
	vipm_int                        aScaleFactor, vipm_int aRoundMode
#endif
	);

__PUB bo_status_t
vipma_mlsC(
#if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_rank_t                     aRank,
	vipm_int const                  aVolume[],
	vipm_uint                       anElemTypeDst,
	vipm_mutptr_t                   aBaseDst,  vipm_int const aStartDst[], vipm_int const aStrideDst[],
	vipm_uint                       anElemTypeSrc1,
	vipm_imuptr_t                   aBaseSrc1, vipm_int const aStartSrc1[], vipm_int const aStrideSrc1[],
	vipm_uint                       anElemTypeSrc2,
	vipm_imuptr_t                   aBaseSrc2, vipm_int const aStartSrc2[], vipm_int const aStrideSrc2[],
	vipm_imuptr_t                   aSrc3,
	/* Useful for integer types */
	vipm_int                        aScaleFactor, vipm_int aRoundMode
#endif
	);

__PUB bo_status_t
vipma_mlsCC(
#if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_rank_t                     aRank,
	vipm_int const                  aVolume[],
	vipm_uint                       anElemTypeDst,
	vipm_mutptr_t                   aBaseDst,  vipm_int const aStartDst[], vipm_int const aStrideDst[],
	vipm_uint                       anElemTypeSrc1,
	vipm_imuptr_t                   aBaseSrc1, vipm_int const aStartSrc1[], vipm_int const aStrideSrc1[],
	vipm_imuptr_t                   aSrc2,
	vipm_imuptr_t                   aSrc3,
	/* Useful for integer types */
	vipm_int                        aScaleFactor, vipm_int aRoundMode
#endif
	);

__PUB bo_status_t
vipma_mlrs(
#if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_rank_t                     aRank,
	vipm_int const                  aVolume[],
	vipm_uint                       anElemTypeDst,
	vipm_mutptr_t                   aBaseDst,  vipm_int const aStartDst[], vipm_int const aStrideDst[],
	vipm_uint                       anElemTypeSrc1,
	vipm_imuptr_t                   aBaseSrc1, vipm_int const aStartSrc1[], vipm_int const aStrideSrc1[],
	vipm_uint                       anElemTypeSrc2,
	vipm_imuptr_t                   aBaseSrc2, vipm_int const aStartSrc2[], vipm_int const aStrideSrc2[],
	vipm_uint                       anElemTypeSrc3,
	vipm_imuptr_t                   aBaseSrc3, vipm_int const aStartSrc3[], vipm_int const aStrideSrc3[],
	/* Useful for integer types */
	vipm_int                        aScaleFactor, vipm_int aRoundMode
#endif
	);

__PUB bo_status_t
vipma_mlrsC(
#if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_rank_t                     aRank,
	vipm_int const                  aVolume[],
	vipm_uint                       anElemTypeDst,
	vipm_mutptr_t                   aBaseDst,  vipm_int const aStartDst[], vipm_int const aStrideDst[],
	vipm_uint                       anElemTypeSrc1,
	vipm_imuptr_t                   aBaseSrc1, vipm_int const aStartSrc1[], vipm_int const aStrideSrc1[],
	vipm_uint                       anElemTypeSrc2,
	vipm_imuptr_t                   aBaseSrc2, vipm_int const aStartSrc2[], vipm_int const aStrideSrc2[],
	vipm_imuptr_t                   aSrc3,
	/* Useful for integer types */
	vipm_int                        aScaleFactor, vipm_int aRoundMode
#endif
	);

__PUB bo_status_t
vipma_mlrsCC(
#if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_rank_t                     aRank,
	vipm_int const                  aVolume[],
	vipm_uint                       anElemTypeDst,
	vipm_mutptr_t                   aBaseDst,  vipm_int const aStartDst[], vipm_int const aStrideDst[],
	vipm_uint                       anElemTypeSrc1,
	vipm_imuptr_t                   aBaseSrc1, vipm_int const aStartSrc1[], vipm_int const aStrideSrc1[],
	vipm_imuptr_t                   aSrc2,
	vipm_imuptr_t                   aSrc3,
	/* Useful for integer types */
	vipm_int                        aScaleFactor, vipm_int aRoundMode
#endif
	);

/*
 * MATMUL
 *
 * mulmm : matrix-matrix multiply
 * mulmv : matrix-vector multiply
 * mulmvn: matrix-vectorList multiply
 */

__PUB bo_status_t
vipma_mulmm(
#if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_rank_t                     aRank,
	vipm_int const                  aVolumeSrc1[],
	vipm_int const                  aVolumeSrc2[],
	vipm_uint                       anElemTypeDst,
	vipm_mutptr_t                   aBaseDst,  vipm_int const aStartDst[], vipm_int const aStrideDst[],
	vipm_uint                       anElemTypeSrc1,
	vipm_imuptr_t                   aBaseSrc1, vipm_int const aStartSrc1[], vipm_int const aStrideSrc1[],
	vipm_uint                       anElemTypeSrc2,
	vipm_imuptr_t                   aBaseSrc2, vipm_int const aStartSrc2[], vipm_int const aStrideSrc2[],
	/* Useful for integer types */
	vipm_int                        aScaleFactor, vipm_int aRoundMode
#endif
	);

__PUB bo_status_t
vipma_mulmv(
#if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_rank_t                     aRank,
	vipm_int const                  aVolume[],
	vipm_uint                       anElemTypeDst,
	vipm_mutptr_t                   aBaseDst,  vipm_int const aStartDst[], vipm_int const aStrideDst[],
	vipm_uint                       anElemTypeSrc1,
	vipm_imuptr_t                   aBaseSrc1, vipm_int const aStartSrc1[], vipm_int const aStrideSrc1[],
	vipm_uint                       anElemTypeSrc2,
	vipm_imuptr_t                   aBaseSrc2, vipm_int const aStartSrc2[], vipm_int const aStrideSrc2[],
	/* Useful for integer types */
	vipm_int                        aScaleFactor, vipm_int aRoundMode
#endif
	);

__PUB bo_status_t
vipma_mulmvn(
#if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_rank_t                     aRank,
	vipm_int const                  aVolume[],
	vipm_uint                       anElemTypeDst,
	vipm_mutptr_t                   aBaseDst,  vipm_int const aStartDst[], vipm_int const aStrideDst[],
	vipm_uint                       anElemTypeSrc1,
	vipm_imuptr_t                   aBaseSrc1, vipm_int const aStartSrc1[], vipm_int const aStrideSrc1[],
	vipm_uint                       anElemTypeSrc2,
	vipm_imuptr_t                  *aBaseSrc2List, vipm_int const aStartSrc2[], vipm_int const aStrideSrc2[],
	vipm_uint                       aSrc2Num,
	/* Useful for integer types */
	vipm_int                        aScaleFactor, vipm_int aRoundMode
#endif
	);


/*
 * NEG
 */

__PUB bo_status_t
vipma_neg(
#if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_rank_t                     aRank,
	vipm_int const                  aVolume[],
	vipm_uint                       anElemTypeDst,
	vipm_mutptr_t                   aBaseDst,  vipm_int const aStartDst[], vipm_int const aStrideDst[],
	vipm_uint                       anElemTypeSrc1,
	vipm_imuptr_t                   aBaseSrc1, vipm_int const aStartSrc1[], vipm_int const aStrideSrc1[],
	/* Useful for integer types */
	vipm_int                        aScaleFactor, vipm_int aRoundMode
# endif
	);

__PUB bo_status_t
vipma_negq(
#if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_rank_t                     aRank,
	vipm_int const                  aVolume[],
	vipm_uint                       anElemTypeDst,
	vipm_mutptr_t                   aBaseDst,  vipm_int const aStartDst[], vipm_int const aStrideDst[],
	vipm_uint                       anElemTypeSrc1,
	vipm_imuptr_t                   aBaseSrc1, vipm_int const aStartSrc1[], vipm_int const aStrideSrc1[],
	/* Useful for integer types */
	vipm_int                        aScaleFactor, vipm_int aRoundMode
# endif
	);


/*
 * EXP
 */

__PUB bo_status_t
vipma_exp(
#if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_rank_t                     aRank,
	vipm_int const                  aVolume[],
	vipm_uint                       anElemTypeDst,
	vipm_mutptr_t                   aBaseDst,  vipm_int const aStartDst[], vipm_int const aStrideDst[],
	vipm_uint                       anElemTypeSrc1,
	vipm_imuptr_t                   aBaseSrc1, vipm_int const aStartSrc1[], vipm_int const aStrideSrc1[],
	/* Useful for integer types */
	vipm_int                        aScaleFactor, vipm_int aRoundMode
# endif
	);


/*
 * SIGMOID
 *
 * sigmoid:      1/(1 + e^(-a[i]))
 * sigmoidalpha: 1/(1 + e^(alpha * a[i]))
 */

__PUB bo_status_t
vipma_sigmoidalpha(
#if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_rank_t                     aRank,
	vipm_int const                  aVolume[],
	vipm_uint                       anElemTypeDst,
	vipm_mutptr_t                   aBaseDst,  vipm_int const aStartDst[], vipm_int const aStrideDst[],
	vipm_uint                       anElemTypeSrc1,
	vipm_imuptr_t                   aBaseSrc1, vipm_int const aStartSrc1[], vipm_int const aStrideSrc1[],
	vipm_imuptr_t                   anAlpha,
	/* Useful for integer types */
	vipm_int                        aScaleFactor, vipm_int aRoundMode
# endif
	);


/*
 * LN
 */

__PUB bo_status_t
vipma_ln(
#if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_rank_t                     aRank,
	vipm_int const                  aVolume[],
	vipm_uint                       anElemTypeDst,
	vipm_mutptr_t                   aBaseDst,  vipm_int const aStartDst[], vipm_int const aStrideDst[],
	vipm_uint                       anElemTypeSrc1,
	vipm_imuptr_t                   aBaseSrc1, vipm_int const aStartSrc1[], vipm_int const aStrideSrc1[],
	/* Useful for integer types */
	vipm_int                        aScaleFactor, vipm_int aRoundMode
# endif
	);


/* ============================================================================
 * Specialized versions
 */
# pragma mark -

# ifndef __VIPM_ARITHLOGIC_ARITHMETIC_ADD_H__
#  include "Vipm/ArithLogic/Arithmetic/Add.h"
# endif

# ifndef __VIPM_ARITHLOGIC_ARITHMETIC_ADDQ_H__
#  include "Vipm/ArithLogic/Arithmetic/Addq.h"
# endif

# ifndef __VIPM_ARITHLOGIC_ARITHMETIC_ADDSQ_H__
#  include "Vipm/ArithLogic/Arithmetic/Addsq.h"
# endif

# ifndef __VIPM_ARITHLOGIC_ARITHMETIC_SUB_H__
#  include "Vipm/ArithLogic/Arithmetic/Sub.h"
# endif

# ifndef __VIPM_ARITHLOGIC_ARITHMETIC_SUBQ_H__
#  include "Vipm/ArithLogic/Arithmetic/Subq.h"
# endif

# ifndef __VIPM_ARITHLOGIC_ARITHMETIC_SUBSQ_H__
#  include "Vipm/ArithLogic/Arithmetic/Subsq.h"
# endif

# ifndef __VIPM_ARITHLOGIC_ARITHMETIC_RSUB_H__
#  include "Vipm/ArithLogic/Arithmetic/RSub.h"
# endif

# ifndef __VIPM_ARITHLOGIC_ARITHMETIC_RSUBQ_H__
#  include "Vipm/ArithLogic/Arithmetic/RSubq.h"
# endif

# ifndef __VIPM_ARITHLOGIC_ARITHMETIC_RSUBSQ_H__
#  include "Vipm/ArithLogic/Arithmetic/RSubsq.h"
# endif

# ifndef __VIPM_ARITHLOGIC_ARITHMETIC_MUL_H__
#  include "Vipm/ArithLogic/Arithmetic/Mul.h"
# endif

# ifndef __VIPM_ARITHLOGIC_ARITHMETIC_DIV_H__
#  include "Vipm/ArithLogic/Arithmetic/Div.h"
# endif

# ifndef __VIPM_ARITHLOGIC_ARITHMETIC_DIVR_H__
#  include "Vipm/ArithLogic/Arithmetic/Divr.h"
# endif

# ifndef __VIPM_ARITHLOGIC_ARITHMETIC_RDIV_H__
#  include "Vipm/ArithLogic/Arithmetic/RDiv.h"
# endif

# ifndef __VIPM_ARITHLOGIC_ARITHMETIC_RDIVR_H__
#  include "Vipm/ArithLogic/Arithmetic/RDivr.h"
# endif

# ifndef __VIPM_ARITHLOGIC_ARITHMETIC_MULADD_H__
#  include "Vipm/ArithLogic/Arithmetic/MulAdd.h"
# endif

# ifndef __VIPM_ARITHLOGIC_ARITHMETIC_MULSUB_H__
#  include "Vipm/ArithLogic/Arithmetic/MulSub.h"
# endif

# ifndef __VIPM_ARITHLOGIC_ARITHMETIC_MULRSUB_H__
#  include "Vipm/ArithLogic/Arithmetic/MulRSub.h"
# endif

# ifndef __VIPM_ARITHLOGIC_ARITHMETIC_MATMUL_H__
#  include "Vipm/ArithLogic/Arithmetic/MatMul.h"
# endif

# ifndef __VIPM_ARITHLOGIC_ARITHMETIC_NEG_H__
#  include "Vipm/ArithLogic/Arithmetic/Neg.h"
# endif

# ifndef __VIPM_ARITHLOGIC_ARITHMETIC_NEG_H__
#  include "Vipm/ArithLogic/Arithmetic/Negq.h"
# endif

# ifndef __VIPM_ARITHLOGIC_ARITHMETIC_EXP_H__
#  include "Vipm/ArithLogic/Arithmetic/Exp.h"
# endif

# ifndef __VIPM_ARITHLOGIC_ARITHMETIC_SIGMOID_H__
#  include "Vipm/ArithLogic/Arithmetic/Sigmoid.h"
# endif

# ifndef __VIPM_ARITHLOGIC_ARITHMETIC_LN_H__
#  include "Vipm/ArithLogic/Arithmetic/Ln.h"
# endif


__MYC_END_CDECLS
# undef __PUB
# undef __PRIV


#endif /* !defined(__VIPM_ARITHLOGIC_ARITHMETIC_ALGORITHM_H__) */


/******************************************************************************
 *
 *
 *
 *****************************************************************************/
