/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright 2018 Seenaptec Ltd. All rights reserved.
 * SEENAPTEC PROPRIETARY/CONFIDENTIAL.
 *
 * $Id$
 */

/*
 * Exp.h	(D.Vinnyk)
 * Vipm/ArithLogic/Arithmetic/Exp.h
 */

/* ------------------------------------------------------------------------- */

#ifndef __VIPM_ARITHLOGIC_ARITHMETIC_EXP_H__
# define __VIPM_ARITHLOGIC_ARITHMETIC_EXP_H__

/* ============================================================================
 * Specialized versions
 */
# pragma mark -

/*
 * exp
 */

/*
 * Source Data type: U8
 * Dest Data type  : U8,S16,S32,F32
 */
# define vipma_exp_u8u8(x,f,rank,vol,D,offsD,strideD,S1,offsS1,strideS1,sf,rnd) \
    vipma_exp(x,f,rank,vol,VipmK_ELEMTYPE_U8,D,offsD,strideD,VipmK_ELEMTYPE_U8,S1,offsS1,strideS1,sf,rnd)

# define vipma_exp_s16u8(x,f,rank,vol,D,offsD,strideD,S1,offsS1,strideS1,sf,rnd) \
    vipma_exp(x,f,rank,vol,VipmK_ELEMTYPE_S16,D,offsD,strideD,VipmK_ELEMTYPE_U8,S1,offsS1,strideS1,sf,rnd)

# define vipma_exp_s32u8(x,f,rank,vol,D,offsD,strideD,S1,offsS1,strideS1,sf,rnd) \
    vipma_exp(x,f,rank,vol,VipmK_ELEMTYPE_S32,D,offsD,strideD,VipmK_ELEMTYPE_U8,S1,offsS1,strideS1,sf,rnd)

# define vipma_exp_f32u8(x,f,rank,vol,D,offsD,strideD,S1,offsS1,strideS1) \
    vipma_exp(x,f,rank,vol,VipmK_ELEMTYPE_F32,D,offsD,strideD,VipmK_ELEMTYPE_U8,S1,offsS1,strideS1,0,0)

/*
 * Source Data type: S16
 * Dest Data type  : U8,S16,S32,F32
 */
# define vipma_exp_u8s16(x,f,rank,vol,D,offsD,strideD,S1,offsS1,strideS1,sf,rnd) \
    vipma_exp(x,f,rank,vol,VipmK_ELEMTYPE_U8,D,offsD,strideD,VipmK_ELEMTYPE_U8,S1,offsS1,strideS1,sf,rnd)

# define vipma_exp_s16s16(x,f,rank,vol,D,offsD,strideD,S1,offsS1,strideS1,sf,rnd) \
    vipma_exp(x,f,rank,vol,VipmK_ELEMTYPE_S16,D,offsD,strideD,VipmK_ELEMTYPE_U8,S1,offsS1,strideS1,sf,rnd)

# define vipma_exp_s32s16(x,f,rank,vol,D,offsD,strideD,S1,offsS1,strideS1,sf,rnd) \
    vipma_exp(x,f,rank,vol,VipmK_ELEMTYPE_S32,D,offsD,strideD,VipmK_ELEMTYPE_U8,S1,offsS1,strideS1,sf,rnd)

# define vipma_exp_f32s16(x,f,rank,vol,D,offsD,strideD,S1,offsS1,strideS1) \
    vipma_exp(x,f,rank,vol,VipmK_ELEMTYPE_F32,D,offsD,strideD,VipmK_ELEMTYPE_U8,S1,offsS1,strideS1,0,0)

/*
 * Source Data type: S32
 * Dest Data type  : U8,S16,S32,F32
 */
# define vipma_exp_u8s32(x,f,rank,vol,D,offsD,strideD,S1,offsS1,strideS1,sf,rnd) \
    vipma_exp(x,f,rank,vol,VipmK_ELEMTYPE_U8,D,offsD,strideD,VipmK_ELEMTYPE_U8,S1,offsS1,strideS1,sf,rnd)

# define vipma_exp_s16s32(x,f,rank,vol,D,offsD,strideD,S1,offsS1,strideS1,sf,rnd) \
    vipma_exp(x,f,rank,vol,VipmK_ELEMTYPE_S16,D,offsD,strideD,VipmK_ELEMTYPE_U8,S1,offsS1,strideS1,sf,rnd)

# define vipma_exp_s32s32(x,f,rank,vol,D,offsD,strideD,S1,offsS1,strideS1,sf,rnd) \
    vipma_exp(x,f,rank,vol,VipmK_ELEMTYPE_S32,D,offsD,strideD,VipmK_ELEMTYPE_U8,S1,offsS1,strideS1,sf,rnd)

# define vipma_exp_f32s32(x,f,rank,vol,D,offsD,strideD,S1,offsS1,strideS1) \
    vipma_exp(x,f,rank,vol,VipmK_ELEMTYPE_F32,D,offsD,strideD,VipmK_ELEMTYPE_U8,S1,offsS1,strideS1,0,0)

/*
 * Source Data type: F32
 * Dest Data type  : U8,S16,S32,F32
 */
# define vipma_exp_u8f32(x,f,rank,vol,D,offsD,strideD,S1,offsS1,strideS1) \
    vipma_exp(x,f,rank,vol,VipmK_ELEMTYPE_U8,D,offsD,strideD,VipmK_ELEMTYPE_U8,S1,offsS1,strideS1,0,0)

# define vipma_exp_s16f32(x,f,rank,vol,D,offsD,strideD,S1,offsS1,strideS1) \
    vipma_exp(x,f,rank,vol,VipmK_ELEMTYPE_S16,D,offsD,strideD,VipmK_ELEMTYPE_U8,S1,offsS1,strideS1,0,0)

# define vipma_exp_s32f32(x,f,rank,vol,D,offsD,strideD,S1,offsS1,strideS1) \
    vipma_exp(x,f,rank,vol,VipmK_ELEMTYPE_S32,D,offsD,strideD,VipmK_ELEMTYPE_U8,S1,offsS1,strideS1,0,0)

# define vipma_exp_f32f32(x,f,rank,vol,D,offsD,strideD,S1,offsS1,strideS1) \
    vipma_exp(x,f,rank,vol,VipmK_ELEMTYPE_F32,D,offsD,strideD,VipmK_ELEMTYPE_U8,S1,offsS1,strideS1,0,0)


#endif /* !defined(__VIPM_ARITHLOGIC_ARITHMETIC_EXP_H__) */


/******************************************************************************
 *
 *
 *
 *****************************************************************************/
