/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright 2018 Seenaptec Ltd. All rights reserved.
 * SEENAPTEC PROPRIETARY/CONFIDENTIAL.
 *
 * $Id$
 */

/*
 * Types.h	(D.Vinnyk)
 * Vipm/ArithLogic/Arithmetic/Types.h
 */

/* ------------------------------------------------------------------------- */

#ifndef __VIPM_ARITHLOGIC_ARITHMETIC_TYPES_H__
# define __VIPM_ARITHLOGIC_ARITHMETIC_TYPES_H__

/******************************************************************************
 * %% BeginSection: includes
 */

# ifndef __VIPM_TYPES_H__
#  include <Vipm/Types.h>
# endif


/******************************************************************************
 * %% BeginSection: types/constants
 */



/* ========================================================================= */

typedef bo_status_t (*vipma_arith_fn)(
# if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_rank_t                     aRank,
	vipm_int const                  aVolume[],
	vipm_uint                       anElemTypeDst,
	vipm_mutptr_t                   aBaseDst,  vipm_int const aStartDst[], vipm_int const aStrideDst[],
	vipm_uint                       anElemTypeSrc1,
	vipm_imuptr_t                   aBaseSrc1, vipm_int const aStartSrc1[], vipm_int const aStrideSrc1[],
	/* Useful for integer types */
	vipm_int                        aScaleFactor, vipm_int aRoundMode
# endif
	);

typedef bo_status_t (*vipma_arith2_fn)(
# if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_rank_t                     aRank,
	vipm_int const                  aVolume[],
	vipm_uint                       anElemTypeDst,
	vipm_mutptr_t                   aBaseDst,  vipm_int const aStartDst[], vipm_int const aStrideDst[],
	vipm_uint                       anElemTypeSrc1,
	vipm_imuptr_t                   aBaseSrc1, vipm_int const aStartSrc1[], vipm_int const aStrideSrc1[],
	vipm_uint                       anElemTypeSrc2,
	vipm_imuptr_t                   aBaseSrc2, vipm_int const aStartSrc2[], vipm_int const aStrideSrc2[],
	/* Useful for integer types */
	vipm_int                        aScaleFactor, vipm_int aRoundMode
# endif
	);

typedef bo_status_t (*vipma_arith2c_fn)(
# if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_rank_t                     aRank,
	vipm_int const                  aVolume[],
	vipm_uint                       anElemTypeDst,
	vipm_mutptr_t                   aBaseDst,  vipm_int const aStartDst[], vipm_int const aStrideDst[],
	vipm_uint                       anElemTypeSrc1,
	vipm_imuptr_t                   aBaseSrc1, vipm_int const aStartSrc1[], vipm_int const aStrideSrc1[],
	vipm_imuptr_t                   aSrc2,
	/* Useful for integer types */
	vipm_int                        aScaleFactor, vipm_int aRoundMode
# endif
	);

typedef bo_status_t (*vipma_arith3_fn)(
# if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_rank_t                     aRank,
	vipm_int const                  aVolume[],
	vipm_uint                       anElemTypeDst,
	vipm_mutptr_t                   aBaseDst,  vipm_int const aStartDst[], vipm_int const aStrideDst[],
	vipm_uint                       anElemTypeSrc1,
	vipm_imuptr_t                   aBaseSrc1, vipm_int const aStartSrc1[], vipm_int const aStrideSrc1[],
	vipm_uint                       anElemTypeSrc2,
	vipm_imuptr_t                   aBaseSrc2, vipm_int const aStartSrc2[], vipm_int const aStrideSrc2[],
	vipm_uint                       anElemTypeSrc3,
	vipm_imuptr_t                   aBaseSrc3, vipm_int const aStartSrc3[], vipm_int const aStrideSrc3[],
	/* Useful for integer types */
	vipm_int                        aScaleFactor, vipm_int aRoundMode
# endif
	);

typedef bo_status_t (*vipma_arith3c_fn)(
# if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_rank_t                     aRank,
	vipm_int const                  aVolume[],
	vipm_uint                       anElemTypeDst,
	vipm_mutptr_t                   aBaseDst,  vipm_int const aStartDst[], vipm_int const aStrideDst[],
	vipm_uint                       anElemTypeSrc1,
	vipm_imuptr_t                   aBaseSrc1, vipm_int const aStartSrc1[], vipm_int const aStrideSrc1[],
	vipm_uint                       anElemTypeSrc2,
	vipm_imuptr_t                   aBaseSrc2, vipm_int const aStartSrc2[], vipm_int const aStrideSrc2[],
	vipm_imuptr_t                   aSrc3,
	/* Useful for integer types */
	vipm_int                        aScaleFactor, vipm_int aRoundMode
# endif
	);

typedef bo_status_t (*vipma_arith3cc_fn)(
# if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_rank_t                     aRank,
	vipm_int const                  aVolume[],
	vipm_uint                       anElemTypeDst,
	vipm_mutptr_t                   aBaseDst,  vipm_int const aStartDst[], vipm_int const aStrideDst[],
	vipm_uint                       anElemTypeSrc1,
	vipm_imuptr_t                   aBaseSrc1, vipm_int const aStartSrc1[], vipm_int const aStrideSrc1[],
	vipm_imuptr_t                   aSrc2,
	vipm_imuptr_t                   aSrc3,
	/* Useful for integer types */
	vipm_int                        aScaleFactor, vipm_int aRoundMode
# endif
	);

typedef bo_status_t (*vipma_arithvol2_fn)(
# if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_rank_t                     aRank,
	vipm_int const                  aVolume1[],
	vipm_int const                  aVolume2[],
	vipm_uint                       anElemTypeDst,
	vipm_mutptr_t                   aBaseDst,  vipm_int const aStartDst[], vipm_int const aStrideDst[],
	vipm_uint                       anElemTypeSrc1,
	vipm_imuptr_t                   aBaseSrc1, vipm_int const aStartSrc1[], vipm_int const aStrideSrc1[],
	vipm_uint                       anElemTypeSrc2,
	vipm_imuptr_t                   aBaseSrc2, vipm_int const aStartSrc2[], vipm_int const aStrideSrc2[],
	/* Useful for integer types */
	vipm_int                        aScaleFactor, vipm_int aRoundMode
# endif
	);

typedef bo_status_t (*vipma_arithsrc2n_fn)(
# if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_rank_t                     aRank,
	vipm_int const                  aVolume[],
	vipm_uint                       anElemTypeDst,
	vipm_mutptr_t                   aBaseDst,  vipm_int const aStartDst[], vipm_int const aStrideDst[],
	vipm_uint                       anElemTypeSrc1,
	vipm_imuptr_t                   aBaseSrc1, vipm_int const aStartSrc1[], vipm_int const aStrideSrc1[],
	vipm_uint                       anElemTypeSrc2,
	vipm_imuptr_t                   aBaseSrc2, vipm_int const aStartSrc2[], vipm_int const aStrideSrc2[],
	vipm_uint                       aSrc2Num,
	/* Useful for integer types */
	vipm_int                        aScaleFactor, vipm_int aRoundMode
# endif
	);


#endif /* !defined(__VIPM_ARITHLOGIC_ARITHMETIC_TYPES_H__) */


/******************************************************************************
 *
 *
 *
 *****************************************************************************/
