/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright 2016 Seenaptec Ltd. All rights reserved.
 * SEENAPTEC PROPRIETARY/CONFIDENTIAL.
 *
 * $Id$
 */

/*
 * Logical.h	(V.Sokur)
 * Vipm/ArithLogic/Logical.h
 */

/* ------------------------------------------------------------------------- */

#ifndef __VIPM_ARITHLOGIC_LOGICAL_H__
# define __VIPM_ARITHLOGIC_LOGICAL_H__

/******************************************************************************
 * %% BeginSection: includes
 */

# ifndef __VIPM_ARITHLOGIC_LOGICAL_ALGORITHM_H__
#  include "Vipm/ArithLogic/Logical/Algorithm.h"
# endif


/******************************************************************************
 * %% BeginSection: function prototypes
 */
# pragma mark -
# pragma mark [ function prototypes ]
# pragma mark -

# include <Vipm/Linkage.h>
# define __PUB __myc_flinkage__(public,libVipm)
__MYC_BEGIN_CDECLS

/*
 * ROI samples:
 * 1) point : (nplanes:0,y,x,nchannels:0)
 *    volume: (nplanes:1,h,w,nchannels)
 */

/*
 * AND
 */

__PUB bo_status_t
VipmAnd(
# if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_mut_array_t                aDest,
	vipm_array_t                    aSource1,
	vipm_array_t                    aSource2,
	vipm_site_t const              *aRoiDst,
	vipm_Npoint_t const            *aStartSrc1,
	vipm_Npoint_t const            *aStartSrc2
# endif
	);

__PUB bo_status_t
VipmAndC(
# if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_mut_array_t                aDest,
	vipm_array_t                    aSource1,
	vipm_scalar_t const             aSource2[/* nchannels */],
	vipm_site_t const              *aRoiDst,
	vipm_Npoint_t const            *aStartSrc1
# endif
	);

/*
 * OR
 */

__PUB bo_status_t
VipmOrr(
# if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_mut_array_t                aDest,
	vipm_array_t                    aSource1,
	vipm_array_t                    aSource2,
	vipm_site_t const              *aRoiDst,
	vipm_Npoint_t const            *aStartSrc1,
	vipm_Npoint_t const            *aStartSrc2
# endif
	);

__PUB bo_status_t
VipmOrrC(
# if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_mut_array_t                aDest,
	vipm_array_t                    aSource1,
	vipm_scalar_t const             aSource2[/* nchannels */],
	vipm_site_t const              *aRoiDst,
	vipm_Npoint_t const            *aStartSrc1
# endif
	);

/*
 * XOR
 */

__PUB bo_status_t
VipmXor(
# if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_mut_array_t                aDest,
	vipm_array_t                    aSource1,
	vipm_array_t                    aSource2,
	vipm_site_t const              *aRoiDst,
	vipm_Npoint_t const            *aStartSrc1,
	vipm_Npoint_t const            *aStartSrc2
# endif
	);

__PUB bo_status_t
VipmXorC(
# if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_mut_array_t                aDest,
	vipm_array_t                    aSource1,
	vipm_scalar_t const             aSource2[/* nchannels */],
	vipm_site_t const              *aRoiDst,
	vipm_Npoint_t const            *aStartSrc1
# endif
	);

/*
 * NOT
 */
__PUB bo_status_t
VipmNot(
# if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_mut_array_t                aDest,
	vipm_array_t                    aSource,
	vipm_site_t const              *aRoiDst,
	vipm_Npoint_t const            *aStartSrc
# endif
	);

__MYC_END_CDECLS
# undef __PUB
# undef __PRIV


#endif /* !defined(__VIPM_ARITHLOGIC_LOGICAL_H__) */


/******************************************************************************
 *
 *
 *
 *****************************************************************************/
