/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright 2018 Seenaptec Ltd. All rights reserved.
 * SEENAPTEC PROPRIETARY/CONFIDENTIAL.
 *
 * $Id$
 */

/*
 * Algorithm.h	(D.Vinnyk)
 * Vipm/ArithLogic/Logical/Algorithm.h
 */

/* ------------------------------------------------------------------------- */

#ifndef __VIPM_ARITHLOGIC_LOGICAL_ALGORITHM_H__
# define __VIPM_ARITHLOGIC_LOGICAL_ALGORITHM_H__

/******************************************************************************
 * %% BeginSection: includes
 */

# ifndef __VIPM_ARITHLOGIC_LOGICAL_TYPES_H__
#  include "Vipm/ArithLogic/Logical/Types.h"
# endif


/******************************************************************************
 * %% BeginSection: function prototypes
 */
# pragma mark -
# pragma mark [ function prototypes ]
# pragma mark -

# include <Vipm/Linkage.h>
# define __PUB __myc_flinkage__(public,libVipm)
# define __PRIV __myc_flinkage__(private,libVipm)
__MYC_BEGIN_CDECLS

/*
 * Generic
 */

/*
 * AND
 */

__PUB bo_status_t
VipmTGAand(
#if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_rref_t                     aParm, /* unused */
	vipm_rank_t                     aRank,
	vipm_int const                  aVolume[],
	vipm_uint                       anElemTypeDst,
	vipm_mutptr_t                   aBaseDst,  vipm_int const aStartDst[], vipm_int const aStrideDst[],
	vipm_uint                       anElemTypeSrc1,
	vipm_imuptr_t                   aBaseSrc1, vipm_int const aStartSrc1[], vipm_int const aStrideSrc1[],
	vipm_uint                       anElemTypeSrc2,
	vipm_imuptr_t                   aBaseSrc2, vipm_int const aStartSrc2[], vipm_int const aStrideSrc2[]
#endif
	);

#if 0 /* @todo: fixme - and TGA pack functions for operations with scalar */
__PUB bo_status_t
VipmTGAandC(
#if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_rref_t                     aParm, /* unused */
	vipm_rank_t                     aRank,
	vipm_int const                  aVolume[],
	vipm_uint                       anElemTypeDst,
	vipm_mutptr_t                   aBaseDst,  vipm_int const aStartDst[], vipm_int const aStrideDst[],
	vipm_uint                       anElemTypeSrc1,
	vipm_imuptr_t                   aBaseSrc1, vipm_int const aStartSrc1[], vipm_int const aStrideSrc1[],
	vipm_uint                       anElemTypeSrc2, /* unused, assumed scalar */
	vipm_imuptr_t                   aBaseSrc2,
	vipm_int const                  aStartSrc2[], vipm_int const aStrideSrc2[] /* both unused, assumed NULL */
#endif
	);
#endif /* if (0) */

/*
 * ORR
 */

__PUB bo_status_t
VipmTGAorr(
#if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_rref_t                     aParm, /* unused */
	vipm_rank_t                     aRank,
	vipm_int const                  aVolume[],
	vipm_uint                       anElemTypeDst,
	vipm_mutptr_t                   aBaseDst,  vipm_int const aStartDst[], vipm_int const aStrideDst[],
	vipm_uint                       anElemTypeSrc1,
	vipm_imuptr_t                   aBaseSrc1, vipm_int const aStartSrc1[], vipm_int const aStrideSrc1[],
	vipm_uint                       anElemTypeSrc2,
	vipm_imuptr_t                   aBaseSrc2, vipm_int const aStartSrc2[], vipm_int const aStrideSrc2[]
#endif
	);

#if 0 /* @todo: fixme - and TGA pack functions for operations with scalar */
__PUB bo_status_t
VipmTGAorrC(
#if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_rref_t                     aParm, /* unused */
	vipm_rank_t                     aRank,
	vipm_int const                  aVolume[],
	vipm_uint                       anElemTypeDst,
	vipm_mutptr_t                   aBaseDst,  vipm_int const aStartDst[], vipm_int const aStrideDst[],
	vipm_uint                       anElemTypeSrc1,
	vipm_imuptr_t                   aBaseSrc1, vipm_int const aStartSrc1[], vipm_int const aStrideSrc1[],
	vipm_uint                       anElemTypeSrc2, /* unused, assumed scalar */
	vipm_imuptr_t                   aBaseSrc2,
	vipm_int const                  aStartSrc2[], vipm_int const aStrideSrc2[] /* both unused, assumed NULL */
#endif
	);
#endif /* if (0) */

__PUB bo_status_t
VipmTGAxor(
#if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_rref_t                     aParm, /* unused */
	vipm_rank_t                     aRank,
	vipm_int const                  aVolume[],
	vipm_uint                       anElemTypeDst,
	vipm_mutptr_t                   aBaseDst,  vipm_int const aStartDst[], vipm_int const aStrideDst[],
	vipm_uint                       anElemTypeSrc1,
	vipm_imuptr_t                   aBaseSrc1, vipm_int const aStartSrc1[], vipm_int const aStrideSrc1[],
	vipm_uint                       anElemTypeSrc2,
	vipm_imuptr_t                   aBaseSrc2, vipm_int const aStartSrc2[], vipm_int const aStrideSrc2[]
#endif
	);

#if 0 /* @todo: fixme - and TGA pack functions for operations with scalar */
__PUB bo_status_t
VipmTGAxorC(
#if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_rref_t                     aParm, /* unused */
	vipm_rank_t                     aRank,
	vipm_int const                  aVolume[],
	vipm_uint                       anElemTypeDst,
	vipm_mutptr_t                   aBaseDst,  vipm_int const aStartDst[], vipm_int const aStrideDst[],
	vipm_uint                       anElemTypeSrc1,
	vipm_imuptr_t                   aBaseSrc1, vipm_int const aStartSrc1[], vipm_int const aStrideSrc1[],
	vipm_uint                       anElemTypeSrc2, /* unused, assumed scalar */
	vipm_imuptr_t                   aBaseSrc2,
	vipm_int const                  aStartSrc2[], vipm_int const aStrideSrc2[] /* both unused, assumed NULL */
#endif
	);
#endif /* if (0) */

/*
 * NOT
 */

__PUB bo_status_t
VipmTGAnot(
#if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_rref_t                     aParm, /* unused */
	vipm_rank_t                     aRank,
	vipm_int const                  aVolume[],
	vipm_uint                       anElemTypeDst,
	vipm_mutptr_t                   aBaseDst,  vipm_int const aStartDst[], vipm_int const aStrideDst[],
	vipm_uint                       anElemTypeSrc,
	vipm_imuptr_t                   aBaseSrc, vipm_int const aStartSrc[], vipm_int const aStrideSrc[]
#endif
	);


/* ========================================================================= */

/*
 * AND
 */

__PUB bo_status_t
vipma_and(
#if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_rank_t                     aRank,
	vipm_int const                  aVolume[],
	vipm_uint                       anElemTypeDst,
	vipm_mutptr_t                   aBaseDst,  vipm_int const aStartDst[], vipm_int const aStrideDst[],
	vipm_uint                       anElemTypeSrc1,
	vipm_imuptr_t                   aBaseSrc1, vipm_int const aStartSrc1[], vipm_int const aStrideSrc1[],
	vipm_uint                       anElemTypeSrc2,
	vipm_imuptr_t                   aBaseSrc2, vipm_int const aStartSrc2[], vipm_int const aStrideSrc2[]
#endif
	);

__PUB bo_status_t
vipma_andC(
#if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_rank_t                     aRank,
	vipm_int const                  aVolume[],
	vipm_uint                       anElemTypeDst,
	vipm_mutptr_t                   aBaseDst,  vipm_int const aStartDst[], vipm_int const aStrideDst[],
	vipm_uint                       anElemTypeSrc1,
	vipm_imuptr_t                   aBaseSrc1, vipm_int const aStartSrc1[], vipm_int const aStrideSrc1[],
	vipm_imuptr_t                   aSrc2
#endif
	);

/*
 * ORR
 */

__PUB bo_status_t
vipma_orr(
#if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_rank_t                     aRank,
	vipm_int const                  aVolume[],
	vipm_uint                       anElemTypeDst,
	vipm_mutptr_t                   aBaseDst,  vipm_int const aStartDst[], vipm_int const aStrideDst[],
	vipm_uint                       anElemTypeSrc1,
	vipm_imuptr_t                   aBaseSrc1, vipm_int const aStartSrc1[], vipm_int const aStrideSrc1[],
	vipm_uint                       anElemTypeSrc2,
	vipm_imuptr_t                   aBaseSrc2, vipm_int const aStartSrc2[], vipm_int const aStrideSrc2[]
#endif
	);

__PUB bo_status_t
vipma_orrC(
#if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_rank_t                     aRank,
	vipm_int const                  aVolume[],
	vipm_uint                       anElemTypeDst,
	vipm_mutptr_t                   aBaseDst,  vipm_int const aStartDst[], vipm_int const aStrideDst[],
	vipm_uint                       anElemTypeSrc1,
	vipm_imuptr_t                   aBaseSrc1, vipm_int const aStartSrc1[], vipm_int const aStrideSrc1[],
	vipm_imuptr_t                   aSrc2
#endif
	);

__PUB bo_status_t
vipma_xor(
#if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_rank_t                     aRank,
	vipm_int const                  aVolume[],
	vipm_uint                       anElemTypeDst,
	vipm_mutptr_t                   aBaseDst,  vipm_int const aStartDst[], vipm_int const aStrideDst[],
	vipm_uint                       anElemTypeSrc1,
	vipm_imuptr_t                   aBaseSrc1, vipm_int const aStartSrc1[], vipm_int const aStrideSrc1[],
	vipm_uint                       anElemTypeSrc2,
	vipm_imuptr_t                   aBaseSrc2, vipm_int const aStartSrc2[], vipm_int const aStrideSrc2[]
#endif
	);

__PUB bo_status_t
vipma_xorC(
#if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_rank_t                     aRank,
	vipm_int const                  aVolume[],
	vipm_uint                       anElemTypeDst,
	vipm_mutptr_t                   aBaseDst,  vipm_int const aStartDst[], vipm_int const aStrideDst[],
	vipm_uint                       anElemTypeSrc1,
	vipm_imuptr_t                   aBaseSrc1, vipm_int const aStartSrc1[], vipm_int const aStrideSrc1[],
	vipm_imuptr_t                   aSrc2
#endif
	);


/*
 * NOT
 */

__PUB bo_status_t
vipma_not(
#if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_rank_t                     aRank,
	vipm_int const                  aVolume[],
	vipm_uint                       anElemTypeDst,
	vipm_mutptr_t                   aBaseDst,  vipm_int const aStartDst[], vipm_int const aStrideDst[],
	vipm_uint                       anElemTypeSrc1,
	vipm_imuptr_t                   aBaseSrc1, vipm_int const aStartSrc1[], vipm_int const aStrideSrc1[]
# endif
	);


/* ============================================================================
 * Specialized versions
 */
# pragma mark -

# ifndef __VIPM_ARITHLOGIC_LOGICAL_AND_H__
#  include "Vipm/ArithLogic/Logical/And.h"
# endif

# ifndef __VIPM_ARITHLOGIC_LOGICAL_ORR_H__
#  include "Vipm/ArithLogic/Logical/Orr.h"
# endif

# ifndef __VIPM_ARITHLOGIC_LOGICAL_XOR_H__
#  include "Vipm/ArithLogic/Logical/Xor.h"
# endif

# ifndef __VIPM_ARITHLOGIC_LOGICAL_NOT_H__
#  include "Vipm/ArithLogic/Logical/Not.h"
# endif


__MYC_END_CDECLS
# undef __PUB
# undef __PRIV


#endif /* !defined(__VIPM_ARITHLOGIC_LOGICAL_ALGORITHM_H__) */


/******************************************************************************
 *
 *
 *
 *****************************************************************************/
