/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright 2018 Seenaptec Ltd. All rights reserved.
 * SEENAPTEC PROPRIETARY/CONFIDENTIAL.
 *
 * $Id$
 */

/*
 * And.h	(D.Vinnyk)
 * Vipm/ArithLogic/Logical/And.h
 */

/* ------------------------------------------------------------------------- */

#ifndef __VIPM_ARITHLOGIC_LOGICAL_AND_H__
# define __VIPM_ARITHLOGIC_LOGICAL_AND_H__

/* ============================================================================
 * Specialized versions
 */
# pragma mark -

/*
 * and
 */

/*
 * Source Data types: U8U8
 * Dest Data type   : U8,S16,S32
 */
# define vipma_and_u8u8u8(x,f,rank,vol,D,offsD,strideD,S1,offsS1,strideS1,S2,offsS2,strideS2) \
    vipma_and(x,f,rank,vol,VipmK_ELEMTYPE_U8,D,offsD,strideD,VipmK_ELEMTYPE_U8,S1,offsS1,strideS1,VipmK_ELEMTYPE_U8,S2,offsS2,strideS2)

# define vipma_and_s16u8u8(x,f,rank,vol,D,offsD,strideD,S1,offsS1,strideS1,S2,offsS2,strideS2) \
    vipma_and(x,f,rank,vol,VipmK_ELEMTYPE_S16,D,offsD,strideD,VipmK_ELEMTYPE_U8,S1,offsS1,strideS1,VipmK_ELEMTYPE_U8,S2,offsS2,strideS2)

# define vipma_and_s32u8u8(x,f,rank,vol,D,offsD,strideD,S1,offsS1,strideS1,S2,offsS2,strideS2) \
    vipma_and(x,f,rank,vol,VipmK_ELEMTYPE_S32,D,offsD,strideD,VipmK_ELEMTYPE_U8,S1,offsS1,strideS1,VipmK_ELEMTYPE_U8,S2,offsS2,strideS2)

/*
 * Source Data types: U8S16
 * Dest Data type   : U8,S16,S32
 */
# define vipma_and_u8u8s16(x,f,rank,vol,D,offsD,strideD,S1,offsS1,strideS1,S2,offsS2,strideS2) \
    vipma_and(x,f,rank,vol,VipmK_ELEMTYPE_U8,D,offsD,strideD,VipmK_ELEMTYPE_U8,S1,offsS1,strideS1,VipmK_ELEMTYPE_S16,S2,offsS2,strideS2)

# define vipma_and_s16u8s16(x,f,rank,vol,D,offsD,strideD,S1,offsS1,strideS1,S2,offsS2,strideS2) \
    vipma_and(x,f,rank,vol,VipmK_ELEMTYPE_S16,D,offsD,strideD,VipmK_ELEMTYPE_U8,S1,offsS1,strideS1,VipmK_ELEMTYPE_S16,S2,offsS2,strideS2)

# define vipma_and_s32u8s16(x,f,rank,vol,D,offsD,strideD,S1,offsS1,strideS1,S2,offsS2,strideS2) \
    vipma_and(x,f,rank,vol,VipmK_ELEMTYPE_S32,D,offsD,strideD,VipmK_ELEMTYPE_U8,S1,offsS1,strideS1,VipmK_ELEMTYPE_S16,S2,offsS2,strideS2)

/*
 * Source Data types: U8S32
 * Dest Data type   : U8,S16,S32
 */
# define vipma_and_u8u8s32(x,f,rank,vol,D,offsD,strideD,S1,offsS1,strideS1,S2,offsS2,strideS2) \
    vipma_and(x,f,rank,vol,VipmK_ELEMTYPE_U8,D,offsD,strideD,VipmK_ELEMTYPE_U8,S1,offsS1,strideS1,VipmK_ELEMTYPE_S32,S2,offsS2,strideS2)

# define vipma_and_s16u8s32(x,f,rank,vol,D,offsD,strideD,S1,offsS1,strideS1,S2,offsS2,strideS2) \
    vipma_and(x,f,rank,vol,VipmK_ELEMTYPE_S16,D,offsD,strideD,VipmK_ELEMTYPE_U8,S1,offsS1,strideS1,VipmK_ELEMTYPE_S32,S2,offsS2,strideS2)

# define vipma_and_s32u8s32(x,f,rank,vol,D,offsD,strideD,S1,offsS1,strideS1,S2,offsS2,strideS2) \
    vipma_and(x,f,rank,vol,VipmK_ELEMTYPE_S32,D,offsD,strideD,VipmK_ELEMTYPE_U8,S1,offsS1,strideS1,VipmK_ELEMTYPE_S32,S2,offsS2,strideS2)

/*
 * Source Data types: S16U8
 * Dest Data type   : U8,S16,S32
 */
# define vipma_and_u8s16u8(x,f,rank,vol,D,offsD,strideD,S1,offsS1,strideS1,S2,offsS2,strideS2) \
    vipma_and(x,f,rank,vol,VipmK_ELEMTYPE_U8,D,offsD,strideD,VipmK_ELEMTYPE_S16,S1,offsS1,strideS1,VipmK_ELEMTYPE_U8,S2,offsS2,strideS2)

# define vipma_and_s16s16u8(x,f,rank,vol,D,offsD,strideD,S1,offsS1,strideS1,S2,offsS2,strideS2) \
    vipma_and(x,f,rank,vol,VipmK_ELEMTYPE_S16,D,offsD,strideD,VipmK_ELEMTYPE_S16,S1,offsS1,strideS1,VipmK_ELEMTYPE_U8,S2,offsS2,strideS2)

# define vipma_and_s32s16u8(x,f,rank,vol,D,offsD,strideD,S1,offsS1,strideS1,S2,offsS2,strideS2) \
    vipma_and(x,f,rank,vol,VipmK_ELEMTYPE_S32,D,offsD,strideD,VipmK_ELEMTYPE_S16,S1,offsS1,strideS1,VipmK_ELEMTYPE_U8,S2,offsS2,strideS2)

/*
 * Source Data types: S16S16
 * Dest Data type   : U8,S16,S32
 */
# define vipma_and_u8s16s16(x,f,rank,vol,D,offsD,strideD,S1,offsS1,strideS1,S2,offsS2,strideS2) \
    vipma_and(x,f,rank,vol,VipmK_ELEMTYPE_U8,D,offsD,strideD,VipmK_ELEMTYPE_S16,S1,offsS1,strideS1,VipmK_ELEMTYPE_S16,S2,offsS2,strideS2)

# define vipma_and_s16s16s16(x,f,rank,vol,D,offsD,strideD,S1,offsS1,strideS1,S2,offsS2,strideS2) \
    vipma_and(x,f,rank,vol,VipmK_ELEMTYPE_S16,D,offsD,strideD,VipmK_ELEMTYPE_S16,S1,offsS1,strideS1,VipmK_ELEMTYPE_S16,S2,offsS2,strideS2)

# define vipma_and_s32s16s16(x,f,rank,vol,D,offsD,strideD,S1,offsS1,strideS1,S2,offsS2,strideS2) \
    vipma_and(x,f,rank,vol,VipmK_ELEMTYPE_S32,D,offsD,strideD,VipmK_ELEMTYPE_S16,S1,offsS1,strideS1,VipmK_ELEMTYPE_S16,S2,offsS2,strideS2)

/*
 * Source Data types: S16S32
 * Dest Data type   : U8,S16,S32
 */
# define vipma_and_u8s16s32(x,f,rank,vol,D,offsD,strideD,S1,offsS1,strideS1,S2,offsS2,strideS2) \
    vipma_and(x,f,rank,vol,VipmK_ELEMTYPE_U8,D,offsD,strideD,VipmK_ELEMTYPE_S16,S1,offsS1,strideS1,VipmK_ELEMTYPE_S32,S2,offsS2,strideS2)

# define vipma_and_s16s16s32(x,f,rank,vol,D,offsD,strideD,S1,offsS1,strideS1,S2,offsS2,strideS2) \
    vipma_and(x,f,rank,vol,VipmK_ELEMTYPE_S16,D,offsD,strideD,VipmK_ELEMTYPE_S16,S1,offsS1,strideS1,VipmK_ELEMTYPE_S32,S2,offsS2,strideS2)

# define vipma_and_s32s16s32(x,f,rank,vol,D,offsD,strideD,S1,offsS1,strideS1,S2,offsS2,strideS2) \
    vipma_and(x,f,rank,vol,VipmK_ELEMTYPE_S32,D,offsD,strideD,VipmK_ELEMTYPE_S16,S1,offsS1,strideS1,VipmK_ELEMTYPE_S32,S2,offsS2,strideS2)

/*
 * Source Data types: S32U8
 * Dest Data type   : U8,S16,S32
 */
# define vipma_and_u8s32u8(x,f,rank,vol,D,offsD,strideD,S1,offsS1,strideS1,S2,offsS2,strideS2) \
    vipma_and(x,f,rank,vol,VipmK_ELEMTYPE_U8,D,offsD,strideD,VipmK_ELEMTYPE_S32,S1,offsS1,strideS1,VipmK_ELEMTYPE_U8,S2,offsS2,strideS2)

# define vipma_and_s16s32u8(x,f,rank,vol,D,offsD,strideD,S1,offsS1,strideS1,S2,offsS2,strideS2) \
    vipma_and(x,f,rank,vol,VipmK_ELEMTYPE_S16,D,offsD,strideD,VipmK_ELEMTYPE_S32,S1,offsS1,strideS1,VipmK_ELEMTYPE_U8,S2,offsS2,strideS2)

# define vipma_and_s32s32u8(x,f,rank,vol,D,offsD,strideD,S1,offsS1,strideS1,S2,offsS2,strideS2) \
    vipma_and(x,f,rank,vol,VipmK_ELEMTYPE_S32,D,offsD,strideD,VipmK_ELEMTYPE_S32,S1,offsS1,strideS1,VipmK_ELEMTYPE_U8,S2,offsS2,strideS2)

/*
 * Source Data types: S32S16
 * Dest Data type   : U8,S16,S32
 */
# define vipma_and_u8s32s16(x,f,rank,vol,D,offsD,strideD,S1,offsS1,strideS1,S2,offsS2,strideS2) \
    vipma_and(x,f,rank,vol,VipmK_ELEMTYPE_U8,D,offsD,strideD,VipmK_ELEMTYPE_S32,S1,offsS1,strideS1,VipmK_ELEMTYPE_S16,S2,offsS2,strideS2)

# define vipma_and_s16s32s16(x,f,rank,vol,D,offsD,strideD,S1,offsS1,strideS1,S2,offsS2,strideS2) \
    vipma_and(x,f,rank,vol,VipmK_ELEMTYPE_S16,D,offsD,strideD,VipmK_ELEMTYPE_S32,S1,offsS1,strideS1,VipmK_ELEMTYPE_S16,S2,offsS2,strideS2)

# define vipma_and_s32s32s16(x,f,rank,vol,D,offsD,strideD,S1,offsS1,strideS1,S2,offsS2,strideS2) \
    vipma_and(x,f,rank,vol,VipmK_ELEMTYPE_S32,D,offsD,strideD,VipmK_ELEMTYPE_S32,S1,offsS1,strideS1,VipmK_ELEMTYPE_S16,S2,offsS2,strideS2)

/*
 * Source Data types: S32S32
 * Dest Data type   : U8,S16,S32
 */
# define vipma_and_u8s32s32(x,f,rank,vol,D,offsD,strideD,S1,offsS1,strideS1,S2,offsS2,strideS2) \
    vipma_and(x,f,rank,vol,VipmK_ELEMTYPE_U8,D,offsD,strideD,VipmK_ELEMTYPE_S32,S1,offsS1,strideS1,VipmK_ELEMTYPE_S32,S2,offsS2,strideS2)

# define vipma_and_s16s32s32(x,f,rank,vol,D,offsD,strideD,S1,offsS1,strideS1,S2,offsS2,strideS2) \
    vipma_and(x,f,rank,vol,VipmK_ELEMTYPE_S16,D,offsD,strideD,VipmK_ELEMTYPE_S32,S1,offsS1,strideS1,VipmK_ELEMTYPE_S32,S2,offsS2,strideS2)

# define vipma_and_s32s32s32(x,f,rank,vol,D,offsD,strideD,S1,offsS1,strideS1,S2,offsS2,strideS2) \
    vipma_and(x,f,rank,vol,VipmK_ELEMTYPE_S32,D,offsD,strideD,VipmK_ELEMTYPE_S32,S1,offsS1,strideS1,VipmK_ELEMTYPE_S32,S2,offsS2,strideS2)

/*
 * andC
 */

/*
 * Source Data type: U8
 * Dest Data type  : U8,S16,S32
 */
# define vipma_andC_u8u8(x,f,rank,vol,D,offsD,strideD,S1,offsS1,strideS1,S2) \
    vipma_andC(x,f,rank,vol,VipmK_ELEMTYPE_U8,D,offsD,strideD,VipmK_ELEMTYPE_U8,S1,offsS1,strideS1,S2)

# define vipma_andC_s16u8(x,f,rank,vol,D,offsD,strideD,S1,offsS1,strideS1,S2) \
    vipma_andC(x,f,rank,vol,VipmK_ELEMTYPE_S16,D,offsD,strideD,VipmK_ELEMTYPE_U8,S1,offsS1,strideS1,S2)

# define vipma_andC_s32u8(x,f,rank,vol,D,offsD,strideD,S1,offsS1,strideS1,S2) \
    vipma_andC(x,f,rank,vol,VipmK_ELEMTYPE_S32,D,offsD,strideD,VipmK_ELEMTYPE_U8,S1,offsS1,strideS1,S2)

/*
 * Source Data type: S16
 * Dest Data type  : U8,S16,S32
 */
# define vipma_andC_u8s16(x,f,rank,vol,D,offsD,strideD,S1,offsS1,strideS1,S2) \
    vipma_andC(x,f,rank,vol,VipmK_ELEMTYPE_U8,D,offsD,strideD,VipmK_ELEMTYPE_U8,S1,offsS1,strideS1,S2)

# define vipma_andC_s16s16(x,f,rank,vol,D,offsD,strideD,S1,offsS1,strideS1,S2) \
    vipma_andC(x,f,rank,vol,VipmK_ELEMTYPE_S16,D,offsD,strideD,VipmK_ELEMTYPE_U8,S1,offsS1,strideS1,S2)

# define vipma_andC_s32s16(x,f,rank,vol,D,offsD,strideD,S1,offsS1,strideS1,S2) \
    vipma_andC(x,f,rank,vol,VipmK_ELEMTYPE_S32,D,offsD,strideD,VipmK_ELEMTYPE_U8,S1,offsS1,strideS1,S2)

/*
 * Source Data type: S32
 * Dest Data type  : U8,S16,S32
 */
# define vipma_andC_u8s32(x,f,rank,vol,D,offsD,strideD,S1,offsS1,strideS1,S2) \
    vipma_andC(x,f,rank,vol,VipmK_ELEMTYPE_U8,D,offsD,strideD,VipmK_ELEMTYPE_U8,S1,offsS1,strideS1,S2)

# define vipma_andC_s16s32(x,f,rank,vol,D,offsD,strideD,S1,offsS1,strideS1,S2) \
    vipma_andC(x,f,rank,vol,VipmK_ELEMTYPE_S16,D,offsD,strideD,VipmK_ELEMTYPE_U8,S1,offsS1,strideS1,S2)

# define vipma_andC_s32s32(x,f,rank,vol,D,offsD,strideD,S1,offsS1,strideS1,S2) \
    vipma_andC(x,f,rank,vol,VipmK_ELEMTYPE_S32,D,offsD,strideD,VipmK_ELEMTYPE_U8,S1,offsS1,strideS1,S2)


#endif /* !defined(__VIPM_ARITHLOGIC_LOGICAL_AND_H__) */


/******************************************************************************
 *
 *
 *
 *****************************************************************************/
