/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright 2018 Seenaptec Ltd. All rights reserved.
 * SEENAPTEC PROPRIETARY/CONFIDENTIAL.
 *
 * $Id$
 */

/*
 * Not.h	(D.Vinnyk)
 * Vipm/ArithLogic/Logical/Not.h
 */

/* ------------------------------------------------------------------------- */

#ifndef __VIPM_ARITHLOGIC_LOGICAL_NOT_H__
# define __VIPM_ARITHLOGIC_LOGICAL_NOT_H__

/* ============================================================================
 * Specialized versions
 */
# pragma mark -

/*
 * not
 */

/*
 * Source Data type: U8
 * Dest Data type  : U8,S16,S32
 */
# define vipma_not_u8u8(x,f,rank,vol,D,offsD,strideD,S1,offsS1,strideS1) \
    vipma_not(x,f,rank,vol,VipmK_ELEMTYPE_U8,D,offsD,strideD,VipmK_ELEMTYPE_U8,S1,offsS1,strideS1)

# define vipma_not_s16u8(x,f,rank,vol,D,offsD,strideD,S1,offsS1,strideS1) \
    vipma_not(x,f,rank,vol,VipmK_ELEMTYPE_S16,D,offsD,strideD,VipmK_ELEMTYPE_U8,S1,offsS1,strideS1)

# define vipma_not_s32u8(x,f,rank,vol,D,offsD,strideD,S1,offsS1,strideS1) \
    vipma_not(x,f,rank,vol,VipmK_ELEMTYPE_S32,D,offsD,strideD,VipmK_ELEMTYPE_U8,S1,offsS1,strideS1)

/*
 * Source Data type: S16
 * Dest Data type  : U8,S16,S32
 */
# define vipma_not_u8s16(x,f,rank,vol,D,offsD,strideD,S1,offsS1,strideS1) \
    vipma_not(x,f,rank,vol,VipmK_ELEMTYPE_U8,D,offsD,strideD,VipmK_ELEMTYPE_U8,S1,offsS1,strideS1)

# define vipma_not_s16s16(x,f,rank,vol,D,offsD,strideD,S1,offsS1,strideS1) \
    vipma_not(x,f,rank,vol,VipmK_ELEMTYPE_S16,D,offsD,strideD,VipmK_ELEMTYPE_U8,S1,offsS1,strideS1)

# define vipma_not_s32s16(x,f,rank,vol,D,offsD,strideD,S1,offsS1,strideS1) \
    vipma_not(x,f,rank,vol,VipmK_ELEMTYPE_S32,D,offsD,strideD,VipmK_ELEMTYPE_U8,S1,offsS1,strideS1)

/*
 * Source Data type: S32
 * Dest Data type  : U8,S16,S32
 */
# define vipma_not_u8s32(x,f,rank,vol,D,offsD,strideD,S1,offsS1,strideS1) \
    vipma_not(x,f,rank,vol,VipmK_ELEMTYPE_U8,D,offsD,strideD,VipmK_ELEMTYPE_U8,S1,offsS1,strideS1)

# define vipma_not_s16s32(x,f,rank,vol,D,offsD,strideD,S1,offsS1,strideS1) \
    vipma_not(x,f,rank,vol,VipmK_ELEMTYPE_S16,D,offsD,strideD,VipmK_ELEMTYPE_U8,S1,offsS1,strideS1)

# define vipma_not_s32s32(x,f,rank,vol,D,offsD,strideD,S1,offsS1,strideS1) \
    vipma_not(x,f,rank,vol,VipmK_ELEMTYPE_S32,D,offsD,strideD,VipmK_ELEMTYPE_U8,S1,offsS1,strideS1)


#endif /* !defined(__VIPM_ARITHLOGIC_LOGICAL_NOT_H__) */


/******************************************************************************
 *
 *
 *
 *****************************************************************************/
