/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright 2018 Seenaptec Ltd. All rights reserved.
 * SEENAPTEC PROPRIETARY/CONFIDENTIAL.
 *
 * $Id$
 */

/*
 * Types.h	(D.Vinnyk)
 * Vipm/ArithLogic/Logical/Types.h
 */

/* ------------------------------------------------------------------------- */

#ifndef __VIPM_ARITHLOGIC_LOGICAL_TYPES_H__
# define __VIPM_ARITHLOGIC_LOGICAL_TYPES_H__

/******************************************************************************
 * %% BeginSection: includes
 */

# ifndef __VIPM_TYPES_H__
#  include <Vipm/Types.h>
# endif


/******************************************************************************
 * %% BeginSection: types/constants
 */



/* ========================================================================= */

typedef bo_status_t (*vipma_logic_fn)(
# if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_rank_t                     aRank,
	vipm_int const                  aVolume[],
	vipm_uint                       anElemTypeDst,
	vipm_mutptr_t                   aBaseDst,  vipm_int const aStartDst[], vipm_int const aStrideDst[],
	vipm_uint                       anElemTypeSrc1,
	vipm_imuptr_t                   aBaseSrc1, vipm_int const aStartSrc1[], vipm_int const aStrideSrc1[]
# endif
	);

typedef bo_status_t (*vipma_logic2_fn)(
# if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_rank_t                     aRank,
	vipm_int const                  aVolume[],
	vipm_uint                       anElemTypeDst,
	vipm_mutptr_t                   aBaseDst,  vipm_int const aStartDst[], vipm_int const aStrideDst[],
	vipm_uint                       anElemTypeSrc1,
	vipm_imuptr_t                   aBaseSrc1, vipm_int const aStartSrc1[], vipm_int const aStrideSrc1[],
	vipm_uint                       anElemTypeSrc2,
	vipm_imuptr_t                   aBaseSrc2, vipm_int const aStartSrc2[], vipm_int const aStrideSrc2[]
# endif
	);

typedef bo_status_t (*vipma_logic2c_fn)(
# if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_rank_t                     aRank,
	vipm_int const                  aVolume[],
	vipm_uint                       anElemTypeDst,
	vipm_mutptr_t                   aBaseDst,  vipm_int const aStartDst[], vipm_int const aStrideDst[],
	vipm_uint                       anElemTypeSrc1,
	vipm_imuptr_t                   aBaseSrc1, vipm_int const aStartSrc1[], vipm_int const aStrideSrc1[],
	vipm_imuptr_t                   aSrc2
# endif
	);


#endif /* !defined(__VIPM_ARITHLOGIC_LOGICAL_TYPES_H__) */


/******************************************************************************
 *
 *
 *
 *****************************************************************************/
