/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright 2016 Seenaptec Ltd. All rights reserved.
 * SEENAPTEC PROPRIETARY/CONFIDENTIAL.
 *
 * $Id$
 */

/*
 * Compare.h	(V.Sokur)
 * Vipm/Comparing/Compare.h
 */

/* ------------------------------------------------------------------------- */

#ifndef __VIPM_COMPARING_COMPARE_H__
# define __VIPM_COMPARING_COMPARE_H__

/******************************************************************************
 * %% BeginSection: includes
 */

# ifndef __VIPM_COMPARING_COMPARE_ALGORITHM_H__
#  include "Vipm/Comparing/Compare/Algorithm.h"
# endif


/******************************************************************************
 * %% BeginSection: function prototypes
 */
# pragma mark -
# pragma mark [ function prototypes ]
# pragma mark -

# include <Vipm/Linkage.h>
# define __PUB  __myc_flinkage__(public,libVipm)
# define __PRIV __myc_flinkage__(private,libVipm)
__MYC_BEGIN_CDECLS

__PUB bo_status_t
VipmCompare(
# if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_mut_array_t                aDest,
	vipm_array_t                    aLhs,
	vipm_array_t                    aRhs,
	vipm_site_t const              *aRoiDst,
	vipm_Npoint_t const            *aStartLhs,
	vipm_Npoint_t const            *aStartRhs,
	vipm_int                        aCmpOp
# endif
	);

__PUB bo_status_t
VipmCompareC(
# if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_mut_array_t                aDest,
	vipm_array_t                    aLhs,
	vipm_scalar_t const            *aRhs,
	vipm_site_t const              *aRoiDst,
	vipm_Npoint_t const            *aStartLhs,
	vipm_int                        aCmpOp
# endif
	);

#if 0
__PUB bo_status_t
VipmCompareEx(
# if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_mut_array_t                aDest,
	vipm_array_t                    aLhs,
	vipm_array_t                    aRhs,
	vipm_array_t                    aMask,
	vipm_site_t const              *aRoiDst,
	vipm_Npoint_t const            *aStartLhs,
	vipm_Npoint_t const            *aStartRhs,
	vipm_Npoint_t const            *aStartMsk,
	vipm_int                        aCmpOp
# endif
	);

__PUB bo_status_t
VipmCompareExC(
# if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_mut_array_t                aDest,
	vipm_array_t                    aLhs,
	vipm_scalar_t const            *aRhs,
	vipm_array_t                    aMask,
	vipm_site_t const              *aRoiDst,
	vipm_Npoint_t const            *aStartLhs,
	vipm_Npoint_t const            *aStartMsk,
	vipm_int                        aCmpOp
# endif
	);
#endif

/* ------------------------------------------------------------------------- */

__PUB bo_status_t
VipmECompare(
# if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_mut_array_t                aDest,
	vipm_array_t                    aLhs,
	vipm_array_t                    aRhs,
	vipm_site_t const              *aRoiDst,
	vipm_Npoint_t const            *aStartLhs,
	vipm_Npoint_t const            *aStartRhs,
	vipm_int                        aCmpOp,
	vipm_scalar_t const             aFillValuevTrue[/* nchannels */],
	vipm_scalar_t const             aFillValuevFalse[/* nchannels */]
# endif
	);

__PUB bo_status_t
VipmECompareC(
# if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_mut_array_t                aDest,
	vipm_array_t                    aLhs,
	vipm_scalar_t const            *aRhs,
	vipm_site_t const              *aRoiDst,
	vipm_Npoint_t const            *aStartLhs,
	vipm_int                        aCmpOp,
	vipm_scalar_t const             aFillValuevTrue[/* nchannels */],
	vipm_scalar_t const             aFillValuevFalse[/* nchannels */]
# endif
	);

#if 0
__PUB bo_status_t
VipmECompareEx(
# if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_mut_array_t                aDest,
	vipm_array_t                    aLhs,
	vipm_array_t                    aRhs,
	vipm_array_t                    aMask,
	vipm_site_t const              *aRoiDst,
	vipm_Npoint_t const            *aStartLhs,
	vipm_Npoint_t const            *aStartRhs,
	vipm_Npoint_t const            *aStartMsk,
	vipm_int                        aCmpOp,
	vipm_scalar_t const             aFillValuevTrue[/* nchannels */],
	vipm_scalar_t const             aFillValuevFalse[/* nchannels */]
# endif
	);

__PUB bo_status_t
VipmECompareExC(
# if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_mut_array_t                aDest,
	vipm_array_t                    aLhs,
	vipm_scalar_t const            *aRhs,
	vipm_array_t                    aMask,
	vipm_site_t const              *aRoiDst,
	vipm_Npoint_t const            *aStartLhs,
	vipm_Npoint_t const            *aStartMsk,
	vipm_int                        aCmpOp,
	vipm_scalar_t const             aFillValuevTrue[/* nchannels */],
	vipm_scalar_t const             aFillValuevFalse[/* nchannels */]
# endif
	);
#endif


__MYC_END_CDECLS
# undef __PUB
# undef __PRIV


#endif /* !defined(__VIPM_COMPARING_COMPARE_H__) */


/******************************************************************************
 *
 *
 *
 *****************************************************************************/
