/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright 2016 Seenaptec Ltd. All rights reserved.
 * SEENAPTEC PROPRIETARY/CONFIDENTIAL.
 *
 * $Id$
 */

/*
 * Algorithm.h	(V.Sokur)
 * Vipm/Comparing/Compare/Algorithm.h
 */

/* ------------------------------------------------------------------------- */

#ifndef __VIPM_COMPARING_COMPARE_ALGORITHM_H__
# define __VIPM_COMPARING_COMPARE_ALGORITHM_H__

/******************************************************************************
 * %% BeginSection: includes
 */

# ifndef __VIPM_COMPARING_COMPARE_TYPES_H__
#  include "Vipm/Comparing/Compare/Types.h"
# endif


/******************************************************************************
 * %% BeginSection: function prototypes
 */
# pragma mark -
# pragma mark [ function prototypes ]
# pragma mark -

# include <Vipm/Linkage.h>
# define __PUB __myc_flinkage__(public,libVipm)
# define __PRIV __myc_flinkage__(private,libVipm)
__MYC_BEGIN_CDECLS

/*
 * Generic
 */

__PUB bo_status_t
VipmTGAcompare(
# if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_rref_t                     aCmpOp, /* vipm_int */
	vipm_rank_t                     aRank,
	vipm_int const                  aVolume[],
	vipm_uint                       anElemTypeDst,
	vipm_mutptr_t                   aBaseDst, vipm_int const aStartDst[], vipm_int const aStrideDst[],
	vipm_uint                       anElemTypeLhs,
	vipm_imuptr_t                   aBaseLhs, vipm_int const aStartLhs[], vipm_int const aStrideLhs[],
	vipm_uint                       anElemTypeRhs,
	vipm_imuptr_t                   aBaseRhs, vipm_int const aStartRhs[], vipm_int const aStrideRhs[]
# endif
	);

__PUB bo_status_t
VipmTGAcompareC(
# if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_rref_t                     aParm, /* (vipm_tga_cmpcparm_t const *) */
	vipm_rank_t                     aRank,
	vipm_int const                  aVolume[],
	vipm_uint                       anElemTypeDst,
	vipm_mutptr_t                   aBaseDst, vipm_int const aStartDst[], vipm_int const aStrideDst[],
	vipm_uint                       anElemTypeLhs,
	vipm_imuptr_t                   aBaseLhs, vipm_int const aStartLhs[], vipm_int const aStrideLhs[]
# endif
	);

__PUB bo_status_t
VipmTGAecompare(
# if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_rref_t                     aParm, /* (vipm_tga_ecmpparm_t const *) */
	vipm_rank_t                     aRank,
	vipm_int const                  aVolume[],
	vipm_uint                       anElemTypeDst,
	vipm_mutptr_t                   aBaseDst, vipm_int const aStartDst[], vipm_int const aStrideDst[],
	vipm_uint                       anElemTypeLhs,
	vipm_imuptr_t                   aBaseLhs, vipm_int const aStartLhs[], vipm_int const aStrideLhs[],
	vipm_uint                       anElemTypeRhs,
	vipm_imuptr_t                   aBaseRhs, vipm_int const aStartRhs[], vipm_int const aStrideRhs[]
# endif
	);

__PUB bo_status_t
VipmTGAecompareC(
# if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_rref_t                     aParm, /* (vipm_tga_ecmpcparm_t const *) */
	vipm_rank_t                     aRank,
	vipm_int const                  aVolume[],
	vipm_uint                       anElemTypeDst,
	vipm_mutptr_t                   aBaseDst, vipm_int const aStartDst[], vipm_int const aStrideDst[],
	vipm_uint                       anElemTypeLhs,
	vipm_imuptr_t                   aBaseLhs, vipm_int const aStartLhs[], vipm_int const aStrideLhs[]
# endif
	);

/* ------------------------------------------------------------------------- */

#if 0
__PUB bo_status_t
VipmTGAcompareEx(
# if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_rref_t                     aCmpOp, /* vipm_int */
	vipm_rank_t                     aRank,
	vipm_int const                  aVolume[],
	vipm_uint                       anElemTypeDst,
	vipm_mutptr_t                   aBaseDst, vipm_int const aStartDst[], vipm_int const aStrideDst[],
	vipm_uint                       anElemTypeLhs,
	vipm_imuptr_t                   aBaseLhs, vipm_int const aStartLhs[], vipm_int const aStrideLhs[],
	vipm_uint                       anElemTypeRhs,
	vipm_imuptr_t                   aBaseRhs, vipm_int const aStartRhs[], vipm_int const aStrideRhs[],
	vipm_uint                       anElemTypeMsk, /* unused, assumed U8 */
	vipm_imuptr_t                   aBaseMsk, vipm_int const aStartMsk[], vipm_int const aStrideMsk[]
# endif
	);

__PUB bo_status_t
VipmTGAcompareExC(
# if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_rref_t                     aParm, /* (vipm_tga_cmpcparm_t const *) */
	vipm_rank_t                     aRank,
	vipm_int const                  aVolume[],
	vipm_uint                       anElemTypeDst,
	vipm_mutptr_t                   aBaseDst, vipm_int const aStartDst[], vipm_int const aStrideDst[],
	vipm_uint                       anElemTypeLhs,
	vipm_imuptr_t                   aBaseLhs, vipm_int const aStartLhs[], vipm_int const aStrideLhs[],
	vipm_uint                       anElemTypeMsk, /* unused, assumed U8 */
	vipm_imuptr_t                   aBaseMsk, vipm_int const aStartMsk[], vipm_int const aStrideMsk[]
# endif
	);

__PUB bo_status_t
VipmTGAecompareEx(
# if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_rref_t                     aParm, /* (vipm_tga_ecmpparm_t const *) */
	vipm_rank_t                     aRank,
	vipm_int const                  aVolume[],
	vipm_uint                       anElemTypeDst,
	vipm_mutptr_t                   aBaseDst, vipm_int const aStartDst[], vipm_int const aStrideDst[],
	vipm_uint                       anElemTypeLhs,
	vipm_imuptr_t                   aBaseLhs, vipm_int const aStartLhs[], vipm_int const aStrideLhs[],
	vipm_uint                       anElemTypeRhs,
	vipm_imuptr_t                   aBaseRhs, vipm_int const aStartRhs[], vipm_int const aStrideRhs[],
	vipm_uint                       anElemTypeMsk, /* unused, assumed U8 */
	vipm_imuptr_t                   aBaseMsk, vipm_int const aStartMsk[], vipm_int const aStrideMsk[]
# endif
	);

__PUB bo_status_t
VipmTGAecompareExC(
# if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_rref_t                     aParm, /* (vipm_tga_ecmpcparm_t const *) */
	vipm_rank_t                     aRank,
	vipm_int const                  aVolume[],
	vipm_uint                       anElemTypeDst,
	vipm_mutptr_t                   aBaseDst, vipm_int const aStartDst[], vipm_int const aStrideDst[],
	vipm_uint                       anElemTypeLhs,
	vipm_imuptr_t                   aBaseLhs, vipm_int const aStartLhs[], vipm_int const aStrideLhs[],
	vipm_uint                       anElemTypeMsk, /* unused, assumed U8 */
	vipm_imuptr_t                   aBaseMsk, vipm_int const aStartMsk[], vipm_int const aStrideMsk[]
# endif
	);
#endif


/* ========================================================================= */

__PUB bo_status_t
vipma_compare(
# if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_rank_t                     aRank,
	vipm_int const                  aVolume[],
	vipm_uint                       anElemTypeDst,
	vipm_mutptr_t                   aBaseDst, vipm_int const aStartDst[], vipm_int const aStrideDst[],
	vipm_uint                       anElemTypeSrc,
	vipm_imuptr_t                   aBaseLhs, vipm_int const aStartLhs[], vipm_int const aStrideLhs[],
	vipm_imuptr_t                   aBaseRhs, vipm_int const aStartRhs[], vipm_int const aStrideRhs[],
	vipm_int                        aCmpOp
# endif
	);

__PUB bo_status_t
vipma_compareC(
# if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_rank_t                     aRank,
	vipm_int const                  aVolume[],
	vipm_uint                       anElemTypeDst,
	vipm_mutptr_t                   aBaseDst, vipm_int const aStartDst[], vipm_int const aStrideDst[],
	vipm_uint                       anElemTypeLhs,
	vipm_imuptr_t                   aBaseLhs, vipm_int const aStartLhs[], vipm_int const aStrideLhs[],
	vipm_scalar_t const             aRhs[/* nchannels */],
	vipm_int                        aCmpOp
# endif
	);

__PUB bo_status_t
vipma_ecompare(
# if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_rank_t                     aRank,
	vipm_int const                  aVolume[],
	vipm_uint                       anElemTypeDst,
	vipm_mutptr_t                   aBaseDst, vipm_int const aStartDst[], vipm_int const aStrideDst[],
	vipm_uint                       anElemTypeSrc,
	vipm_imuptr_t                   aBaseLhs, vipm_int const aStartLhs[], vipm_int const aStrideLhs[],
	vipm_imuptr_t                   aBaseRhs, vipm_int const aStartRhs[], vipm_int const aStrideRhs[],
	vipm_int                        aCmpOp,
	vipm_scalar_t const             aFillValuevTrue[/* nchannels */],
	vipm_scalar_t const             aFillValuevFalse[/* nchannels */]
# endif
	);

__PUB bo_status_t
vipma_ecompareC(
# if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_rank_t                     aRank,
	vipm_int const                  aVolume[],
	vipm_uint                       anElemTypeDst,
	vipm_mutptr_t                   aBaseDst, vipm_int const aStartDst[], vipm_int const aStrideDst[],
	vipm_uint                       anElemTypeLhs,
	vipm_imuptr_t                   aBaseLhs, vipm_int const aStartLhs[], vipm_int const aStrideLhs[],
	vipm_scalar_t const             aRhs[/* nchannels */],
	vipm_int                        aCmpOp,
	vipm_scalar_t const             aFillValuevTrue[/* nchannels */],
	vipm_scalar_t const             aFillValuevFalse[/* nchannels */]
# endif
	);

/* ------------------------------------------------------------------------- */

#if 0
__PUB bo_status_t
vipma_comparexm(
# if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_rank_t                     aRank,
	vipm_int const                  aVolume[],
	vipm_uint                       anElemTypeDst,
	vipm_mutptr_t                   aBaseDst, vipm_int const aStartDst[], vipm_int const aStrideDst[],
	vipm_uint                       anElemTypeSrc,
	vipm_imuptr_t                   aBaseLhs, vipm_int const aStartLhs[], vipm_int const aStrideLhs[],
	vipm_imuptr_t                   aBaseRhs, vipm_int const aStartRhs[], vipm_int const aStrideRhs[],
	vipm_imuptr_t                   aBaseMsk, vipm_int const aStartMsk[], vipm_int const aStrideMsk[],
	vipm_int                        aCmpOp
# endif
	);

__PUB bo_status_t
vipma_comparexmC(
# if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_rank_t                     aRank,
	vipm_int const                  aVolume[],
	vipm_uint                       anElemTypeDst,
	vipm_mutptr_t                   aBaseDst, vipm_int const aStartDst[], vipm_int const aStrideDst[],
	vipm_uint                       anElemTypeLhs,
	vipm_imuptr_t                   aBaseLhs, vipm_int const aStartLhs[], vipm_int const aStrideLhs[],
	vipm_scalar_t const             aRhs[/* nchannels */],
	vipm_imuptr_t                   aBaseMsk, vipm_int const aStartMsk[], vipm_int const aStrideMsk[],
	vipm_int                        aCmpOp
# endif
	);

__PUB bo_status_t
vipma_ecomparexm(
# if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_rank_t                     aRank,
	vipm_int const                  aVolume[],
	vipm_uint                       anElemTypeDst,
	vipm_mutptr_t                   aBaseDst, vipm_int const aStartDst[], vipm_int const aStrideDst[],
	vipm_uint                       anElemTypeSrc,
	vipm_imuptr_t                   aBaseLhs, vipm_int const aStartLhs[], vipm_int const aStrideLhs[],
	vipm_imuptr_t                   aBaseRhs, vipm_int const aStartRhs[], vipm_int const aStrideRhs[],
	vipm_imuptr_t                   aBaseMsk, vipm_int const aStartMsk[], vipm_int const aStrideMsk[],
	vipm_int                        aCmpOp,
	vipm_scalar_t const             aFillValuevTrue[/* nchannels */],
	vipm_scalar_t const             aFillValuevFalse[/* nchannels */]
# endif
	);

__PUB bo_status_t
vipma_ecomparexmC(
# if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_rank_t                     aRank,
	vipm_int const                  aVolume[],
	vipm_uint                       anElemTypeDst,
	vipm_mutptr_t                   aBaseDst, vipm_int const aStartDst[], vipm_int const aStrideDst[],
	vipm_uint                       anElemTypeLhs,
	vipm_imuptr_t                   aBaseLhs, vipm_int const aStartLhs[], vipm_int const aStrideLhs[],
	vipm_scalar_t const             aRhs[/* nchannels */],
	vipm_imuptr_t                   aBaseMsk, vipm_int const aStartMsk[], vipm_int const aStrideMsk[],
	vipm_int                        aCmpOp,
	vipm_scalar_t const             aFillValuevTrue[/* nchannels */],
	vipm_scalar_t const             aFillValuevFalse[/* nchannels */]
# endif
	);
#endif


/* ============================================================================
 * Specialized versions
 */
# pragma mark -

/*
 * compare (partial)
 *
 * Dest Data type            : U8
 * Source(Lhs,Rhs) Data type : U8,S16,S32, F32
 */

# define vipma_compare_u8           vipma_compare_u8u8
# define vipma_compare_s16          vipma_compare_u8s16
# define vipma_compare_s32          vipma_compare_u8s32
# define vipma_compare_f32          vipma_compare_u8f32

/* ------------------------------------------------------------------------- */

# define vipma_compare_u8u8(x,f,rank,vol,D,offsD,strideD,S1,offsS1,strideS1,S2,offsS2,strideS2,op) \
	vipma_compare(x,f,rank,vol,VipmK_ELEMTYPE_U8,D,offsD,strideD,VipmK_ELEMTYPE_U8,S1,offsS1,strideS1,S2,offsS2,strideS2,op)

# define vipma_compare_u8s16(x,f,rank,vol,D,offsD,strideD,S1,offsS1,strideS1,S2,offsS2,strideS2,op) \
	vipma_compare(x,f,rank,vol,VipmK_ELEMTYPE_U8,D,offsD,strideD,VipmK_ELEMTYPE_S16,S1,offsS1,strideS1,S2,offsS2,strideS2,op)

# define vipma_compare_u8s32(x,f,rank,vol,D,offsD,strideD,S1,offsS1,strideS1,S2,offsS2,strideS2,op) \
	vipma_compare(x,f,rank,vol,VipmK_ELEMTYPE_U8,D,offsD,strideD,VipmK_ELEMTYPE_S32,S1,offsS1,strideS1,S2,offsS2,strideS2,op)

# define vipma_compare_u8f32(x,f,rank,vol,D,offsD,strideD,S1,offsS1,strideS1,S2,offsS2,strideS2,op) \
	vipma_compare(x,f,rank,vol,VipmK_ELEMTYPE_U8,D,offsD,strideD,VipmK_ELEMTYPE_F32,S1,offsS1,strideS1,S2,offsS2,strideS2,op)

/* ------------------------------------------------------------------------- */

# define vipma_compare_s16u8(x,f,rank,vol,D,offsD,strideD,S1,offsS1,strideS1,S2,offsS2,strideS2,op) \
	vipma_compare(x,f,rank,vol,VipmK_ELEMTYPE_S16,D,offsD,strideD,VipmK_ELEMTYPE_U8,S1,offsS1,strideS1,S2,offsS2,strideS2,op)

# define vipma_compare_s16s16(x,f,rank,vol,D,offsD,strideD,S1,offsS1,strideS1,S2,offsS2,strideS2,op) \
	vipma_compare(x,f,rank,vol,VipmK_ELEMTYPE_S16,D,offsD,strideD,VipmK_ELEMTYPE_S16,S1,offsS1,strideS1,S2,offsS2,strideS2,op)

# define vipma_compare_s16s32(x,f,rank,vol,D,offsD,strideD,S1,offsS1,strideS1,S2,offsS2,strideS2,op) \
	vipma_compare(x,f,rank,vol,VipmK_ELEMTYPE_S16,D,offsD,strideD,VipmK_ELEMTYPE_S32,S1,offsS1,strideS1,S2,offsS2,strideS2,op)

# define vipma_compare_s16f32(x,f,rank,vol,D,offsD,strideD,S1,offsS1,strideS1,S2,offsS2,strideS2,op) \
	vipma_compare(x,f,rank,vol,VipmK_ELEMTYPE_S16,D,offsD,strideD,VipmK_ELEMTYPE_F32,S1,offsS1,strideS1,S2,offsS2,strideS2,op)

/* ------------------------------------------------------------------------- */

# define vipma_compare_s32u8(x,f,rank,vol,D,offsD,strideD,S1,offsS1,strideS1,S2,offsS2,strideS2,op) \
	vipma_compare(x,f,rank,vol,VipmK_ELEMTYPE_S32,D,offsD,strideD,VipmK_ELEMTYPE_U8,S1,offsS1,strideS1,S2,offsS2,strideS2,op)

# define vipma_compare_s32s16(x,f,rank,vol,D,offsD,strideD,S1,offsS1,strideS1,S2,offsS2,strideS2,op) \
	vipma_compare(x,f,rank,vol,VipmK_ELEMTYPE_S32,D,offsD,strideD,VipmK_ELEMTYPE_S16,S1,offsS1,strideS1,S2,offsS2,strideS2,op)

# define vipma_compare_s32s32(x,f,rank,vol,D,offsD,strideD,S1,offsS1,strideS1,S2,offsS2,strideS2,op) \
	vipma_compare(x,f,rank,vol,VipmK_ELEMTYPE_S32,D,offsD,strideD,VipmK_ELEMTYPE_S32,S1,offsS1,strideS1,S2,offsS2,strideS2,op)

# define vipma_compare_s32f32(x,f,rank,vol,D,offsD,strideD,S1,offsS1,strideS1,S2,offsS2,strideS2,op) \
	vipma_compare(x,f,rank,vol,VipmK_ELEMTYPE_S32,D,offsD,strideD,VipmK_ELEMTYPE_F32,S1,offsS1,strideS1,S2,offsS2,strideS2,op)

/* ------------------------------------------------------------------------- */

# define vipma_compare_f32f32(x,f,rank,vol,D,offsD,strideD,S1,offsS1,strideS1,S2,offsS2,strideS2,op) \
	vipma_compare(x,f,rank,vol,VipmK_ELEMTYPE_F32,D,offsD,strideD,VipmK_ELEMTYPE_F32,S1,offsS1,strideS1,S2,offsS2,strideS2,op)

/* ------------------------------------------------------------------------- */

/*
 * compareC (partial)
 *
 * Dest Data type            : U8
 * Source(Lhs,Rhs) Data type : U8,S16,S32, F32
 */

# define vipma_compareC_u8          vipma_compareC_u8u8
# define vipma_compareC_s16         vipma_compareC_u8s16
# define vipma_compareC_s32         vipma_compareC_u8s32
# define vipma_compareC_f32         vipma_compareC_u8f32

/* ------------------------------------------------------------------------- */

# define vipma_compareC_u8u8(x,f,rank,vol,D,offsD,strideD,S1,offsS1,strideS1,S2,op) \
	vipma_compareC(x,f,rank,vol,VipmK_ELEMTYPE_U8,D,offsD,strideD,VipmK_ELEMTYPE_U8,S1,offsS1,strideS1,S2,op)

# define vipma_compareC_u8s16(x,f,rank,vol,D,offsD,strideD,S1,offsS1,strideS1,S2,op) \
	vipma_compareC(x,f,rank,vol,VipmK_ELEMTYPE_U8,D,offsD,strideD,VipmK_ELEMTYPE_S16,S1,offsS1,strideS1,S2,op)

# define vipma_compareC_u8s32(x,f,rank,vol,D,offsD,strideD,S1,offsS1,strideS1,S2,op) \
	vipma_compareC(x,f,rank,vol,VipmK_ELEMTYPE_U8,D,offsD,strideD,VipmK_ELEMTYPE_S32,S1,offsS1,strideS1,S2,op)

# define vipma_compareC_u8f32(x,f,rank,vol,D,offsD,strideD,S1,offsS1,strideS1,S2,op) \
	vipma_compareC(x,f,rank,vol,VipmK_ELEMTYPE_U8,D,offsD,strideD,VipmK_ELEMTYPE_F32,S1,offsS1,strideS1,S2,op)

/* ------------------------------------------------------------------------- */

# define vipma_compareC_s16u8(x,f,rank,vol,D,offsD,strideD,S1,offsS1,strideS1,S2,op) \
	vipma_compareC(x,f,rank,vol,VipmK_ELEMTYPE_S16,D,offsD,strideD,VipmK_ELEMTYPE_U8,S1,offsS1,strideS1,S2,op)

# define vipma_compareC_s16s16(x,f,rank,vol,D,offsD,strideD,S1,offsS1,strideS1,S2,op) \
	vipma_compareC(x,f,rank,vol,VipmK_ELEMTYPE_S16,D,offsD,strideD,VipmK_ELEMTYPE_S16,S1,offsS1,strideS1,S2,op)

# define vipma_compareC_s16s32(x,f,rank,vol,D,offsD,strideD,S1,offsS1,strideS1,S2,op) \
	vipma_compareC(x,f,rank,vol,VipmK_ELEMTYPE_S16,D,offsD,strideD,VipmK_ELEMTYPE_S32,S1,offsS1,strideS1,S2,op)

# define vipma_compareC_s16f32(x,f,rank,vol,D,offsD,strideD,S1,offsS1,strideS1,S2,op) \
	vipma_compareC(x,f,rank,vol,VipmK_ELEMTYPE_S16,D,offsD,strideD,VipmK_ELEMTYPE_F32,S1,offsS1,strideS1,S2,op)

/* ------------------------------------------------------------------------- */

# define vipma_compareC_s32u8(x,f,rank,vol,D,offsD,strideD,S1,offsS1,strideS1,S2,op) \
	vipma_compareC(x,f,rank,vol,VipmK_ELEMTYPE_S32,D,offsD,strideD,VipmK_ELEMTYPE_U8,S1,offsS1,strideS1,S2,op)

# define vipma_compareC_s32s16(x,f,rank,vol,D,offsD,strideD,S1,offsS1,strideS1,S2,op) \
	vipma_compareC(x,f,rank,vol,VipmK_ELEMTYPE_S32,D,offsD,strideD,VipmK_ELEMTYPE_S16,S1,offsS1,strideS1,S2,op)

# define vipma_compareC_s32s32(x,f,rank,vol,D,offsD,strideD,S1,offsS1,strideS1,S2,op) \
	vipma_compareC(x,f,rank,vol,VipmK_ELEMTYPE_S32,D,offsD,strideD,VipmK_ELEMTYPE_S32,S1,offsS1,strideS1,S2,op)

# define vipma_compareC_s32f32(x,f,rank,vol,D,offsD,strideD,S1,offsS1,strideS1,S2,op) \
	vipma_compareC(x,f,rank,vol,VipmK_ELEMTYPE_S32,D,offsD,strideD,VipmK_ELEMTYPE_F32,S1,offsS1,strideS1,S2,op)

/* ------------------------------------------------------------------------- */

# define vipma_compareC_f32f32(x,f,rank,vol,D,offsD,strideD,S1,offsS1,strideS1,S2,op) \
	vipma_compareC(x,f,rank,vol,VipmK_ELEMTYPE_F32,D,offsD,strideD,VipmK_ELEMTYPE_F32,S1,offsS1,strideS1,S2,op)

/* ------------------------------------------------------------------------- */

/*
 * ecompare (partial)
 *
 * Dest Data type            : U8,S16,S32, F32
 * Source(Lhs,Rhs) Data type : U8,S16,S32, F32
 */

# define vipma_ecompare_u8          vipma_ecompare_u8u8
# define vipma_ecompare_s16         vipma_ecompare_s16s16
# define vipma_ecompare_s32         vipma_ecompare_s32s32
# define vipma_ecompare_f32         vipma_ecompare_f32f32

/* ------------------------------------------------------------------------- */

# define vipma_ecompare_u8u8(x,f,rank,vol,D,offsD,strideD,S1,offsS1,strideS1,S2,offsS2,strideS2,op,tfval,ffval) \
	vipma_ecompare(x,f,rank,vol,VipmK_ELEMTYPE_U8,D,offsD,strideD,VipmK_ELEMTYPE_U8,S1,offsS1,strideS1,S2,offsS2,strideS2,op,tfval,ffval)

# define vipma_ecompare_u8s16(x,f,rank,vol,D,offsD,strideD,S1,offsS1,strideS1,S2,offsS2,strideS2,op,tfval,ffval) \
	vipma_ecompare(x,f,rank,vol,VipmK_ELEMTYPE_U8,D,offsD,strideD,VipmK_ELEMTYPE_S16,S1,offsS1,strideS1,S2,offsS2,strideS2,op,tfval,ffval)

# define vipma_ecompare_u8s32(x,f,rank,vol,D,offsD,strideD,S1,offsS1,strideS1,S2,offsS2,strideS2,op,tfval,ffval) \
	vipma_ecompare(x,f,rank,vol,VipmK_ELEMTYPE_U8,D,offsD,strideD,VipmK_ELEMTYPE_S32,S1,offsS1,strideS1,S2,offsS2,strideS2,op,tfval,ffval)

# define vipma_ecompare_u8f32(x,f,rank,vol,D,offsD,strideD,S1,offsS1,strideS1,S2,offsS2,strideS2,op,tfval,ffval) \
	vipma_ecompare(x,f,rank,vol,VipmK_ELEMTYPE_U8,D,offsD,strideD,VipmK_ELEMTYPE_F32,S1,offsS1,strideS1,S2,offsS2,strideS2,op,tfval,ffval)

/* ------------------------------------------------------------------------- */

# define vipma_ecompare_s16u8(x,f,rank,vol,D,offsD,strideD,S1,offsS1,strideS1,S2,offsS2,strideS2,op,tfval,ffval) \
	vipma_ecompare(x,f,rank,vol,VipmK_ELEMTYPE_S16,D,offsD,strideD,VipmK_ELEMTYPE_U8,S1,offsS1,strideS1,S2,offsS2,strideS2,op,tfval,ffval)

# define vipma_ecompare_s16s16(x,f,rank,vol,D,offsD,strideD,S1,offsS1,strideS1,S2,offsS2,strideS2,op,tfval,ffval) \
	vipma_ecompare(x,f,rank,vol,VipmK_ELEMTYPE_S16,D,offsD,strideD,VipmK_ELEMTYPE_S16,S1,offsS1,strideS1,S2,offsS2,strideS2,op,tfval,ffval)

# define vipma_ecompare_s16s32(x,f,rank,vol,D,offsD,strideD,S1,offsS1,strideS1,S2,offsS2,strideS2,op,tfval,ffval) \
	vipma_ecompare(x,f,rank,vol,VipmK_ELEMTYPE_S16,D,offsD,strideD,VipmK_ELEMTYPE_S32,S1,offsS1,strideS1,S2,offsS2,strideS2,op,tfval,ffval)

# define vipma_ecompare_s16f32(x,f,rank,vol,D,offsD,strideD,S1,offsS1,strideS1,S2,offsS2,strideS2,op,tfval,ffval) \
	vipma_ecompare(x,f,rank,vol,VipmK_ELEMTYPE_S16,D,offsD,strideD,VipmK_ELEMTYPE_F32,S1,offsS1,strideS1,S2,offsS2,strideS2,op,tfval,ffval)

/* ------------------------------------------------------------------------- */

# define vipma_ecompare_s32u8(x,f,rank,vol,D,offsD,strideD,S1,offsS1,strideS1,S2,offsS2,strideS2,op,tfval,ffval) \
	vipma_ecompare(x,f,rank,vol,VipmK_ELEMTYPE_S32,D,offsD,strideD,VipmK_ELEMTYPE_U8,S1,offsS1,strideS1,S2,offsS2,strideS2,op,tfval,ffval)

# define vipma_ecompare_s32s16(x,f,rank,vol,D,offsD,strideD,S1,offsS1,strideS1,S2,offsS2,strideS2,op,tfval,ffval) \
	vipma_ecompare(x,f,rank,vol,VipmK_ELEMTYPE_S32,D,offsD,strideD,VipmK_ELEMTYPE_S16,S1,offsS1,strideS1,S2,offsS2,strideS2,op,tfval,ffval)

# define vipma_ecompare_s32s32(x,f,rank,vol,D,offsD,strideD,S1,offsS1,strideS1,S2,offsS2,strideS2,op,tfval,ffval) \
	vipma_ecompare(x,f,rank,vol,VipmK_ELEMTYPE_S32,D,offsD,strideD,VipmK_ELEMTYPE_S32,S1,offsS1,strideS1,S2,offsS2,strideS2,op,tfval,ffval)

# define vipma_ecompare_s32f32(x,f,rank,vol,D,offsD,strideD,S1,offsS1,strideS1,S2,offsS2,strideS2,op,tfval,ffval) \
	vipma_ecompare(x,f,rank,vol,VipmK_ELEMTYPE_S32,D,offsD,strideD,VipmK_ELEMTYPE_F32,S1,offsS1,strideS1,S2,offsS2,strideS2,op,tfval,ffval)

/* ------------------------------------------------------------------------- */

# define vipma_ecompare_f32f32(x,f,rank,vol,D,offsD,strideD,S1,offsS1,strideS1,S2,offsS2,strideS2,op,tfval,ffval) \
	vipma_ecompare(x,f,rank,vol,VipmK_ELEMTYPE_F32,D,offsD,strideD,VipmK_ELEMTYPE_F32,S1,offsS1,strideS1,S2,offsS2,strideS2,op,tfval,ffval)

/* ------------------------------------------------------------------------- */

/*
 * ecompareC (partial)
 *
 * Dest Data type            : U8,S16,S32, F32
 * Source(Lhs,Rhs) Data type : U8,S16,S32, F32
 */

# define vipma_ecompareC_u8         vipma_ecompareC_u8u8
# define vipma_ecompareC_s16        vipma_ecompareC_s16s16
# define vipma_ecompareC_s32        vipma_ecompareC_s32s32
# define vipma_ecompareC_f32        vipma_ecompareC_f32f32

/* ------------------------------------------------------------------------- */

# define vipma_ecompareC_u8u8(x,f,rank,vol,D,offsD,strideD,S1,offsS1,strideS1,S2,op,tfval,ffval) \
	vipma_ecompareC(x,f,rank,vol,VipmK_ELEMTYPE_U8,D,offsD,strideD,VipmK_ELEMTYPE_U8,S1,offsS1,strideS1,S2,op,tfval,ffval)

# define vipma_ecompareC_u8s16(x,f,rank,vol,D,offsD,strideD,S1,offsS1,strideS1,S2,op,tfval,ffval) \
	vipma_ecompareC(x,f,rank,vol,VipmK_ELEMTYPE_U8,D,offsD,strideD,VipmK_ELEMTYPE_S16,S1,offsS1,strideS1,S2,op,tfval,ffval)

# define vipma_ecompareC_u8s32(x,f,rank,vol,D,offsD,strideD,S1,offsS1,strideS1,S2,op,tfval,ffval) \
	vipma_ecompareC(x,f,rank,vol,VipmK_ELEMTYPE_U8,D,offsD,strideD,VipmK_ELEMTYPE_S32,S1,offsS1,strideS1,S2,op,tfval,ffval)

# define vipma_ecompareC_u8f32(x,f,rank,vol,D,offsD,strideD,S1,offsS1,strideS1,S2,op,tfval,ffval) \
	vipma_ecompareC(x,f,rank,vol,VipmK_ELEMTYPE_U8,D,offsD,strideD,VipmK_ELEMTYPE_F32,S1,offsS1,strideS1,S2,op,tfval,ffval)

/* ------------------------------------------------------------------------- */

# define vipma_ecompareC_s16u8(x,f,rank,vol,D,offsD,strideD,S1,offsS1,strideS1,S2,op,tfval,ffval) \
	vipma_ecompareC(x,f,rank,vol,VipmK_ELEMTYPE_S16,D,offsD,strideD,VipmK_ELEMTYPE_U8,S1,offsS1,strideS1,S2,op,tfval,ffval)

# define vipma_ecompareC_s16s16(x,f,rank,vol,D,offsD,strideD,S1,offsS1,strideS1,S2,op,tfval,ffval) \
	vipma_ecompareC(x,f,rank,vol,VipmK_ELEMTYPE_S16,D,offsD,strideD,VipmK_ELEMTYPE_S16,S1,offsS1,strideS1,S2,op,tfval,ffval)

# define vipma_ecompareC_s16s32(x,f,rank,vol,D,offsD,strideD,S1,offsS1,strideS1,S2,op,tfval,ffval) \
	vipma_ecompareC(x,f,rank,vol,VipmK_ELEMTYPE_S16,D,offsD,strideD,VipmK_ELEMTYPE_S32,S1,offsS1,strideS1,S2,op,tfval,ffval)

# define vipma_ecompareC_s16f32(x,f,rank,vol,D,offsD,strideD,S1,offsS1,strideS1,S2,op,tfval,ffval) \
	vipma_ecompareC(x,f,rank,vol,VipmK_ELEMTYPE_S16,D,offsD,strideD,VipmK_ELEMTYPE_F32,S1,offsS1,strideS1,S2,op,tfval,ffval)

/* ------------------------------------------------------------------------- */

# define vipma_ecompareC_s32u8(x,f,rank,vol,D,offsD,strideD,S1,offsS1,strideS1,S2,op,tfval,ffval) \
	vipma_ecompareC(x,f,rank,vol,VipmK_ELEMTYPE_S32,D,offsD,strideD,VipmK_ELEMTYPE_U8,S1,offsS1,strideS1,S2,op,tfval,ffval)

# define vipma_ecompareC_s32s16(x,f,rank,vol,D,offsD,strideD,S1,offsS1,strideS1,S2,op,tfval,ffval) \
	vipma_ecompareC(x,f,rank,vol,VipmK_ELEMTYPE_S32,D,offsD,strideD,VipmK_ELEMTYPE_S16,S1,offsS1,strideS1,S2,op,tfval,ffval)

# define vipma_ecompareC_s32s32(x,f,rank,vol,D,offsD,strideD,S1,offsS1,strideS1,S2,op,tfval,ffval) \
	vipma_ecompareC(x,f,rank,vol,VipmK_ELEMTYPE_S32,D,offsD,strideD,VipmK_ELEMTYPE_S32,S1,offsS1,strideS1,S2,op,tfval,ffval)

# define vipma_ecompareC_s32f32(x,f,rank,vol,D,offsD,strideD,S1,offsS1,strideS1,S2,op,tfval,ffval) \
	vipma_ecompareC(x,f,rank,vol,VipmK_ELEMTYPE_S32,D,offsD,strideD,VipmK_ELEMTYPE_F32,S1,offsS1,strideS1,S2,op,tfval,ffval)

/* ------------------------------------------------------------------------- */

# define vipma_ecompareC_f32f32(x,f,rank,vol,D,offsD,strideD,S1,offsS1,strideS1,S2,op,tfval,ffval) \
	vipma_ecompareC(x,f,rank,vol,VipmK_ELEMTYPE_F32,D,offsD,strideD,VipmK_ELEMTYPE_F32,S1,offsS1,strideS1,S2,op,tfval,ffval)


__MYC_END_CDECLS
# undef __PUB
# undef __PRIV


#endif /* !defined(__VIPM_COMPARING_COMPARE_ALGORITHM_H__) */


/******************************************************************************
 *
 *
 *
 *****************************************************************************/
