/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright 2016 Seenaptec Ltd. All rights reserved.
 * SEENAPTEC PROPRIETARY/CONFIDENTIAL.
 *
 * $Id$
 */

/*
 * Types.h	(V.Sokur)
 * Vipm/Comparing/Compare/Types.h
 */

/* ------------------------------------------------------------------------- */

#ifndef __VIPM_COMPARING_COMPARE_TYPES_H__
# define __VIPM_COMPARING_COMPARE_TYPES_H__

/******************************************************************************
 * %% BeginSection: includes
 */

# ifndef __VIPM_TYPES_H__
#  include <Vipm/Types.h>
# endif


/******************************************************************************
 * %% BeginSection: types/constants
 */



/* ========================================================================= */

typedef bo_status_t (*vipma_compare_fn)(
# if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_rank_t                     aRank,
	vipm_int const                  aVolume[],
	vipm_uint                       anElemTypeDst,
	vipm_mutptr_t                   aBaseDst, vipm_int const aStartDst[], vipm_int const aStrideDst[],
	vipm_uint                       anElemTypeSrc,
	vipm_imuptr_t                   aBaseLhs, vipm_int const aStartLhs[], vipm_int const aStrideLhs[],
	vipm_imuptr_t                   aBaseRhs, vipm_int const aStartRhs[], vipm_int const aStrideRhs[],
	vipm_int                        aCmpOp
# endif
	);

typedef bo_status_t (*vipma_compareC_fn)(
# if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_rank_t                     aRank,
	vipm_int const                  aVolume[],
	vipm_uint                       anElemTypeDst,
	vipm_mutptr_t                   aBaseDst, vipm_int const aStartDst[], vipm_int const aStrideDst[],
	vipm_uint                       anElemTypeLhs,
	vipm_imuptr_t                   aBaseLhs, vipm_int const aStartLhs[], vipm_int const aStrideLhs[],
	vipm_scalar_t const             aRhs[/* nchannels */],
	vipm_int                        aCmpOp
# endif
	);


typedef bo_status_t (*vipma_ecompare_fn)(
# if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_rank_t                     aRank,
	vipm_int const                  aVolume[],
	vipm_uint                       anElemTypeDst,
	vipm_mutptr_t                   aBaseDst, vipm_int const aStartDst[], vipm_int const aStrideDst[],
	vipm_uint                       anElemTypeSrc,
	vipm_imuptr_t                   aBaseLhs, vipm_int const aStartLhs[], vipm_int const aStrideLhs[],
	vipm_imuptr_t                   aBaseRhs, vipm_int const aStartRhs[], vipm_int const aStrideRhs[],
	vipm_int                        aCmpOp,
	vipm_scalar_t const             aFillValuevTrue[/* nchannels */],
	vipm_scalar_t const             aFillValuevFalse[/* nchannels */]
# endif
	);

typedef bo_status_t (*vipma_ecompareC_fn)(
# if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_rank_t                     aRank,
	vipm_int const                  aVolume[],
	vipm_uint                       anElemTypeDst,
	vipm_mutptr_t                   aBaseDst, vipm_int const aStartDst[], vipm_int const aStrideDst[],
	vipm_uint                       anElemTypeLhs,
	vipm_imuptr_t                   aBaseLhs, vipm_int const aStartLhs[], vipm_int const aStrideLhs[],
	vipm_scalar_t const            *aRhs,
	vipm_int                        aCmpOp,
	vipm_scalar_t const             aFillValuevTrue[/* nchannels */],
	vipm_scalar_t const             aFillValuevFalse[/* nchannels */]
# endif
	);

/* ------------------------------------------------------------------------- */

typedef bo_status_t (*vipma_comparex_fn)(
# if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_rank_t                     aRank,
	vipm_int const                  aVolume[],
	vipm_uint                       anElemTypeDst,
	vipm_mutptr_t                   aBaseDst, vipm_int const aStartDst[], vipm_int const aStrideDst[],
	vipm_uint                       anElemTypeSrc,
	vipm_imuptr_t                   aBaseLhs, vipm_int const aStartLhs[], vipm_int const aStrideLhs[],
	vipm_imuptr_t                   aBaseRhs, vipm_int const aStartRhs[], vipm_int const aStrideRhs[],
	vipm_imuptr_t                   aBaseMsk, vipm_int const aStartMsk[], vipm_int const aStrideMsk[],
	vipm_int                        aCmpOp
# endif
	);

typedef bo_status_t (*vipma_comparexC_fn)(
# if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_rank_t                     aRank,
	vipm_int const                  aVolume[],
	vipm_uint                       anElemTypeDst,
	vipm_mutptr_t                   aBaseDst, vipm_int const aStartDst[], vipm_int const aStrideDst[],
	vipm_uint                       anElemTypeLhs,
	vipm_imuptr_t                   aBaseLhs, vipm_int const aStartLhs[], vipm_int const aStrideLhs[],
	vipm_scalar_t const             aRhs[/* nchannels */],
	vipm_imuptr_t                   aBaseMsk, vipm_int const aStartMsk[], vipm_int const aStrideMsk[],
	vipm_int                        aCmpOp
# endif
	);


typedef bo_status_t (*vipma_ecomparex_fn)(
# if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_rank_t                     aRank,
	vipm_int const                  aVolume[],
	vipm_uint                       anElemTypeDst,
	vipm_mutptr_t                   aBaseDst, vipm_int const aStartDst[], vipm_int const aStrideDst[],
	vipm_uint                       anElemTypeSrc,
	vipm_imuptr_t                   aBaseLhs, vipm_int const aStartLhs[], vipm_int const aStrideLhs[],
	vipm_imuptr_t                   aBaseRhs, vipm_int const aStartRhs[], vipm_int const aStrideRhs[],
	vipm_imuptr_t                   aBaseMsk, vipm_int const aStartMsk[], vipm_int const aStrideMsk[],
	vipm_int                        aCmpOp,
	vipm_scalar_t const             aFillValuevTrue[/* nchannels */],
	vipm_scalar_t const             aFillValuevFalse[/* nchannels */]
# endif
	);

typedef bo_status_t (*vipma_ecomparexC_fn)(
# if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_rank_t                     aRank,
	vipm_int const                  aVolume[],
	vipm_uint                       anElemTypeDst,
	vipm_mutptr_t                   aBaseDst, vipm_int const aStartDst[], vipm_int const aStrideDst[],
	vipm_uint                       anElemTypeLhs,
	vipm_imuptr_t                   aBaseLhs, vipm_int const aStartLhs[], vipm_int const aStrideLhs[],
	vipm_scalar_t const            *aRhs,
	vipm_imuptr_t                   aBaseMsk, vipm_int const aStartMsk[], vipm_int const aStrideMsk[],
	vipm_int                        aCmpOp,
	vipm_scalar_t const             aFillValuevTrue[/* nchannels */],
	vipm_scalar_t const             aFillValuevFalse[/* nchannels */]
# endif
	);


#endif /* !defined(__VIPM_COMPARING_COMPARE_TYPES_H__) */


/******************************************************************************
 *
 *
 *
 *****************************************************************************/
