/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright 2016 Seenaptec Ltd. All rights reserved.
 * SEENAPTEC PROPRIETARY/CONFIDENTIAL.
 *
 * $Id$
 */

/*
 * Threshold.h	(V.Sokur)
 * Vipm/Comparing/Threshold.h
 */

/* ------------------------------------------------------------------------- */

#ifndef __VIPM_COMPARING_THRESHOLD_H__
# define __VIPM_COMPARING_THRESHOLD_H__

/******************************************************************************
 * %% BeginSection: includes
 */

# ifndef __VIPM_COMPARING_THRESHOLD_ALGORITHM_H__
#  include "Vipm/Comparing/Threshold/Algorithm.h"
# endif
# ifndef __VIPM_COMPARING_THRESHOLD_EXTRA_H__
#  include "Vipm/Comparing/Threshold/Extra.h"
# endif


/******************************************************************************
 * %% BeginSection: function prototypes
 */
# pragma mark -
# pragma mark [ function prototypes ]
# pragma mark -

# include <Vipm/Linkage.h>
# define __PUB  __myc_flinkage__(public,libVipm)
# define __PRIV __myc_flinkage__(private,libVipm)
__MYC_BEGIN_CDECLS

__PUB bo_status_t
VipmThreshold(
# if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_mut_array_t                aDest,
	vipm_array_t                    aSource,
	vipm_site_t const              *aRoiDst,
	vipm_Npoint_t const            *aStartSrc,
	struct _Vipm_threshopts const  *Thopts/* = NULL */,
	struct _Vipm_threshparm const   aThparmv[], vipm_int aThparmc
# endif
	);

__PUB bo_status_t
VipmComputeThresholdByOtsu(
# if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_array_t                    aSource,
	vipm_site_t const              *aRoiSrc,
	vipm_scalar_t                   aThreshv[/* nchannels */],
	vipm_range_t                    aValueRangev[/* nchannels */] /* = NULL */,
	vipm_int                        aNumBinsv[/* nchannels */]    /* = NULL */
# endif
	);

/* ------------------------------------------------------------------------- */

#if 0
__PUB bo_status_t
VipmThresholdEx(
# if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_mut_array_t                aDest,
	vipm_array_t                    aSource,
	vipm_array_t                    aMask,
	vipm_site_t const              *aRoiDst,
	vipm_Npoint_t const            *aStartSrc,
	vipm_Npoint_t const            *aStartMsk,
	struct _Vipm_threshopts const  *Thopts/* = NULL */,
	struct _Vipm_threshparm const   aThparmv[], vipm_int aThparmc
# endif
	);
#endif

#if 0
__PUB bo_status_t
VipmComputeThresholdExByOtsu(
# if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_array_t                    aSource,
	vipm_array_t                    aMask,
	vipm_site_t const              *aRoiSrc,
	vipm_Npoint_t const            *aStartMsk,
	vipm_scalar_t                   aThreshv[/* nchannels */],
	vipm_range_t                    aValueRangev[/* nchannels */] /* = NULL */,
	vipm_int                        aNumBinsv[/* nchannels */]    /* = NULL */
# endif
	);
#endif


__MYC_END_CDECLS
# undef __PUB
# undef __PRIV


#endif /* !defined(__VIPM_COMPARING_THRESHOLD_H__) */


/******************************************************************************
 *
 *
 *
 *****************************************************************************/

