/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright 2016 Seenaptec Ltd. All rights reserved.
 * SEENAPTEC PROPRIETARY/CONFIDENTIAL.
 *
 * $Id$
 */

/*
 * Algorithm.h	(V.Sokur)
 * Vipm/Comparing/Threshold/Algorithm.h
 */

/* ------------------------------------------------------------------------- */

#ifndef __VIPM_COMPARING_THRESHOLD_ALGORITHM_H__
# define __VIPM_COMPARING_THRESHOLD_ALGORITHM_H__

/******************************************************************************
 * %% BeginSection: includes
 */

# ifndef __VIPM_COMPARING_THRESHOLD_TYPES_H__
#  include "Vipm/Comparing/Threshold/Types.h"
# endif


/******************************************************************************
 * %% BeginSection: function prototypes
 */
# pragma mark -
# pragma mark [ function prototypes ]
# pragma mark -

# include <Vipm/Linkage.h>
# define __PUB __myc_flinkage__(public,libVipm)
# define __PRIV __myc_flinkage__(private,libVipm)
__MYC_BEGIN_CDECLS

/*
 * Generic
 */

__PUB bo_status_t
VipmTGAthreshold(
# if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_rref_t                     aParm, /* (vipm_tga_thhparm_t *) */
	vipm_rank_t                     aRank,
	vipm_int const                  aVolume[],
	vipm_uint                       anElemTypeDst,
	vipm_mutptr_t                   aBaseDst, vipm_int const aStartDst[], vipm_int const aStrideDst[],
	vipm_uint                       anElemTypeSrc,
	vipm_imuptr_t                   aBaseSrc, vipm_int const aStartSrc[], vipm_int const aStrideSrc[]
# endif
	);

#if 0
__PUB bo_status_t
VipmTGAthresholdEx(
# if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_rref_t                     aParm, /* (vipm_tga_thhparm_t *) */
	vipm_rank_t                     aRank,
	vipm_int const                  aVolume[],
	vipm_uint                       anElemTypeDst,
	vipm_mutptr_t                   aBaseDst, vipm_int const aStartDst[], vipm_int const aStrideDst[],
	vipm_uint                       anElemTypeSrc,
	vipm_imuptr_t                   aBaseSrc, vipm_int const aStartSrc[], vipm_int const aStrideSrc[],
	vipm_uint                       anElemTypeMsk, /* unused, assumed U8 */
	vipm_imuptr_t                   aBaseMsk, vipm_int const aStartMsk[], vipm_int const aStrideMsk[]
# endif
	);
#endif


/* ========================================================================= */

__PUB bo_status_t
vipma_ethreshold(
# if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_rank_t                     aRank,
	vipm_int const                  aVolume[],
	vipm_uint                       anElemType,
	vipm_mutptr_t                   aBaseDst, vipm_int const aStartDst[], vipm_int const aStrideDst[],
	vipm_imuptr_t                   aBaseSrc, vipm_int const aStartSrc[], vipm_int const aStrideSrc[],
	struct _Vipm_threshopts const  *Thopts,
	struct _Vipm_threshparm const   aThparmv[], vipm_int aThparmc,
	struct _Vipm_arrshape const    *aWholeArrShapeSrc
# endif
	);


__PUB bo_status_t
vipma_ethreshold_otsu(
# if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_rank_t                     aRank,
	vipm_int const                  aVolume[],
	vipm_uint                       anElemType,
	vipm_mutptr_t                   aBaseDst, vipm_int const aStartDst[], vipm_int const aStrideDst[],
	vipm_imuptr_t                   aBaseSrc, vipm_int const aStartSrc[], vipm_int const aStrideSrc[],
	struct _Vipm_threshopts const  *Thopts,
	struct _Vipm_threshparm const   aThparmv[], vipm_int aThparmc
# endif
	);

__PUB bo_status_t
vipma_ethreshold_usto(
# if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_rank_t                     aRank,
	vipm_int const                  aVolume[],
	vipm_uint                       anElemType,
	vipm_mutptr_t                   aBaseDst, vipm_int const aStartDst[], vipm_int const aStrideDst[],
	vipm_imuptr_t                   aBaseSrc, vipm_int const aStartSrc[], vipm_int const aStrideSrc[],
	struct _Vipm_threshopts const  *Thopts,
	struct _Vipm_threshparm const   aThparmv[], vipm_int aThparmc,
	struct _Vipm_arrshape const    *aWholeArrShapeSrc
# endif
	);

__PUB bo_status_t
vipma_ethreshold_blur(
# if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_rank_t                     aRank,
	vipm_int const                  aVolume[],
	vipm_uint                       anElemType,
	vipm_mutptr_t                   aBaseDst, vipm_int const aStartDst[], vipm_int const aStrideDst[],
	vipm_imuptr_t                   aBaseSrc, vipm_int const aStartSrc[], vipm_int const aStrideSrc[],
	struct _Vipm_threshopts const  *Thopts,
	struct _Vipm_threshparm const   aThparmv[], vipm_int aThparmc,
	struct _Vipm_arrshape const    *aWholeArrShapeSrc
# endif
	);

/* ------------------------------------------------------------------------- */

__PUB bo_status_t
vipma_threshold(
# if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_rank_t                     aRank,
	vipm_int const                  aVolume[],
	vipm_uint                       anElemType,
	vipm_mutptr_t                   aBaseDst, vipm_int const aStartDst[], vipm_int const aStrideDst[],
	vipm_imuptr_t                   aBaseSrc, vipm_int const aStartSrc[], vipm_int const aStrideSrc[],
	struct _Vipm_threshparm const   aThparmv[], vipm_int aThparmc
# endif
	);


__PUB bo_status_t
vipma_sheer_threshold_n1(
# if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_rank_t                     aRank,
	vipm_int const                  aVolume[],
	vipm_uint                       anElemType,
	vipm_mutptr_t                   aBaseDst, vipm_int const aStartDst[], vipm_int const aStrideDst[],
	vipm_imuptr_t                   aBaseSrc, vipm_int const aStartSrc[], vipm_int const aStrideSrc[],
	struct _Vipm_threshparm const   aThparmv[/* 1 */]
# endif
	);

__PUB bo_status_t
vipma_sheer_threshold_n2(
# if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_rank_t                     aRank,
	vipm_int const                  aVolume[],
	vipm_uint                       anElemType,
	vipm_mutptr_t                   aBaseDst, vipm_int const aStartDst[], vipm_int const aStrideDst[],
	vipm_imuptr_t                   aBaseSrc, vipm_int const aStartSrc[], vipm_int const aStrideSrc[],
	struct _Vipm_threshparm const   aThparmv[/* 2 */]
# endif
	);

__PUB bo_status_t
vipma_adaptive_threshold_n1(
# if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_rank_t                     aRank,
	vipm_int const                  aVolume[],
	vipm_uint                       anElemType,
	vipm_mutptr_t                   aBaseDst, vipm_int const aStartDst[], vipm_int const aStrideDst[],
	vipm_imuptr_t                   aBaseSrc, vipm_int const aStartSrc[], vipm_int const aStrideSrc[],
	struct _Vipm_threshparm const   aThparmv[/* 1 */]
# endif
	);

__PUB bo_status_t
vipma_adaptive_threshold_n2(
# if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_rank_t                     aRank,
	vipm_int const                  aVolume[],
	vipm_uint                       anElemType,
	vipm_mutptr_t                   aBaseDst, vipm_int const aStartDst[], vipm_int const aStrideDst[],
	vipm_imuptr_t                   aBaseSrc, vipm_int const aStartSrc[], vipm_int const aStrideSrc[],
	struct _Vipm_threshparm const   aThparmv[/* 2 */]
# endif
	);


/* ============================================================================
 * Specialized versions
 */
# pragma mark -

/*
 * common "immediate" threshold
 */

# define vipma_threshold_u8(x,f,rank,vol,D,offsD,strideD,S,offsS,strideS,thpv,thpc) \
	vipma_threshold(x,f,rank,vol,VipmK_ELEMTYPE_U8,D,offsD,strideD,S,offsS,strideS,thpv,thpc)

# define vipma_threshold_s16(x,f,rank,vol,D,offsD,strideD,S,offsS,strideS,thpv,thpc) \
	vipma_threshold(x,f,rank,vol,VipmK_ELEMTYPE_S16,D,offsD,strideD,S,offsS,strideS,thpv,thpc)

# define vipma_threshold_s32(x,f,rank,vol,D,offsD,strideD,S,offsS,strideS,thpv,thpc) \
	vipma_threshold(x,f,rank,vol,VipmK_ELEMTYPE_S32,D,offsD,strideD,S,offsS,strideS,thpv,thpc)

# define vipma_threshold_f32(x,f,rank,vol,D,offsD,strideD,S,offsS,strideS,thpv,thpc) \
	vipma_threshold(x,f,rank,vol,VipmK_ELEMTYPE_F32,D,offsD,strideD,S,offsS,strideS,thpv,thpc)


/*
 * sheer threshold_n1
 */

# define vipma_sheer_threshold_n1_u8(x,f,rank,vol,D,offsD,strideD,S,offsS,strideS,thpv) \
	vipma_sheer_threshold_n1(x,f,rank,vol,VipmK_ELEMTYPE_U8,D,offsD,strideD,S,offsS,strideS,thpv)

# define vipma_sheer_threshold_n1_s16(x,f,rank,vol,D,offsD,strideD,S,offsS,strideS,thpv) \
	vipma_sheer_threshold_n1(x,f,rank,vol,VipmK_ELEMTYPE_S16,D,offsD,strideD,S,offsS,strideS,thpv)

# define vipma_sheer_threshold_n1_s32(x,f,rank,vol,D,offsD,strideD,S,offsS,strideS,thpv) \
	vipma_sheer_threshold_n1(x,f,rank,vol,VipmK_ELEMTYPE_S32,D,offsD,strideD,S,offsS,strideS,thpv)

# define vipma_sheer_threshold_n1_f32(x,f,rank,vol,D,offsD,strideD,S,offsS,strideS,thpv) \
	vipma_sheer_threshold_n1(x,f,rank,vol,VipmK_ELEMTYPE_F32,D,offsD,strideD,S,offsS,strideS,thpv)


/*
 * sheer threshold_n2
 */

# define vipma_sheer_threshold_n2_u8(x,f,rank,vol,D,offsD,strideD,S,offsS,strideS,thpv) \
	vipma_sheer_threshold_n2(x,f,rank,vol,VipmK_ELEMTYPE_U8,D,offsD,strideD,S,offsS,strideS,thpv)

# define vipma_sheer_threshold_n2_s16(x,f,rank,vol,D,offsD,strideD,S,offsS,strideS,thpv) \
	vipma_sheer_threshold_n2(x,f,rank,vol,VipmK_ELEMTYPE_S16,D,offsD,strideD,S,offsS,strideS,thpv)

# define vipma_sheer_threshold_n2_s32(x,f,rank,vol,D,offsD,strideD,S,offsS,strideS,thpv) \
	vipma_sheer_threshold_n2(x,f,rank,vol,VipmK_ELEMTYPE_S32,D,offsD,strideD,S,offsS,strideS,thpv)

# define vipma_sheer_threshold_n2_f32(x,f,rank,vol,D,offsD,strideD,S,offsS,strideS,thpv) \
	vipma_sheer_threshold_n2(x,f,rank,vol,VipmK_ELEMTYPE_F32,D,offsD,strideD,S,offsS,strideS,thpv)


/*
 * adaptive threshold_n1
 */

# define vipma_adaptive_threshold_n1_u8(x,f,rank,vol,D,offsD,strideD,S,offsS,strideS,thpv) \
	vipma_adaptive_threshold_n1(x,f,rank,vol,VipmK_ELEMTYPE_U8,D,offsD,strideD,S,offsS,strideS,thpv)

# define vipma_adaptive_threshold_n1_s16(x,f,rank,vol,D,offsD,strideD,S,offsS,strideS,thpv) \
	vipma_adaptive_threshold_n1(x,f,rank,vol,VipmK_ELEMTYPE_S16,D,offsD,strideD,S,offsS,strideS,thpv)

# define vipma_adaptive_threshold_n1_s32(x,f,rank,vol,D,offsD,strideD,S,offsS,strideS,thpv) \
	vipma_adaptive_threshold_n1(x,f,rank,vol,VipmK_ELEMTYPE_S32,D,offsD,strideD,S,offsS,strideS,thpv)

# define vipma_adaptive_threshold_n1_f32(x,f,rank,vol,D,offsD,strideD,S,offsS,strideS,thpv) \
	vipma_adaptive_threshold_n1(x,f,rank,vol,VipmK_ELEMTYPE_F32,D,offsD,strideD,S,offsS,strideS,thpv)


/*
 * adaptive threshold_n2
 */

# define vipma_adaptive_threshold_n2_u8(x,f,rank,vol,D,offsD,strideD,S,offsS,strideS,thpv) \
	vipma_adaptive_threshold_n2(x,f,rank,vol,VipmK_ELEMTYPE_U8,D,offsD,strideD,S,offsS,strideS,thpv)

# define vipma_adaptive_threshold_n2_s16(x,f,rank,vol,D,offsD,strideD,S,offsS,strideS,thpv) \
	vipma_adaptive_threshold_n2(x,f,rank,vol,VipmK_ELEMTYPE_S16,D,offsD,strideD,S,offsS,strideS,thpv)

# define vipma_adaptive_threshold_n2_s32(x,f,rank,vol,D,offsD,strideD,S,offsS,strideS,thpv) \
	vipma_adaptive_threshold_n2(x,f,rank,vol,VipmK_ELEMTYPE_S32,D,offsD,strideD,S,offsS,strideS,thpv)

# define vipma_adaptive_threshold_n2_f32(x,f,rank,vol,D,offsD,strideD,S,offsS,strideS,thpv) \
	vipma_adaptive_threshold_n2(x,f,rank,vol,VipmK_ELEMTYPE_F32,D,offsD,strideD,S,offsS,strideS,thpv)

/* ------------------------------------------------------------------------- */

/*
 * "enhanced" threshold
 */

# define vipma_ethreshold_u8(x,f,rank,vol,D,offsD,strideD,S,offsS,strideS,tho,thpv,thpc,ssh) \
	vipma_ethreshold(x,f,rank,vol,VipmK_ELEMTYPE_U8,D,offsD,strideD,S,offsS,strideS,tho,thpv,thpc,ssh)

# define vipma_ethreshold_s16(x,f,rank,vol,D,offsD,strideD,S,offsS,strideS,tho,thpv,thpc,ssh) \
	vipma_ethreshold(x,f,rank,vol,VipmK_ELEMTYPE_S16,D,offsD,strideD,S,offsS,strideS,tho,thpv,thpc,ssh)

# define vipma_ethreshold_s32(x,f,rank,vol,D,offsD,strideD,S,offsS,strideS,tho,thpv,thpc,ssh) \
	vipma_ethreshold(x,f,rank,vol,VipmK_ELEMTYPE_S32,D,offsD,strideD,S,offsS,strideS,tho,thpv,thpc,ssh)

# define vipma_ethreshold_f32(x,f,rank,vol,D,offsD,strideD,S,offsS,strideS,tho,thpv,thpc,ssh) \
	vipma_ethreshold(x,f,rank,vol,VipmK_ELEMTYPE_F32,D,offsD,strideD,S,offsS,strideS,tho,thpv,thpc,ssh)


/*
 * threshold by Otsu
 */

# define vipma_ethreshold_otsu_u8(x,f,rank,vol,D,offsD,strideD,S,offsS,strideS,tho,thpv,thpc) \
	vipma_ethreshold_otsu(x,f,rank,vol,VipmK_ELEMTYPE_U8,D,offsD,strideD,S,offsS,strideS,tho,thpv,thpc)

# define vipma_ethreshold_otsu_s16(x,f,rank,vol,D,offsD,strideD,S,offsS,strideS,tho,thpv,thpc) \
	vipma_ethreshold_otsu(x,f,rank,vol,VipmK_ELEMTYPE_S16,D,offsD,strideD,S,offsS,strideS,tho,thpv,thpc)

# define vipma_ethreshold_otsu_s32(x,f,rank,vol,D,offsD,strideD,S,offsS,strideS,tho,thpv,thpc) \
	vipma_ethreshold_otsu(x,f,rank,vol,VipmK_ELEMTYPE_S32,D,offsD,strideD,S,offsS,strideS,tho,thpv,thpc)

# define vipma_ethreshold_otsu_f32(x,f,rank,vol,D,offsD,strideD,S,offsS,strideS,tho,thpv,thpc) \
	vipma_ethreshold_otsu(x,f,rank,vol,VipmK_ELEMTYPE_F32,D,offsD,strideD,S,offsS,strideS,tho,thpv,thpc)


/*
 * adaptive threshold by "blur" (box filter)
 */

# define vipma_ethreshold_blur_u8(x,f,rank,vol,D,offsD,strideD,S,offsS,strideS,tho,thpv,thpc,ssh) \
	vipma_ethreshold_blur(x,f,rank,vol,VipmK_ELEMTYPE_U8,D,offsD,strideD,S,offsS,strideS,tho,thpv,thpc,ssh)

# define vipma_ethreshold_blur_s16(x,f,rank,vol,D,offsD,strideD,S,offsS,strideS,tho,thpv,thpc,ssh) \
	vipma_ethreshold_blur(x,f,rank,vol,VipmK_ELEMTYPE_S16,D,offsD,strideD,S,offsS,strideS,tho,thpv,thpc,ssh)

# define vipma_ethreshold_blur_s32(x,f,rank,vol,D,offsD,strideD,S,offsS,strideS,tho,thpv,thpc,ssh) \
	vipma_ethreshold_blur(x,f,rank,vol,VipmK_ELEMTYPE_S32,D,offsD,strideD,S,offsS,strideS,tho,thpv,thpc,ssh)

# define vipma_ethreshold_blur_f32(x,f,rank,vol,D,offsD,strideD,S,offsS,strideS,tho,thpv,thpc,ssh) \
	vipma_ethreshold_blur(x,f,rank,vol,VipmK_ELEMTYPE_F32,D,offsD,strideD,S,offsS,strideS,tho,thpv,thpc,ssh)


/* ========================================================================= */

#if 0
__PUB bo_status_t
vipma_ethreshold_xm(
# if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_rank_t                     aRank,
	vipm_int const                  aVolume[],
	vipm_uint                       anElemType,
	vipm_mutptr_t                   aBaseDst, vipm_int const aStartDst[], vipm_int const aStrideDst[],
	vipm_imuptr_t                   aBaseSrc, vipm_int const aStartSrc[], vipm_int const aStrideSrc[],
	vipm_imuptr_t                   aBaseMsk, vipm_int const aStartMsk[], vipm_int const aStrideMsk[],
	struct _Vipm_threshopts const  *Thopts,
	struct _Vipm_threshparm const   aThparmv[], vipm_int aThparmc
# endif
	);

/* @{ */

__PUB bo_status_t
vipma_ethreshold_xm_otsu(
# if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_rank_t                     aRank,
	vipm_int const                  aVolume[],
	vipm_uint                       anElemType,
	vipm_mutptr_t                   aBaseDst, vipm_int const aStartDst[], vipm_int const aStrideDst[],
	vipm_imuptr_t                   aBaseSrc, vipm_int const aStartSrc[], vipm_int const aStrideSrc[],
	vipm_imuptr_t                   aBaseMsk, vipm_int const aStartMsk[], vipm_int const aStrideMsk[],
	struct _Vipm_threshopts const  *Thopts,
	struct _Vipm_threshparm const   aThparmv[], vipm_int aThparmc
# endif
	);

__PUB bo_status_t
vipma_ethreshold_xm_usto(
# if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_rank_t                     aRank,
	vipm_int const                  aVolume[],
	vipm_uint                       anElemType,
	vipm_mutptr_t                   aBaseDst, vipm_int const aStartDst[], vipm_int const aStrideDst[],
	vipm_imuptr_t                   aBaseSrc, vipm_int const aStartSrc[], vipm_int const aStrideSrc[],
	vipm_imuptr_t                   aBaseMsk, vipm_int const aStartMsk[], vipm_int const aStrideMsk[],
	struct _Vipm_threshopts const  *Thopts,
	struct _Vipm_threshparm const   aThparmv[], vipm_int aThparmc
# endif
	);

__PUB bo_status_t
vipma_ethreshold_xm_blur(
# if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_rank_t                     aRank,
	vipm_int const                  aVolume[],
	vipm_uint                       anElemType,
	vipm_mutptr_t                   aBaseDst, vipm_int const aStartDst[], vipm_int const aStrideDst[],
	vipm_imuptr_t                   aBaseSrc, vipm_int const aStartSrc[], vipm_int const aStrideSrc[],
	vipm_imuptr_t                   aBaseMsk, vipm_int const aStartMsk[], vipm_int const aStrideMsk[],
	struct _Vipm_threshopts const  *Thopts,
	struct _Vipm_threshparm const   aThparmv[], vipm_int aThparmc
# endif
	);

/* @} */
#endif

/* ------------------------------------------------------------------------- */

#if 0
__PUB bo_status_t
vipma_threshold_xm(
# if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_rank_t                     aRank,
	vipm_int const                  aVolume[],
	vipm_uint                       anElemType,
	vipm_mutptr_t                   aBaseDst, vipm_int const aStartDst[], vipm_int const aStrideDst[],
	vipm_imuptr_t                   aBaseSrc, vipm_int const aStartSrc[], vipm_int const aStrideSrc[],
	vipm_imuptr_t                   aBaseMsk, vipm_int const aStartMsk[], vipm_int const aStrideMsk[],
	struct _Vipm_threshparm const   aThparmv[], vipm_int aThparmc
# endif
	);


/* @{ */

__PUB bo_status_t
vipma_sheer_threshold_xm_n1(
# if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_rank_t                     aRank,
	vipm_int const                  aVolume[],
	vipm_uint                       anElemType,
	vipm_mutptr_t                   aBaseDst, vipm_int const aStartDst[], vipm_int const aStrideDst[],
	vipm_imuptr_t                   aBaseSrc, vipm_int const aStartSrc[], vipm_int const aStrideSrc[],
	vipm_imuptr_t                   aBaseMsk, vipm_int const aStartMsk[], vipm_int const aStrideMsk[],
	struct _Vipm_threshparm const   aThparmv[/* 1 */]
# endif
	);

__PUB bo_status_t
vipma_sheer_threshold_xm_n2(
# if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_rank_t                     aRank,
	vipm_int const                  aVolume[],
	vipm_uint                       anElemType,
	vipm_mutptr_t                   aBaseDst, vipm_int const aStartDst[], vipm_int const aStrideDst[],
	vipm_imuptr_t                   aBaseSrc, vipm_int const aStartSrc[], vipm_int const aStrideSrc[],
	vipm_imuptr_t                   aBaseMsk, vipm_int const aStartMsk[], vipm_int const aStrideMsk[],
	struct _Vipm_threshparm const   aThparmv[/* 2 */]
# endif
	);

__PUB bo_status_t
vipma_adaptive_threshold_xm_n1(
# if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_rank_t                     aRank,
	vipm_int const                  aVolume[],
	vipm_uint                       anElemType,
	vipm_mutptr_t                   aBaseDst, vipm_int const aStartDst[], vipm_int const aStrideDst[],
	vipm_imuptr_t                   aBaseSrc, vipm_int const aStartSrc[], vipm_int const aStrideSrc[],
	vipm_imuptr_t                   aBaseMsk, vipm_int const aStartMsk[], vipm_int const aStrideMsk[],
	struct _Vipm_threshparm const   aThparmv[/* 1 */]
# endif
	);

__PUB bo_status_t
vipma_adaptive_threshold_xm_n2(
# if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_rank_t                     aRank,
	vipm_int const                  aVolume[],
	vipm_uint                       anElemType,
	vipm_mutptr_t                   aBaseDst, vipm_int const aStartDst[], vipm_int const aStrideDst[],
	vipm_imuptr_t                   aBaseSrc, vipm_int const aStartSrc[], vipm_int const aStrideSrc[],
	vipm_imuptr_t                   aBaseMsk, vipm_int const aStartMsk[], vipm_int const aStrideMsk[],
	struct _Vipm_threshparm const   aThparmv[/* 2 */]
# endif
	);

/* @} */
#endif


__MYC_END_CDECLS
# undef __PUB
# undef __PRIV


#endif /* !defined(__VIPM_COMPARING_THRESHOLD_ALGORITHM_H__) */


/******************************************************************************
 *
 *
 *
 *****************************************************************************/
