/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright 2016 Seenaptec Ltd. All rights reserved.
 * SEENAPTEC PROPRIETARY/CONFIDENTIAL.
 *
 * $Id$
 */

/*
 * Extra.h	(V.Sokur)
 * Vipm/Comparing/Threshold/Extra.h
 */

/* ------------------------------------------------------------------------- */

#ifndef __VIPM_COMPARING_THRESHOLD_EXTRA_H__
# define __VIPM_COMPARING_THRESHOLD_EXTRA_H__

/******************************************************************************
 * %% BeginSection: includes
 */

# ifndef __VIPM_COMPARING_THRESHOLD_TYPES_H__
#  include "Vipm/Comparing/Threshold/Types.h"
# endif


/******************************************************************************
 * %% BeginSection: function prototypes
 */
# pragma mark -
# pragma mark [ function prototypes ]
# pragma mark -

# include <Vipm/Linkage.h>
# define __PUB __myc_flinkage__(public,libVipm)
# define __PRIV __myc_flinkage__(private,libVipm)
__MYC_BEGIN_CDECLS

/*
 * Generic
 */

__PUB bo_status_t
VipmTGAcomputeThresholdByOtsu(
# if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_rref_t                     aParm, /* (vipm_tga_compthhparm_t *) */
	vipm_rank_t                     aRank,
	vipm_int const                  aVolume[],
	vipm_uint                       anElemType,
	vipm_imuptr_t                   aBaseSrc, vipm_int const aStartSrc[], vipm_int const aStrideSrc[]
# endif
	);

#if 0
__PUB bo_status_t
VipmTGAcomputeThresholdExByOtsu(
# if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_rref_t                     aParm, /* (vipm_tga_compthhparm_t *) */
	vipm_rank_t                     aRank,
	vipm_int const                  aVolume[],
	vipm_uint                       anElemTypeSrc,
	vipm_imuptr_t                   aBaseSrc, vipm_int const aStartSrc[], vipm_int const aStrideSrc[],
	vipm_uint                       anElemTypeMsk, /* unused, assumed U8 */
	vipm_imuptr_t                   aBaseMsk, vipm_int const aStartMsk[], vipm_int const aStrideMsk[]
# endif
	);
#endif


/* ========================================================================= */

__PUB bo_status_t
vipma_compute_threshold_otsu(
# if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_rank_t                     aRank,
	vipm_int const                  aVolume[],
	vipm_uint                       anElemType,
	vipm_imuptr_t                   aBaseSrc, vipm_int const aStartSrc[], vipm_int const aStrideSrc[],
	vipm_scalar_t                   aThreshv[/* nchannels */],
	vipm_range_t                    aValueRangev[/* nchannels */] /* = NULL */,
	vipm_int                        aNumBinsv[/* nchannels */]    /* = NULL */
# endif
	);

#if 0
__PUB bo_status_t
vipma_compute_threshold_xm_otsu(
# if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_rank_t                     aRank,
	vipm_int const                  aVolume[],
	vipm_uint                       anElemType,
	vipm_imuptr_t                   aBaseSrc, vipm_int const aStartSrc[], vipm_int const aStrideSrc[],
	vipm_imuptr_t                   aBaseMsk, vipm_int const aStartMsk[], vipm_int const aStrideMsk[],
	vipm_scalar_t                   aThreshv[/* nchannels */],
	vipm_range_t                    aValueRangev[/* nchannels */] /* = NULL */,
	vipm_int                        aNumBinsv[/* nchannels */]    /* = NULL */
# endif
	);
#endif


__PUB vipm_scalar_t
vipma_calculate_threshold_otsu_i(
# if __myc_require(prototypes)
	struct _Vipm_histogram const   *aHist
# endif
	);

__PUB vipm_scalar_t
vipma_calculate_threshold_otsu_f(
# if __myc_require(prototypes)
	struct _Vipm_histogram const   *aHist
# endif
	);


/* ============================================================================
 * Specialized versions
 */
# pragma mark -

/*
 * compute threshold by Otsu
 */

# define vipma_compute_threshold_otsu_u8(x,f,rank,vol,S,offsS,strideS,thhv,vrngv,nscpv) \
	vipma_compute_threshold_otsu(x,f,rank,vol,VipmK_ELEMTYPE_U8,S,offsS,strideS,thhv,vrngv,nscpv)

# define vipma_compute_threshold_otsu_s16(x,f,rank,vol,S,offsS,strideS,thhv,vrngv,nscpv) \
	vipma_compute_threshold_otsu(x,f,rank,vol,VipmK_ELEMTYPE_S16,S,offsS,strideS,thhv,vrngv,nscpv)

# define vipma_compute_threshold_otsu_s32(x,f,rank,vol,S,offsS,strideS,thhv,vrngv,nscpv) \
	vipma_compute_threshold_otsu(x,f,rank,vol,VipmK_ELEMTYPE_S32,S,offsS,strideS,thhv,vrngv,nscpv)

# define vipma_compute_threshold_otsu_f32(x,f,rank,vol,S,offsS,strideS,thhv,vrngv,nscpv) \
	vipma_compute_threshold_otsu(x,f,rank,vol,VipmK_ELEMTYPE_F32,S,offsS,strideS,thhv,vrngv,nscpv)


__MYC_END_CDECLS
# undef __PUB
# undef __PRIV


#endif /* !defined(__VIPM_COMPARING_THRESHOLD_EXTRA_H__) */


/******************************************************************************
 *
 *
 *
 *****************************************************************************/
