/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright 2016 Seenaptec Ltd. All rights reserved.
 * SEENAPTEC PROPRIETARY/CONFIDENTIAL.
 *
 * $Id$
 */

/*
 * Convert.h	(V.Sokur)
 * Vipm/DXchgInit/Convert.h
 */

/* ------------------------------------------------------------------------- */

#ifndef __VIPM_DXCHGINIT_CONVERT_H__
# define __VIPM_DXCHGINIT_CONVERT_H__

/******************************************************************************
 * %% BeginSection: includes
 */

# ifndef __VIPM_DXCHGINIT_CONVERT_ALGORITHM_H__
#  include "Vipm/DXchgInit/Convert/Algorithm.h"
# endif


/******************************************************************************
 * %% BeginSection: function prototypes
 */
# pragma mark -
# pragma mark [ function prototypes ]
# pragma mark -

# include <Vipm/Linkage.h>
# define __PUB  __myc_flinkage__(public,libVipm)
# define __PRIV __myc_flinkage__(private,libVipm)
__MYC_BEGIN_CDECLS

/* @note: can be error with rounding on signed values */
__PUB bo_status_t
VipmConvert(
# if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_mut_array_t                aDest,
	vipm_array_t                    aSource,
	vipm_site_t const              *aRoiDst,
	vipm_Npoint_t const            *aStartSrc,
	vipm_scalar_t const             aScaleFactor[],     /* = NULL */
	vipm_scalar_t const             aValueOrigin[],     /* = NULL */
	vipm_range_t                    aValueRangevSrc[]   /* = NULL */
# endif
	);

/* @note: can be error with rounding on signed values */
__PUB bo_status_t
VipmVConvert(
# if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_mut_array_t                aDest,
	vipm_array_t                    aSource,
	vipm_site_t const              *aRoiDst,
	vipm_Npoint_t const            *aStartSrc,
	vipm_range_t                    aValueRangevDst[],
	vipm_range_t                    aValueRangevSrc[]
# endif
	);


__MYC_END_CDECLS
# undef __PUB
# undef __PRIV


#endif /* !defined(__VIPM_DXCHGINIT_CONVERT_H__) */


/******************************************************************************
 *
 *
 *
 *****************************************************************************/
