/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright 2016 Seenaptec Ltd. All rights reserved.
 * SEENAPTEC PROPRIETARY/CONFIDENTIAL.
 *
 * $Id$
 */

/*
 * CopyMkb.h	(V.Sokur)
 * Vipm/DXchgInit/CopyMkb.h
 */

/* ------------------------------------------------------------------------- */

#ifndef __VIPM_DXCHGINIT_COPYMKB_H__
# define __VIPM_DXCHGINIT_COPYMKB_H__

/******************************************************************************
 * %% BeginSection: includes
 */

# ifndef __VIPM_DXCHGINIT_COPYMKB_ALGORITHM_H__
#  include "Vipm/DXchgInit/CopyMkb/Algorithm.h"
# endif


/******************************************************************************
 * %% BeginSection: function prototypes
 */
# pragma mark -
# pragma mark [ function prototypes ]
# pragma mark -

/*
 * Available Options: VipmF_MKBRONLY; VipmF_MUTABLE_PADDATA, ...
 */

# include <Vipm/Linkage.h>
# define __PUB  __myc_flinkage__(public,libVipm)
# define __PRIV __myc_flinkage__(private,libVipm)
__MYC_BEGIN_CDECLS

__PUB bo_status_t
VipmCopy(
# if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_mut_array_t                aDest,
	vipm_array_t                    aSource,
	vipm_site_t const              *aRoiDst,
	vipm_Npoint_t const            *aStartSrc
# endif
	);

__PUB bo_status_t
VipmCopyEx(
# if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_mut_array_t                aDest,
	vipm_array_t                    aSource,
	vipm_array_t                    aMask,
	vipm_site_t const              *aRoiDst,
	vipm_Npoint_t const            *aStartSrc,
	vipm_Npoint_t const            *aStartMsk
# endif
	);

__PUB bo_status_t
VipmCopyMkb(
# if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_mut_array_t                aDest,
	vipm_array_t                    aSource,
	vipm_Npoint_t const            *aStartDst,      /* @note: including border; @todo: fixme - test */
	vipm_site_t const              *aRoiSrc,        /* @note: excluding border; @todo: fixme - test */
	vipm_int                        aBorderType,
	vipm_brparm_t const            *aBorderParm
# endif
	);

__PUB bo_status_t
VipmCopyRMkb(
# if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_mut_array_t                aDest,
	vipm_array_t                    aSource,
	vipm_site_t const              *aRoiDst,        /* @note: including border; @todo: check */
	vipm_Npoint_t const            *aStartSrc,      /* @note: excluding border; @todo: check */
	vipm_int                        aBorderType,
	vipm_brparm_t const            *aBorderParm
# endif
	);


__MYC_END_CDECLS
# undef __PUB
# undef __PRIV


#endif /* !defined(__VIPM_DXCHGINIT_COPYMKB_H__) */


/******************************************************************************
 *
 *
 *
 *****************************************************************************/
