/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright 2016 Seenaptec Ltd. All rights reserved.
 * SEENAPTEC PROPRIETARY/CONFIDENTIAL.
 *
 * $Id$
 */

/*
 * Fill.h	(V.Sokur)
 * Vipm/DXchgInit/Fill.h
 */

/* ------------------------------------------------------------------------- */

#ifndef __VIPM_DXCHGINIT_FILL_H__
# define __VIPM_DXCHGINIT_FILL_H__

/******************************************************************************
 * %% BeginSection: includes
 */

# ifndef __VIPM_DXCHGINIT_FILL_ALGORITHM_H__
#  include "Vipm/DXchgInit/Fill/Algorithm.h"
# endif


/******************************************************************************
 * %% BeginSection: function prototypes
 */
# pragma mark -
# pragma mark [ function prototypes ]
# pragma mark -

# include <Vipm/Linkage.h>
# define __PUB __myc_flinkage__(public,libVipm)
# define __PRIV __myc_flinkage__(private,libVipm)
__MYC_BEGIN_CDECLS

/*
 * ROI samples:
 * 1) point : (nplanes:0,y,x,nchannels:0)
 *    volume: (nplanes:1,h,w,nchannels)
 */

__PUB bo_status_t
VipmFill(
# if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_mut_array_t                aDest,
	vipm_site_t const              *aRoiDst,
	vipm_scalar_t const             aFillValuev[/* nchannels */]
# endif
	);

__PUB bo_status_t
VipmFillEx(
# if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_mut_array_t                aDest,
	vipm_array_t                    aMask,
	vipm_site_t const              *aRoiDst,
	vipm_Npoint_t const            *aStartMsk,
	vipm_scalar_t const             aFillValuev[/* nchannels */] /* = NULL */
# endif
	);

__PUB bo_status_t
VipmFillEx2(
# if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_mut_array_t                aDest,
	vipm_array_t                    aMask,
	vipm_site_t const              *aRoiDst,
	vipm_Npoint_t const            *aStartMsk,
	vipm_scalar_t const             aFillValuevTrue[/* nchannels */] /* = NULL */,
	vipm_scalar_t const             aFillValuevFalse[/* nchannels */] /* = NULL */
# endif
	);


__MYC_END_CDECLS
# undef __PUB
# undef __PRIV


#endif /* !defined(__VIPM_DXCHGINIT_FILL_H__) */


/******************************************************************************
 *
 *
 *
 *****************************************************************************/
