/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright 2016 Seenaptec Ltd. All rights reserved.
 * SEENAPTEC PROPRIETARY/CONFIDENTIAL.
 *
 * $Id$
 */

/*
 * Algorithm.h	(V.Sokur)
 * Vipm/DXchgInit/Fill/Algorithm.h
 */

/* ------------------------------------------------------------------------- */

#ifndef __VIPM_DXCHGINIT_FILL_ALGORITHM_H__
# define __VIPM_DXCHGINIT_FILL_ALGORITHM_H__

/******************************************************************************
 * %% BeginSection: includes
 */

# ifndef __VIPM_DXCHGINIT_FILL_TYPES_H__
#  include "Vipm/DXchgInit/Fill/Types.h"
# endif


/******************************************************************************
 * %% BeginSection: function prototypes
 */
# pragma mark -
# pragma mark [ function prototypes ]
# pragma mark -

# include <Vipm/Linkage.h>
# define __PUB __myc_flinkage__(public,libVipm)
# define __PRIV __myc_flinkage__(private,libVipm)
__MYC_BEGIN_CDECLS

/*
 * Generic
 */

__PUB bo_status_t
VipmTGAfill(
#if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_rref_t                     aFillValuev, /* (vipm_scalar_t const *) */
	vipm_rank_t                     aRank,
	vipm_int const                  aVolume[],
	vipm_uint                       anElemType,
	vipm_mutptr_t                   aBaseDst, vipm_int const aStartDst[], vipm_int const aStrideDst[]
#endif
	);

__PUB bo_status_t
VipmTGAfillEx(
#if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_rref_t                     aParm, /* (vipm_tga_flxparm_t const *) */
	vipm_rank_t                     aRank,
	vipm_int const                  aVolume[],
	vipm_uint                       anElemTypeDst,
	vipm_mutptr_t                   aBaseDst, vipm_int const aStartDst[], vipm_int const aStrideDst[],
	vipm_uint                       anElemTypeMsk, /* unused, assumed U8 */
	vipm_imuptr_t                   aBaseMsk, vipm_int const aStartMsk[], vipm_int const aStrideMsk[]
#endif
	);


/* ========================================================================= */

__PUB bo_status_t
vipma_fill(
#if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_rank_t                     aRank,
	vipm_int const                  aVolume[],
	vipm_uint                       anElemTypeDst,
	vipm_mutptr_t                   aBaseDst, vipm_int const aStartDst[], vipm_int const aStrideDst[],
	vipm_scalar_t const             aFillValuev[/* nchannels */]
#endif
	);

__PUB bo_status_t
vipma_fillxm(
#if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_rank_t                     aRank,
	vipm_int const                  aVolume[],
	vipm_uint                       anElemTypeDst,
	vipm_mutptr_t                   aBaseDst, vipm_int const aStartDst[], vipm_int const aStrideDst[],
	vipm_imuptr_t                   aBaseMsk, vipm_int const aStartMsk[], vipm_int const aStrideMsk[],
	vipm_scalar_t const             aFillValuev[/* nchannels */]
#endif
	);

__PUB bo_status_t
vipma_fillxm2(
#if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_rank_t                     aRank,
	vipm_int const                  aVolume[],
	vipm_uint                       anElemTypeDst,
	vipm_mutptr_t                   aBaseDst, vipm_int const aStartDst[], vipm_int const aStrideDst[],
	vipm_imuptr_t                   aBaseMsk, vipm_int const aStartMsk[], vipm_int const aStrideMsk[],
	vipm_scalar_t const             aFillValuevTrue[/* nchannels */],
	vipm_scalar_t const             aFillValuevFalse[/* nchannels */]
#endif
	);

__PUB bo_status_t
vipma_fillem(
#if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_rank_t                     aRank,
	vipm_int const                  aVolume[],
	vipm_uint                       anElemTypeDst,
	vipm_mutptr_t                   aBaseDst, vipm_int const aStartDst[], vipm_int const aStrideDst[],
	vipm_imuptr_t                   aBaseMsk, vipm_int const aStartMsk[], vipm_int const aStrideMsk[],
	vipm_scalar_t const             aFillValuev[/* nchannels */]
#endif
	);

__PUB bo_status_t
vipma_fillem2(
#if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_rank_t                     aRank,
	vipm_int const                  aVolume[],
	vipm_uint                       anElemTypeDst,
	vipm_mutptr_t                   aBaseDst, vipm_int const aStartDst[], vipm_int const aStrideDst[],
	vipm_imuptr_t                   aBaseMsk, vipm_int const aStartMsk[], vipm_int const aStrideMsk[],
	vipm_scalar_t const             aFillValuevTrue[/* nchannels */],
	vipm_scalar_t const             aFillValuevFalse[/* nchannels */]
#endif
	);


/* ============================================================================
 * Specialized versions
 */
# pragma mark -

/*
 * fill
 *
 * Result/Data type: U8,S16,S32, F32
 */

# define vipma_fill_u8(x,f,rank,vol,D,offsD,strideD,fval) \
    vipma_fill(x,f,rank,vol,VipmK_ELEMTYPE_U8,D,offsD,strideD,fval)

# define vipma_fill_s16(x,f,rank,vol,D,offsD,strideD,fval) \
    vipma_fill(x,f,rank,vol,VipmK_ELEMTYPE_S16,D,offsD,strideD,fval)

# define vipma_fill_s32(x,f,rank,vol,D,offsD,strideD,fval) \
    vipma_fill(x,f,rank,vol,VipmK_ELEMTYPE_S32,D,offsD,strideD,fval)

# define vipma_fill_f32(x,f,rank,vol,D,offsD,strideD,fval) \
    vipma_fill(x,f,rank,vol,VipmK_ELEMTYPE_F32,D,offsD,strideD,fval)

/* ------------------------------------------------------------------------- */

/*
 * fillxm (with "pixel" mask)
 *
 * Result/Data type: U8,S16,S32, F32
 */

# define vipma_fillxm_u8(x,f,rank,vol,D,offsD,strideD,Sm,offsSm,strideSm,fval) \
    vipma_fillxm(x,f,rank,vol,VipmK_ELEMTYPE_U8,D,offsD,strideD,Sm,offsSm,strideSm,fval)

# define vipma_fillxm_s16(x,f,rank,vol,D,offsD,strideD,Sm,offsSm,strideSm,fval) \
    vipma_fillxm(x,f,rank,vol,VipmK_ELEMTYPE_S16,D,offsD,strideD,Sm,offsSm,strideSm,fval)

# define vipma_fillxm_s32(x,f,rank,vol,D,offsD,strideD,Sm,offsSm,strideSm,fval) \
    vipma_fillxm(x,f,rank,vol,VipmK_ELEMTYPE_S32,D,offsD,strideD,Sm,offsSm,strideSm,fval)

# define vipma_fillxm_f32(x,f,rank,vol,D,offsD,strideD,Sm,offsSm,strideSm,fval) \
    vipma_fillxm(x,f,rank,vol,VipmK_ELEMTYPE_F32,D,offsD,strideD,Sm,offsSm,strideSm,fval)

/* ------------------------------------------------------------------------- */

/*
 * fillxm2 (with "pixel" mask)
 *
 * Result/Data type: U8,S16,S32, F32
 */

# define vipma_fillxm2_u8(x,f,rank,vol,D,offsD,strideD,Sm,offsSm,strideSm,tfval,ffval) \
    vipma_fillxm2(x,f,rank,vol,VipmK_ELEMTYPE_U8,D,offsD,strideD,Sm,offsSm,strideSm,tfval,ffval)

# define vipma_fillxm2_s16(x,f,rank,vol,D,offsD,strideD,Sm,offsSm,strideSm,tfval,ffval) \
    vipma_fillxm2(x,f,rank,vol,VipmK_ELEMTYPE_S16,D,offsD,strideD,Sm,offsSm,strideSm,tfval,ffval)

# define vipma_fillxm2_s32(x,f,rank,vol,D,offsD,strideD,Sm,offsSm,strideSm,tfval,ffval) \
    vipma_fillxm2(x,f,rank,vol,VipmK_ELEMTYPE_S32,D,offsD,strideD,Sm,offsSm,strideSm,tfval,ffval)

# define vipma_fillxm2_f32(x,f,rank,vol,D,offsD,strideD,Sm,offsSm,strideSm,tfval,ffval) \
    vipma_fillxm2(x,f,rank,vol,VipmK_ELEMTYPE_F32,D,offsD,strideD,Sm,offsSm,strideSm,tfval,ffval)

/* ------------------------------------------------------------------------- */

/*
 * fillem (with "element" mask)
 *
 * Result/Data type: U8,S16,S32, F32
 */

# define vipma_fillem_u8(x,f,rank,vol,D,offsD,strideD,Sm,offsSm,strideSm,fval) \
    vipma_fillem(x,f,rank,vol,VipmK_ELEMTYPE_U8,D,offsD,strideD,Sm,offsSm,strideSm,fval)

# define vipma_fillem_s16(x,f,rank,vol,D,offsD,strideD,Sm,offsSm,strideSm,fval) \
    vipma_fillem(x,f,rank,vol,VipmK_ELEMTYPE_S16,D,offsD,strideD,Sm,offsSm,strideSm,fval)

# define vipma_fillem_s32(x,f,rank,vol,D,offsD,strideD,Sm,offsSm,strideSm,fval) \
    vipma_fillem(x,f,rank,vol,VipmK_ELEMTYPE_S32,D,offsD,strideD,Sm,offsSm,strideSm,fval)

# define vipma_fillem_f32(x,f,rank,vol,D,offsD,strideD,Sm,offsSm,strideSm,fval) \
    vipma_fillem(x,f,rank,vol,VipmK_ELEMTYPE_F32,D,offsD,strideD,Sm,offsSm,strideSm,fval)

/* ------------------------------------------------------------------------- */

/*
 * fillem2 (with "element" mask)
 *
 * Result/Data type: U8,S16,S32, F32
 */

# define vipma_fillem2_u8(x,f,rank,vol,D,offsD,strideD,Sm,offsSm,strideSm,tfval,ffval) \
    vipma_fillem2(x,f,rank,vol,VipmK_ELEMTYPE_U8,D,offsD,strideD,Sm,offsSm,strideSm,tfval,ffval)

# define vipma_fillem2_s16(x,f,rank,vol,D,offsD,strideD,Sm,offsSm,strideSm,tfval,ffval) \
    vipma_fillem2(x,f,rank,vol,VipmK_ELEMTYPE_S16,D,offsD,strideD,Sm,offsSm,strideSm,tfval,ffval)

# define vipma_fillem2_s32(x,f,rank,vol,D,offsD,strideD,Sm,offsSm,strideSm,tfval,ffval) \
    vipma_fillem2(x,f,rank,vol,VipmK_ELEMTYPE_S32,D,offsD,strideD,Sm,offsSm,strideSm,tfval,ffval)

# define vipma_fillem2_f32(x,f,rank,vol,D,offsD,strideD,Sm,offsSm,strideSm,tfval,ffval) \
    vipma_fillem2(x,f,rank,vol,VipmK_ELEMTYPE_F32,D,offsD,strideD,Sm,offsSm,strideSm,tfval,ffval)


__MYC_END_CDECLS
# undef __PUB
# undef __PRIV


#endif /* !defined(__VIPM_DXCHGINIT_FILL_ALGORITHM_H__) */


/******************************************************************************
 *
 *
 *
 *****************************************************************************/
