/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright 2016 Seenaptec Ltd. All rights reserved.
 * SEENAPTEC PROPRIETARY/CONFIDENTIAL.
 *
 * $Id$
 */

/*
 * Types.h	(V.Sokur)
 * Vipm/DXchgInit/Fill/Types.h
 */

/* ------------------------------------------------------------------------- */

#ifndef __VIPM_DXCHGINIT_FILL_TYPES_H__
# define __VIPM_DXCHGINIT_FILL_TYPES_H__

/******************************************************************************
 * %% BeginSection: includes
 */

# ifndef __VIPM_TYPES_H__
#  include <Vipm/Types.h>
# endif


/******************************************************************************
 * %% BeginSection: types/constants
 */



/* ========================================================================= */

typedef bo_status_t (*vipma_fill_fn)(
# if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_rank_t                     aRank,
	vipm_int const                  aVolume[],
	vipm_uint                       anElemTypeDst,
	vipm_mutptr_t                   aBaseDst, vipm_int const aStartDst[], vipm_int const aStrideDst[],
	vipm_scalar_t const             aFillValuev[/* nchannels */]
# endif
	);

typedef bo_status_t (*vipma_fillex1_fn)(
# if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_rank_t                     aRank,
	vipm_int const                  aVolume[],
	vipm_uint                       anElemTypeDst,
	vipm_mutptr_t                   aBaseDst, vipm_int const aStartDst[], vipm_int const aStrideDst[],
	vipm_imuptr_t                   aBaseMsk, vipm_int const aStartMsk[], vipm_int const aStrideMsk[],
	vipm_scalar_t const             aFillValuev[/* nchannels */]
# endif
	);

typedef bo_status_t (*vipma_fillex2_fn)(
# if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_rank_t                     aRank,
	vipm_int const                  aVolume[],
	vipm_uint                       anElemTypeDst,
	vipm_mutptr_t                   aBaseDst, vipm_int const aStartDst[], vipm_int const aStrideDst[],
	vipm_imuptr_t                   aBaseMsk, vipm_int const aStartMsk[], vipm_int const aStrideMsk[],
	vipm_scalar_t const             aFillValuevTrue[/* nchannels */],
	vipm_scalar_t const             aFillValuevFalse[/* nchannels */]
# endif
	);


#endif /* !defined(__VIPM_DXCHGINIT_FILL_TYPES_H__) */


/******************************************************************************
 *
 *
 *
 *****************************************************************************/
