/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright 2016 Seenaptec Ltd. All rights reserved.
 * SEENAPTEC PROPRIETARY/CONFIDENTIAL.
 *
 * $Id$
 */

/*
 * MSER.h	(V.Sokur)
 * Vipm/FeatDetect/MSER.h
 */

/* ------------------------------------------------------------------------- */

#ifndef __VIPM_FEATDETECT_MSER_H__
# define __VIPM_FEATDETECT_MSER_H__

/******************************************************************************
 * %% BeginSection: includes
 */

# ifndef __VIPM_FEATDETECT_MSER_ALGORITHM_H__
#  include <Vipm/FeatDetect/MSER/Algorithm.h>
# endif
# ifndef __VIPM_FEATDETECT_MSER_UTILS_H__
#  include <Vipm/FeatDetect/MSER/Utils.h>
# endif


/******************************************************************************
 * %% BeginSection: function prototypes
 */

# include <Vipm/Linkage.h>
# define __PUB __myc_flinkage__(public,libVipm)
__MYC_BEGIN_CDECLS

__PUB bo_status_t
VipmGenerateMSERs(
# if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_array_t                    aSource,
	vipm_site_t const              *aRoiSrc,
	struct _Vipm_mserfilt          *aMserflt
# endif
	);

/* @note: the function works correctly only with solid mask */
__PUB bo_status_t
VipmGenerateMSERsEx(
# if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_array_t                    aSource,
	vipm_array_t                    aMask,
	vipm_site_t const              *aRoiSrc,
	vipm_Npoint_t const            *aStartMsk,
	struct _Vipm_mserfilt          *aMserflt
# endif
	);

/* ------------------------------------------------------------------------- */

__PUB bo_status_t
VipmMSERgatherFeatures(
#if __myc_require(prototypes)
	struct _Vipm_mserfilt          *aMserflt
#endif
	);

__PUB bo_status_t
VipmMSERgatherFeaturesOfRegion(
#if __myc_require(prototypes)
	struct _Vipm_mserfilt          *aMserflt,
	struct _Vipm_wtsregion         *aRegion,
	int                             UpDownUnk           /* up(>0)/down(<0)/unknown(0) watershed direction */
#endif
	);

__PUB bo_status_t
VipmMSERgatherFeatureOfRegion(
#if __myc_require(prototypes)
	struct _Vipm_mserfilt          *aMserflt,
	struct _Vipm_wtsregion         *aRegion,
	int                             UpDownUnk,          /* up(>0)/down(<0)/unknown(0) watershed direction */
	vipm_int                        aFeatIdx,
	bo_uint32_t                     aFeatMagic
#endif
	);


/* ========================================================================= */

__PUB bo_status_t
VipmGenerateFMSERs(
# if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_array_t                    aSource,
	vipm_site_t const              *aRoiSrc,
	struct _Vipm_fmserfilt         *aMserflt
# endif
	);

/* @note: the function works correctly only with solid mask */
__PUB bo_status_t
VipmGenerateFMSERsEx(
# if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_array_t                    aSource,
	vipm_array_t                    aMask,
	vipm_site_t const              *aRoiSrc,
	vipm_Npoint_t const            *aStartMsk,
	struct _Vipm_fmserfilt         *aMserflt
# endif
	);


__MYC_END_CDECLS
# undef __PUB


#endif /* !defined(__VIPM_FEATDETECT_MSER_H__) */


/******************************************************************************
 *
 *
 *
 *****************************************************************************/
