/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright 2016 Seenaptec Ltd. All rights reserved.
 * SEENAPTEC PROPRIETARY/CONFIDENTIAL.
 *
 * $Id$
 */

/*
 * Detector.h	(V.Sokur)
 * Vipm/FeatDetect/MSER/Detector.h
 */

/* ------------------------------------------------------------------------- */

#ifndef __VIPM_FEATDETECT_MSER_DETECTOR_H__
# define __VIPM_FEATDETECT_MSER_DETECTOR_H__

/******************************************************************************
 * %% BeginSection: includes
 */

# ifndef __VIPM_FEATDETECT_MSER_TYPES_H__
#  include <Vipm/FeatDetect/MSER/Types.h>
# endif


/******************************************************************************
 * %% BeginSection: function prototypes
 */
# pragma mark -
# pragma mark [ function prototypes ]
# pragma mark -

# include <Vipm/Linkage.h>
# define __PUB __myc_flinkage__(public,libVipm)
# define __PRIV __myc_flinkage__(private,libVipm)
__MYC_BEGIN_CDECLS

__PUB bo_seqlist_(vipm_wtsregion_t *) *
VipmDetectMSERs(
#if __myc_require(prototypes)
	bo_seqlist_(vipm_wtsregion_t *)    *aRegionList,
	struct _Vipm_agtree const          *aWtsTree,
	struct _Vipm_mseriparm const       *aParm
#endif
	);

/* ------------------------------------------------------------------------- */

__PUB struct _Vipm_wtsregion **
VipmGatherMSERsFeatures(
#if __myc_require(prototypes)
	struct _Vipm_wtsregion            **aRegionList,
	vipm_int                            aNumRegions,
	struct _Vipm_wtslistener           *aWtsListener,   /* tree-builder */
	struct _Vipm_wtslsrctx             *aWtsLsrctx
#endif
	);

__PUB struct _Vipm_wtsregion *
VipmGatherMSERFeatures(
#if __myc_require(prototypes)
	struct _Vipm_wtsregion             *aRegion,
	struct _Vipm_wtslistener           *aWtsListener,   /* tree-builder */
	struct _Vipm_wtslsrctx             *aWtsLsrctx
#endif
	);

__PUB struct _Vipm_wtsregion *
VipmGatherMSERFeature(
#if __myc_require(prototypes)
	struct _Vipm_wtsregion             *aRegion,
	struct _Vipm_wtslistener           *aWtsListener,   /* tree-builder */
	struct _Vipm_wtslsrctx             *aWtsLsrctx,
	vipm_int                            aFeatIdx,
	bo_uint32_t                         aFeatMagic
#endif
	);


/* ========================================================================= */

__PUB bo_seqlist_(vipm_fwtsregion_t *) *
VipmDetectFMSERs(
#if __myc_require(prototypes)
	bo_seqlist_(vipm_fwtsregion_t *)   *aRegionList,
	struct _Vipm_fwtsregion            *aWtsTree,
	struct _Vipm_mseriparm const       *aParm
#endif
	);


__MYC_END_CDECLS
# undef __PUB
# undef __PRIV


#endif /* !defined(__VIPM_FEATDETECT_MSER_DETECTOR_H__) */


/******************************************************************************
 *
 *
 *
 *****************************************************************************/
