/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright 2018 Seenaptec Ltd. All rights reserved.
 * SEENAPTEC PROPRIETARY/CONFIDENTIAL.
 *
 * $Id$
 */

/*
 * GlobalFilters.h	(D.Vinnyk)
 * Vipm/Filtering/GlobalFilters.h
 */

/* ------------------------------------------------------------------------- */

#ifndef __VIPM_FILTERING_GLOBALFILTERS_H__
# define __VIPM_FILTERING_GLOBALFILTERS_H__

/******************************************************************************
 * %% BeginSection: includes
 */

# ifndef __VIPM_FILTERING_GLOBALFILTERS_ALGORITHM_H__
#  include "Vipm/Filtering/GlobalFilters/Algorithm.h"
# endif


/******************************************************************************
 * %% BeginSection: function prototypes
 */
# pragma mark -
# pragma mark [ function prototypes ]
# pragma mark -

# include <Vipm/Linkage.h>
# define __PUB __myc_flinkage__(public,libVipm)
# define __PRIV __myc_flinkage__(private,libVipm)
__MYC_BEGIN_CDECLS

/*
 * ROI samples:
 * 1) point : (plane:0, y, x, channel:0)
 *    volume: (nplanes:1, h, w, nchannels)
 */

__PUB bo_status_t
VipmFirefly(
# if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_mut_array_t                aDest,
	vipm_array_t                    aSource,
	vipm_site_t const              *aRoiDst,
	vipm_Npoint_t const            *aStartSrc,
	bo_intptr_t                     anAlgType,
	vipm_seshape_t const           *aStrel
# endif
	);

__PUB bo_status_t
VipmFireflyEx(
# if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_mut_array_t                aDest,
	vipm_array_t                    aSource,
	vipm_site_t const              *aRoiDst,
	vipm_Npoint_t const            *aStartSrc,
	bo_intptr_t                     anAlgType,
	vipm_seshape_t const            aStrel[/* aFuncCnt */],
	vipm_int const                  aWeights[/* aFuncCnt */],
	vipm_int                        aFuncCnt /* count of surround functions */
# endif
	);


__MYC_END_CDECLS
# undef __PUB
# undef __PRIV


#endif /* !defined(__VIPM_FILTERING_GLOBALFILTERS_H__) */


/******************************************************************************
 *
 *
 *
 *****************************************************************************/

