/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright 2018 Seenaptec Ltd. All rights reserved.
 * SEENAPTEC PROPRIETARY/CONFIDENTIAL.
 *
 * $Id$
 */

/*
 * Types.h	(D.Vinnyk)
 * Vipm/Filtering/GlobalFilters/Types.h
 */

/* ------------------------------------------------------------------------- */

#ifndef __VIPM_FILTERING_GLOBALFILTERS_TYPES_H__
# define __VIPM_FILTERING_GLOBALFILTERS_TYPES_H__

/******************************************************************************
 * %% BeginSection: includes
 */

# ifndef __VIPM_TYPES_H__
#  include <Vipm/Types.h>
# endif


/******************************************************************************
 * %% BeginSection: types/constants
 */



/* ========================================================================= */

typedef bo_status_t (*vipma_firefly_fn)(
# if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_rank_t                     aRank,
	vipm_int const                  aVolume[],
	vipm_uint                       anElemType,
	vipm_mutptr_t                   aBaseDst, vipm_int const aStartDst[], vipm_int const aStrideDst[],
	vipm_imuptr_t                   aBaseSrc, vipm_int const aStartSrc[], vipm_int const aStrideSrc[],
	bo_intptr_t                     anAlgType,
	vipm_seshape_t const           *aStrel
# endif
	);

typedef bo_status_t (*vipma_efirefly_fn)(
# if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_rank_t                     aRank,
	vipm_int const                  aVolume[],
	vipm_uint                       anElemType,
	vipm_mutptr_t                   aBaseDst, vipm_int const aStartDst[], vipm_int const aStrideDst[],
	vipm_imuptr_t                   aBaseSrc, vipm_int const aStartSrc[], vipm_int const aStrideSrc[],
	bo_intptr_t                     anAlgType,
	vipm_seshape_t const           *aStrel,
	vipm_filtopts_t const          *aFiltOpts,
	vipm_arrshape_t const          *aWholeArrShapeSrc
# endif
	);

typedef bo_status_t (*vipma_fireflyex_fn)(
# if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_rank_t                     aRank,
	vipm_int const                  aVolume[],
	vipm_uint                       anElemType,
	vipm_mutptr_t                   aBaseDst, vipm_int const aStartDst[], vipm_int const aStrideDst[],
	vipm_imuptr_t                   aBaseSrc, vipm_int const aStartSrc[], vipm_int const aStrideSrc[],
	bo_intptr_t                     anAlgType,
	vipm_seshape_t const            aStrel[],
	vipm_int const                  aWeights[],
	vipm_int                        aFuncCnt
# endif
	);

typedef bo_status_t (*vipma_efireflyex_fn)(
# if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_rank_t                     aRank,
	vipm_int const                  aVolume[],
	vipm_uint                       anElemType,
	vipm_mutptr_t                   aBaseDst, vipm_int const aStartDst[], vipm_int const aStrideDst[],
	vipm_imuptr_t                   aBaseSrc, vipm_int const aStartSrc[], vipm_int const aStrideSrc[],
	bo_intptr_t                     anAlgType,
	vipm_seshape_t const            aStrel[],
	vipm_int const                  aWeights[],
	vipm_int                        aFuncCnt,
	vipm_filtopts_t const          *aFiltOpts,
	vipm_arrshape_t const          *aWholeArrShapeSrc
# endif
	);


#endif /* !defined(__VIPM_FILTERING_GLOBALFILTERS_TYPES_H__) */


/******************************************************************************
 *
 *
 *
 *****************************************************************************/

