/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright 2017 Seenaptec Ltd. All rights reserved.
 * SEENAPTEC PROPRIETARY/CONFIDENTIAL.
 *
 * $Id$
 */

/*
 * LocalFilters.h	(D.Vinnyk)
 * Vipm/Filtering/LocalFilters.h
 */

/* ------------------------------------------------------------------------- */

#ifndef __VIPM_FILTERING_LOCALFILTERS_H__
# define __VIPM_FILTERING_LOCALFILTERS_H__

/******************************************************************************
 * %% BeginSection: includes
 */

# ifndef __VIPM_FILTERING_LOCALFILTERS_ALGORITHM_H__
#  include "Vipm/Filtering/LocalFilters/Algorithm.h"
# endif
# ifndef __VIPM_FILTERING_LOCALFILTERS_UTILS_H__
#  include "Vipm/Filtering/LocalFilters/Utils.h"
# endif


/******************************************************************************
 * %% BeginSection: function prototypes
 */
# pragma mark -
# pragma mark [ function prototypes ]
# pragma mark -

# include <Vipm/Linkage.h>
# define __PUB __myc_flinkage__(public,libVipm)
# define __PRIV __myc_flinkage__(private,libVipm)
__MYC_BEGIN_CDECLS

/*
 * ROI samples:
 * 1) point : (plane:0, y, x, channel:0)
 *    volume: (nplanes:1, h, w, nchannels)
 */

__PUB bo_status_t
VipmFilter(
# if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_mut_array_t                aDest,
	vipm_array_t                    aSource,
	vipm_site_t const              *aRoiDst,
	vipm_Npoint_t const            *aStartSrc,
	vipm_int                        aFilterMethod,
	vipm_seshape_t const           *aStrel
# endif
	);

__PUB bo_status_t
VipmGaussianFilter(
# if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_mut_array_t                aDest,
	vipm_array_t                    aSource,
	vipm_site_t const              *aRoiDst,
	vipm_Npoint_t const            *aStartSrc,
	vipm_seshape_t const           *aStrel,
	vipm_scalar_t const             aSigmas[/* grank(aDest) */]           /* =NULL */
# endif
	);

__PUB bo_status_t
VipmSepFilter(
# if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_mut_array_t                aDest,
	vipm_array_t                    aSource,
	vipm_site_t const              *aRoiDst,
	vipm_Npoint_t const            *aStartSrc,
	vipm_sepkern_t const           *aSepKern
# endif
	);


__MYC_END_CDECLS
# undef __PUB
# undef __PRIV


#endif /* !defined(__VIPM_FILTERING_LOCALFILTERS_H__) */


/******************************************************************************
 *
 *
 *
 *****************************************************************************/

