/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright 2019 Seenaptec Ltd. All rights reserved.
 * SEENAPTEC PROPRIETARY/CONFIDENTIAL.
 *
 * $Id$
 */

/*
 * Utils.h	(D.Vinnyk)
 * Vipm/Filtering/LocalFilters/Utils.h
 */

/* ------------------------------------------------------------------------- */

#ifndef __VIPM_FILTERING_LOCALFILTERS_UTILS_H__
# define __VIPM_FILTERING_LOCALFILTERS_UTILS_H__

/******************************************************************************
 * %% BeginSection: includes
 */

# ifndef __VIPM_FILTERING_LOCALFILTERS_TYPES_H__
#  include "Vipm/Filtering/LocalFilters/Types.h"
# endif


/******************************************************************************
 * %% BeginSection: function prototypes
 */
# pragma mark -
# pragma mark [ function prototypes ]
# pragma mark -

# include <Vipm/Linkage.h>
# define __PUB __myc_flinkage__(public,libVipm)
# define __PROT __myc_flinkage__(public,libVipm)
# define __PRIV __myc_flinkage__(private,libVipm)
__MYC_BEGIN_CDECLS

/*
 * Gaussian
 */

__PUB vipm_scalar_t *
vipm__computegauskernel1(
#if __myc_require(prototypes)
	vipm_scalar_t                  *aKernel,    /* != NULL */
	vipm_int                        anAnchor,
	vipm_int                        aSize,
	vipm_scalar_t                   aSigma
#endif
	);

__PUB vipm_scalar_t **
vipm__computegauskernel(
#if __myc_require(prototypes)
	vipm_grank_t                    aRank,
	vipm_scalar_t                  *Kernels[/* aRank, size(kernels[i]) = volume[i] */],/* != NULL */
	vipm_int const                  anAnchor[/* aRank */],  /* != NULL */
	vipm_int const                  aVolume[/* aRank */],   /* != NULL */
	vipm_scalar_t const             Sigmas[/* aRank */]
#endif
	);

__PUB vipm_sepkern_t *
vipm_computegauskernel(
#if __myc_require(prototypes)
	vipm_rank_t                     aRank,
	vipm_sepkern_t                 *aSepKern,   /* != NULL */
	vipm_scalar_t const             Sigmas[/* grank(aRank) */]
#endif
	);

/* ------------------------------------------------------------------------- */

/*
 * if sigma[i] = 0 || sigmas = {}:
 * sigma[i] = 0.3*((strel.vol[i] - 1)/2 - 1) + 0.8
 */
__PUB vipm_scalar_t *
vipm_adjustgaussigmas(
#if __myc_require(prototypes)
	vipm_rank_t                     aRank,
	vipm_scalar_t                  *aResult,    /* != NULL */
	vipm_seshape_t const           *aStrel,     /* != NULL */
	vipm_scalar_t const             Sigmas[/* grank(aRank) */]
#endif
	);

/* +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ */

_VIPM_INLINE vipm_sepkern_t *
vipm_computegauskernel(vipm_rank_t aRank, vipm_sepkern_t *aSepKern, vipm_scalar_t const Sigmas[])
{
	(void)vipm__computegauskernel(VIPM_ERANK(aRank) - 1, aSepKern->ske_kervals,
		aSepKern->ske_anchor.v + VIPM_RRANK(aRank), aSepKern->ske_volume.v + VIPM_RRANK(aRank), Sigmas);
	return (aSepKern);
}


__MYC_END_CDECLS
# undef __PUB
# undef __PROT
# undef __PRIV


#endif /* !defined(__VIPM_FILTERING_LOCALFILTERS_UTILS_H__) */


/******************************************************************************
 *
 *
 *
 *****************************************************************************/
