/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright 2007 Seenaptec Ltd. All rights reserved.
 * SEENAPTEC PROPRIETARY/CONFIDENTIAL.
 *
 * $Id$
 */

/*
 * Linkage.h	(V.Sokur)
 * include/Vipm/Linkage.h
 */

/* ------------------------------------------------------------------------- */

#ifndef __VIPM_LINKAGE_H__
# define __VIPM_LINKAGE_H__

/******************************************************************************
 * %% BeginSection: includes
 */

# include <Bo/Cdefs.h>

/******************************************************************************
 * %% BeginSection: definitions
 */

/*
 * To use macros __myc_flinkage__(), __myc_vlinkage__() it is needed
 * to define the next macros:
 */
# if __myc_build_shlib(libVipm)

#  define myc_flinkage_public_libVipm myc_flinkage_shlib_export
#  define myc_flinkage_private_libVipm myc_flinkage_shlib_private
#  define myc_flinkage_internal_libVipm myc_flinkage_shlib_internal

#  define myc_vlinkage_public_libVipm myc_vlinkage_shlib_export
#  define myc_vlinkage_private_libVipm myc_vlinkage_shlib_private
#  define myc_vlinkage_internal_libVipm myc_vlinkage_shlib_internal

# else
# if __myc_use_shlib(libVipm)

#  define myc_flinkage_public_libVipm myc_flinkage_shlib_import
#  define myc_flinkage_private_libVipm myc_flinkage_shlib_private
#  define myc_flinkage_internal_libVipm myc_flinkage_shlib_internal

#  define myc_vlinkage_public_libVipm myc_vlinkage_shlib_import
#  define myc_vlinkage_private_libVipm myc_vlinkage_shlib_private
#  define myc_vlinkage_internal_libVipm myc_vlinkage_shlib_internal

# else
# if __myc_build_archive(libVipm)

#  define myc_flinkage_public_libVipm myc_flinkage_archive_export
#  define myc_flinkage_private_libVipm myc_flinkage_archive_private
#  define myc_flinkage_internal_libVipm myc_flinkage_archive_internal

#  define myc_vlinkage_public_libVipm myc_vlinkage_archive_export
#  define myc_vlinkage_private_libVipm myc_vlinkage_archive_private
#  define myc_vlinkage_internal_libVipm myc_vlinkage_archive_internal

# else
# if __myc_use_archive(libVipm)

#  define myc_flinkage_public_libVipm myc_flinkage_archive_import
#  define myc_flinkage_private_libVipm myc_flinkage_archive_private
#  define myc_flinkage_internal_libVipm myc_flinkage_archive_internal

#  define myc_vlinkage_public_libVipm myc_vlinkage_archive_import
#  define myc_vlinkage_private_libVipm myc_vlinkage_archive_private
#  define myc_vlinkage_internal_libVipm myc_vlinkage_archive_internal

# else

#  define myc_flinkage_public_libVipm myc_flinkage_shlib_export
#  define myc_flinkage_private_libVipm myc_flinkage_shlib_private
#  define myc_flinkage_internal_libVipm myc_flinkage_shlib_internal

#  define myc_vlinkage_public_libVipm myc_vlinkage_shlib_export
#  define myc_vlinkage_private_libVipm myc_vlinkage_shlib_private
#  define myc_vlinkage_internal_libVipm myc_vlinkage_shlib_internal

# endif /* __myc_use_archive(libVipm) */
# endif /* __myc_build_archive(libVipm) */
# endif /* __myc_use_shlib(libVipm) */
# endif /* __myc_build_shlib(libVipm) */

#endif /* !defined(__VIPM_LINKAGE_H__) */

/******************************************************************************
 *
 *
 *
 *****************************************************************************/
