/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright 2016 Seenaptec Ltd. All rights reserved.
 * SEENAPTEC PROPRIETARY/CONFIDENTIAL.
 *
 * $Id$
 */

/*
 * Ellipse.h	(V.Sokur)
 * Vipm/Math/Geometry/2D/Ellipse.h
 */

/* ------------------------------------------------------------------------- */

#ifndef __VIPM_MATH_GEOMETRY_2D_ELLIPSE_H__
# define __VIPM_MATH_GEOMETRY_2D_ELLIPSE_H__

/******************************************************************************
 * %% BeginSection: includes
 */

# ifndef __VIPM_TYPES_H__
#  include <Vipm/Types.h>
# endif
# ifndef __VIPM_MATH_GEOMETRY_2D_POINT_H__
#  include <Vipm/Math/Geometry/2D/Point.h>
# endif


/******************************************************************************
 * %% BeginSection: function prototypes
 */
# pragma mark -
# pragma mark [ function prototypes ]
# pragma mark -

# include <Vipm/Linkage.h>
# define __PUB __myc_flinkage__(public,libVipm)
# define __PRIV __myc_flinkage__(private,libVipm)
__MYC_BEGIN_CDECLS

/*
 * Ellipse{F2D}
 */

	/*
	 * Construct
	 */

__PUB vipm_Ell_t(f2d)    *vipm_Ellipse(f2d)(cast,r)     __P((vipm_Ell_t(f2d) *, vipm_Ell_t(r2d) const *));
__PUB vipm_Ell_t(f2d)    *vipm_Ellipse(f2d)(moment2,c)  __P((vipm_Ell_t(f2d) *, vipm_Point_t(f2d) const *, double const [/*3*/], double /* =1 */));
__PUB vipm_Ell_t(f2d)    *vipm_Ellipse(f2d)(covariance) __P((vipm_Ell_t(f2d) *, vipm_Point_t(f2d) const *, double const [/*4*/], double /* =1 */));

/* ------------------------------------------------------------------------- */

	/*
	 * Functional
	 */

__PUB double              vipm_Ell_(f2d)(area)          __P((vipm_Ell_t(f2d) const *));
__PUB double              vipm_Ell_(f2d)(rotation)      __P((vipm_Ell_t(f2d) const *));
__PUB int                 vipm_Ell_(f2d)(inside)        __P((vipm_Ell_t(f2d) const *, vipm_Point_t(f2d) const *));
__PUB int                 vipm_Ell_(f2d)(inside2)       __P((vipm_Ell_t(f2d) const *, bo_float32_t, bo_float32_t));
__PUB int                 vipm_Ell_(f2d)(isconvex)      __P((vipm_Ell_t(f2d) const *));

__PUB double             *vipm_Ell_(f2d)(moment1)       __P((double [/*2*/], vipm_Ell_t(f2d) const *));
__PUB double             *vipm_Ell_(f2d)(moment2)       __P((double [/*3*/], vipm_Ell_t(f2d) const *));
__PUB double             *vipm_Ell_(f2d)(moment2,c)     __P((double [/*3*/], vipm_Ell_t(f2d) const *));
__PUB vipm_Point_t(f2d)  *vipm_Ell_(f2d)(centroid)      __P((vipm_Point_t(f2d) *, vipm_Ell_t(f2d) const *));
__PUB vipm_Point_t(r2d)  *vipm_Ell_(f2d)(centroid,r)    __P((vipm_Point_t(r2d) *, vipm_Ell_t(f2d) const *));
# define vipm_f2d_ell_centroid_$f           vipm_f2d_ell_centroid

__PUB vipm_Rect_t(f2d)    *vipm_Ell_(f2d)(brect)        __P((vipm_Rect_t(f2d) *, vipm_Ell_t(f2d) const *));
__PUB vipm_Quad_t(f2d)    *vipm_Ell_(f2d)(bquad)        __P((vipm_Quad_t(f2d) *, vipm_Ell_t(f2d) const *));
__PUB vipm_Quad_t(r2d)    *vipm_Ell_(f2d)(bquad,r)      __P((vipm_Quad_t(r2d) *, vipm_Ell_t(f2d) const *));
__PUB vipm_Quad_t(f2d)    *vipm_Ell_(f2d)(minbquad)     __P((vipm_Quad_t(f2d) *, vipm_Ell_t(f2d) const *));
__PUB vipm_Quad_t(r2d)    *vipm_Ell_(f2d)(minbquad,r)   __P((vipm_Quad_t(r2d) *, vipm_Ell_t(f2d) const *));
# define vipm_f2d_ell_bquad_$f              vipm_f2d_ell_bquad
# define vipm_f2d_ell_minbquad_$f           vipm_f2d_ell_minbquad


/* ========================================================================= */

/*
 * Ellipse{R2D}
 */

	/*
	 * Construct
	 */

__PUB vipm_Ell_t(r2d)    *vipm_Ellipse(r2d)(cast,f)     __P((vipm_Ell_t(r2d) *, vipm_Ell_t(f2d) const *));
__PUB vipm_Ell_t(r2d)    *vipm_Ellipse(r2d)(moment2,c)  __P((vipm_Ell_t(r2d) *, vipm_Point_t(r2d) const *, double const [/*3*/], double));
__PUB vipm_Ell_t(r2d)    *vipm_Ellipse(r2d)(covariance) __P((vipm_Ell_t(r2d) *, vipm_Point_t(r2d) const *, double const [/*4*/], double));

/* ------------------------------------------------------------------------- */

	/*
	 * Functional
	 */

__PUB double              vipm_Ell_(r2d)(area)          __P((vipm_Ell_t(r2d) const *));
__PUB double              vipm_Ell_(r2d)(rotation)      __P((vipm_Ell_t(r2d) const *));
__PUB int                 vipm_Ell_(r2d)(inside)        __P((vipm_Ell_t(r2d) const *, vipm_Point_t(r2d) const *));
__PUB int                 vipm_Ell_(r2d)(inside2)       __P((vipm_Ell_t(r2d) const *, bo_float64_t, bo_float64_t));
__PUB int                 vipm_Ell_(r2d)(isconvex)      __P((vipm_Ell_t(r2d) const *));

__PUB double             *vipm_Ell_(r2d)(moment1)       __P((double [/*2*/], vipm_Ell_t(r2d) const *));
__PUB double             *vipm_Ell_(r2d)(moment2)       __P((double [/*3*/], vipm_Ell_t(r2d) const *));
__PUB double             *vipm_Ell_(r2d)(moment2,c)     __P((double [/*3*/], vipm_Ell_t(r2d) const *));
__PUB vipm_Point_t(r2d)  *vipm_Ell_(r2d)(centroid)      __P((vipm_Point_t(r2d) *, vipm_Ell_t(r2d) const *));
__PUB vipm_Point_t(f2d)  *vipm_Ell_(r2d)(centroid,f)    __P((vipm_Point_t(f2d) *, vipm_Ell_t(r2d) const *));
# define vipm_r2d_ell_centroid_$r           vipm_r2d_ell_centroid

__PUB vipm_Rect_t(r2d)   *vipm_Ell_(r2d)(brect)         __P((vipm_Rect_t(r2d) *, vipm_Ell_t(r2d) const *));
__PUB vipm_Quad_t(r2d)   *vipm_Ell_(r2d)(bquad)         __P((vipm_Quad_t(r2d) *, vipm_Ell_t(r2d) const *));
__PUB vipm_Quad_t(f2d)   *vipm_Ell_(r2d)(bquad,f)       __P((vipm_Quad_t(f2d) *, vipm_Ell_t(r2d) const *));
__PUB vipm_Quad_t(r2d)   *vipm_Ell_(r2d)(minbquad)      __P((vipm_Quad_t(r2d) *, vipm_Ell_t(r2d) const *));
__PUB vipm_Quad_t(f2d)   *vipm_Ell_(r2d)(minbquad,f)    __P((vipm_Quad_t(f2d) *, vipm_Ell_t(r2d) const *));
# define vipm_r2d_ell_bquad_$r              vipm_r2d_ell_bquad
# define vipm_r2d_ell_minbquad_$r           vipm_r2d_ell_minbquad


/* +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ */

/* @{ */

# define vipm_f2d_ell_isconvex(x)           (1)
# define vipm_f2d_ell_rotation(x)           ((double) (x)->el_theta)
# define vipm_f2d_ell_minbquad              vipm_f2d_ell_bquad
# define vipm_f2d_ell_minbquad_$r           vipm_f2d_ell_bquad_$r


_VIPM_INLINE int
vipm_Ell_(f2d)(inside)(vipm_Ell_t(f2d) const *aShape, vipm_Point_t(f2d) const *aPoint)
{
	return vipm_Ell_(f2d)(inside2)(aShape, aPoint->pi_y, aPoint->pi_x);
}

/* ------------------------------------------------------------------------- */

_VIPM_INLINE double *
vipm_Ell_(f2d)(moment1)(double aResult[], vipm_Ell_t(f2d) const *aShape)
{
	aResult[0] = aShape->el_c.__v[0];
	aResult[1] = aShape->el_c.__v[1];
	return (aResult);
}

_VIPM_INLINE vipm_Point_t(f2d) *
vipm_Ell_(f2d)(centroid)(vipm_Point_t(f2d) *aResult, vipm_Ell_t(f2d) const *aShape)
{
	*aResult = aShape->el_c;
	return (aResult);
}

_VIPM_INLINE vipm_Point_t(r2d) *
vipm_Ell_(f2d)(centroid,r)(vipm_Point_t(r2d) *aResult, vipm_Ell_t(f2d) const *aShape)
{
	return vipm_Point(r2d)(cast,f)(aResult, &aShape->el_c);
}

/* @} */


/* ========================================================================= */

/* @{ */

# define vipm_r2d_ell_isconvex(x)           (1)
# define vipm_r2d_ell_rotation(x)           ((x)->el_theta)
# define vipm_r2d_ell_minbquad              vipm_r2d_ell_bquad
# define vipm_r2d_ell_minbquad_$f           vipm_r2d_ell_bquad_$f


_VIPM_INLINE int
vipm_Ell_(r2d)(inside)(vipm_Ell_t(r2d) const *aShape, vipm_Point_t(r2d) const *aPoint)
{
	return vipm_Ell_(r2d)(inside2)(aShape, aPoint->pi_y, aPoint->pi_x);
}

/* ------------------------------------------------------------------------- */

_VIPM_INLINE double *
vipm_Ell_(r2d)(moment1)(double aResult[], vipm_Ell_t(r2d) const *aShape)
{
	aResult[0] = aShape->el_c.__v[0];
	aResult[1] = aShape->el_c.__v[1];
	return (aResult);
}

_VIPM_INLINE vipm_Point_t(r2d) *
vipm_Ell_(r2d)(centroid)(vipm_Point_t(r2d) *aResult, vipm_Ell_t(r2d) const *aShape)
{
	*aResult = aShape->el_c;
	return (aResult);
}

_VIPM_INLINE vipm_Point_t(f2d) *
vipm_Ell_(r2d)(centroid,f)(vipm_Point_t(f2d) *aResult, vipm_Ell_t(r2d) const *aShape)
{
	return vipm_Point(f2d)(cast,r)(aResult, &aShape->el_c);
}

/* @} */


__MYC_END_CDECLS
# undef __PUB
# undef __PRIV


#endif /* !defined(__VIPM_MATH_GEOMETRY_2D_ELLIPSE_H__) */


/******************************************************************************
 *
 *
 *
 *****************************************************************************/
