/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright 2016 Seenaptec Ltd. All rights reserved.
 * SEENAPTEC PROPRIETARY/CONFIDENTIAL.
 *
 * $Id$
 */

/*
 * Point.h	(V.Sokur)
 * Vipm/Math/Geometry/2D/Point.h
 */

/* ------------------------------------------------------------------------- */

#ifndef __VIPM_MATH_GEOMETRY_2D_POINT_H__
# define __VIPM_MATH_GEOMETRY_2D_POINT_H__

/******************************************************************************
 * %% BeginSection: includes
 */

# ifndef __VIPM_TYPES_H__
#  include <Vipm/Types.h>
# endif


/******************************************************************************
 * %% BeginSection: function prototypes
 */
# pragma mark -
# pragma mark [ function prototypes ]
# pragma mark -

# include <Vipm/Linkage.h>
# define __PUB __myc_flinkage__(public,libVipm)
# define __PRIV __myc_flinkage__(private,libVipm)
__MYC_BEGIN_CDECLS

/*
 * Construct
 */

__PUB vipm_Point_t(2d)   *vipm_Point(2d)(cast,f)    __P((vipm_Point_t(2d) *, vipm_Point_t(f2d) const *));
__PUB vipm_Point_t(2d)   *vipm_Point(2d)(cast,r)    __P((vipm_Point_t(2d) *, vipm_Point_t(r2d) const *));

/* ------------------------------------------------------------------------- */

/*
 * Functional
 */

__PUB int                 vipm_Pt_(2d)(equal)       __P((vipm_Point_t(2d) const *, vipm_Point_t(2d) const *));
__PUB int                 vipm_Pt_(2d)(_equal)      __P((vipm_Point_t(2d) const *, vipm_Point_t(2d) const *));

__PUB vipm_Point_t(2d)   *vipm_Pt_(2d)(advance)     __P((vipm_Point_t(2d) *, vipm_Point_t(2d) const *, vipm_int, vipm_int));
__PUB vipm_Point_t(2d)   *vipm_Pt_(2d)(advance,I)   __P((vipm_Point_t(2d) *, vipm_int, vipm_int));
__PUB vipm_Point_t(2d)   *vipm_Pt_(2d)(setadv)      __P((vipm_Point_t(2d) *, vipm_Point_t(2d) const *, vipm_int, vipm_int));


/* ========================================================================= */

/*
 * Construct
 */

__PUB vipm_Point_t(f2d)  *vipm_Point(f2d)(cast,r)   __P((vipm_Point_t(f2d) *, vipm_Point_t(r2d) const *));

/* ------------------------------------------------------------------------- */

/*
 * Functional
 */

__PUB int                 vipm_Pt_(f2d)(equal)      __P((vipm_Point_t(f2d) const *, vipm_Point_t(f2d) const *));
__PUB int                 vipm_Pt_(f2d)(_equal)     __P((vipm_Point_t(f2d) const *, vipm_Point_t(f2d) const *));


/* ========================================================================= */

/*
 * Construct
 */

__PUB vipm_Point_t(r2d)  *vipm_Point(r2d)(cast,f)   __P((vipm_Point_t(r2d) *, vipm_Point_t(f2d) const *));

/* ------------------------------------------------------------------------- */

/*
 * Functional
 */

__PUB int                 vipm_Pt_(r2d)(equal)      __P((vipm_Point_t(r2d) const *, vipm_Point_t(r2d) const *));
__PUB int                 vipm_Pt_(r2d)(_equal)     __P((vipm_Point_t(r2d) const *, vipm_Point_t(r2d) const *));


/* +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ */

/* @{ */

_VIPM_INLINE vipm_Point_t(2d) *
vipm_Point(2d)(cast,f)(vipm_Point_t(2d) *aDst, vipm_Point_t(f2d) const *aSrc)
{
	aDst->__v[0] = vipm_satcast_s32f(aSrc->__v[0]);
	aDst->__v[1] = vipm_satcast_s32f(aSrc->__v[1]);
	return (aDst);
}

_VIPM_INLINE vipm_Point_t(2d) *
vipm_Point(2d)(cast,r)(vipm_Point_t(2d) *aDst, vipm_Point_t(r2d) const *aSrc)
{
	aDst->__v[0] = vipm_satcast_s32d(aSrc->__v[0]);
	aDst->__v[1] = vipm_satcast_s32d(aSrc->__v[1]);
	return (aDst);
}

/* ------------------------------------------------------------------------- */

_VIPM_INLINE int
vipm_Pt_(2d)(_equal)(vipm_Point_t(2d) const *aLhs, vipm_Point_t(2d) const *aRhs)
{
	return (aLhs->__v[0] == aRhs->__v[0] && aLhs->__v[1] == aRhs->__v[1]);
}

_VIPM_INLINE int
vipm_Pt_(2d)(equal)(vipm_Point_t(2d) const *aLhs, vipm_Point_t(2d) const *aRhs)
{
	return (aLhs == aRhs || vipm_Pt_(2d)(_equal)(aLhs, aRhs));
}

/* ------------------------------------------------------------------------- */

_VIPM_INLINE vipm_Point_t(2d) *
vipm_Pt_(2d)(advance,I)(vipm_Point_t(2d) *aDst, vipm_int dY, vipm_int dX)
{
	aDst->pi_y += dY;
	aDst->pi_x += dX;
	return (aDst);
}

/* @} */


/* ========================================================================= */

/* @{ */

_VIPM_INLINE vipm_Point_t(f2d) *
vipm_Point(f2d)(cast,r)(vipm_Point_t(f2d) *aDst, vipm_Point_t(r2d) const *aSrc)
{
	aDst->__v[0] = vipm_satcast_f32d(aSrc->__v[0]);
	aDst->__v[1] = vipm_satcast_f32d(aSrc->__v[1]);
	return (aDst);
}

/* ------------------------------------------------------------------------- */

_VIPM_INLINE int
vipm_Pt_(f2d)(_equal)(vipm_Point_t(f2d) const *aLhs, vipm_Point_t(f2d) const *aRhs)
{
	return (vipmi__equalf(aLhs->__v[0], aRhs->__v[0]) && vipmi__equalf(aLhs->__v[1], aRhs->__v[1]));
}

_VIPM_INLINE int
vipm_Pt_(f2d)(equal)(vipm_Point_t(f2d) const *aLhs, vipm_Point_t(f2d) const *aRhs)
{
	return (aLhs == aRhs || vipm_Pt_(f2d)(_equal)(aLhs, aRhs));
}

/* @} */


/* ========================================================================= */

/* @{ */

_VIPM_INLINE vipm_Point_t(r2d) *
vipm_Point(r2d)(cast,f)(vipm_Point_t(r2d) *aDst, vipm_Point_t(f2d) const *aSrc)
{
	aDst->__v[0] = aSrc->__v[0];
	aDst->__v[1] = aSrc->__v[1];
	return (aDst);
}

/* ------------------------------------------------------------------------- */

_VIPM_INLINE int
vipm_Pt_(r2d)(_equal)(vipm_Point_t(r2d) const *aLhs, vipm_Point_t(r2d) const *aRhs)
{
	return (vipmi__equald(aLhs->__v[0], aRhs->__v[0]) && vipmi__equald(aLhs->__v[1], aRhs->__v[1]));
}

_VIPM_INLINE int
vipm_Pt_(r2d)(equal)(vipm_Point_t(r2d) const *aLhs, vipm_Point_t(r2d) const *aRhs)
{
	return (aLhs == aRhs || vipm_Pt_(r2d)(_equal)(aLhs, aRhs));
}

/* @} */


__MYC_END_CDECLS
# undef __PUB
# undef __PRIV


#endif /* !defined(__VIPM_MATH_GEOMETRY_2D_POINT_H__) */


/******************************************************************************
 *
 *
 *
 *****************************************************************************/
