/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright 2016 Seenaptec Ltd. All rights reserved.
 * SEENAPTEC PROPRIETARY/CONFIDENTIAL.
 *
 * $Id$
 */

/*
 * PolyUtils.h	(V.Sokur)
 * Vipm/Math/Geometry/2D/PolyUtils.h
 */

/* ------------------------------------------------------------------------- */

#ifndef __VIPM_MATH_GEOMETRY_2D_POLYUTILS_H__
# define __VIPM_MATH_GEOMETRY_2D_POLYUTILS_H__

/******************************************************************************
 * %% BeginSection: includes
 */

# ifndef __VIPM_TYPES_H__
#  include <Vipm/Types.h>
# endif

# ifndef __VIPM_MATH_GEOMETRY_2D_POINTLIST_H__
#  include <Vipm/Math/Geometry/2D/PointList.h>
# endif


/******************************************************************************
 * %% BeginSection: function prototypes
 */
# pragma mark -
# pragma mark [ function prototypes ]
# pragma mark -

# include <Vipm/Linkage.h>
# define __PUB __myc_flinkage__(public,libVipm)
# define __PROT __myc_flinkage__(public,libVipm)
# define __PRIV __myc_flinkage__(private,libVipm)
__MYC_BEGIN_CDECLS

/*
 * Shape{2D}
 */

__PUB double              vipm_Poly_(2d)(area)            __P((vipm_Point_t(2d) const [], vipm_int));
__PUB double              vipm_Poly_(2d)(rotation)        __P((vipm_Point_t(2d) const [], vipm_int));
__PUB int                 vipm_Poly_(2d)(isclockwise,M)   __P((vipm_Point_t(2d) const [], vipm_int));
__PUB int                 vipm_Poly_(2d)(iscclockwise,M)  __P((vipm_Point_t(2d) const [], vipm_int));
__PUB int                 vipm_Poly_(2d)(isclockwise)     __P((vipm_Point_t(2d) const [], vipm_int));
__PUB int                 vipm_Poly_(2d)(iscclockwise)    __P((vipm_Point_t(2d) const [], vipm_int));
__PUB int                 vipm_Poly_(2d)(inside)          __P((vipm_Point_t(2d) const [], vipm_int, vipm_Point_t(2d) const *));
__PUB int                 vipm_Poly_(2d)(inside2)         __P((vipm_Point_t(2d) const [], vipm_int, vipm_int, vipm_int));
__PUB int                 vipm_Poly_(2d)(isconvex)        __P((vipm_Point_t(2d) const [], vipm_int));

/* ------------------------------------------------------------------------- */

__PUB double             *vipm_Poly_(2d)(moment1)         __P((double [/*2*/], vipm_Point_t(2d) const [], vipm_int));
__PUB double             *vipm_Poly_(2d)(moment2)         __P((double [/*3*/], vipm_Point_t(2d) const [], vipm_int));
__PUB double             *vipm_Poly_(2d)(moment2,c)       __P((double [/*3*/], vipm_Point_t(2d) const [], vipm_int));
__PUB double             *vipm_Poly_(2d)(covariance)      __P((double [/*4*/], vipm_Point_t(2d) const [], vipm_int));
__PUB vipm_Point_t(2d)   *vipm_Poly_(2d)(centroid)        __P((vipm_Point_t(2d)  *, vipm_Point_t(2d) const [], vipm_int));
__PUB vipm_Point_t(f2d)  *vipm_Poly_(2d)(centroid,f)      __P((vipm_Point_t(f2d) *, vipm_Point_t(2d) const [], vipm_int));
__PUB vipm_Point_t(r2d)  *vipm_Poly_(2d)(centroid,r)      __P((vipm_Point_t(r2d) *, vipm_Point_t(2d) const [], vipm_int));

/* ------------------------------------------------------------------------- */

__PUB vipm_Rect_t(2d)    *vipm_Poly_(2d)(brect)           __P((vipm_Rect_t(2d)  *, vipm_Point_t(2d) const [], vipm_int));
__PUB vipm_Quad_t(f2d)   *vipm_Poly_(2d)(bquad,f)         __P((vipm_Quad_t(f2d) *, vipm_Point_t(2d) const [], vipm_int));
__PUB vipm_Quad_t(r2d)   *vipm_Poly_(2d)(bquad,r)         __P((vipm_Quad_t(r2d) *, vipm_Point_t(2d) const [], vipm_int));
__PUB vipm_Quad_t(f2d)   *vipm_Poly_(2d)(minbquad,f)      __P((vipm_Quad_t(f2d) *, vipm_Point_t(2d) const [], vipm_int));
__PUB vipm_Quad_t(r2d)   *vipm_Poly_(2d)(minbquad,r)      __P((vipm_Quad_t(r2d) *, vipm_Point_t(2d) const [], vipm_int));
__PUB vipm_Ell_t(f2d)    *vipm_Poly_(2d)(fitell,f)        __P((vipm_Ell_t(f2d)  *, vipm_Point_t(2d) const [], vipm_int));
__PUB vipm_Ell_t(r2d)    *vipm_Poly_(2d)(fitell,r)        __P((vipm_Ell_t(r2d)  *, vipm_Point_t(2d) const [], vipm_int));

/* ------------------------------------------------------------------------- */

__PUB vipm_int            vipm_Poly_(2d)(convexhull,I)    __P((vipm_Point_t(2d) [], vipm_int));
__PUB vipm_int            vipm_Poly_(2d)(convexhull)      __P((vipm_Point_t(2d) [], vipm_Point_t(2d) const [], vipm_int));
__PUB vipm_int            vipm_Poly_(2d)(aconvexhull)     __P((vipm_Point_t(2d) **, vipm_Point_t(2d) const [], vipm_int));
__PUB vipm_Point_t(2d)   *vipm_Poly_(2d)(sort,I)          __P((vipm_Point_t(2d) [], vipm_int));


/* ========================================================================= */

/*
 * Shape{F2D}
 */

__PUB double              vipm_Poly_(f2d)(area)           __P((vipm_Point_t(f2d) const [], vipm_int));
__PUB double              vipm_Poly_(f2d)(rotation)       __P((vipm_Point_t(f2d) const [], vipm_int));
__PUB int                 vipm_Poly_(f2d)(isclockwise,M)  __P((vipm_Point_t(f2d) const [], vipm_int));
__PUB int                 vipm_Poly_(f2d)(iscclockwise,M) __P((vipm_Point_t(f2d) const [], vipm_int));
__PUB int                 vipm_Poly_(f2d)(isclockwise)    __P((vipm_Point_t(f2d) const [], vipm_int));
__PUB int                 vipm_Poly_(f2d)(iscclockwise)   __P((vipm_Point_t(f2d) const [], vipm_int));
__PUB int                 vipm_Poly_(f2d)(inside)         __P((vipm_Point_t(f2d) const [], vipm_int, vipm_Point_t(f2d) const *));
__PUB int                 vipm_Poly_(f2d)(inside2)        __P((vipm_Point_t(f2d) const [], vipm_int, bo_float32_t, bo_float32_t));
__PUB int                 vipm_Poly_(f2d)(isconvex)       __P((vipm_Point_t(f2d) const [], vipm_int));

/* ------------------------------------------------------------------------- */

__PUB double             *vipm_Poly_(f2d)(moment1)        __P((double [/*2*/], vipm_Point_t(f2d) const [], vipm_int));
__PUB double             *vipm_Poly_(f2d)(moment2)        __P((double [/*3*/], vipm_Point_t(f2d) const [], vipm_int));
__PUB double             *vipm_Poly_(f2d)(moment2,c)      __P((double [/*3*/], vipm_Point_t(f2d) const [], vipm_int));
__PUB double             *vipm_Poly_(f2d)(covariance)     __P((double [/*4*/], vipm_Point_t(f2d) const [], vipm_int));
__PUB vipm_Point_t(f2d)  *vipm_Poly_(f2d)(centroid)       __P((vipm_Point_t(f2d) *, vipm_Point_t(f2d) const [], vipm_int));
__PUB vipm_Point_t(r2d)  *vipm_Poly_(f2d)(centroid,r)     __P((vipm_Point_t(r2d) *, vipm_Point_t(f2d) const [], vipm_int));
# define vipm_f2d_poly_centroid_$f          vipm_f2d_poly_centroid

/* ------------------------------------------------------------------------- */

__PUB vipm_Rect_t(f2d)   *vipm_Poly_(f2d)(brect)          __P((vipm_Rect_t(f2d) *, vipm_Point_t(f2d) const [], vipm_int));
__PUB vipm_Quad_t(f2d)   *vipm_Poly_(f2d)(bquad)          __P((vipm_Quad_t(f2d) *, vipm_Point_t(f2d) const [], vipm_int));
__PUB vipm_Quad_t(r2d)   *vipm_Poly_(f2d)(bquad,r)        __P((vipm_Quad_t(r2d) *, vipm_Point_t(f2d) const [], vipm_int));
__PUB vipm_Quad_t(f2d)   *vipm_Poly_(f2d)(minbquad)       __P((vipm_Quad_t(f2d) *, vipm_Point_t(f2d) const [], vipm_int));
__PUB vipm_Quad_t(r2d)   *vipm_Poly_(f2d)(minbquad,r)     __P((vipm_Quad_t(r2d) *, vipm_Point_t(f2d) const [], vipm_int));
__PUB vipm_Ell_t(f2d)    *vipm_Poly_(f2d)(fitell)         __P((vipm_Ell_t(f2d)  *, vipm_Point_t(f2d) const [], vipm_int));
__PUB vipm_Ell_t(r2d)    *vipm_Poly_(f2d)(fitell,r)       __P((vipm_Ell_t(r2d)  *, vipm_Point_t(f2d) const [], vipm_int));
# define vipm_f2d_poly_bquad_$f             vipm_f2d_poly_bquad
# define vipm_f2d_poly_minbquad_$f          vipm_f2d_poly_minbquad
# define vipm_f2d_poly_fitell_$f            vipm_f2d_poly_fitell

/* ------------------------------------------------------------------------- */

__PUB vipm_int            vipm_Poly_(f2d)(convexhull,I)   __P((vipm_Point_t(f2d) [], vipm_int));
__PUB vipm_int            vipm_Poly_(f2d)(convexhull)     __P((vipm_Point_t(f2d) [], vipm_Point_t(f2d) const [], vipm_int));
__PUB vipm_int            vipm_Poly_(f2d)(aconvexhull)    __P((vipm_Point_t(f2d) **, vipm_Point_t(f2d) const [], vipm_int));
__PUB vipm_Point_t(f2d)  *vipm_Poly_(f2d)(sort,I)         __P((vipm_Point_t(f2d) [], vipm_int));


/* ========================================================================= */

/*
 * Shape{R2D}
 */

__PUB double              vipm_Poly_(r2d)(area)           __P((vipm_Point_t(r2d) const [], vipm_int));
__PUB double              vipm_Poly_(r2d)(rotation)       __P((vipm_Point_t(r2d) const [], vipm_int));
__PUB int                 vipm_Poly_(r2d)(isclockwise,M)  __P((vipm_Point_t(r2d) const [], vipm_int));
__PUB int                 vipm_Poly_(r2d)(iscclockwise,M) __P((vipm_Point_t(r2d) const [], vipm_int));
__PUB int                 vipm_Poly_(r2d)(isclockwise)    __P((vipm_Point_t(r2d) const [], vipm_int));
__PUB int                 vipm_Poly_(r2d)(iscclockwise)   __P((vipm_Point_t(r2d) const [], vipm_int));
__PUB int                 vipm_Poly_(r2d)(inside)         __P((vipm_Point_t(r2d) const [], vipm_int, vipm_Point_t(r2d) const *));
__PUB int                 vipm_Poly_(r2d)(inside2)        __P((vipm_Point_t(r2d) const [], vipm_int, bo_float64_t, bo_float64_t));
__PUB int                 vipm_Poly_(r2d)(isconvex)       __P((vipm_Point_t(r2d) const [], vipm_int));

/* ------------------------------------------------------------------------- */

__PUB double             *vipm_Poly_(r2d)(moment1)        __P((double [/*2*/], vipm_Point_t(r2d) const [], vipm_int));
__PUB double             *vipm_Poly_(r2d)(moment2)        __P((double [/*3*/], vipm_Point_t(r2d) const [], vipm_int));
__PUB double             *vipm_Poly_(r2d)(moment2,c)      __P((double [/*3*/], vipm_Point_t(r2d) const [], vipm_int));
__PUB double             *vipm_Poly_(r2d)(covariance)     __P((double [/*4*/], vipm_Point_t(r2d) const [], vipm_int));
__PUB vipm_Point_t(r2d)  *vipm_Poly_(r2d)(centroid)       __P((vipm_Point_t(r2d) *, vipm_Point_t(r2d) const [], vipm_int));
__PUB vipm_Point_t(f2d)  *vipm_Poly_(r2d)(centroid,f)     __P((vipm_Point_t(f2d) *, vipm_Point_t(r2d) const [], vipm_int));
# define vipm_r2d_poly_centroid_$r          vipm_r2d_poly_centroid

/* ------------------------------------------------------------------------- */

__PUB vipm_Rect_t(r2d)    *vipm_Poly_(r2d)(brect)         __P((vipm_Rect_t(r2d) *, vipm_Point_t(r2d) const [], vipm_int));
__PUB vipm_Quad_t(r2d)    *vipm_Poly_(r2d)(bquad)         __P((vipm_Quad_t(r2d) *, vipm_Point_t(r2d) const [], vipm_int));
__PUB vipm_Quad_t(f2d)    *vipm_Poly_(r2d)(bquad,f)       __P((vipm_Quad_t(f2d) *, vipm_Point_t(r2d) const [], vipm_int));
__PUB vipm_Quad_t(r2d)    *vipm_Poly_(r2d)(minbquad)      __P((vipm_Quad_t(r2d) *, vipm_Point_t(r2d) const [], vipm_int));
__PUB vipm_Quad_t(f2d)    *vipm_Poly_(r2d)(minbquad,f)    __P((vipm_Quad_t(f2d) *, vipm_Point_t(r2d) const [], vipm_int));
__PUB vipm_Ell_t(r2d)     *vipm_Poly_(r2d)(fitell)        __P((vipm_Ell_t(r2d)  *, vipm_Point_t(r2d) const [], vipm_int));
__PUB vipm_Ell_t(f2d)     *vipm_Poly_(r2d)(fitell,f)      __P((vipm_Ell_t(f2d)  *, vipm_Point_t(r2d) const [], vipm_int));
# define vipm_r2d_poly_bquad_$r             vipm_r2d_poly_bquad
# define vipm_r2d_poly_minbquad_$r          vipm_r2d_poly_minbquad
# define vipm_r2d_poly_fitell_$r            vipm_r2d_poly_fitell

/* ------------------------------------------------------------------------- */

__PUB vipm_int            vipm_Poly_(r2d)(convexhull,I)   __P((vipm_Point_t(r2d) [], vipm_int));
__PUB vipm_int            vipm_Poly_(r2d)(convexhull)     __P((vipm_Point_t(r2d) [], vipm_Point_t(r2d) const [], vipm_int));
__PUB vipm_int            vipm_Poly_(r2d)(aconvexhull)    __P((vipm_Point_t(r2d) **, vipm_Point_t(r2d) const [], vipm_int));
__PUB vipm_Point_t(r2d)  *vipm_Poly_(r2d)(sort,I)         __P((vipm_Point_t(r2d) [], vipm_int));


/* ========================================================================= */

__PROT double             vipm_Poly_(2d)(__sarea)         __P((vipm_Point_t(2d)  const [], vipm_int));
__PROT double             vipm_Poly_(f2d)(__sarea)        __P((vipm_Point_t(f2d) const [], vipm_int));
__PROT double             vipm_Poly_(r2d)(__sarea)        __P((vipm_Point_t(r2d) const [], vipm_int));

# define vipm_2d_poly___sarea                  vipm_2d_ptv___sarea
# define vipm_f2d_poly___sarea                 vipm_f2d_ptv___sarea
# define vipm_r2d_poly___sarea                 vipm_r2d_ptv___sarea


/* +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ */

/* @{ */

# define vipm_2d_poly_isclockwise_$M            vipm_2d_ptv_isclockwise_$M
# define vipm_2d_poly_iscclockwise_$M           vipm_2d_ptv_iscclockwis_$M
# define vipm_2d_poly_isclockwise               vipm_2d_ptv_isclockwise
# define vipm_2d_poly_iscclockwise              vipm_2d_ptv_iscclockwise
# define vipm_2d_poly_isconvex                  vipm_2d_ptv_isconvex

# define vipm_2d_poly_brect                     vipm_2d_ptv_brect
# define vipm_2d_poly_bquad_$f                  vipm_2d_ptv_bquad_$f
# define vipm_2d_poly_bquad_$r                  vipm_2d_ptv_bquad_$r
# define vipm_2d_poly_minbquad_$f               vipm_2d_ptv_minbquad_$f
# define vipm_2d_poly_minbquad_$r               vipm_2d_ptv_minbquad_$r

# define vipm_2d_poly_convexhull_$I             vipm_2d_ptv_convexhull_$I
# define vipm_2d_poly_convexhull                vipm_2d_ptv_convexhull
# define vipm_2d_poly_aconvexhull               vipm_2d_ptv_aconvexhull
# define vipm_2d_poly_sort_$I                   vipm_2d_ptv_sort_$I

# define vipm_2d_poly_centroid_$r(r,sh,n)       vipm_r2d_point_mp(vipm_2d_poly_moment1((double *)(r),sh,n))


_VIPM_INLINE int
vipm_Poly_(2d)(inside)(vipm_Point_t(2d) const aShape[], vipm_int aNumPoints, vipm_Point_t(2d) const *aPoint)
{
	return vipm_Poly_(2d)(inside2)(aShape, aNumPoints, aPoint->pi_y, aPoint->pi_x);
}

/* @} */


/* ========================================================================= */

/* @{ */

# define vipm_f2d_poly_isclockwise_$M           vipm_f2d_ptv_isclockwise_$M
# define vipm_f2d_poly_iscclockwise_$M          vipm_f2d_ptv_iscclockwise_$M
# define vipm_f2d_poly_isclockwise              vipm_f2d_ptv_isclockwise
# define vipm_f2d_poly_iscclockwise             vipm_f2d_ptv_iscclockwise
# define vipm_f2d_poly_isconvex                 vipm_f2d_ptv_isconvex

# define vipm_f2d_poly_brect                    vipm_f2d_ptv_brect
# define vipm_f2d_poly_bquad                    vipm_f2d_ptv_bquad
# define vipm_f2d_poly_bquadf64                 vipm_f2d_ptv_bquad_$r
# define vipm_f2d_poly_minbquad                 vipm_f2d_ptv_minbquad
# define vipm_f2d_poly_minbquadf64              vipm_f2d_ptv_minbquad_$r

# define vipm_f2d_poly_convexhull_$I            vipm_f2d_ptv_convexhull_$I
# define vipm_f2d_poly_convexhull               vipm_f2d_ptv_convexhull
# define vipm_f2d_poly_aconvexhull              vipm_f2d_ptv_aconvexhull
# define vipm_f2d_poly_sort_$I                  vipm_f2d_ptv_sort_$I

# define vipm_f2d_poly_centroid_$r(r,sh,n)      vipm_r2d_point_mp(vipm_f2d_poly_moment1((double *)(r),sh,n))


_VIPM_INLINE int
vipm_Poly_(f2d)(inside)(vipm_Point_t(f2d) const aShape[], vipm_int aNumPoints, vipm_Point_t(f2d) const *aPoint)
{
	return vipm_Poly_(f2d)(inside2)(aShape, aNumPoints, aPoint->pi_y, aPoint->pi_x);
}

/* @} */


/* ========================================================================= */

/* @{ */

# define vipm_r2d_poly_isclockwise_$M           vipm_r2d_ptv_isclockwise_$M
# define vipm_r2d_poly_iscclockwise_$M          vipm_r2d_ptv_iscclockwise_$M
# define vipm_r2d_poly_isclockwise              vipm_r2d_ptv_isclockwise
# define vipm_r2d_poly_iscclockwise             vipm_r2d_ptv_iscclockwise
# define vipm_r2d_poly_isconvex                 vipm_r2d_ptv_isconvex

# define vipm_r2d_poly_brect                    vipm_r2d_ptv_brect
# define vipm_r2d_poly_bquad                    vipm_r2d_ptv_bquad
# define vipm_r2d_poly_bquad_$f                 vipm_r2d_ptv_bquad_$f
# define vipm_r2d_poly_minbquad                 vipm_r2d_ptv_minbquad
# define vipm_r2d_poly_minbquad_$f              vipm_r2d_ptv_minbquad_$f

# define vipm_r2d_poly_convexhull_$I            vipm_r2d_ptv_convexhull_$I
# define vipm_r2d_poly_convexhull               vipm_r2d_ptv_convexhull
# define vipm_r2d_poly_aconvexhull              vipm_r2d_ptv_aconvexhull
# define vipm_r2d_poly_sort_$I                  vipm_r2d_ptv_sort_$I

# define vipm_r2d_poly_centroid(r,sh,n)         vipm_r2d_point_mp(vipm_r2d_poly_moment1((double *)(r),sh,n))


_VIPM_INLINE int
vipm_Poly_(r2d)(inside)(vipm_Point_t(r2d) const aShape[], vipm_int aNumPoints, vipm_Point_t(r2d) const *aPoint)
{
	return vipm_Poly_(r2d)(inside2)(aShape, aNumPoints, aPoint->pi_y, aPoint->pi_x);
}

/* @} */


__MYC_END_CDECLS
# undef __PUB
# undef __PROT
# undef __PRIV


#endif /* !defined(__VIPM_MATH_GEOMETRY_2D_POLYUTILS_H__) */


/******************************************************************************
 *
 *
 *
 *****************************************************************************/
