/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright 2016 Seenaptec Ltd. All rights reserved.
 * SEENAPTEC PROPRIETARY/CONFIDENTIAL.
 *
 * $Id$
 */

/*
 * Quad.h	(V.Sokur)
 * Vipm/Math/Geometry/2D/Quad.h
 */

/* ------------------------------------------------------------------------- */

#ifndef __VIPM_MATH_GEOMETRY_2D_QUAD_H__
# define __VIPM_MATH_GEOMETRY_2D_QUAD_H__

/******************************************************************************
 * %% BeginSection: includes
 */

# ifndef __VIPM_TYPES_H__
#  include <Vipm/Types.h>
# endif

# ifndef __VIPM_MATH_GEOMETRY_2D_POLYUTILS_H__
#  include <Vipm/Math/Geometry/2D/PolyUtils.h>
# endif


/******************************************************************************
 * %% BeginSection: function prototypes
 */
# pragma mark -
# pragma mark [ function prototypes ]
# pragma mark -

# include <Vipm/Linkage.h>
# define __PUB __myc_flinkage__(public,libVipm)
# define __PROT __myc_flinkage__(public,libVipm)
# define __PRIV __myc_flinkage__(private,libVipm)
__MYC_BEGIN_CDECLS

/*
 * Quad{F2D}
 */

	/*
	 * Construct
	 */

__PUB vipm_Quad_t(f2d)   *vipm_Quad(f2d)(4)         __P((vipm_Quad_t(f2d) *, bo_float32_t, bo_float32_t,
                                                             bo_float32_t, bo_float32_t, bo_float32_t, bo_float32_t,
                                                             bo_float32_t, bo_float32_t));
__PUB vipm_Quad_t(f2d)   *vipm_Quad(f2d)(2)         __P((vipm_Quad_t(f2d) *, bo_float32_t, bo_float32_t,
                                                             bo_float32_t, bo_float32_t));

__PUB vipm_Quad_t(f2d)   *vipm_Quad(f2d)(cast,r)    __P((vipm_Quad_t(f2d) *, vipm_Quad_t(r2d) const *));

__PUB vipm_Quad_t(f2d)   *vipm_Quad(f2d)(rcpt,i)    __P((vipm_Quad_t(f2d) *, vipm_Rcpt_t(2d)  const *));
__PUB vipm_Quad_t(f2d)   *vipm_Quad(f2d)(rcpt)      __P((vipm_Quad_t(f2d) *, vipm_Rcpt_t(f2d) const *));
__PUB vipm_Quad_t(f2d)   *vipm_Quad(f2d)(rcpt,r)    __P((vipm_Quad_t(f2d) *, vipm_Rcpt_t(r2d) const *));
__PUB vipm_Quad_t(f2d)   *vipm_Quad(f2d)(rect,i)    __P((vipm_Quad_t(f2d) *, vipm_Rect_t(2d)  const *));
__PUB vipm_Quad_t(f2d)   *vipm_Quad(f2d)(rect)      __P((vipm_Quad_t(f2d) *, vipm_Rect_t(f2d) const *));
__PUB vipm_Quad_t(f2d)   *vipm_Quad(f2d)(rect,r)    __P((vipm_Quad_t(f2d) *, vipm_Rect_t(r2d) const *));
# define vipm_f2d_quad_rcpt_$f              vipm_f2d_quad_rcpt
# define vipm_f2d_quad_rect_$f              vipm_f2d_quad_rect

/* ------------------------------------------------------------------------- */

	/*
	 * Functional
	 */

__PUB double              vipm_Quad_(f2d)(area)           __P((vipm_Quad_t(f2d) const *));
__PUB double              vipm_Quad_(f2d)(rotation)       __P((vipm_Quad_t(f2d) const *));
__PUB int                 vipm_Quad_(f2d)(isclockwise,M)  __P((vipm_Quad_t(f2d) const *));
__PUB int                 vipm_Quad_(f2d)(iscclockwise,M) __P((vipm_Quad_t(f2d) const *));
__PUB int                 vipm_Quad_(f2d)(isclockwise)    __P((vipm_Quad_t(f2d) const *));
__PUB int                 vipm_Quad_(f2d)(iscclockwise)   __P((vipm_Quad_t(f2d) const *));
__PUB int                 vipm_Quad_(f2d)(inside)         __P((vipm_Quad_t(f2d) const *, vipm_Point_t(f2d) const *));
__PUB int                 vipm_Quad_(f2d)(inside,2)       __P((vipm_Quad_t(f2d) const *, bo_float32_t, bo_float32_t));
__PUB int                 vipm_Quad_(f2d)(isconvex)       __P((vipm_Quad_t(f2d) const *));

__PUB double             *vipm_Quad_(f2d)(moment1)        __P((double [/*2*/], vipm_Quad_t(f2d) const *));
__PUB double             *vipm_Quad_(f2d)(moment2)        __P((double [/*3*/], vipm_Quad_t(f2d) const *));
__PUB double             *vipm_Quad_(f2d)(moment2,c)      __P((double [/*3*/], vipm_Quad_t(f2d) const *));
__PUB double             *vipm_Quad_(f2d)(covariance)     __P((double [/*4*/], vipm_Quad_t(f2d) const *));
__PUB vipm_Point_t(f2d)  *vipm_Quad_(f2d)(centroid)       __P((vipm_Point_t(f2d) *, vipm_Quad_t(f2d) const *));
__PUB vipm_Point_t(r2d)  *vipm_Quad_(f2d)(centroid,r)     __P((vipm_Point_t(r2d) *, vipm_Quad_t(f2d) const *));
# define vipm_f2d_quad_centroid_$f          vipm_f2d_quad_centroid

__PUB vipm_Rect_t(f2d)   *vipm_Quad_(f2d)(brect)          __P((vipm_Rect_t(f2d) *, vipm_Quad_t(f2d) const *));
__PUB vipm_Ell_t(f2d)    *vipm_Quad_(f2d)(fitell)         __P((vipm_Ell_t(f2d) *,  vipm_Quad_t(f2d) const *));
__PUB vipm_Ell_t(r2d)    *vipm_Quad_(f2d)(fitell,r)       __P((vipm_Ell_t(r2d) *,  vipm_Quad_t(f2d) const *));
# define vipm_f2d_quad_fitell_$f            vipm_f2d_quad_fitell

/* ------------------------------------------------------------------------- */

/* @{ */
__PUB bo_float32_t        vipm_Quad_(f2d)(width)          __P((vipm_Quad_t(f2d) const *));
__PUB bo_float32_t        vipm_Quad_(f2d)(width_sqr)      __P((vipm_Quad_t(f2d) const *));
__PUB bo_float32_t        vipm_Quad_(f2d)(height)         __P((vipm_Quad_t(f2d) const *));
__PUB bo_float32_t        vipm_Quad_(f2d)(height_sqr)     __P((vipm_Quad_t(f2d) const *));
/* @} */


/* ========================================================================= */

/*
 * Quad{R2D}
 */

	/*
	 * Construct
	 */

__PUB vipm_Quad_t(r2d)   *vipm_Quad(r2d)(4)         __P((vipm_Quad_t(r2d) *, bo_float64_t, bo_float64_t,
                                                             bo_float64_t, bo_float64_t, bo_float64_t, bo_float64_t,
                                                             bo_float64_t, bo_float64_t));
__PUB vipm_Quad_t(r2d)   *vipm_Quad(r2d)(2)         __P((vipm_Quad_t(r2d) *, bo_float64_t, bo_float64_t,
                                                             bo_float64_t, bo_float64_t));

__PUB vipm_Quad_t(r2d)   *vipm_Quad(r2d)(cast,f)    __P((vipm_Quad_t(r2d) *, vipm_Quad_t(f2d) const *));

__PUB vipm_Quad_t(r2d)   *vipm_Quad(r2d)(rcpt,i)    __P((vipm_Quad_t(r2d) *, vipm_Rcpt_t(2d)  const *));
__PUB vipm_Quad_t(r2d)   *vipm_Quad(r2d)(rcpt,f)    __P((vipm_Quad_t(r2d) *, vipm_Rcpt_t(f2d) const *));
__PUB vipm_Quad_t(r2d)   *vipm_Quad(r2d)(rcpt)      __P((vipm_Quad_t(r2d) *, vipm_Rcpt_t(r2d) const *));
__PUB vipm_Quad_t(r2d)   *vipm_Quad(r2d)(rect,i)    __P((vipm_Quad_t(r2d) *, vipm_Rect_t(2d)  const *));
__PUB vipm_Quad_t(r2d)   *vipm_Quad(r2d)(rect,f)    __P((vipm_Quad_t(r2d) *, vipm_Rect_t(f2d) const *));
__PUB vipm_Quad_t(r2d)   *vipm_Quad(r2d)(rect)      __P((vipm_Quad_t(r2d) *, vipm_Rect_t(r2d) const *));
# define vipm_r2d_quad_rcpt_$r              vipm_r2d_quad_rcpt
# define vipm_r2d_quad_rect_$r              vipm_r2d_quad_rect

/* ------------------------------------------------------------------------- */

	/*
	 * Functional
	 */

__PUB double              vipm_Quad_(r2d)(area)           __P((vipm_Quad_t(r2d) const *));
__PUB double              vipm_Quad_(r2d)(rotation)       __P((vipm_Quad_t(r2d) const *));
__PUB int                 vipm_Quad_(r2d)(isclockwise,M)  __P((vipm_Quad_t(r2d) const *));
__PUB int                 vipm_Quad_(r2d)(iscclockwise,M) __P((vipm_Quad_t(r2d) const *));
__PUB int                 vipm_Quad_(r2d)(isclockwise)    __P((vipm_Quad_t(r2d) const *));
__PUB int                 vipm_Quad_(r2d)(iscclockwise)   __P((vipm_Quad_t(r2d) const *));
__PUB int                 vipm_Quad_(r2d)(inside)         __P((vipm_Quad_t(r2d) const *, vipm_Point_t(r2d) const *));
__PUB int                 vipm_Quad_(r2d)(inside,2)       __P((vipm_Quad_t(r2d) const *, bo_float64_t, bo_float64_t));
__PUB int                 vipm_Quad_(r2d)(isconvex)       __P((vipm_Quad_t(r2d) const *));

__PUB double             *vipm_Quad_(r2d)(moment1)        __P((double [/*2*/], vipm_Quad_t(r2d) const *));
__PUB double             *vipm_Quad_(r2d)(moment2)        __P((double [/*3*/], vipm_Quad_t(r2d) const *));
__PUB double             *vipm_Quad_(r2d)(moment2,c)      __P((double [/*3*/], vipm_Quad_t(r2d) const *));
__PUB double             *vipm_Quad_(r2d)(covariance)     __P((double [/*4*/], vipm_Quad_t(r2d) const *));
__PUB vipm_Point_t(r2d)  *vipm_Quad_(r2d)(centroid)       __P((vipm_Point_t(r2d) *, vipm_Quad_t(r2d) const *));
__PUB vipm_Point_t(f2d)  *vipm_Quad_(r2d)(centroid,f)     __P((vipm_Point_t(f2d) *, vipm_Quad_t(r2d) const *));
# define vipm_r2d_quad_centroid_$r          vipm_r2d_quad_centroid

__PUB vipm_Rect_t(r2d)   *vipm_Quad_(r2d)(brect)          __P((vipm_Rect_t(r2d) *, vipm_Quad_t(r2d) const *));
__PUB vipm_Ell_t(r2d)    *vipm_Quad_(r2d)(fitell)         __P((vipm_Ell_t(r2d) *,  vipm_Quad_t(r2d) const *));
__PUB vipm_Ell_t(f2d)    *vipm_Quad_(r2d)(fitell,f)       __P((vipm_Ell_t(f2d) *,  vipm_Quad_t(r2d) const *));
# define vipm_r2d_quad_fitell_$r            vipm_r2d_quad_fitell

/* ------------------------------------------------------------------------- */

/* @{ */
__PUB bo_float64_t        vipm_Quad_(r2d)(width)          __P((vipm_Quad_t(r2d) const *));
__PUB bo_float64_t        vipm_Quad_(r2d)(width_sqr)      __P((vipm_Quad_t(r2d) const *));
__PUB bo_float64_t        vipm_Quad_(r2d)(height)         __P((vipm_Quad_t(r2d) const *));
__PUB bo_float64_t        vipm_Quad_(r2d)(height_sqr)     __P((vipm_Quad_t(r2d) const *));
/* @} */


/* ========================================================================= */

__PROT double             vipm_Quad_(f2d)(__sarea)        __P((vipm_Quad_t(f2d) const *));
__PROT double             vipm_Quad_(r2d)(__sarea)        __P((vipm_Quad_t(r2d) const *));


/* +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ */

/* @{ */

_VIPM_INLINE vipm_Quad_t(f2d) *
vipm_Quad(f2d)(4)(vipm_Quad_t(f2d) *aThis,
		bo_float32_t y0, bo_float32_t x0, bo_float32_t y1, bo_float32_t x1,
		bo_float32_t y2, bo_float32_t x2, bo_float32_t y3, bo_float32_t x3)
{
	bo_float32_t (*q)[2] = vipm_Quad_mp(f2d)(aThis);
	q[0][0] = (y0); q[0][1] = (x0);
	q[1][0] = (y1); q[1][1] = (x1);
	q[2][0] = (y2); q[2][1] = (x2);
	q[3][0] = (y3); q[3][1] = (x3);
	return (aThis);
}


_VIPM_INLINE vipm_Quad_t(f2d) *
vipm_Quad(f2d)(2)(vipm_Quad_t(f2d) *aThis, bo_float32_t y0, bo_float32_t x0, bo_float32_t y1, bo_float32_t x1)
{
	bo_float32_t (*q)[2] = vipm_Quad_mp(f2d)(aThis);
	q[0][0] = (y0); q[0][1] = (x0);
	q[1][0] = (y0); q[1][1] = (x1);
	q[2][0] = (y1); q[2][1] = (x1);
	q[3][0] = (y1); q[3][1] = (x0);
	return (aThis);
}

/* ------------------------------------------------------------------------- */

_VIPM_INLINE double vipm_Quad_(f2d)(__sarea)(vipm_Quad_t(f2d) const *aShape)
{
	return vipm_Poly_(f2d)(__sarea)(aShape->q_points, 4);
}

/* ------------------------------------------------------------------------- */

_VIPM_INLINE int vipm_Quad_(f2d)(isclockwise,M)(vipm_Quad_t(f2d) const *aShape)
{
	return vipm_Poly_(f2d)(isclockwise,M)(aShape->q_points, 4);
}

_VIPM_INLINE int vipm_Quad_(f2d)(iscclockwise,M)(vipm_Quad_t(f2d) const *aShape)
{
	return vipm_Poly_(f2d)(iscclockwise,M)(aShape->q_points, 4);
}


_VIPM_INLINE int vipm_Quad_(f2d)(isclockwise)(vipm_Quad_t(f2d) const *aShape)
{
	return vipm_Poly_(f2d)(isclockwise)(aShape->q_points, 4);
}

_VIPM_INLINE int vipm_Quad_(f2d)(iscclockwise)(vipm_Quad_t(f2d) const *aShape)
{
	return vipm_Poly_(f2d)(iscclockwise)(aShape->q_points, 4);
}

/* ------------------------------------------------------------------------- */

_VIPM_INLINE int vipm_Quad_(f2d)(isconvex)(vipm_Quad_t(f2d) const *aShape)
{
	return vipm_Poly_(f2d)(isconvex)(aShape->q_points, 4);
}

/* ------------------------------------------------------------------------- */

_VIPM_INLINE int
vipm_Quad_(f2d)(inside,2)(vipm_Quad_t(f2d) const *aShape, bo_float32_t Y, bo_float32_t X)
{
	return vipm_Poly_(f2d)(inside2)(aShape->q_points, 4, Y, X);
}

_VIPM_INLINE int
vipm_Quad_(f2d)(inside)(vipm_Quad_t(f2d) const *aShape, vipm_Point_t(f2d) const *aPoint)
{
	return vipm_Quad_(f2d)(inside,2)(aShape, aPoint->pi_y, aPoint->pi_x);
}

/* ------------------------------------------------------------------------- */

_VIPM_INLINE double *
vipm_Quad_(f2d)(moment1)(double aResult[], vipm_Quad_t(f2d) const *aShape)
{
	return vipm_Poly_(f2d)(moment1)(aResult, aShape->q_points, 4);
}

_VIPM_INLINE double *
vipm_Quad_(f2d)(moment2)(double aResult[], vipm_Quad_t(f2d) const *aShape)
{
	return vipm_Poly_(f2d)(moment2)(aResult, aShape->q_points, 4);
}

_VIPM_INLINE double *
vipm_Quad_(f2d)(moment2,c)(double aResult[], vipm_Quad_t(f2d) const *aShape)
{
	return vipm_Poly_(f2d)(moment2,c)(aResult, aShape->q_points, 4);
}

/* ------------------------------------------------------------------------- */

_VIPM_INLINE double *
vipm_Quad_(f2d)(covariance)(double aResult[], vipm_Quad_t(f2d) const *aShape)
{
	return vipm_Poly_(f2d)(covariance)(aResult, aShape->q_points, 4);
}

/* ------------------------------------------------------------------------- */

_VIPM_INLINE vipm_Point_t(f2d) *
vipm_Quad_(f2d)(centroid)(vipm_Point_t(f2d) *aResult, vipm_Quad_t(f2d) const *aShape)
{
	return vipm_Poly_(f2d)(centroid)(aResult, aShape->q_points, 4);
}

_VIPM_INLINE vipm_Point_t(r2d) *
vipm_Quad_(f2d)(centroid,r)(vipm_Point_t(r2d) *aResult, vipm_Quad_t(f2d) const *aShape)
{
	return vipm_Poly_(f2d)(centroid,r)(aResult, aShape->q_points, 4);
}

/* ------------------------------------------------------------------------- */

_VIPM_INLINE vipm_Rect_t(f2d) *
vipm_Quad_(f2d)(brect)(vipm_Rect_t(f2d) *aResult, vipm_Quad_t(f2d) const *aShape)
{
	return vipm_Poly_(f2d)(brect)(aResult, aShape->q_points, 4);
}


_VIPM_INLINE vipm_Ell_t(f2d) *
vipm_Quad_(f2d)(fitell)(vipm_Ell_t(f2d) *aResult, vipm_Quad_t(f2d) const *aShape)
{
	return vipm_Poly_(f2d)(fitell)(aResult, aShape->q_points, 4);
}

_VIPM_INLINE vipm_Ell_t(r2d) *
vipm_Quad_(f2d)(fitell,r)(vipm_Ell_t(r2d) *aResult, vipm_Quad_t(f2d) const *aShape)
{
	return vipm_Poly_(f2d)(fitell,r)(aResult, aShape->q_points, 4);
}

/* @} */


/* ========================================================================= */

/* @{ */

_VIPM_INLINE vipm_Quad_t(r2d) *
vipm_Quad(r2d)(4)(vipm_Quad_t(r2d) *aThis,
		bo_float64_t y0, bo_float64_t x0, bo_float64_t y1, bo_float64_t x1,
		bo_float64_t y2, bo_float64_t x2, bo_float64_t y3, bo_float64_t x3)
{
	bo_float64_t (*q)[2] = vipm_Quad_mp(r2d)(aThis);
	q[0][0] = (y0); q[0][1] = (x0);
	q[1][0] = (y1); q[1][1] = (x1);
	q[2][0] = (y2); q[2][1] = (x2);
	q[3][0] = (y3); q[3][1] = (x3);
	return (aThis);
}

_VIPM_INLINE vipm_Quad_t(r2d) *
vipm_Quad(r2d)(2)(vipm_Quad_t(r2d) *aThis, bo_float64_t y0, bo_float64_t x0, bo_float64_t y1, bo_float64_t x1)
{
	bo_float64_t (*q)[2] = vipm_Quad_mp(r2d)(aThis);
	q[0][0] = (y0); q[0][1] = (x0);
	q[1][0] = (y0); q[1][1] = (x1);
	q[2][0] = (y1); q[2][1] = (x1);
	q[3][0] = (y1); q[3][1] = (x0);
	return (aThis);
}

/* ------------------------------------------------------------------------- */

_VIPM_INLINE double vipm_Quad_(r2d)(__sarea)(vipm_Quad_t(r2d) const *aShape)
{
	return vipm_Poly_(r2d)(__sarea)(aShape->q_points, 4);
}

/* ------------------------------------------------------------------------- */

_VIPM_INLINE int vipm_Quad_(r2d)(isclockwise,M)(vipm_Quad_t(r2d) const *aShape)
{
	return vipm_Poly_(r2d)(isclockwise,M)(aShape->q_points, 4);
}

_VIPM_INLINE int vipm_Quad_(r2d)(iscclockwise,M)(vipm_Quad_t(r2d) const *aShape)
{
	return vipm_Poly_(r2d)(iscclockwise,M)(aShape->q_points, 4);
}


_VIPM_INLINE int vipm_Quad_(r2d)(isclockwise)(vipm_Quad_t(r2d) const *aShape)
{
	return vipm_Poly_(r2d)(isclockwise)(aShape->q_points, 4);
}

_VIPM_INLINE int vipm_Quad_(r2d)(iscclockwise)(vipm_Quad_t(r2d) const *aShape)
{
	return vipm_Poly_(r2d)(iscclockwise)(aShape->q_points, 4);
}

/* ------------------------------------------------------------------------- */

_VIPM_INLINE int vipm_Quad_(r2d)(isconvex)(vipm_Quad_t(r2d) const *aShape)
{
	return vipm_Poly_(r2d)(isconvex)(aShape->q_points, 4);
}

/* ------------------------------------------------------------------------- */

_VIPM_INLINE int
vipm_Quad_(r2d)(inside,2)(vipm_Quad_t(r2d) const *aShape, bo_float64_t Y, bo_float64_t X)
{
	return vipm_Poly_(r2d)(inside2)(aShape->q_points, 4, Y, X);
}

_VIPM_INLINE int
vipm_Quad_(r2d)(inside)(vipm_Quad_t(r2d) const *aShape, vipm_Point_t(r2d) const *aPoint)
{
	return vipm_Quad_(r2d)(inside,2)(aShape, aPoint->pi_y, aPoint->pi_x);
}

/* ------------------------------------------------------------------------- */

_VIPM_INLINE double *
vipm_Quad_(r2d)(moment1)(double aResult[], vipm_Quad_t(r2d) const *aShape)
{
	return vipm_Poly_(r2d)(moment1)(aResult, aShape->q_points, 4);
}

_VIPM_INLINE double *
vipm_Quad_(r2d)(moment2)(double aResult[], vipm_Quad_t(r2d) const *aShape)
{
	return vipm_Poly_(r2d)(moment2)(aResult, aShape->q_points, 4);
}

_VIPM_INLINE double *
vipm_Quad_(r2d)(moment2,c)(double aResult[], vipm_Quad_t(r2d) const *aShape)
{
	return vipm_Poly_(r2d)(moment2,c)(aResult, aShape->q_points, 4);
}

/* ------------------------------------------------------------------------- */

_VIPM_INLINE double *
vipm_Quad_(r2d)(covariance)(double aResult[], vipm_Quad_t(r2d) const *aShape)
{
	return vipm_Poly_(r2d)(covariance)(aResult, aShape->q_points, 4);
}

/* ------------------------------------------------------------------------- */

_VIPM_INLINE vipm_Point_t(r2d) *
vipm_Quad_(r2d)(centroid)(vipm_Point_t(r2d) *aResult, vipm_Quad_t(r2d) const *aShape)
{
	return vipm_Poly_(r2d)(centroid)(aResult, aShape->q_points, 4);
}

_VIPM_INLINE vipm_Point_t(f2d) *
vipm_Quad_(r2d)(centroid,f)(vipm_Point_t(f2d) *aResult, vipm_Quad_t(r2d) const *aShape)
{
	return vipm_Poly_(r2d)(centroid,f)(aResult, aShape->q_points, 4);
}

/* ------------------------------------------------------------------------- */

_VIPM_INLINE vipm_Rect_t(r2d) *
vipm_Quad_(r2d)(brect)(vipm_Rect_t(r2d) *aResult, vipm_Quad_t(r2d) const *aShape)
{
	return vipm_Poly_(r2d)(brect)(aResult, aShape->q_points, 4);
}


_VIPM_INLINE vipm_Ell_t(r2d) *
vipm_Quad_(r2d)(fitell)(vipm_Ell_t(r2d) *aResult, vipm_Quad_t(r2d) const *aShape)
{
	return vipm_Poly_(r2d)(fitell)(aResult, aShape->q_points, 4);
}

_VIPM_INLINE vipm_Ell_t(f2d) *
vipm_Quad_(r2d)(fitell,f)(vipm_Ell_t(f2d) *aResult, vipm_Quad_t(r2d) const *aShape)
{
	return vipm_Poly_(r2d)(fitell,f)(aResult, aShape->q_points, 4);
}

/* @} */


__MYC_END_CDECLS
# undef __PUB
# undef __PROT
# undef __PRIV


#endif /* !defined(__VIPM_MATH_GEOMETRY_2D_QUAD_H__) */


/******************************************************************************
 *
 *
 *
 *****************************************************************************/
