/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright 2016 Seenaptec Ltd. All rights reserved.
 * SEENAPTEC PROPRIETARY/CONFIDENTIAL.
 *
 * $Id$
 */

/*
 * Rect.h	(V.Sokur)
 * Vipm/Math/Geometry/2D/Rect.h
 */

/* ------------------------------------------------------------------------- */

#ifndef __VIPM_MATH_GEOMETRY_2D_RECT_H__
# define __VIPM_MATH_GEOMETRY_2D_RECT_H__

/******************************************************************************
 * %% BeginSection: includes
 */

# ifndef __VIPM_TYPES_H__
#  include <Vipm/Types.h>
# endif

# ifndef __VIPM_MATH_GEOMETRY_2D_POINT_H__
#  include <Vipm/Math/Geometry/2D/Point.h>
# endif


/******************************************************************************
 * %% BeginSection: function prototypes
 */
# pragma mark -
# pragma mark [ function prototypes ]
# pragma mark -

# include <Vipm/Linkage.h>
# define __PUB __myc_flinkage__(public,libVipm)
# define __PRIV __myc_flinkage__(private,libVipm)
__MYC_BEGIN_CDECLS

/*
 * Rcpt{2D}
 */

	/*
	 * Construct
	 */

__PUB vipm_Rcpt_t(2d)    *vipm_Rcpt(2d)(cast,f)         __P((vipm_Rcpt_t(2d) *, vipm_Rcpt_t(f2d) const *));
__PUB vipm_Rcpt_t(2d)    *vipm_Rcpt(2d)(cast,r)         __P((vipm_Rcpt_t(2d) *, vipm_Rcpt_t(r2d) const *));
__PUB vipm_Rcpt_t(2d)    *vipm_Rcpt(2d)(rect)           __P((vipm_Rcpt_t(2d) *, vipm_Rect_t(2d)  const *));

/* ------------------------------------------------------------------------- */

	/*
	 * Functional
	 */

__PUB vipm_Rcpt_t(2d)    *vipm_Rcpt_(2d)(convert)       __P((vipm_Rcpt_t(2d) *, vipm_Rect_t(2d)  const *));
__PUB vipm_Rcpt_t(2d)    *vipm_Rcpt_(2d)(convert,I)     __P((vipm_Rect_t(2d) *));

__PUB vipm_int            vipm_Rcpt_(2d)(height)        __P((vipm_Rcpt_t(2d) const *));
__PUB vipm_int            vipm_Rcpt_(2d)(height,Q)      __P((vipm_Rcpt_t(2d) const *));
__PUB vipm_int            vipm_Rcpt_(2d)(width)         __P((vipm_Rcpt_t(2d) const *));
__PUB vipm_int            vipm_Rcpt_(2d)(width,Q)       __P((vipm_Rcpt_t(2d) const *));
__PUB vipm_int            vipm_Rcpt_(2d)(area)          __P((vipm_Rcpt_t(2d) const *));
__PUB vipm_int            vipm_Rcpt_(2d)(area,Q)        __P((vipm_Rcpt_t(2d) const *));
__PUB int                 vipm_Rcpt_(2d)(empty)         __P((vipm_Rcpt_t(2d) const *));
__PUB int                 vipm_Rcpt_(2d)(inside)        __P((vipm_Rcpt_t(2d) const *, vipm_Point_t(2d) const *));
__PUB int                 vipm_Rcpt_(2d)(inside2)       __P((vipm_Rcpt_t(2d) const *, vipm_int, vipm_int));
__PUB int                 vipm_Rcpt_(2d)(isconvex)      __P((vipm_Rcpt_t(2d) const *));

__PUB vipm_Rcpt_t(2d)    *vipm_Rcpt_(2d)(intersec)      __P((vipm_Rcpt_t(2d) *, vipm_Rcpt_t(2d) const *, vipm_Rcpt_t(2d) const *));
__PUB vipm_Rcpt_t(2d)    *vipm_Rcpt_(2d)(intersec,I)    __P((vipm_Rcpt_t(2d) *, vipm_Rcpt_t(2d) const *));
__PUB vipm_Rcpt_t(2d)    *vipm_Rcpt_(2d)(general)       __P((vipm_Rcpt_t(2d) *, vipm_Rcpt_t(2d) const *, vipm_Rcpt_t(2d) const *)); /* 'union' */
__PUB vipm_Rcpt_t(2d)    *vipm_Rcpt_(2d)(general,I)     __P((vipm_Rcpt_t(2d) *, vipm_Rcpt_t(2d) const *));                         /* 'union' */

__PUB double             *vipm_Rcpt_(2d)(moment1)       __P((double [/*2*/], vipm_Rcpt_t(2d) const *));
__PUB double             *vipm_Rcpt_(2d)(moment2)       __P((double [/*3*/], vipm_Rcpt_t(2d) const *));
__PUB double             *vipm_Rcpt_(2d)(moment2,c)     __P((double [/*3*/], vipm_Rcpt_t(2d) const *));
__PUB vipm_Point_t(2d)   *vipm_Rcpt_(2d)(centroid)      __P((vipm_Point_t(2d)  *, vipm_Rcpt_t(2d) const *));
__PUB vipm_Point_t(f2d)  *vipm_Rcpt_(2d)(centroid,f)    __P((vipm_Point_t(f2d) *, vipm_Rcpt_t(2d) const *));
__PUB vipm_Point_t(r2d)  *vipm_Rcpt_(2d)(centroid,r)    __P((vipm_Point_t(r2d) *, vipm_Rcpt_t(2d) const *));


/* ========================================================================= */

/*
 * Rcpt{F2D}
 */

	/*
	 * Construct
	 */

__PUB vipm_Rcpt_t(f2d)   *vipm_Rcpt(f2d)(cast,i)        __P((vipm_Rcpt_t(f2d) *, vipm_Rcpt_t(2d)  const *));
__PUB vipm_Rcpt_t(f2d)   *vipm_Rcpt(f2d)(cast,r)        __P((vipm_Rcpt_t(f2d) *, vipm_Rcpt_t(r2d) const *));
__PUB vipm_Rcpt_t(f2d)   *vipm_Rcpt(f2d)(rect)          __P((vipm_Rcpt_t(f2d) *, vipm_Rect_t(f2d) const *));

/* ------------------------------------------------------------------------- */

	/*
	 * Functional
	 */

__PUB vipm_Rcpt_t(f2d)   *vipm_Rcpt_(f2d)(convert)      __P((vipm_Rcpt_t(f2d) *, vipm_Rect_t(f2d) const *));
__PUB vipm_Rcpt_t(f2d)   *vipm_Rcpt_(f2d)(convert,I)    __P((vipm_Rect_t(f2d) *));

__PUB bo_float32_t        vipm_Rcpt_(f2d)(height)       __P((vipm_Rcpt_t(f2d) const *));
__PUB bo_float32_t        vipm_Rcpt_(f2d)(height,Q)     __P((vipm_Rcpt_t(f2d) const *));
__PUB bo_float32_t        vipm_Rcpt_(f2d)(width)        __P((vipm_Rcpt_t(f2d) const *));
__PUB bo_float32_t        vipm_Rcpt_(f2d)(width,Q)      __P((vipm_Rcpt_t(f2d) const *));
__PUB bo_float32_t        vipm_Rcpt_(f2d)(area)         __P((vipm_Rcpt_t(f2d) const *));
__PUB bo_float32_t        vipm_Rcpt_(f2d)(area,Q)       __P((vipm_Rcpt_t(f2d) const *));
__PUB int                 vipm_Rcpt_(f2d)(empty)        __P((vipm_Rcpt_t(f2d) const *));
__PUB int                 vipm_Rcpt_(f2d)(inside)       __P((vipm_Rcpt_t(f2d) const *, vipm_Point_t(f2d) const *));
__PUB int                 vipm_Rcpt_(f2d)(inside2)      __P((vipm_Rcpt_t(f2d) const *, bo_float32_t, bo_float32_t));
__PUB int                 vipm_Rcpt_(f2d)(isconvex)     __P((vipm_Rcpt_t(f2d) const *));

__PUB vipm_Rcpt_t(f2d)   *vipm_Rcpt_(f2d)(intersec)     __P((vipm_Rcpt_t(f2d) *, vipm_Rcpt_t(f2d) const *, vipm_Rcpt_t(f2d) const *));
__PUB vipm_Rcpt_t(f2d)   *vipm_Rcpt_(f2d)(intersec,I)   __P((vipm_Rcpt_t(f2d) *, vipm_Rcpt_t(f2d) const *));
__PUB vipm_Rcpt_t(f2d)   *vipm_Rcpt_(f2d)(general)      __P((vipm_Rcpt_t(f2d) *, vipm_Rcpt_t(f2d) const *, vipm_Rcpt_t(f2d) const *)); /* 'union' */
__PUB vipm_Rcpt_t(f2d)   *vipm_Rcpt_(f2d)(general,I)    __P((vipm_Rcpt_t(f2d) *, vipm_Rcpt_t(f2d) const *));                            /* 'union' */

__PUB double             *vipm_Rcpt_(f2d)(moment1)      __P((double [/*2*/], vipm_Rcpt_t(f2d) const *));
__PUB double             *vipm_Rcpt_(f2d)(moment2)      __P((double [/*3*/], vipm_Rcpt_t(f2d) const *));
__PUB double             *vipm_Rcpt_(f2d)(moment2,c)    __P((double [/*3*/], vipm_Rcpt_t(f2d) const *));
__PUB vipm_Point_t(f2d)  *vipm_Rcpt_(f2d)(centroid)     __P((vipm_Point_t(f2d) *, vipm_Rcpt_t(f2d) const *));
__PUB vipm_Point_t(r2d)  *vipm_Rcpt_(f2d)(centroid,r)   __P((vipm_Point_t(r2d) *, vipm_Rcpt_t(f2d) const *));
# define vipm_f2d_rcpt_centroid_$f          vipm_f2d_rcpt_centroid


/* ========================================================================= */

/*
 * Rcpt{R2D}
 */

	/*
	 * Construct
	 */

__PUB vipm_Rcpt_t(r2d)   *vipm_Rcpt(r2d)(cast,i)        __P((vipm_Rcpt_t(r2d) *, vipm_Rcpt_t(2d)  const *));
__PUB vipm_Rcpt_t(r2d)   *vipm_Rcpt(r2d)(cast,f)        __P((vipm_Rcpt_t(r2d) *, vipm_Rcpt_t(f2d) const *));
__PUB vipm_Rcpt_t(r2d)   *vipm_Rcpt(r2d)(rect)          __P((vipm_Rcpt_t(r2d) *, vipm_Rect_t(r2d) const *));

/* ------------------------------------------------------------------------- */

	/*
	 * Functional
	 */

__PUB vipm_Rcpt_t(r2d)   *vipm_Rcpt_(r2d)(convert)      __P((vipm_Rcpt_t(r2d) *, vipm_Rect_t(r2d) const *));
__PUB vipm_Rcpt_t(r2d)   *vipm_Rcpt_(r2d)(convert,I)    __P((vipm_Rect_t(r2d) *));

__PUB bo_float64_t        vipm_Rcpt_(r2d)(height)       __P((vipm_Rcpt_t(r2d) const *));
__PUB bo_float64_t        vipm_Rcpt_(r2d)(height,Q)     __P((vipm_Rcpt_t(r2d) const *));
__PUB bo_float64_t        vipm_Rcpt_(r2d)(width)        __P((vipm_Rcpt_t(r2d) const *));
__PUB bo_float64_t        vipm_Rcpt_(r2d)(width,Q)      __P((vipm_Rcpt_t(r2d) const *));
__PUB bo_float64_t        vipm_Rcpt_(r2d)(area)         __P((vipm_Rcpt_t(r2d) const *));
__PUB bo_float64_t        vipm_Rcpt_(r2d)(area,Q)       __P((vipm_Rcpt_t(r2d) const *));
__PUB int                 vipm_Rcpt_(r2d)(empty)        __P((vipm_Rcpt_t(r2d) const *));
__PUB int                 vipm_Rcpt_(r2d)(inside)       __P((vipm_Rcpt_t(r2d) const *, vipm_Point_t(r2d) const *));
__PUB int                 vipm_Rcpt_(r2d)(inside2)      __P((vipm_Rcpt_t(r2d) const *, bo_float64_t, bo_float64_t));
__PUB int                 vipm_Rcpt_(r2d)(isconvex)     __P((vipm_Rcpt_t(r2d) const *));

__PUB vipm_Rcpt_t(r2d)   *vipm_Rcpt_(r2d)(intersec)     __P((vipm_Rcpt_t(r2d) *, vipm_Rcpt_t(r2d) const *, vipm_Rcpt_t(r2d) const *));
__PUB vipm_Rcpt_t(r2d)   *vipm_Rcpt_(r2d)(intersec,I)   __P((vipm_Rcpt_t(r2d) *, vipm_Rcpt_t(r2d) const *));
__PUB vipm_Rcpt_t(r2d)   *vipm_Rcpt_(r2d)(general)      __P((vipm_Rcpt_t(r2d) *, vipm_Rcpt_t(r2d) const *, vipm_Rcpt_t(r2d) const *)); /* 'union' */
__PUB vipm_Rcpt_t(r2d)   *vipm_Rcpt_(r2d)(general,I)    __P((vipm_Rcpt_t(r2d) *, vipm_Rcpt_t(r2d) const *));                            /* 'union' */

__PUB double             *vipm_Rcpt_(r2d)(moment1)      __P((double [/*2*/], vipm_Rcpt_t(r2d) const *));
__PUB double             *vipm_Rcpt_(r2d)(moment2)      __P((double [/*3*/], vipm_Rcpt_t(r2d) const *));
__PUB double             *vipm_Rcpt_(r2d)(moment2,c)    __P((double [/*3*/], vipm_Rcpt_t(r2d) const *));
__PUB vipm_Point_t(r2d)  *vipm_Rcpt_(r2d)(centroid)     __P((vipm_Point_t(r2d) *, vipm_Rcpt_t(r2d) const *));
__PUB vipm_Point_t(f2d)  *vipm_Rcpt_(r2d)(centroid,f)   __P((vipm_Point_t(f2d) *, vipm_Rcpt_t(r2d) const *));
# define vipm_r2d_rcpt_centroid_$r          vipm_r2d_rcpt_centroid


/* ========================================================================= */

/*
 * Rect{2D}
 */

	/*
	 * Construct
	 */

__PUB vipm_Rect_t(2d)    *vipm_Rect(2d)(cast,f)         __P((vipm_Rect_t(2d) *, vipm_Rect_t(f2d) const *));
__PUB vipm_Rect_t(2d)    *vipm_Rect(2d)(cast,r)         __P((vipm_Rect_t(2d) *, vipm_Rect_t(r2d) const *));
__PUB vipm_Rect_t(2d)    *vipm_Rect(2d)(rcpt)           __P((vipm_Rect_t(2d) *, vipm_Rcpt_t(2d)  const *));

/* ------------------------------------------------------------------------- */

	/*
	 * Functional
	 */

__PUB vipm_Rect_t(2d)    *vipm_Rect_(2d)(convert)       __P((vipm_Rect_t(2d) *, vipm_Rcpt_t(2d) const *));
__PUB vipm_Rect_t(2d)    *vipm_Rect_(2d)(convert,I)     __P((vipm_Rcpt_t(2d) *));

__PUB vipm_int            vipm_Rect_(2d)(height)        __P((vipm_Rect_t(2d) const *));
__PUB vipm_int            vipm_Rect_(2d)(height,Q)      __P((vipm_Rect_t(2d) const *));
__PUB vipm_int            vipm_Rect_(2d)(width)         __P((vipm_Rect_t(2d) const *));
__PUB vipm_int            vipm_Rect_(2d)(width,Q)       __P((vipm_Rect_t(2d) const *));
__PUB vipm_int            vipm_Rect_(2d)(area)          __P((vipm_Rect_t(2d) const *));
__PUB vipm_int            vipm_Rect_(2d)(area,Q)        __P((vipm_Rect_t(2d) const *));
__PUB int                 vipm_Rect_(2d)(empty)         __P((vipm_Rect_t(2d) const *));
__PUB int                 vipm_Rect_(2d)(inside)        __P((vipm_Rect_t(2d) const *, vipm_Point_t(2d) const *));
__PUB int                 vipm_Rect_(2d)(inside2)       __P((vipm_Rect_t(2d) const *, vipm_int, vipm_int));
__PUB int                 vipm_Rect_(2d)(isconvex)      __P((vipm_Rect_t(2d) const *));

__PUB vipm_Rect_t(2d)    *vipm_Rect_(2d)(intersec)      __P((vipm_Rect_t(2d) *, vipm_Rect_t(2d) const *, vipm_Rect_t(2d) const *));
__PUB vipm_Rect_t(2d)    *vipm_Rect_(2d)(intersec,I)    __P((vipm_Rect_t(2d) *, vipm_Rect_t(2d) const *));
__PUB vipm_Rect_t(2d)    *vipm_Rect_(2d)(general)       __P((vipm_Rect_t(2d) *, vipm_Rect_t(2d) const *, vipm_Rect_t(2d) const *));
__PUB vipm_Rect_t(2d)    *vipm_Rect_(2d)(general,I)     __P((vipm_Rect_t(2d) *, vipm_Rect_t(2d) const *));

__PUB double             *vipm_Rect_(2d)(moment1)       __P((double [/*2*/], vipm_Rect_t(2d) const *));
__PUB double             *vipm_Rect_(2d)(moment2)       __P((double [/*3*/], vipm_Rect_t(2d) const *));
__PUB double             *vipm_Rect_(2d)(moment2,c)     __P((double [/*3*/], vipm_Rect_t(2d) const *));
__PUB vipm_Point_t(2d)   *vipm_Rect_(2d)(centroid)      __P((vipm_Point_t(2d)  *, vipm_Rect_t(2d) const *));
__PUB vipm_Point_t(f2d)  *vipm_Rect_(2d)(centroid,f)    __P((vipm_Point_t(f2d) *, vipm_Rect_t(2d) const *));
__PUB vipm_Point_t(r2d)  *vipm_Rect_(2d)(centroid,r)    __P((vipm_Point_t(r2d) *, vipm_Rect_t(2d) const *));


/*
 * Rect *extend(aRoiDst, aRoiSrc, aDeltav[4]);
 * Rect *extend(aRoiDstSrc, aDeltav[4]);
 *
 * symmetric restricted extend:
 * Rect *srextend(aRoiDst, aRoiSrc, dY, dX, aHeightMax, aWidthMax);
 * Rect *srextend(aRoiDstSrc, dY, dX, aHeightMax, aWidthMax);
 *
 * restricted extend
 * retval: bool = equal-size(required-roi, avail-roi)
 *
 * int rextend(aRoiAvail, aRoiReq, aRoiInput, aDeltav[4], aRoiParent);
 */
__PUB vipm_Rect_t(2d)    *vipm_Rect_(2d)(extend)        __P((vipm_Rect_t(2d) *, vipm_Rect_t(2d) const *, vipm_int const [/*4*/]));
__PUB vipm_Rect_t(2d)    *vipm_Rect_(2d)(extend,I)      __P((vipm_Rect_t(2d) *, vipm_int const [/*4*/]));
__PUB vipm_Rect_t(2d)    *vipm_Rect_(2d)(srextend)      __P((vipm_Rect_t(2d) *, vipm_Rect_t(2d) const *,
                                                                 vipm_int, vipm_int, vipm_int, vipm_int));
__PUB vipm_Rect_t(2d)    *vipm_Rect_(2d)(srextend,I)    __P((vipm_Rect_t(2d) *, vipm_int, vipm_int, vipm_int, vipm_int));
__PUB int                 vipm_Rect_(2d)(rextend)       __P((vipm_Rect_t(2d) *, vipm_Rect_t(2d) *,
                                                                 vipm_Rect_t(2d) const *, vipm_int const [/*4*/],
                                                                 vipm_Rect_t(2d) const *));


/* ========================================================================= */

/*
 * Rect{F2D}
 */

	/*
	 * Construct
	 */

__PUB vipm_Rect_t(f2d)   *vipm_Rect(f2d)(cast,i)        __P((vipm_Rect_t(f2d) *, vipm_Rect_t(2d)  const *));
__PUB vipm_Rect_t(f2d)   *vipm_Rect(f2d)(cast,r)        __P((vipm_Rect_t(f2d) *, vipm_Rect_t(r2d) const *));
__PUB vipm_Rect_t(f2d)   *vipm_Rect(f2d)(rcpt)          __P((vipm_Rect_t(f2d) *, vipm_Rcpt_t(f2d) const *));

/* ------------------------------------------------------------------------- */

	/*
	 * Functional
	 */

__PUB vipm_Rect_t(f2d)   *vipm_Rect_(f2d)(convert)      __P((vipm_Rect_t(f2d) *, vipm_Rcpt_t(f2d) const *));
__PUB vipm_Rect_t(f2d)   *vipm_Rect_(f2d)(convert,I)    __P((vipm_Rcpt_t(f2d) *));

__PUB bo_float32_t        vipm_Rect_(f2d)(height)       __P((vipm_Rect_t(f2d) const *));
__PUB bo_float32_t        vipm_Rect_(f2d)(height,Q)     __P((vipm_Rect_t(f2d) const *));
__PUB bo_float32_t        vipm_Rect_(f2d)(width)        __P((vipm_Rect_t(f2d) const *));
__PUB bo_float32_t        vipm_Rect_(f2d)(width,Q)      __P((vipm_Rect_t(f2d) const *));
__PUB bo_float32_t        vipm_Rect_(f2d)(area)         __P((vipm_Rect_t(f2d) const *));
__PUB bo_float32_t        vipm_Rect_(f2d)(area,Q)       __P((vipm_Rect_t(f2d) const *));
__PUB int                 vipm_Rect_(f2d)(empty)        __P((vipm_Rect_t(f2d) const *));
__PUB int                 vipm_Rect_(f2d)(inside)       __P((vipm_Rect_t(f2d) const *, vipm_Point_t(f2d) const *));
__PUB int                 vipm_Rect_(f2d)(inside2)      __P((vipm_Rect_t(f2d) const *, bo_float32_t, bo_float32_t));
__PUB int                 vipm_Rect_(f2d)(isconvex)     __P((vipm_Rect_t(f2d) const *));

__PUB vipm_Rect_t(f2d)   *vipm_Rect_(f2d)(intersec)     __P((vipm_Rect_t(f2d) *, vipm_Rect_t(f2d) const *, vipm_Rect_t(f2d) const *));
__PUB vipm_Rect_t(f2d)   *vipm_Rect_(f2d)(intersec,I)   __P((vipm_Rect_t(f2d) *, vipm_Rect_t(f2d) const *));
__PUB vipm_Rect_t(f2d)   *vipm_Rect_(f2d)(general)      __P((vipm_Rect_t(f2d) *, vipm_Rect_t(f2d) const *, vipm_Rect_t(f2d) const *));
__PUB vipm_Rect_t(f2d)   *vipm_Rect_(f2d)(general,I)    __P((vipm_Rect_t(f2d) *, vipm_Rect_t(f2d) const *));

__PUB double             *vipm_Rect_(f2d)(moment1)     __P((double [/*2*/], vipm_Rect_t(f2d) const *));
__PUB double             *vipm_Rect_(f2d)(moment2)     __P((double [/*3*/], vipm_Rect_t(f2d) const *));
__PUB double             *vipm_Rect_(f2d)(moment2,c)   __P((double [/*3*/], vipm_Rect_t(f2d) const *));
__PUB vipm_Point_t(f2d)  *vipm_Rect_(f2d)(centroid)    __P((vipm_Point_t(f2d) *, vipm_Rect_t(f2d) const *));
__PUB vipm_Point_t(r2d)  *vipm_Rect_(f2d)(centroid,r)  __P((vipm_Point_t(r2d) *, vipm_Rect_t(f2d) const *));
# define vipm_f2d_rect_centroid_$f          vipm_f2d_rect_centroid


/* ========================================================================= */

/*
 * Rect{R2D}
 */

	/*
	 * Construct
	 */

__PUB vipm_Rect_t(r2d)   *vipm_Rect(r2d)(cast,i)        __P((vipm_Rect_t(r2d) *, vipm_Rect_t(2d)  const *));
__PUB vipm_Rect_t(r2d)   *vipm_Rect(r2d)(cast,f)        __P((vipm_Rect_t(r2d) *, vipm_Rect_t(f2d) const *));
__PUB vipm_Rect_t(r2d)   *vipm_Rect(r2d)(rcpt)          __P((vipm_Rect_t(r2d) *, vipm_Rcpt_t(r2d) const *));

/* ------------------------------------------------------------------------- */

	/*
	 * Functional
	 */

__PUB vipm_Rect_t(r2d)   *vipm_Rect_(r2d)(convert)      __P((vipm_Rect_t(r2d) *, vipm_Rcpt_t(r2d) const *));
__PUB vipm_Rect_t(r2d)   *vipm_Rect_(r2d)(convert,I)    __P((vipm_Rcpt_t(r2d) *));

__PUB bo_float64_t        vipm_Rect_(r2d)(height)       __P((vipm_Rect_t(r2d) const *));
__PUB bo_float64_t        vipm_Rect_(r2d)(height,Q)     __P((vipm_Rect_t(r2d) const *));
__PUB bo_float64_t        vipm_Rect_(r2d)(width)        __P((vipm_Rect_t(r2d) const *));
__PUB bo_float64_t        vipm_Rect_(r2d)(width,Q)      __P((vipm_Rect_t(r2d) const *));
__PUB bo_float64_t        vipm_Rect_(r2d)(area)         __P((vipm_Rect_t(r2d) const *));
__PUB bo_float64_t        vipm_Rect_(r2d)(area,Q)       __P((vipm_Rect_t(r2d) const *));
__PUB int                 vipm_Rect_(r2d)(empty)        __P((vipm_Rect_t(r2d) const *));
__PUB int                 vipm_Rect_(r2d)(inside)       __P((vipm_Rect_t(r2d) const *, vipm_Point_t(r2d) const *));
__PUB int                 vipm_Rect_(r2d)(inside2)      __P((vipm_Rect_t(r2d) const *, bo_float64_t, bo_float64_t));
__PUB int                 vipm_Rect_(r2d)(isconvex)     __P((vipm_Rect_t(r2d) const *));

__PUB vipm_Rect_t(r2d)   *vipm_Rect_(r2d)(intersec)     __P((vipm_Rect_t(r2d) *, vipm_Rect_t(r2d) const *, vipm_Rect_t(r2d) const *));
__PUB vipm_Rect_t(r2d)   *vipm_Rect_(r2d)(intersec,I)   __P((vipm_Rect_t(r2d) *, vipm_Rect_t(r2d) const *));
__PUB vipm_Rect_t(r2d)   *vipm_Rect_(r2d)(general)      __P((vipm_Rect_t(r2d) *, vipm_Rect_t(r2d) const *, vipm_Rect_t(r2d) const *));
__PUB vipm_Rect_t(r2d)   *vipm_Rect_(r2d)(general,I)    __P((vipm_Rect_t(r2d) *, vipm_Rect_t(r2d) const *));

__PUB double             *vipm_Rect_(r2d)(moment1)      __P((double [/*2*/], vipm_Rect_t(r2d) const *));
__PUB double             *vipm_Rect_(r2d)(moment2)      __P((double [/*3*/], vipm_Rect_t(r2d) const *));
__PUB double             *vipm_Rect_(r2d)(moment2,c)    __P((double [/*3*/], vipm_Rect_t(r2d) const *));
__PUB vipm_Point_t(r2d)  *vipm_Rect_(r2d)(centroid)     __P((vipm_Point_t(r2d) *, vipm_Rect_t(r2d) const *));
__PUB vipm_Point_t(f2d)  *vipm_Rect_(r2d)(centroid,f)   __P((vipm_Point_t(f2d) *, vipm_Rect_t(r2d) const *));
# define vipm_r2d_rect_centroid_$r          vipm_r2d_rect_centroid


/* +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ */

/* @{ */

# define vipm_2d_rcpt_isconvex(x)               (1)

/* ------------------------------------------------------------------------- */

_VIPM_INLINE vipm_Rcpt_t(2d) *
vipm_Rcpt(2d)(cast,f)(vipm_Rcpt_t(2d) *aThis, vipm_Rcpt_t(f2d) const *aSrc)
{
	aThis->__v[0] = vipmi_rfloorf(aSrc->__v[0]);
	aThis->__v[1] = vipmi_rfloorf(aSrc->__v[1]);
	aThis->__v[2] = vipmi_rceilf(aSrc->__v[2]);
	aThis->__v[3] = vipmi_rceilf(aSrc->__v[3]);
	return (aThis);
}

_VIPM_INLINE vipm_Rcpt_t(2d) *
vipm_Rcpt(2d)(cast,r)(vipm_Rcpt_t(2d) *aThis, vipm_Rcpt_t(r2d) const *aSrc)
{
	aThis->__v[0] = vipmi_rfloord(aSrc->__v[0]);
	aThis->__v[1] = vipmi_rfloord(aSrc->__v[1]);
	aThis->__v[2] = vipmi_rceild(aSrc->__v[2]);
	aThis->__v[3] = vipmi_rceild(aSrc->__v[3]);
	return (aThis);
}

_VIPM_INLINE vipm_Rcpt_t(2d) *
vipm_Rcpt(2d)(rect)(vipm_Rcpt_t(2d) *aThis, vipm_Rect_t(2d) const *aSrc)
{
	return vipm_Rcpt_(2d)(convert)(aThis, aSrc);
}


_VIPM_INLINE vipm_Rcpt_t(2d) *vipm_Rcpt_(2d)(convert,I)(vipm_Rect_t(2d) *aThis)
{
	aThis->rc_bottom += aThis->rc_y;
	aThis->rc_right  += aThis->rc_x;
	return (aThis);
}

/* ------------------------------------------------------------------------- */

_VIPM_INLINE vipm_int vipm_Rcpt_(2d)(height)(vipm_Rcpt_t(2d) const *aShape)
{
	return (aShape->rc_bottom - aShape->rc_top);
}

_VIPM_INLINE vipm_int vipm_Rcpt_(2d)(height,Q)(vipm_Rcpt_t(2d) const *aShape)
{
	vipm_int rv = vipm_Rcpt_(2d)(height)(aShape);
	return (0 <= rv ? rv : 0);
}


_VIPM_INLINE vipm_int vipm_Rcpt_(2d)(width)(vipm_Rcpt_t(2d) const *aShape)
{
	return (aShape->rc_right - aShape->rc_left);
}

_VIPM_INLINE vipm_int vipm_Rcpt_(2d)(width,Q)(vipm_Rcpt_t(2d) const *aShape)
{
	vipm_int rv = vipm_Rcpt_(2d)(width)(aShape);
	return (0 <= rv ? rv : 0);
}


_VIPM_INLINE vipm_int vipm_Rcpt_(2d)(area)(vipm_Rcpt_t(2d) const *aShape)
{
	return (vipm_Rcpt_(2d)(height)(aShape) * vipm_Rcpt_(2d)(width)(aShape));
}

_VIPM_INLINE vipm_int vipm_Rcpt_(2d)(area,Q)(vipm_Rcpt_t(2d) const *aShape)
{
	vipm_int rv, h = vipm_Rcpt_(2d)(height)(aShape);
	rv = vipm_Rcpt_(2d)(width)(aShape) * h;
	return (0 <= (rv | h) ? rv : 0);
}


_VIPM_INLINE int vipm_Rcpt_(2d)(empty)(vipm_Rcpt_t(2d) const *aShape)
{
	return (vipm_Rcpt_(2d)(height)(aShape) <= 0 || vipm_Rcpt_(2d)(width)(aShape) <= 0);
}

/* ------------------------------------------------------------------------- */

_VIPM_INLINE int
vipm_Rcpt_(2d)(inside2)(vipm_Rcpt_t(2d) const *aShape, vipm_int Y, vipm_int X)
{
// v.1
//	return (aShape->rc_top <= Y && Y <= aShape->rc_bottom && aShape->rc_left <= X && X <= aShape->rc_right);

// v.2
//	return (
//		(vipm_uint)(Y - aShape->rc_top) <= (vipm_uint)(aShape->rc_bottom - aShape->rc_top) &&
//		(vipm_uint)(X - aShape->rc_left) <= (vipm_uint)(aShape->rc_right - aShape->rc_left)
//	);

	return (
		(vipm_uint)(Y - aShape->rc_top) <= (vipm_uint)vipm_Rcpt_(2d)(height)(aShape) &&
		(vipm_uint)(X - aShape->rc_left) <= (vipm_uint)vipm_Rcpt_(2d)(width)(aShape)
	);
}

_VIPM_INLINE int
vipm_Rcpt_(2d)(inside)(vipm_Rcpt_t(2d) const *aShape, vipm_Point_t(2d) const *aPoint)
{
	return vipm_Rcpt_(2d)(inside2)(aShape, aPoint->pi_y, aPoint->pi_x);
}

/* ------------------------------------------------------------------------- */

_VIPM_INLINE vipm_Rcpt_t(2d) *
vipm_Rcpt_(2d)(intersec,I)(vipm_Rcpt_t(2d) *aLhsDst, vipm_Rcpt_t(2d) const *aRhs)
{
	return vipm_Rcpt_(2d)(intersec)(aLhsDst, NULL, aRhs);
}

_VIPM_INLINE vipm_Rcpt_t(2d) *
vipm_Rcpt_(2d)(general,I)(vipm_Rcpt_t(2d) *aLhsDst, vipm_Rcpt_t(2d) const *aRhs)
{
	return vipm_Rcpt_(2d)(general)(aLhsDst, NULL, aRhs);
}

/* ------------------------------------------------------------------------- */

_VIPM_INLINE vipm_Point_t(r2d) *
vipm_Rcpt_(2d)(centroid,r)(vipm_Point_t(r2d) *aResult, vipm_Rcpt_t(2d) const *aShape)
{
	return vipm_r2d_point_mp(vipm_Rcpt_(2d)(moment1)(aResult->__v, aShape));
}

#if 0
_VIPM_INLINE vipm_Point_t(f2d) *
vipm_Rcpt_(2d)(centroid,f)(vipm_Point_t(f2d) *aResult, vipm_Rcpt_t(2d) const *aShape)
{
	vipm_Point_t(r2d) mm1;
	return vipm_Point(f2d)(cast,r)(aResult, vipm_Rcpt_(2d)(centroid,r)(moment1)(mm1.__v, aShape));
}
#endif

_VIPM_INLINE vipm_Point_t(2d) *
vipm_Rcpt_(2d)(centroid)(vipm_Point_t(2d) *aResult, vipm_Rcpt_t(2d) const *aShape)
{
	vipm_Point_t(r2d) rv;
	return vipm_Point(2d)(cast,r)(aResult, vipm_Rcpt_(2d)(centroid,r)(&rv, aShape));
}

/* @} */

/* ========================================================================= */

/* @{ */

# define vipm_f2d_rcpt_isconvex(x)              (1)

/* ------------------------------------------------------------------------- */

_VIPM_INLINE vipm_Rcpt_t(f2d) *
vipm_Rcpt(f2d)(cast,i)(vipm_Rcpt_t(f2d) *aThis, vipm_Rcpt_t(2d) const *aSrc)
{
	aThis->__v[0] = (float)aSrc->__v[0];
	aThis->__v[1] = (float)aSrc->__v[1];
	aThis->__v[2] = (float)aSrc->__v[2];
	aThis->__v[3] = (float)aSrc->__v[3];
	return (aThis);
}

_VIPM_INLINE vipm_Rcpt_t(f2d) *
vipm_Rcpt(f2d)(cast,r)(vipm_Rcpt_t(f2d) *aThis, vipm_Rcpt_t(r2d) const *aSrc)
{
	aThis->__v[0] = vipm_satcast_f32d(aSrc->__v[0]);
	aThis->__v[1] = vipm_satcast_f32d(aSrc->__v[1]);
	aThis->__v[2] = vipm_satcast_f32d(aSrc->__v[2]);
	aThis->__v[3] = vipm_satcast_f32d(aSrc->__v[3]);
	return (aThis);
}

_VIPM_INLINE vipm_Rcpt_t(f2d) *
vipm_Rcpt(f2d)(rect)(vipm_Rcpt_t(f2d) *aThis, vipm_Rect_t(f2d) const *aSrc)
{
	return vipm_Rcpt_(f2d)(convert)(aThis, aSrc);
}


_VIPM_INLINE vipm_Rcpt_t(f2d) *vipm_Rcpt_(f2d)(convert,I)(vipm_Rect_t(f2d) *aThis)
{
	aThis->rc_bottom += aThis->rc_y;
	aThis->rc_right  += aThis->rc_x;
	return (aThis);
}

/* ------------------------------------------------------------------------- */

_VIPM_INLINE bo_float32_t vipm_Rcpt_(f2d)(height)(vipm_Rcpt_t(f2d) const *aShape)
{
	return (aShape->rc_bottom - aShape->rc_top);
}

_VIPM_INLINE bo_float32_t vipm_Rcpt_(f2d)(height,Q)(vipm_Rcpt_t(f2d) const *aShape)
{
	bo_float32_t rv = vipm_Rcpt_(f2d)(height)(aShape);
	return (FLT_EPSILON < rv ? rv : 0);
}

_VIPM_INLINE bo_float32_t vipm_Rcpt_(f2d)(width)(vipm_Rcpt_t(f2d) const *aShape)
{
	return (aShape->rc_right - aShape->rc_left);
}

_VIPM_INLINE bo_float32_t vipm_Rcpt_(f2d)(width,Q)(vipm_Rcpt_t(f2d) const *aShape)
{
	bo_float32_t rv = vipm_Rcpt_(f2d)(width)(aShape);
	return (FLT_EPSILON < rv ? rv : 0);
}


_VIPM_INLINE bo_float32_t vipm_Rcpt_(f2d)(area)(vipm_Rcpt_t(f2d) const *aShape)
{
	return (vipm_Rcpt_(f2d)(width)(aShape) * vipm_Rcpt_(f2d)(height)(aShape));
}

_VIPM_INLINE bo_float32_t vipm_Rcpt_(f2d)(area,Q)(vipm_Rcpt_t(f2d) const *aShape)
{
	bo_float32_t rv, h = vipm_Rcpt_(f2d)(height)(aShape);
	rv = vipm_Rcpt_(f2d)(width)(aShape) * h;
	return ((FLT_EPSILON < h && FLT_EPSILON < rv) ? rv : 0);
}


_VIPM_INLINE int vipm_Rcpt_(f2d)(empty)(vipm_Rcpt_t(f2d) const *aShape)
{
	return (vipm_Rcpt_(f2d)(height)(aShape) <= FLT_EPSILON || vipm_Rcpt_(f2d)(width)(aShape) <= FLT_EPSILON);
}

/* ------------------------------------------------------------------------- */

_VIPM_INLINE int
vipm_Rcpt_(f2d)(inside2)(vipm_Rcpt_t(f2d) const *aShape, bo_float32_t Y, bo_float32_t X)
{
	return (aShape->rc_top <= Y && Y <= aShape->rc_bottom && aShape->rc_left <= X && X <= aShape->rc_right);
}

_VIPM_INLINE int
vipm_Rcpt_(f2d)(inside)(vipm_Rcpt_t(f2d) const *aShape, vipm_Point_t(f2d) const *aPoint)
{
	return vipm_Rcpt_(f2d)(inside2)(aShape, aPoint->pi_y, aPoint->pi_x);
}

/* ------------------------------------------------------------------------- */

_VIPM_INLINE vipm_Rcpt_t(f2d) *
vipm_Rcpt_(f2d)(intersec,I)(vipm_Rcpt_t(f2d) *aLhsDst, vipm_Rcpt_t(f2d) const *aRhs)
{
	return vipm_Rcpt_(f2d)(intersec)(aLhsDst, NULL, aRhs);
}

_VIPM_INLINE vipm_Rcpt_t(f2d) *
vipm_Rcpt_(f2d)(general,I)(vipm_Rcpt_t(f2d) *aLhsDst, vipm_Rcpt_t(f2d) const *aRhs)
{
	return vipm_Rcpt_(f2d)(general)(aLhsDst, NULL, aRhs);
}

/* ------------------------------------------------------------------------- */

_VIPM_INLINE vipm_Point_t(r2d) *
vipm_Rcpt_(f2d)(centroid,r)(vipm_Point_t(r2d) *aResult, vipm_Rcpt_t(f2d) const *aShape)
{
	return vipm_r2d_point_mp(vipm_Rcpt_(f2d)(moment1)(aResult->__v, aShape));
}

/* @} */

/* ========================================================================= */

/* @{ */

# define vipm_r2d_rcpt_isconvex(x)              (1)

/* ------------------------------------------------------------------------- */

_VIPM_INLINE vipm_Rcpt_t(r2d) *
vipm_Rcpt(r2d)(cast,i)(vipm_Rcpt_t(r2d) *aThis, vipm_Rcpt_t(2d) const *aSrc)
{
	aThis->__v[0] = aSrc->__v[0];
	aThis->__v[1] = aSrc->__v[1];
	aThis->__v[2] = aSrc->__v[2];
	aThis->__v[3] = aSrc->__v[3];
	return (aThis);
}

_VIPM_INLINE vipm_Rcpt_t(r2d) *
vipm_Rcpt(r2d)(cast,f)(vipm_Rcpt_t(r2d) *aThis, vipm_Rcpt_t(f2d) const *aSrc)
{
	aThis->__v[0] = aSrc->__v[0];
	aThis->__v[1] = aSrc->__v[1];
	aThis->__v[2] = aSrc->__v[2];
	aThis->__v[3] = aSrc->__v[3];
	return (aThis);
}

_VIPM_INLINE vipm_Rcpt_t(r2d) *
vipm_Rcpt(r2d)(rect)(vipm_Rcpt_t(r2d) *aThis, vipm_Rect_t(r2d) const *aSrc)
{
	return vipm_Rcpt_(r2d)(convert)(aThis, aSrc);
}


_VIPM_INLINE vipm_Rcpt_t(r2d) *vipm_Rcpt_(r2d)(convert,I)(vipm_Rect_t(r2d) *aThis)
{
	aThis->rc_bottom += aThis->rc_y;
	aThis->rc_right  += aThis->rc_x;
	return (aThis);
}

/* ------------------------------------------------------------------------- */

_VIPM_INLINE bo_float64_t vipm_Rcpt_(r2d)(height)(vipm_Rcpt_t(r2d) const *aShape)
{
	return (aShape->rc_bottom - aShape->rc_top);
}

_VIPM_INLINE bo_float64_t vipm_Rcpt_(r2d)(height,Q)(vipm_Rcpt_t(r2d) const *aShape)
{
	bo_float64_t rv = vipm_Rcpt_(r2d)(height)(aShape);
	return (DBL_EPSILON < rv ? rv : 0);
}

_VIPM_INLINE bo_float64_t vipm_Rcpt_(r2d)(width)(vipm_Rcpt_t(r2d) const *aShape)
{
	return (aShape->rc_right - aShape->rc_left);
}

_VIPM_INLINE bo_float64_t vipm_Rcpt_(r2d)(width,Q)(vipm_Rcpt_t(r2d) const *aShape)
{
	bo_float64_t rv = vipm_Rcpt_(r2d)(width)(aShape);
	return (DBL_EPSILON < rv ? rv : 0);
}


_VIPM_INLINE bo_float64_t vipm_Rcpt_(r2d)(area)(vipm_Rcpt_t(r2d) const *aShape)
{
	return (vipm_Rcpt_(r2d)(width)(aShape) * vipm_Rcpt_(r2d)(height)(aShape));
}

_VIPM_INLINE bo_float64_t vipm_Rcpt_(r2d)(area,Q)(vipm_Rcpt_t(r2d) const *aShape)
{
	bo_float64_t rv, h = vipm_Rcpt_(r2d)(height)(aShape);
	rv = vipm_Rcpt_(r2d)(width)(aShape) * h;
	return ((DBL_EPSILON < h && DBL_EPSILON < rv) ? rv : 0);
}


_VIPM_INLINE int vipm_Rcpt_(r2d)(empty)(vipm_Rcpt_t(r2d) const *aShape)
{
	return (vipm_Rcpt_(r2d)(height)(aShape) <= DBL_EPSILON || vipm_Rcpt_(r2d)(width)(aShape) <= DBL_EPSILON);
}

/* ------------------------------------------------------------------------- */

_VIPM_INLINE int
vipm_Rcpt_(r2d)(inside2)(vipm_Rcpt_t(r2d) const *aShape, bo_float64_t Y, bo_float64_t X)
{
	return (aShape->rc_top <= Y && Y <= aShape->rc_bottom && aShape->rc_left <= X && X <= aShape->rc_right);
}

_VIPM_INLINE int
vipm_Rcpt_(r2d)(inside)(vipm_Rcpt_t(r2d) const *aShape, vipm_Point_t(r2d) const *aPoint)
{
	return vipm_Rcpt_(r2d)(inside2)(aShape, aPoint->pi_y, aPoint->pi_x);
}

/* ------------------------------------------------------------------------- */

_VIPM_INLINE vipm_Rcpt_t(r2d) *
vipm_Rcpt_(r2d)(intersec,I)(vipm_Rcpt_t(r2d) *aLhsDst, vipm_Rcpt_t(r2d) const *aRhs)
{
	return vipm_Rcpt_(r2d)(intersec)(aLhsDst, NULL, aRhs);
}

_VIPM_INLINE vipm_Rcpt_t(r2d) *
vipm_Rcpt_(r2d)(general,I)(vipm_Rcpt_t(r2d) *aLhsDst, vipm_Rcpt_t(r2d) const *aRhs)
{
	return vipm_Rcpt_(r2d)(general)(aLhsDst, NULL, aRhs);
}

/* ------------------------------------------------------------------------- */

_VIPM_INLINE vipm_Point_t(r2d) *
vipm_Rcpt_(r2d)(centroid)(vipm_Point_t(r2d) *aResult, vipm_Rcpt_t(r2d) const *aShape)
{
	return vipm_r2d_point_mp(vipm_Rcpt_(r2d)(moment1)(aResult->__v, aShape));
}

_VIPM_INLINE vipm_Point_t(f2d) *
vipm_Rcpt_(r2d)(centroid,f)(vipm_Point_t(f2d) *aResult, vipm_Rcpt_t(r2d) const *aShape)
{
	vipm_Point_t(r2d) rv;
	return vipm_Point(f2d)(cast,r)(aResult, vipm_Rcpt_(r2d)(centroid)(&rv, aShape));
}

/* @} */


/* ========================================================================= */

/* @{ */

# define vipm_2d_rect_cast_$f                   vipm_2d_rcpt_cast_$f
# define vipm_2d_rect_cast_$r                   vipm_2d_rcpt_cast_$r

# define vipm_2d_rect_height(rc)               ((rc)->rc_h)
# define vipm_2d_rect_width(rc)                ((rc)->rc_w)
# define vipm_2d_rect_isconvex(x)              (1)

/* ------------------------------------------------------------------------- */

_VIPM_INLINE vipm_Rect_t(2d) *
vipm_Rect(2d)(rcpt)(vipm_Rect_t(2d) *aThis, vipm_Rcpt_t(2d) const *aSrc)
{
	return vipm_Rect_(2d)(convert)(aThis, aSrc);
}


_VIPM_INLINE vipm_Rect_t(2d) *vipm_Rect_(2d)(convert,I)(vipm_Rcpt_t(2d) *aThis)
{
	aThis->rc_h -= aThis->rc_top;
	aThis->rc_w -= aThis->rc_left;
	return (aThis);
}

/* ------------------------------------------------------------------------- */

_VIPM_INLINE vipm_int vipm_Rect_(2d)(height,Q)(vipm_Rect_t(2d) const *aShape)
{
	vipm_int rv = vipm_Rect_(2d)(height)(aShape);
	return (0 <= rv ? rv : 0);
}

_VIPM_INLINE vipm_int vipm_Rect_(2d)(width,Q)(vipm_Rect_t(2d) const *aShape)
{
	vipm_int rv = vipm_Rect_(2d)(width)(aShape);
	return (0 <= rv ? rv : 0);
}


_VIPM_INLINE vipm_int vipm_Rect_(2d)(area)(vipm_Rect_t(2d) const *aShape)
{
	return (vipm_Rect_(2d)(height)(aShape) * vipm_Rect_(2d)(width)(aShape));
}

_VIPM_INLINE vipm_int vipm_Rect_(2d)(area,Q)(vipm_Rect_t(2d) const *aShape)
{
	vipm_int rv, h = vipm_Rect_(2d)(height)(aShape);
	rv = vipm_Rect_(2d)(width)(aShape) * h;
	return (0 <= (rv | h) ? rv : 0);
}


_VIPM_INLINE int vipm_Rect_(2d)(empty)(vipm_Rect_t(2d) const *aShape)
{
	return (vipm_Rect_(2d)(height)(aShape) <= 0 || vipm_Rect_(2d)(width)(aShape) <= 0);
}

/* ------------------------------------------------------------------------- */

_VIPM_INLINE int
vipm_Rect_(2d)(inside2)(vipm_Rect_t(2d) const *aShape, vipm_int Y, vipm_int X)
{
	return (
		(vipm_uint)(Y - aShape->rc_top) <= (vipm_uint)vipm_Rect_(2d)(height)(aShape) &&
		(vipm_uint)(X - aShape->rc_left) <= (vipm_uint)vipm_Rect_(2d)(width)(aShape)
	);
}

_VIPM_INLINE int
vipm_Rect_(2d)(inside)(vipm_Rect_t(2d) const *aShape, vipm_Point_t(2d) const *aPoint)
{
	return vipm_Rect_(2d)(inside2)(aShape, aPoint->pi_y, aPoint->pi_x);
}

/* ------------------------------------------------------------------------- */

_VIPM_INLINE vipm_Point_t(r2d) *
vipm_Rect_(2d)(centroid,r)(vipm_Point_t(r2d) *aResult, vipm_Rect_t(2d) const *aShape)
{
	return vipm_r2d_point_mp(vipm_Rect_(2d)(moment1)(aResult->__v, aShape));
}

#if 0
_VIPM_INLINE vipm_Point_t(f2d) *
vipm_Rect_(2d)(centroid,f)(vipm_Point_t(f2d) *aResult, vipm_Rect_t(2d) const *aShape)
{
	vipm_Point_t(r2d) mm1;
	return vipm_Point(f2d)(cast,r)(aResult, vipm_Rect_(2d)(centroid,r)(moment1)(mm1.__v, aShape));
}
#endif

_VIPM_INLINE vipm_Point_t(2d) *
vipm_Rect_(2d)(centroid)(vipm_Point_t(2d) *aResult, vipm_Rect_t(2d) const *aShape)
{
	vipm_Point_t(r2d) rv;
	return vipm_Point(2d)(cast,r)(aResult, vipm_Rect_(2d)(centroid,r)(&rv, aShape));
}

/* ------------------------------------------------------------------------- */

_VIPM_INLINE vipm_Rect_t(2d) *
vipm_Rect_(2d)(srextend,I)(vipm_Rect_t(2d) *aRoiSrcDst, vipm_int dY, vipm_int dX,
		vipm_int aHeight, vipm_int aWidth)
{
	return vipm_Rect_(2d)(srextend)(aRoiSrcDst, NULL, dY, dX, aHeight, aWidth);
}

/* @} */

/* ========================================================================= */

/* @{ */

# define vipm_f2d_rect_cast_$i                  vipm_f2d_rcpt_cast_$i
# define vipm_f2d_rect_cast_$r                  vipm_f2d_rcpt_cast_$r

# define vipm_f2d_rect_height(rc)              ((rc)->rc_h)
# define vipm_f2d_rect_width(rc)               ((rc)->rc_w)
# define vipm_f2d_rect_isconvex(x)             (1)

/* ------------------------------------------------------------------------- */

_VIPM_INLINE vipm_Rect_t(f2d) *
vipm_Rect(f2d)(rcpt)(vipm_Rect_t(f2d) *aThis, vipm_Rcpt_t(f2d) const *aSrc)
{
	return vipm_Rect_(f2d)(convert)(aThis, aSrc);
}


_VIPM_INLINE vipm_Rect_t(f2d) *vipm_Rect_(f2d)(convert,I)(vipm_Rcpt_t(f2d) *aThis)
{
	aThis->rc_h -= aThis->rc_top;
	aThis->rc_w -= aThis->rc_left;
	return (aThis);
}

/* ------------------------------------------------------------------------- */

_VIPM_INLINE bo_float32_t vipm_Rect_(f2d)(height,Q)(vipm_Rect_t(f2d) const *aShape)
{
	bo_float32_t rv = vipm_Rect_(f2d)(height)(aShape);
	return (FLT_EPSILON < rv ? rv : 0);
}

_VIPM_INLINE bo_float32_t vipm_Rect_(f2d)(width,Q)(vipm_Rect_t(f2d) const *aShape)
{
	bo_float32_t rv = vipm_Rect_(f2d)(width)(aShape);
	return (FLT_EPSILON < rv ? rv : 0);
}


_VIPM_INLINE bo_float32_t vipm_Rect_(f2d)(area)(vipm_Rect_t(f2d) const *aShape)
{
	return (vipm_Rect_(f2d)(width)(aShape) * vipm_Rect_(f2d)(height)(aShape));
}

_VIPM_INLINE bo_float32_t vipm_Rect_(f2d)(area,Q)(vipm_Rect_t(f2d) const *aShape)
{
	bo_float32_t rv, h = vipm_Rect_(f2d)(height)(aShape);
	rv = vipm_Rect_(f2d)(width)(aShape) * h;
	return ((FLT_EPSILON < h && FLT_EPSILON < rv) ? rv : 0);
}


_VIPM_INLINE int vipm_Rect_(f2d)(empty)(vipm_Rect_t(f2d) const *aShape)
{
	return (vipmi__equal0f(vipm_Rect_(f2d)(height)(aShape)) || vipmi__equal0f(vipm_Rect_(f2d)(width)(aShape)));
}

/* ------------------------------------------------------------------------- */

_VIPM_INLINE int
vipm_Rect_(f2d)(inside)(vipm_Rect_t(f2d) const *aShape, vipm_Point_t(f2d) const *aPoint)
{
	return vipm_Rect_(f2d)(inside2)(aShape, aPoint->pi_y, aPoint->pi_x);
}

/* ------------------------------------------------------------------------- */

_VIPM_INLINE vipm_Point_t(r2d) *
vipm_Rect_(f2d)(centroid,r)(vipm_Point_t(r2d) *aResult, vipm_Rect_t(f2d) const *aShape)
{
	return vipm_r2d_point_mp(vipm_Rect_(f2d)(moment1)(aResult->__v, aShape));
}

/* @} */

/* ========================================================================= */

/* @{ */

# define vipm_r2d_rect_cast_$i                  vipm_r2d_rcpt_cast_$i
# define vipm_r2d_rect_cast_$f                  vipm_r2d_rcpt_cast_$f

# define vipm_r2d_rect_height(rc)              ((rc)->rc_h)
# define vipm_r2d_rect_width(rc)               ((rc)->rc_w)
# define vipm_r2d_rect_isconvex(x)             (1)

/* ------------------------------------------------------------------------- */

_VIPM_INLINE vipm_Rect_t(r2d) *
vipm_Rect(r2d)(rcpt)(vipm_Rect_t(r2d) *aThis, vipm_Rcpt_t(r2d) const *aSrc)
{
	return vipm_Rect_(r2d)(convert)(aThis, aSrc);
}


_VIPM_INLINE vipm_Rect_t(r2d) *vipm_Rect_(r2d)(convert,I)(vipm_Rcpt_t(r2d) *aThis)
{
	aThis->rc_h -= aThis->rc_top;
	aThis->rc_w -= aThis->rc_left;
	return (aThis);
}

/* ------------------------------------------------------------------------- */

_VIPM_INLINE bo_float64_t vipm_Rect_(r2d)(height,Q)(vipm_Rect_t(r2d) const *aShape)
{
	bo_float64_t rv = vipm_Rect_(r2d)(height)(aShape);
	return (DBL_EPSILON < rv ? rv : 0);
}

_VIPM_INLINE bo_float64_t vipm_Rect_(r2d)(width,Q)(vipm_Rect_t(r2d) const *aShape)
{
	bo_float64_t rv = vipm_Rect_(r2d)(width)(aShape);
	return (DBL_EPSILON < rv ? rv : 0);
}


_VIPM_INLINE bo_float64_t vipm_Rect_(r2d)(area)(vipm_Rect_t(r2d) const *aShape)
{
	return (vipm_Rect_(r2d)(width)(aShape) * vipm_Rect_(r2d)(height)(aShape));
}

_VIPM_INLINE bo_float64_t vipm_Rect_(r2d)(area,Q)(vipm_Rect_t(r2d) const *aShape)
{
	bo_float64_t rv, h = vipm_Rect_(r2d)(height)(aShape);
	rv = vipm_Rect_(r2d)(width)(aShape) * h;
	return ((DBL_EPSILON < h && DBL_EPSILON < rv) ? rv : 0);
}


_VIPM_INLINE int vipm_Rect_(r2d)(empty)(vipm_Rect_t(r2d) const *aShape)
{
	return (vipm_Rect_(r2d)(height)(aShape) <= DBL_EPSILON || vipm_Rect_(r2d)(width)(aShape) <= DBL_EPSILON);
}

/* ------------------------------------------------------------------------- */

_VIPM_INLINE int
vipm_Rect_(r2d)(inside)(vipm_Rect_t(r2d) const *aShape, vipm_Point_t(r2d) const *aPoint)
{
	return vipm_Rect_(r2d)(inside2)(aShape, aPoint->pi_y, aPoint->pi_x);
}

/* ------------------------------------------------------------------------- */

_VIPM_INLINE vipm_Point_t(r2d) *
vipm_Rect_(r2d)(centroid)(vipm_Point_t(r2d) *aResult, vipm_Rect_t(r2d) const *aShape)
{
	return vipm_r2d_point_mp(vipm_Rect_(r2d)(moment1)(aResult->__v, aShape));
}

_VIPM_INLINE vipm_Point_t(f2d) *
vipm_Rect_(r2d)(centroid,f)(vipm_Point_t(f2d) *aResult, vipm_Rect_t(r2d) const *aShape)
{
	vipm_Point_t(r2d) rv;
	return vipm_Point(f2d)(cast,r)(aResult, vipm_Rect_(r2d)(centroid)(&rv, aShape));
}

/* @} */


__MYC_END_CDECLS
# undef __PUB
# undef __PRIV


#endif /* !defined(__VIPM_MATH_GEOMETRY_2D_RECT_H__) */


/******************************************************************************
 *
 *
 *
 *****************************************************************************/
