/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright 2016 Seenaptec Ltd. All rights reserved.
 * SEENAPTEC PROPRIETARY/CONFIDENTIAL.
 *
 * $Id$
 */

/*
 * Core_Utils.h	(V.Sokur)
 * Vipm/Math/Geometry/Core_Utils.h
 */

/* ------------------------------------------------------------------------- */

#ifndef __VIPM_MATH_GEOMETRY_CORE_UTILS_H__
# define __VIPM_MATH_GEOMETRY_CORE_UTILS_H__

/******************************************************************************
 * %% BeginSection: includes
 */

# ifndef __VIPM_TYPES_H__
#  include <Vipm/Types.h>
# endif

# ifndef __VIPM_MATH_UTILS_VECSPACEUTILS_H__
#  include <Vipm/Math/Utils/VecSpaceUtils.h>
# endif


/******************************************************************************
 * %% BeginSection: function prototypes
 */
# pragma mark -
# pragma mark [ function prototypes ]
# pragma mark -

# include <Vipm/Linkage.h>
# define __PUB  __myc_flinkage__(public,libVipm)
# define __VPUB __myc_vlinkage__(public,libVipm)
__MYC_BEGIN_CDECLS

/*
 * Suffix:
 *
 * L - long; primary rank used; otherwise effective rank used
 * S - safe; for example: nil-pointer can be passed as actual argument
 * I - inplace
 * Q -
 */

/* ========================================================================= */

/*
 * Construct
 */

__PUB vipm_dims_t  *vipm_dims()         __P((vipm_dims_t *));
__PUB vipm_dims_t  *vipm_dims(1)        __P((vipm_dims_t *, vipm_int));
__PUB vipm_dims_t  *vipm_dims(2)        __P((vipm_dims_t *, vipm_int, vipm_int));
__PUB vipm_dims_t  *vipm_dims(3)        __P((vipm_dims_t *, vipm_int, vipm_int, vipm_int));
__PUB vipm_dims_t  *vipm_dims(4)        __P((vipm_dims_t *, vipm_int, vipm_int, vipm_int, vipm_int));
__PUB vipm_dims_t  *vipm_dims(v)        __P((vipm_dims_t *, vipm_rank_t, vipm_int const []));
__PUB vipm_dims_t  *vipm_dims(v,L)      __P((vipm_dims_t *, vipm_rank_t, vipm_int const []));
__PUB vipm_dims_t  *vipm_dims(g1)       __P((vipm_dims_t *, vipm_int));
__PUB vipm_dims_t  *vipm_dims(g2)       __P((vipm_dims_t *, vipm_int, vipm_int));
__PUB vipm_dims_t  *vipm_dims(g3)       __P((vipm_dims_t *, vipm_int, vipm_int, vipm_int));
__PUB vipm_dims_t  *vipm_dims(g4)       __P((vipm_dims_t *, vipm_int, vipm_int, vipm_int, vipm_int));
__PUB vipm_dims_t  *vipm_dims(gv)       __P((vipm_dims_t *, vipm_rank_t, vipm_int const []));
__PUB vipm_dims_t  *vipm_dims(gv,L)     __P((vipm_dims_t *, vipm_rank_t, vipm_int const []));


/*
 * Functional
 */

__PUB vipm_dims_t  *vipm_dims_(zero)    __P((vipm_dims_t *));
__PUB vipm_dims_t  *vipm_dims_(zero,g)  __P((vipm_dims_t *));
__PUB vipm_dims_t  *vipm_dims_(dup)     __P((vipm_dims_t *, vipm_int));
__PUB vipm_dims_t  *vipm_dims_(dup,g)   __P((vipm_dims_t *, vipm_int));

/* ------------------------------------------------------------------------- */

/*
 * Construct
 */

__PUB vipm_Npoint_t    *vipm_Npoint()       __P((vipm_Npoint_t *));
__PUB vipm_Npoint_t    *vipm_Npoint(1)      __P((vipm_Npoint_t *, vipm_int));
__PUB vipm_Npoint_t    *vipm_Npoint(2)      __P((vipm_Npoint_t *, vipm_int, vipm_int));
__PUB vipm_Npoint_t    *vipm_Npoint(3)      __P((vipm_Npoint_t *, vipm_int, vipm_int, vipm_int));
__PUB vipm_Npoint_t    *vipm_Npoint(4)      __P((vipm_Npoint_t *, vipm_int, vipm_int, vipm_int, vipm_int));
__PUB vipm_Npoint_t    *vipm_Npoint(v)      __P((vipm_Npoint_t *, vipm_rank_t, vipm_int const []));
__PUB vipm_Npoint_t    *vipm_Npoint(v,L)    __P((vipm_Npoint_t *, vipm_rank_t, vipm_int const []));
__PUB vipm_Npoint_t    *vipm_Npoint(g1)     __P((vipm_Npoint_t *, vipm_int));
__PUB vipm_Npoint_t    *vipm_Npoint(g2)     __P((vipm_Npoint_t *, vipm_int, vipm_int));
__PUB vipm_Npoint_t    *vipm_Npoint(g3)     __P((vipm_Npoint_t *, vipm_int, vipm_int, vipm_int));
__PUB vipm_Npoint_t    *vipm_Npoint(g4)     __P((vipm_Npoint_t *, vipm_int, vipm_int, vipm_int, vipm_int));
__PUB vipm_Npoint_t    *vipm_Npoint(gv)     __P((vipm_Npoint_t *, vipm_rank_t, vipm_int const []));
__PUB vipm_Npoint_t    *vipm_Npoint(gv,L)   __P((vipm_Npoint_t *, vipm_rank_t, vipm_int const []));


/*
 * Functional
 */

__PUB vipm_Npoint_t    *vipm_Npoint_(zero)  __P((vipm_Npoint_t *));
__PUB vipm_Npoint_t    *vipm_Npoint_(zero,g)__P((vipm_Npoint_t *));
__PUB vipm_Npoint_t    *vipm_Npoint_(dup)   __P((vipm_Npoint_t *, vipm_int));
__PUB vipm_Npoint_t    *vipm_Npoint_(dup,g) __P((vipm_Npoint_t *, vipm_int));

/* ------------------------------------------------------------------------- */

/*
 * Construct
 */

__PUB vipm_Nvector_t   *vipm_Nvector()      __P((vipm_Nvector_t *));
__PUB vipm_Nvector_t   *vipm_Nvector(1)     __P((vipm_Nvector_t *, vipm_int));
__PUB vipm_Nvector_t   *vipm_Nvector(2)     __P((vipm_Nvector_t *, vipm_int, vipm_int));
__PUB vipm_Nvector_t   *vipm_Nvector(3)     __P((vipm_Nvector_t *, vipm_int, vipm_int, vipm_int));
__PUB vipm_Nvector_t   *vipm_Nvector(4)     __P((vipm_Nvector_t *, vipm_int, vipm_int, vipm_int, vipm_int));
__PUB vipm_Nvector_t   *vipm_Nvector(v)     __P((vipm_Nvector_t *, vipm_rank_t, vipm_int const []));
__PUB vipm_Nvector_t   *vipm_Nvector(v,L)   __P((vipm_Nvector_t *, vipm_rank_t, vipm_int const []));
__PUB vipm_Nvector_t   *vipm_Nvector(g1)    __P((vipm_Nvector_t *, vipm_int));
__PUB vipm_Nvector_t   *vipm_Nvector(g2)    __P((vipm_Nvector_t *, vipm_int, vipm_int));
__PUB vipm_Nvector_t   *vipm_Nvector(g3)    __P((vipm_Nvector_t *, vipm_int, vipm_int, vipm_int));
__PUB vipm_Nvector_t   *vipm_Nvector(g4)    __P((vipm_Nvector_t *, vipm_int, vipm_int, vipm_int, vipm_int));
__PUB vipm_Nvector_t   *vipm_Nvector(gv)    __P((vipm_Nvector_t *, vipm_rank_t, vipm_int const []));
__PUB vipm_Nvector_t   *vipm_Nvector(gv,L)  __P((vipm_Nvector_t *, vipm_rank_t, vipm_int const []));


/*
 * Functional
 */

__PUB vipm_Nvector_t   *vipm_Nvector_(zero)     __P((vipm_Nvector_t *));
__PUB vipm_Nvector_t   *vipm_Nvector_(zero,g)   __P((vipm_Nvector_t *));
__PUB vipm_Nvector_t   *vipm_Nvector_(dup)      __P((vipm_Nvector_t *, vipm_int));
__PUB vipm_Nvector_t   *vipm_Nvector_(dup,g)    __P((vipm_Nvector_t *, vipm_int));

/* ------------------------------------------------------------------------- */

/*
 * Construct
 */

__PUB vipm_Nvolume_t   *vipm_Nvolume()      __P((vipm_Nvolume_t *));
__PUB vipm_Nvolume_t   *vipm_Nvolume(1)     __P((vipm_Nvolume_t *, vipm_int));
__PUB vipm_Nvolume_t   *vipm_Nvolume(2)     __P((vipm_Nvolume_t *, vipm_int, vipm_int));
__PUB vipm_Nvolume_t   *vipm_Nvolume(3)     __P((vipm_Nvolume_t *, vipm_int, vipm_int, vipm_int));
__PUB vipm_Nvolume_t   *vipm_Nvolume(4)     __P((vipm_Nvolume_t *, vipm_int, vipm_int, vipm_int, vipm_int));
__PUB vipm_Nvolume_t   *vipm_Nvolume(v)     __P((vipm_Nvolume_t *, vipm_rank_t, vipm_int const []));
__PUB vipm_Nvolume_t   *vipm_Nvolume(v,L)   __P((vipm_Nvolume_t *, vipm_rank_t, vipm_int const []));
__PUB vipm_Nvolume_t   *vipm_Nvolume(g1)    __P((vipm_Nvolume_t *, vipm_int));
__PUB vipm_Nvolume_t   *vipm_Nvolume(g2)    __P((vipm_Nvolume_t *, vipm_int, vipm_int));
__PUB vipm_Nvolume_t   *vipm_Nvolume(g3)    __P((vipm_Nvolume_t *, vipm_int, vipm_int, vipm_int));
__PUB vipm_Nvolume_t   *vipm_Nvolume(g4)    __P((vipm_Nvolume_t *, vipm_int, vipm_int, vipm_int, vipm_int));
__PUB vipm_Nvolume_t   *vipm_Nvolume(gv)    __P((vipm_Nvolume_t *, vipm_rank_t, vipm_int const []));
__PUB vipm_Nvolume_t   *vipm_Nvolume(gv,L)  __P((vipm_Nvolume_t *, vipm_rank_t, vipm_int const []));


/*
 * Functional
 */

__PUB vipm_Nvolume_t   *vipm_Nvolume_(zero)         __P((vipm_Nvolume_t *));
__PUB vipm_Nvolume_t   *vipm_Nvolume_(dup)          __P((vipm_Nvolume_t *, vipm_int));
__PUB vipm_Nvolume_t   *vipm_Nvolume_(zero,g)       __P((vipm_Nvolume_t *));
__PUB vipm_Nvolume_t   *vipm_Nvolume_(dup,g)        __P((vipm_Nvolume_t *, vipm_int));

__PUB int               vipm_Nvolume_(empty)        __P((vipm_Nvolume_t const *));
__PUB vipm_int          vipm_Nvolume_(capacity)     __P((vipm_Nvolume_t const *));
__PUB vipm_int          vipm_Nvolume_(capacity,Q)   __P((vipm_Nvolume_t const *));
__PUB int               vipm_Nvolume_(empty,g)      __P((vipm_Nvolume_t const *));
__PUB vipm_int          vipm_Nvolume_(capacity,g)   __P((vipm_Nvolume_t const *));
__PUB vipm_int          vipm_Nvolume_(capacity,g,Q) __P((vipm_Nvolume_t const *));

__PUB vipm_int          vipm_Nvolume_(height)       __P((vipm_Nvolume_t const *));
__PUB vipm_int          vipm_Nvolume_(width)        __P((vipm_Nvolume_t const *));
__PUB vipm_int          vipm_Nvolume_(nchannels)    __P((vipm_Nvolume_t const *));


/* ========================================================================= */

/*
 * Construct
 */

__PUB vipm_site_t  *vipm_site()             __P((vipm_site_t *));
__PUB vipm_site_t  *vipm_site(g1)           __P((vipm_site_t *, vipm_int, vipm_int));
__PUB vipm_site_t  *vipm_site(g2)           __P((vipm_site_t *, vipm_int, vipm_int, vipm_int, vipm_int));
__PUB vipm_site_t  *vipm_site(g23)          __P((vipm_site_t *, vipm_int, vipm_int, vipm_int, vipm_int, vipm_int));
__PUB vipm_site_t  *vipm_site(g3)           __P((vipm_site_t *, vipm_int, vipm_int, vipm_int,
                                                                vipm_int, vipm_int, vipm_int));
__PUB vipm_site_t  *vipm_site(g34)          __P((vipm_site_t *, vipm_int, vipm_int, vipm_int,
                                                                vipm_int, vipm_int, vipm_int, vipm_int));
__PUB vipm_site_t  *vipm_site(g4)           __P((vipm_site_t *, vipm_int, vipm_int, vipm_int, vipm_int,
                                                                vipm_int, vipm_int, vipm_int, vipm_int));
__PUB vipm_site_t  *vipm_site(4)            __P((vipm_site_t *, vipm_int, vipm_int, vipm_int, vipm_int,
                                                                vipm_int, vipm_int, vipm_int, vipm_int));
__PUB vipm_site_t  *vipm_site(v)            __P((vipm_site_t *, vipm_rank_t, vipm_int const [], vipm_int const []));
__PUB vipm_site_t  *vipm_site(v,L)          __P((vipm_site_t *, vipm_rank_t, vipm_int const [], vipm_int const []));
__PUB vipm_site_t  *vipm_site(gv)           __P((vipm_site_t *, vipm_rank_t, vipm_int const [], vipm_int const []));
__PUB vipm_site_t  *vipm_site(gv,L)         __P((vipm_site_t *, vipm_rank_t, vipm_int const [], vipm_int const []));

/* ------------------------------------------------------------------------- */

/*
 * Functional
 */

__PUB int           vipm_site_(empty)       __P((vipm_site_t const *));
__PUB int           vipm_site_(empty,g)     __P((vipm_site_t const *));


__PUB vipm_site_t  *vipm_site_(zero)        __P((vipm_site_t *));
__PUB vipm_site_t  *vipm_site_(zero,g)      __P((vipm_site_t *));
__PUB vipm_site_t  *vipm_site_(pzero)       __P((vipm_site_t *));
__PUB vipm_site_t  *vipm_site_(pzero,g)     __P((vipm_site_t *));
__PUB vipm_site_t  *vipm_site_(vzero)       __P((vipm_site_t *));
__PUB vipm_site_t  *vipm_site_(vzero,g)     __P((vipm_site_t *));

__PUB vipm_site_t  *vipm_site_(intersec)    __P((vipm_site_t *, vipm_site_t const *, vipm_site_t const *));
__PUB vipm_site_t  *vipm_site_(intersec,I)  __P((vipm_site_t *, vipm_site_t const *));
__PUB vipm_site_t  *vipm_site_(intersec,g)  __P((vipm_site_t *, vipm_site_t const *, vipm_site_t const *));
__PUB vipm_site_t  *vipm_site_(intersec,g,I)__P((vipm_site_t *, vipm_site_t const *));


/* +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ */

_VIPM_INLINE vipm_dims_t *vipm_dims_(zero)(vipm_dims_t *aThis)
{
	(void)vipm_vec_(_zero)(VipmK_MAXDIMS, aThis->v);
	return (aThis);
}

_VIPM_INLINE vipm_dims_t *vipm_dims_(zero,g)(vipm_dims_t *aThis)
{
	(void)vipm_vec_(_zero)(VipmK_MAXGDIMS, aThis->v);
	return (aThis);
}


_VIPM_INLINE vipm_dims_t *vipm_dims_(dup)(vipm_dims_t *aThis, vipm_int aSource)
{
	(void)vipm_vec_(_dup)(VipmK_MAXDIMS, aThis->v, aSource);
	return (aThis);
}

_VIPM_INLINE vipm_dims_t *vipm_dims_(dup,g)(vipm_dims_t *aThis, vipm_int aSource)
{
	(void)vipm_vec_(_dup)(VipmK_MAXGDIMS, aThis->v, aSource);
	return (aThis);
}

/* ------------------------------------------------------------------------- */

_VIPM_INLINE vipm_dims_t *
vipm_dims(4)(vipm_dims_t *aThis, vipm_int z, vipm_int y, vipm_int x, vipm_int cn)
{
	aThis->v[0] = z;
	aThis->v[1] = y;
	aThis->v[2] = x;
	aThis->v[3] = cn;
	return (aThis);
}

//_VIPM_INLINE vipm_dims_t *
//vipm_dims(g4)(vipm_dims_t *aThis, vipm_int z, vipm_int y, vipm_int x, vipm_int cn)
//{
//	return vipm_dims(4)(aThis, z, y, x, cn);
//}
# define __vipm_dims__$g4               __vipm_dims__$4

/* ------------------------------------------------------------------------- */

_VIPM_INLINE vipm_dims_t *vipm_dims()(vipm_dims_t *aThis)
{
	return vipm_dims_(zero)(aThis);
}


_VIPM_INLINE vipm_dims_t *vipm_dims(1)(vipm_dims_t *aThis, vipm_int cn)
{
	return vipm_dims(4)(aThis, 0, 0, 0, cn);
}

_VIPM_INLINE vipm_dims_t *vipm_dims(2)(vipm_dims_t *aThis, vipm_int x, vipm_int cn)
{
	return vipm_dims(4)(aThis, 0, 0, x, cn);
}

_VIPM_INLINE vipm_dims_t *vipm_dims(3)(vipm_dims_t *aThis, vipm_int y, vipm_int x, vipm_int cn)
{
	return vipm_dims(4)(aThis, 0, y, x, cn);
}


_VIPM_INLINE vipm_dims_t *vipm_dims(g1)(vipm_dims_t *aThis, vipm_int x)
{
	return vipm_dims(4)(aThis, 0, 0, x, 0);
}

_VIPM_INLINE vipm_dims_t *vipm_dims(g2)(vipm_dims_t *aThis, vipm_int y, vipm_int x)
{
	return vipm_dims(4)(aThis, 0, y, x, 0);
}

_VIPM_INLINE vipm_dims_t *vipm_dims(g3)(vipm_dims_t *aThis, vipm_int z, vipm_int y, vipm_int x)
{
	return vipm_dims(4)(aThis, z, y, x, 0);
}


/* ------------------------------------------------------------------------- */

# define __vipm_Npoint__$                   __vipm_dims__$
# define __vipm_Npoint__$1                  __vipm_dims__$1
# define __vipm_Npoint__$2                  __vipm_dims__$2
# define __vipm_Npoint__$3                  __vipm_dims__$3
# define __vipm_Npoint__$4                  __vipm_dims__$4
# define __vipm_Npoint__$v                  __vipm_dims__$v
# define __vipm_Npoint__$v$L                __vipm_dims__$v$L
# define __vipm_Npoint__$g1                 __vipm_dims__$g1
# define __vipm_Npoint__$g2                 __vipm_dims__$g2
# define __vipm_Npoint__$g3                 __vipm_dims__$g3
# define __vipm_Npoint__$g4                 __vipm_dims__$g4
# define __vipm_Npoint__$gv                 __vipm_dims__$gv
# define __vipm_Npoint__$gv$L               __vipm_dims__$gv$L

# define vipm_Npoint_zero                   vipm_dims_zero
# define vipm_Npoint_zero_$g                vipm_dims_zero_$g
# define vipm_Npoint_dup                    vipm_dims_dup
# define vipm_Npoint_dup_$g                 vipm_dims_dup_$g


/* ------------------------------------------------------------------------- */

# define __vipm_Nvector__$                  __vipm_dims__$
# define __vipm_Nvector__$1                 __vipm_dims__$1
# define __vipm_Nvector__$2                 __vipm_dims__$2
# define __vipm_Nvector__$3                 __vipm_dims__$3
# define __vipm_Nvector__$4                 __vipm_dims__$4
# define __vipm_Nvector__$v                 __vipm_dims__$v
# define __vipm_Nvector__$v$L               __vipm_dims__$v$L
# define __vipm_Nvector__$g1                __vipm_dims__$g1
# define __vipm_Nvector__$g2                __vipm_dims__$g2
# define __vipm_Nvector__$g3                __vipm_dims__$g3
# define __vipm_Nvector__$g4                __vipm_dims__$g4
# define __vipm_Nvector__$gv                __vipm_dims__$gv
# define __vipm_Nvector__$gv$L              __vipm_dims__$gv$L

# define vipm_Nvector_zero                  vipm_dims_zero
# define vipm_Nvector_zero_$g               vipm_dims_zero_$g
# define vipm_Nvector_dup                   vipm_dims_dup
# define vipm_Nvector_dup_$g                vipm_dims_dup_$g


/* ------------------------------------------------------------------------- */

# define vipm_Nvolume_zero                  vipm_dims_zero
# define vipm_Nvolume_zero_$g               vipm_dims_zero_$g
# define vipm_Nvolume_dup                   vipm_dims_dup
# define vipm_Nvolume_dup_$g                vipm_dims_dup_$g

/* ------------------------------------------------------------------------- */

//_VIPM_INLINE vipm_Nvolume_t *
//vipm_Nvolume(4)(vipm_Nvolume_t *aThis, vipm_int z, vipm_int y, vipm_int x, vipm_int cn)
//{
//	aThis->v[0] = z;
//	aThis->v[1] = y;
//	aThis->v[2] = x;
//	aThis->v[3] = cn;
//	return (aThis);
//}
# define __vipm_Nvolume__$4             __vipm_dims__$4

//_VIPM_INLINE vipm_Nvolume_t *
//vipm_Nvolume(g4)(vipm_Nvolume_t *aThis, vipm_int z, vipm_int y, vipm_int x, vipm_int cn)
//{
//	return vipm_Nvolume(4d)(aThis, z, y, x, cn);
//}
# define __vipm_Nvolume__$g4            __vipm_Nvolume__$4

/* ------------------------------------------------------------------------- */

_VIPM_INLINE vipm_Nvolume_t *vipm_Nvolume()(vipm_Nvolume_t *aThis)
{
	return vipm_Nvolume_(dup)(aThis, 1);
}


_VIPM_INLINE vipm_Nvolume_t *vipm_Nvolume(1)(vipm_Nvolume_t *aThis, vipm_int cn)
{
	return vipm_Nvolume(4)(aThis, 1, 1, 1, cn);
}

_VIPM_INLINE vipm_Nvolume_t *vipm_Nvolume(2)(vipm_Nvolume_t *aThis, vipm_int x, vipm_int cn)
{
	return vipm_Nvolume(4)(aThis, 1, 1, x, cn);
}

_VIPM_INLINE vipm_Nvolume_t *vipm_Nvolume(3)(vipm_Nvolume_t *aThis, vipm_int y, vipm_int x, vipm_int cn)
{
	return vipm_Nvolume(4)(aThis, 1, y, x, cn);
}


_VIPM_INLINE vipm_Nvolume_t *vipm_Nvolume(g1)(vipm_Nvolume_t *aThis, vipm_int x)
{
	return vipm_Nvolume(4)(aThis, 1, 1, x, 1);
}

_VIPM_INLINE vipm_Nvolume_t *vipm_Nvolume(g2)(vipm_Nvolume_t *aThis, vipm_int y, vipm_int x)
{
	return vipm_Nvolume(4)(aThis, 1, y, x, 1);
}

_VIPM_INLINE vipm_Nvolume_t *vipm_Nvolume(g3)(vipm_Nvolume_t *aThis, vipm_int z, vipm_int y, vipm_int x)
{
	return vipm_Nvolume(4)(aThis, z, y, x, 1);
}

/* ------------------------------------------------------------------------- */

_VIPM_INLINE int vipm_Nvolume_(empty)(vipm_Nvolume_t const *aThis)
{
	return vipm_volume_(_empty)(VipmK_MAXDIMS, aThis->v);
}

_VIPM_INLINE int vipm_Nvolume_(empty,g)(vipm_Nvolume_t const *aThis)
{
	return vipm_volume_(_empty)(VipmK_MAXGDIMS, aThis->v);
}


_VIPM_INLINE vipm_int vipm_Nvolume_(capacity)(vipm_Nvolume_t const *aThis)
{
	return vipm_volume_(_capacity)(VipmK_MAXDIMS, aThis->v);
}

_VIPM_INLINE vipm_int vipm_Nvolume_(capacity,g)(vipm_Nvolume_t const *aThis)
{
	return vipm_volume_(_capacity)(VipmK_MAXGDIMS, aThis->v);
}


_VIPM_INLINE vipm_int vipm_Nvolume_(capacity,Q)(vipm_Nvolume_t const *aThis)
{
	return vipm_volume_(_capacity,Q)(VipmK_MAXDIMS, aThis->v);
}

_VIPM_INLINE vipm_int vipm_Nvolume_(capacity,g,Q)(vipm_Nvolume_t const *aThis)
{
	return vipm_volume_(_capacity,Q)(VipmK_MAXGDIMS, aThis->v);
}


_VIPM_INLINE vipm_int vipm_Nvolume_(height)(vipm_Nvolume_t const *aThis)
{
//	return vipm_volume_(_height)(VipmK_MAXDIMS, aThis->v);
	return vipm_pt_y(*aThis);
}

_VIPM_INLINE vipm_int vipm_Nvolume_(width)(vipm_Nvolume_t const *aThis)
{
//	return vipm_volume_(_width)(VipmK_MAXDIMS, aThis->v);
	return vipm_pt_x(*aThis);
}

_VIPM_INLINE vipm_int vipm_Nvolume_(nchannels)(vipm_Nvolume_t const *aThis)
{
//	return vipm_volume_(_nchannels)(VipmK_MAXDIMS, aThis->v);
	return vipm_pt_cn(*aThis);
}


/* ========================================================================= */

_VIPM_INLINE vipm_site_t *vipm_site_(zero)(vipm_site_t *aThis)
{
	(void)vipm_Npoint_(zero)(&aThis->si_point);
	(void)vipm_Nvolume_(zero)(&aThis->si_volume);
	return (aThis);
}

_VIPM_INLINE vipm_site_t *vipm_site_(zero,g)(vipm_site_t *aThis)
{
	(void)vipm_Npoint_(zero,g)(&aThis->si_point);
	(void)vipm_Nvolume_(zero,g)(&aThis->si_volume);
	return (aThis);
}


_VIPM_INLINE vipm_site_t *vipm_site_(pzero)(vipm_site_t *aThis)
{
	(void)vipm_Npoint_(zero)(&aThis->si_point);
	return (aThis);
}

_VIPM_INLINE vipm_site_t *vipm_site_(pzero,g)(vipm_site_t *aThis)
{
	(void)vipm_Npoint_(zero,g)(&aThis->si_point);
	return (aThis);
}


_VIPM_INLINE vipm_site_t *vipm_site_(vzero)(vipm_site_t *aThis)
{
	(void)vipm_Nvolume_(zero)(&aThis->si_volume);
	return (aThis);
}

_VIPM_INLINE vipm_site_t *vipm_site_(vzero,g)(vipm_site_t *aThis)
{
	(void)vipm_Nvolume_(zero,g)(&aThis->si_volume);
	return (aThis);
}

/* ------------------------------------------------------------------------- */

_VIPM_INLINE vipm_site_t *vipm_site()(vipm_site_t *aThis)
{
	(void)vipm_Npoint()(&aThis->si_point);
	(void)vipm_Nvolume()(&aThis->si_volume);
	return (aThis);
}


_VIPM_INLINE vipm_site_t *
vipm_site(g1)(vipm_site_t *aThis, vipm_int x, vipm_int dx)
{
	(void)vipm_Npoint(g1)(&aThis->si_point, x);
	(void)vipm_Nvolume(g1)(&aThis->si_volume, dx);
	return (aThis);
}

_VIPM_INLINE vipm_site_t *
vipm_site(g2)(vipm_site_t *aThis, vipm_int y, vipm_int x, vipm_int dy, vipm_int dx)
{
	(void)vipm_Npoint(g2)(&aThis->si_point, y, x);
	(void)vipm_Nvolume(g2)(&aThis->si_volume, dy, dx);
	return (aThis);
}

_VIPM_INLINE vipm_site_t *
vipm_site(g23)(vipm_site_t *aThis, vipm_int y, vipm_int x,
		vipm_int dy, vipm_int dx, vipm_int cn)
{
	(void)vipm_Npoint(g2)(&aThis->si_point, y, x);
	(void)vipm_Nvolume(3)(&aThis->si_volume, dy, dx, cn);
	return (aThis);
}

_VIPM_INLINE vipm_site_t *
vipm_site(g3)(vipm_site_t *aThis, vipm_int z, vipm_int y, vipm_int x,
		vipm_int dz, vipm_int dy, vipm_int dx)
{
	(void)vipm_Npoint(g3)(&aThis->si_point, z, y, x);
	(void)vipm_Nvolume(g3)(&aThis->si_volume, dz, dy, dx);
	return (aThis);
}

_VIPM_INLINE vipm_site_t *
vipm_site(g34)(vipm_site_t *aThis, vipm_int z, vipm_int y, vipm_int x,
		vipm_int dz, vipm_int dy, vipm_int dx, vipm_int cn)
{
	(void)vipm_Npoint(g3)(&aThis->si_point, z, y, x);
	(void)vipm_Nvolume(4)(&aThis->si_volume, dz, dy, dx, cn);
	return (aThis);
}

_VIPM_INLINE vipm_site_t *
vipm_site(4)(vipm_site_t *aThis, vipm_int z, vipm_int y, vipm_int x, vipm_int cn0,
		vipm_int dz, vipm_int dy, vipm_int dx, vipm_int cn)
{
	(void)vipm_Npoint(4)(&aThis->si_point, z, y, x, cn0);
	(void)vipm_Nvolume(4)(&aThis->si_volume, dz, dy, dx, cn);
	return (aThis);
}

//_VIPM_INLINE vipm_site_t *
//vipm_site(g4)(vipm_site_t *aThis, vipm_int z, vipm_int y, vipm_int x, vipm_int cn0,
//		vipm_int dz, vipm_int dy, vipm_int dx, vipm_int cn)
//{
//	return vipm_site(4)(aThis, z, y, x, cn0, dz, dy, dx, cn);
//}
# define __vipm_site__$g4               __vipm_site__$4


_VIPM_INLINE vipm_site_t *
vipm_site(v)(vipm_site_t *aThis, vipm_int rank, vipm_int const x0[], vipm_int const vol[])
{
	(void)vipm_Npoint(v)(&aThis->si_point, rank, x0);
	(void)vipm_Nvolume(v)(&aThis->si_volume, rank, vol);
	return (aThis);
}

_VIPM_INLINE vipm_site_t *
vipm_site(v,L)(vipm_site_t *aThis, vipm_int rank, vipm_int const x0[], vipm_int const vol[])
{
	(void)vipm_Npoint(v,L)(&aThis->si_point, rank, x0);
	(void)vipm_Nvolume(v,L)(&aThis->si_volume, rank, vol);
	return (aThis);
}


_VIPM_INLINE vipm_site_t *
vipm_site(gv)(vipm_site_t *aThis, vipm_int rank, vipm_int const x0[], vipm_int const vol[])
{
	(void)vipm_Npoint(gv)(&aThis->si_point, rank, x0);
	(void)vipm_Nvolume(gv)(&aThis->si_volume, rank, vol);
	return (aThis);
}

_VIPM_INLINE vipm_site_t *
vipm_site(gv,L)(vipm_site_t *aThis, vipm_int rank, vipm_int const x0[], vipm_int const vol[])
{
	(void)vipm_Npoint(gv,L)(&aThis->si_point, rank, x0);
	(void)vipm_Nvolume(gv,L)(&aThis->si_volume, rank, vol);
	return (aThis);
}

/* ------------------------------------------------------------------------- */

_VIPM_INLINE vipm_site_t *
vipm_site_(intersec,I)(vipm_site_t *aDst, vipm_site_t const *aSrc2)
{
	(void)vipm__intersecI(VipmK_MAXDIMS, aDst->si_point.v, aDst->si_volume.v,
			aSrc2->si_point.v, aSrc2->si_volume.v);
	return (aDst);
}

_VIPM_INLINE vipm_site_t *
vipm_site_(intersec)(vipm_site_t *aDst, vipm_site_t const *aSrc1, vipm_site_t const *aSrc2)
{
	if (NULL == aSrc1) {
		return vipm_site_(intersec,I)(aDst, aSrc2);
		/* NOTREACHED */
	}
	(void)vipm__intersec(VipmK_MAXDIMS, aDst->si_point.v, aDst->si_volume.v,
			aSrc1->si_point.v, aSrc1->si_volume.v, aSrc2->si_point.v, aSrc2->si_volume.v);
	return (aDst);
}


_VIPM_INLINE vipm_site_t *
vipm_site_(intersec,g,I)(vipm_site_t *aDst, vipm_site_t const *aSrc2)
{
	(void)vipm__intersecI(VipmK_MAXGDIMS, aDst->si_point.v, aDst->si_volume.v,
			aSrc2->si_point.v, aSrc2->si_volume.v);
	return (aDst);
}

_VIPM_INLINE vipm_site_t *
vipm_site_(intersec,g)(vipm_site_t *aDst, vipm_site_t const *aSrc1, vipm_site_t const *aSrc2)
{
	if (NULL == aSrc1) {
		return vipm_site_(intersec,g,I)(aDst, aSrc2);
		/* NOTREACHED */
	}
	(void)vipm__intersec(VipmK_MAXGDIMS, aDst->si_point.v, aDst->si_volume.v,
			aSrc1->si_point.v, aSrc1->si_volume.v, aSrc2->si_point.v, aSrc2->si_volume.v);
	return (aDst);
}

/* ------------------------------------------------------------------------- */

_VIPM_INLINE int vipm_site_(empty)(vipm_site_t const *aThis)
{
	return vipm_Nvolume_(empty)(&aThis->si_volume);
}

_VIPM_INLINE int vipm_site_(empty,g)(vipm_site_t const *aThis)
{
	return vipm_Nvolume_(empty,g)(&aThis->si_volume);
}


__MYC_END_CDECLS
# undef __PUB
# undef __VPUB


#endif /* !defined(__VIPM_MATH_GEOMETRY_CORE_UTILS_H__) */


/******************************************************************************
 *
 *
 *
 *****************************************************************************/
