/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright 2016 Seenaptec Ltd. All rights reserved.
 * SEENAPTEC PROPRIETARY/CONFIDENTIAL.
 *
 * $Id$
 */

/*
 * MatrixUtils.h	(V.Sokur)
 * Vipm/Math/Utils/2D/MatrixUtils.h
 */

/* ------------------------------------------------------------------------- */

#ifndef __VIPM_MATH_UTILS_2D_MATRIXUTILS_H__
# define __VIPM_MATH_UTILS_2D_MATRIXUTILS_H__

/******************************************************************************
 * %% BeginSection: includes
 */

# ifndef __VIPM_TYPES_H__
#  include <Vipm/Types.h>
# endif


/******************************************************************************
 * %% BeginSection: function prototypes
 */
# pragma mark -
# pragma mark [ function prototypes ]
# pragma mark -

# define vipm_mat_(...)             VIPM_PFX_FCNAME(vipm_mat, __VA_ARGS__)
# define vipm_f2d_mat_(...)         VIPM_PFX_FCNAME(vipm_f2d_mat, __VA_ARGS__)
# define vipm_r2d_mat_(...)         VIPM_PFX_FCNAME(vipm_r2d_mat, __VA_ARGS__)
# define vipm_Mat_(_Space)          VIPM_GLUE3(vipm_,_Space,_mat_)

# define vipm_symmat_(...)          VIPM_PFX_FCNAME(vipm_symmat, __VA_ARGS__)
# define vipm_f2d_symmat_(...)      VIPM_PFX_FCNAME(vipm_f2d_symmat, __VA_ARGS__)
# define vipm_r2d_symmat_(...)      VIPM_PFX_FCNAME(vipm_r2d_symmat, __VA_ARGS__)
# define vipm_SymMat_(_Space)       VIPM_GLUE3(vipm_,_Space,_symmat_)

# define vipm_symmat2x2_(...)       VIPM_PFX_FCNAME(vipm_symmat2x2, __VA_ARGS__)
# define vipm_f32_symmat2x2_(...)   VIPM_PFX_FCNAME(vipm_f32_symmat2x2, __VA_ARGS__)
# define vipm_f64_symmat2x2_(...)   VIPM_PFX_FCNAME(vipm_f64_symmat2x2, __VA_ARGS__)
# define vipm_SymMat2x2_(_Space)    VIPM_GLUE3(vipm_,_Space,_symmat2x2_)


# include <Vipm/Linkage.h>
# define __PUB __myc_flinkage__(public,libVipm)
# define __PROT __myc_flinkage__(public,libVipm)
# define __PRIV __myc_flinkage__(private,libVipm)
__MYC_BEGIN_CDECLS

__PUB double   *vipm_SymMat2x2_(f64)(eigvals)   __P((double [/*2*/], double const [/*4*/]));
__PUB double    vipm_SymMat2x2_(f64)(xeigvals)  __P((double [/*2*/], double const [/*4*/]));


__MYC_END_CDECLS
# undef __PUB
# undef __PROT
# undef __PRIV


#endif /* !defined(__VIPM_MATH_UTILS_2D_MATRIXUTILS_H__) */


/******************************************************************************
 *
 *
 *
 *****************************************************************************/
