/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright 2016 Seenaptec Ltd. All rights reserved.
 * SEENAPTEC PROPRIETARY/CONFIDENTIAL.
 *
 * $Id$
 */

/*
 * DimsUtils.h	(V.Sokur)
 * Vipm/Utils/DimsUtils.h
 */

/* ------------------------------------------------------------------------- */

#ifndef __VIPM_MATH_UTILS_DIMSUTILS_H__
# define __VIPM_MATH_UTILS_DIMSUTILS_H__

/******************************************************************************
 * %% BeginSection: includes
 */

# ifndef __VIPM_TYPES_H__
#  include <Vipm/Types.h>
# endif


/******************************************************************************
 * %% BeginSection: function prototypes
 */
# pragma mark -
# pragma mark [ function prototypes ]
# pragma mark -

# include <Vipm/Linkage.h>
# define __PUB  __myc_flinkage__(public,libVipm)
# define __VPUB __myc_vlinkage__(public,libVipm)
__MYC_BEGIN_CDECLS

/*
 * Return new value of reduction.
 */

__PUB vipm_int
vipm_dims_xreduce(
#if __myc_require(prototypes)
	vipm_int                        aVolumeRes[],
	vipm_int                      **aStartvRes,
	vipm_int                      **aStridevRes,
	vipm_int                        aReduction,     /* = 0 */
	vipm_int                        aRankOrig,
	vipm_int                        aRankMin,
	vipm_int                        aNumStrides,
	vipm_int                        aPintPadding,
	vipm_int const                  aVolume[],
	vipm_int const                **aStartv,
	vipm_int const                **aStridev
#endif
	);

__PUB vipm_int
vipm_dims_xreduceI(
#if __myc_require(prototypes)
	vipm_int                        aVolumeRes[],
	vipm_int                      **aStartvRes,
	vipm_int                      **aStridevRes,
	vipm_int                        aReduction,     /* = 0 */
	vipm_int                        aRankOrig,
	vipm_int                        aRankMin,
	vipm_int                        aNumStrides,
	vipm_int                        aPintPadding
#endif
	);


__MYC_END_CDECLS
# undef __PUB
# undef __VPUB


#endif /* !defined(__VIPM_MATH_UTILS_DIMSUTILS_H__) */


/******************************************************************************
 *
 *
 *
 *****************************************************************************/
