/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright 2016 Seenaptec Ltd. All rights reserved.
 * SEENAPTEC PROPRIETARY/CONFIDENTIAL.
 *
 * $Id$
 */

/*
 * QuadEqu.h	(V.Sokur)
 * Vipm/Math/Utils/QuadEqu.h
 */

/* ------------------------------------------------------------------------- */

#ifndef __VIPM_MATH_UTILS_QUADEQU_H__
# define __VIPM_MATH_UTILS_QUADEQU_H__

/******************************************************************************
 * %% BeginSection: includes
 */

# ifndef __VIPM_TYPES_H__
#  include <Vipm/Types.h>
# endif


/******************************************************************************
 * %% BeginSection: function prototypes
 */
# pragma mark -
# pragma mark [ function prototypes ]
# pragma mark -

# define vipm_quadequ_(...)             VIPM_PFX_FCNAME(vipm_quadequ, __VA_ARGS__)
# define vipm_f64_quadequ_(...)         VIPM_PFX_FCNAME(vipm_f64_quadequ, __VA_ARGS__)
# define vipm_f32_quadequ_(...)         VIPM_PFX_FCNAME(vipm_f32_quadequ, __VA_ARGS__)
# define vipm_Quadequ_(_Space)          VIPM_GLUE3(vipm_,_Space,_quadequ_)


# include <Vipm/Linkage.h>
# define __PUB __myc_flinkage__(public,libVipm)
# define __PRIV __myc_flinkage__(private,libVipm)
__MYC_BEGIN_CDECLS

__PUB double   *vipm_Quadequ_(f64)(solve,simple)__P((double aResult[/*2*/], double B, double C));
__PUB double   *vipm_Quadequ_(f64)(solve)       __P((double aResult[/*2*/], double A, double B, double C));
__PUB double   *vipm_Quadequ_(f64)(solve,mm)    __P((double aResult[/*2*/], double const A[/*3*/]));


__MYC_END_CDECLS
# undef __PUB
# undef __PRIV


#endif /* !defined(__VIPM_MATH_UTILS_QUADEQU_H__) */


/******************************************************************************
 *
 *
 *
 *****************************************************************************/
