/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright 2016 Seenaptec Ltd. All rights reserved.
 * SEENAPTEC PROPRIETARY/CONFIDENTIAL.
 *
 * $Id$
 */

/*
 * VecSpaceUtils.h	(V.Sokur)
 * Vipm/Math/Utils/VecSpaceUtils.h
 */

/* ------------------------------------------------------------------------- */

#ifndef __VIPM_MATH_UTILS_VECSPACEUTILS_H__
# define __VIPM_MATH_UTILS_VECSPACEUTILS_H__

/******************************************************************************
 * %% BeginSection: includes
 */

# ifndef __VIPM_TYPES_H__
#  include <Vipm/Types.h>
# endif


/******************************************************************************
 * %% BeginSection: function prototypes
 */
# pragma mark -
# pragma mark [ function prototypes ]
# pragma mark -

# include <Vipm/Linkage.h>
# define __PUB  __myc_flinkage__(public,libVipm)
# define __VPUB __myc_vlinkage__(public,libVipm)
__MYC_BEGIN_CDECLS

/*
 * Suffix:
 *
 * L - long; primary rank used; otherwise effective rank used
 * S - safe; for example: nil-pointer can be passed as actual argument
 * I - inplace
 * Q -
 * Z - zero check
 */

/* ========================================================================= */

__PUB vipm_int     *vipm_vec_(assign,LS)    __P((vipm_rank_t, vipm_int [], vipm_int const []));
__PUB vipm_int     *vipm_vec_(assign,L)     __P((vipm_rank_t, vipm_int [], vipm_int const []));
__PUB vipm_int     *vipm_vec_(assign,S)     __P((vipm_rank_t, vipm_int [], vipm_int const []));
__PUB vipm_int     *vipm_vec_(assign)       __P((vipm_rank_t, vipm_int [], vipm_int const []));
__PUB vipm_int     *vipm_vec_(xassign)      __P((vipm_rank_t, vipm_int [], vipm_rank_t, vipm_int const []));

__PUB vipm_int     *vipm_vec_(dup,LS)       __P((vipm_rank_t, vipm_int [], vipm_int));
__PUB vipm_int     *vipm_vec_(dup,L)        __P((vipm_rank_t, vipm_int [], vipm_int));
__PUB vipm_int     *vipm_vec_(dup,S)        __P((vipm_rank_t, vipm_int [], vipm_int));
__PUB vipm_int     *vipm_vec_(dup)          __P((vipm_rank_t, vipm_int [], vipm_int));

__PUB vipm_int     *vipm_vec_(zero,LS)      __P((vipm_rank_t, vipm_int []));
__PUB vipm_int     *vipm_vec_(zero,L)       __P((vipm_rank_t, vipm_int []));
__PUB vipm_int     *vipm_vec_(zero,S)       __P((vipm_rank_t, vipm_int []));
__PUB vipm_int     *vipm_vec_(zero)         __P((vipm_rank_t, vipm_int []));


__PUB vipm_int     *vipm_vec_(_assign)      __P((vipm_int, vipm_int [], vipm_int const []));
__PUB vipm_int     *vipm_vec_(_dup)         __P((vipm_int, vipm_int [], vipm_int));
__PUB vipm_int     *vipm_vec_(_zero)        __P((vipm_int, vipm_int []));


/*
 * retval:bool = 1, if (x[i] > 0), for each i = [0,rank[ ; 0 - otherwise
 */
__PUB int           vipm_vec_(assign,Z)     __P((vipm_rank_t, vipm_int [], vipm_int const []));
__PUB int           vipm_vec_(_assign,Z)    __P((vipm_int,    vipm_int [], vipm_int const []));

/* ------------------------------------------------------------------------- */

/*
 * vipm_int   vipm_vec_(mkloff{LS}) (aRank, aVector = nil, aStride);
 * vipm_int   vipm_vec_(mkloff)     (aRank, aVector,       aStride);
 * vipm_int  *vipm_vec_(fromloff)   (aRank, aVector, aStride, aLinearOffset);
 * vipm_int  *vipm_vec_(update,loff)(aRank, aVector, aStride, aLinearOffset);
 */

__PUB vipm_int      vipm_vec_(mkloff,LS)    __P((vipm_rank_t, vipm_int const [], vipm_int const []));
__PUB vipm_int      vipm_vec_(mkloff,L)     __P((vipm_rank_t, vipm_int const [], vipm_int const []));
__PUB vipm_int      vipm_vec_(mkloff)       __P((vipm_rank_t, vipm_int const [], vipm_int const []));

__PUB vipm_int     *vipm_vec_(fromloff)     __P((vipm_rank_t, vipm_int [], vipm_int const [], vipm_int));
__PUB vipm_int     *vipm_vec_(update,loff)  __P((vipm_rank_t, vipm_int [], vipm_int const [], vipm_int));

/* ------------------------------------------------------------------------- */

/* 3rd(2nd) operational argument ('Addend') can be nil */
__PUB vipm_int     *vipm_vec_(add,S)    __P((vipm_rank_t, vipm_int [], vipm_int const [], vipm_int const []));
__PUB vipm_int     *vipm_vec_(add,IS)   __P((vipm_rank_t, vipm_int [], vipm_int const []));
__PUB vipm_int     *vipm_vec_(sub,S)    __P((vipm_rank_t, vipm_int [], vipm_int const [], vipm_int const []));
__PUB vipm_int     *vipm_vec_(sub,IS)   __P((vipm_rank_t, vipm_int [], vipm_int const []));
__PUB vipm_int     *vipm_vec_(rsb,S)    __P((vipm_rank_t, vipm_int [], vipm_int const [], vipm_int const []));
__PUB vipm_int     *vipm_vec_(rsb,IS)   __P((vipm_rank_t, vipm_int [], vipm_int const []));

__PUB vipm_int     *vipm_vec_(add)      __P((vipm_rank_t, vipm_int [], vipm_int const [], vipm_int const []));
__PUB vipm_int     *vipm_vec_(add,I)    __P((vipm_rank_t, vipm_int [], vipm_int const []));
__PUB vipm_int     *vipm_vec_(sub)      __P((vipm_rank_t, vipm_int [], vipm_int const [], vipm_int const []));
__PUB vipm_int     *vipm_vec_(sub,I)    __P((vipm_rank_t, vipm_int [], vipm_int const []));
__PUB vipm_int     *vipm_vec_(rsb)      __P((vipm_rank_t, vipm_int [], vipm_int const [], vipm_int const []));
__PUB vipm_int     *vipm_vec_(rsb,I)    __P((vipm_rank_t, vipm_int [], vipm_int const []));

__PUB vipm_int     *vipm_vec_(add,C)    __P((vipm_rank_t, vipm_int [], vipm_int const [], vipm_int));
__PUB vipm_int     *vipm_vec_(add,C,I)  __P((vipm_rank_t, vipm_int [], vipm_int));
__PUB vipm_int     *vipm_vec_(sub,C)    __P((vipm_rank_t, vipm_int [], vipm_int const [], vipm_int));
__PUB vipm_int     *vipm_vec_(sub,C,I)  __P((vipm_rank_t, vipm_int [], vipm_int));
__PUB vipm_int     *vipm_vec_(rsb,C)    __P((vipm_rank_t, vipm_int [], vipm_int const [], vipm_int));
__PUB vipm_int     *vipm_vec_(rsb,C,I)  __P((vipm_rank_t, vipm_int [], vipm_int));

__PUB vipm_int     *vipm_vec_(neg)      __P((vipm_rank_t, vipm_int [], vipm_int const []));
__PUB vipm_int     *vipm_vec_(neg,I)    __P((vipm_rank_t, vipm_int []));

__PUB vipm_int     *vipm_vec_(min)      __P((vipm_rank_t, vipm_int [], vipm_int const [], vipm_int const []));
__PUB vipm_int     *vipm_vec_(min,I)    __P((vipm_rank_t, vipm_int [], vipm_int const []));
__PUB vipm_int     *vipm_vec_(max)      __P((vipm_rank_t, vipm_int [], vipm_int const [], vipm_int const []));
__PUB vipm_int     *vipm_vec_(max,I)    __P((vipm_rank_t, vipm_int [], vipm_int const []));

__PUB int           vipm_vec_(equal)    __P((vipm_rank_t, vipm_int const [], vipm_int const []));
__PUB int           vipm_vec_(equal0)   __P((vipm_rank_t, vipm_int const []));

/* ------------------------------------------------------------------------- */

/* 3rd(2nd) operational argument ('Addend') can be nil */
__PUB vipm_int     *vipm_vec_(_add,S)   __P((vipm_int, vipm_int [], vipm_int const [], vipm_int const []));
__PUB vipm_int     *vipm_vec_(_add,IS)  __P((vipm_int, vipm_int [], vipm_int const []));
__PUB vipm_int     *vipm_vec_(_sub,S)   __P((vipm_int, vipm_int [], vipm_int const [], vipm_int const []));
__PUB vipm_int     *vipm_vec_(_sub,IS)  __P((vipm_int, vipm_int [], vipm_int const []));
__PUB vipm_int     *vipm_vec_(_rsb,S)   __P((vipm_int, vipm_int [], vipm_int const [], vipm_int const []));
__PUB vipm_int     *vipm_vec_(_rsb,IS)  __P((vipm_int, vipm_int [], vipm_int const []));

__PUB vipm_int     *vipm_vec_(_add)     __P((vipm_int, vipm_int [], vipm_int const [], vipm_int const []));
__PUB vipm_int     *vipm_vec_(_add,I)   __P((vipm_int, vipm_int [], vipm_int const []));
__PUB vipm_int     *vipm_vec_(_sub)     __P((vipm_int, vipm_int [], vipm_int const [], vipm_int const []));
__PUB vipm_int     *vipm_vec_(_sub,I)   __P((vipm_int, vipm_int [], vipm_int const []));
__PUB vipm_int     *vipm_vec_(_rsb)     __P((vipm_int, vipm_int [], vipm_int const [], vipm_int const []));
__PUB vipm_int     *vipm_vec_(_rsb,I)   __P((vipm_int, vipm_int [], vipm_int const []));

__PUB vipm_int     *vipm_vec_(_add,C)   __P((vipm_int, vipm_int [], vipm_int const [], vipm_int));
__PUB vipm_int     *vipm_vec_(_add,C,I) __P((vipm_int, vipm_int [], vipm_int));
__PUB vipm_int     *vipm_vec_(_sub,C)   __P((vipm_int, vipm_int [], vipm_int const [], vipm_int));
__PUB vipm_int     *vipm_vec_(_sub,C,I) __P((vipm_int, vipm_int [], vipm_int));
__PUB vipm_int     *vipm_vec_(_rsb,C)   __P((vipm_int, vipm_int [], vipm_int const [], vipm_int));
__PUB vipm_int     *vipm_vec_(_rsb,C,I) __P((vipm_int, vipm_int [], vipm_int));

__PUB vipm_int     *vipm_vec_(_neg)     __P((vipm_int, vipm_int [], vipm_int const []));
__PUB vipm_int     *vipm_vec_(_neg,I)   __P((vipm_int, vipm_int []));

__PUB vipm_int     *vipm_vec_(_min)     __P((vipm_int, vipm_int [], vipm_int const [], vipm_int const []));
__PUB vipm_int     *vipm_vec_(_min,I)   __P((vipm_int, vipm_int [], vipm_int const []));
__PUB vipm_int     *vipm_vec_(_max)     __P((vipm_int, vipm_int [], vipm_int const [], vipm_int const []));
__PUB vipm_int     *vipm_vec_(_max,I)   __P((vipm_int, vipm_int [], vipm_int const []));

__PUB int           vipm_vec_(_equal)   __P((vipm_int, vipm_int const [], vipm_int const []));
__PUB int           vipm_vec_(_equal0)  __P((vipm_int, vipm_int const []));


/* ========================================================================= */

__PUB int           vipm_volume_(empty)         __P((vipm_rank_t, vipm_int const []));
__PUB vipm_int      vipm_volume_(capacity)      __P((vipm_rank_t, vipm_int const []));
__PUB vipm_int      vipm_volume_(capacity,Q)    __P((vipm_rank_t, vipm_int const []));

__PUB vipm_int      vipm_volume_(height)        __P((vipm_rank_t, vipm_int const []));
__PUB vipm_int      vipm_volume_(width)         __P((vipm_rank_t, vipm_int const []));
__PUB vipm_int      vipm_volume_(nchannels)     __P((vipm_rank_t, vipm_int const []));
__PUB vipm_int      vipm_volume_(pixcap)        __P((vipm_rank_t, vipm_int const []));
__PUB vipm_int      vipm_volume_(pixcap,Q)      __P((vipm_rank_t, vipm_int const []));

/* ------------------------------------------------------------------------- */

__PUB int           vipm_volume_(_empty)        __P((vipm_int, vipm_int const []));
__PUB vipm_int      vipm_volume_(_capacity)     __P((vipm_int, vipm_int const []));
__PUB vipm_int      vipm_volume_(_capacity,Q)   __P((vipm_int, vipm_int const []));

__PUB vipm_int      vipm_volume_(_height)       __P((vipm_int, vipm_int const []));
__PUB vipm_int      vipm_volume_(_width)        __P((vipm_int, vipm_int const []));
__PUB vipm_int      vipm_volume_(_nchannels)    __P((vipm_int, vipm_int const []));
__PUB vipm_int      vipm_volume_(_pixcap)       __P((vipm_int, vipm_int const []));
__PUB vipm_int      vipm_volume_(_pixcap,Q)     __P((vipm_int, vipm_int const []));


/* ========================================================================= */

/*
 * retval:bool = 1, if non-empty, 0 - otherwise
 *
 * int   vipm_intersecS  (aRank, aStartDst = 0, aVolumeDst, aStartSrc1 = 0, aVolumeSrc1 = 0, aStartSrc2 = 0, aVolumeSrc2);
 * int   vipm_intersec   (aRank, aStartDst,     aVolumeDst, aStartSrc1 = 0, aVolumeSrc1 = 0, aStartSrc2,     aVolumeSrc2);
 * int   vipm_intersecIS (aRank, aStartDst = 0, aVolumeDst, aStartSrc2 = 0, aVolumeSrc2);
 * int   vipm_intersecI  (aRank, aStartDst,     aVolumeDst, aStartSrc2,     aVolumeSrc2);
 *
 * int   vipm__intersec  (aRank, aStartDst,     aVolumeDst, aStartSrc1 = 0, aVolumeSrc1 = 0, aStartSrc2,     aVolumeSrc2);
 * int   vipm__intersecI (aRank, aStartDst,     aVolumeDst, aStartSrc2,     aVolumeSrc2);
 *
 */

__PUB int   vipm_intersecS  __P((vipm_rank_t, vipm_int [], vipm_int [], vipm_int const [], vipm_int const [], vipm_int const [], vipm_int const []));
__PUB int   vipm_intersec   __P((vipm_rank_t, vipm_int [], vipm_int [], vipm_int const [], vipm_int const [], vipm_int const [], vipm_int const []));
__PUB int   vipm_intersecIS __P((vipm_rank_t, vipm_int [], vipm_int [], vipm_int const [], vipm_int const []));
__PUB int   vipm_intersecI  __P((vipm_rank_t, vipm_int [], vipm_int [], vipm_int const [], vipm_int const []));

/* ------------------------------------------------------------------------- */

__PUB int   vipm__intersec  __P((vipm_int, vipm_int [], vipm_int [], vipm_int const [], vipm_int const [], vipm_int const [], vipm_int const []));
__PUB int   vipm__intersecI __P((vipm_int, vipm_int [], vipm_int [], vipm_int const [], vipm_int const []));


/* ========================================================================= */

__PUB vipm_int      vipm_elstride       __P((vipm_rank_t, vipm_int const []));
__PUB vipm_int      vipm_pixstride      __P((vipm_rank_t, vipm_int const []));
__PUB vipm_int      vipm_rowstride      __P((vipm_rank_t, vipm_int const []));
__PUB vipm_int      vipm_rowstride2     __P((vipm_rank_t, vipm_int const [], vipm_int const []));

__PUB vipm_int      vipm_elpadding      __P((vipm_rank_t, vipm_int const [], vipm_int const []));
__PUB vipm_int      vipm_pixpadding     __P((vipm_rank_t, vipm_int const [], vipm_int const []));
__PUB vipm_int      vipm_rowpadding     __P((vipm_rank_t, vipm_int const [], vipm_int const []));

/* ------------------------------------------------------------------------- */

__PUB vipm_int      vipm__elstride      __P((vipm_int, vipm_int const []));
__PUB vipm_int      vipm__pixstride     __P((vipm_int, vipm_int const []));
__PUB vipm_int      vipm__rowstride     __P((vipm_int, vipm_int const []));
__PUB vipm_int      vipm__rowstride2    __P((vipm_int, vipm_int const [], vipm_int const []));

__PUB vipm_int      vipm__elpadding     __P((vipm_int, vipm_int const [], vipm_int const []));
__PUB vipm_int      vipm__pixpadding    __P((vipm_int, vipm_int const [], vipm_int const []));
__PUB vipm_int      vipm__rowpadding    __P((vipm_int, vipm_int const [], vipm_int const []));


/* ========================================================================= */

/*
 * vipm_mutptr_t vipm_base_(advance,{S}) (aBase, anExtraOffset = 0, aRank, aVector = nil, aStride);
 * vipm_mutptr_t vipm_base_(advance)     (aBase, anExtraOffset = 0, aRank, aVector,       aStride);
 * vipm_mutptr_t vipm_base_(at,2d)       (aBase, anExtraOffset = 0, Y,X, aStride);
 * vipm_mutptr_t vipm_base_(at,2d$pt,{S})(aBase, anExtraOffset = 0, (aPoint|aRoi) = nil, ...);
 */

__PUB vipm_mutptr_t vipm_advance_ptr        __P((vipm_imuptr_t, vipm_int));

__PUB vipm_mutptr_t vipm_base_(advance,LS)  __P((vipm_imuptr_t, vipm_int, vipm_rank_t, vipm_int const [], vipm_int const []));
__PUB vipm_mutptr_t vipm_base_(advance,L)   __P((vipm_imuptr_t, vipm_int, vipm_rank_t, vipm_int const [], vipm_int const []));
__PUB vipm_mutptr_t vipm_base_(advance)     __P((vipm_imuptr_t, vipm_int, vipm_rank_t, vipm_int const [], vipm_int const []));

__PUB vipm_mutptr_t vipm_base_(at,2d)       __P((vipm_imuptr_t, vipm_int, vipm_int, vipm_int , vipm_int const [/*2*/]));
__PUB vipm_mutptr_t vipm_base_(at,2d$pt,S)  __P((vipm_imuptr_t, vipm_int, vipm_2d_point_t const *, vipm_int const [/*2*/]));
__PUB vipm_mutptr_t vipm_base_(at,2d$pt)    __P((vipm_imuptr_t, vipm_int, vipm_2d_point_t const *, vipm_int const [/*2*/]));
__PUB vipm_mutptr_t vipm_base_(at,2d$roi,S) __P((vipm_imuptr_t, vipm_int, vipm_2d_rect_t const *, vipm_int const [/*2*/]));
__PUB vipm_mutptr_t vipm_base_(at,2d$roi)   __P((vipm_imuptr_t, vipm_int, vipm_2d_rect_t const *, vipm_int const [/*2*/]));


/* ========================================================================= */

/*
 * @note:
 *     volume: ([nplanes,]      height,     width,      ...)
 *     stride: ([plane-stride,] row-stride, pix-stride, ...)
 *
 * 1. (stride(i) = 0) --> ( stride(i) := volume(i + 1) * stride(i + 1) );
 * 2. (stride(i) < 0) --> ( stride(i) := align(volume(i + 1) * stride(i + 1), -stride(i)) ),
 *     stride[i] = { -2, -4, -8, -16, -32, ... }
 *
 * Sample. 2D space - (height, width)
 *     rank:2
 *     volume:(7,19)
 *     stride:(0,2)   --> stride:(38,2)
 *     stride:(-16,2) --> stride:(48,2)
 */

/*
 * bo_size_t  vipm_vmemsize{L} (aRank, aVector != nil, aStride{mutable} != nil, anExtraSize <- {0,1,2});
 */

__PUB bo_size_t     vipm_vmemsizeL      __P((vipm_rank_t, vipm_int const [], vipm_int [], vipm_int));
__PUB bo_size_t     vipm_vmemsize       __P((vipm_rank_t, vipm_int const [], vipm_int [], vipm_int));


__PUB bo_size_t     vipm__vmemsize0     __P((vipm_int const [], vipm_int const [], vipm_int));


/* ------------------------------------------------------------------------- */

/*
 * int vipm_xoverlappedLS (aBaseLhs, OffsetLhs, aRankLhs, aStartLhs, aVolumeLhs, aStrideLhs != nil,
 *                         aBaseRhs, OffsetRhs, aRankRhs, aStartRhs, aVolumeRhs, aStrideRhs != nil);
 * int vipm_overlappedLS  (aRank, aVolume,
 *                         aBaseLhs, aStartLhs, aStrideLhs != nil,
 *                         aBaseRhs, aStartRhs, aStrideRhs != nil);
 *
 * int vipm__overlapped   (aRank, aVolume, aBaseLhs, aStrideLhs, aBaseRhs, aStrideRhs);
 */

__PUB int   vipm_xoverlappedLS  __P((vipm_imuptr_t, vipm_int, vipm_rank_t,
                                       vipm_int const [], vipm_int const [], vipm_int const [],
                                       vipm_imuptr_t, vipm_int, vipm_rank_t,
                                       vipm_int const [], vipm_int const [], vipm_int const []));
__PUB int   vipm_overlappedLS   __P((vipm_rank_t, vipm_int const [],
                                       vipm_imuptr_t, vipm_int const [], vipm_int const [],
                                       vipm_imuptr_t, vipm_int const [], vipm_int const []));


__PUB int   vipm__overlapped    __P((vipm_int, vipm_int const [], vipm_imuptr_t, vipm_int const [],
                                     vipm_imuptr_t, vipm_int const []));


/* +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ */

# define vipm_overlappedLS(aRank,aVolume,aBaseLhs,aStartLhs,aStrideLhs,aBaseRhs,aStartRhs,aStrideRhs) \
	vipm_xoverlappedLS(aBaseLhs,0,aRank,aStartLhs,aVolume,aStrideLhs, aBaseRhs,0,aRank,aStartRhs,aVolume,aStrideRhs)


/* ========================================================================= */

_VIPM_INLINE vipm_int *
vipm_vec_(dup)(vipm_rank_t aRank, vipm_int aDest[], vipm_int aSource)
{
	return vipm_vec_(_dup)(VIPM_ERANK(aRank), aDest, aSource);
}

_VIPM_INLINE vipm_int *
vipm_vec_(dup,S)(vipm_rank_t aRank, vipm_int aDest[], vipm_int aSource)
{
	return (NULL != aDest ? vipm_vec_(dup)(aRank, aDest, aSource) : aDest);
}


_VIPM_INLINE vipm_int *
vipm_vec_(dup,L)(vipm_rank_t aRank, vipm_int aDest[], vipm_int aSource)
{
	return vipm_vec_(_dup)(VIPM_ERANK(aRank) + VIPM_RRANK(aRank), aDest - VIPM_RRANK(aRank), aSource);
}

_VIPM_INLINE vipm_int *
vipm_vec_(dup,LS)(vipm_rank_t aRank, vipm_int aDest[], vipm_int aSource)
{
	return (NULL != aDest ? vipm_vec_(dup,L)(aRank, aDest, aSource) : aDest);
}

/* ------------------------------------------------------------------------- */

_VIPM_INLINE vipm_int *vipm_vec_(_zero)(vipm_int aRank, vipm_int aDest[])
{
	return vipm_vec_(_dup)(aRank, aDest, 0);
}


_VIPM_INLINE vipm_int *vipm_vec_(zero)(vipm_rank_t aRank, vipm_int aDest[])
{
	return vipm_vec_(dup)(aRank, aDest, 0);
}

_VIPM_INLINE vipm_int *vipm_vec_(zero,S)(vipm_rank_t aRank, vipm_int aDest[])
{
	return vipm_vec_(dup,S)(aRank, aDest, 0);
}

_VIPM_INLINE vipm_int *vipm_vec_(zero,L)(vipm_rank_t aRank, vipm_int aDest[])
{
	return vipm_vec_(dup,L)(aRank, aDest, 0);
}

_VIPM_INLINE vipm_int *vipm_vec_(zero,LS)(vipm_rank_t aRank, vipm_int aDest[])
{
	return vipm_vec_(dup,LS)(aRank, aDest, 0);
}

/* ------------------------------------------------------------------------- */

_VIPM_INLINE vipm_int *
vipm_vec_(assign)(vipm_rank_t aRank, vipm_int aDest[], vipm_int const aSource[])
{
	return vipm_vec_(_assign)(VIPM_ERANK(aRank), aDest, aSource);
}

_VIPM_INLINE vipm_int *
vipm_vec_(assign,S)(vipm_rank_t aRank, vipm_int aDest[], vipm_int const aSource[])
{
	return (NULL == aDest ? aDest
	    : NULL != aSource ? vipm_vec_(assign)(aRank, aDest, aSource)
	                      : vipm_vec_(dup)(aRank, aDest, 0));
}

_VIPM_INLINE vipm_int *
vipm_vec_(assign,L)(vipm_rank_t aRank, vipm_int aDest[], vipm_int const aSource[])
{
	vipm_int rrank = VIPM_RRANK(aRank);
	return vipm_vec_(_assign)(VIPM_ERANK(aRank) + rrank, aDest - rrank, aSource - rrank);
}

_VIPM_INLINE vipm_int *
vipm_vec_(assign,LS)(vipm_rank_t aRank, vipm_int aDest[], vipm_int const aSource[])
{
	return (NULL == aDest ? aDest
	    : NULL != aSource ? vipm_vec_(assign,L)(aRank, aDest, aSource)
	                      : vipm_vec_(dup,L)(aRank, aDest, 0));
}


_VIPM_INLINE int
vipm_vec_(assign,Z)(vipm_rank_t aRank, vipm_int aDest[], vipm_int const aSource[])
{
	return vipm_vec_(_assign,Z)(VIPM_ERANK(aRank), aDest, aSource);
}


/* ------------------------------------------------------------------------- */

_VIPM_INLINE vipm_int *
vipm_vec_(neg,I)(vipm_rank_t aRank, vipm_int aDest[])
{
	return vipm_vec_(_neg,I)(VIPM_ERANK(aRank), aDest);
}

_VIPM_INLINE vipm_int *
vipm_vec_(neg)(vipm_rank_t aRank, vipm_int aDest[], vipm_int const aSource[])
{
	return vipm_vec_(_neg)(VIPM_ERANK(aRank), aDest, aSource);
}

/* ------------------------------------------------------------------------- */

_VIPM_INLINE vipm_int *
vipm_vec_(_add,IS)(vipm_int aRank, vipm_int aResult[], vipm_int const Addend[])
{
	return (NULL != Addend ? vipm_vec_(_add,I)(aRank, aResult, Addend) : aResult);
}

_VIPM_INLINE vipm_int *
vipm_vec_(_add,S)(vipm_int aRank, vipm_int aResult[], vipm_int const Augend[], vipm_int const Addend[])
{
	return (NULL != Addend ? vipm_vec_(_add)(aRank, aResult, Augend, Addend)
	                       : vipm_vec_(_assign)(aRank, aResult, Augend));
}


_VIPM_INLINE vipm_int *
vipm_vec_(_sub,IS)(vipm_int aRank, vipm_int aResult[], vipm_int const Addend[])
{
	return (NULL != Addend ? vipm_vec_(_sub,I)(aRank, aResult, Addend) : aResult);
}

_VIPM_INLINE vipm_int *
vipm_vec_(_sub,S)(vipm_int aRank, vipm_int aResult[], vipm_int const Augend[], vipm_int const Addend[])
{
	return (NULL != Addend ? vipm_vec_(_sub)(aRank, aResult, Augend, Addend)
	                       : vipm_vec_(_assign)(aRank, aResult, Augend));
}


_VIPM_INLINE vipm_int *
vipm_vec_(_rsb,IS)(vipm_int aRank, vipm_int aResult[], vipm_int const Addend[])
{
	return (NULL != Addend ? vipm_vec_(_rsb,I)(aRank, aResult, Addend)
	                       : vipm_vec_(_neg,I)(aRank, aResult));
}

_VIPM_INLINE vipm_int *
vipm_vec_(_rsb,S)(vipm_int aRank, vipm_int aResult[], vipm_int const Augend[], vipm_int const Addend[])
{
	return (NULL != Addend ? vipm_vec_(_rsb)(aRank, aResult, Augend, Addend)
	                       : vipm_vec_(_neg)(aRank, aResult, Augend));
}

/* ------------------------------------------------------------------------- */

_VIPM_INLINE vipm_int *
vipm_vec_(add,I)(vipm_rank_t aRank, vipm_int aResult[], vipm_int const Addend[])
{
	return vipm_vec_(_add,I)(VIPM_ERANK(aRank), aResult, Addend);
}

_VIPM_INLINE vipm_int *
vipm_vec_(add,IS)(vipm_rank_t aRank, vipm_int aResult[], vipm_int const Addend[])
{
	return vipm_vec_(_add,IS)(VIPM_ERANK(aRank), aResult, Addend);
}

_VIPM_INLINE vipm_int *
vipm_vec_(add)(vipm_rank_t aRank, vipm_int aResult[], vipm_int const Augend[], vipm_int const Addend[])
{
	return vipm_vec_(_add)(VIPM_ERANK(aRank), aResult, Augend, Addend);
}

_VIPM_INLINE vipm_int *
vipm_vec_(add,S)(vipm_rank_t aRank, vipm_int aResult[], vipm_int const Augend[], vipm_int const Addend[])
{
	return vipm_vec_(_add,S)(VIPM_ERANK(aRank), aResult, Augend, Addend);
}


_VIPM_INLINE vipm_int *
vipm_vec_(sub,I)(vipm_rank_t aRank, vipm_int aResult[], vipm_int const Addend[])
{
	return vipm_vec_(_sub,I)(VIPM_ERANK(aRank), aResult, Addend);
}

_VIPM_INLINE vipm_int *
vipm_vec_(sub,IS)(vipm_rank_t aRank, vipm_int aResult[], vipm_int const Addend[])
{
	return vipm_vec_(_sub,IS)(VIPM_ERANK(aRank), aResult, Addend);
}

_VIPM_INLINE vipm_int *
vipm_vec_(sub)(vipm_rank_t aRank, vipm_int aResult[], vipm_int const Augend[], vipm_int const Addend[])
{
	return vipm_vec_(_sub)(VIPM_ERANK(aRank), aResult, Augend, Addend);
}

_VIPM_INLINE vipm_int *
vipm_vec_(sub,S)(vipm_rank_t aRank, vipm_int aResult[], vipm_int const Augend[], vipm_int const Addend[])
{
	return vipm_vec_(_sub,S)(VIPM_ERANK(aRank), aResult, Augend, Addend);
}


_VIPM_INLINE vipm_int *
vipm_vec_(rsb,I)(vipm_rank_t aRank, vipm_int aResult[], vipm_int const Addend[])
{
	return vipm_vec_(_rsb,I)(VIPM_ERANK(aRank), aResult, Addend);
}

_VIPM_INLINE vipm_int *
vipm_vec_(rsb,IS)(vipm_rank_t aRank, vipm_int aResult[], vipm_int const Addend[])
{
	return vipm_vec_(_rsb,IS)(VIPM_ERANK(aRank), aResult, Addend);
}

_VIPM_INLINE vipm_int *
vipm_vec_(rsb)(vipm_rank_t aRank, vipm_int aResult[], vipm_int const Augend[], vipm_int const Addend[])
{
	return vipm_vec_(_rsb)(VIPM_ERANK(aRank), aResult, Augend, Addend);
}

_VIPM_INLINE vipm_int *
vipm_vec_(rsb,S)(vipm_rank_t aRank, vipm_int aResult[], vipm_int const Augend[], vipm_int const Addend[])
{
	return vipm_vec_(_rsb,S)(VIPM_ERANK(aRank), aResult, Augend, Addend);
}

/* ------------------------------------------------------------------------- */

_VIPM_INLINE vipm_int *
vipm_vec_(add,C,I)(vipm_rank_t aRank, vipm_int aResult[], vipm_int Addend)
{
	return vipm_vec_(_add,C,I)(VIPM_ERANK(aRank), aResult, Addend);
}

_VIPM_INLINE vipm_int *
vipm_vec_(add,C)(vipm_rank_t aRank, vipm_int aResult[], vipm_int const Augend[], vipm_int Addend)
{
	return vipm_vec_(_add,C)(VIPM_ERANK(aRank), aResult, Augend, Addend);
}


_VIPM_INLINE vipm_int *
vipm_vec_(sub,C,I)(vipm_rank_t aRank, vipm_int aResult[], vipm_int Addend)
{
	return vipm_vec_(_sub,C,I)(VIPM_ERANK(aRank), aResult, Addend);
}

_VIPM_INLINE vipm_int *
vipm_vec_(sub,C)(vipm_rank_t aRank, vipm_int aResult[], vipm_int const Augend[], vipm_int Addend)
{
	return vipm_vec_(_sub,C)(VIPM_ERANK(aRank), aResult, Augend, Addend);
}


_VIPM_INLINE vipm_int *
vipm_vec_(rsb,C,I)(vipm_rank_t aRank, vipm_int aResult[], vipm_int Addend)
{
	return vipm_vec_(_rsb,C,I)(VIPM_ERANK(aRank), aResult, Addend);
}

_VIPM_INLINE vipm_int *
vipm_vec_(rsb,C)(vipm_rank_t aRank, vipm_int aResult[], vipm_int const Augend[], vipm_int Addend)
{
	return vipm_vec_(_rsb,C)(VIPM_ERANK(aRank), aResult, Augend, Addend);
}

/* ------------------------------------------------------------------------- */

_VIPM_INLINE vipm_int *
vipm_vec_(min,I)(vipm_rank_t aRank, vipm_int aResult[], vipm_int const aSource2[])
{
	return vipm_vec_(_min,I)(VIPM_ERANK(aRank), aResult, aSource2);
}

_VIPM_INLINE vipm_int *
vipm_vec_(min)(vipm_rank_t aRank, vipm_int aResult[], vipm_int const aSource1[], vipm_int const aSource2[])
{
	return vipm_vec_(_min)(VIPM_ERANK(aRank), aResult, aSource1, aSource2);
}


_VIPM_INLINE vipm_int *
vipm_vec_(max,I)(vipm_rank_t aRank, vipm_int aResult[], vipm_int const aSource2[])
{
	return vipm_vec_(_max,I)(VIPM_ERANK(aRank), aResult, aSource2);
}

_VIPM_INLINE vipm_int *
vipm_vec_(max)(vipm_rank_t aRank, vipm_int aResult[], vipm_int const aSource1[], vipm_int const aSource2[])
{
	return vipm_vec_(_max)(VIPM_ERANK(aRank), aResult, aSource1, aSource2);
}

/* ------------------------------------------------------------------------- */

_VIPM_INLINE int
vipm_vec_(equal)(vipm_rank_t aRank, vipm_int const aLhs[], vipm_int const aRhs[])
{
	return vipm_vec_(_equal)(VIPM_ERANK(aRank), aLhs, aRhs);
}

_VIPM_INLINE int
vipm_vec_(equal0)(vipm_rank_t aRank, vipm_int const aLhs[])
{
	return vipm_vec_(_equal0)(VIPM_ERANK(aRank), aLhs);
}


/* ========================================================================= */

# define vipm_vol_h(r,v)                vipm_volume_(height)(r,v)
# define vipm_vol_w(r,v)                vipm_volume_(width)(r,v)
# define vipm_vol_cn(r,v)               vipm_volume_(nchannels)(r,v)

# define vipm_vol__h(r,v)               vipm_volume_(_height)(r,v)
# define vipm_vol__w(r,v)               vipm_volume_(_width)(r,v)
# define vipm_vol__cn(r,v)              vipm_volume_(_nchannels)(r,v)

/* ------------------------------------------------------------------------- */

_VIPM_INLINE vipm_int vipm_volume_(_height)(vipm_int aRank, vipm_int const aVolume[])
{
	return (3 <= aRank ? aVolume[aRank - 3] : 1);
}

_VIPM_INLINE vipm_int vipm_volume_(_width)(vipm_int aRank, vipm_int const aVolume[])
{
	return (aVolume[aRank - 2]);
}

_VIPM_INLINE vipm_int vipm_volume_(_nchannels)(vipm_int aRank, vipm_int const aVolume[])
{
	return VIPM_CHANNELC(aVolume[aRank - 1]);
}

/* ------------------------------------------------------------------------- */

_VIPM_INLINE vipm_int vipm_volume_(_pixcap)(vipm_int aRank, vipm_int const aVolume[])
{
	return vipm_volume_(_capacity)(aRank - 1, aVolume);
}

_VIPM_INLINE vipm_int vipm_volume_(_pixcap,Q)(vipm_int aRank, vipm_int const aVolume[])
{
	return vipm_volume_(_capacity,Q)(aRank - 1, aVolume);
}

/* ------------------------------------------------------------------------- */

_VIPM_INLINE vipm_int vipm_volume_(height)(vipm_int aRank, vipm_int const aVolume[])
{
	return vipm_volume_(_height)(VIPM_ERANK(aRank), aVolume);
}

_VIPM_INLINE vipm_int vipm_volume_(width)(vipm_int aRank, vipm_int const aVolume[])
{
	return vipm_volume_(_width)(VIPM_ERANK(aRank), aVolume);
}

_VIPM_INLINE vipm_int vipm_volume_(nchannels)(vipm_int aRank, vipm_int const aVolume[])
{
	return vipm_volume_(_nchannels)(VIPM_ERANK(aRank), aVolume);
}

/* ------------------------------------------------------------------------- */

_VIPM_INLINE int vipm_volume_(empty)(vipm_int aRank, vipm_int const aVolume[])
{
	return vipm_volume_(_empty)(VIPM_ERANK(aRank), aVolume);
}


_VIPM_INLINE vipm_int vipm_volume_(capacity)(vipm_int aRank, vipm_int const aVolume[])
{
	return vipm_volume_(_capacity)(VIPM_ERANK(aRank), aVolume);
}

_VIPM_INLINE vipm_int vipm_volume_(capacity,Q)(vipm_int aRank, vipm_int const aVolume[])
{
	return vipm_volume_(_capacity,Q)(VIPM_ERANK(aRank), aVolume);
}


_VIPM_INLINE vipm_int vipm_volume_(pixcap)(vipm_int aRank, vipm_int const aVolume[])
{
	return vipm_volume_(_pixcap)(VIPM_ERANK(aRank), aVolume);
}

_VIPM_INLINE vipm_int vipm_volume_(pixcap,Q)(vipm_int aRank, vipm_int const aVolume[])
{
	return vipm_volume_(_pixcap,Q)(VIPM_ERANK(aRank), aVolume);
}


/* ========================================================================= */

_VIPM_INLINE int
vipm_intersecI(vipm_rank_t aRank, vipm_int aStartDst[], vipm_int aVolumeDst[],
		vipm_int const aStartSrc2[], vipm_int const aVolumeSrc2[])
{
	return vipm__intersecI(VIPM_ERANK(aRank), aStartDst, aVolumeDst, aStartSrc2, aVolumeSrc2);
}

_VIPM_INLINE int
vipm_intersec(vipm_rank_t aRank, vipm_int aStartDst[], vipm_int aVolumeDst[],
		vipm_int const aStartSrc1[], vipm_int const aVolumeSrc1[],
		vipm_int const aStartSrc2[], vipm_int const aVolumeSrc2[])
{
	return vipm__intersec(VIPM_ERANK(aRank), aStartDst, aVolumeDst,
				aStartSrc1, aVolumeSrc1, aStartSrc2, aVolumeSrc2);
}


/* ========================================================================= */

_VIPM_INLINE vipm_mutptr_t
vipm_base_(advance,LS)(vipm_imuptr_t aBase, vipm_int anOffset,
		vipm_rank_t aRank, vipm_int const aVector[], vipm_int const aStride[])
{
	return vipm_advance_ptr(aBase, anOffset + vipm_vec_(mkloff,LS)(aRank, aVector, aStride));
}

_VIPM_INLINE vipm_mutptr_t
vipm_base_(advance,L)(vipm_imuptr_t aBase, vipm_int anOffset,
		vipm_rank_t aRank, vipm_int const aVector[], vipm_int const aStride[])
{
	return vipm_advance_ptr(aBase, anOffset + vipm_vec_(mkloff,L)(aRank, aVector, aStride));
}

_VIPM_INLINE vipm_mutptr_t
vipm_base_(advance)(vipm_imuptr_t aBase, vipm_int anOffset,
		vipm_rank_t aRank, vipm_int const aVector[], vipm_int const aStride[])
{
	return vipm_advance_ptr(aBase, anOffset + vipm_vec_(mkloff)(aRank, aVector, aStride));
}

/* ------------------------------------------------------------------------- */

_VIPM_INLINE vipm_mutptr_t
vipm_base_(at,2d$pt,S)(vipm_imuptr_t aBase, vipm_int anOffset,
		vipm_2d_point_t const *aPoint, vipm_int const aStride[])
{
	return vipm_base_(advance,LS)(aBase, anOffset, 2, (NULL != aPoint ? aPoint->__v : NULL), aStride);
}

_VIPM_INLINE vipm_mutptr_t
vipm_base_(at,2d$pt)(vipm_imuptr_t aBase, vipm_int anOffset,
		vipm_2d_point_t const *aPoint, vipm_int const aStride[])
{
	return vipm_base_(advance,L)(aBase, anOffset, 2, aPoint->__v, aStride);
}

/* ------------------------------------------------------------------------- */

_VIPM_INLINE vipm_mutptr_t
vipm_base_(at,2d$roi,S)(vipm_imuptr_t aBase, vipm_int anOffset,
		vipm_2d_rect_t const *aRoi, vipm_int const aStride[])
{
	return vipm_base_(advance,LS)(aBase, anOffset, 2, (NULL != aRoi ? aRoi->__v : NULL), aStride);
}

_VIPM_INLINE vipm_mutptr_t
vipm_base_(at,2d$roi)(vipm_imuptr_t aBase, vipm_int anOffset,
		vipm_2d_rect_t const *aRoi, vipm_int const aStride[])
{
	return vipm_base_(advance,L)(aBase, anOffset, 2, aRoi->__v, aStride);
}


/* ========================================================================= */

_VIPM_INLINE vipm_int vipm__elstride(vipm_int aRank, vipm_int const aStride[])
{
	return (aStride[aRank - 1]);
}

_VIPM_INLINE vipm_int vipm__pixstride(vipm_int aRank, vipm_int const aStride[])
{
	return (aStride[aRank - 2]);
}

_VIPM_INLINE vipm_int vipm__rowstride(vipm_int aRank, vipm_int const aStride[])
{
	return (3 <= aRank ? aStride[aRank - 3] : 0);
}

_VIPM_INLINE vipm_int vipm__rowstride2(vipm_int aRank, vipm_int const aVolume[], vipm_int const aStride[])
{
	return (3 <= aRank ? aStride[aRank - 3] : (vipm_vol__w(aRank, aVolume) * vipm__pixstride(aRank, aStride)));
}

/* ------------------------------------------------------------------------- */

_VIPM_INLINE vipm_int vipm__elpadding(vipm_int aRank, vipm_int const aVolume[], vipm_int const aStride[])
{
	/* @todo: fixme */
	(void)aRank;
	(void)aVolume;
	(void)aStride;
	return (0);
}

_VIPM_INLINE vipm_int vipm__pixpadding(vipm_int aRank, vipm_int const aVolume[], vipm_int const aStride[])
{
	return (vipm__pixstride(aRank, aStride) - vipm_vol__cn(aRank, aVolume) * vipm__elstride(aRank, aStride));
}

_VIPM_INLINE vipm_int vipm__rowpadding(vipm_int aRank, vipm_int const aVolume[], vipm_int const aStride[])
{
	return (vipm__rowstride(aRank, aStride) - vipm_vol__w(aRank, aVolume) * vipm__pixstride(aRank, aStride));
}

/* ------------------------------------------------------------------------- */

_VIPM_INLINE vipm_int vipm_elstride(vipm_rank_t aRank, vipm_int const aStride[])
{
	return vipm__elstride(VIPM_ERANK(aRank), aStride);
}

_VIPM_INLINE vipm_int vipm_pixstride(vipm_rank_t aRank, vipm_int const aStride[])
{
	return vipm__pixstride(VIPM_ERANK(aRank), aStride);
}

_VIPM_INLINE vipm_int vipm_rowstride(vipm_rank_t aRank, vipm_int const aStride[])
{
	return vipm__rowstride(VIPM_ERANK(aRank), aStride);
}

_VIPM_INLINE vipm_int vipm_rowstride2(vipm_int aRank, vipm_int const aVolume[], vipm_int const aStride[])
{
	return vipm__rowstride2(VIPM_ERANK(aRank), aVolume, aStride);
}

/* ------------------------------------------------------------------------- */

_VIPM_INLINE vipm_int vipm_elpadding(vipm_int aRank, vipm_int const aVolume[], vipm_int const aStride[])
{
	return vipm__elpadding(VIPM_ERANK(aRank), aVolume, aStride);
}

_VIPM_INLINE vipm_int vipm_pixpadding(vipm_int aRank, vipm_int const aVolume[], vipm_int const aStride[])
{
	return vipm__pixpadding(VIPM_ERANK(aRank), aVolume, aStride);
}

_VIPM_INLINE vipm_int vipm_rowpadding(vipm_int aRank, vipm_int const aVolume[], vipm_int const aStride[])
{
	return vipm__rowpadding(VIPM_ERANK(aRank), aVolume, aStride);
}


__MYC_END_CDECLS
# undef __PUB
# undef __VPUB


#endif /* !defined(__VIPM_MATH_UTILS_VECSPACEUTILS_H__) */


/******************************************************************************
 *
 *
 *
 *****************************************************************************/
