/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright 2016 Seenaptec Ltd. All rights reserved.
 * SEENAPTEC PROPRIETARY/CONFIDENTIAL.
 *
 * $Id$
 */

/*
 * Mmi_inl.arm64.h	(V.Sokur)
 * Vipm/Mmi_inl.arm64.h
 */

/******************************************************************************
 * %% BeginSection: function definitions
 */
# pragma mark -
# pragma mark [ function definitions ]
# pragma mark -

/*
 * Packing/Unpacking operations
 */

#if 0 /* @todo: fixme - implement */
_VIPM_INLINE bo_uint32_t vipmi_swiden88B(/* register */ bo_uint32_t x)
{
	__asm__ __volatile__ (
		"pkhbt  %[x], %[x], %[x],lsl #8  \n\t"
		"sxtb16 %[x], %[x]               \n\t"
		: [x] "+r"(x)
	);
	return (x);
# define vipmi_tm_swiden88B             vipmi_swiden88B
}

_VIPM_INLINE bo_uint32_t vipmi_swiden88T(/* register */ bo_uint32_t x)
{
	__asm__ __volatile__ (
		"lsr    %[x], %[x], #16          \n\t"
		"pkhbt  %[x], %[x], %[x],lsl #8  \n\t"
		"sxtb16 %[x], %[x]               \n\t"
		: [x] "+r"(x)
	);
	return (x);
# define vipmi_tm_swiden88T             vipmi_swiden88T
}

_VIPM_INLINE bo_uint32_t vipmi_swiden88TX(/* register */ bo_uint32_t x)
{
	__asm__ __volatile__ (
		"pkhtb  %[x], %[x], %[x],asr #24  \n\t"
		"sxtb16 %[x], %[x]                \n\t"
		: [x] "+r"(x)
	);
	return (x);
# define vipmi_tm_swiden88TX            vipmi_swiden88TX
}


_VIPM_INLINE bo_uint32_t vipmi_uwiden88B(/* register */ bo_uint32_t x)
{
	__asm__ __volatile__ (
		"pkhbt  %[x], %[x], %[x],lsl #8  \n\t"
		"uxtb16 %[x], %[x]               \n\t"
		: [x] "+r"(x)
	);
	return (x);
# define vipmi_tm_uwiden88B             vipmi_uwiden88B
}

_VIPM_INLINE bo_uint32_t vipmi_uwiden88T(/* register */ bo_uint32_t x)
{
	__asm__ __volatile__ (
		"lsr    %[x], %[x], #16 \n\t"
		"pkhbt  %[x], %[x], %[x],lsl #8  \n\t"
		"uxtb16 %[x], %[x]               \n\t"
		: [x] "+r"(x)
	);
	return (x);
# define vipmi_tm_uwiden88T             vipmi_uwiden8T8
}

_VIPM_INLINE bo_uint32_t vipmi_uwiden88TX(/* register */ bo_uint32_t x)
{
	__asm__ __volatile__ (
		"pkhtb  %[x], %[x], %[x],asr #24  \n\t"
		"uxtb16 %[x], %[x]                \n\t"
		: [x] "+r"(x)
	);
	return (x);
# define vipmi_tm_uwiden88TX            vipmi_uwiden88TX
}
#endif


/* ========================================================================= */

/*
 * Shift operations
 */

_VIPM_INLINE bo_uint32_t vipmi_rotl_32(bo_uint32_t aValue, bo_uint32_t aShift)
{
	__asm__ __volatile__ (
		"ror %w[val], %w[val], %w[sh] \n\t"
		: [val] "+r"(aValue)
		: [sh]  "r" (32 - aShift)
	);
	return (aValue);
# define vipmi_tm_rotl_32               vipmi_rotl_32
}

_VIPM_INLINE bo_uint32_t vipmi_rotr_32(bo_uint32_t aValue, bo_uint32_t aShift)
{
	__asm__ __volatile__ (
		"ror %w[val], %w[val], %w[sh] \n\t"
		: [val] "+r"(aValue)
		: [sh]  "r" (aShift)
	);
	return (aValue);
# define vipmi_tm_rotr_32               vipmi_rotr_32
}


/* ========================================================================= */

/*
 * Logical and Compare operations
 */

	/*
	 * Parallel Signed/Unsigned Min/Max select
	 */

#if 0 /* @todo: fixme - implement */
_VIPM_INLINE bo_uint32_t vipmi_smin8_32(bo_uint32_t aSrc1, bo_uint32_t aSrc2)
{
	bo_uint32_t rv;
	__asm__ __volatile__ (
		"ssub8 %[rv], %[s1], %[s2]  \n\t"
		"sel   %[rv], %[s2], %[s1]  \n\t"
		: [rv] "=&r"(rv)
		: [s1] "r"  (aSrc1),
		  [s2] "r"  (aSrc2)
	);
	return (rv);
# define vipmi_tm_smin8_32              vipmi_smin8_32
}

_VIPM_INLINE bo_uint32_t vipmi_smin16_32(bo_uint32_t aSrc1, bo_uint32_t aSrc2)
{
	bo_uint32_t rv;
	__asm__ __volatile__ (
		"ssub16 %[rv], %[s1], %[s2]  \n\t"
		"sel    %[rv], %[s2], %[s1]  \n\t"
		: [rv] "=&r"(rv)
		: [s1] "r"  (aSrc1),
		  [s2] "r"  (aSrc2)
	);
	return (rv);
# define vipmi_tm_smin16_32             vipmi_smin16_32
}

_VIPM_INLINE bo_uint32_t vipmi_smax8_32(bo_uint32_t aSrc1, bo_uint32_t aSrc2)
{
	bo_uint32_t rv;
	__asm__ __volatile__ (
		"ssub8 %[rv], %[s1], %[s2]  \n\t"
		"sel   %[rv], %[s1], %[s2]  \n\t"
		: [rv] "=&r"(rv)
		: [s1] "r"  (aSrc1),
		  [s2] "r"  (aSrc2)
	);
	return (rv);
# define vipmi_tm_smax8_32              vipmi_smax8_32
}

_VIPM_INLINE bo_uint32_t vipmi_smax16_32(bo_uint32_t aSrc1, bo_uint32_t aSrc2)
{
	bo_uint32_t rv;
	__asm__ __volatile__ (
		"ssub16 %[rv], %[s1], %[s2]  \n\t"
		"sel    %[rv], %[s1], %[s2]  \n\t"
		: [rv] "=&r"(rv)
		: [s1] "r"  (aSrc1),
		  [s2] "r"  (aSrc2)
	);
	return (rv);
# define vipmi_tm_smax16_32             vipmi_smax16_32
}


_VIPM_INLINE bo_uint32_t vipmi_umin8_32(bo_uint32_t aSrc1, bo_uint32_t aSrc2)
{
	bo_uint32_t rv;
	__asm__ __volatile__ (
		"usub8 %[rv], %[s1], %[s2]  \n\t"
		"sel   %[rv], %[s2], %[s1]  \n\t"
		: [rv] "=&r"(rv)
		: [s1] "r"  (aSrc1),
		  [s2] "r"  (aSrc2)
	);
	return (rv);
# define vipmi_tm_umin8_32              vipmi_umin8_32
}

_VIPM_INLINE bo_uint32_t vipmi_umin16_32(bo_uint32_t aSrc1, bo_uint32_t aSrc2)
{
	bo_uint32_t rv;
	__asm__ __volatile__ (
		"usub16 %[rv], %[s1], %[s2]  \n\t"
		"sel    %[rv], %[s2], %[s1]  \n\t"
		: [rv] "=&r"(rv)
		: [s1] "r"  (aSrc1),
		  [s2] "r"  (aSrc2)
	);
	return (rv);
# define vipmi_tm_umin16_32             vipmi_umin16_32
}

_VIPM_INLINE bo_uint32_t vipmi_umax8_32(bo_uint32_t aSrc1, bo_uint32_t aSrc2)
{
	bo_uint32_t rv;
	__asm__ __volatile__ (
		"usub8 %[rv], %[s1], %[s2]  \n\t"
		"sel   %[rv], %[s1], %[s2]  \n\t"
		: [rv] "=&r"(rv)
		: [s1] "r"  (aSrc1),
		  [s2] "r"  (aSrc2)
	);
	return (rv);
# define vipmi_tm_umax8_32              vipmi_umax8_32
}

_VIPM_INLINE bo_uint32_t vipmi_umax16_32(bo_uint32_t aSrc1, bo_uint32_t aSrc2)
{
	bo_uint32_t rv;
	__asm__ __volatile__ (
		"usub16 %[rv], %[s1], %[s2]  \n\t"
		"sel    %[rv], %[s1], %[s2]  \n\t"
		: [rv] "=&r"(rv)
		: [s1] "r"  (aSrc1),
		  [s2] "r"  (aSrc2)
	);
	return (rv);
# define vipmi_tm_umax16_32             vipmi_umax16_32
}


/* ========================================================================= */

/*
 * [Parallel] Add and Subtract operations
 */

_VIPM_INLINE bo_uint32_t vipmi_saddw88B(bo_uint32_t a, bo_uint32_t x)
{
	__asm__ __volatile__ (
		"pkhbt   %[x], %[x], %[x],lsl #8  \n\t"
		"sxtab16 %[a], %[a], %[x]         \n\t"
		: [a] "+r"(a), [x] "+r" (x)
		:
	);
	return (a);
# define vipmi_tm_saddw88B              vipmi_saddw88B
}

_VIPM_INLINE bo_uint32_t vipmi_saddw88T(bo_uint32_t a, bo_uint32_t x)
{
	__asm__ __volatile__ (
		"lsr     %[x], %[x], #16          \n\t"
		"pkhbt   %[x], %[x], %[x],lsl #8  \n\t"
		"sxtab16 %[a], %[a], %[x]         \n\t"
		: [a] "+r"(a), [x] "+r" (x)
		:
	);
	return (a);
# define vipmi_tm_saddw88T              vipmi_saddw88T
}

_VIPM_INLINE bo_uint32_t vipmi_saddw88TX(bo_uint32_t a, bo_uint32_t x)
{
	__asm__ __volatile__ (
		"pkhtb   %[x], %[x], %[x],asr #24  \n\t"
		"sxtab16 %[a], %[a], %[x]          \n\t"
		: [a] "+r"(a), [x] "+r" (x)
		:
	);
	return (a);
# define vipmi_tm_saddw88TX             vipmi_saddw88TX
}


_VIPM_INLINE bo_uint32_t vipmi_uaddw88B(bo_uint32_t a, bo_uint32_t x)
{
	__asm__ __volatile__ (
		"pkhbt   %[x], %[x], %[x],lsl #8  \n\t"
		"uxtab16 %[a], %[a], %[x]         \n\t"
		: [a] "+r"(a), [x] "+r" (x)
		:
	);
	return (a);
# define vipmi_tm_uaddw88B              vipmi_uaddw88B
}

_VIPM_INLINE bo_uint32_t vipmi_uaddw88T(bo_uint32_t a, bo_uint32_t x)
{
	__asm__ __volatile__ (
		"lsr     %[x], %[x], #16          \n\t"
		"pkhbt   %[x], %[x], %[x],lsl #8  \n\t"
		"uxtab16 %[a], %[a], %[x]         \n\t"
		: [a] "+r"(a), [x] "+r" (x)
		:
	);
	return (a);
# define vipmi_tm_uaddw88T              vipmi_uaddw88T
}

_VIPM_INLINE bo_uint32_t vipmi_uaddw88TX(bo_uint32_t a, bo_uint32_t x)
{
	__asm__ __volatile__ (
		"pkhtb   %[x], %[x], %[x],asr #24  \n\t"
		"uxtab16 %[a], %[a], %[x]          \n\t"
		: [a] "+r"(a), [x] "+r" (x)
		:
	);
	return (a);
# define vipmi_tm_uaddw88TX             vipmi_uaddw88TX
}

/* ------------------------------------------------------------------------- */

	/*
	 * Unsigned sum [and accumulate] of bytes
	 */

_VIPM_INLINE bo_uint32_t vipmi_usum8_32(bo_uint32_t x)
{
	__asm__ __volatile__ (
		"usad8 %[x], %[x], %[zero]  \n\t"
		: [x]    "+r"(x)
		: [zero] "r" (0)
	);
	return (x);
# define vipmi_tm_usum8_32              vipmi_usum8_32
}

_VIPM_INLINE bo_uint32_t vipmi_usuma8_32(bo_uint32_t a, bo_uint32_t x)
{
	__asm__ __volatile__ (
		"usada8 %[a], %[x], %[zero], %[a]   \n\t"
		: [a]    "+r"(a)
		: [x]    "r" (x),
		  [zero] "r" (0)
	);
	return (a);
# define vipmi_tm_usuma8_32             vipmi_usuma8_32
}

_VIPM_INLINE bo_uint32_t vipmi_usum16_32(bo_uint32_t x)
{
	bo_uint32_t rv;
	__asm__ __volatile__ (
		"uxth  %[rv], %[x]                 \n\t"
		"uxtah %[rv], %[rv], %[x],ror #16  \n\t"
		: [rv] "=&r"(rv)
		: [x]  "r"  (x)
	);
	return (rv);
# define vipmi_tm_usum16_32             vipmi_usum16_32
}

_VIPM_INLINE bo_uint32_t vipmi_usuma16_32(bo_uint32_t a, bo_uint32_t x)
{
	__asm__ __volatile__ (
		"uxtah %[a], %[a], %[x]            \n\t"
		"uxtah %[a], %[a], %[x],ror #16    \n\t"
		: [a] "+r"(a)
		: [x] "r" (x)
	);
	return (a);
# define vipmi_tm_usuma16_32            vipmi_usuma16_32
}
#endif


/* ========================================================================= */

/*
 * [Parallel] Multiply operations
 */

	/*
	 * Signed[/Unsigned] Multiply, Multiply-Accumulate, Multiply-Subtract
	 */

		/*
		 * 32-bit mla
		 */

_VIPM_INLINE bo_int32_t vipmi_smla_32(bo_int32_t a, bo_int32_t x, bo_int32_t y)
{
	__asm__ __volatile__ (
		"madd %w[a], %w[x], %w[y], %w[a]  \n\t"
		: [a] "+r"(a)
		: [x] "r" (x),
		  [y] "r" (y)
	);
	return (a);
# define vipmi_tm_smla_32               vipmi_smla_32
}

_VIPM_INLINE bo_int64_t vipmi_smlal_32(bo_int64_t a, bo_int32_t x, bo_int32_t y) /* @done */
{
	__asm__ __volatile__ (
		"smaddl %[a], %w[x], %w[y], %[a]    \n\t"
		: [a] "+r"(a)
		: [x] "r" (x), [y] "r" (y)
		: "cc"
	);
	return (a);
# define vipmi_tm_smlal_32              vipmi_smlal_32
}


		/*
		 * 32-bit mls
		 */

_VIPM_INLINE bo_int32_t vipmi_smls_32(bo_int32_t a, bo_int32_t x, bo_int32_t y)
{
	__asm__ __volatile__ (
		"msub %w[a], %w[x], %w[y], %w[a]  \n\t"
		: [a] "+r"(a)
		: [x] "r" (x),
		  [y] "r" (y)
	);
	return (a);
# define vipmi_tm_smls_32               vipmi_smls_32
}

/* ------------------------------------------------------------------------- */

		/*
		 * 32-bit float mla
		 */
#ifdef _AAS_VFMA
_VIPM_INLINE bo_float32_t vipmi_mla_f32(bo_float32_t a, bo_float32_t x, bo_float32_t y)
{
	__asm__ __volatile__ (
		_AAS_VFMA([a], [x], [y])
		: [a] "+w"(a)
		: [x] "w" (x),
		  [y] "w" (y)
	);
	return (a);
# define vipmi_tm_mla_f32               vipmi_mla_f32
}
#endif /* _AAS_VFMA */

		/*
		 * 32-bit float mls
		 */
#ifdef _AAS_VFMS
_VIPM_INLINE bo_float32_t vipmi_mls_f32(bo_float32_t a, bo_float32_t x, bo_float32_t y)
{
	__asm__ __volatile__ (
		_AAS_VFMS([a], [x], [y])
		: [a] "+w"(a)
		: [x] "w" (x),
		  [y] "w" (y)
	);
	return (a);
# define vipmi_tm_mls_f32               vipmi_mls_f32
}
#endif /* _AAS_VFMS */

/* ------------------------------------------------------------------------- */

		/*
		 * 64-bit float mla
		 */
#ifdef _AAS_VFMA64
_VIPM_INLINE bo_float64_t vipmi_mla_f64(bo_float64_t a, bo_float64_t x, bo_float64_t y)
{
	__asm__ __volatile__ (
		_AAS_VFMA64([a], [x], [y])
		: [a] "+w"(a)
		: [x] "w" (x),
		  [y] "w" (y)
	);
	return (a);
# define vipmi_tm_mla_f64               vipmi_mla_f64
}
#endif /* _AAS_VFMA64 */

		/*
		 * 64-bit float mls
		 */
#ifdef _AAS_VFMS64
_VIPM_INLINE bo_float64_t vipmi_mls_f64(bo_float64_t a, bo_float64_t x, bo_float64_t y)
{
	__asm__ __volatile__ (
		_AAS_VFMS64([a], [x], [y])
		: [a] "+w"(a)
		: [x] "w" (x),
		  [y] "w" (y)
	);
	return (a);
# define vipmi_tm_mls_f64               vipmi_mls_f64
}
#endif /* _AAS_VFMS64 */


/******************************************************************************
 *
 *
 *
 *****************************************************************************/
