/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright 2017 Seenaptec Ltd. All rights reserved.
 * SEENAPTEC PROPRIETARY/CONFIDENTIAL.
 *
 * $Id$
 */

/*
 * Morhop.h	(D.Vinnyk)
 * Vipm/Morphology/Morphop.h
 */

/* ------------------------------------------------------------------------- */

#ifndef __VIPM_MORPHOLOGY_MORPHOP_H__
# define __VIPM_MORPHOLOGY_MORPHOP_H__

/******************************************************************************
 * %% BeginSection: includes
 */

# ifndef __VIPM_MORPHOLOGY_MORPHOP_ALGORITHM_H__
#  include "Vipm/Morphology/Morphop/Algorithm.h"
# endif


/******************************************************************************
 * %% BeginSection: function prototypes
 */
# pragma mark -
# pragma mark [ function prototypes ]
# pragma mark -

# include <Vipm/Linkage.h>
# define __PUB __myc_flinkage__(public,libVipm)
# define __PRIV __myc_flinkage__(private,libVipm)
__MYC_BEGIN_CDECLS

/*
 * ROI samples:
 * 1) point : (nplanes:0,y,x,nchannels:0)
 *    volume: (nplanes:1,h,w,nchannels)
 */

__PUB bo_status_t
VipmMorphop(
# if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_mut_array_t                aDest,
	vipm_array_t                    aSource,
	vipm_site_t const              *aRoiDst,
	vipm_Npoint_t const            *aStartSrc,
	vipm_int                        aMorphOp,
	vipm_strel_t const             *aStrel
# endif
	);


__MYC_END_CDECLS
# undef __PUB
# undef __PRIV


#endif /* !defined(__VIPM_MORPHOLOGY_MORPHOP_H__) */


/******************************************************************************
 *
 *
 *
 *****************************************************************************/
