/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright 2017 Seenaptec Ltd. All rights reserved.
 * SEENAPTEC PROPRIETARY/CONFIDENTIAL.
 *
 * $Id$
 */

/*
 * Types.h	(D.Vinnyk)
 * Vipm/Morphology/Morphop/Types.h
 */

/* ------------------------------------------------------------------------- */

#ifndef __VIPM_MORPHOLOGY_MORPHOP_TYPES_H__
# define __VIPM_MORPHOLOGY_MORPHOP_TYPES_H__

/******************************************************************************
 * %% BeginSection: includes
 */

# ifndef __VIPM_TYPES_H__
#  include <Vipm/Types.h>
# endif


/******************************************************************************
 * %% BeginSection: types/constants
 */



/* ========================================================================= */

typedef bo_status_t (*vipma_morphop_fn)(
# if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_rank_t                     aRank,
	vipm_int const                  aVolume[],
	vipm_uint                       anElemTypeDst,
	vipm_mutptr_t                   aBaseDst, vipm_int const aStartDst[], vipm_int const aStrideDst[],
	vipm_imuptr_t                   aBaseSrc, vipm_int const aStartSrc[], vipm_int const aStrideSrc[],
	vipm_int                        aMorphOpMethod,
	vipm_strel_t const             *aStrel
# endif
	);

typedef bo_status_t (*vipma_emorphop_fn)(
# if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_rank_t                     aRank,
	vipm_int const                  aVolume[],
	vipm_uint                       anElemTypeDst,
	vipm_mutptr_t                   aBaseDst, vipm_int const aStartDst[], vipm_int const aStrideDst[],
	vipm_imuptr_t                   aBaseSrc, vipm_int const aStartSrc[], vipm_int const aStrideSrc[],
	vipm_int                        aMorphOpMethod,
	vipm_strel_t const             *aStrel,
	vipm_morphopts_t const         *aMorphOpts,
	vipm_arrshape_t const          *aWholeArrShapeSrc
# endif
	);


#endif /* !defined(__VIPM_MORPHOLOGY_MORPHOP_TYPES_H__) */


/******************************************************************************
 *
 *
 *
 *****************************************************************************/
