/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright 2018 Seenaptec Ltd. All rights reserved.
 * SEENAPTEC PROPRIETARY/CONFIDENTIAL.
 *
 * $Id$
 */

/*
 * CountRelBox.h	(D.Vinnyk)
 * Vipm/Statistics/CountRelBox.h
 */

/* ------------------------------------------------------------------------- */

#ifndef __VIPM_STATISTICS_COUNTRELBOX_H__
# define __VIPM_STATISTICS_COUNTRELBOX_H__

/******************************************************************************
 * %% BeginSection: includes
 */

# ifndef __VIPM_STATISTICS_COUNTRELBOX_ALGORITHM_H__
#  include "Vipm/Statistics/CountRelBox/Algorithm.h"
# endif


/******************************************************************************
 * %% BeginSection: function prototypes
 */
# pragma mark -
# pragma mark [ function prototypes ]
# pragma mark -

# include <Vipm/Linkage.h>
# define __PUB __myc_flinkage__(public,libVipm)
__MYC_BEGIN_CDECLS

__PUB bo_status_t
VipmCountRelBox(
# ifdef __cplusplus
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_mut_array_t                aDest,
	vipm_array_t                    aSource,
	vipm_site_t const              *aRoiDst,
	vipm_Npoint_t const            *aStartSrc,
	vipm_int                        aCmpOp,
	vipm_seshape_t const           *aStrel,
	vipm_range_t                    aValueRangevSrc[],
	/* Useful for large strel */
	vipm_int                        aScaleFactor = 0,
	vipm_int                        aRoundMode   = VipmK_RND_DEFAULT /* used when scale-factor<0 */
# endif
	);


# ifndef __cplusplus
#  define VipmCountRelBox(x,f,d,s,rcd,os,cmp,se,vrng,scf,rnd) \
	(VipmCountRelBox)(x,(vipm_ulong)(f),d,s,rcd,os,(vipm_int)(cmp),se,vrng,(vipm_int)(scf),(vipm_int)(rnd))
# endif


__MYC_END_CDECLS
# undef __PUB


#endif /* !defined(__VIPM_STATISTICS_COUNTRELBOX_H__) */


/******************************************************************************
 *
 *
 *
 *****************************************************************************/
