/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright 2018 Seenaptec Ltd. All rights reserved.
 * SEENAPTEC PROPRIETARY/CONFIDENTIAL.
 *
 * $Id$
 */

/*
 * Types.h	(D.Vinnyk)
 * Vipm/Statistics/CountRelBox/Types.h
 */

/* ------------------------------------------------------------------------- */

#ifndef __VIPM_STATISTICS_COUNTRELBOX_TYPES_H__
# define __VIPM_STATISTICS_COUNTRELBOX_TYPES_H__

/******************************************************************************
 * %% BeginSection: includes
 */

# ifndef __VIPM_TYPES_H__
#  include <Vipm/Types.h>
# endif


/******************************************************************************
 * %% BeginSection: type/constant declarations
 */



/* ========================================================================= */

typedef bo_status_t (*vipma_countrelbox_fn)(
# if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_rank_t                     aRank,
	vipm_int const                  aVolume[],
	vipm_uint                       anElemTypeDst,
	vipm_mutptr_t                   aBaseDst, vipm_int const aStartDst[], vipm_int const aStrideDst[],
	vipm_uint                       anElemTypeSrc,
	vipm_imuptr_t                   aBaseSrc, vipm_int const aStartSrc[], vipm_int const aStrideSrc[],
	vipm_int                        aCmpOp,
	vipm_seshape_t const           *aStrel,
	vipm_range_t                    aValueRangevSrc[],
	/* Useful for large strel */
	vipm_int                        aScaleFactor, vipm_int aRoundMode
# endif
	);

typedef bo_status_t (*vipma_ecountrelbox_fn)(
# if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_rank_t                     aRank,
	vipm_int const                  aVolume[],
	vipm_uint                       anElemTypeDst,
	vipm_mutptr_t                   aBaseDst, vipm_int const aStartDst[], vipm_int const aStrideDst[],
	vipm_uint                       anElemTypeSrc,
	vipm_imuptr_t                   aBaseSrc, vipm_int const aStartSrc[], vipm_int const aStrideSrc[],
	vipm_int                        aCmpOp,
	vipm_seshape_t const           *aStrel,
	vipm_range_t                    aValueRangevSrc[],
	vipm_cntrelboxopts_t const     *anOpts,
	vipm_arrshape_t const          *aWholeArrShapeSrc,
	/* Useful for large strel */
	vipm_int                        aScaleFactor, vipm_int aRoundMode
# endif
	);


#endif /* !defined(__VIPM_STATISTICS_COUNTRELBOX_TYPES_H__) */


/******************************************************************************
 *
 *
 *
 *****************************************************************************/
