/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright 2016 Seenaptec Ltd. All rights reserved.
 * SEENAPTEC PROPRIETARY/CONFIDENTIAL.
 *
 * $Id$
 */

/*
 * Histogram.h	(V.Sokur)
 * Vipm/Statistics/Histogram.h
 */

/* ------------------------------------------------------------------------- */

#ifndef __VIPM_STATISTICS_HISTOGRAM_H__
# define __VIPM_STATISTICS_HISTOGRAM_H__

/******************************************************************************
 * %% BeginSection: includes
 */

# ifndef __VIPM_STATISTICS_HISTOGRAM_ALGORITHM_H__
#  include "Vipm/Statistics/Histogram/Algorithm.h"
# endif
# ifndef __VIPM_STATISTICS_HISTOGRAM_UTILS_H__
#  include "Vipm/Statistics/Histogram/Utils.h"
# endif


/******************************************************************************
 * %% BeginSection: function prototypes
 */
# pragma mark -
# pragma mark [ function prototypes ]
# pragma mark -

# include <Vipm/Linkage.h>
# define __PUB __myc_flinkage__(public,libVipm)
__MYC_BEGIN_CDECLS

__PUB bo_status_t
VipmHistogram(
# if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_array_t                    aSource,
	vipm_site_t const              *aRoiSrc,
	vipm_int                        aWhat,
	struct _Vipm_histogram         *aHistv
# endif
	);

__PUB bo_status_t
VipmHistogramEx(
# if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_array_t                    aSource,
	vipm_array_t                    aMask,
	vipm_site_t const              *aRoiSrc,
	vipm_Npoint_t const            *aStartMsk,
	vipm_int                        aWhat,
	struct _Vipm_histogram         *aHistv
# endif
	);


__MYC_END_CDECLS
# undef __PUB


#endif /* !defined(__VIPM_STATISTICS_HISTOGRAM_H__) */


/******************************************************************************
 *
 *
 *
 *****************************************************************************/
