/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright 2016 Seenaptec Ltd. All rights reserved.
 * SEENAPTEC PROPRIETARY/CONFIDENTIAL.
 *
 * $Id$
 */

/*
 * Utils.h	(V.Sokur)
 * Vipm/Statistics/Histogram/Utils.h
 */

/* ------------------------------------------------------------------------- */

#ifndef __VIPM_STATISTICS_HISTOGRAM_UTILS_H__
# define __VIPM_STATISTICS_HISTOGRAM_UTILS_H__

/******************************************************************************
 * %% BeginSection: includes
 */

# ifndef __VIPM_STATISTICS_HISTOGRAM_TYPES_H__
#  include "Vipm/Statistics/Histogram/Types.h"
# endif


/******************************************************************************
 * %% BeginSection: function prototypes
 */
# pragma mark -
# pragma mark [ function prototypes ]
# pragma mark -

# include <Vipm/Linkage.h>
# define __PUB __myc_flinkage__(public,libVipm)
# define __PROT __myc_flinkage__(public,libVipm)
# define __PRIV __myc_flinkage__(private,libVipm)
__MYC_BEGIN_CDECLS

/*
 * Construct
 */

__PUB bo_status_t       vipm_histogram(ia)   __P((vipm_histogram_t *, vipm_hginitarg_t const *));
__PUB bo_status_t       vipm_histogram(xe)   __P((vipm_histogram_t *, vipm_hginitarg_t const *, struct _Vipm_xenv *));

__PUB void              vipm_hist_(fini)     __P((vipm_histogram_t *));
__PUB void              vipm_hist_(fini,xe)  __P((vipm_histogram_t *, struct _Vipm_xenv *));
__PUB void              vipm_hist_(inithdr)  __P((vipm_histogram_t *, vipm_hginitarg_t const *));
__PUB vipm_histogram_t *vipm_hist_(reset)    __P((vipm_histogram_t *));



__PUB bo_status_t       vipm_histogram(n,ia) __P((vipm_int, vipm_histogram_t [], vipm_hginitarg_t const []));
__PUB bo_status_t       vipm_histogram(n,xe) __P((vipm_int, vipm_histogram_t [], vipm_hginitarg_t const [], struct _Vipm_xenv *));

__PUB void              vipm_hist_(fini,n)   __P((vipm_int, vipm_histogram_t []));
__PUB void              vipm_hist_(fini,n,xe)__P((vipm_int, vipm_histogram_t [], struct _Vipm_xenv *));
__PUB void              vipm_hist_(inithdr,n)__P((vipm_int, vipm_histogram_t [], vipm_hginitarg_t const[]));
__PUB vipm_histogram_t *vipm_hist_(reset,n)  __P((vipm_int, vipm_histogram_t []));


/* ========================================================================= */

/* @{ */

/* I prefer traditional C against stdarg interface :)
 *
 * bo_status_t vipm_hist__init     (vipm_int aCmd, struct _Vipm_histogram *, struct _Vipm_hginitarg const *);
 * bo_status_t vipm_hist__init_n   (vipm_int aCmd, vipm_int aChannelc, struct _Vipm_histogram [] struct _Vipm_hginitarg const []);
 *
 * bo_status_t vipm_hist__init_xe  (vipm_int aCmd, struct _Vipm_histogram *, struct _Vipm_hginitarg const *, struct _Vipm_xenv *);
 * bo_status_t vipm_hist__init_n_xe(vipm_int aCmd, vipm_int aChannelc, struct _Vipm_histogram [] struct _Vipm_hginitarg const [], struct _Vipm_xenv *);
 */

__PROT bo_status_t  vipm_hist__init         ();
__PROT bo_status_t  vipm_hist__init_n       ();
__PROT bo_status_t  vipm_hist__init_xe      ();
__PROT bo_status_t  vipm_hist__init_n_xe    ();


# define vipm_hist__init(aCmd,...)             ((vipm_hist__init)((vipm_int)(aCmd), __VA_ARGS__))
# define vipm_hist__init_n(aCmd,aChannelc,...) ((vipm_hist__init_n)((vipm_int)(aCmd), (vipm_int)(aChannelc), __VA_ARGS__))

# define vipm_hist__init_xe(aCmd,...)             ((vipm_hist__init_xe)((vipm_int)(aCmd), __VA_ARGS__))
# define vipm_hist__init_n_xe(aCmd,aChannelc,...) ((vipm_hist__init_n_xe)((vipm_int)(aCmd), (vipm_int)(aChannelc), __VA_ARGS__))

/* @} */


__MYC_END_CDECLS
# undef __PUB
# undef __PROT
# undef __PRIV


#endif /* !defined(__VIPM_STATISTICS_HISTOGRAM_UTILS_H__) */


/******************************************************************************
 *
 *
 *
 *****************************************************************************/
