/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright 2018 Seenaptec Ltd. All rights reserved.
 * SEENAPTEC PROPRIETARY/CONFIDENTIAL.
 *
 * $Id$
 */

/*
 * Types.h	(D.Vinnyk)
 * Vipm/Statistics/Mean/Types.h
 */

/* ------------------------------------------------------------------------- */

#ifndef __VIPM_STATISTICS_MEAN_TYPES_H__
# define __VIPM_STATISTICS_MEAN_TYPES_H__

/******************************************************************************
 * %% BeginSection: includes
 */

# ifndef __VIPM_TYPES_H__
#  include <Vipm/Types.h>
# endif


/******************************************************************************
 * %% BeginSection: type/constant declarations
 */



/* ========================================================================= */

typedef bo_status_t (*vipma_mean_fn)(
# if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_rank_t                     aRank,
	vipm_int const                  aVolume[],
	vipm_uint                       anElemTypeSrc,
	vipm_imuptr_t                   aBaseSrc, vipm_int const aStartSrc[], vipm_int const aStrideSrc[],
	vipm_scalar_t                   aResult[/* nchannels */]
# endif
	);

typedef bo_status_t (*vipma_meanex_fn)(
# if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_rank_t                     aRank,
	vipm_int const                  aVolume[],
	vipm_uint                       anElemTypeSrc,
	vipm_imuptr_t                   aBaseSrc, vipm_int const aStartSrc[], vipm_int const aStrideSrc[],
	vipm_imuptr_t                   aBaseMsk, vipm_int const aStartMsk[], vipm_int const aStrideMsk[],
	vipm_scalar_t                   aResult[/* nchannels */]
# endif
	);


#endif /* !defined(__VIPM_STATISTICS_MEAN_TYPES_H__) */


/******************************************************************************
 *
 *
 *
 *****************************************************************************/
