/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright 2018 Seenaptec Ltd. All rights reserved.
 * SEENAPTEC PROPRIETARY/CONFIDENTIAL.
 *
 * $Id$
 */

/*
 * Sum.h	(D.Vinnyk)
 * Vipm/Statistics/Sum.h
 */

/* ------------------------------------------------------------------------- */

#ifndef __VIPM_STATISTICS_SUM_H__
# define __VIPM_STATISTICS_SUM_H__

/******************************************************************************
 * %% BeginSection: includes
 */

# ifndef __VIPM_STATISTICS_SUM_ALGORITHM_H__
#  include "Vipm/Statistics/Sum/Algorithm.h"
# endif


/******************************************************************************
 * %% BeginSection: function prototypes
 */
# pragma mark -
# pragma mark [ function prototypes ]
# pragma mark -

# include <Vipm/Linkage.h>
# define __PUB __myc_flinkage__(public,libVipm)
__MYC_BEGIN_CDECLS

/*
 * ROI samples:
 * 1) point : (nplanes:0,y,x,nchannels:0)
 *    volume: (nplanes:1,h,w,nchannels)
 */

__PUB bo_status_t
VipmSum(
# if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_array_t                    aSource,
	vipm_site_t const              *aRoiSrc,
	vipm_scalar_t                   aResult[/* nchannels */]
# endif
	);

__PUB bo_stsint_t
VipmSumEx(
# if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_array_t                    aSource,
	vipm_array_t                    aMask,
	vipm_site_t const              *aRoiSrc,
	vipm_Npoint_t const            *aStartMsk,
	vipm_scalar_t                   aResult[/* nchannels */]
# endif
	);


__MYC_END_CDECLS
# undef __PUB


#endif /* !defined(__VIPM_STATISTICS_SUM_H__) */


/******************************************************************************
 *
 *
 *
 *****************************************************************************/
