/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright 2016 Seenaptec Ltd. All rights reserved.
 * SEENAPTEC PROPRIETARY/CONFIDENTIAL.
 *
 * $Id$
 */

/*
 * Types.h	(V.Sokur)
 * Vipm/Types.h
 */

/* ------------------------------------------------------------------------- */

#ifndef __VIPM_TYPES_H__
# define __VIPM_TYPES_H__

/******************************************************************************
 * %% BeginSection: includes
 */

# ifndef __VIPM_CDEFS_H__
#  include <Vipm/Cdefs.h>
# endif

# ifndef __BO_TYPES__
#  include <Bo/Types.h>
# endif
# ifndef __BO_MEMMAN_TYPES__
#  include <Bo/memman/Types.h>
# endif
# ifndef __BO_LIBC_TIME__
#  include <Bo/libc/Time.h>
# endif
# ifndef __BO_LIBC_LIMITS__
#  include <Bo/libc/Limits.h>
# endif


/******************************************************************************
 * %% BeginSection: type/constant declarations
 */
# pragma mark -
# pragma mark [ type/constant declarations ]
# pragma mark -

/*
 * Base Integer/Float types: ...
 */
# include "Vipm/_Types/Base_Types.h"

/*
 * Base limits: ...
 */
# include "Vipm/_Types/Base_Limits.h"

/*
 * Base [rt] macros: ...
 */
# include "Vipm/_Types/Base_Macros.h"

/*
 * Math consts: ...
 */
# include "Vipm/_Types/Math_Consts.h"

# ifndef __VIPM_MMINTRIN_H__
#  include <Vipm/Mmintrin.h>
# endif

/*
 * Base Cast defs: ...
 */
# include "Vipm/_Types/Base_Cast.h"


/*
 * Err consts: ...
 */
# include "Vipm/_Types/Err_Consts.h"


/*
 * Rnd consts: ...
 */
# include "Vipm/_Types/Rnd_Consts.h"


/*
 * Channel/Elem-Type types/constants/macros: ...
 */
# include "Vipm/_Types/Imel_Types.h"

/*
 * Comparison constants/macros: ...
 */
# include "Vipm/_Types/Cmp_Defs.h"

/*
 * Value range limits/macros: ...
 */
# include "Vipm/_Types/Vrng_Defs.h"


/*
 * Scalar defs: ...
 */
# include "Vipm/_Types/Scalar.h"


/*
 * Core consts: ...
 */
# include "Vipm/_Types/Core_Consts.h"

/*
 * Core types: ...
 */
# include "Vipm/_Types/Core_Types.h"


# include "Vipm/_Types/Xenv.h"
# include "Vipm/_Types/ACB.h"

/*
 * Extra types
 */
# include "Vipm/_Types/Tree.h"


/*
 * Statistics types: ...
 */
# include "Vipm/_Types/_Statistics.h"

/*
 * Comparison/Threshold types: ...
 */
# include "Vipm/_Types/_Comparing.h"

/*
 * Filtering/Morphology types: ...
 */
# include "Vipm/_Types/_Filtering.h"

/*
 * Warp types: ...
 */
# include "Vipm/_Types/_Warp.h"


#endif /* !defined(__VIPM_TYPES_H__) */


/******************************************************************************
 *
 *
 *
 *****************************************************************************/
