/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright 2016 Seenaptec Ltd. All rights reserved.
 * SEENAPTEC PROPRIETARY/CONFIDENTIAL.
 *
 * $Id$
 */

/*
 * AGTree.h	(V.Sokur)
 * Vipm/Utils/AGTree.h
 */

/* ------------------------------------------------------------------------- */

#ifndef __VIPM_UTILS_AGTREE_H__
# define __VIPM_UTILS_AGTREE_H__

/******************************************************************************
 * %% BeginSection: includes
 */

# ifndef __VIPM_TYPES_H__
#  include <Vipm/Types.h>
# endif


/******************************************************************************
 * %% BeginSection: function prototypes
 */
# pragma mark -
# pragma mark [ function prototypes ]
# pragma mark -

# include <Vipm/Linkage.h>
# define __PUB __myc_flinkage__(public,libVipm)
# define __PROT __myc_flinkage__(public,libVipm)
# define __PRIV __myc_flinkage__(private,libVipm)
__MYC_BEGIN_CDECLS

__PUB struct _Vipm_agtreenode *
VipmAGTaddchild(
#if __myc_require(prototypes)
	struct _Vipm_agtreenode        *aNode,
	struct _Vipm_agtreenode        *aChild
#endif
	);

__PUB vipm_int
VipmAGTcountChildren(
#if __myc_require(prototypes)
	struct _Vipm_agtreenode        *aNode,
	int                             aRecursively
#endif
	);

__PUB void
VipmAGTwalk(
#if __myc_require(prototypes)
	struct _Vipm_agtree            *aTree,
	vipm_int                        anOrder,
	vipm_agt_visitor_fn             aVisitor,
	void                           *aContext
#endif
	);

__PUB void
VipmAGTwalkFromNode(
#if __myc_require(prototypes)
	struct _Vipm_agtreenode        *aNode,
	vipm_int                        anOrder,
	vipm_agt_visitor_fn             aVisitor,
	void                           *aContext
#endif
	);

/* ------------------------------------------------------------------------- */

__PUB struct _Vipm_dgtreenode *
VipmDGTnodeData(
#if __myc_require(prototypes)
	struct _Vipm_dgtreenode        *aNode,
	void /* vipm_dgtdata_t */      *aData
#endif
	);


/* ========================================================================= */

__PROT void
__VipmAGTaddchild(
#if __myc_require(prototypes)
	struct _Vipm_agtreenode        *aNode,
	struct _Vipm_agtreenode        *aChild
#endif
	);

__PROT struct _Vipm_dgtreenode *
__VipmDGTnodeData(
#if __myc_require(prototypes)
	struct _Vipm_dgtreenode        *aNode,
	vipm_dgtdata_t                 *aData
#endif
	);


/* +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ */

_VIPM_INLINE void
__VipmAGTaddchild(
#if __myc_require(prototypes)
	struct _Vipm_agtreenode        *aNode,
	struct _Vipm_agtreenode        *aChild
#else
	aNode, aChild
#endif
	)
#if !__myc_require(prototypes)
	struct _Vipm_agtreenode        *aNode, *aChild;
#endif

{
	aChild->gtn_parent = aNode;
	aChild->gtn_next = aNode->gtn_child;
	aNode->gtn_child = aChild;
}

_VIPM_INLINE struct _Vipm_dgtreenode *
__VipmDGTnodeData(
#if __myc_require(prototypes)
	struct _Vipm_dgtreenode        *aNode,
	vipm_dgtdata_t                 *aData
#else
	aNode, aData
#endif
	)
#if !__myc_require(prototypes)
	struct _Vipm_dgtreenode        *aNode;
	vipm_dgtdata_t                 *aData;
#endif

{
	aNode->gtn_data = aData;
	aData->dgt_node = aNode;
	return (aNode);
}


__MYC_END_CDECLS
# undef __PUB
# undef __PROT
# undef __PRIV


#endif /* !defined(__VIPM_UTILS_AGTREE_H__) */


/******************************************************************************
 *
 *
 *
 *****************************************************************************/
