/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright 2019 Seenaptec Ltd. All rights reserved.
 * SEENAPTEC PROPRIETARY/CONFIDENTIAL.
 *
 * $Id$
 */

/*
 * Cpuinfo.h	(D.Vinnyk)
 * Vipm/Utils/Cpuinfo.h
 */

/* ------------------------------------------------------------------------- */

#ifndef __VIPM_UTILS_CPUINFO_H__
# define __VIPM_UTILS_CPUINFO_H__

/******************************************************************************
 * %% BeginSection: includes
 */

# ifndef __VIPM_TYPES_H__
#  include <Vipm/Types.h>
# endif


/******************************************************************************
 * %% BeginSection: constant declarations
 */

/* cache sizes for your machine can be defined in prj/pmake/Vipm.shlib/targopt.mk */
# define VipmK_DFL_LEVEL1_ICACHE_SIZE   32768
# define VipmK_DFL_LEVEL1_DCACHE_SIZE   32768
# define VipmK_DFL_LEVEL2_CACHE_SIZE    2097152


/******************************************************************************
 * %% BeginSection: function prototypes
 */
# pragma mark -
# pragma mark [ function prototypes ]
# pragma mark -

# include <Vipm/Linkage.h>
# define __PUB  __myc_flinkage__(public,libVipm)
# define __VPUB __myc_vlinkage__(public,libVipm)
__MYC_BEGIN_CDECLS

__PUB vipm_int  vipm_level1_icache_size ();
__PUB vipm_int  vipm_level1_dcache_size ();
__PUB vipm_int  vipm_level2_cache_size  ();

__MYC_END_CDECLS
# undef __PUB
# undef __VPUB


#endif /* !defined(__VIPM_UTILS_CPUINFO_H__) */


/******************************************************************************
 *
 *
 *
 *****************************************************************************/
