/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright 2016 Seenaptec Ltd. All rights reserved.
 * SEENAPTEC PROPRIETARY/CONFIDENTIAL.
 *
 * $Id$
 */

/*
 * Extras.h	(V.Sokur)
 * Vipm/Utils/Extras.h
 */

/* ------------------------------------------------------------------------- */

#ifndef __VIPM_UTILS_EXTRAS_H__
# define __VIPM_UTILS_EXTRAS_H__

/******************************************************************************
 * %% BeginSection: includes
 */

# ifndef __VIPM_TYPES_H__
#  include <Vipm/Types.h>
# endif

/* @todo: fixme - remove (?) */
#if 1
#ifndef __VIPM_UTILS_FILLVALUTILS_H__
# include "Vipm/Utils/FillValUtils.h"
#endif
#endif


/******************************************************************************
 * %% BeginSection: function prototypes
 */
# pragma mark -
# pragma mark [ function prototypes ]
# pragma mark -

# include <Vipm/Linkage.h>
# define __PUB  __myc_flinkage__(public,libVipm)
# define __VPUB __myc_vlinkage__(public,libVipm)
__MYC_BEGIN_CDECLS

/*
 *        UI32  vipm_bcshash  (char const *aBase);
 *        UI32  vipm_bcsnhash (char const *aBase, bo_rsize_t aCharcMax);
 *        UI32  vipm_bhash    (void const *aBase, bo_rsize_t aNumBytes);
 *
 *
 *        void  vipm_bcopy    (aDest, aSource, aNumBytes);
 *        void  vipm_bcopy2d  (aDest, aSource, aYStrideDst, aYStrideSrc, H, W-in-bytes);
 *        void  vipm_bfill    (aDest, aNumBytes, aNumChannels, UI32 const aFillValuev[4 ? 16]);
 *        void  vipm_bfill2d  (aDest, aYStrideDst, H, W-in-bytes, aNumChannels, UI32 const aFillValuev[4 ? 16]);
 *
 *
 *  bo_uint8_t  vipm_sumu8_n  (bo_uint8_t const *aBase, vipm_int aNumElems);
 *  bo_uint8_t  vipm_minu8_n  (bo_uint8_t const *aBase, vipm_int aNumElems);
 *  bo_uint8_t  vipm_maxu8_n  (bo_uint8_t const *aBase, vipm_int aNumElems);
 *
 *  bo_int16_t  vipm_sumi16_n (bo_int16_t const *aBase, vipm_int aNumElems);
 *
 *       float  vipm_sumf_n   (float const *aBase, vipm_int aNumElems);
 *       float  vipm_minf_n   (float const *aBase, vipm_int aNumElems);
 *       float  vipm_maxf_n   (float const *aBase, vipm_int aNumElems);
 *
 *
 *        void  vipm_addvcf   (float *aDest, float const *aSource1, float aSource2, vipm_int aNumElems);
 *        void  vipm_subvcf   (float *aDest, float const *aSource1, float aSource2, vipm_int aNumElems);
 *        void  vipm_rsubvcf  (float *aDest, float const *aSource1, float aSource2, vipm_int aNumElems);
 *        void  vipm_mulvcf   (float *aDest, float const *aSource1, float aSource2, vipm_int aNumElems);
 *        void  vipm_divvcf   (float *aDest, float const *aSource1, float aSource2, vipm_int aNumElems);
 *        void  vipm_rdivvcf  (float *aDest, float const *aSource1, float aSource2, vipm_int aNumElems);
 *
 *        void  vipm_addvcfI  (float *aDest, float aSource2, vipm_int aNumElems);
 *        void  vipm_subvcfI  (float *aDest, float aSource2, vipm_int aNumElems);
 *        void  vipm_rsubvcfI (float *aDest, float aSource2, vipm_int aNumElems);
 *        void  vipm_mulvcfI  (float *aDest, float aSource2, vipm_int aNumElems);
 *        void  vipm_divvcfI  (float *aDest, float aSource2, vipm_int aNumElems);
 *        void  vipm_rdivvcfI (float *aDest, float aSource2, vipm_int aNumElems);
 *
 *        void  vipm_add256_8 (bo_uint8_t *aDest, bo_uint8_t const *aSource1, bo_uint8_t const *aSource2);
 *        void  vipm_add256_16(bo_int16_t *aDest, bo_int16_t const *aSource1, bo_int16_t const *aSource2);
 *        void  vipm_add256I_8 (bo_uint8_t *aDest, bo_uint8_t const *aSource2);
 *        void  vipm_add256I_16(bo_int16_t *aDest, bo_int16_t const *aSource2);
 *
 *        suba: aDest = aSource1 + (aSource2 - aSource3)
 *        void  vipm_suba256_8 (bo_uint8_t *aDest, bo_uint8_t const *aSource1, bo_uint8_t const *aSource2, bo_uint8_t cosnt *aSource3);
 *        void  vipm_suba256_16(bo_int16_t *aDest, bo_int16_t const *aSource1, bo_int16_t const *aSource2, bo_int16_t cosnt *aSource3);
 *        subaI: aDest += aSource2 - aSource3
 *        void  vipm_suba256I_8 (bo_uint8_t *aDest, bo_uint8_t const *aSource2, bo_uint8_t const *aSource3);
 *        void  vipm_suba256I_16(bo_int16_t *aDest, bo_int16_t const *aSource2, bo_int16_t const *aSource3);
 *
 *        void  vipm_addLE256_8 (bo_uint8_t *aDest, bo_uint8_t const *aSource1, bo_uint8_t const *aSource2, vipm_int aNumElems);
 *        void  vipm_addLE256_16(bo_int16_t *aDest, bo_int16_t const *aSource1, bo_int16_t const *aSource2, vipm_int aNumElems);
 *        void  vipm_addLE256I_8 (bo_uint8_t *aDest, bo_uint8_t const *aSource2, vipm_int aNumElems);
 *        void  vipm_addLE256I_16(bo_int16_t *aDest, bo_int16_t const *aSource2, vipm_int aNumElems);
 *
 *        void  vipm_subaLE256_8 (bo_uint8_t *aDest, bo_uint8_t const *aSource1, bo_uint8_t const *aSource2, bo_uint8_t cosnt *aSource3, vipm_int aNumElems);
 *        void  vipm_subaLE256_16(bo_int16_t *aDest, bo_int16_t const *aSource1, bo_int16_t const *aSource2, bo_int16_t cosnt *aSource3, vipm_int aNumElems);
 *        void  vipm_subaLE256I_8 (bo_uint8_t *aDest, bo_uint8_t const *aSource2, bo_uint8_t const *aSource3, vipm_int aNumElems);
 *        void  vipm_subaLE256I_16(bo_int16_t *aDest, bo_int16_t const *aSource2, bo_int16_t const *aSource3, vipm_int aNumElems);
 *
 *    vipm_int  vipm_memelem2d (anElemType, aBase, aYStride, H, W-in-elems, vipm_scalar_t aCharacter);
 *    vipm_int  vipm_memcelem2d(anElemType, aBase, aYStride, H, W-in-elems, vipm_scalar_t aCharacter);
 */

/* ------------------------------------------------------------------------- */

__PUB bo_uint32_t   vipm_bcshash        __P((char const *));
__PUB bo_uint32_t   vipm_bcsnhash       __P((char const *, bo_rsize_t));
__PUB bo_uint32_t   vipm_bhash          __P((void const *, bo_rsize_t));

/* ------------------------------------------------------------------------- */

__PUB vipm_int      vipm_memelem2dS     __P((vipm_uint, void const *, vipm_int, vipm_int, vipm_int, vipm_scalar_t));
__PUB vipm_int      vipm_memcelem2dS    __P((vipm_uint, void const *, vipm_int, vipm_int, vipm_int, vipm_scalar_t));
__PUB vipm_int      vipm_memelem2d      __P((vipm_uint, void const *, vipm_int, vipm_int, vipm_int, vipm_scalar_t));
__PUB vipm_int      vipm_memcelem2d     __P((vipm_uint, void const *, vipm_int, vipm_int, vipm_int, vipm_scalar_t));

/* ------------------------------------------------------------------------- */

# if __VIPM_USE_SIMD
#  define vipm_bcopy                simd_vipm_bcopy
#  define vipm_bcopy2d              simd_vipm_bcopy2d
#  define vipm_bfill                simd_vipm_bfill
#  define vipm_bfill2d              simd_vipm_bfill2d

#  define vipm_sumu8_n              simd_vipm_sumu8_n
#  define vipm_minu8_n              simd_vipm_minu8_n
#  define vipm_maxu8_n              simd_vipm_maxu8_n
#  define vipm_sumi16_n             simd_vipm_sumi16_n
#  define vipm_sumf_n               simd_vipm_sumf_n
#  define vipm_minf_n               simd_vipm_minf_n
#  define vipm_maxf_n               simd_vipm_maxf_n

#  define vipm_addvcf               simd_vipm_addvcf
#  define vipm_subvcf               simd_vipm_subvcf
#  define vipm_rsubvcf              simd_vipm_rsubvcf
#  define vipm_mulvcf               simd_vipm_mulvcf
#  define vipm_divvcf               simd_vipm_divvcf
#  define vipm_rdivvcf              simd_vipm_rdivvcf

#  define vipm_addLE256_8           simd_vipm_addLE256_8
#  define vipm_addLE256_16          simd_vipm_addLE256_16
#  define vipm_subaLE256_8          simd_vipm_subaLE256_8
#  define vipm_subaLE256_16         simd_vipm_subaLE256_16
# else
#  define vipm_bcopy                C_vipm_bcopy
#  define vipm_bcopy2d              C_vipm_bcopy2d
#  define vipm_bfill                C_vipm_bfill
#  define vipm_bfill2d              C_vipm_bfill2d

#  define vipm_sumu8_n              C_vipm_sumu8_n
#  define vipm_minu8_n              C_vipm_minu8_n
#  define vipm_maxu8_n              C_vipm_maxu8_n
#  define vipm_sumi16_n             C_vipm_sumi16_n
#  define vipm_sumf_n               C_vipm_sumf_n
#  define vipm_minf_n               C_vipm_minf_n
#  define vipm_maxf_n               C_vipm_maxf_n

#  define vipm_addvcf               C_vipm_addvcf
#  define vipm_subvcf               C_vipm_subvcf
#  define vipm_rsubvcf              C_vipm_rsubvcf
#  define vipm_mulvcf               C_vipm_mulvcf
#  define vipm_divvcf               C_vipm_divvcf
#  define vipm_rdivvcf              C_vipm_rdivvcf

#  define vipm_addLE256_8           C_vipm_addLE256_8
#  define vipm_addLE256_16          C_vipm_addLE256_16
#  define vipm_subaLE256_8          C_vipm_subaLE256_8
#  define vipm_subaLE256_16         C_vipm_subaLE256_16
# endif


# define vipm_addvcfI(D,S,sz)       vipm_addvcf(D,NULL,S,sz)
# define vipm_subvcfI(D,S,sz)       vipm_subvcf(D,NULL,S,sz)
# define vipm_rsubvcfI(D,S,sz)      vipm_rsubvcf(D,NULL,S,sz)
# define vipm_mulvcfI(D,S,sz)       vipm_mulvcf(D,NULL,S,sz)
# define vipm_divvcfI(D,S,sz)       vipm_divvcf(D,NULL,S,sz)
# define vipm_rdivvcfI(D,S,sz)      vipm_rdivvcf(D,NULL,S,sz)

# define vipm_add256_8(D,S1,S2)         vipm_addLE256_8(D,S1,S2,256)
# define vipm_add256_16(D,S1,S2)        vipm_addLE256_16(D,S1,S2,256)
# define vipm_suba256_8(D,S1,S2,S3)     vipm_subaLE256_8(D,S1,S2,S3,256)
# define vipm_suba256_16(D,S1,S2,S3)    vipm_subaLE256_16(D,S1,S2,S3,256)
# define vipm_add256I_8(D,S)            vipm_add256_8(D,NULL,S)
# define vipm_add256I_16(D,S)           vipm_add256_16(D,NULL,S)
# define vipm_suba256I_8(D,S1,S2)       vipm_suba256_8(D,NULL,S1,S2)
# define vipm_suba256I_16(D,S1,S2)      vipm_suba256_16(D,NULL,S1,S2)
# define vipm_addLE256I_8(D,S,sz)       vipm_addLE256_8(D,NULL,S,sz)
# define vipm_addLE256I_16(D,S,sz)      vipm_addLE256_16(D,NULL,S,sz)
# define vipm_subaLE256I_8(D,S1,S2,sz)  vipm_subaLE256_8(D,NULL,S1,S2,sz)
# define vipm_subaLE256I_16(D,S1,S2,sz) vipm_subaLE256_16(D,NULL,S1,S2,sz)


# define C_vipm_bcopy(d,s,n)        (void)memcpy(d,s,(size_t)(n))

/*
 * @note: NOT FOR YOUR BUSINESS @{
 */
# define ___vipm_bcopy2d            C_vipm_bcopy2d
# define ___vipm_bfill              C_vipm_bfill
# define ___vipm_bfill2d            C_vipm_bfill2d

# define ___vipm_sumu8_n            C_vipm_sumu8_n
# define ___vipm_minu8_n            C_vipm_minu8_n
# define ___vipm_maxu8_n            C_vipm_maxu8_n
# define ___vipm_sumi16_n           C_vipm_sumi16_n
# define ___vipm_sumf_n             C_vipm_sumf_n
# define ___vipm_minf_n             C_vipm_minf_n
# define ___vipm_maxf_n             C_vipm_maxf_n

# define ___vipm_addvcf             C_vipm_addvcf
# define ___vipm_subvcf             C_vipm_subvcf
# define ___vipm_rsubvcf            C_vipm_rsubvcf
# define ___vipm_mulvcf             C_vipm_mulvcf
# define ___vipm_divvcf             C_vipm_divvcf
# define ___vipm_rdivvcf            C_vipm_rdivvcf

# define ___vipm_addLE256_8         C_vipm_addLE256_8
# define ___vipm_addLE256_16        C_vipm_addLE256_16
# define ___vipm_subaLE256_8        C_vipm_subaLE256_8
# define ___vipm_subaLE256_16       C_vipm_subaLE256_16

__PUB void  ___vipm_bcopy       __P((void *, void const *, vipm_int));
__PUB void  ___vipm_bcopy2d     __P((void *, void const *, vipm_int, vipm_int, vipm_int, vipm_int));
__PUB void  ___vipm_bfill       __P((void *, vipm_int, vipm_int, bo_uint32_t const [/* 4 */]));
__PUB void  ___vipm_bfill2d     __P((void *, vipm_int, vipm_int, vipm_int, vipm_int, bo_uint32_t const [/* 4 */]));

__PUB bo_int16_t    ___vipm_sumu8_n     __P((bo_uint8_t const *, vipm_int));
__PUB bo_uint8_t    ___vipm_minu8_n     __P((bo_uint8_t const *, vipm_int));
__PUB bo_uint8_t    ___vipm_maxu8_n     __P((bo_uint8_t const *, vipm_int));
__PUB bo_int16_t    ___vipm_sumi16_n    __P((bo_int16_t const *, vipm_int));

__PUB float ___vipm_sumf_n      __P((float const *, vipm_int));
__PUB float ___vipm_minf_n      __P((float const *, vipm_int));
__PUB float ___vipm_maxf_n      __P((float const *, vipm_int));

__PUB void  ___vipm_addvcf      __P((float *, float const *, float, vipm_int));
__PUB void  ___vipm_subvcf      __P((float *, float const *, float, vipm_int));
__PUB void  ___vipm_rsubvcf     __P((float *, float const *, float, vipm_int));
__PUB void  ___vipm_mulvcf      __P((float *, float const *, float, vipm_int));
__PUB void  ___vipm_divvcf      __P((float *, float const *, float, vipm_int));
__PUB void  ___vipm_rdivvcf     __P((float *, float const *, float, vipm_int));

__PUB void  ___vipm_addLE256_8      __P((bo_uint8_t *, bo_uint8_t const *, bo_uint8_t const *, vipm_int));
__PUB void  ___vipm_addLE256_16     __P((bo_int16_t *, bo_int16_t const *, bo_int16_t const *, vipm_int));
__PUB void  ___vipm_subaLE256_8     __P((bo_uint8_t *, bo_uint8_t const *, bo_uint8_t const *, bo_uint8_t const *, vipm_int));
__PUB void  ___vipm_subaLE256_16    __P((bo_int16_t *, bo_int16_t const *, bo_int16_t const *, bo_int16_t const *, vipm_int));
/* @} */


# ifdef __VIPM_ARM_NEON
#  define simd_vipm_bcopy           arm_neon_vipm_bcopy
#  define simd_vipm_bcopy2d         arm_neon_vipm_bcopy2d
#  define simd_vipm__bfill          arm_neon_vipm__bfill
#  define simd_vipm_bfill           arm_neon_vipm_bfill
#  define simd_vipm_bfill2d         arm_neon_vipm_bfill2d

#  define simd_vipm_sumu8_n         arm_neon_vipm_sumu8_n
#  define simd_vipm_minu8_n         arm_neon_vipm_minu8_n
#  define simd_vipm_maxu8_n         arm_neon_vipm_maxu8_n
#  define simd_vipm_sumi16_n        arm_neon_vipm_sumi16_n
#  define simd_vipm_sumf_n          arm_neon_vipm_sumf_n
#  define simd_vipm_minf_n          arm_neon_vipm_minf_n
#  define simd_vipm_maxf_n          arm_neon_vipm_maxf_n

#  define simd_vipm_addvcf          arm_neon_vipm_addvcf
#  define simd_vipm_subvcf          arm_neon_vipm_subvcf
#  define simd_vipm_rsubvcf         arm_neon_vipm_rsubvcf
#  define simd_vipm_mulvcf          arm_neon_vipm_mulvcf
#  define simd_vipm_divvcf          arm_neon_vipm_divvcf
#  define simd_vipm_rdivvcf         arm_neon_vipm_rdivvcf

#  define simd_vipm_addLE256_8      arm_neon_vipm_addLE256_8
#  define simd_vipm_addLE256_16     arm_neon_vipm_addLE256_16
#  define simd_vipm_subaLE256_8     arm_neon_vipm_subaLE256_8
#  define simd_vipm_subaLE256_16    arm_neon_vipm_subaLE256_16
# endif

/*
 * @note: NOT FOR YOUR BUSINESS @{
 */
# if __VIPM_SIMD

#  define ___simd_vipm_bcopy        simd_vipm_bcopy
#  define ___simd_vipm_bcopy2d      simd_vipm_bcopy2d
#  ifdef simd_vipm__bfill
#   define ___simd_vipm__bfill      simd_vipm__bfill
#  endif
#  define ___simd_vipm_bfill        simd_vipm_bfill
#  define ___simd_vipm_bfill2d      simd_vipm_bfill2d

#  define ___simd_vipm_sumu8_n      simd_vipm_sumu8_n
#  define ___simd_vipm_minu8_n      simd_vipm_minu8_n
#  define ___simd_vipm_maxu8_n      simd_vipm_maxu8_n
#  define ___simd_vipm_sumi16_n     simd_vipm_sumi16_n
#  define ___simd_vipm_sumf_n       simd_vipm_sumf_n
#  define ___simd_vipm_minf_n       simd_vipm_minf_n
#  define ___simd_vipm_maxf_n       simd_vipm_maxf_n

#  define ___simd_vipm_addvcf       simd_vipm_addvcf
#  define ___simd_vipm_subvcf       simd_vipm_subvcf
#  define ___simd_vipm_rsubvcf      simd_vipm_rsubvcf
#  define ___simd_vipm_mulvcf       simd_vipm_mulvcf
#  define ___simd_vipm_divvcf       simd_vipm_divvcf
#  define ___simd_vipm_rdivvcf      simd_vipm_rdivvcf

#  define ___simd_vipm_addLE256_8   simd_vipm_addLE256_8
#  define ___simd_vipm_addLE256_16  simd_vipm_addLE256_16
#  define ___simd_vipm_subaLE256_8  simd_vipm_subaLE256_8
#  define ___simd_vipm_subaLE256_16 simd_vipm_subaLE256_16


__PUB void  ___simd_vipm_bcopy   __P((void *, void const *, vipm_int));
__PUB void  ___simd_vipm_bcopy2d __P((void *, void const *, vipm_int, vipm_int, vipm_int, vipm_int));
__PUB void  ___simd_vipm__bfill  __P((void *, vipm_int, vipm_int));
__PUB void  ___simd_vipm_bfill   __P((void *, vipm_int, vipm_int, bo_uint32_t const [/* 16 */]));
__PUB void  ___simd_vipm_bfill2d __P((void *, vipm_int, vipm_int, vipm_int, vipm_int, bo_uint32_t const [/* 16 */]));


__PUB bo_uint8_t    ___simd_vipm_sumu8_n    __P((bo_uint8_t const *, vipm_int));
__PUB bo_uint8_t    ___simd_vipm_minu8_n    __P((bo_uint8_t const *, vipm_int));
__PUB bo_uint8_t    ___simd_vipm_maxu8_n    __P((bo_uint8_t const *, vipm_int));
__PUB bo_int16_t    ___simd_vipm_sumi16_n   __P((bo_int16_t const *, vipm_int));
__PUB float ___simd_vipm_sumf_n  __P((float const *, vipm_int));
__PUB float ___simd_vipm_minf_n  __P((float const *, vipm_int));
__PUB float ___simd_vipm_maxf_n  __P((float const *, vipm_int));

__PUB void  ___simd_vipm_addvcf  __P((float *, float const *, float, vipm_int));
__PUB void  ___simd_vipm_subvcf  __P((float *, float const *, float, vipm_int));
__PUB void  ___simd_vipm_rsubvcf __P((float *, float const *, float, vipm_int));
__PUB void  ___simd_vipm_mulvcf  __P((float *, float const *, float, vipm_int));
__PUB void  ___simd_vipm_divvcf  __P((float *, float const *, float, vipm_int));
__PUB void  ___simd_vipm_rdivvcf __P((float *, float const *, float, vipm_int));

__PUB void  ___simd_vipm_addLE256_8     __P((bo_uint8_t *, bo_uint8_t const *, bo_uint8_t const *, vipm_int));
__PUB void  ___simd_vipm_addLE256_16    __P((bo_int16_t *, bo_int16_t const *, bo_int16_t const *, vipm_int));
__PUB void  ___simd_vipm_subaLE256_8    __P((bo_uint8_t *, bo_uint8_t const *, bo_uint8_t const *, bo_uint8_t const *, vipm_int));
__PUB void  ___simd_vipm_subaLE256_16   __P((bo_int16_t *, bo_int16_t const *, bo_int16_t const *, bo_int16_t const *, vipm_int));
# endif /* SIMD */
/* @} */

/* ------------------------------------------------------------------------- */

__PUB bo_status_t
vipm_xlat2d_u8(
#if __myc_require(prototypes)
	bo_uint8_t const               *aXlatabv[],
	bo_uint8_t                     *aBaseDst,
	bo_uint8_t const               *aBaseSrc,
	vipm_int                        aYStrideDst,
	vipm_int                        aYStrideSrc,
	vipm_int                        aHeight,
	vipm_int                        aWidthInPix,
	vipm_int                        aChannelc
#endif
	);

/* ------------------------------------------------------------------------- */

__PUB bo_status_t
vipm_mkcmpxlatab(
#if __myc_require(prototypes)
	bo_uint8_t                     *aXlatabv[],
	vipm_int                        aCmpOp,
	vipm_scalar_t const             aRhs[/* aChannelc */],
	bo_uint32_t const               aFillValuevTrue[/* >=4 */],
	bo_uint32_t const               aFillValuevFalse[/* >=4 */],
	vipm_int                        aChannelc
#endif
	);

__PUB bo_status_t
vipm_mkcmpxlatab2(
#if __myc_require(prototypes)
	bo_uint8_t                     *aXlatabv[],
	vipm_int                        aCmpOp0,
	vipm_int                        aCmpOp1,
	vipm_scalar_t const             aRhs0[/* aChannelc */],
	vipm_scalar_t const             aRhs1[/* aChannelc */],
	bo_uint32_t const               aFillValuev0[/* >=4 */],
	bo_uint32_t const               aFillValuev1[/* >=4 */],
	vipm_int                        aChannelc
#endif
	);


__PUB bo_status_t
vipm__mkcmpxlatab(
#if __myc_require(prototypes)
	bo_uint8_t                     *aXlatabv[],
	vipm_int                        aCmpOp,
	vipm_imuptr_t                   aRhs,
	bo_uint32_t const               aFillValuevTrue[/* >=4 */],
	bo_uint32_t const               aFillValuevFalse[/* >=4 */],
	vipm_int                        aChannelc
#endif
	);

__PUB bo_status_t
vipm__mkcmpxlatab2(
#if __myc_require(prototypes)
	bo_uint8_t                     *aXlatabv[],
	vipm_int                        aCmpOp0,
	vipm_int                        aCmpOp1,
	vipm_imuptr_t                   aRhs0,
	vipm_imuptr_t                   aRhs1,
	bo_uint32_t const               aFillValuev0[/* >=4 */],
	bo_uint32_t const               aFillValuev1[/* >=4 */],
	vipm_int                        aChannelc
#endif
	);


__MYC_END_CDECLS
# undef __PUB
# undef __VPUB


#endif /* !defined(__VIPM_UTILS_EXTRAS_H__) */


/******************************************************************************
 *
 *
 *
 *****************************************************************************/
