/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright 2016 Seenaptec Ltd. All rights reserved.
 * SEENAPTEC PROPRIETARY/CONFIDENTIAL.
 *
 * $Id$
 */

/*
 * FillValUtils.h	(V.Sokur)
 * Vipm/Utils/FillValUtils.h
 */

/* ------------------------------------------------------------------------- */

#ifndef __VIPM_UTILS_FILLVALUTILS_H__
# define __VIPM_UTILS_FILLVALUTILS_H__

/******************************************************************************
 * %% BeginSection: includes
 */

# ifndef __VIPM_TYPES_H__
#  include <Vipm/Types.h>
# endif


/******************************************************************************
 * %% BeginSection: function prototypes
 */
# pragma mark -
# pragma mark [ function prototypes ]
# pragma mark -

# include <Vipm/Linkage.h>
# define __PUB  __myc_flinkage__(public,libVipm)
# define __VPUB __myc_vlinkage__(public,libVipm)
__MYC_BEGIN_CDECLS

__PUB bo_status_t
vipm_defillvals(
#if __myc_require(prototypes)
	vipm_uint                       anElemType,
	vipm_scalar_t                   aFillValuevTrue[/* aChannelc */],
	vipm_scalar_t                   aFillValuevFalse[/* aChannelc */],
	vipm_int                        aChannelc
#endif
	);


/* @todo: fixme (?) saturate?
   @sa: functions with scalar(like addC,compareC,fill,...) */
__PUB bo_status_t
vipm_mkifillvalv16(
#if __myc_require(prototypes)
	vipm_uint                       anElemType,
	bo_uint32_t                     aFillValuevRet[/* >=4 */],
	vipm_scalar_t const             aFillValuevSrc[/* aChannelc */],
	vipm_int                        aChannelc
#endif
	);

__PUB bo_status_t
vipm_mkifillvalv32(
#if __myc_require(prototypes)
	vipm_uint                       anElemType,
	bo_uint32_t                     aFillValuevRet[/* >=8 */],
	vipm_scalar_t const             aFillValuevSrc[/* aChannelc */],
	vipm_int                        aChannelc
#endif
	);

__PUB bo_status_t
vipm_mkifillvalv64(
#if __myc_require(prototypes)
	vipm_uint                       anElemType,
	bo_uint32_t                     aFillValuevRet[/* >=16 */],
	vipm_scalar_t const             aFillValuevSrc[/* aChannelc */],
	vipm_int                        aChannelc
#endif
	);

__PUB bo_status_t
vipm_dupifillvalv3216(
#if __myc_require(prototypes)
	bo_uint32_t                     aFillValuev[/* >=8 */],
	vipm_int                        aChannelc
#endif
	);

__PUB bo_status_t
vipm_dupifillvalv6416(
#if __myc_require(prototypes)
	bo_uint32_t                     aFillValuev[/* >=16 */],
	vipm_int                        aChannelc
#endif
	);

__PUB bo_status_t
vipm_dupifillvalv6432(
#if __myc_require(prototypes)
	bo_uint32_t                     aFillValuev[/* >=16 */],
	vipm_int                        aChannelc
#endif
	);

__PUB void
vipm_readifillvals4(
#if __myc_require(prototypes)
	bo_uint32_t                    *aVal0,
	bo_uint32_t const               aSrcv[/* >=4 */],
	bo_uint32_t                     aShift /* in bytes */
#endif
	);

__PUB void
vipm_readifillvals4x2(
#if __myc_require(prototypes)
	bo_uint32_t                    *aVal0, bo_uint32_t *aVal1,
	bo_uint32_t const               aSrcv[/* >=4 */],
	bo_uint32_t                     aShift /* in bytes */
#endif
	);

__PUB void
vipm_readifillvals4x3(
#if __myc_require(prototypes)
	bo_uint32_t                    *aVal0, bo_uint32_t *aVal1, bo_uint32_t *aVal2,
	bo_uint32_t const               aSrcv[/* >=4 */],
	bo_uint32_t                     aShift /* in bytes */
#endif
	);

__PUB void
vipm_readifillvals4x4(
#if __myc_require(prototypes)
	bo_uint32_t                    *aVal0, bo_uint32_t *aVal1, bo_uint32_t *aVal2, bo_uint32_t *aVal3,
	bo_uint32_t const               aSrcv[/* >=4 */],
	bo_uint32_t                     aShift /* in bytes */
#endif
	);

# define vipm_readifillvals4(v0, srcv,shift) \
	(vipm_readifillvals4)(&v0, srcv,shift)

# define vipm_readifillvals4x2(v0,v1, srcv,shift) \
	(vipm_readifillvals4x2)(&v0,&v1, srcv,shift)

# define vipm_readifillvals4x3(v0,v1,v2, srcv,shift) \
	(vipm_readifillvals4x3)(&v0,&v1,&v2, srcv,shift)

# define vipm_readifillvals4x4(v0,v1,v2,v3, srcv,shift) \
	(vipm_readifillvals4x4)(&v0,&v1,&v2,&v3, srcv,shift)


# define VIPM_GEFILLVAL_CN(_ET,fvalv,cn)    (((VIPM_ELTY_T(_ET) const *)(fvalv))[cn])
# define VIPM_GEFILLVAL_CN_0(_ET,fvalv)     VIPM_GEFILLVAL_CN(_ET,fvalv,0)
# define VIPM_GEFILLVAL_CN_1(_ET,fvalv)     VIPM_GEFILLVAL_CN(_ET,fvalv,1)
# define VIPM_GEFILLVAL_CN_2(_ET,fvalv)     VIPM_GEFILLVAL_CN(_ET,fvalv,2)
# define VIPM_GEFILLVAL_CN_3(_ET,fvalv)     VIPM_GEFILLVAL_CN(_ET,fvalv,3)


/* +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ */

_VIPM_INLINE void
(vipm_readifillvals4)(
#if __myc_require(prototypes)
	bo_uint32_t                    *aVal0,
	bo_uint32_t const               aSrcv[/* >=4 */],
	bo_uint32_t                     aShift /* in bytes */
#else
	aVal0, aSrcv, aShift
#endif
	)
#if !__myc_require(prototypes)
	bo_uint32_t                    *aVal0;
	bo_uint32_t const               aSrcv[];
	bo_uint32_t                     aShift;
#endif
{
	bo_uint32_t n = aShift << 3; /* aShift * 8 */
#if (BO_BYTE_ORDER == BIG_BYTE_ORDER)
	*aVal0 = (aSrcv[0] << n) | (aSrcv[1] >> (32 - n));
#else
	*aVal0 = (aSrcv[0] >> n) | (aSrcv[1] << (32 - n));
#endif
}

_VIPM_INLINE void
(vipm_readifillvals4x2)(
#if __myc_require(prototypes)
	bo_uint32_t                    *aVal0, bo_uint32_t *aVal1,
	bo_uint32_t const               aSrcv[/* >=4 */],
	bo_uint32_t                     aShift /* in bytes */
#else
	aVal0, aVal1, aSrcv, aShift
#endif
	)
#if !__myc_require(prototypes)
	bo_uint32_t                    *aVal0, *aVal1;
	bo_uint32_t const               aSrcv[];
	bo_uint32_t                     aShift;
#endif
{
	bo_uint32_t n = aShift << 3; /* aShift * 8 */
#if (BO_BYTE_ORDER == BIG_BYTE_ORDER)
	*aVal0 = (aSrcv[0] << n) | (aSrcv[1] >> (32 - n));
	*aVal1 = (aSrcv[1] << n) | (aSrcv[2] >> (32 - n));
#else
	*aVal0 = (aSrcv[0] >> n) | (aSrcv[1] << (32 - n));
	*aVal1 = (aSrcv[1] >> n) | (aSrcv[2] << (32 - n));
#endif
}

_VIPM_INLINE void
(vipm_readifillvals4x3)(
#if __myc_require(prototypes)
	bo_uint32_t                    *aVal0, bo_uint32_t *aVal1, bo_uint32_t *aVal2,
	bo_uint32_t const               aSrcv[/* >=4 */],
	bo_uint32_t                     aShift /* in bytes */
#else
	aVal0, aVal1, aVal2, aSrcv, aShift
#endif
	)
#if !__myc_require(prototypes)
	bo_uint32_t                    *aVal0, *aVal1, *aVal2;
	bo_uint32_t const               aSrcv[];
	bo_uint32_t                     aShift;
#endif
{
	bo_uint32_t n = aShift << 3; /* aShift * 8 */
#if (BO_BYTE_ORDER == BIG_BYTE_ORDER)
	*aVal0 = (aSrcv[0] << n) | (aSrcv[1] >> (32 - n));
	*aVal1 = (aSrcv[1] << n) | (aSrcv[2] >> (32 - n));
	*aVal2 = (aSrcv[2] << n) | (aSrcv[3] >> (32 - n));
#else
	*aVal0 = (aSrcv[0] >> n) | (aSrcv[1] << (32 - n));
	*aVal1 = (aSrcv[1] >> n) | (aSrcv[2] << (32 - n));
	*aVal2 = (aSrcv[2] >> n) | (aSrcv[3] << (32 - n));
#endif
}

_VIPM_INLINE void
(vipm_readifillvals4x4)(
#if __myc_require(prototypes)
	bo_uint32_t                    *aVal0, bo_uint32_t *aVal1, bo_uint32_t *aVal2, bo_uint32_t *aVal3,
	bo_uint32_t const               aSrcv[/* >=4 */],
	bo_uint32_t                     aShift /* in bytes */
#else
	aVal0, aVal1, aVal2, aVal3, aSrcv, aShift
#endif
	)
#if !__myc_require(prototypes)
	bo_uint32_t                    *aVal0, *aVal1, *aVal2, *aVal3;
	bo_uint32_t const               aSrcv[];
	bo_uint32_t                     aShift;
#endif
{
	bo_uint32_t n = aShift << 3; /* aShift * 8 */
#if (BO_BYTE_ORDER == BIG_BYTE_ORDER)
	*aVal0 = (aSrcv[0] << n) | (aSrcv[1] >> (32 - n));
	*aVal1 = (aSrcv[1] << n) | (aSrcv[2] >> (32 - n));
	*aVal2 = (aSrcv[2] << n) | (aSrcv[3] >> (32 - n));
	*aVal3 = (aSrcv[3] << n) | (aSrcv[0] >> (32 - n));
#else
	*aVal0 = (aSrcv[0] >> n) | (aSrcv[1] << (32 - n));
	*aVal1 = (aSrcv[1] >> n) | (aSrcv[2] << (32 - n));
	*aVal2 = (aSrcv[2] >> n) | (aSrcv[3] << (32 - n));
	*aVal3 = (aSrcv[3] >> n) | (aSrcv[0] << (32 - n));
#endif
}


__MYC_END_CDECLS
# undef __PUB
# undef __VPUB


#endif /* !defined(__VIPM_UTILS_FILLVALUTILS_H__) */


/******************************************************************************
 *
 *
 *
 *****************************************************************************/
