/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright 2016 Seenaptec Ltd. All rights reserved.
 * SEENAPTEC PROPRIETARY/CONFIDENTIAL.
 *
 * $Id$
 */

/*
 * Motley.h	(V.Sokur)
 * Vipm/Utils/Motley.h
 */

/* ------------------------------------------------------------------------- */

#ifndef __VIPM_UTILS_MOTLEY_H__
# define __VIPM_UTILS_MOTLEY_H__

/******************************************************************************
 * %% BeginSection: includes
 */

# ifndef __VIPM_TYPES_H__
#  include <Vipm/Types.h>
# endif


/******************************************************************************
 * %% BeginSection: function prototypes
 */
# pragma mark -
# pragma mark [ function prototypes ]
# pragma mark -

# include <Vipm/Linkage.h>
# define __PUB  __myc_flinkage__(public,libVipm)
# define __VPUB __myc_vlinkage__(public,libVipm)
__MYC_BEGIN_CDECLS

__PUB char const   *vipm_filter_str     __P((int));
__PUB char const   *vipm_morphop_str    __P((int));
__PUB char const   *vipm_border_str     __P((int));
__PUB char const   *vipm_cmpop_str      __P((int));
__PUB char const   *vipm_thhmethod_str  __P((int));

/* ------------------------------------------------------------------------- */

__PUB int           vipm_sclu8rngchk    __P((vipm_scalar_t const [], vipm_int));
__PUB int           vipm_scfochk        __P((vipm_scalar_t const [], vipm_scalar_t const [], vipm_int));
	/* retval:
	 *     1) 0 - no scale-factor, no value-origin
	 *     2) 1 - scale-factor, no value-origin
	 *     3) 2 - no scale-factor, value-origin
	 *     4) 3 - scale-factor, value-origin
	 */


__MYC_END_CDECLS
# undef __PUB
# undef __VPUB


#endif /* !defined(__VIPM_UTILS_MOTLEY_H__) */


/******************************************************************************
 *
 *
 *
 *****************************************************************************/
