/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright 2016 Seenaptec Ltd. All rights reserved.
 * SEENAPTEC PROPRIETARY/CONFIDENTIAL.
 *
 * $Id$
 */

/*
 * STree.h	(V.Sokur)
 * Vipm/Utils/STree.h
 */

/* ------------------------------------------------------------------------- */

#ifndef __VIPM_UTILS_STREE_H__
# define __VIPM_UTILS_STREE_H__

/******************************************************************************
 * %% BeginSection: includes
 */

# ifndef __VIPM_UTILS_AGTREE_H__
#  include <Vipm/Utils/AGTree.h>
# endif


/******************************************************************************
 * %% BeginSection: function prototypes
 */
# pragma mark -
# pragma mark [ function prototypes ]
# pragma mark -

# include <Vipm/Linkage.h>
# define __PUB __myc_flinkage__(public,libVipm)
# define __PROT __myc_flinkage__(public,libVipm)
# define __PRIV __myc_flinkage__(private,libVipm)
__MYC_BEGIN_CDECLS

/*
 * The next fields should be set [by default] before calling of the routine:
 *
 * 1. aTree->gt_custom_construct = NULLF (for instance)
 * 2. aTree->gt_custom_destroy   = NULLF (for instance)
 * 3. aTree->gt_dispose          = NULLF (for instance)
 */
__PUB struct _Vipm_stree *
VipmSTopen(
#if __myc_require(prototypes)
	struct _Vipm_stree             *aTree,          /* = NULL */
	struct _Vipm_streebuilder      *aBuilder
#endif
	);

__PUB void
VipmSTclose(
#if __myc_require(prototypes)
	struct _Vipm_stree             *aTree,
	int                             NoCloseBuilder  /* [default: 0]*/
#endif
	);

__PUB struct _Vipm_stree *
VipmSTinit(
#if __myc_require(prototypes)
	struct _Vipm_stree             *aTree,          /* != NULL */
	struct _Vipm_streebuilder      *aBuilder
#endif
	);

__PUB struct _Vipm_stree *
VipmSTfini(
#if __myc_require(prototypes)
	struct _Vipm_stree             *aTree,
	int                             NoCloseBuilder  /* [default: 0]*/
#endif
	);

__PUB struct _Vipm_stree *
VipmSTclear(
#if __myc_require(prototypes)
	struct _Vipm_stree             *aTree,
	int                             DetachBuilder   /* [default: 0]*/
#endif
	);

__PUB struct _Vipm_stree *
VipmSTsetbuilder(
#if __myc_require(prototypes)
	struct _Vipm_stree             *aTree,
	struct _Vipm_streebuilder      *aBuilder
#endif
	);


/* ========================================================================= */

__PROT struct _Vipm_stree *
__VipmST_setbuilder(
#if __myc_require(prototypes)
	struct _Vipm_stree             *aTree,
	struct _Vipm_streebuilder      *aBuilder
#endif
	);


__MYC_END_CDECLS
# undef __PUB
# undef __PROT
# undef __PRIV


#endif /* !defined(__VIPM_UTILS_STREE_H__) */


/******************************************************************************
 *
 *
 *
 *****************************************************************************/
