/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright 2016 Seenaptec Ltd. All rights reserved.
 * SEENAPTEC PROPRIETARY/CONFIDENTIAL.
 *
 * $Id$
 */

/*
 * ValueRange.h	(V.Sokur)
 * Vipm/Utils/ValueRange.h
 */

/* ------------------------------------------------------------------------- */

#ifndef __VIPM_UTILS_VALUERANGE_H__
# define __VIPM_UTILS_VALUERANGE_H__

/******************************************************************************
 * %% BeginSection: includes
 */

# ifndef __VIPM_TYPES_H__
#  include <Vipm/Types.h>
# endif


/******************************************************************************
 * %% BeginSection: function prototypes
 */
# pragma mark -
# pragma mark [ function prototypes ]
# pragma mark -

struct _Vipm_minmaxinfo;

# include <Vipm/Linkage.h>
# define __PUB  __myc_flinkage__(public,libVipm)
# define __VPUB __myc_vlinkage__(public,libVipm)
__MYC_BEGIN_CDECLS

/*
 * Construct
 */

__PUB vipm_rngf32_t *vipm_rngf32(2)         __P((vipm_rngf32_t *, bo_float32_t, bo_float32_t));
__PUB vipm_rngf64_t *vipm_rngf64(2)         __P((vipm_rngf64_t *, bo_float64_t, bo_float64_t));


__PUB vipm_range_t  *vipm_vrng()            __P((vipm_range_t *));
__PUB vipm_range_t  *vipm_vrng(2)           __P((vipm_range_t *, vipm_scalar_t, vipm_scalar_t));
__PUB vipm_range_t  *vipm_vrng(2,Q)         __P((vipm_uint, vipm_range_t *, vipm_scalar_t, vipm_scalar_t));
__PUB vipm_range_t  *vipm_vrng(minmax)      __P((vipm_range_t *, struct _Vipm_minmaxinfo const *));
__PUB vipm_range_t  *vipm_vrng(minmax,Q)    __P((vipm_uint, vipm_range_t *, struct _Vipm_minmaxinfo const *));

__PUB vipm_range_t  *vipm_vrng(cn,2)        __P((vipm_range_t [], vipm_int, vipm_scalar_t, vipm_scalar_t));
__PUB vipm_range_t  *vipm_vrng(cn,2,Q)      __P((vipm_uint, vipm_range_t [], vipm_int, vipm_scalar_t, vipm_scalar_t));
__PUB vipm_range_t  *vipm_vrng(cn,minmax)   __P((vipm_range_t [], vipm_int, struct _Vipm_minmaxinfo const *));
__PUB vipm_range_t  *vipm_vrng(cn,minmax,Q) __P((vipm_uint, vipm_range_t [], vipm_int, struct _Vipm_minmaxinfo const *));

/* ------------------------------------------------------------------------- */

/*
 * vipm_range_t *vipm_vrng_(saturate)      (anElemType, aDest, aSource);
 * vipm_range_t *vipm_vrng_(saturate,I)    (anElemType, aDestSrc);
 *
 * vipm_range_t *vipm_vrng_(saturate,cn)   (anElemType, aDest, aSource, aChannelc);
 * vipm_range_t *vipm_vrng_(saturate,cn,I) (anElemType, aDestSrc, aChannelc);
 */

__PUB vipm_range_t *vipm_vrng_(saturate)    __P((vipm_uint, vipm_range_t *, vipm_range_t const *));
__PUB vipm_range_t *vipm_vrng_(saturate,I)  __P((vipm_uint, vipm_range_t *));

__PUB vipm_range_t *vipm_vrng_(saturate,cn)   __P((vipm_uint, vipm_range_t [], vipm_range_t const [], vipm_int));
__PUB vipm_range_t *vipm_vrng_(saturate,cn,I) __P((vipm_uint, vipm_range_t [], vipm_int));

/* ------------------------------------------------------------------------- */

/*
 * vipm_range_t *vipm_vrng_(normalize,QS)     (anElemType, aDest = nil, aSource, aHint);
 * vipm_range_t *vipm_vrng_(normalize,Q)      (anElemType, aDest,       aSource, aHint);
 * vipm_range_t *vipm_vrng_(normalize)        (anElemType, aDest,       aSource, aHint);
 * vipm_range_t *vipm_vrng_(normalize,IQS)    (anElemType, aDestSrc = nil, aHint);
 * vipm_range_t *vipm_vrng_(normalize,IQ)     (anElemType, aDestSrc,       aHint);
 * vipm_range_t *vipm_vrng_(normalize,I)      (anElemType, aDestSrc,       aHint);
 *
 * vipm_range_t *vipm_vrng_(normalize,cn,QS)  (anElemType, aDest = nil, aSource, aHintv, aChannelc);
 * vipm_range_t *vipm_vrng_(normalize,cn,Q)   (anElemType, aDest = nil, aSource, aHintv, aChannelc);
 * vipm_range_t *vipm_vrng_(normalize,cn)     (anElemType, aDest,       aSource, aHintv, aChannelc);
 * vipm_range_t *vipm_vrng_(normalize,cn,IQS) (anElemType, aDestSrc = nil, aHintv, aChannelc);
 * vipm_range_t *vipm_vrng_(normalize,cn,IQ)  (anElemType, aDestSrc = nil, aHintv, aChannelc);
 * vipm_range_t *vipm_vrng_(normalize,cn,I)   (anElemType, aDestSrc,       aHintv, aChannelc);
 *
 *
 * bo_status_t   vipm_vrng_(scale,cn,Q)      (anElemTypeDst, aDest, aSource,
 *                                             aScaleFactor = nil { --> 1 },
 *                                             aValueOrigin = nil { --> 0 }, aChannelc);
 *
 * void          vipm_vrng_(solve,cn)         (aMultiplier, anAddend, aRangeDst, aRangeSrc, aChannelc);
 */

__PUB vipm_range_t *vipm_vrng_(normalize,QS)    __P((vipm_uint, vipm_range_t *, vipm_range_t const *, vipm_range_t const *));
__PUB vipm_range_t *vipm_vrng_(normalize,Q)     __P((vipm_uint, vipm_range_t *, vipm_range_t const *, vipm_range_t const *));
__PUB vipm_range_t *vipm_vrng_(normalize)       __P((vipm_uint, vipm_range_t *, vipm_range_t const *, vipm_range_t const *));

__PUB vipm_range_t *vipm_vrng_(normalize,IQS)   __P((vipm_uint, vipm_range_t *, vipm_range_t const *));
__PUB vipm_range_t *vipm_vrng_(normalize,IQ)    __P((vipm_uint, vipm_range_t *, vipm_range_t const *));
__PUB vipm_range_t *vipm_vrng_(normalize,I)     __P((vipm_uint, vipm_range_t *, vipm_range_t const *));


__PUB vipm_range_t *vipm_vrng_(normalize,cn,QS) __P((vipm_uint, vipm_range_t [], vipm_range_t const [],
                                                                vipm_range_t const [], vipm_int));
__PUB vipm_range_t *vipm_vrng_(normalize,cn,Q)  __P((vipm_uint, vipm_range_t [], vipm_range_t const [],
                                                                vipm_range_t const [], vipm_int));
__PUB vipm_range_t *vipm_vrng_(normalize,cn)    __P((vipm_uint, vipm_range_t [], vipm_range_t const [],
                                                                vipm_range_t const [], vipm_int));

__PUB vipm_range_t *vipm_vrng_(normalize,cn,IQS)__P((vipm_uint, vipm_range_t [], vipm_range_t const [], vipm_int));
__PUB vipm_range_t *vipm_vrng_(normalize,cn,IQ) __P((vipm_uint, vipm_range_t [], vipm_range_t const [], vipm_int));
__PUB vipm_range_t *vipm_vrng_(normalize,cn,I)  __P((vipm_uint, vipm_range_t [], vipm_range_t const [], vipm_int));


__PUB bo_status_t   vipm_vrng_(scale,Q)         __P((vipm_uint, vipm_range_t *, vipm_range_t const *,
                                                                vipm_scalar_t, vipm_scalar_t));
__PUB bo_status_t   vipm_vrng_(scale,cn,Q)      __P((vipm_uint, vipm_range_t [], vipm_range_t const [],
                                                                vipm_scalar_t const [], vipm_scalar_t const [], vipm_int));

__PUB void          vipm_vrng_(solve)           __P((vipm_scalar_t *, vipm_scalar_t *,
                                                     vipm_range_t const *, vipm_range_t const *));
__PUB void          vipm_vrng_(solve,cn)        __P((vipm_scalar_t [], vipm_scalar_t [],
                                                     vipm_range_t const [], vipm_range_t const [], vipm_int));

/* ------------------------------------------------------------------------- */

/*
 * @note: the `xequalize' functions can work with unnormalized value-ranges.
 *
 * vipm_range_t *vipm_vrng_(xequalize)  (anElemType, aDest, aSource, aChannelc);
 * vipm_range_t *vipm_vrng_(xequalize,I)(anElemType, aDestSrc, aChannelc);
 * vipm_range_t *vipm_vrng_(equalize)   (aDest, aSource, aChannelc);
 * vipm_range_t *vipm_vrng_(equalize,I) (aDestSrc, aChannelc);
 *
 * bool          vipm_vrng_(equalized)  (aValueRangev, aChannelc);
 */

__PUB vipm_range_t *vipm_vrng_(xequalize)   __P((vipm_uint, vipm_range_t [], vipm_range_t const [], vipm_int));
__PUB vipm_range_t *vipm_vrng_(xequalize,I) __P((vipm_uint, vipm_range_t [], vipm_int));
__PUB vipm_range_t *vipm_vrng_(equalize)    __P((vipm_range_t [], vipm_range_t const [], vipm_int));
__PUB vipm_range_t *vipm_vrng_(equalize,I)  __P((vipm_range_t [], vipm_int));

__PUB int           vipm_vrng_(equalized)   __P((vipm_range_t const [], vipm_int));

/* ------------------------------------------------------------------------- */

__PUB int   vipm_vrng_(xequal,S)    __P((vipm_uint, vipm_range_t const *, vipm_range_t const *));
__PUB int   vipm_vrng_(xequal)      __P((vipm_uint, vipm_range_t const *, vipm_range_t const *));
__PUB int   vipm_vrng_(equal,S)     __P((vipm_range_t const *, vipm_range_t const *));
__PUB int   vipm_vrng_(equal)       __P((vipm_range_t const *, vipm_range_t const *));

__PUB int   vipm_vrng_(xequal,cn,S) __P((vipm_uint, vipm_range_t const [], vipm_range_t const [], vipm_int));
__PUB int   vipm_vrng_(xequal,cn)   __P((vipm_uint, vipm_range_t const [], vipm_range_t const [], vipm_int));
__PUB int   vipm_vrng_(equal,cn,S)  __P((vipm_range_t const [], vipm_range_t const [], vipm_int));
__PUB int   vipm_vrng_(equal,cn)    __P((vipm_range_t const [], vipm_range_t const [], vipm_int));

/* ------------------------------------------------------------------------- */

/*
 * int vipm_vrng_(uxchk,cn)     (aValueRangev, aChannelc, aNumBitsMax, aNumBits);
 * int vipm_vrng_(sxchk,cn)     (aValueRangev, aChannelc, aNumBitsMax, aNumBits);
 * int vipm_vrng_(diffuxchk,cn) (aValueRangev, aChannelc, aNumBits);
 * int vipm_vrng_(m2chk,cn)     (aValueRangev, aChannelc);
 */

__PUB int   vipm_vrng_(uxchk,cn)        __P((vipm_range_t const [], vipm_int, vipm_int, vipm_int));
__PUB int   vipm_vrng_(sxchk,cn)        __P((vipm_range_t const [], vipm_int, vipm_int, vipm_int));
__PUB int   vipm_vrng_(diffuxchk,cn)    __P((vipm_range_t const [], vipm_int, vipm_int));
__PUB int   vipm_vrng_(m2chk,cn)        __P((vipm_range_t const [], vipm_int));


# define vipm_vrng_u8chk(vrng,_cn)          vipm_vrng_(uxchk,cn)(vrng,_cn,8,8)
# define vipm_vrng_u8P7chk(vrng,_cn)        vipm_vrng_(uxchk,cn)(vrng,_cn,8,7)
# define vipm_vrng_s8chk(vrng,_cn)          vipm_vrng_(sxchk,cn)(vrng,_cn,8,8)
# define vipm_vrng_s8P7chk(vrng,_cn)        vipm_vrng_(sxchk,cn)(vrng,_cn,8,7)

# define vipm_vrng_u16chk(vrng,_cn)         vipm_vrng_(uxchk,cn)(vrng,_cn,16,16)
# define vipm_vrng_u16P15chk(vrng,_cn)      vipm_vrng_(uxchk,cn)(vrng,_cn,16,15)
# define vipm_vrng_s16chk(vrng,_cn)         vipm_vrng_(sxchk,cn)(vrng,_cn,16,16)
# define vipm_vrng_s16P15chk(vrng,_cn)      vipm_vrng_(sxchk,cn)(vrng,_cn,16,15)

# define vipm_vrng_u32chk(vrng,_cn)         vipm_vrng_(uxchk,cn)(vrng,_cn,32,32)
# define vipm_vrng_u32P17chk(vrng,_cn)      vipm_vrng_(uxchk,cn)(vrng,_cn,32,17)
# define vipm_vrng_u32P18chk(vrng,_cn)      vipm_vrng_(uxchk,cn)(vrng,_cn,32,18)
# define vipm_vrng_u32P19chk(vrng,_cn)      vipm_vrng_(uxchk,cn)(vrng,_cn,32,19)
# define vipm_vrng_u32P20chk(vrng,_cn)      vipm_vrng_(uxchk,cn)(vrng,_cn,32,20)
# define vipm_vrng_u32P21chk(vrng,_cn)      vipm_vrng_(uxchk,cn)(vrng,_cn,32,21)
# define vipm_vrng_u32P22chk(vrng,_cn)      vipm_vrng_(uxchk,cn)(vrng,_cn,32,22)
# define vipm_vrng_u32P23chk(vrng,_cn)      vipm_vrng_(uxchk,cn)(vrng,_cn,32,23)
# define vipm_vrng_u32P24chk(vrng,_cn)      vipm_vrng_(uxchk,cn)(vrng,_cn,32,24)
# define vipm_vrng_u32P25chk(vrng,_cn)      vipm_vrng_(uxchk,cn)(vrng,_cn,32,25)
# define vipm_vrng_u32P26chk(vrng,_cn)      vipm_vrng_(uxchk,cn)(vrng,_cn,32,26)
# define vipm_vrng_u32P27chk(vrng,_cn)      vipm_vrng_(uxchk,cn)(vrng,_cn,32,27)
# define vipm_vrng_u32P31chk(vrng,_cn)      vipm_vrng_(uxchk,cn)(vrng,_cn,32,31)
# define vipm_vrng_s32chk(vrng,_cn)         vipm_vrng_(sxchk,cn)(vrng,_cn,32,32)
# define vipm_vrng_s32P17chk(vrng,_cn)      vipm_vrng_(sxchk,cn)(vrng,_cn,32,17)
# define vipm_vrng_s32P18chk(vrng,_cn)      vipm_vrng_(sxchk,cn)(vrng,_cn,32,18)
# define vipm_vrng_s32P19chk(vrng,_cn)      vipm_vrng_(sxchk,cn)(vrng,_cn,32,19)
# define vipm_vrng_s32P20chk(vrng,_cn)      vipm_vrng_(sxchk,cn)(vrng,_cn,32,20)
# define vipm_vrng_s32P21chk(vrng,_cn)      vipm_vrng_(sxchk,cn)(vrng,_cn,32,21)
# define vipm_vrng_s32P22chk(vrng,_cn)      vipm_vrng_(sxchk,cn)(vrng,_cn,32,22)
# define vipm_vrng_s32P23chk(vrng,_cn)      vipm_vrng_(sxchk,cn)(vrng,_cn,32,23)
# define vipm_vrng_s32P24chk(vrng,_cn)      vipm_vrng_(sxchk,cn)(vrng,_cn,32,24)
# define vipm_vrng_s32P25chk(vrng,_cn)      vipm_vrng_(sxchk,cn)(vrng,_cn,32,25)
# define vipm_vrng_s32P26chk(vrng,_cn)      vipm_vrng_(sxchk,cn)(vrng,_cn,32,26)
# define vipm_vrng_s32P27chk(vrng,_cn)      vipm_vrng_(sxchk,cn)(vrng,_cn,32,27)
# define vipm_vrng_s32P31chk(vrng,_cn)      vipm_vrng_(sxchk,cn)(vrng,_cn,32,31)


# define vipm_vrng_diffu8chk(vrng,_cn)      vipm_vrng_(diffuxchk,cn)(vrng,_cn,8)
# define vipm_vrng_diffu8P7chk(vrng,_cn)    vipm_vrng_(diffuxchk,cn)(vrng,_cn,7)
# define vipm_vrng_diffu16chk(vrng,_cn)     vipm_vrng_(diffuxchk,cn)(vrng,_cn,16)
# define vipm_vrng_diffu16P15chk(vrng,_cn)  vipm_vrng_(diffuxchk,cn)(vrng,_cn,15)
# define vipm_vrng_diffu32chk(vrng,_cn)     vipm_vrng_(diffuxchk,cn)(vrng,_cn,32)
# define vipm_vrng_diffu32P17chk(vrng,_cn)  vipm_vrng_(diffuxchk,cn)(vrng,_cn,17)
# define vipm_vrng_diffu32P18chk(vrng,_cn)  vipm_vrng_(diffuxchk,cn)(vrng,_cn,18)
# define vipm_vrng_diffu32P19chk(vrng,_cn)  vipm_vrng_(diffuxchk,cn)(vrng,_cn,19)
# define vipm_vrng_diffu32P20chk(vrng,_cn)  vipm_vrng_(diffuxchk,cn)(vrng,_cn,20)
# define vipm_vrng_diffu32P21chk(vrng,_cn)  vipm_vrng_(diffuxchk,cn)(vrng,_cn,21)
# define vipm_vrng_diffu32P22chk(vrng,_cn)  vipm_vrng_(diffuxchk,cn)(vrng,_cn,22)
# define vipm_vrng_diffu32P23chk(vrng,_cn)  vipm_vrng_(diffuxchk,cn)(vrng,_cn,23)
# define vipm_vrng_diffu32P24chk(vrng,_cn)  vipm_vrng_(diffuxchk,cn)(vrng,_cn,24)
# define vipm_vrng_diffu32P25chk(vrng,_cn)  vipm_vrng_(diffuxchk,cn)(vrng,_cn,25)
# define vipm_vrng_diffu32P26chk(vrng,_cn)  vipm_vrng_(diffuxchk,cn)(vrng,_cn,26)
# define vipm_vrng_diffu32P27chk(vrng,_cn)  vipm_vrng_(diffuxchk,cn)(vrng,_cn,27)
# define vipm_vrng_diffu32P31chk(vrng,_cn)  vipm_vrng_(diffuxchk,cn)(vrng,_cn,31)


/* +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ */

_VIPM_INLINE vipm_rngf32_t *vipm_rngf32(2)(vipm_rngf32_t *dp, bo_float32_t x0, bo_float32_t x1)
{
	dp->val[0] = x0;
	dp->val[1] = x1;
	return (dp);
}

_VIPM_INLINE vipm_rngf64_t *vipm_rngf64(2)(vipm_rngf64_t *dp, bo_float64_t x0, bo_float64_t x1)
{
	dp->val[0] = x0;
	dp->val[1] = x1;
	return (dp);
}


/* ========================================================================= */

_VIPM_INLINE vipm_range_t *vipm_vrng()(vipm_range_t *aThis)
{
	aThis->val[0] = 0;
	aThis->val[1] = 0;
	return (aThis);
}

_VIPM_INLINE vipm_range_t *
vipm_vrng(2)(vipm_range_t *aThis, vipm_scalar_t x0, vipm_scalar_t x1)
{
	aThis->val[0] = x0;
	aThis->val[1] = x1;
	return (aThis);
}

_VIPM_INLINE vipm_range_t *
vipm_vrng(2,Q)(vipm_uint anElemType, vipm_range_t *aThis, vipm_scalar_t x0, vipm_scalar_t x1)
{
	return vipm_vrng_(saturate,I)(anElemType, vipm_vrng(2)(aThis, x0, x1));
}


/* ------------------------------------------------------------------------- */

_VIPM_INLINE vipm_range_t *
vipm_vrng_(saturate,I)(vipm_uint anElemType, vipm_range_t *aDestSrc)
{
	return vipm_vrng_(saturate)(anElemType, aDestSrc, NULL);
}

/* ------------------------------------------------------------------------- */

_VIPM_INLINE vipm_range_t *
vipm_vrng_(saturate,cn,I)(vipm_uint anElemType, vipm_range_t aDestSrc[], vipm_int aChannelc)
{
	return vipm_vrng_(saturate,cn)(anElemType, aDestSrc, NULL, aChannelc);
}


/* ------------------------------------------------------------------------- */

_VIPM_INLINE vipm_range_t *
vipm_vrng_(normalize,IQS)(vipm_uint anElemType, vipm_range_t *aDestSrc, vipm_range_t const *aHint)
{
	return (NULL != aDestSrc ? vipm_vrng_(normalize,IQ)(anElemType, aDestSrc, aHint) : NULL);
}


_VIPM_INLINE vipm_range_t *
vipm_vrng_(normalize)(vipm_uint anElemType, vipm_range_t *aDest, vipm_range_t const *aSource,
		vipm_range_t const *aHint)
{
	if (NULL != aSource && aDest != aSource)
		*aDest = *aSource;
	return vipm_vrng_(normalize,I)(anElemType, aDest, aHint);
}

_VIPM_INLINE vipm_range_t *
vipm_vrng_(normalize,Q)(vipm_uint anElemType, vipm_range_t *aDest, vipm_range_t const *aSource,
		vipm_range_t const *aHint)
{
	if (NULL != aSource && aDest != aSource)
		*aDest = *aSource;
	return vipm_vrng_(normalize,IQ)(anElemType, aDest, aHint);
}

_VIPM_INLINE vipm_range_t *
vipm_vrng_(normalize,QS)(vipm_uint anElemType, vipm_range_t *aDest, vipm_range_t const *aSource,
		vipm_range_t const *aHint)
{
	if (NULL != aDest) {
		if (NULL != aSource && aDest != aSource)
			*aDest = *aSource;
		(void)vipm_vrng_(normalize,IQ)(anElemType, aDest, aHint);
	}
	return (aDest);
}

/* ------------------------------------------------------------------------- */

_VIPM_INLINE vipm_range_t *
vipm_vrng_(normalize,cn,IQS)(vipm_uint anElemType, vipm_range_t aDestSrc[],
		vipm_range_t const aHintv[], vipm_int aChannelc)
{
	return (NULL != aDestSrc
		? vipm_vrng_(normalize,cn,IQ)(anElemType, aDestSrc, aHintv, aChannelc)
		: NULL
	);
}


/* ------------------------------------------------------------------------- */

_VIPM_INLINE bo_status_t
vipm_vrng_(scale,Q)(vipm_uint anElemType, vipm_range_t *aDest, vipm_range_t const *aSource,
		vipm_scalar_t aScaleFactor, vipm_scalar_t aValueOrigin)
{
	return vipm_vrng_(scale,cn,Q)(anElemType, aDest, aSource, &aScaleFactor, &aValueOrigin, 1);
}


/* ------------------------------------------------------------------------- */

_VIPM_INLINE int
vipm_vrng_(equal)(vipm_range_t const *aLhs, vipm_range_t const *aRhs)
{
// @todo: fixme - ?
//	return (vipmi__equalf(aLhs->val[0], aRhs->val[0]) &&
//				vipmi__equalf(aLhs->val[1], aRhs->val[1]));
	return (vipmi__equalf(aLhs->val[0], aRhs->val[0]) &
				vipmi__equalf(aLhs->val[1], aRhs->val[1]));
}

_VIPM_INLINE int
vipm_vrng_(equal,S)(vipm_range_t const *aLhs, vipm_range_t const *aRhs)
{
	return (  NULL == aLhs ? (NULL == aRhs)
	        : NULL == aRhs ? 0
	                       : vipm_vrng_(equal)(aLhs, aRhs));
}


_VIPM_INLINE int
vipm_vrng_(xequal)(vipm_uint anElemType, vipm_range_t const *aLhs, vipm_range_t const *aRhs)
{
	vipm_range_t lhs, rhs;
	return vipm_vrng_(equal)(vipm_vrng_(normalize,Q)(anElemType, &lhs, aLhs, NULL),
			vipm_vrng_(normalize,Q)(anElemType, &rhs, aRhs, NULL));
}

_VIPM_INLINE int
vipm_vrng_(xequal,S)(vipm_uint anElemType, vipm_range_t const *aLhs, vipm_range_t const *aRhs)
{
	return (  NULL == aLhs ? (NULL == aRhs)
	        : NULL == aRhs ? 0
	                       : vipm_vrng_(xequal)(anElemType, aLhs, aRhs));
}


_VIPM_INLINE int
vipm_vrng_(equal,cn,S)(vipm_range_t const aLhs[], vipm_range_t const aRhs[], vipm_int aChannelc)
{
	return (  NULL == aLhs ? (NULL == aRhs)
	        : NULL == aRhs ? 0
	                       : vipm_vrng_(equal,cn)(aLhs, aRhs, aChannelc));
}

_VIPM_INLINE int
vipm_vrng_(xequal,cn,S)(vipm_uint anElemType, vipm_range_t const aLhs[],
		vipm_range_t const aRhs[], vipm_int aChannelc)
{
	return (  NULL == aLhs ? (NULL == aRhs)
	        : NULL == aRhs ? 0
	                       : vipm_vrng_(xequal,cn)(anElemType, aLhs, aRhs, aChannelc));
}


__MYC_END_CDECLS
# undef __PUB
# undef __VPUB


#endif /* !defined(__VIPM_UTILS_VALUERANGE_H__) */


/******************************************************************************
 *
 *
 *
 *****************************************************************************/
