/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright 2016 Seenaptec Ltd. All rights reserved.
 * SEENAPTEC PROPRIETARY/CONFIDENTIAL.
 *
 * $Id$
 */

/*
 * Xenv.h	(V.Sokur)
 * Vipm/Utils/Xenv.h
 */

/* ------------------------------------------------------------------------- */

#ifndef __VIPM_UTILS_XENV_H__
# define __VIPM_UTILS_XENV_H__

/******************************************************************************
 * %% BeginSection: includes
 */

# ifndef __VIPM_TYPES_H__
#  include <Vipm/Types.h>
# endif
# ifndef __BO_MEMMAN_MEMSTG__
#  include <Bo/memman/Memstg.h>
# endif


/******************************************************************************
 * %% BeginSection: function prototypes
 */
# pragma mark -
# pragma mark [ function prototypes ]
# pragma mark -

# include <Vipm/Linkage.h>
# define __PUB  __myc_flinkage__(public,libVipm)
# define __VPUB __myc_vlinkage__(public,libVipm)
__MYC_BEGIN_CDECLS

__PUB vipm_rref_t
vipm_mmstack_open(
#if __myc_require(prototypes)
	vipm_mutptr_t                   aMemory,
	vipm_rref_t                     aParentMmstack
#endif
	);

__PUB void
vipm_mmstack_close(
#if __myc_require(prototypes)
	vipm_rref_t                     aMmstack
#endif
	);

__PUB void
vipm_mmstack_destroy(
#if __myc_require(prototypes)
	vipm_rref_t                     aMmstack
#endif
	);

__PUB void
vipm_mmstack_reset(
#if __myc_require(prototypes)
	vipm_rref_t                     aMmstack
#endif
	);

__PUB vipm_mmstate_t *
vipm_mmstack_state(
#if __myc_require(prototypes)
	vipm_rref_t                     aMmstack,
	vipm_mmstate_t                 *aState
#endif
	);

__PUB vipm_rref_t
vipm_mmstack_setstate(
#if __myc_require(prototypes)
	vipm_rref_t                     aMmstack,
	vipm_mmstate_t const           *aState
#endif
	);

__PUB vipm_mutptr_t
vipm_mmstack_alloca(
#if __myc_require(prototypes)
	vipm_rref_t                     aMmstack,
	bo_size_t                       aBytec,
	bo_size_t                       Align
#endif
	);

__PUB void
vipm_mmstack_freea(
#if __myc_require(prototypes)
	vipm_rref_t                     aMmstack,
	vipm_mutptr_t                   aPtr
#endif
	);


/* ========================================================================= */

__PUB vipm_xenv_t *
VipmXEopen(
#if __myc_require(prototypes)
	vipm_xenv_t                    *aXenv,
	vipm_rref_t                     aXtrnMmstack,
	vipm_rref_t                     aParentMmstack
#endif
	);

__PUB void
VipmXEclose(
#if __myc_require(prototypes)
	vipm_xenv_t                    *aXenv
#endif
	);

__PUB vipm_xenv_t *
VipmXEinit(
#if __myc_require(prototypes)
	vipm_xenv_t                    *aXenv,
	vipm_rref_t                     aXtrnMmstack
#endif
	);

__PUB vipm_xenv_t *
VipmXEinit2(
#if __myc_require(prototypes)
	vipm_xenv_t                    *aXenv,
	vipm_rref_t                     aXtrnMmstack,
	vipm_rref_t                     aParentMmstack
#endif
	);

__PUB vipm_xenv_t *
VipmXEfini(
#if __myc_require(prototypes)
	vipm_xenv_t                    *aXenv
#endif
	);

__PUB vipm_xenv_t *
VipmXEclear(
#if __myc_require(prototypes)
	vipm_xenv_t                    *aXenv
#endif
	);

/* ------------------------------------------------------------------------- */

__PUB int
VipmXEuseSimd(
#if __myc_require(prototypes)
	vipm_xenv_t                    *aXenv,
	vipm_ulong                      Options,
	vipm_rref_t                     aParm
#endif
	);

/* ------------------------------------------------------------------------- */

__PUB vipm_mutptr_t
VipmXEalloca(
#if __myc_require(prototypes)
	vipm_xenv_t                    *aXenv,
	bo_size_t                       aBytec,
	bo_size_t                       Align
#endif
	);

__PUB void
VipmXEfreea(
#if __myc_require(prototypes)
	vipm_xenv_t                    *aXenv,
	vipm_mutptr_t                   aPtr
#endif
	);


__PUB void
VipmXEgetmmsp(
#if __myc_require(prototypes)
	vipm_xenv_t                    *aXenv,
	vipm_mmstate_t                 *aState
#endif
	);

__PUB void
VipmXEsetmmsp(
#if __myc_require(prototypes)
	vipm_xenv_t                    *aXenv,
	vipm_mmstate_t const           *aState
#endif
	);

/* ------------------------------------------------------------------------- */

__PUB vipm_xenv_t *
VipmXEinitMmstack(
#if __myc_require(prototypes)
	vipm_xenv_t                    *aXenv,
	vipm_rref_t                     aParentMmstack
#endif
	);

__PUB vipm_xenv_t *
VipmXEdestroyMmstack(
#if __myc_require(prototypes)
	vipm_xenv_t                    *aXenv
#endif
	);

__PUB vipm_xenv_t *
VipmXEresetMmstack(
#if __myc_require(prototypes)
	vipm_xenv_t                    *aXenv,
	vipm_rref_t                     aXtrnMmstack,       /* = NULL */
	vipm_rref_t                     aParentMmstack      /* = NULL */
#endif
	);

__PUB vipm_rref_t
VipmXEmmstack(
#if __myc_require(prototypes)
	vipm_xenv_t                    *aXenv
#endif
	);


/* +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ */

/* @todo: fixme; @{ */
# define vipm_mmstack_close(stg)        BoMEMSTGclose((void *)(stg))
# define vipm_mmstack_destroy(stg)      BoMEMSTGdestroy((void *)(stg))
# define vipm_mmstack_open(m,p)        ((vipm_rref_t) BoSMEMSTGopen(m,p,NULL))
# define vipm_mmstack_reset(stg)        BoSMEMSTGclear((void *)(stg))
# define vipm_mmstack_state(stg,sp)    (BoSMEMSTGgetstate(&(sp)->imp_,(void *)(stg)),(sp))
# define vipm_mmstack_setstate(stg,sp) ((vipm_rref_t) BoSMEMSTGsetstate((void *)(stg),&(sp)->imp_))
# define vipm_mmstack_alloca(stg,n,a)   BoSMEMSTGaalloc((void *)(stg), n, ((a) ? (a) : __VIPM_BASE_ALIGN), NULL)
# define vipm_mmstack_freea(stg,p)      BoSMEMSTGfree((void *)(stg),p)
# define VipmXEinit(x,s)                VipmXEinit2(x, s, (vipm_rref_t)NULL)
# define VipmXEdestroyMmstack(x)        VipmXEresetMmstack(x, (vipm_rref_t)NULL, (vipm_rref_t)NULL)
/* @} */


__MYC_END_CDECLS
# undef __PUB
# undef __VPUB

#endif /* !defined(__VIPM_UTILS_XENV_H__) */


/******************************************************************************
 *
 *
 *
 *****************************************************************************/
