/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright 2007 Seenaptec Ltd. All rights reserved.
 * SEENAPTEC PROPRIETARY/CONFIDENTIAL.
 *
 * $Id$
 */

/*
 * VipmAll.h	(V.Sokur)
 * Vipm/VipmAll.h
 */

/* ------------------------------------------------------------------------- */

#ifndef __VIPM_VIPMALL_H__
# define __VIPM_VIPMALL_H__

/******************************************************************************
 * %% BeginSection: includes
 */

# ifndef __VIPM_TYPES_H__
#  include <Vipm/Types.h>
# endif
# ifndef __VIPM_UTILS_H__
#  include <Vipm/Utils.h>
# endif

# ifndef __BO_SYS_BYTEORDER__
#  include <Bo/sys/Byteorder.h>
# endif


/******************************************************************************
 * %% BeginSection: conditional macros
 */

# ifndef _VIPM_NEED_ALL_ALG
#  define _VIPM_NEED_ALL_ALG            1
# endif

# ifndef _VIPM_NEED_ANALYSIS_ALG
#  define _VIPM_NEED_ANALYSIS_ALG     _VIPM_NEED_ALL_ALG
# endif
# ifndef _VIPM_NEED_ARITHLOGIC_ALG
#  define _VIPM_NEED_ARITHLOGIC_ALG     _VIPM_NEED_ALL_ALG
# endif
# ifndef _VIPM_NEED_COMPARING_ALG
#  define _VIPM_NEED_COMPARING_ALG      _VIPM_NEED_ALL_ALG
# endif
# ifndef _VIPM_NEED_DXCHGINIT_ALG
#  define _VIPM_NEED_DXCHGINIT_ALG      _VIPM_NEED_ALL_ALG
# endif
# ifndef _VIPM_NEED_FEATDETECT_ALG
#  define _VIPM_NEED_FEATDETECT_ALG     _VIPM_NEED_ALL_ALG
# endif
# ifndef _VIPM_NEED_FILTERING_ALG
#  define _VIPM_NEED_FILTERING_ALG      _VIPM_NEED_ALL_ALG
# endif
# ifndef _VIPM_NEED_MORPHOLOGY_ALG
#  define _VIPM_NEED_MORPHOLOGY_ALG     _VIPM_NEED_ALL_ALG
# endif
# ifndef _VIPM_NEED_STATISTICS_ALG
#  define _VIPM_NEED_STATISTICS_ALG     _VIPM_NEED_ALL_ALG
# endif
# ifndef _VIPM_NEED_WARP_ALG
#  define _VIPM_NEED_WARP_ALG           _VIPM_NEED_ALL_ALG
# endif

#endif /* !defined(__VIPM_VIPMALL_H__) */

/* ========================================================================= */

#ifndef __VIPM_GENERIC_H__
# include <Vipm/Generic.h>
#endif


/*
 * Analysis (Watershed Operations)
 */
#if _VIPM_NEED_ANALYSIS_ALG
# undef _VIPM_NEED_ANALYSIS_ALG
# define _VIPM_NEED_ANALYSIS_ALG      0
# ifndef __VIPM_ANALYSIS_H__
#  include "Vipm/Analysis.h"
# endif
#endif

/*
 * Arithmetic/Logical [Operations]
 */
#if _VIPM_NEED_ARITHLOGIC_ALG
# undef _VIPM_NEED_ARITHLOGIC_ALG
# define _VIPM_NEED_ARITHLOGIC_ALG      0
# ifndef __VIPM_ARITHLOGIC_H__
#  include "Vipm/ArithLogic.h"
# endif
#endif

/*
 * Comparing/Thresholding [Operations]
 */
#if _VIPM_NEED_COMPARING_ALG
# undef _VIPM_NEED_COMPARING_ALG
# define _VIPM_NEED_COMPARING_ALG      0
# ifndef __VIPM_COMPARING_H__
#  include "Vipm/Comparing.h"
# endif
#endif

/*
 * Data Exchange/Initialization [Operations]
 */
#if _VIPM_NEED_DXCHGINIT_ALG
# undef _VIPM_NEED_DXCHGINIT_ALG
# define _VIPM_NEED_DXCHGINIT_ALG       0
# ifndef __VIPM_DXCHGINIT_H__
#  include "Vipm/DXchgInit.h"
# endif
#endif

/*
 * Feature detector (MSER operations)
 */
#if _VIPM_NEED_FEATDETECT_ALG
# undef _VIPM_NEED_FEATDETECT_ALG
# define _VIPM_NEED_FEATDETECT_ALG       0
# ifndef __VIPM_FEATDETECT_H__
#  include "Vipm/FeatDetect.h"
# endif
#endif

/*
 * Filtering [Operations]
 */
#if _VIPM_NEED_FILTERING_ALG
# undef _VIPM_NEED_FILTERING_ALG
# define _VIPM_NEED_FILTERING_ALG       0
# ifndef __VIPM_FILTERING_H__
#  include "Vipm/Filtering.h"
# endif
#endif

/*
 * Morphology (Morphological Operations)
 */
#if _VIPM_NEED_MORPHOLOGY_ALG
# undef _VIPM_NEED_MORPHOLOGY_ALG
# define _VIPM_NEED_MORPHOLOGY_ALG      0
# ifndef __VIPM_MORPHOLOGY_H__
#  include "Vipm/Morphology.h"
# endif
#endif

/*
 * Statistics [Operations]
 */
#if _VIPM_NEED_STATISTICS_ALG
# undef _VIPM_NEED_STATISTICS_ALG
# define _VIPM_NEED_STATISTICS_ALG      0
# ifndef __VIPM_STATISTICS_H__
#  include "Vipm/Statistics.h"
# endif
#endif

/*
 * Warp Transformation [Operations]
 */
#if _VIPM_NEED_WARP_ALG
# undef _VIPM_NEED_WARP_ALG
# define _VIPM_NEED_WARP_ALG       0
# ifndef __VIPM_WARP_H__
#  include "Vipm/Warp.h"
# endif
#endif


/******************************************************************************
 *
 *
 *
 *****************************************************************************/
