/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright 2016 Seenaptec Ltd. All rights reserved.
 * SEENAPTEC PROPRIETARY/CONFIDENTIAL.
 *
 * $Id$
 */

/*
 * Resize.h	(V.Sokur)
 * Vipm/Warp/Resize.h
 */

/* ------------------------------------------------------------------------- */

#ifndef __VIPM_WARP_RESIZE_H__
# define __VIPM_WARP_RESIZE_H__

/******************************************************************************
 * %% BeginSection: includes
 */

# ifndef __VIPM_WARP_RESIZE_ALGORITHM_H__
#  include "Vipm/Warp/Resize/Algorithm.h"
# endif
# ifndef __VIPM_WARP_RESIZE_UTILS_H__
#  include "Vipm/Warp/Resize/Utils.h"
# endif


/******************************************************************************
 * %% BeginSection: function prototypes
 */
# pragma mark -
# pragma mark [ function prototypes ]
# pragma mark -

# include <Vipm/Linkage.h>
# define __PUB  __myc_flinkage__(public,libVipm)
# define __PRIV __myc_flinkage__(private,libVipm)
__MYC_BEGIN_CDECLS

__PUB bo_status_t
VipmResize(
# if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_mut_array_t                aDest,
	vipm_array_t                    aSource,
	vipm_site_t const              *aRoiDst,
	vipm_Npoint_t const            *aStartSrc,
	vipm_int                        anInterMethod,
	vipm_scalar_t const             aReszFactor[/* grank(aDest) */]       /* =NULL */
# endif
	);

__PUB bo_status_t
VipmEResize(
# if __myc_require(prototypes)
	struct _Vipm_xenv              *aXenv,
	vipm_ulong                      Options,
	vipm_mut_array_t                aDest,
	vipm_array_t                    aSource,
	vipm_site_t const              *aRoiDst,
	vipm_site_t const              *aRoiSrc,
	vipm_int                        anInterMethod,
	vipm_scalar_t const             aReszFactor[/* grank(aDest) */]       /* =NULL */
# endif
	);


__MYC_END_CDECLS
# undef __PUB
# undef __PRIV


#endif /* !defined(__VIPM_WARP_RESIZE_H__) */


/******************************************************************************
 *
 *
 *
 *****************************************************************************/
