/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright 2016 Seenaptec Ltd. All rights reserved.
 * SEENAPTEC PROPRIETARY/CONFIDENTIAL.
 *
 * $Id$
 */

/*
 * ACB.h	(V.Sokur)
 * Vipm/_Types/ACB.h
 */

/* ------------------------------------------------------------------------- */

#ifndef __VIPM__TYPES_ACB_H__
# define __VIPM__TYPES_ACB_H__

/******************************************************************************
 * %% BeginSection: includes
 */

/*
# ifndef __VIPM_CDEFS_H__
#  include <Vipm/Cdefs.h>
# endif

# ifndef __VIPM__TYPES_CORE__TYPES_H__
#  include "Vipm/_Types/Core_Types.h"
# endif

#if 0
# ifndef __VIPM__TYPES_XENV_H__
#  include "Vipm/_Types/Xenv.h"
# endif
#endif
 */


/******************************************************************************
 * %% BeginSection: constant declarations / definitions
 */

/*
 * @{
 * Algorithm Control Block
 */

/*
 * Algorithm category
 */

/* @note: DO NOT MODIFY VALUES OF ACB CATEGORY CONSTANTS */
/* @sa: alg_call (GenericP.h) */
# define VipmK_UNK_ALG                  0
# define VipmK_CUSTOM_ALG               VipmK_UNK_ALG
# define VipmK_GEN_ALG                  1
# define VipmK_MAP_ALG                  2
# define VipmK_ZIP_ALG                  3
# define VipmK_ZIP3_ALG                 4
# define VipmK_ZIP4_ALG                 5

# define VipmK_MAXALGARGS               5

# define VIPM_ALG_NARGS(Cat)            Cat

/*
 * Algorithm [routine] hints
 */
# define VipmF_ALGH_SIMD                0x1
# define VipmF_ALGH_GPINTPAD            0x2


struct _Vipm_xenv;

struct _Vipm_algcb;
struct _Vipm_local_algcb;


typedef bo_status_t (*vipma_unknown_fn) __P((void));
typedef bo_status_t (*vipma_cpsalg_fn)  __P((struct _Vipm_algcb *, vipm_ulong, struct _Vipm_local_algcb *));


struct _Vipm_spcarg {
	vipm_int               *start;
	vipm_int               *stride;
};

struct _Vipm_algarg {
	vipm_uint               elemtype;
	vipm_mutptr_t           base;
	vipm_int const         *start;
	vipm_int const         *stride;
};


struct _Vipm_local_algcb {
	vipm_ushort             prank, /* primary rank and reduction */
	                        rrank;
	vipm_rank_t             rank;
	vipm_int               *volume;
	struct _Vipm_spcarg     sargv[1];
};
# define _VIPM_LOCAL_ALGCB_STRUCT(_Name,N) \
struct _Name {                             \
	vipm_ushort             prank,         \
	                        rrank;         \
	vipm_rank_t             rank;          \
	vipm_int               *volume;        \
	struct _Vipm_spcarg     sargv[N];      \
}

struct _Vipm_algcb {
	bo_uint16_t             algcat;
	bo_int16_t              pintpad; /* (pintpad<0) ==> (pintpad := default-value{simd,reg}) */
	bo_uint32_t             optype;
	bo_uint32_t             opsign;
	bo_status_t           (*routine) __P((void));
	char const             *algname;
	struct _Vipm_xenv      *xenv;
	vipm_ulong              options;
	vipm_rref_t             parm;
	vipm_int                prank;   /* primary rank */
	vipm_int                minrank; /* required to be one of (2,3) */
	vipm_int const         *volume;
	struct _Vipm_algarg     argv[1];
};
# define _VIPM_ALGCB_STRUCT(_Name,N)      \
struct _Name {                            \
	bo_uint16_t             algcat;       \
	bo_int16_t              pintpad;      \
	bo_uint32_t             optype;       \
	bo_uint32_t             opsign;       \
	bo_status_t           (*routine) __P((void)); \
	char const             *algname;      \
	struct _Vipm_xenv      *xenv;         \
	vipm_ulong              options;      \
	vipm_rref_t             parm;         \
	vipm_int                prank;        \
	vipm_int                minrank;      \
	vipm_int const         *volume;       \
	struct _Vipm_algarg     argv[N];      \
}


_VIPM_LOCAL_ALGCB_STRUCT(_Vipm_local_anyalgcb,VipmK_MAXALGARGS);
_VIPM_ALGCB_STRUCT(_Vipm_anyalgcb,VipmK_MAXALGARGS);

/*
 * Algorithm Control Block
 * @}
 */

#endif /* !defined(__VIPM__TYPES_ACB_H__) */


/******************************************************************************
 *
 *
 *
 *****************************************************************************/
