/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright 2016 Seenaptec Ltd. All rights reserved.
 * SEENAPTEC PROPRIETARY/CONFIDENTIAL.
 *
 * $Id$
 */

/*
 * Base_Cast.h	(V.Sokur)
 * Vipm/_Types/Base_Cast.h
 */

/* ------------------------------------------------------------------------- */

#ifndef __VIPM__TYPES_BASE__CAST_H__
# define __VIPM__TYPES_BASE__CAST_H__

/******************************************************************************
 * %% BeginSection: includes
 */

/*
# ifndef __VIPM_CDEFS_H__
#  include <Vipm/Cdefs.h>
# endif

# ifndef __VIPM__TYPES_BASE__TYPES_H__
#  include "Vipm/_Types/Base_Types.h"
# endif
# ifndef __VIPM__TYPES_BASE__LIMITS_H__
#  include "Vipm/_Types/Base_Limits.h"
# endif
 */


/******************************************************************************
 * %% BeginSection: constant declarations / definitions
 */

/*
 * @{
 * Cast/Saturate
 */

/*
 * Saturate destination: I8
 */
# if __myc_support(macro_retval)

#  define vipm_satcast_u8s8(v)                                         \
	__extension__ ({                                                   \
		bo_int8_t ___u8s8v = (bo_int8_t)(v);                           \
		/* return */ ( 0 <= ___u8s8v ? (bo_uint8_t)___u8s8v            \
		                             : (bo_uint8_t)0 );                \
	})
#  define vipm_satcast_u8uint(v)                                                    \
	__extension__ ({                                                                \
		vipm_uint ___u8uiv = (vipm_uint)(v);                                        \
		/* return */ ( ___u8uiv <= VipmK_UCHAR_MAX ? (bo_uint8_t)___u8uiv           \
		                                           : (bo_uint8_t)VipmK_UCHAR_MAX ); \
	})
#  define vipm_satcast_u8sint(v)                                                    \
	__extension__ ({                                                                \
		vipm_int ___u8siv = (vipm_int)(v);                                          \
		/* return */ ( ___u8siv <= 0               ? (bo_uint8_t)0                  \
		             : ___u8siv <= VipmK_UCHAR_MAX ? (bo_uint8_t)___u8siv           \
		                                           : (bo_uint8_t)VipmK_UCHAR_MAX ); \
	})
#  define vipm_satcast_u8u64(v)                                                     \
	__extension__ ({                                                                \
		bo_uint64_t ___u8ulv = (bo_uint64_t)(v);                                    \
		/* return */ ( ___u8ulv <= VipmK_UCHAR_MAX ? (bo_uint8_t)___u8ulv           \
		                                           : (bo_uint8_t)VipmK_UCHAR_MAX ); \
	})
#  define vipm_satcast_u8s64(v)                                                     \
	__extension__ ({                                                                \
		bo_int64_t ___u8slv = (bo_int64_t)(v);                                      \
		/* return */ ( ___u8slv <= 0               ? (bo_uint8_t)0                  \
		             : ___u8slv <= VipmK_UCHAR_MAX ? (bo_uint8_t)___u8slv           \
		                                           : (bo_uint8_t)VipmK_UCHAR_MAX ); \
	})

#  define vipm_satcast_s8u8(v)                                                      \
	__extension__ ({                                                                \
		bo_uint8_t ___s8u8v = (bo_uint8_t)(v);                                      \
		/* return */ ( ___s8u8v <= VipmK_SCHAR_MAX ? (bo_int8_t)___s8u8v            \
		                                           : (bo_int8_t)VipmK_SCHAR_MAX );  \
	})
#  define vipm_satcast_s8uint(v)                                                    \
	__extension__ ({                                                                \
		vipm_uint ___i8uiv = (vipm_uint)(v);                                        \
		/* return */ ( ___i8uiv <= VipmK_SCHAR_MAX ? (bo_int8_t)___i8uiv            \
		                                           : (bo_int8_t)VipmK_SCHAR_MAX );  \
	})
#  define vipm_satcast_s8sint(v)                                                    \
	__extension__ ({                                                                \
		vipm_int ___i8siv = (vipm_int)(v);                                          \
		/* return */ ( ___i8siv <= VipmK_SCHAR_MIN ? (bo_int8_t)VipmK_SCHAR_MIN     \
		             : ___i8siv <= VipmK_SCHAR_MAX ? (bo_int8_t)___i8siv            \
		                                          : (bo_int8_t)VipmK_SCHAR_MAX );   \
	})
#  define vipm_satcast_s8u64(v)                                                     \
	__extension__ ({                                                                \
		bo_uint64_t ___i8ulv = (bo_uint64_t)(v);                                    \
		/* return */ ( ___i8ulv <= VipmK_SCHAR_MAX ? (bo_int8_t)___i8ulv            \
		                                           : (bo_int8_t)VipmK_SCHAR_MAX );  \
	})
#  define vipm_satcast_s8s64(v)                                                     \
	__extension__ ({                                                                \
		bo_int64_t ___i8slv = (bo_int64_t)(v);                                      \
		/* return */ ( ___i8slv <= VipmK_SCHAR_MIN ? (bo_int8_t)VipmK_SCHAR_MIN     \
		             : ___i8slv <= VipmK_SCHAR_MAX ? (bo_int8_t)___i8slv            \
		                                          : (bo_int8_t)VipmK_SCHAR_MAX );   \
	})

# else /* !__myc_support(macro_retval) */

__MYC_BEGIN_CDECLS

bo_uint8_t vipm_satcast_u8s8   __P((bo_int8_t));
bo_uint8_t vipm_satcast_u8uint __P((vipm_uint));
bo_uint8_t vipm_satcast_u8sint __P((vipm_int));
bo_int8_t  vipm_satcast_s8u8   __P((bo_uint8_t));
bo_int8_t  vipm_satcast_s8uint __P((vipm_uint));
bo_int8_t  vipm_satcast_s8sint __P((vipm_int));

_VIPM_INLINE bo_uint8_t vipm_satcast_u8s8(bo_int8_t v)
{
	return (0 <= v ? (bo_uint8_t)v : 0);
}
_VIPM_INLINE bo_uint8_t vipm_satcast_u8uint(vipm_uint v)
{
	return (v <= VipmK_UCHAR_MAX ? (bo_uint8_t)v : VipmK_UCHAR_MAX);
}
_VIPM_INLINE bo_uint8_t vipm_satcast_u8sint(vipm_int v)
{
	return ( v <= 0               ? 0
	       : v <= VipmK_UCHAR_MAX ? (bo_uint8_t)v
	                              : VipmK_UCHAR_MAX );
}
_VIPM_INLINE bo_uint8_t vipm_satcast_u8u64(bo_uint64_t v)
{
	return (v <= VipmK_UCHAR_MAX ? (bo_uint8_t)v : VipmK_UCHAR_MAX);
}
_VIPM_INLINE bo_uint8_t vipm_satcast_u8s64(bo_int64_t v)
{
	return ( v <= 0               ? 0
	       : v <= VipmK_UCHAR_MAX ? (bo_uint8_t)v
	                              : VipmK_UCHAR_MAX );
}

_VIPM_INLINE bo_int8_t vipm_satcast_s8u8(bo_uint8_t v)
{
	return (v <= VipmK_SCHAR_MAX ? (bo_int8_t)v : VipmK_SCHAR_MAX);
}
_VIPM_INLINE bo_int8_t vipm_satcast_s8uint(vipm_uint v)
{
	return (v <= VipmK_SCHAR_MAX ? (bo_int8_t)v : VipmK_SCHAR_MAX);
}
_VIPM_INLINE bo_int8_t vipm_satcast_s8sint(vipm_int v)
{
	return ( v <= VipmK_SCHAR_MIN ? VipmK_SCHAR_MIN
	       : v <= VipmK_SCHAR_MAX ? (bo_int8_t)v
	                              : VipmK_SCHAR_MAX );
}
_VIPM_INLINE bo_int8_t vipm_satcast_s8u64(bo_uint64_t v)
{
	return (v <= VipmK_SCHAR_MAX ? (bo_int8_t)v : VipmK_SCHAR_MAX);
}
_VIPM_INLINE bo_int8_t vipm_satcast_s8s64(bo_int64_t v)
{
	return ( v <= VipmK_SCHAR_MIN ? VipmK_SCHAR_MIN
	       : v <= VipmK_SCHAR_MAX ? (bo_int8_t)v
	                              : VipmK_SCHAR_MAX );
}

__MYC_END_CDECLS

# endif /* __myc_support(macro_retval) */

/*
# define vipm_satcast_u8s8(v)
# define vipm_satcast_u8sint(v)
# define vipm_satcast_u8uint(v)
# define vipm_satcast_u8s64(v)
# define vipm_satcast_u8u64(v)
# define vipm_satcast_s8u8(v)
# define vipm_satcast_s8uint(v)
# define vipm_satcast_s8sint(v)
# define vipm_satcast_s8u64(v)
# define vipm_satcast_s8s64(v)
 */
/* @todo: fixme; rint with saturate */
# define vipm_satcast_u8f(v)       vipm_satcast_u8sint(vipmi_rintf((float)(v)))
# define vipm_satcast_u8d(v)       vipm_satcast_u8sint(vipmi_rintd((double)(v)))
# define vipm_satcast_s8f(v)       vipm_satcast_s8sint(vipmi_rintf((float)(v)))
# define vipm_satcast_s8d(v)       vipm_satcast_s8sint(vipmi_rintd((double)(v)))


/*
 * Saturate destination: I16
 */
# if __myc_support(macro_retval)

#  define vipm_satcast_u16s16(v)                                                      \
	__extension__ ({                                                                  \
		bo_int16_t ___u16s16v = (bo_int16_t)(v);                                      \
		/* return */ ( 0 <= ___u16s16v ? (bo_uint16_t)___u16s16v                      \
		                               : (bo_uint16_t)0 );                            \
	})
#  define vipm_satcast_u16uint(v)                                                     \
	__extension__ ({                                                                  \
		vipm_uint ___u16uiv = (vipm_uint)(v);                                         \
		/* return */ ( ___u16uiv <= VipmK_USHRT_MAX ? (bo_uint16_t)___u16uiv          \
		                                            : (bo_uint16_t)VipmK_USHRT_MAX ); \
	})
#  define vipm_satcast_u16sint(v)                                                     \
	__extension__ ({                                                                  \
		vipm_int ___u16siv = (vipm_int)(v);                                           \
		/* return */ ( ___u16siv <= 0               ? (bo_uint16_t)0                  \
		             : ___u16siv <= VipmK_USHRT_MAX ? (bo_uint16_t)___u16siv          \
		                                            : (bo_uint16_t)VipmK_USHRT_MAX ); \
	})
#  define vipm_satcast_u16u64(v)                                                      \
	__extension__ ({                                                                  \
		bo_uint64_t ___u16ulv = (bo_uint64_t)(v);                                     \
		/* return */ ( ___u16ulv <= VipmK_USHRT_MAX ? (bo_uint16_t)___u16ulv          \
		                                            : (bo_uint16_t)VipmK_USHRT_MAX ); \
	})
#  define vipm_satcast_u16s64(v)                                                      \
	__extension__ ({                                                                  \
		bo_int64_t ___u16slv = (bo_int64_t)(v);                                       \
		/* return */ ( ___u16slv <= 0               ? (bo_uint16_t)0                  \
		             : ___u16slv <= VipmK_USHRT_MAX ? (bo_uint16_t)___u16slv          \
		                                            : (bo_uint16_t)VipmK_USHRT_MAX ); \
	})

#  define vipm_satcast_s16u16(v)                                                    \
	__extension__ ({                                                                \
		bo_uint16_t ___s16u16v = (bo_uint16_t)(v);                                  \
		/* return */ ( ___s16u16v <= VipmK_SHRT_MAX ? (bo_int16_t)___s16u16v        \
		                                            : (bo_int16_t)VipmK_SHRT_MAX ); \
	})
#  define vipm_satcast_s16uint(v)                                                   \
	__extension__ ({                                                                \
		vipm_uint ___i16uiv = (vipm_uint)(v);                                       \
		/* return */ ( ___i16uiv <= VipmK_SHRT_MAX ? (bo_int16_t)___i16uiv          \
		                                           : (bo_int16_t)VipmK_SHRT_MAX );  \
	})
#  define vipm_satcast_s16sint(v)                                                   \
	__extension__ ({                                                                \
		int ___i16siv = (int)(v);                                                   \
		/* return */ ( ___i16siv <= VipmK_SHRT_MIN ? (bo_int16_t)VipmK_SHRT_MIN     \
		             : ___i16siv <= VipmK_SHRT_MAX ? (bo_int16_t)___i16siv          \
		                                           : (bo_int16_t)VipmK_SHRT_MAX );  \
	})
#  define vipm_satcast_s16u64(v)                                                    \
	__extension__ ({                                                                \
		bo_uint64_t ___i16ulv = (bo_uint64_t)(v);                                   \
		/* return */ ( ___i16ulv <= VipmK_SHRT_MAX ? (bo_int16_t)___i16ulv          \
		                                           : (bo_int16_t)VipmK_SHRT_MAX );  \
	})
#  define vipm_satcast_s16s64(v)                                                    \
	__extension__ ({                                                                \
		bo_int64_t ___i16slv = (bo_int64_t)(v);                                     \
		/* return */ ( ___i16slv <= VipmK_SHRT_MIN ? (bo_int16_t)VipmK_SHRT_MIN     \
		             : ___i16slv <= VipmK_SHRT_MAX ? (bo_int16_t)___i16slv          \
		                                           : (bo_int16_t)VipmK_SHRT_MAX );  \
	})

# else /* !__myc_support(macro_retval) */

__MYC_BEGIN_CDECLS

bo_uint16_t vipm_satcast_u16s16  __P((bo_int16_t));
bo_uint16_t vipm_satcast_u16uint __P((vipm_uint));
bo_uint16_t vipm_satcast_u16sint __P((vipm_int));
bo_int16_t  vipm_satcast_s16u16  __P((bo_uint16_t));
bo_int16_t  vipm_satcast_s16uint __P((vipm_uint));
bo_int16_t  vipm_satcast_s16sint __P((vipm_int));

_VIPM_INLINE bo_uint16_t vipm_satcast_u16s16(bo_int16_t v)
{
	return (0 <= v ? (bo_uint16_t)v : 0);
}
_VIPM_INLINE bo_uint16_t vipm_satcast_u16uint(vipm_uint v)
{
	return (v <= VipmK_USHRT_MAX ? (bo_uint16_t)v : VipmK_USHRT_MAX);
}
_VIPM_INLINE bo_uint16_t vipm_satcast_u16sint(vipm_int v)
{
	return ( v <= 0               ? 0
	       : v <= VipmK_USHRT_MAX ? (bo_uint16_t)v
	                              : VipmK_USHRT_MAX );
}
_VIPM_INLINE bo_uint16_t vipm_satcast_u16u64(bo_uint64_t v)
{
	return (v <= VipmK_USHRT_MAX ? (bo_uint16_t)v : VipmK_USHRT_MAX);
}
_VIPM_INLINE bo_uint16_t vipm_satcast_u16s64(bo_int64_t v)
{
	return ( v <= 0               ? 0
	       : v <= VipmK_USHRT_MAX ? (bo_uint16_t)v
	                              : VipmK_USHRT_MAX );
}

_VIPM_INLINE bo_int16_t vipm_satcast_s16u16(bo_uint16_t v)
{
	return (v <= VipmK_SHRT_MAX ? (bo_int16_t)v : VipmK_SHRT_MAX);
}
_VIPM_INLINE bo_int16_t vipm_satcast_s16uint(vipm_uint v)
{
	return (v <= VipmK_SHRT_MAX ? (bo_int16_t)v : VipmK_SHRT_MAX);
}
_VIPM_INLINE bo_int16_t vipm_satcast_s16sint(vipm_int v)
{
	return ( v <= VipmK_SHRT_MIN ? VipmK_SHRT_MIN
	       : v <= VipmK_SHRT_MAX ? (bo_int16_t)v
	                             : VipmK_SHRT_MAX );
}
_VIPM_INLINE bo_int16_t vipm_satcast_s16u64(bo_uint64_t v)
{
	return (v <= VipmK_SHRT_MAX ? (bo_int16_t)v : VipmK_SHRT_MAX);
}
_VIPM_INLINE bo_int16_t vipm_satcast_s16s64(bo_int64_t v)
{
	return ( v <= VipmK_SHRT_MIN ? VipmK_SHRT_MIN
	       : v <= VipmK_SHRT_MAX ? (bo_int16_t)v
	                             : VipmK_SHRT_MAX );
}

__MYC_END_CDECLS

# endif /* __myc_support(macro_retval) */

/*
# define vipm_satcast_u16s16(v)
# define vipm_satcast_u16sint(v)
# define vipm_satcast_u16uint(v)
# define vipm_satcast_u16s64(v)
# define vipm_satcast_u16u64(v)
# define vipm_satcast_s16u16(v)
# define vipm_satcast_s16uint(v)
# define vipm_satcast_s16sint(v)
# define vipm_satcast_s16u64(v)
# define vipm_satcast_s16s64(v)
 */
/* @todo: fixme; rint with saturate */
# define vipm_satcast_u16f(v)      vipm_satcast_u16sint(vipmi_rintf((float)(v)))
# define vipm_satcast_u16d(v)      vipm_satcast_u16sint(vipmi_rintd((double)(v)))
# define vipm_satcast_s16f(v)      vipm_satcast_s16sint(vipmi_rintf((float)(v)))
# define vipm_satcast_s16d(v)      vipm_satcast_s16sint(vipmi_rintd((double)(v)))


/*
 * Saturate destination: I32
 */
# if __myc_support(macro_retval)

#  define vipm_satcast_u32s32(v)                                                      \
	__extension__ ({                                                                  \
		bo_int32_t ___u32s32v = (bo_int32_t)(v);                                      \
		/* return */ ( 0 <= ___u32s32v ? (bo_uint32_t)___u32s32v                      \
		                               : (bo_uint32_t)0 );                            \
	})
#  define vipm_satcast_u32uint(v)                                                     \
	__extension__ ({                                                                  \
		vipm_uint ___u32uiv = (vipm_uint)(v);                                         \
		/* return */ ( ___u32uiv <= VipmK_UINT_MAX ? (bo_uint32_t)___u32uiv           \
		                                           : (bo_uint32_t)VipmK_UINT_MAX );   \
	})
#  define vipm_satcast_u32sint(v)                                                     \
	__extension__ ({                                                                  \
		vipm_int ___u32siv = (vipm_int)(v);                                           \
		/* return */ ( ___u32siv <= 0              ? (bo_uint32_t)0                   \
		  : (vipm_uint)___u32siv <= VipmK_UINT_MAX ? (bo_uint32_t)___u32siv           \
		                                           : (bo_uint32_t)VipmK_UINT_MAX );   \
	})
#  define vipm_satcast_u32u64(v)                                                      \
	__extension__ ({                                                                  \
		bo_uint64_t ___u32ulv = (bo_uint64_t)(v);                                     \
		/* return */ ( ___u32ulv <= VipmK_UINT_MAX ? (bo_uint32_t)___u32ulv           \
		                                           : (bo_uint32_t)VipmK_UINT_MAX );   \
	})
#  define vipm_satcast_u32s64(v)                                                      \
	__extension__ ({                                                                  \
		bo_int64_t ___u32slv = (bo_int64_t)(v);                                       \
		/* return */ ( ___u32slv <= 0               ? (bo_uint32_t)0                  \
		  : (bo_uint64_t)___u32slv <= VipmK_UINT_MAX ? (bo_uint32_t)___u32slv         \
		                                            : (bo_uint32_t)VipmK_UINT_MAX );  \
	})
#  define vipm_satcast_s32u32(v)                                                    \
	__extension__ ({                                                                \
		vipm_uint ___i32uiv = (vipm_uint)(v);                                       \
		/* return */ ( ___i32uiv <= VipmK_INT_MAX ? (bo_int32_t)___i32uiv           \
		                                          : (bo_int32_t)VipmK_INT_MAX );    \
	})
#  define vipm_satcast_s32uint(v)                                                   \
	__extension__ ({                                                                \
		vipm_uint ___i32uiv = (vipm_uint)(v);                                       \
		/* return */ ( ___i32uiv <= VipmK_INT_MAX ? (bo_int32_t)___i32uiv           \
		                                          : (bo_int32_t)VipmK_INT_MAX );    \
	})
#  define vipm_satcast_s32u64(v)                                                    \
	__extension__ ({                                                                \
		bo_uint64_t ___i32ulv = (bo_uint64_t)(v);                                   \
		/* return */ ( ___i32ulv <= VipmK_INT_MAX ? (bo_int32_t)___i32ulv           \
		                                          : (bo_int32_t)VipmK_INT_MAX );    \
	})
#  define vipm_satcast_s32s64(v)                                                    \
	__extension__ ({                                                                \
		bo_int64_t ___i32slv = (bo_int64_t)(v);                                     \
		/* return */ ( ___i32slv <= VipmK_INT_MIN ? (bo_int32_t)VipmK_INT_MIN       \
		             : ___i32slv <= VipmK_INT_MAX ? (bo_int32_t)___i32slv           \
		                                           : (bo_int32_t)VipmK_INT_MAX );   \
	})

# else /* !__myc_support(macro_retval) */

__MYC_BEGIN_CDECLS

bo_uint32_t vipm_satcast_u32s32  __P((bo_int32_t));
bo_uint32_t vipm_satcast_u32uint __P((vipm_uint));
bo_uint32_t vipm_satcast_u32sint __P((vipm_int));
bo_uint32_t vipm_satcast_u32u64  __P((bo_uint64_t));
bo_uint32_t vipm_satcast_u32s64  __P((bo_int64_t));
bo_int32_t  vipm_satcast_s32u32  __P((bo_uint32_t));
bo_int32_t  vipm_satcast_s32uint __P((vipm_uint));
bo_int32_t  vipm_satcast_s32u64  __P((bo_uint64_t));
bo_int32_t  vipm_satcast_s32s64  __P((bo_int64_t));

_VIPM_INLINE bo_uint32_t vipm_satcast_u32s32(bo_int32_t v)
{
	return (0 <= v ? (bo_uint32_t)v : 0);
}
_VIPM_INLINE bo_uint32_t vipm_satcast_u32uint(vipm_uint v)
{
	return (v <= VipmK_UINT_MAX ? (bo_uint32_t)v : VipmK_UINT_MAX);
}
_VIPM_INLINE bo_uint32_t vipm_satcast_u32sint(vipm_int v)
{
	return ( v <= 0              ? 0
	       : v <= VipmK_UINT_MAX ? (bo_uint32_t)v
	                             : VipmK_UINT_MAX );
}
_VIPM_INLINE bo_uint32_t vipm_satcast_u32u64(bo_uint64_t v)
{
	return (v <= VipmK_UINT_MAX ? (bo_uint32_t)v : VipmK_UINT_MAX);
}
_VIPM_INLINE bo_uint32_t vipm_satcast_u32s64(bo_int64_t v)
{
	return ( v <= 0              ? 0
	       : v <= VipmK_UINT_MAX ? (bo_uint32_t)v
	                             : VipmK_UINT_MAX );
}

_VIPM_INLINE bo_int32_t vipm_satcast_s32u32(bo_uint32_t v)
{
	return (v <= VipmK_INT_MAX ? (bo_int32_t)v : VipmK_INT_MAX);
}
_VIPM_INLINE bo_int32_t vipm_satcast_s32uint(vipm_uint v)
{
	return (v <= VipmK_INT_MAX ? (bo_int32_t)v : VipmK_INT_MAX);
}
_VIPM_INLINE bo_int32_t vipm_satcast_s32u64(bo_uint64_t v)
{
	return (v <= VipmK_INT_MAX ? (bo_int32_t)v : VipmK_INT_MAX);
}
_VIPM_INLINE bo_int32_t vipm_satcast_s32s64(bo_int64_t v)
{
	return ( v <= VipmK_INT_MIN ? VipmK_INT_MIN
	       : v <= VipmK_INT_MAX ? (bo_int32_t)v
	                             : VipmK_INT_MAX );
}

__MYC_END_CDECLS

# endif /* __myc_support(macro_retval) */

/*
# define vipm_satcast_u32s32(v)
# define vipm_satcast_u32uint(v)
# define vipm_satcast_u32sint(v)
# define vipm_satcast_u32u64(v)
# define vipm_satcast_u32s64(v)
# define vipm_satcast_s32u32(v)
# define vipm_satcast_s32uint(v)
# define vipm_satcast_s32u64(v)
# define vipm_satcast_s32s64(v)
 */
# define vipm_satcast_s32sint(v)   ((bo_int32_t)(v))
# define vipm_satcast_u32f(v)      vipm_satcast_u32sint(vipmi_rintf((float)(v)))
# define vipm_satcast_u32d(v)      vipm_satcast_u32sint(vipmi_rintd((double)(v)))
# define vipm_satcast_s32f(v)      ((bo_int32_t)vipmi_rintf((float)(v)))
# define vipm_satcast_s32d(v)      ((bo_int32_t)vipmi_rintd((double)(v)))


/*
 * Saturate destination: I64
 */
# if __myc_support(macro_retval)

#  define vipm_satcast_u64s64(v)                                                      \
	__extension__ ({                                                                  \
		bo_int64_t ___u64s64v = (bo_int64_t)(v);                                      \
		/* return */ ( 0 <= ___u64s64v ? (bo_uint64_t)___u64s64v                      \
		                               : (bo_uint64_t)0 );                            \
	})
#  define vipm_satcast_u64sint(v)                                                     \
	__extension__ ({                                                                  \
		vipm_int ___u64siv = (vipm_int)(v);                                           \
		/* return */ ( ___u64siv <= 0 ? (bo_uint64_t)0                                \
		                              : (bo_uint64_t)___u64siv );                     \
	})
#  define vipm_satcast_s64u64(v)                                                      \
	__extension__ ({                                                                  \
		bo_uint64_t ___i64uiv = (bo_uint64_t)(v);                                     \
		/* return */ ( ___i64uiv <= VipmK_INT64_MAX ? (bo_int64_t)___i64uiv           \
		                                            : (bo_int64_t)VipmK_INT64_MAX );  \
	})

# else /* !__myc_support(macro_retval) */

__MYC_BEGIN_CDECLS

bo_uint64_t vipm_satcast_u64s64  __P((bo_int64_t));
bo_uint64_t vipm_satcast_u64sint __P((vipm_int));
bo_int64_t  vipm_satcast_s64u64  __P((bo_uint64_t));

_VIPM_INLINE bo_uint64_t vipm_satcast_u64s64(bo_int64_t v)
{
	return (0 <= v ? (bo_uint64_t)v : 0);
}
_VIPM_INLINE bo_uint64_t vipm_satcast_u64sint(vipm_int v)
{
	return ( v <= 0 ? 0 : (bo_uint64_t)v);
}

_VIPM_INLINE bo_int64_t vipm_satcast_s64u64(bo_uint64_t v)
{
	return (v <= VipmK_INT64_MAX ? (bo_int64_t)v : VipmK_INT64_MAX);
}

__MYC_END_CDECLS

# endif /* __myc_support(macro_retval) */

/*
# define vipm_satcast_u64s64(v)
# define vipm_satcast_u64sint(v)
# define vipm_satcast_s64u64(v)
 */
# define vipm_satcast_u64uint(v)   ((bo_uint64_t)(v))
# define vipm_satcast_s64uint(v)   ((bo_int64_t)(v))
# define vipm_satcast_s64sint(v)   ((bo_int64_t)(v))
# define vipm_satcast_u64f(v)      vipm_satcast_u64s64(vipmi_llrintf((float)(v)))
# define vipm_satcast_u64d(v)      vipm_satcast_u64s64(vipmi_llrintd((double)(v)))
# define vipm_satcast_s64f(v)      ((bo_int64_t)vipmi_llrintf((float)(v)))
# define vipm_satcast_s64d(v)      ((bo_int64_t)vipmi_llrintd((double)(v)))


/*
 * Saturate destination: F32
 * @todo: fixme
 */
# define vipm_satcast_f32d(v)      ((float)(v))

/*
 * Saturate destination: F64
 * @todo: fixme
 */
# define vipm_satcast_f64d(v)      (v)

/*
 * Cast/Saturate
 * @}
 */

#endif /* !defined(__VIPM__TYPES_BASE__CAST_H__) */


/******************************************************************************
 *
 *
 *
 *****************************************************************************/
