/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright 2016 Seenaptec Ltd. All rights reserved.
 * SEENAPTEC PROPRIETARY/CONFIDENTIAL.
 *
 * $Id$
 */

/*
 * Cmp_Defs.h	(V.Sokur)
 * Vipm/_Types/Cmp_Defs.h
 */

/* ------------------------------------------------------------------------- */

#ifndef __VIPM__TYPES_CMP__DEFS_H__
# define __VIPM__TYPES_CMP__DEFS_H__

/******************************************************************************
 * %% BeginSection: includes
 */

/*
# ifndef __VIPM_CDEFS_H__
#  include <Vipm/Cdefs.h>
# endif

# ifndef __VIPM__TYPES_IMEL__TYPES_H__
#  include "Vipm/_Types/Imel_Types.h"
# endif
 */


/******************************************************************************
 * %% BeginSection: constant declarations / definitions
 */

/*
 * @{
 * Comparing operation constants/macros
 */

# define VipmF_CMPOP_MASK               0x0F

/* @note : DO NOT MODIFY ORDER!!! */
# define VipmK_INVAL_CMP              (-1)
# define VipmK_NULL_CMP                 0
# define VipmK_UNK_CMP                  2
# define VipmK_EQU_CMP                  3 /* equ ~ nequ */
# define VipmK_LESS_CMP                 4 /* less ~ gequ */
# define VipmK_LEQU_CMP                 5 /* lequ ~ greater */
# define VipmK_GREATER_CMP              6
# define VipmK_GEQU_CMP                 7

/* @note: NOT FOR YOUR BUSINESS!!! */
# define _VipmK_NEQU_CMP                8

# define VIPM_CCMPOP(op) ((((op) - 3) ^ 7) + 1)     /* @todo: fixme */

/*
 * Comparing operation constants/macros
 * @}
 */

/* ------------------------------------------------------------------------- */

/*
 * @{
 * Comparing macros
 */

/*
 * CMPOP:
 * LT     LESS
 * LE     LEQU
 * GT     GREATER
 * GE     GEQU
 * EQ     EQU
 * NE     NEQU
 */
# define VIPM_CMP_C(_Op,_ET, aLhs,aRhs)                 VIPM_GLUE(VIPM__CMP_, _Op)(_ET, aLhs,aRhs)
# define VIPM_ARITH_CMP_C(_Op,_ET, aLhs,aRhs)           VIPM_GLUE(VIPM__ARITH_CMP_, _Op)(_ET, aLhs,aRhs)
# define VIPM_MARITH_CMP_C(_Op,_ET, aLhs,aRhs)          VIPM_GLUE(VIPM__MARITH_CMP_, _Op)(_ET, aLhs,aRhs)
# define VIPM_EARITH_CMP_C(_Op,_EDT,_EST, aLhs,aRhs)    VIPM_GLUE(VIPM__EARITH_CMP_, _Op)(_EDT,_EST, aLhs,aRhs)
# define VIPM_MEARITH_CMP_C(_Op,_EDT,_EST,aLhs,aRhs)    VIPM_GLUE(VIPM__MEARITH_CMP_, _Op)(_EDT,_EST, aLhs,aRhs)
# define VIPM_ECMPSEL_C(_Op,_EDT,_EST,aLhs,aRhs,TV,FV)  VIPM_GLUE(vipmi_bitift_, VIPM_ELTY_WIDTHOF_C(_EDT))(FV,TV, VIPM_MEARITH_CMP_C(_Op,_EDT,_EST,aLhs,aRhs))
# define VIPM_ECMPSELC_C(_Op,_EDT,_EST,aLhs,aRhs,TV,FV) VIPM_GLUE(vipmi_bitiff_, VIPM_ELTY_WIDTHOF_C(_EDT))(FV,TV, VIPM_MEARITH_CMP_C(_Op,_EDT,_EST,aLhs,aRhs))


# define VIPM_LESS_C(_ElemType, aLhs,aRhs)      VIPM_GLUE(VIPM__LESS_,VIPM_ELTY_UTW(_ElemType))(aLhs,aRhs)
# define VIPM_LEQU_C(_ElemType, aLhs,aRhs)      VIPM_GLUE(VIPM__LEQU_,VIPM_ELTY_UTW(_ElemType))(aLhs,aRhs)
# define VIPM_GREATER_C(_ElemType, aLhs,aRhs)   VIPM_GLUE(VIPM__GREATER_,VIPM_ELTY_UTW(_ElemType))(aLhs,aRhs)
# define VIPM_GEQU_C(_ElemType, aLhs,aRhs)      VIPM_GLUE(VIPM__GEQU_,VIPM_ELTY_UTW(_ElemType))(aLhs,aRhs)
# define VIPM_EQU_C(_ElemType, aLhs,aRhs)       VIPM_GLUE(VIPM__EQU_,VIPM_ELTY_UTW(_ElemType))(aLhs,aRhs)
# define VIPM_NEQU_C(_ElemType, aLhs,aRhs)      VIPM_GLUE(VIPM__NEQU_,VIPM_ELTY_UTW(_ElemType))(aLhs,aRhs)

/* @todo: fixme - reimplement(?), test */

# define VIPM_ARITH_LESS_C(_ET,aLhs,aRhs)       ((bo_uint8_t) (VIPM_LESS_C(_ET,aLhs,aRhs)    ? VipmK_ARITH_TRUE : VipmK_ARITH_FALSE))
# define VIPM_ARITH_LEQU_C(_ET,aLhs,aRhs)       ((bo_uint8_t) (VIPM_LEQU_C(_ET,aLhs,aRhs)    ? VipmK_ARITH_TRUE : VipmK_ARITH_FALSE))
# define VIPM_ARITH_GREATER_C(_ET,aLhs,aRhs)    ((bo_uint8_t) (VIPM_GREATER_C(_ET,aLhs,aRhs) ? VipmK_ARITH_TRUE : VipmK_ARITH_FALSE))
# define VIPM_ARITH_GEQU_C(_ET,aLhs,aRhs)       ((bo_uint8_t) (VIPM_GEQU_C(_ET,aLhs,aRhs)    ? VipmK_ARITH_TRUE : VipmK_ARITH_FALSE))
# define VIPM_ARITH_EQU_C(_ET,aLhs,aRhs)        ((bo_uint8_t) (VIPM_EQU_C(_ET,aLhs,aRhs)     ? VipmK_ARITH_TRUE : VipmK_ARITH_FALSE))
# define VIPM_ARITH_NEQU_C(_ET,aLhs,aRhs)       ((bo_uint8_t) (VIPM_EQU_C(_ET,aLhs,aRhs)     ? VipmK_ARITH_FALSE : VipmK_ARITH_TRUE))

# define VIPM_MARITH_LESS_C(_ET,aLhs,aRhs)      ((bo_uint8_t)-(bo_int8_t) VIPM_LESS_C(_ET,aLhs,aRhs)   )
# define VIPM_MARITH_LEQU_C(_ET,aLhs,aRhs)      ((bo_uint8_t)-(bo_int8_t) VIPM_LEQU_C(_ET,aLhs,aRhs)   )
# define VIPM_MARITH_GREATER_C(_ET,aLhs,aRhs)   ((bo_uint8_t)-(bo_int8_t) VIPM_GREATER_C(_ET,aLhs,aRhs))
# define VIPM_MARITH_GEQU_C(_ET,aLhs,aRhs)      ((bo_uint8_t)-(bo_int8_t) VIPM_GEQU_C(_ET,aLhs,aRhs)   )
# define VIPM_MARITH_EQU_C(_ET,aLhs,aRhs)       ((bo_uint8_t)-(bo_int8_t) VIPM_EQU_C(_ET,aLhs,aRhs)    )
# define VIPM_MARITH_NEQU_C(_ET,aLhs,aRhs)      ((bo_uint8_t)-(bo_int8_t) VIPM_NEQU_C(_ET,aLhs,aRhs)   )


# define VIPM_EARITH_LESS_C(_EDT,_EST,aLhs,aRhs)      ((VIPM_EUINT_T(_EDT)) (VIPM_LESS_C(_EST,aLhs,aRhs)    ? VipmK_ARITH_ETRUE(_EDT) : VipmK_ARITH_EFALSE(_EDT)))
# define VIPM_EARITH_LEQU_C(_EDT,_EST,aLhs,aRhs)      ((VIPM_EUINT_T(_EDT)) (VIPM_LEQU_C(_EST,aLhs,aRhs)    ? VipmK_ARITH_ETRUE(_EDT) : VipmK_ARITH_EFALSE(_EDT)))
# define VIPM_EARITH_GREATER_C(_EDT,_EST,aLhs,aRhs)   ((VIPM_EUINT_T(_EDT)) (VIPM_GREATER_C(_EST,aLhs,aRhs) ? VipmK_ARITH_ETRUE(_EDT) : VipmK_ARITH_EFALSE(_EDT)))
# define VIPM_EARITH_GEQU_C(_EDT,_EST,aLhs,aRhs)      ((VIPM_EUINT_T(_EDT)) (VIPM_GEQU_C(_EST,aLhs,aRhs)    ? VipmK_ARITH_ETRUE(_EDT) : VipmK_ARITH_EFALSE(_EDT)))
# define VIPM_EARITH_EQU_C(_EDT,_EST,aLhs,aRhs)       ((VIPM_EUINT_T(_EDT)) (VIPM_EQU_C(_EST,aLhs,aRhs)     ? VipmK_ARITH_ETRUE(_EDT) : VipmK_ARITH_EFALSE(_EDT)))
# define VIPM_EARITH_NEQU_C(_EDT,_EST,aLhs,aRhs)      ((VIPM_EUINT_T(_EDT)) (VIPM_EQU_C(_EST,aLhs,aRhs)     ? VipmK_ARITH_EFALSE(_EDT) : VipmK_ARITH_ETRUE(_EDT)))

# define VIPM_MEARITH_LESS_C(_EDT,_EST,aLhs,aRhs)     ((VIPM_EUINT_T(_EDT))-(VIPM_ESINT_T(_EDT)) VIPM_LESS_C(_EST,aLhs,aRhs)   )
# define VIPM_MEARITH_LEQU_C(_EDT,_EST,aLhs,aRhs)     ((VIPM_EUINT_T(_EDT))-(VIPM_ESINT_T(_EDT)) VIPM_LEQU_C(_EST,aLhs,aRhs)   )
# define VIPM_MEARITH_GREATER_C(_EDT,_EST,aLhs,aRhs)  ((VIPM_EUINT_T(_EDT))-(VIPM_ESINT_T(_EDT)) VIPM_GREATER_C(_EST,aLhs,aRhs))
# define VIPM_MEARITH_GEQU_C(_EDT,_EST,aLhs,aRhs)     ((VIPM_EUINT_T(_EDT))-(VIPM_ESINT_T(_EDT)) VIPM_GEQU_C(_EST,aLhs,aRhs)   )
# define VIPM_MEARITH_EQU_C(_EDT,_EST,aLhs,aRhs)      ((VIPM_EUINT_T(_EDT))-(VIPM_ESINT_T(_EDT)) VIPM_EQU_C(_EST,aLhs,aRhs)    )
# define VIPM_MEARITH_NEQU_C(_EDT,_EST,aLhs,aRhs)     ((VIPM_EUINT_T(_EDT))-(VIPM_ESINT_T(_EDT)) VIPM_NEQU_C(_EST,aLhs,aRhs)   )



# define VIPM_LESS_I(aLhs,aRhs)         ((aLhs) <  (aRhs))
# define VIPM_LEQU_I(aLhs,aRhs)         ((aLhs) <= (aRhs))
# define VIPM_GREATER_I(aLhs,aRhs)      ((aLhs) >  (aRhs))
# define VIPM_GEQU_I(aLhs,aRhs)         ((aLhs) >= (aRhs))
# define VIPM_EQU_I(aLhs,aRhs)          ((aLhs) == (aRhs))
# define VIPM_NEQU_I(aLhs,aRhs)         ((aLhs) != (aRhs))

/* @todo: fixme */
#if 1
# define VIPM_LESS_F(aLhs,aRhs)         vipmi__lessf(aLhs,aRhs)    /* ((aLhs) - (aRhs) < -FLT_EPSILON) */
# define VIPM_LEQU_F(aLhs,aRhs)         vipmi__lequf(aLhs,aRhs)    /* ((aLhs) - (aRhs) <= FLT_EPSILON) */
# define VIPM_GREATER_F(aLhs,aRhs)      vipmi__greaterf(aLhs,aRhs) /* ((aLhs) - (aRhs) > FLT_EPSILON) */
# define VIPM_GEQU_F(aLhs,aRhs)         vipmi__gequf(aLhs,aRhs)    /* ((aLhs) - (aRhs) >= -FLT_EPSILON) */
# define VIPM_EQU_F(aLhs,aRhs)          vipmi__equalf(aLhs,aRhs)   /* (fabsf((aLhs) - (aRhs)) < FLT_EPSILON) */
# define VIPM_NEQU_F(aLhs,aRhs)       (!vipmi__equalf(aLhs,aRhs))
#else
# define VIPM_LESS_F(aLhs,aRhs)         vipmi_lessf(aLhs,aRhs,FLT_EPSILON)    /* ((aLhs) - (aRhs) < -FLT_EPSILON) */
# define VIPM_LEQU_F(aLhs,aRhs)         vipmi_lequf(aLhs,aRhs,FLT_EPSILON)    /* ((aLhs) - (aRhs) <= FLT_EPSILON) */
# define VIPM_GREATER_F(aLhs,aRhs)      vipmi_greaterf(aLhs,aRhs,FLT_EPSILON) /* ((aLhs) - (aRhs) > FLT_EPSILON) */
# define VIPM_GEQU_F(aLhs,aRhs)         vipmi_gequf(aLhs,aRhs,FLT_EPSILON)    /* ((aLhs) - (aRhs) >= -FLT_EPSILON) */
# define VIPM_EQU_F(aLhs,aRhs)          vipmi_aequalf(aLhs,aRhs,FLT_EPSILON)  /* (fabsf((aLhs) - (aRhs)) < FLT_EPSILON) */
# define VIPM_NEQU_F(aLhs,aRhs)       (!vipmi_aequalf(aLhs,aRhs,FLT_EPSILON))
#endif


/* @todo: fixme - reimplement(?), test */

# define VIPM_ARITH_LESS_I(aLhs,aRhs)           ((bo_uint8_t) (VIPM_LESS_I(aLhs,aRhs)    ? VipmK_ARITH_TRUE : VipmK_ARITH_FALSE))
# define VIPM_ARITH_LEQU_I(aLhs,aRhs)           ((bo_uint8_t) (VIPM_LEQU_I(aLhs,aRhs)    ? VipmK_ARITH_TRUE : VipmK_ARITH_FALSE))
# define VIPM_ARITH_GREATER_I(aLhs,aRhs)        ((bo_uint8_t) (VIPM_GREATER_I(aLhs,aRhs) ? VipmK_ARITH_TRUE : VipmK_ARITH_FALSE))
# define VIPM_ARITH_GEQU_I(aLhs,aRhs)           ((bo_uint8_t) (VIPM_GEQU_I(aLhs,aRhs)    ? VipmK_ARITH_TRUE : VipmK_ARITH_FALSE))
# define VIPM_ARITH_EQU_I(aLhs,aRhs)            ((bo_uint8_t) (VIPM_EQU_I(aLhs,aRhs)     ? VipmK_ARITH_TRUE : VipmK_ARITH_FALSE))
# define VIPM_ARITH_NEQU_I(aLhs,aRhs)           ((bo_uint8_t) (VIPM_EQU_I(aLhs,aRhs)     ? VipmK_ARITH_FALSE : VipmK_ARITH_TRUE))

# define VIPM_ARITH_LESS_F(aLhs,aRhs)           ((bo_uint8_t) (VIPM_LESS_F(aLhs,aRhs)    ? VipmK_ARITH_TRUE : VipmK_ARITH_FALSE))
# define VIPM_ARITH_LEQU_F(aLhs,aRhs)           ((bo_uint8_t) (VIPM_LEQU_F(aLhs,aRhs)    ? VipmK_ARITH_TRUE : VipmK_ARITH_FALSE))
# define VIPM_ARITH_GREATER_F(aLhs,aRhs)        ((bo_uint8_t) (VIPM_GREATER_F(aLhs,aRhs) ? VipmK_ARITH_TRUE : VipmK_ARITH_FALSE))
# define VIPM_ARITH_GEQU_F(aLhs,aRhs)           ((bo_uint8_t) (VIPM_GEQU_F(aLhs,aRhs)    ? VipmK_ARITH_TRUE : VipmK_ARITH_FALSE))
# define VIPM_ARITH_EQU_F(aLhs,aRhs)            ((bo_uint8_t) (VIPM_EQU_F(aLhs,aRhs)     ? VipmK_ARITH_TRUE : VipmK_ARITH_FALSE))
# define VIPM_ARITH_NEQU_F(aLhs,aRhs)           ((bo_uint8_t) (VIPM_EQU_F(aLhs,aRhs)     ? VipmK_ARITH_FALSE : VipmK_ARITH_TRUE))


# define VIPM_MARITH_LESS_I(aLhs,aRhs)          ((bo_uint8_t)-(bo_int8_t) VIPM_LESS_I(aLhs,aRhs)   )
# define VIPM_MARITH_LEQU_I(aLhs,aRhs)          ((bo_uint8_t)-(bo_int8_t) VIPM_LEQU_I(aLhs,aRhs)   )
# define VIPM_MARITH_GREATER_I(aLhs,aRhs)       ((bo_uint8_t)-(bo_int8_t) VIPM_GREATER_I(aLhs,aRhs))
# define VIPM_MARITH_GEQU_I(aLhs,aRhs)          ((bo_uint8_t)-(bo_int8_t) VIPM_GEQU_I(aLhs,aRhs)   )
# define VIPM_MARITH_EQU_I(aLhs,aRhs)           ((bo_uint8_t)-(bo_int8_t) VIPM_EQU_I(aLhs,aRhs)    )
# define VIPM_MARITH_NEQU_I(aLhs,aRhs)          ((bo_uint8_t)-(bo_int8_t) VIPM_NEQU_I(aLhs,aRhs)   )

# define VIPM_MARITH_LESS_F(aLhs,aRhs)          ((bo_uint8_t)-(bo_int8_t) VIPM_LESS_F(aLhs,aRhs)   )
# define VIPM_MARITH_LEQU_F(aLhs,aRhs)          ((bo_uint8_t)-(bo_int8_t) VIPM_LEQU_F(aLhs,aRhs)   )
# define VIPM_MARITH_GREATER_F(aLhs,aRhs)       ((bo_uint8_t)-(bo_int8_t) VIPM_GREATER_F(aLhs,aRhs))
# define VIPM_MARITH_GEQU_F(aLhs,aRhs)          ((bo_uint8_t)-(bo_int8_t) VIPM_GEQU_F(aLhs,aRhs)   )
# define VIPM_MARITH_EQU_F(aLhs,aRhs)           ((bo_uint8_t)-(bo_int8_t) VIPM_EQU_F(aLhs,aRhs)    )
# define VIPM_MARITH_NEQU_F(aLhs,aRhs)          ((bo_uint8_t)-(bo_int8_t) VIPM_NEQU_F(aLhs,aRhs)   )


/* internal @{ */

/* @todo: fixme - reimplement(?), test */

# define VIPM__CMP_LT(_ElemType, aLhs,aRhs)     VIPM_LESS_C(_ElemType, aLhs,aRhs)
# define VIPM__CMP_LESS(_ElemType, aLhs,aRhs)   VIPM_LESS_C(_ElemType, aLhs,aRhs)
# define VIPM__CMP_LE(_ElemType, aLhs,aRhs)     VIPM_LEQU_C(_ElemType, aLhs,aRhs)
# define VIPM__CMP_LEQU(_ElemType, aLhs,aRhs)   VIPM_LEQU_C(_ElemType, aLhs,aRhs)
# define VIPM__CMP_GT(_ElemType, aLhs,aRhs)     VIPM_GREATER_C(_ElemType, aLhs,aRhs)
# define VIPM__CMP_GREATER(_ElemType,aLhs,aRhs) VIPM_GREATER_C(_ElemType, aLhs,aRhs)
# define VIPM__CMP_GE(_ElemType, aLhs,aRhs)     VIPM_GEQU_C(_ElemType, aLhs,aRhs)
# define VIPM__CMP_GEQU(_ElemType, aLhs,aRhs)   VIPM_GEQU_C(_ElemType, aLhs,aRhs)
# define VIPM__CMP_EQ(_ElemType, aLhs,aRhs)     VIPM_EQU_C(_ElemType, aLhs,aRhs)
# define VIPM__CMP_EQU(_ElemType, aLhs,aRhs)    VIPM_EQU_C(_ElemType, aLhs,aRhs)
# define VIPM__CMP_NE(_ElemType, aLhs,aRhs)     VIPM_NEQU_C(_ElemType, aLhs,aRhs)
# define VIPM__CMP_NEQU(_ElemType, aLhs,aRhs)   VIPM_NEQU_C(_ElemType, aLhs,aRhs)

# define VIPM__ARITH_CMP_LT(_ElemType, aLhs,aRhs)       VIPM_ARITH_LESS_C(_ElemType, aLhs,aRhs)
# define VIPM__ARITH_CMP_LESS(_ElemType, aLhs,aRhs)     VIPM_ARITH_LESS_C(_ElemType, aLhs,aRhs)
# define VIPM__ARITH_CMP_LE(_ElemType, aLhs,aRhs)       VIPM_ARITH_LEQU_C(_ElemType, aLhs,aRhs)
# define VIPM__ARITH_CMP_LEQU(_ElemType, aLhs,aRhs)     VIPM_ARITH_LEQU_C(_ElemType, aLhs,aRhs)
# define VIPM__ARITH_CMP_GT(_ElemType, aLhs,aRhs)       VIPM_ARITH_GREATER_C(_ElemType, aLhs,aRhs)
# define VIPM__ARITH_CMP_GREATER(_ElemType,aLhs,aRhs)   VIPM_ARITH_GREATER_C(_ElemType, aLhs,aRhs)
# define VIPM__ARITH_CMP_GE(_ElemType, aLhs,aRhs)       VIPM_ARITH_GEQU_C(_ElemType, aLhs,aRhs)
# define VIPM__ARITH_CMP_GEQU(_ElemType, aLhs,aRhs)     VIPM_ARITH_GEQU_C(_ElemType, aLhs,aRhs)
# define VIPM__ARITH_CMP_EQ(_ElemType, aLhs,aRhs)       VIPM_ARITH_EQU_C(_ElemType, aLhs,aRhs)
# define VIPM__ARITH_CMP_EQU(_ElemType, aLhs,aRhs)      VIPM_ARITH_EQU_C(_ElemType, aLhs,aRhs)
# define VIPM__ARITH_CMP_NE(_ElemType, aLhs,aRhs)       VIPM_ARITH_NEQU_C(_ElemType, aLhs,aRhs)
# define VIPM__ARITH_CMP_NEQU(_ElemType, aLhs,aRhs)     VIPM_ARITH_NEQU_C(_ElemType, aLhs,aRhs)

# define VIPM__MARITH_CMP_LT(_ElemType, aLhs,aRhs)      VIPM_MARITH_LESS_C(_ElemType, aLhs,aRhs)
# define VIPM__MARITH_CMP_LESS(_ElemType, aLhs,aRhs)    VIPM_MARITH_LESS_C(_ElemType, aLhs,aRhs)
# define VIPM__MARITH_CMP_LE(_ElemType, aLhs,aRhs)      VIPM_MARITH_LEQU_C(_ElemType, aLhs,aRhs)
# define VIPM__MARITH_CMP_LEQU(_ElemType, aLhs,aRhs)    VIPM_MARITH_LEQU_C(_ElemType, aLhs,aRhs)
# define VIPM__MARITH_CMP_GT(_ElemType, aLhs,aRhs)      VIPM_MARITH_GREATER_C(_ElemType, aLhs,aRhs)
# define VIPM__MARITH_CMP_GREATER(_ElemType,aLhs,aRhs)  VIPM_MARITH_GREATER_C(_ElemType, aLhs,aRhs)
# define VIPM__MARITH_CMP_GE(_ElemType, aLhs,aRhs)      VIPM_MARITH_GEQU_C(_ElemType, aLhs,aRhs)
# define VIPM__MARITH_CMP_GEQU(_ElemType, aLhs,aRhs)    VIPM_MARITH_GEQU_C(_ElemType, aLhs,aRhs)
# define VIPM__MARITH_CMP_EQ(_ElemType, aLhs,aRhs)      VIPM_MARITH_EQU_C(_ElemType, aLhs,aRhs)
# define VIPM__MARITH_CMP_EQU(_ElemType, aLhs,aRhs)     VIPM_MARITH_EQU_C(_ElemType, aLhs,aRhs)
# define VIPM__MARITH_CMP_NE(_ElemType, aLhs,aRhs)      VIPM_MARITH_NEQU_C(_ElemType, aLhs,aRhs)
# define VIPM__MARITH_CMP_NEQU(_ElemType, aLhs,aRhs)    VIPM_MARITH_NEQU_C(_ElemType, aLhs,aRhs)

# define VIPM__EARITH_CMP_LT(_EDT,_EST, aLhs,aRhs)      VIPM_EARITH_LESS_C(_EDT,_EST, aLhs,aRhs)
# define VIPM__EARITH_CMP_LESS(_EDT,_EST, aLhs,aRhs)    VIPM_EARITH_LESS_C(_EDT,_EST, aLhs,aRhs)
# define VIPM__EARITH_CMP_LE(_EDT,_EST, aLhs,aRhs)      VIPM_EARITH_LEQU_C(_EDT,_EST, aLhs,aRhs)
# define VIPM__EARITH_CMP_LEQU(_EDT,_EST, aLhs,aRhs)    VIPM_EARITH_LEQU_C(_EDT,_EST, aLhs,aRhs)
# define VIPM__EARITH_CMP_GT(_EDT,_EST, aLhs,aRhs)      VIPM_EARITH_GREATER_C(_EDT,_EST, aLhs,aRhs)
# define VIPM__EARITH_CMP_GREATER(_EDT,_EST,aLhs,aRhs)  VIPM_EARITH_GREATER_C(_EDT,_EST, aLhs,aRhs)
# define VIPM__EARITH_CMP_GE(_EDT,_EST, aLhs,aRhs)      VIPM_EARITH_GEQU_C(_EDT,_EST, aLhs,aRhs)
# define VIPM__EARITH_CMP_GEQU(_EDT,_EST, aLhs,aRhs)    VIPM_EARITH_GEQU_C(_EDT,_EST, aLhs,aRhs)
# define VIPM__EARITH_CMP_EQ(_EDT,_EST, aLhs,aRhs)      VIPM_EARITH_EQU_C(_EDT,_EST, aLhs,aRhs)
# define VIPM__EARITH_CMP_EQU(_EDT,_EST, aLhs,aRhs)     VIPM_EARITH_EQU_C(_EDT,_EST, aLhs,aRhs)
# define VIPM__EARITH_CMP_NE(_EDT,_EST, aLhs,aRhs)      VIPM_EARITH_NEQU_C(_EDT,_EST, aLhs,aRhs)
# define VIPM__EARITH_CMP_NEQU(_EDT,_EST, aLhs,aRhs)    VIPM_EARITH_NEQU_C(_EDT,_EST, aLhs,aRhs)

# define VIPM__MEARITH_CMP_LT(_EDT,_EST, aLhs,aRhs)     VIPM_MEARITH_LESS_C(_EDT,_EST, aLhs,aRhs)
# define VIPM__MEARITH_CMP_LESS(_EDT,_EST, aLhs,aRhs)   VIPM_MEARITH_LESS_C(_EDT,_EST, aLhs,aRhs)
# define VIPM__MEARITH_CMP_LE(_EDT,_EST, aLhs,aRhs)     VIPM_MEARITH_LEQU_C(_EDT,_EST, aLhs,aRhs)
# define VIPM__MEARITH_CMP_LEQU(_EDT,_EST, aLhs,aRhs)   VIPM_MEARITH_LEQU_C(_EDT,_EST, aLhs,aRhs)
# define VIPM__MEARITH_CMP_GT(_EDT,_EST, aLhs,aRhs)     VIPM_MEARITH_GREATER_C(_EDT,_EST, aLhs,aRhs)
# define VIPM__MEARITH_CMP_GREATER(_EDT,_EST,aLhs,aRhs) VIPM_MEARITH_GREATER_C(_EDT,_EST, aLhs,aRhs)
# define VIPM__MEARITH_CMP_GE(_EDT,_EST, aLhs,aRhs)     VIPM_MEARITH_GEQU_C(_EDT,_EST, aLhs,aRhs)
# define VIPM__MEARITH_CMP_GEQU(_EDT,_EST, aLhs,aRhs)   VIPM_MEARITH_GEQU_C(_EDT,_EST, aLhs,aRhs)
# define VIPM__MEARITH_CMP_EQ(_EDT,_EST, aLhs,aRhs)     VIPM_MEARITH_EQU_C(_EDT,_EST, aLhs,aRhs)
# define VIPM__MEARITH_CMP_EQU(_EDT,_EST, aLhs,aRhs)    VIPM_MEARITH_EQU_C(_EDT,_EST, aLhs,aRhs)
# define VIPM__MEARITH_CMP_NE(_EDT,_EST, aLhs,aRhs)     VIPM_MEARITH_NEQU_C(_EDT,_EST, aLhs,aRhs)
# define VIPM__MEARITH_CMP_NEQU(_EDT,_EST, aLhs,aRhs)   VIPM_MEARITH_NEQU_C(_EDT,_EST, aLhs,aRhs)


# define VIPM__LESS_U8(lhs,rhs)         ((lhs) < (rhs))
# define VIPM__LESS_S8(lhs,rhs)         ((lhs) < (rhs))
# define VIPM__LESS_U16(lhs,rhs)        ((lhs) < (rhs))
# define VIPM__LESS_S16(lhs,rhs)        ((lhs) < (rhs))
# define VIPM__LESS_U32(lhs,rhs)        ((lhs) < (rhs))
# define VIPM__LESS_S32(lhs,rhs)        ((lhs) < (rhs))
# define VIPM__LESS_F32(lhs,rhs)        vipmi__lessf(lhs,rhs)
# define VIPM__LESS_F64(lhs,rhs)        vipmi__lessd(lhs,rhs)

# define VIPM__LEQU_U8(lhs,rhs)         ((lhs) <= (rhs))
# define VIPM__LEQU_S8(lhs,rhs)         ((lhs) <= (rhs))
# define VIPM__LEQU_U16(lhs,rhs)        ((lhs) <= (rhs))
# define VIPM__LEQU_S16(lhs,rhs)        ((lhs) <= (rhs))
# define VIPM__LEQU_U32(lhs,rhs)        ((lhs) <= (rhs))
# define VIPM__LEQU_S32(lhs,rhs)        ((lhs) <= (rhs))
# define VIPM__LEQU_F32(lhs,rhs)        vipmi__lequf(lhs,rhs)
# define VIPM__LEQU_F64(lhs,rhs)        vipmi__lequd(lhs,rhs)

# define VIPM__GREATER_U8(lhs,rhs)      ((lhs) > (rhs))
# define VIPM__GREATER_S8(lhs,rhs)      ((lhs) > (rhs))
# define VIPM__GREATER_U16(lhs,rhs)     ((lhs) > (rhs))
# define VIPM__GREATER_S16(lhs,rhs)     ((lhs) > (rhs))
# define VIPM__GREATER_U32(lhs,rhs)     ((lhs) > (rhs))
# define VIPM__GREATER_S32(lhs,rhs)     ((lhs) > (rhs))
# define VIPM__GREATER_F32(lhs,rhs)     vipmi__greaterf(lhs,rhs)
# define VIPM__GREATER_F64(lhs,rhs)     vipmi__greaterd(lhs,rhs)

# define VIPM__GEQU_U8(lhs,rhs)         ((lhs) >= (rhs))
# define VIPM__GEQU_S8(lhs,rhs)         ((lhs) >= (rhs))
# define VIPM__GEQU_U16(lhs,rhs)        ((lhs) >= (rhs))
# define VIPM__GEQU_S16(lhs,rhs)        ((lhs) >= (rhs))
# define VIPM__GEQU_U32(lhs,rhs)        ((lhs) >= (rhs))
# define VIPM__GEQU_S32(lhs,rhs)        ((lhs) >= (rhs))
# define VIPM__GEQU_F32(lhs,rhs)        vipmi__gequf(lhs,rhs)
# define VIPM__GEQU_F64(lhs,rhs)        vipmi__gequd(lhs,rhs)

# define VIPM__EQU_U8(lhs,rhs)          ((lhs) == (rhs))
# define VIPM__EQU_S8(lhs,rhs)          ((lhs) == (rhs))
# define VIPM__EQU_U16(lhs,rhs)         ((lhs) == (rhs))
# define VIPM__EQU_S16(lhs,rhs)         ((lhs) == (rhs))
# define VIPM__EQU_U32(lhs,rhs)         ((lhs) == (rhs))
# define VIPM__EQU_S32(lhs,rhs)         ((lhs) == (rhs))
# define VIPM__EQU_F32(lhs,rhs)         vipmi__equalf(lhs,rhs)
# define VIPM__EQU_F64(lhs,rhs)         vipmi__equald(lhs,rhs)

# define VIPM__NEQU_U8(lhs,rhs)         ((lhs) != (rhs))
# define VIPM__NEQU_S8(lhs,rhs)         ((lhs) != (rhs))
# define VIPM__NEQU_U16(lhs,rhs)        ((lhs) != (rhs))
# define VIPM__NEQU_S16(lhs,rhs)        ((lhs) != (rhs))
# define VIPM__NEQU_U32(lhs,rhs)        ((lhs) != (rhs))
# define VIPM__NEQU_S32(lhs,rhs)        ((lhs) != (rhs))
/* @todo: fixme */
# define VIPM__NEQU_F32(lhs,rhs)        (!vipmi__equalf(lhs,rhs))
# define VIPM__NEQU_F64(lhs,rhs)        (!vipmi__equald(lhs,rhs))
/* @} */

/*
 * Comparing macros
 * @}
 */

#endif /* !defined(__VIPM__TYPES_CMP__DEFS_H__) */


/******************************************************************************
 *
 *
 *
 *****************************************************************************/
