/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright 2016 Seenaptec Ltd. All rights reserved.
 * SEENAPTEC PROPRIETARY/CONFIDENTIAL.
 *
 * $Id$
 */

/*
 * Err_Consts.h	(V.Sokur)
 * Vipm/_Types/Err_Consts.h
 */

/* ------------------------------------------------------------------------- */

#ifndef __VIPM__TYPES_ERR__CONSTS_H__
# define __VIPM__TYPES_ERR__CONSTS_H__

/******************************************************************************
 * %% BeginSection: includes
 */

/*
# ifndef __VIPM_CDEFS_H__
#  include <Vipm/Cdefs.h>
# endif
 */


/******************************************************************************
 * %% BeginSection: constant declarations
 */

/*
 * @{
 * Error constants
 *
 * #include <errno.h>
 */

/*
 * ENOMEM
 * EINVAL
 *    1. Invalid elem-type, number-of-channels;
 *    2. Invalid ROI or other geom things;
 *    3. Invalid compare-op, morph-op, filter-op, threshold-method, other actual arguments;
 * ENOROI
 *    1. Result (negotiated) [working] ROI is empty;
 * ENOTSUP
 *    1. Unsupported actual elem-type, number-of-channels;
 *    2. Unsupported [type of, extents of] structuring-element or other geom things;
 *    3. Unsupported actual compare-op, [morph-op, filter-op, threshold-method], other [algorithmical] features;
 * ENOSYS
 *    1. Actual algorithm not implemented: morph-op, filter-op, threshold-method, other;
 * EAGAIN
 *    1. Filtering, Morphology: border required
 */
# ifdef _WIN32
#  define VipmK_ENOTSUP         _BoSTATUS(~0,ENOTTY)
# else
#  define VipmK_ENOTSUP         _BoSTATUS(~0,ENOTSUP)
# endif
# define VipmK_SUCCESS          0
# define VipmK_ENOMEM           _BoSTATUS(~0,ENOMEM)
# define VipmK_EINVAL           _BoSTATUS(~0,EINVAL)
# define VipmK_ENOSYS           _BoSTATUS(~0,ENOSYS)
# define VipmK_EAGAIN           _BoSTATUS(~0,EAGAIN)
# define VipmK_ENOROI           _BoSTATUS(~0,ENOSPC)

/*
 * Error constants
 * @}
 */

#endif /* !defined(__VIPM__TYPES_ERR__CONSTS_H__) */


/******************************************************************************
 *
 *
 *
 *****************************************************************************/
