/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright 2016 Seenaptec Ltd. All rights reserved.
 * SEENAPTEC PROPRIETARY/CONFIDENTIAL.
 *
 * $Id$
 */

/*
 * Rnd_Consts.h	(V.Sokur)
 * Vipm/_Types/Rnd_Consts.h
 */

/* ------------------------------------------------------------------------- */

#ifndef __VIPM__TYPES_RND__CONSTS_H__
# define __VIPM__TYPES_RND__CONSTS_H__

/******************************************************************************
 * %% BeginSection: includes
 */

/*
# ifndef __VIPM_CDEFS_H__
#  include <Vipm/Cdefs.h>
# endif
 */


/******************************************************************************
 * %% BeginSection: constant declarations
 */

/*
 * @{
 * Rounding constants
 */

/*
 * Rounding Modes
 *
 * Used modes:
 *    VipmK_RND_HALF_EVEN
 *    VipmK_RND_HALF_TOINF
 *    VipmK_RND_HALF_TOZERO (truncate)
 */

	/*
	 * near rounding
	 */

# define VipmK_RND_HALF_EVEN            0 /* half-to-zero: y = sign(x)ceil(abs(x) - 0.5), truncate(x) is even;
                                             half-to-inf:  y = sign(x)floor(abs(x) + 0.5), truncate(x) is odd */

# define VipmK_RND_HALF_TOINF           1 /* half towards infinity:       y = sign(x)floor(abs(x) + 0.5) */
# define VipmK_RND_FINANCIAL            VipmK_RND_HALF_TOINF
# define VipmK_RND_HALF_TOZERO          6 /* half towards zero:           y = sign(x)ceil(abs(x) - 0.5) */

# define VipmK_RND_HALF_UP              7 /* half towards plus infinity:  y = floor(x + 0.5) */
# define VipmK_RND_HALF_DOWN            8 /* half towards minus infinity: y = ceil(x - 0.5) */
# define VipmK_RND_HALF_ODD             9


	/*
	 * direct rounding
	 */

# define VipmK_RND_TOZERO               2 /* towards zero (truncate):     y = sign(x)floor(abs(x)) */
# define VipmK_RND_TRUNCATE             VipmK_RND_TOZERO
# define VipmK_RND_CEIL                 3 /* towards plus infinity:       y = ceil(x) */
# define VipmK_RND_FLOOR                4 /* towards minus infinity:      y = floor(x) */
# define VipmK_RND_TOINF                5 /* towards infinity:            y = sign(x)ceil(abs(x)) */


	/*
	 * rounding by default
	 *
	 * @todo: fixme
	 */
#if 0
# define VipmK_RND_DEFAULT              VipmK_RND_HALF_TOINF /* IEEE 754 - floating point arithmetic */
#else
# define VipmK_RND_DEFAULT              VipmK_RND_HALF_EVEN  /* IEEE 754 - floating point arithmetic */
#endif
/* @}
 */

#endif /* !defined(__VIPM__TYPES_RND__CONSTS_H__) */


/******************************************************************************
 *
 *
 *
 *****************************************************************************/
