/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright 2016 Seenaptec Ltd. All rights reserved.
 * SEENAPTEC PROPRIETARY/CONFIDENTIAL.
 *
 * $Id$
 */

/*
 * Vrng_Defs.h	(V.Sokur)
 * Vipm/_Types/Vrng_Defs.h
 */

/* ------------------------------------------------------------------------- */

#ifndef __VIPM__TYPES_VRNG__DEFS_H__
# define __VIPM__TYPES_VRNG__DEFS_H__

/******************************************************************************
 * %% BeginSection: includes
 */

/*
# ifndef __VIPM_CDEFS_H__
#  include <Vipm/Cdefs.h>
# endif

# ifndef __VIPM__TYPES_IMEL__TYPES_H__
#  include "Vipm/_Types/Imel_Types.h"
# endif
 */


/******************************************************************************
 * %% BeginSection: constant declarations / definitions
 */

/*
 * @{
 * Value range [limit] constants
 */

# define VipmK_STD_VRANGEI_MIN          0
# define VipmK_STD_VRANGEI_MAX          255
# define VipmK_STD_VRANGEI_NSCALEPT     256

/* @todo: fixme; may be [-1, 1] ? */
# define VipmK_STD_VRANGEF_MIN          0.0
# define VipmK_STD_VRANGEF_MAX          1.0
# define VipmK_STD_VRANGEF_NSCALEPT     384

/*
 * Value range [limit] constants
 * @}
 */

/* ------------------------------------------------------------------------- */

/*
 * @{
 * Value range [limit] macros
 */

# define _VIPM_STD_VRANGE_MIN(ElemType)                                         \
    (  VipmK_ELEMTYPE_U8  == (ElemType) ? (vipm_scalar_t)VipmK_STD_VRANGEI_MIN  \
     : VipmK_ELEMTYPE_S16 == (ElemType) ? (vipm_scalar_t)VipmK_STD_VRANGEI_MIN  \
     : VipmK_ELEMTYPE_S32 == (ElemType) ? (vipm_scalar_t)VipmK_STD_VRANGEI_MIN  \
     : VipmK_ELEMTYPE_F32 == (ElemType) ? (vipm_scalar_t)VipmK_STD_VRANGEF_MIN  \
                                        : (vipm_scalar_t)VipmK_STD_VRANGEF_MIN)
# define _VIPM_STD_VRANGE_MAX(ElemType)                                         \
    (  VipmK_ELEMTYPE_U8  == (ElemType) ? (vipm_scalar_t)VipmK_STD_VRANGEI_MAX  \
     : VipmK_ELEMTYPE_S16 == (ElemType) ? (vipm_scalar_t)VipmK_STD_VRANGEI_MAX  \
     : VipmK_ELEMTYPE_S32 == (ElemType) ? (vipm_scalar_t)VipmK_STD_VRANGEI_MAX  \
     : VipmK_ELEMTYPE_F32 == (ElemType) ? (vipm_scalar_t)VipmK_STD_VRANGEF_MAX  \
                                        : (vipm_scalar_t)VipmK_STD_VRANGEF_MAX)
# define _VIPM_STD_VRANGE_NSCALEPT(ElemType)                            \
    (  VipmK_ELEMTYPE_U8  == (ElemType) ? VipmK_STD_VRANGEI_NSCALEPT    \
     : VipmK_ELEMTYPE_S16 == (ElemType) ? VipmK_STD_VRANGEI_NSCALEPT    \
     : VipmK_ELEMTYPE_S32 == (ElemType) ? VipmK_STD_VRANGEI_NSCALEPT    \
     : VipmK_ELEMTYPE_F32 == (ElemType) ? VipmK_STD_VRANGEF_NSCALEPT    \
                                        : VipmK_STD_VRANGEF_NSCALEPT)

# define _VIPM_NAT_VRANGE_MIN(ElemType) _VIPM_ELTY_MIN(ElemType)
# define _VIPM_NAT_VRANGE_MAX(ElemType) _VIPM_ELTY_MAX(ElemType)

/*
 * Value range [limit] macros
 * @}
 */

/* ------------------------------------------------------------------------- */

/*
 * @{
 * Value range macros
 */

/* 1) value range by default: vrange[0] = VipmK_DFL_VRANGE,
   2) value range should be computed: vrange[0] = VipmK_CMT_VRANGE */
# define VipmK_DFL_VRANGE           VipmK_SCALAR_DFL
# define VipmK_CMT_VRANGE           VipmK_SCALAR_CMT
# define VIPM_DFL_VRANGE(x)         VIPM_SCALAR_DEFAULT(x)
# define VIPM_CMT_VRANGE(x)         VIPM_SCALAR_COMPUTE(x)

/*
 * Value range macros
 * @}
 */

#endif /* !defined(__VIPM__TYPES_VRNG__DEFS_H__) */


/******************************************************************************
 *
 *
 *
 *****************************************************************************/
