/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright 2016 Seenaptec Ltd. All rights reserved.
 * SEENAPTEC PROPRIETARY/CONFIDENTIAL.
 *
 * $Id$
 */

/*
 * Xenv.h	(V.Sokur)
 * Vipm/_Types/Xenv.h
 */

/* ------------------------------------------------------------------------- */

#ifndef __VIPM__TYPES_XENV_H__
# define __VIPM__TYPES_XENV_H__

/******************************************************************************
 * %% BeginSection: includes
 */

/*
# ifndef __VIPM_CDEFS_H__
#  include "Vipm/Cdefs.h"
# endif

# ifndef __VIPM__TYPES_BASE__TYPES_H__
#  include "Vipm/_Types/Base_Types.h"
# endif

# ifndef __BO_MEMMAN_TYPES__
#  include <Bo/memman/Types.h>
# endif
	// bo_memstg_t
 */


/******************************************************************************
 * %% BeginSection: constant declarations / definitions
 */

/*
 * @{
 * Executable Environment
 */

struct _Vipm_mmstate {
	bo_memstg_state_t       imp_;
};
typedef struct _Vipm_mmstate            vipm_mmstate_t;


struct _Vipm_xenv {
	/* private (?) */
	vipm_rref_t             xe_mmstack_;

	/* internal */
	vipm_long               xe_flags_;
	vipm_rref_t             xe_pmmstack_;               /* parent mmstack */
	bo_memstg_t             xe_mmstackb_;
	vipm_mmstate_t          xe_mmstate_;
};
typedef struct _Vipm_xenv               vipm_xenv_t;
# define vipm_xenv_p(x)                 vipm_xenv_cp(x)
# define vipm_xenv_cp(x)               ((struct _Vipm_xenv const *)(x))
# define vipm_xenv_mp(x)               ((struct _Vipm_xenv *)(x))

# define __VipmF_XE_INITED              0x01
# define __VipmF_XE_SELFALLOC           0x10
# define __VipmF_XE_XTRN_MMST_OPENED    0x10

/*
 * Executable Environment
 * @}
 */

#endif /* !defined(__VIPM__TYPES_XENV_H__) */


/******************************************************************************
 *
 *
 *
 *****************************************************************************/
