/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright 2007 Seenaptec Ltd. All rights reserved.
 * SEENAPTEC PROPRIETARY/CONFIDENTIAL.
 *
 * $Id$
 */

/*
 * ISO3166.h	(N.Panasiuk)
 * include/Vodi/ISO3166.h
 */

/* ------------------------------------------------------------------------- */

#ifndef __VODI_ISO3166__
# define __VODI_ISO3166__

/******************************************************************************
 * %% BeginSection: definitions
 */
# pragma mark -
# pragma mark [ definitions ]
# pragma mark -

/*
 * Codes for the representation of names of countries and their subdivisions
 */

/*
 * ISO 3166-1
 *
 * Country codes, defines codes for the names of countries,
 * dependent territories, and special areas of geographical interest.
 */

/* NOTE: it isn't in ISO */
/* Abhasia */
# define VODI_ABHASIA_NAME "Abhasia"
# define _VODI_ABHASIA_NAME Abhasia
# define VODI_ABHASIA_ALPHA3 "abh"
# define _VODI_ABHASIA_ALPHA3 abh
# define VodiK_ABHASIA_NUMERIC 2268

/* Afghanistan */
# define VODI_AFGHANISTAN_NAME "Afghanistan"
# define _VODI_AFGHANISTAN_NAME Afghanistan
# define VODI_AFGHANISTAN_ALPHA2 "af"
# define _VODI_AFGHANISTAN_ALPHA2 af
# define VODI_AFGHANISTAN_ALPHA3 "afg"
# define _VODI_AFGHANISTAN_ALPHA3 afg
# define VodiK_AFGHANISTAN_NUMERIC 4

/* Åland Islands */
# define VODI_ALAND_ISLANDS_NAME "Åland Islands"
# define _VODI_ALAND_ISLANDS_NAME Aland_Islands
# define VODI_ALAND_ISLANDS_ALPHA2 "ax"
# define _VODI_ALAND_ISLANDS_ALPHA2 ax
# define VODI_ALAND_ISLANDS_ALPHA3 "ala"
# define _VODI_ALAND_ISLANDS_ALPHA3 ala
# define VodiK_ALAND_ISLANDS_NUMERIC 248

/* Albania */
# define VODI_ALBANIA_NAME "Albania"
# define _VODI_ALBANIA_NAME Albania
# define VODI_ALBANIA_ALPHA2 "al"
# define _VODI_ALBANIA_ALPHA2 al
# define VODI_ALBANIA_ALPHA3 "alb"
# define _VODI_ALBANIA_ALPHA3 alb
# define VodiK_ALBANIA_NUMERIC 8

/* Algeria */
# define VODI_ALGERIA_NAME "Algeria"
# define _VODI_ALGERIA_NAME Algeria
# define VODI_ALGERIA_ALPHA2 "dz"
# define _VODI_ALGERIA_ALPHA2 dz
# define VODI_ALGERIA_ALPHA3 "dza"
# define _VODI_ALGERIA_ALPHA3 dza
# define VodiK_ALGERIA_NUMERIC 12

/* American Samoa */
# define VODI_AMERICAN_SAMOA_NAME "American Samoa"
# define _VODI_AMERICAN_SAMOA_NAME American_Samoa
# define VODI_AMERICAN_SAMOA_ALPHA2 "as"
# define _VODI_AMERICAN_SAMOA_ALPHA2 as
# define VODI_AMERICAN_SAMOA_ALPHA3 "asm"
# define _VODI_AMERICAN_SAMOA_ALPHA3 asm
# define VodiK_AMERICAN_SAMOA_NUMERIC 16

/* Andorra */
# define VODI_ANDORRA_NAME "Andorra"
# define _VODI_ANDORRA_NAME Andorra
# define VODI_ANDORRA_ALPHA2 "ad"
# define _VODI_ANDORRA_ALPHA2 ad
# define VODI_ANDORRA_ALPHA3 "and"
# define _VODI_ANDORRA_ALPHA3 and
# define VodiK_ANDORRA_NUMERIC 20

/* Angola */
# define VODI_ANGOLA_NAME "Angola"
# define _VODI_ANGOLA_NAME Angola
# define VODI_ANGOLA_ALPHA2 "ao"
# define _VODI_ANGOLA_ALPHA2 ao
# define VODI_ANGOLA_ALPHA3 "ago"
# define _VODI_ANGOLA_ALPHA3 ago
# define VodiK_ANGOLA_NUMERIC 24

/* Anguilla */
# define VODI_ANGUILLA_NAME "Anguilla"
# define _VODI_ANGUILLA_NAME Anguilla
# define VODI_ANGUILLA_ALPHA2 "ai"
# define _VODI_ANGUILLA_ALPHA2 ai
# define VODI_ANGUILLA_ALPHA3 "aia"
# define _VODI_ANGUILLA_ALPHA3 aia
# define VodiK_ANGUILLA_NUMERIC 660

/* Antarctica */
# define VODI_ANTARCTICA_NAME "Antarctica"
# define _VODI_ANTARCTICA_NAME Antarctica
# define VODI_ANTARCTICA_ALPHA2 "aq"
# define _VODI_ANTARCTICA_ALPHA2 aq
# define VODI_ANTARCTICA_ALPHA3 "ata"
# define _VODI_ANTARCTICA_ALPHA3 ata
# define VodiK_ANTARCTICA_NUMERIC 10

/* Antigua and Barbuda */
# define VODI_ANTIGUA_AND_BARBUDA_NAME "Antigua and Barbuda"
# define _VODI_ANTIGUA_AND_BARBUDA_NAME Antigua_and_Barbuda
# define VODI_ANTIGUA_AND_BARBUDA_ALPHA2 "ag"
# define _VODI_ANTIGUA_AND_BARBUDA_ALPHA2 ag
# define VODI_ANTIGUA_AND_BARBUDA_ALPHA3 "atg"
# define _VODI_ANTIGUA_AND_BARBUDA_ALPHA3 atg
# define VodiK_ANTIGUA_AND_BARBUDA_NUMERIC 28

/* Argentina */
# define VODI_ARGENTINA_NAME "Argentina"
# define _VODI_ARGENTINA_NAME Argentina
# define VODI_ARGENTINA_ALPHA2 "ar"
# define _VODI_ARGENTINA_ALPHA2 ar
# define VODI_ARGENTINA_ALPHA3 "arg"
# define _VODI_ARGENTINA_ALPHA3 arg
# define VodiK_ARGENTINA_NUMERIC 32

/* Armenia */
# define VODI_ARMENIA_NAME "Armenia"
# define _VODI_ARMENIA_NAME Armenia
# define VODI_ARMENIA_ALPHA2 "am"
# define _VODI_ARMENIA_ALPHA2 am
# define VODI_ARMENIA_ALPHA3 "arm"
# define _VODI_ARMENIA_ALPHA3 arm
# define VodiK_ARMENIA_NUMERIC 51

/* Aruba */
# define VODI_ARUBA_NAME "Aruba"
# define _VODI_ARUBA_NAME Aruba
# define VODI_ARUBA_ALPHA2 "aw"
# define _VODI_ARUBA_ALPHA2 aw
# define VODI_ARUBA_ALPHA3 "abw"
# define _VODI_ARUBA_ALPHA3 abw
# define VodiK_ARUBA_NUMERIC 533

/* Australia */
# define VODI_AUSTRALIA_NAME "Australia"
# define _VODI_AUSTRALIA_NAME Australia
# define VODI_AUSTRALIA_ALPHA2 "au"
# define _VODI_AUSTRALIA_ALPHA2 au
# define VODI_AUSTRALIA_ALPHA3 "aus"
# define _VODI_AUSTRALIA_ALPHA3 aus
# define VodiK_AUSTRALIA_NUMERIC 36

/* Austria */
# define VODI_AUSTRIA_NAME "Austria"
# define _VODI_AUSTRIA_NAME Austria
# define VODI_AUSTRIA_ALPHA2 "at"
# define _VODI_AUSTRIA_ALPHA2 at
# define VODI_AUSTRIA_ALPHA3 "aut"
# define _VODI_AUSTRIA_ALPHA3 aut
# define VodiK_AUSTRIA_NUMERIC 40

/* Azerbaijan */
# define VODI_AZERBAIJAN_NAME "Azerbaijan"
# define _VODI_AZERBAIJAN_NAME Azerbaijan
# define VODI_AZERBAIJAN_ALPHA2 "az"
# define _VODI_AZERBAIJAN_ALPHA2 az
# define VODI_AZERBAIJAN_ALPHA3 "aze"
# define _VODI_AZERBAIJAN_ALPHA3 aze
# define VodiK_AZERBAIJAN_NUMERIC 31

/* Bahamas */
# define VODI_BAHAMAS_NAME "Bahamas"
# define _VODI_BAHAMAS_NAME Bahamas
# define VODI_BAHAMAS_ALPHA2 "bs"
# define _VODI_BAHAMAS_ALPHA2 bs
# define VODI_BAHAMAS_ALPHA3 "bhs"
# define _VODI_BAHAMAS_ALPHA3 bhs
# define VodiK_BAHAMAS_NUMERIC 44

/* Bahrain */
# define VODI_BAHRAIN_NAME "Bahrain"
# define _VODI_BAHRAIN_NAME Bahrain
# define VODI_BAHRAIN_ALPHA2 "bh"
# define _VODI_BAHRAIN_ALPHA2 bh
# define VODI_BAHRAIN_ALPHA3 "bhr"
# define _VODI_BAHRAIN_ALPHA3 bhr
# define VodiK_BAHRAIN_NUMERIC 48

/* Bangladesh */
# define VODI_BANGLADESH_NAME "Bangladesh"
# define _VODI_BANGLADESH_NAME Bangladesh
# define VODI_BANGLADESH_ALPHA2 "bd"
# define _VODI_BANGLADESH_ALPHA2 bd
# define VODI_BANGLADESH_ALPHA3 "bgd"
# define _VODI_BANGLADESH_ALPHA3 bgd
# define VodiK_BANGLADESH_NUMERIC 50

/* Barbados */
# define VODI_BARBADOS_NAME "Barbados"
# define _VODI_BARBADOS_NAME Barbados
# define VODI_BARBADOS_ALPHA2 "bb"
# define _VODI_BARBADOS_ALPHA2 bb
# define VODI_BARBADOS_ALPHA3 "brb"
# define _VODI_BARBADOS_ALPHA3 brb
# define VodiK_BARBADOS_NUMERIC 52

/* Belarus */
# define VODI_BELARUS_NAME "Belarus"
# define _VODI_BELARUS_NAME Belarus
# define VODI_BELARUS_ALPHA2 "by"
# define _VODI_BELARUS_ALPHA2 by
# define VODI_BELARUS_ALPHA3 "blr"
# define _VODI_BELARUS_ALPHA3 blr
# define VodiK_BELARUS_NUMERIC 112

/* Belgium */
# define VODI_BELGIUM_NAME "Belgium"
# define _VODI_BELGIUM_NAME Belgium
# define VODI_BELGIUM_ALPHA2 "be"
# define _VODI_BELGIUM_ALPHA2 be
# define VODI_BELGIUM_ALPHA3 "bel"
# define _VODI_BELGIUM_ALPHA3 bel
# define VodiK_BELGIUM_NUMERIC 56

/* Belize */
# define VODI_BELIZE_NAME "Belize"
# define _VODI_BELIZE_NAME Belize
# define VODI_BELIZE_ALPHA2 "bz"
# define _VODI_BELIZE_ALPHA2 bz
# define VODI_BELIZE_ALPHA3 "blz"
# define _VODI_BELIZE_ALPHA3 blz
# define VodiK_BELIZE_NUMERIC 84

/* Benin */
# define VODI_BENIN_NAME "Benin"
# define _VODI_BENIN_NAME Benin
# define VODI_BENIN_ALPHA2 "bj"
# define _VODI_BENIN_ALPHA2 bj
# define VODI_BENIN_ALPHA3 "ben"
# define _VODI_BENIN_ALPHA3 ben
# define VodiK_BENIN_NUMERIC 204

/* Bermuda */
# define VODI_BERMUDA_NAME "Bermuda"
# define _VODI_BERMUDA_NAME Bermuda
# define VODI_BERMUDA_ALPHA2 "bm"
# define _VODI_BERMUDA_ALPHA2 bm
# define VODI_BERMUDA_ALPHA3 "bmu"
# define _VODI_BERMUDA_ALPHA3 bmu
# define VodiK_BERMUDA_NUMERIC 60

/* Bhutan */
# define VODI_BHUTAN_NAME "Bhutan"
# define _VODI_BHUTAN_NAME Bhutan
# define VODI_BHUTAN_ALPHA2 "bt"
# define _VODI_BHUTAN_ALPHA2 bt
# define VODI_BHUTAN_ALPHA3 "btn"
# define _VODI_BHUTAN_ALPHA3 btn
# define VodiK_BHUTAN_NUMERIC 64

/* Bolivia, Plurinational State of */
# define VODI_BOLIVIA_NAME "Bolivia, Plurinational State of"
# define _VODI_BOLIVIA_NAME Bolivia
# define VODI_BOLIVIA_ALPHA2 "bo"
# define _VODI_BOLIVIA_ALPHA2 bo
# define VODI_BOLIVIA_ALPHA3 "bol"
# define _VODI_BOLIVIA_ALPHA3 bol
# define VodiK_BOLIVIA_NUMERIC 68
# define VODI_BOLIVIA_ALIAS "Bolivia"

/* Bonaire, Sint Eustatius and Saba */
# define VODI_BONAIRE_NAME "Bonaire, Sint Eustatius and Saba"
# define _VODI_BONAIRE_NAME Bonaire
# define VODI_BONAIRE_ALPHA2 "bq"
# define _VODI_BONAIRE_ALPHA2 bq
# define VODI_BONAIRE_ALPHA3 "bes"
# define _VODI_BONAIRE_ALPHA3 bes
# define VodiK_BONAIRE_NUMERIC 535
# define VODI_BONAIRE_ALIAS "Bonaire"

/* Bosnia and Herzegovina */
# define VODI_BOSNIA_AND_HERZEGOVINA_NAME "Bosnia and Herzegovina"
# define _VODI_BOSNIA_AND_HERZEGOVINA_NAME Bosnia_and_Herzegovina
# define VODI_BOSNIA_AND_HERZEGOVINA_ALPHA2 "ba"
# define _VODI_BOSNIA_AND_HERZEGOVINA_ALPHA2 ba
# define VODI_BOSNIA_AND_HERZEGOVINA_ALPHA3 "bih"
# define _VODI_BOSNIA_AND_HERZEGOVINA_ALPHA3 bih
# define VodiK_BOSNIA_AND_HERZEGOVINA_NUMERIC 70

/* Botswana */
# define VODI_BOTSWANA_NAME "Botswana"
# define _VODI_BOTSWANA_NAME Botswana
# define VODI_BOTSWANA_ALPHA2 "bw"
# define _VODI_BOTSWANA_ALPHA2 bw
# define VODI_BOTSWANA_ALPHA3 "bwa"
# define _VODI_BOTSWANA_ALPHA3 bwa
# define VodiK_BOTSWANA_NUMERIC 72

/* Bouvet Island */
# define VODI_BOUVET_ISLAND_NAME "Bouvet Island"
# define _VODI_BOUVET_ISLAND_NAME Bouvet_Island
# define VODI_BOUVET_ISLAND_ALPHA2 "bv"
# define _VODI_BOUVET_ISLAND_ALPHA2 bv
# define VODI_BOUVET_ISLAND_ALPHA3 "bvt"
# define _VODI_BOUVET_ISLAND_ALPHA3 bvt
# define VodiK_BOUVET_ISLAND_NUMERIC 74

/* Brazil */
# define VODI_BRAZIL_NAME "Brazil"
# define _VODI_BRAZIL_NAME Brazil
# define VODI_BRAZIL_ALPHA2 "br"
# define _VODI_BRAZIL_ALPHA2 br
# define VODI_BRAZIL_ALPHA3 "bra"
# define _VODI_BRAZIL_ALPHA3 bra
# define VodiK_BRAZIL_NUMERIC 76

/* British Indian Ocean Territory */
# define VODI_BRITISH_INDIAN_OCEAN_TERRITORY_NAME "British Indian Ocean Territory"
# define _VODI_BRITISH_INDIAN_OCEAN_TERRITORY_NAME British_Indian_Ocean_Territory
# define VODI_BRITISH_INDIAN_OCEAN_TERRITORY_ALPHA2 "io"
# define _VODI_BRITISH_INDIAN_OCEAN_TERRITORY_ALPHA2 io
# define VODI_BRITISH_INDIAN_OCEAN_TERRITORY_ALPHA3 "iot"
# define _VODI_BRITISH_INDIAN_OCEAN_TERRITORY_ALPHA3 iot
# define VodiK_BRITISH_INDIAN_OCEAN_TERRITORY_NUMERIC 86

/* Brunei Darussalam */
# define VODI_BRUNEI_DARUSSALAM_NAME "Brunei Darussalam"
# define _VODI_BRUNEI_DARUSSALAM_NAME Brunei_Darussalam
# define VODI_BRUNEI_DARUSSALAM_ALPHA2 "bn"
# define _VODI_BRUNEI_DARUSSALAM_ALPHA2 bn
# define VODI_BRUNEI_DARUSSALAM_ALPHA3 "brn"
# define _VODI_BRUNEI_DARUSSALAM_ALPHA3 brn
# define VodiK_BRUNEI_DARUSSALAM_NUMERIC 96

/* Bulgaria */
# define VODI_BULGARIA_NAME "Bulgaria"
# define _VODI_BULGARIA_NAME Bulgaria
# define VODI_BULGARIA_ALPHA2 "bg"
# define _VODI_BULGARIA_ALPHA2 bg
# define VODI_BULGARIA_ALPHA3 "bgr"
# define _VODI_BULGARIA_ALPHA3 bgr
# define VodiK_BULGARIA_NUMERIC 100

/* Burkina Faso */
# define VODI_BURKINA_FASO_NAME "Burkina Faso"
# define _VODI_BURKINA_FASO_NAME Burkina_Faso
# define VODI_BURKINA_FASO_ALPHA2 "bf"
# define _VODI_BURKINA_FASO_ALPHA2 bf
# define VODI_BURKINA_FASO_ALPHA3 "bfa"
# define _VODI_BURKINA_FASO_ALPHA3 bfa
# define VodiK_BURKINA_FASO_NUMERIC 854

/* Burundi */
# define VODI_BURUNDI_NAME "Burundi"
# define _VODI_BURUNDI_NAME Burundi
# define VODI_BURUNDI_ALPHA2 "bi"
# define _VODI_BURUNDI_ALPHA2 bi
# define VODI_BURUNDI_ALPHA3 "bdi"
# define _VODI_BURUNDI_ALPHA3 bdi
# define VodiK_BURUNDI_NUMERIC 108

/* Cambodia */
# define VODI_CAMBODIA_NAME "Cambodia"
# define _VODI_CAMBODIA_NAME Cambodia
# define VODI_CAMBODIA_ALPHA2 "kh"
# define _VODI_CAMBODIA_ALPHA2 kh
# define VODI_CAMBODIA_ALPHA3 "khm"
# define _VODI_CAMBODIA_ALPHA3 khm
# define VodiK_CAMBODIA_NUMERIC 116

/* Cameroon */
# define VODI_CAMEROON_NAME "Cameroon"
# define _VODI_CAMEROON_NAME Cameroon
# define VODI_CAMEROON_ALPHA2 "cm"
# define _VODI_CAMEROON_ALPHA2 cm
# define VODI_CAMEROON_ALPHA3 "cmr"
# define _VODI_CAMEROON_ALPHA3 cmr
# define VodiK_CAMEROON_NUMERIC 120

/* Canada */
# define VODI_CANADA_NAME "Canada"
# define _VODI_CANADA_NAME Canada
# define VODI_CANADA_ALPHA2 "ca"
# define _VODI_CANADA_ALPHA2 ca
# define VODI_CANADA_ALPHA3 "can"
# define _VODI_CANADA_ALPHA3 can
# define VodiK_CANADA_NUMERIC 124

/* Cape Verde */
# define VODI_CAPE_VERDE_NAME "Cape Verde"
# define _VODI_CAPE_VERDE_NAME Cape_Verde
# define VODI_CAPE_VERDE_ALPHA2 "cv"
# define _VODI_CAPE_VERDE_ALPHA2 cv
# define VODI_CAPE_VERDE_ALPHA3 "cpv"
# define _VODI_CAPE_VERDE_ALPHA3 cpv
# define VodiK_CAPE_VERDE_NUMERIC 132

/* Cayman Islands */
# define VODI_CAYMAN_ISLANDS_NAME "Cayman Islands"
# define _VODI_CAYMAN_ISLANDS_NAME Cayman_Islands
# define VODI_CAYMAN_ISLANDS_ALPHA2 "ky"
# define _VODI_CAYMAN_ISLANDS_ALPHA2 ky
# define VODI_CAYMAN_ISLANDS_ALPHA3 "cym"
# define _VODI_CAYMAN_ISLANDS_ALPHA3 cym
# define VodiK_CAYMAN_ISLANDS_NUMERIC 136

/* Central African Republic */
# define VODI_CENTRAL_AFRICAN_REPUBLIC_NAME "Central African Republic"
# define _VODI_CENTRAL_AFRICAN_REPUBLIC_NAME Central_African_Republic
# define VODI_CENTRAL_AFRICAN_REPUBLIC_ALPHA2 "cf"
# define _VODI_CENTRAL_AFRICAN_REPUBLIC_ALPHA2 cf
# define VODI_CENTRAL_AFRICAN_REPUBLIC_ALPHA3 "caf"
# define _VODI_CENTRAL_AFRICAN_REPUBLIC_ALPHA3 caf
# define VodiK_CENTRAL_AFRICAN_REPUBLIC_NUMERIC 140

/* Chad */
# define VODI_CHAD_NAME "Chad"
# define _VODI_CHAD_NAME Chad
# define VODI_CHAD_ALPHA2 "td"
# define _VODI_CHAD_ALPHA2 td
# define VODI_CHAD_ALPHA3 "tcd"
# define _VODI_CHAD_ALPHA3 tcd
# define VodiK_CHAD_NUMERIC 148

/* Chile */
# define VODI_CHILE_NAME "Chile"
# define _VODI_CHILE_NAME Chile
# define VODI_CHILE_ALPHA2 "cl"
# define _VODI_CHILE_ALPHA2 cl
# define VODI_CHILE_ALPHA3 "chl"
# define _VODI_CHILE_ALPHA3 chl
# define VodiK_CHILE_NUMERIC 152

/* China */
# define VODI_CHINA_NAME "China"
# define _VODI_CHINA_NAME China
# define VODI_CHINA_ALPHA2 "cn"
# define _VODI_CHINA_ALPHA2 cn
# define VODI_CHINA_ALPHA3 "chn"
# define _VODI_CHINA_ALPHA3 chn
# define VodiK_CHINA_NUMERIC 156

/* Christmas Island */
# define VODI_CHRISTMAS_ISLAND_NAME "Christmas Island"
# define _VODI_CHRISTMAS_ISLAND_NAME Christmas_Island
# define VODI_CHRISTMAS_ISLAND_ALPHA2 "cx"
# define _VODI_CHRISTMAS_ISLAND_ALPHA2 cx
# define VODI_CHRISTMAS_ISLAND_ALPHA3 "cxr"
# define _VODI_CHRISTMAS_ISLAND_ALPHA3 cxr
# define VodiK_CHRISTMAS_ISLAND_NUMERIC 162

/* Cocos (Keeling) Islands */
# define VODI_COCOS_ISLANDS_NAME "Cocos (Keeling) Islands"
# define _VODI_COCOS_ISLANDS_NAME Cocos_Islands
# define VODI_COCOS_ISLANDS_ALPHA2 "cc"
# define _VODI_COCOS_ISLANDS_ALPHA2 cc
# define VODI_COCOS_ISLANDS_ALPHA3 "cck"
# define _VODI_COCOS_ISLANDS_ALPHA3 cck
# define VodiK_COCOS_ISLANDS_NUMERIC 166

/* Colombia */
# define VODI_COLOMBIA_NAME "Colombia"
# define _VODI_COLOMBIA_NAME Colombia
# define VODI_COLOMBIA_ALPHA2 "co"
# define _VODI_COLOMBIA_ALPHA2 co
# define VODI_COLOMBIA_ALPHA3 "col"
# define _VODI_COLOMBIA_ALPHA3 col
# define VodiK_COLOMBIA_NUMERIC 170

/* Comoros */
# define VODI_COMOROS_NAME "Comoros"
# define _VODI_COMOROS_NAME Comoros
# define VODI_COMOROS_ALPHA2 "km"
# define _VODI_COMOROS_ALPHA2 km
# define VODI_COMOROS_ALPHA3 "com"
# define _VODI_COMOROS_ALPHA3 com
# define VodiK_COMOROS_NUMERIC 174

/* Congo */
# define VODI_CONGO_NAME "Congo"
# define _VODI_CONGO_NAME Congo
# define VODI_CONGO_ALPHA2 "cg"
# define _VODI_CONGO_ALPHA2 cg
# define VODI_CONGO_ALPHA3 "cog"
# define _VODI_CONGO_ALPHA3 cog
# define VodiK_CONGO_NUMERIC 178

/* Democratic Republic of the Congo */
# define VODI_CONGO_DEMOCRATIC_REPUBLIC_NAME "Democratic Republic of the Congo"
# define _VODI_CONGO_DEMOCRATIC_REPUBLIC_NAME Democratic_Republic_of_the_Congo
# define VODI_CONGO_DEMOCRATIC_REPUBLIC_ALPHA2 "cd"
# define _VODI_CONGO_DEMOCRATIC_REPUBLIC_ALPHA2 cd
# define VODI_CONGO_DEMOCRATIC_REPUBLIC_ALPHA3 "cod"
# define _VODI_CONGO_DEMOCRATIC_REPUBLIC_ALPHA3 cod
# define VodiK_CONGO_DEMOCRATIC_REPUBLIC_NUMERIC 180

/* Cook Islands */
# define VODI_COOK_ISLANDS_NAME "Cook Islands"
# define _VODI_COOK_ISLANDS_NAME Cook_Islands
# define VODI_COOK_ISLANDS_ALPHA2 "ck"
# define _VODI_COOK_ISLANDS_ALPHA2 ck
# define VODI_COOK_ISLANDS_ALPHA3 "cok"
# define _VODI_COOK_ISLANDS_ALPHA3 cok
# define VodiK_COOK_ISLANDS_NUMERIC 184

/* Costa Rica */
# define VODI_COSTA_RICA_NAME "Costa Rica"
# define _VODI_COSTA_RICA_NAME Costa_Rica
# define VODI_COSTA_RICA_ALPHA2 "cr"
# define _VODI_COSTA_RICA_ALPHA2 cr
# define VODI_COSTA_RICA_ALPHA3 "cri"
# define _VODI_COSTA_RICA_ALPHA3 cri
# define VodiK_COSTA_RICA_NUMERIC 188

/* Côte d'Ivoire */
# define VODI_COTE_D_IVOIRE_NAME "Côte d'Ivoire"
# define _VODI_COTE_D_IVOIRE_NAME Cote_d_Ivoire
# define VODI_COTE_D_IVOIRE_ALPHA2 "ci"
# define _VODI_COTE_D_IVOIRE_ALPHA2 ci
# define VODI_COTE_D_IVOIRE_ALPHA3 "civ"
# define _VODI_COTE_D_IVOIRE_ALPHA3 civ
# define VodiK_COTE_D_IVOIRE_NUMERIC 384

/* Croatia */
# define VODI_CROATIA_NAME "Croatia"
# define _VODI_CROATIA_NAME Croatia
# define VODI_CROATIA_ALPHA2 "hr"
# define _VODI_CROATIA_ALPHA2 hr
# define VODI_CROATIA_ALPHA3 "hrv"
# define _VODI_CROATIA_ALPHA3 hrv
# define VodiK_CROATIA_NUMERIC 191

/* Cuba */
# define VODI_CUBA_NAME "Cuba"
# define _VODI_CUBA_NAME Cuba
# define VODI_CUBA_ALPHA2 "cu"
# define _VODI_CUBA_ALPHA2 cu
# define VODI_CUBA_ALPHA3 "cub"
# define _VODI_CUBA_ALPHA3 cub
# define VodiK_CUBA_NUMERIC 192

/* Curaçao */
# define VODI_CURACAO_NAME "Curaçao"
# define _VODI_CURACAO_NAME Curacao
# define VODI_CURACAO_ALPHA2 "cw"
# define _VODI_CURACAO_ALPHA2 cw
# define VODI_CURACAO_ALPHA3 "cuw"
# define _VODI_CURACAO_ALPHA3 cuw
# define VodiK_CURACAO_NUMERIC 531

/* Cyprus */
# define VODI_CYPRUS_NAME "Cyprus"
# define _VODI_CYPRUS_NAME Cyprus
# define VODI_CYPRUS_ALPHA2 "cy"
# define _VODI_CYPRUS_ALPHA2 cy
# define VODI_CYPRUS_ALPHA3 "cyp"
# define _VODI_CYPRUS_ALPHA3 cyp
# define VodiK_CYPRUS_NUMERIC 196

/* Czech Republic */
# define VODI_CZECH_REPUBLIC_NAME "Czech Republic"
# define _VODI_CZECH_REPUBLIC_NAME Czech_Republic
# define VODI_CZECH_REPUBLIC_ALPHA2 "cz"
# define _VODI_CZECH_REPUBLIC_ALPHA2 cz
# define VODI_CZECH_REPUBLIC_ALPHA3 "cze"
# define _VODI_CZECH_REPUBLIC_ALPHA3 cze
# define VodiK_CZECH_REPUBLIC_NUMERIC 203

/* Denmark */
# define VODI_DENMARK_NAME "Denmark"
# define _VODI_DENMARK_NAME Denmark
# define VODI_DENMARK_ALPHA2 "dk"
# define _VODI_DENMARK_ALPHA2 dk
# define VODI_DENMARK_ALPHA3 "dnk"
# define _VODI_DENMARK_ALPHA3 dnk
# define VodiK_DENMARK_NUMERIC 208

/* Djibouti */
# define VODI_DJIBOUTI_NAME "Djibouti"
# define _VODI_DJIBOUTI_NAME Djibouti
# define VODI_DJIBOUTI_ALPHA2 "dj"
# define _VODI_DJIBOUTI_ALPHA2 dj
# define VODI_DJIBOUTI_ALPHA3 "dji"
# define _VODI_DJIBOUTI_ALPHA3 dji
# define VodiK_DJIBOUTI_NUMERIC 262

/* Dominica */
# define VODI_DOMINICA_NAME "Dominica"
# define _VODI_DOMINICA_NAME Dominica
# define VODI_DOMINICA_ALPHA2 "dm"
# define _VODI_DOMINICA_ALPHA2 dm
# define VODI_DOMINICA_ALPHA3 "dma"
# define _VODI_DOMINICA_ALPHA3 dma
# define VodiK_DOMINICA_NUMERIC 212

/* Dominican Republic */
# define VODI_DOMINICAN_REPUBLIC_NAME "Dominican Republic"
# define _VODI_DOMINICAN_REPUBLIC_NAME Dominican_Republic
# define VODI_DOMINICAN_REPUBLIC_ALPHA2 "do"
# define _VODI_DOMINICAN_REPUBLIC_ALPHA2 do
# define VODI_DOMINICAN_REPUBLIC_ALPHA3 "dom"
# define _VODI_DOMINICAN_REPUBLIC_ALPHA3 dom
# define VodiK_DOMINICAN_REPUBLIC_NUMERIC 214

/* Ecuador */
# define VODI_ECUADOR_NAME "Ecuador"
# define _VODI_ECUADOR_NAME Ecuador
# define VODI_ECUADOR_ALPHA2 "ec"
# define _VODI_ECUADOR_ALPHA2 ec
# define VODI_ECUADOR_ALPHA3 "ecu"
# define _VODI_ECUADOR_ALPHA3 ecu
# define VodiK_ECUADOR_NUMERIC 218

/* Egypt */
# define VODI_EGYPT_NAME "Egypt"
# define _VODI_EGYPT_NAME Egypt
# define VODI_EGYPT_ALPHA2 "eg"
# define _VODI_EGYPT_ALPHA2 eg
# define VODI_EGYPT_ALPHA3 "egy"
# define _VODI_EGYPT_ALPHA3 egy
# define VodiK_EGYPT_NUMERIC 818

/* El Salvador */
# define VODI_EL_SALVADOR_NAME "El Salvador"
# define _VODI_EL_SALVADOR_NAME El_Salvador
# define VODI_EL_SALVADOR_ALPHA2 "sv"
# define _VODI_EL_SALVADOR_ALPHA2 sv
# define VODI_EL_SALVADOR_ALPHA3 "slv"
# define _VODI_EL_SALVADOR_ALPHA3 slv
# define VodiK_EL_SALVADOR_NUMERIC 222

/* Equatorial Guinea */
# define VODI_EQUATORIAL_GUINEA_NAME "Equatorial Guinea"
# define _VODI_EQUATORIAL_GUINEA_NAME Equatorial_Guinea
# define VODI_EQUATORIAL_GUINEA_ALPHA2 "gq"
# define _VODI_EQUATORIAL_GUINEA_ALPHA2 gq
# define VODI_EQUATORIAL_GUINEA_ALPHA3 "gnq"
# define _VODI_EQUATORIAL_GUINEA_ALPHA3 gnq
# define VodiK_EQUATORIAL_GUINEA_NUMERIC 226

/* Eritrea */
# define VODI_ERITREA_NAME "Eritrea"
# define _VODI_ERITREA_NAME Eritrea
# define VODI_ERITREA_ALPHA2 "er"
# define _VODI_ERITREA_ALPHA2 er
# define VODI_ERITREA_ALPHA3 "eri"
# define _VODI_ERITREA_ALPHA3 eri
# define VodiK_ERITREA_NUMERIC 232

/* Estonia */
# define VODI_ESTONIA_NAME "Estonia"
# define _VODI_ESTONIA_NAME Estonia
# define VODI_ESTONIA_ALPHA2 "ee"
# define _VODI_ESTONIA_ALPHA2 ee
# define VODI_ESTONIA_ALPHA3 "est"
# define _VODI_ESTONIA_ALPHA3 est
# define VodiK_ESTONIA_NUMERIC 233

/* Ethiopia */
# define VODI_ETHIOPIA_NAME "Ethiopia"
# define _VODI_ETHIOPIA_NAME Ethiopia
# define VODI_ETHIOPIA_ALPHA2 "et"
# define _VODI_ETHIOPIA_ALPHA2 et
# define VODI_ETHIOPIA_ALPHA3 "eth"
# define _VODI_ETHIOPIA_ALPHA3 eth
# define VodiK_ETHIOPIA_NUMERIC 231

/* Falkland Islands (Malvinas) */
# define VODI_FALKLAND_ISLANDS_NAME "Falkland Islands (Malvinas)"
# define _VODI_FALKLAND_ISLANDS_NAME Falkland_Islands
# define VODI_FALKLAND_ISLANDS_ALPHA2 "fk"
# define _VODI_FALKLAND_ISLANDS_ALPHA2 fk
# define VODI_FALKLAND_ISLANDS_ALPHA3 "flk"
# define _VODI_FALKLAND_ISLANDS_ALPHA3 flk
# define VodiK_FALKLAND_ISLANDS_NUMERIC 238

/* Faroe Islands */
# define VODI_FAROE_ISLANDS_NAME "Faroe Islands"
# define _VODI_FAROE_ISLANDS_NAME Faroe_Islands
# define VODI_FAROE_ISLANDS_ALPHA2 "fo"
# define _VODI_FAROE_ISLANDS_ALPHA2 fo
# define VODI_FAROE_ISLANDS_ALPHA3 "fro"
# define _VODI_FAROE_ISLANDS_ALPHA3 fro
# define VodiK_FAROE_ISLANDS_NUMERIC 234

/* Fiji */
# define VODI_FIJI_NAME "Fiji"
# define _VODI_FIJI_NAME Fiji
# define VODI_FIJI_ALPHA2 "fj"
# define _VODI_FIJI_ALPHA2 fj
# define VODI_FIJI_ALPHA3 "fji"
# define _VODI_FIJI_ALPHA3 fji
# define VodiK_FIJI_NUMERIC 242

/* Finland */
# define VODI_FINLAND_NAME "Finland"
# define _VODI_FINLAND_NAME Finland
# define VODI_FINLAND_ALPHA2 "fi"
# define _VODI_FINLAND_ALPHA2 fi
# define VODI_FINLAND_ALPHA3 "fin"
# define _VODI_FINLAND_ALPHA3 fin
# define VodiK_FINLAND_NUMERIC 246

/* France */
# define VODI_FRANCE_NAME "France"
# define _VODI_FRANCE_NAME France
# define VODI_FRANCE_ALPHA2 "fr"
# define _VODI_FRANCE_ALPHA2 fr
# define VODI_FRANCE_ALPHA3 "fra"
# define _VODI_FRANCE_ALPHA3 fra
# define VodiK_FRANCE_NUMERIC 250

/* French Guiana */
# define VODI_FRENCH_GUIANA_NAME "French Guiana"
# define _VODI_FRENCH_GUIANA_NAME French_Guiana
# define VODI_FRENCH_GUIANA_ALPHA2 "gf"
# define _VODI_FRENCH_GUIANA_ALPHA2 gf
# define VODI_FRENCH_GUIANA_ALPHA3 "guf"
# define _VODI_FRENCH_GUIANA_ALPHA3 guf
# define VodiK_FRENCH_GUIANA_NUMERIC 254

/* French Polynesia */
# define VODI_FRENCH_POLYNESIA_NAME "French Polynesia"
# define _VODI_FRENCH_POLYNESIA_NAME French_Polynesia
# define VODI_FRENCH_POLYNESIA_ALPHA2 "pf"
# define _VODI_FRENCH_POLYNESIA_ALPHA2 pf
# define VODI_FRENCH_POLYNESIA_ALPHA3 "pyf"
# define _VODI_FRENCH_POLYNESIA_ALPHA3 pyf
# define VodiK_FRENCH_POLYNESIA_NUMERIC 258

/* French Southern Territories */
# define VODI_FRENCH_SOUTHERN_TERRITORIES_NAME "French Southern Territories"
# define _VODI_FRENCH_SOUTHERN_TERRITORIES_NAME French_Southern_Territories
# define VODI_FRENCH_SOUTHERN_TERRITORIES_ALPHA2 "tf"
# define _VODI_FRENCH_SOUTHERN_TERRITORIES_ALPHA2 tf
# define VODI_FRENCH_SOUTHERN_TERRITORIES_ALPHA3 "atf"
# define _VODI_FRENCH_SOUTHERN_TERRITORIES_ALPHA3 atf
# define VodiK_FRENCH_SOUTHERN_TERRITORIES_NUMERIC 260

/* Gabon */
# define VODI_GABON_NAME "Gabon"
# define _VODI_GABON_NAME Gabon
# define VODI_GABON_ALPHA2 "ga"
# define _VODI_GABON_ALPHA2 ga
# define VODI_GABON_ALPHA3 "gab"
# define _VODI_GABON_ALPHA3 gab
# define VodiK_GABON_NUMERIC 266

/* Gambia */
# define VODI_GAMBIA_NAME "Gambia"
# define _VODI_GAMBIA_NAME Gambia
# define VODI_GAMBIA_ALPHA2 "gm"
# define _VODI_GAMBIA_ALPHA2 gm
# define VODI_GAMBIA_ALPHA3 "gmb"
# define _VODI_GAMBIA_ALPHA3 gmb
# define VodiK_GAMBIA_NUMERIC 270

/* Georgia */
# define VODI_GEORGIA_NAME "Georgia"
# define _VODI_GEORGIA_NAME Georgia
# define VODI_GEORGIA_ALPHA2 "ge"
# define _VODI_GEORGIA_ALPHA2 ge
# define VODI_GEORGIA_ALPHA3 "geo"
# define _VODI_GEORGIA_ALPHA3 geo
# define VodiK_GEORGIA_NUMERIC 268

/* Germany */
# define VODI_GERMANY_NAME "Germany"
# define _VODI_GERMANY_NAME Germany
# define VODI_GERMANY_ALPHA2 "de"
# define _VODI_GERMANY_ALPHA2 de
# define VODI_GERMANY_ALPHA3 "deu"
# define _VODI_GERMANY_ALPHA3 deu
# define VodiK_GERMANY_NUMERIC 276

/* Ghana */
# define VODI_GHANA_NAME "Ghana"
# define _VODI_GHANA_NAME Ghana
# define VODI_GHANA_ALPHA2 "gh"
# define _VODI_GHANA_ALPHA2 gh
# define VODI_GHANA_ALPHA3 "gha"
# define _VODI_GHANA_ALPHA3 gha
# define VodiK_GHANA_NUMERIC 288

/* Gibraltar */
# define VODI_GIBRALTAR_NAME "Gibraltar"
# define _VODI_GIBRALTAR_NAME Gibraltar
# define VODI_GIBRALTAR_ALPHA2 "gi"
# define _VODI_GIBRALTAR_ALPHA2 gi
# define VODI_GIBRALTAR_ALPHA3 "gib"
# define _VODI_GIBRALTAR_ALPHA3 gib
# define VodiK_GIBRALTAR_NUMERIC 292

/* Greece */
# define VODI_GREECE_NAME "Greece"
# define _VODI_GREECE_NAME Greece
# define VODI_GREECE_ALPHA2 "gr"
# define _VODI_GREECE_ALPHA2 gr
# define VODI_GREECE_ALPHA3 "grc"
# define _VODI_GREECE_ALPHA3 grc
# define VodiK_GREECE_NUMERIC 300

/* Greenland */
# define VODI_GREENLAND_NAME "Greenland"
# define _VODI_GREENLAND_NAME Greenland
# define VODI_GREENLAND_ALPHA2 "gl"
# define _VODI_GREENLAND_ALPHA2 gl
# define VODI_GREENLAND_ALPHA3 "grl"
# define _VODI_GREENLAND_ALPHA3 grl
# define VodiK_GREENLAND_NUMERIC 304

/* Grenada */
# define VODI_GRENADA_NAME "Grenada"
# define _VODI_GRENADA_NAME Grenada
# define VODI_GRENADA_ALPHA2 "gd"
# define _VODI_GRENADA_ALPHA2 gd
# define VODI_GRENADA_ALPHA3 "grd"
# define _VODI_GRENADA_ALPHA3 grd
# define VodiK_GRENADA_NUMERIC 308

/* Guadeloupe */
# define VODI_GUADELOUPE_NAME "Guadeloupe"
# define _VODI_GUADELOUPE_NAME Guadeloupe
# define VODI_GUADELOUPE_ALPHA2 "gp"
# define _VODI_GUADELOUPE_ALPHA2 gp
# define VODI_GUADELOUPE_ALPHA3 "glp"
# define _VODI_GUADELOUPE_ALPHA3 glp
# define VodiK_GUADELOUPE_NUMERIC 312

/* Guam */
# define VODI_GUAM_NAME "Guam"
# define _VODI_GUAM_NAME Guam
# define VODI_GUAM_ALPHA2 "gu"
# define _VODI_GUAM_ALPHA2 gu
# define VODI_GUAM_ALPHA3 "gum"
# define _VODI_GUAM_ALPHA3 gum
# define VodiK_GUAM_NUMERIC 316

/* Guatemala */
# define VODI_GUATEMALA_NAME "Guatemala"
# define _VODI_GUATEMALA_NAME Guatemala
# define VODI_GUATEMALA_ALPHA2 "gt"
# define _VODI_GUATEMALA_ALPHA2 gt
# define VODI_GUATEMALA_ALPHA3 "gtm"
# define _VODI_GUATEMALA_ALPHA3 gtm
# define VodiK_GUATEMALA_NUMERIC 320

/* Guernsey */
# define VODI_GUERNSEY_NAME "Guernsey"
# define _VODI_GUERNSEY_NAME Guernsey
# define VODI_GUERNSEY_ALPHA2 "gg"
# define _VODI_GUERNSEY_ALPHA2 gg
# define VODI_GUERNSEY_ALPHA3 "ggy"
# define _VODI_GUERNSEY_ALPHA3 ggy
# define VodiK_GUERNSEY_NUMERIC 831

/* Guinea */
# define VODI_GUINEA_NAME "Guinea"
# define _VODI_GUINEA_NAME Guinea
# define VODI_GUINEA_ALPHA2 "gn"
# define _VODI_GUINEA_ALPHA2 gn
# define VODI_GUINEA_ALPHA3 "gin"
# define _VODI_GUINEA_ALPHA3 gin
# define VodiK_GUINEA_NUMERIC 324

/* Guinea-Bissau */
# define VODI_GUINEA_BISSAU_NAME "Guinea-Bissau"
# define _VODI_GUINEA_BISSAU_NAME Guinea_Bissau
# define VODI_GUINEA_BISSAU_ALPHA2 "gw"
# define _VODI_GUINEA_BISSAU_ALPHA2 gw
# define VODI_GUINEA_BISSAU_ALPHA3 "gnb"
# define _VODI_GUINEA_BISSAU_ALPHA3 gnb
# define VodiK_GUINEA_BISSAU_NUMERIC 624

/* Guyana */
# define VODI_GUYANA_NAME "Guyana"
# define _VODI_GUYANA_NAME Guyana
# define VODI_GUYANA_ALPHA2 "gy"
# define _VODI_GUYANA_ALPHA2 gy
# define VODI_GUYANA_ALPHA3 "guy"
# define _VODI_GUYANA_ALPHA3 guy
# define VodiK_GUYANA_NUMERIC 328

/* Haiti */
# define VODI_HAITI_NAME "Haiti"
# define _VODI_HAITI_NAME Haiti
# define VODI_HAITI_ALPHA2 "ht"
# define _VODI_HAITI_ALPHA2 ht
# define VODI_HAITI_ALPHA3 "hti"
# define _VODI_HAITI_ALPHA3 hti
# define VodiK_HAITI_NUMERIC 332

/* Heard Island and McDonald Islands */
# define VODI_HEARD_ISLAND_AND_MCDONALD_ISLANDS_NAME "Heard Island and McDonald Islands"
# define _VODI_HEARD_ISLAND_AND_MCDONALD_ISLANDS_NAME Heard_Island_and_McDonald_Islands
# define VODI_HEARD_ISLAND_AND_MCDONALD_ISLANDS_ALPHA2 "hm"
# define _VODI_HEARD_ISLAND_AND_MCDONALD_ISLANDS_ALPHA2 hm
# define VODI_HEARD_ISLAND_AND_MCDONALD_ISLANDS_ALPHA3 "hmd"
# define _VODI_HEARD_ISLAND_AND_MCDONALD_ISLANDS_ALPHA3 hmd
# define VodiK_HEARD_ISLAND_AND_MCDONALD_ISLANDS_NUMERIC 334

/* Holy See (Vatican City State) */
# define VODI_HOLY_SEE_NAME "Holy See (Vatican City State)"
# define _VODI_HOLY_SEE_NAME Holy_See
# define VODI_HOLY_SEE_ALPHA2 "va"
# define _VODI_HOLY_SEE_ALPHA2 va
# define VODI_HOLY_SEE_ALPHA3 "vat"
# define _VODI_HOLY_SEE_ALPHA3 vat
# define VodiK_HOLY_SEE_NUMERIC 336

/* Honduras */
# define VODI_HONDURAS_NAME "Honduras"
# define _VODI_HONDURAS_NAME Honduras
# define VODI_HONDURAS_ALPHA2 "hn"
# define _VODI_HONDURAS_ALPHA2 hn
# define VODI_HONDURAS_ALPHA3 "hnd"
# define _VODI_HONDURAS_ALPHA3 hnd
# define VodiK_HONDURAS_NUMERIC 340

/* Hong Kong */
# define VODI_HONG_KONG_NAME "Hong Kong"
# define _VODI_HONG_KONG_NAME Hong_Kong
# define VODI_HONG_KONG_ALPHA2 "hk"
# define _VODI_HONG_KONG_ALPHA2 hk
# define VODI_HONG_KONG_ALPHA3 "hkg"
# define _VODI_HONG_KONG_ALPHA3 hkg
# define VodiK_HONG_KONG_NUMERIC 344

/* Hungary */
# define VODI_HUNGARY_NAME "Hungary"
# define _VODI_HUNGARY_NAME Hungary
# define VODI_HUNGARY_ALPHA2 "hu"
# define _VODI_HUNGARY_ALPHA2 hu
# define VODI_HUNGARY_ALPHA3 "hun"
# define _VODI_HUNGARY_ALPHA3 hun
# define VodiK_HUNGARY_NUMERIC 348

/* Iceland */
# define VODI_ICELAND_NAME "Iceland"
# define _VODI_ICELAND_NAME Iceland
# define VODI_ICELAND_ALPHA2 "is"
# define _VODI_ICELAND_ALPHA2 is
# define VODI_ICELAND_ALPHA3 "isl"
# define _VODI_ICELAND_ALPHA3 isl
# define VodiK_ICELAND_NUMERIC 352

/* India */
# define VODI_INDIA_NAME "India"
# define _VODI_INDIA_NAME India
# define VODI_INDIA_ALPHA2 "in"
# define _VODI_INDIA_ALPHA2 in
# define VODI_INDIA_ALPHA3 "ind"
# define _VODI_INDIA_ALPHA3 ind
# define VodiK_INDIA_NUMERIC 356

/* Indonesia */
# define VODI_INDONESIA_NAME "Indonesia"
# define _VODI_INDONESIA_NAME Indonesia
# define VODI_INDONESIA_ALPHA2 "id"
# define _VODI_INDONESIA_ALPHA2 id
# define VODI_INDONESIA_ALPHA3 "idn"
# define _VODI_INDONESIA_ALPHA3 idn
# define VodiK_INDONESIA_NUMERIC 360

/* Iran, Islamic Republic of */
# define VODI_IRAN_NAME "Iran, Islamic Republic of"
# define _VODI_IRAN_NAME Iran
# define VODI_IRAN_ALPHA2 "ir"
# define _VODI_IRAN_ALPHA2 ir
# define VODI_IRAN_ALPHA3 "irn"
# define _VODI_IRAN_ALPHA3 irn
# define VodiK_IRAN_NUMERIC 364
# define VODI_IRAN_ALIAS "Iran"

/* Iraq */
# define VODI_IRAQ_NAME "Iraq"
# define _VODI_IRAQ_NAME Iraq
# define VODI_IRAQ_ALPHA2 "iq"
# define _VODI_IRAQ_ALPHA2 iq
# define VODI_IRAQ_ALPHA3 "irq"
# define _VODI_IRAQ_ALPHA3 irq
# define VodiK_IRAQ_NUMERIC 368

/* Ireland */
# define VODI_IRELAND_NAME "Ireland"
# define _VODI_IRELAND_NAME Ireland
# define VODI_IRELAND_ALPHA2 "ie"
# define _VODI_IRELAND_ALPHA2 ie
# define VODI_IRELAND_ALPHA3 "irl"
# define _VODI_IRELAND_ALPHA3 irl
# define VodiK_IRELAND_NUMERIC 372

/* Isle of Man */
# define VODI_ISLE_OF_MAN_NAME "Isle of Man"
# define _VODI_ISLE_OF_MAN_NAME Isle_of_Man
# define VODI_ISLE_OF_MAN_ALPHA2 "im"
# define _VODI_ISLE_OF_MAN_ALPHA2 im
# define VODI_ISLE_OF_MAN_ALPHA3 "imn"
# define _VODI_ISLE_OF_MAN_ALPHA3 imn
# define VodiK_ISLE_OF_MAN_NUMERIC 833

/* Israel */
# define VODI_ISRAEL_NAME "Israel"
# define _VODI_ISRAEL_NAME Israel
# define VODI_ISRAEL_ALPHA2 "il"
# define _VODI_ISRAEL_ALPHA2 il
# define VODI_ISRAEL_ALPHA3 "isr"
# define _VODI_ISRAEL_ALPHA3 isr
# define VodiK_ISRAEL_NUMERIC 376

/* Italy */
# define VODI_ITALY_NAME "Italy"
# define _VODI_ITALY_NAME Italy
# define VODI_ITALY_ALPHA2 "it"
# define _VODI_ITALY_ALPHA2 it
# define VODI_ITALY_ALPHA3 "ita"
# define _VODI_ITALY_ALPHA3 ita
# define VodiK_ITALY_NUMERIC 380

/* Jamaica */
# define VODI_JAMAICA_NAME "Jamaica"
# define _VODI_JAMAICA_NAME Jamaica
# define VODI_JAMAICA_ALPHA2 "jm"
# define _VODI_JAMAICA_ALPHA2 jm
# define VODI_JAMAICA_ALPHA3 "jam"
# define _VODI_JAMAICA_ALPHA3 jam
# define VodiK_JAMAICA_NUMERIC 388

/* Japan */
# define VODI_JAPAN_NAME "Japan"
# define _VODI_JAPAN_NAME Japan
# define VODI_JAPAN_ALPHA2 "jp"
# define _VODI_JAPAN_ALPHA2 jp
# define VODI_JAPAN_ALPHA3 "jpn"
# define _VODI_JAPAN_ALPHA3 jpn
# define VodiK_JAPAN_NUMERIC 392

/* Jersey */
# define VODI_JERSEY_NAME "Jersey"
# define _VODI_JERSEY_NAME Jersey
# define VODI_JERSEY_ALPHA2 "je"
# define _VODI_JERSEY_ALPHA2 je
# define VODI_JERSEY_ALPHA3 "jey"
# define _VODI_JERSEY_ALPHA3 jey
# define VodiK_JERSEY_NUMERIC 832

/* Jordan */
# define VODI_JORDAN_NAME "Jordan"
# define _VODI_JORDAN_NAME Jordan
# define VODI_JORDAN_ALPHA2 "jo"
# define _VODI_JORDAN_ALPHA2 jo
# define VODI_JORDAN_ALPHA3 "jor"
# define _VODI_JORDAN_ALPHA3 jor
# define VodiK_JORDAN_NUMERIC 400

/* Kazakhstan */
# define VODI_KAZAKHSTAN_NAME "Kazakhstan"
# define _VODI_KAZAKHSTAN_NAME Kazakhstan
# define VODI_KAZAKHSTAN_ALPHA2 "kz"
# define _VODI_KAZAKHSTAN_ALPHA2 kz
# define VODI_KAZAKHSTAN_ALPHA3 "kaz"
# define _VODI_KAZAKHSTAN_ALPHA3 kaz
# define VodiK_KAZAKHSTAN_NUMERIC 398

/* Kenya */
# define VODI_KENYA_NAME "Kenya"
# define _VODI_KENYA_NAME Kenya
# define VODI_KENYA_ALPHA2 "ke"
# define _VODI_KENYA_ALPHA2 ke
# define VODI_KENYA_ALPHA3 "ken"
# define _VODI_KENYA_ALPHA3 ken
# define VodiK_KENYA_NUMERIC 404

/* Kiribati */
# define VODI_KIRIBATI_NAME "Kiribati"
# define _VODI_KIRIBATI_NAME Kiribati
# define VODI_KIRIBATI_ALPHA2 "ki"
# define _VODI_KIRIBATI_ALPHA2 ki
# define VODI_KIRIBATI_ALPHA3 "kir"
# define _VODI_KIRIBATI_ALPHA3 kir
# define VodiK_KIRIBATI_NUMERIC 296

/* Korea, Democratic People's Republic of */
# define VODI_KOREA_DEMOCRATIC_PEOPLE_S_REPUBLIC_NAME "Korea, Democratic People's Republic of"
# define _VODI_KOREA_DEMOCRATIC_PEOPLE_S_REPUBLIC_NAME Democratic_Peoples_Republic_of_Korea
# define VODI_KOREA_DEMOCRATIC_PEOPLE_S_REPUBLIC_ALPHA2 "kp"
# define _VODI_KOREA_DEMOCRATIC_PEOPLE_S_REPUBLIC_ALPHA2 kp
# define VODI_KOREA_DEMOCRATIC_PEOPLE_S_REPUBLIC_ALPHA3 "prk"
# define _VODI_KOREA_DEMOCRATIC_PEOPLE_S_REPUBLIC_ALPHA3 prk
# define VodiK_KOREA_DEMOCRATIC_PEOPLE_S_REPUBLIC_NUMERIC 408

/* Republic of Korea */
# define VODI_KOREA_REPUBLIC_NAME "Republic of Korea"
# define _VODI_KOREA_REPUBLIC_NAME Republic_of_Korea
# define VODI_KOREA_REPUBLIC_ALPHA2 "kr"
# define _VODI_KOREA_REPUBLIC_ALPHA2 kr
# define VODI_KOREA_REPUBLIC_ALPHA3 "kor"
# define _VODI_KOREA_REPUBLIC_ALPHA3 kor
# define VodiK_KOREA_REPUBLIC_NUMERIC 410

/* NOTE: it isn't in ISO */
/* Kosovo */
# define VODI_KOSOVO_NAME "Kosovo"
# define _VODI_KOSOVO_NAME Kosovo
# define VODI_KOSOVO_ALPHA3 "rks"
# define _VODI_KOSOVO_ALPHA3 rks
# define VodiK_KOSOVO_NUMERIC 1688

/* Kuwait */
# define VODI_KUWAIT_NAME "Kuwait"
# define _VODI_KUWAIT_NAME Kuwait
# define VODI_KUWAIT_ALPHA2 "kw"
# define _VODI_KUWAIT_ALPHA2 kw
# define VODI_KUWAIT_ALPHA3 "kwt"
# define _VODI_KUWAIT_ALPHA3 kwt
# define VodiK_KUWAIT_NUMERIC 414

/* Kyrgyzstan */
# define VODI_KYRGYZSTAN_NAME "Kyrgyzstan"
# define _VODI_KYRGYZSTAN_NAME Kyrgyzstan
# define VODI_KYRGYZSTAN_ALPHA2 "kg"
# define _VODI_KYRGYZSTAN_ALPHA2 kg
# define VODI_KYRGYZSTAN_ALPHA3 "kgz"
# define _VODI_KYRGYZSTAN_ALPHA3 kgz
# define VodiK_KYRGYZSTAN_NUMERIC 417

/* Lao People's Democratic Republic */
# define VODI_LAO_PEOPLES_DEMOCRATIC_REPUBLIC_NAME "Lao People's Democratic Republic"
# define _VODI_LAO_PEOPLES_DEMOCRATIC_REPUBLIC_NAME Lao_Peoples_Democratic_Republic
# define VODI_LAO_PEOPLES_DEMOCRATIC_REPUBLIC_ALPHA2 "la"
# define _VODI_LAO_PEOPLES_DEMOCRATIC_REPUBLIC_ALPHA2 la
# define VODI_LAO_PEOPLES_DEMOCRATIC_REPUBLIC_ALPHA3 "lao"
# define _VODI_LAO_PEOPLES_DEMOCRATIC_REPUBLIC_ALPHA3 lao
# define VodiK_LAO_PEOPLES_DEMOCRATIC_REPUBLIC_NUMERIC 418

/* Latvia */
# define VODI_LATVIA_NAME "Latvia"
# define _VODI_LATVIA_NAME Latvia
# define VODI_LATVIA_ALPHA2 "lv"
# define _VODI_LATVIA_ALPHA2 lv
# define VODI_LATVIA_ALPHA3 "lva"
# define _VODI_LATVIA_ALPHA3 lva
# define VodiK_LATVIA_NUMERIC 428

/* Lebanon */
# define VODI_LEBANON_NAME "Lebanon"
# define _VODI_LEBANON_NAME Lebanon
# define VODI_LEBANON_ALPHA2 "lb"
# define _VODI_LEBANON_ALPHA2 lb
# define VODI_LEBANON_ALPHA3 "lbn"
# define _VODI_LEBANON_ALPHA3 lbn
# define VodiK_LEBANON_NUMERIC 422

/* Lesotho */
# define VODI_LESOTHO_NAME "Lesotho"
# define _VODI_LESOTHO_NAME Lesotho
# define VODI_LESOTHO_ALPHA2 "ls"
# define _VODI_LESOTHO_ALPHA2 ls
# define VODI_LESOTHO_ALPHA3 "lso"
# define _VODI_LESOTHO_ALPHA3 lso
# define VodiK_LESOTHO_NUMERIC 426

/* Liberia */
# define VODI_LIBERIA_NAME "Liberia"
# define _VODI_LIBERIA_NAME Liberia
# define VODI_LIBERIA_ALPHA2 "lr"
# define _VODI_LIBERIA_ALPHA2 lr
# define VODI_LIBERIA_ALPHA3 "lbr"
# define _VODI_LIBERIA_ALPHA3 lbr
# define VodiK_LIBERIA_NUMERIC 430

/* Libya */
# define VODI_LIBYA_NAME "Libya"
# define _VODI_LIBYA_NAME Libya
# define VODI_LIBYA_ALPHA2 "ly"
# define _VODI_LIBYA_ALPHA2 ly
# define VODI_LIBYA_ALPHA3 "lby"
# define _VODI_LIBYA_ALPHA3 lby
# define VodiK_LIBYA_NUMERIC 434

/* Liechtenstein */
# define VODI_LIECHTENSTEIN_NAME "Liechtenstein"
# define _VODI_LIECHTENSTEIN_NAME Liechtenstein
# define VODI_LIECHTENSTEIN_ALPHA2 "li"
# define _VODI_LIECHTENSTEIN_ALPHA2 li
# define VODI_LIECHTENSTEIN_ALPHA3 "lie"
# define _VODI_LIECHTENSTEIN_ALPHA3 lie
# define VodiK_LIECHTENSTEIN_NUMERIC 438

/* Lithuania */
# define VODI_LITHUANIA_NAME "Lithuania"
# define _VODI_LITHUANIA_NAME Lithuania
# define VODI_LITHUANIA_ALPHA2 "lt"
# define _VODI_LITHUANIA_ALPHA2 lt
# define VODI_LITHUANIA_ALPHA3 "ltu"
# define _VODI_LITHUANIA_ALPHA3 ltu
# define VodiK_LITHUANIA_NUMERIC 440

/* Luxembourg */
# define VODI_LUXEMBOURG_NAME "Luxembourg"
# define _VODI_LUXEMBOURG_NAME Luxembourg
# define VODI_LUXEMBOURG_ALPHA2 "lu"
# define _VODI_LUXEMBOURG_ALPHA2 lu
# define VODI_LUXEMBOURG_ALPHA3 "lux"
# define _VODI_LUXEMBOURG_ALPHA3 lux
# define VodiK_LUXEMBOURG_NUMERIC 442

/* Macao */
# define VODI_MACAO_NAME "Macao"
# define _VODI_MACAO_NAME Macao
# define VODI_MACAO_ALPHA2 "mo"
# define _VODI_MACAO_ALPHA2 mo
# define VODI_MACAO_ALPHA3 "mac"
# define _VODI_MACAO_ALPHA3 mac
# define VodiK_MACAO_NUMERIC 446

/* Macedonia, Republic of */
# define VODI_MACEDONIA_NAME "Macedonia, Republic of"
# define _VODI_MACEDONIA_NAME Republic_of_Macedonia
# define VODI_MACEDONIA_ALPHA2 "mk"
# define _VODI_MACEDONIA_ALPHA2 mk
# define VODI_MACEDONIA_ALPHA3 "mkd"
# define _VODI_MACEDONIA_ALPHA3 mkd
# define VodiK_MACEDONIA_NUMERIC 807
# define VODI_MACEDONIA_ALIAS "Macedonia"

/* Madagascar */
# define VODI_MADAGASCAR_NAME "Madagascar"
# define _VODI_MADAGASCAR_NAME Madagascar
# define VODI_MADAGASCAR_ALPHA2 "mg"
# define _VODI_MADAGASCAR_ALPHA2 mg
# define VODI_MADAGASCAR_ALPHA3 "mdg"
# define _VODI_MADAGASCAR_ALPHA3 mdg
# define VodiK_MADAGASCAR_NUMERIC 450

/* Malawi */
# define VODI_MALAWI_NAME "Malawi"
# define _VODI_MALAWI_NAME Malawi
# define VODI_MALAWI_ALPHA2 "mw"
# define _VODI_MALAWI_ALPHA2 mw
# define VODI_MALAWI_ALPHA3 "mwi"
# define _VODI_MALAWI_ALPHA3 mwi
# define VodiK_MALAWI_NUMERIC 454

/* Malaysia */
# define VODI_MALAYSIA_NAME "Malaysia"
# define _VODI_MALAYSIA_NAME Malaysia
# define VODI_MALAYSIA_ALPHA2 "my"
# define _VODI_MALAYSIA_ALPHA2 my
# define VODI_MALAYSIA_ALPHA3 "mys"
# define _VODI_MALAYSIA_ALPHA3 mys
# define VodiK_MALAYSIA_NUMERIC 458

/* Maldives */
# define VODI_MALDIVES_NAME "Maldives"
# define _VODI_MALDIVES_NAME Maldives
# define VODI_MALDIVES_ALPHA2 "mv"
# define _VODI_MALDIVES_ALPHA2 mv
# define VODI_MALDIVES_ALPHA3 "mdv"
# define _VODI_MALDIVES_ALPHA3 mdv
# define VodiK_MALDIVES_NUMERIC 462

/* Mali */
# define VODI_MALI_NAME "Mali"
# define _VODI_MALI_NAME Mali
# define VODI_MALI_ALPHA2 "ml"
# define _VODI_MALI_ALPHA2 ml
# define VODI_MALI_ALPHA3 "mli"
# define _VODI_MALI_ALPHA3 mli
# define VodiK_MALI_NUMERIC 466

/* Malta */
# define VODI_MALTA_NAME "Malta"
# define _VODI_MALTA_NAME Malta
# define VODI_MALTA_ALPHA2 "mt"
# define _VODI_MALTA_ALPHA2 mt
# define VODI_MALTA_ALPHA3 "mlt"
# define _VODI_MALTA_ALPHA3 mlt
# define VodiK_MALTA_NUMERIC 470

/* Marshall Islands */
# define VODI_MARSHALL_ISLANDS_NAME "Marshall Islands"
# define _VODI_MARSHALL_ISLANDS_NAME Marshall_Islands
# define VODI_MARSHALL_ISLANDS_ALPHA2 "mh"
# define _VODI_MARSHALL_ISLANDS_ALPHA2 mh
# define VODI_MARSHALL_ISLANDS_ALPHA3 "mhl"
# define _VODI_MARSHALL_ISLANDS_ALPHA3 mhl
# define VodiK_MARSHALL_ISLANDS_NUMERIC 584

/* Martinique */
# define VODI_MARTINIQUE_NAME "Martinique"
# define _VODI_MARTINIQUE_NAME Martinique
# define VODI_MARTINIQUE_ALPHA2 "mq"
# define _VODI_MARTINIQUE_ALPHA2 mq
# define VODI_MARTINIQUE_ALPHA3 "mtq"
# define _VODI_MARTINIQUE_ALPHA3 mtq
# define VodiK_MARTINIQUE_NUMERIC 474

/* Mauritania */
# define VODI_MAURITANIA_NAME "Mauritania"
# define _VODI_MAURITANIA_NAME Mauritania
# define VODI_MAURITANIA_ALPHA2 "mr"
# define _VODI_MAURITANIA_ALPHA2 mr
# define VODI_MAURITANIA_ALPHA3 "mrt"
# define _VODI_MAURITANIA_ALPHA3 mrt
# define VodiK_MAURITANIA_NUMERIC 478

/* Mauritius */
# define VODI_MAURITIUS_NAME "Mauritius"
# define _VODI_MAURITIUS_NAME Mauritius
# define VODI_MAURITIUS_ALPHA2 "mu"
# define _VODI_MAURITIUS_ALPHA2 mu
# define VODI_MAURITIUS_ALPHA3 "mus"
# define _VODI_MAURITIUS_ALPHA3 mus
# define VodiK_MAURITIUS_NUMERIC 480

/* Mayotte */
# define VODI_MAYOTTE_NAME "Mayotte"
# define _VODI_MAYOTTE_NAME Mayotte
# define VODI_MAYOTTE_ALPHA2 "yt"
# define _VODI_MAYOTTE_ALPHA2 yt
# define VODI_MAYOTTE_ALPHA3 "myt"
# define _VODI_MAYOTTE_ALPHA3 myt
# define VodiK_MAYOTTE_NUMERIC 175

/* Mexico */
# define VODI_MEXICO_NAME "Mexico"
# define _VODI_MEXICO_NAME Mexico
# define VODI_MEXICO_ALPHA2 "mx"
# define _VODI_MEXICO_ALPHA2 mx
# define VODI_MEXICO_ALPHA3 "mex"
# define _VODI_MEXICO_ALPHA3 mex
# define VodiK_MEXICO_NUMERIC 484

/* Micronesia, Federated States of */
# define VODI_MICRONESIA_NAME "Micronesia, Federated States of"
# define _VODI_MICRONESIA_NAME Federated_States_of_Micronesia
# define VODI_MICRONESIA_ALPHA2 "fm"
# define _VODI_MICRONESIA_ALPHA2 fm
# define VODI_MICRONESIA_ALPHA3 "fsm"
# define _VODI_MICRONESIA_ALPHA3 fsm
# define VodiK_MICRONESIA_NUMERIC 583
# define VODI_MICRONESIA_ALIAS "Micronesia"

/* Moldova, Republic of */
# define VODI_MOLDOVA_NAME "Moldova, Republic of"
# define _VODI_MOLDOVA_NAME Republic_of_Moldova
# define VODI_MOLDOVA_ALPHA2 "md"
# define _VODI_MOLDOVA_ALPHA2 md
# define VODI_MOLDOVA_ALPHA3 "mda"
# define _VODI_MOLDOVA_ALPHA3 mda
# define VodiK_MOLDOVA_NUMERIC 498
# define VODI_MOLDOVA_ALIAS "Moldova"

/* NOTE: it isn't in ISO */
/* Pridnestrovian Moldavian Republic; Pridnestrovie (Transnistria) */
# define VODI_PRIDNESTROVIAN_NAME "Pridnestrovian Moldavian Republic"
# define _VODI_PRIDNESTROVIAN_NAME Pridnestrovian_Moldavian_Republic
# define VODI_PRIDNESTROVIAN_ALPHA3 "pmr"
# define _VODI_PRIDNESTROVIAN_ALPHA3 pmr
# define VodiK_PRIDNESTROVIAN_NUMERIC 1498

/* Monaco */
# define VODI_MONACO_NAME "Monaco"
# define _VODI_MONACO_NAME Monaco
# define VODI_MONACO_ALPHA2 "mc"
# define _VODI_MONACO_ALPHA2 mc
# define VODI_MONACO_ALPHA3 "mco"
# define _VODI_MONACO_ALPHA3 mco
# define VodiK_MONACO_NUMERIC 492

/* Mongolia */
# define VODI_MONGOLIA_NAME "Mongolia"
# define _VODI_MONGOLIA_NAME Mongolia
# define VODI_MONGOLIA_ALPHA2 "mn"
# define _VODI_MONGOLIA_ALPHA2 mn
# define VODI_MONGOLIA_ALPHA3 "mng"
# define _VODI_MONGOLIA_ALPHA3 mng
# define VodiK_MONGOLIA_NUMERIC 496

/* Montenegro */
# define VODI_MONTENEGRO_NAME "Montenegro"
# define _VODI_MONTENEGRO_NAME Montenegro
# define VODI_MONTENEGRO_ALPHA2 "me"
# define _VODI_MONTENEGRO_ALPHA2 me
# define VODI_MONTENEGRO_ALPHA3 "mne"
# define _VODI_MONTENEGRO_ALPHA3 mne
# define VodiK_MONTENEGRO_NUMERIC 499

/* Montserrat */
# define VODI_MONTSERRAT_NAME "Montserrat"
# define _VODI_MONTSERRAT_NAME Montserrat
# define VODI_MONTSERRAT_ALPHA2 "ms"
# define _VODI_MONTSERRAT_ALPHA2 ms
# define VODI_MONTSERRAT_ALPHA3 "msr"
# define _VODI_MONTSERRAT_ALPHA3 msr
# define VodiK_MONTSERRAT_NUMERIC 500

/* Morocco */
# define VODI_MOROCCO_NAME "Morocco"
# define _VODI_MOROCCO_NAME Morocco
# define VODI_MOROCCO_ALPHA2 "ma"
# define _VODI_MOROCCO_ALPHA2 ma
# define VODI_MOROCCO_ALPHA3 "mar"
# define _VODI_MOROCCO_ALPHA3 mar
# define VodiK_MOROCCO_NUMERIC 504

/* Mozambique */
# define VODI_MOZAMBIQUE_NAME "Mozambique"
# define _VODI_MOZAMBIQUE_NAME Mozambique
# define VODI_MOZAMBIQUE_ALPHA2 "mz"
# define _VODI_MOZAMBIQUE_ALPHA2 mz
# define VODI_MOZAMBIQUE_ALPHA3 "moz"
# define _VODI_MOZAMBIQUE_ALPHA3 moz
# define VodiK_MOZAMBIQUE_NUMERIC 508

/* Myanmar */
# define VODI_MYANMAR_NAME "Myanmar"
# define _VODI_MYANMAR_NAME Myanmar
# define VODI_MYANMAR_ALPHA2 "mm"
# define _VODI_MYANMAR_ALPHA2 mm
# define VODI_MYANMAR_ALPHA3 "mmr"
# define _VODI_MYANMAR_ALPHA3 mmr
# define VodiK_MYANMAR_NUMERIC 104

/* Namibia */
# define VODI_NAMIBIA_NAME "Namibia"
# define _VODI_NAMIBIA_NAME Namibia
# define VODI_NAMIBIA_ALPHA2 "na"
# define _VODI_NAMIBIA_ALPHA2 na
# define VODI_NAMIBIA_ALPHA3 "nam"
# define _VODI_NAMIBIA_ALPHA3 nam
# define VodiK_NAMIBIA_NUMERIC 516

/* Nauru */
# define VODI_NAURU_NAME "Nauru"
# define _VODI_NAURU_NAME Nauru
# define VODI_NAURU_ALPHA2 "nr"
# define _VODI_NAURU_ALPHA2 nr
# define VODI_NAURU_ALPHA3 "nru"
# define _VODI_NAURU_ALPHA3 nru
# define VodiK_NAURU_NUMERIC 520

/* Nepal */
# define VODI_NEPAL_NAME "Nepal"
# define _VODI_NEPAL_NAME Nepal
# define VODI_NEPAL_ALPHA2 "np"
# define _VODI_NEPAL_ALPHA2 np
# define VODI_NEPAL_ALPHA3 "npl"
# define _VODI_NEPAL_ALPHA3 npl
# define VodiK_NEPAL_NUMERIC 524

/* Netherlands */
# define VODI_NETHERLANDS_NAME "Netherlands"
# define _VODI_NETHERLANDS_NAME Netherlands
# define VODI_NETHERLANDS_ALPHA2 "nl"
# define _VODI_NETHERLANDS_ALPHA2 nl
# define VODI_NETHERLANDS_ALPHA3 "nld"
# define _VODI_NETHERLANDS_ALPHA3 nld
# define VodiK_NETHERLANDS_NUMERIC 528

/* New Caledonia */
# define VODI_NEW_CALEDONIA_NAME "New Caledonia"
# define _VODI_NEW_CALEDONIA_NAME New_Caledonia
# define VODI_NEW_CALEDONIA_ALPHA2 "nc"
# define _VODI_NEW_CALEDONIA_ALPHA2 nc
# define VODI_NEW_CALEDONIA_ALPHA3 "ncl"
# define _VODI_NEW_CALEDONIA_ALPHA3 ncl
# define VodiK_NEW_CALEDONIA_NUMERIC 540

/* New Zealand */
# define VODI_NEW_ZEALAND_NAME "New Zealand"
# define _VODI_NEW_ZEALAND_NAME New_Zealand
# define VODI_NEW_ZEALAND_ALPHA2 "nz"
# define _VODI_NEW_ZEALAND_ALPHA2 nz
# define VODI_NEW_ZEALAND_ALPHA3 "nzl"
# define _VODI_NEW_ZEALAND_ALPHA3 nzl
# define VodiK_NEW_ZEALAND_NUMERIC 554

/* Nicaragua */
# define VODI_NICARAGUA_NAME "Nicaragua"
# define _VODI_NICARAGUA_NAME Nicaragua
# define VODI_NICARAGUA_ALPHA2 "ni"
# define _VODI_NICARAGUA_ALPHA2 ni
# define VODI_NICARAGUA_ALPHA3 "nic"
# define _VODI_NICARAGUA_ALPHA3 nic
# define VodiK_NICARAGUA_NUMERIC 558

/* Niger */
# define VODI_NIGER_NAME "Niger"
# define _VODI_NIGER_NAME Niger
# define VODI_NIGER_ALPHA2 "ne"
# define _VODI_NIGER_ALPHA2 ne
# define VODI_NIGER_ALPHA3 "ner"
# define _VODI_NIGER_ALPHA3 ner
# define VodiK_NIGER_NUMERIC 562

/* Nigeria */
# define VODI_NIGERIA_NAME "Nigeria"
# define _VODI_NIGERIA_NAME Nigeria
# define VODI_NIGERIA_ALPHA2 "ng"
# define _VODI_NIGERIA_ALPHA2 ng
# define VODI_NIGERIA_ALPHA3 "nga"
# define _VODI_NIGERIA_ALPHA3 nga
# define VodiK_NIGERIA_NUMERIC 566

/* Niue */
# define VODI_NIUE_NAME "Niue"
# define _VODI_NIUE_NAME Niue
# define VODI_NIUE_ALPHA2 "nu"
# define _VODI_NIUE_ALPHA2 nu
# define VODI_NIUE_ALPHA3 "niu"
# define _VODI_NIUE_ALPHA3 niu
# define VodiK_NIUE_NUMERIC 570

/* Norfolk Island */
# define VODI_NORFOLK_ISLAND_NAME "Norfolk Island"
# define _VODI_NORFOLK_ISLAND_NAME Norfolk_Island
# define VODI_NORFOLK_ISLAND_ALPHA2 "nf"
# define _VODI_NORFOLK_ISLAND_ALPHA2 nf
# define VODI_NORFOLK_ISLAND_ALPHA3 "nfk"
# define _VODI_NORFOLK_ISLAND_ALPHA3 nfk
# define VodiK_NORFOLK_ISLAND_NUMERIC 574

/* Northern Mariana Islands */
# define VODI_NORTHERN_MARIANA_ISLANDS_NAME "Northern Mariana Islands"
# define _VODI_NORTHERN_MARIANA_ISLANDS_NAME Northern_Mariana_Islands
# define VODI_NORTHERN_MARIANA_ISLANDS_ALPHA2 "mp"
# define _VODI_NORTHERN_MARIANA_ISLANDS_ALPHA2 mp
# define VODI_NORTHERN_MARIANA_ISLANDS_ALPHA3 "mnp"
# define _VODI_NORTHERN_MARIANA_ISLANDS_ALPHA3 mnp
# define VodiK_NORTHERN_MARIANA_ISLANDS_NUMERIC 580

/* Norway */
# define VODI_NORWAY_NAME "Norway"
# define _VODI_NORWAY_NAME Norway
# define VODI_NORWAY_ALPHA2 "no"
# define _VODI_NORWAY_ALPHA2 no
# define VODI_NORWAY_ALPHA3 "nor"
# define _VODI_NORWAY_ALPHA3 nor
# define VodiK_NORWAY_NUMERIC 578

/* Oman */
# define VODI_OMAN_NAME "Oman"
# define _VODI_OMAN_NAME Oman
# define VODI_OMAN_ALPHA2 "om"
# define _VODI_OMAN_ALPHA2 om
# define VODI_OMAN_ALPHA3 "omn"
# define _VODI_OMAN_ALPHA3 omn
# define VodiK_OMAN_NUMERIC 512

/* NOTE: it isn't in ISO */
/* Ossetia */
# define VODI_OSSETIA_NAME "Ossetia"
# define _VODI_OSSETIA_NAME Ossetia
# define VODI_OSSETIA_ALPHA2 "os"
# define _VODI_OSSETIA_ALPHA2 os
# define VODI_OSSETIA_ALPHA3 "oss"
# define _VODI_OSSETIA_ALPHA3 oss
# define VodiK_OSSETIA_NUMERIC 1268

/* Pakistan */
# define VODI_PAKISTAN_NAME "Pakistan"
# define _VODI_PAKISTAN_NAME Pakistan
# define VODI_PAKISTAN_ALPHA2 "pk"
# define _VODI_PAKISTAN_ALPHA2 pk
# define VODI_PAKISTAN_ALPHA3 "pak"
# define _VODI_PAKISTAN_ALPHA3 pak
# define VodiK_PAKISTAN_NUMERIC 586

/* Palau */
# define VODI_PALAU_NAME "Palau"
# define _VODI_PALAU_NAME Palau
# define VODI_PALAU_ALPHA2 "pw"
# define _VODI_PALAU_ALPHA2 pw
# define VODI_PALAU_ALPHA3 "plw"
# define _VODI_PALAU_ALPHA3 plw
# define VodiK_PALAU_NUMERIC 585

/* Palestinian Territories */
# define VODI_PALESTINIAN_TERRITORIES_NAME "Palestinian Territories"
# define _VODI_PALESTINIAN_TERRITORIES_NAME Palestinian_Territories
# define VODI_PALESTINIAN_TERRITORIES_ALPHA2 "ps"
# define _VODI_PALESTINIAN_TERRITORIES_ALPHA2 ps
# define VODI_PALESTINIAN_TERRITORIES_ALPHA3 "pse"
# define _VODI_PALESTINIAN_TERRITORIES_ALPHA3 pse
# define VodiK_PALESTINIAN_TERRITORIES_NUMERIC 275

/* Panama */
# define VODI_PANAMA_NAME "Panama"
# define _VODI_PANAMA_NAME Panama
# define VODI_PANAMA_ALPHA2 "pa"
# define _VODI_PANAMA_ALPHA2 pa
# define VODI_PANAMA_ALPHA3 "pan"
# define _VODI_PANAMA_ALPHA3 pan
# define VodiK_PANAMA_NUMERIC 591

/* Papua New Guinea */
# define VODI_PAPUA_NEW_GUINEA_NAME "Papua New Guinea"
# define _VODI_PAPUA_NEW_GUINEA_NAME Papua_New_Guinea
# define VODI_PAPUA_NEW_GUINEA_ALPHA2 "pg"
# define _VODI_PAPUA_NEW_GUINEA_ALPHA2 pg
# define VODI_PAPUA_NEW_GUINEA_ALPHA3 "png"
# define _VODI_PAPUA_NEW_GUINEA_ALPHA3 png
# define VodiK_PAPUA_NEW_GUINEA_NUMERIC 598

/* Paraguay */
# define VODI_PARAGUAY_NAME "Paraguay"
# define _VODI_PARAGUAY_NAME Paraguay
# define VODI_PARAGUAY_ALPHA2 "py"
# define _VODI_PARAGUAY_ALPHA2 py
# define VODI_PARAGUAY_ALPHA3 "pry"
# define _VODI_PARAGUAY_ALPHA3 pry
# define VodiK_PARAGUAY_NUMERIC 600

/* Peru */
# define VODI_PERU_NAME "Peru"
# define _VODI_PERU_NAME Peru
# define VODI_PERU_ALPHA2 "pe"
# define _VODI_PERU_ALPHA2 pe
# define VODI_PERU_ALPHA3 "per"
# define _VODI_PERU_ALPHA3 per
# define VodiK_PERU_NUMERIC 604

/* Philippines */
# define VODI_PHILIPPINES_NAME "Philippines"
# define _VODI_PHILIPPINES_NAME Philippines
# define VODI_PHILIPPINES_ALPHA2 "ph"
# define _VODI_PHILIPPINES_ALPHA2 ph
# define VODI_PHILIPPINES_ALPHA3 "phl"
# define _VODI_PHILIPPINES_ALPHA3 phl
# define VodiK_PHILIPPINES_NUMERIC 608

/* Pitcairn */
# define VODI_PITCAIRN_NAME "Pitcairn"
# define _VODI_PITCAIRN_NAME Pitcairn
# define VODI_PITCAIRN_ALPHA2 "pn"
# define _VODI_PITCAIRN_ALPHA2 pn
# define VODI_PITCAIRN_ALPHA3 "pcn"
# define _VODI_PITCAIRN_ALPHA3 pcn
# define VodiK_PITCAIRN_NUMERIC 612

/* Poland */
# define VODI_POLAND_NAME "Poland"
# define _VODI_POLAND_NAME Poland
# define VODI_POLAND_ALPHA2 "pl"
# define _VODI_POLAND_ALPHA2 pl
# define VODI_POLAND_ALPHA3 "pol"
# define _VODI_POLAND_ALPHA3 pol
# define VodiK_POLAND_NUMERIC 616

/* Portugal */
# define VODI_PORTUGAL_NAME "Portugal"
# define _VODI_PORTUGAL_NAME Portugal
# define VODI_PORTUGAL_ALPHA2 "pt"
# define _VODI_PORTUGAL_ALPHA2 pt
# define VODI_PORTUGAL_ALPHA3 "prt"
# define _VODI_PORTUGAL_ALPHA3 prt
# define VodiK_PORTUGAL_NUMERIC 620

/* Puerto Rico */
# define VODI_PUERTO_RICO_NAME "Puerto Rico"
# define _VODI_PUERTO_RICO_NAME Puerto_Rico
# define VODI_PUERTO_RICO_ALPHA2 "pr"
# define _VODI_PUERTO_RICO_ALPHA2 pr
# define VODI_PUERTO_RICO_ALPHA3 "pri"
# define _VODI_PUERTO_RICO_ALPHA3 pri
# define VodiK_PUERTO_RICO_NUMERIC 630

/* Qatar */
# define VODI_QATAR_NAME "Qatar"
# define _VODI_QATAR_NAME Qatar
# define VODI_QATAR_ALPHA2 "qa"
# define _VODI_QATAR_ALPHA2 qa
# define VODI_QATAR_ALPHA3 "qat"
# define _VODI_QATAR_ALPHA3 qat
# define VodiK_QATAR_NUMERIC 634

/* Réunion */
# define VODI_REUNION_NAME "Réunion"
# define _VODI_REUNION_NAME Reunion
# define VODI_REUNION_ALPHA2 "re"
# define _VODI_REUNION_ALPHA2 re
# define VODI_REUNION_ALPHA3 "reu"
# define _VODI_REUNION_ALPHA3 reu
# define VodiK_REUNION_NUMERIC 638

/* Romania */
# define VODI_ROMANIA_NAME "Romania"
# define _VODI_ROMANIA_NAME Romania
# define VODI_ROMANIA_ALPHA2 "ro"
# define _VODI_ROMANIA_ALPHA2 ro
# define VODI_ROMANIA_ALPHA3 "rou"
# define _VODI_ROMANIA_ALPHA3 rou
# define VodiK_ROMANIA_NUMERIC 642

/* Russian Federation */
# define VODI_RUSSIAN_NAME "Russian Federation"
# define _VODI_RUSSIAN_NAME Russian
# define VODI_RUSSIAN_ALPHA2 "ru"
# define _VODI_RUSSIAN_ALPHA2 ru
# define VODI_RUSSIAN_ALPHA3 "rus"
# define _VODI_RUSSIAN_ALPHA3 rus
# define VodiK_RUSSIAN_NUMERIC 643
# define VODI_RUSSIAN_ALIAS "Russia"

/* Rwanda */
# define VODI_RWANDA_NAME "Rwanda"
# define _VODI_RWANDA_NAME Rwanda
# define VODI_RWANDA_ALPHA2 "rw"
# define _VODI_RWANDA_ALPHA2 rw
# define VODI_RWANDA_ALPHA3 "rwa"
# define _VODI_RWANDA_ALPHA3 rwa
# define VodiK_RWANDA_NUMERIC 646

/* Saint Barthélemy */
# define VODI_SAINT_BARTHELEMY_NAME "Saint Barthélemy"
# define _VODI_SAINT_BARTHELEMY_NAME Saint_Barthelemy
# define VODI_SAINT_BARTHELEMY_ALPHA2 "bl"
# define _VODI_SAINT_BARTHELEMY_ALPHA2 bl
# define VODI_SAINT_BARTHELEMY_ALPHA3 "blm"
# define _VODI_SAINT_BARTHELEMY_ALPHA3 blm
# define VodiK_SAINT_BARTHELEMY_NUMERIC 652

/* Saint Helena, Ascension and Tristan da Cunha */
# define VODI_SAINT_HELENA_NAME "Saint Helena, Ascension and Tristan da Cunha"
# define _VODI_SAINT_HELENA_NAME Saint_Helena
# define VODI_SAINT_HELENA_ALPHA2 "sh"
# define _VODI_SAINT_HELENA_ALPHA2 sh
# define VODI_SAINT_HELENA_ALPHA3 "shn"
# define _VODI_SAINT_HELENA_ALPHA3 shn
# define VodiK_SAINT_HELENA_NUMERIC 654

/* Saint Kitts and Nevis */
# define VODI_SAINT_KITTS_AND_NEVIS_NAME "Saint Kitts and Nevis"
# define _VODI_SAINT_KITTS_AND_NEVIS_NAME Saint_Kitts_and_Nevis
# define VODI_SAINT_KITTS_AND_NEVIS_ALPHA2 "kn"
# define _VODI_SAINT_KITTS_AND_NEVIS_ALPHA2 kn
# define VODI_SAINT_KITTS_AND_NEVIS_ALPHA3 "kna"
# define _VODI_SAINT_KITTS_AND_NEVIS_ALPHA3 kna
# define VodiK_SAINT_KITTS_AND_NEVIS_NUMERIC 659

/* Saint Lucia */
# define VODI_SAINT_LUCIA_NAME "Saint Lucia"
# define _VODI_SAINT_LUCIA_NAME Saint_Lucia
# define VODI_SAINT_LUCIA_ALPHA2 "lc"
# define _VODI_SAINT_LUCIA_ALPHA2 lc
# define VODI_SAINT_LUCIA_ALPHA3 "lca"
# define _VODI_SAINT_LUCIA_ALPHA3 lca
# define VodiK_SAINT_LUCIA_NUMERIC 662

/* Saint Martin (French part) */
# define VODI_SAINT_MARTIN_NAME "Saint Martin (French part)"
# define _VODI_SAINT_MARTIN_NAME Saint_Martin
# define VODI_SAINT_MARTIN_ALPHA2 "mf"
# define _VODI_SAINT_MARTIN_ALPHA2 mf
# define VODI_SAINT_MARTIN_ALPHA3 "maf"
# define _VODI_SAINT_MARTIN_ALPHA3 maf
# define VodiK_SAINT_MARTIN_NUMERIC 663

/* Saint Pierre and Miquelon */
# define VODI_SAINT_PIERRE_AND_MIQUELON_NAME "Saint Pierre and Miquelon"
# define _VODI_SAINT_PIERRE_AND_MIQUELON_NAME Saint_Pierre_and_Miquelon
# define VODI_SAINT_PIERRE_AND_MIQUELON_ALPHA2 "pm"
# define _VODI_SAINT_PIERRE_AND_MIQUELON_ALPHA2 pm
# define VODI_SAINT_PIERRE_AND_MIQUELON_ALPHA3 "spm"
# define _VODI_SAINT_PIERRE_AND_MIQUELON_ALPHA3 spm
# define VodiK_SAINT_PIERRE_AND_MIQUELON_NUMERIC 666

/* Saint Vincent and the Grenadines */
# define VODI_SAINT_VINCENT_AND_THE_GRENADINES_NAME "Saint Vincent and the Grenadines"
# define _VODI_SAINT_VINCENT_AND_THE_GRENADINES_NAME Saint_Vincent_and_the_Grenadines
# define VODI_SAINT_VINCENT_AND_THE_GRENADINES_ALPHA2 "vc"
# define _VODI_SAINT_VINCENT_AND_THE_GRENADINES_ALPHA2 vc
# define VODI_SAINT_VINCENT_AND_THE_GRENADINES_ALPHA3 "vct"
# define _VODI_SAINT_VINCENT_AND_THE_GRENADINES_ALPHA3 vct
# define VodiK_SAINT_VINCENT_AND_THE_GRENADINES_NUMERIC 670

/* Samoa */
# define VODI_SAMOA_NAME "Samoa"
# define _VODI_SAMOA_NAME Samoa
# define VODI_SAMOA_ALPHA2 "ws"
# define _VODI_SAMOA_ALPHA2 ws
# define VODI_SAMOA_ALPHA3 "wsm"
# define _VODI_SAMOA_ALPHA3 wsm
# define VodiK_SAMOA_NUMERIC 882

/* San Marino */
# define VODI_SAN_MARINO_NAME "San Marino"
# define _VODI_SAN_MARINO_NAME San_Marino
# define VODI_SAN_MARINO_ALPHA2 "sm"
# define _VODI_SAN_MARINO_ALPHA2 sm
# define VODI_SAN_MARINO_ALPHA3 "smr"
# define _VODI_SAN_MARINO_ALPHA3 smr
# define VodiK_SAN_MARINO_NUMERIC 674

/* Sao Tome and Principe */
# define VODI_SAO_TOME_AND_PRINCIPE_NAME "Sao Tome and Principe"
# define _VODI_SAO_TOME_AND_PRINCIPE_NAME Sao_Tome_and_Principe
# define VODI_SAO_TOME_AND_PRINCIPE_ALPHA2 "st"
# define _VODI_SAO_TOME_AND_PRINCIPE_ALPHA2 st
# define VODI_SAO_TOME_AND_PRINCIPE_ALPHA3 "stp"
# define _VODI_SAO_TOME_AND_PRINCIPE_ALPHA3 stp
# define VodiK_SAO_TOME_AND_PRINCIPE_NUMERIC 678

/* Saudi Arabia */
# define VODI_SAUDI_ARABIA_NAME "Saudi Arabia"
# define _VODI_SAUDI_ARABIA_NAME Saudi_Arabia
# define VODI_SAUDI_ARABIA_ALPHA2 "sa"
# define _VODI_SAUDI_ARABIA_ALPHA2 sa
# define VODI_SAUDI_ARABIA_ALPHA3 "sau"
# define _VODI_SAUDI_ARABIA_ALPHA3 sau
# define VodiK_SAUDI_ARABIA_NUMERIC 682

/* Senegal */
# define VODI_SENEGAL_NAME "Senegal"
# define _VODI_SENEGAL_NAME Senegal
# define VODI_SENEGAL_ALPHA2 "sn"
# define _VODI_SENEGAL_ALPHA2 sn
# define VODI_SENEGAL_ALPHA3 "sen"
# define _VODI_SENEGAL_ALPHA3 sen
# define VodiK_SENEGAL_NUMERIC 686

/* Serbia */
# define VODI_SERBIA_NAME "Serbia"
# define _VODI_SERBIA_NAME Serbia
# define VODI_SERBIA_ALPHA2 "rs"
# define _VODI_SERBIA_ALPHA2 rs
# define VODI_SERBIA_ALPHA3 "srb"
# define _VODI_SERBIA_ALPHA3 srb
# define VodiK_SERBIA_NUMERIC 688

/* Seychelles */
# define VODI_SEYCHELLES_NAME "Seychelles"
# define _VODI_SEYCHELLES_NAME Seychelles
# define VODI_SEYCHELLES_ALPHA2 "sc"
# define _VODI_SEYCHELLES_ALPHA2 sc
# define VODI_SEYCHELLES_ALPHA3 "syc"
# define _VODI_SEYCHELLES_ALPHA3 syc
# define VodiK_SEYCHELLES_NUMERIC 690

/* Sierra Leone */
# define VODI_SIERRA_LEONE_NAME "Sierra Leone"
# define _VODI_SIERRA_LEONE_NAME Sierra_Leone
# define VODI_SIERRA_LEONE_ALPHA2 "sl"
# define _VODI_SIERRA_LEONE_ALPHA2 sl
# define VODI_SIERRA_LEONE_ALPHA3 "sle"
# define _VODI_SIERRA_LEONE_ALPHA3 sle
# define VodiK_SIERRA_LEONE_NUMERIC 694

/* Singapore */
# define VODI_SINGAPORE_NAME "Singapore"
# define _VODI_SINGAPORE_NAME Singapore
# define VODI_SINGAPORE_ALPHA2 "sg"
# define _VODI_SINGAPORE_ALPHA2 sg
# define VODI_SINGAPORE_ALPHA3 "sgp"
# define _VODI_SINGAPORE_ALPHA3 sgp
# define VodiK_SINGAPORE_NUMERIC 702

/* Sint Maarten (Dutch part) */
# define VODI_SINT_MAARTEN_NAME "Sint Maarten (Dutch part)"
# define _VODI_SINT_MAARTEN_NAME Sint_Maarten
# define VODI_SINT_MAARTEN_ALPHA2 "sx"
# define _VODI_SINT_MAARTEN_ALPHA2 sx
# define VODI_SINT_MAARTEN_ALPHA3 "sxm"
# define _VODI_SINT_MAARTEN_ALPHA3 sxm
# define VodiK_SINT_MAARTEN_NUMERIC 534

/* Slovakia */
# define VODI_SLOVAKIA_NAME "Slovakia"
# define _VODI_SLOVAKIA_NAME Slovakia
# define VODI_SLOVAKIA_ALPHA2 "sk"
# define _VODI_SLOVAKIA_ALPHA2 sk
# define VODI_SLOVAKIA_ALPHA3 "svk"
# define _VODI_SLOVAKIA_ALPHA3 svk
# define VodiK_SLOVAKIA_NUMERIC 703

/* Slovenia */
# define VODI_SLOVENIA_NAME "Slovenia"
# define _VODI_SLOVENIA_NAME Slovenia
# define VODI_SLOVENIA_ALPHA2 "si"
# define _VODI_SLOVENIA_ALPHA2 si
# define VODI_SLOVENIA_ALPHA3 "svn"
# define _VODI_SLOVENIA_ALPHA3 svn
# define VodiK_SLOVENIA_NUMERIC 705

/* Solomon Islands */
# define VODI_SOLOMON_ISLANDS_NAME "Solomon Islands"
# define _VODI_SOLOMON_ISLANDS_NAME Solomon_Islands
# define VODI_SOLOMON_ISLANDS_ALPHA2 "sb"
# define _VODI_SOLOMON_ISLANDS_ALPHA2 sb
# define VODI_SOLOMON_ISLANDS_ALPHA3 "slb"
# define _VODI_SOLOMON_ISLANDS_ALPHA3 slb
# define VodiK_SOLOMON_ISLANDS_NUMERIC 90

/* Somalia */
# define VODI_SOMALIA_NAME "Somalia"
# define _VODI_SOMALIA_NAME Somalia
# define VODI_SOMALIA_ALPHA2 "so"
# define _VODI_SOMALIA_ALPHA2 so
# define VODI_SOMALIA_ALPHA3 "som"
# define _VODI_SOMALIA_ALPHA3 som
# define VodiK_SOMALIA_NUMERIC 706

/* South Africa */
# define VODI_SOUTH_AFRICA_NAME "South Africa"
# define _VODI_SOUTH_AFRICA_NAME South_Africa
# define VODI_SOUTH_AFRICA_ALPHA2 "za"
# define _VODI_SOUTH_AFRICA_ALPHA2 za
# define VODI_SOUTH_AFRICA_ALPHA3 "zaf"
# define _VODI_SOUTH_AFRICA_ALPHA3 zaf
# define VodiK_SOUTH_AFRICA_NUMERIC 710

/* South Georgia and the South Sandwich Islands */
# define VODI_SOUTH_GEORGIA_AND_THE_SOUTH_SANDWICH_ISLANDS_NAME "South Georgia and the South Sandwich Islands"
# define _VODI_SOUTH_GEORGIA_AND_THE_SOUTH_SANDWICH_ISLANDS_NAME South_Georgia_and_the_South_Sandwich_Islands
# define VODI_SOUTH_GEORGIA_AND_THE_SOUTH_SANDWICH_ISLANDS_ALPHA2 "gs"
# define _VODI_SOUTH_GEORGIA_AND_THE_SOUTH_SANDWICH_ISLANDS_ALPHA2 gs
# define VODI_SOUTH_GEORGIA_AND_THE_SOUTH_SANDWICH_ISLANDS_ALPHA3 "sgs"
# define _VODI_SOUTH_GEORGIA_AND_THE_SOUTH_SANDWICH_ISLANDS_ALPHA3 sgs
# define VodiK_SOUTH_GEORGIA_AND_THE_SOUTH_SANDWICH_ISLANDS_NUMERIC 239

/* South Sudan */
# define VODI_SOUTH_SUDAN_NAME "South Sudan"
# define _VODI_SOUTH_SUDAN_NAME South Sudan
# define VODI_SOUTH_SUDAN_ALPHA2 "ss"
# define _VODI_SOUTH_SUDAN_ALPHA2 ss
# define VODI_SOUTH_SUDAN_ALPHA3 "ssd"
# define _VODI_SOUTH_SUDAN_ALPHA3 ssd
# define VodiK_SOUTH_SUDAN_NUMERIC 728

/* Spain */
# define VODI_SPAIN_NAME "Spain"
# define _VODI_SPAIN_NAME Spain
# define VODI_SPAIN_ALPHA2 "es"
# define _VODI_SPAIN_ALPHA2 es
# define VODI_SPAIN_ALPHA3 "esp"
# define _VODI_SPAIN_ALPHA3 esp
# define VodiK_SPAIN_NUMERIC 724

/* Sri Lanka */
# define VODI_SRI_LANKA_NAME "Sri Lanka"
# define _VODI_SRI_LANKA_NAME Sri_Lanka
# define VODI_SRI_LANKA_ALPHA2 "lk"
# define _VODI_SRI_LANKA_ALPHA2 lk
# define VODI_SRI_LANKA_ALPHA3 "lka"
# define _VODI_SRI_LANKA_ALPHA3 lka
# define VodiK_SRI_LANKA_NUMERIC 144

/* Sudan */
# define VODI_SUDAN_NAME "Sudan"
# define _VODI_SUDAN_NAME Sudan
# define VODI_SUDAN_ALPHA2 "sd"
# define _VODI_SUDAN_ALPHA2 sd
# define VODI_SUDAN_ALPHA3 "sdn"
# define _VODI_SUDAN_ALPHA3 sdn
# define VodiK_SUDAN_NUMERIC 729

/* Suriname */
# define VODI_SURINAME_NAME "Suriname"
# define _VODI_SURINAME_NAME Suriname
# define VODI_SURINAME_ALPHA2 "sr"
# define _VODI_SURINAME_ALPHA2 sr
# define VODI_SURINAME_ALPHA3 "sur"
# define _VODI_SURINAME_ALPHA3 sur
# define VodiK_SURINAME_NUMERIC 740

/* Svalbard and Jan Mayen */
# define VODI_SVALBARD_AND_JAN_MAYEN_NAME "Svalbard and Jan Mayen"
# define _VODI_SVALBARD_AND_JAN_MAYEN_NAME Svalbard_and_Jan_Mayen
# define VODI_SVALBARD_AND_JAN_MAYEN_ALPHA2 "sj"
# define _VODI_SVALBARD_AND_JAN_MAYEN_ALPHA2 sj
# define VODI_SVALBARD_AND_JAN_MAYEN_ALPHA3 "sjm"
# define _VODI_SVALBARD_AND_JAN_MAYEN_ALPHA3 sjm
# define VodiK_SVALBARD_AND_JAN_MAYEN_NUMERIC 744

/* Swaziland */
# define VODI_SWAZILAND_NAME "Swaziland"
# define _VODI_SWAZILAND_NAME Swaziland
# define VODI_SWAZILAND_ALPHA2 "sz"
# define _VODI_SWAZILAND_ALPHA2 sz
# define VODI_SWAZILAND_ALPHA3 "swz"
# define _VODI_SWAZILAND_ALPHA3 swz
# define VodiK_SWAZILAND_NUMERIC 748

/* Sweden */
# define VODI_SWEDEN_NAME "Sweden"
# define _VODI_SWEDEN_NAME Sweden
# define VODI_SWEDEN_ALPHA2 "se"
# define _VODI_SWEDEN_ALPHA2 se
# define VODI_SWEDEN_ALPHA3 "swe"
# define _VODI_SWEDEN_ALPHA3 swe
# define VodiK_SWEDEN_NUMERIC 752

/* Switzerland */
# define VODI_SWITZERLAND_NAME "Switzerland"
# define _VODI_SWITZERLAND_NAME Switzerland
# define VODI_SWITZERLAND_ALPHA2 "ch"
# define _VODI_SWITZERLAND_ALPHA2 ch
# define VODI_SWITZERLAND_ALPHA3 "che"
# define _VODI_SWITZERLAND_ALPHA3 che
# define VodiK_SWITZERLAND_NUMERIC 756

/* Syrian Arab Republic */
# define VODI_SYRIAN_ARAB_REPUBLIC_NAME "Syrian Arab Republic"
# define _VODI_SYRIAN_ARAB_REPUBLIC_NAME Syrian_Arab_Republic
# define VODI_SYRIAN_ARAB_REPUBLIC_ALPHA2 "sy"
# define _VODI_SYRIAN_ARAB_REPUBLIC_ALPHA2 sy
# define VODI_SYRIAN_ARAB_REPUBLIC_ALPHA3 "syr"
# define _VODI_SYRIAN_ARAB_REPUBLIC_ALPHA3 syr
# define VodiK_SYRIAN_ARAB_REPUBLIC_NUMERIC 760

/* Taiwan */
# define VODI_TAIWAN_NAME "Taiwan"
# define _VODI_TAIWAN_NAME Taiwan
# define VODI_TAIWAN_ALPHA2 "tw"
# define _VODI_TAIWAN_ALPHA2 tw
# define VODI_TAIWAN_ALPHA3 "twn"
# define _VODI_TAIWAN_ALPHA3 twn
# define VodiK_TAIWAN_NUMERIC 158
# define VODI_TAIWAN_ALIAS "Taiwan"

/* Tajikistan */
# define VODI_TAJIKISTAN_NAME "Tajikistan"
# define _VODI_TAJIKISTAN_NAME Tajikistan
# define VODI_TAJIKISTAN_ALPHA2 "tj"
# define _VODI_TAJIKISTAN_ALPHA2 tj
# define VODI_TAJIKISTAN_ALPHA3 "tjk"
# define _VODI_TAJIKISTAN_ALPHA3 tjk
# define VodiK_TAJIKISTAN_NUMERIC 762

/* Tanzania, United Republic of */
# define VODI_TANZANIA_NAME "Tanzania, United Republic of"
# define _VODI_TANZANIA_NAME United_Republic_of_Tanzania
# define VODI_TANZANIA_ALPHA2 "tz"
# define _VODI_TANZANIA_ALPHA2 tz
# define VODI_TANZANIA_ALPHA3 "tza"
# define _VODI_TANZANIA_ALPHA3 tza
# define VodiK_TANZANIA_NUMERIC 834
# define VODI_TANZANIA_ALIAS "Tanzania"

/* Thailand */
# define VODI_THAILAND_NAME "Thailand"
# define _VODI_THAILAND_NAME Thailand
# define VODI_THAILAND_ALPHA2 "th"
# define _VODI_THAILAND_ALPHA2 th
# define VODI_THAILAND_ALPHA3 "tha"
# define _VODI_THAILAND_ALPHA3 tha
# define VodiK_THAILAND_NUMERIC 764

/* Timor-Leste */
# define VODI_TIMOR_LESTE_NAME "Timor-Leste"
# define _VODI_TIMOR_LESTE_NAME Timor_Leste
# define VODI_TIMOR_LESTE_ALPHA2 "tl"
# define _VODI_TIMOR_LESTE_ALPHA2 tl
# define VODI_TIMOR_LESTE_ALPHA3 "tls"
# define _VODI_TIMOR_LESTE_ALPHA3 tls
# define VodiK_TIMOR_LESTE_NUMERIC 626

/* Togo */
# define VODI_TOGO_NAME "Togo"
# define _VODI_TOGO_NAME Togo
# define VODI_TOGO_ALPHA2 "tg"
# define _VODI_TOGO_ALPHA2 tg
# define VODI_TOGO_ALPHA3 "tgo"
# define _VODI_TOGO_ALPHA3 tgo
# define VodiK_TOGO_NUMERIC 768

/* Tokelau */
# define VODI_TOKELAU_NAME "Tokelau"
# define _VODI_TOKELAU_NAME Tokelau
# define VODI_TOKELAU_ALPHA2 "tk"
# define _VODI_TOKELAU_ALPHA2 tk
# define VODI_TOKELAU_ALPHA3 "tkl"
# define _VODI_TOKELAU_ALPHA3 tkl
# define VodiK_TOKELAU_NUMERIC 772

/* Tonga */
# define VODI_TONGA_NAME "Tonga"
# define _VODI_TONGA_NAME Tonga
# define VODI_TONGA_ALPHA2 "to"
# define _VODI_TONGA_ALPHA2 to
# define VODI_TONGA_ALPHA3 "ton"
# define _VODI_TONGA_ALPHA3 ton
# define VodiK_TONGA_NUMERIC 776

/* Trinidad and Tobago */
# define VODI_TRINIDAD_AND_TOBAGO_NAME "Trinidad and Tobago"
# define _VODI_TRINIDAD_AND_TOBAGO_NAME Trinidad_and_Tobago
# define VODI_TRINIDAD_AND_TOBAGO_ALPHA2 "tt"
# define _VODI_TRINIDAD_AND_TOBAGO_ALPHA2 tt
# define VODI_TRINIDAD_AND_TOBAGO_ALPHA3 "tto"
# define _VODI_TRINIDAD_AND_TOBAGO_ALPHA3 tto
# define VodiK_TRINIDAD_AND_TOBAGO_NUMERIC 780

/* Tunisia */
# define VODI_TUNISIA_NAME "Tunisia"
# define _VODI_TUNISIA_NAME Tunisia
# define VODI_TUNISIA_ALPHA2 "tn"
# define _VODI_TUNISIA_ALPHA2 tn
# define VODI_TUNISIA_ALPHA3 "tun"
# define _VODI_TUNISIA_ALPHA3 tun
# define VodiK_TUNISIA_NUMERIC 788

/* Turkey */
# define VODI_TURKEY_NAME "Turkey"
# define _VODI_TURKEY_NAME Turkey
# define VODI_TURKEY_ALPHA2 "tr"
# define _VODI_TURKEY_ALPHA2 tr
# define VODI_TURKEY_ALPHA3 "tur"
# define _VODI_TURKEY_ALPHA3 tur
# define VodiK_TURKEY_NUMERIC 792

/* Turkmenistan */
# define VODI_TURKMENISTAN_NAME "Turkmenistan"
# define _VODI_TURKMENISTAN_NAME Turkmenistan
# define VODI_TURKMENISTAN_ALPHA2 "tm"
# define _VODI_TURKMENISTAN_ALPHA2 tm
# define VODI_TURKMENISTAN_ALPHA3 "tkm"
# define _VODI_TURKMENISTAN_ALPHA3 tkm
# define VodiK_TURKMENISTAN_NUMERIC 795

/* Turks and Caicos Islands */
# define VODI_TURKS_AND_CAICOS_ISLANDS_NAME "Turks and Caicos Islands"
# define _VODI_TURKS_AND_CAICOS_ISLANDS_NAME Turks_and_Caicos_Islands
# define VODI_TURKS_AND_CAICOS_ISLANDS_ALPHA2 "tc"
# define _VODI_TURKS_AND_CAICOS_ISLANDS_ALPHA2 tc
# define VODI_TURKS_AND_CAICOS_ISLANDS_ALPHA3 "tca"
# define _VODI_TURKS_AND_CAICOS_ISLANDS_ALPHA3 tca
# define VodiK_TURKS_AND_CAICOS_ISLANDS_NUMERIC 796

/* Tuvalu */
# define VODI_TUVALU_NAME "Tuvalu"
# define _VODI_TUVALU_NAME Tuvalu
# define VODI_TUVALU_ALPHA2 "tv"
# define _VODI_TUVALU_ALPHA2 tv
# define VODI_TUVALU_ALPHA3 "tuv"
# define _VODI_TUVALU_ALPHA3 tuv
# define VodiK_TUVALU_NUMERIC 798

/* Uganda */
# define VODI_UGANDA_NAME "Uganda"
# define _VODI_UGANDA_NAME Uganda
# define VODI_UGANDA_ALPHA2 "ug"
# define _VODI_UGANDA_ALPHA2 ug
# define VODI_UGANDA_ALPHA3 "uga"
# define _VODI_UGANDA_ALPHA3 uga
# define VodiK_UGANDA_NUMERIC 800

/* Ukraine */
# define VODI_UKRAINE_NAME "Ukraine"
# define _VODI_UKRAINE_NAME Ukraine
# define VODI_UKRAINE_ALPHA2 "ua"
# define _VODI_UKRAINE_ALPHA2 ua
# define VODI_UKRAINE_ALPHA3 "ukr"
# define _VODI_UKRAINE_ALPHA3 ukr
# define VodiK_UKRAINE_NUMERIC 804

/* United Arab Emirates */
# define VODI_UNITED_ARAB_EMIRATES_NAME "United Arab Emirates"
# define _VODI_UNITED_ARAB_EMIRATES_NAME United_Arab_Emirates
# define VODI_UNITED_ARAB_EMIRATES_ALPHA2 "ae"
# define _VODI_UNITED_ARAB_EMIRATES_ALPHA2 ae
# define VODI_UNITED_ARAB_EMIRATES_ALPHA3 "are"
# define _VODI_UNITED_ARAB_EMIRATES_ALPHA3 are
# define VodiK_UNITED_ARAB_EMIRATES_NUMERIC 784

/* United Kingdom */
# define VODI_UNITED_KINGDOM_NAME "United Kingdom"
# define _VODI_UNITED_KINGDOM_NAME United_Kingdom
# define VODI_UNITED_KINGDOM_ALPHA2 "gb"
# define _VODI_UNITED_KINGDOM_ALPHA2 gb
# define VODI_UNITED_KINGDOM_ALPHA3 "gbr"
# define _VODI_UNITED_KINGDOM_ALPHA3 gbr
# define VodiK_UNITED_KINGDOM_NUMERIC 826

/* United States */
# define VODI_UNITED_STATES_NAME "United States"
# define _VODI_UNITED_STATES_NAME United_States
# define VODI_UNITED_STATES_ALPHA2 "us"
# define _VODI_UNITED_STATES_ALPHA2 us
# define VODI_UNITED_STATES_ALPHA3 "usa"
# define _VODI_UNITED_STATES_ALPHA3 usa
# define VodiK_UNITED_STATES_NUMERIC 840

/* United States Minor Outlying Islands */
# define VODI_UNITED_STATES_MINOR_OUTLYING_ISLANDS_NAME "United States Minor Outlying Islands"
# define _VODI_UNITED_STATES_MINOR_OUTLYING_ISLANDS_NAME United_States_Minor_Outlying_Islands
# define VODI_UNITED_STATES_MINOR_OUTLYING_ISLANDS_ALPHA2 "um"
# define _VODI_UNITED_STATES_MINOR_OUTLYING_ISLANDS_ALPHA2 um
# define VODI_UNITED_STATES_MINOR_OUTLYING_ISLANDS_ALPHA3 "umi"
# define _VODI_UNITED_STATES_MINOR_OUTLYING_ISLANDS_ALPHA3 umi
# define VodiK_UNITED_STATES_MINOR_OUTLYING_ISLANDS_NUMERIC 581

/* Uruguay */
# define VODI_URUGUAY_NAME "Uruguay"
# define _VODI_URUGUAY_NAME Uruguay
# define VODI_URUGUAY_ALPHA2 "uy"
# define _VODI_URUGUAY_ALPHA2 uy
# define VODI_URUGUAY_ALPHA3 "ury"
# define _VODI_URUGUAY_ALPHA3 ury
# define VodiK_URUGUAY_NUMERIC 858

/* Uzbekistan */
# define VODI_UZBEKISTAN_NAME "Uzbekistan"
# define _VODI_UZBEKISTAN_NAME Uzbekistan
# define VODI_UZBEKISTAN_ALPHA2 "uz"
# define _VODI_UZBEKISTAN_ALPHA2 uz
# define VODI_UZBEKISTAN_ALPHA3 "uzb"
# define _VODI_UZBEKISTAN_ALPHA3 uzb
# define VodiK_UZBEKISTAN_NUMERIC 860

/* Vanuatu */
# define VODI_VANUATU_NAME "Vanuatu"
# define _VODI_VANUATU_NAME Vanuatu
# define VODI_VANUATU_ALPHA2 "vu"
# define _VODI_VANUATU_ALPHA2 vu
# define VODI_VANUATU_ALPHA3 "vut"
# define _VODI_VANUATU_ALPHA3 vut
# define VodiK_VANUATU_NUMERIC 548

/* Venezuela, Bolivarian Republic of */
# define VODI_VENEZUELA_NAME "Venezuela, Bolivarian Republic of"
# define _VODI_VENEZUELA_NAME Bolivarian_Republic_of_Venezuela
# define VODI_VENEZUELA_ALPHA2 "ve"
# define _VODI_VENEZUELA_ALPHA2 ve
# define VODI_VENEZUELA_ALPHA3 "ven"
# define _VODI_VENEZUELA_ALPHA3 ven
# define VodiK_VENEZUELA_NUMERIC 862
# define VODI_VENEZUELA_ALIAS "Venezuela"

/* Vietnam */
# define VODI_VIETNAM_NAME "Vietnam"
# define _VODI_VIETNAM_NAME Vietnam
# define VODI_VIETNAM_ALPHA2 "vn"
# define _VODI_VIETNAM_ALPHA2 vn
# define VODI_VIETNAM_ALPHA3 "vnm"
# define _VODI_VIETNAM_ALPHA3 vnm
# define VodiK_VIETNAM_NUMERIC 704

/* Virgin Islands, British */
# define VODI_VIRGIN_ISLANDS_BRITISH_NAME "Virgin Islands, British"
# define _VODI_VIRGIN_ISLANDS_BRITISH_NAME Virgin_Islands_British
# define VODI_VIRGIN_ISLANDS_BRITISH_ALPHA2 "vg"
# define _VODI_VIRGIN_ISLANDS_BRITISH_ALPHA2 vg
# define VODI_VIRGIN_ISLANDS_BRITISH_ALPHA3 "vgb"
# define _VODI_VIRGIN_ISLANDS_BRITISH_ALPHA3 vgb
# define VodiK_VIRGIN_ISLANDS_BRITISH_NUMERIC 92

/* Virgin Islands, U.S. */
# define VODI_VIRGIN_ISLANDS_US_NAME "Virgin Islands, U.S."
# define _VODI_VIRGIN_ISLANDS_US_NAME Virgin_Islands_US
# define VODI_VIRGIN_ISLANDS_US_ALPHA2 "vi"
# define _VODI_VIRGIN_ISLANDS_US_ALPHA2 vi
# define VODI_VIRGIN_ISLANDS_US_ALPHA3 "vir"
# define _VODI_VIRGIN_ISLANDS_US_ALPHA3 vir
# define VodiK_VIRGIN_ISLANDS_US_NUMERIC 850

/* Wallis and Futuna */
# define VODI_WALLIS_AND_FUTUNA_NAME "Wallis and Futuna"
# define _VODI_WALLIS_AND_FUTUNA_NAME Wallis_and_Futuna
# define VODI_WALLIS_AND_FUTUNA_ALPHA2 "wf"
# define _VODI_WALLIS_AND_FUTUNA_ALPHA2 wf
# define VODI_WALLIS_AND_FUTUNA_ALPHA3 "wlf"
# define _VODI_WALLIS_AND_FUTUNA_ALPHA3 wlf
# define VodiK_WALLIS_AND_FUTUNA_NUMERIC 876

/* Western Sahara */
# define VODI_WESTERN_SAHARA_NAME "Western Sahara"
# define _VODI_WESTERN_SAHARA_NAME Western_Sahara
# define VODI_WESTERN_SAHARA_ALPHA2 "eh"
# define _VODI_WESTERN_SAHARA_ALPHA2 eh
# define VODI_WESTERN_SAHARA_ALPHA3 "esh"
# define _VODI_WESTERN_SAHARA_ALPHA3 esh
# define VodiK_WESTERN_SAHARA_NUMERIC 732

/* Yemen */
# define VODI_YEMEN_NAME "Yemen"
# define _VODI_YEMEN_NAME Yemen
# define VODI_YEMEN_ALPHA2 "ye"
# define _VODI_YEMEN_ALPHA2 ye
# define VODI_YEMEN_ALPHA3 "yem"
# define _VODI_YEMEN_ALPHA3 yem
# define VodiK_YEMEN_NUMERIC 887

/* Zambia */
# define VODI_ZAMBIA_NAME "Zambia"
# define _VODI_ZAMBIA_NAME Zambia
# define VODI_ZAMBIA_ALPHA2 "zm"
# define _VODI_ZAMBIA_ALPHA2 zm
# define VODI_ZAMBIA_ALPHA3 "zmb"
# define _VODI_ZAMBIA_ALPHA3 zmb
# define VodiK_ZAMBIA_NUMERIC 894

/* Zimbabwe */
# define VODI_ZIMBABWE_NAME "Zimbabwe"
# define _VODI_ZIMBABWE_NAME Zimbabwe
# define VODI_ZIMBABWE_ALPHA2 "zw"
# define _VODI_ZIMBABWE_ALPHA2 zw
# define VODI_ZIMBABWE_ALPHA3 "zwe"
# define _VODI_ZIMBABWE_ALPHA3 zwe
# define VodiK_ZIMBABWE_NUMERIC 716


/*
 * ISO 3166-2
 *
 * Defines codes for identifying the principal subdivisions
 * of all countries coded in ISO 3166-1.
 */

/* ae (United Arab Emirates) @{ */

/* ae-aj */
# define VODI_AE_AJ_SUBNAME "'Ajmān"
# define VODI_AE_AJ_SUBCODE "aj"
# define VODI_AE_AJ_CODE "ae-aj"
# define VodiK_AE_AJ_SUBNUM 1

/* ae-az */
# define VODI_AE_AZ_SUBNAME "Abū Z̧aby"
# define VODI_AE_AZ_SUBCODE "az"
# define VODI_AE_AZ_CODE "ae-az"
# define VodiK_AE_AZ_SUBNUM 2
# define VODI_AE_AZ_SUBALIAS "Abu Dhabi"

/* ae-du */
# define VODI_AE_DU_SUBNAME "Dubayy"
# define VODI_AE_DU_SUBCODE "du"
# define VODI_AE_DU_CODE "ae-du"
# define VodiK_AE_DU_SUBNUM 3
# define VODI_AE_DU_SUBALIAS "Dubai"

/* ae-fu */
# define VODI_AE_FU_SUBNAME "Al Fujayrah"
# define VODI_AE_FU_SUBCODE "fu"
# define VODI_AE_FU_CODE "ae-fu"
# define VodiK_AE_FU_SUBNUM 4

/* ae-rk */
# define VODI_AE_RK_SUBNAME "Ra’s al Khaymah"
# define VODI_AE_RK_SUBCODE "rk"
# define VODI_AE_RK_CODE "ae-rk"
# define VodiK_AE_RK_SUBNUM 5

/* ae-sh */
# define VODI_AE_SH_SUBNAME "Ash Shāriqah"
# define VODI_AE_SH_SUBCODE "sh"
# define VODI_AE_SH_CODE "ae-sh"
# define VodiK_AE_SH_SUBNUM 6
# define VODI_AE_SH_SUBALIAS "Sharjah"

/* ae-uq */
# define VODI_AE_UQ_SUBNAME "Umm al Qaywayn"
# define VODI_AE_UQ_SUBCODE "uq"
# define VODI_AE_UQ_CODE "ae-uq"
# define VodiK_AE_UQ_SUBNUM 7

/* @} */

/* au (Australia) @{ */

/* au-act (Australian Capital Territory) */
# define VODI_AU_ACT_CODE "au-"VODI_AU_ACT_SUBCODE
# define VODI_AU_ACT_SUBCODE "act"
# define VODI_AU_ACT_SUBNAME "Australian Capital Territory"
# define VodiK_AU_ACT_SUBNUM 1

/* au-nsw (New South Wales) */
# define VODI_AU_NSW_CODE "au-"VODI_AU_NSW_SUBCODE
# define VODI_AU_NSW_SUBCODE "nsw"
# define VODI_AU_NSW_SUBNAME "New South Wales"
# define VodiK_AU_NSW_SUBNUM 2

/* au-nt (Northern Territory) */
# define VODI_AU_NT_CODE "au-"VODI_AU_NT_SUBCODE
# define VODI_AU_NT_SUBCODE "nt"
# define VODI_AU_NT_SUBNAME "Northern Territory"
# define VodiK_AU_NT_SUBNUM 3

/* au-qld (Queensland) */
# define VODI_AU_QLD_CODE "au-"VODI_AU_QLD_SUBCODE
# define VODI_AU_QLD_SUBCODE "qld"
# define VODI_AU_QLD_SUBNAME "Queensland"
# define VodiK_AU_QLD_SUBNUM 4

/* au-sa (South Australia) */
# define VODI_AU_SA_CODE "au-"VODI_AU_SA_SUBCODE
# define VODI_AU_SA_SUBCODE "sa"
# define VODI_AU_SA_SUBNAME "South Australia"
# define VodiK_AU_SA_SUBNUM 5

/* au-tas (Tasmania) */
# define VODI_AU_TAS_CODE "au-"VODI_AU_TAS_SUBCODE
# define VODI_AU_TAS_SUBCODE "tas"
# define VODI_AU_TAS_SUBNAME "Tasmania"
# define VodiK_AU_TAS_SUBNUM 6

/* au-vic (Victoria) */
# define VODI_AU_VIC_CODE "au-"VODI_AU_VIC_SUBCODE
# define VODI_AU_VIC_SUBCODE "vic"
# define VODI_AU_VIC_SUBNAME "Victoria"
# define VodiK_AU_VIC_SUBNUM 7

/* au-wa (Western Australia) */
# define VODI_AU_WA_CODE "au-"VODI_AU_WA_SUBCODE
# define VODI_AU_WA_SUBCODE "wa"
# define VODI_AU_WA_SUBNAME "Western Australia"
# define VodiK_AU_WA_SUBNUM 8

/* @} */

/* ca (Canada) @{ */

/* ca-ab (Alberta) */
# define VODI_CA_AB_CODE "ca-"VODI_CA_AB_SUBCODE
# define VODI_CA_AB_SUBCODE "ab"
# define VODI_CA_AB_SUBNAME "Alberta"
# define VodiK_CA_AB_SUBNUM 1

/* ca-bc (British Columbia) */
# define VODI_CA_BC_CODE "ca-"VODI_CA_BC_SUBCODE
# define VODI_CA_BC_SUBCODE "bc"
# define VODI_CA_BC_SUBNAME "British Columbia"
# define VodiK_CA_BC_SUBNUM 2

/* ca-mb (Manitoba) */
# define VODI_CA_MB_CODE "ca-"VODI_CA_MB_SUBCODE
# define VODI_CA_MB_SUBCODE "mb"
# define VODI_CA_MB_SUBNAME "Manitoba"
# define VodiK_CA_MB_SUBNUM 3

/* ca-nb (New Brunswick) */
# define VODI_CA_NB_CODE "ca-"VODI_CA_NB_SUBCODE
# define VODI_CA_NB_SUBCODE "nb"
# define VODI_CA_NB_SUBNAME "New Brunswick"
# define VodiK_CA_NB_SUBNUM 4

/* ca-nl (Newfoundland and Labrador) */
# define VODI_CA_NL_CODE "ca-"VODI_CA_NL_SUBCODE
# define VODI_CA_NL_SUBCODE "nl"
# define VODI_CA_NL_SUBNAME "Newfoundland and Labrador"
# define VodiK_CA_NL_SUBNUM 5

/* ca-ns (Nova Scotia) */
# define VODI_CA_NS_CODE "ca-"VODI_CA_NS_SUBCODE
# define VODI_CA_NS_SUBCODE "ns"
# define VODI_CA_NS_SUBNAME "Nova Scotia"
# define VodiK_CA_NS_SUBNUM 6

/* ca-nt (Northwest Territories) */
# define VODI_CA_NT_CODE "ca-"VODI_CA_NT_SUBCODE
# define VODI_CA_NT_SUBCODE "nt"
# define VODI_CA_NT_SUBNAME "Northwest Territories"
# define VodiK_CA_NT_SUBNUM 7

/* ca-nu (Nunavut) */
# define VODI_CA_NU_CODE "ca-"VODI_CA_NU_SUBCODE
# define VODI_CA_NU_SUBCODE "nu"
# define VODI_CA_NU_SUBNAME "Nunavut"
# define VodiK_CA_NU_SUBNUM 8

/* ca-on (Ontario) */
# define VODI_CA_ON_CODE "ca-"VODI_CA_ON_SUBCODE
# define VODI_CA_ON_SUBCODE "on"
# define VODI_CA_ON_SUBNAME "Ontario"
# define VodiK_CA_ON_SUBNUM 9

/* ca-pe (Prince Edward Island) */
# define VODI_CA_PE_CODE "ca-"VODI_CA_PE_SUBCODE
# define VODI_CA_PE_SUBCODE "pe"
# define VODI_CA_PE_SUBNAME "Prince Edward Island"
# define VodiK_CA_PE_SUBNUM 10

/* ca-qc (Quebec) */
# define VODI_CA_QC_CODE "ca-"VODI_CA_QC_SUBCODE
# define VODI_CA_QC_SUBCODE "qc"
# define VODI_CA_QC_SUBNAME "Quebec"
# define VodiK_CA_QC_SUBNUM 11

/* ca-sk (Saskatchewan) */
# define VODI_CA_SK_CODE "ca-"VODI_CA_SK_SUBCODE
# define VODI_CA_SK_SUBCODE "sk"
# define VODI_CA_SK_SUBNAME "Saskatchewan"
# define VodiK_CA_SK_SUBNUM 12

/* ca-yt (Yukon Territory) */
# define VODI_CA_YT_CODE "ca-"VODI_CA_YT_SUBCODE
# define VODI_CA_YT_SUBCODE "yt"
# define VODI_CA_YT_SUBNAME "Territoire du Yukon"
# define VodiK_CA_YT_SUBNUM 13

/* @} */

/* us (United States) @{ */

/* us-ak (Alaska) */
# define VODI_US_AK_CODE "us-"VODI_US_AK_SUBCODE
# define VODI_US_AK_SUBCODE "ak"
# define VODI_US_AK_SUBNAME "Alaska"
# define VodiK_US_AK_SUBNUM 1

/* us-al (Alabama) */
# define VODI_US_AL_CODE "us-"VODI_US_AL_SUBCODE
# define VODI_US_AL_SUBCODE "al"
# define VODI_US_AL_SUBNAME "Alabama"
# define VodiK_US_AL_SUBNUM 2

/* us-ar (Arkansas) */
# define VODI_US_AR_CODE "us-"VODI_US_AR_SUBCODE
# define VODI_US_AR_SUBCODE "ar"
# define VODI_US_AR_SUBNAME "Arkansas"
# define VodiK_US_AR_SUBNUM 3

/* us-az (Arizona) */
# define VODI_US_AZ_CODE "us-"VODI_US_AZ_SUBCODE
# define VODI_US_AZ_SUBCODE "az"
# define VODI_US_AZ_SUBNAME "Arizona"
# define VodiK_US_AZ_SUBNUM 4

/* us-ca (California) */
# define VODI_US_CA_CODE "us-"VODI_US_CA_SUBCODE
# define VODI_US_CA_SUBCODE "ca"
# define VODI_US_CA_SUBNAME "California"
# define VodiK_US_CA_SUBNUM 5

/* us-co (Colorado) */
# define VODI_US_CO_CODE "us-"VODI_US_CO_SUBCODE
# define VODI_US_CO_SUBCODE "co"
# define VODI_US_CO_SUBNAME "Colorado"
# define VodiK_US_CO_SUBNUM 6

/* us-ct (Connecticut) */
# define VODI_US_CT_CODE "us-"VODI_US_CT_SUBCODE
# define VODI_US_CT_SUBCODE "ct"
# define VODI_US_CT_SUBNAME "Connecticut"
# define VodiK_US_CT_SUBNUM 7

/* us-dc (District of Columbia) */
# define VODI_US_DC_CODE "us-"VODI_US_DC_SUBCODE
# define VODI_US_DC_SUBCODE "dc"
# define VODI_US_DC_SUBNAME "District of Columbia"
# define VodiK_US_DC_SUBNUM 8

/* us-de (Delaware) */
# define VODI_US_DE_CODE "us-"VODI_US_DE_SUBCODE
# define VODI_US_DE_SUBCODE "de"
# define VODI_US_DE_SUBNAME "Delaware"
# define VodiK_US_DE_SUBNUM 9

/* us-fl (Florida) */
# define VODI_US_FL_CODE "us-"VODI_US_FL_SUBCODE
# define VODI_US_FL_SUBCODE "fl"
# define VODI_US_FL_SUBNAME "Florida"
# define VodiK_US_FL_SUBNUM 10

/* us-ga (Georgia) */
# define VODI_US_GA_CODE "us-"VODI_US_GA_SUBCODE
# define VODI_US_GA_SUBCODE "ga"
# define VODI_US_GA_SUBNAME "Georgia"
# define VodiK_US_GA_SUBNUM 11

/* us-hi (Hawaii) */
# define VODI_US_HI_CODE "us-"VODI_US_HI_SUBCODE
# define VODI_US_HI_SUBCODE "hi"
# define VODI_US_HI_SUBNAME "Hawaii"
# define VodiK_US_HI_SUBNUM 12

/* us-ia (Iowa) */
# define VODI_US_IA_CODE "us-"VODI_US_IA_SUBCODE
# define VODI_US_IA_SUBCODE "ia"
# define VODI_US_IA_SUBNAME "Iowa"
# define VodiK_US_IA_SUBNUM 13

/* us-id (Idaho) */
# define VODI_US_ID_CODE "us-"VODI_US_ID_SUBCODE
# define VODI_US_ID_SUBCODE "id"
# define VODI_US_ID_SUBNAME "Idaho"
# define VodiK_US_ID_SUBNUM 14

/* us-il (Illinois) */
# define VODI_US_IL_CODE "us-"VODI_US_IL_SUBCODE
# define VODI_US_IL_SUBCODE "il"
# define VODI_US_IL_SUBNAME "Illinois"
# define VodiK_US_IL_SUBNUM 15

/* us-in (Indiana) */
# define VODI_US_IN_CODE "us-"VODI_US_IN_SUBCODE
# define VODI_US_IN_SUBCODE "in"
# define VODI_US_IN_SUBNAME "Indiana"
# define VodiK_US_IN_SUBNUM 16

/* us-ks (Kansas) */
# define VODI_US_KS_CODE "us-"VODI_US_KS_SUBCODE
# define VODI_US_KS_SUBCODE "ks"
# define VODI_US_KS_SUBNAME "Kansas"
# define VodiK_US_KS_SUBNUM 17

/* us-ky (Kentucky) */
# define VODI_US_KY_CODE "us-"VODI_US_KY_SUBCODE
# define VODI_US_KY_SUBCODE "ky"
# define VODI_US_KY_SUBNAME "Kentucky"
# define VodiK_US_KY_SUBNUM 18

/* us-la (Louisiana) */
# define VODI_US_LA_CODE "us-"VODI_US_LA_SUBCODE
# define VODI_US_LA_SUBCODE "la"
# define VODI_US_LA_SUBNAME "Louisiana"
# define VodiK_US_LA_SUBNUM 19

/* us-ma (Massachusetts) */
# define VODI_US_MA_CODE "us-"VODI_US_MA_SUBCODE
# define VODI_US_MA_SUBCODE "ma"
# define VODI_US_MA_SUBNAME "Massachusetts"
# define VodiK_US_MA_SUBNUM 20

/* us-md (Maryland) */
# define VODI_US_MD_CODE "us-"VODI_US_MD_SUBCODE
# define VODI_US_MD_SUBCODE "md"
# define VODI_US_MD_SUBNAME "Maryland"
# define VodiK_US_MD_SUBNUM 21

/* us-me (Maine) */
# define VODI_US_ME_CODE "us-"VODI_US_ME_SUBCODE
# define VODI_US_ME_SUBCODE "me"
# define VODI_US_ME_SUBNAME "Maine"
# define VodiK_US_ME_SUBNUM 22

/* us-mi (Michigan) */
# define VODI_US_MI_CODE "us-"VODI_US_MI_SUBCODE
# define VODI_US_MI_SUBCODE "mi"
# define VODI_US_MI_SUBNAME "Michigan"
# define VodiK_US_MI_SUBNUM 23

/* us-mn (Minnesota) */
# define VODI_US_MN_CODE "us-"VODI_US_MN_SUBCODE
# define VODI_US_MN_SUBCODE "mn"
# define VODI_US_MN_SUBNAME "Minnesota"
# define VodiK_US_MN_SUBNUM 24

/* us-mo (Missouri) */
# define VODI_US_MO_CODE "us-"VODI_US_MO_SUBCODE
# define VODI_US_MO_SUBCODE "mo"
# define VODI_US_MO_SUBNAME "Missouri"
# define VodiK_US_MO_SUBNUM 25

/* us-ms (Mississippi) */
# define VODI_US_MS_CODE "us-"VODI_US_MS_SUBCODE
# define VODI_US_MS_SUBCODE "ms"
# define VODI_US_MS_SUBNAME "Mississippi"
# define VodiK_US_MS_SUBNUM 26

/* us-mt (Montana) */
# define VODI_US_MT_CODE "us-"VODI_US_MT_SUBCODE
# define VODI_US_MT_SUBCODE "mt"
# define VODI_US_MT_SUBNAME "Montana"
# define VodiK_US_MT_SUBNUM 27

/* us-nc (North Carolina) */
# define VODI_US_NC_CODE "us-"VODI_US_NC_SUBCODE
# define VODI_US_NC_SUBCODE "nc"
# define VODI_US_NC_SUBNAME "North Carolina"
# define VodiK_US_NC_SUBNUM 28

/* us-nd (North Dakota) */
# define VODI_US_ND_CODE "us-"VODI_US_ND_SUBCODE
# define VODI_US_ND_SUBCODE "nd"
# define VODI_US_ND_SUBNAME "North Dakota"
# define VodiK_US_ND_SUBNUM 29

/* us-ne (Nebraska) */
# define VODI_US_NE_CODE "us-"VODI_US_NE_SUBCODE
# define VODI_US_NE_SUBCODE "ne"
# define VODI_US_NE_SUBNAME "Nebraska"
# define VodiK_US_NE_SUBNUM 30

/* us-nh (New Hampshire) */
# define VODI_US_NH_CODE "us-"VODI_US_NH_SUBCODE
# define VODI_US_NH_SUBCODE "nh"
# define VODI_US_NH_SUBNAME "New Hampshire"
# define VodiK_US_NH_SUBNUM 31

/* us-nj (New Jersey) */
# define VODI_US_NJ_CODE "us-"VODI_US_NJ_SUBCODE
# define VODI_US_NJ_SUBCODE "nj"
# define VODI_US_NJ_SUBNAME "New Jersey"
# define VodiK_US_NJ_SUBNUM 32

/* us-nm (New Mexico) */
# define VODI_US_NM_CODE "us-"VODI_US_NM_SUBCODE
# define VODI_US_NM_SUBCODE "nm"
# define VODI_US_NM_SUBNAME "New Mexico"
# define VodiK_US_NM_SUBNUM 33

/* us-nv (Nevada) */
# define VODI_US_NV_CODE "us-"VODI_US_NV_SUBCODE
# define VODI_US_NV_SUBCODE "nv"
# define VODI_US_NV_SUBNAME "Nevada"
# define VodiK_US_NV_SUBNUM 34

/* us-ny (New York) */
# define VODI_US_NY_CODE "us-"VODI_US_NY_SUBCODE
# define VODI_US_NY_SUBCODE "ny"
# define VODI_US_NY_SUBNAME "New York"
# define VodiK_US_NY_SUBNUM 35

/* us-oh (Ohio) */
# define VODI_US_OH_CODE "us-"VODI_US_OH_SUBCODE
# define VODI_US_OH_SUBCODE "oh"
# define VODI_US_OH_SUBNAME "Ohio"
# define VodiK_US_OH_SUBNUM 36

/* us-ok (Oklahoma) */
# define VODI_US_OK_CODE "us-"VODI_US_OK_SUBCODE
# define VODI_US_OK_SUBCODE "ok"
# define VODI_US_OK_SUBNAME "Oklahoma"
# define VodiK_US_OK_SUBNUM 37

/* us-or (Oregon) */
# define VODI_US_OR_CODE "us-"VODI_US_OR_SUBCODE
# define VODI_US_OR_SUBCODE "or"
# define VODI_US_OR_SUBNAME "Oregon"
# define VodiK_US_OR_SUBNUM 38

/* us-pa (Pennsylvania) */
# define VODI_US_PA_CODE "us-"VODI_US_PA_SUBCODE
# define VODI_US_PA_SUBCODE "pa"
# define VODI_US_PA_SUBNAME "Pennsylvania"
# define VodiK_US_PA_SUBNUM 39

/* us-ri (Rhode Island) */
# define VODI_US_RI_CODE "us-"VODI_US_RI_SUBCODE
# define VODI_US_RI_SUBCODE "ri"
# define VODI_US_RI_SUBNAME "Rhode Island"
# define VodiK_US_RI_SUBNUM 40

/* us-sc (South Carolina) */
# define VODI_US_SC_CODE "us-"VODI_US_SC_SUBCODE
# define VODI_US_SC_SUBCODE "sc"
# define VODI_US_SC_SUBNAME "South Carolina"
# define VodiK_US_SC_SUBNUM 41

/* us-sd (South Dakota) */
# define VODI_US_SD_CODE "us-"VODI_US_SD_SUBCODE
# define VODI_US_SD_SUBCODE "sd"
# define VODI_US_SD_SUBNAME "South Dakota"
# define VodiK_US_SD_SUBNUM 42

/* us-tn (Tennessee) */
# define VODI_US_TN_CODE "us-"VODI_US_TN_SUBCODE
# define VODI_US_TN_SUBCODE "tn"
# define VODI_US_TN_SUBNAME "Tennessee"
# define VodiK_US_TN_SUBNUM 43

/* us-tx (Texas) */
# define VODI_US_TX_CODE "us-"VODI_US_TX_SUBCODE
# define VODI_US_TX_SUBCODE "tx"
# define VODI_US_TX_SUBNAME "Texas"
# define VodiK_US_TX_SUBNUM 44

/* us-ut (Utah) */
# define VODI_US_UT_CODE "us-"VODI_US_UT_SUBCODE
# define VODI_US_UT_SUBCODE "ut"
# define VODI_US_UT_SUBNAME "Utah"
# define VodiK_US_UT_SUBNUM 45

/* us-va (Virginia) */
# define VODI_US_VA_CODE "us-"VODI_US_VA_SUBCODE
# define VODI_US_VA_SUBCODE "va"
# define VODI_US_VA_SUBNAME "Virginia"
# define VodiK_US_VA_SUBNUM 46

/* us-vt (Vermont) */
# define VODI_US_VT_CODE "us-"VODI_US_VT_SUBCODE
# define VODI_US_VT_SUBCODE "vt"
# define VODI_US_VT_SUBNAME "Vermont"
# define VodiK_US_VT_SUBNUM 47

/* us-wa (Washington) */
# define VODI_US_WA_CODE "us-"VODI_US_WA_SUBCODE
# define VODI_US_WA_SUBCODE "wa"
# define VODI_US_WA_SUBNAME "Washington"
# define VodiK_US_WA_SUBNUM 48

/* us-wi (Wisconsin) */
# define VODI_US_WI_CODE "us-"VODI_US_WI_SUBCODE
# define VODI_US_WI_SUBCODE "wi"
# define VODI_US_WI_SUBNAME "Wisconsin"
# define VodiK_US_WI_SUBNUM 49

/* us-wv (West Virginia) */
# define VODI_US_WV_CODE "us-"VODI_US_WV_SUBCODE
# define VODI_US_WV_SUBCODE "wv"
# define VODI_US_WV_SUBNAME "West Virginia"
# define VodiK_US_WV_SUBNUM 50

/* us-wy (Wyoming ) */
# define VODI_US_WY_CODE "us-"VODI_US_WY_SUBCODE
# define VODI_US_WY_SUBCODE "wy"
# define VODI_US_WY_SUBNAME "Wyoming"
# define VodiK_US_WY_SUBNUM 51

/* @} */


/*
 * ISO 3166-3
 *
 * Defines codes for country names which have been deleted from ISO 3166-1
 * since its first publication in 1974.
 */

/* USSR */
# define VODI_USSR_NAME "USSR"
# define _VODI_USSR_NAME USSR
# define VODI_USSR_ALPHA2 "su"
# define _VODI_USSR_ALPHA2 su
# define VODI_USSR_ALPHA3 "sun"
# define _VODI_USSR_ALPHA3 sun
# define VodiK_USSR_NUMERIC 810


/*
 * Pseudo countries
 *
 */

/* Accord Dangereuses Route */
# define VODI_ADR_NAME "Accord Dangereuses Route"
# define _VODI_ADR_NAME Accord_Dangereuses_Route
# define VODI_ADR_ALPHA3 "adr"
# define _VODI_ADR_ALPHA3 adr
# define VodiK_ADR_NUMERIC 1000

/* ============================================================================
 * FOR COMPATIBILITY
 */
# define VodiK_VPW_CCODE_UKRAINE VodiK_UKRAINE_NUMERIC
# define VodiK_VPW_CCODE_RUSSIA VodiK_RUSSIAN_NUMERIC
# define VodiK_VPW_CCODE_USSR VodiK_USSR_NUMERIC
# define VodiK_VPW_CCODE_FINLAND VodiK_FINLAND_NUMERIC
# define VodiK_VPW_CCODE_ITALY VodiK_ITALY_NUMERIC
# define VodiK_VPW_CCODE_BELARUS VodiK_BELARUS_NUMERIC
# define VodiK_VPW_CCODE_MEXICO VodiK_MEXICO_NUMERIC
# define VodiK_VPW_CCODE_COLOMBIA VodiK_COLOMBIA_NUMERIC
# define VodiK_VPW_CCODE_KAZAKHSTAN VodiK_KAZAKHSTAN_NUMERIC
# define VodiK_VPW_CCODE_SWEDEN VodiK_SWEDEN_NUMERIC
# define VodiK_VPW_CCODE_BULGARIA VodiK_BULGARIA_NUMERIC
# define VodiK_VPW_CCODE_MOLDOVA_PRE VodiK_PRIDNESTROVIAN_NUMERIC
# define VodiK_VPW_CCODE_MOLDOVA VodiK_MOLDOVA_NUMERIC
# define VodiK_VPW_CCODE_UZBEKISTAN VodiK_UZBEKISTAN_NUMERIC
# define VodiK_VPW_CCODE_TURKEY VodiK_TURKEY_NUMERIC
# define VodiK_VPW_CCODE_OSETIA VodiK_OSSETIA_NUMERIC
# define VodiK_VPW_CCODE_TAIWAN VodiK_TAIWAN_NUMERIC
# define VodiK_VPW_CCODE_POLAND VodiK_POLAND_NUMERIC
# define VodiK_VPW_CCODE_HUNGARY VodiK_HUNGARY_NUMERIC
# define VodiK_VPW_CCODE_SLOVAKIA VodiK_SLOVAKIA_NUMERIC
# define VodiK_VPW_CCODE_KYRGYZSTAN VodiK_KYRGYZSTAN_NUMERIC
# define VodiK_VPW_CCODE_CZECH_REPUBLIC VodiK_CZECH_REPUBLIC_NUMERIC
# define VodiK_VPW_CCODE_ROMANIA VodiK_ROMANIA_NUMERIC
# define VodiK_VPW_CCODE_LATVIA VodiK_LATVIA_NUMERIC
# define VodiK_VPW_CCODE_FRANCE VodiK_FRANCE_NUMERIC
# define VodiK_VPW_CCODE_SLOVENIA VodiK_SLOVENIA_NUMERIC
# define VodiK_VPW_CCODE_BRAZIL VodiK_BRAZIL_NUMERIC
# define VodiK_VPW_CCODE_GEORGIA VodiK_GEORGIA_NUMERIC
# define VodiK_VPW_CCODE_CROATIA VodiK_CROATIA_NUMERIC
# define VodiK_VPW_CCODE_LITHUANIA VodiK_LITHUANIA_NUMERIC
# define VodiK_VPW_CCODE_ISRAEL VodiK_ISRAEL_NUMERIC
# define VodiK_VPW_CCODE_ARGENTINA VodiK_ARGENTINA_NUMERIC
# define VodiK_VPW_CCODE_PUERTO_RICO VodiK_PUERTO_RICO_NUMERIC

#endif /* !defined(__VODI_ISO3166__) */

/******************************************************************************
 *
 *
 *
 *****************************************************************************/
