/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright 2007 Seenaptec Ltd. All rights reserved.
 * SEENAPTEC PROPRIETARY/CONFIDENTIAL.
 *
 * $Id$
 */

/*
 * ISO3166lib.h	(N.Panasiuk)
 * include/Vodi/ISO3166lib.h
 */

/* ------------------------------------------------------------------------- */

#ifndef __VODI_ISO3166LIB__
# define __VODI_ISO3166LIB__

/******************************************************************************
 * %% BeginSection: includes
 */

# include <Bo/Types.h>

# include <Bo/libc/Stdarg.h>

/******************************************************************************
 * %% BeginSection: function prototypes
 */
# pragma mark -
# pragma mark [ function prototypes ]
# pragma mark -

/* Forward declarations */
struct vodi_iso3166_elem;

# include <Vodi/VodiLinkage.h>

__MYC_BEGIN_CDECLS

__myc_flinkage__(public,libVodi) struct vodi_iso3166_elem const *
VodiISO3166elembynum(
# if __myc_require(prototypes)
	struct aorp_error *anErrPtr /* = NULL */,
	struct vodi_iso3166_elem const *aBase /* = NULL */,
	/* int aNumeric, */
	... /* 0 terminated */
# endif
	);

__myc_flinkage__(public,libVodi) struct vodi_iso3166_elem const *
VodiISO3166elembynum_1(
# if __myc_require(prototypes)
	struct vodi_iso3166_elem const *aBase /* = NULL */,
	int aNumeric,
	struct aorp_error *anErrPtr __myc_defval__(NULL)
# endif
	);

__myc_flinkage__(public,libVodi) struct vodi_iso3166_elem const *
__attribute__((nonnull(2)))
VodiISO3166elembynum_v(
# if __myc_require(prototypes)
	struct vodi_iso3166_elem const *aBase /* = NULL */,
	int const aNumv[], /* 0 terminated */
	struct aorp_error *anErrPtr __myc_defval__(NULL)
# endif
	);

__myc_flinkage__(public,libVodi) struct vodi_iso3166_elem const *
__attribute__((nonnull(2)))
VodiISO3166elembynum_n(
# if __myc_require(prototypes)
	struct vodi_iso3166_elem const *aBase /* = NULL */,
	int const aNumv[],
	size_t aNumc,
	struct aorp_error *anErrPtr __myc_defval__(NULL)
# endif
	);

# pragma mark -

__myc_flinkage__(public,libVodi) struct vodi_iso3166_elem const *
VodiISO3166elembyname(
# if __myc_require(prototypes)
	struct aorp_error *anErrPtr /* = NULL */,
	struct vodi_iso3166_elem const *aBase /* = NULL */,
	/* char const *aName, */
	... /* NULL terminated */
# endif
	);

__myc_flinkage__(public,libVodi) struct vodi_iso3166_elem const *
VodiISO3166elembyname_1(
# if __myc_require(prototypes)
	struct vodi_iso3166_elem const *aBase /* = NULL */,
	char const *aName,
	struct aorp_error *anErrPtr __myc_defval__(NULL)
# endif
	);

__myc_flinkage__(public,libVodi) struct vodi_iso3166_elem const *
__attribute__((nonnull(2)))
VodiISO3166elembyname_v(
# if __myc_require(prototypes)
	struct vodi_iso3166_elem const *aBase /* = NULL */,
	char const *aNamev[], /* NULL terminated */
	struct aorp_error *anErrPtr __myc_defval__(NULL)
# endif
	);

__myc_flinkage__(public,libVodi) struct vodi_iso3166_elem const *
__attribute__((nonnull(2)))
VodiISO3166elembyname_n(
# if __myc_require(prototypes)
	struct vodi_iso3166_elem const *aBase /* = NULL */,
	char const *aNamev[],
	size_t aNamec,
	struct aorp_error *anErrPtr __myc_defval__(NULL)
# endif
	);

# pragma mark -

/* numeric([784]) => 784; numeric([784, 3]) => 3 */
__myc_flinkage__(public,libVodi) int
VodiISO3166numeric(
# if __myc_require(prototypes)
	struct vodi_iso3166_elem const *anElem
# endif
	);

/* alpha2([784]) => ae; alpha2([784, 3]) => du */
__myc_flinkage__(public,libVodi) char const *
VodiISO3166alpha2(
# if __myc_require(prototypes)
	struct vodi_iso3166_elem const *anElem
# endif
	);

/* alpha3([784]) => are; alpha3([784, 3]) => NULL */
__myc_flinkage__(public,libVodi) char const *
VodiISO3166alpha3(
# if __myc_require(prototypes)
	struct vodi_iso3166_elem const *anElem
# endif
	);

/* name([ae]) => United Arab Emirates; name([ae, du]) => Dubayy */
__myc_flinkage__(public,libVodi) char const *
VodiISO3166name(
# if __myc_require(prototypes)
	struct vodi_iso3166_elem const *anElem
# endif
	);

# pragma mark -

/* ccode([784]) = ccode([784, 3]) => 784 */
__myc_flinkage__(public,libVodi) int
VodiISO3166ccode(
# if __myc_require(prototypes)
	struct vodi_iso3166_elem const *anElem
# endif
	);

/* cname2([784]) = cname2([784, 3]) => ae */
__myc_flinkage__(public,libVodi) char const *
VodiISO3166cname2(
# if __myc_require(prototypes)
	struct vodi_iso3166_elem const *anElem
# endif
	);

/* cname3([784]) = cname3([784, 3]) => are */
__myc_flinkage__(public,libVodi) char const *
VodiISO3166cname3(
# if __myc_require(prototypes)
	struct vodi_iso3166_elem const *anElem
# endif
	);

/* cname([784]) = cname([784, 3]) => United Arab Emirates */
__myc_flinkage__(public,libVodi) char const *
VodiISO3166cname(
# if __myc_require(prototypes)
	struct vodi_iso3166_elem const *anElem
# endif
	);

# pragma mark -

/* NULL terminated list of elements */
__myc_vlinkage__(public,libVodi) struct vodi_iso3166_elem const **
_G_iso3166_elemv;

/* NULL terminated list of elements */
__myc_flinkage__(public,libVodi) struct vodi_iso3166_elem const **
__attribute__((nonnull(1)))
VodiISO3166children(
# if __myc_require(prototypes)
	struct vodi_iso3166_elem const *anElem
# endif
	);

__myc_flinkage__(public,libVodi) struct vodi_iso3166_elem const *
__attribute__((nonnull(1)))
VodiISO3166parent(
# if __myc_require(prototypes)
	struct vodi_iso3166_elem const *anElem
# endif
	);

__MYC_END_CDECLS

#endif /* !defined(__VODI_ISO3166LIB__) */

/******************************************************************************
 *
 *
 *
 *****************************************************************************/
