/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright 2007 Seenaptec Ltd. All rights reserved.
 * SEENAPTEC PROPRIETARY/CONFIDENTIAL.
 *
 * $Id$
 */

/*
 * VodiLinkage.h	(N.Panasiuk)
 * include/Vodi/VodiLinkage.h
 */

/* ------------------------------------------------------------------------- */

#ifndef __VODILINKAGE__
# define __VODILINKAGE__

/******************************************************************************
 * %% BeginSection: includes
 */

# include <Bo/Cdefs.h>

/******************************************************************************
 * %% BeginSection: definitions
 */

/*
 * To use macros __myc_flinkage__(), __myc_vlinkage__() it is needed
 * to define the next macros: 
 */
# if __myc_build_shlib(libVodi)

#  define myc_flinkage_public_libVodi myc_flinkage_shlib_export
#  define myc_flinkage_private_libVodi myc_flinkage_shlib_private
#  define myc_flinkage_internal_libVodi myc_flinkage_shlib_internal

#  define myc_vlinkage_public_libVodi myc_vlinkage_shlib_export
#  define myc_vlinkage_private_libVodi myc_vlinkage_shlib_private
#  define myc_vlinkage_internal_libVodi myc_vlinkage_shlib_internal

# else
# if __myc_use_shlib(libVodi)

#  define myc_flinkage_public_libVodi myc_flinkage_shlib_import
#  define myc_flinkage_private_libVodi myc_flinkage_shlib_private
#  define myc_flinkage_internal_libVodi myc_flinkage_shlib_internal

#  define myc_vlinkage_public_libVodi myc_vlinkage_shlib_import
#  define myc_vlinkage_private_libVodi myc_vlinkage_shlib_private
#  define myc_vlinkage_internal_libVodi myc_vlinkage_shlib_internal

# else
# if __myc_build_archive(libVodi)

#  define myc_flinkage_public_libVodi myc_flinkage_archive_export
#  define myc_flinkage_private_libVodi myc_flinkage_archive_private
#  define myc_flinkage_internal_libVodi myc_flinkage_archive_internal

#  define myc_vlinkage_public_libVodi myc_vlinkage_archive_export
#  define myc_vlinkage_private_libVodi myc_vlinkage_archive_private
#  define myc_vlinkage_internal_libVodi myc_vlinkage_archive_internal

# else
# if __myc_use_archive(libVodi)

#  define myc_flinkage_public_libVodi myc_flinkage_archive_import
#  define myc_flinkage_private_libVodi myc_flinkage_archive_private
#  define myc_flinkage_internal_libVodi myc_flinkage_archive_internal

#  define myc_vlinkage_public_libVodi myc_vlinkage_archive_import
#  define myc_vlinkage_private_libVodi myc_vlinkage_archive_private
#  define myc_vlinkage_internal_libVodi myc_vlinkage_archive_internal

# else

#  define myc_flinkage_public_libVodi myc_flinkage_shlib_export
#  define myc_flinkage_private_libVodi myc_flinkage_shlib_private
#  define myc_flinkage_internal_libVodi myc_flinkage_shlib_internal

#  define myc_vlinkage_public_libVodi myc_vlinkage_shlib_export
#  define myc_vlinkage_private_libVodi myc_vlinkage_shlib_private
#  define myc_vlinkage_internal_libVodi myc_vlinkage_shlib_internal

# endif /* __myc_use_archive(libVodi) */
# endif /* __myc_build_archive(libVodi) */
# endif /* __myc_use_shlib(libVodi) */
# endif /* __myc_build_shlib(libVodi) */

#endif /* !defined(__VODILINKAGE__) */

/******************************************************************************
 *
 *
 *
 *****************************************************************************/
