/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright 2007 Seenaptec Ltd. All rights reserved.
 * SEENAPTEC PROPRIETARY/CONFIDENTIAL.
 *
 * $Id$
 */

/*
 * Vodilib.h	(N.Panasiuk)
 * include/Vodi/Vodilib.h
 */

/* ------------------------------------------------------------------------- */

#ifndef __VODI_VODILIB__
# define __VODI_VODILIB__

/******************************************************************************
 * %% BeginSection: includes
 */

# include <Vodi/Types.h>

/******************************************************************************
 * %% BeginSection: function prototypes
 */
# pragma mark -
# pragma mark [ function prototypes ]
# pragma mark -

struct bo_zmalloc;
struct vodi_result_info;

# include <Vodi/VodiLinkage.h>

__MYC_BEGIN_CDECLS

__myc_flinkage__(public,libVodi) struct vodi_image *
VodiImageCreate(
# if __myc_require(prototypes)
	long                        aWidth,  /* in pixels */
	long                        aHeight, /* in pixels */
	unsigned                    aBPP,
	struct aorp_error          *anErrPtr __myc_defval__(NULL)
# endif
	);

__myc_flinkage__(public,libVodi) struct vodi_image *
__myc_calltype__(mcall)
VodiImageCreate_copy(
# if __myc_require(prototypes)
	struct vodi_image const    *anImage,
	struct aorp_error          *anErrPtr __myc_defval__(NULL)
# endif
	) __attribute__((nonnull(1)));

__myc_flinkage__(public,libVodi) struct vodi_image *
VodiImageCreate_za(
# if __myc_require(prototypes)
	struct bo_zmalloc          *anAllocator,
	struct aorp_error          *anErrPtr __myc_defval__(NULL)
# endif
	);


__myc_flinkage__(public,libVodi) ssize_t
__myc_calltype__(mcall)
VodiImageRetain(
# if __myc_require(prototypes)
	struct vodi_image          *anImage,
	struct aorp_error          *anErrPtr __myc_defval__(NULL)
# endif
	) __attribute__((nonnull(1)));

__myc_flinkage__(public,libVodi) ssize_t
__myc_calltype__(mcall)
VodiImageRelease(
# if __myc_require(prototypes)
	struct vodi_image          *anImage,
	bo_opflags_t                Flags __myc_defval__(0),
	struct aorp_error          *anErrPtr __myc_defval__(NULL)
# endif
	) __attribute__((nonnull(1)));

/* ------------------------------------------------------------------------- */
# pragma mark -
/* ------------------------------------------------------------------------- */

__myc_flinkage__(public,libVodi) struct bo_zmalloc *
VodiOpenGrabimgalloc(
# if __myc_require(prototypes)
	unsigned                    aBPP,
	size_t                      aGrabDatasz,     /* in bytes */
	long                        aVodiImageWidth,   /* in pixels */
	long                        aVodiImageHeight,  /* in pixels */
	unsigned                    aVodiImageBPP,
	struct aorp_error          *anErrPtr __myc_defval__(NULL)
# endif
	);

__myc_flinkage__(public,libVodi) void
VodiFreeGrabimgalloc(
# if __myc_require(prototypes)
	struct bo_zmalloc          *anAllocator,
	struct aorp_error          *anErrPtr __myc_defval__(NULL)
# endif
	);


__myc_flinkage__(public,libVodi) struct vodi_grabimg *
VodiGrabimgCreate(
# if __myc_require(prototypes)
	unsigned                    aBPP,
	size_t                      aGrabDatasz,     /* in bytes */
	long                        aVodiImageWidth,   /* in pixels */
	long                        aVodiImageHeight,  /* in pixels */
	unsigned                    aVodiImageBPP,
	struct aorp_error          *anErrPtr __myc_defval__(NULL)
# endif
	);

# define VodiGrabimgCreateGray(aBPP,aGrabDatasz,aWidth,aHeight,anErrPtr) \
	VodiGrabimgCreate(aBPP,aGrabDatasz,aWidth,aHeight,8,anErrPtr)

__myc_flinkage__(public,libVodi) struct vodi_grabimg *
VodiGrabimgCreate_za(
# if __myc_require(prototypes)
	unsigned                    aBPP,
	size_t                      aGrabDatasz,
	struct bo_zmalloc          *aVodiImageAllocator,
	struct aorp_error          *anErrPtr __myc_defval__(NULL)
# endif
	);

__myc_flinkage__(public,libVodi) struct vodi_grabimg *
VodiGrabimgCreate_za2(
# if __myc_require(prototypes)
	struct bo_zmalloc          *aVodiGrabimgAllocator,
	struct aorp_error          *anErrPtr __myc_defval__(NULL)
# endif
	);


__myc_flinkage__(public,libVodi) ssize_t
__myc_calltype__(mcall)
VodiGrabimgRetain(
# if __myc_require(prototypes)
	struct vodi_grabimg        *anImage,
	struct aorp_error          *anErrPtr __myc_defval__(NULL)
# endif
	) __attribute__((nonnull(1)));

__myc_flinkage__(public,libVodi) ssize_t
__myc_calltype__(mcall)
VodiGrabimgRelease(
# if __myc_require(prototypes)
	struct vodi_grabimg        *anImage,
	bo_opflags_t                Flags __myc_defval__(0),
	struct aorp_error          *anErrPtr __myc_defval__(NULL)
# endif
	) __attribute__((nonnull(1)));

/* ------------------------------------------------------------------------- */
# pragma mark -
/* ------------------------------------------------------------------------- */

__myc_flinkage__(public,libVodi) void
VodiResultInfoDestroy(
# if __myc_require(prototypes)
	struct vodi_result_info    *anInfo
# endif
	) __attribute__((nonnull(1)));

/* ------------------------------------------------------------------------- */
# pragma mark -
/* ------------------------------------------------------------------------- */

__myc_flinkage__(public,libVodi) bo_status_t
VodiClassify(
# if __myc_require(prototypes)
	aorp_object_t              *aResclsEnsPtr,
	aorp_object_t               InputResults,  /* single result or ensemble of results */
	struct vodi_clsfycb        *aCB,
	struct aorp_error          *anErrPtr
# endif
	);


__myc_flinkage__(public,libVodi) double
__myc_calltype__(mcall)
_VpwCLSFY__mira__(
# if __myc_require(prototypes)
	struct vodi_clsfycb        *aCB,
	aorp_object_t               aLhs,
	aorp_object_t               aRhs
# endif
	) __attribute__((nonnull(1,2)));

/* ------------------------------------------------------------------------- */
# pragma mark -
/* ------------------------------------------------------------------------- */

__myc_vlinkage__(public,libVodi) int         _G_vodi_version[/* 3 */];
__myc_vlinkage__(public,libVodi) char const *_G_vodi_version_str;

__MYC_END_CDECLS

#endif /* !defined(__VODI_VODILIB__) */

/******************************************************************************
 *
 *
 *
 *****************************************************************************/
