/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright 2007 Seenaptec Ltd. All rights reserved.
 * SEENAPTEC PROPRIETARY/CONFIDENTIAL.
 *
 * $Id$
 */

/*
 * Vpwlimits.h	(V.Sokur)
 * include/Vodi/Vpwlimits.h
 */

/* ------------------------------------------------------------------------- */

#ifndef __VODI_VPWLIMITS__
# define __VODI_VPWLIMITS__

/******************************************************************************
 * %% BeginSection: includes
 */

# ifndef __VODI_LIMITS__
#  include <Vodi/Limits.h>
# endif

/******************************************************************************
 * %% BeginSection: constant declarations
 */
# pragma mark -
# pragma mark [ constant declarations ]
# pragma mark -

/* max variant count in a result */
# define VodiL_VPW_VARIANT_MAX (5)

/* max symbol count of a plate number */
# define VodiL_VPW_SYMBOL_MAX (15)

/* max zone count to analyse on a frame */
# define VodiL_VPW_ANALYSE_ZONE_MAX (20)

// @todo: from 7027
/* symbols breaking coefficients */
# define VodiK_VPWSYM_BREAKING_R1 (1.0)
# define VodiK_VPWSYM_BREAKING_R2 (1.5)
# define VodiK_VPWSYM_BREAKING_R3 (2.2)
# define VodiK_VPWSYM_BREAKING_R4 (3.5)

/* maximum amount of constraints */
# define VodiL_VPW_CONSTRAINT_MAX (512)

/* minimum factor value of plate filter by dencity, strategy 1 */
# define VodiL_PLATE_FILTER_ROFACTOR_MIN (40)

/* maximum factor value of plate filter by dencity, strategy 1 */
# define VodiL_PLATE_FILTER_ROFACTOR_MAX (100)

/* minimum factor value of plate filter by dencity, strategy 2 */
# define VodiL_VPW_PLATE_FILTER_RODROPFACTOR_MIN (10)

/* maximum factor value of plate filter by dencity, strategy 2 */
# define VodiL_VPW_PLATE_FILTER_RODROPFACTOR_MAX (100)

#endif /* !defined(__VODI_VPWLIMITS__) */

/******************************************************************************
 *
 *
 *
 *****************************************************************************/
