/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright 2007 Seenaptec Ltd. All rights reserved.
 * SEENAPTEC PROPRIETARY/CONFIDENTIAL.
 *
 * $Id$
 */

/*
 * Vpwparam.h	(Y.Zubets)
 * include/Vodi/Vpwparam.h
 */

/* ------------------------------------------------------------------------- */

#ifndef __VODI_VPWPARAM__
# define __VODI_VPWPARAM__

/******************************************************************************
 * %% BeginSection: includes
 */

# ifndef __VODI_PARAM__
#  include <Vodi/Param.h>
# endif

# ifndef __VODI_VPWLIMITS__
#  include <Vodi/Vpwlimits.h>
# endif

/******************************************************************************
 * %% BeginSection: constant declarations
 */
# pragma mark -
# pragma mark [ constant declarations ]
# pragma mark -

/* width of image with recognized number */
# define VodiK_VPW_PLATE_IMAGE_WIDTH (268)

/* height of image with recognized number */
# define VodiK_VPW_PLATE_IMAGE_HEIGHT (60)

/* candidate level for motion detector */
# define VodiK_VPWLEVEL_MOTIONDETECT (3)

/* candidate level for plate detector */
# define VodiK_VPWLEVEL_PLATEDETECT (4)

/* candidate level for plate recognition */
# define VodiK_VPWLEVEL_PLATERECOGNITION (5)

/* default templates */
# define VodiK_VPW_TEMPLATES_DEFAULT "*"

/* default value of plate blur mask size */
# define VodiK_VPW_IMAGE_BLUR_DEFAULT (13)

/* default value of image threshold */
# define VodiK_VPW_IMAGE_THRESHOLD_DEFAULT (40)

/* default value of plate size min */
# define VodiK_VPW_PLATE_SIZE_MIN_DEFAULT (49)

/* default value of plate size max */
# define VodiK_VPW_PLATE_SIZE_MAX_DEFAULT (192)

/* default value of plate probability min */
# define VodiK_VPW_PLATE_PROBABILITY_MIN_DEFAULT (15)

/* default value of plate star max */
# define VodiK_VPW_PLATE_STAR_MAX_DEFAULT (0)

/* default value of plate extra angle analyse */
# define VodiK_VPW_PLATE_EXTRA_ANGLE_ANALYSE_DEFAULT (0)

/* default value of plate extra ranges analyse */
# define VodiK_VPW_PLATE_EXTRA_RANGES_ANALYSE_DEFAULT (0)

/* default value of plate precise analyse */
# define VodiK_VPW_PLATE_PRECISE_ANALYSE_DEFAULT (0)

/* default DNN DEVICES */
# ifdef _A_ARM
#  define VodiK_VPW_DNN_DEVICES_DEFAULT "MYRIAD"
# else
#  define VodiK_VPW_DNN_DEVICES_DEFAULT "CPU"
# endif

/* default PLATECANDS methods */
# define VodiF_VPW_PLATECANDS_BY_MORPH 0x1
# define VodiF_VPW_PLATECANDS_BY_DNN   0x2
# define VodiK_VPW_PLATECANDS_METHODS_DEFAULT VodiF_VPW_PLATECANDS_BY_MORPH

/* default PLATE ANALYSE methods */
# define VodiF_VPW_BLURAN 0x1
# define VodiF_VPW_NAN    0x2
# define VodiF_VPW_TMPLAN 0x4
# define VodiF_VPW_DNNAN  0x8
# define VodiF_VPW_OTSUAN 0x10
# define VodiK_VPW_PLATE_ANALYSE_METHODS_DEFAULT \
	(VodiF_VPW_BLURAN | VodiF_VPW_NAN | VodiF_VPW_TMPLAN)

/* default value of using a DNN plate filter */
# define VodiK_VPW_PLATE_DNN_FILTER_ENABLE_DEFAULT (0)

/* default value of analyse level */
# define VodiK_VPW_PLATECANDS_ANALYSE 0
# define VodiK_VPW_SYMCANDS_ANALYSE 1
# define VodiK_VPW_TEXT_ANALYSE 2
# define VodiK_VPW_FULL_ANALYSE VodiK_VPW_TEXT_ANALYSE
# define VodiK_VPW_ANALYSE_LEVEL_DEFAULT VodiK_VPW_FULL_ANALYSE

/* default factor value of plate filter by dencity, strategy 1 */
# define VodiK_VPW_PLATE_FILTER_ROFACTOR_DEFAULT (95)  // 73 - enabled default

/* default factor value of plate filter by dencity, strategy 2 */
# define VodiK_VPW_PLATE_FILTER_RODROPFACTOR_DEFAULT (0) // 27 - enabled default

/* default state of filter by symbol count in plate detection */
# define VodiK_VPW_PLATE_FILTER_SYMCOUNT_DEFAULT (0)

/* default type for image scale in plate detection, 0 - not used */
# define VodiK_VPW_PLATE_NO_SCALE_IMAGE (0)
# define VodiK_VPW_PLATE_SCALE_FACTOR (1)
# define VodiK_VPW_PLATE_SCALE_SIZE (2)

/* default factor value for image height scale in plate detection */
# define VodiK_VPW_PLATE_HEIGHT_SCALE_FACTOR_DEFAULT (1)

/* default factor value for image width scale in plate detection */
# define VodiK_VPW_PLATE_WIDTH_SCALE_FACTOR_DEFAULT (1)

/* default value for sequential flush mode */
# define VodiK_VPW_SEQUENTIAL_FLUSH_ENABLE_DEFAULT (0)

/* default value for dynamic output frame count */
# define VodiK_VPW_DYNAMIC_OUTPUT_FRAMECOUNT_DEFAULT (6)

/* default value for dynamic output timeout */
# define VodiK_VPW_DYNAMIC_OUTPUT_TIMEOUT_DEFAULT (2000000) /* us */

/* default value for dynamic output period */
# define VodiK_VPW_DYNAMIC_OUTPUT_PERIOD_DEFAULT (500000) /* us */

/* default value for dynamic with duplicate */
# define VodiK_VPW_DYNAMIC_WITH_DUPLICATE_DEFAULT (0)

/* default value for dynamic duration without access */
# define VodiK_VPW_DYNAMIC_DURATION_WITHOUT_ACCESS_DEFAULT (3000000) /* us */

/* default value for dynamic comparable time max */
# define VodiK_VPW_DYNAMIC_COMPARABLE_TIME_MAX_DEFAULT (80) /* ms */

/* default value for dynamic plate location mismatch factor */
# define VodiK_VPW_DYNAMIC_PLATE_LOCATION_MISMATCH_FACTOR_DEFAULT (1.5)

/* default value for dynamic comparable time factor */
# define VodiK_VPW_DYNAMIC_COMPARABLE_TIME_FACTOR_DEFAULT (2)

/* default value for dynamic plate location mismatch factor 2 */
# define VodiK_VPW_DYNAMIC_PLATE_LOCATION_MISMATCH_FACTOR2_DEFAULT (0.7)

/* default value of limit factor for the new trac point in dynamic */
# define VodiK_VPW_DYNAMIC_TRAC_LIMIT_DEFAULT (3)

/* default value for dynamic velocity max */
# define VodiK_VPW_DYNAMIC_VELOCITY_MAX_DEFAULT (49)

/* default value for dynamic comparable symbols min */
# define VodiK_VPW_DYNAMIC_COMPARABLE_SYMBOLS_MIN_DEFAULT (80)

/* default value for dynamic lost algorithm enable */
# define VodiK_VPW_DYNAMIC_LOSTALG_ENABLE_DEFAULT (1)

/* default value for dynamic before lost track factor */
# define VodiK_VPW_DYNAMIC_BEFORE_LOST_TRACK_FACTOR_DEFAULT (2)

/* default value for dynamic before lost track time max */
# define VodiK_VPW_DYNAMIC_BEFORE_LOST_TRACK_TIME_MAX_DEFAULT (100000) /* us */

/* default value for dynamic after lost factor */
# define VodiK_VPW_DYNAMIC_AFTER_LOST_FACTOR_DEFAULT (1.3)

/* default value for dynamic after lost time max */
# define VodiK_VPW_DYNAMIC_AFTER_LOST_TIME_MAX_DEFAULT (100000) /* us */

/* possible values for plate ratio */
#define VodiK_VPW_PLATE_RATIO_AUTO (0) // use auto detected plate ratio
#define VodiK_VPW_PLATE_RATIO_USER (1) // use user defined plate ratio
#define VodiK_VPW_PLATE_RATIO_DEFAULT (2) // not use auto detection for plate ratio

/* default value of plate ratio type */
# define VodiK_VPW_PLATE_RATIO_TYPE_DEFAULT VodiK_VPW_PLATE_RATIO_AUTO

/* default value of plate ratio factor */
# define VodiK_VPW_PLATE_RATIO_FACTOR_DEFAULT (1)

/* compat */
# define VodiL_VPWLEVEL_MOTIONDETECT VodiK_VPWLEVEL_MOTIONDETECT
# define VodiL_VPWLEVEL_PLATEDETECT VodiK_VPWLEVEL_PLATEDETECT
# define VodiL_VPWLEVEL_PLATERECOGNITION VodiK_VPWLEVEL_PLATERECOGNITION

#endif /* !defined(__VODI_VPWPARAM__) */

/******************************************************************************
 *
 *
 *
 *****************************************************************************/
