/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright 2007 Seenaptec Ltd. All rights reserved.
 * SEENAPTEC PROPRIETARY/CONFIDENTIAL.
 *
 * $Id$
 */

/*
 * Vpwtypes.h	(Y.Zubets)
 * include/Vodi/Vpwtypes.h
 */

/* ------------------------------------------------------------------------- */

#ifndef __VODI_VPWTYPES__
# define __VODI_VPWTYPES__

/******************************************************************************
 * %% BeginSection: includes
 */

# ifndef __VODI_TYPES__
#  include <Vodi/Types.h>
# endif

# ifndef __VODI_VPWPARAM__
#  include <Vodi/Vpwparam.h>
# endif

# ifndef __VODI_LPVTYPE__
#  include <Vodi/lpvType.h>
# endif

# ifndef __VODI_SYMBOL_TYPE__
#  include <Vodi/symbolType.h>
# endif

/******************************************************************************
 * %% BeginSection: type/constant declarations
 */
# pragma mark -
# pragma mark [ type/constant declarations ]
# pragma mark -

/*
 * OPTIONS MAGIC constants
 */

# define VodiK_VPW_OPTIONS_WORK_MAGIC (0)

/*
 * CONTROL PARAM constants
 */

/*
 * VodiprincControl
 */

/* vpwi (plate templates) */
# define VodiCTL_GETVPWI 3 /* (char **) */
# define VodiCTL_ADDVPWI 4 /* (char const *) */
# define VodiCTL_SETVPWI 5 /* (char const *) */
# define VodiCTL_DELVPWI 6 /* (char const *) */

# define VodiCTL_PRINT_APPLIED_SETTINGS 7 /* (char **) */

/*
 * VodiprincGetparam/VodiprincSetparam
 */

# define VodiCTL_VPW_PLATE_EXTRA_RANGES_ANALYSE                (49) /* bool:int */
# define VodiCTL_VPW_PLATE_PROBABILITY_MIN                     (51) /* unsigned */
# define VodiCTL_VPW_PLATE_STAR_MAX                            (52) /* unsigned */
# define VodiCTL_VPW_PLATE_SIZE_MAX                            (53) /* unsigned */
# define VodiCTL_VPW_PLATE_SIZE_MIN                            (54) /* unsigned */
# define VodiCTL_VPW_PLATE_EXTRA_ANGLE_ANALYSE                 (55) /* bool:int */
# define VodiCTL_VPW_PLATE_FILTER_ROFACTOR                     (56) /* unsigned */
# define VodiCTL_VPW_PLATE_FILTER_RODROPFACTOR                 (57) /* unsigned */
# define VodiCTL_VPW_PLATE_IMAGE_SCALE_FACTOR                  (58) /* vodi_scale_factor */
# define VodiCTL_VPW_PLATE_IMAGE_SIZE                          (59) /* vodi_size */
# define VodiCTL_VPW_PLATE_FILTER_SYMCOUNT                     (61) /* unsigned */
# define VodiCTL_VPW_LOG_SETTINGS                              (62) /* bool:int */
# define VodiCTL_VPW_PLATE_PRECISE_ANALYSE                     (63) /* bool:int */
# define VodiCTL_VPW_DNN_DEVICES                               (64) /* vodi_devtyp_t[], unsigned */
# define VodiCTL_VPW_PLATECANDS_METHODS                        (65) /* unsigned */
# define VodiCTL_VPW_ANALYSE_LEVEL                             (66) /* unsigned */
# define VodiCTL_VPW_PLATE_ANALYSE_METHODS                     (67) /* unsigned */
# define VodiCTL_VPW_PLATE_DNN_FILTER_ENABLE                   (68) /* bool:int */
# define VodiCTL_VPW_TREAT_PLATECAND_AS_PLATE                  (69) /* bool:int */

# define VodiCTL_VPW_IMAGE_BLUR                                (104) /* int */
# define VodiCTL_VPW_IMAGE_THRESHOLD                           (105) /* unsigned */
# define VodiCTL_VPW_IMAGE_ANALYSE_ZONE                        (106) /* vodi_rect[], unsigned */
# define VodiCTL_VPW_IMAGE_AZONE_MASK                          (111) /* vodi_image* */
# define VodiCTL_VPW_IMAGE_NOT_ANALYSE_ZONE                    (110) /* vodi_rect[], unsigned */
# define VodiCTL_VPW_PLATE_RATIO                               (114) /* unsigned, double*/

# define VodiCTL_VPW_SEQUENTIAL_FLUSH_ENABLE                   (150) /* bool:int */

# define VodiCTL_VPW_DYNAMIC_ENABLE                            (300) /* bool:int */
# define VodiCTL_VPW_DYNAMIC_OUTPUT_FRAMECOUNT                 (305) /* unsigned */
# define VodiCTL_VPW_DYNAMIC_OUTPUT_TIMEOUT                    (306) /* bo_usec_t */
# define VodiCTL_VPW_DYNAMIC_OUTPUT_PERIOD                     (307) /* bo_usec_t */
# define VodiCTL_VPW_DYNAMIC_WITH_DUPLICATE                    (308) /* bool:int */
# define VodiCTL_VPW_DYNAMIC_DURATION_WITHOUT_ACCESS           (309) /* bo_usec_t */
# define VodiCTL_VPW_DYNAMIC_COMPARABLE_TIME_MAX               (310) /* bo_msec_t */
# define VodiCTL_VPW_DYNAMIC_PLATE_LOCATION_MISMATCH_FACTOR    (311) /* double */
# define VodiCTL_VPW_DYNAMIC_COMPARABLE_TIME_FACTOR            (312) /* double */
# define VodiCTL_VPW_DYNAMIC_PLATE_LOCATION_MISMATCH_FACTOR2   (313) /* double */
# define VodiCTL_VPW_DYNAMIC_VELOCITY_MAX                      (314) /* unsigned */
# define VodiCTL_VPW_DYNAMIC_COMPARABLE_SYMBOLS_MIN            (315) /* unsigned */
# define VodiCTL_VPW_DYNAMIC_LOSTALG_ENABLE                    (336) /* int */
# define VodiCTL_VPW_DYNAMIC_TRAC_LIMIT                        (320) /* double */

# define VodiCTL_VPW_CALLBACK_UCTX                             (330) /* bo_pointer_t */
# define VodiCTL_VPW_DYNAMIC_RINIT_CALLBACK                    (331) /* vodi_rinit_fn */
# define VodiCTL_VPW_DYNAMIC_RFINI_CALLBACK                    (332) /* vodi_rfini_fn */
# define VodiCTL_VPW_DYNAMIC_COMPARE_CALLBACK                  (333) /* vodi_rcmp_fn */
# define VodiCTL_VPW_DYNAMIC_SUPERPOSITION_CALLBACK            (334) /* vodi_rpoza_fn */
# define VodiCTL_VPW_DYNAMIC_BESTFRAME_CALLBACK                (335) /* vodi_rpoza_fn */

/* DEPRECATED/UNSUPPORTED CONTROLS @{ */
# define VodiCTL_VPW_PRINCIPAL_ENABLE       (3) /* bool:int */
# define VodiCTL_VPW_RUNNING_TIME           (4) /* clock_t */

# define VodiCTL_VPW_PLATE_INVERSE_ANALYSE  (50) /* bool:int */
# define VodiCTL_VPW_PLATE_TEMPLATE         (60) /* vodi_vpw_country_id_t *, unsigned */

# define VodiCTL_VPW_IMAGE_WIDTH            (100) /* unsigned */
# define VodiCTL_VPW_IMAGE_HEIGHT           (101) /* unsigned */
# define VodiCTL_VPW_IMAGE_BRIGHTNES        (102) /* int */
# define VodiCTL_VPW_IMAGE_CONTRAST         (103) /* int */
# define VodiCTL_VPW_IMAGE_REVERSED         (107) /* bool:int */
# define VodiCTL_VPW_IMAGE_ANGLE            (112) /* unsigned */

# define VodiCTL_VPW_MD_ENABLE              (200) /* bool:int */
# define VodiCTL_VPW_MD_CELL_SIZE           (201) /* unsigned */
# define VodiCTL_VPW_MD_THRESHOLD           (202) /* unsigned */
# define VodiCTL_VPW_MD_SQUARE_MIN          (203) /* unsigned */
# define VodiCTL_VPW_MD_MASK                (204) /* float[], unsigned */
# define VodiCTL_VPW_MD_MASK_H_SIZE         (205) /* unsigned read only */
# define VodiCTL_VPW_MD_MASK_V_SIZE         (206) /* unsigned read only */

# define VodiCTL_VPW_DYNAMIC_BEFORE_LOST_TRACK_FACTOR   (316) /* double */
# define VodiCTL_VPW_DYNAMIC_BEFORE_LOST_TRACK_TIME_MAX (317) /* bo_usec_t */
# define VodiCTL_VPW_DYNAMIC_AFTER_LOST_FACTOR          (318) /* double */
# define VodiCTL_VPW_DYNAMIC_AFTER_LOST_TIME_MAX        (319) /* bo_usec_t */
/* @} */

/*
 * License type declaration (see also VpwprincOpen_v3)
 */

struct vpw_license
{
	char const *vlc_templates;
	int         vlc_threadc_max;
	int         vlc_fps_max;
	int         vlc_with_delay :1;  /* archived version */
};
typedef struct vpw_license vpw_license_t;

/*
 * [CREATE-] PARAM declarations
 */

struct vodi_vpw_princ_param {
	vodi_bool_t     enable;       /* deprecated/unsupported */
	unsigned int    thread_max;   /* 0 - default value */

	unsigned int    image_width;  /* deprecated/unsupported */
	unsigned int    image_height; /* deprecated/unsupported */

	int             image_brightnes; /* deprecated/unsupported */
	int             image_contrast;  /* deprecated/unsupported */
	int             image_blur;
	unsigned int    image_treshold;

	vodi_bool_t     image_reversed; /* deprecated/unsupported */

	int             image_angle;    /* deprecated/unsupported */
	vodi_rect_t     analysed_zone[VodiL_VPW_ANALYSE_ZONE_MAX];
	unsigned int    analysed_zone_count;

	unsigned int    plate_size_max;
	unsigned int    plate_size_min;
	vodi_bool_t     plate_inverse_analyse;
	unsigned int    plate_probability_min;
	unsigned int    plate_star_max;

	vodi_bool_t     md_enable;      /* deprecated/unsupported */
	unsigned int    md_cell_size;   /* deprecated/unsupported */
	unsigned int    md_threshold;   /* deprecated/unsupported */
	unsigned int    md_square_min;  /* deprecated/unsupported */
	float          *md_mask;        /* deprecated/unsupported */
	unsigned int    md_mask_h_size; /* deprecated/unsupported */
	unsigned int    md_mask_v_size; /* deprecated/unsupported */

	vodi_bool_t     dynamic_enable;
	unsigned int    log_settings;
};

/*
 * PLATE-INFO declarations
 */

struct vodi_plate_symbol {
	vodi_rect_t        ps_rect;
	u_int32_t          ps_code;
	float              ps_validity;
	float              ps_geom_deviation;
	vodi_color_t       ps_bcolor;
	vodi_color_t       ps_color;
};
typedef struct vodi_plate_symbol vodi_plate_symbol_t;

struct vodi_plate {
	wchar_t              pv_plate_string[VodiL_VPW_SYMBOL_MAX + 1];
	wchar_t              pv_plate_type[VodiL_VPW_SYMBOL_MAX + 5];
	/* deprecated; use .pv_tmpl_id instead of these @{ */
	u_int32_t            pv_plate_id;       /* old plate id */
	u_int32_t            pv_country_id;     /* == _VODI_PLATEID_CCODE(.pv_tmpl_id) */
	u_int32_t            pv_subdivision_id; /* == _VODI_PLATEID_SCODE(.pv_tmpl_id) */
	/* @} */
	float                pv_validity;
	float                pv_validity_coeff;
	/* deprecated @{ */
	float                pv_min_symb_validity;
	float                pv_max_geom_deviation;
	float                pv_max_symb_validity;
	float                pv_avg_symb_validity;
	/* @} */
	vodi_plateid_t       pv_tmpl_id; /* see also: <Vodi/lpvType.h>, <Vodi/services/Lpvlib.h> */
	vodi_color_t         pv_background;
	vodi_color_t         pv_sym_color;
	size_t               pv_symbolc;
	vodi_plate_symbol_t  pv_symbolv[VodiL_VPW_SYMBOL_MAX];
	vodi_rect_t          pv_exact_rect;
};
typedef struct vodi_plate vodi_plate_t;

/* user-space structure */
struct vodi_plate_info_spec {
	size_t			     pis_plate_variantc;
	vodi_plate_t         pis_plate_variantv[VodiL_VPW_VARIANT_MAX];

	vodi_rect_t          pis_outer_rect;
	vodi_rect_t          pis_exact_rect;
	vodi_quad64f_t       pis_exact_quad;

	vodi_bool_t          pis_inversed;
	vodi_motiondir_t     pis_direction;
	double               pis_angle;
	double               pis_speed;
	size_t               pis_index;
	unsigned             pis_flags;
	vodi_bool_t          pis_move_in;
	size_t               pis_status;

	vodi_ucontext_t      pis_uctx;
	vodi_image_t         pis_image;  /* canonical image of a plate */

	bo_utime_t           pis_bftime; /* best frame timestamp */
	bo_utime_t           pis_ctime;  /* create timestamp */
	bo_utime_t           pis_ltime;  /* lost timestamp */

	// @todo: redesign
	vodi_size_t          pis_imgsz;  /* original-image-size */
	u_int32_t            pis_seqnum; /* original image sequence mark */
	//
};

struct vodi_vpw_result_info {
	struct vodi_result_info_header  _h;
	struct vodi_plate_info_spec     _spec;
};

struct vodi_vpw_options {
	int                  magic;         /* = VodiK_VPW_OPTIONS_WORK_MAGIC */
	vodi_size_t          imgsz;         /* reserved; deprecated */

	u_int32_t            img_seqnum;    /* original image sequence mark */
	bo_utime_t           img_timestamp; /* original image timestamp */
};
typedef struct vodi_vpw_options vodi_vpw_options_t;

struct vodi_vpw_country_id {
	unsigned int code; /* iso3166-1 */
	unsigned int id;
	unsigned int sub_id;
};
typedef struct vodi_vpw_country_id vodi_vpw_country_id_t;

/******************************************************************************
 * Compatibility
 */


#endif /* !defined(__VODI_VPWTYPES__) */

/******************************************************************************
 *
 *
 *
 *****************************************************************************/
