/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright 2007 Seenaptec Ltd. All rights reserved.
 * SEENAPTEC PROPRIETARY/CONFIDENTIAL.
 *
 * $Id$
 */

/*
 * clrsType.h	(N.Panasiuk)
 * include/Vodi/clrsType.h
 */

/* ------------------------------------------------------------------------- */

#ifndef __VODI_CLRSTYPE__
# define __VODI_CLRSTYPE__

/******************************************************************************
 * %% BeginSection: includes
 */

# ifndef __BO_SYS_TYPES__
#  include <Bo/sys/Types.h>
# endif

/******************************************************************************
 * %% BeginSection: type/constant declarations
 */
# pragma mark -
# pragma mark [ type/constant declarations ]
# pragma mark -

# ifndef VODI_CLRS_TYPE_DEFINED
#  define VODI_CLRS_TYPE_DEFINED

typedef int vodi_color_t;
typedef int32_t vodi_color_x;

typedef int32_t vodi_clrs_t;
typedef int32_t vodi_clrs_x;

#  define VodiK_INVAL_COLOR ((vodi_color_t)-1)
#  define VodiK_NULL_COLOR (0)
#  define VodiK_UNK_COLOR (2)

#  define VodiK_INVAL_CLRS ((vodi_clrs_t)-1)
#  define VodiK_NULL_CLRS (0)
#  define VodiK_UNK_CLRS (2)

# endif /* !defined(VODI_CLRS_TYPE_DEFINED) */

/* for compatibility */
typedef vodi_clrs_t vodi_colorspace_t;

/*
 * Well-known COLOR constants
 * @{
 */

# define VodiK_WHITE_COLOR (3)
# define VodiK_BLACK_COLOR (4)
# define VodiK_RED_COLOR (5)
# define VodiK_GREEN_COLOR (6)
# define VodiK_BLUE_COLOR (7)
# define VodiK_YELLOW_COLOR (8)
# define VodiK_CYAN_COLOR (9)
# define VodiK_ORANGE_COLOR (10)

/* @} */

/*
 * Well-known COLOR SPACE constants
 * @{
 */

/* 1 byte per pixel */
# define VodiK_Y800_CLRS   __myc_mk4cc('Y','8','0','0')
# define VodiK_Y8_CLRS     VodiK_Y800_CLRS
# define VodiK_GRAY_CLRS   VodiK_Y800_CLRS

/* 2 byte per pixel, macro-pixel: (YU,YV) (YU,YV) ... */
# define VodiK_YUY2_CLRS   __myc_mk4cc('Y','U','Y','2')
/* 2 byte per pixel, macro-pixel: (UY,VY) (UY,VY) ... */
# define VodiK_UYVY_CLRS   __myc_mk4cc('U','Y','V','Y')

# define VodiK_RGB24_CLRS  __myc_mk4cc('R','G','B','o')
# define VodiK_BGR24_CLRS  __myc_mk4cc('B','G','R','o')

# define VodiK_RGB32_CLRS  __myc_mk4cc('R','G','B','w')
# define VodiK_BGR32_CLRS  __myc_mk4cc('B','G','R','w')

# define VodiK_XRGB_CLRS   __myc_mk4cc('X','R','G','B')
# define VodiK_RGBX_CLRS   __myc_mk4cc('R','G','B','X')

# define VodiK_ARGB_CLRS   __myc_mk4cc('A','R','G','B')
# define VodiK_RGBA_CLRS   __myc_mk4cc('R','G','B','A')

# define VodiK_XBGR_CLRS   __myc_mk4cc('X','B','G','R')
# define VodiK_BGRX_CLRS   __myc_mk4cc('B','G','R','X')

# define VodiK_ABGR_CLRS   __myc_mk4cc('A','B','G','R')
# define VodiK_BGRA_CLRS   __myc_mk4cc('B','G','R','A')

/* @} */

#endif /* !defined(__VODI_CLRSTYPE__) */

/******************************************************************************
 *
 *
 *
 *****************************************************************************/
