/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright 2007 Seenaptec Ltd. All rights reserved.
 * SEENAPTEC PROPRIETARY/CONFIDENTIAL.
 *
 * $Id$
 */

/*
 * Vpwprinc.h	(N.Panasiuk)
 * include/Vodi/objects/Vpwprinc.h
 */

/* ------------------------------------------------------------------------- */

#ifndef __VODI_OBJECTS_VPWPRINC__
# define __VODI_OBJECTS_VPWPRINC__

/******************************************************************************
 * %% BeginSection: includes
 */

# include <Bo/sys/Types.h>

/******************************************************************************
 * %% BeginSection: type/constant declarations
 */
# pragma mark -
# pragma mark [ type/constant declarations ]
# pragma mark -

/*
 * Vpwprinc
 * oid: <<category>>/<<object>>/<<impl>>
 *
 * constructor, descriptor, ucntl, vodiprinc
 */
/*
# define AorpK_Vpwprinc_object (1501)
# define AorpK_Vpwprinc_object_creatable 1
*/
# include <Vodi/services/MIB/Objects.h>

/******************************************************************************
* %% BeginSection: type declarations
*/
# pragma mark -
# pragma mark [ type declarations ]
# pragma mark -

_A_xobject(Vpwprinc);

# include <Bo/services/alg/_Xucntl.h>
# include <Vodi/services/alg/_Vpwprinc.h>

/******************************************************************************
* %% BeginSection: function prototypes
*/
# pragma mark -
# pragma mark [ function prototypes ]
# pragma mark -

# include <Vodi/VodiLinkage.h>

__MYC_BEGIN_CDECLS

/*
 * Canonical prototype
 */

 __myc_flinkage__(public, libVodi) aorp_object_t
VpwprincOpen_c(
	aorp_opflags_t Flags,
	bo_pointer_t aMemory,
	aorp_podinit_t aParmv[],
	size_t aParmc,
	struct aorp_error *anErrPtr __myc_defval__(NULL)
	);

__myc_flinkage__(public, libVodi) aorp_object_t
VpwprincOpen(
	aorp_opflags_t Flags __myc_defval__(0),
	bo_pointer_t aMemory __myc_defval__(NULL),
	struct vodi_vpw_princ_param const *aParm __myc_defval__(NULL),
	struct aorp_error *anErrPtr __myc_defval__(NULL)
	);

__myc_flinkage__(public, libVodi) aorp_object_t
VpwprincOpen_v2(
	aorp_opflags_t Flags __myc_defval__(0),
	bo_pointer_t aMemory __myc_defval__(NULL),
	unsigned aThreadcMax __myc_defval__(0),
	unsigned aFPSmax __myc_defval__(0),
	struct vodi_vpw_princ_param const *aParm __myc_defval__(NULL),
	struct aorp_error *anErrPtr __myc_defval__(NULL)
	);

__myc_flinkage__(public, libVodi) aorp_object_t
VpwprincOpen_v3(
	aorp_opflags_t Flags __myc_defval__(0),
	bo_pointer_t aMemory __myc_defval__(NULL),
	unsigned aThreadcMax __myc_defval__(0),
	vodi_bool_t (*aLicensePred)(vpw_license_t const *) __myc_defval__(NULLF),
	vpw_license_t const *(*aSelectLicenseOp)(
		vpw_license_t const *, vpw_license_t const *) __myc_defval__(NULLF),
	struct vodi_vpw_princ_param const *aParm __myc_defval__(NULL),
	struct aorp_error *anErrPtr __myc_defval__(NULL)
	);

/*
 * Std license predicates and operations
 */

/* Selects licenses without delay feature */
__myc_flinkage__(public, libVodi) vodi_bool_t
__attribute__((nonnull(1)))
VpwLicenseNormal(vpw_license_t const *);

/* Selects licenses with delay (archived) feature */
__myc_flinkage__(public, libVodi) vodi_bool_t
__attribute__((nonnull(1)))
VpwLicenseWithDelay(vpw_license_t const *);

/* It selects license with max fps feature */
__myc_flinkage__(public, libVodi) vpw_license_t const *
__attribute__((nonnull(1,2)))
VpwLicenseWithMaxFPS(vpw_license_t const *, vpw_license_t const *);

__MYC_END_CDECLS

#endif /* !__VODI_OBJECTS_VPWPRINC__ */

/*
 *
 */
