/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright 2007 Seenaptec Ltd. All rights reserved.
 * SEENAPTEC PROPRIETARY/CONFIDENTIAL.
 *
 * $Id$
 */

/*
 * ZLCb.h	(N.Panasiuk)
 * include/Vodi/objects/ZLCb.h
 */

/* ------------------------------------------------------------------------- */

#ifndef __VODI_OBJECTS_ZLCB__
# define __VODI_OBJECTS_ZLCB__

/******************************************************************************
 * %% BeginSection: includes
 */

# include <Vodi/objects/ZLNil.h>

/******************************************************************************
* %% BeginSection: type/constant declarations
*/
# pragma mark -
# pragma mark [ type/constant declarations ]
# pragma mark -

/*
 * ZLCb
 * oid: <<category>>/<<object>>/<<impl>>
 *
 * constructor, descriptor, ucntl, zlist
 */
/*
# define AorpK_ZLCb_object (1507)
# define AorpK_ZLCb_object_creatable 1
*/
# include <Vodi/services/MIB/Objects.h>

/******************************************************************************
* %% BeginSection: type declarations
*/
# pragma mark -
# pragma mark [ type declarations ]
# pragma mark -

_A_xobject(ZLCb);

# include <Vodi/services/alg/_ZLCb.h>

/******************************************************************************
* %% BeginSection: function prototypes
*/
# pragma mark -
# pragma mark [ function prototypes ]
# pragma mark -

/*
 * Canonical prototype
 *
aorp_object_t
ZLCbOpen_c(
	aorp_opflags_t Flags,       // 0
	bo_pointer_t aMemory,       // NULL
	struct aorp_podinit *aParmv[],
	size_t aParmc,
	struct aorp_error *anErrPtr // NULL
);
 */
# define ZLCbOpen_c(Flags, aMemory, aParmv, aParmc, anErrPtr) \
	_A_open1(ZLCb, Flags, aMemory, aParmv, (size_t)(aParmc), anErrPtr)

/* ------------------------------------------------------------------------- */

/*
void
ZLCbOpen(
	aorp_object_t &aResultRef,
	aorp_opflags_t Flags,       // 0
	bo_pointer_t aMemory,       // NULL
	struct zlcb *aCallback,
	struct aorp_error *anErrPtr // NULL
	);
 *
 * NOTE! The parameter @callback is not retained.
 */
# define ZLCbOpen(aResultRef, Flags, aMemory, aCallback, anErrPtr) \
	_A_openbyname_v1( \
		aResultRef, (ZLCb), Flags, aMemory, \
		(2,(zlist,ZLCb), aCallback), \
		anErrPtr \
	)

/* ------------------------------------------------------------------------- */

/*
 * NOTE! The parameter is not retained.
 */
# if __myc_support(macro_retval)
#  define ZLCb(aCallback) \
	__extension__ ({ \
		aorp_object_t ___retval; \
		ZLCbOpen(___retval, 0, NULL, zlcb_p(aCallback), NULL); \
		/* return */ (___retval); \
	})
# else
__myc_extern_inline__ aorp_object_t ZLCb(bo_pointer_t aCallback)
{
	aorp_object_t retval;
	ZLCbOpen(retval, 0, NULL, zlcb_p(aCallback), NULL);
	return (retval);
}
# endif

/* ------------------------------------------------------------------------- */

# if __myc_support(macro_retval)
#  define ZLCbnil(aCallback) \
	__extension__ ({ \
		ZLCB_Free(aCallback); \
		/* return */ ZLNil(); \
	})
# else
__myc_extern_inline__ aorp_object_t ZLCbnil(bo_pointer_t aCallback)
{
	ZLCB_Free(aCallback);
	return ZLNil();
}
# endif

#endif /* !__VODI_OBJECTS_ZLCB__ */

/*
 *
 */
