/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright 2007 Seenaptec Ltd. All rights reserved.
 * SEENAPTEC PROPRIETARY/CONFIDENTIAL.
 *
 * $Id$
 */

/*
 * ZLCons.h	(N.Panasiuk)
 * include/Vodi/objects/ZLCons.h
 */

/* ------------------------------------------------------------------------- */

#ifndef __VODI_OBJECTS_ZLCONS__
# define __VODI_OBJECTS_ZLCONS__

/******************************************************************************
 * %% BeginSection: includes
 */

# include <Bo/sys/Types.h>

/******************************************************************************
* %% BeginSection: type/constant declarations
*/
# pragma mark -
# pragma mark [ type/constant declarations ]
# pragma mark -

/*
 * ZLCons
 * oid: <<category>>/<<object>>/<<impl>>
 *
 * constructor, descriptor, ucntl, zlist
 */
/*
# define AorpK_ZLCons_object (1506)
# define AorpK_ZLCons_object_creatable 1
*/
# include <Vodi/services/MIB/Objects.h>

/******************************************************************************
* %% BeginSection: type declarations
*/
# pragma mark -
# pragma mark [ type declarations ]
# pragma mark -

_A_xobject(ZLCons);

# include <Vodi/services/alg/_ZLCons.h>

/******************************************************************************
* %% BeginSection: function prototypes
*/
# pragma mark -
# pragma mark [ function prototypes ]
# pragma mark -

/*
 * Canonical prototype
 *
aorp_object_t
ZLConsOpen_c(
	aorp_opflags_t Flags,       // 0
	bo_pointer_t aMemory,       // NULL
	struct aorp_podinit *aParmv[],
	size_t aParmc,
	struct aorp_error *anErrPtr // NULL
);
 */
# define ZLConsOpen_c(Flags, aMemory, aParmv, aParmc, anErrPtr) \
	_A_open1(ZLCons, Flags, aMemory, aParmv, (size_t)(aParmc), anErrPtr)

/* ------------------------------------------------------------------------- */

/*
void
ZLConsOpen(
	aorp_object_t &aResultRef,
	aorp_opflags_t Flags,       // 0
	bo_pointer_t aMemory,       // NULL
	aorp_object_t anElem,
	aorp_object_t aList,
	struct aorp_error *anErrPtr // NULL
	);
 *
 * NOTE!
 * The object pointed to by the parameter @elem is not retained.
 * The object pointed to by the parameter @list is not retained.
 */
# define ZLConsOpen(aResultRef, Flags, aMemory, anElem, aList, anErrPtr) \
	_A_openbyname_v1( \
		aResultRef, (ZLCons), Flags, aMemory, \
		(2,(zlist,ZLCons), anElem, aList), \
		anErrPtr \
	)

/* ------------------------------------------------------------------------- */

/*
 * ZLCons :: a -> [a] -> [a]
 *
 * NOTE! Function will become the owner of its arguments.
 */
# if __myc_support(macro_retval)
#  define ZLCons(x, xs) \
	__extension__ ({ \
		aorp_object_t ___retval; \
		ZLConsOpen(___retval, 0, NULL, x, xs, NULL); \
		/* return */ (___retval); \
	})
# else
__myc_extern_inline__ aorp_object_t ZLCons(aorp_object_t x, aorp_object_t xs)
{
	aorp_object_t retval;
	ZLConsOpen(retval, 0, NULL, x, xs, NULL);
	return (retval);
}
# endif

/* ------------------------------------------------------------------------- */

# include <Vodi/VodiLinkage.h>

__MYC_BEGIN_CDECLS

__myc_flinkage__(public,libVodi) aorp_object_t
ZLFin(
# if __myc_require(prototypes)
	size_t anElemc,
	...
# endif
	);

__myc_flinkage__(public,libVodi) aorp_object_t
__attribute__((nonnull(1)))
ZLNFin(
# if __myc_require(prototypes)
	aorp_object_t anElems[],
	size_t anElemc
# endif
	);

# define ZLSingleton(x) ZLFin(1, x)

__MYC_END_CDECLS

#endif /* !__VODI_OBJECTS_ZLCONS__ */

/*
 *
 */
