/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright 2007 Seenaptec Ltd. All rights reserved.
 * SEENAPTEC PROPRIETARY/CONFIDENTIAL.
 *
 * $Id$
 */

/*
 * ZLGuard.h	(N.Panasiuk)
 * include/Vodi/objects/ZLGuard.h
 */

/* ------------------------------------------------------------------------- */

#ifndef __VODI_OBJECTS_ZLGUARD__
# define __VODI_OBJECTS_ZLGUARD__

/******************************************************************************
 * %% BeginSection: includes
 */

# include <Bo/sys/Types.h>

/******************************************************************************
* %% BeginSection: type/constant declarations
*/
# pragma mark -
# pragma mark [ type/constant declarations ]
# pragma mark -

/*
 * ZLGuard
 * oid: <<category>>/<<object>>/<<impl>>
 *
 * constructor, descriptor, ucntl, zlist
 */
/*
# define AorpK_ZLGuard_object (1508)
# define AorpK_ZLGuard_object_creatable 1
*/
# include <Vodi/services/MIB/Objects.h>

/******************************************************************************
* %% BeginSection: type declarations
*/
# pragma mark -
# pragma mark [ type declarations ]
# pragma mark -

_A_xobject(ZLGuard);

# include <Vodi/services/alg/_ZLGuard.h>

/******************************************************************************
* %% BeginSection: function prototypes
*/
# pragma mark -
# pragma mark [ function prototypes ]
# pragma mark -

/*
 * Canonical prototype
 *
aorp_object_t
ZLGuardOpen_c(
	aorp_opflags_t Flags,       // 0
	bo_pointer_t aMemory,       // NULL
	struct aorp_podinit *aParmv[],
	size_t aParmc,
	struct aorp_error *anErrPtr // NULL
);
 */
# define ZLGuardOpen_c(Flags, aMemory, aParmv, aParmc, anErrPtr) \
	_A_open1(ZLGuard, Flags, aMemory, aParmv, (size_t)(aParmc), anErrPtr)

/* ------------------------------------------------------------------------- */

/*
void
ZLGuardOpen(
	aorp_object_t &aResultRef,
	aorp_opflags_t Flags,       // 0
	bo_pointer_t aMemory,       // NULL
	bo_smutex_t *aMutex,        // NULL
	aorp_object_t aList,
	struct aorp_error *anErrPtr // NULL
	);
 *
 * NOTE! The parameter @list is not retained.
 */
# define ZLGuardOpen(aResultRef, Flags, aMemory, aMutex, aList, anErrPtr) \
	_A_openbyname_v1( \
		aResultRef, (ZLGuard), Flags, aMemory, \
		(2,(zlist,ZLGuard), aMutex, aList), \
		anErrPtr \
	)

/* ------------------------------------------------------------------------- */

/*
 * NOTE! The parameter @list is not retained.
 */
# if __myc_support(macro_retval)
#  define ZLGuard(aList) \
	__extension__ ({ \
		aorp_object_t ___retval; \
		ZLGuardOpen(___retval, 0, NULL, NULL, aList, NULL); \
		/* return */ (___retval); \
	})
# else
__myc_extern_inline__ aorp_object_t ZLGuard(aorp_object_t aList)
{
	aorp_object_t retval;
	ZLGuardOpen(retval, 0, NULL, NULL, aList, NULL);
	return (retval);
}
# endif

#endif /* !__VODI_OBJECTS_ZLGUARD__ */

/*
 *
 */
