/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright 2007 Seenaptec Ltd. All rights reserved.
 * SEENAPTEC PROPRIETARY/CONFIDENTIAL.
 *
 * $Id$
 */

/*
 * Lpvlib.h	(N.Panasiuk)
 * include/Devel/Vodi/services/Lpvlib.h
 */

/* ------------------------------------------------------------------------- */

#ifndef __VODI_SERVICES_LPVLIB__
# define __VODI_SERVICES_LPVLIB__

/******************************************************************************
 * %% BeginSection: includes
 */

# include <Vodi/services/LpvlibP.h>

/******************************************************************************
 * %% BeginSection: function prototypes
 */
# pragma mark -
# pragma mark [ function prototypes ]
# pragma mark -

# include <Vodi/VodiLinkage.h>

__MYC_BEGIN_CDECLS

__myc_vlinkage__(public,libVodi) aorp_object_t _G_lpvlib_service_default;

/* ------------------------------------------------------------------------- */
# pragma mark -
/* ------------------------------------------------------------------------- */

__myc_flinkage__(public,libVodi) aorp_object_t
LpviOpen(
# if __myc_require(prototypes)
	aorp_object_t aSelf /* = NULL */,
	vodi_plateid_t aPlateId,
	struct aorp_error *anErrPtr __myc_defval__(NULL)
# endif
	);

/* ------------------------------------------------------------------------- */
# pragma mark -
/* ------------------------------------------------------------------------- */

__myc_flinkage__(public,libVodi) bo_seqlist_(char *) *
__attribute__((nonnull(2)))
LpvlibModulesOf(
# if __myc_require(prototypes)
	aorp_object_t aSelf /* = NULL */,
	bo_seqlist_(char *) *aResultPtr,
	char const *aSet /* = NULL */,
	struct aorp_error *anErrPtr __myc_defval__(NULL)
# endif
	);

__myc_flinkage__(public,libVodi) void
__attribute__((nonnull(1)))
LpvlibStrlstDestroy(
# if __myc_require(prototypes)
	bo_seqlist_(char *) *
# endif
	);

/* ------------------------------------------------------------------------- */
# pragma mark -
/* ------------------------------------------------------------------------- */

__myc_flinkage__(public,libVodi) bo_status_t
__attribute__((nonnull(3)))
LpvlibForeach(
# if __myc_require(prototypes)
	aorp_object_t aSelf /* = NULL */,
	char const *aSet /* = NULL */,
	struct aorp_foreach_pred *aPred,
	struct aorp_error *anErrPtr __myc_defval__(NULL)
# endif
	);

/* ------------------------------------------------------------------------- */
# pragma mark -
/* ------------------------------------------------------------------------- */

__myc_flinkage__(public,libVodi) char **
__attribute__((nonnull(2)))
LpvlibPrint(
# if __myc_require(prototypes)
	aorp_object_t aSelf /* = NULL */,
	char **aResultPtr,
	aorp_object_t aLpviv[] __myc_defval__(NULL),
	size_t aLpvic __myc_defval__(0),
	aorp_opflags_t Flags __myc_defval__(0),
	struct aorp_error *anErrPtr __myc_defval__(NULL)
# endif
	);

/* ------------------------------------------------------------------------- */
# pragma mark -
/* ------------------------------------------------------------------------- */

__myc_flinkage__(public,libVodi) char **
__attribute__((nonnull(2)))
LpvlibCanonize(
# if __myc_require(prototypes)
	aorp_object_t aSelf /* = NULL */,
	char **aResultPtr,
	char const *aSet /* = NULL */,
	aorp_opflags_t Flags __myc_defval__(0),
	struct aorp_error *anErrPtr __myc_defval__(NULL)
# endif
	);

/* ------------------------------------------------------------------------- */
# pragma mark -
/* ------------------------------------------------------------------------- */

__myc_flinkage__(public,libVodi) bo_stsbool_t
LpvlibIselemof(
# if __myc_require(prototypes)
	aorp_object_t aSelf /* = NULL */,
	vodi_plateid_t aPlateId,
	char const *aSet /* = NULL */,
	struct aorp_error *anErrPtr __myc_defval__(NULL)
# endif
	);

/* ------------------------------------------------------------------------- */
# pragma mark -
/* ------------------------------------------------------------------------- */

__myc_flinkage__(public,libVodi) bo_stsbool_t
LpvlibIsnull(
# if __myc_require(prototypes)
	aorp_object_t aSelf /* = NULL */,
	char const *aSet /* = NULL */,
	struct aorp_error *anErrPtr __myc_defval__(NULL)
# endif
	);

__myc_flinkage__(public,libVodi) bo_stsbool_t
LpvlibIsuniverse(
# if __myc_require(prototypes)
	aorp_object_t aSelf /* = NULL */,
	char const *aSet /* = NULL */,
	struct aorp_error *anErrPtr __myc_defval__(NULL)
# endif
	);

/* ------------------------------------------------------------------------- */
# pragma mark -
/* ------------------------------------------------------------------------- */

__myc_flinkage__(public,libVodi) bo_stsbool_t
LpvlibEq(
# if __myc_require(prototypes)
	aorp_object_t aSelf /* = NULL */,
	char const *aLhs /* = NULL */,
	char const *aRhs /* = NULL */,
	struct aorp_error *anErrPtr __myc_defval__(NULL)
# endif
	);

__myc_flinkage__(public,libVodi) bo_stsbool_t
LpvlibProsubset(
# if __myc_require(prototypes)
	aorp_object_t aSelf /* = NULL */,
	char const *aLhs /* = NULL */,
	char const *aRhs /* = NULL */,
	struct aorp_error *anErrPtr __myc_defval__(NULL)
# endif
	);

__myc_flinkage__(public,libVodi) bo_stsbool_t
LpvlibSubset(
# if __myc_require(prototypes)
	aorp_object_t aSelf /* = NULL */,
	char const *aLhs /* = NULL */,
	char const *aRhs /* = NULL */,
	struct aorp_error *anErrPtr __myc_defval__(NULL)
# endif
	);

__myc_flinkage__(public,libVodi) bo_stsbool_t
LpvlibProsuperset(
# if __myc_require(prototypes)
	aorp_object_t aSelf /* = NULL */,
	char const *aLhs /* = NULL */,
	char const *aRhs /* = NULL */,
	struct aorp_error *anErrPtr __myc_defval__(NULL)
# endif
	);

__myc_flinkage__(public,libVodi) bo_stsbool_t
LpvlibSuperset(
# if __myc_require(prototypes)
	aorp_object_t aSelf /* = NULL */,
	char const *aLhs /* = NULL */,
	char const *aRhs /* = NULL */,
	struct aorp_error *anErrPtr __myc_defval__(NULL)
# endif
	);

/* ------------------------------------------------------------------------- */
# pragma mark -
/* ------------------------------------------------------------------------- */

__myc_flinkage__(public,libVodi) char **
__attribute__((nonnull(2)))
LpvlibUnion(
# if __myc_require(prototypes)
	aorp_object_t aSelf /* = NULL */,
	char **aResultPtr,
	char const *aLhs /* = NULL */,
	char const *aRhs /* = NULL */,
	aorp_opflags_t Flags __myc_defval__(0),
	struct aorp_error *anErrPtr __myc_defval__(NULL)
# endif
	);

__myc_flinkage__(public,libVodi) char **
__attribute__((nonnull(2)))
LpvlibMinus(
# if __myc_require(prototypes)
	aorp_object_t aSelf /* = NULL */,
	char **aResultPtr,
	char const *aLhs /* = NULL */,
	char const *aRhs /* = NULL */,
	aorp_opflags_t Flags __myc_defval__(0),
	struct aorp_error *anErrPtr __myc_defval__(NULL)
# endif
	);

__myc_flinkage__(public,libVodi) char **
__attribute__((nonnull(2)))
LpvlibIntersec(
# if __myc_require(prototypes)
	aorp_object_t aSelf /* = NULL */,
	char **aResultPtr,
	char const *aLhs /* = NULL */,
	char const *aRhs /* = NULL */,
	aorp_opflags_t Flags __myc_defval__(0),
	struct aorp_error *anErrPtr __myc_defval__(NULL)
# endif
	);

__myc_flinkage__(public,libVodi) char **
__attribute__((nonnull(2)))
LpvlibComplement(
# if __myc_require(prototypes)
	aorp_object_t aSelf /* = NULL */,
	char **aResultPtr,
	char const *aSet /* = NULL */,
	aorp_opflags_t Flags __myc_defval__(0),
	struct aorp_error *anErrPtr __myc_defval__(NULL)
# endif
	);

/* ------------------------------------------------------------------------- */
# pragma mark -
/* ------------------------------------------------------------------------- */

__myc_flinkage__(public,libVodi) char *
__attribute__((nonnull(1)))
LpvlibShowPlateid(
# if __myc_require(prototypes)
	char aResultPtr[/* LpvlibK_PLATEID_CHAR_MAX */],
	vodi_plateid_t aPlateid,
	aorp_opflags_t Flags __myc_defval__(0)
# endif
	);

__myc_flinkage__(public,libVodi) vodi_plateid_t
__attribute__((nonnull(1)))
LpvlibReadPlateid(
# if __myc_require(prototypes)
	char const *aSrc,
	struct aorp_error *anErrPtr __myc_defval__(NULL)
# endif
	);

__MYC_END_CDECLS

#endif /* !defined(__VODI_SERVICES_LPVLIB__) */

/******************************************************************************
 *
 *
 *
 *****************************************************************************/
