/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright 2007 Seenaptec Ltd. All rights reserved.
 * SEENAPTEC PROPRIETARY/CONFIDENTIAL.
 *
 * $Id$
 */

/*
 * LpvlibP.h	(N.Panasiuk)
 * include/Devel/Vodi/services/LpvlibP.h
 */

/* ------------------------------------------------------------------------- */

#ifndef __VODI_SERVICES_LPVLIB_P__
# define __VODI_SERVICES_LPVLIB_P__

/******************************************************************************
 * %% BeginSection: includes
 */

# include <Vodi/Types.h>

# include <Vodi/lpvType.h>

/******************************************************************************
 * %% BeginSection: lpvlib service declarations
 */
# pragma mark -
# pragma mark [ lpvlib service declarations ]
# pragma mark -

# define __aorpc_need_service_lpvlib 1

#endif /* !defined(__VODI_SERVICES_LPVLIB_P__) */

#pragma mark -

#if __aorpc_uses_service(lpvlib)
# undef __aorpc_need_service_lpvlib

/*
 * lpvlib service
 * @{
 */

/*
 * lpvlib {\object(class)}
 */
/*
# define AorpK_lpvlib_service (1505)
 */
# include <Vodi/services/MIB/Services.h>

# define __aorpc_service_name lpvlib
# include <Bo/aorp/AorpCsrvc.h>

_A_service(lpvlib)

# if __aorpc_interface

#  define LpvlibF_HUMAN_READABLE (0x01)

#  define LpvlibK_PLATEID_CHAR_MAX (24)

# endif /* __aorpc_interface */

_A_end_ctb

	_A_attribute((nonnull(1)))
	_A_op(open, "lpvi:open", (
			struct aorp_closure *aClosure,
			struct aorp_error *anErrPtr,
			vodi_plateid_t aPlateId
		)),

	_A_attribute((nonnull(1,3)))
	_A_op(modulesof, "lpvlib:modulesof", (
			struct aorp_closure *aClosure,
			struct aorp_error *anErrPtr,
			bo_seqlist_(char *) *aResultPtr,
			char const *aSet
		)),

	_A_attribute((nonnull(1,4)))
	_A_op(foreach, "lpvlib:foreach", (
			struct aorp_closure *aClosure,
			struct aorp_error *anErrPtr,
			char const *aSet,
			struct aorp_foreach_pred *aPred
		)),

	_A_attribute((nonnull(1)))
	_A_op(xlatid, "lpvlib:translate-type-id", (
			struct aorp_closure *aClosure,
			struct aorp_error *anErrPtr,
			int aTypeId
		)),

	_A_attribute((nonnull(1,3)))
	_A_op(print, "lpvlib:print", (
			struct aorp_closure *aClosure,
			struct aorp_error *anErrPtr,
			char **aResultPtr,
			aorp_object_t aLpviv[],
			size_t aLpvic,
			aorp_opflags_t Flags
		)),

	_A_attribute((nonnull(1,3)))
	_A_op(canonize, "lpvlib:canonize", (
			struct aorp_closure *aClosure,
			struct aorp_error *anErrPtr,
			char **aResultPtr,
			char const *aSet,
			aorp_opflags_t Flags
		)),

	_A_attribute((nonnull(1)))
	_A_op(iselemof, "lpvlib:iselemof", (
			struct aorp_closure *aClosure,
			struct aorp_error *anErrPtr,
			vodi_plateid_t aPlateId,
			char const *aSet
		)),

	_A_attribute((nonnull(1)))
	_A_op(isnull, "lpvlib:isnull", (
			struct aorp_closure *aClosure,
			struct aorp_error *anErrPtr,
			char const *aSet
		)),

	_A_attribute((nonnull(1)))
	_A_op(isuniverse, "lpvlib:isuniverse", (
			struct aorp_closure *aClosure,
			struct aorp_error *anErrPtr,
			char const *aSet
		)),

	_A_attribute((nonnull(1)))
	_A_op(eq, "lpvlib:eq", (
			struct aorp_closure *aClosure,
			struct aorp_error *anErrPtr,
			char const *aLhs,
			char const *aRhs
		)),

	_A_attribute((nonnull(1)))
	_A_op(prosubset, "lpvlib:prosubset", (
			struct aorp_closure *aClosure,
			struct aorp_error *anErrPtr,
			char const *aLhs,
			char const *aRhs
		)),

	_A_attribute((nonnull(1)))
	_A_op(subset, "lpvlib:subset", (
			struct aorp_closure *aClosure,
			struct aorp_error *anErrPtr,
			char const *aLhs,
			char const *aRhs
		)),

	_A_attribute((nonnull(1)))
	_A_op(prosuperset, "lpvlib:prosuperset", (
			struct aorp_closure *aClosure,
			struct aorp_error *anErrPtr,
			char const *aLhs,
			char const *aRhs
		)),

	_A_attribute((nonnull(1)))
	_A_op(superset, "lpvlib:superset", (
			struct aorp_closure *aClosure,
			struct aorp_error *anErrPtr,
			char const *aLhs,
			char const *aRhs
		)),

	_A_attribute((nonnull(1,3)))
	_A_op(union, "lpvlib:union", (
			struct aorp_closure *aClosure,
			struct aorp_error *anErrPtr,
			char **aResultPtr,
			char const *aLhs,
			char const *aRhs,
			aorp_opflags_t Flags
		)),

	_A_attribute((nonnull(1,3)))
	_A_op(minus, "lpvlib:minus", (
			struct aorp_closure *aClosure,
			struct aorp_error *anErrPtr,
			char **aResultPtr,
			char const *aLhs,
			char const *aRhs,
			aorp_opflags_t Flags
		)),

	_A_attribute((nonnull(1,3)))
	_A_op(intersec, "lpvlib:intersec", (
			struct aorp_closure *aClosure,
			struct aorp_error *anErrPtr,
			char **aResultPtr,
			char const *aLhs,
			char const *aRhs,
			aorp_opflags_t Flags
		)),

	_A_attribute((nonnull(1,3)))
	_A_op(complement, "lpvlib:complement", (
			struct aorp_closure *aClosure,
			struct aorp_error *anErrPtr,
			char **aResultPtr,
			char const *aSet,
			aorp_opflags_t Flags
		)),

_A_end;

# include <Bo/aorp/AorpCend.h>
/* @} */
#endif /* __aorpc_uses_service(lpvlib) */

/******************************************************************************
 *
 *
 *
 *****************************************************************************/
