/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright 2007 Seenaptec Ltd. All rights reserved.
 * SEENAPTEC PROPRIETARY/CONFIDENTIAL.
 *
 * $Id$
 */

/*
 * Opdom.h	(N.Panasiuk)
 * include/Vodi/services/MIB/Opdom.h
 */

/* ------------------------------------------------------------------------- */

#ifndef __VODI_SERVICES_MIB_OPDOM__
# define __VODI_SERVICES_MIB_OPDOM__

/******************************************************************************
 * %% BeginSection: constant declarations
 */

/*
 * Operation Domain (MIB)
 */
# include <Bo/services/MIB/Opdom.h>

/*
 * Range: [1500 - 1600[
 */

/*
 * Vpwprinc
 *
 * vodiprinc
 * oid: <<category>>/<<service>>/<<domain>>/<<impl>>
 */
# define AorpK_Vpwprinc_opdom (1501)
# define AorpK_Vpwprinc_opdom_empty 0

/*
 * Vpwens
 *
 * vodiens
 * oid: <<category>>/<<service>>/<<domain>>/<<impl>>
 */
# define AorpK_Vpwens_opdom (1502)
# define AorpK_Vpwens_opdom_empty 0

/*
 * Vpwres
 *
 * vodires
 * oid: <<category>>/<<service>>/<<domain>>/<<impl>>
 */
# define AorpK_Vpwres_opdom (1503)
# define AorpK_Vpwres_opdom_empty 0

/*
 * Vpwi
 *
 * lpvi
 * oid: <<category>>/<<service>>/<<domain>>/<<impl>>
 */
# define AorpK_Vpwi_opdom (1504)
# define AorpK_Vpwi_opdom_empty 0

/*
 * Cvpwprinc
 *
 * vodiprinc
 * oid: <<category>>/<<service>>/<<domain>>/<<impl>>
 */
# define AorpK_Cvpwprinc_opdom (1505)
# define AorpK_Cvpwprinc_opdom_empty 0

/*
 * Vpwlib
 *
 * lpvlib
 * oid: <<category>>/<<service>>/<<domain>>/<<impl>>
 */
# define AorpK_Vpwlib_opdom (1506)
# define AorpK_Vpwlib_opdom_empty 1

/*
 * ZLNil
 *
 * zlist
 * oid: <<category>>/<<service>>/<<domain>>/<<impl>>
 */
# define AorpK_ZLNil_opdom (1510)
# define AorpK_ZLNil_opdom_empty 1

/*
 * Vipm
 *
 * vipm
 * oid: <<category>>/<<service>>/<<domain>>/<<impl>>
 */
# define AorpK_Vipm_opdom (1511)
# define AorpK_Vipm_opdom_empty 1

/*
 * ZLCons
 *
 * zlist
 * oid: <<category>>/<<service>>/<<domain>>/<<impl>>
 */
# define AorpK_ZLCons_opdom (1513)
# define AorpK_ZLCons_opdom_empty 0

/*
 * ZLCb
 *
 * zlist
 * oid: <<category>>/<<service>>/<<domain>>/<<impl>>
 */
# define AorpK_ZLCb_opdom (1514)
# define AorpK_ZLCb_opdom_empty 0

/*
 * ZLGuard
 *
 * zlist
 * oid: <<category>>/<<service>>/<<domain>>/<<impl>>
 */
# define AorpK_ZLGuard_opdom (1515)
# define AorpK_ZLGuard_opdom_empty 0

/*
 * Tlw
 *
 * voditl
 * oid: <<category>>/<<service>>/<<domain>>/<<impl>>
 */
# define AorpK_Tlw_opdom (1516)
# define AorpK_Tlw_opdom_empty 1

/*
 * Tlwcunlim
 *
 * vodilim
 * oid: <<category>>/<<service>>/<<domain>>/<<impl>>
 */
# define AorpK_Tlwcunlim_opdom (1517)
# define AorpK_Tlwcunlim_opdom_empty 1

/*
 * Tlwchasp
 *
 * vodilim
 * oid: <<category>>/<<service>>/<<domain>>/<<impl>>
 */
# define AorpK_Tlwchasp_opdom (1518)
# define AorpK_Tlwchasp_opdom_empty 1

/*
 * Vpwprincopen
 *
 * vodiprincopen
 * oid: <<category>>/<<service>>/<<domain>>/<<impl>>
 */
# define AorpK_Vpwprincopen_opdom (1519)
# define AorpK_Vpwprincopen_opdom_empty 1

/*
 * Vpwcunlim
 *
 * vodilim
 * oid: <<category>>/<<service>>/<<domain>>/<<impl>>
 */
# define AorpK_Vpwcunlim_opdom (1520)
# define AorpK_Vpwcunlim_opdom_empty 1

/*
 * Vpwchasp
 *
 * vodilim
 * oid: <<category>>/<<service>>/<<domain>>/<<impl>>
 */
# define AorpK_Vpwchasp_opdom (1521)
# define AorpK_Vpwchasp_opdom_empty 1

/*
 * Rvpwprinc
 *
 * vodiprinc
 * oid: <<category>>/<<service>>/<<domain>>/<<impl>>
 */
# define AorpK_Rvpwprinc_opdom (1522)
# define AorpK_Rvpwprinc_opdom_empty 0

/*
 * Free: [1523 - 1540[
 */

/*
 * Vipmc
 *
 * vipm-c
 * oid: <<category>>/<<service>>/<<domain>>/<<impl>>
 */
# define AorpK_Vipmc_opdom (1542)
# define AorpK_Vipmc_opdom_empty 1

/*
 * Vipmipp
 *
 * vipm-ipp
 * oid: <<category>>/<<service>>/<<domain>>/<<impl>>
 */
# define AorpK_Vipmipp_opdom (1543)
# define AorpK_Vipmipp_opdom_empty 1

 /*
 * Vipmopencv
 *
 * vipm-opencv
 * oid: <<category>>/<<service>>/<<domain>>/<<impl>>
 */
# define AorpK_Vipmopencv_opdom (1544)
# define AorpK_Vipmopencv_opdom_empty 0

 /*
 * Vipmcvtegra
 *
 * vipm-cvtegra
 * oid: <<category>>/<<service>>/<<domain>>/<<impl>>
 */
# define AorpK_Vipmcvtegra_opdom (1545)
# define AorpK_Vipmcvtegra_opdom_empty 1

 /*
 * Vipmcfull
 *
 * vipm-cfull
 * oid: <<category>>/<<service>>/<<domain>>/<<impl>>
 */
# define AorpK_Vipmcfull_opdom (1546)
# define AorpK_Vipmcfull_opdom_empty 1

#endif /* !__VODI_SERVICES_MIB_OPDOM__ */

/*
 *
 */
