/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright 2007 Seenaptec Ltd. All rights reserved.
 * SEENAPTEC PROPRIETARY/CONFIDENTIAL.
 *
 * $Id$
 */

/*
 * VodiTL.h	(N.Panasiuk)
 * include/Vodi/services/VodiTL.h
 */

/* ------------------------------------------------------------------------- */

#ifndef __VODI_SERVICES_VODITL__
# define __VODI_SERVICES_VODITL__

/******************************************************************************
 * %% BeginSection: includes
 */

# include <Vodi/services/VodiTLP.h>

# include <Vodi/services/Zlist.h>

/******************************************************************************
 * %% BeginSection: function prototypes
 */
# pragma mark -
# pragma mark [ function prototypes ]
# pragma mark -

# include <Vodi/VodiLinkage.h>

__MYC_BEGIN_CDECLS

/*
 * type TL a      = [a]   -- traffic light - a list of lamps of type `a`
 * type Intensity = Float -- intensity of lamp; range is [0, 1]
 * type State     = Bool  -- state of lamp
 */

/*
 * VodiTLparse :: (t -> t -> Int) -> [t] -> TL Rect -> [Image]
 * -> [TL (State, Intensity)]
 *
 * NOTE! Function will become the owner of its arguments.
 */
__myc_flinkage__(public,libVodi) aorp_object_t
__attribute__((nonnull(1,2,3,4)))
VodiTLparse(
# if __myc_require(prototypes)
	aorp_object_t aMetric,     /* :: t -> t -> Int */
	aorp_object_t aTimeSeq,    /* :: [t] */
	aorp_object_t aRectList,   /* :: TL Rect */
	aorp_object_t anImageList  /* :: [Image] */
# endif
	);

#if 0
/*
 * VodiTLclassify :: (t -> t -> Int) -> [t] -> [TL (State, Intensity)]
 * -> [(TL State, [TL Intensity])]
 *
 * NOTE! Function will become the owner of its arguments.
 */
__myc_flinkage__(public,libVodi) aorp_object_t
__attribute__((nonnull(1,2,3)))
VodiTLclassify(
# if __myc_require(prototypes)
	aorp_object_t aMetric,     /* :: t -> t -> Int */
	aorp_object_t aTimeSeq,    /* :: [t] */
	aorp_object_t TLStates     /* :: [TL (State, Intensity)] */
# endif
	);
#endif

/*
 * VodiTLstate :: TL State -> u_int32_t
 */
__myc_flinkage__(public,libVodi) u_int32_t
__attribute__((nonnull(1)))
VodiTLstate(
# if __myc_require(prototypes)
	aorp_object_t /* :: TL State */
# endif
	);

__MYC_END_CDECLS

#endif /* !__VODI_SERVICES_VODITL__ */

/*
 *
 */
