/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright 2007 Seenaptec Ltd. All rights reserved.
 * SEENAPTEC PROPRIETARY/CONFIDENTIAL.
 *
 * $Id$
 */

/*
 * Vodiens.h	(N.Panasiuk)
 * include/Vodi/services/Vodiens.h
 */

/* ------------------------------------------------------------------------- */

#ifndef __VODI_SERVICES_VODIENS__
# define __VODI_SERVICES_VODIENS__

/******************************************************************************
 * %% BeginSection: includes
 */

# include <Vodi/services/VodiensP.h>

/******************************************************************************
 * %% BeginSection: function prototypes
 */
# pragma mark -
# pragma mark [ function prototypes ]
# pragma mark -

__MYC_BEGIN_CDECLS

/*
bo_stsbool_t
__attribute__((nonnull(1,2)))
VodiensSwap(
	aorp_object_t      aThis,
	aorp_object_t      aSrc,
	struct aorp_error *anErrPtr
	);
*/
# define VodiensSwap(aThis, aSrc, anErrPtr) \
	_A_call(swap, vodiens, aThis, anErrPtr, aSrc)

# pragma mark -

/*
ssize_t
__attribute__((nonnull(1)))
VodiensCount(
	aorp_object_t      aThis,
	struct aorp_error *anErrPtr
	);
*/
# define VodiensCount(aThis, anErrPtr) \
	((ssize_t) _A_call(count, vodiens, aThis, anErrPtr))

# pragma mark -

/*
bo_status_t
__attribute__((nonnull(1)))
VodiensClear(
	aorp_object_t      aThis,
	struct aorp_error *anErrPtr
	);
*
* All results, contained by the ensemble, are released.
*/
# define VodiensClear(aThis, anErrPtr) \
	_A_call(clear, vodiens, aThis, anErrPtr)

# pragma mark -

/*
ssize_t
__attribute__((nonnull(1,2)))
VodiensAdd(
	aorp_object_t      aThis,
	aorp_object_t      aResult,
	struct aorp_error *anErrPtr
	);
*
* NOTE! The object referenced by the parameter @result is retained.
*/
# define VodiensAdd(aThis, aResult, anErrPtr) \
	((ssize_t) _A_call(add, vodiens, aThis, anErrPtr, aResult))

/*
ssize_t
__attribute__((nonnull(1,2)))
VodiensAddf(
	aorp_object_t      aThis,
	aorp_object_t      aResult,
	aorp_opflags_t     Flags,
	struct aorp_error *anErrPtr
	);
*
* NOTE! The object referenced by the parameter @result is retained.
*
* If VodiensF_PRESERVE_TIMESTAMP_ORDER is set, then assume
* the input ensemble @this is ordered by result's timestamp.
*/
# define VodiensAddf(aThis, aResult, Flags, anErrPtr) \
	((ssize_t) _A_call(addf, vodiens, aThis, anErrPtr, aResult, (aorp_opflags_t)(Flags)))

# define VodiensAddWithTimestampOrder(aThis, aResult, anErrPtr) \
	VodiensAddf(aThis, aResult, VodiensF_PRESERVE_TIMESTAMP_ORDER, anErrPtr)

/*
ssize_t
__attribute__((nonnull(1)))
VodiensAddfN(
	aorp_object_t      aThis,
	size_t             aResultc,
	aorp_object_t      aResultv[],
	aorp_opflags_t     Flags,
	struct aorp_error *anErrPtr
	);
*/
# define VodiensAddfN(aThis, aResultc, aResultv, Flags, anErrPtr) \
	((ssize_t) _A_call(addf_n, vodiens, aThis, anErrPtr, aResultc, aResultv, (aorp_opflags_t)(Flags)))

/*
ssize_t
__attribute__((nonnull(1,2)))
VodiensAddfU(
	aorp_object_t      aThis,
	aorp_object_t      aResultClass,
	aorp_opflags_t     Flags,
	struct aorp_error *anErrPtr
	);
*/
# define VodiensAddfU(aThis, aResultClass, Flags, anErrPtr) \
	((ssize_t) _A_call(addf_u, vodiens, aThis, anErrPtr, aResultClass, (aorp_opflags_t)(Flags)))

# pragma mark -

/*
bo_status_t
__attribute__((nonnull(1)))
VodiensRemove(
	aorp_object_t      aThis,
	bo_index_t         anIndex,
	aorp_object_t     *aResultPtr,
	struct aorp_error *anErrPtr
	);
*
* NOTE! The returned object, stored to the (*aResultPtr), is not released/retained.
*/
# define VodiensRemove(aThis, anIndex, aResultPtr, anErrPtr) \
	_A_call(remove, vodiens, aThis, anErrPtr, (bo_index_t)(anIndex), aResultPtr)

/*
ssize_t
__attribute__((nonnull(1)))
VodiensRemoveN(
	aorp_object_t      aThis,
	bo_index_t         aStartIndex,
	size_t             aCount,
	aorp_object_t      aResultvOut[]
	struct aorp_error *anErrPtr
	);
*/
# define VodiensRemoveN(aThis, aStartIndex, aCount, aResultvOut, anErrPtr) \
	((ssize_t) _A_call(remove_n, vodiens, aThis, anErrPtr, \
	                   (bo_index_t)(aStartIndex), (size_t)(aCount), aResultvOut))

# pragma mark -

/*
bo_status_t
__attribute__((nonnull(1)))
VodiensDelete(
	aorp_object_t      aThis,
	bo_index_t         anIndex,
	struct aorp_error *anErrPtr
	);
*
* The object referenced by the parameter @index is released.
*/
# define VodiensDelete(aThis, anIndex, anErrPtr) \
	_A_call(delete, vodiens, aThis, anErrPtr, (bo_index_t)(anIndex))

/*
ssize_t
__attribute__((nonnull(1)))
VodiensDeleteN(
	aorp_object_t      aThis,
	bo_index_t         aStartIndex,
	size_t             aCount
	struct aorp_error *anErrPtr
	);
*/
# define VodiensDeleteN(aThis, aStartIndex, aCount, anErrPtr) \
	((ssize_t) _A_call(delete_n, vodiens, aThis, anErrPtr, \
	                   (bo_index_t)(aStartIndex), (size_t)(aCount)))

# pragma mark -

/*
ssize_t
__attribute__((nonnull(1)))
VodiensGet(
	aorp_object_t      aThis,
	bo_index_t         aFrom,
	bo_index_t         aTo,
	size_t             aCount,
	aorp_object_t      aResultv[],
	struct aorp_error *anErrPtr
	);
*
* NOTE! The returned objects, stored to the list referenced by the
* parameter @resultv, are not retained.
*/
# define VodiensGet(aThis, aFrom, aTo, aCount, aResultv, anErrPtr) \
	((ssize_t) _A_call(get, vodiens, aThis, anErrPtr, \
		(bo_index_t)(aFrom), (bo_index_t)(aTo), (size_t)(aCount), aResultv))

/*
ssize_t
__attribute__((nonnull(1)))
VodiensGetByTime(
	aorp_object_t      aThis,
	bo_utime_t         aTimeBegin,
	bo_utime_t         aTimeEnd,
	size_t             aCount,
	aorp_object_t      aResultv[],
	struct aorp_error *anErrPtr
	);
*
* NOTE! The returned objects, stored to the list referenced by the
* parameter @resultv, are not retained.
*/
# define VodiensGetByTime(aThis, aTimeBegin, aTimeEnd, aCount, aResultv, anErrPtr) \
	((ssize_t) _A_call(getbytime, vodiens, aThis, anErrPtr, \
		(bo_utime_t)(aTimeBegin), (bo_utime_t)(aTimeEnd), (size_t)(aCount), aResultv))

# pragma mark -

/*
bo_status_t
__attribute__((nonnull(1,2)))
VodiensForeach(
	aorp_object_t             aThis,
	struct aorp_foreach_pred *aPred,
	struct aorp_error        *anErrPtr __myc_defval__(NULL)
	);
 */
# define VodiensForeach(aThis, aPred, anErrPtr) \
	_A_call(foreach, vodiens, aThis, anErrPtr, aPred)

/*
bo_status_t
__attribute__((nonnull(1,2)))
VodiensForeachAboutTimePoint(
	aorp_object_t             aThis,
	struct aorp_foreach_pred *aPred,
	bo_utime_t                aTimePoint,
	bo_utime_t                aTimeAreaRadius,
	struct aorp_error        *anErrPtr __myc_defval__(NULL)
	);
 */
# define VodiensForeachAboutTimePoint(aThis, aPred, aTimePoint, aTimeAreaRadius, anErrPtr) \
	_A_call(foreach_atp, vodiens, aThis, anErrPtr, aPred, aTimePoint, aTimeAreaRadius)

/*
bo_status_t
__attribute__((nonnull(1,2)))
VodiensOrder(
	aorp_object_t      aThis,
	vodi_compare3_fn   aCmpProc,
	bo_pointer_t       aCmpCtx __myc_defval__(NULL),
	struct aorp_error *anErrPtr __myc_defval__(NULL)
	);
 */
# define VodiensOrder(aThis, aCmpProc, aCmpCtx, anErrPtr) \
	_A_call(order, vodiens, aThis, anErrPtr, aCmpProc, aCmpCtx)

/*
bo_status_t
__attribute__((nonnull(1)))
VodiensOrderByTimestamp(
	aorp_object_t      aThis,
	struct aorp_error *anErrPtr __myc_defval__(NULL)
	);
 */
# define VodiensOrderByTimestamp(aThis, anErrPtr) \
	_A_call(order_ts, vodiens, aThis, anErrPtr)

# pragma mark -

/*
ssize_t
__attribute__((nonnull(1)))
VodiensCandidateCount(
	aorp_object_t      aThis,
	struct aorp_error *anErrPtr
	);
*/
# define VodiensCandidateCount(aThis, anErrPtr) \
	((ssize_t) _A_call(candidatecount, vodiens, aThis, anErrPtr))

# pragma mark -

/*
bo_status_t
__attribute__((nonnull(1,2)))
VodiensPushCandidate(
	aorp_object_t                         aThis,
	size_t                                aCandc,
	struct vodi_ensemble_candidate const  aCandv[],
	struct aorp_error                    *anErrPtr
	);
*/
# define VodiensPushCandidate(aThis, aCandc, aCandv, anErrPtr) \
	_A_call(pushcandidate, vodiens, aThis, anErrPtr, (size_t)(aCandc), aCandv)

# pragma mark -

/*
ssize_t
__attribute__((nonnull(1)))
VodiensFetchCandidates(
	aorp_object_t                   aThis,
	int                             aType,
	size_t                          aCandc,
	struct vodi_ensemble_candidate  aCandv[],
	struct aorp_error              *anErrPtr
	);
*/
# define VodiensFetchCandidates(aThis, aType, aCandc, aCandv, anErrPtr) \
	((ssize_t) _A_call(fetchcandidates, vodiens, aThis, anErrPtr, aType, \
			(size_t)(aCandc), aCandv))

/*
ssize_t
__attribute__((nonnull(1)))
VodiensFetchCandidates_rc(
	aorp_object_t      aThis,
	int                aType,
	size_t             aCandc,
	vodi_rect_t   aCandv[],
	struct aorp_error *anErrPtr
	);
*/
# define VodiensFetchCandidates_rc(aThis, aType, aCandc, aCandv, anErrPtr) \
	((ssize_t) _A_call(fetchcandidates_rc, vodiens, aThis, anErrPtr, aType, \
			(size_t)(aCandc), aCandv))

/*
bo_status_t
__attribute__((nonnull(1)))
VodiensClearCandidates(
	aorp_object_t      aThis,
	struct aorp_error *anErrPtr
	);
*/
# define VodiensClearCandidates(aThis, anErrPtr) \
	_A_call(clearcandidates, vodiens, aThis, anErrPtr)

/*
ssize_t
__attribute__((nonnull(1)))
VodiensUnique(
	aorp_object_t      aThis,
	aorp_object_t      aPrincipal,
	struct aorp_error *anErrPtr
	);
*/
# define VodiensUnique(aThis, aPrincipal, anErrPtr) \
	((ssize_t) _A_call(unique, vodiens, aThis, anErrPtr, aPrincipal))

/*
ssize_t
__attribute__((nonnull(1)))
VodiensCombine(
	aorp_object_t      aThis,
	aorp_objec_t       aPrincipal,
	int                aWithMerge,
	size_t             anEnsc,
	aorp_object_t      anEnsv[],
	struct aorp_error *anErrPtr
	);
*/
# define VodiensCombine(aThis, aPrincipal, aWithMerge, anEnsc, anEnsv, anErrPtr) \
	((ssize_t) _A_call(combine_v2, vodiens, aThis, anErrPtr, \
		aPrincipal, (aorp_opflags_t)((aWithMerge) ? VodiensF_COMBINE_WITH_MERGE : 0), (size_t)(anEnsc), anEnsv))

/*
ssize_t
__attribute__((nonnull(1)))
VodiensCombine_v2(
	aorp_object_t      aThis,
	aorp_objec_t       aPrincipal,
	aorp_opflags_t     Flags, // = 0
	size_t             anEnsc,
	aorp_object_t      anEnsv[],
	struct aorp_error *anErrPtr
	);
*/
# define VodiensCombine_v2(aThis, aPrincipal, Flags, anEnsc, anEnsv, anErrPtr) \
	((ssize_t) _A_call(combine_v2, vodiens, aThis, anErrPtr, \
		aPrincipal, (aorp_opflags_t)(Flags), (size_t)(anEnsc), anEnsv))

/* ------------------------------------------------------------------------- */

/*
 * @{
 * NOT FOR YOUR BUSINESS (?)
 */

/*
	bo_stsptr_t repsts;
	repsts = _VodiensGetRepresentor(aThis, anErrPtr);
	return aorp_object_p(BoSP_NORMAL(repsts) ? BO_PTR_FROM_STATUS(repsts) : BoS_EPTR);
 */
# define _VodiensGetRepresentor(aThis, anErrPtr) \
	_A_call(getrep, vodiens, aThis, anErrPtr)

# define _VodiensSetRepresentor(aThis, aRepresentor, anErrPtr) \
	_A_call(setrep, vodiens, aThis, anErrPtr, aRepresentor)

/* ------------------------------------------------------------------------- */

# define _VodiensGetChaos(aThis, aChaosPtr, anErrPtr) \
	_A_call(getchaos, vodiens, aThis, anErrPtr, aChaosPtr)

# define _VodiensSetChaos(aThis, aChaos, anErrPtr) \
	_A_call(setchaos, vodiens, aThis, anErrPtr, (double)(aChaos))

/* @} */

/* ------------------------------------------------------------------------- */

/* @compat */
# define VodiensPushcandidate       VodiensPushCandidate
# define VodiensFetchcandidates     VodiensFetchCandidates
# define VodiensFetchcandidates_rc  VodiensFetchCandidates_rc
# define VodiensFetchcandidates_r   VodiensFetchCandidates_rc
# define VodiensClearcandidates     VodiensClearCandidates

__MYC_END_CDECLS

#endif /* !__VODI_SERVICES_VODIENS__ */

/*
 *
 */
