/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright 2007 Seenaptec Ltd. All rights reserved.
 * SEENAPTEC PROPRIETARY/CONFIDENTIAL.
 *
 * $Id$
 */

/*
 * VodiensP.h	(N.Panasiuk)
 * include/Vodi/services/VodiensP.h
 */

/* ------------------------------------------------------------------------- */

#ifndef __VODI_SERVICES_VODIENS_P__
# define __VODI_SERVICES_VODIENS_P__

/******************************************************************************
 * %% BeginSection: includes
 */

# include <Vodi/Types.h>

/******************************************************************************
 * %% BeginSection: vodiens service declarations
 */
# pragma mark -
# pragma mark [ vodiens service declarations ]
# pragma mark -

# define __aorpc_need_service_vodiens 1

#endif /* !__VODI_SERVICES_VODIENS_P__ */

#pragma mark -

#if __aorpc_uses_service(vodiens)
# undef __aorpc_need_service_vodiens

/*
 * vodiens service
 * @{
 */

/*
 * vodiens {\object(instance)}
 */
/*
# define AorpK_vodiens_service (1502)
 */
# include <Vodi/services/MIB/Services.h>

# define __aorpc_service_name vodiens
# include <Bo/aorp/AorpCsrvc.h>

_A_service(vodiens)

# if __aorpc_interface

	/*
	 * Candidate types
	 */

	enum {
		VodiK_ENSEMBLE_INVAL_CANDIDATE  = -1,
		VodiK_ENSEMBLE_NULL_CANDIDATE   = 0,
		VodiK_ENSEMBLE_UNK_CANDIDATE    = 2,

		VodiK_ENSEMBLE_LAST_CANDIDATE
	};

	struct vodi_ensemble_candidate {
		int            escd_type;
		vodi_quad64f_t escd_quad;
	};

	/*
	 * FLAGS
	 */

#  define VodiensF_PRESERVE_TIMESTAMP_ORDER (0x01) /* ops: addf */
#  define VodiensF_COMBINE_WITH_MERGE       (0x01)
#  define VodiensF_COMBINE_WITH_DUP         (0x02)

# endif /* __aorpc_interface */

_A_end_ctb

	_A_attribute((nonnull(1)))
	_A_op(count, "count", (
			struct aorp_closure *aClosure,
			struct aorp_error   *anErrPtr
		)),

	_A_attribute((nonnull(1)))
	_A_op(clear, "clear", (
			struct aorp_closure *aClosure,
			struct aorp_error   *anErrPtr
		)),

	_A_attribute((nonnull(1,3)))
	_A_op(add, "add", (
			struct aorp_closure *aClosure,
			struct aorp_error   *anErrPtr,
			aorp_object_t        aResult
		)),

	_A_attribute((nonnull(1)))
	_A_op(remove, "remove", (
			struct aorp_closure *aClosure,
			struct aorp_error   *anErrPtr,
			bo_index_t           anIndex,
			aorp_object_t       *aResultPtr
		)),

	_A_attribute((nonnull(1)))
	_A_op(delete, "delete", (
			struct aorp_closure *aClosure,
			struct aorp_error   *anErrPtr,
			bo_index_t           anIndex
		)),

	_A_attribute((nonnull(1)))
	_A_op(get, "get", (
			struct aorp_closure *aClosure,
			struct aorp_error   *anErrPtr,
			bo_index_t           anIndexFrom,
			bo_index_t           anIndexTo,
			size_t               aResultc,
			aorp_object_t        aResultv[]
		)),


	_A_attribute((nonnull(1)))
	_A_op(candidatecount, "candidate-count", (
			struct aorp_closure *aClosure,
			struct aorp_error   *anErrPtr
		)),

	_A_attribute((nonnull(1)))
	_A_op(pushcandidate, "push-candidate", (
			struct aorp_closure                  *aClosure,
			struct aorp_error                    *anErrPtr,
			size_t                                aCandc,
			struct vodi_ensemble_candidate const  aCandv[]
		)),

	_A_attribute((nonnull(1)))
	_A_op(fetchcandidates, "fetch-candidates", (
			struct aorp_closure            *aClosure,
			struct aorp_error              *anErrPtr,
			int                             aType,
			size_t                          aCandc,
			struct vodi_ensemble_candidate  aCandv[]
		)),

	_A_attribute((nonnull(1)))
	_A_op(fetchcandidates_rc, "fetch-candidates_rc", (
			struct aorp_closure *aClosure,
			struct aorp_error   *anErrPtr,
			int                  aType,
			size_t               aCandc,
			vodi_rect_t     aCandv[]
		)),

	_A_attribute((nonnull(1)))
	_A_op(clearcandidates, "clear-candidates", (
			struct aorp_closure *aClosure,
			struct aorp_error   *anErrPtr
		)),

	_A_attribute((nonnull(1)))
	_A_op(unique, "unique", (
			struct aorp_closure *aClosure,
			struct aorp_error   *anErrPtr,
			aorp_object_t        aPrincipal
		)),

	_A_attribute((nonnull(1)))
	_A_op(combine, "combine", (
			struct aorp_closure *aClosure,
			struct aorp_error   *anErrPtr,
			aorp_object_t        aPrincipal,
			int                  aWithMerge,
			size_t               anEnsc,
			aorp_object_t        anEnsv[]
		)),

	_A_attribute((nonnull(1)))
	_A_op(combine_v2, "combine-v2", (
			struct aorp_closure *aClosure,
			struct aorp_error   *anErrPtr,
			aorp_object_t        aPrincipal,
			aorp_opflags_t       Flags,
			size_t               anEnsc,
			aorp_object_t        anEnsv[]
		)),


	_A_attribute((nonnull(1,3)))
	_A_op(swap, "swap", (
			struct aorp_closure *aClosure,
			struct aorp_error   *anErrPtr,
			aorp_object_t        anEns
		)),

	_A_attribute((nonnull(1,3)))
	_A_op(foreach, "for-each", (
			struct aorp_closure      *aClosure,
			struct aorp_error        *anErrPtr,
			struct aorp_foreach_pred *aPred
		)),

	_A_attribute((nonnull(1,3)))
	_A_op(foreach_atp, "for-each-about-time-point", (
			struct aorp_closure      *aClosure,
			struct aorp_error        *anErrPtr,
			struct aorp_foreach_pred *aPred,
			bo_utime_t                aTimePoint,
			bo_utime_t                aTimeAreaRadius
		)),

	_A_attribute((nonnull(1,3)))
	_A_op(order, "order", (
			struct aorp_closure *aClosure,
			struct aorp_error   *anErrPtr,
			vodi_compare3_fn     aCmpProc,
			bo_pointer_t         aCmpCtx
		)),

	_A_attribute((nonnull(1)))
	_A_op(order_ts, "order-by-timestamp", (
			struct aorp_closure *aClosure,
			struct aorp_error   *anErrPtr
		)),

	_A_attribute((nonnull(1)))
	_A_op(getbytime, "get-by-time", (
			struct aorp_closure *aClosure,
			struct aorp_error   *anErrPtr,
			bo_utime_t           aTimeBegin,
			bo_utime_t           aTimeEnd,
			size_t               aResultc,
			aorp_object_t        aResultv[]
		)),

	_A_attribute((nonnull(1,3)))
	_A_op(addf, "addf", (
			struct aorp_closure *aClosure,
			struct aorp_error   *anErrPtr,
			aorp_object_t        aResult,
			aorp_opflags_t       Flags
		)),

	_A_attribute((nonnull(1)))
	_A_op(addf_n, "addf_n", (
			struct aorp_closure *aClosure,
			struct aorp_error   *anErrPtr,
			size_t               aResultc,
			aorp_object_t        aResultv[],
			aorp_opflags_t       Flags
		)),

	_A_attribute((nonnull(1,3)))
	_A_op(addf_u, "addf_u", (
			struct aorp_closure *aClosure,
			struct aorp_error   *anErrPtr,
			aorp_object_t        aResultClass,
			aorp_opflags_t       Flags
		)),

	_A_attribute((nonnull(1)))
	_A_op(remove_n, "remove_n", (
			struct aorp_closure *aClosure,
			struct aorp_error   *anErrPtr,
			bo_index_t           aStartIndex,
			size_t               aCount,
			aorp_object_t        aResultvOut[]
		)),

	_A_attribute((nonnull(1)))
	_A_op(delete_n, "delete_n", (
			struct aorp_closure *aClosure,
			struct aorp_error   *anErrPtr,
			bo_index_t           aStartIndex,
			size_t               aCount
		)),


	_A_attribute((nonnull(1)))
	_A_op(getrep, "get-representor", (
			struct aorp_closure *aClosure,
			struct aorp_error   *anErrPtr
		)),

	_A_attribute((nonnull(1)))
	_A_op(setrep, "set-representor", (
			struct aorp_closure *aClosure,
			struct aorp_error   *anErrPtr,
			aorp_object_t        aRepresentor
		)),

	_A_attribute((nonnull(1)))
	_A_op(getchaos, "get-chaos", (
			struct aorp_closure *aClosure,
			struct aorp_error   *anErrPtr,
			double              *aChaosPtr
		)),

	_A_attribute((nonnull(1)))
	_A_op(setchaos, "set-chaos", (
			struct aorp_closure *aClosure,
			struct aorp_error   *anErrPtr,
			double               aChaos
		)),

_A_end;

# include <Bo/aorp/AorpCend.h>
/* @} */
#endif /* __aorpc_uses_service(vodiens) */

/*
 *
 */
