/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright 2007 Seenaptec Ltd. All rights reserved.
 * SEENAPTEC PROPRIETARY/CONFIDENTIAL.
 *
 * $Id$
 */

/*
 * Vodiprinc.h	(N.Panasiuk)
 * include/Vodi/services/Vodiprinc.h
 */

/* ------------------------------------------------------------------------- */

#ifndef __VODI_SERVICES_VODIPRINC__
# define __VODI_SERVICES_VODIPRINC__

/******************************************************************************
 * %% BeginSection: includes
 */

# include <Vodi/services/VodiprincP.h>

/******************************************************************************
 * %% BeginSection: function prototypes
 */
# pragma mark -
# pragma mark [ function prototypes ]
# pragma mark -

__MYC_BEGIN_CDECLS

/*
bo_status_t
__attribute__((nonnull(1)))
VodiprincControl(
	aorp_object_t aThis,
	struct aorp_error *anErrPtr __myc_defval__(NULL),
	int aCommand,
	...
	);
*/
# if __myc_support(NVM)
#  define VodiprincControl(aThis, anErrPtr, aCommand...) \
		_A_call(control, vodiprinc, aThis, anErrPtr, aCommand)
# else
# if __myc_support(AVM)
#  define VodiprincControl(aThis, anErrPtr, aCommand, ...) \
		_A_call(control, vodiprinc, aThis, anErrPtr, aCommand, __VA_ARGS__)
# endif /* __myc_support(AVM) */
# endif /* __myc_support(NVM) */

# pragma mark -

/*
bo_status_t
__attribute__((nonnull(1)))
VodiprincGetparam(
	aorp_object_t aThis,
	struct aorp_error *anErrPtr __myc_defval__(NULL),
	int aParam,
	...
	);
*/
# if __myc_support(NVM)
#  define VodiprincGetparam(aThis, anErrPtr, aParam...) \
		_A_call(getparam, vodiprinc, aThis, anErrPtr, aParam)
# else
# if __myc_support(AVM)
#  define VodiprincGetparam(aThis, anErrPtr, aParam, ...) \
		_A_call(getparam, vodiprinc, aThis, anErrPtr, aParam, __VA_ARGS__)
# endif /* __myc_support(AVM) */
# endif /* __myc_support(NVM) */

# pragma mark -

/*
bo_status_t
__attribute__((nonnull(1)))
VodiprincSetparam(
	aorp_object_t aThis,
	struct aorp_error *anErrPtr __myc_defval__(NULL),
	int aParam,
	...
	);
*/
# if __myc_support(NVM)
#  define VodiprincSetparam(aThis, anErrPtr, aParam...) \
		_A_call(setparam, vodiprinc, aThis, anErrPtr, aParam)
# else
# if __myc_support(AVM)
#  define VodiprincSetparam(aThis, anErrPtr, aParam, ...) \
		_A_call(setparam, vodiprinc, aThis, anErrPtr, aParam, __VA_ARGS__)
# endif /* __myc_support(AVM) */
# endif /* __myc_support(NVM) */

# pragma mark -

/*
bo_status_t
__attribute__((nonnull(1)))
VodiprincApplyparam(
	aorp_object_t aThis,
	struct aorp_error *anErrPtr __myc_defval__(NULL)
	);
*/
# define VodiprincApplyparam(aThis, anErrPtr) \
	_A_call(applyparam, vodiprinc, aThis, anErrPtr)

# pragma mark -

/*
bo_status_t
__attribute__((nonnull(1,2,7)))
VodiprincProcess(
	aorp_object_t aThis,
	struct vodi_image *anImage,
	size_t aZonec __myc_defval__(0),
	vodi_rect_t const anAnalizeZonev[] __myc_defval__(NULL),
	struct vodi_ucontext const *anUserCtx __myc_defval__(NULL),
	aorp_object_t anInputEnsemble __myc_defval__(NULL),
	aorp_object_t *anOutputEnsemblePtr,
	void *Options __myc_defval__(NULL),
	struct aorp_error *anErrPtr __myc_defval__(NULL)
	);
*/
# define VodiprincProcess(aThis, anImage, aZonec, anAnalizeZonev, anUserCtx, anInputEnsemble, anOutputEnsemblePtr, Options, anErrPtr) \
	_A_call(process, vodiprinc, aThis, anErrPtr, \
		anImage, (size_t)(aZonec), anAnalizeZonev, anUserCtx, anInputEnsemble, anOutputEnsemblePtr, Options)

# pragma mark -

/*
bo_status_t
__attribute__((nonnull(1,3)))
VodiprincFlush(
	aorp_object_t aThis,
	aorp_object_t anInputEnsemble __myc_defval__(NULL),
	aorp_object_t *anOutputEnsemblePtr,
	struct aorp_error *anErrPtr __myc_defval__(NULL)
	);
*/
# define VodiprincFlush(aThis, anInputEnsemble, anOutputEnsemblePtr, anErrPtr) \
	_A_call(flush, vodiprinc, aThis, anErrPtr, anInputEnsemble, anOutputEnsemblePtr)

/* ============================================================================
 * DEPRECATED OPERATIONS
 * See also <Vodi/services/Lpvilib.h>
 */
# pragma mark -

/*
bo_status_t
__attribute__((nonnull(1,3)))
VodiprincChecktype(
	aorp_object_t aThis,
	unsigned aTypeId,
	wchar_t const *aStr,
	struct aorp_error *anErrPtr
	);
*/
# define VodiprincChecktype(aThis, aTypeId, aStr, anErrPtr) \
	_A_call(checktype, vodiprinc, aThis, anErrPtr, aTypeId, aStr)

/*
bo_status_t
__attribute__((nonnull(1,2)))
VodiprincNearestnumber(
	aorp_object_t aThis,
	wchar_t const *aStr,
	struct aorp_error *anErrPtr
	);
*/
# define VodiprincNearestnumber(aThis, aStr, anErrPtr) \
	_A_call(nearestnumber, vodiprinc, aThis, anErrPtr, aStr)

/*
bo_status_t
__attribute__((nonnull(1)))
VodiprincGetTypes(
	aorp_object_t aThis,
	unsigned *aTypev,
	unsigned aTypec,
	struct aorp_error *anErrPtr
	);
*/
# define VodiprincGettypes(aThis, aTypev, aTypec, anErrPtr) \
	_A_call(gettypes, vodiprinc, aThis, anErrPtr, aTypev, aTypec)

__MYC_END_CDECLS

#endif /* !__VODI_SERVICES_VODIPRINC__ */

/*
 *
 */
