/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright 2007 Seenaptec Ltd. All rights reserved.
 * SEENAPTEC PROPRIETARY/CONFIDENTIAL.
 *
 * $Id$
 */

/*
 * VodiprincP.h	(N.Panasiuk)
 * include/Vodi/services/VodiprincP.h
 */

/* ------------------------------------------------------------------------- */

#ifndef __VODI_SERVICES_VODIPRINC_P__
# define __VODI_SERVICES_VODIPRINC_P__

/******************************************************************************
 * %% BeginSection: includes
 */

# include <Vodi/Types.h>

# include <Bo/libc/Stdarg.h>

/******************************************************************************
 * %% BeginSection: vodiprinc service declarations
 */
# pragma mark -
# pragma mark [ vodiprinc service declarations ]
# pragma mark -

# define __aorpc_need_service_vodiprinc 1

#endif /* !__VODI_SERVICES_VODIPRINC_P__ */

#pragma mark -

#if __aorpc_uses_service(vodiprinc)
# undef __aorpc_need_service_vodiprinc

/*
 * vodiprinc service
 * @{
 */

/*
 * vodiprinc {\object(instance)}
 */
/*
# define AorpK_vodiprinc_service (1501)
 */
# include <Vodi/services/MIB/Services.h>

# define __aorpc_service_name vodiprinc
# include <Bo/aorp/AorpCsrvc.h>

_A_service(vodiprinc)
_A_end_ctb

	_A_attribute((nonnull(1)))
	_A_op(getparam, "get-param", (
			struct aorp_closure *aClosure,
			struct aorp_error *anErrPtr,
			int aParam,
			...
		)),

	_A_attribute((nonnull(1)))
	_A_op(setparam, "set-param", (
			struct aorp_closure *aClosure,
			struct aorp_error *anErrPtr,
			int aParam,
			...
		)),

	_A_attribute((nonnull(1)))
	_A_op(applyparam, "apply-param", (
			struct aorp_closure *aClosure,
			struct aorp_error *anErrPtr
		)),

	_A_attribute((nonnull(1)))
	_A_op(process, "process", (
			struct aorp_closure *aClosure,
			struct aorp_error *anErrPtr,
			struct vodi_image *anImage,
			size_t aZonec,
			vodi_rect_t const anAnalizeZonev[],
			struct vodi_ucontext const *anUserCtx,
			aorp_object_t anInputEnsemble,
			aorp_object_t *anOutputEnsemblePtr,
			void *Options
		)),

	_A_attribute((nonnull(1)))
	_A_op(process_ndelay, "process-ndelay", (
			struct aorp_closure *aClosure,
			struct aorp_error *anErrPtr,
			aorp_object_t anInputEnsemble,
			aorp_object_t *anOutputEnsemblePtr
		)),

	_A_attribute((nonnull(1)))
	_A_op(flush, "flush", (
			struct aorp_closure *aClosure,
			struct aorp_error *anErrPtr,
			aorp_object_t anInputEnsemble,
			aorp_object_t *anOutputEnsemblePtr
		)),

	_A_attribute((nonnull(1,4)))
	_A_op(checktype, "checktype", (
			struct aorp_closure *aClosure,
			struct aorp_error *anErrPtr,
			unsigned aTypeId,
			wchar_t const *aStr
		)),

	_A_attribute((nonnull(1,2)))
	_A_op(nearestnumber, "nearestnumber", (
			struct aorp_closure *aClosure,
			struct aorp_error *anErrPtr,
			wchar_t const *aStr
		)),

	_A_attribute((nonnull(1)))
	_A_op(gettypes, "get-types", (
			struct aorp_closure *aClosure,
			struct aorp_error *anErrPtr,
			unsigned *aTypev,
			unsigned aType
		)),

	_A_attribute((nonnull(1)))
	_A_op(control, "control", (
			struct aorp_closure *aClosure,
			struct aorp_error *anErrPtr,
			int aCommand,
			...
		)),

	_A_attribute((nonnull(1)))
	_A_op(vcontrol, "vcontrol", (
			struct aorp_closure *aClosure,
			struct aorp_error *anErrPtr,
			int aCommand,
			va_list ArgPtr
		)),

	_A_attribute((nonnull(1)))
	_A_op(vgetparam, "vget-param", (
			struct aorp_closure *aClosure,
			struct aorp_error *anErrPtr,
			int aParam,
			va_list ArgPtr
		)),

	_A_attribute((nonnull(1)))
	_A_op(vsetparam, "vset-param", (
			struct aorp_closure *aClosure,
			struct aorp_error *anErrPtr,
			int aParam,
			va_list ArgPtr
		)),

	_A_attribute((nonnull(1)))
	_A_op(process_array, "process-array", (
			struct aorp_closure *aClosure,
			struct aorp_error *anErrPtr,
			void *anArr, /* vodi_array_t */
			size_t aZonec,
			vodi_rect_t const anAnalizeZonev[],
			struct vodi_ucontext const *anUserCtx,
			aorp_object_t anInputEnsemble,
			aorp_object_t *anOutputEnsemblePtr,
			void *Options
		)),

_A_end;

# include <Bo/aorp/AorpCend.h>
/* @} */
#endif /* __aorpc_uses_service(vodiprinc) */

/*
 *
 */
