/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright 2007 Seenaptec Ltd. All rights reserved.
 * SEENAPTEC PROPRIETARY/CONFIDENTIAL.
 *
 * $Id$
 */

/*
 * Vodires.h	(N.Panasiuk)
 * include/Vodi/services/Vodires.h
 */

/* ------------------------------------------------------------------------- */

#ifndef __VODI_SERVICES_VODIRES__
# define __VODI_SERVICES_VODIRES__

/******************************************************************************
 * %% BeginSection: includes
 */

# include <Vodi/services/VodiresP.h>

/******************************************************************************
 * %% BeginSection: function prototypes
 */
# pragma mark -
# pragma mark [ function prototypes ]
# pragma mark -

__MYC_BEGIN_CDECLS

/*
bo_status_t
__attribute__((nonnull(1,2)))
VodiresGetUserdata(
	aorp_object_t               aThis,
	struct vodi_ucontext       *anUserCtx,
	struct aorp_error          *anErrPtr
	);
 *
 * NOTE! The returned data, stored to the buffer pointed to by the
 * parameter @user-ctx, is not retained.
 */
# define VodiresGetUserdata(aThis, anUserCtx, anErrPtr) \
	_A_call(getuserdata, vodires, aThis, anErrPtr, anUserCtx)

# pragma mark -

/*
bo_status_t
__attribute__((nonnull(1)))
VodiresSetUserdata(
	aorp_object_t               aThis,
	struct vodi_ucontext       *anUserCtx,
	struct aorp_error          *anErrPtr
	);
 *
 * NOTE! The data pointed to by the parameter @user-ctx, is retained.
 */
# define VodiresSetUserdata(aThis, anUserCtx, anErrPtr) \
	_A_call(setuserdata, vodires, aThis, anErrPtr, anUserCtx)

# pragma mark -

/*
bo_status_t
__attribute__((nonnull(1,2)))
VodiresFetchInfo(
	aorp_object_t               aThis,
	struct vodi_result_info    *anInfo,
	struct aorp_error          *anErrPtr
	);
 *
 * NOTE!
 * It is required, that the result-info-type of the info
 * pointed to by the parameter @info is set.
 * Allowed values are: VodiK_VPW_RESULT_INFO, VodiK_FCW_RESULT_INFO.
 *
 * The caller is responsible for the destroying info, stored to the
 * buffer pointed to by the parameter @info, via the 'VodiresInfoDestroy()'
 * call.
 */
# define VodiresFetchInfo(aThis, anInfo, anErrPtr) \
	_A_call(fetchinfo, vodires, aThis, anErrPtr, anInfo)

# pragma mark -

/*
bo_status_t
__attribute__((nonnull(1)))
VodiresTimestamp(
	aorp_object_t               aThis,
	bo_utime_t                 *aTimePtr,
	struct aorp_error          *anErrPtr
	);
 */
# define VodiresTimestamp(aThis, aTimePtr, anErrPtr) \
	_A_call(timestamp, vodires, aThis, anErrPtr, aTimePtr)

# pragma mark -

/* NOT FOR YOUR BUSINESS @{ */

/*
bo_status_t
__attribute__((nonnull(1,2)))
_VodiresGetCanonicalimg(
	aorp_object_t               aThis,
	struct vodi_image         **anImagePtr,
	struct aorp_error          *anErrPtr
	);
 *
 * NOTE! The returned image, stored to the buffer pointed to by the
 * parameter @image-ptr, is not retained.
 */
# define _VodiresGetCanonicalimg(aThis, anImagePtr, anErrPtr) \
	_A_call(getcanonicalimg, vodires, aThis, anErrPtr, anImagePtr)

# pragma mark -

/*
bo_status_t
__attribute__((nonnull(1)))
_VodiresSetCanonicalimg(
	aorp_object_t               aThis,
	struct vodi_image          *anImage,
	struct aorp_error          *anErrPtr
	);
 *
 * NOTE! The image pointed to by the parameter @image is retained.
 */
# define _VodiresSetCanonicalimg(aThis, anImage, anErrPtr) \
	_A_call(setcanonicalimg, vodires, aThis, anErrPtr, anImage)

# pragma mark -

/*
bo_status_t
__attribute__((nonnull(1)))
_VodiresSetResinfospec(
	aorp_object_t               aThis,
	bo_pointer_t                anInfoSpec,
	int                         aSpecType,
	struct aorp_error          *anErrPtr
	);
 *
 *
 */
# define _VodiresSetResinfospec(aThis, anInfoSpec, aSpecType, anErrPtr) \
	_A_call(setresinfospec, vodires, aThis, anErrPtr, anInfoSpec, aSpecType)

/* @} */

/* ------------------------------------------------------------------------- */

/* @compat */
# define VodiresGetuserdata         VodiresGetUserdata
# define VodiresSetuserdata         VodiresSetUserdata
# define VodiresFetchinfo           VodiresFetchInfo
# define _VodiresGetcanonicalimg    _VodiresGetCanonicalimg
# define _VodiresSetcanonicalimg    _VodiresSetCanonicalimg
# define _VodiresSetresinfospec     _VodiresSetResinfospec

__MYC_END_CDECLS

#endif /* !__VODI_SERVICES_VODIRES__ */

/*
 *
 */
