/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright 2007 Seenaptec Ltd. All rights reserved.
 * SEENAPTEC PROPRIETARY/CONFIDENTIAL.
 *
 * $Id$
 */

/*
 * VodiresP.h	(N.Panasiuk)
 * include/Vodi/services/VodiresP.h
 */

/* ------------------------------------------------------------------------- */

#ifndef __VODI_SERVICES_VODIRES_P__
# define __VODI_SERVICES_VODIRES_P__

/******************************************************************************
 * %% BeginSection: includes
 */

# include <Vodi/Types.h>

/******************************************************************************
 * %% BeginSection: vodires service declarations
 */
# pragma mark -
# pragma mark [ vodires service declarations ]
# pragma mark -

# define __aorpc_need_service_vodires 1

#endif /* !__VODI_SERVICES_VODIRES_P__ */

#pragma mark -

#if __aorpc_uses_service(vodires)
# undef __aorpc_need_service_vodires

/*
 * vodires service
 * @{
 */

/*
 * vodires {\object(instance)}
 */
/*
# define AorpK_vodires_service (1503)
 */
# include <Vodi/services/MIB/Services.h>

# define __aorpc_service_name vodires
# include <Bo/aorp/AorpCsrvc.h>

_A_service(vodires)
_A_end_ctb

	_A_attribute((nonnull(1,3)))
	_A_op(getuserdata, "get-user-data", (
			struct aorp_closure *aClosure,
			struct aorp_error *anErrPtr,
			struct vodi_ucontext *anUserCtx
		)),

	_A_attribute((nonnull(1)))
	_A_op(setuserdata, "set-user-data", (
			struct aorp_closure *aClosure,
			struct aorp_error *anErrPtr,
			struct vodi_ucontext *anUserCtx
		)),

	_A_attribute((nonnull(1,3)))
	_A_op(fetchinfo, "fetch-information", (
			struct aorp_closure *aClosure,
			struct aorp_error *anErrPtr,
			struct vodi_result_info *anInfo
		)),

	_A_attribute((nonnull(1,3)))
	_A_op(getcanonicalimg, "get-canonical-img", (
			struct aorp_closure *aClosure,
			struct aorp_error *anErrPtr,
			struct vodi_image **anImagePtr
		)),

	_A_attribute((nonnull(1)))
	_A_op(setcanonicalimg, "set-canonical-img", (
			struct aorp_closure *aClosure,
			struct aorp_error *anErrPtr,
			struct vodi_image *anImage
		)),

	_A_attribute((nonnull(1)))
	_A_op(setresinfospec, "set-resinfo-spec", (
			struct aorp_closure *aClosure,
			struct aorp_error *anErrPtr,
			bo_pointer_t anInfoSpec,
			int aSpecType
		)),

	_A_attribute((nonnull(1)))
	_A_op(timestamp, "timestamp", (
			struct aorp_closure *aClosure,
			struct aorp_error *anErrPtr,
			bo_utime_t *aTimePtr
		)),

_A_end;

# include <Bo/aorp/AorpCend.h>
/* @} */
#endif /* __aorpc_uses_service(vodires) */

/*
 *
 */
