/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright 2007 Seenaptec Ltd. All rights reserved.
 * SEENAPTEC PROPRIETARY/CONFIDENTIAL.
 *
 * $Id$
 */

/*
 * ZlistP.h	(N.Panasiuk)
 * include/Vodi/services/ZlistP.h
 */

/* ------------------------------------------------------------------------- */

#ifndef __VODI_SERVICES_ZLIST_P__
# define __VODI_SERVICES_ZLIST_P__

/******************************************************************************
 * %% BeginSection: includes
 */

# include <Vodi/Types.h>

# include <Bo/memman/Types.h>

/******************************************************************************
 * %% BeginSection: zlist service declarations
 */
# pragma mark -
# pragma mark [ zlist service declarations ]
# pragma mark -

# define __aorpc_need_service_zlist 1

#endif /* !__VODI_SERVICES_ZLIST_P__ */

#pragma mark -

#if __aorpc_uses_service(zlist)
# undef __aorpc_need_service_zlist

/*
 * zlist service
 * @{
 */

/*
 * zlist
 */
/*
# define AorpK_zlist_service (1510)
 */
# include <Vodi/services/MIB/Services.h>

# define __aorpc_service_name zlist
# include <Bo/aorp/AorpCsrvc.h>

_A_service(zlist)

# if __aorpc_interface

struct zlcb;

typedef aorp_object_t
(__myc_tcalltype__(mcall) *zlcb_next_fn)(
#  if __myc_require(prototypes)
	struct zlcb *
#  endif
	) __attribute__((mcalltype, nonnull(1)));

struct zlcb {
	bo_malloc_free_fn  free;
	zlcb_next_fn       next;

	/*
		Your data
	 */
};
#  define zlcb_p(x) ((struct zlcb *)(x))

#  define ZLCB_Free(x) \
	(NULLF != zlcb_p(x)->free ? (*zlcb_p(x)->free)(x) : (void)(x))

#  define ZLCB_Next(x) \
	(NULLF != zlcb_p(x)->next ? (*zlcb_p(x)->next)(zlcb_p(x)) : ZLNil())


struct zlfun;

typedef aorp_object_t
(__myc_tcalltype__(mcall) *zlfun_imp_fn)(
#  if __myc_require(prototypes)
	struct zlfun *,
	...
#  endif
	) __attribute__((mcalltype, nonnull(1)));

struct zlfun {
	bo_malloc_free_fn  free;
	zlfun_imp_fn       imp;

	/*
		Your data
	 */
};
#  define zlfun_p(x) ((struct zlfun *)(x))

#  define ZLFUN_Free(x) \
	(NULLF != zlfun_p(x)->free ? (*zlfun_p(x)->free)(x) : (void)(x))

#  ifdef BO_SYSTYPE_WIN32
#   define ZLFUN_Call(f, ...) ZLFUN_Call_I(f, __VA_ARGS__)
#   define ZLFUN_Call_I(f, ...) ((*zlfun_p(f)->imp)(zlfun_p(f), __VA_ARGS__))
#  else
#  if __myc_support(AVM)
#   define ZLFUN_Call(...) ZLFUN_Call_I(__VA_ARGS__)
#   define ZLFUN_Call_I(f, ...) ((*zlfun_p(f)->imp)(zlfun_p(f), ##__VA_ARGS__))
#  else
#  if __myc_support(NVM)
#   define ZLFUN_Call(f, x...) ZLFUN_Call_I(f, x)
#   define ZLFUN_Call_I(f, x...) ((*zlfun_p(f)->imp)(zlfun_p(f), ##x))
#  endif /* __myc_support(NVM) */
#  endif /* __myc_support(AVM) */
#  endif /* !BO_SYSTYPE_WIN32 */

# endif /* __aorpc_interface */

_A_end_ctb

	_A_attribute((nonnull(1)))
	_A_op(isnil, "zlist.isnil", (
			struct aorp_closure *aClosure,
			struct aorp_error *anErrPtr
		)),

	_A_attribute((nonnull(1)))
	_A_op(hd, "zlist.hd", (
			struct aorp_closure *aClosure,
			struct aorp_error *anErrPtr
		)),

	_A_attribute((nonnull(1)))
	_A_op(tl, "zlist.tl", (
			struct aorp_closure *aClosure,
			struct aorp_error *anErrPtr
		)),

	_A_attribute((nonnull(1)))
	_A_op(hdtl, "zlist.hdtl", (
			struct aorp_closure *aClosure,
			struct aorp_error *anErrPtr,
			aorp_object_t *aHeadPtr,
			aorp_object_t *aTailPtr
		)),

_A_end;

# include <Bo/aorp/AorpCend.h>
/* @} */
#endif /* __aorpc_uses_service(zlist) */

/*
 *
 */
