/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright 2007 Seenaptec Ltd. All rights reserved.
 * SEENAPTEC PROPRIETARY/CONFIDENTIAL.
 *
 * $Id$
 */

/*
 * symbolType.h	(Y.Bukhtiyarov)
 * include/Vodi/symbolType.h
 */

/* ------------------------------------------------------------------------- */

#ifndef __VODI_SYMBOL_TYPE__
# define __VODI_SYMBOL_TYPE__

/******************************************************************************
 * %% BeginSection: definitions
 */
# pragma mark -
# pragma mark [ definitions ]
# pragma mark -

enum {
	VodiK_0_SYMBOL = 0,
	VodiK_1_SYMBOL = 1,
	VodiK_2_SYMBOL = 2,
	VodiK_3_SYMBOL = 3,
	VodiK_4_SYMBOL = 4,
	VodiK_5_SYMBOL = 5,
	VodiK_6_SYMBOL = 6,
	VodiK_7_SYMBOL = 7,
	VodiK_8_SYMBOL = 8,
	VodiK_9_SYMBOL = 9,

	VodiK_X_SYMBOL = 10,
	VodiK_C_SYMBOL = 11,
	VodiK_B_SYMBOL = 12,
	VodiK_Y_SYMBOL = 13,
	VodiK_A_SYMBOL = 14,
	VodiK_P_SYMBOL = 15,
	VodiK_T_SYMBOL = 16,
	VodiK_K_SYMBOL = 17,
	VodiK_E_SYMBOL = 18,
	VodiK_M_SYMBOL = 19,
	VodiK_H_SYMBOL = 20,

	VodiK_STAR_SYMBOL = 21,

	VodiK_I_SYMBOL = 22,

	VodiK_CYRD_SYMBOL  = 23, /* Д */
	VodiK_CYRY_SYMBOL  = 24, /* И */
	VodiK_CYRB_SYMBOL  = 25, /* Б */
	VodiK_CYRL_SYMBOL  = 26, /* Л */
	VodiK_CYRP_SYMBOL  = 27, /* П */
	VodiK_CYRG_SYMBOL  = 28, /* Г */
	VodiK_CYRCH_SYMBOL = 29, /* Ч */
	VodiK_CYRZH_SYMBOL = 30, /* Ж */
	VodiK_CYRC_SYMBOL  = 31, /* Ц */
	VodiK_CYRJA_SYMBOL = 32, /* Я */
	VodiK_CYRSH_SYMBOL = 33, /* Ш */
	VodiK_CYRZ_SYMBOL  = 34, /* З */
	VodiK_CYRJU_SYMBOL = 35, /* Ю */
	VodiK_CYRE_SYMBOL  = 36, /* Э */
	VodiK_CYRF_SYMBOL  = 37, /* Ф */

	VodiK_D_SYMBOL = 38,
	VodiK_F_SYMBOL = 39,
	VodiK_G_SYMBOL = 40,
	VodiK_J_SYMBOL = 41,
	VodiK_L_SYMBOL = 42,
	VodiK_N_SYMBOL = 43,
	VodiK_Z_SYMBOL = 44,
	VodiK_Q_SYMBOL = 45,
	VodiK_R_SYMBOL = 46,
	VodiK_S_SYMBOL = 47,
	VodiK_U_SYMBOL = 48,
	VodiK_V_SYMBOL = 49,
	VodiK_W_SYMBOL = 50,

	VodiK_OUM_SYMBOL       = 51, /* O umlyaut */
	VodiK_AUM_SYMBOL       = 52, /* A umlyaut */
	VodiK_ACI_SYMBOL       = 53, /* A + circle */
	VodiK_UUM_SYMBOL       = 54, /* U umlyaut */
	VodiK_HEBRTSADI_SYMBOL = 55, /* Hebrew letter tsadi  */
	VodiK_HEBRMEM_SYMBOL   = 56, /* Hebrew letter mem */

	VodiK_EXTLATIN_C_ACUTE_SYMBOL  = 57,
	VodiK_EXTLATIN_C_CARON_SYMBOL  = 58,
	VodiK_EXTLATIN_D_STROKE_SYMBOL = 59,
	VodiK_EXTLATIN_S_CARON_SYMBOL  = 60,
	VodiK_EXTLATIN_Z_CARON_SYMBOL  = 61,

	VodiK_CYR_O_BARRED_SYMBOL = 62,

/* Greek symbols */
	VodiK_GREEK_THETA_SYMBOL  = 63,
	VodiK_GREEK_XI_SYMBOL     = 64,
	VodiK_GREEK_PSI_SYMBOL    = 65,
	VodiK_GREEK_OMEGA_SYMBOL  = 66,
	VodiK_GREEK_DELTA_SYMBOL  = 67,
	VodiK_GREEK_SIGMA_SYMBOL  = 68,
	VodiK_GREEK_PI_SYMBOL     = 69,
	VodiK_GREEK_LAMBDA_SYMBOL = 70,

/* Arab symbols */
	VodiK_ARAB_0_SYMBOL = 71, /* ۰ */
	VodiK_ARAB_1_SYMBOL = 72, /* ۱ */
	VodiK_ARAB_2_SYMBOL = 73, /* ۲ */
	VodiK_ARAB_3_SYMBOL = 74, /* ۳ */
	VodiK_ARAB_4_SYMBOL = 75, /* ۴ */
	VodiK_ARAB_5_SYMBOL = 76, /* ۵ */
	VodiK_ARAB_6_SYMBOL = 77, /* ۶ */
	VodiK_ARAB_7_SYMBOL = 78, /* ۷ */
	VodiK_ARAB_8_SYMBOL = 79, /* ۸ */
	VodiK_ARAB_9_SYMBOL = 80, /* ۹ */

	VodiK_ARAB_ALEF_SYMBOL         = 81,
	VodiK_ARAB_BEH_SYMBOL          = 82,
	VodiK_ARAB_TEH_SYMBOL          = 83,
	VodiK_ARAB_THEH_SYMBOL         = 84,
	VodiK_ARAB_JEEM_SYMBOL         = 85,
	VodiK_ARAB_HAH_SYMBOL          = 86,
	VodiK_ARAB_KHAH_SYMBOL         = 87,
	VodiK_ARAB_DAL_SYMBOL          = 88,
	VodiK_ARAB_THAL_SYMBOL         = 89,
	VodiK_ARAB_REH_SYMBOL          = 90,
	VodiK_ARAB_ZAIN_SYMBOL         = 91,
	VodiK_ARAB_SEEN_SYMBOL         = 92,
	VodiK_ARAB_SHEEN_SYMBOL        = 93,
	VodiK_ARAB_SAD_SYMBOL          = 94,
	VodiK_ARAB_DAD_SYMBOL          = 95,
	VodiK_ARAB_TAH_SYMBOL          = 96,
	VodiK_ARAB_ZAH_SYMBOL          = 97,
	VodiK_ARAB_AIN_SYMBOL          = 98,
	VodiK_ARAB_GHAIN_SYMBOL        = 99,
	VodiK_ARAB_FEH_SYMBOL          = 100,
	VodiK_ARAB_QAF_SYMBOL          = 101,
	VodiK_ARAB_KAF_SYMBOL          = 102,
	VodiK_ARAB_LAM_SYMBOL          = 103,
	VodiK_ARAB_MEEM_SYMBOL         = 104,
	VodiK_ARAB_NOON_SYMBOL         = 105,
	VodiK_ARAB_HEH_SYMBOL          = 106,
	VodiK_ARAB_WAW_SYMBOL          = 107,
	VodiK_ARAB_YEH_SYMBOL          = 108,
	VodiK_ARAB_HEH_D_SYMBOL        = 109,

/* @todo: add to translate table */
	VodiK_EXTLATIN_N_TILDE_SYMBOL  = 110,

/* Armenian symbols */
/* @todo: add to translate table */
	VodiK_ARMEN_VO_SYMBOL          = 111, /* Ո */

	VodiK_ARAB_ALEF_MAKSURA_SYMBOL = 112,

/* Some Japan symbols */
	VodiK_JAPAN_3042_SYMBOL = 150,
	VodiK_JAPAN_3044_SYMBOL = 151,
	VodiK_JAPAN_3046_SYMBOL = 152,
	VodiK_JAPAN_3048_SYMBOL = 153,
	VodiK_JAPAN_304B_SYMBOL = 154,
	VodiK_JAPAN_304D_SYMBOL = 155,
	VodiK_JAPAN_304E_SYMBOL = 156,
	VodiK_JAPAN_304F_SYMBOL = 157,
	VodiK_JAPAN_3051_SYMBOL = 158,
	VodiK_JAPAN_3053_SYMBOL = 159,
	VodiK_JAPAN_3055_SYMBOL = 160,
	VodiK_JAPAN_3059_SYMBOL = 161,
	VodiK_JAPAN_305B_SYMBOL = 162,
	VodiK_JAPAN_305D_SYMBOL = 163,
	VodiK_JAPAN_305F_SYMBOL = 164,
	VodiK_JAPAN_3061_SYMBOL = 165,
	VodiK_JAPAN_3064_SYMBOL = 166,
	VodiK_JAPAN_3066_SYMBOL = 167,
	VodiK_JAPAN_3068_SYMBOL = 168,
	VodiK_JAPAN_306A_SYMBOL = 169,
	VodiK_JAPAN_306B_SYMBOL = 170,
	VodiK_JAPAN_306C_SYMBOL = 171,
	VodiK_JAPAN_306D_SYMBOL = 172,
	VodiK_JAPAN_306E_SYMBOL = 173,
	VodiK_JAPAN_306F_SYMBOL = 174,
	VodiK_JAPAN_3070_SYMBOL = 175,
	VodiK_JAPAN_3072_SYMBOL = 176,
	VodiK_JAPAN_3075_SYMBOL = 177,
	VodiK_JAPAN_307B_SYMBOL = 178,
	VodiK_JAPAN_307E_SYMBOL = 179,
	VodiK_JAPAN_307F_SYMBOL = 180,
	VodiK_JAPAN_3080_SYMBOL = 181,
	VodiK_JAPAN_3081_SYMBOL = 182,
	VodiK_JAPAN_3082_SYMBOL = 183,
	VodiK_JAPAN_3084_SYMBOL = 184,
	VodiK_JAPAN_3086_SYMBOL = 185,
	VodiK_JAPAN_3088_SYMBOL = 186,
	VodiK_JAPAN_3089_SYMBOL = 187,
	VodiK_JAPAN_308A_SYMBOL = 188,
	VodiK_JAPAN_308B_SYMBOL = 189,
	VodiK_JAPAN_308C_SYMBOL = 190,
	VodiK_JAPAN_308D_SYMBOL = 191,
	VodiK_JAPAN_308F_SYMBOL = 192,
	VodiK_JAPAN_3092_SYMBOL = 193,
	VodiK_JAPAN_30F6_SYMBOL = 194,
	VodiK_JAPAN_4E00_SYMBOL = 195,
	VodiK_JAPAN_4E09_SYMBOL = 196,
	VodiK_JAPAN_4E0B_SYMBOL = 197,
	VodiK_JAPAN_4E16_SYMBOL = 198,
	VodiK_JAPAN_4E45_SYMBOL = 199,
	VodiK_JAPAN_4E5D_SYMBOL = 200,
	VodiK_JAPAN_4E95_SYMBOL = 201,
	VodiK_JAPAN_4EAC_SYMBOL = 202,
	VodiK_JAPAN_4ED9_SYMBOL = 203,
	VodiK_JAPAN_4F0A_SYMBOL = 204,
	VodiK_JAPAN_4F1A_SYMBOL = 205,
	VodiK_JAPAN_4F50_SYMBOL = 206,
	VodiK_JAPAN_4FDD_SYMBOL = 207,
	VodiK_JAPAN_5009_SYMBOL = 208,
	VodiK_JAPAN_5150_SYMBOL = 209,
	VodiK_JAPAN_516B_SYMBOL = 210,
	VodiK_JAPAN_5185_SYMBOL = 211,
	VodiK_JAPAN_51FD_SYMBOL = 212,
	VodiK_JAPAN_5206_SYMBOL = 213,
	VodiK_JAPAN_5317_SYMBOL = 214,
	VodiK_JAPAN_5343_SYMBOL = 215,
	VodiK_JAPAN_5357_SYMBOL = 216,
	VodiK_JAPAN_53D6_SYMBOL = 217,
	VodiK_JAPAN_53E3_SYMBOL = 218,
	VodiK_JAPAN_53E4_SYMBOL = 219,
	VodiK_JAPAN_53F0_SYMBOL = 220,
	VodiK_JAPAN_540D_SYMBOL = 221,
	VodiK_JAPAN_548C_SYMBOL = 222,
	VodiK_JAPAN_54C1_SYMBOL = 223,
	VodiK_JAPAN_571F_SYMBOL = 224,
	VodiK_JAPAN_57CE_SYMBOL = 225,
	VodiK_JAPAN_583A_SYMBOL = 226,
	VodiK_JAPAN_58EB_SYMBOL = 227,
	VodiK_JAPAN_591A_SYMBOL = 228,
	VodiK_JAPAN_5927_SYMBOL = 229,
	VodiK_JAPAN_5948_SYMBOL = 230,
	VodiK_JAPAN_59EB_SYMBOL = 231,
	VodiK_JAPAN_5A9B_SYMBOL = 232,
	VodiK_JAPAN_5B50_SYMBOL = 233,
	VodiK_JAPAN_5B87_SYMBOL = 234,
	VodiK_JAPAN_5BA4_SYMBOL = 235,
	VodiK_JAPAN_5BAE_SYMBOL = 236,
	VodiK_JAPAN_5BCC_SYMBOL = 237,
	VodiK_JAPAN_5C0F_SYMBOL = 238,
	VodiK_JAPAN_5C3E_SYMBOL = 239,
	VodiK_JAPAN_5C4B_SYMBOL = 240,
	VodiK_JAPAN_5C71_SYMBOL = 241,
	VodiK_JAPAN_5C90_SYMBOL = 242,
	VodiK_JAPAN_5CA1_SYMBOL = 243,
	VodiK_JAPAN_5CA9_SYMBOL = 244,
	VodiK_JAPAN_5CF6_SYMBOL = 245,
	VodiK_JAPAN_5D0E_SYMBOL = 246,
	VodiK_JAPAN_5DDD_SYMBOL = 247,
	VodiK_JAPAN_5DDE_SYMBOL = 248,
	VodiK_JAPAN_5E2F_SYMBOL = 249,
	VodiK_JAPAN_5E4C_SYMBOL = 250,
	VodiK_JAPAN_5E83_SYMBOL = 251,
	VodiK_JAPAN_5E84_SYMBOL = 252,
	VodiK_JAPAN_5F35_SYMBOL = 253,
	VodiK_JAPAN_5F62_SYMBOL = 254,
	VodiK_JAPAN_5FB3_SYMBOL = 256,
	VodiK_JAPAN_5FD7_SYMBOL = 257,
	VodiK_JAPAN_611B_SYMBOL = 258,
	VodiK_JAPAN_6210_SYMBOL = 259,
	VodiK_JAPAN_6238_SYMBOL = 260,
	VodiK_JAPAN_6240_SYMBOL = 261,
	VodiK_JAPAN_624B_SYMBOL = 262,
	VodiK_JAPAN_6469_SYMBOL = 263,
	VodiK_JAPAN_6577_SYMBOL = 264,
	VodiK_JAPAN_65B0_SYMBOL = 265,
	VodiK_JAPAN_65E5_SYMBOL = 266,
	VodiK_JAPAN_65ED_SYMBOL = 267,
	VodiK_JAPAN_6625_SYMBOL = 268,
	VodiK_JAPAN_672C_SYMBOL = 269,
	VodiK_JAPAN_672D_SYMBOL = 270,
	VodiK_JAPAN_677E_SYMBOL = 271,
	VodiK_JAPAN_67CF_SYMBOL = 272,
	VodiK_JAPAN_6839_SYMBOL = 273,
	VodiK_JAPAN_68A8_SYMBOL = 274,
	VodiK_JAPAN_68EE_SYMBOL = 275,
	VodiK_JAPAN_6A21_SYMBOL = 276,
	VodiK_JAPAN_6A2A_SYMBOL = 277,
	VodiK_JAPAN_6A4B_SYMBOL = 278,
	VodiK_JAPAN_6B4C_SYMBOL = 279,
	VodiK_JAPAN_6C34_SYMBOL = 280,
	VodiK_JAPAN_6C96_SYMBOL = 281,
	VodiK_JAPAN_6CA2_SYMBOL = 282,
	VodiK_JAPAN_6CB3_SYMBOL = 283,
	VodiK_JAPAN_6CBC_SYMBOL = 284,
	VodiK_JAPAN_6CC9_SYMBOL = 285,
	VodiK_JAPAN_6D25_SYMBOL = 286,
	VodiK_JAPAN_6D5C_SYMBOL = 287,
	VodiK_JAPAN_6D66_SYMBOL = 288,
	VodiK_JAPAN_6E58_SYMBOL = 289,
	VodiK_JAPAN_6ECB_SYMBOL = 290,
	VodiK_JAPAN_6F5F_SYMBOL = 291,
	VodiK_JAPAN_718A_SYMBOL = 292,
	VodiK_JAPAN_7267_SYMBOL = 293,
	VodiK_JAPAN_738B_SYMBOL = 294,
	VodiK_JAPAN_7530_SYMBOL = 295,
	VodiK_JAPAN_7559_SYMBOL = 296,
	VodiK_JAPAN_76F8_SYMBOL = 297,
	VodiK_JAPAN_77E5_SYMBOL = 298,
	VodiK_JAPAN_77F3_SYMBOL = 299,
	VodiK_JAPAN_795E_SYMBOL = 300,
	VodiK_JAPAN_798F_SYMBOL = 301,
	VodiK_JAPAN_79CB_SYMBOL = 302,
	VodiK_JAPAN_7ACB_SYMBOL = 303,
	VodiK_JAPAN_7B51_SYMBOL = 304,
	VodiK_JAPAN_7C73_SYMBOL = 305,
	VodiK_JAPAN_7DF4_SYMBOL = 306,
	VodiK_JAPAN_7E04_SYMBOL = 307,
	VodiK_JAPAN_7FA4_SYMBOL = 308,
	VodiK_JAPAN_7FD2_SYMBOL = 309,
	VodiK_JAPAN_826F_SYMBOL = 310,
	VodiK_JAPAN_8449_SYMBOL = 311,
	VodiK_JAPAN_862D_SYMBOL = 312,
	VodiK_JAPAN_8896_SYMBOL = 313,
	VodiK_JAPAN_898B_SYMBOL = 314,
	VodiK_JAPAN_8A2A_SYMBOL = 315,
	VodiK_JAPAN_8ACF_SYMBOL = 316,
	VodiK_JAPAN_8C37_SYMBOL = 317,
	VodiK_JAPAN_8C46_SYMBOL = 318,
	VodiK_JAPAN_8C4A_SYMBOL = 319,
	VodiK_JAPAN_8CC0_SYMBOL = 320,
	VodiK_JAPAN_8D8A_SYMBOL = 321,
	VodiK_JAPAN_8DB3_SYMBOL = 322,
	VodiK_JAPAN_8DEF_SYMBOL = 323,
	VodiK_JAPAN_90A3_SYMBOL = 324,
	VodiK_JAPAN_90E8_SYMBOL = 325,
	VodiK_JAPAN_90FD_SYMBOL = 326,
	VodiK_JAPAN_91CD_SYMBOL = 327,
	VodiK_JAPAN_91CE_SYMBOL = 328,
	VodiK_JAPAN_91D1_SYMBOL = 329,
	VodiK_JAPAN_91E7_SYMBOL = 330,
	VodiK_JAPAN_9234_SYMBOL = 331,
	VodiK_JAPAN_9577_SYMBOL = 332,
	VodiK_JAPAN_95A2_SYMBOL = 333,
	VodiK_JAPAN_961C_SYMBOL = 334,
	VodiK_JAPAN_962A_SYMBOL = 335,
	VodiK_JAPAN_9752_SYMBOL = 336,
	VodiK_JAPAN_9759_SYMBOL = 337,
	VodiK_JAPAN_9808_SYMBOL = 338,
	VodiK_JAPAN_98DB_SYMBOL = 339,
	VodiK_JAPAN_9928_SYMBOL = 340,
	VodiK_JAPAN_9999_SYMBOL = 341,
	VodiK_JAPAN_99AC_SYMBOL = 342,
	VodiK_JAPAN_9A28_SYMBOL = 343,
	VodiK_JAPAN_9AD8_SYMBOL = 344,
	VodiK_JAPAN_9CE5_SYMBOL = 345,
	VodiK_JAPAN_9E7F_SYMBOL = 346,

	VodiK_CYRU_SYMBOL = 347, /* У */

	VodiK_EXTLATIN_N_CARON_SYMBOL = 348,

	VodiK_ARAB_PEH_SYMBOL   = 349,
	VodiK_ARAB_KEHEH_SYMBOL = 350,

/* Hangul (Korean alphabet) */
	VodiK_HANGUL_PIEUP_SYMBOL  = 351, /* ㅂ U+3142 */
	VodiK_HANGUL_HIEUH_SYMBOL  = 352, /* ㅎ U+314E */
	VodiK_HANGUL_GA_SYMBOL     = 353, /* 가 U+AC00 */
	VodiK_HANGUL_GANG_SYMBOL   = 354, /* 강 U+AC15 */
	VodiK_HANGUL_GEO_SYMBOL    = 355, /* 거 U+AC70 */
	VodiK_HANGUL_GYEONG_SYMBOL = 356, /* 경 U+ACBD */
	VodiK_HANGUL_GO_SYMBOL     = 357, /* 고 U+ACE0 */
	VodiK_HANGUL_GWANG_SYMBOL  = 358, /* 광 U+AD11 */
	VodiK_HANGUL_GU_SYMBOL     = 359, /* 구 U+AD6C */
	VodiK_HANGUL_GI_SYMBOL     = 360, /* 기 U+AE30 */
	VodiK_HANGUL_NA_SYMBOL     = 361, /* 나 U+B098 */
	VodiK_HANGUL_NAM_SYMBOL    = 362, /* 남 U+B0A8 */
	VodiK_HANGUL_NEO_SYMBOL    = 363, /* 너 U+B108 */
	VodiK_HANGUL_NO_SYMBOL     = 364, /* 노 U+B178 */
	VodiK_HANGUL_NU_SYMBOL     = 365, /* 누 U+B204 */
	VodiK_HANGUL_DA_SYMBOL     = 366, /* 다 U+B2E4 */
	VodiK_HANGUL_DAE_SYMBOL    = 367, /* 대 U+B300 */
	VodiK_HANGUL_DEO_SYMBOL    = 368, /* 더 U+B354 */
	VodiK_HANGUL_DO_SYMBOL     = 369, /* 도 U+B3C4 */
	VodiK_HANGUL_DU_SYMBOL     = 370, /* 두 U+B450 */
	VodiK_HANGUL_DI_SYMBOL     = 371, /* 디 U+B514 */
	VodiK_HANGUL_RA_SYMBOL     = 372, /* 라 U+B77C */
	VodiK_HANGUL_REO_SYMBOL    = 373, /* 러 U+B7EC */
	VodiK_HANGUL_RO_SYMBOL     = 374, /* 로 U+B85C */
	VodiK_HANGUL_RU_SYMBOL     = 375, /* 루 U+B8E8 */
	VodiK_HANGUL_RI_SYMBOL     = 376, /* 리 U+B9AC */
	VodiK_HANGUL_MA_SYMBOL     = 377, /* 마 U+B9C8 */
	VodiK_HANGUL_MEO_SYMBOL    = 378, /* 머 U+BA38 */
	VodiK_HANGUL_MO_SYMBOL     = 379, /* 모 U+BAA8 */
	VodiK_HANGUL_MU_SYMBOL     = 380, /* 무 U+BB34 */
	VodiK_HANGUL_BA_SYMBOL     = 381, /* 바 U+BC14 */
	VodiK_HANGUL_BAE_SYMBOL    = 382, /* 배 U+BC30 */
	VodiK_HANGUL_BEO_SYMBOL    = 383, /* 버 U+BC84 */
	VodiK_HANGUL_BO_SYMBOL     = 384, /* 보 U+BCF4 */
	VodiK_HANGUL_BU_SYMBOL     = 385, /* 부 U+BD80 */
	VodiK_HANGUL_BUG_SYMBOL    = 386, /* 북 U+BD81 */
	VodiK_HANGUL_SA_SYMBOL     = 387, /* 사 U+C0AC */
	VodiK_HANGUL_SAN_SYMBOL    = 388, /* 산 U+C0B0 */
	VodiK_HANGUL_SEO_SYMBOL    = 389, /* 서 U+C11C */
	VodiK_HANGUL_SO_SYMBOL     = 390, /* 소 U+C18C */
	VodiK_HANGUL_SU_SYMBOL     = 391, /* 수 U+C218 */
	VodiK_HANGUL_A_SYMBOL      = 392, /* 아 U+C544 */
	VodiK_HANGUL_EO_SYMBOL     = 393, /* 어 U+C5B4 */
	VodiK_HANGUL_O_SYMBOL      = 394, /* 오 U+C624 */
	VodiK_HANGUL_U_SYMBOL      = 395, /* 우 U+C6B0 */
	VodiK_HANGUL_UI_SYMBOL     = 396, /* 울 U+C6B8 */
	VodiK_HANGUL_WON_SYMBOL    = 397, /* 원 U+C6D0 */
	VodiK_HANGUL_JA_SYMBOL     = 398, /* 자 U+C790 */
	VodiK_HANGUL_JEO_SYMBOL    = 399, /* 저 U+C800 */
	VodiK_HANGUL_JEON_SYMBOL   = 400, /* 전 U+C804 */
	VodiK_HANGUL_JO_SYMBOL     = 401, /* 조 U+C870 */
	VodiK_HANGUL_JU_SYMBOL     = 402, /* 주 U+C8FC */
	VodiK_HANGUL_CUNG_SYMBOL   = 403, /* 충 U+CDA9 */
	VodiK_HANGUL_TA_SYMBOL     = 404, /* 타 U+D0C0 */
	VodiK_HANGUL_HA_SYMBOL     = 405, /* 하 U+D558 */
	VodiK_HANGUL_HEO_SYMBOL    = 406, /* 허 U+D5C8 */
	VodiK_HANGUL_HO_SYMBOL     = 407, /* 호 U+D638 */
	VodiK_HANGUL_HI_SYMBOL     = 408, /* 히 U+D788 */
	VodiK_WHEELCHAIR_SYMBOL    = 409, /* ♿ U+267F */
	VodiK_HANGUL_CEON_SYMBOL = 410, /* 천 U+CC9C */
	VodiK_HANGUL_IN_SYMBOL = 411, /* 인 U+C778 */
	VodiK_HANGUL_BUK_SYMBOL = 412, /* 붘 U+BD98 */
	VodiK_HANGUL_JE_SYMBOL = 413, /* 제 U+C81C */

	VodiL_NSYMBOLS
};

#endif /* !defined(__VODI_SYMBOL_TYPE__) */

/******************************************************************************
 *
 *
 *
 *****************************************************************************/
