/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright 2007 Seenaptec Ltd. All rights reserved.
 * SEENAPTEC PROPRIETARY/CONFIDENTIAL.
 *
 * $Id$
 */

/*
 * Strmio.h	(N.Panasiuk)
 * include/bwr/Vodi/utils/arrio/Strmio.h
 */

/* ------------------------------------------------------------------------- */

#ifndef __VODI_UTILS_ARRIO_STRMIO__
# define __VODI_UTILS_ARRIO_STRMIO__

/******************************************************************************
 * %% BeginSection: includes
 */

# ifndef __VODI_UTILS_ARRIO_TYPES__
#  include <Vodi/utils/arrio/Types.h>
# endif

/******************************************************************************
 * %% BeginSection: function prototypes
 */
# pragma mark -
# pragma mark [ function prototypes ]
# pragma mark -

# ifndef __VODI_UTILS_LIBINTR_LINKAGE__
#  include <Vodi/utils/libintr/Linkage.h>
# endif

__MYC_BEGIN_CDECLS

__myc_flinkage__(public,libVodiUTILS) void
__attribute__((nonnull(1)))
VodiARRIOSTATEdestroy(
# if __myc_require(prototypes)
	struct vodi_arrios_state *anIOState
# endif
	);

	/*
	 * Raw Input/Output
	 */

__myc_flinkage__(public,libVodiUTILS) bo_status_t
__attribute__((nonnull(1,3)))
VodiARRIOSread(
# if __myc_require(prototypes)
	FILE *aStrm,
	struct vodi_arrios_state *anIOState /* = NULL */,
	struct vodi_image *aDest,
	vodi_rect_t const *aROIdst __myc_defval__(NULL),
	struct aorp_error *anErrPtr __myc_defval__(NULL)
# endif
	);

__myc_flinkage__(public,libVodiUTILS) bo_status_t
__attribute__((nonnull(1,3)))
VodiARRIOSwrite(
# if __myc_require(prototypes)
	FILE *aStrm,
	struct vodi_arrios_state *anIOState /* = NULL */,
	struct vodi_image const *aSource,
	vodi_rect_t const *aROIsrc __myc_defval__(NULL),
	char const *aFormat __myc_defval__(NULL),
	struct aorp_error *anErrPtr __myc_defval__(NULL)
# endif
	);

/* ------------------------------------------------------------------------- */

	/*
	 * Image Input
	 */

__myc_flinkage__(public,libVodiUTILS) struct vodi_image *
__attribute__((nonnull(1)))
VodiARRIOSgetimage(
# if __myc_require(prototypes)
	FILE *aStrm,
	struct vodi_arrios_state *anIOState /* = NULL */,
	struct vodi_size const *aRequiredSize __myc_defval__(NULL),
	struct aorp_error *anErrPtr __myc_defval__(NULL)
# endif
	);

__MYC_END_CDECLS

#endif /* !defined(__VODI_UTILS_ARRIO_STRMIO__) */

/******************************************************************************
 *
 *
 *
 *****************************************************************************/
