/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright 2007 Seenaptec Ltd. All rights reserved.
 * SEENAPTEC PROPRIETARY/CONFIDENTIAL.
 *
 * $Id$
 */

/*
 * Types.h	(N.Panasiuk)
 * include/bwr/Vodi/utils/arrio/Types.h
 */

/* ------------------------------------------------------------------------- */

#ifndef __VODI_UTILS_ARRIO_TYPES__
# define __VODI_UTILS_ARRIO_TYPES__

/******************************************************************************
 * %% BeginSection: includes
 */

# ifndef __VODI_UTILS_TYPES__
#  include <Vodi/utils/Types.h>
# endif

# ifndef __VODI_TYPES__
#  include <Vodi/Types.h>
# endif

# ifndef __BO_LIBC_STDIO__
#  include <Bo/libc/Stdio.h>
# endif

/******************************************************************************
 * %% BeginSection: type/constant declarations
 */
# pragma mark -
# pragma mark [ type/constant declarations ]
# pragma mark -

/*
 * I/O state of stream
 */

struct vodi_arrios_state {
	struct bo_absbuf  ios_buf;
	ptrdiff_t         ios_bpos;
		/* Position in the buffer [.ios_buf] to read from/to write to. */
	size_t            ios_wcnt;
		/* Available space for writing */
	size_t            ios_rcnt;
		/* Number of bytes available for reading */
	size_t            ios_fsz;
		/* Read the file size */
};

# define VODI_ARRIOS_STATE_ZERO_INITIALIZER \
	VODI_ARRIOS_STATE_INITIALIZER(0,NULL,0,0,0,0)

# define VODI_ARRIOS_STATE_INITIALIZER(aBsize,aBbase,aBpos,aWcnt,aRcnt,aFsz) \
	{ {(aBsize), (aBbase)}, (aBpos), (aWcnt), (aRcnt), (aFsz) }

# define VODI_ARRIOS_STATE_ZeroInit(anIOState) \
	VODI_ARRIOS_STATE_Init(anIOState,0,NULL,0,0,0,0)

# define VODI_ARRIOS_STATE_Init(anIOState,aBsize,aBbase,aBpos,aWcnt,aRcnt,aFsz) \
	do { \
		struct vodi_arrios_state *___ios_init_state = (anIOState); \
		___ios_init_state->ios_buf.size = (aBsize); \
		___ios_init_state->ios_buf.base = (aBbase); \
		___ios_init_state->ios_bpos = (aBpos); \
		___ios_init_state->ios_wcnt = (aWcnt); \
		___ios_init_state->ios_rcnt = (aRcnt); \
		___ios_init_state->ios_fsz = (aFsz); \
	} while (0)

# if 0
/* ============================================================================
 * @{
 * GRAB-IMAGE context structure
 */
# pragma mark -

struct vodi_grabimg_ctx {
	char const    *img_frmt;
		/* format of the grabimg in the file */
	char const    *img_path;
		/* path to the file that contains the grabimg */
	bo_off_t       img_index;
		/* position in the file to the grabimg [in images] */
	bo_off_t       img_fpos;
		/* position in the file to the grabimg [in bytes] */
	size_t         img_size;
		/* size grabimg in the file [in bytes] */
};

# define VODI_GRABIMG_Frmt(aGrabimg) (__VODI_GRABIMG_CTX(aGrabimg)->img_frmt)
# define VODI_GRABIMG_Path(aGrabimg) (__VODI_GRABIMG_CTX(aGrabimg)->img_path)
# define VODI_GRABIMG_Index(aGrabimg) (__VODI_GRABIMG_CTX(aGrabimg)->img_index)
# define VODI_GRABIMG_Fpos(aGrabimg) (__VODI_GRABIMG_CTX(aGrabimg)->img_fpos)
# define VODI_GRABIMG_Size(aGrabimg) (__VODI_GRABIMG_CTX(aGrabimg)->img_size)

# define __VODI_GRABIMG_CTX(x) \
	((struct vodi_grabimg_ctx *)((x)->img_uctx.u.udc_udata))
/* @} */
# endif

#endif /* !defined(__VODI_UTILS_ARRIO_TYPES__) */

/******************************************************************************
 *
 *
 *
 *****************************************************************************/