/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright 2007 Seenaptec Ltd. All rights reserved.
 * SEENAPTEC PROPRIETARY/CONFIDENTIAL.
 *
 * $Id$
 */

/*
 * Linkage.h	(N.Panasiuk)
 * include/bwr/Vodi/utils/libintr/Linkage.h
 */

/* ------------------------------------------------------------------------- */

#ifndef __VODI_UTILS_LIBINTR_LINKAGE__
# define __VODI_UTILS_LIBINTR_LINKAGE__

/******************************************************************************
 * %% BeginSection: includes
 */

# include <Bo/Cdefs.h>

/******************************************************************************
 * %% BeginSection: definitions
 */

/*
 * To use macros __myc_flinkage__(), __myc_vlinkage__() it is needed
 * to define the next macros: 
 */
# if __myc_build_shlib(libVodiUTILS)

#  define myc_flinkage_public_libVodiUTILS myc_flinkage_shlib_export
#  define myc_flinkage_private_libVodiUTILS myc_flinkage_shlib_private
#  define myc_flinkage_internal_libVodiUTILS myc_flinkage_shlib_internal

#  define myc_vlinkage_public_libVodiUTILS myc_vlinkage_shlib_export
#  define myc_vlinkage_private_libVodiUTILS myc_vlinkage_shlib_private
#  define myc_vlinkage_internal_libVodiUTILS myc_vlinkage_shlib_internal

# else
# if __myc_use_shlib(libVodiUTILS)

#  define myc_flinkage_public_libVodiUTILS myc_flinkage_shlib_import
#  define myc_flinkage_private_libVodiUTILS myc_flinkage_shlib_private
#  define myc_flinkage_internal_libVodiUTILS myc_flinkage_shlib_internal

#  define myc_vlinkage_public_libVodiUTILS myc_vlinkage_shlib_import
#  define myc_vlinkage_private_libVodiUTILS myc_vlinkage_shlib_private
#  define myc_vlinkage_internal_libVodiUTILS myc_vlinkage_shlib_internal

# else
# if __myc_build_archive(libVodiUTILS)

#  define myc_flinkage_public_libVodiUTILS myc_flinkage_archive_export
#  define myc_flinkage_private_libVodiUTILS myc_flinkage_archive_private
#  define myc_flinkage_internal_libVodiUTILS myc_flinkage_archive_internal

#  define myc_vlinkage_public_libVodiUTILS myc_vlinkage_archive_export
#  define myc_vlinkage_private_libVodiUTILS myc_vlinkage_archive_private
#  define myc_vlinkage_internal_libVodiUTILS myc_vlinkage_archive_internal

# else
# if __myc_use_archive(libVodiUTILS)

#  define myc_flinkage_public_libVodiUTILS myc_flinkage_archive_import
#  define myc_flinkage_private_libVodiUTILS myc_flinkage_archive_private
#  define myc_flinkage_internal_libVodiUTILS myc_flinkage_archive_internal

#  define myc_vlinkage_public_libVodiUTILS myc_vlinkage_archive_import
#  define myc_vlinkage_private_libVodiUTILS myc_vlinkage_archive_private
#  define myc_vlinkage_internal_libVodiUTILS myc_vlinkage_archive_internal

# else

#  define myc_flinkage_public_libVodiUTILS myc_flinkage_shlib_export
#  define myc_flinkage_private_libVodiUTILS myc_flinkage_shlib_private
#  define myc_flinkage_internal_libVodiUTILS myc_flinkage_shlib_internal

#  define myc_vlinkage_public_libVodiUTILS myc_vlinkage_shlib_export
#  define myc_vlinkage_private_libVodiUTILS myc_vlinkage_shlib_private
#  define myc_vlinkage_internal_libVodiUTILS myc_vlinkage_shlib_internal

# endif /* __myc_use_archive(libVodiUTILS) */
# endif /* __myc_build_archive(libVodiUTILS) */
# endif /* __myc_use_shlib(libVodiUTILS) */
# endif /* __myc_build_shlib(libVodiUTILS) */

#endif /* !defined(__VODI_UTILS_LIBINTR_LINKAGE__) */

/******************************************************************************
 *
 *
 *
 *****************************************************************************/
