/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright (c) 2005-2007 V.Sokur
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

/*
 * Fuzzymatch.h	(N.Panasiuk)
 * include/Bo/stralg/Fuzzymatch.h
 *
 * $Id$
 */

/* ------------------------------------------------------------------------- */

#ifndef __BO_STRALG_FUZZYMATCH__
# define __BO_STRALG_FUZZYMATCH__

/******************************************************************************
 * %% BeginSection: includes
 */

# include <Bo/Types.h>

/******************************************************************************
 * %% BeginSection: function prototypes
 */
# pragma mark -
# pragma mark [ function prototypes ]
# pragma mark -

# include <Bo/BoLinkage.h>

__MYC_BEGIN_CDECLS

/*
 * Returned status
 */

/* Failure */
# define BoS_LEVENSHTEIN_NOMEM BoS_ERR

__myc_flinkage__(public,libBo) ssize_t
__attribute__((nonnull(1,3)))
BoLevenshtein(
# if __myc_require(prototypes)
	char const *aLhs,
	size_t aLhsLen, /* -1 means that the data len should be calculated */
	char const *aRhs,
	size_t aRhsLen, /* -1 means that the data len should be calculated */
	int aCostIns __myc_defval__(1),
	int aCostRep __myc_defval__(1),
	int aCostDel __myc_defval__(1)
# endif
	);

__myc_flinkage__(public,libBo) ssize_t
__attribute__((nonnull(1,3)))
BoWLevenshtein(
# if __myc_require(prototypes)
	wchar_t const *aLhs,
	size_t aLhsLen, /* -1 means that the data len should be calculated */
	wchar_t const *aRhs,
	size_t aRhsLen, /* -1 means that the data len should be calculated */
	int aCostIns __myc_defval__(1),
	int aCostRep __myc_defval__(1),
	int aCostDel __myc_defval__(1)
# endif
	);

__MYC_END_CDECLS

#endif /* !__BO_STRALG_FUZZYMATCH__ */

/******************************************************************************
 * Revision History:
 *		$Log$
 *
 *****************************************************************************/
