
/* -*- Mode: c; tab-width: 4; -*-
 * -*- ex: ts=4 -*-
 */

/*
 * Copyright 2007 Seenaptec Ltd. All rights reserved.
 * SEENAPTEC PROPRIETARY/CONFIDENTIAL.
 *
 * $Id$
 */

/*
 * lpvType.h	(Y.Bukhtiyarov)
 * include/Vodi/lpvType.h
 */

/* ------------------------------------------------------------------------- */

#ifndef __VODI_LPVTYPE__
# define __VODI_LPVTYPE__

/******************************************************************************
 * %% BeginSection: includes
 */

# ifndef __BO_SYS_TYPES__
#  include <Bo/sys/Types.h>
# endif

# ifndef __VODI_ISO3166__
#  include <Vodi/ISO3166.h>
# endif

/******************************************************************************
 * %% BeginSection: type/constant declarations
 */
# pragma mark -
# pragma mark [ type/constant declarations ]
# pragma mark -

# ifndef VODI_PLATEID_TYPE_DEFINED
#  define VODI_PLATEID_TYPE_DEFINED

typedef u_int32_t vodi_plateid_t;
typedef u_int32_t vodi_plateid_x;

#  define VodiK_INVAL_PLATEID ((vodi_plateid_t)-1)
#  define VodiK_NULL_PLATEID (0)
#  define VodiK_ANY_PLATEID (1)
#  define VodiK_UNK_PLATEID (2)

# endif /* !defined(VODI_PLATEID_TYPE_DEFINED) */

/*
 * PLATE ID declarations
 */

/* vodi_plateid_t
   _VODI_MAKE_PLATEID3(int aCountry, int aSubdivision, int aCode); */
# define _VODI_MAKE_PLATEID3(x,y,z) ( \
		(((x) & 0xfff) << 20) | (((y) & 0x3ff) << 10) | ((z) & 0x3ff) \
	)

/* vodi_plateid_t _VODI_MAKE_PLATEID(int aCountry, int aCode); */
# define _VODI_MAKE_PLATEID(x,y) _VODI_MAKE_PLATEID3(x,0,y)

/* int _VODI_PLATEID_CCODE(vodi_plateid_t anId); */
# define _VODI_PLATEID_CCODE(anId) ((((u_int32_t)(anId)) >> 20) & 0xfff)

/* int _VODI_PLATEID_SCODE(vodi_plateid_t anId); */
# define _VODI_PLATEID_SCODE(anId) ((((u_int32_t)(anId)) >> 10) & 0x3ff)

/* int _VODI_PLATEID_PCODE(vodi_plateid_t anId); */
# define _VODI_PLATEID_PCODE(anId) ((anId) & 0x3ff)

/*
 * Well-known PLATE ID constants
 */

 /*
 * ABH
 * @{
 */
# define _VODI_MAKE_PLATEID_ABH(aCode) _VODI_MAKE_PLATEID(VodiK_ABHASIA_NUMERIC,aCode)

/* mask = zxxxzz, id = 751 */
# define VodiK_ABH1_PLATE _VODI_MAKE_PLATEID_ABH(_VodiK_PCODE_ABH1)
# define _VodiK_PCODE_ABH1 1

/* mask = xxxzxxx, id = 753 */
# define VodiK_ABH2_PLATE _VODI_MAKE_PLATEID_ABH(_VodiK_PCODE_ABH2)
# define _VodiK_PCODE_ABH2 2

/* mask = zzxxxx, id = 752 */
# define VodiK_ABH3_PLATE _VODI_MAKE_PLATEID_ABH(_VodiK_PCODE_ABH3)
# define _VodiK_PCODE_ABH3 3
/* @} */


/*
 * AD
 * @{
 */
# define _VODI_MAKE_PLATEID_AD(aCode) _VODI_MAKE_PLATEID(VodiK_ANDORRA_NUMERIC,aCode)

/* mask = zxxxx, id = 824 */
# define VodiK_AD1_PLATE _VODI_MAKE_PLATEID_AD(_VodiK_PCODE_AD1)
# define _VodiK_PCODE_AD1 1

/* mask = xxxxx, id = 827 */
# define VodiK_AD2_PLATE _VODI_MAKE_PLATEID_AD(_VodiK_PCODE_AD2)
# define _VodiK_PCODE_AD2 2

/* mask = zzxz, id = 825 */
# define VodiK_AD3_PLATE _VODI_MAKE_PLATEID_AD(_VodiK_PCODE_AD3)
# define _VodiK_PCODE_AD3 3

/* mask = zzzxz, id = 826 */
# define VodiK_AD4_PLATE _VODI_MAKE_PLATEID_AD(_VodiK_PCODE_AD4)
# define _VodiK_PCODE_AD4 4
/* @} */

/*
 * AE
 * @{
 */
# define _VODI_MAKE_PLATEID_AE(aSubdivision,aCode) \
	_VODI_MAKE_PLATEID3(VodiK_UNITED_ARAB_EMIRATES_NUMERIC,aSubdivision,aCode)

/*
 * AE_AJ
 * @{
 */
# define _VODI_MAKE_PLATEID_AE_AJ(aCode) \
_VODI_MAKE_PLATEID_AE(VodiK_AE_AJ_SUBNUM,aCode)

/* mask = xxxxxz, id = 1267 */
# define VodiK_AE_AJ1_PLATE _VODI_MAKE_PLATEID_AE_AJ(_VodiK_PCODE_AE_AJ1)
# define _VodiK_PCODE_AE_AJ1 1
/* @} */


/*
 * AE_DU
 * @{
 */
# define _VODI_MAKE_PLATEID_AE_DU(aCode) \
_VODI_MAKE_PLATEID_AE(VodiK_AE_DU_SUBNUM,aCode)

/* mask = ZXXXXX, id = 429 */
# define VodiK_AE_DU1_PLATE _VODI_MAKE_PLATEID_AE_DU(_VodiK_PCODE_AE_DU1)
# define _VodiK_PCODE_AE_DU1 1

/* mask = ZXXXXX, id = 430 */
# define VodiK_AE_DU2_PLATE _VODI_MAKE_PLATEID_AE_DU(_VodiK_PCODE_AE_DU2)
# define _VodiK_PCODE_AE_DU2 2

/* mask = XXXXXX, id = 431 */
# define VodiK_AE_DU3_PLATE _VODI_MAKE_PLATEID_AE_DU(_VodiK_PCODE_AE_DU3)
# define _VodiK_PCODE_AE_DU3 3

/* mask = xxxxx, id = 1266 */
# define VodiK_AE_DU4_PLATE _VODI_MAKE_PLATEID_AE_DU(_VodiK_PCODE_AE_DU4)
# define _VodiK_PCODE_AE_DU4 4
/* @} */


/*
 * AE_RK
 * @{
 */
# define _VODI_MAKE_PLATEID_AE_RK(aCode) \
_VODI_MAKE_PLATEID_AE(VodiK_AE_RK_SUBNUM,aCode)

/* mask = xxxxx, id = 1269 */
# define VodiK_AE_RK1_PLATE _VODI_MAKE_PLATEID_AE_RK(_VodiK_PCODE_AE_RK1)
# define _VodiK_PCODE_AE_RK1 1

/* mask = xxxx, id = 1270 */
# define VodiK_AE_RK2_PLATE _VODI_MAKE_PLATEID_AE_RK(_VodiK_PCODE_AE_RK2)
# define _VodiK_PCODE_AE_RK2 2
/* @} */


/*
* AL
* @{
*/
# define _VODI_MAKE_PLATEID_AL(aCode) _VODI_MAKE_PLATEID(VodiK_ALBANIA_NUMERIC,aCode)

/* mask = ZZXXXXZ, id = 491 */
# define VodiK_AL1_PLATE _VODI_MAKE_PLATEID_AL(_VodiK_PCODE_AL1)
# define _VodiK_PCODE_AL1 1

/* mask = ZZXXXZZ, id = 492 */
# define VodiK_AL2_PLATE _VODI_MAKE_PLATEID_AL(_VodiK_PCODE_AL2)
# define _VodiK_PCODE_AL2 2

/* mask = zzxxxxx, id = 1275 */
# define VodiK_AL3_PLATE _VODI_MAKE_PLATEID_AL(_VodiK_PCODE_AL3)
# define _VodiK_PCODE_AL3 3

/* mask = zzxxxxz, id = 1277 */
# define VodiK_AL4_PLATE _VODI_MAKE_PLATEID_AL(_VodiK_PCODE_AL4)
# define _VodiK_PCODE_AL4 4

/* mask = zzxxxz, id = 1252 */
# define VodiK_AL5_PLATE _VODI_MAKE_PLATEID_AL(_VodiK_PCODE_AL5)
# define _VodiK_PCODE_AL5 5

/* mask = zzxxxz, id = 1274 */
# define VodiK_AL6_PLATE _VODI_MAKE_PLATEID_AL(_VodiK_PCODE_AL6)
# define _VodiK_PCODE_AL6 6

/* mask = zzxxx, id = 1703 */
# define VodiK_AL7_PLATE _VODI_MAKE_PLATEID_AL(_VodiK_PCODE_AL7)
# define _VodiK_PCODE_AL7 7

/* mask = zzxzzz, id = 1704 */
# define VodiK_AL8_PLATE _VODI_MAKE_PLATEID_AL(_VodiK_PCODE_AL8)
# define _VodiK_PCODE_AL8 8

/* mask = zzxzzzz, id = 1705 */
# define VodiK_AL9_PLATE _VODI_MAKE_PLATEID_AL(_VodiK_PCODE_AL9)
# define _VodiK_PCODE_AL9 9

/* mask = zzzzzzzxxxx, id = 1706 */
# define VodiK_AL10_PLATE _VODI_MAKE_PLATEID_AL(_VodiK_PCODE_AL10)
# define _VodiK_PCODE_AL10 10

/* mask = zzzzzzzxxxx, id = 1707 */
# define VodiK_AL11_PLATE _VODI_MAKE_PLATEID_AL(_VodiK_PCODE_AL11)
# define _VodiK_PCODE_AL11 11

/* mask = zzxxxz, id = 1708 */
# define VodiK_AL12_PLATE _VODI_MAKE_PLATEID_AL(_VodiK_PCODE_AL12)
# define _VodiK_PCODE_AL12 12

/* mask = zzxxxz, id = 1709 */
# define VodiK_AL13_PLATE _VODI_MAKE_PLATEID_AL(_VodiK_PCODE_AL13)
# define _VodiK_PCODE_AL13 13
/* @} */


/*
* AM
* @{
*/
# define _VODI_MAKE_PLATEID_AM(aCode) _VODI_MAKE_PLATEID(VodiK_ARMENIA_NUMERIC,aCode)

/* mask = xxzzxxx, id = 888 */
# define VodiK_AM1_PLATE _VODI_MAKE_PLATEID_AM(_VodiK_PCODE_AM1)
# define _VodiK_PCODE_AM1 1

/* mask = xxzzxxx, id = 1209 */
# define VodiK_AM2_PLATE _VODI_MAKE_PLATEID_AM(_VodiK_PCODE_AM2)
# define _VodiK_PCODE_AM2 2

/* mask = xxzxxxzz, id = 891 */
# define VodiK_AM3_PLATE _VODI_MAKE_PLATEID_AM(_VodiK_PCODE_AM3)
# define _VodiK_PCODE_AM3 3

/* mask = zzxxxx, id = 893 */
# define VodiK_AM4_PLATE _VODI_MAKE_PLATEID_AM(_VodiK_PCODE_AM4)
# define _VodiK_PCODE_AM4 4

/* mask = xxxzzxx, id = 889 */
# define VodiK_AM5_PLATE _VODI_MAKE_PLATEID_AM(_VodiK_PCODE_AM5)
# define _VodiK_PCODE_AM5 5

/* mask = zxxxx, id = 890 */
# define VodiK_AM6_PLATE _VODI_MAKE_PLATEID_AM(_VodiK_PCODE_AM6)
# define _VodiK_PCODE_AM6 6

/* mask = xxxxz, id = 892 */
# define VodiK_AM7_PLATE _VODI_MAKE_PLATEID_AM(_VodiK_PCODE_AM7)
# define _VodiK_PCODE_AM7 7

/* mask = xxxzzxx, id = 1210 */
# define VodiK_AM8_PLATE _VODI_MAKE_PLATEID_AM(_VodiK_PCODE_AM8)
# define _VodiK_PCODE_AM8 8

/* mask = zzxxx, id = 1682 */
# define VodiK_AM9_PLATE _VODI_MAKE_PLATEID_AM(_VodiK_PCODE_AM9)
# define _VodiK_PCODE_AM9 9

/* mask = zzxxxx, id = 1683 */
# define VodiK_AM10_PLATE _VODI_MAKE_PLATEID_AM(_VodiK_PCODE_AM10)
# define _VodiK_PCODE_AM10 10

/* mask = xxxxzz, id = 1684 */
# define VodiK_AM11_PLATE _VODI_MAKE_PLATEID_AM(_VodiK_PCODE_AM11)
# define _VodiK_PCODE_AM11 11

/* mask = zzxxxx, id = 1685 */
# define VodiK_AM12_PLATE _VODI_MAKE_PLATEID_AM(_VodiK_PCODE_AM12)
# define _VodiK_PCODE_AM12 12

/* mask = zzxxxzz, id = 1686 */
# define VodiK_AM13_PLATE _VODI_MAKE_PLATEID_AM(_VodiK_PCODE_AM13)
# define _VodiK_PCODE_AM13 13

/* mask = xxxzzxx, id = 1687 */
# define VodiK_AM14_PLATE _VODI_MAKE_PLATEID_AM(_VodiK_PCODE_AM14)
# define _VodiK_PCODE_AM14 14

/* mask = zxxxx, id = 1688 */
# define VodiK_AM15_PLATE _VODI_MAKE_PLATEID_AM(_VodiK_PCODE_AM15)
# define _VodiK_PCODE_AM15 15

/* mask = xxxxz, id = 1778 */
# define VodiK_AM16_PLATE _VODI_MAKE_PLATEID_AM(_VodiK_PCODE_AM16)
# define _VodiK_PCODE_AM16 16

/* mask = xxxzzxx, id = 1779 */
# define VodiK_AM17_PLATE _VODI_MAKE_PLATEID_AM(_VodiK_PCODE_AM17)
# define _VodiK_PCODE_AM17 17

/* mask = xxxxz, id = 1781 */
# define VodiK_AM18_PLATE _VODI_MAKE_PLATEID_AM(_VodiK_PCODE_AM18)
# define _VodiK_PCODE_AM18 18

/* mask = xx|zxxx, id = 2172 */
# define VodiK_AM19_PLATE _VODI_MAKE_PLATEID_AM(_VodiK_PCODE_AM19)
# define _VodiK_PCODE_AM19 19

/* mask = xxxz|xx, id = 2173 */
# define VodiK_AM20_PLATE _VODI_MAKE_PLATEID_AM(_VodiK_PCODE_AM20)
# define _VodiK_PCODE_AM20 20

/* mask = xx|zxxx, id = 2174 */
# define VodiK_AM21_PLATE _VODI_MAKE_PLATEID_AM(_VodiK_PCODE_AM21)
# define _VodiK_PCODE_AM21 21

/* mask = xx|zxxx, id = 2175 */
# define VodiK_AM22_PLATE _VODI_MAKE_PLATEID_AM(_VodiK_PCODE_AM22)
# define _VodiK_PCODE_AM22 22

/* mask = xxxz|xx, id = 2176 */
# define VodiK_AM23_PLATE _VODI_MAKE_PLATEID_AM(_VodiK_PCODE_AM23)
# define _VodiK_PCODE_AM23 23

/* mask = xxxz|xx, id = 2177 */
# define VodiK_AM24_PLATE _VODI_MAKE_PLATEID_AM(_VodiK_PCODE_AM24)
# define _VodiK_PCODE_AM24 24

/* mask = xxxx, id = 2178 */
# define VodiK_AM25_PLATE _VODI_MAKE_PLATEID_AM(_VodiK_PCODE_AM25)
# define _VodiK_PCODE_AM25 25
/* @} */


/*
 * AO
 * @{
 */
# define _VODI_MAKE_PLATEID_AO(aCode) _VODI_MAKE_PLATEID(VodiK_ANGOLA_NUMERIC,aCode)

/* mask = zzxxxxzz, id = 902 */
# define VodiK_AO1_PLATE _VODI_MAKE_PLATEID_AO(_VodiK_PCODE_AO1)
# define _VodiK_PCODE_AO1 1

/* mask = zzzxxxx, id = 2227 */
# define VodiK_AO2_PLATE _VODI_MAKE_PLATEID_AO(_VodiK_PCODE_AO2)
# define _VodiK_PCODE_AO2 2
/* @} */


/*
 * AR
 * @{
 */
# define _VODI_MAKE_PLATEID_AR(aCode) _VODI_MAKE_PLATEID(VodiK_ARGENTINA_NUMERIC,aCode)

/* mask = ZZZXXX, id = 330 */
# define VodiK_AR1_PLATE _VODI_MAKE_PLATEID_AR(_VodiK_PCODE_AR1)
# define _VodiK_PCODE_AR1 1

/* mask = ZZ-XXXX, id = 332 */
# define VodiK_AR3_PLATE _VODI_MAKE_PLATEID_AR(_VodiK_PCODE_AR3)
# define _VodiK_PCODE_AR3 3

/* mask = XXXZZZXXX, id = 333 */
# define VodiK_AR4_PLATE _VODI_MAKE_PLATEID_AR(_VodiK_PCODE_AR4)
# define _VodiK_PCODE_AR4 4

/* mask = ZXXXZZZ, id = 334 */
# define VodiK_AR5_PLATE _VODI_MAKE_PLATEID_AR(_VodiK_PCODE_AR5)
# define _VodiK_PCODE_AR5 5

/* mask = ZZZXXXX, id = 344 */
# define VodiK_AR6_PLATE _VODI_MAKE_PLATEID_AR(_VodiK_PCODE_AR6)
# define _VodiK_PCODE_AR6 6

/* mask = ZZXXXZZ, id = 1367 */
# define VodiK_AR7_PLATE _VODI_MAKE_PLATEID_AR(_VodiK_PCODE_AR7)
# define _VodiK_PCODE_AR7 7

/* mask = ZXXXZZZ, id = 1371 */
# define VodiK_AR8_PLATE _VODI_MAKE_PLATEID_AR(_VodiK_PCODE_AR8)
# define _VodiK_PCODE_AR8 8

/* mask = XXXZZZ, id = 1413 */
# define VodiK_AR9_PLATE _VODI_MAKE_PLATEID_AR(_VodiK_PCODE_AR9)
# define _VodiK_PCODE_AR9 9
/* @} */


/*
* AT
* @{
*/
# define _VODI_MAKE_PLATEID_AT(aCode) _VODI_MAKE_PLATEID(VodiK_AUSTRIA_NUMERIC,aCode)

/* mask = zxxxxxz, id = 628 */
# define VodiK_AT1_PLATE _VODI_MAKE_PLATEID_AT(_VodiK_PCODE_AT1)
# define _VodiK_PCODE_AT1 1

/* mask = zzxxxzz, id = 629 */
# define VodiK_AT2_PLATE _VODI_MAKE_PLATEID_AT(_VodiK_PCODE_AT2)
# define _VodiK_PCODE_AT2 2

/* mask = zzxxxz, id = 630 */
# define VodiK_AT3_PLATE _VODI_MAKE_PLATEID_AT(_VodiK_PCODE_AT3)
# define _VodiK_PCODE_AT3 3

/* mask = zxxxzz, id = 631 */
# define VodiK_AT4_PLATE _VODI_MAKE_PLATEID_AT(_VodiK_PCODE_AT4)
# define _VodiK_PCODE_AT4 4

/* mask = zxxzzz, id = 633 */
# define VodiK_AT5_PLATE _VODI_MAKE_PLATEID_AT(_VodiK_PCODE_AT5)
# define _VodiK_PCODE_AT5 5

/* mask = zzxzzz, id = 634 */
# define VodiK_AT6_PLATE _VODI_MAKE_PLATEID_AT(_VodiK_PCODE_AT6)
# define _VodiK_PCODE_AT6 6

/* mask = zxxxxzz, id = 640 */
# define VodiK_AT7_PLATE _VODI_MAKE_PLATEID_AT(_VodiK_PCODE_AT7)
# define _VodiK_PCODE_AT7 7

/* mask = zzxxxx, id = 636 */
# define VodiK_AT8_PLATE _VODI_MAKE_PLATEID_AT(_VodiK_PCODE_AT8)
# define _VodiK_PCODE_AT8 8

/* mask = zzxxx, id = 637 */
# define VodiK_AT9_PLATE _VODI_MAKE_PLATEID_AT(_VodiK_PCODE_AT9)
# define _VodiK_PCODE_AT9 9

/* mask = zzx, id = 638 */
# define VodiK_AT10_PLATE _VODI_MAKE_PLATEID_AT(_VodiK_PCODE_AT10)
# define _VodiK_PCODE_AT10 10

/* mask = zxx, id = 632 */
# define VodiK_AT11_PLATE _VODI_MAKE_PLATEID_AT(_VodiK_PCODE_AT11)
# define _VodiK_PCODE_AT11 11

/* mask = zzxxxxx, id = 635 */
# define VodiK_AT12_PLATE _VODI_MAKE_PLATEID_AT(_VodiK_PCODE_AT12)
# define _VodiK_PCODE_AT12 12

/* mask = zzxxzz, id = 639 */
# define VodiK_AT13_PLATE _VODI_MAKE_PLATEID_AT(_VodiK_PCODE_AT13)
# define _VodiK_PCODE_AT13 13

/* mask = zxxxxzz, id = 641 */
# define VodiK_AT14_PLATE _VODI_MAKE_PLATEID_AT(_VodiK_PCODE_AT14)
# define _VodiK_PCODE_AT14 14

/* mask = zxxzz, id = 642 */
# define VodiK_AT15_PLATE _VODI_MAKE_PLATEID_AT(_VodiK_PCODE_AT15)
# define _VodiK_PCODE_AT15 15

/* mask = zxxzzz, id = 643 */
# define VodiK_AT16_PLATE _VODI_MAKE_PLATEID_AT(_VodiK_PCODE_AT16)
# define _VodiK_PCODE_AT16 16

/* mask = zxxxxz, id = 644 */
# define VodiK_AT17_PLATE _VODI_MAKE_PLATEID_AT(_VodiK_PCODE_AT17)
# define _VodiK_PCODE_AT17 17

/* mask = zzxxx, id = 1837 */
# define VodiK_AT18_PLATE _VODI_MAKE_PLATEID_AT(_VodiK_PCODE_AT18)
# define _VodiK_PCODE_AT18 18

/* mask = zzx, id = 1838 */
# define VodiK_AT19_PLATE _VODI_MAKE_PLATEID_AT(_VodiK_PCODE_AT19)
# define _VodiK_PCODE_AT19 19

/* mask = zxx, id = 1839 */
# define VodiK_AT20_PLATE _VODI_MAKE_PLATEID_AT(_VodiK_PCODE_AT20)
# define _VodiK_PCODE_AT20 20

/* mask = zzxxxxx, id = 1840 */
# define VodiK_AT21_PLATE _VODI_MAKE_PLATEID_AT(_VodiK_PCODE_AT21)
# define _VodiK_PCODE_AT21 21

/* mask = zzxxzz, id = 1841 */
# define VodiK_AT22_PLATE _VODI_MAKE_PLATEID_AT(_VodiK_PCODE_AT22)
# define _VodiK_PCODE_AT22 22

/* mask = zxxxxzz, id = 1842 */
# define VodiK_AT23_PLATE _VODI_MAKE_PLATEID_AT(_VodiK_PCODE_AT23)
# define _VodiK_PCODE_AT23 23

/* mask = zxxzz, id = 1843 */
# define VodiK_AT24_PLATE _VODI_MAKE_PLATEID_AT(_VodiK_PCODE_AT24)
# define _VodiK_PCODE_AT24 24

/* mask = zxxzzz, id = 1844 */
# define VodiK_AT25_PLATE _VODI_MAKE_PLATEID_AT(_VodiK_PCODE_AT25)
# define _VodiK_PCODE_AT25 25

/* mask = zxxxxz, id = 1845 */
# define VodiK_AT26_PLATE _VODI_MAKE_PLATEID_AT(_VodiK_PCODE_AT26)
# define _VodiK_PCODE_AT26 26

/* mask = zzxzzz, id = 1898 */
# define VodiK_AT27_PLATE _VODI_MAKE_PLATEID_AT(_VodiK_PCODE_AT27)
# define _VodiK_PCODE_AT27 27

/* mask = zzxxzz, id = 1899 */
# define VodiK_AT28_PLATE _VODI_MAKE_PLATEID_AT(_VodiK_PCODE_AT28)
# define _VodiK_PCODE_AT28 28

/* mask = zzxxzzz, id = 1900 */
# define VodiK_AT29_PLATE _VODI_MAKE_PLATEID_AT(_VodiK_PCODE_AT29)
# define _VodiK_PCODE_AT29 29

/* mask = zzxxxxz, id = 1901 */
# define VodiK_AT30_PLATE _VODI_MAKE_PLATEID_AT(_VodiK_PCODE_AT30)
# define _VodiK_PCODE_AT30 30

/* mask = zzxxxx, id = 1902 */
# define VodiK_AT31_PLATE _VODI_MAKE_PLATEID_AT(_VodiK_PCODE_AT31)
# define _VodiK_PCODE_AT31 31

/* mask = zzxxx, id = 1903 */
# define VodiK_AT32_PLATE _VODI_MAKE_PLATEID_AT(_VodiK_PCODE_AT32)
# define _VodiK_PCODE_AT32 32

/* mask = zzx, id = 1904 */
# define VodiK_AT33_PLATE _VODI_MAKE_PLATEID_AT(_VodiK_PCODE_AT33)
# define _VodiK_PCODE_AT33 33

/* mask = zzzx, id = 1905 */
# define VodiK_AT34_PLATE _VODI_MAKE_PLATEID_AT(_VodiK_PCODE_AT34)
# define _VodiK_PCODE_AT34 34

/* mask = zzzzx, id = 1906 */
# define VodiK_AT35_PLATE _VODI_MAKE_PLATEID_AT(_VodiK_PCODE_AT35)
# define _VodiK_PCODE_AT35 35

/* mask = zzzzzx, id = 1907 */
# define VodiK_AT36_PLATE _VODI_MAKE_PLATEID_AT(_VodiK_PCODE_AT36)
# define _VodiK_PCODE_AT36 36

/* mask = zzzzzzx, id = 1908 */
# define VodiK_AT37_PLATE _VODI_MAKE_PLATEID_AT(_VodiK_PCODE_AT37)
# define _VodiK_PCODE_AT37 37

/* mask = zzxx, id = 1909 */
# define VodiK_AT38_PLATE _VODI_MAKE_PLATEID_AT(_VodiK_PCODE_AT38)
# define _VodiK_PCODE_AT38 38

/* mask = zzxxx, id = 1910 */
# define VodiK_AT39_PLATE _VODI_MAKE_PLATEID_AT(_VodiK_PCODE_AT39)
# define _VodiK_PCODE_AT39 39

/* mask = zzxxxx, id = 1911 */
# define VodiK_AT40_PLATE _VODI_MAKE_PLATEID_AT(_VodiK_PCODE_AT40)
# define _VodiK_PCODE_AT40 40

/* mask = zzxxxxx, id = 1912 */
# define VodiK_AT41_PLATE _VODI_MAKE_PLATEID_AT(_VodiK_PCODE_AT41)
# define _VodiK_PCODE_AT41 41

/* mask = zzzzx, id = 1913 */
# define VodiK_AT42_PLATE _VODI_MAKE_PLATEID_AT(_VodiK_PCODE_AT42)
# define _VodiK_PCODE_AT42 42

/* mask = zzzzzx, id = 1914 */
# define VodiK_AT43_PLATE _VODI_MAKE_PLATEID_AT(_VodiK_PCODE_AT43)
# define _VodiK_PCODE_AT43 43

/* mask = zzzzzzx, id = 1915 */
# define VodiK_AT44_PLATE _VODI_MAKE_PLATEID_AT(_VodiK_PCODE_AT44)
# define _VodiK_PCODE_AT44 44

/* mask = zzzxx, id = 1916 */
# define VodiK_AT45_PLATE _VODI_MAKE_PLATEID_AT(_VodiK_PCODE_AT45)
# define _VodiK_PCODE_AT45 45

/* mask = zzzxxx, id = 1917 */
# define VodiK_AT46_PLATE _VODI_MAKE_PLATEID_AT(_VodiK_PCODE_AT46)
# define _VodiK_PCODE_AT46 46

/* mask = zzzxxxx, id = 1918 */
# define VodiK_AT47_PLATE _VODI_MAKE_PLATEID_AT(_VodiK_PCODE_AT47)
# define _VodiK_PCODE_AT47 47

/* mask = zzzx, id = 1919 */
# define VodiK_AT48_PLATE _VODI_MAKE_PLATEID_AT(_VodiK_PCODE_AT48)
# define _VodiK_PCODE_AT48 48

/* mask = zzzzx, id = 1920 */
# define VodiK_AT49_PLATE _VODI_MAKE_PLATEID_AT(_VodiK_PCODE_AT49)
# define _VodiK_PCODE_AT49 49

/* mask = zzzzzx, id = 1921 */
# define VodiK_AT50_PLATE _VODI_MAKE_PLATEID_AT(_VodiK_PCODE_AT50)
# define _VodiK_PCODE_AT50 50

/* mask = zzzzzzx, id = 1922 */
# define VodiK_AT51_PLATE _VODI_MAKE_PLATEID_AT(_VodiK_PCODE_AT51)
# define _VodiK_PCODE_AT51 51

/* mask = zzxx, id = 1923 */
# define VodiK_AT52_PLATE _VODI_MAKE_PLATEID_AT(_VodiK_PCODE_AT52)
# define _VodiK_PCODE_AT52 52

/* mask = zzxxx, id = 1924 */
# define VodiK_AT53_PLATE _VODI_MAKE_PLATEID_AT(_VodiK_PCODE_AT53)
# define _VodiK_PCODE_AT53 53

/* mask = zzxxxx, id = 1925 */
# define VodiK_AT54_PLATE _VODI_MAKE_PLATEID_AT(_VodiK_PCODE_AT54)
# define _VodiK_PCODE_AT54 54

/* mask = zzxxxxx, id = 1926 */
# define VodiK_AT55_PLATE _VODI_MAKE_PLATEID_AT(_VodiK_PCODE_AT55)
# define _VodiK_PCODE_AT55 55

/* mask = zzzzx, id = 1927 */
# define VodiK_AT56_PLATE _VODI_MAKE_PLATEID_AT(_VodiK_PCODE_AT56)
# define _VodiK_PCODE_AT56 56

/* mask = zzzzzx, id = 1928 */
# define VodiK_AT57_PLATE _VODI_MAKE_PLATEID_AT(_VodiK_PCODE_AT57)
# define _VodiK_PCODE_AT57 57

/* mask = zzzzzzx, id = 1929 */
# define VodiK_AT58_PLATE _VODI_MAKE_PLATEID_AT(_VodiK_PCODE_AT58)
# define _VodiK_PCODE_AT58 58

/* mask = zzzxx, id = 1930 */
# define VodiK_AT59_PLATE _VODI_MAKE_PLATEID_AT(_VodiK_PCODE_AT59)
# define _VodiK_PCODE_AT59 59

/* mask = zzzxxx, id = 1931 */
# define VodiK_AT60_PLATE _VODI_MAKE_PLATEID_AT(_VodiK_PCODE_AT60)
# define _VodiK_PCODE_AT60 60

/* mask = zzzxxxx, id = 1932 */
# define VodiK_AT61_PLATE _VODI_MAKE_PLATEID_AT(_VodiK_PCODE_AT61)
# define _VodiK_PCODE_AT61 61

/* mask = zxx, id = 1933 */
# define VodiK_AT62_PLATE _VODI_MAKE_PLATEID_AT(_VodiK_PCODE_AT62)
# define _VodiK_PCODE_AT62 62

/* mask = zzxxxxx, id = 1934 */
# define VodiK_AT63_PLATE _VODI_MAKE_PLATEID_AT(_VodiK_PCODE_AT63)
# define _VodiK_PCODE_AT63 63

/* mask = zzxxzz, id = 1935 */
# define VodiK_AT64_PLATE _VODI_MAKE_PLATEID_AT(_VodiK_PCODE_AT64)
# define _VodiK_PCODE_AT64 64

/* mask = zxxxxzz, id = 1936 */
# define VodiK_AT65_PLATE _VODI_MAKE_PLATEID_AT(_VodiK_PCODE_AT65)
# define _VodiK_PCODE_AT65 65

/* mask = zxxzz, id = 1937 */
# define VodiK_AT66_PLATE _VODI_MAKE_PLATEID_AT(_VodiK_PCODE_AT66)
# define _VodiK_PCODE_AT66 66

/* mask = zxxzzz, id = 1938 */
# define VodiK_AT67_PLATE _VODI_MAKE_PLATEID_AT(_VodiK_PCODE_AT67)
# define _VodiK_PCODE_AT67 67

/* mask = zxxxxz, id = 1939 */
# define VodiK_AT68_PLATE _VODI_MAKE_PLATEID_AT(_VodiK_PCODE_AT68)
# define _VodiK_PCODE_AT68 68
/* @} */

/*
* AU
* @{
*/
# define _VODI_MAKE_PLATEID_AU(aSubdivision,aCode) \
_VODI_MAKE_PLATEID3(VodiK_AUSTRALIA_NUMERIC,aSubdivision,aCode)

/*
 * AU_ACT
 * @{
 */
# define _VODI_MAKE_PLATEID_AU_ACT(aCode) \
_VODI_MAKE_PLATEID_AU(VodiK_AU_ACT_SUBNUM,aCode)

/* mask = zzzxxz, id = 584 */
# define VodiK_AU_ACT1_PLATE _VODI_MAKE_PLATEID_AU_ACT(_VodiK_PCODE_AU_ACT1)
# define _VodiK_PCODE_AU_ACT1 1

/* mask = zzxxxx, id = 590 */
# define VodiK_AU_ACT2_PLATE _VODI_MAKE_PLATEID_AU_ACT(_VodiK_PCODE_AU_ACT2)
# define _VodiK_PCODE_AU_ACT2 2

/* mask = xxxxxx, id = 586 */
# define VodiK_AU_ACT3_PLATE _VODI_MAKE_PLATEID_AU_ACT(_VodiK_PCODE_AU_ACT3)
# define _VodiK_PCODE_AU_ACT3 3

/* mask = zzxxxx, id = 587 */
# define VodiK_AU_ACT4_PLATE _VODI_MAKE_PLATEID_AU_ACT(_VodiK_PCODE_AU_ACT4)
# define _VodiK_PCODE_AU_ACT4 4

/* mask = xxxxx, id = 588 */
# define VodiK_AU_ACT5_PLATE _VODI_MAKE_PLATEID_AU_ACT(_VodiK_PCODE_AU_ACT5)
# define _VodiK_PCODE_AU_ACT5 5

/* mask = zzxxxx, id = 585 */
# define VodiK_AU_ACT6_PLATE _VODI_MAKE_PLATEID_AU_ACT(_VodiK_PCODE_AU_ACT6)
# define _VodiK_PCODE_AU_ACT6 6

/* mask = zxxxxx, id = 589 */
# define VodiK_AU_ACT7_PLATE _VODI_MAKE_PLATEID_AU_ACT(_VodiK_PCODE_AU_ACT7)
# define _VodiK_PCODE_AU_ACT7 7

/* mask = zxxx, id = 591 */
# define VodiK_AU_ACT8_PLATE _VODI_MAKE_PLATEID_AU_ACT(_VodiK_PCODE_AU_ACT8)
# define _VodiK_PCODE_AU_ACT8 8

/* mask = zzzxxx, id = 592 */
# define VodiK_AU_ACT9_PLATE _VODI_MAKE_PLATEID_AU_ACT(_VodiK_PCODE_AU_ACT9)
# define _VodiK_PCODE_AU_ACT9 9
/* @} */


/*
 * AU_NSW
 * @{
 */
# define _VODI_MAKE_PLATEID_AU_NSW(aCode) \
_VODI_MAKE_PLATEID_AU(VodiK_AU_NSW_SUBNUM,aCode)

/* mask = zzxxzz, id = 593 */
# define VodiK_AU_NSW1_PLATE _VODI_MAKE_PLATEID_AU_NSW(_VodiK_PCODE_AU_NSW1)
# define _VodiK_PCODE_AU_NSW1 1

/* mask = zzzxx, id = 597 */
# define VodiK_AU_NSW2_PLATE _VODI_MAKE_PLATEID_AU_NSW(_VodiK_PCODE_AU_NSW2)
# define _VodiK_PCODE_AU_NSW2 2

/* mask = zzxxx, id = 598 */
# define VodiK_AU_NSW3_PLATE _VODI_MAKE_PLATEID_AU_NSW(_VodiK_PCODE_AU_NSW3)
# define _VodiK_PCODE_AU_NSW3 3

/* mask = zzzxxz, id = 594 */
# define VodiK_AU_NSW4_PLATE _VODI_MAKE_PLATEID_AU_NSW(_VodiK_PCODE_AU_NSW4)
# define _VodiK_PCODE_AU_NSW4 4

/* mask = zzzxxx, id = 595 */
# define VodiK_AU_NSW5_PLATE _VODI_MAKE_PLATEID_AU_NSW(_VodiK_PCODE_AU_NSW5)
# define _VodiK_PCODE_AU_NSW5 5

/* mask = zxxxxx, id = 596 */
# define VodiK_AU_NSW6_PLATE _VODI_MAKE_PLATEID_AU_NSW(_VodiK_PCODE_AU_NSW6)
# define _VodiK_PCODE_AU_NSW6 6

/* mask = zxxxx, id = 599 */
# define VodiK_AU_NSW7_PLATE _VODI_MAKE_PLATEID_AU_NSW(_VodiK_PCODE_AU_NSW7)
# define _VodiK_PCODE_AU_NSW7 7

/* mask = zzxxxx, id = 600 */
# define VodiK_AU_NSW8_PLATE _VODI_MAKE_PLATEID_AU_NSW(_VodiK_PCODE_AU_NSW8)
# define _VodiK_PCODE_AU_NSW8 8

/* mask = zzzxxz, id = 601 */
# define VodiK_AU_NSW9_PLATE _VODI_MAKE_PLATEID_AU_NSW(_VodiK_PCODE_AU_NSW9)
# define _VodiK_PCODE_AU_NSW9 9

/* mask = xxxxz, id = 602 */
# define VodiK_AU_NSW10_PLATE _VODI_MAKE_PLATEID_AU_NSW(_VodiK_PCODE_AU_NSW10)
# define _VodiK_PCODE_AU_NSW10 10

/* mask = zzxxxx, id = 603 */
# define VodiK_AU_NSW11_PLATE _VODI_MAKE_PLATEID_AU_NSW(_VodiK_PCODE_AU_NSW11)
# define _VodiK_PCODE_AU_NSW11 11

/* mask = zzxxxx, id = 604 */
# define VodiK_AU_NSW12_PLATE _VODI_MAKE_PLATEID_AU_NSW(_VodiK_PCODE_AU_NSW12)
# define _VodiK_PCODE_AU_NSW12 12

/* mask = xxxxxz, id = 605 */
# define VodiK_AU_NSW13_PLATE _VODI_MAKE_PLATEID_AU_NSW(_VodiK_PCODE_AU_NSW13)
# define _VodiK_PCODE_AU_NSW13 13

/* mask = zzzxx, id = 597 */
# define VodiK_AU_NSW14_PLATE _VODI_MAKE_PLATEID_AU_NSW(_VodiK_PCODE_AU_NSW14)
# define _VodiK_PCODE_AU_NSW14 14

/* mask = zzxxx, id = 598 */
# define VodiK_AU_NSW15_PLATE _VODI_MAKE_PLATEID_AU_NSW(_VodiK_PCODE_AU_NSW15)
# define _VodiK_PCODE_AU_NSW15 15

/* mask = zzzzzz, id = 2029 */
# define VodiK_AU_NSW16_PLATE _VODI_MAKE_PLATEID_AU_NSW(_VodiK_PCODE_AU_NSW16)
# define _VodiK_PCODE_AU_NSW16 16

/* mask = zzzzzz, id = 2030 */
# define VodiK_AU_NSW17_PLATE _VODI_MAKE_PLATEID_AU_NSW(_VodiK_PCODE_AU_NSW17)
# define _VodiK_PCODE_AU_NSW17 17

/* mask = zzzzxx, id = 2031 */
# define VodiK_AU_NSW18_PLATE _VODI_MAKE_PLATEID_AU_NSW(_VodiK_PCODE_AU_NSW18)
# define _VodiK_PCODE_AU_NSW18 18

/* mask = zzzzzx, id = 2035 */
# define VodiK_AU_NSW19_PLATE _VODI_MAKE_PLATEID_AU_NSW(_VodiK_PCODE_AU_NSW19)
# define _VodiK_PCODE_AU_NSW19 19

/* mask = zzzxxz, id = 594 */
# define VodiK_AU_NSW20_PLATE _VODI_MAKE_PLATEID_AU_NSW(_VodiK_PCODE_AU_NSW20)
# define _VodiK_PCODE_AU_NSW20 20

/* mask = zzzxxx, id = 595 */
# define VodiK_AU_NSW21_PLATE _VODI_MAKE_PLATEID_AU_NSW(_VodiK_PCODE_AU_NSW21)
# define _VodiK_PCODE_AU_NSW21 21

/* mask = zxxxxx, id = 596 */
# define VodiK_AU_NSW22_PLATE _VODI_MAKE_PLATEID_AU_NSW(_VodiK_PCODE_AU_NSW22)
# define _VodiK_PCODE_AU_NSW22 22

/* mask = zxxxx, id = 599 */
# define VodiK_AU_NSW23_PLATE _VODI_MAKE_PLATEID_AU_NSW(_VodiK_PCODE_AU_NSW23)
# define _VodiK_PCODE_AU_NSW23 23

/* mask = zzxxxx, id = 600 */
# define VodiK_AU_NSW24_PLATE _VODI_MAKE_PLATEID_AU_NSW(_VodiK_PCODE_AU_NSW24)
# define _VodiK_PCODE_AU_NSW24 24

/* mask = zzzxxz, id = 601 */
# define VodiK_AU_NSW25_PLATE _VODI_MAKE_PLATEID_AU_NSW(_VodiK_PCODE_AU_NSW25)
# define _VodiK_PCODE_AU_NSW25 25

/* mask = xxxxz, id = 602 */
# define VodiK_AU_NSW26_PLATE _VODI_MAKE_PLATEID_AU_NSW(_VodiK_PCODE_AU_NSW26)
# define _VodiK_PCODE_AU_NSW26 26

/* mask = zzxxxx, id = 603 */
# define VodiK_AU_NSW27_PLATE _VODI_MAKE_PLATEID_AU_NSW(_VodiK_PCODE_AU_NSW27)
# define _VodiK_PCODE_AU_NSW27 27

/* mask = zzxxxx, id = 604 */
# define VodiK_AU_NSW28_PLATE _VODI_MAKE_PLATEID_AU_NSW(_VodiK_PCODE_AU_NSW28)
# define _VodiK_PCODE_AU_NSW28 28

/* mask = xxxxxz, id = 605 */
# define VodiK_AU_NSW29_PLATE _VODI_MAKE_PLATEID_AU_NSW(_VodiK_PCODE_AU_NSW29)
# define _VodiK_PCODE_AU_NSW29 29
/* @} */


/*
 * AU_NT
 * @{
 */
# define _VODI_MAKE_PLATEID_AU_NT(aCode) \
_VODI_MAKE_PLATEID_AU(VodiK_AU_NT_SUBNUM,aCode)

/* mask = xxxxxx, id = 606 */
# define VodiK_AU_NT1_PLATE _VODI_MAKE_PLATEID_AU_NT(_VodiK_PCODE_AU_NT1)
# define _VodiK_PCODE_AU_NT1 1

/* mask = xxxxxx, id = 612 */
# define VodiK_AU_NT2_PLATE _VODI_MAKE_PLATEID_AU_NT(_VodiK_PCODE_AU_NT2)
# define _VodiK_PCODE_AU_NT2 2

/* mask = xxxxx, id = 614 */
# define VodiK_AU_NT3_PLATE _VODI_MAKE_PLATEID_AU_NT(_VodiK_PCODE_AU_NT3)
# define _VodiK_PCODE_AU_NT3 3

/* mask = zzxx, id = 607 */
# define VodiK_AU_NT4_PLATE _VODI_MAKE_PLATEID_AU_NT(_VodiK_PCODE_AU_NT4)
# define _VodiK_PCODE_AU_NT4 4

/* mask = zxxx, id = 608 */
# define VodiK_AU_NT5_PLATE _VODI_MAKE_PLATEID_AU_NT(_VodiK_PCODE_AU_NT5)
# define _VodiK_PCODE_AU_NT5 5

/* mask = zzzzxxx, id = 610 */
# define VodiK_AU_NT7_PLATE _VODI_MAKE_PLATEID_AU_NT(_VodiK_PCODE_AU_NT7)
# define _VodiK_PCODE_AU_NT7 7

/* mask = xx, id = 611 */
# define VodiK_AU_NT8_PLATE _VODI_MAKE_PLATEID_AU_NT(_VodiK_PCODE_AU_NT8)
# define _VodiK_PCODE_AU_NT8 8

/* mask = xxxxxx, id = 613 */
# define VodiK_AU_NT9_PLATE _VODI_MAKE_PLATEID_AU_NT(_VodiK_PCODE_AU_NT9)
# define _VodiK_PCODE_AU_NT9 9

/* mask = zzzxxx, id = 615 */
# define VodiK_AU_NT10_PLATE _VODI_MAKE_PLATEID_AU_NT(_VodiK_PCODE_AU_NT10)
# define _VodiK_PCODE_AU_NT10 10

/* mask = zxxxxx, id = 1227 */
# define VodiK_AU_NT11_PLATE _VODI_MAKE_PLATEID_AU_NT(_VodiK_PCODE_AU_NT11)
# define _VodiK_PCODE_AU_NT11 11
/* @} */


/*
 * AU_QLD
 * @{
 */
# define _VODI_MAKE_PLATEID_AU_QLD(aCode) \
_VODI_MAKE_PLATEID_AU(VodiK_AU_QLD_SUBNUM,aCode)

/* mask = xxxzzz, id = 616 */
# define VodiK_AU_QLD1_PLATE _VODI_MAKE_PLATEID_AU_QLD(_VodiK_PCODE_AU_QLD1)
# define _VodiK_PCODE_AU_QLD1 1

/* mask = xxxzz, id = 619 */
# define VodiK_AU_QLD2_PLATE _VODI_MAKE_PLATEID_AU_QLD(_VodiK_PCODE_AU_QLD2)
# define _VodiK_PCODE_AU_QLD2 2

/* mask = zxxxxx, id = 617 */
# define VodiK_AU_QLD3_PLATE _VODI_MAKE_PLATEID_AU_QLD(_VodiK_PCODE_AU_QLD3)
# define _VodiK_PCODE_AU_QLD3 3

/* mask = zzzxx, id = 618 */
# define VodiK_AU_QLD4_PLATE _VODI_MAKE_PLATEID_AU_QLD(_VodiK_PCODE_AU_QLD4)
# define _VodiK_PCODE_AU_QLD4 4

/* mask = zxxxxx, id = 620 */
# define VodiK_AU_QLD5_PLATE _VODI_MAKE_PLATEID_AU_QLD(_VodiK_PCODE_AU_QLD5)
# define _VodiK_PCODE_AU_QLD5 5

/* mask = zxxxxx, id = 621 */
# define VodiK_AU_QLD6_PLATE _VODI_MAKE_PLATEID_AU_QLD(_VodiK_PCODE_AU_QLD6)
# define _VodiK_PCODE_AU_QLD6 6

/* mask = zzzxxz, id = 622 */
# define VodiK_AU_QLD7_PLATE _VODI_MAKE_PLATEID_AU_QLD(_VodiK_PCODE_AU_QLD7)
# define _VodiK_PCODE_AU_QLD7 7

/* mask = zxxxxx, id = 623 */
# define VodiK_AU_QLD8_PLATE _VODI_MAKE_PLATEID_AU_QLD(_VodiK_PCODE_AU_QLD8)
# define _VodiK_PCODE_AU_QLD8 8

/* mask = zzxxzz, id = 624 */
# define VodiK_AU_QLD9_PLATE _VODI_MAKE_PLATEID_AU_QLD(_VodiK_PCODE_AU_QLD9)
# define _VodiK_PCODE_AU_QLD9 9

/* mask = zzzxx, id = 625 */
# define VodiK_AU_QLD10_PLATE _VODI_MAKE_PLATEID_AU_QLD(_VodiK_PCODE_AU_QLD10)
# define _VodiK_PCODE_AU_QLD10 10

/* mask = zxzz, id = 2022 */
# define VodiK_AU_QLD11_PLATE _VODI_MAKE_PLATEID_AU_QLD(_VodiK_PCODE_AU_QLD11)
# define _VodiK_PCODE_AU_QLD11 11
/* @} */


/*
 * AU_SA
 * @{
 */
# define _VODI_MAKE_PLATEID_AU_SA(aCode) \
_VODI_MAKE_PLATEID_AU(VodiK_AU_SA_SUBNUM,aCode)

/* mask = zzzxxx, id = 646 */
# define VodiK_AU_SA1_PLATE _VODI_MAKE_PLATEID_AU_SA(_VodiK_PCODE_AU_SA1)
# define _VodiK_PCODE_AU_SA1 1

/* mask = zxxxzzz, id = 1256 */
# define VodiK_AU_SA2_PLATE _VODI_MAKE_PLATEID_AU_SA(_VodiK_PCODE_AU_SA2)
# define _VodiK_PCODE_AU_SA2 2

/* mask = zzzxxx, id = 645 */
# define VodiK_AU_SA3_PLATE _VODI_MAKE_PLATEID_AU_SA(_VodiK_PCODE_AU_SA3)
# define _VodiK_PCODE_AU_SA3 3

/* mask = zzxxxx, id = 655 */
# define VodiK_AU_SA4_PLATE _VODI_MAKE_PLATEID_AU_SA(_VodiK_PCODE_AU_SA4)
# define _VodiK_PCODE_AU_SA4 4

/* mask = xxxzz, id = 651 */
# define VodiK_AU_SA5_PLATE _VODI_MAKE_PLATEID_AU_SA(_VodiK_PCODE_AU_SA5)
# define _VodiK_PCODE_AU_SA5 5

/* mask = zzzzxxxx, id = 647 */
# define VodiK_AU_SA6_PLATE _VODI_MAKE_PLATEID_AU_SA(_VodiK_PCODE_AU_SA6)
# define _VodiK_PCODE_AU_SA6 6

/* mask = zzzxxz, id = 648 */
# define VodiK_AU_SA7_PLATE _VODI_MAKE_PLATEID_AU_SA(_VodiK_PCODE_AU_SA7)
# define _VodiK_PCODE_AU_SA7 7

/* mask = xxxz, id = 649 */
# define VodiK_AU_SA8_PLATE _VODI_MAKE_PLATEID_AU_SA(_VodiK_PCODE_AU_SA8)
# define _VodiK_PCODE_AU_SA8 8

/* mask = xxxxzz, id = 650 */
# define VodiK_AU_SA9_PLATE _VODI_MAKE_PLATEID_AU_SA(_VodiK_PCODE_AU_SA9)
# define _VodiK_PCODE_AU_SA9 9

/* mask = xxx, id = 652 */
# define VodiK_AU_SA10_PLATE _VODI_MAKE_PLATEID_AU_SA(_VodiK_PCODE_AU_SA10)
# define _VodiK_PCODE_AU_SA10 10

/* mask = zzxxxx, id = 653 */
# define VodiK_AU_SA11_PLATE _VODI_MAKE_PLATEID_AU_SA(_VodiK_PCODE_AU_SA11)
# define _VodiK_PCODE_AU_SA11 11

/* mask = xxxxz, id = 654 */
# define VodiK_AU_SA12_PLATE _VODI_MAKE_PLATEID_AU_SA(_VodiK_PCODE_AU_SA12)
# define _VodiK_PCODE_AU_SA12 12
/* @} */


/*
 * AU_TAS
 * @{
 */
# define _VODI_MAKE_PLATEID_AU_TAS(aCode) \
_VODI_MAKE_PLATEID_AU(VodiK_AU_TAS_SUBNUM,aCode)

/* mask = zzxxxx, id = 660 */
# define VodiK_AU_TAS1_PLATE _VODI_MAKE_PLATEID_AU_TAS(_VodiK_PCODE_AU_TAS1)
# define _VodiK_PCODE_AU_TAS1 1

/* mask = zxxzz, id = 662 */
# define VodiK_AU_TAS2_PLATE _VODI_MAKE_PLATEID_AU_TAS(_VodiK_PCODE_AU_TAS2)
# define _VodiK_PCODE_AU_TAS2 2

/* mask = xxx, id = 665 */
# define VodiK_AU_TAS3_PLATE _VODI_MAKE_PLATEID_AU_TAS(_VodiK_PCODE_AU_TAS3)
# define _VodiK_PCODE_AU_TAS3 3

/* mask = zxxxxx, id = 657 */
# define VodiK_AU_TAS4_PLATE _VODI_MAKE_PLATEID_AU_TAS(_VodiK_PCODE_AU_TAS4)
# define _VodiK_PCODE_AU_TAS4 4

/* mask = zzzxxx, id = 659 */
# define VodiK_AU_TAS5_PLATE _VODI_MAKE_PLATEID_AU_TAS(_VodiK_PCODE_AU_TAS5)
# define _VodiK_PCODE_AU_TAS5 5

/* mask = zxxxz, id = 661 */
# define VodiK_AU_TAS6_PLATE _VODI_MAKE_PLATEID_AU_TAS(_VodiK_PCODE_AU_TAS6)
# define _VodiK_PCODE_AU_TAS6 6

/* mask = zxxxx, id = 656 */
# define VodiK_AU_TAS7_PLATE _VODI_MAKE_PLATEID_AU_TAS(_VodiK_PCODE_AU_TAS7)
# define _VodiK_PCODE_AU_TAS7 7

/* mask = zzxx, id = 658 */
# define VodiK_AU_TAS8_PLATE _VODI_MAKE_PLATEID_AU_TAS(_VodiK_PCODE_AU_TAS8)
# define _VodiK_PCODE_AU_TAS8 8

/* mask = zxxxxx, id = 663 */
# define VodiK_AU_TAS9_PLATE _VODI_MAKE_PLATEID_AU_TAS(_VodiK_PCODE_AU_TAS9)
# define _VodiK_PCODE_AU_TAS9 9

/* mask = zxxx, id = 664 */
# define VodiK_AU_TAS10_PLATE _VODI_MAKE_PLATEID_AU_TAS(_VodiK_PCODE_AU_TAS10)
# define _VodiK_PCODE_AU_TAS10 10

/* mask = zzxxx, id = 666 */
# define VodiK_AU_TAS11_PLATE _VODI_MAKE_PLATEID_AU_TAS(_VodiK_PCODE_AU_TAS11)
# define _VodiK_PCODE_AU_TAS11 11
/* @} */


/*
 * AU_VIC
 * @{
 */
# define _VODI_MAKE_PLATEID_AU_VIC(aCode) \
_VODI_MAKE_PLATEID_AU(VodiK_AU_VIC_SUBNUM,aCode)

/* mask = zzzxxx, id = 672 */
# define VodiK_AU_VIC1_PLATE _VODI_MAKE_PLATEID_AU_VIC(_VodiK_PCODE_AU_VIC1)
# define _VodiK_PCODE_AU_VIC1 1

/* mask = zzxxx, id = 1238 */
# define VodiK_AU_VIC2_PLATE _VODI_MAKE_PLATEID_AU_VIC(_VodiK_PCODE_AU_VIC2)
# define _VodiK_PCODE_AU_VIC2 2

/* mask = xxxxxz, id = 1239 */
# define VodiK_AU_VIC3_PLATE _VODI_MAKE_PLATEID_AU_VIC(_VodiK_PCODE_AU_VIC3)
# define _VodiK_PCODE_AU_VIC3 3

/* mask = xzzxzz, id = 1257 */
# define VodiK_AU_VIC4_PLATE _VODI_MAKE_PLATEID_AU_VIC(_VodiK_PCODE_AU_VIC4)
# define _VodiK_PCODE_AU_VIC4 4

/* mask = zzzxx, id = 679 */
# define VodiK_AU_VIC5_PLATE _VODI_MAKE_PLATEID_AU_VIC(_VodiK_PCODE_AU_VIC5)
# define _VodiK_PCODE_AU_VIC5 5

/* mask = xxxxzz, id = 677 */
# define VodiK_AU_VIC6_PLATE _VODI_MAKE_PLATEID_AU_VIC(_VodiK_PCODE_AU_VIC6)
# define _VodiK_PCODE_AU_VIC6 6

/* mask = zzzxxx, id = 1232 */
# define VodiK_AU_VIC7_PLATE _VODI_MAKE_PLATEID_AU_VIC(_VodiK_PCODE_AU_VIC7)
# define _VodiK_PCODE_AU_VIC7 7

/* mask = zzz, id = 1259 */
# define VodiK_AU_VIC8_PLATE _VODI_MAKE_PLATEID_AU_VIC(_VodiK_PCODE_AU_VIC8)
# define _VodiK_PCODE_AU_VIC8 8

/* mask = zzzzzz, id = 1260 */
# define VodiK_AU_VIC9_PLATE _VODI_MAKE_PLATEID_AU_VIC(_VodiK_PCODE_AU_VIC9)
# define _VodiK_PCODE_AU_VIC9 9

/* mask = xxzxxxx, id = 667 */
# define VodiK_AU_VIC10_PLATE _VODI_MAKE_PLATEID_AU_VIC(_VodiK_PCODE_AU_VIC10)
# define _VodiK_PCODE_AU_VIC10 10

/* mask = xxxxzz, id = 668 */
# define VodiK_AU_VIC11_PLATE _VODI_MAKE_PLATEID_AU_VIC(_VodiK_PCODE_AU_VIC11)
# define _VodiK_PCODE_AU_VIC11 11

/* mask = xxxxxz, id = 669 */
# define VodiK_AU_VIC12_PLATE _VODI_MAKE_PLATEID_AU_VIC(_VodiK_PCODE_AU_VIC12)
# define _VodiK_PCODE_AU_VIC12 12

/* mask = xxxxxz, id = 670 */
# define VodiK_AU_VIC13_PLATE _VODI_MAKE_PLATEID_AU_VIC(_VodiK_PCODE_AU_VIC13)
# define _VodiK_PCODE_AU_VIC13 13

/* mask = zzxxx, id = 671 */
# define VodiK_AU_VIC14_PLATE _VODI_MAKE_PLATEID_AU_VIC(_VodiK_PCODE_AU_VIC14)
# define _VodiK_PCODE_AU_VIC14 14

/* mask = zzzxxx, id = 673 */
# define VodiK_AU_VIC15_PLATE _VODI_MAKE_PLATEID_AU_VIC(_VodiK_PCODE_AU_VIC15)
# define _VodiK_PCODE_AU_VIC15 15

/* mask = zxxxx, id = 674 */
# define VodiK_AU_VIC16_PLATE _VODI_MAKE_PLATEID_AU_VIC(_VodiK_PCODE_AU_VIC16)
# define _VodiK_PCODE_AU_VIC16 16

/* mask = xxxxx, id = 675 */
# define VodiK_AU_VIC17_PLATE _VODI_MAKE_PLATEID_AU_VIC(_VodiK_PCODE_AU_VIC17)
# define _VodiK_PCODE_AU_VIC17 17

/* mask = zxxxx, id = 676 */
# define VodiK_AU_VIC18_PLATE _VODI_MAKE_PLATEID_AU_VIC(_VodiK_PCODE_AU_VIC18)
# define _VodiK_PCODE_AU_VIC18 18

/* mask = xxx, id = 678 */
# define VodiK_AU_VIC19_PLATE _VODI_MAKE_PLATEID_AU_VIC(_VodiK_PCODE_AU_VIC19)
# define _VodiK_PCODE_AU_VIC19 19

/* mask = zzxxxx, id = 680 */
# define VodiK_AU_VIC20_PLATE _VODI_MAKE_PLATEID_AU_VIC(_VodiK_PCODE_AU_VIC20)
# define _VodiK_PCODE_AU_VIC20 20

/* mask = zzzzxx, id = 1258 */
# define VodiK_AU_VIC21_PLATE _VODI_MAKE_PLATEID_AU_VIC(_VodiK_PCODE_AU_VIC21)
# define _VodiK_PCODE_AU_VIC21 21

/* mask = zzzzzx, id = 1261 */
# define VodiK_AU_VIC22_PLATE _VODI_MAKE_PLATEID_AU_VIC(_VodiK_PCODE_AU_VIC22)
# define _VodiK_PCODE_AU_VIC22 22

/* mask = zzzx, id = 2043 */
# define VodiK_AU_VIC24_PLATE _VODI_MAKE_PLATEID_AU_VIC(_VodiK_PCODE_AU_VIC24)
# define _VodiK_PCODE_AU_VIC24 24

/* mask = zzzxx, id = 2047 */
# define VodiK_AU_VIC25_PLATE _VODI_MAKE_PLATEID_AU_VIC(_VodiK_PCODE_AU_VIC25)
# define _VodiK_PCODE_AU_VIC25 25

/* mask = zzzzzz, id = 2048 */
# define VodiK_AU_VIC26_PLATE _VODI_MAKE_PLATEID_AU_VIC(_VodiK_PCODE_AU_VIC26)
# define _VodiK_PCODE_AU_VIC26 26

/* mask = xzzzzz, id = 2049 */
# define VodiK_AU_VIC27_PLATE _VODI_MAKE_PLATEID_AU_VIC(_VodiK_PCODE_AU_VIC27)
# define _VodiK_PCODE_AU_VIC27 27

/* mask = zzxzzx, id = 2050 */
# define VodiK_AU_VIC28_PLATE _VODI_MAKE_PLATEID_AU_VIC(_VodiK_PCODE_AU_VIC28)
# define _VodiK_PCODE_AU_VIC28 28

/* mask = zzzzxx, id = 2052 */
# define VodiK_AU_VIC29_PLATE _VODI_MAKE_PLATEID_AU_VIC(_VodiK_PCODE_AU_VIC29)
# define _VodiK_PCODE_AU_VIC29 29

/* mask = zzzzz, id = 2053 */
# define VodiK_AU_VIC30_PLATE _VODI_MAKE_PLATEID_AU_VIC(_VodiK_PCODE_AU_VIC30)
# define _VodiK_PCODE_AU_VIC30 30

/* mask = zzxzzz, id = 2054 */
# define VodiK_AU_VIC31_PLATE _VODI_MAKE_PLATEID_AU_VIC(_VodiK_PCODE_AU_VIC31)
# define _VodiK_PCODE_AU_VIC31 31

/* mask = zzzz, id = 2056 */
# define VodiK_AU_VIC32_PLATE _VODI_MAKE_PLATEID_AU_VIC(_VodiK_PCODE_AU_VIC32)
# define _VodiK_PCODE_AU_VIC32 32

/* mask = zzzzzx, id = 2058 */
# define VodiK_AU_VIC33_PLATE _VODI_MAKE_PLATEID_AU_VIC(_VodiK_PCODE_AU_VIC33)
# define _VodiK_PCODE_AU_VIC33 33

/* mask = zzzzx, id = 2059 */
# define VodiK_AU_VIC34_PLATE _VODI_MAKE_PLATEID_AU_VIC(_VodiK_PCODE_AU_VIC34)
# define _VodiK_PCODE_AU_VIC34 34

/* mask = zzzx, id = 2060 */
# define VodiK_AU_VIC35_PLATE _VODI_MAKE_PLATEID_AU_VIC(_VodiK_PCODE_AU_VIC35)
# define _VodiK_PCODE_AU_VIC35 35

/* mask = zzzzzz, id = 2061 */
# define VodiK_AU_VIC36_PLATE _VODI_MAKE_PLATEID_AU_VIC(_VodiK_PCODE_AU_VIC36)
# define _VodiK_PCODE_AU_VIC36 36

/* mask = zxzzxz, id = 2064 */
# define VodiK_AU_VIC37_PLATE _VODI_MAKE_PLATEID_AU_VIC(_VodiK_PCODE_AU_VIC37)
# define _VodiK_PCODE_AU_VIC37 37

/* mask = zzzzzz, id = 2066 */
# define VodiK_AU_VIC38_PLATE _VODI_MAKE_PLATEID_AU_VIC(_VodiK_PCODE_AU_VIC38)
# define _VodiK_PCODE_AU_VIC38 38

/* mask = xxzxxxx, id = 667 */
# define VodiK_AU_VIC39_PLATE _VODI_MAKE_PLATEID_AU_VIC(_VodiK_PCODE_AU_VIC39)
# define _VodiK_PCODE_AU_VIC39 39

/* mask = xxxxzz, id = 668 */
# define VodiK_AU_VIC40_PLATE _VODI_MAKE_PLATEID_AU_VIC(_VodiK_PCODE_AU_VIC40)
# define _VodiK_PCODE_AU_VIC40 40

/* mask = xxxxxz, id = 669 */
# define VodiK_AU_VIC41_PLATE _VODI_MAKE_PLATEID_AU_VIC(_VodiK_PCODE_AU_VIC41)
# define _VodiK_PCODE_AU_VIC41 41

/* mask = xxxxxz, id = 670 */
# define VodiK_AU_VIC42_PLATE _VODI_MAKE_PLATEID_AU_VIC(_VodiK_PCODE_AU_VIC42)
# define _VodiK_PCODE_AU_VIC42 42

/* mask = zzxxx, id = 671 */
# define VodiK_AU_VIC43_PLATE _VODI_MAKE_PLATEID_AU_VIC(_VodiK_PCODE_AU_VIC43)
# define _VodiK_PCODE_AU_VIC43 43

/* mask = zzzxxx, id = 673 */
# define VodiK_AU_VIC44_PLATE _VODI_MAKE_PLATEID_AU_VIC(_VodiK_PCODE_AU_VIC44)
# define _VodiK_PCODE_AU_VIC44 44

/* mask = zxxxx, id = 674 */
# define VodiK_AU_VIC45_PLATE _VODI_MAKE_PLATEID_AU_VIC(_VodiK_PCODE_AU_VIC45)
# define _VodiK_PCODE_AU_VIC45 45

/* mask = xxxxx, id = 675 */
# define VodiK_AU_VIC46_PLATE _VODI_MAKE_PLATEID_AU_VIC(_VodiK_PCODE_AU_VIC46)
# define _VodiK_PCODE_AU_VIC46 46

/* mask = zxxxx, id = 676 */
# define VodiK_AU_VIC47_PLATE _VODI_MAKE_PLATEID_AU_VIC(_VodiK_PCODE_AU_VIC47)
# define _VodiK_PCODE_AU_VIC47 47

/* mask = xxx, id = 678 */
# define VodiK_AU_VIC48_PLATE _VODI_MAKE_PLATEID_AU_VIC(_VodiK_PCODE_AU_VIC48)
# define _VodiK_PCODE_AU_VIC48 48

/* mask = zzxxxx, id = 680 */
# define VodiK_AU_VIC49_PLATE _VODI_MAKE_PLATEID_AU_VIC(_VodiK_PCODE_AU_VIC49)
# define _VodiK_PCODE_AU_VIC49 49

/* mask = zzzzxx, id = 1258 */
# define VodiK_AU_VIC50_PLATE _VODI_MAKE_PLATEID_AU_VIC(_VodiK_PCODE_AU_VIC50)
# define _VodiK_PCODE_AU_VIC50 50

/* mask = zzzzzx, id = 1261 */
# define VodiK_AU_VIC51_PLATE _VODI_MAKE_PLATEID_AU_VIC(_VodiK_PCODE_AU_VIC51)
# define _VodiK_PCODE_AU_VIC51 51
/* @} */


/*
 * AU_WA
 * @{
 */
# define _VODI_MAKE_PLATEID_AU_WA(aCode) \
_VODI_MAKE_PLATEID_AU(VodiK_AU_WA_SUBNUM,aCode)

/* mask = xzzzxxx, id = 865 */
# define VodiK_AU_WA1_PLATE _VODI_MAKE_PLATEID_AU_WA(_VodiK_PCODE_AU_WA1)
# define _VodiK_PCODE_AU_WA1 1

/* mask = xzzzxxx, id = 866 */
# define VodiK_AU_WA2_PLATE _VODI_MAKE_PLATEID_AU_WA(_VodiK_PCODE_AU_WA2)
# define _VodiK_PCODE_AU_WA2 2

/* mask = xzzxxx, id = 867 */
# define VodiK_AU_WA3_PLATE _VODI_MAKE_PLATEID_AU_WA(_VodiK_PCODE_AU_WA3)
# define _VodiK_PCODE_AU_WA3 3

/* mask = zxxxx, id = 868 */
# define VodiK_AU_WA4_PLATE _VODI_MAKE_PLATEID_AU_WA(_VodiK_PCODE_AU_WA4)
# define _VodiK_PCODE_AU_WA4 4

/* mask = zzxxx, id = 869 */
# define VodiK_AU_WA5_PLATE _VODI_MAKE_PLATEID_AU_WA(_VodiK_PCODE_AU_WA5)
# define _VodiK_PCODE_AU_WA5 5

/* mask = zzxxxx, id = 870 */
# define VodiK_AU_WA6_PLATE _VODI_MAKE_PLATEID_AU_WA(_VodiK_PCODE_AU_WA6)
# define _VodiK_PCODE_AU_WA6 6

/* mask = zzzzxxx, id = 871 */
# define VodiK_AU_WA7_PLATE _VODI_MAKE_PLATEID_AU_WA(_VodiK_PCODE_AU_WA7)
# define _VodiK_PCODE_AU_WA7 7

/* mask = zzzzxxxx, id = 872 */
# define VodiK_AU_WA8_PLATE _VODI_MAKE_PLATEID_AU_WA(_VodiK_PCODE_AU_WA8)
# define _VodiK_PCODE_AU_WA8 8

/* mask = zzzxxxz, id = 873 */
# define VodiK_AU_WA9_PLATE _VODI_MAKE_PLATEID_AU_WA(_VodiK_PCODE_AU_WA9)
# define _VodiK_PCODE_AU_WA9 9

/* mask = zzxxxx, id = 874 */
# define VodiK_AU_WA10_PLATE _VODI_MAKE_PLATEID_AU_WA(_VodiK_PCODE_AU_WA10)
# define _VodiK_PCODE_AU_WA10 10
/* @} */


/*
 * AZ
 * @{
 */
# define _VODI_MAKE_PLATEID_AZ(aCode) _VODI_MAKE_PLATEID(VodiK_AZERBAIJAN_NUMERIC,aCode)

/* mask = xxzzxxx, id = 401 */
# define VodiK_AZ1_PLATE _VODI_MAKE_PLATEID_AZ(_VodiK_PCODE_AZ1)
# define _VodiK_PCODE_AZ1 1

/* mask = zxxxxx, id = 402 */
# define VodiK_AZ2_PLATE _VODI_MAKE_PLATEID_AZ(_VodiK_PCODE_AZ2)
# define _VodiK_PCODE_AZ2 2

/* mask = zzzxxxx, id = 403 */
# define VodiK_AZ3_PLATE _VODI_MAKE_PLATEID_AZ(_VodiK_PCODE_AZ3)
# define _VodiK_PCODE_AZ3 3

/* mask = zxxxxx, id = 404 */
# define VodiK_AZ4_PLATE _VODI_MAKE_PLATEID_AZ(_VodiK_PCODE_AZ4)
# define _VodiK_PCODE_AZ4 4

/* mask = zzxxx, id = 405 */
# define VodiK_AZ5_PLATE _VODI_MAKE_PLATEID_AZ(_VodiK_PCODE_AZ5)
# define _VodiK_PCODE_AZ5 5

/* mask = xxzxxxxx, id = 1231 */
# define VodiK_AZ6_PLATE _VODI_MAKE_PLATEID_AZ(_VodiK_PCODE_AZ6)
# define _VodiK_PCODE_AZ6 6

/* mask = xxxxx, id = 1233 */
# define VodiK_AZ7_PLATE _VODI_MAKE_PLATEID_AZ(_VodiK_PCODE_AZ7)
# define _VodiK_PCODE_AZ7 7

/* mask = zzxxxxx, id = 1234 */
# define VodiK_AZ8_PLATE _VODI_MAKE_PLATEID_AZ(_VodiK_PCODE_AZ8)
# define _VodiK_PCODE_AZ8 8

/* mask = zzzxxxxx, id = 1235 */
# define VodiK_AZ9_PLATE _VODI_MAKE_PLATEID_AZ(_VodiK_PCODE_AZ9)
# define _VodiK_PCODE_AZ9 9

/* mask = zxxxxxx, id = 400 */
# define VodiK_AZ10_PLATE _VODI_MAKE_PLATEID_AZ(_VodiK_PCODE_AZ10)
# define _VodiK_PCODE_AZ10 10

/* mask = xxxxzz, id = 406 */
# define VodiK_AZ11_PLATE _VODI_MAKE_PLATEID_AZ(_VodiK_PCODE_AZ11)
# define _VodiK_PCODE_AZ11 11

/* mask = xxxxzz, id = 407 */
# define VodiK_AZ12_PLATE _VODI_MAKE_PLATEID_AZ(_VodiK_PCODE_AZ12)
# define _VodiK_PCODE_AZ12 12

/* mask = xxxxzz, id = 408 */
# define VodiK_AZ13_PLATE _VODI_MAKE_PLATEID_AZ(_VodiK_PCODE_AZ13)
# define _VodiK_PCODE_AZ13 13

/* mask = xxzzxxx, id = 409 */
# define VodiK_AZ14_PLATE _VODI_MAKE_PLATEID_AZ(_VodiK_PCODE_AZ14)
# define _VodiK_PCODE_AZ14 14

/* mask = xxzzxxx, id = 1361, two row */
# define VodiK_AZ15_PLATE _VODI_MAKE_PLATEID_AZ(_VodiK_PCODE_AZ15)
# define _VodiK_PCODE_AZ15 15

/* mask = xxzzxxx, id = 1362, two row */
# define VodiK_AZ16_PLATE _VODI_MAKE_PLATEID_AZ(_VodiK_PCODE_AZ16)
# define _VodiK_PCODE_AZ16 16

/* mask = xxzxxx, id = 1363, two row */
# define VodiK_AZ17_PLATE _VODI_MAKE_PLATEID_AZ(_VodiK_PCODE_AZ17)
# define _VodiK_PCODE_AZ17 17

/* mask = xxzxxx, id = 1364, two row */
# define VodiK_AZ18_PLATE _VODI_MAKE_PLATEID_AZ(_VodiK_PCODE_AZ18)
# define _VodiK_PCODE_AZ18 18

/* mask = xxzzxxx, id = 2329 */
# define VodiK_AZ19_PLATE _VODI_MAKE_PLATEID_AZ(_VodiK_PCODE_AZ19)
# define _VodiK_PCODE_AZ19 19
/* @} */


/*
* BA
* @{
*/
# define _VODI_MAKE_PLATEID_BA(aCode) _VODI_MAKE_PLATEID(VodiK_BOSNIA_AND_HERZEGOVINA_NUMERIC,aCode)

/* mask = ZXXZXXX, id = 425 */
# define VodiK_BA1_PLATE _VODI_MAKE_PLATEID_BA(_VodiK_PCODE_BA1)
# define _VodiK_PCODE_BA1 1

/* mask = XXXZXXX, id = 426 */
# define VodiK_BA2_PLATE _VODI_MAKE_PLATEID_BA(_VodiK_PCODE_BA2)
# define _VodiK_PCODE_BA2 2

/* mask = xxxxxxz, id = 1710 */
# define VodiK_BA3_PLATE _VODI_MAKE_PLATEID_BA(_VodiK_PCODE_BA3)
# define _VodiK_PCODE_BA3 3

/* mask = XXXZXXX, id = 1711 */
# define VodiK_BA4_PLATE _VODI_MAKE_PLATEID_BA(_VodiK_PCODE_BA4)
# define _VodiK_PCODE_BA4 4

/* mask = zzxxxxxx, id = 1712 */
# define VodiK_BA5_PLATE _VODI_MAKE_PLATEID_BA(_VodiK_PCODE_BA5)
# define _VodiK_PCODE_BA5 5
/* @} */


/*
 * BE
 * @{
 */
# define _VODI_MAKE_PLATEID_BE(aCode) _VODI_MAKE_PLATEID(VodiK_BELGIUM_NUMERIC,aCode)

/* mask = XXXZZZ, id = 410 */
# define VodiK_BE1_PLATE _VODI_MAKE_PLATEID_BE(_VodiK_PCODE_BE1)
# define _VodiK_PCODE_BE1 1

/* mask = XZZZXXX, id = 414 */
# define VodiK_BE2_PLATE _VODI_MAKE_PLATEID_BE(_VodiK_PCODE_BE2)
# define _VodiK_PCODE_BE2 2

/* mask = XXXZZZ, id = 419 */
# define VodiK_BE3_PLATE _VODI_MAKE_PLATEID_BE(_VodiK_PCODE_BE3)
# define _VodiK_PCODE_BE3 3

/* mask = ZXXXX, id = 420 */
# define VodiK_BE4_PLATE _VODI_MAKE_PLATEID_BE(_VodiK_PCODE_BE4)
# define _VodiK_PCODE_BE4 4

/* mask = ZXXXZ, id = 421 */
# define VodiK_BE5_PLATE _VODI_MAKE_PLATEID_BE(_VodiK_PCODE_BE5)
# define _VodiK_PCODE_BE5 5

/* mask = ZZZXXX, id = 422 */
# define VodiK_BE6_PLATE _VODI_MAKE_PLATEID_BE(_VodiK_PCODE_BE6)
# define _VodiK_PCODE_BE6 6

/* mask = XXXXXX, id = 413 */
# define VodiK_BE7_PLATE _VODI_MAKE_PLATEID_BE(_VodiK_PCODE_BE7)
# define _VodiK_PCODE_BE7 7

/* mask = XXXXX, id = 417 */
# define VodiK_BE8_PLATE _VODI_MAKE_PLATEID_BE(_VodiK_PCODE_BE8)
# define _VodiK_PCODE_BE8 8

/* mask = ZXXXX, id = 418 */
# define VodiK_BE9_PLATE _VODI_MAKE_PLATEID_BE(_VodiK_PCODE_BE9)
# define _VodiK_PCODE_BE9 9

/* mask = ZZZXXX, id = 411 */
# define VodiK_BE10_PLATE _VODI_MAKE_PLATEID_BE(_VodiK_PCODE_BE10)
# define _VodiK_PCODE_BE10 10

/* mask = ZZXXXZ, id = 412 */
# define VodiK_BE11_PLATE _VODI_MAKE_PLATEID_BE(_VodiK_PCODE_BE11)
# define _VodiK_PCODE_BE11 11

/* mask = ZZZZXXX, id = 416 */
# define VodiK_BE12_PLATE _VODI_MAKE_PLATEID_BE(_VodiK_PCODE_BE12)
# define _VodiK_PCODE_BE12 12

/* mask = XXXXZZZ, id = 415 */
# define VodiK_BE13_PLATE _VODI_MAKE_PLATEID_BE(_VodiK_PCODE_BE13)
# define _VodiK_PCODE_BE13 13

/* mask = XZZZXXX, id = 1606 */
# define VodiK_BE14_PLATE _VODI_MAKE_PLATEID_BE(_VodiK_PCODE_BE14)
# define _VodiK_PCODE_BE14 14

/* mask = XXXXZZZ, id = 1607 */
# define VodiK_BE15_PLATE _VODI_MAKE_PLATEID_BE(_VodiK_PCODE_BE15)
# define _VodiK_PCODE_BE15 15

/* mask = XXXXZZZ, id = 1636 */
# define VodiK_BE16_PLATE _VODI_MAKE_PLATEID_BE(_VodiK_PCODE_BE16)
# define _VodiK_PCODE_BE16 16

/* mask = xxzxxx, id = 2069 */
# define VodiK_BE17_PLATE _VODI_MAKE_PLATEID_BE(_VodiK_PCODE_BE17)
# define _VodiK_PCODE_BE17 17

/* mask = xzzzxxx, id = 2068 */
# define VodiK_BE18_PLATE _VODI_MAKE_PLATEID_BE(_VodiK_PCODE_BE18)
# define _VodiK_PCODE_BE18 18

/* mask = zzzzxxx, id = 2070 */
# define VodiK_BE19_PLATE _VODI_MAKE_PLATEID_BE(_VodiK_PCODE_BE19)
# define _VodiK_PCODE_BE19 19

/* mask = zzzzxxx, id = 2071 */
# define VodiK_BE20_PLATE _VODI_MAKE_PLATEID_BE(_VodiK_PCODE_BE20)
# define _VodiK_PCODE_BE20 20
/* @} */


/*
 * BG
 * @{
 */
# define _VODI_MAKE_PLATEID_BG(aCode) _VODI_MAKE_PLATEID(VodiK_BULGARIA_NUMERIC,aCode)

/* mask = ZXXXXZZ, id = 82 */
# define VodiK_BG1_PLATE _VODI_MAKE_PLATEID_BG(_VodiK_PCODE_BG1)
# define _VodiK_PCODE_BG1 1

/* mask = ZZXXXXZZ, id = 83 */
# define VodiK_BG2_PLATE _VODI_MAKE_PLATEID_BG(_VodiK_PCODE_BG2)
# define _VodiK_PCODE_BG2 2

/* mask = XXXZXXX, id = 84 */
# define VodiK_BG3_PLATE _VODI_MAKE_PLATEID_BG(_VodiK_PCODE_BG3)
# define _VodiK_PCODE_BG3 3

/* mask = ZZXXXXXX, id = 85 */
# define VodiK_BG4_PLATE _VODI_MAKE_PLATEID_BG(_VodiK_PCODE_BG4)
# define _VodiK_PCODE_BG4 4

/* mask = ZZXXXXX, id = 88 */
# define VodiK_BG5_PLATE _VODI_MAKE_PLATEID_BG(_VodiK_PCODE_BG5)
# define _VodiK_PCODE_BG5 5

/* mask = ZXXXX, id = 86 */
# define VodiK_BG6_PLATE _VODI_MAKE_PLATEID_BG(_VodiK_PCODE_BG6)
# define _VodiK_PCODE_BG6 6

/* mask = ZZXXXX, id = 87 */
# define VodiK_BG7_PLATE _VODI_MAKE_PLATEID_BG(_VodiK_PCODE_BG7)
# define _VodiK_PCODE_BG7 7

/* mask = ZXXXXZZ, id = 89 */
# define VodiK_BG8_PLATE _VODI_MAKE_PLATEID_BG(_VodiK_PCODE_BG8)
# define _VodiK_PCODE_BG8 8

/* mask = ZXXXXXX, id = 1621 */
# define VodiK_BG9_PLATE _VODI_MAKE_PLATEID_BG(_VodiK_PCODE_BG9)
# define _VodiK_PCODE_BG9 9

/* mask = ZZXXXXZZ, id = 1622 */
# define VodiK_BG10_PLATE _VODI_MAKE_PLATEID_BG(_VodiK_PCODE_BG10)
# define _VodiK_PCODE_BG10 10

/* mask = ZZXXXXXX, id = 1623 */
# define VodiK_BG11_PLATE _VODI_MAKE_PLATEID_BG(_VodiK_PCODE_BG11)
# define _VodiK_PCODE_BG11 11

/* mask = ZZXXXXXX, id = 1624 */
# define VodiK_BG12_PLATE _VODI_MAKE_PLATEID_BG(_VodiK_PCODE_BG12)
# define _VodiK_PCODE_BG12 12

/* mask = ZZZXXXX, id = 1625 */
# define VodiK_BG13_PLATE _VODI_MAKE_PLATEID_BG(_VodiK_PCODE_BG13)
# define _VodiK_PCODE_BG13 13

/* mask = ZZXXXX, id = 2072 */
# define VodiK_BG14_PLATE _VODI_MAKE_PLATEID_BG(_VodiK_PCODE_BG14)
# define _VodiK_PCODE_BG14 14

/* mask = ZXXXXZ, id = 2073 */
# define VodiK_BG15_PLATE _VODI_MAKE_PLATEID_BG(_VodiK_PCODE_BG15)
# define _VodiK_PCODE_BG15 15

/* mask = ZZZXXXX, id = 2093 */
# define VodiK_BG16_PLATE _VODI_MAKE_PLATEID_BG(_VodiK_PCODE_BG16)
# define _VodiK_PCODE_BG16 16

/* mask = ZZXXXXZ, id = 2094 */
# define VodiK_BG17_PLATE _VODI_MAKE_PLATEID_BG(_VodiK_PCODE_BG17)
# define _VodiK_PCODE_BG17 17
/* @} */


/*
 * BH
 * @{
 */
# define _VODI_MAKE_PLATEID_BH(aCode) _VODI_MAKE_PLATEID(VodiK_BAHRAIN_NUMERIC,aCode)

/* mask = XXXXXX, id = 1470 */
# define VodiK_BH1_PLATE _VODI_MAKE_PLATEID_BH(_VodiK_PCODE_BH1)
# define _VodiK_PCODE_BH1 1

/* mask = XXXX, id = 1554 */
# define VodiK_BH2_PLATE _VODI_MAKE_PLATEID_BH(_VodiK_PCODE_BH2)
# define _VodiK_PCODE_BH2 2

/* mask = XXXXX, id = 2200 */
# define VodiK_BH3_PLATE _VODI_MAKE_PLATEID_BH(_VodiK_PCODE_BH3)
# define _VodiK_PCODE_BH3 3
/* @} */


/*
 * BO
 * @{
 */
# define _VODI_MAKE_PLATEID_BO(aCode) _VODI_MAKE_PLATEID(VodiK_BOLIVIA_NUMERIC,aCode)

/* mask = xxxzzz, id = 767 */
# define VodiK_BO1_PLATE _VODI_MAKE_PLATEID_BO(_VodiK_PCODE_BO1)
# define _VodiK_PCODE_BO1 1

/* mask = xxxxzzz, id = 768 */
# define VodiK_BO2_PLATE _VODI_MAKE_PLATEID_BO(_VodiK_PCODE_BO2)
# define _VodiK_PCODE_BO2 2

/* mask = xxzzxx, id = 771 */
# define VodiK_BO3_PLATE _VODI_MAKE_PLATEID_BO(_VodiK_PCODE_BO3)
# define _VodiK_PCODE_BO3 3

/* mask = zzxxxx, id = 769 */
# define VodiK_BO4_PLATE _VODI_MAKE_PLATEID_BO(_VodiK_PCODE_BO4)
# define _VodiK_PCODE_BO4 4

/* mask = zzxxxx, id = 770 */
# define VodiK_BO5_PLATE _VODI_MAKE_PLATEID_BO(_VodiK_PCODE_BO5)
# define _VodiK_PCODE_BO5 5
/* @} */


/*
 * BR
 * @{
 */
# define _VODI_MAKE_PLATEID_BR(aCode) _VODI_MAKE_PLATEID(VodiK_BRAZIL_NUMERIC,aCode)

/* mask = ZZZXXXX, id = 225 */
# define VodiK_BR1_PLATE _VODI_MAKE_PLATEID_BR(_VodiK_PCODE_BR1)
# define _VodiK_PCODE_BR1 1

/* mask = ZZZXXXX, id = 226 */
# define VodiK_BR2_PLATE _VODI_MAKE_PLATEID_BR(_VodiK_PCODE_BR2)
# define _VodiK_PCODE_BR2 2

/* mask = ZZZXXXX, id = 227 */
# define VodiK_BR3_PLATE _VODI_MAKE_PLATEID_BR(_VodiK_PCODE_BR3)
# define _VodiK_PCODE_BR3 3

/* mask = ZZZXXXX, id = 228 */
# define VodiK_BR4_PLATE _VODI_MAKE_PLATEID_BR(_VodiK_PCODE_BR4)
# define _VodiK_PCODE_BR4 4

/* mask = ZZZXXXX, id = 232 */
# define VodiK_BR5_PLATE _VODI_MAKE_PLATEID_BR(_VodiK_PCODE_BR5)
# define _VodiK_PCODE_BR5 5

/* mask = ZZZXXXX, id = 233 */
# define VodiK_BR6_PLATE _VODI_MAKE_PLATEID_BR(_VodiK_PCODE_BR6)
# define _VodiK_PCODE_BR6 6

/* mask = ZZZXZXX, id = 1404 */
# define VodiK_BR7_PLATE _VODI_MAKE_PLATEID_BR(_VodiK_PCODE_BR7)
# define _VodiK_PCODE_BR7 7

/* mask = ZZZXXZX, id = 1405 */
# define VodiK_BR8_PLATE _VODI_MAKE_PLATEID_BR(_VodiK_PCODE_BR8)
# define _VodiK_PCODE_BR8 8
/* @} */


/*
 * BW
 * @{
 */
# define _VODI_MAKE_PLATEID_BW(aCode) _VODI_MAKE_PLATEID(VodiK_BOTSWANA_NUMERIC,aCode)

/* mask = zxxxzzz, id = 2139 */
# define VodiK_BW1_PLATE _VODI_MAKE_PLATEID_BW(_VodiK_PCODE_BW1)
# define _VodiK_PCODE_BW1 1

/* mask = zxxxzzz, id = 2140 */
# define VodiK_BW2_PLATE _VODI_MAKE_PLATEID_BW(_VodiK_PCODE_BW2)
# define _VodiK_PCODE_BW2 2

/* mask = zxxxzzz, id = 2142 */
# define VodiK_BW3_PLATE _VODI_MAKE_PLATEID_BW(_VodiK_PCODE_BW3)
# define _VodiK_PCODE_BW3 3

/* mask = zxxxzzz, id = 2143 */
# define VodiK_BW4_PLATE _VODI_MAKE_PLATEID_BW(_VodiK_PCODE_BW4)
# define _VodiK_PCODE_BW4 4

/* mask = zzxxxxxx, id = 2141 */
# define VodiK_BW5_PLATE _VODI_MAKE_PLATEID_BW(_VodiK_PCODE_BW5)
# define _VodiK_PCODE_BW5 5

/* mask = zzxxxxxx, id = 2144 */
# define VodiK_BW6_PLATE _VODI_MAKE_PLATEID_BW(_VodiK_PCODE_BW6)
# define _VodiK_PCODE_BW6 6
/* @} */


/*
 * BY
 * @{
 */
# define _VODI_MAKE_PLATEID_BY(aCode) _VODI_MAKE_PLATEID(VodiK_BELARUS_NUMERIC,aCode)

/* mask = XXXXZZX, id = 39 */
# define VodiK_BY1_PLATE _VODI_MAKE_PLATEID_BY(_VodiK_PCODE_BY1)
# define _VodiK_PCODE_BY1 1

/* mask = ZZXXXXX, id = 40 */
# define VodiK_BY2_PLATE _VODI_MAKE_PLATEID_BY(_VodiK_PCODE_BY2)
# define _VodiK_PCODE_BY2 2

/* mask = ZXXXXZX, id = 41 */
# define VodiK_BY3_PLATE _VODI_MAKE_PLATEID_BY(_VodiK_PCODE_BY3)
# define _VodiK_PCODE_BY3 3

/* mask = XXXXZZ, id = 45 */
# define VodiK_BY4_PLATE _VODI_MAKE_PLATEID_BY(_VodiK_PCODE_BY4)
# define _VodiK_PCODE_BY4 4

/* mask = XXXXZZ, id = 46 */
# define VodiK_BY5_PLATE _VODI_MAKE_PLATEID_BY(_VodiK_PCODE_BY5)
# define _VodiK_PCODE_BY5 5

/* mask = XXXXZZZ, id = 47 */
# define VodiK_BY6_PLATE _VODI_MAKE_PLATEID_BY(_VodiK_PCODE_BY6)
# define _VodiK_PCODE_BY6 6

/* mask = ZZXXXX, id = 48 */
# define VodiK_BY7_PLATE _VODI_MAKE_PLATEID_BY(_VodiK_PCODE_BY7)
# define _VodiK_PCODE_BY7 7

/* mask = ZXXXX, id = 49 */
# define VodiK_BY8_PLATE _VODI_MAKE_PLATEID_BY(_VodiK_PCODE_BY8)
# define _VodiK_PCODE_BY8 8

/* mask = ZXXXXX, id = 90 */
# define VodiK_BY9_PLATE _VODI_MAKE_PLATEID_BY(_VodiK_PCODE_BY9)
# define _VodiK_PCODE_BY9 9

/* mask = ZZXXXXX, id = 42 */
# define VodiK_BY10_PLATE _VODI_MAKE_PLATEID_BY(_VodiK_PCODE_BY10)
# define _VodiK_PCODE_BY10 10

/* mask = XZZZXXXX, id = 43 */
# define VodiK_BY11_PLATE _VODI_MAKE_PLATEID_BY(_VodiK_PCODE_BY11)
# define _VodiK_PCODE_BY11 11

/* mask = XZZZXXXX, id = 44 */
# define VodiK_BY12_PLATE _VODI_MAKE_PLATEID_BY(_VodiK_PCODE_BY12)
# define _VodiK_PCODE_BY12 12

/* mask = XZZZXXXX, id = 91 */
# define VodiK_BY13_PLATE _VODI_MAKE_PLATEID_BY(_VodiK_PCODE_BY13)
# define _VodiK_PCODE_BY13 13

/* mask = ZZXXXX, id = 1612 */
# define VodiK_BY14_PLATE _VODI_MAKE_PLATEID_BY(_VodiK_PCODE_BY14)
# define _VodiK_PCODE_BY14 14

/* mask = XXXXZX, id = 1648 */
# define VodiK_BY15_PLATE _VODI_MAKE_PLATEID_BY(_VodiK_PCODE_BY15)
# define _VodiK_PCODE_BY15 15

/* mask = XXXXZZX, id = 1649 */
# define VodiK_BY16_PLATE _VODI_MAKE_PLATEID_BY(_VodiK_PCODE_BY16)
# define _VodiK_PCODE_BY16 16

/* mask = XXXXZZX, id = 1650 */
# define VodiK_BY17_PLATE _VODI_MAKE_PLATEID_BY(_VodiK_PCODE_BY17)
# define _VodiK_PCODE_BY17 17

/* mask = XXXXZ, id = 1651 */
# define VodiK_BY18_PLATE _VODI_MAKE_PLATEID_BY(_VodiK_PCODE_BY18)
# define _VodiK_PCODE_BY18 18

/* mask = ZZXXXXX, id = 2244 */
# define VodiK_BY19_PLATE _VODI_MAKE_PLATEID_BY(_VodiK_PCODE_BY19)
# define _VodiK_PCODE_BY19 19
/* @} */

/*
* CA
* @{
*/
# define _VODI_MAKE_PLATEID_CA(aSubdivision,aCode) \
_VODI_MAKE_PLATEID3(VodiK_CANADA_NUMERIC,aSubdivision,aCode)

/*
 * CA_AB
 * @{
 */
# define _VODI_MAKE_PLATEID_CA_AB(aCode) \
_VODI_MAKE_PLATEID_CA(VodiK_CA_AB_SUBNUM,aCode)

/* mask = ZZZXXX, id = 385 */
# define VodiK_CA_AB1_PLATE _VODI_MAKE_PLATEID_CA_AB(_VodiK_PCODE_CA_AB1)
# define _VodiK_PCODE_CA_AB1 1

/* mask = ZZZXXXX, id = 386 */
# define VodiK_CA_AB2_PLATE _VODI_MAKE_PLATEID_CA_AB(_VodiK_PCODE_CA_AB2)
# define _VodiK_PCODE_CA_AB2 2

/* mask = ZXXXXX, id = 387 */
# define VodiK_CA_AB3_PLATE _VODI_MAKE_PLATEID_CA_AB(_VodiK_PCODE_CA_AB3)
# define _VodiK_PCODE_CA_AB3 3

/* mask = XXZXXX, id = 388 */
# define VodiK_CA_AB4_PLATE _VODI_MAKE_PLATEID_CA_AB(_VodiK_PCODE_CA_AB4)
# define _VodiK_PCODE_CA_AB4 4

/* mask = ZXXXXX, id = 389 */
# define VodiK_CA_AB5_PLATE _VODI_MAKE_PLATEID_CA_AB(_VodiK_PCODE_CA_AB5)
# define _VodiK_PCODE_CA_AB5 5

/* mask = ZZXXXX, id = 390 */
# define VodiK_CA_AB6_PLATE _VODI_MAKE_PLATEID_CA_AB(_VodiK_PCODE_CA_AB6)
# define _VodiK_PCODE_CA_AB6 6

/* mask = ZXXXXX, id = 391 */
# define VodiK_CA_AB7_PLATE _VODI_MAKE_PLATEID_CA_AB(_VodiK_PCODE_CA_AB7)
# define _VodiK_PCODE_CA_AB7 7

/* mask = ZZXZZZ, id = 392 */
# define VodiK_CA_AB8_PLATE _VODI_MAKE_PLATEID_CA_AB(_VodiK_PCODE_CA_AB8)
# define _VodiK_PCODE_CA_AB8 8

/* mask = ZZZXX, id = 393 */
# define VodiK_CA_AB9_PLATE _VODI_MAKE_PLATEID_CA_AB(_VodiK_PCODE_CA_AB9)
# define _VodiK_PCODE_CA_AB9 9
/* @} */


/*
 * CA_BC
 * @{
 */
# define _VODI_MAKE_PLATEID_CA_BC(aCode) \
_VODI_MAKE_PLATEID_CA(VodiK_CA_BC_SUBNUM,aCode)

/* mask = xxxzzz, id = 681 */
# define VodiK_CA_BC1_PLATE _VODI_MAKE_PLATEID_CA_BC(_VodiK_PCODE_CA_BC1)
# define _VodiK_PCODE_CA_BC1 1

/* mask = zzzxxx, id = 682 */
# define VodiK_CA_BC2_PLATE _VODI_MAKE_PLATEID_CA_BC(_VodiK_PCODE_CA_BC2)
# define _VodiK_PCODE_CA_BC2 2

/* mask = zxxxxx, id = 684 */
# define VodiK_CA_BC3_PLATE _VODI_MAKE_PLATEID_CA_BC(_VodiK_PCODE_CA_BC3)
# define _VodiK_PCODE_CA_BC3 3

/* mask = zzxxxx, id = 683 */
# define VodiK_CA_BC4_PLATE _VODI_MAKE_PLATEID_CA_BC(_VodiK_PCODE_CA_BC4)
# define _VodiK_PCODE_CA_BC4 4

/* mask = xxxxxz, id = 685 */
# define VodiK_CA_BC5_PLATE _VODI_MAKE_PLATEID_CA_BC(_VodiK_PCODE_CA_BC5)
# define _VodiK_PCODE_CA_BC5 5

/* mask = xxxxxx, id = 686 */
# define VodiK_CA_BC6_PLATE _VODI_MAKE_PLATEID_CA_BC(_VodiK_PCODE_CA_BC6)
# define _VodiK_PCODE_CA_BC6 6

/* mask = zzzzzzxxx, id = 687 */
# define VodiK_CA_BC7_PLATE _VODI_MAKE_PLATEID_CA_BC(_VodiK_PCODE_CA_BC7)
# define _VodiK_PCODE_CA_BC7 7

/* mask = xxxxxx, id = 688 */
# define VodiK_CA_BC8_PLATE _VODI_MAKE_PLATEID_CA_BC(_VodiK_PCODE_CA_BC8)
# define _VodiK_PCODE_CA_BC8 8

/* mask = xxxzzz, id = 689 */
# define VodiK_CA_BC9_PLATE _VODI_MAKE_PLATEID_CA_BC(_VodiK_PCODE_CA_BC9)
# define _VodiK_PCODE_CA_BC9 9

/* mask = zxxxxx, id = 690 */
# define VodiK_CA_BC10_PLATE _VODI_MAKE_PLATEID_CA_BC(_VodiK_PCODE_CA_BC10)
# define _VodiK_PCODE_CA_BC10 10
/* @} */


/*
 * CA_MB
 * @{
 */
# define _VODI_MAKE_PLATEID_CA_MB(aCode) \
_VODI_MAKE_PLATEID_CA(VodiK_CA_MB_SUBNUM,aCode)

/* mask = zzzxxx, id = 691 */
# define VodiK_CA_MB1_PLATE _VODI_MAKE_PLATEID_CA_MB(_VodiK_PCODE_CA_MB1)
# define _VodiK_PCODE_CA_MB1 1

/* mask = zzxxxx, id = 692 */
# define VodiK_CA_MB2_PLATE _VODI_MAKE_PLATEID_CA_MB(_VodiK_PCODE_CA_MB2)
# define _VodiK_PCODE_CA_MB2 2
/* @} */


/*
 * CA_NB
 * @{
 */
# define _VODI_MAKE_PLATEID_CA_NB(aCode) \
_VODI_MAKE_PLATEID_CA(VodiK_CA_NB_SUBNUM,aCode)

/* mask = zzzxxx, id = 693 */
# define VodiK_CA_NB1_PLATE _VODI_MAKE_PLATEID_CA_NB(_VodiK_PCODE_CA_NB1)
# define _VodiK_PCODE_CA_NB1 1

/* mask = zzxxx, id = 694 */
# define VodiK_CA_NB2_PLATE _VODI_MAKE_PLATEID_CA_NB(_VodiK_PCODE_CA_NB2)
# define _VodiK_PCODE_CA_NB2 2

/* mask = zzxxxx, id = 695 */
# define VodiK_CA_NB3_PLATE _VODI_MAKE_PLATEID_CA_NB(_VodiK_PCODE_CA_NB3)
# define _VodiK_PCODE_CA_NB3 3
/* @} */


/*
 * CA_NL
 * @{
 */
# define _VODI_MAKE_PLATEID_CA_NL(aCode) \
_VODI_MAKE_PLATEID_CA(VodiK_CA_NL_SUBNUM,aCode)

/* mask = zzzxxx, id = 696 */
# define VodiK_CA_NL1_PLATE _VODI_MAKE_PLATEID_CA_NL(_VodiK_PCODE_CA_NL1)
# define _VodiK_PCODE_CA_NL1 1
/* @} */


/*
 * CA_NS
 * @{
 */
# define _VODI_MAKE_PLATEID_CA_NS(aCode) \
_VODI_MAKE_PLATEID_CA(VodiK_CA_NS_SUBNUM,aCode)

/* mask = zzzxxx, id = 703 */
# define VodiK_CA_NS1_PLATE _VODI_MAKE_PLATEID_CA_NS(_VodiK_PCODE_CA_NS1)
# define _VodiK_PCODE_CA_NS1 1

/* mask = xzxx, id = 704 */
# define VodiK_CA_NS2_PLATE _VODI_MAKE_PLATEID_CA_NS(_VodiK_PCODE_CA_NS2)
# define _VodiK_PCODE_CA_NS2 2

/* mask = zzzxxxx, id = 705 */
# define VodiK_CA_NS3_PLATE _VODI_MAKE_PLATEID_CA_NS(_VodiK_PCODE_CA_NS3)
# define _VodiK_PCODE_CA_NS3 3

/* mask = zzxxxxx, id = 706 */
# define VodiK_CA_NS4_PLATE _VODI_MAKE_PLATEID_CA_NS(_VodiK_PCODE_CA_NS4)
# define _VodiK_PCODE_CA_NS4 4

/* mask = xxxxxz, id = 707 */
# define VodiK_CA_NS5_PLATE _VODI_MAKE_PLATEID_CA_NS(_VodiK_PCODE_CA_NS5)
# define _VodiK_PCODE_CA_NS5 5

/* mask = zzzxx, id = 708 */
# define VodiK_CA_NS6_PLATE _VODI_MAKE_PLATEID_CA_NS(_VodiK_PCODE_CA_NS6)
# define _VodiK_PCODE_CA_NS6 6

/* mask = zxxxxxx, id = 709 */
# define VodiK_CA_NS7_PLATE _VODI_MAKE_PLATEID_CA_NS(_VodiK_PCODE_CA_NS7)
# define _VodiK_PCODE_CA_NS7 7
/* @} */


/*
 * CA_NT
 * @{
 */
# define _VODI_MAKE_PLATEID_CA_NT(aCode) \
_VODI_MAKE_PLATEID_CA(VodiK_CA_NT_SUBNUM,aCode)

/* mask = xxxxx, id = 698 */
# define VodiK_CA_NT1_PLATE _VODI_MAKE_PLATEID_CA_NT(_VodiK_PCODE_CA_NT1)
# define _VodiK_PCODE_CA_NT1 1

/* mask = zxxxx, id = 701 */
# define VodiK_CA_NT2_PLATE _VODI_MAKE_PLATEID_CA_NT(_VodiK_PCODE_CA_NT2)
# define _VodiK_PCODE_CA_NT2 2

/* mask = zzxxxx, id = 702 */
# define VodiK_CA_NT3_PLATE _VODI_MAKE_PLATEID_CA_NT(_VodiK_PCODE_CA_NT3)
# define _VodiK_PCODE_CA_NT3 3

/* mask = zzxxx, id = 697 */
# define VodiK_CA_NT4_PLATE _VODI_MAKE_PLATEID_CA_NT(_VodiK_PCODE_CA_NT4)
# define _VodiK_PCODE_CA_NT4 4

/* mask = zxxxxx, id = 699 */
# define VodiK_CA_NT5_PLATE _VODI_MAKE_PLATEID_CA_NT(_VodiK_PCODE_CA_NT5)
# define _VodiK_PCODE_CA_NT5 5

/* mask = zxxx, id = 700 */
# define VodiK_CA_NT6_PLATE _VODI_MAKE_PLATEID_CA_NT(_VodiK_PCODE_CA_NT6)
# define _VodiK_PCODE_CA_NT6 6
/* @} */


/*
 * CA_NU
 * @{
 */
# define _VODI_MAKE_PLATEID_CA_NU(aCode) \
_VODI_MAKE_PLATEID_CA(VodiK_CA_NU_SUBNUM,aCode)

/* mask = xxxxxz, id = 710 */
# define VodiK_CA_NU1_PLATE _VODI_MAKE_PLATEID_CA_NU(_VodiK_PCODE_CA_NU1)
# define _VodiK_PCODE_CA_NU1 1

/* mask = zzxxxz, id = 711 */
# define VodiK_CA_NU2_PLATE _VODI_MAKE_PLATEID_CA_NU(_VodiK_PCODE_CA_NU2)
# define _VodiK_PCODE_CA_NU2 2

/* mask = zzzzx, id = 712 */
# define VodiK_CA_NU3_PLATE _VODI_MAKE_PLATEID_CA_NU(_VodiK_PCODE_CA_NU3)
# define _VodiK_PCODE_CA_NU3 3

/* mask = zzxxx, id = 713 */
# define VodiK_CA_NU4_PLATE _VODI_MAKE_PLATEID_CA_NU(_VodiK_PCODE_CA_NU4)
# define _VodiK_PCODE_CA_NU4 4
/* @} */


/*
 * CA_ON
 * @{
 */
# define _VODI_MAKE_PLATEID_CA_ON(aCode) \
_VODI_MAKE_PLATEID_CA(VodiK_CA_ON_SUBNUM,aCode)

/* mask = zzzzxxx, id = 714 */
# define VodiK_CA_ON1_PLATE _VODI_MAKE_PLATEID_CA_ON(_VodiK_PCODE_CA_ON1)
# define _VodiK_PCODE_CA_ON1 1

/* mask = xxxzzz, id = 717 */
# define VodiK_CA_ON2_PLATE _VODI_MAKE_PLATEID_CA_ON(_VodiK_PCODE_CA_ON2)
# define _VodiK_PCODE_CA_ON2 2

/* mask = xxxzzz, id = 715 */
# define VodiK_CA_ON3_PLATE _VODI_MAKE_PLATEID_CA_ON(_VodiK_PCODE_CA_ON3)
# define _VodiK_PCODE_CA_ON3 3

/* mask = xxzzxx, id = 716 */
# define VodiK_CA_ON4_PLATE _VODI_MAKE_PLATEID_CA_ON(_VodiK_PCODE_CA_ON4)
# define _VodiK_PCODE_CA_ON4 4

/* mask = zzxxxx, id = 718 */
# define VodiK_CA_ON5_PLATE _VODI_MAKE_PLATEID_CA_ON(_VodiK_PCODE_CA_ON5)
# define _VodiK_PCODE_CA_ON5 5

/* mask = zzxxxx, id = 719 */
# define VodiK_CA_ON6_PLATE _VODI_MAKE_PLATEID_CA_ON(_VodiK_PCODE_CA_ON6)
# define _VodiK_PCODE_CA_ON6 6

/* mask = zzxzzz, id = 720 */
# define VodiK_CA_ON7_PLATE _VODI_MAKE_PLATEID_CA_ON(_VodiK_PCODE_CA_ON7)
# define _VodiK_PCODE_CA_ON7 7

/* mask = xzxxxx, id = 721 */
# define VodiK_CA_ON8_PLATE _VODI_MAKE_PLATEID_CA_ON(_VodiK_PCODE_CA_ON8)
# define _VodiK_PCODE_CA_ON8 8
/* @} */


/*
 * CA_PE
 * @{
 */
# define _VODI_MAKE_PLATEID_CA_PE(aCode) \
_VODI_MAKE_PLATEID_CA(VodiK_CA_PE_SUBNUM,aCode)

/* mask = zzxxx, id = 722 */
# define VodiK_CA_PE1_PLATE _VODI_MAKE_PLATEID_CA_PE(_VodiK_PCODE_CA_PE1)
# define _VodiK_PCODE_CA_PE1 1

/* mask = zzxxx, id = 723 */
# define VodiK_CA_PE2_PLATE _VODI_MAKE_PLATEID_CA_PE(_VodiK_PCODE_CA_PE2)
# define _VodiK_PCODE_CA_PE2 2

/* mask = xxxz, id = 727 */
# define VodiK_CA_PE3_PLATE _VODI_MAKE_PLATEID_CA_PE(_VodiK_PCODE_CA_PE3)
# define _VodiK_PCODE_CA_PE3 3

/* mask = zzxxx, id = 725 */
# define VodiK_CA_PE4_PLATE _VODI_MAKE_PLATEID_CA_PE(_VodiK_PCODE_CA_PE4)
# define _VodiK_PCODE_CA_PE4 4

/* mask = zxxxx, id = 724 */
# define VodiK_CA_PE5_PLATE _VODI_MAKE_PLATEID_CA_PE(_VodiK_PCODE_CA_PE5)
# define _VodiK_PCODE_CA_PE5 5

/* mask = zzxxxx, id = 726 */
# define VodiK_CA_PE6_PLATE _VODI_MAKE_PLATEID_CA_PE(_VodiK_PCODE_CA_PE6)
# define _VodiK_PCODE_CA_PE6 6
/* @} */


/*
 * CA_QC
 * @{
 */
# define _VODI_MAKE_PLATEID_CA_QC(aCode) \
_VODI_MAKE_PLATEID_CA(VodiK_CA_QC_SUBNUM,aCode)

/* mask = XXXZXXX, id = 299 */
# define VodiK_CA_QC1_PLATE _VODI_MAKE_PLATEID_CA_QC(_VodiK_PCODE_CA_QC1)
# define _VodiK_PCODE_CA_QC1 1

/* mask = ZXXZXXX, id = 300 */
# define VodiK_CA_QC2_PLATE _VODI_MAKE_PLATEID_CA_QC(_VodiK_PCODE_CA_QC2)
# define _VodiK_PCODE_CA_QC2 2

/* mask = ZXXZZZ, id = 394 */
# define VodiK_CA_QC3_PLATE _VODI_MAKE_PLATEID_CA_QC(_VodiK_PCODE_CA_QC3)
# define _VodiK_PCODE_CA_QC3 3

/* mask = XXXZZZ, id = 395 */
# define VodiK_CA_QC4_PLATE _VODI_MAKE_PLATEID_CA_QC(_VodiK_PCODE_CA_QC4)
# define _VodiK_PCODE_CA_QC4 4

/* mask = ZZXXXXZ, id = 396 */
# define VodiK_CA_QC5_PLATE _VODI_MAKE_PLATEID_CA_QC(_VodiK_PCODE_CA_QC5)
# define _VodiK_PCODE_CA_QC5 5

/* mask = ZZZXXXX, id = 398 */
# define VodiK_CA_QC6_PLATE _VODI_MAKE_PLATEID_CA_QC(_VodiK_PCODE_CA_QC6)
# define _VodiK_PCODE_CA_QC6 6

/* mask = ZZXXXXX, id = 399 */
# define VodiK_CA_QC7_PLATE _VODI_MAKE_PLATEID_CA_QC(_VodiK_PCODE_CA_QC7)
# define _VodiK_PCODE_CA_QC7 7

/* mask = zzzxxx, id = 520 */
# define VodiK_CA_QC8_PLATE _VODI_MAKE_PLATEID_CA_QC(_VodiK_PCODE_CA_QC8)
# define _VodiK_PCODE_CA_QC8 8

/* mask = zxxxxxx, id = 517 */
# define VodiK_CA_QC9_PLATE _VODI_MAKE_PLATEID_CA_QC(_VodiK_PCODE_CA_QC9)
# define _VodiK_PCODE_CA_QC9 9

/* mask = zzzxxxx, id = 518 */
# define VodiK_CA_QC10_PLATE _VODI_MAKE_PLATEID_CA_QC(_VodiK_PCODE_CA_QC10)
# define _VodiK_PCODE_CA_QC10 10

/* mask = zzxxxx, id = 519 */
# define VodiK_CA_QC11_PLATE _VODI_MAKE_PLATEID_CA_QC(_VodiK_PCODE_CA_QC11)
# define _VodiK_PCODE_CA_QC11 11

/* mask = zzxxxxz, id = 521 */
# define VodiK_CA_QC12_PLATE _VODI_MAKE_PLATEID_CA_QC(_VodiK_PCODE_CA_QC12)
# define _VodiK_PCODE_CA_QC12 12

/* mask = zzxxxxx, id = 522 */
# define VodiK_CA_QC13_PLATE _VODI_MAKE_PLATEID_CA_QC(_VodiK_PCODE_CA_QC13)
# define _VodiK_PCODE_CA_QC13 13

/* mask = zxxxxx, id = 523 */
# define VodiK_CA_QC14_PLATE _VODI_MAKE_PLATEID_CA_QC(_VodiK_PCODE_CA_QC14)
# define _VodiK_PCODE_CA_QC14 14
/* @} */


/*
 * CA_SK
 * @{
 */
# define _VODI_MAKE_PLATEID_CA_SK(aCode) \
_VODI_MAKE_PLATEID_CA(VodiK_CA_SK_SUBNUM,aCode)

/* mask = xxxzzz, id = 728 */
# define VodiK_CA_SK1_PLATE _VODI_MAKE_PLATEID_CA_SK(_VodiK_PCODE_CA_SK1)
# define _VodiK_PCODE_CA_SK1 1

/* mask = zzzxxx, id = 729 */
# define VodiK_CA_SK2_PLATE _VODI_MAKE_PLATEID_CA_SK(_VodiK_PCODE_CA_SK2)
# define _VodiK_PCODE_CA_SK2 2

/* mask = xxxzz, id = 731 */
# define VodiK_CA_SK3_PLATE _VODI_MAKE_PLATEID_CA_SK(_VodiK_PCODE_CA_SK3)
# define _VodiK_PCODE_CA_SK3 3

/* mask = zxxxx, id = 730 */
# define VodiK_CA_SK4_PLATE _VODI_MAKE_PLATEID_CA_SK(_VodiK_PCODE_CA_SK4)
# define _VodiK_PCODE_CA_SK4 4
/* @} */


/*
 * CA_YT
 * @{
 */
# define _VODI_MAKE_PLATEID_CA_YT(aCode) \
_VODI_MAKE_PLATEID_CA(VodiK_CA_YT_SUBNUM,aCode)

/* mask = zzzxx, id = 732 */
# define VodiK_CA_YT1_PLATE _VODI_MAKE_PLATEID_CA_YT(_VodiK_PCODE_CA_YT1)
# define _VodiK_PCODE_CA_YT1 1

/* mask = zxxxxx, id = 735 */
# define VodiK_CA_YT2_PLATE _VODI_MAKE_PLATEID_CA_YT(_VodiK_PCODE_CA_YT2)
# define _VodiK_PCODE_CA_YT2 2

/* mask = zxxxx, id = 738 */
# define VodiK_CA_YT3_PLATE _VODI_MAKE_PLATEID_CA_YT(_VodiK_PCODE_CA_YT3)
# define _VodiK_PCODE_CA_YT3 3

/* mask = zzxxx, id = 733 */
# define VodiK_CA_YT4_PLATE _VODI_MAKE_PLATEID_CA_YT(_VodiK_PCODE_CA_YT4)
# define _VodiK_PCODE_CA_YT4 4

/* mask = zzzxxx, id = 734 */
# define VodiK_CA_YT5_PLATE _VODI_MAKE_PLATEID_CA_YT(_VodiK_PCODE_CA_YT5)
# define _VodiK_PCODE_CA_YT5 5

/* mask = zxxxxx, id = 736 */
# define VodiK_CA_YT6_PLATE _VODI_MAKE_PLATEID_CA_YT(_VodiK_PCODE_CA_YT6)
# define _VodiK_PCODE_CA_YT6 6

/* mask = xxxx, id = 737 */
# define VodiK_CA_YT7_PLATE _VODI_MAKE_PLATEID_CA_YT(_VodiK_PCODE_CA_YT7)
# define _VodiK_PCODE_CA_YT7 7
/* @} */


/*
* CG
* @{
*/
# define _VODI_MAKE_PLATEID_CG(aCode) _VODI_MAKE_PLATEID(VodiK_CONGO_NUMERIC,aCode)

/* mask = xxxxzzxx, id = 2271 */
# define VodiK_CG1_PLATE _VODI_MAKE_PLATEID_CG(_VodiK_PCODE_CG1)
# define _VodiK_PCODE_CG1 1
/* @} */


/*
 * CH
 * @{
 */
# define _VODI_MAKE_PLATEID_CH(aCode) _VODI_MAKE_PLATEID(VodiK_SWITZERLAND_NUMERIC,aCode)

/* mask = ZZXXXXXX, id = 473 */
# define VodiK_CH1_PLATE _VODI_MAKE_PLATEID_CH(_VodiK_PCODE_CH1)
# define _VodiK_PCODE_CH1 1

/* mask = ZZXXXXX, id = 474 */
# define VodiK_CH2_PLATE _VODI_MAKE_PLATEID_CH(_VodiK_PCODE_CH2)
# define _VodiK_PCODE_CH2 2

/* mask = ZZXXXX, id = 1674 */
# define VodiK_CH3_PLATE _VODI_MAKE_PLATEID_CH(_VodiK_PCODE_CH3)
# define _VodiK_PCODE_CH3 3

/* mask = ZZXXXXXX, id = 1675 */
# define VodiK_CH4_PLATE _VODI_MAKE_PLATEID_CH(_VodiK_PCODE_CH4)
# define _VodiK_PCODE_CH4 4

/* mask = ZZXXXX, id = 1676 */
# define VodiK_CH5_PLATE _VODI_MAKE_PLATEID_CH(_VodiK_PCODE_CH5)
# define _VodiK_PCODE_CH5 5
/* @} */


/*
 * CL
 * @{
 */
# define _VODI_MAKE_PLATEID_CL(aCode) _VODI_MAKE_PLATEID(VodiK_CHILE_NUMERIC,aCode)

/* mask = zzzzxx, id = 848 */
# define VodiK_CL1_PLATE _VODI_MAKE_PLATEID_CL(_VodiK_PCODE_CL1)
# define _VodiK_PCODE_CL1 1

/* mask = zzxxxx, id = 849 */
# define VodiK_CL2_PLATE _VODI_MAKE_PLATEID_CL(_VodiK_PCODE_CL2)
# define _VodiK_PCODE_CL2 2

/* mask = zzxxxx, id = 1372 */
# define VodiK_CL3_PLATE _VODI_MAKE_PLATEID_CL(_VodiK_PCODE_CL3)
# define _VodiK_PCODE_CL3 3

/* mask = zzxxx, id = 1373 */
# define VodiK_CL4_PLATE _VODI_MAKE_PLATEID_CL(_VodiK_PCODE_CL4)
# define _VodiK_PCODE_CL4 4

/* mask = zzxxxx, id = 1374 */
# define VodiK_CL5_PLATE _VODI_MAKE_PLATEID_CL(_VodiK_PCODE_CL5)
# define _VodiK_PCODE_CL5 5

/* mask = zxxxx, id = 1375 */
# define VodiK_CL6_PLATE _VODI_MAKE_PLATEID_CL(_VodiK_PCODE_CL6)
# define _VodiK_PCODE_CL6 6

/* mask = zzxxx, id = 1376 */
# define VodiK_CL7_PLATE _VODI_MAKE_PLATEID_CL(_VodiK_PCODE_CL7)
# define _VodiK_PCODE_CL7 7

/* mask = zzxxx, id = 1377 */
# define VodiK_CL8_PLATE _VODI_MAKE_PLATEID_CL(_VodiK_PCODE_CL8)
# define _VodiK_PCODE_CL8 8

/* mask = zzzzxx, id = 1399 */
# define VodiK_CL9_PLATE _VODI_MAKE_PLATEID_CL(_VodiK_PCODE_CL9)
# define _VodiK_PCODE_CL9 9

/* mask = zxxxx, id = 1406 */
# define VodiK_CL10_PLATE _VODI_MAKE_PLATEID_CL(_VodiK_PCODE_CL10)
# define _VodiK_PCODE_CL10 10

/* mask = zzzzxxxx, id = 1407 */
# define VodiK_CL11_PLATE _VODI_MAKE_PLATEID_CL(_VodiK_PCODE_CL11)
# define _VodiK_PCODE_CL11 11

/* mask = zzxxxx, id = 1408 */
# define VodiK_CL12_PLATE _VODI_MAKE_PLATEID_CL(_VodiK_PCODE_CL12)
# define _VodiK_PCODE_CL12 12

/* mask = zzzxx, id = 1409 */
# define VodiK_CL13_PLATE _VODI_MAKE_PLATEID_CL(_VodiK_PCODE_CL13)
# define _VodiK_PCODE_CL13 13

/* mask = zzzxxx, id = 1410 */
# define VodiK_CL14_PLATE _VODI_MAKE_PLATEID_CL(_VodiK_PCODE_CL14)
# define _VodiK_PCODE_CL14 14

/* mask = zzzxxx, id = 1411 */
# define VodiK_CL15_PLATE _VODI_MAKE_PLATEID_CL(_VodiK_PCODE_CL15)
# define _VodiK_PCODE_CL15 15

/* mask = zzzxxx, id = 1412 */
# define VodiK_CL16_PLATE _VODI_MAKE_PLATEID_CL(_VodiK_PCODE_CL16)
# define _VodiK_PCODE_CL16 16
/* @} */


/*
 * CM
 * @{
 */
# define _VODI_MAKE_PLATEID_CM(aCode) _VODI_MAKE_PLATEID(VodiK_CAMEROON_NUMERIC,aCode)

/* mask = zzxxxzz, id = 742 */
# define VodiK_CM1_PLATE _VODI_MAKE_PLATEID_CM(_VodiK_PCODE_CM1)
# define _VodiK_PCODE_CM1 1

/* mask = zzxxxxz, id = 743 */
# define VodiK_CM2_PLATE _VODI_MAKE_PLATEID_CM(_VodiK_PCODE_CM2)
# define _VodiK_PCODE_CM2 2

/* mask = zzxxxxx, id = 746 */
# define VodiK_CM3_PLATE _VODI_MAKE_PLATEID_CM(_VodiK_PCODE_CM3)
# define _VodiK_PCODE_CM3 3

/* mask = zzxxxxx, id = 750 */
# define VodiK_CM4_PLATE _VODI_MAKE_PLATEID_CM(_VodiK_PCODE_CM4)
# define _VodiK_PCODE_CM4 4

/* mask = zzzzxxxxz, id = 744 */
# define VodiK_CM5_PLATE _VODI_MAKE_PLATEID_CM(_VodiK_PCODE_CM5)
# define _VodiK_PCODE_CM5 5

/* mask = zzxxx, id = 745 */
# define VodiK_CM6_PLATE _VODI_MAKE_PLATEID_CM(_VodiK_PCODE_CM6)
# define _VodiK_PCODE_CM6 6

/* mask = zzxxxx, id = 747 */
# define VodiK_CM7_PLATE _VODI_MAKE_PLATEID_CM(_VodiK_PCODE_CM7)
# define _VodiK_PCODE_CM7 7

/* mask = zzzxxxx, id = 748 */
# define VodiK_CM8_PLATE _VODI_MAKE_PLATEID_CM(_VodiK_PCODE_CM8)
# define _VodiK_PCODE_CM8 8

/* mask = zzzxxx, id = 749 */
# define VodiK_CM9_PLATE _VODI_MAKE_PLATEID_CM(_VodiK_PCODE_CM9)
# define _VodiK_PCODE_CM9 9
/* @} */


/*
 * CN
 * @{
 */
# define _VODI_MAKE_PLATEID_CN(aCode) _VODI_MAKE_PLATEID(VodiK_CHINA_NUMERIC,aCode)

/* mask = zzxxxxx, id = 1346 */
# define VodiK_CN1_PLATE _VODI_MAKE_PLATEID_CN(_VodiK_PCODE_CN1)
# define _VodiK_PCODE_CN1 1

/* mask = zyyyyy, id = 1347 */
# define VodiK_CN2_PLATE _VODI_MAKE_PLATEID_CN(_VodiK_PCODE_CN2)
# define _VodiK_PCODE_CN2 2

/* mask = zyyyyy, id = 1350 */
# define VodiK_CN3_PLATE _VODI_MAKE_PLATEID_CN(_VodiK_PCODE_CN3)
# define _VodiK_PCODE_CN3 3

/* mask = zzyyyy, id = 2197 */
# define VodiK_CN4_PLATE _VODI_MAKE_PLATEID_CN(_VodiK_PCODE_CN4)
# define _VodiK_PCODE_CN4 4

/* mask = xxxxxx_inv, id = 2241 */
# define VodiK_CN5_PLATE _VODI_MAKE_PLATEID_CN(_VodiK_PCODE_CN5)
# define _VodiK_PCODE_CN5 5

/* mask = xxxxxx, id = 2242 */
# define VodiK_CN6_PLATE _VODI_MAKE_PLATEID_CN(_VodiK_PCODE_CN6)
# define _VodiK_PCODE_CN6 6

/* mask = xxxxxx_inv, id = 2243 */
# define VodiK_CN7_PLATE _VODI_MAKE_PLATEID_CN(_VodiK_PCODE_CN7)
# define _VodiK_PCODE_CN7 7
/* @} */


/*
 * CO
 * @{
 */
# define _VODI_MAKE_PLATEID_CO(aCode) _VODI_MAKE_PLATEID(VodiK_COLOMBIA_NUMERIC,aCode)

/* mask = ZZZXXX, id = 55 */
# define VodiK_CO1_PLATE _VODI_MAKE_PLATEID_CO(_VodiK_PCODE_CO1)
# define _VodiK_PCODE_CO1 1

/* mask = ZZZXX, id = 56 */
# define VodiK_CO2_PLATE _VODI_MAKE_PLATEID_CO(_VodiK_PCODE_CO2)
# define _VodiK_PCODE_CO2 2

/* mask = ZZXXXX, id = 57 */
# define VodiK_CO3_PLATE _VODI_MAKE_PLATEID_CO(_VodiK_PCODE_CO3)
# define _VodiK_PCODE_CO3 3

/* mask = ZZXXXX, id = 58 */
# define VodiK_CO4_PLATE _VODI_MAKE_PLATEID_CO(_VodiK_PCODE_CO4)
# define _VodiK_PCODE_CO4 4

/* mask = ZZZXXZ, id = 59 */
# define VodiK_CO5_PLATE _VODI_MAKE_PLATEID_CO(_VodiK_PCODE_CO5)
# define _VodiK_PCODE_CO5 5

/* mask = ZXXXXX, id = 60 */
# define VodiK_CO6_PLATE _VODI_MAKE_PLATEID_CO(_VodiK_PCODE_CO6)
# define _VodiK_PCODE_CO6 6

/* mask = ZXXXX, id = 61 */
# define VodiK_CO7_PLATE _VODI_MAKE_PLATEID_CO(_VodiK_PCODE_CO7)
# define _VodiK_PCODE_CO7 7
/* @} */


/*
 * CR
 * @{
 */
# define _VODI_MAKE_PLATEID_CR(aCode) _VODI_MAKE_PLATEID(VodiK_COSTA_RICA_NUMERIC,aCode)

/* mask = xxxxxx, id = 785 */
# define VodiK_CR1_PLATE _VODI_MAKE_PLATEID_CR(_VodiK_PCODE_CR1)
# define _VodiK_PCODE_CR1 1

/* mask = zzzxxx, id = 1199 */
# define VodiK_CR2_PLATE _VODI_MAKE_PLATEID_CR(_VodiK_PCODE_CR2)
# define _VodiK_PCODE_CR2 2

/* mask = zxxxxxx, id = 1200 */
# define VodiK_CR3_PLATE _VODI_MAKE_PLATEID_CR(_VodiK_PCODE_CR3)
# define _VodiK_PCODE_CR3 3

/* mask = zxxxxx, id = 786 */
# define VodiK_CR4_PLATE _VODI_MAKE_PLATEID_CR(_VodiK_PCODE_CR4)
# define _VodiK_PCODE_CR4 4

/* mask = zxxxxxx, id = 1207 */
# define VodiK_CR5_PLATE _VODI_MAKE_PLATEID_CR(_VodiK_PCODE_CR5)
# define _VodiK_PCODE_CR5 5

/* mask = xxxxxxx, id = 787 */
# define VodiK_CR6_PLATE _VODI_MAKE_PLATEID_CR(_VodiK_PCODE_CR6)
# define _VodiK_PCODE_CR6 6

/* mask = zzzxxxxx, id = 788 */
# define VodiK_CR7_PLATE _VODI_MAKE_PLATEID_CR(_VodiK_PCODE_CR7)
# define _VodiK_PCODE_CR7 7

/* mask = zzxxxx, id = 789 */
# define VodiK_CR8_PLATE _VODI_MAKE_PLATEID_CR(_VodiK_PCODE_CR8)
# define _VodiK_PCODE_CR8 8

/* mask = zzzxxxx, id = 790 */
# define VodiK_CR9_PLATE _VODI_MAKE_PLATEID_CR(_VodiK_PCODE_CR9)
# define _VodiK_PCODE_CR9 9

/* mask = zxxxxx, id = 791 */
# define VodiK_CR10_PLATE _VODI_MAKE_PLATEID_CR(_VodiK_PCODE_CR10)
# define _VodiK_PCODE_CR10 10

/* mask = xxxx, id = 792 */
# define VodiK_CR11_PLATE _VODI_MAKE_PLATEID_CR(_VodiK_PCODE_CR11)
# define _VodiK_PCODE_CR11 11

/* mask = zxxx, id = 793 */
# define VodiK_CR12_PLATE _VODI_MAKE_PLATEID_CR(_VodiK_PCODE_CR12)
# define _VodiK_PCODE_CR12 12

/* mask = xxxx, id = 1202 */
# define VodiK_CR13_PLATE _VODI_MAKE_PLATEID_CR(_VodiK_PCODE_CR13)
# define _VodiK_PCODE_CR13 13

/* mask = xxx, id = 1522 */
# define VodiK_CR14_PLATE _VODI_MAKE_PLATEID_CR(_VodiK_PCODE_CR14)
# define _VodiK_PCODE_CR14 14

/* mask = zxxx, id = 1523 */
# define VodiK_CR15_PLATE _VODI_MAKE_PLATEID_CR(_VodiK_PCODE_CR15)
# define _VodiK_PCODE_CR15 15

/* mask = xxxxxx, id = 1524 */
# define VodiK_CR16_PLATE _VODI_MAKE_PLATEID_CR(_VodiK_PCODE_CR16)
# define _VodiK_PCODE_CR16 16

/* mask = zxxxxzx, id = 1525 */
# define VodiK_CR17_PLATE _VODI_MAKE_PLATEID_CR(_VodiK_PCODE_CR17)
# define _VodiK_PCODE_CR17 17

/* mask = zxxxxxxz, id = 1526 */
# define VodiK_CR18_PLATE _VODI_MAKE_PLATEID_CR(_VodiK_PCODE_CR18)
# define _VodiK_PCODE_CR18 18
/* @} */


/*
 * CU
 * @{
 */
# define _VODI_MAKE_PLATEID_CU(aCode) _VODI_MAKE_PLATEID(VodiK_CUBA_NUMERIC,aCode)

/* mask = zzzxxx, id = 794 */
# define VodiK_CU1_PLATE _VODI_MAKE_PLATEID_CU(_VodiK_PCODE_CU1)
# define _VodiK_PCODE_CU1 1

/* mask = zxxxxz, id = 836 */
# define VodiK_CU2_PLATE _VODI_MAKE_PLATEID_CU(_VodiK_PCODE_CU2)
# define _VodiK_PCODE_CU2 2

/* mask = xxxxxx, id = 837 */
# define VodiK_CU3_PLATE _VODI_MAKE_PLATEID_CU(_VodiK_PCODE_CU3)
# define _VodiK_PCODE_CU3 3

/* mask = xxx, id = 839 */
# define VodiK_CU4_PLATE _VODI_MAKE_PLATEID_CU(_VodiK_PCODE_CU4)
# define _VodiK_PCODE_CU4 4

/* mask = zxxxxx, id = 835 */
# define VodiK_CU5_PLATE _VODI_MAKE_PLATEID_CU(_VodiK_PCODE_CU5)
# define _VodiK_PCODE_CU5 5

/* mask = zxxxxx, id = 838 */
# define VodiK_CU6_PLATE _VODI_MAKE_PLATEID_CU(_VodiK_PCODE_CU6)
# define _VodiK_PCODE_CU6 6

/* mask = zzzxxx, id = 1518 */
# define VodiK_CU7_PLATE _VODI_MAKE_PLATEID_CU(_VodiK_PCODE_CU7)
# define _VodiK_PCODE_CU7 7

/* mask = zxxxxxx, id = 1519 */
# define VodiK_CU8_PLATE _VODI_MAKE_PLATEID_CU(_VodiK_PCODE_CU8)
# define _VodiK_PCODE_CU8 8

/* mask = zxxxxxx, id = 1520 */
# define VodiK_CU9_PLATE _VODI_MAKE_PLATEID_CU(_VodiK_PCODE_CU9)
# define _VodiK_PCODE_CU9 9
/* @} */


/*
 * CY
 * @{
 */
# define _VODI_MAKE_PLATEID_CY(aCode) _VODI_MAKE_PLATEID(VodiK_CYPRUS_NUMERIC,aCode)

/* mask = zzzxxx, id = 537 */
# define VodiK_CY1_PLATE _VODI_MAKE_PLATEID_CY(_VodiK_PCODE_CY1)
# define _VodiK_PCODE_CY1 1

/* mask = zzzxxx, id = 2211 */
# define VodiK_CY2_PLATE _VODI_MAKE_PLATEID_CY(_VodiK_PCODE_CY2)
# define _VodiK_PCODE_CY2 2

/* mask = zzzxxx, id = 2212 */
# define VodiK_CY3_PLATE _VODI_MAKE_PLATEID_CY(_VodiK_PCODE_CY3)
# define _VodiK_PCODE_CY3 3

/* mask = zzzxxx, id = 2213 */
# define VodiK_CY4_PLATE _VODI_MAKE_PLATEID_CY(_VodiK_PCODE_CY4)
# define _VodiK_PCODE_CY4 4

/* mask = zzzzxxx, id = 2214 */
# define VodiK_CY5_PLATE _VODI_MAKE_PLATEID_CY(_VodiK_PCODE_CY5)
# define _VodiK_PCODE_CY5 5

/* mask = zzzzxxx, id = 2215 */
# define VodiK_CY6_PLATE _VODI_MAKE_PLATEID_CY(_VodiK_PCODE_CY6)
# define _VodiK_PCODE_CY6 6

/* mask = zzzzxxx, id = 2216 */
# define VodiK_CY7_PLATE _VODI_MAKE_PLATEID_CY(_VodiK_PCODE_CY7)
# define _VodiK_PCODE_CY7 7

/* mask = zzzx, id = 2217 */
# define VodiK_CY8_PLATE _VODI_MAKE_PLATEID_CY(_VodiK_PCODE_CY8)
# define _VodiK_PCODE_CY8 8

/* mask = xxzzx, id = 2218 */
# define VodiK_CY9_PLATE _VODI_MAKE_PLATEID_CY(_VodiK_PCODE_CY9)
# define _VodiK_PCODE_CY9 9

/* mask = zzxxx, id = 2219 */
# define VodiK_CY10_PLATE _VODI_MAKE_PLATEID_CY(_VodiK_PCODE_CY10)
# define _VodiK_PCODE_CY10 10

/* mask = zzxxx, id = 2220 */
# define VodiK_CY11_PLATE _VODI_MAKE_PLATEID_CY(_VodiK_PCODE_CY11)
# define _VodiK_PCODE_CY11 11

/* mask = zzxxx, id = 2221 */
# define VodiK_CY12_PLATE _VODI_MAKE_PLATEID_CY(_VodiK_PCODE_CY12)
# define _VodiK_PCODE_CY12 12

/* mask = zxxxxx, id = 2222 */
# define VodiK_CY13_PLATE _VODI_MAKE_PLATEID_CY(_VodiK_PCODE_CY13)
# define _VodiK_PCODE_CY13 13

/* mask = zxxxxx, id = 2223 */
# define VodiK_CY14_PLATE _VODI_MAKE_PLATEID_CY(_VodiK_PCODE_CY14)
# define _VodiK_PCODE_CY14 14

/* mask = zxxxxx, id = 2224 */
# define VodiK_CY15_PLATE _VODI_MAKE_PLATEID_CY(_VodiK_PCODE_CY15)
# define _VodiK_PCODE_CY15 15

/* mask = xxxxzz, id = 2225 */
# define VodiK_CY16_PLATE _VODI_MAKE_PLATEID_CY(_VodiK_PCODE_CY16)
# define _VodiK_PCODE_CY16 16

/* mask = xxxxxzz, id = 2226 */
# define VodiK_CY17_PLATE _VODI_MAKE_PLATEID_CY(_VodiK_PCODE_CY17)
# define _VodiK_PCODE_CY17 17
/* @} */


/*
 * CZ
 * @{
 */
# define _VODI_MAKE_PLATEID_CZ(aCode) _VODI_MAKE_PLATEID(VodiK_CZECH_REPUBLIC_NUMERIC,aCode)

/* mask = XZXXXXX, id = 170 */
# define VodiK_CZ1_PLATE _VODI_MAKE_PLATEID_CZ(_VodiK_PCODE_CZ1)
# define _VodiK_PCODE_CZ1 1

/* mask = XXXZZXX, id = 171 */
# define VodiK_CZ2_PLATE _VODI_MAKE_PLATEID_CZ(_VodiK_PCODE_CZ2)
# define _VodiK_PCODE_CZ2 2

/* mask = XXZXXXX, id = 172 */
# define VodiK_CZ3_PLATE _VODI_MAKE_PLATEID_CZ(_VodiK_PCODE_CZ3)
# define _VodiK_PCODE_CZ3 3

/* mask = ZZXXXX, id = 173 */
# define VodiK_CZ4_PLATE _VODI_MAKE_PLATEID_CZ(_VodiK_PCODE_CZ4)
# define _VodiK_PCODE_CZ4 4

/* mask = ZZZXXXX, id = 174 */
# define VodiK_CZ5_PLATE _VODI_MAKE_PLATEID_CZ(_VodiK_PCODE_CZ5)
# define _VodiK_PCODE_CZ5 5

/* mask = XZZXXXX, id = 175 */
# define VodiK_CZ6_PLATE _VODI_MAKE_PLATEID_CZ(_VodiK_PCODE_CZ6)
# define _VodiK_PCODE_CZ6 6

/* mask = ZXXXXZ, id = 176 */
# define VodiK_CZ7_PLATE _VODI_MAKE_PLATEID_CZ(_VodiK_PCODE_CZ7)
# define _VodiK_PCODE_CZ7 7

/* mask = ZZXXXZ, id = 177 */
# define VodiK_CZ8_PLATE _VODI_MAKE_PLATEID_CZ(_VodiK_PCODE_CZ8)
# define _VodiK_PCODE_CZ8 8

/* mask = zxxxx, id = 1228 */
# define VodiK_CZ9_PLATE _VODI_MAKE_PLATEID_CZ(_VodiK_PCODE_CZ9)
# define _VodiK_PCODE_CZ9 9

/* mask = XXXZZXX, id = 1662 */
# define VodiK_CZ10_PLATE _VODI_MAKE_PLATEID_CZ(_VodiK_PCODE_CZ10)
# define _VodiK_PCODE_CZ10 10

/* mask = XXXZZXX, id = 1663 */
# define VodiK_CZ11_PLATE _VODI_MAKE_PLATEID_CZ(_VodiK_PCODE_CZ11)
# define _VodiK_PCODE_CZ11 11

/* mask = XXXXXZ, id = 1664 */
# define VodiK_CZ12_PLATE _VODI_MAKE_PLATEID_CZ(_VodiK_PCODE_CZ12)
# define _VodiK_PCODE_CZ12 12

/* mask = XZXXXXX, id = 1665 */
# define VodiK_CZ13_PLATE _VODI_MAKE_PLATEID_CZ(_VodiK_PCODE_CZ13)
# define _VodiK_PCODE_CZ13 13

/* mask = XZXXXXX, id = 1666 */
# define VodiK_CZ14_PLATE _VODI_MAKE_PLATEID_CZ(_VodiK_PCODE_CZ14)
# define _VodiK_PCODE_CZ14 14

/* mask = XZXXXX, id = 1667 */
# define VodiK_CZ15_PLATE _VODI_MAKE_PLATEID_CZ(_VodiK_PCODE_CZ15)
# define _VodiK_PCODE_CZ15 15
/* @} */


/*
* DE
* @{
*/
# define _VODI_MAKE_PLATEID_DE(aCode) _VODI_MAKE_PLATEID(VodiK_GERMANY_NUMERIC,aCode)

/* mask = ZZZZXXXX, id = 355 */
# define VodiK_DE1_PLATE _VODI_MAKE_PLATEID_DE(_VodiK_PCODE_DE1)
# define _VodiK_PCODE_DE1 1

/* mask = ZZZZZXXX, id = 356 */
# define VodiK_DE2_PLATE _VODI_MAKE_PLATEID_DE(_VodiK_PCODE_DE2)
# define _VodiK_PCODE_DE2 2

/* mask = ZZZZXXX, id = 357 */
# define VodiK_DE3_PLATE _VODI_MAKE_PLATEID_DE(_VodiK_PCODE_DE3)
# define _VodiK_PCODE_DE3 3

/* mask = ZZZZZXX, id = 358 */
# define VodiK_DE4_PLATE _VODI_MAKE_PLATEID_DE(_VodiK_PCODE_DE4)
# define _VodiK_PCODE_DE4 4

/* mask = ZZZZZX, id = 359 */
# define VodiK_DE5_PLATE _VODI_MAKE_PLATEID_DE(_VodiK_PCODE_DE5)
# define _VodiK_PCODE_DE5 5

/* mask = ZZZZXXXX, id = 360 */
# define VodiK_DE6_PLATE _VODI_MAKE_PLATEID_DE(_VodiK_PCODE_DE6)
# define _VodiK_PCODE_DE6 6

/* mask = ZZZXXXX, id = 361 */
# define VodiK_DE7_PLATE _VODI_MAKE_PLATEID_DE(_VodiK_PCODE_DE7)
# define _VodiK_PCODE_DE7 7

/* mask = ZZZZXXX, id = 362 */
# define VodiK_DE8_PLATE _VODI_MAKE_PLATEID_DE(_VodiK_PCODE_DE8)
# define _VodiK_PCODE_DE8 8

/* mask = ZZZXXX, id = 363 */
# define VodiK_DE9_PLATE _VODI_MAKE_PLATEID_DE(_VodiK_PCODE_DE9)
# define _VodiK_PCODE_DE9 9

/* mask = ZZZZXX, id = 364 */
# define VodiK_DE10_PLATE _VODI_MAKE_PLATEID_DE(_VodiK_PCODE_DE10)
# define _VodiK_PCODE_DE10 10

/* mask = ZZZZX, id = 365 */
# define VodiK_DE11_PLATE _VODI_MAKE_PLATEID_DE(_VodiK_PCODE_DE11)
# define _VodiK_PCODE_DE11 11

/* mask = ZZZX, id = 366 */
# define VodiK_DE12_PLATE _VODI_MAKE_PLATEID_DE(_VodiK_PCODE_DE12)
# define _VodiK_PCODE_DE12 12

/* mask = ZZZXXXX, id = 367 */
# define VodiK_DE13_PLATE _VODI_MAKE_PLATEID_DE(_VodiK_PCODE_DE13)
# define _VodiK_PCODE_DE13 13

/* mask = ZZXXXX, id = 368 */
# define VodiK_DE14_PLATE _VODI_MAKE_PLATEID_DE(_VodiK_PCODE_DE14)
# define _VodiK_PCODE_DE14 14

/* mask = ZZZXXX, id = 369 */
# define VodiK_DE15_PLATE _VODI_MAKE_PLATEID_DE(_VodiK_PCODE_DE15)
# define _VodiK_PCODE_DE15 15

/* mask = ZZXXX, id = 370 */
# define VodiK_DE16_PLATE _VODI_MAKE_PLATEID_DE(_VodiK_PCODE_DE16)
# define _VodiK_PCODE_DE16 16

/* mask = ZZZXX, id = 371 */
# define VodiK_DE17_PLATE _VODI_MAKE_PLATEID_DE(_VodiK_PCODE_DE17)
# define _VodiK_PCODE_DE17 17

/* mask = ZZZX, id = 372 */
# define VodiK_DE18_PLATE _VODI_MAKE_PLATEID_DE(_VodiK_PCODE_DE18)
# define _VodiK_PCODE_DE18 18

/* mask = ZXXXX, id = 1635 */
# define VodiK_DE19_PLATE _VODI_MAKE_PLATEID_DE(_VodiK_PCODE_DE19)
# define _VodiK_PCODE_DE19 19

/* mask = ZZZZXXXZ, id = 1638 */
# define VodiK_DE20_PLATE _VODI_MAKE_PLATEID_DE(_VodiK_PCODE_DE20)
# define _VodiK_PCODE_DE20 20

/* mask = zzzzzxx, id = 1769 */
# define VodiK_DE21_PLATE _VODI_MAKE_PLATEID_DE(_VodiK_PCODE_DE21)
# define _VodiK_PCODE_DE21 21

/* mask = zzzzx, id = 1770 */
# define VodiK_DE22_PLATE _VODI_MAKE_PLATEID_DE(_VodiK_PCODE_DE22)
# define _VodiK_PCODE_DE22 22

/* mask = zzzxx, id = 1771 */
# define VodiK_DE23_PLATE _VODI_MAKE_PLATEID_DE(_VodiK_PCODE_DE23)
# define _VodiK_PCODE_DE23 23

/* mask = zzzzzx, id = 1772 */
# define VodiK_DE24_PLATE _VODI_MAKE_PLATEID_DE(_VodiK_PCODE_DE24)
# define _VodiK_PCODE_DE24 24

/* mask = zzzzzx, id = 1773 */
# define VodiK_DE25_PLATE _VODI_MAKE_PLATEID_DE(_VodiK_PCODE_DE25)
# define _VodiK_PCODE_DE25 25

/* mask = zzzzzxxx, id = 1774 */
# define VodiK_DE26_PLATE _VODI_MAKE_PLATEID_DE(_VodiK_PCODE_DE26)
# define _VodiK_PCODE_DE26 26

/* mask = zzzzx, id = 1775 */
# define VodiK_DE27_PLATE _VODI_MAKE_PLATEID_DE(_VodiK_PCODE_DE27)
# define _VodiK_PCODE_DE27 27

/* mask = zzzzxx, id = 1776 */
# define VodiK_DE28_PLATE _VODI_MAKE_PLATEID_DE(_VodiK_PCODE_DE28)
# define _VodiK_PCODE_DE28 28

/* mask = zzzzxx, id = 1777 */
# define VodiK_DE29_PLATE _VODI_MAKE_PLATEID_DE(_VodiK_PCODE_DE29)
# define _VodiK_PCODE_DE29 29

/* mask = zzzzxxx, id = 1782 */
# define VodiK_DE30_PLATE _VODI_MAKE_PLATEID_DE(_VodiK_PCODE_DE30)
# define _VodiK_PCODE_DE30 30

/* mask = zzzzxxxx, id = 1783 */
# define VodiK_DE31_PLATE _VODI_MAKE_PLATEID_DE(_VodiK_PCODE_DE31)
# define _VodiK_PCODE_DE31 31

/* mask = zzzzx, id = 1784 */
# define VodiK_DE32_PLATE _VODI_MAKE_PLATEID_DE(_VodiK_PCODE_DE32)
# define _VodiK_PCODE_DE32 32

/* mask = zzzzx, id = 1785 */
# define VodiK_DE33_PLATE _VODI_MAKE_PLATEID_DE(_VodiK_PCODE_DE33)
# define _VodiK_PCODE_DE33 33

/* mask = zzzzxx, id = 1786 */
# define VodiK_DE34_PLATE _VODI_MAKE_PLATEID_DE(_VodiK_PCODE_DE34)
# define _VodiK_PCODE_DE34 34

/* mask = zzzzxx, id = 1787 */
# define VodiK_DE35_PLATE _VODI_MAKE_PLATEID_DE(_VodiK_PCODE_DE35)
# define _VodiK_PCODE_DE35 35

/* mask = zzzzxxxx, id = 1788 */
# define VodiK_DE36_PLATE _VODI_MAKE_PLATEID_DE(_VodiK_PCODE_DE36)
# define _VodiK_PCODE_DE36 36

/* mask = zzzxx, id = 1789 */
# define VodiK_DE37_PLATE _VODI_MAKE_PLATEID_DE(_VodiK_PCODE_DE37)
# define _VodiK_PCODE_DE37 37

/* mask = zzzxx, id = 1790 */
# define VodiK_DE38_PLATE _VODI_MAKE_PLATEID_DE(_VodiK_PCODE_DE38)
# define _VodiK_PCODE_DE38 38

/* mask = zzzxxx, id = 1791 */
# define VodiK_DE39_PLATE _VODI_MAKE_PLATEID_DE(_VodiK_PCODE_DE39)
# define _VodiK_PCODE_DE39 39

/* mask = zzzxxx, id = 1792 */
# define VodiK_DE40_PLATE _VODI_MAKE_PLATEID_DE(_VodiK_PCODE_DE40)
# define _VodiK_PCODE_DE40 40

/* mask = zzzxxxx, id = 1793 */
# define VodiK_DE41_PLATE _VODI_MAKE_PLATEID_DE(_VodiK_PCODE_DE41)
# define _VodiK_PCODE_DE41 41

/* mask = zzzx, id = 1794 */
# define VodiK_DE42_PLATE _VODI_MAKE_PLATEID_DE(_VodiK_PCODE_DE42)
# define _VodiK_PCODE_DE42 42

/* mask = zzzxx, id = 1795 */
# define VodiK_DE43_PLATE _VODI_MAKE_PLATEID_DE(_VodiK_PCODE_DE43)
# define _VodiK_PCODE_DE43 43

/* mask = zzzxxx, id = 1796 */
# define VodiK_DE44_PLATE _VODI_MAKE_PLATEID_DE(_VodiK_PCODE_DE44)
# define _VodiK_PCODE_DE44 44

/* mask = zzzxxx, id = 1797 */
# define VodiK_DE45_PLATE _VODI_MAKE_PLATEID_DE(_VodiK_PCODE_DE45)
# define _VodiK_PCODE_DE45 45

/* mask = zzzxxxx, id = 1798 */
# define VodiK_DE46_PLATE _VODI_MAKE_PLATEID_DE(_VodiK_PCODE_DE46)
# define _VodiK_PCODE_DE46 46

/* mask = zzxxx, id = 1799 */
# define VodiK_DE47_PLATE _VODI_MAKE_PLATEID_DE(_VodiK_PCODE_DE47)
# define _VodiK_PCODE_DE47 47

/* mask = zzxxx, id = 1800 */
# define VodiK_DE48_PLATE _VODI_MAKE_PLATEID_DE(_VodiK_PCODE_DE48)
# define _VodiK_PCODE_DE48 48

/* mask = zzxxxx, id = 1801 */
# define VodiK_DE49_PLATE _VODI_MAKE_PLATEID_DE(_VodiK_PCODE_DE49)
# define _VodiK_PCODE_DE49 49

/* mask = zzxxxx, id = 1802 */
# define VodiK_DE50_PLATE _VODI_MAKE_PLATEID_DE(_VodiK_PCODE_DE50)
# define _VodiK_PCODE_DE50 50

/* mask = Xxxxx, id = 1803 */
# define VodiK_DE51_PLATE _VODI_MAKE_PLATEID_DE(_VodiK_PCODE_DE51)
# define _VodiK_PCODE_DE51 51

/* mask = zzxxxz, id = 1804 */
# define VodiK_DE52_PLATE _VODI_MAKE_PLATEID_DE(_VodiK_PCODE_DE52)
# define _VodiK_PCODE_DE52 52

/* mask = zzxxxz, id = 1805 */
# define VodiK_DE53_PLATE _VODI_MAKE_PLATEID_DE(_VodiK_PCODE_DE53)
# define _VodiK_PCODE_DE53 53

/* mask = ZZZX, id = 1806 */
# define VodiK_DE54_PLATE _VODI_MAKE_PLATEID_DE(_VodiK_PCODE_DE54)
# define _VodiK_PCODE_DE54 54

/* mask = ZZZX, id = 1807 */
# define VodiK_DE55_PLATE _VODI_MAKE_PLATEID_DE(_VodiK_PCODE_DE55)
# define _VodiK_PCODE_DE55 55

/* mask = zzzxxxx, id = 1808 */
# define VodiK_DE56_PLATE _VODI_MAKE_PLATEID_DE(_VodiK_PCODE_DE56)
# define _VodiK_PCODE_DE56 56

/* mask = zzxxxxx, id = 1809 */
# define VodiK_DE57_PLATE _VODI_MAKE_PLATEID_DE(_VodiK_PCODE_DE57)
# define _VodiK_PCODE_DE57 57

/* mask = zzzxxxxz, id = 1810 */
# define VodiK_DE58_PLATE _VODI_MAKE_PLATEID_DE(_VodiK_PCODE_DE58)
# define _VodiK_PCODE_DE58 58

/* mask = zzzxxxxz, id = 1811 */
# define VodiK_DE59_PLATE _VODI_MAKE_PLATEID_DE(_VodiK_PCODE_DE59)
# define _VodiK_PCODE_DE59 59

/* mask = zzx, id = 1812 */
# define VodiK_DE60_PLATE _VODI_MAKE_PLATEID_DE(_VodiK_PCODE_DE60)
# define _VodiK_PCODE_DE60 60

/* mask = zzxx, id = 1813 */
# define VodiK_DE61_PLATE _VODI_MAKE_PLATEID_DE(_VodiK_PCODE_DE61)
# define _VodiK_PCODE_DE61 61

/* mask = zzxxxxz, id = 1814 */
# define VodiK_DE62_PLATE _VODI_MAKE_PLATEID_DE(_VodiK_PCODE_DE62)
# define _VodiK_PCODE_DE62 62

/* mask = zzzx, id = 1815 */
# define VodiK_DE63_PLATE _VODI_MAKE_PLATEID_DE(_VodiK_PCODE_DE63)
# define _VodiK_PCODE_DE63 63

/* mask = zzzxxxxz, id = 1816 */
# define VodiK_DE64_PLATE _VODI_MAKE_PLATEID_DE(_VodiK_PCODE_DE64)
# define _VodiK_PCODE_DE64 64

/* mask = zzx, id = 1817 */
# define VodiK_DE65_PLATE _VODI_MAKE_PLATEID_DE(_VodiK_PCODE_DE65)
# define _VodiK_PCODE_DE65 65

/* mask = zzxx, id = 1818 */
# define VodiK_DE66_PLATE _VODI_MAKE_PLATEID_DE(_VodiK_PCODE_DE66)
# define _VodiK_PCODE_DE66 66

/* mask = zzxxxxz, id = 1819 */
# define VodiK_DE67_PLATE _VODI_MAKE_PLATEID_DE(_VodiK_PCODE_DE67)
# define _VodiK_PCODE_DE67 67

/* mask = zxz, id = 2101 */
# define VodiK_DE68_PLATE _VODI_MAKE_PLATEID_DE(_VodiK_PCODE_DE68)
# define _VodiK_PCODE_DE68 68

/* mask = zxxz, id = 2102 */
# define VodiK_DE69_PLATE _VODI_MAKE_PLATEID_DE(_VodiK_PCODE_DE69)
# define _VodiK_PCODE_DE69 69

/* mask = zxxxz, id = 2103 */
# define VodiK_DE70_PLATE _VODI_MAKE_PLATEID_DE(_VodiK_PCODE_DE70)
# define _VodiK_PCODE_DE70 70

/* mask = zxxxxz, id = 2104 */
# define VodiK_DE71_PLATE _VODI_MAKE_PLATEID_DE(_VodiK_PCODE_DE71)
# define _VodiK_PCODE_DE71 71

/* mask = zzxz, id = 2105 */
# define VodiK_DE72_PLATE _VODI_MAKE_PLATEID_DE(_VodiK_PCODE_DE72)
# define _VodiK_PCODE_DE72 72

/* mask = zzxxz, id = 2106 */
# define VodiK_DE73_PLATE _VODI_MAKE_PLATEID_DE(_VodiK_PCODE_DE73)
# define _VodiK_PCODE_DE73 73

/* mask = zzxxxxz, id = 2107 */
# define VodiK_DE74_PLATE _VODI_MAKE_PLATEID_DE(_VodiK_PCODE_DE74)
# define _VodiK_PCODE_DE74 74

/* mask = zzzxz, id = 2108 */
# define VodiK_DE75_PLATE _VODI_MAKE_PLATEID_DE(_VodiK_PCODE_DE75)
# define _VodiK_PCODE_DE75 75

/* mask = zzzxxz, id = 2109 */
# define VodiK_DE76_PLATE _VODI_MAKE_PLATEID_DE(_VodiK_PCODE_DE76)
# define _VodiK_PCODE_DE76 76

/* mask = zzzxxxz, id = 2110 */
# define VodiK_DE77_PLATE _VODI_MAKE_PLATEID_DE(_VodiK_PCODE_DE77)
# define _VodiK_PCODE_DE77 77

/* mask = zzzxxxxz, id = 2111 */
# define VodiK_DE78_PLATE _VODI_MAKE_PLATEID_DE(_VodiK_PCODE_DE78)
# define _VodiK_PCODE_DE78 78

/* mask = ZZZX, id = 2112 */
# define VodiK_DE79_PLATE _VODI_MAKE_PLATEID_DE(_VodiK_PCODE_DE79)
# define _VodiK_PCODE_DE79 79

/* mask = ZZZX, id = 2113 */
# define VodiK_DE80_PLATE _VODI_MAKE_PLATEID_DE(_VodiK_PCODE_DE80)
# define _VodiK_PCODE_DE80 80

/* mask = zzzxxxx, id = 2114 */
# define VodiK_DE81_PLATE _VODI_MAKE_PLATEID_DE(_VodiK_PCODE_DE81)
# define _VodiK_PCODE_DE81 81

/* mask = zzxxxxx, id = 2115 */
# define VodiK_DE82_PLATE _VODI_MAKE_PLATEID_DE(_VodiK_PCODE_DE82)
# define _VodiK_PCODE_DE82 82

/* mask = zzzxxxxz, id = 2116 */
# define VodiK_DE83_PLATE _VODI_MAKE_PLATEID_DE(_VodiK_PCODE_DE83)
# define _VodiK_PCODE_DE83 83

/* mask = zzzxxxxz, id = 2117 */
# define VodiK_DE84_PLATE _VODI_MAKE_PLATEID_DE(_VodiK_PCODE_DE84)
# define _VodiK_PCODE_DE84 84

/* mask = zzx, id = 2118 */
# define VodiK_DE85_PLATE _VODI_MAKE_PLATEID_DE(_VodiK_PCODE_DE85)
# define _VodiK_PCODE_DE85 85

/* mask = zzxx, id = 2119 */
# define VodiK_DE86_PLATE _VODI_MAKE_PLATEID_DE(_VodiK_PCODE_DE86)
# define _VodiK_PCODE_DE86 86

/* mask = zzxxxxz, id = 2120 */
# define VodiK_DE87_PLATE _VODI_MAKE_PLATEID_DE(_VodiK_PCODE_DE87)
# define _VodiK_PCODE_DE87 87

/* mask = zzzx, id = 2121 */
# define VodiK_DE88_PLATE _VODI_MAKE_PLATEID_DE(_VodiK_PCODE_DE88)
# define _VodiK_PCODE_DE88 88

/* mask = zzzxxxxz, id = 2122 */
# define VodiK_DE89_PLATE _VODI_MAKE_PLATEID_DE(_VodiK_PCODE_DE89)
# define _VodiK_PCODE_DE89 89

/* mask = zzx, id = 2123 */
# define VodiK_DE90_PLATE _VODI_MAKE_PLATEID_DE(_VodiK_PCODE_DE90)
# define _VodiK_PCODE_DE90 90

/* mask = zzxx, id = 2124 */
# define VodiK_DE91_PLATE _VODI_MAKE_PLATEID_DE(_VodiK_PCODE_DE91)
# define _VodiK_PCODE_DE91 91

/* mask = zzxxxxz, id = 2125 */
# define VodiK_DE92_PLATE _VODI_MAKE_PLATEID_DE(_VodiK_PCODE_DE92)
# define _VodiK_PCODE_DE92 92
/* @} */


/*
 * DK
 * @{
 */
# define _VODI_MAKE_PLATEID_DK(aCode) _VODI_MAKE_PLATEID(VodiK_DENMARK_NUMERIC,aCode)

/* mask = ZZXXXXX, id = 448 */
# define VodiK_DK1_PLATE _VODI_MAKE_PLATEID_DK(_VodiK_PCODE_DK1)
# define _VodiK_PCODE_DK1 1

/* mask = ZZXXXXX, id = 449 */
# define VodiK_DK2_PLATE _VODI_MAKE_PLATEID_DK(_VodiK_PCODE_DK2)
# define _VodiK_PCODE_DK2 2

/* mask = ZZXXXX, id = 450 */
# define VodiK_DK3_PLATE _VODI_MAKE_PLATEID_DK(_VodiK_PCODE_DK3)
# define _VodiK_PCODE_DK3 3

/* mask = xxxxx, id = 451 */
# define VodiK_DK4_PLATE _VODI_MAKE_PLATEID_DK(_VodiK_PCODE_DK4)
# define _VodiK_PCODE_DK4 4

/* mask = ZZXXXXX, id = 1668 */
# define VodiK_DK5_PLATE _VODI_MAKE_PLATEID_DK(_VodiK_PCODE_DK5)
# define _VodiK_PCODE_DK5 5
/* @} */


/*
 * DO
 * @{
 */
# define _VODI_MAKE_PLATEID_DO(aCode) _VODI_MAKE_PLATEID(VodiK_DOMINICAN_REPUBLIC_NUMERIC,aCode)

/* mask = zxxxxxx, id = 783 */
# define VodiK_DO1_PLATE _VODI_MAKE_PLATEID_DO(_VodiK_PCODE_DO1)
# define _VodiK_PCODE_DO1 1

/* mask = zzxxxxx, id = 784 */
# define VodiK_DO2_PLATE _VODI_MAKE_PLATEID_DO(_VodiK_PCODE_DO2)
# define _VodiK_PCODE_DO2 2

/* mask = zzxxxx, id = 1528 */
# define VodiK_DO3_PLATE _VODI_MAKE_PLATEID_DO(_VodiK_PCODE_DO3)
# define _VodiK_PCODE_DO3 3

/* mask = zzxxxxx, id = 784 */
# define VodiK_DO4_PLATE _VODI_MAKE_PLATEID_DO(_VodiK_PCODE_DO4)
# define _VodiK_PCODE_DO4 4
/* @} */


/*
 * DZ
 * @{
 */
# define _VODI_MAKE_PLATEID_DZ(aCode) _VODI_MAKE_PLATEID(VodiK_ALGERIA_NUMERIC,aCode)

/* mask = xxxxxxxxxx, id = 815 */
# define VodiK_DZ1_PLATE _VODI_MAKE_PLATEID_DZ(_VodiK_PCODE_DZ1)
# define _VodiK_PCODE_DZ1 1

/* mask = xxxxxxxxxx, id = 816 */
# define VodiK_DZ2_PLATE _VODI_MAKE_PLATEID_DZ(_VodiK_PCODE_DZ2)
# define _VodiK_PCODE_DZ2 2
/* @} */


/*
 * EC
 * @{
 */
# define _VODI_MAKE_PLATEID_EC(aCode) _VODI_MAKE_PLATEID(VodiK_ECUADOR_NUMERIC,aCode)

/* mask = zzzxxx, id = 809 */
# define VodiK_EC1_PLATE _VODI_MAKE_PLATEID_EC(_VodiK_PCODE_EC1)
# define _VodiK_PCODE_EC1 1

/* mask = zzzxxxx, id = 810 */
# define VodiK_EC2_PLATE _VODI_MAKE_PLATEID_EC(_VodiK_PCODE_EC2)
# define _VodiK_PCODE_EC2 2

/* mask = zzxxxz, id = 1454 */
# define VodiK_EC3_PLATE _VODI_MAKE_PLATEID_EC(_VodiK_PCODE_EC3)
# define _VodiK_PCODE_EC3 3

/* mask = zzxxxx, id = 1455 */
# define VodiK_EC4_PLATE _VODI_MAKE_PLATEID_EC(_VodiK_PCODE_EC4)
# define _VodiK_PCODE_EC4 4
/* @} */


/*
 * EE
 * @{
 */
# define _VODI_MAKE_PLATEID_EE(aCode) _VODI_MAKE_PLATEID(VodiK_ESTONIA_NUMERIC,aCode)

/* mask = XXXZZZ, id = 345 */
# define VodiK_EE1_PLATE _VODI_MAKE_PLATEID_EE(_VodiK_PCODE_EE1)
# define _VodiK_PCODE_EE1 1

/* mask = XXZZZ, id = 346 */
# define VodiK_EE2_PLATE _VODI_MAKE_PLATEID_EE(_VodiK_PCODE_EE2)
# define _VodiK_PCODE_EE2 2

/* mask = XXZZ, id = 347 */
# define VodiK_EE3_PLATE _VODI_MAKE_PLATEID_EE(_VodiK_PCODE_EE3)
# define _VodiK_PCODE_EE3 3

/* mask = XXXZ, id = 348 */
# define VodiK_EE4_PLATE _VODI_MAKE_PLATEID_EE(_VodiK_PCODE_EE4)
# define _VodiK_PCODE_EE4 4

/* mask = ZZXXXX, id = 349 */
# define VodiK_EE5_PLATE _VODI_MAKE_PLATEID_EE(_VodiK_PCODE_EE5)
# define _VodiK_PCODE_EE5 5

/* mask = ZZZXXX, id = 350 */
# define VodiK_EE6_PLATE _VODI_MAKE_PLATEID_EE(_VodiK_PCODE_EE6)
# define _VodiK_PCODE_EE6 6

/* mask = XXXZZZ, id = 351 */
# define VodiK_EE7_PLATE _VODI_MAKE_PLATEID_EE(_VodiK_PCODE_EE7)
# define _VodiK_PCODE_EE7 7

/* mask = ZZXXXX, id = 352 */
# define VodiK_EE8_PLATE _VODI_MAKE_PLATEID_EE(_VodiK_PCODE_EE8)
# define _VodiK_PCODE_EE8 8

/* mask = XXXZZ, id = 353 */
# define VodiK_EE9_PLATE _VODI_MAKE_PLATEID_EE(_VodiK_PCODE_EE9)
# define _VodiK_PCODE_EE9 9
/* @} */

/*
 * EG
 * @{
 */
# define _VODI_MAKE_PLATEID_EG(aCode) _VODI_MAKE_PLATEID(VodiK_EGYPT_NUMERIC,aCode)

/* mask = XXXZZZ, id = 442 */
# define VodiK_EG1_PLATE _VODI_MAKE_PLATEID_EG(_VodiK_PCODE_EG1)
# define _VodiK_PCODE_EG1 1

/* mask = XXXXZZ, id = 443 */
# define VodiK_EG2_PLATE _VODI_MAKE_PLATEID_EG(_VodiK_PCODE_EG2)
# define _VodiK_PCODE_EG2 2

/* mask = XXXXZZZ, id = 444 */
# define VodiK_EG3_PLATE _VODI_MAKE_PLATEID_EG(_VodiK_PCODE_EG3)
# define _VodiK_PCODE_EG3 3
/* @} */

/*
 * ES
 * @{
 */
# define _VODI_MAKE_PLATEID_ES(aCode) _VODI_MAKE_PLATEID(VodiK_SPAIN_NUMERIC,aCode)

/* mask = XXXXZZZ, id = 335 */
# define VodiK_ES1_PLATE _VODI_MAKE_PLATEID_ES(_VodiK_PCODE_ES1)
# define _VodiK_PCODE_ES1 1

/* mask = ZXXXXZZZ, id = 336 */
# define VodiK_ES2_PLATE _VODI_MAKE_PLATEID_ES(_VodiK_PCODE_ES2)
# define _VodiK_PCODE_ES2 2

/* mask = ZXXXXZZZ, id = 337 */
# define VodiK_ES3_PLATE _VODI_MAKE_PLATEID_ES(_VodiK_PCODE_ES3)
# define _VodiK_PCODE_ES3 3

/* mask = zzxxxxx, id = 516 */
# define VodiK_ES4_PLATE _VODI_MAKE_PLATEID_ES(_VodiK_PCODE_ES4)
# define _VodiK_PCODE_ES4 4

/* mask = zzxxxxz, id = 513 */
# define VodiK_ES5_PLATE _VODI_MAKE_PLATEID_ES(_VodiK_PCODE_ES5)
# define _VodiK_PCODE_ES5 5

/* mask = zzxxxxzz, id = 514 */
# define VodiK_ES6_PLATE _VODI_MAKE_PLATEID_ES(_VodiK_PCODE_ES6)
# define _VodiK_PCODE_ES6 6

/* mask = zxxxxzz, id = 515 */
# define VodiK_ES7_PLATE _VODI_MAKE_PLATEID_ES(_VodiK_PCODE_ES7)
# define _VodiK_PCODE_ES7 7

/* mask = ZZXXXXXX, id = 338 */
# define VodiK_ES8_PLATE _VODI_MAKE_PLATEID_ES(_VodiK_PCODE_ES8)
# define _VodiK_PCODE_ES8 8

/* mask = ZZXXXXX, id = 339 */
# define VodiK_ES9_PLATE _VODI_MAKE_PLATEID_ES(_VodiK_PCODE_ES9)
# define _VodiK_PCODE_ES9 9

/* mask = ZZXXXX, id = 340 */
# define VodiK_ES10_PLATE _VODI_MAKE_PLATEID_ES(_VodiK_PCODE_ES10)
# define _VodiK_PCODE_ES10 10

/* mask = ZZXXXXXX, id = 341 */
# define VodiK_ES11_PLATE _VODI_MAKE_PLATEID_ES(_VodiK_PCODE_ES11)
# define _VodiK_PCODE_ES11 11

/* mask = XXXXZZZ, id = 1658 */
# define VodiK_ES12_PLATE _VODI_MAKE_PLATEID_ES(_VodiK_PCODE_ES12)
# define _VodiK_PCODE_ES12 12

/* mask = ZXXXXZ, id = 2074 */
# define VodiK_ES13_PLATE _VODI_MAKE_PLATEID_ES(_VodiK_PCODE_ES13)
# define _VodiK_PCODE_ES13 13

/* mask = ZXXXXZZZ, id = 2255 */
# define VodiK_ES14_PLATE _VODI_MAKE_PLATEID_ES(_VodiK_PCODE_ES14)
# define _VodiK_PCODE_ES14 14
/* @} */

/*
 * ET
 * @{
 */
# define _VODI_MAKE_PLATEID_ET(aCode) _VODI_MAKE_PLATEID(VodiK_ETHIOPIA_NUMERIC,aCode)

/* mask = XXXXX, id = 1594 */
# define VodiK_ET1_PLATE _VODI_MAKE_PLATEID_ET(_VodiK_PCODE_ET1)
# define _VodiK_PCODE_ET1 1

/* mask = XXX, id = 1595 */
# define VodiK_ET2_PLATE _VODI_MAKE_PLATEID_ET(_VodiK_PCODE_ET2)
# define _VodiK_PCODE_ET2 2

/* mask = XXXXXX, id = 1596 */
# define VodiK_ET3_PLATE _VODI_MAKE_PLATEID_ET(_VodiK_PCODE_ET3)
# define _VodiK_PCODE_ET3 3

/* mask = XXXXX, id = 1597 */
# define VodiK_ET4_PLATE _VODI_MAKE_PLATEID_ET(_VodiK_PCODE_ET4)
# define _VodiK_PCODE_ET4 4

/* mask = XXXXXXX, id = 1598 */
# define VodiK_ET5_PLATE _VODI_MAKE_PLATEID_ET(_VodiK_PCODE_ET5)
# define _VodiK_PCODE_ET5 5

/* mask = XXXXXX, id = 1599 */
# define VodiK_ET6_PLATE _VODI_MAKE_PLATEID_ET(_VodiK_PCODE_ET6)
# define _VodiK_PCODE_ET6 6

/* mask = XXXXXX, id = 1600 */
# define VodiK_ET7_PLATE _VODI_MAKE_PLATEID_ET(_VodiK_PCODE_ET7)
# define _VodiK_PCODE_ET7 7

/* mask = XXXXXXXX, id = 1601 */
# define VodiK_ET8_PLATE _VODI_MAKE_PLATEID_ET(_VodiK_PCODE_ET8)
# define _VodiK_PCODE_ET8 8

/* mask = XXXXXX, id = 1602 */
# define VodiK_ET9_PLATE _VODI_MAKE_PLATEID_ET(_VodiK_PCODE_ET9)
# define _VodiK_PCODE_ET9 9

/* mask = XXXX, id = 1603 */
# define VodiK_ET10_PLATE _VODI_MAKE_PLATEID_ET(_VodiK_PCODE_ET10)
# define _VodiK_PCODE_ET10 10
/* @} */

/*
* FI
* @{
*/
# define _VODI_MAKE_PLATEID_FI(aCode) _VODI_MAKE_PLATEID(VodiK_FINLAND_NUMERIC,aCode)

/* mask = ZZZXXX, id = 18 */
# define VodiK_FI1_PLATE _VODI_MAKE_PLATEID_FI(_VodiK_PCODE_FI1)
# define _VodiK_PCODE_FI1 1

/* mask = ZZXXX, id = 318 */
# define VodiK_FI2_PLATE _VODI_MAKE_PLATEID_FI(_VodiK_PCODE_FI2)
# define _VodiK_PCODE_FI2 2

/* mask = ZZZX, id = 319 */
# define VodiK_FI3_PLATE _VODI_MAKE_PLATEID_FI(_VodiK_PCODE_FI3)
# define _VodiK_PCODE_FI3 3

/* mask = ZZZXX, id = 320 */
# define VodiK_FI4_PLATE _VODI_MAKE_PLATEID_FI(_VodiK_PCODE_FI4)
# define _VodiK_PCODE_FI4 4

/* mask = ZZXXXX, id = 310 */
# define VodiK_FI5_PLATE _VODI_MAKE_PLATEID_FI(_VodiK_PCODE_FI5)
# define _VodiK_PCODE_FI5 5

/* mask = ZXXX, id = 312 */
# define VodiK_FI6_PLATE _VODI_MAKE_PLATEID_FI(_VodiK_PCODE_FI6)
# define _VodiK_PCODE_FI6 6

/* mask = ZXXXX, id = 313 */
# define VodiK_FI7_PLATE _VODI_MAKE_PLATEID_FI(_VodiK_PCODE_FI7)
# define _VodiK_PCODE_FI7 7

/* mask = ZZXXXX, id = 314 */
# define VodiK_FI8_PLATE _VODI_MAKE_PLATEID_FI(_VodiK_PCODE_FI8)
# define _VodiK_PCODE_FI8 8

/* mask = XXXZZZ, id = 315 */
# define VodiK_FI9_PLATE _VODI_MAKE_PLATEID_FI(_VodiK_PCODE_FI9)
# define _VodiK_PCODE_FI9 9

/* mask = ZZX, id = 316 */
# define VodiK_FI10_PLATE _VODI_MAKE_PLATEID_FI(_VodiK_PCODE_FI10)
# define _VodiK_PCODE_FI10 10

/* mask = ZZXX, id = 317 */
# define VodiK_FI11_PLATE _VODI_MAKE_PLATEID_FI(_VodiK_PCODE_FI11)
# define _VodiK_PCODE_FI11 11

/* mask = ZZXXXX, id = 1689 */
# define VodiK_FI12_PLATE _VODI_MAKE_PLATEID_FI(_VodiK_PCODE_FI12)
# define _VodiK_PCODE_FI12 12

/* mask = XXXZZZ, id = 1690 */
# define VodiK_FI13_PLATE _VODI_MAKE_PLATEID_FI(_VodiK_PCODE_FI13)
# define _VodiK_PCODE_FI13 13

/* mask = ZZX, id = 1691 */
# define VodiK_FI14_PLATE _VODI_MAKE_PLATEID_FI(_VodiK_PCODE_FI14)
# define _VodiK_PCODE_FI14 14

/* mask = ZZXX, id = 1692 */
# define VodiK_FI15_PLATE _VODI_MAKE_PLATEID_FI(_VodiK_PCODE_FI15)
# define _VodiK_PCODE_FI15 15
/* @} */


/*
* FR
* @{
*/
# define _VODI_MAKE_PLATEID_FR(aCode) _VODI_MAKE_PLATEID(VodiK_FRANCE_NUMERIC,aCode)

/* mask = ZZXXXZZ, id = 196 */
# define VodiK_FR1_PLATE _VODI_MAKE_PLATEID_FR(_VodiK_PCODE_FR1)
# define _VodiK_PCODE_FR1 1

/* mask = ZZXXXZZ, id = 197 */
# define VodiK_FR2_PLATE _VODI_MAKE_PLATEID_FR(_VodiK_PCODE_FR2)
# define _VodiK_PCODE_FR2 2

/* mask = XXXXZZXX, id = 198 */
# define VodiK_FR3_PLATE _VODI_MAKE_PLATEID_FR(_VodiK_PCODE_FR3)
# define _VodiK_PCODE_FR3 3

/* mask = XXXXZZXZ, id = 199 */
# define VodiK_FR4_PLATE _VODI_MAKE_PLATEID_FR(_VodiK_PCODE_FR4)
# define _VodiK_PCODE_FR4 4

/* mask = XXXZZZXX, id = 200 */
# define VodiK_FR5_PLATE _VODI_MAKE_PLATEID_FR(_VodiK_PCODE_FR5)
# define _VodiK_PCODE_FR5 5

/* mask = XXXZZZXZ, id = 201 */
# define VodiK_FR6_PLATE _VODI_MAKE_PLATEID_FR(_VodiK_PCODE_FR6)
# define _VodiK_PCODE_FR6 6

/* mask = ZXXXZZ, id = 202 */
# define VodiK_FR7_PLATE _VODI_MAKE_PLATEID_FR(_VodiK_PCODE_FR7)
# define _VodiK_PCODE_FR7 7

/* mask = xxxxzzzxx, id = 846 */
# define VodiK_FR8_PLATE _VODI_MAKE_PLATEID_FR(_VodiK_PCODE_FR8)
# define _VodiK_PCODE_FR8 8

/* mask = ZXXXZ, id = 1563 */
# define VodiK_FR9_PLATE _VODI_MAKE_PLATEID_FR(_VodiK_PCODE_FR9)
# define _VodiK_PCODE_FR9 9

/* mask = XXXXZZXZ, id = 1564 */
# define VodiK_FR10_PLATE _VODI_MAKE_PLATEID_FR(_VodiK_PCODE_FR10)
# define _VodiK_PCODE_FR10 10

/* mask = XXXXZZXX, id = 1565 */
# define VodiK_FR11_PLATE _VODI_MAKE_PLATEID_FR(_VodiK_PCODE_FR11)
# define _VodiK_PCODE_FR11 11

/* mask = XXXXZZZXX, id = 1566 */
# define VodiK_FR12_PLATE _VODI_MAKE_PLATEID_FR(_VodiK_PCODE_FR12)
# define _VodiK_PCODE_FR12 12

/* mask = XXZZXX, id = 1567 */
# define VodiK_FR13_PLATE _VODI_MAKE_PLATEID_FR(_VodiK_PCODE_FR13)
# define _VodiK_PCODE_FR13 13

/* mask = XXZZZXX, id = 1568 */
# define VodiK_FR14_PLATE _VODI_MAKE_PLATEID_FR(_VodiK_PCODE_FR14)
# define _VodiK_PCODE_FR14 14

/* mask = XXXZZZXX, id = 1569 */
# define VodiK_FR15_PLATE _VODI_MAKE_PLATEID_FR(_VodiK_PCODE_FR15)
# define _VodiK_PCODE_FR15 15

/* mask = ZXXXZZ, id = 1570 */
# define VodiK_FR16_PLATE _VODI_MAKE_PLATEID_FR(_VodiK_PCODE_FR16)
# define _VodiK_PCODE_FR16 16

/* mask = ZZXXXZZ, id = 1571 */
# define VodiK_FR17_PLATE _VODI_MAKE_PLATEID_FR(_VodiK_PCODE_FR17)
# define _VodiK_PCODE_FR17 17

/* mask = XXXZZXX, id = 1572 */
# define VodiK_FR18_PLATE _VODI_MAKE_PLATEID_FR(_VodiK_PCODE_FR18)
# define _VodiK_PCODE_FR18 18

/* mask = XXZZZXX, id = 1573 */
# define VodiK_FR19_PLATE _VODI_MAKE_PLATEID_FR(_VodiK_PCODE_FR19)
# define _VodiK_PCODE_FR19 19

/* mask = xxzzzxx, id = 1846 */
# define VodiK_FR20_PLATE _VODI_MAKE_PLATEID_FR(_VodiK_PCODE_FR20)
# define _VodiK_PCODE_FR20 20

/* mask = xxxzzzxx, id = 1847 */
# define VodiK_FR21_PLATE _VODI_MAKE_PLATEID_FR(_VodiK_PCODE_FR21)
# define _VodiK_PCODE_FR21 21

/* mask = zxxxzz, id = 1848 */
# define VodiK_FR22_PLATE _VODI_MAKE_PLATEID_FR(_VodiK_PCODE_FR22)
# define _VodiK_PCODE_FR22 22

/* mask = zzxxxzz, id = 1849 */
# define VodiK_FR23_PLATE _VODI_MAKE_PLATEID_FR(_VodiK_PCODE_FR23)
# define _VodiK_PCODE_FR23 23
/* @} */


/*
 * GB
 * @{
 */
# define _VODI_MAKE_PLATEID_GB(aCode) _VODI_MAKE_PLATEID(VodiK_UNITED_KINGDOM_NUMERIC,aCode)

/* mask = ZZXXZZZ, id = 463 */
# define VodiK_GB1_PLATE _VODI_MAKE_PLATEID_GB(_VodiK_PCODE_GB1)
# define _VodiK_PCODE_GB1 1

/* mask = ZXXXZZZ, id = 464 */
# define VodiK_GB2_PLATE _VODI_MAKE_PLATEID_GB(_VodiK_PCODE_GB2)
# define _VodiK_PCODE_GB2 2

/* mask = zxxzzz, id = 1279 */
# define VodiK_GB3_PLATE _VODI_MAKE_PLATEID_GB(_VodiK_PCODE_GB3)
# define _VodiK_PCODE_GB3 3

/* mask = zxzzz, id = 1281 */
# define VodiK_GB4_PLATE _VODI_MAKE_PLATEID_GB(_VodiK_PCODE_GB4)
# define _VodiK_PCODE_GB4 4

/* mask = xxxzxxx, id = 851 */
# define VodiK_GB5_PLATE _VODI_MAKE_PLATEID_GB(_VodiK_PCODE_GB5)
# define _VodiK_PCODE_GB5 5

/* mask = ZXXXZZZ, id = 1574 */
# define VodiK_GB6_PLATE _VODI_MAKE_PLATEID_GB(_VodiK_PCODE_GB6)
# define _VodiK_PCODE_GB6 6

/* mask = ZZXXZZZ, id = 1575 */
# define VodiK_GB7_PLATE _VODI_MAKE_PLATEID_GB(_VodiK_PCODE_GB7)
# define _VodiK_PCODE_GB7 7

/* mask = zxzzz, id = 1576 */
# define VodiK_GB8_PLATE _VODI_MAKE_PLATEID_GB(_VodiK_PCODE_GB8)
# define _VodiK_PCODE_GB8 8

/* mask = zxxzzz, id = 1577 */
# define VodiK_GB9_PLATE _VODI_MAKE_PLATEID_GB(_VodiK_PCODE_GB9)
# define _VodiK_PCODE_GB9 9

/* mask = XXXZXXX, id = 1641 */
# define VodiK_GB10_PLATE _VODI_MAKE_PLATEID_GB(_VodiK_PCODE_GB10)
# define _VodiK_PCODE_GB10 10

/* mask = XXXQXX, id = 1642 */
# define VodiK_GB11_PLATE _VODI_MAKE_PLATEID_GB(_VodiK_PCODE_GB11)
# define _VodiK_PCODE_GB11 11

/* mask = XXXQXX, id = 1643 */
# define VodiK_GB12_PLATE _VODI_MAKE_PLATEID_GB(_VodiK_PCODE_GB12)
# define _VodiK_PCODE_GB12 12

/* mask = XXXXX, id = 1644 */
# define VodiK_GB13_PLATE _VODI_MAKE_PLATEID_GB(_VodiK_PCODE_GB13)
# define _VodiK_PCODE_GB13 13

/* mask = ZZZXXXX, id = 1944 */
# define VodiK_GB14_PLATE _VODI_MAKE_PLATEID_GB(_VodiK_PCODE_GB14)
# define _VodiK_PCODE_GB14 14

/* mask = xxzz, id = 2009 */
# define VodiK_GB15_PLATE _VODI_MAKE_PLATEID_GB(_VodiK_PCODE_GB15)
# define _VodiK_PCODE_GB15 15

/* mask = zzxx, id = 2010 */
# define VodiK_GB16_PLATE _VODI_MAKE_PLATEID_GB(_VodiK_PCODE_GB16)
# define _VodiK_PCODE_GB16 16

/* mask = xxxzz, id = 2011 */
# define VodiK_GB17_PLATE _VODI_MAKE_PLATEID_GB(_VodiK_PCODE_GB17)
# define _VodiK_PCODE_GB17 17

/* mask = zzzx, id = 2012 */
# define VodiK_GB18_PLATE _VODI_MAKE_PLATEID_GB(_VodiK_PCODE_GB18)
# define _VodiK_PCODE_GB18 18

/* mask = zzzxxx, id = 2013 */
# define VodiK_GB19_PLATE _VODI_MAKE_PLATEID_GB(_VodiK_PCODE_GB19)
# define _VodiK_PCODE_GB19 19

/* mask = xzzz, id = 2014 */
# define VodiK_GB20_PLATE _VODI_MAKE_PLATEID_GB(_VodiK_PCODE_GB20)
# define _VodiK_PCODE_GB20 20

/* mask = xzz, id = 2015 */
# define VodiK_GB21_PLATE _VODI_MAKE_PLATEID_GB(_VodiK_PCODE_GB21)
# define _VodiK_PCODE_GB21 21

/* mask = xxxzxx, id = 2016 */
# define VodiK_GB22_PLATE _VODI_MAKE_PLATEID_GB(_VodiK_PCODE_GB22)
# define _VodiK_PCODE_GB22 22

/* mask = xxxzxx, id = 2018 */
# define VodiK_GB23_PLATE _VODI_MAKE_PLATEID_GB(_VodiK_PCODE_GB23)
# define _VodiK_PCODE_GB23 23

/* mask = xxxxx, id = 2019 */
# define VodiK_GB24_PLATE _VODI_MAKE_PLATEID_GB(_VodiK_PCODE_GB24)
# define _VodiK_PCODE_GB24 24

/* mask = zzzxxxx, id = 2020 */
# define VodiK_GB25_PLATE _VODI_MAKE_PLATEID_GB(_VodiK_PCODE_GB25)
# define _VodiK_PCODE_GB25 25
/* @} */


/*
 * GD
 * @{
 */
# define _VODI_MAKE_PLATEID_GD(aCode) _VODI_MAKE_PLATEID(VodiK_GRENADA_NUMERIC,aCode)

/* mask = zzzxxx, id = 828 */
# define VodiK_GD1_PLATE _VODI_MAKE_PLATEID_GD(_VodiK_PCODE_GD1)
# define _VodiK_PCODE_GD1 1

/* mask = zxxxx, id = 829 */
# define VodiK_GD2_PLATE _VODI_MAKE_PLATEID_GD(_VodiK_PCODE_GD2)
# define _VodiK_PCODE_GD2 2

/* mask = zxxx, id = 830 */
# define VodiK_GD3_PLATE _VODI_MAKE_PLATEID_GD(_VodiK_PCODE_GD3)
# define _VodiK_PCODE_GD3 3

/* mask = zxx, id = 831 */
# define VodiK_GD4_PLATE _VODI_MAKE_PLATEID_GD(_VodiK_PCODE_GD4)
# define _VodiK_PCODE_GD4 4
/* @} */


/*
 * GE
 * @{
 */
# define _VODI_MAKE_PLATEID_GE(aCode) _VODI_MAKE_PLATEID(VodiK_GEORGIA_NUMERIC,aCode)

/* mask = ZZZXXX, id = 229 */
# define VodiK_GE1_PLATE _VODI_MAKE_PLATEID_GE(_VodiK_PCODE_GE1)
# define _VodiK_PCODE_GE1 1

/* mask = ZZXXX, id = 230 */
# define VodiK_GE2_PLATE _VODI_MAKE_PLATEID_GE(_VodiK_PCODE_GE2)
# define _VodiK_PCODE_GE2 2

/* mask = XXXXZZ, id = 231 */
# define VodiK_GE3_PLATE _VODI_MAKE_PLATEID_GE(_VodiK_PCODE_GE3)
# define _VodiK_PCODE_GE3 3

/* mask = zzxxxzz, id = 1278 */
# define VodiK_GE4_PLATE _VODI_MAKE_PLATEID_GE(_VodiK_PCODE_GE4)
# define _VodiK_PCODE_GE4 4

/* mask = zzxxxzz, id = 1368 */
# define VodiK_GE5_PLATE _VODI_MAKE_PLATEID_GE(_VodiK_PCODE_GE5)
# define _VodiK_PCODE_GE5 5

/* mask = zzzxxx, id = 1369 */
# define VodiK_GE6_PLATE _VODI_MAKE_PLATEID_GE(_VodiK_PCODE_GE6)
# define _VodiK_PCODE_GE6 6

/* mask = zzxxxx, id = 1370 */
# define VodiK_GE7_PLATE _VODI_MAKE_PLATEID_GE(_VodiK_PCODE_GE7)
# define _VodiK_PCODE_GE7 7

/* mask = zzxxxz, id = 1431 */
# define VodiK_GE8_PLATE _VODI_MAKE_PLATEID_GE(_VodiK_PCODE_GE8)
# define _VodiK_PCODE_GE8 8

/* mask = zzxxxz, id = 1432 */
# define VodiK_GE9_PLATE _VODI_MAKE_PLATEID_GE(_VodiK_PCODE_GE9)
# define _VodiK_PCODE_GE9 9

/* mask = xxxcmdx, id = 1433 */
# define VodiK_GE10_PLATE _VODI_MAKE_PLATEID_GE(_VodiK_PCODE_GE10)
# define _VodiK_PCODE_GE10 10

/* mask = xxxcmdx, id = 1434 */
# define VodiK_GE11_PLATE _VODI_MAKE_PLATEID_GE(_VodiK_PCODE_GE11)
# define _VodiK_PCODE_GE11 11

/* mask = xxxdxxx, id = 1435 */
# define VodiK_GE12_PLATE _VODI_MAKE_PLATEID_GE(_VodiK_PCODE_GE12)
# define _VodiK_PCODE_GE12 12

/* mask = xxxdxxx, id = 1436 */
# define VodiK_GE13_PLATE _VODI_MAKE_PLATEID_GE(_VodiK_PCODE_GE13)
# define _VodiK_PCODE_GE13 13

/* mask = xxxdxx, id = 1437 */
# define VodiK_GE14_PLATE _VODI_MAKE_PLATEID_GE(_VodiK_PCODE_GE14)
# define _VodiK_PCODE_GE14 14

/* mask = xxxzzxxx, id = 1438 */
# define VodiK_GE15_PLATE _VODI_MAKE_PLATEID_GE(_VodiK_PCODE_GE15)
# define _VodiK_PCODE_GE15 15

/* mask = xxxzzxxx, id = 1439 */
# define VodiK_GE16_PLATE _VODI_MAKE_PLATEID_GE(_VodiK_PCODE_GE16)
# define _VodiK_PCODE_GE16 16

/* mask = xxxzzxx, id = 1440 */
# define VodiK_GE17_PLATE _VODI_MAKE_PLATEID_GE(_VodiK_PCODE_GE17)
# define _VodiK_PCODE_GE17 17

/* mask = eummxxx, id = 1441 */
# define VodiK_GE18_PLATE _VODI_MAKE_PLATEID_GE(_VodiK_PCODE_GE18)
# define _VodiK_PCODE_GE18 18

/* mask = eummxxx, id = 1442 */
# define VodiK_GE19_PLATE _VODI_MAKE_PLATEID_GE(_VodiK_PCODE_GE19)
# define _VodiK_PCODE_GE19 19

/* mask = zzxxxx, id = 1443 */
# define VodiK_GE20_PLATE _VODI_MAKE_PLATEID_GE(_VodiK_PCODE_GE20)
# define _VodiK_PCODE_GE20 20

/* mask = zxxxx, id = 1444 */
# define VodiK_GE21_PLATE _VODI_MAKE_PLATEID_GE(_VodiK_PCODE_GE21)
# define _VodiK_PCODE_GE21 21

/* mask = xxxdxx, id = 1445 */
# define VodiK_GE22_PLATE _VODI_MAKE_PLATEID_GE(_VodiK_PCODE_GE22)
# define _VodiK_PCODE_GE22 22

/* mask = zzxxx, id = 1452 */
# define VodiK_GE23_PLATE _VODI_MAKE_PLATEID_GE(_VodiK_PCODE_GE23)
# define _VodiK_PCODE_GE23 23

/* mask = zzxxxx, id = 1453 */
# define VodiK_GE24_PLATE _VODI_MAKE_PLATEID_GE(_VodiK_PCODE_GE24)
# define _VodiK_PCODE_GE24 24
/* @} */


/*
 * GI
 * @{
 */
# define _VODI_MAKE_PLATEID_GI(aCode) _VODI_MAKE_PLATEID(VodiK_GIBRALTAR_NUMERIC,aCode)

/* mask = zxxxxz, id = 548 */
# define VodiK_GI1_PLATE _VODI_MAKE_PLATEID_GI(_VodiK_PCODE_GI1)
# define _VodiK_PCODE_GI1 1

/* mask = zxxxxx, id = 549 */
# define VodiK_GI2_PLATE _VODI_MAKE_PLATEID_GI(_VodiK_PCODE_GI2)
# define _VodiK_PCODE_GI2 2

/* mask = zxxxxx, id = 550 */
# define VodiK_GI3_PLATE _VODI_MAKE_PLATEID_GI(_VodiK_PCODE_GI3)
# define _VodiK_PCODE_GI3 3
/* @} */


/*
 * GQ
 * @{
 */
# define _VODI_MAKE_PLATEID_GQ(aCode) _VODI_MAKE_PLATEID(VodiK_EQUATORIAL_GUINEA_NUMERIC,aCode)

/* mask = zzxxxz, id = 897 */
# define VodiK_GQ1_PLATE _VODI_MAKE_PLATEID_GQ(_VodiK_PCODE_GQ1)
# define _VodiK_PCODE_GQ1 1

/* mask = zzxxxx, id = 900 */
# define VodiK_GQ2_PLATE _VODI_MAKE_PLATEID_GQ(_VodiK_PCODE_GQ2)
# define _VodiK_PCODE_GQ2 2

/* mask = zzxxxx, id = 901 */
# define VodiK_GQ3_PLATE _VODI_MAKE_PLATEID_GQ(_VodiK_PCODE_GQ3)
# define _VodiK_PCODE_GQ3 3

/* mask = zzxxxzxx, id = 899 */
# define VodiK_GQ4_PLATE _VODI_MAKE_PLATEID_GQ(_VodiK_PCODE_GQ4)
# define _VodiK_PCODE_GQ4 4

/* mask = zzxxxzz, id = 898 */
# define VodiK_GQ5_PLATE _VODI_MAKE_PLATEID_GQ(_VodiK_PCODE_GQ5)
# define _VodiK_PCODE_GQ5 5
/* @} */


/*
* GR
* @{
*/
# define _VODI_MAKE_PLATEID_GR(aCode) _VODI_MAKE_PLATEID(VodiK_GREECE_NUMERIC,aCode)

/* mask = zzzxxxx, id = 524 */
# define VodiK_GR1_PLATE _VODI_MAKE_PLATEID_GR(_VodiK_PCODE_GR1)
# define _VodiK_PCODE_GR1 1

/* mask = zzzxxxx, id = 526 */
# define VodiK_GR2_PLATE _VODI_MAKE_PLATEID_GR(_VodiK_PCODE_GR2)
# define _VodiK_PCODE_GR2 2

/* mask = zzxxxxx, id = 527 */
# define VodiK_GR3_PLATE _VODI_MAKE_PLATEID_GR(_VodiK_PCODE_GR3)
# define _VodiK_PCODE_GR3 3

/* mask = zxxxxx, id = 525 */
# define VodiK_GR4_PLATE _VODI_MAKE_PLATEID_GR(_VodiK_PCODE_GR4)
# define _VodiK_PCODE_GR4 4

/* mask = zzxxxxx, id = 1700 */
# define VodiK_GR5_PLATE _VODI_MAKE_PLATEID_GR(_VodiK_PCODE_GR5)
# define _VodiK_PCODE_GR5 5

/* mask = zxxxxx, id = 1701 */
# define VodiK_GR6_PLATE _VODI_MAKE_PLATEID_GR(_VodiK_PCODE_GR6)
# define _VodiK_PCODE_GR6 6

/* mask = zzzxxxx, id = 1702 */
# define VodiK_GR7_PLATE _VODI_MAKE_PLATEID_GR(_VodiK_PCODE_GR7)
# define _VodiK_PCODE_GR7 7
/* @} */


/*
 * GT
 * @{
 */
# define _VODI_MAKE_PLATEID_GT(aCode) _VODI_MAKE_PLATEID(VodiK_GUATEMALA_NUMERIC,aCode)

/* mask = zxxxzzz, id = 772 */
# define VodiK_GT1_PLATE _VODI_MAKE_PLATEID_GT(_VodiK_PCODE_GT1)
# define _VodiK_PCODE_GT1 1

/* mask = zxxxzzz, id = 773 */
# define VodiK_GT2_PLATE _VODI_MAKE_PLATEID_GT(_VodiK_PCODE_GT2)
# define _VodiK_PCODE_GT2 2

/* mask = zzxxzzz, id = 774 */
# define VodiK_GT3_PLATE _VODI_MAKE_PLATEID_GT(_VodiK_PCODE_GT3)
# define _VodiK_PCODE_GT3 3

/* mask = zzzzxxx, id = 777 */
# define VodiK_GT4_PLATE _VODI_MAKE_PLATEID_GT(_VodiK_PCODE_GT4)
# define _VodiK_PCODE_GT4 4

/* mask = xxx, id = 775 */
# define VodiK_GT5_PLATE _VODI_MAKE_PLATEID_GT(_VodiK_PCODE_GT5)
# define _VodiK_PCODE_GT5 5

/* mask = zzzxxx, id = 776 */
# define VodiK_GT6_PLATE _VODI_MAKE_PLATEID_GT(_VodiK_PCODE_GT6)
# define _VodiK_PCODE_GT6 6
/* @} */


/*
 * HK
 * @{
 */
# define _VODI_MAKE_PLATEID_HK(aCode) _VODI_MAKE_PLATEID(VodiK_HONG_KONG_NUMERIC,aCode)

/* mask = ZZXXXX, id = 472 */
# define VodiK_HK1_PLATE _VODI_MAKE_PLATEID_HK(_VodiK_PCODE_HK1)
# define _VodiK_PCODE_HK1 1

/* mask = zzxxx, id = 2261 */
# define VodiK_HK2_PLATE _VODI_MAKE_PLATEID_HK(_VodiK_PCODE_HK2)
# define _VodiK_PCODE_HK2 2

/* mask = zzxxxx, id = 2262 */
# define VodiK_HK3_PLATE _VODI_MAKE_PLATEID_HK(_VodiK_PCODE_HK3)
# define _VodiK_PCODE_HK3 3

/* mask = zzxxx, id = 2263 */
# define VodiK_HK4_PLATE _VODI_MAKE_PLATEID_HK(_VodiK_PCODE_HK4)
# define _VodiK_PCODE_HK4 4

/* mask = zzxx, id = 2268 */
# define VodiK_HK5_PLATE _VODI_MAKE_PLATEID_HK(_VodiK_PCODE_HK5)
# define _VodiK_PCODE_HK5 5

/* mask = zzx, id = 2269 */
# define VodiK_HK6_PLATE _VODI_MAKE_PLATEID_HK(_VodiK_PCODE_HK6)
# define _VodiK_PCODE_HK6 6
/* @} */


/*
 * HN
 * @{
 */
# define _VODI_MAKE_PLATEID_HN(aCode) _VODI_MAKE_PLATEID(VodiK_HONDURAS_NUMERIC,aCode)

/* mask = zzzxxxx, id = 778 */
# define VodiK_HN1_PLATE _VODI_MAKE_PLATEID_HN(_VodiK_PCODE_HN1)
# define _VodiK_PCODE_HN1 1

/* mask = zzxxxx, id = 781 */
# define VodiK_HN2_PLATE _VODI_MAKE_PLATEID_HN(_VodiK_PCODE_HN2)
# define _VodiK_PCODE_HN2 2

/* mask = zzxxxxx, id = 779 */
# define VodiK_HN3_PLATE _VODI_MAKE_PLATEID_HN(_VodiK_PCODE_HN3)
# define _VodiK_PCODE_HN3 3

/* mask = zxxxxx, id = 780 */
# define VodiK_HN4_PLATE _VODI_MAKE_PLATEID_HN(_VodiK_PCODE_HN4)
# define _VodiK_PCODE_HN4 4

/* mask = zzxxxx, id = 782 */
# define VodiK_HN5_PLATE _VODI_MAKE_PLATEID_HN(_VodiK_PCODE_HN5)
# define _VodiK_PCODE_HN5 5

/* mask = zzzxxxx, id = 1505 */
# define VodiK_HN6_PLATE _VODI_MAKE_PLATEID_HN(_VodiK_PCODE_HN6)
# define _VodiK_PCODE_HN6 6
/* @} */


/*
* HR
* @{
*/
# define _VODI_MAKE_PLATEID_HR(aCode) _VODI_MAKE_PLATEID(VodiK_CROATIA_NUMERIC,aCode)

/* mask = ZZXXXZZ, id = 235 */
# define VodiK_HR1_PLATE _VODI_MAKE_PLATEID_HR(_VodiK_PCODE_HR1)
# define _VodiK_PCODE_HR1 1

/* mask = ZZXXXXZZ, id = 236 */
# define VodiK_HR2_PLATE _VODI_MAKE_PLATEID_HR(_VodiK_PCODE_HR2)
# define _VodiK_PCODE_HR2 2

/* mask = ZZXXXZ, id = 237 */
# define VodiK_HR3_PLATE _VODI_MAKE_PLATEID_HR(_VodiK_PCODE_HR3)
# define _VodiK_PCODE_HR3 3

/* mask = XXXZXXX, id = 238 */
# define VodiK_HR4_PLATE _VODI_MAKE_PLATEID_HR(_VodiK_PCODE_HR4)
# define _VodiK_PCODE_HR4 4

/* mask = zzxxxzz, id = 1715 */
# define VodiK_HR5_PLATE _VODI_MAKE_PLATEID_HR(_VodiK_PCODE_HR5)
# define _VodiK_PCODE_HR5 5

/* mask = zzxxxzz, id = 1717 */
# define VodiK_HR6_PLATE _VODI_MAKE_PLATEID_HR(_VodiK_PCODE_HR6)
# define _VodiK_PCODE_HR6 6

/* mask = zzxxxxzz, id = 1718 */
# define VodiK_HR7_PLATE _VODI_MAKE_PLATEID_HR(_VodiK_PCODE_HR7)
# define _VodiK_PCODE_HR7 7

/* mask = zzxxxxx, id = 1713 */
# define VodiK_HR8_PLATE _VODI_MAKE_PLATEID_HR(_VodiK_PCODE_HR8)
# define _VodiK_PCODE_HR8 8

/* mask = zzxxxxz, id = 1717 */
# define VodiK_HR9_PLATE _VODI_MAKE_PLATEID_HR(_VodiK_PCODE_HR9)
# define _VodiK_PCODE_HR9 9

/* mask = zzxxxzz, id = 1718 */
# define VodiK_HR10_PLATE _VODI_MAKE_PLATEID_HR(_VodiK_PCODE_HR10)
# define _VodiK_PCODE_HR10 10

/* mask = zzxxxxzz, id = 1719 */
# define VodiK_HR11_PLATE _VODI_MAKE_PLATEID_HR(_VodiK_PCODE_HR11)
# define _VodiK_PCODE_HR11 11

/* mask = zzzzxxxx, id = 1716 */
# define VodiK_HR12_PLATE _VODI_MAKE_PLATEID_HR(_VodiK_PCODE_HR12)
# define _VodiK_PCODE_HR12 12

/* mask = zzzzxxxx, id = 1719 */
# define VodiK_HR13_PLATE _VODI_MAKE_PLATEID_HR(_VodiK_PCODE_HR13)
# define _VodiK_PCODE_HR13 13

/* mask = ZZXXXXZZ, id = 1947 */
# define VodiK_HR14_PLATE _VODI_MAKE_PLATEID_HR(_VodiK_PCODE_HR14)
# define _VodiK_PCODE_HR14 14

/* mask = zzxxxxz, id = 1948 */
# define VodiK_HR15_PLATE _VODI_MAKE_PLATEID_HR(_VodiK_PCODE_HR15)
# define _VodiK_PCODE_HR15 15

/* mask = zzxxxz, id = 1949 */
# define VodiK_HR16_PLATE _VODI_MAKE_PLATEID_HR(_VodiK_PCODE_HR16)
# define _VodiK_PCODE_HR16 16

/* mask = zzxxxxz, id = 1950 */
# define VodiK_HR17_PLATE _VODI_MAKE_PLATEID_HR(_VodiK_PCODE_HR17)
# define _VodiK_PCODE_HR17 17
/* @} */


/*
 * HU
 * @{
 */
# define _VODI_MAKE_PLATEID_HU(aCode) _VODI_MAKE_PLATEID(VodiK_HUNGARY_NUMERIC,aCode)

/* mask = ZZZXXX, id = 145 */
# define VodiK_HU1_PLATE _VODI_MAKE_PLATEID_HU(_VodiK_PCODE_HU1)
# define _VodiK_PCODE_HU1 1

/* mask = ZXXXXX, id = 146 */
# define VodiK_HU2_PLATE _VODI_MAKE_PLATEID_HU(_VodiK_PCODE_HU2)
# define _VodiK_PCODE_HU2 2

/* mask = ZZXXXX, id = 147 */
# define VodiK_HU3_PLATE _VODI_MAKE_PLATEID_HU(_VodiK_PCODE_HU3)
# define _VodiK_PCODE_HU3 3

/* mask = ZZXXXX, id = 148 */
# define VodiK_HU4_PLATE _VODI_MAKE_PLATEID_HU(_VodiK_PCODE_HU4)
# define _VodiK_PCODE_HU4 4

/* mask = ZZXXXX, id = 149 */
# define VodiK_HU5_PLATE _VODI_MAKE_PLATEID_HU(_VodiK_PCODE_HU5)
# define _VodiK_PCODE_HU5 5

/* mask = ZZZZZX, id = 150 */
# define VodiK_HU6_PLATE _VODI_MAKE_PLATEID_HU(_VodiK_PCODE_HU6)
# define _VodiK_PCODE_HU6 6

/* mask = CDXXXXXX, id = 1677 */
# define VodiK_HU7_PLATE _VODI_MAKE_PLATEID_HU(_VodiK_PCODE_HU7)
# define _VodiK_PCODE_HU7 7

/* mask = CDXXXXXX, id = 1678 */
# define VodiK_HU8_PLATE _VODI_MAKE_PLATEID_HU(_VodiK_PCODE_HU8)
# define _VodiK_PCODE_HU8 8

/* mask = ZZZXXX, id = 1679 */
# define VodiK_HU9_PLATE _VODI_MAKE_PLATEID_HU(_VodiK_PCODE_HU9)
# define _VodiK_PCODE_HU9 9

/* mask = ZZZXXXinv, id = 1680 */
# define VodiK_HU10_PLATE _VODI_MAKE_PLATEID_HU(_VodiK_PCODE_HU10)
# define _VodiK_PCODE_HU10 10
/* @} */


/*
 * ID
 * @{
 */
# define _VODI_MAKE_PLATEID_ID(aCode) _VODI_MAKE_PLATEID(VodiK_INDONESIA_NUMERIC,aCode)

/* mask = ZXXXXZZinv, id = 1456 */
# define VodiK_ID1_PLATE _VODI_MAKE_PLATEID_ID(_VodiK_PCODE_ID1)
# define _VodiK_PCODE_ID1 1

/* mask = ZXXXXZZZinv, id = 1457 */
# define VodiK_ID2_PLATE _VODI_MAKE_PLATEID_ID(_VodiK_PCODE_ID2)
# define _VodiK_PCODE_ID2 2

/* mask = ZXXXXZZ, id = 1458 */
# define VodiK_ID3_PLATE _VODI_MAKE_PLATEID_ID(_VodiK_PCODE_ID3)
# define _VodiK_PCODE_ID3 3

/* mask = ZZXXXZZinv, id = 1459 */
# define VodiK_ID4_PLATE _VODI_MAKE_PLATEID_ID(_VodiK_PCODE_ID4)
# define _VodiK_PCODE_ID4 4

/* mask = ZZXXXXZZinv, id = 1460 */
# define VodiK_ID5_PLATE _VODI_MAKE_PLATEID_ID(_VodiK_PCODE_ID5)
# define _VodiK_PCODE_ID5 5

/* mask = ZXXXZZZinv, id = 1461 */
# define VodiK_ID6_PLATE _VODI_MAKE_PLATEID_ID(_VodiK_PCODE_ID6)
# define _VodiK_PCODE_ID6 6

/* mask = ZXXXXZZZ, id = 1462 */
# define VodiK_ID7_PLATE _VODI_MAKE_PLATEID_ID(_VodiK_PCODE_ID7)
# define _VodiK_PCODE_ID7 7

/* mask = ZXXXXZZ, id = 1555 */
# define VodiK_ID8_PLATE _VODI_MAKE_PLATEID_ID(_VodiK_PCODE_ID8)
# define _VodiK_PCODE_ID8 8

/* mask = ZXXXZZZ, id = 1556 */
# define VodiK_ID9_PLATE _VODI_MAKE_PLATEID_ID(_VodiK_PCODE_ID9)
# define _VodiK_PCODE_ID9 9

/* mask = ZZXXXX, id = 1557 */
# define VodiK_ID10_PLATE _VODI_MAKE_PLATEID_ID(_VodiK_PCODE_ID10)
# define _VodiK_PCODE_ID10 10

/* mask = ZZXXXXZZ, id = 1558 */
# define VodiK_ID11_PLATE _VODI_MAKE_PLATEID_ID(_VodiK_PCODE_ID11)
# define _VodiK_PCODE_ID11 11
/* @} */


/*
* IE
* @{
*/
# define _VODI_MAKE_PLATEID_IE(aCode) _VODI_MAKE_PLATEID(VodiK_IRELAND_NUMERIC,aCode)

/* mask = xxzzxxxx, id = 852 */
# define VodiK_IE1_PLATE _VODI_MAKE_PLATEID_IE(_VodiK_PCODE_IE1)
# define _VodiK_PCODE_IE1 1

/* mask = xxzxxxxx, id = 853 */
# define VodiK_IE2_PLATE _VODI_MAKE_PLATEID_IE(_VodiK_PCODE_IE2)
# define _VodiK_PCODE_IE2 2

/* mask = xxzxxxx, id = 855 */
# define VodiK_IE3_PLATE _VODI_MAKE_PLATEID_IE(_VodiK_PCODE_IE3)
# define _VodiK_PCODE_IE3 3

/* mask = xxzzxxx, id = 856 */
# define VodiK_IE4_PLATE _VODI_MAKE_PLATEID_IE(_VodiK_PCODE_IE4)
# define _VodiK_PCODE_IE4 4

/* mask = xxzxxx, id = 859 */
# define VodiK_IE5_PLATE _VODI_MAKE_PLATEID_IE(_VodiK_PCODE_IE5)
# define _VodiK_PCODE_IE5 5

/* mask = xxzzxx, id = 860 */
# define VodiK_IE6_PLATE _VODI_MAKE_PLATEID_IE(_VodiK_PCODE_IE6)
# define _VodiK_PCODE_IE6 6

/* mask = xxzxxxxxx, id = 862 */
# define VodiK_IE7_PLATE _VODI_MAKE_PLATEID_IE(_VodiK_PCODE_IE7)
# define _VodiK_PCODE_IE7 7

/* mask = xxzxxxxx, id = 863 */
# define VodiK_IE8_PLATE _VODI_MAKE_PLATEID_IE(_VodiK_PCODE_IE8)
# define _VodiK_PCODE_IE8 8

/* mask = xxzzzxxxxx, id = 858 */
# define VodiK_IE9_PLATE _VODI_MAKE_PLATEID_IE(_VodiK_PCODE_IE9)
# define _VodiK_PCODE_IE9 9

/* mask = zzxxxxx, id = 857 */
# define VodiK_IE10_PLATE _VODI_MAKE_PLATEID_IE(_VodiK_PCODE_IE10)
# define _VodiK_PCODE_IE10 10

/* mask = zzxxxx, id = 854 */
# define VodiK_IE11_PLATE _VODI_MAKE_PLATEID_IE(_VodiK_PCODE_IE11)
# define _VodiK_PCODE_IE11 11

/* mask = xxxzxx, id = 861 */
# define VodiK_IE12_PLATE _VODI_MAKE_PLATEID_IE(_VodiK_PCODE_IE12)
# define _VodiK_PCODE_IE12 12

/* mask = xxzzxx, id = 864 */
# define VodiK_IE13_PLATE _VODI_MAKE_PLATEID_IE(_VodiK_PCODE_IE13)
# define _VodiK_PCODE_IE13 13

/* mask = zzxxxx, id = 1726 */
# define VodiK_IE14_PLATE _VODI_MAKE_PLATEID_IE(_VodiK_PCODE_IE14)
# define _VodiK_PCODE_IE14 14

/* mask = xxxzxx, id = 1727 */
# define VodiK_IE15_PLATE _VODI_MAKE_PLATEID_IE(_VodiK_PCODE_IE15)
# define _VodiK_PCODE_IE15 15

/* mask = xxzzxx, id = 1728 */
# define VodiK_IE16_PLATE _VODI_MAKE_PLATEID_IE(_VodiK_PCODE_IE16)
# define _VodiK_PCODE_IE16 16

/* mask = zzxx, id = 1729 */
# define VodiK_IE17_PLATE _VODI_MAKE_PLATEID_IE(_VodiK_PCODE_IE17)
# define _VodiK_PCODE_IE17 17

/* mask = xxxzx, id = 1850 */
# define VodiK_IE18_PLATE _VODI_MAKE_PLATEID_IE(_VodiK_PCODE_IE18)
# define _VodiK_PCODE_IE18 18

/* mask = xxxzxx, id = 1851 */
# define VodiK_IE19_PLATE _VODI_MAKE_PLATEID_IE(_VodiK_PCODE_IE19)
# define _VodiK_PCODE_IE19 19

/* mask = xxxzxx, id = 1852 */
# define VodiK_IE20_PLATE _VODI_MAKE_PLATEID_IE(_VodiK_PCODE_IE20)
# define _VodiK_PCODE_IE20 20

/* mask = xxxzxxx, id = 1853 */
# define VodiK_IE21_PLATE _VODI_MAKE_PLATEID_IE(_VodiK_PCODE_IE21)
# define _VodiK_PCODE_IE21 21

/* mask = xxxzxxx, id = 1854 */
# define VodiK_IE22_PLATE _VODI_MAKE_PLATEID_IE(_VodiK_PCODE_IE22)
# define _VodiK_PCODE_IE22 22

/* mask = xxxzxxxx, id = 1855 */
# define VodiK_IE23_PLATE _VODI_MAKE_PLATEID_IE(_VodiK_PCODE_IE23)
# define _VodiK_PCODE_IE23 23

/* mask = xxxzxxxx, id = 1856 */
# define VodiK_IE24_PLATE _VODI_MAKE_PLATEID_IE(_VodiK_PCODE_IE24)
# define _VodiK_PCODE_IE24 24

/* mask = xxxzzx, id = 1857 */
# define VodiK_IE25_PLATE _VODI_MAKE_PLATEID_IE(_VodiK_PCODE_IE25)
# define _VodiK_PCODE_IE25 25

/* mask = xxxzzx, id = 1858 */
# define VodiK_IE26_PLATE _VODI_MAKE_PLATEID_IE(_VodiK_PCODE_IE26)
# define _VodiK_PCODE_IE26 26

/* mask = xxxzzxx, id = 1859 */
# define VodiK_IE27_PLATE _VODI_MAKE_PLATEID_IE(_VodiK_PCODE_IE27)
# define _VodiK_PCODE_IE27 27

/* mask = xxxzzxx, id = 1860 */
# define VodiK_IE28_PLATE _VODI_MAKE_PLATEID_IE(_VodiK_PCODE_IE28)
# define _VodiK_PCODE_IE28 28

/* mask = xxxzzxxx, id = 1861 */
# define VodiK_IE29_PLATE _VODI_MAKE_PLATEID_IE(_VodiK_PCODE_IE29)
# define _VodiK_PCODE_IE29 29

/* mask = xxxzzxxx, id = 1862 */
# define VodiK_IE30_PLATE _VODI_MAKE_PLATEID_IE(_VodiK_PCODE_IE30)
# define _VodiK_PCODE_IE30 30

/* mask = xxxzzxxxx, id = 1863 */
# define VodiK_IE31_PLATE _VODI_MAKE_PLATEID_IE(_VodiK_PCODE_IE31)
# define _VodiK_PCODE_IE31 31

/* mask = xxxzzxxxx, id = 1864 */
# define VodiK_IE32_PLATE _VODI_MAKE_PLATEID_IE(_VodiK_PCODE_IE32)
# define _VodiK_PCODE_IE32 32

/* mask = xxzxxxxx, id = 1865 */
# define VodiK_IE33_PLATE _VODI_MAKE_PLATEID_IE(_VodiK_PCODE_IE33)
# define _VodiK_PCODE_IE33 33

/* mask = xxzzzxxxxx, id = 1866 */
# define VodiK_IE34_PLATE _VODI_MAKE_PLATEID_IE(_VodiK_PCODE_IE34)
# define _VodiK_PCODE_IE34 34

/* mask = zzxxxxx, id = 1867 */
# define VodiK_IE35_PLATE _VODI_MAKE_PLATEID_IE(_VodiK_PCODE_IE35)
# define _VodiK_PCODE_IE35 35

/* mask = zzxxxx, id = 1868 */
# define VodiK_IE36_PLATE _VODI_MAKE_PLATEID_IE(_VodiK_PCODE_IE36)
# define _VodiK_PCODE_IE36 36

/* mask = xxxzxx, id = 1869 */
# define VodiK_IE37_PLATE _VODI_MAKE_PLATEID_IE(_VodiK_PCODE_IE37)
# define _VodiK_PCODE_IE37 37

/* mask = xxzzxx, id = 1870 */
# define VodiK_IE38_PLATE _VODI_MAKE_PLATEID_IE(_VodiK_PCODE_IE38)
# define _VodiK_PCODE_IE38 38

/* mask = zzxx, id = 1871 */
# define VodiK_IE39_PLATE _VODI_MAKE_PLATEID_IE(_VodiK_PCODE_IE39)
# define _VodiK_PCODE_IE39 39
/* @} */


/*
 * IL
 * @{
 */
# define _VODI_MAKE_PLATEID_IL(aCode) _VODI_MAKE_PLATEID(VodiK_ISRAEL_NUMERIC,aCode)

/* mask = XXXXXXX, id = 280 */
# define VodiK_IL1_PLATE _VODI_MAKE_PLATEID_IL(_VodiK_PCODE_IL1)
# define _VodiK_PCODE_IL1 1

/* mask = ZZZZXXXXXXX, id = 282 */
# define VodiK_IL2_PLATE _VODI_MAKE_PLATEID_IL(_VodiK_PCODE_IL2)
# define _VodiK_PCODE_IL2 2

/* mask = ZZzzzXXXXXXX, id = 283 */
# define VodiK_IL3_PLATE _VODI_MAKE_PLATEID_IL(_VodiK_PCODE_IL3)
# define _VodiK_PCODE_IL3 3

/* mask = ZZZXXXZ, id = 284 */
# define VodiK_IL4_PLATE _VODI_MAKE_PLATEID_IL(_VodiK_PCODE_IL4)
# define _VodiK_PCODE_IL4 4

/* mask = ZZZXXXX, id = 285 */
# define VodiK_IL5_PLATE _VODI_MAKE_PLATEID_IL(_VodiK_PCODE_IL5)
# define _VodiK_PCODE_IL5 5

/* mask = XXXXXX, id = 286 */
# define VodiK_IL6_PLATE _VODI_MAKE_PLATEID_IL(_VodiK_PCODE_IL6)
# define _VodiK_PCODE_IL6 6

/* mask = XXXXXXZ, id = 287 */
# define VodiK_IL7_PLATE _VODI_MAKE_PLATEID_IL(_VodiK_PCODE_IL7)
# define _VodiK_PCODE_IL7 7

/* mask = XXXXXZ, id = 288 */
# define VodiK_IL8_PLATE _VODI_MAKE_PLATEID_IL(_VodiK_PCODE_IL8)
# define _VodiK_PCODE_IL8 8

/* mask = XXXXZ, id = 289 */
# define VodiK_IL9_PLATE _VODI_MAKE_PLATEID_IL(_VodiK_PCODE_IL9)
# define _VodiK_PCODE_IL9 9

/* mask = XXXZ, id = 290 */
# define VodiK_IL10_PLATE _VODI_MAKE_PLATEID_IL(_VodiK_PCODE_IL10)
# define _VodiK_PCODE_IL10 10

/* mask = XXZ, id = 291 */
# define VodiK_IL11_PLATE _VODI_MAKE_PLATEID_IL(_VodiK_PCODE_IL11)
# define _VodiK_PCODE_IL11 11

/* mask = XZ, id = 292 */
# define VodiK_IL12_PLATE _VODI_MAKE_PLATEID_IL(_VodiK_PCODE_IL12)
# define _VodiK_PCODE_IL12 12

/* mask = XXXZZ, id = 294 */
# define VodiK_IL14_PLATE _VODI_MAKE_PLATEID_IL(_VodiK_PCODE_IL14)
# define _VodiK_PCODE_IL14 14

/* mask = XXZZ, id = 295 */
# define VodiK_IL15_PLATE _VODI_MAKE_PLATEID_IL(_VodiK_PCODE_IL15)
# define _VodiK_PCODE_IL15 15

/* mask = XXXZZ, id = 296 */
# define VodiK_IL16_PLATE _VODI_MAKE_PLATEID_IL(_VodiK_PCODE_IL16)
# define _VodiK_PCODE_IL16 16

/* mask = ZZXXXXXXX, id = 281 */
# define VodiK_IL17_PLATE _VODI_MAKE_PLATEID_IL(_VodiK_PCODE_IL17)
# define _VodiK_PCODE_IL17 17

/* mask = xxxxxx, id = 1240 */
# define VodiK_IL18_PLATE _VODI_MAKE_PLATEID_IL(_VodiK_PCODE_IL18)
# define _VodiK_PCODE_IL18 18

/* mask = xx-xxx-xx 2row, id = 1608 */
# define VodiK_IL19_PLATE _VODI_MAKE_PLATEID_IL(_VodiK_PCODE_IL19)
# define _VodiK_PCODE_IL19 19

/* mask = xxx-xx-xxx 2row, id = 1609 */
# define VodiK_IL20_PLATE _VODI_MAKE_PLATEID_IL(_VodiK_PCODE_IL20)
# define _VodiK_PCODE_IL20 20

/* mask = xxx-xx-xxx, id = 1610 */
# define VodiK_IL21_PLATE _VODI_MAKE_PLATEID_IL(_VodiK_PCODE_IL21)
# define _VodiK_PCODE_IL21 21
/* @} */


/*
 * IN
 * @{
 */
# define _VODI_MAKE_PLATEID_IN(aCode) _VODI_MAKE_PLATEID(VodiK_INDIA_NUMERIC,aCode)

/* mask = zzxxzzxxxx, id = 894 */
# define VodiK_IN1_PLATE _VODI_MAKE_PLATEID_IN(_VodiK_PCODE_IN1)
# define _VodiK_PCODE_IN1 1

/* mask = zzxxzxxxx, id = 895 */
# define VodiK_IN2_PLATE _VODI_MAKE_PLATEID_IN(_VodiK_PCODE_IN2)
# define _VodiK_PCODE_IN2 2

/* mask = zzxxxxxx, id = 896 */
# define VodiK_IN3_PLATE _VODI_MAKE_PLATEID_IN(_VodiK_PCODE_IN3)
# define _VodiK_PCODE_IN3 3

/* mask = zzxzzxxxx, id = 1230 */
# define VodiK_IN4_PLATE _VODI_MAKE_PLATEID_IN(_VodiK_PCODE_IN4)
# define _VodiK_PCODE_IN4 4

/* mask = zzxzzxxxx, id = 1945 */
# define VodiK_IN5_PLATE _VODI_MAKE_PLATEID_IN(_VodiK_PCODE_IN5)
# define _VodiK_PCODE_IN5 5

/* mask = zzxzxxxx, id = 1946 */
# define VodiK_IN6_PLATE _VODI_MAKE_PLATEID_IN(_VodiK_PCODE_IN6)
# define _VodiK_PCODE_IN6 6

/* mask = zzxzxxxx, id = 2150 */
# define VodiK_IN7_PLATE _VODI_MAKE_PLATEID_IN(_VodiK_PCODE_IN7)
# define _VodiK_PCODE_IN7 7

/* mask = zzxzxxxx, id = 2151 */
# define VodiK_IN8_PLATE _VODI_MAKE_PLATEID_IN(_VodiK_PCODE_IN8)
# define _VodiK_PCODE_IN8 8

/* mask = zzxzxxxx, id = 2152 */
# define VodiK_IN9_PLATE _VODI_MAKE_PLATEID_IN(_VodiK_PCODE_IN9)
# define _VodiK_PCODE_IN9 9

/* mask = xxzxxxxxz, id = 2180 */
# define VodiK_IN10_PLATE _VODI_MAKE_PLATEID_IN(_VodiK_PCODE_IN10)
# define _VodiK_PCODE_IN10 10

/* mask = zzxzzzxxxx, id = 2181 */
# define VodiK_IN11_PLATE _VODI_MAKE_PLATEID_IN(_VodiK_PCODE_IN11)
# define _VodiK_PCODE_IN11 11

/* mask = zzxxzxxxx, id = 2182 */
# define VodiK_IN12_PLATE _VODI_MAKE_PLATEID_IN(_VodiK_PCODE_IN12)
# define _VodiK_PCODE_IN12 12

/* mask = zzxxzzxxxx, id = 2183 */
# define VodiK_IN13_PLATE _VODI_MAKE_PLATEID_IN(_VodiK_PCODE_IN13)
# define _VodiK_PCODE_IN13 13

/* mask = zzxzzxxxx, id = 2184 */
# define VodiK_IN14_PLATE _VODI_MAKE_PLATEID_IN(_VodiK_PCODE_IN14)
# define _VodiK_PCODE_IN14 14

/* mask = zzxzzxxxx, id = 2185 */
# define VodiK_IN15_PLATE _VODI_MAKE_PLATEID_IN(_VodiK_PCODE_IN15)
# define _VodiK_PCODE_IN15 15

/* mask = zzxxxxxx, id = 2186 */
# define VodiK_IN16_PLATE _VODI_MAKE_PLATEID_IN(_VodiK_PCODE_IN16)
# define _VodiK_PCODE_IN16 16

/* mask = zzxxzzxxxx, id = 2187 */
# define VodiK_IN17_PLATE _VODI_MAKE_PLATEID_IN(_VodiK_PCODE_IN17)
# define _VodiK_PCODE_IN17 17
/* @} */


/*
 * IR
 * @{
 */
# define _VODI_MAKE_PLATEID_IR(aCode) _VODI_MAKE_PLATEID(VodiK_IRAN_NUMERIC,aCode)

/* mask = xxzxxxxx, id = 475 */
# define VodiK_IR1_PLATE _VODI_MAKE_PLATEID_IR(_VodiK_PCODE_IR1)
# define _VodiK_PCODE_IR1 1

/* mask = xxzxxxxx, id = 1203 */
# define VodiK_IR2_PLATE _VODI_MAKE_PLATEID_IR(_VodiK_PCODE_IR2)
# define _VodiK_PCODE_IR2 2

/* mask = xxzxxxxx, id = 2138 */
# define VodiK_IR3_PLATE _VODI_MAKE_PLATEID_IR(_VodiK_PCODE_IR3)
# define _VodiK_PCODE_IR3 3

/* mask = xxxxxxxx, id = 2146 */
# define VodiK_IR4_PLATE _VODI_MAKE_PLATEID_IR(_VodiK_PCODE_IR4)
# define _VodiK_PCODE_IR4 4

/* mask = xxzxxxxx, id = 2147 */
# define VodiK_IR5_PLATE _VODI_MAKE_PLATEID_IR(_VodiK_PCODE_IR5)
# define _VodiK_PCODE_IR5 5

/* mask = xxzxxxxx, id = 2148 */
# define VodiK_IR6_PLATE _VODI_MAKE_PLATEID_IR(_VodiK_PCODE_IR6)
# define _VodiK_PCODE_IR6 6

/* mask = xxzxxxxx, id = 2149 */
# define VodiK_IR7_PLATE _VODI_MAKE_PLATEID_IR(_VodiK_PCODE_IR7)
# define _VodiK_PCODE_IR7 7
/* @} */


/*
* IS
* @{
*/
# define _VODI_MAKE_PLATEID_IS(aCode) _VODI_MAKE_PLATEID(VodiK_ICELAND_NUMERIC,aCode)

/* mask = zzxxx, id = 551 */
# define VodiK_IS1_PLATE _VODI_MAKE_PLATEID_IS(_VodiK_PCODE_IS1)
# define _VodiK_PCODE_IS1 1

/* mask = zzzxx, id = 552 */
# define VodiK_IS2_PLATE _VODI_MAKE_PLATEID_IS(_VodiK_PCODE_IS2)
# define _VodiK_PCODE_IS2 2

/* mask = zzzxx, id = 553 */
# define VodiK_IS3_PLATE _VODI_MAKE_PLATEID_IS(_VodiK_PCODE_IS3)
# define _VodiK_PCODE_IS3 3

/* mask = zzzxx, id = 1723 */
# define VodiK_IS4_PLATE _VODI_MAKE_PLATEID_IS(_VodiK_PCODE_IS4)
# define _VodiK_PCODE_IS4 4

/* mask = zzzxx, id = 1725 */
# define VodiK_IS5_PLATE _VODI_MAKE_PLATEID_IS(_VodiK_PCODE_IS5)
# define _VodiK_PCODE_IS5 5
/* @} */


/*
 * IT
 * @{
 */
# define _VODI_MAKE_PLATEID_IT(aCode) _VODI_MAKE_PLATEID(VodiK_ITALY_NUMERIC,aCode)

/* mask = ZZXXXZZ, id = 29 */
# define VodiK_IT1_PLATE _VODI_MAKE_PLATEID_IT(_VodiK_PCODE_IT1)
# define _VodiK_PCODE_IT1 1

/* mask = ZZXXXXZZ, id = 33 */
# define VodiK_IT2_PLATE _VODI_MAKE_PLATEID_IT(_VodiK_PCODE_IT2)
# define _VodiK_PCODE_IT2 2

/* mask = ZZZXXXXX, id = 35 */
# define VodiK_IT3_PLATE _VODI_MAKE_PLATEID_IT(_VodiK_PCODE_IT3)
# define _VodiK_PCODE_IT3 3

/* mask = ZZXXXZZ, id = 30 */
# define VodiK_IT4_PLATE _VODI_MAKE_PLATEID_IT(_VodiK_PCODE_IT4)
# define _VodiK_PCODE_IT4 4

/* mask = ZZXXXXX, id = 31 */
# define VodiK_IT5_PLATE _VODI_MAKE_PLATEID_IT(_VodiK_PCODE_IT5)
# define _VodiK_PCODE_IT5 5

/* mask = ZZXXXXXX, id = 32 */
# define VodiK_IT6_PLATE _VODI_MAKE_PLATEID_IT(_VodiK_PCODE_IT6)
# define _VodiK_PCODE_IT6 6

/* mask = ZZXXXX, id = 34 */
# define VodiK_IT7_PLATE _VODI_MAKE_PLATEID_IT(_VodiK_PCODE_IT7)
# define _VodiK_PCODE_IT7 7

/* mask = ZZZXXXXX, id = 36 */
# define VodiK_IT8_PLATE _VODI_MAKE_PLATEID_IT(_VodiK_PCODE_IT8)
# define _VodiK_PCODE_IT8 8

/* mask = ZZXXXXXZ, id = 37 */
# define VodiK_IT9_PLATE _VODI_MAKE_PLATEID_IT(_VodiK_PCODE_IT9)
# define _VodiK_PCODE_IT9 9

/* mask = ZZXXXXXZ, id = 38 */
# define VodiK_IT10_PLATE _VODI_MAKE_PLATEID_IT(_VodiK_PCODE_IT10)
# define _VodiK_PCODE_IT10 10

/* mask = ZZXXXZZ, id = 1639 */
# define VodiK_IT11_PLATE _VODI_MAKE_PLATEID_IT(_VodiK_PCODE_IT11)
# define _VodiK_PCODE_IT11 11

/* mask = ZZXXXXX, id = 1640 */
# define VodiK_IT12_PLATE _VODI_MAKE_PLATEID_IT(_VodiK_PCODE_IT12)
# define _VodiK_PCODE_IT12 12
/* @} */


/*
 * JO
 * @{
 */
# define _VODI_MAKE_PLATEID_JO(aCode) _VODI_MAKE_PLATEID(VodiK_JORDAN_NUMERIC,aCode)

/* mask = xxxxxxx, id = 1198 */
# define VodiK_JO1_PLATE _VODI_MAKE_PLATEID_JO(_VodiK_PCODE_JO1)
# define _VodiK_PCODE_JO1 1

/* mask = xxxxxxx, id = 1530 */
# define VodiK_JO2_PLATE _VODI_MAKE_PLATEID_JO(_VodiK_PCODE_JO2)
# define _VodiK_PCODE_JO2 2

/* mask = xxxxxx, id = 1531 */
# define VodiK_JO3_PLATE _VODI_MAKE_PLATEID_JO(_VodiK_PCODE_JO3)
# define _VodiK_PCODE_JO3 3

/* mask = xxxxxx, id = 1532 */
# define VodiK_JO4_PLATE _VODI_MAKE_PLATEID_JO(_VodiK_PCODE_JO4)
# define _VodiK_PCODE_JO4 4

/* mask = xxxxx, id = 1533 */
# define VodiK_JO5_PLATE _VODI_MAKE_PLATEID_JO(_VodiK_PCODE_JO5)
# define _VodiK_PCODE_JO5 5

/* mask = xxxxx, id = 1534 */
# define VodiK_JO6_PLATE _VODI_MAKE_PLATEID_JO(_VodiK_PCODE_JO6)
# define _VodiK_PCODE_JO6 6

/* mask = xxxxxx, id = 1535 */
# define VodiK_JO7_PLATE _VODI_MAKE_PLATEID_JO(_VodiK_PCODE_JO7)
# define _VodiK_PCODE_JO7 7

/* mask = xxxxxx, id = 1536 */
# define VodiK_JO8_PLATE _VODI_MAKE_PLATEID_JO(_VodiK_PCODE_JO8)
# define _VodiK_PCODE_JO8 8

/* mask = xxxxxx, id = 1587 */
# define VodiK_JO9_PLATE _VODI_MAKE_PLATEID_JO(_VodiK_PCODE_JO9)
# define _VodiK_PCODE_JO9 9

/* mask = xxxxx, id = 1588 */
# define VodiK_JO10_PLATE _VODI_MAKE_PLATEID_JO(_VodiK_PCODE_JO10)
# define _VodiK_PCODE_JO10 10
/* @} */

/*
 * JP
 * @{
 */
# define _VODI_MAKE_PLATEID_JP(aCode) _VODI_MAKE_PLATEID(VodiK_JAPAN_NUMERIC,aCode)

/* mask = ZZXXXZXXXX, id = 480 */
# define VodiK_JP1_PLATE _VODI_MAKE_PLATEID_JP(_VodiK_PCODE_JP1)
# define _VodiK_PCODE_JP1 1

/* mask = ZZXXXZXXXX, inversed, id = 481 */
# define VodiK_JP2_PLATE _VODI_MAKE_PLATEID_JP(_VodiK_PCODE_JP2)
# define _VodiK_PCODE_JP2 2

/* mask = ZZZXXXZXXXX, id = 482 */
# define VodiK_JP3_PLATE _VODI_MAKE_PLATEID_JP(_VodiK_PCODE_JP3)
# define _VodiK_PCODE_JP3 3

/* mask = ZZZXXXZXXXX, inversed, id = 483 */
# define VodiK_JP4_PLATE _VODI_MAKE_PLATEID_JP(_VodiK_PCODE_JP4)
# define _VodiK_PCODE_JP4 4

 /* mask = ZZXXZXXXX, id = 484 */
# define VodiK_JP5_PLATE _VODI_MAKE_PLATEID_JP(_VodiK_PCODE_JP5)
# define _VodiK_PCODE_JP5 5

/* mask = ZZXXZXXXX, inversed, id = 485 */
# define VodiK_JP6_PLATE _VODI_MAKE_PLATEID_JP(_VodiK_PCODE_JP6)
# define _VodiK_PCODE_JP6 6

/* mask = ZZZXXZXXXX, id = 486 */
# define VodiK_JP7_PLATE _VODI_MAKE_PLATEID_JP(_VodiK_PCODE_JP7)
# define _VodiK_PCODE_JP7 7

/* mask = ZZZXXZXXXX, inversed, id = 487 */
# define VodiK_JP8_PLATE _VODI_MAKE_PLATEID_JP(_VodiK_PCODE_JP8)
# define _VodiK_PCODE_JP8 8

/*
 * KE
 * @{
 */
# define _VODI_MAKE_PLATEID_KE(aCode) _VODI_MAKE_PLATEID(VodiK_KENYA_NUMERIC,aCode)

/* mask = ZZZXXXZ, id = 1559 */
# define VodiK_KE1_PLATE _VODI_MAKE_PLATEID_KE(_VodiK_PCODE_KE1)
# define _VodiK_PCODE_KE1 1

/* mask = ZZZXXXZ, id = 1560 */
# define VodiK_KE2_PLATE _VODI_MAKE_PLATEID_KE(_VodiK_PCODE_KE2)
# define _VodiK_PCODE_KE2 2

/* mask = ZZZXXX, id = 1561 */
# define VodiK_KE3_PLATE _VODI_MAKE_PLATEID_KE(_VodiK_PCODE_KE3)
# define _VodiK_PCODE_KE3 3

/* mask = ZZZXXX, id = 1562 */
# define VodiK_KE4_PLATE _VODI_MAKE_PLATEID_KE(_VodiK_PCODE_KE4)
# define _VodiK_PCODE_KE4 4

/* mask = ZZXXXX, id = 2239 */
# define VodiK_KE5_PLATE _VODI_MAKE_PLATEID_KE(_VodiK_PCODE_KE5)
# define _VodiK_PCODE_KE5 5

/* mask = ZZXXXX, id = 2240 */
# define VodiK_KE6_PLATE _VODI_MAKE_PLATEID_KE(_VodiK_PCODE_KE6)
# define _VodiK_PCODE_KE6 6

/* mask = ZZXXXX, id = 2305 */
# define VodiK_KE7_PLATE _VODI_MAKE_PLATEID_KE(_VodiK_PCODE_KE7)
# define _VodiK_PCODE_KE7 7
/* @} */

/*
 * KG
 * @{
 */
# define _VODI_MAKE_PLATEID_KG(aCode) _VODI_MAKE_PLATEID(VodiK_KYRGYZSTAN_NUMERIC,aCode)

/* mask = XXXZZ, id = 160 */
# define VodiK_KG1_PLATE _VODI_MAKE_PLATEID_KG(_VodiK_PCODE_KG1)
# define _VodiK_PCODE_KG1 1

/* mask = XXXXZZ, id = 161 */
# define VodiK_KG2_PLATE _VODI_MAKE_PLATEID_KG(_VodiK_PCODE_KG2)
# define _VodiK_PCODE_KG2 2

/* mask = ZXXXXZ, id = 162 */
# define VodiK_KG3_PLATE _VODI_MAKE_PLATEID_KG(_VodiK_PCODE_KG3)
# define _VodiK_PCODE_KG3 3

/* mask = ZXXXXZZ, id = 163 */
# define VodiK_KG4_PLATE _VODI_MAKE_PLATEID_KG(_VodiK_PCODE_KG4)
# define _VodiK_PCODE_KG4 4

/* mask = ZZZZXXXX, id = 164 */
# define VodiK_KG5_PLATE _VODI_MAKE_PLATEID_KG(_VodiK_PCODE_KG5)
# define _VodiK_PCODE_KG5 5

/* mask = ZZZXXXZ, id = 165 */
# define VodiK_KG6_PLATE _VODI_MAKE_PLATEID_KG(_VodiK_PCODE_KG6)
# define _VodiK_PCODE_KG6 6

/* mask = XXXXZZ, id = 166 */
# define VodiK_KG7_PLATE _VODI_MAKE_PLATEID_KG(_VodiK_PCODE_KG7)
# define _VodiK_PCODE_KG7 7

/* mask = xxxxxzzz, id = 1475 */
# define VodiK_KG8_PLATE _VODI_MAKE_PLATEID_KG(_VodiK_PCODE_KG8)
# define _VodiK_PCODE_KG8 8

/* mask = xxxxxzzz, id = 1476 */
# define VodiK_KG9_PLATE _VODI_MAKE_PLATEID_KG(_VodiK_PCODE_KG9)
# define _VodiK_PCODE_KG9 9

/* mask = xxxxxzz, id = 1477 */
# define VodiK_KG10_PLATE _VODI_MAKE_PLATEID_KG(_VodiK_PCODE_KG10)
# define _VodiK_PCODE_KG10 10

/* mask = xxxxxzz, id = 1478 */
# define VodiK_KG11_PLATE _VODI_MAKE_PLATEID_KG(_VodiK_PCODE_KG11)
# define _VodiK_PCODE_KG11 11

/* mask = zzzxxx, id = 1479 */
# define VodiK_KG12_PLATE _VODI_MAKE_PLATEID_KG(_VodiK_PCODE_KG12)
# define _VodiK_PCODE_KG12 12

/* mask = zxxxxx, id = 1480 */
# define VodiK_KG13_PLATE _VODI_MAKE_PLATEID_KG(_VodiK_PCODE_KG13)
# define _VodiK_PCODE_KG13 13

/* mask = xxxxxxz, id = 1481 */
# define VodiK_KG14_PLATE _VODI_MAKE_PLATEID_KG(_VodiK_PCODE_KG14)
# define _VodiK_PCODE_KG14 14

/* mask = xxzzzzzzz, id = 1482 */
# define VodiK_KG15_PLATE _VODI_MAKE_PLATEID_KG(_VodiK_PCODE_KG15)
# define _VodiK_PCODE_KG15 15

/* mask = xxxxzz, id = 1549 */
# define VodiK_KG16_PLATE _VODI_MAKE_PLATEID_KG(_VodiK_PCODE_KG16)
# define _VodiK_PCODE_KG16 16

/* mask = xxxxzzz, id = 1550 */
# define VodiK_KG17_PLATE _VODI_MAKE_PLATEID_KG(_VodiK_PCODE_KG17)
# define _VodiK_PCODE_KG17 17

/* mask = xxxzz, id = 2204 */
# define VodiK_KG18_PLATE _VODI_MAKE_PLATEID_KG(_VodiK_PCODE_KG18)
# define _VodiK_PCODE_KG18 18

/* mask = zxxxx, id = 2205 */
# define VodiK_KG19_PLATE _VODI_MAKE_PLATEID_KG(_VodiK_PCODE_KG19)
# define _VodiK_PCODE_KG19 19

/* mask = zzxxxx, id = 2206 */
# define VodiK_KG20_PLATE _VODI_MAKE_PLATEID_KG(_VodiK_PCODE_KG20)
# define _VodiK_PCODE_KG20 20

/* mask = zzzxxxx, id = 2207 */
# define VodiK_KG21_PLATE _VODI_MAKE_PLATEID_KG(_VodiK_PCODE_KG21)
# define _VodiK_PCODE_KG21 21

/* mask = xxzz, id = 2208 */
# define VodiK_KG22_PLATE _VODI_MAKE_PLATEID_KG(_VodiK_PCODE_KG22)
# define _VodiK_PCODE_KG22 22
/* @} */

/*
 * KR
 * @{
 */
# define _VODI_MAKE_PLATEID_KR(aCode) _VODI_MAKE_PLATEID(VodiK_KOREA_REPUBLIC_NUMERIC,aCode)

/* mask = xxzxxxx, id = 1613 */
# define VodiK_KR1_PLATE _VODI_MAKE_PLATEID_KR(_VodiK_PCODE_KR1)
# define _VodiK_PCODE_KR1 1

/* mask = xxzxxxx, id = 1614 */
# define VodiK_KR2_PLATE _VODI_MAKE_PLATEID_KR(_VodiK_PCODE_KR2)
# define _VodiK_PCODE_KR2 2

/* mask = ZZXXZXXXX, id = 1615 */
# define VodiK_KR3_PLATE _VODI_MAKE_PLATEID_KR(_VodiK_PCODE_KR3)
# define _VodiK_PCODE_KR3 3

/* mask = ZZXXXXXX, id = 1616 */
# define VodiK_KR4_PLATE _VODI_MAKE_PLATEID_KR(_VodiK_PCODE_KR4)
# define _VodiK_PCODE_KR4 4

/* mask = XXZXXXX, id = 2169 */
# define VodiK_KR5_PLATE _VODI_MAKE_PLATEID_KR(_VodiK_PCODE_KR5)
# define _VodiK_PCODE_KR5 5

/* mask = ZZXXZXXXX, id = 2170 */
# define VodiK_KR6_PLATE _VODI_MAKE_PLATEID_KR(_VodiK_PCODE_KR6)
# define _VodiK_PCODE_KR6 6

/* mask = ZZXXZXXXX, id = 2171 */
# define VodiK_KR7_PLATE _VODI_MAKE_PLATEID_KR(_VodiK_PCODE_KR7)
# define _VodiK_PCODE_KR7 7

/* mask = ZZXXZXXXX, id = 2201 */
# define VodiK_KR8_PLATE _VODI_MAKE_PLATEID_KR(_VodiK_PCODE_KR8)
# define _VodiK_PCODE_KR8 8

/* mask = XXXZXXXX, id = 2202 */
# define VodiK_KR9_PLATE _VODI_MAKE_PLATEID_KR(_VodiK_PCODE_KR9)
# define _VodiK_PCODE_KR9 9

/* mask = ZZZZZXXXX, id = 2209 */
# define VodiK_KR10_PLATE _VODI_MAKE_PLATEID_KR(_VodiK_PCODE_KR10)
# define _VodiK_PCODE_KR10 10

/* mask = ZZXXZXXXX, id = 2210 */
# define VodiK_KR11_PLATE _VODI_MAKE_PLATEID_KR(_VodiK_PCODE_KR11)
# define _VodiK_PCODE_KR11 11
/* @} */

/*
 * KW
 * @{
 */
# define _VODI_MAKE_PLATEID_KW(aCode) _VODI_MAKE_PLATEID(VodiK_KUWAIT_NUMERIC,aCode)

/* mask = xxxxxx, id = 813 */
# define VodiK_KW1_PLATE _VODI_MAKE_PLATEID_KW(_VodiK_PCODE_KW1)
# define _VodiK_PCODE_KW1 1

/* mask = xxxx, id = 814 */
# define VodiK_KW2_PLATE _VODI_MAKE_PLATEID_KW(_VodiK_PCODE_KW2)
# define _VodiK_PCODE_KW2 2

/* mask = xxxxxx, id = 811 */
# define VodiK_KW3_PLATE _VODI_MAKE_PLATEID_KW(_VodiK_PCODE_KW3)
# define _VodiK_PCODE_KW3 3

/* mask = xxxxx, id = 812 */
# define VodiK_KW4_PLATE _VODI_MAKE_PLATEID_KW(_VodiK_PCODE_KW4)
# define _VodiK_PCODE_KW4 4

/* mask = xxxxxx, id = 1472 */
# define VodiK_KW5_PLATE _VODI_MAKE_PLATEID_KW(_VodiK_PCODE_KW5)
# define _VodiK_PCODE_KW5 5

/* mask = xxxxx, id = 1473 */
# define VodiK_KW6_PLATE _VODI_MAKE_PLATEID_KW(_VodiK_PCODE_KW6)
# define _VodiK_PCODE_KW6 6

/* mask = xxxxxx, id = 1474 */
# define VodiK_KW7_PLATE _VODI_MAKE_PLATEID_KW(_VodiK_PCODE_KW7)
# define _VodiK_PCODE_KW7 7

/* mask = xxxxxxx, id = 1584 */
# define VodiK_KW8_PLATE _VODI_MAKE_PLATEID_KW(_VodiK_PCODE_KW8)
# define _VodiK_PCODE_KW8 8

/* mask = xxxxx, id = 1589 */
# define VodiK_KW9_PLATE _VODI_MAKE_PLATEID_KW(_VodiK_PCODE_KW9)
# define _VodiK_PCODE_KW9 9

/* mask = xxxxxx, id = 1590 */
# define VodiK_KW10_PLATE _VODI_MAKE_PLATEID_KW(_VodiK_PCODE_KW10)
# define _VodiK_PCODE_KW10 10

/* mask = xxxxxxx, id = 1591 */
# define VodiK_KW11_PLATE _VODI_MAKE_PLATEID_KW(_VodiK_PCODE_KW11)
# define _VodiK_PCODE_KW11 11
/* @} */


/*
 * KZ
 * @{
 */
# define _VODI_MAKE_PLATEID_KZ(aCode) _VODI_MAKE_PLATEID(VodiK_KAZAKHSTAN_NUMERIC,aCode)

/* mask = ZXXXZZZ, id = 64 */
# define VodiK_KZ1_PLATE _VODI_MAKE_PLATEID_KZ(_VodiK_PCODE_KZ1)
# define _VodiK_PCODE_KZ1 1

/* mask = ZXXXZZ, id = 65 */
# define VodiK_KZ2_PLATE _VODI_MAKE_PLATEID_KZ(_VodiK_PCODE_KZ2)
# define _VodiK_PCODE_KZ2 2

/* mask = ZXXXZZ, id = 66 */
# define VodiK_KZ3_PLATE _VODI_MAKE_PLATEID_KZ(_VodiK_PCODE_KZ3)
# define _VodiK_PCODE_KZ3 3

/* mask = XXXZZZ, id = 67 */
# define VodiK_KZ4_PLATE _VODI_MAKE_PLATEID_KZ(_VodiK_PCODE_KZ4)
# define _VodiK_PCODE_KZ4 4

/* mask = ZXXXXXX, id = 68 */
# define VodiK_KZ5_PLATE _VODI_MAKE_PLATEID_KZ(_VodiK_PCODE_KZ5)
# define _VodiK_PCODE_KZ5 5

/* mask = ZXXXXXX, id = 69 */
# define VodiK_KZ6_PLATE _VODI_MAKE_PLATEID_KZ(_VodiK_PCODE_KZ6)
# define _VodiK_PCODE_KZ6 6

/* mask = ZZZXXXX, id = 70 */
# define VodiK_KZ7_PLATE _VODI_MAKE_PLATEID_KZ(_VodiK_PCODE_KZ7)
# define _VodiK_PCODE_KZ7 7

/* mask = XXXZZ, id = 71 */
# define VodiK_KZ8_PLATE _VODI_MAKE_PLATEID_KZ(_VodiK_PCODE_KZ8)
# define _VodiK_PCODE_KZ8 8

/* mask = ZZXXX, id = 72 */
# define VodiK_KZ9_PLATE _VODI_MAKE_PLATEID_KZ(_VodiK_PCODE_KZ9)
# define _VodiK_PCODE_KZ9 9

/* mask = XXXXZZ, id = 73 */
# define VodiK_KZ10_PLATE _VODI_MAKE_PLATEID_KZ(_VodiK_PCODE_KZ10)
# define _VodiK_PCODE_KZ10 10

/* mask = xxxzzzxx, id = 328 */
# define VodiK_KZ11_PLATE _VODI_MAKE_PLATEID_KZ(_VodiK_PCODE_KZ11)
# define _VodiK_PCODE_KZ11 11

/* mask = xxxzzxx, id = 329 */
# define VodiK_KZ12_PLATE _VODI_MAKE_PLATEID_KZ(_VodiK_PCODE_KZ12)
# define _VodiK_PCODE_KZ12 12

/* mask = xxxxzz, id = 1284, two row */
# define VodiK_KZ13_PLATE _VODI_MAKE_PLATEID_KZ(_VodiK_PCODE_KZ13)
# define _VodiK_PCODE_KZ13 13

/* mask = zzzxxxx, id = 1285, two row */
# define VodiK_KZ14_PLATE _VODI_MAKE_PLATEID_KZ(_VodiK_PCODE_KZ14)
# define _VodiK_PCODE_KZ14 14

/* mask = xxxxxzz, id = 1286, two row */
# define VodiK_KZ15_PLATE _VODI_MAKE_PLATEID_KZ(_VodiK_PCODE_KZ15)
# define _VodiK_PCODE_KZ15 15

/* mask = zxxxzz, id = 1292, two row */
# define VodiK_KZ16_PLATE _VODI_MAKE_PLATEID_KZ(_VodiK_PCODE_KZ16)
# define _VodiK_PCODE_KZ16 16

/* mask = zxxxzzz, id = 1293, two row */
# define VodiK_KZ17_PLATE _VODI_MAKE_PLATEID_KZ(_VodiK_PCODE_KZ17)
# define _VodiK_PCODE_KZ17 17

/* mask = xxxxzz, id = 1294, two row */
# define VodiK_KZ18_PLATE _VODI_MAKE_PLATEID_KZ(_VodiK_PCODE_KZ18)
# define _VodiK_PCODE_KZ18 18

/* mask = xxxxxzzz, id = 1300, two row */
# define VodiK_KZ19_PLATE _VODI_MAKE_PLATEID_KZ(_VodiK_PCODE_KZ19)
# define _VodiK_PCODE_KZ19 19

/* mask = zxxxxxx, id = 1301 */
# define VodiK_KZ20_PLATE _VODI_MAKE_PLATEID_KZ(_VodiK_PCODE_KZ20)
# define _VodiK_PCODE_KZ20 20

/* mask = xxxxxx, id = 1483 */
# define VodiK_KZ21_PLATE _VODI_MAKE_PLATEID_KZ(_VodiK_PCODE_KZ21)
# define _VodiK_PCODE_KZ21 21

/* mask = xxxzzxx, id = 1484 */
# define VodiK_KZ22_PLATE _VODI_MAKE_PLATEID_KZ(_VodiK_PCODE_KZ22)
# define _VodiK_PCODE_KZ22 22

/* mask = xxxzzxx_inv, id = 1485 */
# define VodiK_KZ23_PLATE _VODI_MAKE_PLATEID_KZ(_VodiK_PCODE_KZ23)
# define _VodiK_PCODE_KZ23 23

/* mask = ZXXXXXX, id = 1652 */
# define VodiK_KZ24_PLATE _VODI_MAKE_PLATEID_KZ(_VodiK_PCODE_KZ24)
# define _VodiK_PCODE_KZ24 24

/* mask = MXXXXXX, id = 1653 */
# define VodiK_KZ25_PLATE _VODI_MAKE_PLATEID_KZ(_VodiK_PCODE_KZ25)
# define _VodiK_PCODE_KZ25 25

/* mask = TXXXXXX_inv, id = 1654 */
# define VodiK_KZ26_PLATE _VODI_MAKE_PLATEID_KZ(_VodiK_PCODE_KZ26)
# define _VodiK_PCODE_KZ26 26

/* mask = XXXXZZ_inv, id = 1655 */
# define VodiK_KZ27_PLATE _VODI_MAKE_PLATEID_KZ(_VodiK_PCODE_KZ27)
# define _VodiK_PCODE_KZ27 27

/* mask = MXXXXXX, id = 1656 */
# define VodiK_KZ28_PLATE _VODI_MAKE_PLATEID_KZ(_VodiK_PCODE_KZ28)
# define _VodiK_PCODE_KZ28 28

/* mask = TXXXXXX, id = 1657 */
# define VodiK_KZ29_PLATE _VODI_MAKE_PLATEID_KZ(_VodiK_PCODE_KZ29)
# define _VodiK_PCODE_KZ29 29

/* mask = XXXiiiXX, id = 2179 */
# define VodiK_KZ30_PLATE _VODI_MAKE_PLATEID_KZ(_VodiK_PCODE_KZ30)
# define _VodiK_PCODE_KZ30 30
/* @} */


/*
 * LI
 * @{
 */
# define _VODI_MAKE_PLATEID_LI(aCode) _VODI_MAKE_PLATEID(VodiK_LIECHTENSTEIN_NUMERIC,aCode)

/* mask = zzxxxx, id = 2089 */
# define VodiK_LI1_PLATE _VODI_MAKE_PLATEID_LI(_VodiK_PCODE_LI1)
# define _VodiK_PCODE_LI1 1

/* mask = zzxxxx, id = 2090 */
# define VodiK_LI2_PLATE _VODI_MAKE_PLATEID_LI(_VodiK_PCODE_LI2)
# define _VodiK_PCODE_LI2 2

/* mask = zzxxxxx, id = 2091 */
# define VodiK_LI3_PLATE _VODI_MAKE_PLATEID_LI(_VodiK_PCODE_LI3)
# define _VodiK_PCODE_LI3 3

/* mask = zzxxxxx, id = 2092 */
# define VodiK_LI4_PLATE _VODI_MAKE_PLATEID_LI(_VodiK_PCODE_LI4)
# define _VodiK_PCODE_LI4 4
/* @} */


/*
 * LK
 * @{
 */
# define _VODI_MAKE_PLATEID_LK(aCode) _VODI_MAKE_PLATEID(VodiK_SRI_LANKA_NUMERIC,aCode)

/* mask = zzzzxxxx, id = 2228 */
# define VodiK_LK1_PLATE _VODI_MAKE_PLATEID_LK(_VodiK_PCODE_LK1)
# define _VodiK_PCODE_LK1 1

/* mask = zzzzxxxx, id = 2229 */
# define VodiK_LK2_PLATE _VODI_MAKE_PLATEID_LK(_VodiK_PCODE_LK2)
# define _VodiK_PCODE_LK2 2

/* mask = zzzxxxxx, id = 2230 */
# define VodiK_LK3_PLATE _VODI_MAKE_PLATEID_LK(_VodiK_PCODE_LK3)
# define _VodiK_PCODE_LK3 3

/* mask = zzzxxxxxx, id = 2231 */
# define VodiK_LK4_PLATE _VODI_MAKE_PLATEID_LK(_VodiK_PCODE_LK4)
# define _VodiK_PCODE_LK4 4

/* mask = zzzzzxxxx, id = 2232 */
# define VodiK_LK5_PLATE _VODI_MAKE_PLATEID_LK(_VodiK_PCODE_LK5)
# define _VodiK_PCODE_LK5 5

/* mask = zzzzzxxxx, id = 2233 */
# define VodiK_LK6_PLATE _VODI_MAKE_PLATEID_LK(_VodiK_PCODE_LK6)
# define _VodiK_PCODE_LK6 6

/* mask = zzzzzxxxx, id = 2234 */
# define VodiK_LK7_PLATE _VODI_MAKE_PLATEID_LK(_VodiK_PCODE_LK7)
# define _VodiK_PCODE_LK7 7

/* mask = zzzzxxxx, id = 2235 */
# define VodiK_LK8_PLATE _VODI_MAKE_PLATEID_LK(_VodiK_PCODE_LK8)
# define _VodiK_PCODE_LK8 8

/* mask = zzzzxxxx, id = 2236 */
# define VodiK_LK9_PLATE _VODI_MAKE_PLATEID_LK(_VodiK_PCODE_LK9)
# define _VodiK_PCODE_LK9 9

/* mask = zzzzxxxx, id = 2237 */
# define VodiK_LK10_PLATE _VODI_MAKE_PLATEID_LK(_VodiK_PCODE_LK10)
# define _VodiK_PCODE_LK10 10

/* mask = zzxxxxxxx, id = 2238 */
# define VodiK_LK11_PLATE _VODI_MAKE_PLATEID_LK(_VodiK_PCODE_LK11)
# define _VodiK_PCODE_LK11 11
/* @} */


/*
* LT
* @{
*/
# define _VODI_MAKE_PLATEID_LT(aCode) _VODI_MAKE_PLATEID(VodiK_LITHUANIA_NUMERIC,aCode)

/* mask = ZZZXXX, id = 242 */
# define VodiK_LT1_PLATE _VODI_MAKE_PLATEID_LT(_VodiK_PCODE_LT1)
# define _VodiK_PCODE_LT1 1

/* mask = ZZXXX, id = 243 */
# define VodiK_LT2_PLATE _VODI_MAKE_PLATEID_LT(_VodiK_PCODE_LT2)
# define _VodiK_PCODE_LT2 2

/* mask = ZXXXXX, id = 244 */
# define VodiK_LT3_PLATE _VODI_MAKE_PLATEID_LT(_VodiK_PCODE_LT3)
# define _VodiK_PCODE_LT3 3

/* mask = XXXXXZZ, id = 245 */
# define VodiK_LT4_PLATE _VODI_MAKE_PLATEID_LT(_VodiK_PCODE_LT4)
# define _VodiK_PCODE_LT4 4

/* mask = ZXXXXXX, id = 246 */
# define VodiK_LT5_PLATE _VODI_MAKE_PLATEID_LT(_VodiK_PCODE_LT5)
# define _VodiK_PCODE_LT5 5

/* mask = XXXXXX, id = 247 */
# define VodiK_LT6_PLATE _VODI_MAKE_PLATEID_LT(_VodiK_PCODE_LT6)
# define _VodiK_PCODE_LT6 6

/* mask = ZZXXXZ, id = 248 */
# define VodiK_LT7_PLATE _VODI_MAKE_PLATEID_LT(_VodiK_PCODE_LT7)
# define _VodiK_PCODE_LT7 7

/* mask = ZZZXXX, id = 1309, similar to 242 */
# define VodiK_LT8_PLATE _VODI_MAKE_PLATEID_LT(_VodiK_PCODE_LT8)
# define _VodiK_PCODE_LT8 8

/* mask = EVXXXX, id = 1672 */
# define VodiK_LT9_PLATE _VODI_MAKE_PLATEID_LT(_VodiK_PCODE_LT9)
# define _VodiK_PCODE_LT9 9

/* mask = HXXXXX, id = 1673 */
# define VodiK_LT10_PLATE _VODI_MAKE_PLATEID_LT(_VodiK_PCODE_LT10)
# define _VodiK_PCODE_LT10 10

/* mask = ZZXXXZ, id = 1872 */
# define VodiK_LT11_PLATE _VODI_MAKE_PLATEID_LT(_VodiK_PCODE_LT11)
# define _VodiK_PCODE_LT11 11

/* mask = zzxxxx, id = 1873 */
# define VodiK_LT12_PLATE _VODI_MAKE_PLATEID_LT(_VodiK_PCODE_LT12)
# define _VodiK_PCODE_LT12 12

/* mask = zxxxxx, id = 1874 */
# define VodiK_LT13_PLATE _VODI_MAKE_PLATEID_LT(_VodiK_PCODE_LT13)
# define _VodiK_PCODE_LT13 13

/* mask = zzxxx, id = 1875 */
# define VodiK_LT14_PLATE _VODI_MAKE_PLATEID_LT(_VodiK_PCODE_LT14)
# define _VodiK_PCODE_LT14 14
/* @} */


/*
* LU
* @{
*/
# define _VODI_MAKE_PLATEID_LU(aCode) _VODI_MAKE_PLATEID(VodiK_LUXEMBOURG_NUMERIC,aCode)

/* mask = zzxxxx, id = 817 */
# define VodiK_LU1_PLATE _VODI_MAKE_PLATEID_LU(_VodiK_PCODE_LU1)
# define _VodiK_PCODE_LU1 1

/* mask = zzxxx, id = 819 */
# define VodiK_LU2_PLATE _VODI_MAKE_PLATEID_LU(_VodiK_PCODE_LU2)
# define _VodiK_PCODE_LU2 2

/* mask = zzxxxx, id = 821 */
# define VodiK_LU3_PLATE _VODI_MAKE_PLATEID_LU(_VodiK_PCODE_LU3)
# define _VodiK_PCODE_LU3 3

/* mask = zzxx, id = 823 */
# define VodiK_LU4_PLATE _VODI_MAKE_PLATEID_LU(_VodiK_PCODE_LU4)
# define _VodiK_PCODE_LU4 4

/* mask = xxxxx, id = 818 */
# define VodiK_LU5_PLATE _VODI_MAKE_PLATEID_LU(_VodiK_PCODE_LU5)
# define _VodiK_PCODE_LU5 5

/* mask = xx, id = 822 */
# define VodiK_LU7_PLATE _VODI_MAKE_PLATEID_LU(_VodiK_PCODE_LU7)
# define _VodiK_PCODE_LU7 7

/* mask = xxxx, id = 1734 */
# define VodiK_LU8_PLATE _VODI_MAKE_PLATEID_LU(_VodiK_PCODE_LU8)
# define _VodiK_PCODE_LU8 8

/* mask = xx, id = 1735 */
# define VodiK_LU9_PLATE _VODI_MAKE_PLATEID_LU(_VodiK_PCODE_LU9)
# define _VodiK_PCODE_LU9 9

/* mask = ZXXXX, id = 2075 */
# define VodiK_LU10_PLATE _VODI_MAKE_PLATEID_LU(_VodiK_PCODE_LU10)
# define _VodiK_PCODE_LU10 10
/* @} */


/*
* LV
* @{
*/
# define _VODI_MAKE_PLATEID_LV(aCode) _VODI_MAKE_PLATEID(VodiK_LATVIA_NUMERIC,aCode)

/* mask = ZZXX, id = 187 */
# define VodiK_LV1_PLATE _VODI_MAKE_PLATEID_LV(_VodiK_PCODE_LV1)
# define _VodiK_PCODE_LV1 1

/* mask = ZZXX, id = 188 */
# define VodiK_LV2_PLATE _VODI_MAKE_PLATEID_LV(_VodiK_PCODE_LV2)
# define _VodiK_PCODE_LV2 2

/* mask = ZZXXX, id = 189 */
# define VodiK_LV3_PLATE _VODI_MAKE_PLATEID_LV(_VodiK_PCODE_LV3)
# define _VodiK_PCODE_LV3 3

/* mask = ZZXXXX, id = 190 */
# define VodiK_LV4_PLATE _VODI_MAKE_PLATEID_LV(_VodiK_PCODE_LV4)
# define _VodiK_PCODE_LV4 4

/* mask = ZZXXXX, id = 191 */
# define VodiK_LV5_PLATE _VODI_MAKE_PLATEID_LV(_VodiK_PCODE_LV5)
# define _VodiK_PCODE_LV5 5

/* mask = ZXXXX, id = 192 */
# define VodiK_LV6_PLATE _VODI_MAKE_PLATEID_LV(_VodiK_PCODE_LV6)
# define _VodiK_PCODE_LV6 6

/* mask = ZZX, id = 193 */
# define VodiK_LV7_PLATE _VODI_MAKE_PLATEID_LV(_VodiK_PCODE_LV7)
# define _VodiK_PCODE_LV7 7

/* mask = ZZX, id = 194 */
# define VodiK_LV8_PLATE _VODI_MAKE_PLATEID_LV(_VodiK_PCODE_LV8)
# define _VodiK_PCODE_LV8 8

/* mask = ZZXXXX, id = 194 */
# define VodiK_LV9_PLATE _VODI_MAKE_PLATEID_LV(_VodiK_PCODE_LV9)
# define _VodiK_PCODE_LV9 9

/* mask = ZZXXX, id = 1659 */
# define VodiK_LV10_PLATE _VODI_MAKE_PLATEID_LV(_VodiK_PCODE_LV10)
# define _VodiK_PCODE_LV10 10

/* mask = ZXXX, id = 1660 */
# define VodiK_LV11_PLATE _VODI_MAKE_PLATEID_LV(_VodiK_PCODE_LV11)
# define _VodiK_PCODE_LV11 11

/* mask = ZZXXXXX, id = 1661 */
# define VodiK_LV12_PLATE _VODI_MAKE_PLATEID_LV(_VodiK_PCODE_LV12)
# define _VodiK_PCODE_LV12 12

/* mask = zzxxxx, id = 1876 */
# define VodiK_LV13_PLATE _VODI_MAKE_PLATEID_LV(_VodiK_PCODE_LV13)
# define _VodiK_PCODE_LV13 13

/* mask = zxxxx, id = 1877 */
# define VodiK_LV14_PLATE _VODI_MAKE_PLATEID_LV(_VodiK_PCODE_LV14)
# define _VodiK_PCODE_LV14 14

/* mask = zxxx, id = 1878 */
# define VodiK_LV15_PLATE _VODI_MAKE_PLATEID_LV(_VodiK_PCODE_LV15)
# define _VodiK_PCODE_LV15 15

/* mask = zxxx, id = 1879 */
# define VodiK_LV16_PLATE _VODI_MAKE_PLATEID_LV(_VodiK_PCODE_LV16)
# define _VodiK_PCODE_LV16 16

/* mask = zxx, id = 1880 */
# define VodiK_LV17_PLATE _VODI_MAKE_PLATEID_LV(_VodiK_PCODE_LV17)
# define _VodiK_PCODE_LV17 17

/* mask = zxxxx, id = 1881 */
# define VodiK_LV18_PLATE _VODI_MAKE_PLATEID_LV(_VodiK_PCODE_LV18)
# define _VodiK_PCODE_LV18 18

/* mask = zzxx, id = 2304 */
# define VodiK_LV19_PLATE _VODI_MAKE_PLATEID_LV(_VodiK_PCODE_LV19)
# define _VodiK_PCODE_LV19 19
/* @} */


/*
 * MC
 * @{
 */
# define _VODI_MAKE_PLATEID_MC(aCode) _VODI_MAKE_PLATEID(VodiK_MONACO_NUMERIC,aCode)

/* mask = xxxz, id = 2081 */
# define VodiK_MC1_PLATE _VODI_MAKE_PLATEID_MC(_VodiK_PCODE_MC1)
# define _VodiK_PCODE_MC1 1

/* mask = xxxx, id = 2082 */
# define VodiK_MC2_PLATE _VODI_MAKE_PLATEID_MC(_VodiK_PCODE_MC2)
# define _VodiK_PCODE_MC2 2

/* mask = zxxx, id = 2083 */
# define VodiK_MC3_PLATE _VODI_MAKE_PLATEID_MC(_VodiK_PCODE_MC3)
# define _VodiK_PCODE_MC3 3

/* mask = xzxx, id = 2084 */
# define VodiK_MC4_PLATE _VODI_MAKE_PLATEID_MC(_VodiK_PCODE_MC4)
# define _VodiK_PCODE_MC4 4

/* mask = xzzx, id = 2085 */
# define VodiK_MC5_PLATE _VODI_MAKE_PLATEID_MC(_VodiK_PCODE_MC5)
# define _VodiK_PCODE_MC5 5

/* mask = zzxz, id = 2086 */
# define VodiK_MC6_PLATE _VODI_MAKE_PLATEID_MC(_VodiK_PCODE_MC6)
# define _VodiK_PCODE_MC6 6

/* mask = zzxx, id = 2087 */
# define VodiK_MC7_PLATE _VODI_MAKE_PLATEID_MC(_VodiK_PCODE_MC7)
# define _VodiK_PCODE_MC7 7

/* mask = xxxxzzzz, id = 2088 */
# define VodiK_MC8_PLATE _VODI_MAKE_PLATEID_MC(_VodiK_PCODE_MC8)
# define _VodiK_PCODE_MC8 8
/* @} */


/*
* MD
* @{
*/
# define _VODI_MAKE_PLATEID_MD(aCode) _VODI_MAKE_PLATEID(VodiK_MOLDOVA_NUMERIC,aCode)

/* mask = ZZZXXX, id = 205 */
# define VodiK_MD1_PLATE _VODI_MAKE_PLATEID_MD(_VodiK_PCODE_MD1)
# define _VodiK_PCODE_MD1 1

/* mask = ZZZZXXX, id = 206 */
# define VodiK_MD2_PLATE _VODI_MAKE_PLATEID_MD(_VodiK_PCODE_MD2)
# define _VodiK_PCODE_MD2 2

/* mask = ZZXXXZZ, id = 207 */
# define VodiK_MD3_PLATE _VODI_MAKE_PLATEID_MD(_VodiK_PCODE_MD3)
# define _VodiK_PCODE_MD3 3

/* mask = ZZZXXXX, id = 208 */
# define VodiK_MD4_PLATE _VODI_MAKE_PLATEID_MD(_VodiK_PCODE_MD4)
# define _VodiK_PCODE_MD4 4

/* mask = ZZXXXX, id = 209 */
# define VodiK_MD5_PLATE _VODI_MAKE_PLATEID_MD(_VodiK_PCODE_MD5)
# define _VodiK_PCODE_MD5 5

/* mask = ZXXXX, id = 210 */
# define VodiK_MD6_PLATE _VODI_MAKE_PLATEID_MD(_VodiK_PCODE_MD6)
# define _VodiK_PCODE_MD6 6

/* mask = ZzXXXz, id = 211 */
# define VodiK_MD7_PLATE _VODI_MAKE_PLATEID_MD(_VodiK_PCODE_MD7)
# define _VodiK_PCODE_MD7 7

/* mask = ZZXXXX, id = 212 */
# define VodiK_MD8_PLATE _VODI_MAKE_PLATEID_MD(_VodiK_PCODE_MD8)
# define _VodiK_PCODE_MD8 8

/* mask = ZZXXX, id = 213 */
# define VodiK_MD9_PLATE _VODI_MAKE_PLATEID_MD(_VodiK_PCODE_MD9)
# define _VodiK_PCODE_MD9 9

/* mask = ZXXXZZ, id = 214 */
# define VodiK_MD10_PLATE _VODI_MAKE_PLATEID_MD(_VodiK_PCODE_MD10)
# define _VodiK_PCODE_MD10 10

/* mask = ZZZXXX, id = 1288, two row */
# define VodiK_MD11_PLATE _VODI_MAKE_PLATEID_MD(_VodiK_PCODE_MD11)
# define _VodiK_PCODE_MD11 11

/* mask = ZZZZXXX, id = 1289, two row */
# define VodiK_MD12_PLATE _VODI_MAKE_PLATEID_MD(_VodiK_PCODE_MD12)
# define _VodiK_PCODE_MD12 12

/* mask = XXXZZZ, id = 1290, two row */
# define VodiK_MD13_PLATE _VODI_MAKE_PLATEID_MD(_VodiK_PCODE_MD13)
# define _VodiK_PCODE_MD13 13

/* mask = XXXZZZZ, id = 1291, two row */
# define VodiK_MD14_PLATE _VODI_MAKE_PLATEID_MD(_VodiK_PCODE_MD14)
# define _VodiK_PCODE_MD14 14

/* mask = ZZZZXXX, id = 1302, similar to 214 */
# define VodiK_MD15_PLATE _VODI_MAKE_PLATEID_MD(_VodiK_PCODE_MD15)
# define _VodiK_PCODE_MD15 15

/* mask = ZZXXXZZ, id = 1303, With fake I on first position */
# define VodiK_MD16_PLATE _VODI_MAKE_PLATEID_MD(_VodiK_PCODE_MD16)
# define _VodiK_PCODE_MD16 16

/* mask = ZZZXX, id = 1304 */
# define VodiK_MD17_PLATE _VODI_MAKE_PLATEID_MD(_VodiK_PCODE_MD17)
# define _VodiK_PCODE_MD17 17

/* mask = XXXZZZ, id = 1305, two row */
# define VodiK_MD18_PLATE _VODI_MAKE_PLATEID_MD(_VodiK_PCODE_MD18)
# define _VodiK_PCODE_MD18 18

/* mask = ZZZXXX, id = 1306, two row */
# define VodiK_MD19_PLATE _VODI_MAKE_PLATEID_MD(_VodiK_PCODE_MD19)
# define _VodiK_PCODE_MD19 19

/* mask = ZZZXXX, id = 1307 */
# define VodiK_MD20_PLATE _VODI_MAKE_PLATEID_MD(_VodiK_PCODE_MD20)
# define _VodiK_PCODE_MD20 20

/* mask = ZZZX, id = 1308 */
# define VodiK_MD21_PLATE _VODI_MAKE_PLATEID_MD(_VodiK_PCODE_MD21)
# define _VodiK_PCODE_MD21 21

/* mask = ZzXXXz, id = 1765 */
# define VodiK_MD22_PLATE _VODI_MAKE_PLATEID_MD(_VodiK_PCODE_MD22)
# define _VodiK_PCODE_MD22 22

/* mask = ZZXXXX, id = 1766 */
# define VodiK_MD23_PLATE _VODI_MAKE_PLATEID_MD(_VodiK_PCODE_MD23)
# define _VodiK_PCODE_MD23 23

/* mask = ZZXXX, id = 1767 */
# define VodiK_MD24_PLATE _VODI_MAKE_PLATEID_MD(_VodiK_PCODE_MD24)
# define _VodiK_PCODE_MD24 24

/* mask = ZXXXZZ, id = 1768 */
# define VodiK_MD25_PLATE _VODI_MAKE_PLATEID_MD(_VodiK_PCODE_MD25)
# define _VodiK_PCODE_MD25 25
/* @} */


/*
* ME
* @{
*/
# define _VODI_MAKE_PLATEID_ME(aCode) _VODI_MAKE_PLATEID(VodiK_MONTENEGRO_NUMERIC,aCode)

/* mask = zzzzxxx, id = 847 */
# define VodiK_ME1_PLATE _VODI_MAKE_PLATEID_ME(_VodiK_PCODE_ME1)
# define _VodiK_PCODE_ME1 1

/* mask = zzzzxxx, id = 1742 */
# define VodiK_ME2_PLATE _VODI_MAKE_PLATEID_ME(_VodiK_PCODE_ME2)
# define _VodiK_PCODE_ME2 2

/* mask = zzxxxzz, id = 1743 */
# define VodiK_ME3_PLATE _VODI_MAKE_PLATEID_ME(_VodiK_PCODE_ME3)
# define _VodiK_PCODE_ME3 3

/* mask = zzzxx, id = 1744 */
# define VodiK_ME4_PLATE _VODI_MAKE_PLATEID_ME(_VodiK_PCODE_ME4)
# define _VodiK_PCODE_ME4 4

/* mask = xxxzxxx, id = 1745 */
# define VodiK_ME5_PLATE _VODI_MAKE_PLATEID_ME(_VodiK_PCODE_ME5)
# define _VodiK_PCODE_ME5 5

/* mask = xxzxxx, id = 1746 */
# define VodiK_ME6_PLATE _VODI_MAKE_PLATEID_ME(_VodiK_PCODE_ME6)
# define _VodiK_PCODE_ME6 6

/* mask = zzzzxx, id = 1747 */
# define VodiK_ME7_PLATE _VODI_MAKE_PLATEID_ME(_VodiK_PCODE_ME7)
# define _VodiK_PCODE_ME7 7

/* mask = zzzxxx, id = 1748 */
# define VodiK_ME8_PLATE _VODI_MAKE_PLATEID_ME(_VodiK_PCODE_ME8)
# define _VodiK_PCODE_ME8 8
/* @} */


/*
 * MG
 * @{
 */
# define _VODI_MAKE_PLATEID_MG(aCode) _VODI_MAKE_PLATEID(VodiK_MADAGASCAR_NUMERIC,aCode)

/* mask = xxxxzzz, id = 1968 */
# define VodiK_MG1_PLATE _VODI_MAKE_PLATEID_MG(_VodiK_PCODE_MG1)
# define _VodiK_PCODE_MG1 1

/* mask = xxxxzz, id = 1969 */
# define VodiK_MG2_PLATE _VODI_MAKE_PLATEID_MG(_VodiK_PCODE_MG2)
# define _VodiK_PCODE_MG2 2

/* mask = xxxxzzz, id = 1970 */
# define VodiK_MG3_PLATE _VODI_MAKE_PLATEID_MG(_VodiK_PCODE_MG3)
# define _VodiK_PCODE_MG3 3

/* mask = xxxxzz, id = 1971 */
# define VodiK_MG4_PLATE _VODI_MAKE_PLATEID_MG(_VodiK_PCODE_MG4)
# define _VodiK_PCODE_MG4 4

/* mask = xxxxxzzz, id = 2004 */
# define VodiK_MG5_PLATE _VODI_MAKE_PLATEID_MG(_VodiK_PCODE_MG5)
# define _VodiK_PCODE_MG5 5

/* mask = xxxxzz, id = 2005 */
# define VodiK_MG6_PLATE _VODI_MAKE_PLATEID_MG(_VodiK_PCODE_MG6)
# define _VodiK_PCODE_MG6 6

/* mask = xxxxzzz, id = 2006 */
# define VodiK_MG7_PLATE _VODI_MAKE_PLATEID_MG(_VodiK_PCODE_MG7)
# define _VodiK_PCODE_MG7 7

/* mask = xxxxxzzz, id = 2007 */
# define VodiK_MG8_PLATE _VODI_MAKE_PLATEID_MG(_VodiK_PCODE_MG8)
# define _VodiK_PCODE_MG8 8
/* @} */


/*
* MK
* @{
*/
# define _VODI_MAKE_PLATEID_MK(aCode) _VODI_MAKE_PLATEID(VodiK_MACEDONIA_NUMERIC,aCode)

/* mask = ZZXXXZZ, id = 459 */
# define VodiK_MK1_PLATE _VODI_MAKE_PLATEID_MK(_VodiK_PCODE_MK1)
# define _VodiK_PCODE_MK1 1

/* mask = zzxxxxzz, id = 1693 */
# define VodiK_MK2_PLATE _VODI_MAKE_PLATEID_MK(_VodiK_PCODE_MK2)
# define _VodiK_PCODE_MK2 2

/* mask = zzxxxxzz, id = 1694 */
# define VodiK_MK3_PLATE _VODI_MAKE_PLATEID_MK(_VodiK_PCODE_MK3)
# define _VodiK_PCODE_MK3 3

/* mask = zzxxxxzz, id = 1695 */
# define VodiK_MK4_PLATE _VODI_MAKE_PLATEID_MK(_VodiK_PCODE_MK4)
# define _VodiK_PCODE_MK4 4

/* mask = xxxzzxxx, id = 1696 */
# define VodiK_MK5_PLATE _VODI_MAKE_PLATEID_MK(_VodiK_PCODE_MK5)
# define _VodiK_PCODE_MK5 5

/* mask = xxzzxxx, id = 1697 */
# define VodiK_MK6_PLATE _VODI_MAKE_PLATEID_MK(_VodiK_PCODE_MK6)
# define _VodiK_PCODE_MK6 6

/* mask = xxzxxx, id = 1698 */
# define VodiK_MK7_PLATE _VODI_MAKE_PLATEID_MK(_VodiK_PCODE_MK7)
# define _VodiK_PCODE_MK7 7

/* mask = xxzxxx, id = 1699 */
# define VodiK_MK8_PLATE _VODI_MAKE_PLATEID_MK(_VodiK_PCODE_MK8)
# define _VodiK_PCODE_MK8 8

/* mask = xxzxxx, id = 1882 */
# define VodiK_MK9_PLATE _VODI_MAKE_PLATEID_MK(_VodiK_PCODE_MK9)
# define _VodiK_PCODE_MK9 9
/* @} */


/*
 * MN
 * @{
 */
# define _VODI_MAKE_PLATEID_MN(aCode) _VODI_MAKE_PLATEID(VodiK_MONGOLIA_NUMERIC,aCode)

/* mask = XXXXZZZ, id = 476 */
# define VodiK_MN1_PLATE _VODI_MAKE_PLATEID_MN(_VodiK_PCODE_MN1)
# define _VodiK_PCODE_MN1 1

/* mask = ZXXXXZZ, id = 477 */
# define VodiK_MN2_PLATE _VODI_MAKE_PLATEID_MN(_VodiK_PCODE_MN2)
# define _VodiK_PCODE_MN2 2

/* mask = XXXXZZZ, id = 478 */
# define VodiK_MN3_PLATE _VODI_MAKE_PLATEID_MN(_VodiK_PCODE_MN3)
# define _VodiK_PCODE_MN3 3

/* mask = xxxxzzz, id = 1229 */
# define VodiK_MN4_PLATE _VODI_MAKE_PLATEID_MN(_VodiK_PCODE_MN4)
# define _VodiK_PCODE_MN4 4

/* mask = xxxxzz, id = 1236 */
# define VodiK_MN5_PLATE _VODI_MAKE_PLATEID_MN(_VodiK_PCODE_MN5)
# define _VodiK_PCODE_MN5 5

/* mask = XXXXzz, id = 1942 */
# define VodiK_MN6_PLATE _VODI_MAKE_PLATEID_MN(_VodiK_PCODE_MN6)
# define _VodiK_PCODE_MN6 6

/* mask = ZZXXXX, id = 1236 */
# define VodiK_MN7_PLATE _VODI_MAKE_PLATEID_MN(_VodiK_PCODE_MN7)
# define _VodiK_PCODE_MN7 7
/* @} */


/*
* MM
* @{
*/
# define _VODI_MAKE_PLATEID_MM(aCode) _VODI_MAKE_PLATEID(VodiK_MYANMAR_NUMERIC,aCode)

/* mask = XXXXZZZ, id = 2264 */
# define VodiK_MM1_PLATE _VODI_MAKE_PLATEID_MM(_VodiK_PCODE_MM1)
# define _VodiK_PCODE_MM1 1

/* mask = XXXXZZZ, id = 2265 */
# define VodiK_MM2_PLATE _VODI_MAKE_PLATEID_MM(_VodiK_PCODE_MM2)
# define _VodiK_PCODE_MM2 2

/* mask = XXXXZZZ, id = 2266 */
# define VodiK_MM3_PLATE _VODI_MAKE_PLATEID_MM(_VodiK_PCODE_MM3)
# define _VodiK_PCODE_MM3 3
/* @} */


/*
* MT
* @{
*/
# define _VODI_MAKE_PLATEID_MT(aCode) _VODI_MAKE_PLATEID(VodiK_MALTA_NUMERIC,aCode)

/* mask = zzzxxx, id = 545 */
# define VodiK_MT1_PLATE _VODI_MAKE_PLATEID_MT(_VodiK_PCODE_MT1)
# define _VodiK_PCODE_MT1 1

/* mask = zzxx, id = 546 */
# define VodiK_MT2_PLATE _VODI_MAKE_PLATEID_MT(_VodiK_PCODE_MT2)
# define _VodiK_PCODE_MT2 2

/* mask = zzzzxxx, id = 547 */
# define VodiK_MT3_PLATE _VODI_MAKE_PLATEID_MT(_VodiK_PCODE_MT3)
# define _VodiK_PCODE_MT3 3

/* mask = zzxx, id = 1736 */
# define VodiK_MT4_PLATE _VODI_MAKE_PLATEID_MT(_VodiK_PCODE_MT4)
# define _VodiK_PCODE_MT4 4

/* mask = zzzzxxx, id = 1737 */
# define VodiK_MT5_PLATE _VODI_MAKE_PLATEID_MT(_VodiK_PCODE_MT5)
# define _VodiK_PCODE_MT5 5

/* mask = zzzzxxxz, id = 1738 */
# define VodiK_MT6_PLATE _VODI_MAKE_PLATEID_MT(_VodiK_PCODE_MT6)
# define _VodiK_PCODE_MT6 6

/* mask = zzzzxx, id = 1739 */
# define VodiK_MT7_PLATE _VODI_MAKE_PLATEID_MT(_VodiK_PCODE_MT7)
# define _VodiK_PCODE_MT7 7

/* mask = zzzzzzzzxxx, id = 1740 */
# define VodiK_MT8_PLATE _VODI_MAKE_PLATEID_MT(_VodiK_PCODE_MT8)
# define _VodiK_PCODE_MT8 8

/* mask = zzzzzzzxx, id = 1741 */
# define VodiK_MT9_PLATE _VODI_MAKE_PLATEID_MT(_VodiK_PCODE_MT9)
# define _VodiK_PCODE_MT9 9
/* @} */


/*
 * MX
 * @{
 */
# define _VODI_MAKE_PLATEID_MX(aCode) _VODI_MAKE_PLATEID(VodiK_MEXICO_NUMERIC,aCode)

/* mask = XXXZZZ, id = 50 */
# define VodiK_MX1_PLATE _VODI_MAKE_PLATEID_MX(_VodiK_PCODE_MX1)
# define _VodiK_PCODE_MX1 1

/* mask = ZXXXXX, id = 51 */
# define VodiK_MX2_PLATE _VODI_MAKE_PLATEID_MX(_VodiK_PCODE_MX2)
# define _VodiK_PCODE_MX2 2

/* mask = ZZZXXXX, id = 52 */
# define VodiK_MX3_PLATE _VODI_MAKE_PLATEID_MX(_VodiK_PCODE_MX3)
# define _VodiK_PCODE_MX3 3

/* mask = XXXZZX, id = 53 */
# define VodiK_MX4_PLATE _VODI_MAKE_PLATEID_MX(_VodiK_PCODE_MX4)
# define _VodiK_PCODE_MX4 4

/* mask = XXXXZZ, id = 54 */
# define VodiK_MX5_PLATE _VODI_MAKE_PLATEID_MX(_VodiK_PCODE_MX5)
# define _VodiK_PCODE_MX5 5

/* mask = XXXXZZZ, id = 75 */
# define VodiK_MX6_PLATE _VODI_MAKE_PLATEID_MX(_VodiK_PCODE_MX6)
# define _VodiK_PCODE_MX6 6

/* mask = ZZXXXXX, id = 76 */
# define VodiK_MX7_PLATE _VODI_MAKE_PLATEID_MX(_VodiK_PCODE_MX7)
# define _VodiK_PCODE_MX7 7

/* mask = XXXXXXZ, id = 77 */
# define VodiK_MX8_PLATE _VODI_MAKE_PLATEID_MX(_VodiK_PCODE_MX8)
# define _VodiK_PCODE_MX8 8

/* mask = XXXZZZX, id = 78 */
# define VodiK_MX9_PLATE _VODI_MAKE_PLATEID_MX(_VodiK_PCODE_MX9)
# define _VodiK_PCODE_MX9 9

/* mask = XXXXXXZ, id = 79 */
# define VodiK_MX10_PLATE _VODI_MAKE_PLATEID_MX(_VodiK_PCODE_MX10)
# define _VodiK_PCODE_MX10 10

/* mask = ZZZXXXX, id = 80 */
# define VodiK_MX11_PLATE _VODI_MAKE_PLATEID_MX(_VodiK_PCODE_MX11)
# define _VodiK_PCODE_MX11 11

/* mask = ZZXXXX, id = 81 */
# define VodiK_MX12_PLATE _VODI_MAKE_PLATEID_MX(_VodiK_PCODE_MX12)
# define _VodiK_PCODE_MX12 12

/* mask = XXZZXZ, id = 1379 */
# define VodiK_MX13_PLATE _VODI_MAKE_PLATEID_MX(_VodiK_PCODE_MX13)
# define _VodiK_PCODE_MX13 13

/* mask = ZZZXXXZ, id = 1380 */
# define VodiK_MX14_PLATE _VODI_MAKE_PLATEID_MX(_VodiK_PCODE_MX14)
# define _VodiK_PCODE_MX14 14

/* mask = ZXXZZZ, id = 1382 */
# define VodiK_MX16_PLATE _VODI_MAKE_PLATEID_MX(_VodiK_PCODE_MX16)
# define _VodiK_PCODE_MX16 16

/* mask = XZZZXX, id = 1384 */
# define VodiK_MX18_PLATE _VODI_MAKE_PLATEID_MX(_VodiK_PCODE_MX18)
# define _VodiK_PCODE_MX18 18

/* mask = XXXXXXX, id = 1385 */
# define VodiK_MX19_PLATE _VODI_MAKE_PLATEID_MX(_VodiK_PCODE_MX19)
# define _VodiK_PCODE_MX19 19

/* mask = XXXZZXXX, id = 1386 */
# define VodiK_MX20_PLATE _VODI_MAKE_PLATEID_MX(_VodiK_PCODE_MX20)
# define _VodiK_PCODE_MX20 20

/* mask = XXXXXX, id = 1387 */
# define VodiK_MX21_PLATE _VODI_MAKE_PLATEID_MX(_VodiK_PCODE_MX21)
# define _VodiK_PCODE_MX21 21

/* mask = XZZZXXX, id = 1388 */
# define VodiK_MX22_PLATE _VODI_MAKE_PLATEID_MX(_VodiK_PCODE_MX22)
# define _VodiK_PCODE_MX22 22

/* mask = ZZXXXXZ, id = 1389 */
# define VodiK_MX23_PLATE _VODI_MAKE_PLATEID_MX(_VodiK_PCODE_MX23)
# define _VodiK_PCODE_MX23 23

/* mask = ZZZXX, id = 1390 */
# define VodiK_MX24_PLATE _VODI_MAKE_PLATEID_MX(_VodiK_PCODE_MX24)
# define _VodiK_PCODE_MX24 24

/* mask = XZZXXX, id = 1391 */
# define VodiK_MX25_PLATE _VODI_MAKE_PLATEID_MX(_VodiK_PCODE_MX25)
# define _VodiK_PCODE_MX25 25

/* mask = ZXXXX, id = 1392 */
# define VodiK_MX26_PLATE _VODI_MAKE_PLATEID_MX(_VodiK_PCODE_MX26)
# define _VodiK_PCODE_MX26 26

/* mask = XZZXXXX, id = 1393 */
# define VodiK_MX27_PLATE _VODI_MAKE_PLATEID_MX(_VodiK_PCODE_MX27)
# define _VodiK_PCODE_MX27 27

/* mask = XXXXZZ, id = 1394 */
# define VodiK_MX28_PLATE _VODI_MAKE_PLATEID_MX(_VodiK_PCODE_MX28)
# define _VodiK_PCODE_MX28 28

/* mask = XXXXXX, id = 1395 */
# define VodiK_MX29_PLATE _VODI_MAKE_PLATEID_MX(_VodiK_PCODE_MX29)
# define _VodiK_PCODE_MX29 29

/* mask = ZZXXXX, id = 1396 */
# define VodiK_MX30_PLATE _VODI_MAKE_PLATEID_MX(_VodiK_PCODE_MX30)
# define _VodiK_PCODE_MX30 30

/* mask = ZZZXXX, id = 1397 */
# define VodiK_MX31_PLATE _VODI_MAKE_PLATEID_MX(_VodiK_PCODE_MX31)
# define _VodiK_PCODE_MX31 31

/* mask = XZZXX, id = 1398 */
# define VodiK_MX32_PLATE _VODI_MAKE_PLATEID_MX(_VodiK_PCODE_MX32)
# define _VodiK_PCODE_MX32 32

/* mask = ZXXZZZX, id = 1951 */
# define VodiK_MX33_PLATE _VODI_MAKE_PLATEID_MX(_VodiK_PCODE_MX33)
# define _VodiK_PCODE_MX33 33

/* mask = ZXXXX, id = 1952 */
# define VodiK_MX34_PLATE _VODI_MAKE_PLATEID_MX(_VodiK_PCODE_MX34)
# define _VodiK_PCODE_MX34 34

/* mask = XXXZZ, id = 1953 */
# define VodiK_MX35_PLATE _VODI_MAKE_PLATEID_MX(_VodiK_PCODE_MX35)
# define _VodiK_PCODE_MX35 35

/* mask = ZZZXXXZ, id = 1954 */
# define VodiK_MX36_PLATE _VODI_MAKE_PLATEID_MX(_VodiK_PCODE_MX36)
# define _VodiK_PCODE_MX36 36

/* mask = ZXXXZZZ, id = 2021 */
# define VodiK_MX37_PLATE _VODI_MAKE_PLATEID_MX(_VodiK_PCODE_MX37)
# define _VodiK_PCODE_MX37 37
/* @} */


/*
* MY
* @{
*/
# define _VODI_MAKE_PLATEID_MY(aCode) _VODI_MAKE_PLATEID(VodiK_MALAYSIA_NUMERIC,aCode)

/* mask = ZZZXXXX, id = 495 */
# define VodiK_MY1_PLATE _VODI_MAKE_PLATEID_MY(_VodiK_PCODE_MY1)
# define _VodiK_PCODE_MY1 1

/* mask = ZZZXXX, id = 496 */
# define VodiK_MY2_PLATE _VODI_MAKE_PLATEID_MY(_VodiK_PCODE_MY2)
# define _VodiK_PCODE_MY2 2

/* mask = zzzxx, id = 1254 */
# define VodiK_MY3_PLATE _VODI_MAKE_PLATEID_MY(_VodiK_PCODE_MY3)
# define _VodiK_PCODE_MY3 3

/* mask = zxxxxz, id = 1255 */
# define VodiK_MY4_PLATE _VODI_MAKE_PLATEID_MY(_VodiK_PCODE_MY4)
# define _VodiK_PCODE_MY4 4

/* mask = zzzxxxx, id = 1253 */
# define VodiK_MY5_PLATE _VODI_MAKE_PLATEID_MY(_VodiK_PCODE_MY5)
# define _VodiK_PCODE_MY5 5

/* mask = zzxxxx, id = 1883 */
# define VodiK_MY6_PLATE _VODI_MAKE_PLATEID_MY(_VodiK_PCODE_MY6)
# define _VodiK_PCODE_MY6 6

/* mask = zzzxxxx, id = 1884 */
# define VodiK_MY7_PLATE _VODI_MAKE_PLATEID_MY(_VodiK_PCODE_MY7)
# define _VodiK_PCODE_MY7 7

/* mask = zzzxx, id = 1885 */
# define VodiK_MY8_PLATE _VODI_MAKE_PLATEID_MY(_VodiK_PCODE_MY8)
# define _VodiK_PCODE_MY8 8

/* mask = zzzxxxx, id = 1886 */
# define VodiK_MY9_PLATE _VODI_MAKE_PLATEID_MY(_VodiK_PCODE_MY9)
# define _VodiK_PCODE_MY9 9

/* mask = zzzxxx, id = 2330 */
# define VodiK_MY10_PLATE _VODI_MAKE_PLATEID_MY(_VodiK_PCODE_MY10)
# define _VodiK_PCODE_MY10 10

/* mask = zxxxx, id = 2331 */
# define VodiK_MY11_PLATE _VODI_MAKE_PLATEID_MY(_VodiK_PCODE_MY11)
# define _VodiK_PCODE_MY11 11

/* mask = zzxx, id = 2332 */
# define VodiK_MY12_PLATE _VODI_MAKE_PLATEID_MY(_VodiK_PCODE_MY12)
# define _VodiK_PCODE_MY12 12

/* mask = zzxxxz, id = 2333 */
# define VodiK_MY13_PLATE _VODI_MAKE_PLATEID_MY(_VodiK_PCODE_MY13)
# define _VodiK_PCODE_MY13 13

/* mask = zzxxx, id = 2334 */
# define VodiK_MY14_PLATE _VODI_MAKE_PLATEID_MY(_VodiK_PCODE_MY14)
# define _VodiK_PCODE_MY14 14

/* mask = zzxxxx, id = 2335 */
# define VodiK_MY15_PLATE _VODI_MAKE_PLATEID_MY(_VodiK_PCODE_MY15)
# define _VodiK_PCODE_MY15 15

/* mask = zzxxz, id = 2336 */
# define VodiK_MY16_PLATE _VODI_MAKE_PLATEID_MY(_VodiK_PCODE_MY16)
# define _VodiK_PCODE_MY16 16

/* mask = zzzx, id = 2337 */
# define VodiK_MY17_PLATE _VODI_MAKE_PLATEID_MY(_VodiK_PCODE_MY17)
# define _VodiK_PCODE_MY17 17

/* mask = zzxxxxz, id = 2338 */
# define VodiK_MY18_PLATE _VODI_MAKE_PLATEID_MY(_VodiK_PCODE_MY18)
# define _VodiK_PCODE_MY18 18

/* mask = zzzxxx, id = 2339 */
# define VodiK_MY19_PLATE _VODI_MAKE_PLATEID_MY(_VodiK_PCODE_MY19)
# define _VodiK_PCODE_MY19 19

/* mask = zzzx, id = 2340 */
# define VodiK_MY20_PLATE _VODI_MAKE_PLATEID_MY(_VodiK_PCODE_MY20)
# define _VodiK_PCODE_MY20 20

/* mask = zzzzxxxxz, id = 2341 */
# define VodiK_MY21_PLATE _VODI_MAKE_PLATEID_MY(_VodiK_PCODE_MY21)
# define _VodiK_PCODE_MY21 21

/* mask = xxxxzz, id = 2342 */
# define VodiK_MY22_PLATE _VODI_MAKE_PLATEID_MY(_VodiK_PCODE_MY22)
# define _VodiK_PCODE_MY22 22

/* mask = xxxxxzz, id = 2343 */
# define VodiK_MY23_PLATE _VODI_MAKE_PLATEID_MY(_VodiK_PCODE_MY23)
# define _VodiK_PCODE_MY23 23

/* mask = zzzxxxx, id = 2344 */
# define VodiK_MY24_PLATE _VODI_MAKE_PLATEID_MY(_VodiK_PCODE_MY24)
# define _VodiK_PCODE_MY24 24
/* @} */


/*
 * NG
 * @{
 */
# define _VODI_MAKE_PLATEID_NG(aCode) _VODI_MAKE_PLATEID(VodiK_NIGERIA_NUMERIC,aCode)

/* mask = ZZXXXZZZ, id = 380 */
# define VodiK_NG1_PLATE _VODI_MAKE_PLATEID_NG(_VodiK_PCODE_NG1)
# define _VodiK_PCODE_NG1 1

/* mask = ZZXXZZZ, id = 381 */
# define VodiK_NG2_PLATE _VODI_MAKE_PLATEID_NG(_VodiK_PCODE_NG2)
# define _VodiK_PCODE_NG2 2

/* mask = ZZXXZZZ, id = 2161 */
# define VodiK_NG3_PLATE _VODI_MAKE_PLATEID_NG(_VodiK_PCODE_NG3)
# define _VodiK_PCODE_NG3 3

/* mask = ZZXXZZZ, id = 2162 */
# define VodiK_NG4_PLATE _VODI_MAKE_PLATEID_NG(_VodiK_PCODE_NG4)
# define _VodiK_PCODE_NG4 4
/* @} */


/*
 * NI
 * @{
 */
# define _VODI_MAKE_PLATEID_NI(aCode) _VODI_MAKE_PLATEID(VodiK_NICARAGUA_NUMERIC,aCode)

/* mask = zzxxxx, id = 795 */
# define VodiK_NI1_PLATE _VODI_MAKE_PLATEID_NI(_VodiK_PCODE_NI1)
# define _VodiK_PCODE_NI1 1

/* mask = zzxxxxx, id = 796 */
# define VodiK_NI2_PLATE _VODI_MAKE_PLATEID_NI(_VodiK_PCODE_NI2)
# define _VodiK_PCODE_NI2 2

/* mask = zxxxxxx, id = 797 */
# define VodiK_NI3_PLATE _VODI_MAKE_PLATEID_NI(_VodiK_PCODE_NI3)
# define _VodiK_PCODE_NI3 3

/* mask = zzxxx, id = 1492 */
# define VodiK_NI4_PLATE _VODI_MAKE_PLATEID_NI(_VodiK_PCODE_NI4)
# define _VodiK_PCODE_NI4 4

/* mask = zxxxx, id = 1493 */
# define VodiK_NI5_PLATE _VODI_MAKE_PLATEID_NI(_VodiK_PCODE_NI5)
# define _VodiK_PCODE_NI5 5

/* mask = xxx, id = 1494 */
# define VodiK_NI6_PLATE _VODI_MAKE_PLATEID_NI(_VodiK_PCODE_NI6)
# define _VodiK_PCODE_NI6 6

/* mask = zzxxxx, id = 1496 */
# define VodiK_NI7_PLATE _VODI_MAKE_PLATEID_NI(_VodiK_PCODE_NI7)
# define _VodiK_PCODE_NI7 7

/* mask = zxxxxx, id = 1497 */
# define VodiK_NI8_PLATE _VODI_MAKE_PLATEID_NI(_VodiK_PCODE_NI8)
# define _VodiK_PCODE_NI8 8
/* @} */


/*
 * NL
 * @{
 */
# define _VODI_MAKE_PLATEID_NL(aCode) _VODI_MAKE_PLATEID(VodiK_NETHERLANDS_NUMERIC,aCode)

/* mask = XXZZZZ, id = 454 */
# define VodiK_NL1_PLATE _VODI_MAKE_PLATEID_NL(_VodiK_PCODE_NL1)
# define _VodiK_PCODE_NL1 1

/* mask = ZZZZXX, id = 455 */
# define VodiK_NL2_PLATE _VODI_MAKE_PLATEID_NL(_VodiK_PCODE_NL2)
# define _VodiK_PCODE_NL2 2

/* mask = XXZZZX, id = 456 */
# define VodiK_NL3_PLATE _VODI_MAKE_PLATEID_NL(_VodiK_PCODE_NL3)
# define _VodiK_PCODE_NL3 3

/* mask = xzzzxx, id = 554 */
# define VodiK_NL4_PLATE _VODI_MAKE_PLATEID_NL(_VodiK_PCODE_NL4)
# define _VodiK_PCODE_NL4 4

/* mask = zzxxxz, id = 1578 */
# define VodiK_NL5_PLATE _VODI_MAKE_PLATEID_NL(_VodiK_PCODE_NL5)
# define _VodiK_PCODE_NL5 5

/* mask = xzzzxx, id = 1579 */
# define VodiK_NL6_PLATE _VODI_MAKE_PLATEID_NL(_VodiK_PCODE_NL6)
# define _VodiK_PCODE_NL6 6

/* mask = zzxxxx, id = 1580 */
# define VodiK_NL7_PLATE _VODI_MAKE_PLATEID_NL(_VodiK_PCODE_NL7)
# define _VodiK_PCODE_NL7 7

/* mask = zzxxxx, id = 1581 */
# define VodiK_NL8_PLATE _VODI_MAKE_PLATEID_NL(_VodiK_PCODE_NL8)
# define _VodiK_PCODE_NL8 8

/* mask = xxzzzz, id = 1582 */
# define VodiK_NL9_PLATE _VODI_MAKE_PLATEID_NL(_VodiK_PCODE_NL9)
# define _VodiK_PCODE_NL9 9

/* mask = zzzzxx, id = 1583 */
# define VodiK_NL10_PLATE _VODI_MAKE_PLATEID_NL(_VodiK_PCODE_NL10)
# define _VodiK_PCODE_NL10 10

/* mask = zzxxxz, id = 1604 */
# define VodiK_NL11_PLATE _VODI_MAKE_PLATEID_NL(_VodiK_PCODE_NL11)
# define _VodiK_PCODE_NL11 11

/* mask = zzzzxx, id = 1605 */
# define VodiK_NL12_PLATE _VODI_MAKE_PLATEID_NL(_VodiK_PCODE_NL12)
# define _VodiK_PCODE_NL12 12

/* mask = ZZXXZZ, id = 1645 */
# define VodiK_NL13_PLATE _VODI_MAKE_PLATEID_NL(_VodiK_PCODE_NL13)
# define _VodiK_PCODE_NL13 13

/* mask = ZXXXZZ, id = 1646 */
# define VodiK_NL14_PLATE _VODI_MAKE_PLATEID_NL(_VodiK_PCODE_NL14)
# define _VodiK_PCODE_NL14 14

/* mask = XXZZXX, id = 1647 */
# define VodiK_NL15_PLATE _VODI_MAKE_PLATEID_NL(_VodiK_PCODE_NL15)
# define _VodiK_PCODE_NL15 15

/* mask = zxxxzz, id = 2076 */
# define VodiK_NL16_PLATE _VODI_MAKE_PLATEID_NL(_VodiK_PCODE_NL16)
# define _VodiK_PCODE_NL16 16

/* mask = xxxxzz, id = 2077 */
# define VodiK_NL17_PLATE _VODI_MAKE_PLATEID_NL(_VodiK_PCODE_NL17)
# define _VodiK_PCODE_NL17 17

/* mask = zzxxxx, id = 2078 */
# define VodiK_NL18_PLATE _VODI_MAKE_PLATEID_NL(_VodiK_PCODE_NL18)
# define _VodiK_PCODE_NL18 18

/* mask = zzxxxx, id = 2079 */
# define VodiK_NL19_PLATE _VODI_MAKE_PLATEID_NL(_VodiK_PCODE_NL19)
# define _VodiK_PCODE_NL19 19

/* mask = zzxxzzz, id = 2246 */
# define VodiK_NL20_PLATE _VODI_MAKE_PLATEID_NL(_VodiK_PCODE_NL20)
# define _VodiK_PCODE_NL20 20

/* mask = zzxxzzz, id = 2247 */
# define VodiK_NL21_PLATE _VODI_MAKE_PLATEID_NL(_VodiK_PCODE_NL21)
# define _VodiK_PCODE_NL21 21
/* @} */


/*
* NO
* @{
*/
# define _VODI_MAKE_PLATEID_NO(aCode) _VODI_MAKE_PLATEID(VodiK_NORWAY_NUMERIC,aCode)

/* mask = zzxxxxx, id = 528 */
# define VodiK_NO1_PLATE _VODI_MAKE_PLATEID_NO(_VodiK_PCODE_NO1)
# define _VodiK_PCODE_NO1 1

/* mask = xxxxx, id = 530 */
# define VodiK_NO2_PLATE _VODI_MAKE_PLATEID_NO(_VodiK_PCODE_NO2)
# define _VodiK_PCODE_NO2 2

/* mask = zzxxxxx, id = 531 */
# define VodiK_NO3_PLATE _VODI_MAKE_PLATEID_NO(_VodiK_PCODE_NO3)
# define _VodiK_PCODE_NO3 3

/* mask = zzxx, id = 529 */
# define VodiK_NO4_PLATE _VODI_MAKE_PLATEID_NO(_VodiK_PCODE_NO4)
# define _VodiK_PCODE_NO4 4

/* mask = ZZZXXXXX, id = 1681 */
# define VodiK_NO5_PLATE _VODI_MAKE_PLATEID_NO(_VodiK_PCODE_NO5)
# define _VodiK_PCODE_NO5 5

/* mask = ZZXXXX, id = 1887 */
# define VodiK_NO6_PLATE _VODI_MAKE_PLATEID_NO(_VodiK_PCODE_NO6)
# define _VodiK_PCODE_NO6 6

/* mask = zzxx, id = 2002 */
# define VodiK_NO7_PLATE _VODI_MAKE_PLATEID_NO(_VodiK_PCODE_NO7)
# define _VodiK_PCODE_NO7 7

/* mask = zzxx, id = 2003 */
# define VodiK_NO8_PLATE _VODI_MAKE_PLATEID_NO(_VodiK_PCODE_NO8)
# define _VodiK_PCODE_NO8 8
/* @} */


/*
 * NZ
 * @{
 */
# define _VODI_MAKE_PLATEID_NZ(aCode) _VODI_MAKE_PLATEID(VodiK_NEW_ZEALAND_NUMERIC,aCode)

/* mask = ZZZXXX, id = 460 */
# define VodiK_NZ1_PLATE _VODI_MAKE_PLATEID_NZ(_VodiK_PCODE_NZ1)
# define _VodiK_PCODE_NZ1 1

/* mask = ZZXXX, id = 461 */
# define VodiK_NZ2_PLATE _VODI_MAKE_PLATEID_NZ(_VodiK_PCODE_NZ2)
# define _VodiK_PCODE_NZ2 2

/* mask = ZZXXXX, id = 462 */
# define VodiK_NZ3_PLATE _VODI_MAKE_PLATEID_NZ(_VodiK_PCODE_NZ3)
# define _VodiK_PCODE_NZ3 3

/* mask = zzzxx, id = 1204 */
# define VodiK_NZ4_PLATE _VODI_MAKE_PLATEID_NZ(_VodiK_PCODE_NZ4)
# define _VodiK_PCODE_NZ4 4
/* @} */

/*
 * OM
 * @{
 */
# define _VODI_MAKE_PLATEID_OM(aCode) _VODI_MAKE_PLATEID(VodiK_OMAN_NUMERIC,aCode)

/* mask = XXXXZZ, id = 2153 */
# define VodiK_OM1_PLATE _VODI_MAKE_PLATEID_OM(_VodiK_PCODE_OM1)
# define _VodiK_PCODE_OM1 1

/* mask = XXXXZZ, id = 2154 */
# define VodiK_OM2_PLATE _VODI_MAKE_PLATEID_OM(_VodiK_PCODE_OM2)
# define _VodiK_PCODE_OM2 2

/* mask = XXXXXZ, id = 2155 */
# define VodiK_OM3_PLATE _VODI_MAKE_PLATEID_OM(_VodiK_PCODE_OM3)
# define _VodiK_PCODE_OM3 3

/* mask = XXXXZ, id = 2156 */
# define VodiK_OM4_PLATE _VODI_MAKE_PLATEID_OM(_VodiK_PCODE_OM4)
# define _VodiK_PCODE_OM4 4

/* mask = XXXXZ, id = 2157 */
# define VodiK_OM5_PLATE _VODI_MAKE_PLATEID_OM(_VodiK_PCODE_OM5)
# define _VodiK_PCODE_OM5 5

/* mask = XXXXZ, id = 2158 */
# define VodiK_OM6_PLATE _VODI_MAKE_PLATEID_OM(_VodiK_PCODE_OM6)
# define _VodiK_PCODE_OM6 6

/* mask = XXXXZ, id = 2159 */
# define VodiK_OM7_PLATE _VODI_MAKE_PLATEID_OM(_VodiK_PCODE_OM7)
# define _VodiK_PCODE_OM7 7

/* mask = XXXXZ, id = 2160 */
# define VodiK_OM8_PLATE _VODI_MAKE_PLATEID_OM(_VodiK_PCODE_OM8)
# define _VodiK_PCODE_OM8 8


/* mask = XXXXZ, id = 2163 */
# define VodiK_OM9_PLATE _VODI_MAKE_PLATEID_OM(_VodiK_PCODE_OM9)
# define _VodiK_PCODE_OM9 9


/* mask = XXXXZ, id = 2164 */
# define VodiK_OM10_PLATE _VODI_MAKE_PLATEID_OM(_VodiK_PCODE_OM10)
# define _VodiK_PCODE_OM10 10
/* @} */

/*
 * OS
 * @{
 */
# define _VODI_MAKE_PLATEID_OS(aCode) _VODI_MAKE_PLATEID(VodiK_OSSETIA_NUMERIC,aCode)

/* mask = zXXXzz, id = 110 */
# define VodiK_OS1_PLATE _VODI_MAKE_PLATEID_OS(_VodiK_PCODE_OS1)
# define _VodiK_PCODE_OS1 1

/* mask = zzXXXz, id = 111 */
# define VodiK_OS2_PLATE _VODI_MAKE_PLATEID_OS(_VodiK_PCODE_OS2)
# define _VodiK_PCODE_OS2 2

/* mask = XXXzzz, id = 112 */
# define VodiK_OS3_PLATE _VODI_MAKE_PLATEID_OS(_VodiK_PCODE_OS3)
# define _VodiK_PCODE_OS3 3

/* mask = XXXzz, id = 113 */
# define VodiK_OS4_PLATE _VODI_MAKE_PLATEID_OS(_VodiK_PCODE_OS4)
# define _VodiK_PCODE_OS4 4
/* @} */


/*
 * PA
 * @{
 */
# define _VODI_MAKE_PLATEID_PA(aCode) _VODI_MAKE_PLATEID(VodiK_PANAMA_NUMERIC,aCode)

/* mask = xxxxxx, id = 840 */
# define VodiK_PA1_PLATE _VODI_MAKE_PLATEID_PA(_VodiK_PCODE_PA1)
# define _VodiK_PCODE_PA1 1

/* mask = zzxxxx, id = 841 */
# define VodiK_PA2_PLATE _VODI_MAKE_PLATEID_PA(_VodiK_PCODE_PA2)
# define _VodiK_PCODE_PA2 2

/* mask = xzxxxx, id = 832 */
# define VodiK_PA3_PLATE _VODI_MAKE_PLATEID_PA(_VodiK_PCODE_PA3)
# define _VodiK_PCODE_PA3 3

/* mask = zxxxxx, id = 842 */
# define VodiK_PA4_PLATE _VODI_MAKE_PLATEID_PA(_VodiK_PCODE_PA4)
# define _VodiK_PCODE_PA4 4

/* mask = zzxxx, id = 843 */
# define VodiK_PA5_PLATE _VODI_MAKE_PLATEID_PA(_VodiK_PCODE_PA5)
# define _VodiK_PCODE_PA5 5

/* mask = zzxxx, id = 1488 */
# define VodiK_PA6_PLATE _VODI_MAKE_PLATEID_PA(_VodiK_PCODE_PA6)
# define _VodiK_PCODE_PA6 6

/* mask = zzxxxxx, id = 1489 */
# define VodiK_PA7_PLATE _VODI_MAKE_PLATEID_PA(_VodiK_PCODE_PA7)
# define _VodiK_PCODE_PA7 7

/* mask = zxxxxx, id = 1490 */
# define VodiK_PA8_PLATE _VODI_MAKE_PLATEID_PA(_VodiK_PCODE_PA8)
# define _VodiK_PCODE_PA8 8

/* mask = zzxxxx, id = 1527 */
# define VodiK_PA9_PLATE _VODI_MAKE_PLATEID_PA(_VodiK_PCODE_PA9)
# define _VodiK_PCODE_PA9 9
/* @} */


/*
 * PE
 * @{
 */
# define _VODI_MAKE_PLATEID_PE(aCode) _VODI_MAKE_PLATEID(VodiK_PERU_NUMERIC,aCode)

/* mask = zxzxxx, id = 758 */
# define VodiK_PE1_PLATE _VODI_MAKE_PLATEID_PE(_VodiK_PCODE_PE1)
# define _VodiK_PCODE_PE1 1

/* mask = zzzxxx, id = 761 */
# define VodiK_PE2_PLATE _VODI_MAKE_PLATEID_PE(_VodiK_PCODE_PE2)
# define _VodiK_PCODE_PE2 2

/* mask = zzzxxx, id = 759 */
# define VodiK_PE3_PLATE _VODI_MAKE_PLATEID_PE(_VodiK_PCODE_PE3)
# define _VodiK_PCODE_PE3 3

/* mask = zxxxxx, id = 762 */
# define VodiK_PE4_PLATE _VODI_MAKE_PLATEID_PE(_VodiK_PCODE_PE4)
# define _VodiK_PCODE_PE4 4

/* mask = zzzxxx, id = 760 */
# define VodiK_PE5_PLATE _VODI_MAKE_PLATEID_PE(_VodiK_PCODE_PE5)
# define _VodiK_PCODE_PE5 5

/* mask = zzxxxx, id = 1446 */
# define VodiK_PE8_PLATE _VODI_MAKE_PLATEID_PE(_VodiK_PCODE_PE8)
# define _VodiK_PCODE_PE8 8

/* mask = zzzxxx, id = 1447 */
# define VodiK_PE9_PLATE _VODI_MAKE_PLATEID_PE(_VodiK_PCODE_PE9)
# define _VodiK_PCODE_PE9 9

/* mask = zzzxxx, id = 1448 */
# define VodiK_PE10_PLATE _VODI_MAKE_PLATEID_PE(_VodiK_PCODE_PE10)
# define _VodiK_PCODE_PE10 10

/* mask = zzzxxx, id = 1449 */
# define VodiK_PE11_PLATE _VODI_MAKE_PLATEID_PE(_VodiK_PCODE_PE11)
# define _VodiK_PCODE_PE11 11

/* mask = zzzxxx, id = 1450 */
# define VodiK_PE12_PLATE _VODI_MAKE_PLATEID_PE(_VodiK_PCODE_PE12)
# define _VodiK_PCODE_PE12 12
/* @} */


/*
 * PH
 * @{
 */
# define _VODI_MAKE_PLATEID_PH(aCode) _VODI_MAKE_PLATEID(VodiK_PHILIPPINES_NUMERIC,aCode)

/* mask = zzzxxx, id = 1189 */
# define VodiK_PH1_PLATE _VODI_MAKE_PLATEID_PH(_VodiK_PCODE_PH1)
# define _VodiK_PCODE_PH1 1

/* mask = zzzxxx, id = 1190 */
# define VodiK_PH2_PLATE _VODI_MAKE_PLATEID_PH(_VodiK_PCODE_PH2)
# define _VodiK_PCODE_PH2 2

/* mask = xxxxx, id = 1197 */
# define VodiK_PH3_PLATE _VODI_MAKE_PLATEID_PH(_VodiK_PCODE_PH3)
# define _VodiK_PCODE_PH3 3

/* mask = zzxxxx, id = 1191 */
# define VodiK_PH4_PLATE _VODI_MAKE_PLATEID_PH(_VodiK_PCODE_PH4)
# define _VodiK_PCODE_PH4 4

/* mask = xxxxzz, id = 1262 */
# define VodiK_PH5_PLATE _VODI_MAKE_PLATEID_PH(_VodiK_PCODE_PH5)
# define _VodiK_PCODE_PH5 5

/* mask = zzzxxx, id = 1192 */
# define VodiK_PH6_PLATE _VODI_MAKE_PLATEID_PH(_VodiK_PCODE_PH6)
# define _VodiK_PCODE_PH6 6

/* mask = zzxxx, id = 1193 */
# define VodiK_PH7_PLATE _VODI_MAKE_PLATEID_PH(_VodiK_PCODE_PH7)
# define _VodiK_PCODE_PH7 7

/* mask = zxxxxx, id = 1194 */
# define VodiK_PH8_PLATE _VODI_MAKE_PLATEID_PH(_VodiK_PCODE_PH8)
# define _VodiK_PCODE_PH8 8

/* mask = zxxxx, id = 1195 */
# define VodiK_PH9_PLATE _VODI_MAKE_PLATEID_PH(_VodiK_PCODE_PH9)
# define _VodiK_PCODE_PH9 9

/* mask = zxxxx, id = 1196 */
# define VodiK_PH10_PLATE _VODI_MAKE_PLATEID_PH(_VodiK_PCODE_PH10)
# define _VodiK_PCODE_PH10 10

/* mask = zzzxxxx, id = 1486 */
# define VodiK_PH11_PLATE _VODI_MAKE_PLATEID_PH(_VodiK_PCODE_PH11)
# define _VodiK_PCODE_PH11 11

/* mask = zzxxxxx, id = 1487 */
# define VodiK_PH12_PLATE _VODI_MAKE_PLATEID_PH(_VodiK_PCODE_PH12)
# define _VodiK_PCODE_PH12 12

/* mask = xxxxxx, id = 1537 */
# define VodiK_PH13_PLATE _VODI_MAKE_PLATEID_PH(_VodiK_PCODE_PH13)
# define _VodiK_PCODE_PH13 13

/* mask = zzzxx, id = 1592 */
# define VodiK_PH14_PLATE _VODI_MAKE_PLATEID_PH(_VodiK_PCODE_PH14)
# define _VodiK_PCODE_PH14 14

/* mask = zzzxx, id = 1593 */
# define VodiK_PH15_PLATE _VODI_MAKE_PLATEID_PH(_VodiK_PCODE_PH15)
# define _VodiK_PCODE_PH15 15
/* @} */


/*
 * PL
 * @{
 */
# define _VODI_MAKE_PLATEID_PL(aCode) _VODI_MAKE_PLATEID(VodiK_POLAND_NUMERIC,aCode)

/* mask = ZZXXXXX, id = 125 */
# define VodiK_PL1_PLATE _VODI_MAKE_PLATEID_PL(_VodiK_PCODE_PL1)
# define _VodiK_PCODE_PL1 1

/* mask = ZZXXXXZ, id = 126 */
# define VodiK_PL2_PLATE _VODI_MAKE_PLATEID_PL(_VodiK_PCODE_PL2)
# define _VodiK_PCODE_PL2 2

/* mask = ZZXXXZZ, id = 127 */
# define VodiK_PL3_PLATE _VODI_MAKE_PLATEID_PL(_VodiK_PCODE_PL3)
# define _VodiK_PCODE_PL3 3

/* mask = ZZZXXZZ, id = 129 */
# define VodiK_PL4_PLATE _VODI_MAKE_PLATEID_PL(_VodiK_PCODE_PL4)
# define _VodiK_PCODE_PL4 4

/* mask = ZZZXZXX, id = 130 */
# define VodiK_PL5_PLATE _VODI_MAKE_PLATEID_PL(_VodiK_PCODE_PL5)
# define _VodiK_PCODE_PL5 5

/* mask = ZZZXXZX, id = 131 */
# define VodiK_PL6_PLATE _VODI_MAKE_PLATEID_PL(_VodiK_PCODE_PL6)
# define _VodiK_PCODE_PL6 6

/* mask = ZZZXZZX, id = 132 */
# define VodiK_PL7_PLATE _VODI_MAKE_PLATEID_PL(_VodiK_PCODE_PL7)
# define _VodiK_PCODE_PL7 7

/* mask = ZZZZZXX, id = 133 */
# define VodiK_PL8_PLATE _VODI_MAKE_PLATEID_PL(_VodiK_PCODE_PL8)
# define _VodiK_PCODE_PL8 8

/* mask = ZZZZXXX, id = 128 */
# define VodiK_PL9_PLATE _VODI_MAKE_PLATEID_PL(_VodiK_PCODE_PL9)
# define _VodiK_PCODE_PL9 9

/* mask = ZZZXXXXX, id = 134 */
# define VodiK_PL10_PLATE _VODI_MAKE_PLATEID_PL(_VodiK_PCODE_PL10)
# define _VodiK_PCODE_PL10 10

/* mask = ZXXXXZ, id = 135 */
# define VodiK_PL11_PLATE _VODI_MAKE_PLATEID_PL(_VodiK_PCODE_PL11)
# define _VodiK_PCODE_PL11 11

/* mask = ZXXXXX, id = 136 */
# define VodiK_PL12_PLATE _VODI_MAKE_PLATEID_PL(_VodiK_PCODE_PL12)
# define _VodiK_PCODE_PL12 12

/* mask = ZZZXXXZ, id = 137 */
# define VodiK_PL13_PLATE _VODI_MAKE_PLATEID_PL(_VodiK_PCODE_PL13)
# define _VodiK_PCODE_PL13 13

/* mask = ZZZXXXX, id = 138 */
# define VodiK_PL14_PLATE _VODI_MAKE_PLATEID_PL(_VodiK_PCODE_PL14)
# define _VodiK_PCODE_PL14 14

/* mask = ZXXXXXX, id = 139 */
# define VodiK_PL15_PLATE _VODI_MAKE_PLATEID_PL(_VodiK_PCODE_PL15)
# define _VodiK_PCODE_PL15 15

/* mask = ZZXZXXX, id = 140 */
# define VodiK_PL16_PLATE _VODI_MAKE_PLATEID_PL(_VodiK_PCODE_PL16)
# define _VodiK_PCODE_PL16 16

/* mask = ZZXZZXX, id = 141 */
# define VodiK_PL17_PLATE _VODI_MAKE_PLATEID_PL(_VodiK_PCODE_PL17)
# define _VodiK_PCODE_PL17 17

/* mask = ZZZXXXXZ, id = 142 */
# define VodiK_PL18_PLATE _VODI_MAKE_PLATEID_PL(_VodiK_PCODE_PL18)
# define _VodiK_PCODE_PL18 18

/* mask = ZZZXXXZZ, id = 143 */
# define VodiK_PL19_PLATE _VODI_MAKE_PLATEID_PL(_VodiK_PCODE_PL19)
# define _VodiK_PCODE_PL19 19

/* mask = ZXXXXXX, id = 144 */
# define VodiK_PL20_PLATE _VODI_MAKE_PLATEID_PL(_VodiK_PCODE_PL20)
# define _VodiK_PCODE_PL20 20

/* mask = ZZXXZZZ, id = 1617 */
# define VodiK_PL21_PLATE _VODI_MAKE_PLATEID_PL(_VodiK_PCODE_PL21)
# define _VodiK_PCODE_PL21 21

/* mask = ZXZZZZZ, id = 1618 */
# define VodiK_PL22_PLATE _VODI_MAKE_PLATEID_PL(_VodiK_PCODE_PL22)
# define _VodiK_PCODE_PL22 22

/* mask = ZXZZZ, id = 1619 */
# define VodiK_PL23_PLATE _VODI_MAKE_PLATEID_PL(_VodiK_PCODE_PL23)
# define _VodiK_PCODE_PL23 23

/* mask = ZXZZZZ, id = 1620 */
# define VodiK_PL24_PLATE _VODI_MAKE_PLATEID_PL(_VodiK_PCODE_PL24)
# define _VodiK_PCODE_PL24 24

/* mask = ZZXXXY, id = 1626 */
# define VodiK_PL25_PLATE _VODI_MAKE_PLATEID_PL(_VodiK_PCODE_PL25)
# define _VodiK_PCODE_PL25 25

/* mask = ZZZYYYY, id = 1627 */
# define VodiK_PL26_PLATE _VODI_MAKE_PLATEID_PL(_VodiK_PCODE_PL26)
# define _VodiK_PCODE_PL26 26

/* mask = ZZXYYYY, id = 1628 */
# define VodiK_PL27_PLATE _VODI_MAKE_PLATEID_PL(_VodiK_PCODE_PL27)
# define _VodiK_PCODE_PL27 27

/* mask = ZZZXXXYY, id = 1629 */
# define VodiK_PL28_PLATE _VODI_MAKE_PLATEID_PL(_VodiK_PCODE_PL28)
# define _VodiK_PCODE_PL28 28

/* mask = ZZXXZ, id = 1630 */
# define VodiK_PL29_PLATE _VODI_MAKE_PLATEID_PL(_VodiK_PCODE_PL29)
# define _VodiK_PCODE_PL29 29
/* @} */


/*
 * PMR
 * @{
 */
# define _VODI_MAKE_PLATEID_PMR(aCode) _VODI_MAKE_PLATEID(VodiK_PRIDNESTROVIAN_NUMERIC,aCode)

/* mask = ZXXXZZ, id = 92 */
# define VodiK_PMR1_PLATE _VODI_MAKE_PLATEID_PMR(_VodiK_PCODE_PMR1)
# define _VodiK_PCODE_PMR1 1

/* mask = XXXZZ, id = 93 */
# define VodiK_PMR2_PLATE _VODI_MAKE_PLATEID_PMR(_VodiK_PCODE_PMR2)
# define _VodiK_PCODE_PMR2 2

/* mask = ZZXXX, id = 94 */
# define VodiK_PMR3_PLATE _VODI_MAKE_PLATEID_PMR(_VodiK_PCODE_PMR3)
# define _VodiK_PCODE_PMR3 3

/* mask = ZZZZXX, id = 1295, two row */
# define VodiK_PMR4_PLATE _VODI_MAKE_PLATEID_PMR(_VodiK_PCODE_PMR4)
# define _VodiK_PCODE_PMR4 4

/* mask = ZZZXXX, id = 2198 */
# define VodiK_PMR5_PLATE _VODI_MAKE_PLATEID_PMR(_VodiK_PCODE_PMR5)
# define _VodiK_PCODE_PMR5 5

/* mask = ZZZXXX, id = 2199, two row */
# define VodiK_PMR6_PLATE _VODI_MAKE_PLATEID_PMR(_VodiK_PCODE_PMR6)
# define _VodiK_PCODE_PMR6 6
/* @} */


/*
 * PR
 * @{
 */
# define _VODI_MAKE_PLATEID_PR(aCode) _VODI_MAKE_PLATEID(VodiK_PUERTO_RICO_NUMERIC,aCode)

/* mask = ZZZXXX, id = 324 */
# define VodiK_PR1_PLATE _VODI_MAKE_PLATEID_PR(_VodiK_PCODE_PR1)
# define _VodiK_PCODE_PR1 1

/* mask = XXXXXX, id = 325 */
# define VodiK_PR2_PLATE _VODI_MAKE_PLATEID_PR(_VodiK_PCODE_PR2)
# define _VodiK_PCODE_PR2 2

/* mask = zzxxxx, id = 1507 */
# define VodiK_PR3_PLATE _VODI_MAKE_PLATEID_PR(_VodiK_PCODE_PR3)
# define _VodiK_PCODE_PR3 3

/* mask = zzxxxxx, id = 1512 */
# define VodiK_PR4_PLATE _VODI_MAKE_PLATEID_PR(_VodiK_PCODE_PR4)
# define _VodiK_PCODE_PR4 4

/* mask = xxxxxzz, id = 1513 */
# define VodiK_PR5_PLATE _VODI_MAKE_PLATEID_PR(_VodiK_PCODE_PR5)
# define _VodiK_PCODE_PR5 5

/* mask = xxxxxx, id = 1509 */
# define VodiK_PR6_PLATE _VODI_MAKE_PLATEID_PR(_VodiK_PCODE_PR6)
# define _VodiK_PCODE_PR6 6

/* mask = zzxxxx, id = 1506 */
# define VodiK_PR7_PLATE _VODI_MAKE_PLATEID_PR(_VodiK_PCODE_PR7)
# define _VodiK_PCODE_PR7 7

/* mask = zxxxxx, id = 1517 */
# define VodiK_PR8_PLATE _VODI_MAKE_PLATEID_PR(_VodiK_PCODE_PR8)
# define _VodiK_PCODE_PR8 8

/* mask = xxxxx, id = 1511 */
# define VodiK_PR9_PLATE _VODI_MAKE_PLATEID_PR(_VodiK_PCODE_PR9)
# define _VodiK_PCODE_PR9 9

/* mask = zzxxz, id = 1514 */
# define VodiK_PR10_PLATE _VODI_MAKE_PLATEID_PR(_VodiK_PCODE_PR10)
# define _VodiK_PCODE_PR10 10

/* mask = xxxxzz, id = 1516 */
# define VodiK_PR11_PLATE _VODI_MAKE_PLATEID_PR(_VodiK_PCODE_PR11)
# define _VodiK_PCODE_PR11 11
/* @} */


/*
* PT
* @{
*/
# define _VODI_MAKE_PLATEID_PT(aCode) _VODI_MAKE_PLATEID(VodiK_PORTUGAL_NUMERIC,aCode)

/* mask = xxzzxx, id = 497 */
# define VodiK_PT1_PLATE _VODI_MAKE_PLATEID_PT(_VodiK_PCODE_PT1)
# define _VodiK_PCODE_PT1 1

/* mask = zzxxxx, id = 502 */
# define VodiK_PT2_PLATE _VODI_MAKE_PLATEID_PT(_VodiK_PCODE_PT2)
# define _VodiK_PCODE_PT2 2

/* mask = xxxxzz, id = 503 */
# define VodiK_PT3_PLATE _VODI_MAKE_PLATEID_PT(_VodiK_PCODE_PT3)
# define _VodiK_PCODE_PT3 3

/* mask = xxxzzxxx, id = 509 */
# define VodiK_PT4_PLATE _VODI_MAKE_PLATEID_PT(_VodiK_PCODE_PT4)
# define _VodiK_PCODE_PT4 4

/* mask = xxxxxz, id = 507 */
# define VodiK_PT5_PLATE _VODI_MAKE_PLATEID_PT(_VodiK_PCODE_PT5)
# define _VodiK_PCODE_PT5 5

/* mask = zxxxxx, id = 498 */
# define VodiK_PT6_PLATE _VODI_MAKE_PLATEID_PT(_VodiK_PCODE_PT6)
# define _VodiK_PCODE_PT6 6

/* mask = zxxxxxx, id = 499 */
# define VodiK_PT7_PLATE _VODI_MAKE_PLATEID_PT(_VodiK_PCODE_PT7)
# define _VodiK_PCODE_PT7 7

/* mask = zzzzxxxx, id = 505 */
# define VodiK_PT8_PLATE _VODI_MAKE_PLATEID_PT(_VodiK_PCODE_PT8)
# define _VodiK_PCODE_PT8 8

/* mask = zzxxxxx, id = 508 */
# define VodiK_PT9_PLATE _VODI_MAKE_PLATEID_PT(_VodiK_PCODE_PT9)
# define _VodiK_PCODE_PT9 9

/* mask = zxxxxx, id = 1888 */
# define VodiK_PT10_PLATE _VODI_MAKE_PLATEID_PT(_VodiK_PCODE_PT10)
# define _VodiK_PCODE_PT10 10

/* mask = zxxxxxx, id = 1889 */
# define VodiK_PT11_PLATE _VODI_MAKE_PLATEID_PT(_VodiK_PCODE_PT11)
# define _VodiK_PCODE_PT11 11

/* mask = zzzzxxxx, id = 1890 */
# define VodiK_PT12_PLATE _VODI_MAKE_PLATEID_PT(_VodiK_PCODE_PT12)
# define _VodiK_PCODE_PT12 12

/* mask = zzxxxxx, id = 1891 */
# define VodiK_PT13_PLATE _VODI_MAKE_PLATEID_PT(_VodiK_PCODE_PT13)
# define _VodiK_PCODE_PT13 13
/* @} */


/*
 * PY
 * @{
 */
# define _VODI_MAKE_PLATEID_PY(aCode) _VODI_MAKE_PLATEID(VodiK_PARAGUAY_NUMERIC,aCode)

/* mask = zzzxxx, id = 754 */
# define VodiK_PY1_PLATE _VODI_MAKE_PLATEID_PY(_VodiK_PCODE_PY1)
# define _VodiK_PCODE_PY1 1

/* mask = zzzxxxxxx, id = 756 */
# define VodiK_PY2_PLATE _VODI_MAKE_PLATEID_PY(_VodiK_PCODE_PY2)
# define _VodiK_PCODE_PY2 2

/* mask = zzxxxxxx, id = 757 */
# define VodiK_PY3_PLATE _VODI_MAKE_PLATEID_PY(_VodiK_PCODE_PY3)
# define _VodiK_PCODE_PY3 3

/* mask = xxxzzz, id = 755 */
# define VodiK_PY4_PLATE _VODI_MAKE_PLATEID_PY(_VodiK_PCODE_PY4)
# define _VodiK_PCODE_PY4 4

/* mask = xxxzzz, id = 2327 */
# define VodiK_PY5_PLATE _VODI_MAKE_PLATEID_PY(_VodiK_PCODE_PY5)
# define _VodiK_PCODE_PY5 5

/* mask = xxxzzzz, id = 2328 */
# define VodiK_PY6_PLATE _VODI_MAKE_PLATEID_PY(_VodiK_PCODE_PY6)
# define _VodiK_PCODE_PY6 6
/* @} */


/*
 * QA
 * @{
 */
# define _VODI_MAKE_PLATEID_QA(aCode) _VODI_MAKE_PLATEID(VodiK_QATAR_NUMERIC,aCode)

/* mask = xxxxxx, id = 1471 */
# define VodiK_QA1_PLATE _VODI_MAKE_PLATEID_QA(_VodiK_PCODE_QA1)
# define _VodiK_PCODE_QA1 1

/* mask = xxx, id = 2126 */
# define VodiK_QA2_PLATE _VODI_MAKE_PLATEID_QA(_VodiK_PCODE_QA2)
# define _VodiK_PCODE_QA2 2

/* mask = xxxx, id = 2127 */
# define VodiK_QA3_PLATE _VODI_MAKE_PLATEID_QA(_VodiK_PCODE_QA3)
# define _VodiK_PCODE_QA3 3

/* mask = xxxxx, id = 2128 */
# define VodiK_QA4_PLATE _VODI_MAKE_PLATEID_QA(_VodiK_PCODE_QA4)
# define _VodiK_PCODE_QA4 4

/* mask = xxxx, id = 2129 */
# define VodiK_QA5_PLATE _VODI_MAKE_PLATEID_QA(_VodiK_PCODE_QA5)
# define _VodiK_PCODE_QA5 5

/* mask = xxxxx, id = 2130 */
# define VodiK_QA6_PLATE _VODI_MAKE_PLATEID_QA(_VodiK_PCODE_QA6)
# define _VodiK_PCODE_QA6 6

/* mask = xxxxxx, id = 2131 */
# define VodiK_QA7_PLATE _VODI_MAKE_PLATEID_QA(_VodiK_PCODE_QA7)
# define _VodiK_PCODE_QA7 7

/* mask = xxxx, id = 2310 */
# define VodiK_QA8_PLATE _VODI_MAKE_PLATEID_QA(_VodiK_PCODE_QA8)
# define _VodiK_PCODE_QA8 8

/* mask = xxxx, id = 2314 */
# define VodiK_QA9_PLATE _VODI_MAKE_PLATEID_QA(_VodiK_PCODE_QA9)
# define _VodiK_PCODE_QA9 9

/* mask = xxxxx, id = 2320 */
# define VodiK_QA10_PLATE _VODI_MAKE_PLATEID_QA(_VodiK_PCODE_QA10)
# define _VodiK_PCODE_QA10 10

/* mask = xxx, id = 2308 */
# define VodiK_QA11_PLATE _VODI_MAKE_PLATEID_QA(_VodiK_PCODE_QA11)
# define _VodiK_PCODE_QA11 11

/* mask = xxxxx, id = 2322 */
# define VodiK_QA12_PLATE _VODI_MAKE_PLATEID_QA(_VodiK_PCODE_QA12)
# define _VodiK_PCODE_QA12 12

/* mask = xxxxx, id = 2316 */
# define VodiK_QA13_PLATE _VODI_MAKE_PLATEID_QA(_VodiK_PCODE_QA13)
# define _VodiK_PCODE_QA13 13

/* mask = xxxxx, id = 2318 */
# define VodiK_QA14_PLATE _VODI_MAKE_PLATEID_QA(_VodiK_PCODE_QA14)
# define _VodiK_PCODE_QA14 14

/* mask = xxxxx, id = 2324 */
# define VodiK_QA15_PLATE _VODI_MAKE_PLATEID_QA(_VodiK_PCODE_QA15)
# define _VodiK_PCODE_QA15 15

/* mask = xxxx, id = 2307 */
# define VodiK_QA16_PLATE _VODI_MAKE_PLATEID_QA(_VodiK_PCODE_QA16)
# define _VodiK_PCODE_QA16 16

/* mask = xxxxx, id = 2312 */
# define VodiK_QA17_PLATE _VODI_MAKE_PLATEID_QA(_VodiK_PCODE_QA17)
# define _VodiK_PCODE_QA17 17

/* mask = xxxxx, id = 2315 */
# define VodiK_QA18_PLATE _VODI_MAKE_PLATEID_QA(_VodiK_PCODE_QA18)
# define _VodiK_PCODE_QA18 18

/* mask = xxxx, id = 2317 */
# define VodiK_QA19_PLATE _VODI_MAKE_PLATEID_QA(_VodiK_PCODE_QA19)
# define _VodiK_PCODE_QA19 19

/* mask = xxxx, id = 2319 */
# define VodiK_QA20_PLATE _VODI_MAKE_PLATEID_QA(_VodiK_PCODE_QA20)
# define _VodiK_PCODE_QA20 20

/* mask = xxxxxx, id = 2311 */
# define VodiK_QA21_PLATE _VODI_MAKE_PLATEID_QA(_VodiK_PCODE_QA21)
# define _VodiK_PCODE_QA21 21

/* mask = xxxxx, id = 2309 */
# define VodiK_QA22_PLATE _VODI_MAKE_PLATEID_QA(_VodiK_PCODE_QA22)
# define _VodiK_PCODE_QA22 22

/* mask = xxxxx, id = 2313 */
# define VodiK_QA23_PLATE _VODI_MAKE_PLATEID_QA(_VodiK_PCODE_QA23)
# define _VodiK_PCODE_QA23 23

/* mask = xxxx, id = 2321 */
# define VodiK_QA24_PLATE _VODI_MAKE_PLATEID_QA(_VodiK_PCODE_QA24)
# define _VodiK_PCODE_QA24 24

/* mask = xxxxx, id = 2323 */
# define VodiK_QA25_PLATE _VODI_MAKE_PLATEID_QA(_VodiK_PCODE_QA25)
# define _VodiK_PCODE_QA25 25

/* mask = xxxxx, id = 2325 */
# define VodiK_QA26_PLATE _VODI_MAKE_PLATEID_QA(_VodiK_PCODE_QA26)
# define _VodiK_PCODE_QA26 26

/* mask = xxxxx, id = 2326 */
# define VodiK_QA27_PLATE _VODI_MAKE_PLATEID_QA(_VodiK_PCODE_QA27)
# define _VodiK_PCODE_QA27 27

/* mask = xxxxx, id = 2306 */
# define VodiK_QA28_PLATE _VODI_MAKE_PLATEID_QA(_VodiK_PCODE_QA28)
# define _VodiK_PCODE_QA28 28
/* @} */


/*
* RKS
* @{
*/
# define _VODI_MAKE_PLATEID_RKS(aCode) _VODI_MAKE_PLATEID(VodiK_KOSOVO_NUMERIC,aCode)

/* mask = xxxxxzz, id = 538 */
# define VodiK_RKS1_PLATE _VODI_MAKE_PLATEID_RKS(_VodiK_PCODE_RKS1)
# define _VodiK_PCODE_RKS1 1

/* mask = xxxzzxxx, id = 539 */
# define VodiK_RKS2_PLATE _VODI_MAKE_PLATEID_RKS(_VodiK_PCODE_RKS2)
# define _VodiK_PCODE_RKS2 2

/* mask = xxxzzxxx, id = 541 */
# define VodiK_RKS3_PLATE _VODI_MAKE_PLATEID_RKS(_VodiK_PCODE_RKS3)
# define _VodiK_PCODE_RKS3 3

/* mask = zzzzzzxxxxx, id = 543 */
# define VodiK_RKS4_PLATE _VODI_MAKE_PLATEID_RKS(_VodiK_PCODE_RKS4)
# define _VodiK_PCODE_RKS4 4

/* mask = xzxxxxx, id = 540 */
# define VodiK_RKS5_PLATE _VODI_MAKE_PLATEID_RKS(_VodiK_PCODE_RKS5)
# define _VodiK_PCODE_RKS5 5

/* mask = zzzxxxxx, id = 542 */
# define VodiK_RKS6_PLATE _VODI_MAKE_PLATEID_RKS(_VodiK_PCODE_RKS6)
# define _VodiK_PCODE_RKS6 6

/* mask = xxxxxxxx, id = 544 */
# define VodiK_RKS7_PLATE _VODI_MAKE_PLATEID_RKS(_VodiK_PCODE_RKS7)
# define _VodiK_PCODE_RKS7 7

/* mask = zzzzzzxxxxx, id = 1730 */
# define VodiK_RKS8_PLATE _VODI_MAKE_PLATEID_RKS(_VodiK_PCODE_RKS8)
# define _VodiK_PCODE_RKS8 8

/* mask = xzxxxxx, id = 1731 */
# define VodiK_RKS9_PLATE _VODI_MAKE_PLATEID_RKS(_VodiK_PCODE_RKS9)
# define _VodiK_PCODE_RKS9 9

/* mask = zzzxxxxx, id = 1732 */
# define VodiK_RKS10_PLATE _VODI_MAKE_PLATEID_RKS(_VodiK_PCODE_RKS10)
# define _VodiK_PCODE_RKS10 10

/* mask = xxxxxzz, id = 1733 */
# define VodiK_RKS11_PLATE _VODI_MAKE_PLATEID_RKS(_VodiK_PCODE_RKS11)
# define _VodiK_PCODE_RKS11 11
/* @} */


/*
* RO
* @{
*/
# define _VODI_MAKE_PLATEID_RO(aCode) _VODI_MAKE_PLATEID(VodiK_ROMANIA_NUMERIC,aCode)

/* mask = ZZXXZZZ, id = 178 */
# define VodiK_RO1_PLATE _VODI_MAKE_PLATEID_RO(_VodiK_PCODE_RO1)
# define _VodiK_PCODE_RO1 1

/* mask = ZXXZZZ, id = 179 */
# define VodiK_RO2_PLATE _VODI_MAKE_PLATEID_RO(_VodiK_PCODE_RO2)
# define _VodiK_PCODE_RO2 2

/* mask = ZZXXXXXX, id = 182 */
# define VodiK_RO3_PLATE _VODI_MAKE_PLATEID_RO(_VodiK_PCODE_RO3)
# define _VodiK_PCODE_RO3 3

/* mask = ZXXXXXX, id = 180 */
# define VodiK_RO4_PLATE _VODI_MAKE_PLATEID_RO(_VodiK_PCODE_RO4)
# define _VodiK_PCODE_RO4 4

/* mask = ZXXXX, id = 181 */
# define VodiK_RO5_PLATE _VODI_MAKE_PLATEID_RO(_VodiK_PCODE_RO5)
# define _VodiK_PCODE_RO5 5

/* mask = ZZXXXXX, id = 183 */
# define VodiK_RO6_PLATE _VODI_MAKE_PLATEID_RO(_VodiK_PCODE_RO6)
# define _VodiK_PCODE_RO6 6

/* mask = ZZXXXX, id = 184 */
# define VodiK_RO7_PLATE _VODI_MAKE_PLATEID_RO(_VodiK_PCODE_RO7)
# define _VodiK_PCODE_RO7 7

/* mask = ZXXXZZZZZ, id = 185 */
# define VodiK_RO8_PLATE _VODI_MAKE_PLATEID_RO(_VodiK_PCODE_RO8)
# define _VodiK_PCODE_RO8 8

/* mask = ZZZXXXXX, id = 186 */
# define VodiK_RO9_PLATE _VODI_MAKE_PLATEID_RO(_VodiK_PCODE_RO9)
# define _VodiK_PCODE_RO9 9

/* mask = ZZXXXZZZZZ, id = 301 */
# define VodiK_RO10_PLATE _VODI_MAKE_PLATEID_RO(_VodiK_PCODE_RO10)
# define _VodiK_PCODE_RO10 10

/* mask = ZZXXXX, id = 1749 */
# define VodiK_RO11_PLATE _VODI_MAKE_PLATEID_RO(_VodiK_PCODE_RO11)
# define _VodiK_PCODE_RO11 11

/* mask = ZXXXZZZZZ, id = 1750 */
# define VodiK_RO12_PLATE _VODI_MAKE_PLATEID_RO(_VodiK_PCODE_RO12)
# define _VodiK_PCODE_RO12 12

/* mask = ZZZXXXXX, id = 1751 */
# define VodiK_RO13_PLATE _VODI_MAKE_PLATEID_RO(_VodiK_PCODE_RO13)
# define _VodiK_PCODE_RO13 13

/* mask = ZZXXXZZZZZ, id = 1752 */
# define VodiK_RO14_PLATE _VODI_MAKE_PLATEID_RO(_VodiK_PCODE_RO14)
# define _VodiK_PCODE_RO14 14

/* mask = ZZXXXZZZZZ, id = 1892 */
# define VodiK_RO15_PLATE _VODI_MAKE_PLATEID_RO(_VodiK_PCODE_RO15)
# define _VodiK_PCODE_RO15 15

/* mask = ZZXXXZZZZZ, id = 1940 */
# define VodiK_RO16_PLATE _VODI_MAKE_PLATEID_RO(_VodiK_PCODE_RO16)
# define _VodiK_PCODE_RO16 16

/* mask = ZZXXXZZZZZ, id = 1941 */
# define VodiK_RO17_PLATE _VODI_MAKE_PLATEID_RO(_VodiK_PCODE_RO17)
# define _VodiK_PCODE_RO17 17
/* @} */


/*
* RS
* @{
*/
# define _VODI_MAKE_PLATEID_RS(aCode) _VODI_MAKE_PLATEID(VodiK_SERBIA_NUMERIC,aCode)

/* mask = zzxxxzz, id = 532 */
# define VodiK_RS1_PLATE _VODI_MAKE_PLATEID_RS(_VodiK_PCODE_RS1)
# define _VodiK_PCODE_RS1 1

/* mask = zxxxx, id = 536 */
# define VodiK_RS2_PLATE _VODI_MAKE_PLATEID_RS(_VodiK_PCODE_RS2)
# define _VodiK_PCODE_RS2 2

/* mask = xxzxxx, id = 533 */
# define VodiK_RS3_PLATE _VODI_MAKE_PLATEID_RS(_VodiK_PCODE_RS3)
# define _VodiK_PCODE_RS3 3

/* mask = xxxzzzzz, id = 535 */
# define VodiK_RS4_PLATE _VODI_MAKE_PLATEID_RS(_VodiK_PCODE_RS4)
# define _VodiK_PCODE_RS4 4

/* mask = zzxxxzz, id = 534 */
# define VodiK_RS5_PLATE _VODI_MAKE_PLATEID_RS(_VodiK_PCODE_RS5)
# define _VodiK_PCODE_RS5 5

/* mask = ZZXXXXZZ, id = 1631 */
# define VodiK_RS6_PLATE _VODI_MAKE_PLATEID_RS(_VodiK_PCODE_RS6)
# define _VodiK_PCODE_RS6 6

/* mask = zzxxxxx, id = 1632 */
# define VodiK_RS7_PLATE _VODI_MAKE_PLATEID_RS(_VodiK_PCODE_RS7)
# define _VodiK_PCODE_RS7 7

/* mask = zzxxxzz, id = 1633 */
# define VodiK_RS8_PLATE _VODI_MAKE_PLATEID_RS(_VodiK_PCODE_RS8)
# define _VodiK_PCODE_RS8 8

/* mask = zxxxxxx, id = 1634 */
# define VodiK_RS9_PLATE _VODI_MAKE_PLATEID_RS(_VodiK_PCODE_RS9)
# define _VodiK_PCODE_RS9 9

/* mask = zxxxxx, id = 1753 */
# define VodiK_RS10_PLATE _VODI_MAKE_PLATEID_RS(_VodiK_PCODE_RS10)
# define _VodiK_PCODE_RS10 10

/* mask = xxxxxxz, id = 1754 */
# define VodiK_RS11_PLATE _VODI_MAKE_PLATEID_RS(_VodiK_PCODE_RS11)
# define _VodiK_PCODE_RS11 11

/* mask = zzxxxzz, id = 1755 */
# define VodiK_RS12_PLATE _VODI_MAKE_PLATEID_RS(_VodiK_PCODE_RS12)
# define _VodiK_PCODE_RS12 12
/* @} */

/*
 * RU
 * @{
 */
# define _VODI_MAKE_PLATEID_RU(aCode) _VODI_MAKE_PLATEID(VodiK_RUSSIAN_NUMERIC,aCode)

/* mask = zXXXzzxxx, id = 5 */
# define VodiK_RU1_PLATE _VODI_MAKE_PLATEID_RU(_VodiK_PCODE_RU1)
# define _VodiK_PCODE_RU1 1

/* mask = zXXXzzxx, id = 6 */
# define VodiK_RU2_PLATE _VODI_MAKE_PLATEID_RU(_VodiK_PCODE_RU2)
# define _VodiK_PCODE_RU2 2

/* mask = zXXXXxx, id = 10 */
# define VodiK_RU3_PLATE _VODI_MAKE_PLATEID_RU(_VodiK_PCODE_RU3)
# define _VodiK_PCODE_RU3 3

/* mask = xxxzxx, id = 1208 */
# define VodiK_RU4_PLATE _VODI_MAKE_PLATEID_RU(_VodiK_PCODE_RU4)
# define _VodiK_PCODE_RU4 4

/* mask = zzXXXxx, id = 7 */
# define VodiK_RU5_PLATE _VODI_MAKE_PLATEID_RU(_VodiK_PCODE_RU5)
# define _VodiK_PCODE_RU5 5

/* mask = XXXXzzxx, id = 8 */
# define VodiK_RU6_PLATE _VODI_MAKE_PLATEID_RU(_VodiK_PCODE_RU6)
# define _VodiK_PCODE_RU6 6

/* mask = zXXXXxx, id = 9 */
# define VodiK_RU7_PLATE _VODI_MAKE_PLATEID_RU(_VodiK_PCODE_RU7)
# define _VodiK_PCODE_RU7 7

/* mask = zzXXXXxx, id = 11 */
# define VodiK_RU8_PLATE _VODI_MAKE_PLATEID_RU(_VodiK_PCODE_RU8)
# define _VodiK_PCODE_RU8 8

/* mask = zzXXXXxx, id = 12 */
# define VodiK_RU9_PLATE _VODI_MAKE_PLATEID_RU(_VodiK_PCODE_RU9)
# define _VodiK_PCODE_RU9 9

/* mask = XXXzxxxxx, id = 13 */
# define VodiK_RU10_PLATE _VODI_MAKE_PLATEID_RU(_VodiK_PCODE_RU10)
# define _VodiK_PCODE_RU10 10

/* mask = XXXzzXxx, id = 14 */
# define VodiK_RU11_PLATE _VODI_MAKE_PLATEID_RU(_VodiK_PCODE_RU11)
# define _VodiK_PCODE_RU11 11

/* mask = ZzzXXXxx, id = 15 */
# define VodiK_RU12_PLATE _VODI_MAKE_PLATEID_RU(_VodiK_PCODE_RU12)
# define _VodiK_PCODE_RU12 12

/* mask = zzXXXzxx, id = 74 */
# define VodiK_RU13_PLATE _VODI_MAKE_PLATEID_RU(_VodiK_PCODE_RU13)
# define _VodiK_PCODE_RU13 13

/* mask = XXXXZZXX, id = 1283, two row  */
# define VodiK_RU14_PLATE _VODI_MAKE_PLATEID_RU(_VodiK_PCODE_RU14)
# define _VodiK_PCODE_RU14 14

/* mask = XXXXZZXX, id = 1296, two row */
# define VodiK_RU15_PLATE _VODI_MAKE_PLATEID_RU(_VodiK_PCODE_RU15)
# define _VodiK_PCODE_RU15 15

/* mask = XXXXZXX, id = 1297, two row */
# define VodiK_RU16_PLATE _VODI_MAKE_PLATEID_RU(_VodiK_PCODE_RU16)
# define _VodiK_PCODE_RU16 16

/* mask = XXXXBA3, id = 1451 */
# define VodiK_RU17_PLATE _VODI_MAKE_PLATEID_RU(_VodiK_PCODE_RU17)
# define _VodiK_PCODE_RU17 17

/* mask = ZXXXZZXXX, id = 2165, two row */
# define VodiK_RU18_PLATE _VODI_MAKE_PLATEID_RU(_VodiK_PCODE_RU18)
# define _VodiK_PCODE_RU18 18

/* mask = ZXXXZZXX, id = 2166, two row */
# define VodiK_RU19_PLATE _VODI_MAKE_PLATEID_RU(_VodiK_PCODE_RU19)
# define _VodiK_PCODE_RU19 19

/* mask = ZZZXXX|xx, id = 2167, two row */
# define VodiK_RU20_PLATE _VODI_MAKE_PLATEID_RU(_VodiK_PCODE_RU20)
# define _VodiK_PCODE_RU20 20

/* mask = ZZZXXXXX, id = 2168, two row */
# define VodiK_RU21_PLATE _VODI_MAKE_PLATEID_RU(_VodiK_PCODE_RU21)
# define _VodiK_PCODE_RU21 21

/* mask = ZZZXXXxx, id = 2190 */
# define VodiK_RU22_PLATE _VODI_MAKE_PLATEID_RU(_VodiK_PCODE_RU22)
# define _VodiK_PCODE_RU22 22

/* mask = zz|xx|xxxx, id = 2191 */
# define VodiK_RU23_PLATE _VODI_MAKE_PLATEID_RU(_VodiK_PCODE_RU23)
# define _VodiK_PCODE_RU23 23

/* mask = zxxxzzxx, id = 2192 */
# define VodiK_RU24_PLATE _VODI_MAKE_PLATEID_RU(_VodiK_PCODE_RU24)
# define _VodiK_PCODE_RU24 24

/* mask = zzxxxx|xx, id = 2193 */
# define VodiK_RU25_PLATE _VODI_MAKE_PLATEID_RU(_VodiK_PCODE_RU25)
# define _VodiK_PCODE_RU25 25
/* @} */


/*
* SA
* @{
*/
# define _VODI_MAKE_PLATEID_SA(aCode) _VODI_MAKE_PLATEID(VodiK_SAUDI_ARABIA_NUMERIC,aCode)

/* mask = xxxxzzz, id = 2095 */
# define VodiK_SA1_PLATE _VODI_MAKE_PLATEID_SA(_VodiK_PCODE_SA1)
# define _VodiK_PCODE_SA1 1

/* mask = xxxxzzz, id = 2096 */
# define VodiK_SA2_PLATE _VODI_MAKE_PLATEID_SA(_VodiK_PCODE_SA2)
# define _VodiK_PCODE_SA2 2

/* mask = xxxzzz, id = 2097 */
# define VodiK_SA3_PLATE _VODI_MAKE_PLATEID_SA(_VodiK_PCODE_SA3)
# define _VodiK_PCODE_SA3 3

/* mask = xxxzzz, id = 2098 */
# define VodiK_SA4_PLATE _VODI_MAKE_PLATEID_SA(_VodiK_PCODE_SA4)
# define _VodiK_PCODE_SA4 4

/* mask = xxzzz, id = 2099 */
# define VodiK_SA5_PLATE _VODI_MAKE_PLATEID_SA(_VodiK_PCODE_SA5)
# define _VodiK_PCODE_SA5 5

/* mask = xxzzz, id = 2100 */
# define VodiK_SA6_PLATE _VODI_MAKE_PLATEID_SA(_VodiK_PCODE_SA6)
# define _VodiK_PCODE_SA6 6

/* mask = xzzz, id = 2132 */
# define VodiK_SA7_PLATE _VODI_MAKE_PLATEID_SA(_VodiK_PCODE_SA7)
# define _VodiK_PCODE_SA7 7

/* mask = xzzz, id = 2133 */
# define VodiK_SA8_PLATE _VODI_MAKE_PLATEID_SA(_VodiK_PCODE_SA8)
# define _VodiK_PCODE_SA8 8

/* mask = xxxzzz, id = 2134 */
# define VodiK_SA9_PLATE _VODI_MAKE_PLATEID_SA(_VodiK_PCODE_SA9)
# define _VodiK_PCODE_SA9 9
/* @} */


/*
 * SC
 * @{
 */
# define _VODI_MAKE_PLATEID_SC(aCode) _VODI_MAKE_PLATEID(VodiK_SEYCHELLES_NUMERIC,aCode)

/* mask = zxxxxx, id = 1244 */
# define VodiK_SC1_PLATE _VODI_MAKE_PLATEID_SC(_VodiK_PCODE_SC1)
# define _VodiK_PCODE_SC1 1

/* mask = zxxxx, id = 1250 */
# define VodiK_SC2_PLATE _VODI_MAKE_PLATEID_SC(_VodiK_PCODE_SC2)
# define _VodiK_PCODE_SC2 2

/* mask = zxxxxx, id = 1251 */
# define VodiK_SC3_PLATE _VODI_MAKE_PLATEID_SC(_VodiK_PCODE_SC3)
# define _VodiK_PCODE_SC3 3

/* mask = zzxxxxx, id = 1247 */
# define VodiK_SC4_PLATE _VODI_MAKE_PLATEID_SC(_VodiK_PCODE_SC4)
# define _VodiK_PCODE_SC4 4

/* mask = zxxxxzz, id = 1246 */
# define VodiK_SC5_PLATE _VODI_MAKE_PLATEID_SC(_VodiK_PCODE_SC5)
# define _VodiK_PCODE_SC5 5

/* mask = zxxxxxzz, id = 1248 */
# define VodiK_SC6_PLATE _VODI_MAKE_PLATEID_SC(_VodiK_PCODE_SC6)
# define _VodiK_PCODE_SC6 6

/* mask = zxxxxzz, id = 1249 */
# define VodiK_SC7_PLATE _VODI_MAKE_PLATEID_SC(_VodiK_PCODE_SC7)
# define _VodiK_PCODE_SC7 7
/* @} */


/*
 * SE
 * @{
 */
# define _VODI_MAKE_PLATEID_SE(aCode) _VODI_MAKE_PLATEID(VodiK_SWEDEN_NUMERIC,aCode)

/* mask = ZZZXXX, id = 490 */
# define VodiK_SE1_PLATE _VODI_MAKE_PLATEID_SE(_VodiK_PCODE_SE1)
# define _VodiK_PCODE_SE1 1

/* mask = ZZZMXXX, id = 1669 */
# define VodiK_SE2_PLATE _VODI_MAKE_PLATEID_SE(_VodiK_PCODE_SE2)
# define _VodiK_PCODE_SE2 2

/* mask = ZZZXXX, id = 1670 */
# define VodiK_SE3_PLATE _VODI_MAKE_PLATEID_SE(_VodiK_PCODE_SE3)
# define _VodiK_PCODE_SE3 3

/* mask = ZZZXXXt, id = 1671 */
# define VodiK_SE4_PLATE _VODI_MAKE_PLATEID_SE(_VodiK_PCODE_SE4)
# define _VodiK_PCODE_SE4 4

/* mask = zzxxxz, id = 2188 */
# define VodiK_SE5_PLATE _VODI_MAKE_PLATEID_SE(_VodiK_PCODE_SE5)
# define _VodiK_PCODE_SE5 5

/* mask = zzxxxz, id = 2189 */
# define VodiK_SE6_PLATE _VODI_MAKE_PLATEID_SE(_VodiK_PCODE_SE6)
# define _VodiK_PCODE_SE6 6
/* @} */


/*
* SG
* @{
*/
# define _VODI_MAKE_PLATEID_SG(aCode) _VODI_MAKE_PLATEID(VodiK_SINGAPORE_NUMERIC,aCode)

/* mask = ZZZXXXXZ, id = 465 */
# define VodiK_SG1_PLATE _VODI_MAKE_PLATEID_SG(_VodiK_PCODE_SG1)
# define _VodiK_PCODE_SG1 1

/* mask = ZZXXXXZ, id = 467 */
# define VodiK_SG2_PLATE _VODI_MAKE_PLATEID_SG(_VodiK_PCODE_SG2)
# define _VodiK_PCODE_SG2 2

/* mask = zzzxxz, id = 468 */
# define VodiK_SG3_PLATE _VODI_MAKE_PLATEID_SG(_VodiK_PCODE_SG3)
# define _VodiK_PCODE_SG3 3

/* mask = ZZXXXZ, id = 469 */
# define VodiK_SG4_PLATE _VODI_MAKE_PLATEID_SG(_VodiK_PCODE_SG4)
# define _VodiK_PCODE_SG4 4

/* mask = ZXXXXZZ, id = 1313 */
# define VodiK_SG5_PLATE _VODI_MAKE_PLATEID_SG(_VodiK_PCODE_SG5)
# define _VodiK_PCODE_SG5 5

/* mask = zzzxxxxz, id = 1315 */
# define VodiK_SG6_PLATE _VODI_MAKE_PLATEID_SG(_VodiK_PCODE_SG6)
# define _VodiK_PCODE_SG6 6

/* mask = zzzxxxz, id = 1316 */
# define VodiK_SG7_PLATE _VODI_MAKE_PLATEID_SG(_VodiK_PCODE_SG7)
# define _VodiK_PCODE_SG7 7

/* mask = zzzxxxz, id = 1318 */
# define VodiK_SG8_PLATE _VODI_MAKE_PLATEID_SG(_VodiK_PCODE_SG8)
# define _VodiK_PCODE_SG8 8

/* mask = zzxxz, id = 1321 */
# define VodiK_SG9_PLATE _VODI_MAKE_PLATEID_SG(_VodiK_PCODE_SG9)
# define _VodiK_PCODE_SG9 9

/* mask = zzxxxxz, id = 1323 */
# define VodiK_SG10_PLATE _VODI_MAKE_PLATEID_SG(_VodiK_PCODE_SG10)
# define _VodiK_PCODE_SG10 10

/* mask = zzxxxz, id = 1324 */
# define VodiK_SG11_PLATE _VODI_MAKE_PLATEID_SG(_VodiK_PCODE_SG11)
# define _VodiK_PCODE_SG11 11

/* mask = zzzxz, id = 1325 */
# define VodiK_SG12_PLATE _VODI_MAKE_PLATEID_SG(_VodiK_PCODE_SG12)
# define _VodiK_PCODE_SG12 12

/* mask = zzzxxz, id = 1326 */
# define VodiK_SG13_PLATE _VODI_MAKE_PLATEID_SG(_VodiK_PCODE_SG13)
# define _VodiK_PCODE_SG13 13

/* mask = zzxxz, id = 1894 */
# define VodiK_SG14_PLATE _VODI_MAKE_PLATEID_SG(_VodiK_PCODE_SG14)
# define _VodiK_PCODE_SG14 14
/* @} */

/*
* SI
* @{
*/
# define _VODI_MAKE_PLATEID_SI(aCode) _VODI_MAKE_PLATEID(VodiK_SLOVENIA_NUMERIC,aCode)

/* mask = ZZZXXXX, id = 215 */
# define VodiK_SI1_PLATE _VODI_MAKE_PLATEID_SI(_VodiK_PCODE_SI1)
# define _VodiK_PCODE_SI1 1

/* mask = ZZZXXXZ, id = 216 */
# define VodiK_SI2_PLATE _VODI_MAKE_PLATEID_SI(_VodiK_PCODE_SI2)
# define _VodiK_PCODE_SI2 2

/* mask = ZZXXXXZ, id = 217 */
# define VodiK_SI3_PLATE _VODI_MAKE_PLATEID_SI(_VodiK_PCODE_SI3)
# define _VodiK_PCODE_SI3 3

/* mask = ZZZZXXX, id = 218 */
# define VodiK_SI4_PLATE _VODI_MAKE_PLATEID_SI(_VodiK_PCODE_SI4)
# define _VodiK_PCODE_SI4 4

/* mask = ZXXXZZZ, id = 221 */
# define VodiK_SI5_PLATE _VODI_MAKE_PLATEID_SI(_VodiK_PCODE_SI5)
# define _VodiK_PCODE_SI5 5

/* mask = ZZZXXXXX, id = 253 */
# define VodiK_SI6_PLATE _VODI_MAKE_PLATEID_SI(_VodiK_PCODE_SI6)
# define _VodiK_PCODE_SI6 6

/* mask = ZZZXXX, id = 219 */
# define VodiK_SI7_PLATE _VODI_MAKE_PLATEID_SI(_VodiK_PCODE_SI7)
# define _VodiK_PCODE_SI7 7

/* mask = ZXXXZZ, id = 220 */
# define VodiK_SI8_PLATE _VODI_MAKE_PLATEID_SI(_VodiK_PCODE_SI8)
# define _VodiK_PCODE_SI8 8

/* mask = ZZXXXXX, id = 222 */
# define VodiK_SI9_PLATE _VODI_MAKE_PLATEID_SI(_VodiK_PCODE_SI9)
# define _VodiK_PCODE_SI9 9

/* mask = ZZXXXX, id = 252 */
# define VodiK_SI10_PLATE _VODI_MAKE_PLATEID_SI(_VodiK_PCODE_SI10)
# define _VodiK_PCODE_SI10 10

/* mask = ZXXXXX, id = 254 */
# define VodiK_SI11_PLATE _VODI_MAKE_PLATEID_SI(_VodiK_PCODE_SI11)
# define _VodiK_PCODE_SI11 11

/* mask = ZXXXXX, id = 255 */
# define VodiK_SI12_PLATE _VODI_MAKE_PLATEID_SI(_VodiK_PCODE_SI12)
# define _VodiK_PCODE_SI12 12

/* mask = ZXXXXX, id = 256 */
# define VodiK_SI13_PLATE _VODI_MAKE_PLATEID_SI(_VodiK_PCODE_SI13)
# define _VodiK_PCODE_SI13 13

/* mask = ZZXXXZZ, id = 302 */
# define VodiK_SI14_PLATE _VODI_MAKE_PLATEID_SI(_VodiK_PCODE_SI14)
# define _VodiK_PCODE_SI14 14

/* mask = ZXXXXX, id = 1762 */
# define VodiK_SI15_PLATE _VODI_MAKE_PLATEID_SI(_VodiK_PCODE_SI15)
# define _VodiK_PCODE_SI15 15

/* mask = ZXXXXX, id = 1763 */
# define VodiK_SI16_PLATE _VODI_MAKE_PLATEID_SI(_VodiK_PCODE_SI16)
# define _VodiK_PCODE_SI16 16

/* mask = ZZXXXZZ, id = 1764 */
# define VodiK_SI17_PLATE _VODI_MAKE_PLATEID_SI(_VodiK_PCODE_SI17)
# define _VodiK_PCODE_SI17 17

/* mask = ZZXXZZZ, id = 2245 */
# define VodiK_SI18_PLATE _VODI_MAKE_PLATEID_SI(_VodiK_PCODE_SI18)
# define _VodiK_PCODE_SI18 18
/* @} */


/*
* SK
* @{
*/
# define _VODI_MAKE_PLATEID_SK(aCode) _VODI_MAKE_PLATEID(VodiK_SLOVAKIA_NUMERIC,aCode)

/* mask = ZZ-XXXZZ, id = 153 */
# define VodiK_SK1_PLATE _VODI_MAKE_PLATEID_SK(_VodiK_PCODE_SK1)
# define _VodiK_PCODE_SK1 1

/* mask = ZZ-XXXZZ, id = 1551 */
# define VodiK_SK2_PLATE _VODI_MAKE_PLATEID_SK(_VodiK_PCODE_SK2)
# define _VodiK_PCODE_SK2 2

/* mask = ZZZXXX, id = 1552 */
# define VodiK_SK3_PLATE _VODI_MAKE_PLATEID_SK(_VodiK_PCODE_SK3)
# define _VodiK_PCODE_SK3 3

/* mask = ZZZZXXX, id = 1553 */
# define VodiK_SK4_PLATE _VODI_MAKE_PLATEID_SK(_VodiK_PCODE_SK4)
# define _VodiK_PCODE_SK4 4

/* mask = xxxxxxx, id = 1756 */
# define VodiK_SK5_PLATE _VODI_MAKE_PLATEID_SK(_VodiK_PCODE_SK5)
# define _VodiK_PCODE_SK5 5

/* mask = xxxxxxx, id = 1757 */
# define VodiK_SK6_PLATE _VODI_MAKE_PLATEID_SK(_VodiK_PCODE_SK6)
# define _VodiK_PCODE_SK6 6

/* mask = zzxxxxx, id = 1758 */
# define VodiK_SK7_PLATE _VODI_MAKE_PLATEID_SK(_VodiK_PCODE_SK7)
# define _VodiK_PCODE_SK7 7

/* mask = zxxxxx, id = 1759 */
# define VodiK_SK8_PLATE _VODI_MAKE_PLATEID_SK(_VodiK_PCODE_SK8)
# define _VodiK_PCODE_SK8 8

/* mask = zzzzxxx, id = 1760 */
# define VodiK_SK9_PLATE _VODI_MAKE_PLATEID_SK(_VodiK_PCODE_SK9)
# define _VodiK_PCODE_SK9 9

/* mask = zzzxxx, id = 1761 */
# define VodiK_SK10_PLATE _VODI_MAKE_PLATEID_SK(_VodiK_PCODE_SK10)
# define _VodiK_PCODE_SK10 10

/* mask = zxxxxx, id = 2080 */
# define VodiK_SK11_PLATE _VODI_MAKE_PLATEID_SK(_VodiK_PCODE_SK11)
# define _VodiK_PCODE_SK11 11
/* @} */

/*
* SU
* @{
*/
# define _VODI_MAKE_PLATEID_SU(aCode) _VODI_MAKE_PLATEID(VodiK_USSR_NUMERIC,aCode)

/* mask = XXXXZZZ, id = 16 */
# define VodiK_SU1_PLATE _VODI_MAKE_PLATEID_SU(_VodiK_PCODE_SU1)
# define _VodiK_PCODE_SU1 1

/* mask = zXXXXZZ, id = 17 */
# define VodiK_SU2_PLATE _VODI_MAKE_PLATEID_SU(_VodiK_PCODE_SU2)
# define _VodiK_PCODE_SU2 2

/* mask = ZZZXXXX, id = 23 */
# define VodiK_SU3_PLATE _VODI_MAKE_PLATEID_SU(_VodiK_PCODE_SU3)
# define _VodiK_PCODE_SU3 3

/* mask = XXXXzzz, id = 24 */
# define VodiK_SU4_PLATE _VODI_MAKE_PLATEID_SU(_VodiK_PCODE_SU4)
# define _VodiK_PCODE_SU4 4
/* @} */

/*
 * SV
 * @{
 */
# define _VODI_MAKE_PLATEID_SV(aCode) _VODI_MAKE_PLATEID(VodiK_EL_SALVADOR_NUMERIC,aCode)

/* mask = zxxxxxx, id = 798 */
# define VodiK_SV1_PLATE _VODI_MAKE_PLATEID_SV(_VodiK_PCODE_SV1)
# define _VodiK_PCODE_SV1 1

/* mask = zzxxx, id = 800 */
# define VodiK_SV2_PLATE _VODI_MAKE_PLATEID_SV(_VodiK_PCODE_SV2)
# define _VodiK_PCODE_SV2 2

/* mask = zxxxxx, id = 799 */
# define VodiK_SV3_PLATE _VODI_MAKE_PLATEID_SV(_VodiK_PCODE_SV3)
# define _VodiK_PCODE_SV3 3

/* mask = zxxxxx, id = 801 */
# define VodiK_SV4_PLATE _VODI_MAKE_PLATEID_SV(_VodiK_PCODE_SV4)
# define _VodiK_PCODE_SV4 4

/* mask = zxxxx, id = 802 */
# define VodiK_SV5_PLATE _VODI_MAKE_PLATEID_SV(_VodiK_PCODE_SV5)
# define _VodiK_PCODE_SV5 5

/* mask = zzxxxxx, id = 803 */
# define VodiK_SV6_PLATE _VODI_MAKE_PLATEID_SV(_VodiK_PCODE_SV6)
# define _VodiK_PCODE_SV6 6

/* mask = zxxxxx, id = 804 */
# define VodiK_SV7_PLATE _VODI_MAKE_PLATEID_SV(_VodiK_PCODE_SV7)
# define _VodiK_PCODE_SV7 7

/* mask = xxx, id = 805 */
# define VodiK_SV8_PLATE _VODI_MAKE_PLATEID_SV(_VodiK_PCODE_SV8)
# define _VodiK_PCODE_SV8 8

/* mask = zxxxxx, id = 806 */
# define VodiK_SV9_PLATE _VODI_MAKE_PLATEID_SV(_VodiK_PCODE_SV9)
# define _VodiK_PCODE_SV9 9

/* mask = zxxxxx, id = 807 */
# define VodiK_SV10_PLATE _VODI_MAKE_PLATEID_SV(_VodiK_PCODE_SV10)
# define _VodiK_PCODE_SV10 10

/* mask = zzxxxx, id = 808 */
# define VodiK_SV11_PLATE _VODI_MAKE_PLATEID_SV(_VodiK_PCODE_SV11)
# define _VodiK_PCODE_SV11 11

/* mask = zzxxxxx, id = 1503 */
# define VodiK_SV12_PLATE _VODI_MAKE_PLATEID_SV(_VodiK_PCODE_SV12)
# define _VodiK_PCODE_SV12 12
/* @} */


/*
 * TJ
 * @{
 */
# define _VODI_MAKE_PLATEID_TJ(aCode) _VODI_MAKE_PLATEID(VodiK_TAJIKISTAN_NUMERIC,aCode)

/* mask = xxxxzzxx, id = 875 */
# define VodiK_TJ1_PLATE _VODI_MAKE_PLATEID_TJ(_VodiK_PCODE_TJ1)
# define _VodiK_PCODE_TJ1 1

/* mask = zzxxxxxx, id = 876 */
# define VodiK_TJ2_PLATE _VODI_MAKE_PLATEID_TJ(_VodiK_PCODE_TJ2)
# define _VodiK_PCODE_TJ2 2

/* mask = zxxxxxx, id = 877 */
# define VodiK_TJ3_PLATE _VODI_MAKE_PLATEID_TJ(_VodiK_PCODE_TJ3)
# define _VodiK_PCODE_TJ3 3

/* mask = xxxzxxx, id = 878 */
# define VodiK_TJ4_PLATE _VODI_MAKE_PLATEID_TJ(_VodiK_PCODE_TJ4)
# define _VodiK_PCODE_TJ4 4

/* mask = xxxzz, id = 879 */
# define VodiK_TJ5_PLATE _VODI_MAKE_PLATEID_TJ(_VodiK_PCODE_TJ5)
# define _VodiK_PCODE_TJ5 5

/* mask = xxxxzxx, id = 880 */
# define VodiK_TJ6_PLATE _VODI_MAKE_PLATEID_TJ(_VodiK_PCODE_TJ6)
# define _VodiK_PCODE_TJ6 6

/* mask = xxxxzxx, id = 881 */
# define VodiK_TJ7_PLATE _VODI_MAKE_PLATEID_TJ(_VodiK_PCODE_TJ7)
# define _VodiK_PCODE_TJ7 7

/* mask = xxxzzxx, id = 2145 */
# define VodiK_TJ8_PLATE _VODI_MAKE_PLATEID_TJ(_VodiK_PCODE_TJ8)
# define _VodiK_PCODE_TJ8 8
/* @} */


/*
 * TM
 * @{
 */
# define _VODI_MAKE_PLATEID_TM(aCode) _VODI_MAKE_PLATEID(VodiK_TURKMENISTAN_NUMERIC,aCode)

/* mask = zzxxxxzz, id = 882 */
# define VodiK_TM1_PLATE _VODI_MAKE_PLATEID_TM(_VodiK_PCODE_TM1)
# define _VodiK_PCODE_TM1 1

/* mask = zxxxxzz, id = 883 */
# define VodiK_TM2_PLATE _VODI_MAKE_PLATEID_TM(_VodiK_PCODE_TM2)
# define _VodiK_PCODE_TM2 2

/* mask = xxxxzz, id = 885 */
# define VodiK_TM3_PLATE _VODI_MAKE_PLATEID_TM(_VodiK_PCODE_TM3)
# define _VodiK_PCODE_TM3 3

/* mask = xxxxzzz, id = 884 */
# define VodiK_TM4_PLATE _VODI_MAKE_PLATEID_TM(_VodiK_PCODE_TM4)
# define _VodiK_PCODE_TM4 4

/* mask = xxzzxxx, id = 886 */
# define VodiK_TM5_PLATE _VODI_MAKE_PLATEID_TM(_VodiK_PCODE_TM5)
# define _VodiK_PCODE_TM5 5

/* mask = zzzxxxx, id = 887 */
# define VodiK_TM6_PLATE _VODI_MAKE_PLATEID_TM(_VodiK_PCODE_TM6)
# define _VodiK_PCODE_TM6 6
/* @} */


/*
 * TN
 * @{
 */
# define _VODI_MAKE_PLATEID_TN(aCode) _VODI_MAKE_PLATEID(VodiK_TUNISIA_NUMERIC,aCode)

/* mask = xxxxxxx, id = 1211 */
# define VodiK_TN1_PLATE _VODI_MAKE_PLATEID_TN(_VodiK_PCODE_TN1)
# define _VodiK_PCODE_TN1 1

/* mask = xxxxxx, id = 1212 */
# define VodiK_TN2_PLATE _VODI_MAKE_PLATEID_TN(_VodiK_PCODE_TN2)
# define _VodiK_PCODE_TN2 2

/* mask = xxxxx, id = 1214 */
# define VodiK_TN3_PLATE _VODI_MAKE_PLATEID_TN(_VodiK_PCODE_TN3)
# define _VodiK_PCODE_TN3 3

/* mask = xxxxxx, id = 1217 */
# define VodiK_TN4_PLATE _VODI_MAKE_PLATEID_TN(_VodiK_PCODE_TN4)
# define _VodiK_PCODE_TN4 4

/* mask = xxxx, id = 1221 */
# define VodiK_TN5_PLATE _VODI_MAKE_PLATEID_TN(_VodiK_PCODE_TN5)
# define _VodiK_PCODE_TN5 5

/* mask = xxxxxxxx, id = 1218 */
# define VodiK_TN6_PLATE _VODI_MAKE_PLATEID_TN(_VodiK_PCODE_TN6)
# define _VodiK_PCODE_TN6 6

/* mask = xxzzxx, id = 1213 */
# define VodiK_TN7_PLATE _VODI_MAKE_PLATEID_TN(_VodiK_PCODE_TN7)
# define _VodiK_PCODE_TN7 7

/* mask = xxxzzxx, id = 1219 */
# define VodiK_TN8_PLATE _VODI_MAKE_PLATEID_TN(_VodiK_PCODE_TN8)
# define _VodiK_PCODE_TN8 8

/* mask = xxxzzxxx, id = 1223 */
# define VodiK_TN9_PLATE _VODI_MAKE_PLATEID_TN(_VodiK_PCODE_TN9)
# define _VodiK_PCODE_TN9 9

/* mask = xxzzzx, id = 1224 */
# define VodiK_TN10_PLATE _VODI_MAKE_PLATEID_TN(_VodiK_PCODE_TN10)
# define _VodiK_PCODE_TN10 10

/* mask = xxzzzxx, id = 1225 */
# define VodiK_TN11_PLATE _VODI_MAKE_PLATEID_TN(_VodiK_PCODE_TN11)
# define _VodiK_PCODE_TN11 11

/* mask = zzxxxxx, id = 1215 */
# define VodiK_TN12_PLATE _VODI_MAKE_PLATEID_TN(_VodiK_PCODE_TN12)
# define _VodiK_PCODE_TN12 12

/* mask = xxxxxxx, id = 1216 */
# define VodiK_TN13_PLATE _VODI_MAKE_PLATEID_TN(_VodiK_PCODE_TN13)
# define _VodiK_PCODE_TN13 13

/* mask = xxxzzzxxx, id = 1220 */
# define VodiK_TN14_PLATE _VODI_MAKE_PLATEID_TN(_VodiK_PCODE_TN14)
# define _VodiK_PCODE_TN14 14

/* mask = xxxzzxxxx, id = 1222 */
# define VodiK_TN15_PLATE _VODI_MAKE_PLATEID_TN(_VodiK_PCODE_TN15)
# define _VodiK_PCODE_TN15 15

/* mask = xxxxzzxxx, id = 1226 */
# define VodiK_TN16_PLATE _VODI_MAKE_PLATEID_TN(_VodiK_PCODE_TN16)
# define _VodiK_PCODE_TN16 16
/* @} */


/*
* TR
* @{
*/
# define _VODI_MAKE_PLATEID_TR(aCode) _VODI_MAKE_PLATEID(VodiK_TURKEY_NUMERIC,aCode)

/* mask = xxzzxxx, id = 105 */
# define VodiK_TR1_PLATE _VODI_MAKE_PLATEID_TR(_VodiK_PCODE_TR1)
# define _VodiK_PCODE_TR1 1

/* mask = xxzzzxx, id = 106 */
# define VodiK_TR2_PLATE _VODI_MAKE_PLATEID_TR(_VodiK_PCODE_TR2)
# define _VodiK_PCODE_TR2 2

/* mask = xxzzxxx, id = 107 */
# define VodiK_TR3_PLATE _VODI_MAKE_PLATEID_TR(_VodiK_PCODE_TR3)
# define _VodiK_PCODE_TR3 3

/* mask = xxzzxxxx, id = 108 */
# define VodiK_TR4_PLATE _VODI_MAKE_PLATEID_TR(_VodiK_PCODE_TR4)
# define _VodiK_PCODE_TR4 4

/* mask = xxzxxxx, id = 109 */
# define VodiK_TR5_PLATE _VODI_MAKE_PLATEID_TR(_VodiK_PCODE_TR5)
# define _VodiK_PCODE_TR5 5

/* mask = xxzxxxxx, id = 1282 */
# define VodiK_TR6_PLATE _VODI_MAKE_PLATEID_TR(_VodiK_PCODE_TR6)
# define _VodiK_PCODE_TR6 6

/* mask = xxzxxxx, id = 626 */
# define VodiK_TR7_PLATE _VODI_MAKE_PLATEID_TR(_VodiK_PCODE_TR7)
# define _VodiK_PCODE_TR7 7

/* mask = xxzzxxxx, id = 627 */
# define VodiK_TR8_PLATE _VODI_MAKE_PLATEID_TR(_VodiK_PCODE_TR8)
# define _VodiK_PCODE_TR8 8

/* mask = xxzzzxx, id = 1820 */
# define VodiK_TR9_PLATE _VODI_MAKE_PLATEID_TR(_VodiK_PCODE_TR9)
# define _VodiK_PCODE_TR9 9

/* mask = xxzxxxx, id = 1821 */
# define VodiK_TR10_PLATE _VODI_MAKE_PLATEID_TR(_VodiK_PCODE_TR10)
# define _VodiK_PCODE_TR10 10

/* mask = xxzzxxxx, id = 1822 */
# define VodiK_TR11_PLATE _VODI_MAKE_PLATEID_TR(_VodiK_PCODE_TR11)
# define _VodiK_PCODE_TR11 11

/* mask = xxzzxxx, id = 1823 */
# define VodiK_TR12_PLATE _VODI_MAKE_PLATEID_TR(_VodiK_PCODE_TR12)
# define _VodiK_PCODE_TR12 12

/* mask = xxzzzxxx, id = 1824 */
# define VodiK_TR13_PLATE _VODI_MAKE_PLATEID_TR(_VodiK_PCODE_TR13)
# define _VodiK_PCODE_TR13 13

/* mask = xxzzxxx, id = 1825 */
# define VodiK_TR14_PLATE _VODI_MAKE_PLATEID_TR(_VodiK_PCODE_TR14)
# define _VodiK_PCODE_TR14 14

/* mask = xxzzzxxx, id = 1826 */
# define VodiK_TR15_PLATE _VODI_MAKE_PLATEID_TR(_VodiK_PCODE_TR15)
# define _VodiK_PCODE_TR15 15

/* mask = xxzzxxxx, id = 1827 */
# define VodiK_TR16_PLATE _VODI_MAKE_PLATEID_TR(_VodiK_PCODE_TR16)
# define _VodiK_PCODE_TR16 16

/* mask = xxzxxxx, id = 1828 */
# define VodiK_TR17_PLATE _VODI_MAKE_PLATEID_TR(_VodiK_PCODE_TR17)
# define _VodiK_PCODE_TR17 17

/* mask = xxzzzxx, id = 1829 */
# define VodiK_TR18_PLATE _VODI_MAKE_PLATEID_TR(_VodiK_PCODE_TR18)
# define _VodiK_PCODE_TR18 18

/* mask = xxzxxxx, id = 1830 */
# define VodiK_TR19_PLATE _VODI_MAKE_PLATEID_TR(_VodiK_PCODE_TR19)
# define _VodiK_PCODE_TR19 19

/* mask = xxzzxxx, id = 1831 */
# define VodiK_TR20_PLATE _VODI_MAKE_PLATEID_TR(_VodiK_PCODE_TR20)
# define _VodiK_PCODE_TR20 20

/* mask = xxzzzxx, id = 1832 */
# define VodiK_TR21_PLATE _VODI_MAKE_PLATEID_TR(_VodiK_PCODE_TR21)
# define _VodiK_PCODE_TR21 21

/* mask = xxzzzxxx, id = 1833 */
# define VodiK_TR22_PLATE _VODI_MAKE_PLATEID_TR(_VodiK_PCODE_TR22)
# define _VodiK_PCODE_TR22 22

/* mask = xxzzxxxx, id = 1834 */
# define VodiK_TR23_PLATE _VODI_MAKE_PLATEID_TR(_VodiK_PCODE_TR23)
# define _VodiK_PCODE_TR23 23

/* mask = xxzzxxxx, id = 1835 */
# define VodiK_TR24_PLATE _VODI_MAKE_PLATEID_TR(_VodiK_PCODE_TR24)
# define _VodiK_PCODE_TR24 24

/* mask = xxzxxxx, id = 1836 */
# define VodiK_TR25_PLATE _VODI_MAKE_PLATEID_TR(_VodiK_PCODE_TR25)
# define _VodiK_PCODE_TR25 25

/* mask = xxzxxxxx, id = 2001 */
# define VodiK_TR26_PLATE _VODI_MAKE_PLATEID_TR(_VodiK_PCODE_TR26)
# define _VodiK_PCODE_TR26 26
/* @} */


/*
 * TW
 * @{
 */
# define _VODI_MAKE_PLATEID_TW(aCode) _VODI_MAKE_PLATEID(VodiK_TAIWAN_NUMERIC,aCode)

/* mask = XXXXZZ, id = 115 */
# define VodiK_TW1_PLATE _VODI_MAKE_PLATEID_TW(_VodiK_PCODE_TW1)
# define _VodiK_PCODE_TW1 1

/* mask = XZXXXX, id = 116 */
# define VodiK_TW2_PLATE _VODI_MAKE_PLATEID_TW(_VodiK_PCODE_TW2)
# define _VodiK_PCODE_TW2 2

/* mask = ZZXXXX, id = 117 */
# define VodiK_TW3_PLATE _VODI_MAKE_PLATEID_TW(_VodiK_PCODE_TW3)
# define _VodiK_PCODE_TW3 3

/* mask = ZXXXXX, id = 118 */
# define VodiK_TW4_PLATE _VODI_MAKE_PLATEID_TW(_VodiK_PCODE_TW4)
# define _VodiK_PCODE_TW4 4

/* mask = zzzxxxx, id = 1241 */
# define VodiK_TW5_PLATE _VODI_MAKE_PLATEID_TW(_VodiK_PCODE_TW5)
# define _VodiK_PCODE_TW5 5

/* mask = xxxxzx, id = 1242 */
# define VodiK_TW6_PLATE _VODI_MAKE_PLATEID_TW(_VodiK_PCODE_TW6)
# define _VodiK_PCODE_TW6 6

/* mask = xxxxxx, id = 1243 */
# define VodiK_TW7_PLATE _VODI_MAKE_PLATEID_TW(_VodiK_PCODE_TW7)
# define _VodiK_PCODE_TW7 7

/* mask = ZZZXXX, id = 119 */
# define VodiK_TW8_PLATE _VODI_MAKE_PLATEID_TW(_VodiK_PCODE_TW8)
# define _VodiK_PCODE_TW8 8

/* mask = ZZXXXX, id = 120 */
# define VodiK_TW9_PLATE _VODI_MAKE_PLATEID_TW(_VodiK_PCODE_TW9)
# define _VodiK_PCODE_TW9 9

/* mask = ZZZXXX, id = 121 */
# define VodiK_TW10_PLATE _VODI_MAKE_PLATEID_TW(_VodiK_PCODE_TW10)
# define _VodiK_PCODE_TW10 10

/* mask = ZZXXXX, id = 122 */
# define VodiK_TW11_PLATE _VODI_MAKE_PLATEID_TW(_VodiK_PCODE_TW11)
# define _VodiK_PCODE_TW11 11

/* mask = ZZXXX, id = 123 */
# define VodiK_TW12_PLATE _VODI_MAKE_PLATEID_TW(_VodiK_PCODE_TW12)
# define _VodiK_PCODE_TW12 12

/* mask = ZXXXX, id = 124 */
# define VodiK_TW13_PLATE _VODI_MAKE_PLATEID_TW(_VodiK_PCODE_TW13)
# define _VodiK_PCODE_TW13 13

/* mask = XXXZZ, id = 260 */
# define VodiK_TW14_PLATE _VODI_MAKE_PLATEID_TW(_VodiK_PCODE_TW14)
# define _VodiK_PCODE_TW14 14

/* mask = ZZXXX, id = 261 */
# define VodiK_TW15_PLATE _VODI_MAKE_PLATEID_TW(_VodiK_PCODE_TW15)
# define _VodiK_PCODE_TW15 15

/* mask = XXXZZ, id = 262 */
# define VodiK_TW16_PLATE _VODI_MAKE_PLATEID_TW(_VodiK_PCODE_TW16)
# define _VodiK_PCODE_TW16 16

/* mask = ZXXXXX, id = 263 */
# define VodiK_TW17_PLATE _VODI_MAKE_PLATEID_TW(_VodiK_PCODE_TW17)
# define _VodiK_PCODE_TW17 17

/* mask = XZXXX, id = 264 */
# define VodiK_TW18_PLATE _VODI_MAKE_PLATEID_TW(_VodiK_PCODE_TW18)
# define _VodiK_PCODE_TW18 18

/* mask = ZXXXXX, id = 265 */
# define VodiK_TW19_PLATE _VODI_MAKE_PLATEID_TW(_VodiK_PCODE_TW19)
# define _VodiK_PCODE_TW19 19

/* mask = ZXZXXX, id = 266 */
# define VodiK_TW20_PLATE _VODI_MAKE_PLATEID_TW(_VodiK_PCODE_TW20)
# define _VodiK_PCODE_TW20 20

/* mask = XZZXXX, id = 267 */
# define VodiK_TW21_PLATE _VODI_MAKE_PLATEID_TW(_VodiK_PCODE_TW21)
# define _VodiK_PCODE_TW21 21

/* mask = XXXZZZ, id = 268 */
# define VodiK_TW22_PLATE _VODI_MAKE_PLATEID_TW(_VodiK_PCODE_TW22)
# define _VodiK_PCODE_TW22 22

/* mask = XXXZZZ, id = 269 */
# define VodiK_TW23_PLATE _VODI_MAKE_PLATEID_TW(_VodiK_PCODE_TW23)
# define _VodiK_PCODE_TW23 23

/* mask = ZZXX, id = 270 */
# define VodiK_TW24_PLATE _VODI_MAKE_PLATEID_TW(_VodiK_PCODE_TW24)
# define _VodiK_PCODE_TW24 24

/* mask = XXXX, id = 271 */
# define VodiK_TW25_PLATE _VODI_MAKE_PLATEID_TW(_VodiK_PCODE_TW25)
# define _VodiK_PCODE_TW25 25

/* mask = XXZZ, id = 272 */
# define VodiK_TW26_PLATE _VODI_MAKE_PLATEID_TW(_VodiK_PCODE_TW26)
# define _VodiK_PCODE_TW26 26

/* mask = ZZXX, id = 273 */
# define VodiK_TW27_PLATE _VODI_MAKE_PLATEID_TW(_VodiK_PCODE_TW27)
# define _VodiK_PCODE_TW27 27

/* mask = ZXXX, id = 274 */
# define VodiK_TW28_PLATE _VODI_MAKE_PLATEID_TW(_VodiK_PCODE_TW28)
# define _VodiK_PCODE_TW28 28

/* mask = ZZZX, id = 275 */
# define VodiK_TW29_PLATE _VODI_MAKE_PLATEID_TW(_VodiK_PCODE_TW29)
# define _VodiK_PCODE_TW29 29

/* mask = XZXX, id = 276 */
# define VodiK_TW30_PLATE _VODI_MAKE_PLATEID_TW(_VodiK_PCODE_TW30)
# define _VodiK_PCODE_TW30 30

/* mask = XXZZ, id = 277 */
# define VodiK_TW31_PLATE _VODI_MAKE_PLATEID_TW(_VodiK_PCODE_TW31)
# define _VodiK_PCODE_TW31 31

/* mask = XZXXX, id = 278 */
# define VodiK_TW32_PLATE _VODI_MAKE_PLATEID_TW(_VodiK_PCODE_TW32)
# define _VodiK_PCODE_TW32 32

/* mask = ZXXXX, id = 279 */
# define VodiK_TW33_PLATE _VODI_MAKE_PLATEID_TW(_VodiK_PCODE_TW33)
# define _VodiK_PCODE_TW33 33

/* mask = XXXXZ, id = 1611 */
# define VodiK_TW34_PLATE _VODI_MAKE_PLATEID_TW(_VodiK_PCODE_TW34)
# define _VodiK_PCODE_TW34 34
/* @} */


/*
 * UA
 * @{
 */
# define _VODI_MAKE_PLATEID_UA(aCode) _VODI_MAKE_PLATEID(VodiK_UKRAINE_NUMERIC,aCode)

/* mask = ZZXXXXZZ, id = 1 */
# define VodiK_UA1_PLATE _VODI_MAKE_PLATEID_UA(_VodiK_PCODE_UA1)
# define _VodiK_PCODE_UA1 1

/* mask = XXXXXZZ, id = 2 */
# define VodiK_UA2_PLATE _VODI_MAKE_PLATEID_UA(_VodiK_PCODE_UA2)
# define _VodiK_PCODE_UA2 2

/* mask = XXXX, id = 4, police */
# define VodiK_UA3_PLATE _VODI_MAKE_PLATEID_UA(_VodiK_PCODE_UA3)
# define _VodiK_PCODE_UA3 3
# define VodiK_UA_POLICE_TYPE (4)

/* mask = ZXXXXXX, id = 20 */
# define VodiK_UA4_PLATE _VODI_MAKE_PLATEID_UA(_VodiK_PCODE_UA4)
# define _VodiK_PCODE_UA4 4

/* mask = xxZZXXXX, id = 21 */
# define VodiK_UA5_PLATE _VODI_MAKE_PLATEID_UA(_VodiK_PCODE_UA5)
# define _VodiK_PCODE_UA5 5

/* mask = XXXXZX, id = 22 */
# define VodiK_UA6_PLATE _VODI_MAKE_PLATEID_UA(_VodiK_PCODE_UA6)
# define _VodiK_PCODE_UA6 6

/* mask = ZZZXXX, id = 1328 */
# define VodiK_UA7_PLATE _VODI_MAKE_PLATEID_UA(_VodiK_PCODE_UA7)
# define _VodiK_PCODE_UA7 7

/* mask = ZZXXXXXX, id = 1329 */
# define VodiK_UA8_PLATE _VODI_MAKE_PLATEID_UA(_VodiK_PCODE_UA8)
# define _VodiK_PCODE_UA8 8

/* mask = ZZZZXXXX, id = 1330, two row */
# define VodiK_UA9_PLATE _VODI_MAKE_PLATEID_UA(_VodiK_PCODE_UA9)
# define _VodiK_PCODE_UA9 9

/* mask = ZZZZXXXX, id = 1331, two row */
# define VodiK_UA10_PLATE _VODI_MAKE_PLATEID_UA(_VodiK_PCODE_UA10)
# define _VodiK_PCODE_UA10 10

/* mask = ZZZZXXXX, id = 1332, two row, inversed */
# define VodiK_UA11_PLATE _VODI_MAKE_PLATEID_UA(_VodiK_PCODE_UA11)
# define _VodiK_PCODE_UA11 11

/* mask = ZXZZXXXX, id = 1333, two row, inversed */
# define VodiK_UA12_PLATE _VODI_MAKE_PLATEID_UA(_VodiK_PCODE_UA12)
# define _VodiK_PCODE_UA12 12

/* mask = XXXXZX, id = 1334, two row, inversed */
# define VodiK_UA13_PLATE _VODI_MAKE_PLATEID_UA(_VodiK_PCODE_UA13)
# define _VodiK_PCODE_UA13 13

/* mask = XXZZXXXX, id = 1335, two row, inversed */
# define VodiK_UA14_PLATE _VODI_MAKE_PLATEID_UA(_VodiK_PCODE_UA14)
# define _VodiK_PCODE_UA14 14

/* mask = XXXXXZZ, id = 1336, two row */
# define VodiK_UA15_PLATE _VODI_MAKE_PLATEID_UA(_VodiK_PCODE_UA15)
# define _VodiK_PCODE_UA15 15

/* mask = ZZXXXX, id = 1337, two row, inversed */
# define VodiK_UA16_PLATE _VODI_MAKE_PLATEID_UA(_VodiK_PCODE_UA16)
# define _VodiK_PCODE_UA16 16

/* mask = XXXXXZZZ, id = 1338, two row */
# define VodiK_UA17_PLATE _VODI_MAKE_PLATEID_UA(_VodiK_PCODE_UA17)
# define _VodiK_PCODE_UA17 17

/* mask = ZZZZXXXX, id = 1365, two row */
# define VodiK_UA18_PLATE _VODI_MAKE_PLATEID_UA(_VodiK_PCODE_UA18)
# define _VodiK_PCODE_UA18 18

/* mask = xxzzxxxx, id = 2194 */
# define VodiK_UA19_PLATE _VODI_MAKE_PLATEID_UA(_VodiK_PCODE_UA19)
# define _VodiK_PCODE_UA19 19

/* mask = xxxxxzz, id = 2195 */
# define VodiK_UA20_PLATE _VODI_MAKE_PLATEID_UA(_VodiK_PCODE_UA20)
# define _VodiK_PCODE_UA20 20

/* mask = xxxxxzzz, id = 2196 */
# define VodiK_UA21_PLATE _VODI_MAKE_PLATEID_UA(_VodiK_PCODE_UA21)
# define _VodiK_PCODE_UA21 21

/* mask = zzxxxx, id = 2203 */
# define VodiK_UA22_PLATE _VODI_MAKE_PLATEID_UA(_VodiK_PCODE_UA22)
# define _VodiK_PCODE_UA22 22

/* mask = ZZXXXZ, id = 2248 */
# define VodiK_UA23_PLATE _VODI_MAKE_PLATEID_UA(_VodiK_PCODE_UA23)
# define _VodiK_PCODE_UA23 23

/* mask = ZZXXXZ, id = 2249 */
# define VodiK_UA24_PLATE _VODI_MAKE_PLATEID_UA(_VodiK_PCODE_UA24)
# define _VodiK_PCODE_UA24 24

/* mask = ZZZXXX, id = 2250 */
# define VodiK_UA25_PLATE _VODI_MAKE_PLATEID_UA(_VodiK_PCODE_UA25)
# define _VodiK_PCODE_UA25 25

/* mask = ZZXXXXXX, id = 2251 */
# define VodiK_UA26_PLATE _VODI_MAKE_PLATEID_UA(_VodiK_PCODE_UA26)
# define _VodiK_PCODE_UA26 26

/* mask = ZXXXXXX, id = 2252 */
# define VodiK_UA27_PLATE _VODI_MAKE_PLATEID_UA(_VodiK_PCODE_UA27)
# define _VodiK_PCODE_UA27 27

/* mask = XXXXXZZ, id = 2253 */
# define VodiK_UA28_PLATE _VODI_MAKE_PLATEID_UA(_VodiK_PCODE_UA28)
# define _VodiK_PCODE_UA28 28

/* mask = zzzzzzzx, id = 2254 */
# define VodiK_UA29_PLATE _VODI_MAKE_PLATEID_UA(_VodiK_PCODE_UA29)
# define _VodiK_PCODE_UA29 29

/* mask = zzzzzzzx, id = 2267 */
# define VodiK_UA30_PLATE _VODI_MAKE_PLATEID_UA(_VodiK_PCODE_UA30)
# define _VodiK_PCODE_UA30 30
/* @} */

/*
* US
* @{
*/
# define _VODI_MAKE_PLATEID_US(aSubdivision,aCode) \
_VODI_MAKE_PLATEID3(VodiK_UNITED_STATES_NUMERIC,aSubdivision,aCode)

/*
 * US_AK
 * @{
 */
# define _VODI_MAKE_PLATEID_US_AK(aCode) \
_VODI_MAKE_PLATEID_US(VodiK_US_AK_SUBNUM,aCode)

/* mask = zzzxxx, id = 908 */
# define VodiK_US_AK1_PLATE _VODI_MAKE_PLATEID_US_AK(_VodiK_PCODE_US_AK1)
# define _VodiK_PCODE_US_AK1 1

/* mask = zzzxxx, id = 909 */
# define VodiK_US_AK2_PLATE _VODI_MAKE_PLATEID_US_AK(_VodiK_PCODE_US_AK2)
# define _VodiK_PCODE_US_AK2 2

/* mask = zzxxx, id = 907 */
# define VodiK_US_AK3_PLATE _VODI_MAKE_PLATEID_US_AK(_VodiK_PCODE_US_AK3)
# define _VodiK_PCODE_US_AK3 3

/* mask = zzzxxx, id = 910 */
# define VodiK_US_AK4_PLATE _VODI_MAKE_PLATEID_US_AK(_VodiK_PCODE_US_AK4)
# define _VodiK_PCODE_US_AK4 4

/* mask = zzzxxx, id = 911 */
# define VodiK_US_AK5_PLATE _VODI_MAKE_PLATEID_US_AK(_VodiK_PCODE_US_AK5)
# define _VodiK_PCODE_US_AK5 5
/* @} */


/*
 * US_AL
 * @{
 */
# define _VODI_MAKE_PLATEID_US_AL(aCode) \
_VODI_MAKE_PLATEID_US(VodiK_US_AL_SUBNUM,aCode)

/* mask = xzxxzxx, id = 903 */
# define VodiK_US_AL1_PLATE _VODI_MAKE_PLATEID_US_AL(_VodiK_PCODE_US_AL1)
# define _VodiK_PCODE_US_AL1 1

/* mask = xxzxxzx, id = 904 */
# define VodiK_US_AL2_PLATE _VODI_MAKE_PLATEID_US_AL(_VodiK_PCODE_US_AL2)
# define _VodiK_PCODE_US_AL2 2

/* mask = xxxxxzz, id = 905 */
# define VodiK_US_AL3_PLATE _VODI_MAKE_PLATEID_US_AL(_VodiK_PCODE_US_AL3)
# define _VodiK_PCODE_US_AL3 3

/* mask = zzxxxxx, id = 906 */
# define VodiK_US_AL4_PLATE _VODI_MAKE_PLATEID_US_AL(_VodiK_PCODE_US_AL4)
# define _VodiK_PCODE_US_AL4 4
/* @} */


/*
 * US_AR
 * @{
 */
# define _VODI_MAKE_PLATEID_US_AR(aCode) \
_VODI_MAKE_PLATEID_US(VodiK_US_AR_SUBNUM,aCode)

/* mask = xxxzzz, id = 925 */
# define VodiK_US_AR1_PLATE _VODI_MAKE_PLATEID_US_AR(_VodiK_PCODE_US_AR1)
# define _VodiK_PCODE_US_AR1 1

/* mask = zzzxxx, id = 926 */
# define VodiK_US_AR2_PLATE _VODI_MAKE_PLATEID_US_AR(_VodiK_PCODE_US_AR2)
# define _VodiK_PCODE_US_AR2 2

/* mask = zzxzzz, id = 927 */
# define VodiK_US_AR3_PLATE _VODI_MAKE_PLATEID_US_AR(_VodiK_PCODE_US_AR3)
# define _VodiK_PCODE_US_AR3 3

/* mask = zzzxxxx, id = 928 */
# define VodiK_US_AR4_PLATE _VODI_MAKE_PLATEID_US_AR(_VodiK_PCODE_US_AR4)
# define _VodiK_PCODE_US_AR4 4
/* @} */


/*
 * US_AZ
 * @{
 */
# define _VODI_MAKE_PLATEID_US_AZ(aCode) \
_VODI_MAKE_PLATEID_US(VodiK_US_AZ_SUBNUM,aCode)

/* mask = xxxzzz, id = 913 */
# define VodiK_US_AZ1_PLATE _VODI_MAKE_PLATEID_US_AZ(_VodiK_PCODE_US_AZ1)
# define _VodiK_PCODE_US_AZ1 1

/* mask = zzzxxxx, id = 919 */
# define VodiK_US_AZ2_PLATE _VODI_MAKE_PLATEID_US_AZ(_VodiK_PCODE_US_AZ2)
# define _VodiK_PCODE_US_AZ2 2

/* mask = zzzxxx, id = 921 */
# define VodiK_US_AZ3_PLATE _VODI_MAKE_PLATEID_US_AZ(_VodiK_PCODE_US_AZ3)
# define _VodiK_PCODE_US_AZ3 3

/* mask = zzxzzz, id = 912 */
# define VodiK_US_AZ4_PLATE _VODI_MAKE_PLATEID_US_AZ(_VodiK_PCODE_US_AZ4)
# define _VodiK_PCODE_US_AZ4 4

/* mask = zzzzzx, id = 914 */
# define VodiK_US_AZ5_PLATE _VODI_MAKE_PLATEID_US_AZ(_VodiK_PCODE_US_AZ5)
# define _VodiK_PCODE_US_AZ5 5

/* mask = zzxxxx, id = 915 */
# define VodiK_US_AZ6_PLATE _VODI_MAKE_PLATEID_US_AZ(_VodiK_PCODE_US_AZ6)
# define _VodiK_PCODE_US_AZ6 6

/* mask = zzxxxz, id = 916 */
# define VodiK_US_AZ7_PLATE _VODI_MAKE_PLATEID_US_AZ(_VodiK_PCODE_US_AZ7)
# define _VodiK_PCODE_US_AZ7 7

/* mask = zxzzz, id = 917 */
# define VodiK_US_AZ8_PLATE _VODI_MAKE_PLATEID_US_AZ(_VodiK_PCODE_US_AZ8)
# define _VodiK_PCODE_US_AZ8 8

/* mask = zzxxxxx, id = 918 */
# define VodiK_US_AZ9_PLATE _VODI_MAKE_PLATEID_US_AZ(_VodiK_PCODE_US_AZ9)
# define _VodiK_PCODE_US_AZ9 9

/* mask = zzxxxx, id = 920 */
# define VodiK_US_AZ10_PLATE _VODI_MAKE_PLATEID_US_AZ(_VodiK_PCODE_US_AZ10)
# define _VodiK_PCODE_US_AZ10 10

/* mask = zxxxx, id = 922 */
# define VodiK_US_AZ11_PLATE _VODI_MAKE_PLATEID_US_AZ(_VodiK_PCODE_US_AZ11)
# define _VodiK_PCODE_US_AZ11 11

/* mask = zzxx, id = 923 */
# define VodiK_US_AZ12_PLATE _VODI_MAKE_PLATEID_US_AZ(_VodiK_PCODE_US_AZ12)
# define _VodiK_PCODE_US_AZ12 12

/* mask = zzzxx, id = 924 */
# define VodiK_US_AZ13_PLATE _VODI_MAKE_PLATEID_US_AZ(_VodiK_PCODE_US_AZ13)
# define _VodiK_PCODE_US_AZ13 13
/* @} */


/*
 * US_CA
 * @{
 */
# define _VODI_MAKE_PLATEID_US_CA(aCode) \
_VODI_MAKE_PLATEID_US(VodiK_US_CA_SUBNUM,aCode)

/* mask = xzzzxxx, id = 930 */
# define VodiK_US_CA1_PLATE _VODI_MAKE_PLATEID_US_CA(_VodiK_PCODE_US_CA1)
# define _VodiK_PCODE_US_CA1 1

/* mask = xzxxxxx, id = 929 */
# define VodiK_US_CA2_PLATE _VODI_MAKE_PLATEID_US_CA(_VodiK_PCODE_US_CA2)
# define _VodiK_PCODE_US_CA2 2

/* mask = xzzxxxx, id = 931 */
# define VodiK_US_CA3_PLATE _VODI_MAKE_PLATEID_US_CA(_VodiK_PCODE_US_CA3)
# define _VodiK_PCODE_US_CA3 3

/* mask = zzzxxxx, id = 932 */
# define VodiK_US_CA4_PLATE _VODI_MAKE_PLATEID_US_CA(_VodiK_PCODE_US_CA4)
# define _VodiK_PCODE_US_CA4 4

/* mask = zzzxxxxxz, id = 933 */
# define VodiK_US_CA5_PLATE _VODI_MAKE_PLATEID_US_CA(_VodiK_PCODE_US_CA5)
# define _VodiK_PCODE_US_CA5 5

/* mask = zxxxzx, id = 1961 */
# define VodiK_US_CA6_PLATE _VODI_MAKE_PLATEID_US_CA(_VodiK_PCODE_US_CA6)
# define _VodiK_PCODE_US_CA6 6

/* mask = xzxxxxx, id = 1962 */
# define VodiK_US_CA7_PLATE _VODI_MAKE_PLATEID_US_CA(_VodiK_PCODE_US_CA7)
# define _VodiK_PCODE_US_CA7 7

/* mask = zzzzzzz, id = 1955 */
# define VodiK_US_CA8_PLATE _VODI_MAKE_PLATEID_US_CA(_VodiK_PCODE_US_CA8)
# define _VodiK_PCODE_US_CA8 8

/* mask = xzxxxxx, id = 929 */
# define VodiK_US_CA9_PLATE _VODI_MAKE_PLATEID_US_CA(_VodiK_PCODE_US_CA9)
# define _VodiK_PCODE_US_CA9 9

/* mask = xzzxxxx, id = 931 */
# define VodiK_US_CA10_PLATE _VODI_MAKE_PLATEID_US_CA(_VodiK_PCODE_US_CA10)
# define _VodiK_PCODE_US_CA10 10

/* mask = zzzxxxx, id = 932 */
# define VodiK_US_CA11_PLATE _VODI_MAKE_PLATEID_US_CA(_VodiK_PCODE_US_CA11)
# define _VodiK_PCODE_US_CA11 11

/* mask = zzzxxxxxz, id = 933 */
# define VodiK_US_CA12_PLATE _VODI_MAKE_PLATEID_US_CA(_VodiK_PCODE_US_CA12)
# define _VodiK_PCODE_US_CA12 12

/* mask = zxxxzzz, id = 1958 */
# define VodiK_US_CA13_PLATE _VODI_MAKE_PLATEID_US_CA(_VodiK_PCODE_US_CA13)
# define _VodiK_PCODE_US_CA13 13
/* @} */


/*
 * US_CO
 * @{
 */
# define _VODI_MAKE_PLATEID_US_CO(aCode) \
_VODI_MAKE_PLATEID_US(VodiK_US_CO_SUBNUM,aCode)

/* mask = xxxzzz, id = 934 */
# define VodiK_US_CO1_PLATE _VODI_MAKE_PLATEID_US_CO(_VodiK_PCODE_US_CO1)
# define _VodiK_PCODE_US_CO1 1

/* mask = zzzxxxx, id = 935 */
# define VodiK_US_CO2_PLATE _VODI_MAKE_PLATEID_US_CO(_VodiK_PCODE_US_CO2)
# define _VodiK_PCODE_US_CO2 2

/* mask = zzxxxx, id = 936 */
# define VodiK_US_CO3_PLATE _VODI_MAKE_PLATEID_US_CO(_VodiK_PCODE_US_CO3)
# define _VodiK_PCODE_US_CO3 3
/* @} */


/*
 * US_CT
 * @{
 */
# define _VODI_MAKE_PLATEID_US_CT(aCode) \
_VODI_MAKE_PLATEID_US(VodiK_US_CT_SUBNUM,aCode)

/* mask = xxxzzz, id = 937 */
# define VodiK_US_CT1_PLATE _VODI_MAKE_PLATEID_US_CT(_VodiK_PCODE_US_CT1)
# define _VodiK_PCODE_US_CT1 1

/* mask = zzxxxx, id = 939 */
# define VodiK_US_CT2_PLATE _VODI_MAKE_PLATEID_US_CT(_VodiK_PCODE_US_CT2)
# define _VodiK_PCODE_US_CT2 2

/* mask = xxxxxx, id = 940 */
# define VodiK_US_CT3_PLATE _VODI_MAKE_PLATEID_US_CT(_VodiK_PCODE_US_CT3)
# define _VodiK_PCODE_US_CT3 3

/* mask = xxxxz, id = 938 */
# define VodiK_US_CT4_PLATE _VODI_MAKE_PLATEID_US_CT(_VodiK_PCODE_US_CT4)
# define _VodiK_PCODE_US_CT4 4
/* @} */


/*
 * US_DC
 * @{
 */
# define _VODI_MAKE_PLATEID_US_DC(aCode) \
_VODI_MAKE_PLATEID_US(VodiK_US_DC_SUBNUM,aCode)

/* mask = zzxxxx, id = 948 */
# define VodiK_US_DC1_PLATE _VODI_MAKE_PLATEID_US_DC(_VodiK_PCODE_US_DC1)
# define _VodiK_PCODE_US_DC1 1

/* mask = xxxxxx, id = 951 */
# define VodiK_US_DC2_PLATE _VODI_MAKE_PLATEID_US_DC(_VodiK_PCODE_US_DC2)
# define _VodiK_PCODE_US_DC2 2

/* mask = zzxxxx, id = 954 */
# define VodiK_US_DC3_PLATE _VODI_MAKE_PLATEID_US_DC(_VodiK_PCODE_US_DC3)
# define _VodiK_PCODE_US_DC3 3

/* mask = zzxxxx, id = 956 */
# define VodiK_US_DC4_PLATE _VODI_MAKE_PLATEID_US_DC(_VodiK_PCODE_US_DC4)
# define _VodiK_PCODE_US_DC4 4

/* mask = zxxxx, id = 947 */
# define VodiK_US_DC5_PLATE _VODI_MAKE_PLATEID_US_DC(_VodiK_PCODE_US_DC5)
# define _VodiK_PCODE_US_DC5 5

/* mask = zzzxxxx, id = 949 */
# define VodiK_US_DC6_PLATE _VODI_MAKE_PLATEID_US_DC(_VodiK_PCODE_US_DC6)
# define _VodiK_PCODE_US_DC6 6

/* mask = xxxxxz, id = 950 */
# define VodiK_US_DC7_PLATE _VODI_MAKE_PLATEID_US_DC(_VodiK_PCODE_US_DC7)
# define _VodiK_PCODE_US_DC7 7

/* mask = xxxxxx, id = 952 */
# define VodiK_US_DC8_PLATE _VODI_MAKE_PLATEID_US_DC(_VodiK_PCODE_US_DC8)
# define _VodiK_PCODE_US_DC8 8

/* mask = zzxxx, id = 953 */
# define VodiK_US_DC9_PLATE _VODI_MAKE_PLATEID_US_DC(_VodiK_PCODE_US_DC9)
# define _VodiK_PCODE_US_DC9 9

/* mask = xxxxx, id = 955 */
# define VodiK_US_DC10_PLATE _VODI_MAKE_PLATEID_US_DC(_VodiK_PCODE_US_DC10)
# define _VodiK_PCODE_US_DC10 10

/* mask = zzzxxx, id = 957 */
# define VodiK_US_DC11_PLATE _VODI_MAKE_PLATEID_US_DC(_VodiK_PCODE_US_DC11)
# define _VodiK_PCODE_US_DC11 11
/* @} */


/*
 * US_DE
 * @{
 */
# define _VODI_MAKE_PLATEID_US_DE(aCode) \
_VODI_MAKE_PLATEID_US(VodiK_US_DE_SUBNUM,aCode)

/* mask = xxxxxx, id = 941 */
# define VodiK_US_DE1_PLATE _VODI_MAKE_PLATEID_US_DE(_VodiK_PCODE_US_DE1)
# define _VodiK_PCODE_US_DE1 1

/* mask = zzxxxxxx, id = 942 */
# define VodiK_US_DE2_PLATE _VODI_MAKE_PLATEID_US_DE(_VodiK_PCODE_US_DE2)
# define _VodiK_PCODE_US_DE2 2

/* mask = xxxx, id = 943 */
# define VodiK_US_DE3_PLATE _VODI_MAKE_PLATEID_US_DE(_VodiK_PCODE_US_DE3)
# define _VodiK_PCODE_US_DE3 3

/* mask = zzxxxx, id = 944 */
# define VodiK_US_DE4_PLATE _VODI_MAKE_PLATEID_US_DE(_VodiK_PCODE_US_DE4)
# define _VodiK_PCODE_US_DE4 4

/* mask = zzxxxxxx, id = 945 */
# define VodiK_US_DE5_PLATE _VODI_MAKE_PLATEID_US_DE(_VodiK_PCODE_US_DE5)
# define _VodiK_PCODE_US_DE5 5
/* @} */


/*
 * US_FL
 * @{
 */
# define _VODI_MAKE_PLATEID_US_FL(aCode) \
_VODI_MAKE_PLATEID_US(VodiK_US_FL_SUBNUM,aCode)

/* mask = zxxzzz, id = 963 */
# define VodiK_US_FL1_PLATE _VODI_MAKE_PLATEID_US_FL(_VodiK_PCODE_US_FL1)
# define _VodiK_PCODE_US_FL1 1

/* mask = xxxxzz, id = 964 */
# define VodiK_US_FL2_PLATE _VODI_MAKE_PLATEID_US_FL(_VodiK_PCODE_US_FL2)
# define _VodiK_PCODE_US_FL2 2

/* mask = xxxxxz, id = 962 */
# define VodiK_US_FL3_PLATE _VODI_MAKE_PLATEID_US_FL(_VodiK_PCODE_US_FL3)
# define _VodiK_PCODE_US_FL3 3

/* mask = xxxxx, id = 958 */
# define VodiK_US_FL4_PLATE _VODI_MAKE_PLATEID_US_FL(_VodiK_PCODE_US_FL4)
# define _VodiK_PCODE_US_FL4 4

/* mask = xxxx, id = 959 */
# define VodiK_US_FL5_PLATE _VODI_MAKE_PLATEID_US_FL(_VodiK_PCODE_US_FL5)
# define _VodiK_PCODE_US_FL5 5

/* mask = zzxxxz, id = 960 */
# define VodiK_US_FL6_PLATE _VODI_MAKE_PLATEID_US_FL(_VodiK_PCODE_US_FL6)
# define _VodiK_PCODE_US_FL6 6

/* mask = zzxxxxx, id = 961 */
# define VodiK_US_FL7_PLATE _VODI_MAKE_PLATEID_US_FL(_VodiK_PCODE_US_FL7)
# define _VodiK_PCODE_US_FL7 7

/* mask = xxxxxz, id = 962 */
# define VodiK_US_FL8_PLATE _VODI_MAKE_PLATEID_US_FL(_VodiK_PCODE_US_FL8)
# define _VodiK_PCODE_US_FL8 8

/* mask = xxxxx, id = 958 */
# define VodiK_US_FL9_PLATE _VODI_MAKE_PLATEID_US_FL(_VodiK_PCODE_US_FL9)
# define _VodiK_PCODE_US_FL9 9

/* mask = xxxx, id = 959 */
# define VodiK_US_FL10_PLATE _VODI_MAKE_PLATEID_US_FL(_VodiK_PCODE_US_FL10)
# define _VodiK_PCODE_US_FL10 10

/* mask = zzxxxz, id = 960 */
# define VodiK_US_FL11_PLATE _VODI_MAKE_PLATEID_US_FL(_VodiK_PCODE_US_FL11)
# define _VodiK_PCODE_US_FL11 11

/* mask = zzxxxxx, id = 961 */
# define VodiK_US_FL12_PLATE _VODI_MAKE_PLATEID_US_FL(_VodiK_PCODE_US_FL12)
# define _VodiK_PCODE_US_FL12 12
/* @} */


/*
 * US_GA
 * @{
 */
# define _VODI_MAKE_PLATEID_US_GA(aCode) \
_VODI_MAKE_PLATEID_US(VodiK_US_GA_SUBNUM,aCode)

/* mask = zzzxxxx, id = 967 */
# define VodiK_US_GA1_PLATE _VODI_MAKE_PLATEID_US_GA(_VodiK_PCODE_US_GA1)
# define _VodiK_PCODE_US_GA1 1

/* mask = xxxzzz, id = 968 */
# define VodiK_US_GA2_PLATE _VODI_MAKE_PLATEID_US_GA(_VodiK_PCODE_US_GA2)
# define _VodiK_PCODE_US_GA2 2

/* mask = zzzxxxx, id = 969 */
# define VodiK_US_GA3_PLATE _VODI_MAKE_PLATEID_US_GA(_VodiK_PCODE_US_GA3)
# define _VodiK_PCODE_US_GA3 3

/* mask = xxxxzzz, id = 970 */
# define VodiK_US_GA4_PLATE _VODI_MAKE_PLATEID_US_GA(_VodiK_PCODE_US_GA4)
# define _VodiK_PCODE_US_GA4 4

/* mask = zzxxxz, id = 966 */
# define VodiK_US_GA5_PLATE _VODI_MAKE_PLATEID_US_GA(_VodiK_PCODE_US_GA5)
# define _VodiK_PCODE_US_GA5 5

/* mask = zzxxz, id = 965 */
# define VodiK_US_GA6_PLATE _VODI_MAKE_PLATEID_US_GA(_VodiK_PCODE_US_GA6)
# define _VodiK_PCODE_US_GA6 6
/* @} */


/*
 * US_HI
 * @{
 */
# define _VODI_MAKE_PLATEID_US_HI(aCode) \
_VODI_MAKE_PLATEID_US(VodiK_US_HI_SUBNUM,aCode)

/* mask = zzzxxx, id = 971 */
# define VodiK_US_HI1_PLATE _VODI_MAKE_PLATEID_US_HI(_VodiK_PCODE_US_HI1)
# define _VodiK_PCODE_US_HI1 1

/* mask = xxxzzz, id = 972 */
# define VodiK_US_HI2_PLATE _VODI_MAKE_PLATEID_US_HI(_VodiK_PCODE_US_HI2)
# define _VodiK_PCODE_US_HI2 2

/* mask = xxx, id = 973 */
# define VodiK_US_HI3_PLATE _VODI_MAKE_PLATEID_US_HI(_VodiK_PCODE_US_HI3)
# define _VodiK_PCODE_US_HI3 3

/* mask = zzxxxx, id = 974 */
# define VodiK_US_HI4_PLATE _VODI_MAKE_PLATEID_US_HI(_VodiK_PCODE_US_HI4)
# define _VodiK_PCODE_US_HI4 4

/* mask = xxxx, id = 975 */
# define VodiK_US_HI5_PLATE _VODI_MAKE_PLATEID_US_HI(_VodiK_PCODE_US_HI5)
# define _VodiK_PCODE_US_HI5 5
/* @} */


/*
 * US_IA
 * @{
 */
# define _VODI_MAKE_PLATEID_US_IA(aCode) \
_VODI_MAKE_PLATEID_US(VodiK_US_IA_SUBNUM,aCode)

/* mask = xxxzzz, id = 999 */
# define VodiK_US_IA1_PLATE _VODI_MAKE_PLATEID_US_IA(_VodiK_PCODE_US_IA1)
# define _VodiK_PCODE_US_IA1 1

/* mask = zzxxxxx, id = 998 */
# define VodiK_US_IA2_PLATE _VODI_MAKE_PLATEID_US_IA(_VodiK_PCODE_US_IA2)
# define _VodiK_PCODE_US_IA2 2

/* mask = xxxxz, id = 1000 */
# define VodiK_US_IA3_PLATE _VODI_MAKE_PLATEID_US_IA(_VodiK_PCODE_US_IA3)
# define _VodiK_PCODE_US_IA3 3

/* mask = zzxxxx, id = 1001 */
# define VodiK_US_IA4_PLATE _VODI_MAKE_PLATEID_US_IA(_VodiK_PCODE_US_IA4)
# define _VodiK_PCODE_US_IA4 4

/* mask = zzxxxx, id = 1002 */
# define VodiK_US_IA5_PLATE _VODI_MAKE_PLATEID_US_IA(_VodiK_PCODE_US_IA5)
# define _VodiK_PCODE_US_IA5 5
/* @} */


/*
 * US_ID
 * @{
 */
# define _VODI_MAKE_PLATEID_US_ID(aCode) \
_VODI_MAKE_PLATEID_US(VodiK_US_ID_SUBNUM,aCode)

/* mask = xzxxxxxx, id = 977 */
# define VodiK_US_ID1_PLATE _VODI_MAKE_PLATEID_US_ID(_VodiK_PCODE_US_ID1)
# define _VodiK_PCODE_US_ID1 1

/* mask = xzxxxxx, id = 979 */
# define VodiK_US_ID2_PLATE _VODI_MAKE_PLATEID_US_ID(_VodiK_PCODE_US_ID2)
# define _VodiK_PCODE_US_ID2 2

/* mask = xzxxxx, id = 980 */
# define VodiK_US_ID3_PLATE _VODI_MAKE_PLATEID_US_ID(_VodiK_PCODE_US_ID3)
# define _VodiK_PCODE_US_ID3 3

/* mask = zxxxxxx, id = 981 */
# define VodiK_US_ID4_PLATE _VODI_MAKE_PLATEID_US_ID(_VodiK_PCODE_US_ID4)
# define _VodiK_PCODE_US_ID4 4

/* mask = xzzxxxx, id = 982 */
# define VodiK_US_ID5_PLATE _VODI_MAKE_PLATEID_US_ID(_VodiK_PCODE_US_ID5)
# define _VodiK_PCODE_US_ID5 5

/* mask = xzzzxxx, id = 983 */
# define VodiK_US_ID6_PLATE _VODI_MAKE_PLATEID_US_ID(_VodiK_PCODE_US_ID6)
# define _VodiK_PCODE_US_ID6 6

/* mask = xzxzxxx, id = 984 */
# define VodiK_US_ID7_PLATE _VODI_MAKE_PLATEID_US_ID(_VodiK_PCODE_US_ID7)
# define _VodiK_PCODE_US_ID7 7

/* mask = zxxxxxx, id = 985 */
# define VodiK_US_ID8_PLATE _VODI_MAKE_PLATEID_US_ID(_VodiK_PCODE_US_ID8)
# define _VodiK_PCODE_US_ID8 8

/* mask = zxxxz, id = 986 */
# define VodiK_US_ID9_PLATE _VODI_MAKE_PLATEID_US_ID(_VodiK_PCODE_US_ID9)
# define _VodiK_PCODE_US_ID9 9

/* mask = zzxx, id = 978 */
# define VodiK_US_ID10_PLATE _VODI_MAKE_PLATEID_US_ID(_VodiK_PCODE_US_ID10)
# define _VodiK_PCODE_US_ID10 10
/* @} */


/*
 * US_IL
 * @{
 */
# define _VODI_MAKE_PLATEID_US_IL(aCode) \
_VODI_MAKE_PLATEID_US(VodiK_US_IL_SUBNUM,aCode)

/* mask = xxxxxxx, id = 987 */
# define VodiK_US_IL1_PLATE _VODI_MAKE_PLATEID_US_IL(_VodiK_PCODE_US_IL1)
# define _VodiK_PCODE_US_IL1 1

/* mask = zxxxxxx, id = 988 */
# define VodiK_US_IL2_PLATE _VODI_MAKE_PLATEID_US_IL(_VodiK_PCODE_US_IL2)
# define _VodiK_PCODE_US_IL2 2

/* mask = xxxxxxz, id = 989 */
# define VodiK_US_IL3_PLATE _VODI_MAKE_PLATEID_US_IL(_VodiK_PCODE_US_IL3)
# define _VodiK_PCODE_US_IL3 3
/* @} */


/*
 * US_IN
 * @{
 */
# define _VODI_MAKE_PLATEID_US_IN(aCode) \
_VODI_MAKE_PLATEID_US(VodiK_US_IN_SUBNUM,aCode)

/* mask = xxxzzz, id = 990 */
# define VodiK_US_IN1_PLATE _VODI_MAKE_PLATEID_US_IN(_VodiK_PCODE_US_IN1)
# define _VodiK_PCODE_US_IN1 1

/* mask = zxxxxz, id = 995 */
# define VodiK_US_IN2_PLATE _VODI_MAKE_PLATEID_US_IN(_VodiK_PCODE_US_IN2)
# define _VodiK_PCODE_US_IN2 2

/* mask = zxxxzz, id = 996 */
# define VodiK_US_IN3_PLATE _VODI_MAKE_PLATEID_US_IN(_VodiK_PCODE_US_IN3)
# define _VodiK_PCODE_US_IN3 3

/* mask = xxxxz, id = 991 */
# define VodiK_US_IN4_PLATE _VODI_MAKE_PLATEID_US_IN(_VodiK_PCODE_US_IN4)
# define _VodiK_PCODE_US_IN4 4

/* mask = zxxxxxz, id = 992 */
# define VodiK_US_IN5_PLATE _VODI_MAKE_PLATEID_US_IN(_VodiK_PCODE_US_IN5)
# define _VodiK_PCODE_US_IN5 5

/* mask = zzxxxxz, id = 993 */
# define VodiK_US_IN6_PLATE _VODI_MAKE_PLATEID_US_IN(_VodiK_PCODE_US_IN6)
# define _VodiK_PCODE_US_IN6 6

/* mask = xxxxzx, id = 994 */
# define VodiK_US_IN7_PLATE _VODI_MAKE_PLATEID_US_IN(_VodiK_PCODE_US_IN7)
# define _VodiK_PCODE_US_IN7 7

/* mask = zzxxxzzz, id = 997 */
# define VodiK_US_IN8_PLATE _VODI_MAKE_PLATEID_US_IN(_VodiK_PCODE_US_IN8)
# define _VodiK_PCODE_US_IN8 8
/* @} */


/*
 * US_KS
 * @{
 */
# define _VODI_MAKE_PLATEID_US_KS(aCode) \
_VODI_MAKE_PLATEID_US(VodiK_US_KS_SUBNUM,aCode)

/* mask = zzzxxx, id = 1003 */
# define VodiK_US_KS1_PLATE _VODI_MAKE_PLATEID_US_KS(_VodiK_PCODE_US_KS1)
# define _VodiK_PCODE_US_KS1 1

/* mask = xxxzzz, id = 1004 */
# define VodiK_US_KS2_PLATE _VODI_MAKE_PLATEID_US_KS(_VodiK_PCODE_US_KS2)
# define _VodiK_PCODE_US_KS2 2

/* mask = zzzxx, id = 1005 */
# define VodiK_US_KS3_PLATE _VODI_MAKE_PLATEID_US_KS(_VodiK_PCODE_US_KS3)
# define _VodiK_PCODE_US_KS3 3

/* mask = zxxxxx, id = 1006 */
# define VodiK_US_KS4_PLATE _VODI_MAKE_PLATEID_US_KS(_VodiK_PCODE_US_KS4)
# define _VodiK_PCODE_US_KS4 4
/* @} */


/*
 * US_KY
 * @{
 */
# define _VODI_MAKE_PLATEID_US_KY(aCode) \
_VODI_MAKE_PLATEID_US(VodiK_US_KY_SUBNUM,aCode)

/* mask = xxxzzz, id = 1007 */
# define VodiK_US_KY1_PLATE _VODI_MAKE_PLATEID_US_KY(_VodiK_PCODE_US_KY1)
# define _VodiK_PCODE_US_KY1 1
/* @} */


/*
 * US_LA
 * @{
 */
# define _VODI_MAKE_PLATEID_US_LA(aCode) \
_VODI_MAKE_PLATEID_US(VodiK_US_LA_SUBNUM,aCode)

/* mask = zzzxxx, id = 1008 */
# define VodiK_US_LA1_PLATE _VODI_MAKE_PLATEID_US_LA(_VodiK_PCODE_US_LA1)
# define _VodiK_PCODE_US_LA1 1

/* mask = zzzxxx, id = 1009 */
# define VodiK_US_LA2_PLATE _VODI_MAKE_PLATEID_US_LA(_VodiK_PCODE_US_LA2)
# define _VodiK_PCODE_US_LA2 2

/* mask = xxxxxx, id = 1010 */
# define VodiK_US_LA3_PLATE _VODI_MAKE_PLATEID_US_LA(_VodiK_PCODE_US_LA3)
# define _VodiK_PCODE_US_LA3 3
/* @} */


/*
 * US_MA
 * @{
 */
# define _VODI_MAKE_PLATEID_US_MA(aCode) \
_VODI_MAKE_PLATEID_US(VodiK_US_MA_SUBNUM,aCode)

/* mask = xxxzzz, id = 1020 */
# define VodiK_US_MA1_PLATE _VODI_MAKE_PLATEID_US_MA(_VodiK_PCODE_US_MA1)
# define _VodiK_PCODE_US_MA1 1

/* mask = xxxzzx, id = 1021 */
# define VodiK_US_MA2_PLATE _VODI_MAKE_PLATEID_US_MA(_VodiK_PCODE_US_MA2)
# define _VodiK_PCODE_US_MA2 2

/* mask = xxzzxx, id = 1022 */
# define VodiK_US_MA3_PLATE _VODI_MAKE_PLATEID_US_MA(_VodiK_PCODE_US_MA3)
# define _VodiK_PCODE_US_MA3 3

/* mask = xxxxx, id = 1023 */
# define VodiK_US_MA4_PLATE _VODI_MAKE_PLATEID_US_MA(_VodiK_PCODE_US_MA4)
# define _VodiK_PCODE_US_MA4 4

/* mask = zxxxxx, id = 1024 */
# define VodiK_US_MA5_PLATE _VODI_MAKE_PLATEID_US_MA(_VodiK_PCODE_US_MA5)
# define _VodiK_PCODE_US_MA5 5
/* @} */


/*
 * US_MD
 * @{
 */
# define _VODI_MAKE_PLATEID_US_MD(aCode) \
_VODI_MAKE_PLATEID_US(VodiK_US_MD_SUBNUM,aCode)

/* mask = xzxxxxz, id = 1018 */
# define VodiK_US_MD1_PLATE _VODI_MAKE_PLATEID_US_MD(_VodiK_PCODE_US_MD1)
# define _VodiK_PCODE_US_MD1 1

/* mask = zxxxxxz, id = 1019 */
# define VodiK_US_MD2_PLATE _VODI_MAKE_PLATEID_US_MD(_VodiK_PCODE_US_MD2)
# define _VodiK_PCODE_US_MD2 2

/* mask = zxxxxxx, id = 1015 */
# define VodiK_US_MD3_PLATE _VODI_MAKE_PLATEID_US_MD(_VodiK_PCODE_US_MD3)
# define _VodiK_PCODE_US_MD3 3

/* mask = zxxxxxz, id = 1016 */
# define VodiK_US_MD4_PLATE _VODI_MAKE_PLATEID_US_MD(_VodiK_PCODE_US_MD4)
# define _VodiK_PCODE_US_MD4 4

/* mask = xxxzxxx, id = 1017 */
# define VodiK_US_MD5_PLATE _VODI_MAKE_PLATEID_US_MD(_VodiK_PCODE_US_MD5)
# define _VodiK_PCODE_US_MD5 5
/* @} */


/*
 * US_ME
 * @{
 */
# define _VODI_MAKE_PLATEID_US_ME(aCode) \
_VODI_MAKE_PLATEID_US(VodiK_US_ME_SUBNUM,aCode)

/* mask = xxxxzz, id = 1011 */
# define VodiK_US_ME1_PLATE _VODI_MAKE_PLATEID_US_ME(_VodiK_PCODE_US_ME1)
# define _VodiK_PCODE_US_ME1 1

/* mask = xxxxx, id = 1012 */
# define VodiK_US_ME2_PLATE _VODI_MAKE_PLATEID_US_ME(_VodiK_PCODE_US_ME2)
# define _VodiK_PCODE_US_ME2 2

/* mask = zxxxxx, id = 1013 */
# define VodiK_US_ME3_PLATE _VODI_MAKE_PLATEID_US_ME(_VodiK_PCODE_US_ME3)
# define _VodiK_PCODE_US_ME3 3

/* mask = xxxxxxx, id = 1014 */
# define VodiK_US_ME4_PLATE _VODI_MAKE_PLATEID_US_ME(_VodiK_PCODE_US_ME4)
# define _VodiK_PCODE_US_ME4 4
/* @} */


/*
 * US_MI
 * @{
 */
# define _VODI_MAKE_PLATEID_US_MI(aCode) \
_VODI_MAKE_PLATEID_US(VodiK_US_MI_SUBNUM,aCode)

/* mask = zzzxxxx, id = 1028 */
# define VodiK_US_MI1_PLATE _VODI_MAKE_PLATEID_US_MI(_VodiK_PCODE_US_MI1)
# define _VodiK_PCODE_US_MI1 1

/* mask = xxzxxx, id = 1025 */
# define VodiK_US_MI2_PLATE _VODI_MAKE_PLATEID_US_MI(_VodiK_PCODE_US_MI2)
# define _VodiK_PCODE_US_MI2 2

/* mask = xxzxxx, id = 1026 */
# define VodiK_US_MI3_PLATE _VODI_MAKE_PLATEID_US_MI(_VodiK_PCODE_US_MI3)
# define _VodiK_PCODE_US_MI3 3

/* mask = xzzzxx, id = 1027 */
# define VodiK_US_MI4_PLATE _VODI_MAKE_PLATEID_US_MI(_VodiK_PCODE_US_MI4)
# define _VodiK_PCODE_US_MI4 4

/* mask = xxxzxxx, id = 1029 */
# define VodiK_US_MI5_PLATE _VODI_MAKE_PLATEID_US_MI(_VodiK_PCODE_US_MI5)
# define _VodiK_PCODE_US_MI5 5

/* mask = zzxx, id = 1030 */
# define VodiK_US_MI6_PLATE _VODI_MAKE_PLATEID_US_MI(_VodiK_PCODE_US_MI6)
# define _VodiK_PCODE_US_MI6 6
/* @} */


/*
 * US_MN
 * @{
 */
# define _VODI_MAKE_PLATEID_US_MN(aCode) \
_VODI_MAKE_PLATEID_US(VodiK_US_MN_SUBNUM,aCode)

/* mask = xxxzzz, id = 1032 */
# define VodiK_US_MN1_PLATE _VODI_MAKE_PLATEID_US_MN(_VodiK_PCODE_US_MN1)
# define _VodiK_PCODE_US_MN1 1

/* mask = zzzxxx, id = 1037 */
# define VodiK_US_MN2_PLATE _VODI_MAKE_PLATEID_US_MN(_VodiK_PCODE_US_MN2)
# define _VodiK_PCODE_US_MN2 2

/* mask = zxxxxxz, id = 1038 */
# define VodiK_US_MN3_PLATE _VODI_MAKE_PLATEID_US_MN(_VodiK_PCODE_US_MN3)
# define _VodiK_PCODE_US_MN3 3

/* mask = xxxxzz, id = 1031 */
# define VodiK_US_MN4_PLATE _VODI_MAKE_PLATEID_US_MN(_VodiK_PCODE_US_MN4)
# define _VodiK_PCODE_US_MN4 4

/* mask = zzxxx, id = 1033 */
# define VodiK_US_MN5_PLATE _VODI_MAKE_PLATEID_US_MN(_VodiK_PCODE_US_MN5)
# define _VodiK_PCODE_US_MN5 5

/* mask = zxxxxx, id = 1034 */
# define VodiK_US_MN6_PLATE _VODI_MAKE_PLATEID_US_MN(_VodiK_PCODE_US_MN6)
# define _VodiK_PCODE_US_MN6 6

/* mask = xxxzz, id = 1035 */
# define VodiK_US_MN7_PLATE _VODI_MAKE_PLATEID_US_MN(_VodiK_PCODE_US_MN7)
# define _VodiK_PCODE_US_MN7 7

/* mask = xzzxxx, id = 1036 */
# define VodiK_US_MN8_PLATE _VODI_MAKE_PLATEID_US_MN(_VodiK_PCODE_US_MN8)
# define _VodiK_PCODE_US_MN8 8
/* @} */


/*
 * US_MO
 * @{
 */
# define _VODI_MAKE_PLATEID_US_MO(aCode) \
_VODI_MAKE_PLATEID_US(VodiK_US_MO_SUBNUM,aCode)

/* mask = zzxzxz, id = 1057 */
# define VodiK_US_MO1_PLATE _VODI_MAKE_PLATEID_US_MO(_VodiK_PCODE_US_MO1)
# define _VodiK_PCODE_US_MO1 1

/* mask = xxxzzx, id = 1054 */
# define VodiK_US_MO2_PLATE _VODI_MAKE_PLATEID_US_MO(_VodiK_PCODE_US_MO2)
# define _VodiK_PCODE_US_MO2 2

/* mask = xxxxxx, id = 1052 */
# define VodiK_US_MO3_PLATE _VODI_MAKE_PLATEID_US_MO(_VodiK_PCODE_US_MO3)
# define _VodiK_PCODE_US_MO3 3

/* mask = xzzz, id = 1053 */
# define VodiK_US_MO4_PLATE _VODI_MAKE_PLATEID_US_MO(_VodiK_PCODE_US_MO4)
# define _VodiK_PCODE_US_MO4 4

/* mask = xxxzzz, id = 1055 */
# define VodiK_US_MO5_PLATE _VODI_MAKE_PLATEID_US_MO(_VodiK_PCODE_US_MO5)
# define _VodiK_PCODE_US_MO5 5

/* mask = zxxxxz, id = 1056 */
# define VodiK_US_MO6_PLATE _VODI_MAKE_PLATEID_US_MO(_VodiK_PCODE_US_MO6)
# define _VodiK_PCODE_US_MO6 6
/* @} */


/*
 * US_MS
 * @{
 */
# define _VODI_MAKE_PLATEID_US_MS(aCode) \
_VODI_MAKE_PLATEID_US(VodiK_US_MS_SUBNUM,aCode)

/* mask = zzzxxx, id = 1047 */
# define VodiK_US_MS1_PLATE _VODI_MAKE_PLATEID_US_MS(_VodiK_PCODE_US_MS1)
# define _VodiK_PCODE_US_MS1 1

/* mask = zxxxxz, id = 1050 */
# define VodiK_US_MS2_PLATE _VODI_MAKE_PLATEID_US_MS(_VodiK_PCODE_US_MS2)
# define _VodiK_PCODE_US_MS2 2

/* mask = zzxxxx, id = 1049 */
# define VodiK_US_MS3_PLATE _VODI_MAKE_PLATEID_US_MS(_VodiK_PCODE_US_MS3)
# define _VodiK_PCODE_US_MS3 3

/* mask = zxxxxz, id = 1039 */
# define VodiK_US_MS4_PLATE _VODI_MAKE_PLATEID_US_MS(_VodiK_PCODE_US_MS4)
# define _VodiK_PCODE_US_MS4 4

/* mask = xxxzz, id = 1040 */
# define VodiK_US_MS5_PLATE _VODI_MAKE_PLATEID_US_MS(_VodiK_PCODE_US_MS5)
# define _VodiK_PCODE_US_MS5 5

/* mask = xxxzz, id = 1041 */
# define VodiK_US_MS6_PLATE _VODI_MAKE_PLATEID_US_MS(_VodiK_PCODE_US_MS6)
# define _VodiK_PCODE_US_MS6 6

/* mask = zzxxxxz, id = 1042 */
# define VodiK_US_MS7_PLATE _VODI_MAKE_PLATEID_US_MS(_VodiK_PCODE_US_MS7)
# define _VodiK_PCODE_US_MS7 7

/* mask = xxxzxx, id = 1043 */
# define VodiK_US_MS8_PLATE _VODI_MAKE_PLATEID_US_MS(_VodiK_PCODE_US_MS8)
# define _VodiK_PCODE_US_MS8 8

/* mask = xxxxzz, id = 1044 */
# define VodiK_US_MS9_PLATE _VODI_MAKE_PLATEID_US_MS(_VodiK_PCODE_US_MS9)
# define _VodiK_PCODE_US_MS9 9

/* mask = xxxxzx, id = 1045 */
# define VodiK_US_MS10_PLATE _VODI_MAKE_PLATEID_US_MS(_VodiK_PCODE_US_MS10)
# define _VodiK_PCODE_US_MS10 10

/* mask = zxxxxz, id = 1046 */
# define VodiK_US_MS11_PLATE _VODI_MAKE_PLATEID_US_MS(_VodiK_PCODE_US_MS11)
# define _VodiK_PCODE_US_MS11 11

/* mask = zxxxxxxx, id = 1048 */
# define VodiK_US_MS12_PLATE _VODI_MAKE_PLATEID_US_MS(_VodiK_PCODE_US_MS12)
# define _VodiK_PCODE_US_MS12 12

/* mask = zzxxxx, id = 1051 */
# define VodiK_US_MS13_PLATE _VODI_MAKE_PLATEID_US_MS(_VodiK_PCODE_US_MS13)
# define _VodiK_PCODE_US_MS13 13
/* @} */


/*
 * US_MT
 * @{
 */
# define _VODI_MAKE_PLATEID_US_MT(aCode) \
_VODI_MAKE_PLATEID_US(VodiK_US_MT_SUBNUM,aCode)

/* mask = xxxxxxz, id = 1061 */
# define VodiK_US_MT1_PLATE _VODI_MAKE_PLATEID_US_MT(_VodiK_PCODE_US_MT1)
# define _VodiK_PCODE_US_MT1 1

/* mask = xxxxxxz, id = 1062 */
# define VodiK_US_MT2_PLATE _VODI_MAKE_PLATEID_US_MT(_VodiK_PCODE_US_MT2)
# define _VodiK_PCODE_US_MT2 2

/* mask = xzzxxxx, id = 1063 */
# define VodiK_US_MT3_PLATE _VODI_MAKE_PLATEID_US_MT(_VodiK_PCODE_US_MT3)
# define _VodiK_PCODE_US_MT3 3

/* mask = xzxxxxz, id = 1058 */
# define VodiK_US_MT4_PLATE _VODI_MAKE_PLATEID_US_MT(_VodiK_PCODE_US_MT4)
# define _VodiK_PCODE_US_MT4 4

/* mask = zxxxxx, id = 1059 */
# define VodiK_US_MT5_PLATE _VODI_MAKE_PLATEID_US_MT(_VodiK_PCODE_US_MT5)
# define _VodiK_PCODE_US_MT5 5

/* mask = xzxxxxx, id = 1060 */
# define VodiK_US_MT6_PLATE _VODI_MAKE_PLATEID_US_MT(_VodiK_PCODE_US_MT6)
# define _VodiK_PCODE_US_MT6 6
/* @} */


/*
 * US_NC
 * @{
 */
# define _VODI_MAKE_PLATEID_US_NC(aCode) \
_VODI_MAKE_PLATEID_US(VodiK_US_NC_SUBNUM,aCode)

/* mask = zzzxxxx, id = 1105 */
# define VodiK_US_NC1_PLATE _VODI_MAKE_PLATEID_US_NC(_VodiK_PCODE_US_NC1)
# define _VodiK_PCODE_US_NC1 1

/* mask = xzxxxx, id = 1106 */
# define VodiK_US_NC2_PLATE _VODI_MAKE_PLATEID_US_NC(_VodiK_PCODE_US_NC2)
# define _VodiK_PCODE_US_NC2 2

/* mask = xxxxxxxx, id = 1107 */
# define VodiK_US_NC3_PLATE _VODI_MAKE_PLATEID_US_NC(_VodiK_PCODE_US_NC3)
# define _VodiK_PCODE_US_NC3 3
/* @} */


/*
 * US_ND
 * @{
 */
# define _VODI_MAKE_PLATEID_US_ND(aCode) \
_VODI_MAKE_PLATEID_US(VodiK_US_ND_SUBNUM,aCode)

/* mask = zzzxxx, id = 1108 */
# define VodiK_US_ND1_PLATE _VODI_MAKE_PLATEID_US_ND(_VodiK_PCODE_US_ND1)
# define _VodiK_PCODE_US_ND1 1

/* mask = zxxxz, id = 1109 */
# define VodiK_US_ND2_PLATE _VODI_MAKE_PLATEID_US_ND(_VodiK_PCODE_US_ND2)
# define _VodiK_PCODE_US_ND2 2

/* mask = zxxxxxx, id = 1110 */
# define VodiK_US_ND3_PLATE _VODI_MAKE_PLATEID_US_ND(_VodiK_PCODE_US_ND3)
# define _VodiK_PCODE_US_ND3 3
/* @} */


/*
 * US_NE
 * @{
 */
# define _VODI_MAKE_PLATEID_US_NE(aCode) \
_VODI_MAKE_PLATEID_US(VodiK_US_NE_SUBNUM,aCode)

/* mask = xxzxxx, id = 1065 */
# define VodiK_US_NE1_PLATE _VODI_MAKE_PLATEID_US_NE(_VodiK_PCODE_US_NE1)
# define _VodiK_PCODE_US_NE1 1

/* mask = zzzxxx, id = 1067 */
# define VodiK_US_NE2_PLATE _VODI_MAKE_PLATEID_US_NE(_VodiK_PCODE_US_NE2)
# define _VodiK_PCODE_US_NE2 2

/* mask = xxxxx, id = 1066 */
# define VodiK_US_NE3_PLATE _VODI_MAKE_PLATEID_US_NE(_VodiK_PCODE_US_NE3)
# define _VodiK_PCODE_US_NE3 3

/* mask = xxxxx, id = 1064 */
# define VodiK_US_NE4_PLATE _VODI_MAKE_PLATEID_US_NE(_VodiK_PCODE_US_NE4)
# define _VodiK_PCODE_US_NE4 4
/* @} */


/*
 * US_NH
 * @{
 */
# define _VODI_MAKE_PLATEID_US_NH(aCode) \
_VODI_MAKE_PLATEID_US(VodiK_US_NH_SUBNUM,aCode)

/* mask = xxxxxx, id = 1075 */
# define VodiK_US_NH1_PLATE _VODI_MAKE_PLATEID_US_NH(_VodiK_PCODE_US_NH1)
# define _VodiK_PCODE_US_NH1 1

/* mask = xxxxxxx, id = 1076 */
# define VodiK_US_NH2_PLATE _VODI_MAKE_PLATEID_US_NH(_VodiK_PCODE_US_NH2)
# define _VodiK_PCODE_US_NH2 2

/* mask = xxxxxx, id = 1077 */
# define VodiK_US_NH3_PLATE _VODI_MAKE_PLATEID_US_NH(_VodiK_PCODE_US_NH3)
# define _VodiK_PCODE_US_NH3 3

/* mask = xxxz, id = 1073 */
# define VodiK_US_NH4_PLATE _VODI_MAKE_PLATEID_US_NH(_VodiK_PCODE_US_NH4)
# define _VodiK_PCODE_US_NH4 4

/* mask = zxxxxzz, id = 1074 */
# define VodiK_US_NH5_PLATE _VODI_MAKE_PLATEID_US_NH(_VodiK_PCODE_US_NH5)
# define _VodiK_PCODE_US_NH5 5
/* @} */


/*
 * US_NJ
 * @{
 */
# define _VODI_MAKE_PLATEID_US_NJ(aCode) \
_VODI_MAKE_PLATEID_US(VodiK_US_NJ_SUBNUM,aCode)

/* mask = zzzxxz, id = 1080 */
# define VodiK_US_NJ1_PLATE _VODI_MAKE_PLATEID_US_NJ(_VodiK_PCODE_US_NJ1)
# define _VodiK_PCODE_US_NJ1 1

/* mask = xxxxz, id = 1078 */
# define VodiK_US_NJ2_PLATE _VODI_MAKE_PLATEID_US_NJ(_VodiK_PCODE_US_NJ2)
# define _VodiK_PCODE_US_NJ2 2

/* mask = zxxxx, id = 1082 */
# define VodiK_US_NJ3_PLATE _VODI_MAKE_PLATEID_US_NJ(_VodiK_PCODE_US_NJ3)
# define _VodiK_PCODE_US_NJ3 3

/* mask = zxxxxxz, id = 1084 */
# define VodiK_US_NJ4_PLATE _VODI_MAKE_PLATEID_US_NJ(_VodiK_PCODE_US_NJ4)
# define _VodiK_PCODE_US_NJ4 4

/* mask = xxxxzzz, id = 1079 */
# define VodiK_US_NJ5_PLATE _VODI_MAKE_PLATEID_US_NJ(_VodiK_PCODE_US_NJ5)
# define _VodiK_PCODE_US_NJ5 5

/* mask = zxxzxz, id = 1081 */
# define VodiK_US_NJ6_PLATE _VODI_MAKE_PLATEID_US_NJ(_VodiK_PCODE_US_NJ6)
# define _VodiK_PCODE_US_NJ6 6

/* mask = xxxxzzz, id = 1083 */
# define VodiK_US_NJ7_PLATE _VODI_MAKE_PLATEID_US_NJ(_VodiK_PCODE_US_NJ7)
# define _VodiK_PCODE_US_NJ7 7

/* mask = zzxxxz, id = 1085 */
# define VodiK_US_NJ8_PLATE _VODI_MAKE_PLATEID_US_NJ(_VodiK_PCODE_US_NJ8)
# define _VodiK_PCODE_US_NJ8 8

/* mask = zxxz, id = 1086 */
# define VodiK_US_NJ9_PLATE _VODI_MAKE_PLATEID_US_NJ(_VodiK_PCODE_US_NJ9)
# define _VodiK_PCODE_US_NJ9 9

/* mask = zzxxxxx, id = 1087 */
# define VodiK_US_NJ10_PLATE _VODI_MAKE_PLATEID_US_NJ(_VodiK_PCODE_US_NJ10)
# define _VodiK_PCODE_US_NJ10 10
/* @} */


/*
 * US_NM
 * @{
 */
# define _VODI_MAKE_PLATEID_US_NM(aCode) \
_VODI_MAKE_PLATEID_US(VodiK_US_NM_SUBNUM,aCode)

/* mask = xxxzzz, id = 1095 */
# define VodiK_US_NM1_PLATE _VODI_MAKE_PLATEID_US_NM(_VodiK_PCODE_US_NM1)
# define _VodiK_PCODE_US_NM1 1

/* mask = zxxxxx, id = 1088 */
# define VodiK_US_NM2_PLATE _VODI_MAKE_PLATEID_US_NM(_VodiK_PCODE_US_NM2)
# define _VodiK_PCODE_US_NM2 2

/* mask = zzxxxx, id = 1089 */
# define VodiK_US_NM3_PLATE _VODI_MAKE_PLATEID_US_NM(_VodiK_PCODE_US_NM3)
# define _VodiK_PCODE_US_NM3 3

/* mask = zxxxxxx, id = 1094 */
# define VodiK_US_NM4_PLATE _VODI_MAKE_PLATEID_US_NM(_VodiK_PCODE_US_NM4)
# define _VodiK_PCODE_US_NM4 4

/* mask = zzxxx, id = 1090 */
# define VodiK_US_NM5_PLATE _VODI_MAKE_PLATEID_US_NM(_VodiK_PCODE_US_NM5)
# define _VodiK_PCODE_US_NM5 5

/* mask = zzzxxx, id = 1091 */
# define VodiK_US_NM6_PLATE _VODI_MAKE_PLATEID_US_NM(_VodiK_PCODE_US_NM6)
# define _VodiK_PCODE_US_NM6 6

/* mask = zxxxxz, id = 1092 */
# define VodiK_US_NM7_PLATE _VODI_MAKE_PLATEID_US_NM(_VodiK_PCODE_US_NM7)
# define _VodiK_PCODE_US_NM7 7

/* mask = zxxxzz, id = 1093 */
# define VodiK_US_NM8_PLATE _VODI_MAKE_PLATEID_US_NM(_VodiK_PCODE_US_NM8)
# define _VodiK_PCODE_US_NM8 8

/* mask = zzxxx, id = 1096 */
# define VodiK_US_NM9_PLATE _VODI_MAKE_PLATEID_US_NM(_VodiK_PCODE_US_NM9)
# define _VodiK_PCODE_US_NM9 9
/* @} */


/*
 * US_NV
 * @{
 */
# define _VODI_MAKE_PLATEID_US_NV(aCode) \
_VODI_MAKE_PLATEID_US(VodiK_US_NV_SUBNUM,aCode)

/* mask = xxxzzz, id = 1068 */
# define VodiK_US_NV1_PLATE _VODI_MAKE_PLATEID_US_NV(_VodiK_PCODE_US_NV1)
# define _VodiK_PCODE_US_NV1 1

/* mask = xxxxxz, id = 1069 */
# define VodiK_US_NV2_PLATE _VODI_MAKE_PLATEID_US_NV(_VodiK_PCODE_US_NV2)
# define _VodiK_PCODE_US_NV2 2

/* mask = zzzxxxxx, id = 1070 */
# define VodiK_US_NV3_PLATE _VODI_MAKE_PLATEID_US_NV(_VodiK_PCODE_US_NV3)
# define _VodiK_PCODE_US_NV3 3

/* mask = zxxxxxzzz, id = 1071 */
# define VodiK_US_NV4_PLATE _VODI_MAKE_PLATEID_US_NV(_VodiK_PCODE_US_NV4)
# define _VodiK_PCODE_US_NV4 4

/* mask = xxxxx, id = 1072 */
# define VodiK_US_NV5_PLATE _VODI_MAKE_PLATEID_US_NV(_VodiK_PCODE_US_NV5)
# define _VodiK_PCODE_US_NV5 5
/* @} */


/*
 * US_NY
 * @{
 */
# define _VODI_MAKE_PLATEID_US_NY(aCode) \
_VODI_MAKE_PLATEID_US(VodiK_US_NY_SUBNUM,aCode)

/* mask = zzzxxxx, id = 1097 */
# define VodiK_US_NY1_PLATE _VODI_MAKE_PLATEID_US_NY(_VodiK_PCODE_US_NY1)
# define _VodiK_PCODE_US_NY1 1

/* mask = xxxxxx, id = 1102 */
# define VodiK_US_NY2_PLATE _VODI_MAKE_PLATEID_US_NY(_VodiK_PCODE_US_NY2)
# define _VodiK_PCODE_US_NY2 2

/* mask = xxxxxzz, id = 1098 */
# define VodiK_US_NY3_PLATE _VODI_MAKE_PLATEID_US_NY(_VodiK_PCODE_US_NY3)
# define _VodiK_PCODE_US_NY3 3

/* mask = zxxxxxxz, id = 1099 */
# define VodiK_US_NY4_PLATE _VODI_MAKE_PLATEID_US_NY(_VodiK_PCODE_US_NY4)
# define _VodiK_PCODE_US_NY4 4

/* mask = zxxxxxz, id = 1100 */
# define VodiK_US_NY5_PLATE _VODI_MAKE_PLATEID_US_NY(_VodiK_PCODE_US_NY5)
# define _VodiK_PCODE_US_NY5 5

/* mask = zxxxxx, id = 1101 */
# define VodiK_US_NY6_PLATE _VODI_MAKE_PLATEID_US_NY(_VodiK_PCODE_US_NY6)
# define _VodiK_PCODE_US_NY6 6

/* mask = xxxxxxx, id = 1103 */
# define VodiK_US_NY7_PLATE _VODI_MAKE_PLATEID_US_NY(_VodiK_PCODE_US_NY7)
# define _VodiK_PCODE_US_NY7 7

/* mask = xxxzzz, id = 1104 */
# define VodiK_US_NY8_PLATE _VODI_MAKE_PLATEID_US_NY(_VodiK_PCODE_US_NY8)
# define _VodiK_PCODE_US_NY8 8
/* @} */


/*
 * US_OH
 * @{
 */
# define _VODI_MAKE_PLATEID_US_OH(aCode) \
_VODI_MAKE_PLATEID_US(VodiK_US_OH_SUBNUM,aCode)

/* mask = zzzxxxx, id = 1112 */
# define VodiK_US_OH1_PLATE _VODI_MAKE_PLATEID_US_OH(_VodiK_PCODE_US_OH1)
# define _VodiK_PCODE_US_OH1 1

/* mask = zxxxxxx, id = 1113 */
# define VodiK_US_OH2_PLATE _VODI_MAKE_PLATEID_US_OH(_VodiK_PCODE_US_OH2)
# define _VodiK_PCODE_US_OH2 2

/* mask = xxzzz, id = 1111 */
# define VodiK_US_OH3_PLATE _VODI_MAKE_PLATEID_US_OH(_VodiK_PCODE_US_OH3)
# define _VodiK_PCODE_US_OH3 3
/* @} */


/*
 * US_OK
 * @{
 */
# define _VODI_MAKE_PLATEID_US_OK(aCode) \
_VODI_MAKE_PLATEID_US(VodiK_US_OK_SUBNUM,aCode)

/* mask = xxxzzz, id = 1114 */
# define VodiK_US_OK1_PLATE _VODI_MAKE_PLATEID_US_OK(_VodiK_PCODE_US_OK1)
# define _VodiK_PCODE_US_OK1 1
/* @} */


/*
 * US_OR
 * @{
 */
# define _VODI_MAKE_PLATEID_US_OR(aCode) \
_VODI_MAKE_PLATEID_US(VodiK_US_OR_SUBNUM,aCode)

/* mask = zzzxxx, id = 1117 */
# define VodiK_US_OR1_PLATE _VODI_MAKE_PLATEID_US_OR(_VodiK_PCODE_US_OR1)
# define _VodiK_PCODE_US_OR1 1

/* mask = xxxzzz, id = 1119 */
# define VodiK_US_OR2_PLATE _VODI_MAKE_PLATEID_US_OR(_VodiK_PCODE_US_OR2)
# define _VodiK_PCODE_US_OR2 2

/* mask = zzzzxxx, id = 1118 */
# define VodiK_US_OR3_PLATE _VODI_MAKE_PLATEID_US_OR(_VodiK_PCODE_US_OR3)
# define _VodiK_PCODE_US_OR3 3

/* mask = zxxxxzz, id = 1115 */
# define VodiK_US_OR4_PLATE _VODI_MAKE_PLATEID_US_OR(_VodiK_PCODE_US_OR4)
# define _VodiK_PCODE_US_OR4 4

/* mask = zxxxxxz, id = 1116 */
# define VodiK_US_OR5_PLATE _VODI_MAKE_PLATEID_US_OR(_VodiK_PCODE_US_OR5)
# define _VodiK_PCODE_US_OR5 5

/* mask = zxxxxxx, id = 1120 */
# define VodiK_US_OR6_PLATE _VODI_MAKE_PLATEID_US_OR(_VodiK_PCODE_US_OR6)
# define _VodiK_PCODE_US_OR6 6

/* mask = zxxxxxz, id = 1121 */
# define VodiK_US_OR7_PLATE _VODI_MAKE_PLATEID_US_OR(_VodiK_PCODE_US_OR7)
# define _VodiK_PCODE_US_OR7 7
/* @} */


/*
 * US_PA
 * @{
 */
# define _VODI_MAKE_PLATEID_US_PA(aCode) \
_VODI_MAKE_PLATEID_US(VodiK_US_PA_SUBNUM,aCode)

/* mask = zzzxxxx, id = 1122 */
# define VodiK_US_PA1_PLATE _VODI_MAKE_PLATEID_US_PA(_VodiK_PCODE_US_PA1)
# define _VodiK_PCODE_US_PA1 1

/* mask = zzxxxxx, id = 1123 */
# define VodiK_US_PA2_PLATE _VODI_MAKE_PLATEID_US_PA(_VodiK_PCODE_US_PA2)
# define _VodiK_PCODE_US_PA2 2

/* mask = zxxxxxz, id = 1124 */
# define VodiK_US_PA3_PLATE _VODI_MAKE_PLATEID_US_PA(_VodiK_PCODE_US_PA3)
# define _VodiK_PCODE_US_PA3 3

/* mask = xxxxxzz, id = 1125 */
# define VodiK_US_PA4_PLATE _VODI_MAKE_PLATEID_US_PA(_VodiK_PCODE_US_PA4)
# define _VodiK_PCODE_US_PA4 4

/* mask = xxxxxzz, id = 1126 */
# define VodiK_US_PA5_PLATE _VODI_MAKE_PLATEID_US_PA(_VodiK_PCODE_US_PA5)
# define _VodiK_PCODE_US_PA5 5

/* mask = zzxxxxz, id = 1127 */
# define VodiK_US_PA6_PLATE _VODI_MAKE_PLATEID_US_PA(_VodiK_PCODE_US_PA6)
# define _VodiK_PCODE_US_PA6 6
/* @} */


/*
 * US_RI
 * @{
 */
# define _VODI_MAKE_PLATEID_US_RI(aCode) \
_VODI_MAKE_PLATEID_US(VodiK_US_RI_SUBNUM,aCode)

/* mask = xxxxxx, id = 1128 */
# define VodiK_US_RI1_PLATE _VODI_MAKE_PLATEID_US_RI(_VodiK_PCODE_US_RI1)
# define _VodiK_PCODE_US_RI1 1

/* mask = zzxxx, id = 1129 */
# define VodiK_US_RI2_PLATE _VODI_MAKE_PLATEID_US_RI(_VodiK_PCODE_US_RI2)
# define _VodiK_PCODE_US_RI2 2

/* mask = xxxxx, id = 1130 */
# define VodiK_US_RI3_PLATE _VODI_MAKE_PLATEID_US_RI(_VodiK_PCODE_US_RI3)
# define _VodiK_PCODE_US_RI3 3

/* mask = zxxxzz, id = 1131 */
# define VodiK_US_RI4_PLATE _VODI_MAKE_PLATEID_US_RI(_VodiK_PCODE_US_RI4)
# define _VodiK_PCODE_US_RI4 4

/* mask = xxxx, id = 1132 */
# define VodiK_US_RI5_PLATE _VODI_MAKE_PLATEID_US_RI(_VodiK_PCODE_US_RI5)
# define _VodiK_PCODE_US_RI5 5

/* mask = zxxxxz, id = 1133 */
# define VodiK_US_RI6_PLATE _VODI_MAKE_PLATEID_US_RI(_VodiK_PCODE_US_RI6)
# define _VodiK_PCODE_US_RI6 6
/* @} */


/*
 * US_SC
 * @{
 */
# define _VODI_MAKE_PLATEID_US_SC(aCode) \
_VODI_MAKE_PLATEID_US(VodiK_US_SC_SUBNUM,aCode)

/* mask = zzzxxx, id = 1135 */
# define VodiK_US_SC1_PLATE _VODI_MAKE_PLATEID_US_SC(_VodiK_PCODE_US_SC1)
# define _VodiK_PCODE_US_SC1 1

/* mask = xxxzzz, id = 1136 */
# define VodiK_US_SC2_PLATE _VODI_MAKE_PLATEID_US_SC(_VodiK_PCODE_US_SC2)
# define _VodiK_PCODE_US_SC2 2

/* mask = xxxxzz, id = 1137 */
# define VodiK_US_SC3_PLATE _VODI_MAKE_PLATEID_US_SC(_VodiK_PCODE_US_SC3)
# define _VodiK_PCODE_US_SC3 3

/* mask = zzxxxxx, id = 1134 */
# define VodiK_US_SC4_PLATE _VODI_MAKE_PLATEID_US_SC(_VodiK_PCODE_US_SC4)
# define _VodiK_PCODE_US_SC4 4

/* mask = zzzxxxx, id = 1138 */
# define VodiK_US_SC5_PLATE _VODI_MAKE_PLATEID_US_SC(_VodiK_PCODE_US_SC5)
# define _VodiK_PCODE_US_SC5 5
/* @} */


/*
 * US_SD
 * @{
 */
# define _VODI_MAKE_PLATEID_US_SD(aCode) \
_VODI_MAKE_PLATEID_US(VodiK_US_SD_SUBNUM,aCode)

/* mask = xzzxxx, id = 1140 */
# define VodiK_US_SD1_PLATE _VODI_MAKE_PLATEID_US_SD(_VodiK_PCODE_US_SD1)
# define _VodiK_PCODE_US_SD1 1

/* mask = xxzxxx, id = 1141 */
# define VodiK_US_SD2_PLATE _VODI_MAKE_PLATEID_US_SD(_VodiK_PCODE_US_SD2)
# define _VodiK_PCODE_US_SD2 2

/* mask = zxxxxz, id = 1139 */
# define VodiK_US_SD3_PLATE _VODI_MAKE_PLATEID_US_SD(_VodiK_PCODE_US_SD3)
# define _VodiK_PCODE_US_SD3 3

/* mask = zxxxxz, id = 1142 */
# define VodiK_US_SD4_PLATE _VODI_MAKE_PLATEID_US_SD(_VodiK_PCODE_US_SD4)
# define _VodiK_PCODE_US_SD4 4
/* @} */


/*
 * US_TN
 * @{
 */
# define _VODI_MAKE_PLATEID_US_TN(aCode) \
_VODI_MAKE_PLATEID_US(VodiK_US_TN_SUBNUM,aCode)

/* mask = xxxzzz, id = 1146 */
# define VodiK_US_TN1_PLATE _VODI_MAKE_PLATEID_US_TN(_VodiK_PCODE_US_TN1)
# define _VodiK_PCODE_US_TN1 1

/* mask = zxxxxz, id = 1147 */
# define VodiK_US_TN2_PLATE _VODI_MAKE_PLATEID_US_TN(_VodiK_PCODE_US_TN2)
# define _VodiK_PCODE_US_TN2 2

/* mask = zxxxx, id = 1143 */
# define VodiK_US_TN3_PLATE _VODI_MAKE_PLATEID_US_TN(_VodiK_PCODE_US_TN3)
# define _VodiK_PCODE_US_TN3 3

/* mask = zxxxxx, id = 1144 */
# define VodiK_US_TN4_PLATE _VODI_MAKE_PLATEID_US_TN(_VodiK_PCODE_US_TN4)
# define _VodiK_PCODE_US_TN4 4

/* mask = zxxxxz, id = 1145 */
# define VodiK_US_TN5_PLATE _VODI_MAKE_PLATEID_US_TN(_VodiK_PCODE_US_TN5)
# define _VodiK_PCODE_US_TN5 5
/* @} */


/*
 * US_TX
 * @{
 */
# define _VODI_MAKE_PLATEID_US_TX(aCode) \
_VODI_MAKE_PLATEID_US(VodiK_US_TX_SUBNUM,aCode)

/* mask = zzxzxxx, id = 1148 */
# define VodiK_US_TX1_PLATE _VODI_MAKE_PLATEID_US_TX(_VodiK_PCODE_US_TX1)
# define _VodiK_PCODE_US_TX1 1

/* mask = zzzxxxx, id = 1149 */
# define VodiK_US_TX2_PLATE _VODI_MAKE_PLATEID_US_TX(_VodiK_PCODE_US_TX2)
# define _VodiK_PCODE_US_TX2 2

/* mask = xzzzz, id = 1150 */
# define VodiK_US_TX3_PLATE _VODI_MAKE_PLATEID_US_TX(_VodiK_PCODE_US_TX3)
# define _VodiK_PCODE_US_TX3 3
/* @} */


/*
 * US_UT
 * @{
 */
# define _VODI_MAKE_PLATEID_US_UT(aCode) \
_VODI_MAKE_PLATEID_US(VodiK_US_UT_SUBNUM,aCode)

/* mask = xxxzzz, id = 1151 */
# define VodiK_US_UT1_PLATE _VODI_MAKE_PLATEID_US_UT(_VodiK_PCODE_US_UT1)
# define _VodiK_PCODE_US_UT1 1

/* mask = zxxxzz, id = 1153 */
# define VodiK_US_UT2_PLATE _VODI_MAKE_PLATEID_US_UT(_VodiK_PCODE_US_UT2)
# define _VodiK_PCODE_US_UT2 2

/* mask = xxxxxzz, id = 1155 */
# define VodiK_US_UT3_PLATE _VODI_MAKE_PLATEID_US_UT(_VodiK_PCODE_US_UT3)
# define _VodiK_PCODE_US_UT3 3

/* mask = zxxxxxxz, id = 1157 */
# define VodiK_US_UT4_PLATE _VODI_MAKE_PLATEID_US_UT(_VodiK_PCODE_US_UT4)
# define _VodiK_PCODE_US_UT4 4

/* mask = xxxzz, id = 1156 */
# define VodiK_US_UT5_PLATE _VODI_MAKE_PLATEID_US_UT(_VodiK_PCODE_US_UT5)
# define _VodiK_PCODE_US_UT5 5

/* mask = xxxxzz, id = 1152 */
# define VodiK_US_UT6_PLATE _VODI_MAKE_PLATEID_US_UT(_VodiK_PCODE_US_UT6)
# define _VodiK_PCODE_US_UT6 6

/* mask = zzzxxx, id = 1154 */
# define VodiK_US_UT7_PLATE _VODI_MAKE_PLATEID_US_UT(_VodiK_PCODE_US_UT7)
# define _VodiK_PCODE_US_UT7 7
/* @} */


/*
 * US_VA
 * @{
 */
# define _VODI_MAKE_PLATEID_US_VA(aCode) \
_VODI_MAKE_PLATEID_US(VodiK_US_VA_SUBNUM,aCode)

/* mask = zzzxxxx, id = 1162 */
# define VodiK_US_VA1_PLATE _VODI_MAKE_PLATEID_US_VA(_VodiK_PCODE_US_VA1)
# define _VodiK_PCODE_US_VA1 1

/* mask = zxxxxxz, id = 1163 */
# define VodiK_US_VA2_PLATE _VODI_MAKE_PLATEID_US_VA(_VodiK_PCODE_US_VA2)
# define _VodiK_PCODE_US_VA2 2

/* mask = zxxxxxx, id = 1166 */
# define VodiK_US_VA3_PLATE _VODI_MAKE_PLATEID_US_VA(_VodiK_PCODE_US_VA3)
# define _VodiK_PCODE_US_VA3 3

/* mask = zxxxxx, id = 1164 */
# define VodiK_US_VA4_PLATE _VODI_MAKE_PLATEID_US_VA(_VodiK_PCODE_US_VA4)
# define _VodiK_PCODE_US_VA4 4

/* mask = zxxxxzz, id = 1165 */
# define VodiK_US_VA5_PLATE _VODI_MAKE_PLATEID_US_VA(_VodiK_PCODE_US_VA5)
# define _VodiK_PCODE_US_VA5 5

/* mask = zxxxxxxz, id = 1167 */
# define VodiK_US_VA6_PLATE _VODI_MAKE_PLATEID_US_VA(_VodiK_PCODE_US_VA6)
# define _VodiK_PCODE_US_VA6 6
/* @} */


/*
 * US_VT
 * @{
 */
# define _VODI_MAKE_PLATEID_US_VT(aCode) \
_VODI_MAKE_PLATEID_US(VodiK_US_VT_SUBNUM,aCode)

/* mask = zzzxxx, id = 1159 */
# define VodiK_US_VT1_PLATE _VODI_MAKE_PLATEID_US_VT(_VodiK_PCODE_US_VT1)
# define _VodiK_PCODE_US_VT1 1

/* mask = zxxxx, id = 1158 */
# define VodiK_US_VT2_PLATE _VODI_MAKE_PLATEID_US_VT(_VodiK_PCODE_US_VT2)
# define _VodiK_PCODE_US_VT2 2

/* mask = zzxxxx, id = 1160 */
# define VodiK_US_VT3_PLATE _VODI_MAKE_PLATEID_US_VT(_VodiK_PCODE_US_VT3)
# define _VodiK_PCODE_US_VT3 3

/* mask = zzxxx, id = 1161 */
# define VodiK_US_VT4_PLATE _VODI_MAKE_PLATEID_US_VT(_VodiK_PCODE_US_VT4)
# define _VodiK_PCODE_US_VT4 4
/* @} */


/*
 * US_WA
 * @{
 */
# define _VODI_MAKE_PLATEID_US_WA(aCode) \
_VODI_MAKE_PLATEID_US(VodiK_US_WA_SUBNUM,aCode)

/* mask = xxxzzz, id = 1169 */
# define VodiK_US_WA1_PLATE _VODI_MAKE_PLATEID_US_WA(_VodiK_PCODE_US_WA1)
# define _VodiK_PCODE_US_WA1 1

/* mask = zzzxxxx, id = 1177 */
# define VodiK_US_WA2_PLATE _VODI_MAKE_PLATEID_US_WA(_VodiK_PCODE_US_WA2)
# define _VodiK_PCODE_US_WA2 2

/* mask = zxxxxxz, id = 1171 */
# define VodiK_US_WA3_PLATE _VODI_MAKE_PLATEID_US_WA(_VodiK_PCODE_US_WA3)
# define _VodiK_PCODE_US_WA3 3

/* mask = xxxxxzz, id = 1176 */
# define VodiK_US_WA4_PLATE _VODI_MAKE_PLATEID_US_WA(_VodiK_PCODE_US_WA4)
# define _VodiK_PCODE_US_WA4 4

/* mask = zxxxxxz, id = 1168 */
# define VodiK_US_WA5_PLATE _VODI_MAKE_PLATEID_US_WA(_VodiK_PCODE_US_WA5)
# define _VodiK_PCODE_US_WA5 5

/* mask = xxxxzz, id = 1170 */
# define VodiK_US_WA6_PLATE _VODI_MAKE_PLATEID_US_WA(_VodiK_PCODE_US_WA6)
# define _VodiK_PCODE_US_WA6 6

/* mask = zxxxxxz, id = 1172 */
# define VodiK_US_WA7_PLATE _VODI_MAKE_PLATEID_US_WA(_VodiK_PCODE_US_WA7)
# define _VodiK_PCODE_US_WA7 7

/* mask = xxxxzzz, id = 1173 */
# define VodiK_US_WA8_PLATE _VODI_MAKE_PLATEID_US_WA(_VodiK_PCODE_US_WA8)
# define _VodiK_PCODE_US_WA8 8

/* mask = zzxxxxz, id = 1174 */
# define VodiK_US_WA9_PLATE _VODI_MAKE_PLATEID_US_WA(_VodiK_PCODE_US_WA9)
# define _VodiK_PCODE_US_WA9 9

/* mask = zxxxxxz, id = 1175 */
# define VodiK_US_WA10_PLATE _VODI_MAKE_PLATEID_US_WA(_VodiK_PCODE_US_WA10)
# define _VodiK_PCODE_US_WA10 10
/* @} */


/*
 * US_WI
 * @{
 */
# define _VODI_MAKE_PLATEID_US_WI(aCode) \
_VODI_MAKE_PLATEID_US(VodiK_US_WI_SUBNUM,aCode)

/* mask = xxxzzz, id = 1180 */
# define VodiK_US_WI1_PLATE _VODI_MAKE_PLATEID_US_WI(_VodiK_PCODE_US_WI1)
# define _VodiK_PCODE_US_WI1 1

/* mask = zxxxxzz, id = 1181 */
# define VodiK_US_WI2_PLATE _VODI_MAKE_PLATEID_US_WI(_VodiK_PCODE_US_WI2)
# define _VodiK_PCODE_US_WI2 2
/* @} */


/*
 * US_WV
 * @{
 */
# define _VODI_MAKE_PLATEID_US_WV(aCode) \
_VODI_MAKE_PLATEID_US(VodiK_US_WV_SUBNUM,aCode)

/* mask = xzzxxx, id = 1178 */
# define VodiK_US_WV1_PLATE _VODI_MAKE_PLATEID_US_WV(_VodiK_PCODE_US_WV1)
# define _VodiK_PCODE_US_WV1 1

/* mask = xzxxxx, id = 1179 */
# define VodiK_US_WV2_PLATE _VODI_MAKE_PLATEID_US_WV(_VodiK_PCODE_US_WV2)
# define _VodiK_PCODE_US_WV2 2
/* @} */


/*
 * US_WY
 * @{
 */
# define _VODI_MAKE_PLATEID_US_WY(aCode) \
_VODI_MAKE_PLATEID_US(VodiK_US_WY_SUBNUM,aCode)

/* mask = xxxxx, id = 1182 */
# define VodiK_US_WY1_PLATE _VODI_MAKE_PLATEID_US_WY(_VodiK_PCODE_US_WY1)
# define _VodiK_PCODE_US_WY1 1

/* mask = xxxxxx, id = 1184 */
# define VodiK_US_WY2_PLATE _VODI_MAKE_PLATEID_US_WY(_VodiK_PCODE_US_WY2)
# define _VodiK_PCODE_US_WY2 2

/* mask = xxxxxxx, id = 1187 */
# define VodiK_US_WY3_PLATE _VODI_MAKE_PLATEID_US_WY(_VodiK_PCODE_US_WY3)
# define _VodiK_PCODE_US_WY3 3

/* mask = xxxx, id = 1185 */
# define VodiK_US_WY4_PLATE _VODI_MAKE_PLATEID_US_WY(_VodiK_PCODE_US_WY4)
# define _VodiK_PCODE_US_WY4 4

/* mask = xxxxx, id = 1186 */
# define VodiK_US_WY5_PLATE _VODI_MAKE_PLATEID_US_WY(_VodiK_PCODE_US_WY5)
# define _VodiK_PCODE_US_WY5 5

/* mask = xxxxz, id = 1183 */
# define VodiK_US_WY6_PLATE _VODI_MAKE_PLATEID_US_WY(_VodiK_PCODE_US_WY6)
# define _VodiK_PCODE_US_WY6 6

/* mask = xzxxxxzz, id = 1188 */
# define VodiK_US_WY7_PLATE _VODI_MAKE_PLATEID_US_WY(_VodiK_PCODE_US_WY7)
# define _VodiK_PCODE_US_WY7 7
/* @} */


/*
* UY
* @{
*/
# define _VODI_MAKE_PLATEID_UY(aCode) _VODI_MAKE_PLATEID(VodiK_URUGUAY_NUMERIC,aCode)

/* mask = zzzxxxx, id = 763 */
# define VodiK_UY1_PLATE _VODI_MAKE_PLATEID_UY(_VodiK_PCODE_UY1)
# define _VodiK_PCODE_UY1 1

/* mask = zxxxxxx, id = 764 */
# define VodiK_UY2_PLATE _VODI_MAKE_PLATEID_UY(_VodiK_PCODE_UY2)
# define _VodiK_PCODE_UY2 2

/* mask = zzzxxx, id = 766 */
# define VodiK_UY3_PLATE _VODI_MAKE_PLATEID_UY(_VodiK_PCODE_UY3)
# define _VodiK_PCODE_UY3 3

/* mask = zxxxxx, id = 766 */
# define VodiK_UY4_PLATE _VODI_MAKE_PLATEID_UY(_VodiK_PCODE_UY4)
# define _VodiK_PCODE_UY4 4

/* mask = zzzxxx, id = 1378 */
# define VodiK_UY5_PLATE _VODI_MAKE_PLATEID_UY(_VodiK_PCODE_UY5)
# define _VodiK_PCODE_UY5 5

/* mask = zxxxxx, id = 1414 */
# define VodiK_UY6_PLATE _VODI_MAKE_PLATEID_UY(_VodiK_PCODE_UY6)
# define _VodiK_PCODE_UY6 6

/* mask = zzzxxx, id = 1415 */
# define VodiK_UY7_PLATE _VODI_MAKE_PLATEID_UY(_VodiK_PCODE_UY7)
# define _VodiK_PCODE_UY7 7

/* mask = zzzxxxx, id = 1416 */
# define VodiK_UY8_PLATE _VODI_MAKE_PLATEID_UY(_VodiK_PCODE_UY8)
# define _VodiK_PCODE_UY8 8

/* mask = zzzxxx, id = 1780 */
# define VodiK_UY9_PLATE _VODI_MAKE_PLATEID_UY(_VodiK_PCODE_UY9)
# define _VodiK_PCODE_UY9 9
/* @} */


/*
 * UZ
 * @{
 */
# define _VODI_MAKE_PLATEID_UZ(aCode) _VODI_MAKE_PLATEID(VodiK_UZBEKISTAN_NUMERIC,aCode)

/* mask = XXZXXXX, id = 95 */
# define VodiK_UZ1_PLATE _VODI_MAKE_PLATEID_UZ(_VodiK_PCODE_UZ1)
# define _VodiK_PCODE_UZ1 1

/* mask = xxZXXXZZ, id = 96 */
# define VodiK_UZ2_PLATE _VODI_MAKE_PLATEID_UZ(_VodiK_PCODE_UZ2)
# define _VodiK_PCODE_UZ2 2

/* mask = xxZXXXZZ, id = 97 */
# define VodiK_UZ3_PLATE _VODI_MAKE_PLATEID_UZ(_VodiK_PCODE_UZ3)
# define _VodiK_PCODE_UZ3 3

/* mask = xxZXXXXXX, id = 98 */
# define VodiK_UZ4_PLATE _VODI_MAKE_PLATEID_UZ(_VodiK_PCODE_UZ4)
# define _VodiK_PCODE_UZ4 4

/* mask = xxXXXZZZ, id = 100 */
# define VodiK_UZ5_PLATE _VODI_MAKE_PLATEID_UZ(_VodiK_PCODE_UZ5)
# define _VodiK_PCODE_UZ5 5

/* mask = XXZZXXX, id = 102 */
# define VodiK_UZ6_PLATE _VODI_MAKE_PLATEID_UZ(_VodiK_PCODE_UZ6)
# define _VodiK_PCODE_UZ6 6

/* mask = xxZXXXXXX, id = 99 */
# define VodiK_UZ7_PLATE _VODI_MAKE_PLATEID_UZ(_VodiK_PCODE_UZ7)
# define _VodiK_PCODE_UZ7 7

/* mask = ZXXXX, id = 101 */
# define VodiK_UZ8_PLATE _VODI_MAKE_PLATEID_UZ(_VodiK_PCODE_UZ8)
# define _VodiK_PCODE_UZ8 8

/* mask = ZXXXXXX, id = 103 */
# define VodiK_UZ9_PLATE _VODI_MAKE_PLATEID_UZ(_VodiK_PCODE_UZ9)
# define _VodiK_PCODE_UZ9 9

/* mask = xxxxxxzxx, id = 1541 */
# define VodiK_UZ10_PLATE _VODI_MAKE_PLATEID_UZ(_VodiK_PCODE_UZ10)
# define _VodiK_PCODE_UZ10 10

/* mask = zxxxxxxxx, id = 1542 */
# define VodiK_UZ11_PLATE _VODI_MAKE_PLATEID_UZ(_VodiK_PCODE_UZ11)
# define _VodiK_PCODE_UZ11 11

/* mask = xxxzzzxx, id = 1543 */
# define VodiK_UZ12_PLATE _VODI_MAKE_PLATEID_UZ(_VodiK_PCODE_UZ12)
# define _VodiK_PCODE_UZ12 12

/* mask = xxxzzxx, id = 1544 */
# define VodiK_UZ13_PLATE _VODI_MAKE_PLATEID_UZ(_VodiK_PCODE_UZ13)
# define _VodiK_PCODE_UZ13 13

/* mask = xxxxzzxx, id = 1545 */
# define VodiK_UZ14_PLATE _VODI_MAKE_PLATEID_UZ(_VodiK_PCODE_UZ14)
# define _VodiK_PCODE_UZ14 14

/* mask = zxxxxxx, id = 1546 */
# define VodiK_UZ15_PLATE _VODI_MAKE_PLATEID_UZ(_VodiK_PCODE_UZ15)
# define _VodiK_PCODE_UZ15 15

/* mask = zxxxxxxxx, id = 1547 */
# define VodiK_UZ16_PLATE _VODI_MAKE_PLATEID_UZ(_VodiK_PCODE_UZ16)
# define _VodiK_PCODE_UZ16 16

/* mask = zxxxxxxxx, id = 1548 */
# define VodiK_UZ17_PLATE _VODI_MAKE_PLATEID_UZ(_VodiK_PCODE_UZ17)
# define _VodiK_PCODE_UZ17 17
/* @} */


/*
* VA
* @{
*/
# define _VODI_MAKE_PLATEID_VA(aCode) _VODI_MAKE_PLATEID(VodiK_HOLY_SEE_NUMERIC,aCode)

/* mask = zzzxxxxx, id = 833 */
# define VodiK_VA1_PLATE _VODI_MAKE_PLATEID_VA(_VodiK_PCODE_VA1)
# define _VodiK_PCODE_VA1 1

/* mask = zzxxxxx, id = 834 */
# define VodiK_VA2_PLATE _VODI_MAKE_PLATEID_VA(_VodiK_PCODE_VA2)
# define _VodiK_PCODE_VA2 2

/* mask = zzxxxx, id = 1896 */
# define VodiK_VA3_PLATE _VODI_MAKE_PLATEID_VA(_VodiK_PCODE_VA3)
# define _VodiK_PCODE_VA3 3

/* mask = zzxxxxx, id = 1897 */
# define VodiK_VA4_PLATE _VODI_MAKE_PLATEID_VA(_VodiK_PCODE_VA4)
# define _VodiK_PCODE_VA4 4
/* @} */


/*
 * VE
 * @{
 */
# define _VODI_MAKE_PLATEID_VE(aCode) _VODI_MAKE_PLATEID(VodiK_VENEZUELA_NUMERIC,aCode)

/* mask = zzxxxzz, id = 510 */
# define VodiK_VE1_PLATE _VODI_MAKE_PLATEID_VE(_VodiK_PCODE_VE1)
# define _VodiK_PCODE_VE1 1

/* mask = xxxxxx, id = 511 */
# define VodiK_VE2_PLATE _VODI_MAKE_PLATEID_VE(_VodiK_PCODE_VE2)
# define _VodiK_PCODE_VE2 2

/* mask = ZZZXXX, id = 1463 */
# define VodiK_VE3_PLATE _VODI_MAKE_PLATEID_VE(_VodiK_PCODE_VE3)
# define _VodiK_PCODE_VE3 3

/* mask = ZZZXXZ, id = 1464 */
# define VodiK_VE4_PLATE _VODI_MAKE_PLATEID_VE(_VodiK_PCODE_VE4)
# define _VodiK_PCODE_VE4 4

/* mask = ZZXXXX, id = 1465 */
# define VodiK_VE5_PLATE _VODI_MAKE_PLATEID_VE(_VodiK_PCODE_VE5)
# define _VodiK_PCODE_VE5 5

/* mask = XXZZXZZ, id = 1466 */
# define VodiK_VE6_PLATE _VODI_MAKE_PLATEID_VE(_VodiK_PCODE_VE6)
# define _VodiK_PCODE_VE6 6

/* mask = ZZXXXZ, id = 1467 */
# define VodiK_VE7_PLATE _VODI_MAKE_PLATEID_VE(_VodiK_PCODE_VE7)
# define _VodiK_PCODE_VE7 7

/* mask = ZZXZXXZ, id = 1468 */
# define VodiK_VE8_PLATE _VODI_MAKE_PLATEID_VE(_VodiK_PCODE_VE8)
# define _VodiK_PCODE_VE8 8

/* mask = XXXZZZ, id = 1469 */
# define VodiK_VE9_PLATE _VODI_MAKE_PLATEID_VE(_VodiK_PCODE_VE9)
# define _VodiK_PCODE_VE9 9
/* @} */


/*
 * VN
 * @{
 */
# define _VODI_MAKE_PLATEID_VN(aCode) _VODI_MAKE_PLATEID(VodiK_VIETNAM_NUMERIC,aCode)

/* mask = xxzxxxx, id = 850 */
# define VodiK_VN1_PLATE _VODI_MAKE_PLATEID_VN(_VodiK_PCODE_VN1)
# define _VodiK_PCODE_VN1 1

/* mask = xxzxxxx, id = 1417 */
# define VodiK_VN2_PLATE _VODI_MAKE_PLATEID_VN(_VodiK_PCODE_VN2)
# define _VodiK_PCODE_VN2 2

/* mask = xxzz-xxx.xx, id = 1418 */
# define VodiK_VN3_PLATE _VODI_MAKE_PLATEID_VN(_VodiK_PCODE_VN3)
# define _VodiK_PCODE_VN3 3

/* mask = zzxx-xx, id = 1419 */
# define VodiK_VN4_PLATE _VODI_MAKE_PLATEID_VN(_VodiK_PCODE_VN4)
# define _VodiK_PCODE_VN4 4

/* mask = xxz-xxxx, id = 1420 */
# define VodiK_VN5_PLATE _VODI_MAKE_PLATEID_VN(_VodiK_PCODE_VN5)
# define _VodiK_PCODE_VN5 5

/* mask = xxz-xxxx, id = 1421 */
# define VodiK_VN6_PLATE _VODI_MAKE_PLATEID_VN(_VodiK_PCODE_VN6)
# define _VodiK_PCODE_VN6 6

/* mask = xxzxxxx, id = 1422 */
# define VodiK_VN7_PLATE _VODI_MAKE_PLATEID_VN(_VodiK_PCODE_VN7)
# define _VodiK_PCODE_VN7 7

/* mask = xxzxxx.xx, id = 1423 */
# define VodiK_VN8_PLATE _VODI_MAKE_PLATEID_VN(_VodiK_PCODE_VN8)
# define _VodiK_PCODE_VN8 8

/* mask = xxz-xxx.xx, id = 1424 */
# define VodiK_VN9_PLATE _VODI_MAKE_PLATEID_VN(_VodiK_PCODE_VN9)
# define _VodiK_PCODE_VN9 9

/* mask = xxzxxx.xx, id = 1425 */
# define VodiK_VN10_PLATE _VODI_MAKE_PLATEID_VN(_VodiK_PCODE_VN10)
# define _VodiK_PCODE_VN10 10

/* mask = zz-xx-xx, id = 1426 */
# define VodiK_VN11_PLATE _VODI_MAKE_PLATEID_VN(_VodiK_PCODE_VN11)
# define _VodiK_PCODE_VN11 11

/* mask = xx-zxxxxx, id = 1427 */
# define VodiK_VN12_PLATE _VODI_MAKE_PLATEID_VN(_VodiK_PCODE_VN12)
# define _VodiK_PCODE_VN12 12

/* mask = xxzzxx-xx, id = 1428 */
# define VodiK_VN13_PLATE _VODI_MAKE_PLATEID_VN(_VodiK_PCODE_VN13)
# define _VodiK_PCODE_VN13 13

/* mask = xxzxxxx.xx, id = 1429 */
# define VodiK_VN14_PLATE _VODI_MAKE_PLATEID_VN(_VodiK_PCODE_VN14)
# define _VodiK_PCODE_VN14 14

/* mask = xxz-xxx.xx, id = 1430 */
# define VodiK_VN15_PLATE _VODI_MAKE_PLATEID_VN(_VodiK_PCODE_VN15)
# define _VodiK_PCODE_VN15 15
/* @} */


/*
 * ZA
 * @{
 */
# define _VODI_MAKE_PLATEID_ZA(aCode) _VODI_MAKE_PLATEID(VodiK_SOUTH_AFRICA_NUMERIC,aCode)

/* mask = zzzxxxzz, id = 555 */
# define VodiK_ZA1_PLATE _VODI_MAKE_PLATEID_ZA(_VodiK_PCODE_ZA1)
# define _VodiK_PCODE_ZA1 1

/* mask = zzzxxxzz, id = 558 */
# define VodiK_ZA2_PLATE _VODI_MAKE_PLATEID_ZA(_VodiK_PCODE_ZA2)
# define _VodiK_PCODE_ZA2 2

/* mask = zzzxxxzz, id = 560 */
# define VodiK_ZA3_PLATE _VODI_MAKE_PLATEID_ZA(_VodiK_PCODE_ZA3)
# define _VodiK_PCODE_ZA3 3

/* mask = zzxxzzzz, id = 561 */
# define VodiK_ZA4_PLATE _VODI_MAKE_PLATEID_ZA(_VodiK_PCODE_ZA4)
# define _VodiK_PCODE_ZA4 4

/* mask = zzzxxxxx, id = 563 */
# define VodiK_ZA5_PLATE _VODI_MAKE_PLATEID_ZA(_VodiK_PCODE_ZA5)
# define _VodiK_PCODE_ZA5 5

/* mask = zzxxxx, id = 564 */
# define VodiK_ZA6_PLATE _VODI_MAKE_PLATEID_ZA(_VodiK_PCODE_ZA6)
# define _VodiK_PCODE_ZA6 6

/* mask = zzxxxxxx, id = 565 */
# define VodiK_ZA7_PLATE _VODI_MAKE_PLATEID_ZA(_VodiK_PCODE_ZA7)
# define _VodiK_PCODE_ZA7 7

/* mask = zzxxxxx, id = 568 */
# define VodiK_ZA8_PLATE _VODI_MAKE_PLATEID_ZA(_VodiK_PCODE_ZA8)
# define _VodiK_PCODE_ZA8 8

/* mask = zzzxxxx, id = 569 */
# define VodiK_ZA9_PLATE _VODI_MAKE_PLATEID_ZA(_VodiK_PCODE_ZA9)
# define _VodiK_PCODE_ZA9 9

/* mask = zzzxxx, id = 570 */
# define VodiK_ZA10_PLATE _VODI_MAKE_PLATEID_ZA(_VodiK_PCODE_ZA10)
# define _VodiK_PCODE_ZA10 10

/* mask = zzzxxxz, id = 572 */
# define VodiK_ZA11_PLATE _VODI_MAKE_PLATEID_ZA(_VodiK_PCODE_ZA11)
# define _VodiK_PCODE_ZA11 11

/* mask = zzzxxxzz, id = 574 */
# define VodiK_ZA12_PLATE _VODI_MAKE_PLATEID_ZA(_VodiK_PCODE_ZA12)
# define _VodiK_PCODE_ZA12 12

/* mask = zzzxxxzz, id = 575 */
# define VodiK_ZA13_PLATE _VODI_MAKE_PLATEID_ZA(_VodiK_PCODE_ZA13)
# define _VodiK_PCODE_ZA13 13

/* mask = zzzxxxzz, id = 578 */
# define VodiK_ZA14_PLATE _VODI_MAKE_PLATEID_ZA(_VodiK_PCODE_ZA14)
# define _VodiK_PCODE_ZA14 14

/* mask = zzzxxxzz, id = 579 */
# define VodiK_ZA15_PLATE _VODI_MAKE_PLATEID_ZA(_VodiK_PCODE_ZA15)
# define _VodiK_PCODE_ZA15 15

/* mask = zzxxxxxx, id = 580 */
# define VodiK_ZA16_PLATE _VODI_MAKE_PLATEID_ZA(_VodiK_PCODE_ZA16)
# define _VodiK_PCODE_ZA16 16

/* mask = zzzxxxxx, id = 581 */
# define VodiK_ZA17_PLATE _VODI_MAKE_PLATEID_ZA(_VodiK_PCODE_ZA17)
# define _VodiK_PCODE_ZA17 17

/* mask = zzzxxxzz, id = 556 */
# define VodiK_ZA18_PLATE _VODI_MAKE_PLATEID_ZA(_VodiK_PCODE_ZA18)
# define _VodiK_PCODE_ZA18 18

/* mask = zzzxxxzz, id = 559 */
# define VodiK_ZA19_PLATE _VODI_MAKE_PLATEID_ZA(_VodiK_PCODE_ZA19)
# define _VodiK_PCODE_ZA19 19

/* mask = zzzxxxz, id = 562 */
# define VodiK_ZA20_PLATE _VODI_MAKE_PLATEID_ZA(_VodiK_PCODE_ZA20)
# define _VodiK_PCODE_ZA20 20

/* mask = zzzxxxxx, id = 567 */
# define VodiK_ZA21_PLATE _VODI_MAKE_PLATEID_ZA(_VodiK_PCODE_ZA21)
# define _VodiK_PCODE_ZA21 21

/* mask = zzzxxxz, id = 573 */
# define VodiK_ZA22_PLATE _VODI_MAKE_PLATEID_ZA(_VodiK_PCODE_ZA22)
# define _VodiK_PCODE_ZA22 22

/* mask = zzzxxxzz, id = 576 */
# define VodiK_ZA23_PLATE _VODI_MAKE_PLATEID_ZA(_VodiK_PCODE_ZA23)
# define _VodiK_PCODE_ZA23 23

/* mask = zzxxxxxx, id = 583 */
# define VodiK_ZA24_PLATE _VODI_MAKE_PLATEID_ZA(_VodiK_PCODE_ZA24)
# define _VodiK_PCODE_ZA24 24

/* mask = xxxzzzzz, id = 566 */
# define VodiK_ZA25_PLATE _VODI_MAKE_PLATEID_ZA(_VodiK_PCODE_ZA25)
# define _VodiK_PCODE_ZA25 25

/* mask = zzzxxxz, id = 557 */
# define VodiK_ZA26_PLATE _VODI_MAKE_PLATEID_ZA(_VodiK_PCODE_ZA26)
# define _VodiK_PCODE_ZA26 26

/* mask = xxxxzz, id = 571 */
# define VodiK_ZA27_PLATE _VODI_MAKE_PLATEID_ZA(_VodiK_PCODE_ZA27)
# define _VodiK_PCODE_ZA27 27

/* mask = zzzxxxzz, id = 577 */
# define VodiK_ZA28_PLATE _VODI_MAKE_PLATEID_ZA(_VodiK_PCODE_ZA28)
# define _VodiK_PCODE_ZA28 28

/* mask = xxxzz, id = 582 */
# define VodiK_ZA29_PLATE _VODI_MAKE_PLATEID_ZA(_VodiK_PCODE_ZA29)
# define _VodiK_PCODE_ZA29 29

/* mask = zzzxxxxx, id = 567 */
# define VodiK_ZA30_PLATE _VODI_MAKE_PLATEID_ZA(_VodiK_PCODE_ZA30)
# define _VodiK_PCODE_ZA30 30

/* mask = zzzxxxz, id = 573 */
# define VodiK_ZA31_PLATE _VODI_MAKE_PLATEID_ZA(_VodiK_PCODE_ZA31)
# define _VodiK_PCODE_ZA31 31

/* mask = zzzxxxzz, id = 576 */
# define VodiK_ZA32_PLATE _VODI_MAKE_PLATEID_ZA(_VodiK_PCODE_ZA32)
# define _VodiK_PCODE_ZA32 32

/* mask = zzxxxxxx, id = 583 */
# define VodiK_ZA33_PLATE _VODI_MAKE_PLATEID_ZA(_VodiK_PCODE_ZA33)
# define _VodiK_PCODE_ZA33 33

/* mask = yyyyyyzz, id = 566 */
# define VodiK_ZA34_PLATE _VODI_MAKE_PLATEID_ZA(_VodiK_PCODE_ZA34)
# define _VodiK_PCODE_ZA34 34

/* mask = yyyzz, id = 1972 */
# define VodiK_ZA35_PLATE _VODI_MAKE_PLATEID_ZA(_VodiK_PCODE_ZA35)
# define _VodiK_PCODE_ZA35 35

/* mask = yyyyzz, id = 1973 */
# define VodiK_ZA36_PLATE _VODI_MAKE_PLATEID_ZA(_VodiK_PCODE_ZA36)
# define _VodiK_PCODE_ZA36 36

/* mask = yyyyyzz, id = 1974 */
# define VodiK_ZA37_PLATE _VODI_MAKE_PLATEID_ZA(_VodiK_PCODE_ZA37)
# define _VodiK_PCODE_ZA37 37

/* mask = yyyyyyyzz, id = 1975 */
# define VodiK_ZA38_PLATE _VODI_MAKE_PLATEID_ZA(_VodiK_PCODE_ZA38)
# define _VodiK_PCODE_ZA38 38

/* mask = yyyyyyzz, id = 1976 */
# define VodiK_ZA39_PLATE _VODI_MAKE_PLATEID_ZA(_VodiK_PCODE_ZA39)
# define _VodiK_PCODE_ZA39 39

/* mask = yyyyyyzz, id = 1977 */
# define VodiK_ZA40_PLATE _VODI_MAKE_PLATEID_ZA(_VodiK_PCODE_ZA40)
# define _VodiK_PCODE_ZA40 40

/* mask = yyyyyzz, id = 1978 */
# define VodiK_ZA41_PLATE _VODI_MAKE_PLATEID_ZA(_VodiK_PCODE_ZA41)
# define _VodiK_PCODE_ZA41 41

/* mask = yyyyyyzz, id = 1979 */
# define VodiK_ZA42_PLATE _VODI_MAKE_PLATEID_ZA(_VodiK_PCODE_ZA42)
# define _VodiK_PCODE_ZA42 42

/* mask = zzzxzz, id = 1980 */
# define VodiK_ZA43_PLATE _VODI_MAKE_PLATEID_ZA(_VodiK_PCODE_ZA43)
# define _VodiK_PCODE_ZA43 43

/* mask = zzzxxxz, id = 557 */
# define VodiK_ZA44_PLATE _VODI_MAKE_PLATEID_ZA(_VodiK_PCODE_ZA44)
# define _VodiK_PCODE_ZA44 44

/* mask = xxxxzz, id = 571 */
# define VodiK_ZA45_PLATE _VODI_MAKE_PLATEID_ZA(_VodiK_PCODE_ZA45)
# define _VodiK_PCODE_ZA45 45

/* mask = zzzxxxzz, id = 577 */
# define VodiK_ZA46_PLATE _VODI_MAKE_PLATEID_ZA(_VodiK_PCODE_ZA46)
# define _VodiK_PCODE_ZA46 46

/* mask = xxxzz, id = 582 */
# define VodiK_ZA47_PLATE _VODI_MAKE_PLATEID_ZA(_VodiK_PCODE_ZA47)
# define _VodiK_PCODE_ZA47 47

/* mask = zzzxzz, id = 1980 */
# define VodiK_ZA48_PLATE _VODI_MAKE_PLATEID_ZA(_VodiK_PCODE_ZA48)
# define _VodiK_PCODE_ZA48 48

/* mask = yyyyyyzz, id = 1994 */
# define VodiK_ZA49_PLATE _VODI_MAKE_PLATEID_ZA(_VodiK_PCODE_ZA49)
# define _VodiK_PCODE_ZA49 49

/* mask = yyyyyyyzz, id = 1995 */
# define VodiK_ZA50_PLATE _VODI_MAKE_PLATEID_ZA(_VodiK_PCODE_ZA50)
# define _VodiK_PCODE_ZA50 50

/* mask = yyyyyyzz, id = 1996 */
# define VodiK_ZA51_PLATE _VODI_MAKE_PLATEID_ZA(_VodiK_PCODE_ZA51)
# define _VodiK_PCODE_ZA51 51

/* mask = yyyxxzz, id = 1998 */
# define VodiK_ZA52_PLATE _VODI_MAKE_PLATEID_ZA(_VodiK_PCODE_ZA52)
# define _VodiK_PCODE_ZA52 52

/* mask = yyyyyxxzz, id = 1999 */
# define VodiK_ZA53_PLATE _VODI_MAKE_PLATEID_ZA(_VodiK_PCODE_ZA53)
# define _VodiK_PCODE_ZA53 53

/* mask = yyyyyzz, id = 2000 */
# define VodiK_ZA54_PLATE _VODI_MAKE_PLATEID_ZA(_VodiK_PCODE_ZA54)
# define _VodiK_PCODE_ZA54 54

/* mask = zzzxxxz, id = 557 */
# define VodiK_ZA55_PLATE _VODI_MAKE_PLATEID_ZA(_VodiK_PCODE_ZA55)
# define _VodiK_PCODE_ZA55 55

/* mask = xxxxzz, id = 571 */
# define VodiK_ZA56_PLATE _VODI_MAKE_PLATEID_ZA(_VodiK_PCODE_ZA56)
# define _VodiK_PCODE_ZA56 56

/* mask = zzzxxxzz, id = 577 */
# define VodiK_ZA57_PLATE _VODI_MAKE_PLATEID_ZA(_VodiK_PCODE_ZA57)
# define _VodiK_PCODE_ZA57 57

/* mask = xxxzz, id = 582 */
# define VodiK_ZA58_PLATE _VODI_MAKE_PLATEID_ZA(_VodiK_PCODE_ZA58)
# define _VodiK_PCODE_ZA58 58

/* mask = zzxxzzzz, id = 2008 */
# define VodiK_ZA59_PLATE _VODI_MAKE_PLATEID_ZA(_VodiK_PCODE_ZA59)
# define _VodiK_PCODE_ZA59 59
/* @} */


/*
 * ZM
 * @{
 */
# define _VODI_MAKE_PLATEID_ZM(aCode) _VODI_MAKE_PLATEID(VodiK_ZAMBIA_NUMERIC,aCode)

/* mask = zzzxxxx, id = 2135 */
# define VodiK_ZM1_PLATE _VODI_MAKE_PLATEID_ZM(_VodiK_PCODE_ZM1)
# define _VodiK_PCODE_ZM1 1

/* mask = zzzxxxx, id = 2136 */
# define VodiK_ZM2_PLATE _VODI_MAKE_PLATEID_ZM(_VodiK_PCODE_ZM2)
# define _VodiK_PCODE_ZM2 2

/* mask = zzzxxxx, id = 2137 */
# define VodiK_ZM3_PLATE _VODI_MAKE_PLATEID_ZM(_VodiK_PCODE_ZM3)
# define _VodiK_PCODE_ZM3 3
/* @} */


/*
 * ADR
 * @{
 */
# define _VODI_MAKE_PLATEID_ADR(aCode) _VODI_MAKE_PLATEID(VodiK_ADR_NUMERIC,aCode)

/* mask = xxxxxx, id = 1538 */
# define VodiK_ADR1_PLATE _VODI_MAKE_PLATEID_ADR(_VodiK_PCODE_ADR1)
# define _VodiK_PCODE_ADR1 1

/* mask = xxxxxx, id = 1539 */
# define VodiK_ADR2_PLATE _VODI_MAKE_PLATEID_ADR(_VodiK_PCODE_ADR2)
# define _VodiK_PCODE_ADR2 2

/* mask = xxxxxxx, id = 1540 */
# define VodiK_ADR3_PLATE _VODI_MAKE_PLATEID_ADR(_VodiK_PCODE_ADR3)
# define _VodiK_PCODE_ADR3 3
/* @} */

#endif /* !defined(__VODI_LPVTYPE__) */

/******************************************************************************
 *
 *
 *
 *****************************************************************************/
